(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[  12672837,     263896]
NotebookOptionsPosition[  12628001,     262718]
NotebookOutlinePosition[  12628352,     262734]
CellTagsIndexPosition[  12628309,     262731]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Introduction of run samept", "Section",
 CellChangeTimes->{{3.705132796517497*^9, 3.705132803172352*^9}, {
  3.7056172496116457`*^9, 3.705617254310611*^9}}],

Cell["\<\
Function description:
1. This program read  \[OpenCurlyDoubleQuote]config1.txt\
\[CloseCurlyDoubleQuote], \[OpenCurlyDoubleQuote]plotdata_config.txt\
\[CloseCurlyDoubleQuote], and read data in /CorrDataDir/CorrDataFile to plot  \
samept figures
2. (x, Q) are points of  samept method (please read the tutorial note of this \
program)
3. plot figures for selected experiments , flavours, and observables
(observable: correlation, sensitivity (dR*correlation) of PDF and residual of \
data, residual central value, residual uncertainty, (expt error)/(expt \
central) )
figures: 2D-xQ & histograms of observable values
2D-xQ: Draw (x, Q) of an observable data on x-Q plane. colors and sizes of \
points are determined by the value of the observable at that point)
  
\:2217 #PDF set, # Figures to plot, # Experiments to include, #Functions to \
use in correlations, #User function parameters are for setup of the input data

\:2217 #x-Q figure parameters, #Histogram figure parameters, #in plots, \
#highlight mode, #data point size are for setup of how figures look like 

\:2217 datalis file, Correlation Path, Correlation File  in \
\[OpenCurlyDoubleQuote]plotdata_config.txt\[CloseCurlyDoubleQuote] are setup \
of filenames that are read in this executable. If the executable need to load \
PDF data f(x, Q), filenames are determined by F(x,Q) Samept Path, F(x,Q) \
Samept File. 
If Correlation File, F(x,Q) Samept File = \[OpenCurlyDoubleQuote]default\
\[CloseCurlyDoubleQuote], data filenames are determined by #PDF set.

\[Dash] output: 2D-xQ, histograms

formats of data files in ../quick_data/ are List of dimension:
\[OpenCurlyDoubleQuote]fxQ\[CloseCurlyDoubleQuote]: [[iexpt, iflavour]]
\[OpenCurlyDoubleQuote]residualNset\[CloseCurlyDoubleQuote]: [[iexpt]]
\[OpenCurlyDoubleQuote]dtacentral\[CloseCurlyDoubleQuote]: [[iexpt]]

formats of data (variables) for generating figures are List of dimension: 
\[OpenCurlyDoubleQuote]corr\[CloseCurlyDoubleQuote]: [[iexpt, iflavour]]
\[OpenCurlyDoubleQuote]dRcorr\[CloseCurlyDoubleQuote]: [[iexpt, iflavour]]
\[OpenCurlyDoubleQuote] dR\[CloseCurlyDoubleQuote]: [[iexpt]]
\[OpenCurlyDoubleQuote]residual\[CloseCurlyDoubleQuote]: [[iexpt]]
\[OpenCurlyDoubleQuote]expterror\[CloseCurlyDoubleQuote]: [[iexpt]]\
\>", "Text",
 CellChangeTimes->{{3.705132820393243*^9, 3.7051328208311863`*^9}, {
   3.705132858336154*^9, 3.705132888070714*^9}, {3.7051329192012987`*^9, 
   3.705133017636792*^9}, {3.705133106136004*^9, 3.705133147016699*^9}, {
   3.7051339919616737`*^9, 3.705134021934216*^9}, {3.705134086092985*^9, 
   3.705134161269755*^9}, {3.705134201788497*^9, 3.705134485838325*^9}, {
   3.705134522850583*^9, 3.705134573461507*^9}, {3.705138528281351*^9, 
   3.7051385693342323`*^9}, 3.705141053070818*^9, {3.705141739223968*^9, 
   3.7051417529403687`*^9}, {3.705141790309513*^9, 3.705141824666563*^9}, {
   3.7051609852706423`*^9, 3.705160986556631*^9}, {3.705161028675593*^9, 
   3.7051611284177094`*^9}, {3.705161180282694*^9, 3.705161209988885*^9}, {
   3.7051612598375587`*^9, 3.7051612750317802`*^9}, {3.7051613272436113`*^9, 
   3.705161370144936*^9}, {3.705626949300805*^9, 3.7056269526134653`*^9}, {
   3.705627790165189*^9, 3.7056278017203197`*^9}, {3.705627840050625*^9, 
   3.705627877894486*^9}, {3.705633185541461*^9, 3.7056333173504553`*^9}, {
   3.705633384007337*^9, 3.7056333842356377`*^9}, {3.705634194551084*^9, 
   3.705634203238192*^9}, {3.705634295396474*^9, 3.7056343156519747`*^9}, {
   3.7072334515116453`*^9, 3.7072334639570627`*^9}, {3.707233557179541*^9, 
   3.70723359673044*^9}, {3.707233677893839*^9, 3.707233780743367*^9}, {
   3.707233816620089*^9, 3.70723386958356*^9}, {3.707233918536131*^9, 
   3.707234183645583*^9}, 3.707234909639123*^9, {3.707237121989306*^9, 
   3.707237123605507*^9}, {3.708405881775283*^9, 3.708405884646042*^9}, {
   3.718593034824778*^9, 3.7185931695759172`*^9}, {3.718593204140058*^9, 
   3.7185932433232307`*^9}, {3.718593461043128*^9, 3.7185934641923428`*^9}, {
   3.718597514040494*^9, 3.7185975296571093`*^9}},
 Background->RGBColor[0.88, 1, 0.88]]
}, Open  ]],

Cell[CellGroupData[{

Cell["How to Run", "Section",
 CellChangeTimes->{{3.706788977874497*^9, 3.706788983612884*^9}, 
   3.706789014422559*^9, 3.7067892793048687`*^9}],

Cell["\<\
1. setup arguments in \[OpenCurlyDoubleQuote]config1.txt\
\[CloseCurlyDoubleQuote] & \[OpenCurlyDoubleQuote]plotdata_config.txt\
\[CloseCurlyDoubleQuote] 
2. 
a. if this file\[CloseCurlyQuote]s extension is .nb, run \
\[OpenCurlyDoubleQuote]control runfunc you want to \
run\[CloseCurlyDoubleQuote] title at bottom of your code
b. if this file\[CloseCurlyQuote]s extension is .m (script version), type \
math -script \[OpenCurlyDoubleQuote]filename of this file\
\[CloseCurlyDoubleQuote] in the terminal  \
\>", "Text",
 CellChangeTimes->{{3.705132820393243*^9, 3.7051328208311863`*^9}, {
   3.705132858336154*^9, 3.705132888070714*^9}, {3.7051329192012987`*^9, 
   3.705133017636792*^9}, {3.705133106136004*^9, 3.705133147016699*^9}, {
   3.7051339919616737`*^9, 3.705134021934216*^9}, {3.705134086092985*^9, 
   3.705134161269755*^9}, {3.705134201788497*^9, 3.705134485838325*^9}, {
   3.705134522850583*^9, 3.705134573461507*^9}, {3.705138528281351*^9, 
   3.7051385693342323`*^9}, 3.705141053070818*^9, {3.705141739223968*^9, 
   3.7051417529403687`*^9}, {3.705141790309513*^9, 3.705141824666563*^9}, {
   3.7051609852706423`*^9, 3.705160986556631*^9}, {3.705161028675593*^9, 
   3.7051611284177094`*^9}, {3.705161180282694*^9, 3.705161209988885*^9}, {
   3.7051612598375587`*^9, 3.7051612750317802`*^9}, {3.7051613272436113`*^9, 
   3.705161370144936*^9}, {3.70561731217622*^9, 3.705617376622374*^9}, {
   3.705617425817935*^9, 3.705617520094151*^9}, {3.7056186030321007`*^9, 
   3.705618606899289*^9}, 3.705618707276335*^9, {3.7056187403369503`*^9, 
   3.705618813760572*^9}, {3.7056189071423483`*^9, 3.705618949438397*^9}, {
   3.705619972913897*^9, 3.705619985029442*^9}, {3.705620407059811*^9, 
   3.705620485809678*^9}, {3.705621101372929*^9, 3.705621194338462*^9}, 
   3.705621244524444*^9, {3.705621411532015*^9, 3.705621420256465*^9}, {
   3.7056214669774523`*^9, 3.705621573205015*^9}, {3.705621694451981*^9, 
   3.7056217592741327`*^9}, {3.705621839124731*^9, 3.705621839281027*^9}, {
   3.706789038174892*^9, 3.7067892571558104`*^9}, {3.706789595575741*^9, 
   3.706789667194002*^9}},
 FontSize->24,
 Background->RGBColor[0.88, 1, 0.88]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Functions for .tsv output", "Section",
 CellChangeTimes->{{3.7257920890222282`*^9, 3.725792103398747*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "this", " ", "function", " ", "find", " ", "the", " ", "components", " ", 
    "of", " ", "the", " ", "Hessian", " ", "correlation"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"pdfHessianCorrelationVectorfake", "[", 
      RowBox[{"list1_", ",", " ", "list2_"}], "]"}], " ", ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "Neigen", ",", "Neigen1", ",", " ", "Neigen2", ",", " ", "PDFerror1", 
         ",", " ", "PDFerror2"}], "}"}], ",", "\n", "   ", 
       RowBox[{
        RowBox[{"If", "[", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"!", " ", 
            RowBox[{"ListQ", "[", "list1", "]"}]}], " ", "||", " ", 
           RowBox[{"!", " ", 
            RowBox[{"ListQ", "[", "list2", "]"}]}]}], ",", " ", "\n", "    ", 
          
          RowBox[{
           RowBox[{
           "Print", "[", 
            "\"\<pdfHessianCorrelationfake: both arguments must be lists\>\"",
             "]"}], ";", " ", "Return"}]}], "]"}], ";", "\n", "   ", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "list1", "]"}], " ", "!=", " ", 
           RowBox[{"Length", "[", "list2", "]"}]}], ",", "\n", "    ", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<Problem: length of the lists do not match, \>\"", ",", " ", 
            "\n", "     ", 
            RowBox[{"Length", "[", "list1", "]"}], " ", ",", " ", 
            "\"\<!=\>\"", ",", " ", 
            RowBox[{
             RowBox[{"Length", "[", "list2", "]"}], ";", " ", "Return"}]}], 
           "]"}]}], "\n", "    ", "]"}], ";", "\n", "   ", 
        RowBox[{"Neigen", " ", "=", " ", 
         RowBox[{"Length", "[", "list1", "]"}]}], ";", "\n", "   ", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"EvenQ", "[", "Neigen", "]"}], ",", " ", 
          RowBox[{
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<Stop, an even number of eigenvectors: \>\"", ",", " ", 
             "Neigen"}], "]"}], ";", " ", "Return"}]}], "]"}], ";", "\n", 
        "   ", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"PDFerror1", ",", " ", "PDFerror2"}], "}"}], " ", "=", " ", 
         
         RowBox[{
          RowBox[{
           RowBox[{"Max", "[", 
            RowBox[{
             RowBox[{"pdfHessianSymErrorfake", "[", "#", "]"}], ",", " ", 
             RowBox[{"10", "^", 
              RowBox[{"-", "8"}]}]}], "]"}], " ", "&"}], " ", "/@", " ", 
          RowBox[{"{", 
           RowBox[{"list1", ",", " ", "list2"}], "}"}]}]}], ";", "\n", "   ", 
        
        RowBox[{
         RowBox[{"1", "/", 
          RowBox[{"(", 
           RowBox[{"PDFerror1", " ", "PDFerror2"}], ")"}]}], " ", 
         RowBox[{"1", "/", "4"}], " ", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"list1", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"2", "*", "iset"}], " ", "+", " ", "1"}], "]"}], 
               "]"}], " ", "-", " ", 
              RowBox[{"list1", "[", 
               RowBox[{"[", 
                RowBox[{"2", "*", "iset"}], "]"}], "]"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"list2", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"2", "*", "iset"}], " ", "+", " ", "1"}], "]"}], 
               "]"}], " ", "-", " ", 
              RowBox[{"list2", "[", 
               RowBox[{"[", 
                RowBox[{"2", "*", "iset"}], "]"}], "]"}]}], ")"}]}], ",", " ", 
           RowBox[{"{", 
            RowBox[{"iset", ",", " ", "1", ",", " ", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"Neigen", " ", "-", " ", "1"}], ")"}], "/", "2"}]}], 
            "}"}]}], "]"}]}]}]}], "\n", "   ", "]"}]}], ";"}], 
   "\n"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.725988747095153*^9, 3.7259888051507053`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Table", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"pdfHessianCorrelationVectorfake", "[", 
          RowBox[{
           RowBox[{"List", "@@", 
            RowBox[{
             RowBox[{
              RowBox[{"fxQsamept2classfinal", "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", 
                 RowBox[{"0", "+", "6"}]}], "]"}], "]"}], "[", 
              RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"ipt", ",", 
               RowBox[{"3", ";;", 
                RowBox[{"-", "1"}]}]}], "]"}], "]"}]}], ",", 
           RowBox[{"List", "@@", 
            RowBox[{
             RowBox[{
              RowBox[{"residualNsetclassfinal", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "[", 
              RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"ipt", ",", 
               RowBox[{"3", ";;", 
                RowBox[{"-", "1"}]}]}], "]"}], "]"}]}]}], " ", "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"ipt", ",", "5"}], "}"}]}], "\[IndentingNewLine]", "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"iexpt", ",", "2"}], "}"}]}], "\[IndentingNewLine]", "]"}], 
     ",", "1"}], "]"}], "//", "Dimensions"}]}]], "Input",
 CellChangeTimes->{{3.72598903759513*^9, 3.725989037677026*^9}, {
  3.725989112730134*^9, 3.7259892130601683`*^9}, {3.7259892687689247`*^9, 
  3.7259893051291533`*^9}, {3.725989386555142*^9, 3.725989442508317*^9}, {
  3.725990106164198*^9, 3.7259901200204563`*^9}, {3.72599015619811*^9, 
  3.725990202252593*^9}}],

Cell[BoxData[
 TemplateBox[{
  "Part","partd",
   "\"Part specification \\!\\(\\*RowBox[{\\\"fxQsamept2classfinal\\\", \\\"\
\[LeftDoubleBracket]\\\", RowBox[{\\\"1\\\", \\\",\\\", \\\"6\\\"}], \\\"\
\[RightDoubleBracket]\\\"}]\\) is longer than depth of object.\"",2,3,1,
   25905414409066200839,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.732017117021825*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","pspec1",
   "\"Part specification \\!\\(\\*RowBox[{\\\"\\\\\\\"data\\\\\\\"\\\"}]\\) \
is not applicable.\"",2,3,2,25905414409066200839,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7320171170292892`*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","partd",
   "\"Part specification \\!\\(\\*RowBox[{\\\"residualNsetclassfinal\\\", \
\\\"\[LeftDoubleBracket]\\\", \\\"1\\\", \\\"\[RightDoubleBracket]\\\"}]\\) \
is longer than depth of object.\"",2,3,3,25905414409066200839,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.732017117036508*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","pspec1",
   "\"Part specification \\!\\(\\*RowBox[{\\\"\\\\\\\"data\\\\\\\"\\\"}]\\) \
is not applicable.\"",2,3,4,25905414409066200839,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.732017117043606*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","argm",
   "\"\\!\\(\\*RowBox[{\\\"Part\\\"}]\\) called with \\!\\(\\*RowBox[{\\\"0\\\
\"}]\\) arguments; \\!\\(\\*RowBox[{\\\"1\\\"}]\\) or more arguments are \
expected.\"",2,3,5,25905414409066200839,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.732017117044552*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"pdfHessianCorrelationfake: both arguments must be \
lists\"\>"], "Print",
 CellChangeTimes->{3.732017117052128*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Stop, an even number of eigenvectors: \"\>", 
   "\[InvisibleSpace]", "0"}],
  SequenceForm["Stop, an even number of eigenvectors: ", 0],
  Editable->False]], "Print",
 CellChangeTimes->{3.732017117053372*^9}]
}, Open  ]],

Cell[BoxData[
 TemplateBox[{
  "Part","partd",
   "\"Part specification \\!\\(\\*RowBox[{\\\"fxQsamept2classfinal\\\", \\\"\
\[LeftDoubleBracket]\\\", RowBox[{\\\"1\\\", \\\",\\\", \\\"6\\\"}], \\\"\
\[RightDoubleBracket]\\\"}]\\) is longer than depth of object.\"",2,3,6,
   25905414409066200839,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.732017117054543*^9}],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"Part\\\", \\\"::\\\", \
\\\"partd\\\"}], \\\"MessageName\\\"]\\) will be suppressed during this \
calculation.\"",2,3,7,25905414409066200839,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.732017117061426*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","pspec1",
   "\"Part specification \\!\\(\\*RowBox[{\\\"\\\\\\\"data\\\\\\\"\\\"}]\\) \
is not applicable.\"",2,3,8,25905414409066200839,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.732017117068705*^9}],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"Part\\\", \\\"::\\\", \
\\\"pspec1\\\"}], \\\"MessageName\\\"]\\) will be suppressed during this \
calculation.\"",2,3,9,25905414409066200839,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.732017117075777*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","take",
   "\"Cannot take positions \\!\\(\\*RowBox[{\\\"3\\\"}]\\) through \
\\!\\(\\*RowBox[{\\\"-\\\", \\\"1\\\"}]\\) in \
\\!\\(\\*RowBox[{\\\"\\\\\\\"data\\\\\\\"\\\"}]\\).\"",2,3,10,
   25905414409066200839,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.732017117083301*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","take",
   "\"Cannot take positions \\!\\(\\*RowBox[{\\\"3\\\"}]\\) through \
\\!\\(\\*RowBox[{\\\"-\\\", \\\"1\\\"}]\\) in \
\\!\\(\\*RowBox[{\\\"\\\\\\\"data\\\\\\\"\\\"}]\\).\"",2,3,11,
   25905414409066200839,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.732017117090757*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","partw",
   "\"Part \\!\\(\\*RowBox[{\\\"3\\\"}]\\) of \
\\!\\(\\*RowBox[{RowBox[{\\\"fxQsamept2classfinal\\\", \\\"\
\[LeftDoubleBracket]\\\", RowBox[{\\\"1\\\", \\\",\\\", \\\"6\\\"}], \\\"\
\[RightDoubleBracket]\\\"}], \\\"\[LeftDoubleBracket]\\\", \\\"\\\\\\\"data\\\
\\\\\"\\\", \\\"\[RightDoubleBracket]\\\"}]\\) does not exist.\"",2,3,12,
   25905414409066200839,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.732017117098042*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","partw",
   "\"Part \\!\\(\\*RowBox[{\\\"3\\\"}]\\) of \
\\!\\(\\*RowBox[{RowBox[{\\\"residualNsetclassfinal\\\", \\\"\
\[LeftDoubleBracket]\\\", \\\"1\\\", \\\"\[RightDoubleBracket]\\\"}], \\\"\
\[LeftDoubleBracket]\\\", \\\"\\\\\\\"data\\\\\\\"\\\", \\\"\
\[RightDoubleBracket]\\\"}]\\) does not exist.\"",2,3,13,25905414409066200839,
   "New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7320171171050177`*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","partw",
   "\"Part \\!\\(\\*RowBox[{\\\"4\\\"}]\\) of \
\\!\\(\\*RowBox[{RowBox[{\\\"fxQsamept2classfinal\\\", \\\"\
\[LeftDoubleBracket]\\\", RowBox[{\\\"1\\\", \\\",\\\", \\\"6\\\"}], \\\"\
\[RightDoubleBracket]\\\"}], \\\"\[LeftDoubleBracket]\\\", \\\"\\\\\\\"data\\\
\\\\\"\\\", \\\"\[RightDoubleBracket]\\\"}]\\) does not exist.\"",2,3,14,
   25905414409066200839,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.732017117111855*^9}],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"Part\\\", \\\"::\\\", \
\\\"partw\\\"}], \\\"MessageName\\\"]\\) will be suppressed during this \
calculation.\"",2,3,15,25905414409066200839,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.732017117119075*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","argm",
   "\"\\!\\(\\*RowBox[{\\\"Part\\\"}]\\) called with \\!\\(\\*RowBox[{\\\"0\\\
\"}]\\) arguments; \\!\\(\\*RowBox[{\\\"1\\\"}]\\) or more arguments are \
expected.\"",2,3,16,25905414409066200839,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.732017117125792*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"pdfHessianCorrelationfake: both arguments must be \
lists\"\>"], "Print",
 CellChangeTimes->{3.732017117132578*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Stop, an even number of eigenvectors: \"\>", 
   "\[InvisibleSpace]", "0"}],
  SequenceForm["Stop, an even number of eigenvectors: ", 0],
  Editable->False]], "Print",
 CellChangeTimes->{3.732017117133664*^9}]
}, Open  ]],

Cell[BoxData[
 TemplateBox[{
  "Part","take",
   "\"Cannot take positions \\!\\(\\*RowBox[{\\\"3\\\"}]\\) through \
\\!\\(\\*RowBox[{\\\"-\\\", \\\"1\\\"}]\\) in \
\\!\\(\\*RowBox[{\\\"\\\\\\\"data\\\\\\\"\\\"}]\\).\"",2,3,17,
   25905414409066200839,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.732017117134836*^9}],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"Part\\\", \\\"::\\\", \
\\\"take\\\"}], \\\"MessageName\\\"]\\) will be suppressed during this \
calculation.\"",2,3,18,25905414409066200839,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.732017117141919*^9}],

Cell[BoxData[
 RowBox[{"{", "10", "}"}]], "Output",
 CellChangeTimes->{
  3.72598921603798*^9, {3.725989270211203*^9, 3.7259893062891283`*^9}, 
   3.72598944945487*^9, {3.7259901671697903`*^9, 3.725990202872376*^9}, 
   3.73201711714859*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "test", " ", "if", " ", "the", " ", "ID", " ", "in", " ", "in", " ", "the",
     " ", "fit", " ", "of", " ", "the", " ", "PDF", " ", "with", " ", 
    "PDFname"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"InPDFFitQ", "[", 
     RowBox[{"IDin_", ",", "PDFnamein_"}], "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ID", "=", "IDin"}], ",", 
        RowBox[{"PDFname", "=", "PDFnamein"}], ",", "IDinCT14", ",", 
        "IDinCT14HERA2", ",", "IDinCT14HERA2NoJet", ",", "output"}], "}"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"IDinCT14", "=", 
        RowBox[{"{", 
         RowBox[{
         "159", ",", "101", ",", "102", ",", "104", ",", "106", ",", "108", 
          ",", "109", ",", "110", ",", "111", ",", "124", ",", "125", ",", 
          "126", ",", "127", ",", "147", ",", "145", ",", "169", ",", "201", 
          ",", "203", ",", "204", ",", "225", ",", "227", ",", "234", ",", 
          "260", ",", "261", ",", "267", ",", "268", ",", "240", ",", "241", 
          ",", "281", ",", "266", ",", "504", ",", "514", ",", "535", ",", 
          "538"}], "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"IDinCT14HERA2", "=", 
        RowBox[{"{", 
         RowBox[{
         "160", ",", "101", ",", "102", ",", "104", ",", "108", ",", "109", 
          ",", "110", ",", "111", ",", "124", ",", "125", ",", "126", ",", 
          "127", ",", "147", ",", "145", ",", "169", ",", "201", ",", "203", 
          ",", "204", ",", "225", ",", "227", ",", "234", ",", "260", ",", 
          "261", ",", "267", ",", "268", ",", "240", ",", "241", ",", "281", 
          ",", "266", ",", "504", ",", "514", ",", "535", ",", "538"}], 
         "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"IDinCT14HERA2NoJet", "=", 
        RowBox[{"{", 
         RowBox[{
         "160", ",", "101", ",", "102", ",", "104", ",", "108", ",", "109", 
          ",", "110", ",", "111", ",", "124", ",", "125", ",", "126", ",", 
          "127", ",", "147", ",", "145", ",", "169", ",", "201", ",", "203", 
          ",", "204", ",", "225", ",", "227", ",", "234", ",", "260", ",", 
          "261", ",", "267", ",", "268", ",", "240", ",", "241", ",", "281", 
          ",", "266"}], "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"output", "=", "\[IndentingNewLine]", 
        RowBox[{"Switch", "[", "\[IndentingNewLine]", 
         RowBox[{
         "PDFname", ",", "\[IndentingNewLine]", "\"\<CT14NNLO\>\"", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Intersection", "[", 
              RowBox[{"IDinCT14", ",", 
               RowBox[{"{", "ID", "}"}]}], "]"}], "\[Equal]", 
             RowBox[{"{", "ID", "}"}]}], ",", "1", ",", "0"}], "]"}], ",", 
          "\[IndentingNewLine]", "\"\<CT14HERA2NNLO\>\"", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Intersection", "[", 
              RowBox[{"IDinCT14HERA2", ",", 
               RowBox[{"{", "ID", "}"}]}], "]"}], "\[Equal]", 
             RowBox[{"{", "ID", "}"}]}], ",", "1", ",", "0"}], "]"}], ",", 
          "\[IndentingNewLine]", "\"\<CT14HERA2_no_jet\>\"", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Intersection", "[", 
              RowBox[{"IDinCT14HERA2NoJet", ",", 
               RowBox[{"{", "ID", "}"}]}], "]"}], "\[Equal]", 
             RowBox[{"{", "ID", "}"}]}], ",", "1", ",", "0"}], "]"}], ",", 
          "\[IndentingNewLine]", "\"\<CT14HERA2NNLONoJet\>\"", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Intersection", "[", 
              RowBox[{"IDinCT14HERA2NoJet", ",", 
               RowBox[{"{", "ID", "}"}]}], "]"}], "\[Equal]", 
             RowBox[{"{", "ID", "}"}]}], ",", "1", ",", "0"}], "]"}], ",", 
          "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
           "Print", "[", "\"\<error, input PDFname is not in the list\>\"", 
            "]"}], ";", 
           RowBox[{"Abort", "[", "]"}]}]}], "\[IndentingNewLine]", 
         "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"give", " ", "data", " ", "type", " ", "by", " ", "DIS"}], ",", 
     " ", "VBP", ",", " ", "JP"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ExptIDType", "[", "IDin_", "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ID", "=", "IDin"}], ",", "output"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"output", "=", 
        RowBox[{"Which", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"ID", "\[GreaterEqual]", "100"}], "&&", 
           RowBox[{"ID", "<", "200"}]}], ",", "1", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"ID", "\[GreaterEqual]", "200"}], "&&", 
           RowBox[{"ID", "<", "300"}]}], ",", "2", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"ID", "\[GreaterEqual]", "500"}], "&&", 
           RowBox[{"ID", "<", "600"}]}], ",", "5"}], "\[IndentingNewLine]", 
         "]"}]}], ";", "\[IndentingNewLine]", "output"}]}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], 
   "\[IndentingNewLine]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.726005965523291*^9, 3.726006082468295*^9}, {
  3.7260061491057587`*^9, 3.7260063485752153`*^9}, {3.726006393345347*^9, 
  3.7260066180288973`*^9}, {3.7260066576783323`*^9, 3.726006684037438*^9}, {
  3.7260068920028143`*^9, 3.726006958365703*^9}, {3.72600700160465*^9, 
  3.72600707838699*^9}, {3.72600712099609*^9, 3.72600713427421*^9}, {
  3.726007190963006*^9, 3.726007231901359*^9}, {3.7260075652843523`*^9, 
  3.726007581856642*^9}, {3.733293202805057*^9, 3.733293210734866*^9}, {
  3.7332934354359922`*^9, 3.733293435989653*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "this", " ", "function", " ", "transfer", " ", "the", " ", "list", " ", 
    "elements", " ", "into", " ", "the", " ", "tsv", " ", "output"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"TotsvVector", "[", "veclistin_", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"veclist", "=", "veclistin"}], ",", "vectorstr"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"change", " ", "the", " ", "number", " ", "format"}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"to", " ", "string"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vectorstr", "=", 
       RowBox[{"StringJoin", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"ToString", "[", "#", "]"}], "<>", "\"\<\\t\>\""}], ")"}],
           "&"}], "/@", "veclist"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"vectorstr", "=", 
       RowBox[{"vectorstr", "<>", "\"\<\\n\>\""}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", "output", "*)"}], "\[IndentingNewLine]", "vectorstr"}]}], 
    "\[IndentingNewLine]", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.7257921246906853`*^9, 3.725792311793171*^9}, {
  3.7257923480832043`*^9, 3.725792408175828*^9}, {3.7257924656351643`*^9, 
  3.725792492124542*^9}, {3.725811273110304*^9, 3.72581129148731*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"GatherByNptSpecified", "[", 
     RowBox[{"specifieddatain_", ",", "ptindexlistin_"}], "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"specifieddata", "=", "specifieddatain"}], ",", 
        RowBox[{"ptindexlist", "=", "ptindexlistin"}], ",", "Npt1", ",", 
        "Npt2", ",", "outputin"}], "}"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Npt1", "=", 
        RowBox[{"Length", "[", "specifieddata", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Npt2", "=", 
        RowBox[{"Length", "[", "ptindexlist", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"Npt1", "\[NotEqual]", "Npt2"}], ",", 
         RowBox[{
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<error, the length of input data should be the same as the ipt \
index list, {Ndata, Niptlist} = \>\"", ",", 
            RowBox[{"{", 
             RowBox[{"Npt1", ",", "Npt2"}], "}"}]}], "]"}], ";", 
          RowBox[{"Abort", "[", "]"}]}]}], " ", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
        "gather", " ", "the", " ", "specified", " ", "data", " ", "by", " ", 
         "the", " ", "pt", " ", "index"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"outputin", "=", 
        RowBox[{"GatherBy", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"ptindexlist", ",", "specifieddata"}], "}"}], "//", 
           "Transpose"}], ",", 
          RowBox[{
           RowBox[{"#", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "&"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
        "the", " ", "dimension", " ", "of", " ", "the", " ", "output", " ", 
         "is", " ", 
         RowBox[{"{", 
          RowBox[{"groups", ",", 
           RowBox[{"data", " ", "in", " ", "the", " ", "same", " ", "group"}],
            ",", " ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"pt", " ", "index"}], ",", " ", "data"}], "}"}]}], 
          "}"}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
        "we", " ", "only", " ", "take", " ", "the", " ", "data", " ", 
         "part"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"outputin", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "All", ",", "2"}], "]"}], "]"}]}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DeleteDuplicatesByNptSpecified", "[", 
    RowBox[{"specifieddatain_", ",", "ptindexlistin_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"specifieddata", "=", "specifieddatain"}], ",", 
       RowBox[{"ptindexlist", "=", "ptindexlistin"}], ",", "Npt1", ",", 
       "Npt2", ",", "outputin"}], "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Npt1", "=", 
       RowBox[{"Length", "[", "specifieddata", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Npt2", "=", 
       RowBox[{"Length", "[", "ptindexlist", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Npt1", "\[NotEqual]", "Npt2"}], ",", 
        RowBox[{
         RowBox[{"Print", "[", 
          RowBox[{
          "\"\<error, the length of input data should be the same as the ipt \
index list, {Ndata, Niptlist} = \>\"", ",", 
           RowBox[{"{", 
            RowBox[{"Npt1", ",", "Npt2"}], "}"}]}], "]"}], ";", 
         RowBox[{"Abort", "[", "]"}]}]}], " ", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
       "delete", " ", "the", " ", "duplicate", " ", "data", " ", "by", " ", 
        "the", " ", "specified", " ", "data", " ", "by", " ", "the", " ", 
        "pt", " ", "index"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"outputin", "=", 
       RowBox[{"DeleteDuplicatesBy", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"ptindexlist", ",", "specifieddata"}], "}"}], "//", 
          "Transpose"}], ",", 
         RowBox[{
          RowBox[{"#", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "&"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
       "the", " ", "dimension", " ", "of", " ", "the", " ", "output", " ", 
        "is", " ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"left", " ", "data"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"pt", " ", "index"}], ",", " ", "data"}], "}"}]}], 
         "}"}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
       "we", " ", "only", " ", "take", " ", "the", " ", "data", " ", "part"}],
        "*)"}], "\[IndentingNewLine]", 
      RowBox[{"outputin", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "2"}], "]"}], "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\[IndentingNewLine]"}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.731955388394079*^9, 3.7319553988669443`*^9}, 
   3.731955444537608*^9, {3.731969193195204*^9, 3.731969244374816*^9}, {
   3.731969291629718*^9, 3.731969467882964*^9}, {3.731969560469057*^9, 
   3.73196958364359*^9}, {3.731970238783201*^9, 3.731970280411231*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"processdatatotsv", "[", 
   RowBox[{"(*", 
    RowBox[{"corrfxQdtaobsclassin_", ","}], "*)"}], 
   RowBox[{"configargumentsin_", ",", "plottypein_", ",", "flavourin_"}], 
   "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"configarguments", "=", "configargumentsin"}], ",", 
      RowBox[{"plottype", "=", "plottypein"}], ",", "\[IndentingNewLine]", 
      "Jobid", ",", "JobDescription", 
      RowBox[{"(*", "20171128", "*)"}], ",", "PDFname", ",", "FigureType", 
      ",", "FigureFlag", ",", "ExptidType", ",", "ExptidFlag", ",", 
      "CorrelationArgType", ",", "CorrelationArgFlag", ",", 
      RowBox[{"(*", 
       RowBox[{"UserArgName", ",", "UserArgValue", ","}], "*)"}], "\n", 
      "XQfigureXrange", ",", "XQfigureYrange", ",", "ColorPaletterange", 
      RowBox[{"(*", "20171128", "*)"}], ",", "Hist1figureNbin", ",", 
      RowBox[{"(*", 
       RowBox[{"Hist1figureXrange", ",", "Hist1figureYrange", ","}], "*)"}], 
      "\n", 
      RowBox[{"(*", 
       RowBox[{"ColorSeperator", ","}], "*)"}], "\n", "Size", ",", 
      "HighlightType", ",", "HighlightMode", ",", "HighlightMode1", ",", 
      "HighlightMode2", ",", "\[IndentingNewLine]", "userdifinefuncfilename", 
      ",", "UserArgName", ",", "MetadataList", ",", "VecList", ",", "Nexpt", 
      ",", "Npt", ",", "ExptID", ",", "inputdata", ",", "residualNormList", 
      ",", "outputfile", ",", "Nflavour", ",", "iRawdataResidual", ",", 
      "RawNpt", ",", "TotalRawChi2", ",", "SensNormalize", ",", 
      "MetadataListRaw", ",", "\[IndentingNewLine]", "VecListRaw", ",", 
      "residualNormListRaw", ",", "iptpos", ",", "plottypestr"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
     "read", " ", "arguments", " ", "in", " ", "config", " ", "file"}], 
     "*)"}], "\n", 
    RowBox[{"(*", 
     RowBox[{
     "===", "===", "===", "===", "===", "===", "===", "===", "===", "==="}], 
     "*)"}], "\n", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Jobid", ",", "JobDescription", 
        RowBox[{"(*", "20171128", "*)"}], ",", "PDFname", ",", "FigureType", 
        ",", "FigureFlag", ",", "ExptidType", ",", "ExptidFlag", ",", 
        "CorrelationArgType", ",", "CorrelationArgFlag", ",", 
        RowBox[{"(*", 
         RowBox[{"UserArgName", ",", "UserArgValue", ","}], "*)"}], "\n", 
        "XQfigureXrange", ",", "XQfigureYrange", ",", "ColorPaletterange", 
        RowBox[{"(*", "20171128", "*)"}], ",", "Hist1figureNbin", ",", 
        RowBox[{"(*", 
         RowBox[{"Hist1figureXrange", ",", "Hist1figureYrange", ","}], "*)"}],
         "\n", 
        RowBox[{"(*", 
         RowBox[{"ColorSeperator", ","}], "*)"}], "\n", "Size", ",", 
        "HighlightType", ",", "HighlightMode", ",", "HighlightMode1", ",", 
        "HighlightMode2"}], "}"}], "=", "configarguments"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"20171109", ":", " ", 
       RowBox[{"seperate", " ", "user", " ", "difine", " ", 
        RowBox[{"function", "/", "data"}], " ", "IO", " ", "and", " ", 
        "configure", " ", "file"}]}], "*)"}], 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"20171116", ":"}], " ", "->", "ReadUserFunctionV2"}], ",", 
       " ", 
       RowBox[{
       "which", " ", "read", " ", "Expression", " ", "from", " ", "the", " ", 
        "file"}]}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"20171119", " ", "new", " ", "user", " ", "function", " ", 
       RowBox[{"format", ":", " ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"user", " ", "name", " ", "1"}], ",", " ", 
            RowBox[{"user", " ", "function", " ", "1"}]}], "}"}], ",", " ", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"user", " ", "name", " ", "2"}], ",", " ", 
             RowBox[{"user", " ", "function", " ", "2"}]}], "}"}], "..."}]}], 
         "}"}]}]}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"userdifinefuncfilename", "=", "\"\<user_func.txt\>\""}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"UserArgName", ",", "UserArgValue"}], "}"}], "=", 
        RowBox[{"ReadUserFunctionV2", "[", 
         RowBox[{"\"\<./\>\"", ",", "userdifinefuncfilename"}], "]"}]}], 
       ";"}], "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"(*", "20171127", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"CorrelationArgFlag", "[", 
         RowBox[{"[", 
          RowBox[{"-", "1"}], "]"}], "]"}], "\[Equal]", "1"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"UserArgName", "=", 
          RowBox[{"ReadUserFunctionV3", "[", 
           RowBox[{"\"\<./\>\"", ",", "userdifinefuncfilename"}], "]"}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"UserArgName", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "&"}], "/@", "UserArgName"}]}], 
         ";"}], "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
        "20171217", " ", "define", " ", "global", " ", "variable", " ", "for",
          " ", "username"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"UserArgName", "=", "UserNameGlobal"}], ";", 
        "\[IndentingNewLine]", "\"\<dummy\>\""}]}], "\[IndentingNewLine]", 
      "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
      "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
        "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
       "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
        "===", "===", "===", "===", "===", "===", "===", "===", "===", "=="}],
       "*)"}], "\n", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"Data", " ", "organization"}], "===", "===", "===", "===", "===",
        "===", "===", "===", "===", "===", "===", 
       RowBox[{"==", 
        RowBox[{
        "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
         "===", "===", "===", "===", "===", "===", "===", "===", "===", 
         RowBox[{"==", 
          RowBox[{"===", "===", "===", "===", "=="}]}]}]}]}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
      "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
        "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
       "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
        "===", "===", "===", "===", "===", "===", "===", "===", "===", "=="}],
       "*)"}], "\[IndentingNewLine]", "corrdataclassfinal", ";", 
     "\[IndentingNewLine]", "dRcorrdataclassfinal", ";", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "expterrordataclassfinal", ",", "residualdataclassfinal", ",", 
       "dRdataclassfinal"}], "}"}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
      "determine", " ", "the", " ", "input", " ", "data", " ", "based", " ", 
       "on", " ", "the", " ", "plot", " ", "type"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"inputdata", "=", 
      RowBox[{"Switch", "[", "\[IndentingNewLine]", 
       RowBox[{
       "plottype", ",", "\[IndentingNewLine]", "1", ",", 
        "\[IndentingNewLine]", "dRdataclassfinal", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"because", " ", "the", " ", 
           RowBox[{"correlation", "/", "sensitivity"}], " ", "data", " ", 
           "are", " ", "possible", " ", "to", " ", "be", " ", "throw", " ", 
           "away", " ", "for", " ", "bad", " ", "values"}], ",", " ", 
          RowBox[{
          "we", " ", "just", " ", "use", " ", "\[Delta]r", " ", "data", " ", 
           "to", " ", "get", " ", 
           RowBox[{"(", 
            RowBox[{"x", ",", "Q"}], ")"}], " ", "values"}]}], "*)"}], ",", 
        "\[IndentingNewLine]", "2", ",", "\[IndentingNewLine]", 
        "expterrordataclassfinal", ",", "\[IndentingNewLine]", "3", ",", 
        "\[IndentingNewLine]", "residualdataclassfinal", ",", 
        "\[IndentingNewLine]", "4", ",", "\[IndentingNewLine]", 
        "dRdataclassfinal", ",", "\[IndentingNewLine]", "5", ",", 
        "\[IndentingNewLine]", "dRcorrdataclassfinal", ",", 
        "\[IndentingNewLine]", "6", ",", "\[IndentingNewLine]", 
        "corrdataclassfinal"}], "\[IndentingNewLine]", "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Nexpt", "=", 
      RowBox[{"Length", "[", "inputdata", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
      "make", " ", "meta", " ", "data", " ", "for", " ", "the", " ", "input", 
       " ", "data"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"MetadataList", "=", "\[IndentingNewLine]", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Npt", "=", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"plottype", ">=", "1"}], " ", "&&", " ", 
              RowBox[{"plottype", "\[LessEqual]", "4"}]}], ")"}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"inputdata", "[", 
               RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
              RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "//", "Length"}], 
            ",", 
            RowBox[{
             RowBox[{
              RowBox[{"inputdata", "[", 
               RowBox[{"[", 
                RowBox[{"iexpt", ",", 
                 RowBox[{"flavourin", "+", "6"}]}], "]"}], "]"}], "[", 
              RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "//", "Length"}]}], 
           " ", "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"ExptID", "=", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"plottype", ">=", "1"}], " ", "&&", " ", 
                 RowBox[{"plottype", "\[LessEqual]", "4"}]}], ")"}], ",", 
               RowBox[{
                RowBox[{"inputdata", "[", 
                 RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{"\"\<exptinfo\>\"", ",", "\"\<exptid\>\""}], "]"}], 
                "]"}], ",", 
               RowBox[{
                RowBox[{"inputdata", "[", 
                 RowBox[{"[", 
                  RowBox[{"iexpt", ",", 
                   RowBox[{"flavourin", "+", "6"}]}], "]"}], "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{"\"\<exptinfo\>\"", ",", "\"\<exptid\>\""}], "]"}], 
                "]"}]}], " ", "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"If", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"plottype", ">=", "1"}], " ", "&&", " ", 
                RowBox[{"plottype", "\[LessEqual]", "4"}]}], ")"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"InPDFFitQ", "[", 
                 RowBox[{"ExptID", ",", "PDFname"}], "]"}], ",", 
                RowBox[{"ExptIDType", "[", "ExptID", "]"}], ",", "ExptID", 
                ",", "ipt", ",", 
                RowBox[{
                 RowBox[{
                  RowBox[{"inputdata", "[", 
                   RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                  RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{"ipt", ",", "1"}], "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{
                  RowBox[{"inputdata", "[", 
                   RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                  RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{"ipt", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"InPDFFitQ", "[", 
                 RowBox[{"ExptID", ",", "PDFname"}], "]"}], ",", 
                RowBox[{"ExptIDType", "[", "ExptID", "]"}], ",", "ExptID", 
                ",", "ipt", ",", 
                RowBox[{
                 RowBox[{
                  RowBox[{"inputdata", "[", 
                   RowBox[{"[", 
                    RowBox[{"iexpt", ",", 
                    RowBox[{"flavourin", "+", "6"}]}], "]"}], "]"}], "[", 
                  RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{"ipt", ",", "1"}], "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{
                  RowBox[{"inputdata", "[", 
                   RowBox[{"[", 
                    RowBox[{"iexpt", ",", 
                    RowBox[{"flavourin", "+", "6"}]}], "]"}], "]"}], "[", 
                  RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{"ipt", ",", "2"}], "]"}], "]"}]}], "}"}]}], 
             "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"ipt", ",", "Npt"}], "}"}]}], "\[IndentingNewLine]", 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"iexpt", ",", "Nexpt"}], "}"}]}], "\[IndentingNewLine]", 
       "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"for", " ", "each", " ", "ID"}], ",", " ", 
       RowBox[{
       "output", " ", "the", " ", "corresponding", " ", "tsv", " ", 
        "output"}]}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"VecList", "=", "\[IndentingNewLine]", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Switch", "[", "\[IndentingNewLine]", 
         RowBox[{
         "plottype", ",", "\[IndentingNewLine]", "1", ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"ExptID", "=", 
            RowBox[{
             RowBox[{"inputdata", "[", 
              RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"\"\<exptinfo\>\"", ",", "\"\<exptid\>\""}], "]"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"inputdata", "[", 
              RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
             RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "/.", 
            RowBox[{
             RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
             RowBox[{
              RowBox[{"{", "a", "}"}], "[", 
              RowBox[{"[", "3", "]"}], "]"}]}]}]}], 
          RowBox[{"(*", 
           RowBox[{"{", 
            RowBox[{"(*", 
             RowBox[{"PDFname", ",", "ExptID", ","}], "*)"}], 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"FigureFlag", "[", 
                RowBox[{"[", "plottype", "]"}], "]"}], "\[Equal]", 
               RowBox[{"-", "1"}]}], ",", 
              RowBox[{
               RowBox[{"{", "a", "}"}], "[", 
               RowBox[{"[", "3", "]"}], "]"}], ",", 
              RowBox[{"Abs", "[", 
               RowBox[{
                RowBox[{"{", "a", "}"}], "[", 
                RowBox[{"[", "3", "]"}], "]"}], " ", "]"}]}], " ", "]"}], 
            "}"}], "*)"}], ",", "\[IndentingNewLine]", "2", ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"ExptID", "=", 
            RowBox[{
             RowBox[{"inputdata", "[", 
              RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"\"\<exptinfo\>\"", ",", "\"\<exptid\>\""}], "]"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"inputdata", "[", 
              RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
             RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "/.", 
            RowBox[{
             RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
             RowBox[{
              RowBox[{"{", "a", "}"}], "[", 
              RowBox[{"[", "3", "]"}], "]"}]}]}]}], 
          RowBox[{"(*", 
           RowBox[{"{", 
            RowBox[{"(*", 
             RowBox[{"PDFname", ",", "ExptID", ","}], "*)"}], 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"FigureFlag", "[", 
                RowBox[{"[", "plottype", "]"}], "]"}], "\[Equal]", 
               RowBox[{"-", "1"}]}], ",", 
              RowBox[{
               RowBox[{"{", "a", "}"}], "[", 
               RowBox[{"[", "3", "]"}], "]"}], ",", 
              RowBox[{"Abs", "[", 
               RowBox[{
                RowBox[{"{", "a", "}"}], "[", 
                RowBox[{"[", "3", "]"}], "]"}], " ", "]"}]}], " ", "]"}], 
            "}"}], "*)"}], ",", "\[IndentingNewLine]", "3", ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"ExptID", "=", 
            RowBox[{
             RowBox[{"inputdata", "[", 
              RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"\"\<exptinfo\>\"", ",", "\"\<exptid\>\""}], "]"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"20180301", ",", " ", 
             RowBox[{"r_iset", " ", "\[Rule]", " ", 
              RowBox[{"(", 
               RowBox[{"r_iset", "-", 
                RowBox[{"r_", "0"}]}], ")"}]}]}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"residualNsetclassfinal", "[", 
              RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
             RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "/.", 
            RowBox[{
             RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Drop", "[", 
                RowBox[{
                 RowBox[{"{", "a", "}"}], ",", "3"}], "]"}], "-", 
               RowBox[{
                RowBox[{"{", "a", "}"}], "[", 
                RowBox[{"[", "3", "]"}], "]"}]}], ")"}]}]}]}], 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"inputdata", "[", 
              RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
             RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "/.", 
            RowBox[{
             RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
             RowBox[{"{", 
              RowBox[{"(*", 
               RowBox[{"PDFname", ",", "ExptID", ","}], "*)"}], 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"FigureFlag", "[", 
                  RowBox[{"[", "plottype", "]"}], "]"}], "\[Equal]", 
                 RowBox[{"-", "1"}]}], ",", 
                RowBox[{
                 RowBox[{"{", "a", "}"}], "[", 
                 RowBox[{"[", "3", "]"}], "]"}], ",", 
                RowBox[{"Abs", "[", 
                 RowBox[{
                  RowBox[{"{", "a", "}"}], "[", 
                  RowBox[{"[", "3", "]"}], "]"}], " ", "]"}]}], " ", "]"}], 
              "}"}]}]}], "*)"}], ",", "\[IndentingNewLine]", "4", ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"ExptID", "=", 
            RowBox[{
             RowBox[{"inputdata", "[", 
              RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"\"\<exptinfo\>\"", ",", "\"\<exptid\>\""}], "]"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"inputdata", "[", 
              RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
             RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "/.", 
            RowBox[{
             RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
             RowBox[{
              RowBox[{"{", "a", "}"}], "[", 
              RowBox[{"[", "3", "]"}], "]"}]}]}]}], 
          RowBox[{"(*", 
           RowBox[{"{", 
            RowBox[{"(*", 
             RowBox[{"PDFname", ",", "ExptID", ","}], "*)"}], 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"FigureFlag", "[", 
                RowBox[{"[", "plottype", "]"}], "]"}], "\[Equal]", 
               RowBox[{"-", "1"}]}], ",", 
              RowBox[{
               RowBox[{"{", "a", "}"}], "[", 
               RowBox[{"[", "3", "]"}], "]"}], ",", 
              RowBox[{"Abs", "[", 
               RowBox[{
                RowBox[{"{", "a", "}"}], "[", 
                RowBox[{"[", "3", "]"}], "]"}], " ", "]"}]}], " ", "]"}], 
            "}"}], "*)"}], ",", "\[IndentingNewLine]", "5", ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"ExptID", "=", 
            RowBox[{
             RowBox[{"inputdata", "[", 
              RowBox[{"[", 
               RowBox[{"iexpt", ",", 
                RowBox[{"flavourin", "+", "6"}]}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"\"\<exptinfo\>\"", ",", "\"\<exptid\>\""}], "]"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"Npt", "=", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"plottype", ">=", "1"}], " ", "&&", " ", 
                RowBox[{"plottype", "\[LessEqual]", "4"}]}], ")"}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"inputdata", "[", 
                 RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "//", "Length"}], 
              ",", 
              RowBox[{
               RowBox[{
                RowBox[{"inputdata", "[", 
                 RowBox[{"[", 
                  RowBox[{"iexpt", ",", 
                   RowBox[{"flavourin", "+", "6"}]}], "]"}], "]"}], "[", 
                RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "//", "Length"}]}],
              " ", "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{"define", " ", "the", " ", "sqrt", 
              RowBox[{"(", 
               RowBox[{"Sum", " ", 
                SuperscriptBox["r", "2"]}], ")"}], " ", "as", " ", 
              "normalization", " ", "factor"}], "*)"}], "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"iRawdataResidual", "=", 
              RowBox[{
               RowBox[{"Position", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"dtacentralclassfinal", "[", 
                   RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                  RowBox[{"[", "\"\<label\>\"", "]"}], "]"}], ",", 
                 "\"\<ReducedChi2\>\""}], "]"}], "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"RawNpt", "=", 
              RowBox[{
               RowBox[{
                RowBox[{"dtacentralclassfinal", "[", 
                 RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "//", "Length"}]}],
              ";", "\[IndentingNewLine]", 
             RowBox[{"TotalRawChi2", "=", 
              RowBox[{"Sum", "[", 
               RowBox[{
                RowBox[{"Abs", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"dtacentralclassfinal", "[", 
                    RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                   RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"irawpt", ",", "iRawdataResidual"}], "]"}], "]"}], 
                 " ", "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"irawpt", ",", "RawNpt"}], "}"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"SensNormalize", "=", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"TotalRawChi2", "/", "RawNpt"}], ")"}], "0.5"]}], 
             ";"}], "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"20180420", ":", " ", 
             RowBox[{
             "replace", " ", "the", " ", "calculation", " ", "of", " ", "the",
               " ", "rms", " ", "of", " ", "residual", " ", "by", " ", "the", 
              " ", "function"}]}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"SensNormalize", "=", 
            RowBox[{"GetResidualRMS", "[", 
             RowBox[{
              RowBox[{"residualNsetclassfinal", "[", 
               RowBox[{"[", "iexpt", "]"}], "]"}], ",", 
              RowBox[{"dtacentralclassfinal", "[", 
               RowBox[{"[", "iexpt", "]"}], "]"}]}], " ", "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"Nflavour", "=", "11"}], ";"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"output", " ", "the", " ", "flavour", " ", "from", " ", 
             RowBox[{"dbar", " ", "~", " ", "b"}]}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"Table", "[", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
             "sensitivity", " ", "components", " ", "for", " ", "each", " ", 
              "Hessian", " ", "direction"}], "*)"}], 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{
               RowBox[{"3", "~", 
                RowBox[{"-", "1"}]}], ":", " ", 
               RowBox[{
               "only", " ", "take", " ", "values", " ", "of", " ", 
                "replicas"}]}], ",", " ", 
              RowBox[{"so", " ", "delete", " ", "x"}], ",", " ", "Q"}], 
             "*)"}], "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
             "List", " ", "is", " ", "from", " ", "components", " ", "of", 
              " ", "dbar", " ", "to", " ", "b"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Flatten", "[", "\[IndentingNewLine]", " ", 
              RowBox[{"(", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"dRdataclassfinal", "[", 
                    RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                    RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
                   RowBox[{"[", 
                    RowBox[{"ipt", ",", "3"}], "]"}], "]"}], "/", 
                  "SensNormalize"}], ")"}], "*", 
                RowBox[{
                "pdfHessianCorrelationVectorfake", "[", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"List", "@@", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"fxQsamept2classfinal", "[", 
                    RowBox[{"[", 
                    RowBox[{"iexpt", ",", 
                    RowBox[{"flavourin", "+", "6"}]}], "]"}], "]"}], "[", 
                    RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"ipt", ",", 
                    RowBox[{"3", ";;", 
                    RowBox[{"-", "1"}]}]}], "]"}], "]"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"List", "@@", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"residualNsetclassfinal", "[", 
                    RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                    RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"ipt", ",", 
                    RowBox[{"3", ";;", 
                    RowBox[{"-", "1"}]}]}], "]"}], "]"}]}]}], " ", 
                 "\[IndentingNewLine]", "]"}]}], ")"}], "\[IndentingNewLine]",
               "]"}], "\[IndentingNewLine]", 
             RowBox[{"(*", "\[IndentingNewLine]", 
              RowBox[{"If", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"FigureFlag", "[", 
                  RowBox[{"[", "plottype", "]"}], "]"}], "\[Equal]", 
                 RowBox[{"-", "1"}]}], ",", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"inputdata", "[", 
                    RowBox[{"[", 
                    RowBox[{"iexpt", ",", 
                    RowBox[{"#", "+", "6"}]}], "]"}], "]"}], "[", 
                    RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
                   RowBox[{"[", 
                    RowBox[{"ipt", ",", "3"}], "]"}], "]"}], "&"}], "/@", 
                 RowBox[{"Range", "[", 
                  RowBox[{
                   RowBox[{"-", "2"}], ",", "5"}], "]"}]}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Abs", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"inputdata", "[", 
                    RowBox[{"[", 
                    RowBox[{"iexpt", ",", 
                    RowBox[{"#", "+", "6"}]}], "]"}], "]"}], "[", 
                    RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"ipt", ",", "3"}], "]"}], "]"}], " ", "]"}], 
                  "&"}], "/@", 
                 RowBox[{"Range", "[", 
                  RowBox[{
                   RowBox[{"-", "2"}], ",", "5"}], "]"}]}]}], 
               "\[IndentingNewLine]", "]"}], "*)"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"ipt", ",", "Npt"}], "}"}]}], "\[IndentingNewLine]", 
            "]"}]}], "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"inputdata", "[", 
              RowBox[{"[", 
               RowBox[{"iexpt", ",", 
                RowBox[{"flavourin", "+", "6"}]}], "]"}], "]"}], "[", 
             RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "/.", 
            RowBox[{
             RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
             RowBox[{"{", 
              RowBox[{"(*", 
               RowBox[{"PDFname", ",", "ExptID", ","}], "*)"}], 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"FigureFlag", "[", 
                  RowBox[{"[", "plottype", "]"}], "]"}], "\[Equal]", 
                 RowBox[{"-", "1"}]}], ",", 
                RowBox[{
                 RowBox[{"{", "a", "}"}], "[", 
                 RowBox[{"[", "3", "]"}], "]"}], ",", 
                RowBox[{"Abs", "[", 
                 RowBox[{
                  RowBox[{"{", "a", "}"}], "[", 
                  RowBox[{"[", "3", "]"}], "]"}], " ", "]"}]}], " ", "]"}], 
              "}"}]}]}], "*)"}], ",", "\[IndentingNewLine]", "6", ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"ExptID", "=", 
            RowBox[{
             RowBox[{"inputdata", "[", 
              RowBox[{"[", 
               RowBox[{"iexpt", ",", 
                RowBox[{"flavourin", "+", "6"}]}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"\"\<exptinfo\>\"", ",", "\"\<exptid\>\""}], "]"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"Npt", "=", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"plottype", ">=", "1"}], " ", "&&", " ", 
                RowBox[{"plottype", "\[LessEqual]", "4"}]}], ")"}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"inputdata", "[", 
                 RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "//", "Length"}], 
              ",", 
              RowBox[{
               RowBox[{
                RowBox[{"inputdata", "[", 
                 RowBox[{"[", 
                  RowBox[{"iexpt", ",", 
                   RowBox[{"flavourin", "+", "6"}]}], "]"}], "]"}], "[", 
                RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "//", "Length"}]}],
              " ", "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"Nflavour", "=", "11"}], ";"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"output", " ", "the", " ", "flavour", " ", "from", " ", 
             RowBox[{"dbar", " ", "~", " ", "b"}]}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"Table", "[", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
             "correlation", " ", "components", " ", "for", " ", "each", " ", 
              "Hessian", " ", "direction"}], "*)"}], 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{
               RowBox[{"3", "~", 
                RowBox[{"-", "1"}]}], ":", " ", 
               RowBox[{
               "only", " ", "take", " ", "values", " ", "of", " ", 
                "replicas"}]}], ",", " ", 
              RowBox[{"so", " ", "delete", " ", "x"}], ",", " ", "Q"}], 
             "*)"}], "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
             "List", " ", "is", " ", "from", " ", "components", " ", "of", 
              " ", "dbar", " ", "to", " ", "b"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
              RowBox[{
              "pdfHessianCorrelationVectorfake", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"List", "@@", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"fxQsamept2classfinal", "[", 
                    RowBox[{"[", 
                    RowBox[{"iexpt", ",", 
                    RowBox[{"flavourin", "+", "6"}]}], "]"}], "]"}], "[", 
                   RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"ipt", ",", 
                    RowBox[{"3", ";;", 
                    RowBox[{"-", "1"}]}]}], "]"}], "]"}]}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"List", "@@", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"residualNsetclassfinal", "[", 
                    RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                   RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"ipt", ",", 
                    RowBox[{"3", ";;", 
                    RowBox[{"-", "1"}]}]}], "]"}], "]"}]}]}], " ", 
               "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "]"}], 
             "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{"corr", " ", "values", " ", "from", " ", 
               RowBox[{"dbar", " ", "~", " ", "b"}], "\[IndentingNewLine]", 
               RowBox[{"If", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{
                  RowBox[{"FigureFlag", "[", 
                   RowBox[{"[", "plottype", "]"}], "]"}], "\[Equal]", 
                  RowBox[{"-", "1"}]}], ",", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{"inputdata", "[", 
                    RowBox[{"[", 
                    RowBox[{"iexpt", ",", 
                    RowBox[{"#", "+", "6"}]}], "]"}], "]"}], "[", 
                    RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"ipt", ",", "3"}], "]"}], "]"}], "&"}], "/@", 
                  RowBox[{"Range", "[", 
                   RowBox[{
                    RowBox[{"-", "2"}], ",", "5"}], "]"}]}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Abs", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"inputdata", "[", 
                    RowBox[{"[", 
                    RowBox[{"iexpt", ",", 
                    RowBox[{"#", "+", "6"}]}], "]"}], "]"}], "[", 
                    RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"ipt", ",", "3"}], "]"}], "]"}], " ", "]"}], 
                   "&"}], "/@", 
                  RowBox[{"Range", "[", 
                   RowBox[{
                    RowBox[{"-", "2"}], ",", "5"}], "]"}]}]}], 
                "\[IndentingNewLine]", "]"}]}], "*)"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"ipt", ",", "Npt"}], "}"}]}], "\[IndentingNewLine]", 
            "]"}]}], ",", "\[IndentingNewLine]", "_", ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
           "Print", "[", "\"\<error, plottype input should be 1~6\>\"", "]"}],
            ";", 
           RowBox[{"Abort", "[", "]"}]}]}], "\[IndentingNewLine]", "]"}], ",",
         "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"iexpt", ",", "Nexpt"}], "}"}]}], "\[IndentingNewLine]", 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"20180405", " ", "setup", " ", "the", " ", 
       RowBox[{"sign", "/", "abs"}], " ", "mode"}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"FigureFlag", "[", 
         RowBox[{"[", "plottype", "]"}], "]"}], "\[Equal]", "1"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"VecList", "=", 
        RowBox[{"Abs", "[", "VecList", "]"}]}]}], "\[IndentingNewLine]", 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"plottypestr", "=", 
      RowBox[{"ToString", "[", 
       RowBox[{"FigureFlag", "[", 
        RowBox[{"[", "plottype", "]"}], "]"}], " ", "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"20180405", " ", "also", " ", "make", " ", 
       RowBox[{"the", " ", ".", "tsv"}], " ", "files", " ", "of", " ", "raw", 
       " ", "data"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
      "make", " ", "raw", " ", "data", " ", "by", " ", "deleting", " ", 
       "points", " ", "duplicate", " ", "raw", " ", "data", " ", "ipt", " ", 
       "index"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"MetadataListRaw", "=", "\[IndentingNewLine]", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
        "find", " ", "the", " ", "position", " ", "of", " ", "ipt", " ", 
         "index"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"iptpos", "=", 
          RowBox[{
           RowBox[{"Position", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"dtacentralclassfinal", "[", 
               RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
              RowBox[{"[", "\"\<label\>\"", "]"}], "]"}], ",", 
             "\"\<ipt\>\""}], "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"DeleteDuplicatesByNptSpecified", "[", 
          RowBox[{
           RowBox[{"MetadataList", "[", 
            RowBox[{"[", "iexpt", "]"}], "]"}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"dtacentralclassfinal", "[", 
              RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
             RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "iptpos"}], "]"}], "]"}]}], " ", "]"}]}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"iexpt", ",", "Nexpt"}], "}"}]}], "\[IndentingNewLine]", 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"plottype", "\[Equal]", "2"}], " ", "||", 
        RowBox[{"plottype", "\[Equal]", "3"}], " ", "||", 
        RowBox[{"plottype", "\[Equal]", "4"}]}], ",", " ", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"VecListRaw", "=", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
           "find", " ", "the", " ", "position", " ", "of", " ", "ipt", " ", 
            "index"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"iptpos", "=", 
             RowBox[{
              RowBox[{"Position", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"dtacentralclassfinal", "[", 
                  RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                 RowBox[{"[", "\"\<label\>\"", "]"}], "]"}], ",", 
                "\"\<ipt\>\""}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"DeleteDuplicatesByNptSpecified", "[", 
             RowBox[{
              RowBox[{"VecList", "[", 
               RowBox[{"[", "iexpt", "]"}], "]"}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"dtacentralclassfinal", "[", 
                 RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "iptpos"}], "]"}], "]"}]}], " ", "]"}]}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"iexpt", ",", "Nexpt"}], "}"}]}], "\[IndentingNewLine]", 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Print", "[", 
           RowBox[{"\"\<dim meta: \>\"", ",", 
            RowBox[{
             RowBox[{
              RowBox[{"Dimensions", "[", "#", "]"}], "&"}], "/@", 
             "MetadataList"}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"Print", "[", 
           RowBox[{"\"\<dim vec: \>\"", ",", 
            RowBox[{
             RowBox[{
              RowBox[{"Dimensions", "[", "#", "]"}], "&"}], "/@", 
             "VecList"}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"Print", "[", 
           RowBox[{"\"\<dim of raw: \>\"", ",", 
            RowBox[{
             RowBox[{
              RowBox[{"Dimensions", "[", "#", "]"}], "&"}], "/@", 
             RowBox[{"{", 
              RowBox[{"MetadataListRaw", ",", "VecListRaw"}], "}"}]}]}], 
           "]"}], ";"}], "\[IndentingNewLine]", "*)"}], 
        "\[IndentingNewLine]", "\"\<dummy\>\""}]}], "\[IndentingNewLine]", 
      "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"merge", " ", "all", " ", "ID", " ", "lists"}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"MetadataList", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{"MetadataList", ",", "1"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"VecList", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{"VecList", ",", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
      "add", " ", "variable", " ", "names", " ", "for", " ", "columns"}], 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{"MetadataList", "=", 
      RowBox[{"Prepend", "[", 
       RowBox[{"MetadataList", ",", 
        RowBox[{"{", 
         RowBox[{
         "\"\<InFit\>\"", ",", "\"\<Type\>\"", ",", "\"\<ID\>\"", ",", 
          "\"\<pt\>\"", ",", "\"\<x\>\"", ",", "\"\<mu\>\""}], "}"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"VecList", "=", 
        RowBox[{"Prepend", "[", 
         RowBox[{"VecList", ",", 
          RowBox[{"{", "\"\<value\>\"", "}"}]}], "]"}]}], ";"}], "*)"}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"output", " ", "to", " ", "tsv", "  ", "file"}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"outputfile", "=", "\"\<metadata.tsv\>\""}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<now writing file: \>\"", ",", 
       RowBox[{"saveparentpath", "<>", "jobpath", "<>", "outputfile"}]}], 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Export", "[", 
      RowBox[{
       RowBox[{"saveparentpath", "<>", "jobpath", "<>", "outputfile"}], ",", 
       "MetadataList", ",", "\"\<TSV\>\""}], "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"outputfile", "=", 
      RowBox[{"Switch", "[", 
       RowBox[{"plottype", ",", "1", ",", 
        RowBox[{
        "\"\<xQbyexpt_\>\"", "<>", "plottypestr", "<>", "\"\<.tsv\>\""}], ",",
         "2", ",", 
        RowBox[{
        "\"\<expt_error_\>\"", "<>", "plottypestr", "<>", "\"\<.tsv\>\""}], 
        ",", "3", ",", 
        RowBox[{
        "\"\<residual_\>\"", "<>", "plottypestr", "<>", "\"\<.tsv\>\""}], ",",
         "4", ",", 
        RowBox[{"\"\<dr_\>\"", "<>", "plottypestr", "<>", "\"\<.tsv\>\""}], 
        ",", "5", ",", 
        RowBox[{"\"\<corrdr_\>\"", "<>", "plottypestr", "<>", "\"\<_f\>\"", "<>", 
         RowBox[{"ToString", "[", "flavourin", "]"}], "<>", "\"\<.tsv\>\""}], 
        ",", "6", ",", 
        RowBox[{"\"\<corr_\>\"", "<>", "plottypestr", "<>", "\"\<_f\>\"", "<>", 
         RowBox[{"ToString", "[", "flavourin", "]"}], "<>", 
         "\"\<.tsv\>\""}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<now writing file: \>\"", ",", 
       RowBox[{"saveparentpath", "<>", "jobpath", "<>", "outputfile"}]}], 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Export", "[", 
      RowBox[{
       RowBox[{"saveparentpath", "<>", "jobpath", "<>", "outputfile"}], ",", 
       "VecList", ",", "\"\<TSV\>\""}], "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
       "for", " ", "type", " ", "4", " ", "and", " ", "type", " ", "5"}], ",",
        " ", 
       RowBox[{
       "we", " ", "need", " ", "to", " ", "also", " ", "output", " ", "all", 
        " ", "sets", " ", "of", " ", "residuals", " ", "and", " ", 
        "residuals", " ", "normalized", " ", "by", " ", "the", " ", "central",
         " ", "value"}]}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"for", " ", "type", " ", "5"}], "*)"}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"plottype", "\[Equal]", "5"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"residualNormList", "=", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{"(*", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"define", " ", "the", " ", "sqrt", 
             RowBox[{"(", 
              RowBox[{"Sum", " ", 
               SuperscriptBox["r", "2"]}], ")"}], " ", "as", " ", 
             "normalization", " ", "factor"}], "*)"}], "\[IndentingNewLine]", 
           
           RowBox[{
            RowBox[{"iRawdataResidual", "=", 
             RowBox[{
              RowBox[{"Position", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"dtacentralclassfinal", "[", 
                  RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                 RowBox[{"[", "\"\<label\>\"", "]"}], "]"}], ",", 
                "\"\<ReducedChi2\>\""}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"RawNpt", "=", 
             RowBox[{
              RowBox[{
               RowBox[{"dtacentralclassfinal", "[", 
                RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
               RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "//", "Length"}]}], 
            ";", "\[IndentingNewLine]", 
            RowBox[{"TotalRawChi2", "=", 
             RowBox[{"Sum", "[", 
              RowBox[{
               RowBox[{"Abs", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"dtacentralclassfinal", "[", 
                   RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                  RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{"irawpt", ",", "iRawdataResidual"}], "]"}], "]"}], 
                " ", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"irawpt", ",", "RawNpt"}], "}"}]}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"SensNormalize", "=", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"TotalRawChi2", "/", "RawNpt"}], ")"}], "0.5"]}], 
            ";"}], "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{"20180420", ":", " ", 
            RowBox[{
            "replace", " ", "the", " ", "calculation", " ", "of", " ", "the", 
             " ", "rms", " ", "of", " ", "residual", " ", "by", " ", "the", 
             " ", "function"}]}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"SensNormalize", "=", 
             RowBox[{"GetResidualRMS", "[", 
              RowBox[{
               RowBox[{"residualNsetclassfinal", "[", 
                RowBox[{"[", "iexpt", "]"}], "]"}], ",", 
               RowBox[{"dtacentralclassfinal", "[", 
                RowBox[{"[", "iexpt", "]"}], "]"}]}], " ", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{
              "output", " ", "the", " ", "residual", " ", "values", " ", "of",
                " ", "replicas", " ", "except", " ", "for", " ", "the", " ", 
               "central", " ", "set"}], ",", " ", 
              RowBox[{"normalized", " ", "by", " ", "the", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"\[Sum]", 
                 SuperscriptBox[
                  SubscriptBox["r", 
                   RowBox[{"i", ",", "ID"}]], "2"]}]}]}]}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{"20180301", ",", " ", 
              RowBox[{"r_iset", " ", "\[Rule]", " ", 
               RowBox[{"(", 
                RowBox[{"r_iset", "-", 
                 RowBox[{"r_", "0"}]}], ")"}]}]}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"residualNsetclassfinal", "[", 
               RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
              RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "/.", 
             RowBox[{
              RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"Drop", "[", 
                  RowBox[{
                   RowBox[{"{", "a", "}"}], ",", "3"}], "]"}], "-", 
                 RowBox[{
                  RowBox[{"{", "a", "}"}], "[", 
                  RowBox[{"[", "3", "]"}], "]"}]}], ")"}], "/", 
               "SensNormalize"}]}]}]}], 
           RowBox[{"(*", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"FigureFlag", "[", 
                RowBox[{"[", "plottype", "]"}], "]"}], "\[Equal]", 
               RowBox[{"-", "1"}]}], ",", 
              RowBox[{
               RowBox[{"Drop", "[", 
                RowBox[{
                 RowBox[{"{", "a", "}"}], ",", "3"}], "]"}], "/", 
               "SensNormalize"}], ",", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{"take", " ", "|", "data", "|", " ", 
                 RowBox[{"when", " ", "flag"}]}], " ", "=", " ", "1"}], 
               "*)"}], 
              RowBox[{"Abs", "[", 
               RowBox[{
                RowBox[{"Drop", "[", 
                 RowBox[{
                  RowBox[{"{", "a", "}"}], ",", "3"}], "]"}], "/", 
                "SensNormalize"}], " ", "]"}]}], " ", "]"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"(*", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"residualNsetclassfinal", "[", 
               RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
              RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "/.", 
             RowBox[{
              RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"FigureFlag", "[", 
                  RowBox[{"[", "plottype", "]"}], "]"}], "\[Equal]", 
                 RowBox[{"-", "1"}]}], ",", 
                RowBox[{
                 RowBox[{"{", "a", "}"}], "[", 
                 RowBox[{"[", 
                  RowBox[{"3", ":", 
                   RowBox[{"-", "1"}]}], "]"}], "]"}], ",", 
                RowBox[{"Abs", "[", 
                 RowBox[{
                  RowBox[{"{", "a", "}"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"3", ":", 
                    RowBox[{"-", "1"}]}], "]"}], "]"}], " ", "]"}]}], " ", 
               "]"}]}]}], "\[IndentingNewLine]", "*)"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"iexpt", ",", "Nexpt"}], "}"}]}], "\[IndentingNewLine]", 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"20180405", " ", "setup", " ", "the", " ", 
          RowBox[{"sign", "/", "abs"}], " ", "mode"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"FigureFlag", "[", 
            RowBox[{"[", "plottype", "]"}], "]"}], "\[Equal]", "1"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"residualNormList", "=", 
           RowBox[{"Abs", "[", "residualNormList", "]"}]}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"20180405", " ", "also", " ", "make", " ", 
          RowBox[{"the", " ", ".", "tsv"}], " ", "files", " ", "of", " ", 
          "raw", " ", "data"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "make", " ", "raw", " ", "data", " ", "by", " ", "deleting", " ", 
          "points", " ", "duplicate", " ", "raw", " ", "data", " ", "ipt", 
          " ", "index"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"residualNormListRaw", "=", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
           "find", " ", "the", " ", "position", " ", "of", " ", "ipt", " ", 
            "index"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"iptpos", "=", 
             RowBox[{
              RowBox[{"Position", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"dtacentralclassfinal", "[", 
                  RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                 RowBox[{"[", "\"\<label\>\"", "]"}], "]"}], ",", 
                "\"\<ipt\>\""}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"DeleteDuplicatesByNptSpecified", "[", 
             RowBox[{
              RowBox[{"residualNormList", "[", 
               RowBox[{"[", "iexpt", "]"}], "]"}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"dtacentralclassfinal", "[", 
                 RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "iptpos"}], "]"}], "]"}]}], " ", "]"}]}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"iexpt", ",", "Nexpt"}], "}"}]}], "\[IndentingNewLine]", 
          "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"merge", " ", "all", " ", "ID", " ", "lists"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"residualNormList", "=", 
         RowBox[{"Flatten", "[", 
          RowBox[{"residualNormList", ",", "1"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<dim: \>\"", ",", 
          RowBox[{"residualNormList", "//", "Dimensions"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"add", " ", "variables", " ", "for", " ", "columns"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"residualNormList", "=", 
           RowBox[{"Prepend", "[", 
            RowBox[{"residualNormList", ",", 
             RowBox[{"Drop", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"residualNsetclassfinal", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "\"\<label\>\"", "]"}], "]"}], ",", "2"}], 
              "]"}]}], " ", "]"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<dim: \>\"", ",", 
          RowBox[{"residualNormList", "//", "Dimensions"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"outputfile", "=", 
         RowBox[{
         "\"\<residual_all_norm_\>\"", "<>", "plottypestr", "<>", 
          "\"\<.tsv\>\""}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<now writing file: \>\"", ",", 
          RowBox[{"saveparentpath", "<>", "jobpath", "<>", "outputfile"}]}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"FileExistsQ", "[", 
            RowBox[{"saveparentpath", "<>", "jobpath", "<>", "outputfile"}], 
            "]"}], "\[Equal]", "False"}], ",", 
          RowBox[{"Export", "[", 
           RowBox[{
            RowBox[{"saveparentpath", "<>", "jobpath", "<>", "outputfile"}], 
            ",", "residualNormList", ",", "\"\<TSV\>\""}], "]"}]}], " ", 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"20180405", " ", "also", " ", "make", " ", 
          RowBox[{"the", " ", ".", "tsv"}], " ", "files", " ", "of", " ", 
          "raw", " ", "data"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"merge", " ", "all", " ", "ID", " ", "lists"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"residualNormListRaw", "=", 
         RowBox[{"Flatten", "[", 
          RowBox[{"residualNormListRaw", ",", "1"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"outputfile", "=", 
         RowBox[{
         "\"\<residual_all_norm_\>\"", "<>", "plottypestr", "<>", 
          "\"\<_RawData.tsv\>\""}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<now writing file: \>\"", ",", 
          RowBox[{"saveparentpath", "<>", "jobpath", "<>", "outputfile"}]}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"FileExistsQ", "[", 
            RowBox[{"saveparentpath", "<>", "jobpath", "<>", "outputfile"}], 
            "]"}], "\[Equal]", "False"}], ",", 
          RowBox[{"Export", "[", 
           RowBox[{
            RowBox[{"saveparentpath", "<>", "jobpath", "<>", "outputfile"}], 
            ",", "residualNormListRaw", ",", "\"\<TSV\>\""}], "]"}]}], " ", 
         "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<dim: \>\"", ",", 
       RowBox[{
        RowBox[{
         RowBox[{"Dimensions", "[", "#", "]"}], "&"}], "/@", 
        RowBox[{"{", 
         RowBox[{"MetadataList", ",", "VecList", ",", "residualNormList"}], 
         "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<dim of raw: \>\"", ",", 
       RowBox[{
        RowBox[{
         RowBox[{"Dimensions", "[", "#", "]"}], "&"}], "/@", 
        RowBox[{"{", 
         RowBox[{
         "MetadataListRaw", ",", "VecListRaw", ",", "residualNormListRaw"}], 
         "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"20180405", " ", "also", " ", "make", " ", 
       RowBox[{"the", " ", ".", "tsv"}], " ", "files", " ", "of", " ", "raw", 
       " ", "data"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"merge", " ", "all", " ", "ID", " ", "lists"}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"MetadataListRaw", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{"MetadataListRaw", ",", "1"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
      "add", " ", "variable", " ", "names", " ", "for", " ", "columns"}], 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{"MetadataListRaw", "=", 
      RowBox[{"Prepend", "[", 
       RowBox[{"MetadataListRaw", ",", 
        RowBox[{"{", 
         RowBox[{
         "\"\<InFit\>\"", ",", "\"\<Type\>\"", ",", "\"\<ID\>\"", ",", 
          "\"\<pt\>\"", ",", "\"\<x\>\"", ",", "\"\<mu\>\""}], "}"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"VecList", "=", 
        RowBox[{"Prepend", "[", 
         RowBox[{"VecList", ",", 
          RowBox[{"{", "\"\<value\>\"", "}"}]}], "]"}]}], ";"}], "*)"}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"output", " ", "to", " ", "tsv", "  ", "file"}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"outputfile", "=", "\"\<metadata_RawData.tsv\>\""}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<now writing file: \>\"", ",", 
       RowBox[{"saveparentpath", "<>", "jobpath", "<>", "outputfile"}]}], 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Export", "[", 
      RowBox[{
       RowBox[{"saveparentpath", "<>", "jobpath", "<>", "outputfile"}], ",", 
       "MetadataListRaw", ",", "\"\<TSV\>\""}], "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"plottype", "\[Equal]", "2"}], " ", "||", 
        RowBox[{"plottype", "\[Equal]", "3"}], " ", "||", 
        RowBox[{"plottype", "\[Equal]", "4"}]}], ",", " ", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"VecListRaw", "=", 
         RowBox[{"Flatten", "[", 
          RowBox[{"VecListRaw", ",", "1"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"outputfile", "=", 
         RowBox[{"Switch", "[", 
          RowBox[{"plottype", ",", "1", ",", 
           RowBox[{
           "\"\<xQbyexpt_\>\"", "<>", "plottypestr", "<>", 
            "\"\<_RawData.tsv\>\""}], ",", "2", ",", 
           RowBox[{
           "\"\<expt_error_\>\"", "<>", "plottypestr", "<>", 
            "\"\<_RawData.tsv\>\""}], ",", "3", ",", 
           RowBox[{
           "\"\<residual_\>\"", "<>", "plottypestr", "<>", 
            "\"\<_RawData.tsv\>\""}], ",", "4", ",", 
           RowBox[{
           "\"\<dr_\>\"", "<>", "plottypestr", "<>", "\"\<_RawData.tsv\>\""}],
            ",", "5", ",", 
           RowBox[{
           "\"\<corrdr_\>\"", "<>", "plottypestr", "<>", "\"\<_f\>\"", "<>", 
            RowBox[{"ToString", "[", "flavourin", "]"}], "<>", 
            "\"\<_RawData.tsv\>\""}], ",", "6", ",", 
           RowBox[{"\"\<corr_\>\"", "<>", "plottypestr", "<>", "\"\<_f\>\"", "<>", 
            RowBox[{"ToString", "[", "flavourin", "]"}], "<>", 
            "\"\<_RawData.tsv\>\""}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<now writing file: \>\"", ",", 
          RowBox[{"saveparentpath", "<>", "jobpath", "<>", "outputfile"}]}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Export", "[", 
         RowBox[{
          RowBox[{"saveparentpath", "<>", "jobpath", "<>", "outputfile"}], 
          ",", "VecListRaw", ",", "\"\<TSV\>\""}], "]"}], ";", 
        "\[IndentingNewLine]", "\"\<dummy\>\""}]}], "\[IndentingNewLine]", 
      "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", "output", "*)"}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"MetadataList", ",", "VecList", ",", "residualNormList"}], 
      "}"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.725811356586411*^9, 3.725811358813388*^9}, {
   3.725811392721147*^9, 3.7258114476495047`*^9}, {3.72581206700819*^9, 
   3.7258120833703623`*^9}, {3.725812114382612*^9, 3.725812127979444*^9}, {
   3.725812210660019*^9, 3.7258122178953114`*^9}, {3.725812482726227*^9, 
   3.725812563211844*^9}, {3.725812692138579*^9, 3.725812741069906*^9}, {
   3.725815180017761*^9, 3.725815275304892*^9}, {3.725815312581091*^9, 
   3.725815381668737*^9}, {3.7258154400045223`*^9, 3.725815440485388*^9}, {
   3.7258154832419167`*^9, 3.725815510415447*^9}, {3.725815545929414*^9, 
   3.7258155835966177`*^9}, {3.725815846204535*^9, 3.725815850544137*^9}, {
   3.725815948748417*^9, 3.725816045570711*^9}, {3.725817030871149*^9, 
   3.7258170816989517`*^9}, {3.725831672104299*^9, 3.725831733425803*^9}, {
   3.725831796443198*^9, 3.725831844592936*^9}, {3.7258322105070868`*^9, 
   3.725832310290124*^9}, {3.72583235053054*^9, 3.7258325085909777`*^9}, {
   3.725832572356991*^9, 3.72583257853448*^9}, {3.725832620652993*^9, 
   3.7258326521779003`*^9}, {3.7258335226379213`*^9, 3.725833581582656*^9}, {
   3.7258336923697453`*^9, 3.725833708364956*^9}, {3.725885699374954*^9, 
   3.725885823513565*^9}, {3.725885859626799*^9, 3.725885874850306*^9}, {
   3.72588591259464*^9, 3.725885999327475*^9}, {3.725886321721081*^9, 
   3.725886325341545*^9}, {3.725886409537344*^9, 3.725886622694969*^9}, {
   3.7258866583514767`*^9, 3.725886669117866*^9}, {3.725887701857099*^9, 
   3.725887708681711*^9}, {3.7258877673015423`*^9, 3.7258878030806627`*^9}, {
   3.72588784235028*^9, 3.725887918163904*^9}, {3.725887966718883*^9, 
   3.725888010809466*^9}, {3.7258880831197987`*^9, 3.725888231437769*^9}, {
   3.725888730906458*^9, 3.725888741547995*^9}, {3.72588880333561*^9, 
   3.7258890147685213`*^9}, 3.725889098440111*^9, {3.7258891334813967`*^9, 
   3.7258892621447*^9}, {3.725889319548773*^9, 3.725889419329631*^9}, 
   3.725889480264379*^9, {3.7258895415260897`*^9, 3.725889551043256*^9}, {
   3.725889609561832*^9, 3.725889617813545*^9}, {3.7258896621238403`*^9, 
   3.725889670029378*^9}, {3.7258897793655157`*^9, 3.725889781938614*^9}, {
   3.7258898172390947`*^9, 3.7258898194404497`*^9}, {3.7258898650771112`*^9, 
   3.7258899878484983`*^9}, {3.7258900619658403`*^9, 3.725890227096773*^9}, 
   3.7258902884332037`*^9, {3.725890350180704*^9, 3.725890448783463*^9}, {
   3.725890511929113*^9, 3.725890526379135*^9}, {3.725890618558661*^9, 
   3.7258908232028522`*^9}, {3.7258914881325617`*^9, 3.725891549580435*^9}, {
   3.7258918663174057`*^9, 3.725891920767127*^9}, {3.725892001520686*^9, 
   3.725892034864603*^9}, {3.7258921053088923`*^9, 3.725892105974037*^9}, {
   3.725896790208543*^9, 3.725896814764421*^9}, {3.725896991730575*^9, 
   3.725897018385088*^9}, {3.725897166037529*^9, 3.725897166374839*^9}, {
   3.725902931226869*^9, 3.725902934100277*^9}, {3.7259030157347107`*^9, 
   3.7259030745716*^9}, {3.7259049715708323`*^9, 3.725904993708859*^9}, {
   3.7259050459639587`*^9, 3.7259051951702623`*^9}, {3.725905263926476*^9, 
   3.725905363770679*^9}, {3.725905425136907*^9, 3.725905497783053*^9}, {
   3.725905570956626*^9, 3.725905572061412*^9}, {3.725905817535898*^9, 
   3.725905821571292*^9}, {3.725907690079535*^9, 3.725907694187153*^9}, {
   3.725907763793347*^9, 3.725907768363578*^9}, {3.725910297698778*^9, 
   3.725910299683663*^9}, {3.725910370843233*^9, 3.725910496689086*^9}, {
   3.725910534627833*^9, 3.725910540098199*^9}, {3.725911601368793*^9, 
   3.72591166835995*^9}, {3.7259903482261353`*^9, 3.725990357500743*^9}, {
   3.725990417617124*^9, 3.7259905858115396`*^9}, {3.725990724376491*^9, 
   3.725990814921489*^9}, {3.725991055789747*^9, 3.7259910574575853`*^9}, {
   3.725992123274914*^9, 3.72599220233663*^9}, {3.725992726154222*^9, 
   3.7259927829193993`*^9}, {3.725996064591158*^9, 3.72599618765727*^9}, {
   3.726007649584503*^9, 3.7260076552412977`*^9}, {3.726007817318655*^9, 
   3.726007827646484*^9}, {3.7277187748459377`*^9, 3.7277188797716703`*^9}, {
   3.727718979026854*^9, 3.7277189977275963`*^9}, 3.72771903013981*^9, {
   3.727719146982381*^9, 3.727719196275173*^9}, {3.729004208488163*^9, 
   3.729004267345965*^9}, {3.729004302491584*^9, 3.729004314585536*^9}, {
   3.731972616379128*^9, 3.7319726254270372`*^9}, {3.7319726607613783`*^9, 
   3.731972713061389*^9}, {3.731972753843961*^9, 3.731972757091323*^9}, {
   3.731972792469431*^9, 3.731972843772541*^9}, {3.731972889738052*^9, 
   3.731972988897407*^9}, {3.731973024727598*^9, 3.7319730500480556`*^9}, {
   3.731973082031028*^9, 3.731973105657839*^9}, {3.731973635984318*^9, 
   3.731973649028013*^9}, {3.731973692275674*^9, 3.731973692563448*^9}, {
   3.731973761673098*^9, 3.7319739136485443`*^9}, {3.731973948775926*^9, 
   3.731974070379801*^9}, {3.73197416109554*^9, 3.731974174280273*^9}, {
   3.731974324145565*^9, 3.731974358008132*^9}, {3.731974507906374*^9, 
   3.731974574192307*^9}, {3.73197462734216*^9, 3.731974632065296*^9}, {
   3.731974769578165*^9, 3.731974777613283*^9}, {3.731974907702539*^9, 
   3.731974938020912*^9}, {3.7319750157017097`*^9, 3.7319750223219357`*^9}, {
   3.731977164592833*^9, 3.731977206610928*^9}, {3.731977416443263*^9, 
   3.7319774188748617`*^9}, {3.73201542693785*^9, 3.7320154611656857`*^9}, {
   3.732015506660447*^9, 3.732015610743704*^9}, {3.732015884530499*^9, 
   3.732015908816761*^9}, {3.7320159965495043`*^9, 3.7320160539044456`*^9}, {
   3.73201608471345*^9, 3.732016121178178*^9}, {3.732016415561082*^9, 
   3.732016455701438*^9}, {3.732016500679953*^9, 3.7320166660806503`*^9}, {
   3.73329181043602*^9, 3.733291906872109*^9}}],

Cell[BoxData[
 RowBox[{"Clear", "[", "processdatatotsv", "]"}]], "Input",
 CellChangeTimes->{{3.725889846109864*^9, 3.725889852079548*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.725889698817039*^9, 3.725889716608296*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"residualNsetclassfinal", "[", 
    RowBox[{"[", "1", "]"}], "]"}], "[", 
   RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "//", 
  "Length"}], "\[IndentingNewLine]", 
 RowBox[{"Length", "[", 
  RowBox[{"residualNsetclassfinal", "//", "Length"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Sum", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"residualNsetclassfinal", "[", 
      RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
     RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "//", "Length"}], ",", 
   RowBox[{"{", 
    RowBox[{"iexpt", ",", 
     RowBox[{"residualNsetclassfinal", "//", "Length"}]}], "}"}]}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.725896550671547*^9, 3.7258966576741467`*^9}}],

Cell[BoxData[
 TemplateBox[{
  "Part","partd",
   "\"Part specification \\!\\(\\*RowBox[{\\\"residualNsetclassfinal\\\", \
\\\"\[LeftDoubleBracket]\\\", \\\"1\\\", \\\"\[RightDoubleBracket]\\\"}]\\) \
is longer than depth of object.\"",2,12,19,25905414409066200839,"New Kernel"},
  
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.732017117272575*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","pspec1",
   "\"Part specification \\!\\(\\*RowBox[{\\\"\\\\\\\"data\\\\\\\"\\\"}]\\) \
is not applicable.\"",2,12,20,25905414409066200839,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.732017117280501*^9}],

Cell[BoxData["2"], "Output",
 CellChangeTimes->{{3.725896591492979*^9, 3.7258966585400047`*^9}, 
   3.73201711729123*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.725896591492979*^9, 3.7258966585400047`*^9}, 
   3.7320171172925663`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.725896591492979*^9, 3.7258966585400047`*^9}, 
   3.732017117293975*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"residualNormList", "=", "\[IndentingNewLine]", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"residualNsetclassfinal", "[", 
          RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
         RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "/.", 
        RowBox[{
         RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"1", "\[Equal]", 
            RowBox[{"-", "1"}]}], ",", 
           RowBox[{"Drop", "[", 
            RowBox[{
             RowBox[{"{", "a", "}"}], ",", "2"}], "]"}], ",", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"take", " ", "|", "data", "|", " ", 
              RowBox[{"when", " ", "flag"}]}], " ", "=", " ", "1"}], "*)"}], 
           RowBox[{"Abs", "[", 
            RowBox[{"Drop", "[", 
             RowBox[{
              RowBox[{"{", "a", "}"}], ",", "2"}], "]"}], " ", "]"}]}], " ", 
          "]"}]}]}], "\[IndentingNewLine]", 
       RowBox[{"(*", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"residualNsetclassfinal", "[", 
           RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
          RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "/.", 
         RowBox[{
          RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"FigureFlag", "[", 
              RowBox[{"[", "plottype", "]"}], "]"}], "\[Equal]", 
             RowBox[{"-", "1"}]}], ",", 
            RowBox[{
             RowBox[{"{", "a", "}"}], "[", 
             RowBox[{"[", 
              RowBox[{"3", ":", 
               RowBox[{"-", "1"}]}], "]"}], "]"}], ",", 
            RowBox[{"Abs", "[", 
             RowBox[{
              RowBox[{"{", "a", "}"}], "[", 
              RowBox[{"[", 
               RowBox[{"3", ":", 
                RowBox[{"-", "1"}]}], "]"}], "]"}], " ", "]"}]}], " ", 
           "]"}]}]}], "\[IndentingNewLine]", "*)"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"iexpt", ",", 
         RowBox[{"Length", "[", "residualNsetclassfinal", "]"}]}], "}"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{"merge", " ", "all", " ", "ID", " ", "lists"}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"residualNormList", "=", 
     RowBox[{"Flatten", "[", 
      RowBox[{"residualNormList", ",", "1"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"residualNormList", "//", "Dimensions"}]}], "\[IndentingNewLine]",
    "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.725896718423129*^9, 3.72589677904244*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"processdatatotsv", "[", 
  RowBox[{
   RowBox[{"readcorrconfigfile6", "[", 
    RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "5", ",", "0"}],
   "]"}]], "Input",
 CellChangeTimes->{{3.725905601686233*^9, 3.725905602604851*^9}, {
  3.7259077112938433`*^9, 3.7259077114209223`*^9}, {3.7259105701221123`*^9, 
  3.725910570289895*^9}, {3.725990836754908*^9, 3.725990837631749*^9}, {
  3.725992822762639*^9, 3.72599282348667*^9}}],

Cell[BoxData[
 RowBox[{"processdatatotsv", "[", 
  RowBox[{
   RowBox[{"readcorrconfigfile6", "[", 
    RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "5", ",", "0"}],
   "]"}]], "Output",
 CellChangeTimes->{
  3.725905641477459*^9, 3.725905876513166*^9, 3.725906181975049*^9, 
   3.725907721825049*^9, 3.725907779553567*^9, {3.725910567840378*^9, 
   3.725910578431563*^9}, 3.725910655996231*^9, 3.7259908644824142`*^9, 
   3.725991104362461*^9, 3.725992868627596*^9, 3.7259934917340517`*^9, 
   3.725996216467312*^9, 3.7320171173384943`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"processdatatotsv", "[", 
  RowBox[{
   RowBox[{"readcorrconfigfile6", "[", 
    RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "5", ",", "0"}],
   "]"}]], "Input",
 CellChangeTimes->{{3.727719069199898*^9, 3.727719069287798*^9}, {
  3.7277192141917458`*^9, 3.72771921431571*^9}, {3.727719291436022*^9, 
  3.727719291565319*^9}}],

Cell[BoxData[
 RowBox[{"processdatatotsv", "[", 
  RowBox[{
   RowBox[{"readcorrconfigfile6", "[", 
    RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "5", ",", "0"}],
   "]"}]], "Output",
 CellChangeTimes->{3.727719271839168*^9, 3.727719355883935*^9, 
  3.7277195604031076`*^9, 3.73201711735012*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"processdatatotsv", "[", 
    RowBox[{
     RowBox[{"readcorrconfigfile6", "[", 
      RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "6", ",", 
     "#"}], "]"}], "&"}], "/@", 
  RowBox[{"Range", "[", 
   RowBox[{
    RowBox[{"-", "5"}], ",", 
    RowBox[{"-", "5"}]}], "]"}]}]], "Input",
 CellChangeTimes->{3.726007685834558*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"processdatatotsv", "[", 
   RowBox[{
    RowBox[{"readcorrconfigfile6", "[", 
     RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "6", ",", 
    RowBox[{"-", "5"}]}], "]"}], "}"}]], "Output",
 CellChangeTimes->{3.7260077170491133`*^9, 3.726007858498608*^9, 
  3.7320171173610287`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Nflavour", "=", 
   RowBox[{
    RowBox[{"corrdataclassfinal", "[", 
     RowBox[{"[", "1", "]"}], "]"}], "//", "Length"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"processdatatotsv", "[", 
    RowBox[{
     RowBox[{"readcorrconfigfile6", "[", 
      RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "6", ",", 
     "#"}], "]"}], "&"}], "/@", 
  RowBox[{"Range", "[", 
   RowBox[{
    RowBox[{"-", "5"}], ",", 
    RowBox[{
     RowBox[{"-", "5"}], "+", "Nflavour", "-", "1"}]}], 
   "]"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.725886043201997*^9, 3.725886065666627*^9}, 
   3.7258862655990047`*^9, {3.72588673960415*^9, 3.72588682259606*^9}, {
   3.725887605792199*^9, 3.725887722547505*^9}, {3.72588793396663*^9, 
   3.725887934061553*^9}, {3.725889424452134*^9, 3.725889433818606*^9}, {
   3.725889531756865*^9, 3.725889533028552*^9}, 3.725889633854662*^9, 
   3.725889677214904*^9, {3.725890209498999*^9, 3.725890218556718*^9}, {
   3.725891643899424*^9, 3.7258917377642317`*^9}, {3.7258968406153803`*^9, 
   3.725896845968628*^9}, 3.725903257088365*^9, {3.725996571399831*^9, 
   3.7259965715118*^9}}],

Cell[BoxData[
 TemplateBox[{
  "Part","partd",
   "\"Part specification \\!\\(\\*RowBox[{\\\"corrdataclassfinal\\\", \\\"\
\[LeftDoubleBracket]\\\", \\\"1\\\", \\\"\[RightDoubleBracket]\\\"}]\\) is \
longer than depth of object.\"",2,19,21,25905414409066200839,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.732017117372665*^9}],

Cell[BoxData["2"], "Output",
 CellChangeTimes->{{3.725886120567945*^9, 3.725886120634853*^9}, 
   3.72588626720266*^9, 3.7258863443507633`*^9, 3.725886409975383*^9, 
   3.725886635114541*^9, {3.725886728009738*^9, 3.725886823067214*^9}, {
   3.725887606517288*^9, 3.72588762326061*^9}, {3.725887654937187*^9, 
   3.725887665024756*^9}, {3.7258877151894503`*^9, 3.725887723434814*^9}, {
   3.7258879305392237`*^9, 3.725887936246293*^9}, 3.725888296868361*^9, {
   3.7258894298569603`*^9, 3.725889444638183*^9}, 3.725889484777397*^9, {
   3.725889533659781*^9, 3.725889554262269*^9}, {3.725889595470809*^9, 
   3.725889639226739*^9}, {3.725889674177491*^9, 3.7258896872161083`*^9}, 
   3.725889795472509*^9, {3.725890211712091*^9, 3.725890240375437*^9}, 
   3.725890296520545*^9, {3.725890355141464*^9, 3.7258903809544086`*^9}, 
   3.725890539620406*^9, 3.725890850908231*^9, 3.72589157130135*^9, 
   3.7258916714816923`*^9, 3.725891739190199*^9, 3.72589194630721*^9, 
   3.725892041544897*^9, 3.7258921164827633`*^9, 3.7258968469178534`*^9, 
   3.725897028536398*^9, 3.7258970952532988`*^9, 3.725897192182366*^9, 
   3.725903259030548*^9, 3.725996233548739*^9, 3.7259965722916307`*^9, 
   3.732017117380806*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"processdatatotsv", "[", 
    RowBox[{
     RowBox[{"readcorrconfigfile6", "[", 
      RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "6", ",", 
     RowBox[{"-", "5"}]}], "]"}], ",", 
   RowBox[{"processdatatotsv", "[", 
    RowBox[{
     RowBox[{"readcorrconfigfile6", "[", 
      RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "6", ",", 
     RowBox[{"-", "4"}]}], "]"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.725886120567945*^9, 3.725886120634853*^9}, 
   3.72588626720266*^9, 3.7258863443507633`*^9, 3.725886409975383*^9, 
   3.725886635114541*^9, {3.725886728009738*^9, 3.725886823067214*^9}, {
   3.725887606517288*^9, 3.72588762326061*^9}, {3.725887654937187*^9, 
   3.725887665024756*^9}, {3.7258877151894503`*^9, 3.725887723434814*^9}, {
   3.7258879305392237`*^9, 3.725887936246293*^9}, 3.725888296868361*^9, {
   3.7258894298569603`*^9, 3.725889444638183*^9}, 3.725889484777397*^9, {
   3.725889533659781*^9, 3.725889554262269*^9}, {3.725889595470809*^9, 
   3.725889639226739*^9}, {3.725889674177491*^9, 3.7258896872161083`*^9}, 
   3.725889795472509*^9, {3.725890211712091*^9, 3.725890240375437*^9}, 
   3.725890296520545*^9, {3.725890355141464*^9, 3.7258903809544086`*^9}, 
   3.725890539620406*^9, 3.725890850908231*^9, 3.72589157130135*^9, 
   3.7258916714816923`*^9, 3.725891739190199*^9, 3.72589194630721*^9, 
   3.725892041544897*^9, 3.7258921164827633`*^9, 3.7258968469178534`*^9, 
   3.725897028536398*^9, 3.7258970952532988`*^9, 3.725897192182366*^9, 
   3.725903259030548*^9, 3.725996233548739*^9, 3.7259965722916307`*^9, 
   3.732017117381946*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Set Working path and call .m packages", "Section",
 CellChangeTimes->{{3.706788977874497*^9, 3.706788983612884*^9}, 
   3.706789014422559*^9, 3.7067892793048687`*^9, {3.713100950211649*^9, 
   3.713100976153716*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
       "this", " ", "switch", " ", "is", " ", "for", " ", "controling", " ", 
        RowBox[{"of", " ", ".", "nb"}]}], "&"}], " ", ".", "m"}], " ", 
     "versions"}], ",", " ", 
    RowBox[{
     RowBox[{
     "the", " ", "option", " ", "of", " ", "the", " ", "switch", " ", 
      "depends", " ", "this", " ", "file", " ", "is", " ", "saved", " ", 
      RowBox[{"as", " ", ".", "nb"}]}], "/.", 
     RowBox[{"m", " ", 
      RowBox[{"(", "package", ")"}], " ", "extension"}]}]}], "  ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{".", "m"}], " ", "file", " ", "could", " ", "be", " ", 
    "implemented", " ", "in", " ", "the", " ", "terminal"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"option", ":", " ", 
    RowBox[{"\"\<nb\>\"", " ", "or", " ", "\"\<m\>\""}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ThisFileExtension", "=", "\"\<nb\>\""}], ";"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713122558917322*^9, 3.713122649056539*^9}, {
   3.7131226848439913`*^9, 3.7131226977299213`*^9}, {3.713122779285274*^9, 
   3.713122819456328*^9}, {3.713123045896586*^9, 3.713123260634577*^9}, {
   3.7131233240110064`*^9, 3.713123324961534*^9}, 3.713125926782509*^9, {
   3.713128609885027*^9, 3.7131286105742826`*^9}, {3.718592449803526*^9, 
   3.718592449924893*^9}, {3.718592515565954*^9, 3.7185925166111927`*^9}, {
   3.718592562293191*^9, 3.718592589974844*^9}, {3.7185926264656277`*^9, 
   3.718592627822405*^9}, 3.719169123986948*^9, {3.7192235219996243`*^9, 
   3.719223522393216*^9}, 3.719223787228325*^9, {3.71922597045619*^9, 
   3.7192259711228523`*^9}, 3.7197199840176573`*^9, {3.7197200753790913`*^9, 
   3.719720075812718*^9}, 3.719723352274332*^9, {3.719723896484687*^9, 
   3.719723896833445*^9}, 3.7197240234653997`*^9, {3.7197309965315027`*^9, 
   3.719730996655485*^9}, 3.719731434637245*^9, {3.7197534690568533`*^9, 
   3.719753469158743*^9}, 3.71984169013463*^9, {3.719842144203179*^9, 
   3.7198421449685583`*^9}, 3.72013018529725*^9, {3.720135756392521*^9, 
   3.720135756475223*^9}, 3.720140304806806*^9, {3.720144664507587*^9, 
   3.720144665447139*^9}, {3.7201487492335577`*^9, 3.720148757551399*^9}, {
   3.7201886894732323`*^9, 3.7201887184628773`*^9}, {3.720504998657585*^9, 
   3.720505012860978*^9}, {3.720721633585623*^9, 3.720721645140532*^9}, {
   3.720807647701*^9, 3.720807656279951*^9}, {3.7208130424306192`*^9, 
   3.7208130519858093`*^9}, {3.7208926033249683`*^9, 3.720892611889628*^9}, {
   3.72089362151985*^9, 3.720893622678523*^9}, {3.720909446882286*^9, 
   3.720909447876141*^9}, {3.721103981370215*^9, 3.721103982923607*^9}, {
   3.7211817597424183`*^9, 3.721181759832815*^9}, 3.72128649928568*^9, {
   3.721287992580473*^9, 3.721287993076688*^9}, 3.721867347116873*^9, {
   3.721868283645455*^9, 3.7218682837425117`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "this", " ", "switch", " ", "is", " ", "for", " ", "controling", " ", 
     "of", " ", "two", " ", "versions", " ", "of", " ", "the", " ", 
     "executables"}], ",", " ", 
    RowBox[{"v1", ":", "False"}], ",", " ", 
    RowBox[{"v2", ":", " ", 
     RowBox[{"True", "\[IndentingNewLine]", "v1"}], ":", " ", 
     RowBox[{
      RowBox[{"read", " ", "Expt", " ", "IDs", " ", "from", " ", 
       RowBox[{"config1", ".", "txt"}], " ", "and", " ", "plot", " ", "all", 
       " ", "data", " ", "in", " ", "one", " ", "x"}], "-", 
      RowBox[{"\[Mu]", " ", "figure", "\[IndentingNewLine]", 
       RowBox[{"v2", ":", " ", 
        RowBox[{"read", " ", "Expt", " ", "IDs", " ", "from", " ", 
         RowBox[{"config1", ".", "txt"}], " ", "and", " ", "plot", " ", 
         "experiments", " ", "seperately"}]}]}]}]}], ",", " ", 
    RowBox[{
     RowBox[{
     "storing", " ", "each", " ", "Expt", " ", "plots", " ", "into", " ", 
      "the", " ", "directory", " ", "with", " ", 
      RowBox[{"it", "'"}], "s", " ", "name"}], " ", "\[Equal]", " ", 
     RowBox[{"Expt", " ", "ID"}]}]}], "  ", "\[IndentingNewLine]", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"LoopExptBool", "=", "False"}], ";"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7131259361511087`*^9, 3.713125987320829*^9}, {
  3.713126054801506*^9, 3.713126124119007*^9}, {3.713126180839493*^9, 
  3.713126503640934*^9}, {3.718592476928343*^9, 3.718592478857126*^9}, {
  3.718592605100793*^9, 3.718592606008563*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Switch", "[", "\[IndentingNewLine]", 
    RowBox[{
    "ThisFileExtension", ",", "\[IndentingNewLine]", "\"\<nb\>\"", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SetDirectory", "[", 
      RowBox[{"NotebookDirectory", "[", "]"}], 
      RowBox[{"(*", 
       RowBox[{"DirectoryName", "[", "$InputFileName", "]"}], "*)"}], " ", 
      "]"}], ",", "\[IndentingNewLine]", "\"\<m\>\"", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SetDirectory", "[", 
      RowBox[{"(*", 
       RowBox[{"NotebookDirectory", "[", "]"}], "*)"}], 
      RowBox[{"DirectoryName", "[", "$InputFileName", "]"}], " ", "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
      "Print", "[", 
       "\"\<file extension should be \\\"nb\\\" or \\\"m\\\"\>\"", "]"}], ";", 
      RowBox[{"Abort", "[", "]"}]}]}], "\[IndentingNewLine]", "]"}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"20171114", ":", " ", "\[IndentingNewLine]", 
    RowBox[{"SetDirectory", "[", 
     RowBox[{"NotebookDirectory", "[", "]"}], 
     RowBox[{"(*", 
      RowBox[{"DirectoryName", "[", "$InputFileName", "]"}], "*)"}], " ", 
     "]"}]}], "\[IndentingNewLine]", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"Get", "[", "\"\<corr_proj_funcs.m\>\"", "]"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.692985164173634*^9, 3.692985178415265*^9}, 
   3.6933121226758823`*^9, {3.693482326874186*^9, 3.693482364657818*^9}, {
   3.6934824093993273`*^9, 3.6934824122561913`*^9}, 3.697076793329196*^9, {
   3.6970826630081463`*^9, 3.697082667127668*^9}, {3.697083007950918*^9, 
   3.697083025522183*^9}, {3.697142087754139*^9, 3.697142091266272*^9}, 
   3.697142142847148*^9, {3.697155700029079*^9, 3.697155707851334*^9}, {
   3.6971603291918383`*^9, 3.697160432286948*^9}, {3.6974034607002296`*^9, 
   3.697403475824501*^9}, {3.697410327936952*^9, 3.6974103429271383`*^9}, 
   3.697417772959425*^9, {3.697555879467354*^9, 3.6975558893605957`*^9}, {
   3.6979021265919333`*^9, 3.697902135305357*^9}, {3.697996558396339*^9, 
   3.697996566797716*^9}, {3.698644694461232*^9, 3.698644702883518*^9}, {
   3.698645623591576*^9, 3.698645632187537*^9}, {3.702691933094817*^9, 
   3.7026919407393436`*^9}, {3.7026919956935663`*^9, 
   3.7026920026503077`*^9}, {3.705642175588872*^9, 3.705642183916155*^9}, {
   3.713122865959545*^9, 3.713123005984516*^9}, {3.7191689826466417`*^9, 
   3.7191689949599667`*^9}, {3.719730949872065*^9, 3.719730974446721*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"present directory: \"\>", 
   "\[InvisibleSpace]", \
"\<\"/home/botingw/Downloads/Sean_20171114/PDFsense-0320_for_sens_ranking_\
copy/bin_parrel22_nojet_tsv\"\>"}],
  SequenceForm[
  "present directory: ", 
   "/home/botingw/Downloads/Sean_20171114/PDFsense-0320_for_sens_ranking_copy/\
bin_parrel22_nojet_tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.720144696388948*^9, 3.720144810741227*^9, 3.720145495700119*^9, 
   3.72014678745185*^9, 3.720147169320963*^9, 3.72018831828052*^9, 
   3.720190504507353*^9, 3.720495929009359*^9, 3.720505266881147*^9, 
   3.720628292485796*^9, 3.720680297734885*^9, 3.720680659930004*^9, 
   3.72068076872574*^9, 3.7206810100604362`*^9, 3.7207136805935507`*^9, {
   3.720807328472129*^9, 3.720807337481612*^9}, 3.720814142988145*^9, 
   3.720892627984097*^9, 3.720892773107277*^9, 3.720893313964099*^9, 
   3.720893444867209*^9, 3.721090660280789*^9, 3.72109127611456*^9, 
   3.7210961902058487`*^9, 3.7210980428877993`*^9, 3.721141887292027*^9, 
   3.721181765812688*^9, 3.7211818367642937`*^9, 3.721240106787428*^9, 
   3.721284650387249*^9, 3.721285009945486*^9, 3.721862889621936*^9, 
   3.721867397141345*^9, 3.721868288285502*^9, 3.721868613642144*^9, 
   3.722188786018449*^9, 3.722474985421026*^9, 3.722489483799247*^9, 
   3.722871189151216*^9, 3.7258836674578648`*^9, 3.725890966863105*^9, 
   3.725896408682308*^9, 3.725988817474636*^9, 3.7277156218732224`*^9, 
   3.729004336374831*^9, 3.731953126295195*^9, 3.7320171319243298`*^9, 
   3.733292608179693*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"loading \"\>", 
   "\[InvisibleSpace]", "\<\"../lib/pdfParsePDS2013.m\"\>"}],
  SequenceForm["loading ", "../lib/pdfParsePDS2013.m"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.720144696388948*^9, 3.720144810741227*^9, 3.720145495700119*^9, 
   3.72014678745185*^9, 3.720147169320963*^9, 3.72018831828052*^9, 
   3.720190504507353*^9, 3.720495929009359*^9, 3.720505266881147*^9, 
   3.720628292485796*^9, 3.720680297734885*^9, 3.720680659930004*^9, 
   3.72068076872574*^9, 3.7206810100604362`*^9, 3.7207136805935507`*^9, {
   3.720807328472129*^9, 3.720807337481612*^9}, 3.720814142988145*^9, 
   3.720892627984097*^9, 3.720892773107277*^9, 3.720893313964099*^9, 
   3.720893444867209*^9, 3.721090660280789*^9, 3.72109127611456*^9, 
   3.7210961902058487`*^9, 3.7210980428877993`*^9, 3.721141887292027*^9, 
   3.721181765812688*^9, 3.7211818367642937`*^9, 3.721240106787428*^9, 
   3.721284650387249*^9, 3.721285009945486*^9, 3.721862889621936*^9, 
   3.721867397141345*^9, 3.721868288285502*^9, 3.721868613642144*^9, 
   3.722188786018449*^9, 3.722474985421026*^9, 3.722489483799247*^9, 
   3.722871189151216*^9, 3.7258836674578648`*^9, 3.725890966863105*^9, 
   3.725896408682308*^9, 3.725988817474636*^9, 3.7277156218732224`*^9, 
   3.729004336374831*^9, 3.731953126295195*^9, 3.7320171319243298`*^9, 
   3.733292608183093*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"loading \"\>", 
   "\[InvisibleSpace]", "\<\"../lib/dtareadbotingw2016.m\"\>"}],
  SequenceForm["loading ", "../lib/dtareadbotingw2016.m"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.720144696388948*^9, 3.720144810741227*^9, 3.720145495700119*^9, 
   3.72014678745185*^9, 3.720147169320963*^9, 3.72018831828052*^9, 
   3.720190504507353*^9, 3.720495929009359*^9, 3.720505266881147*^9, 
   3.720628292485796*^9, 3.720680297734885*^9, 3.720680659930004*^9, 
   3.72068076872574*^9, 3.7206810100604362`*^9, 3.7207136805935507`*^9, {
   3.720807328472129*^9, 3.720807337481612*^9}, 3.720814142988145*^9, 
   3.720892627984097*^9, 3.720892773107277*^9, 3.720893313964099*^9, 
   3.720893444867209*^9, 3.721090660280789*^9, 3.72109127611456*^9, 
   3.7210961902058487`*^9, 3.7210980428877993`*^9, 3.721141887292027*^9, 
   3.721181765812688*^9, 3.7211818367642937`*^9, 3.721240106787428*^9, 
   3.721284650387249*^9, 3.721285009945486*^9, 3.721862889621936*^9, 
   3.721867397141345*^9, 3.721868288285502*^9, 3.721868613642144*^9, 
   3.722188786018449*^9, 3.722474985421026*^9, 3.722489483799247*^9, 
   3.722871189151216*^9, 3.7258836674578648`*^9, 3.725890966863105*^9, 
   3.725896408682308*^9, 3.725988817474636*^9, 3.7277156218732224`*^9, 
   3.729004336374831*^9, 3.731953126295195*^9, 3.7320171319243298`*^9, 
   3.7332926082242126`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Global variables", "Section",
 CellChangeTimes->{{3.706788977874497*^9, 3.706788983612884*^9}, 
   3.706789014422559*^9, 3.7067892793048687`*^9, {3.713100950211649*^9, 
   3.713100976153716*^9}, {3.720157462833156*^9, 3.720157467032984*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"this", " ", "project", " ", "includes", " ", "three", " ", 
     RowBox[{"branches", ":", " ", 
      RowBox[{"Mathematica", " ", "script"}]}]}], ",", " ", 
    RowBox[{"python", " ", "script"}], ",", " ", 
    RowBox[{"and", " ", "webpage"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"1.", " ", "Mathematica", " ", 
     RowBox[{"script", ":", " ", 
      RowBox[{"by", " ", "setting", " ", "config", " ", "files"}]}]}], ",", 
    " ", 
    RowBox[{
    "users", " ", "can", " ", "read", " ", "CTEQ", " ", "analyzed", " ", 
     "data", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{".", "dta"}], " ", "&"}], " ", ".", "pds"}], " ", "files"}], 
      ")"}], " ", "to", " ", "extract", " ", "observables", " ", "by", " ", 
     RowBox[{"(", 
      RowBox[{"x", ",", "\[Mu]"}], ")"}]}], ",", " ", 
    RowBox[{"then", " ", "generate", " ", "figures", " ", "by", " ", 
     RowBox[{"run_v4", ".", "nb", ".", " ", "outputs"}], " ", "are", " ", 
     "in", " ", "a", " ", "subdirectory", " ", 
     RowBox[{
      RowBox[{"of", " ", "."}], "/", "plots"}], " ", "\[IndentingNewLine]", 
     "Advandage", " ", "are", " ", "that", " ", "1.", " ", "users", " ", 
     "can", " ", "generate", " ", "many", " ", "figures", " ", "of", " ", 
     "many", " ", "flavours"}], ",", " ", 
    RowBox[{
     RowBox[{"observables", ".", " ", "2."}], " ", "users", " ", "can", " ", 
     "customize", " ", "user", " ", "define", " ", "functions", 
     "\[IndentingNewLine]", " ", "\[IndentingNewLine]", "2.", " ", "python", 
     " ", 
     RowBox[{"script", ":", " ", 
      RowBox[{
      "users", " ", "can", " ", "use", " ", "python", " ", "script", " ", 
       "to", " ", "run", " ", "a", " ", "GUI"}]}]}], ",", " ", 
    RowBox[{
    "them", " ", "set", " ", "the", " ", "expected", " ", "outputs", " ", 
     "in", " ", "the", " ", 
     RowBox[{"GUI", ".", " ", "After"}], " ", "submit"}], ",", " ", 
    RowBox[{
    "outputs", " ", "will", " ", "show", " ", "by", " ", "html", " ", 
     "format", "\[IndentingNewLine]", "Advantages", " ", "are", " ", "1.", 
     " ", "easy", " ", "to", " ", "use", "  ", "2.", " ", "users", " ", "can",
      " ", "customize", " ", "user", " ", "define", " ", "functions", 
     "\[IndentingNewLine]", "3.", " ", 
     RowBox[{"webpage", ":", " ", 
      RowBox[{
      "users", " ", "can", " ", "use", " ", "the", " ", "python", " ", "GUI", 
       " ", "on", " ", "a", " ", 
       RowBox[{"website", ".", " ", "outputs"}], " ", "are", " ", "in", " ", 
       "another", " ", 
       RowBox[{"webpage", ".", "\[IndentingNewLine]", "Advantages"}]}], ":", 
      " ", 
      RowBox[{
      "1.", " ", "easy", " ", "to", " ", "use", " ", "2.", " ", "users", " ", 
       
       RowBox[{"don", "'"}], "t", " ", "need", " ", "to", " ", "install", " ",
        "Mathematica"}]}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", "\[IndentingNewLine]", 
   RowBox[{"modes", ":", "\[IndentingNewLine]", 
    RowBox[{
    "1.", " ", "Mathematica", " ", "script", "\[IndentingNewLine]", "2.", " ",
      "python", " ", "script", "\[IndentingNewLine]", "3.", " ", 
     "webpage"}]}], "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"BranchMode", "=", "2"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", "ClassifyMode", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
     "classify", " ", "data", " ", "by", " ", "various", " ", "groups"}], ",",
      " ", 
     RowBox[{
      RowBox[{"e", ".", "g", ".", " ", "DIS"}], " ", "\[Equal]", " ", "100", 
      "<", "ID", "<", "199"}], ",", " ", 
     RowBox[{"200", "<", "VBP", "<", "299"}], ",", " ", 
     RowBox[{
     "etc", "\[IndentingNewLine]", "then", " ", "use", " ", "different", " ", 
      "shapes", " ", "to", " ", "represent", " ", "data", " ", "points", " ", 
      "in", " ", "their", " ", "respective", " ", "groups", " ", "in", " ", 
      "output", " ", "figures", "\[IndentingNewLine]", 
      RowBox[{"modes", ":", "\[IndentingNewLine]", "\"\<all\>\"", ":", " ", 
       RowBox[{
       "all", " ", "data", " ", "use", " ", "one", " ", "shape", 
        "\[IndentingNewLine]", "\"\<single\>\""}], ":", " ", 
       RowBox[{
       "each", " ", "Expt", " ", "ID", " ", "one", " ", "shape"}]}]}]}], 
    "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ClassifyMode", "=", "\"\<single\>\""}], ";"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.720157477269477*^9, 3.7201576143359423`*^9}, {
  3.7201576747337723`*^9, 3.720158229543068*^9}, {3.720721240875095*^9, 
  3.720721466747151*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
read correlation (and other data of FigureType in config1.txt) from the data \
in files\
\>", "Section",
 CellChangeTimes->{
  3.696830464807551*^9, {3.713100704611657*^9, 3.713100774068632*^9}, {
   3.713100817627109*^9, 3.713100828506674*^9}}],

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Quicksaveplot", "[", "]"}], ":=", "\[IndentingNewLine]", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"(*", 
         RowBox[{
         "runfunc", ",", "figureDir", ",", "myPDFsetDir", ",", "PDFsetmethod",
           ",", "PDFname", ",", "PDFDataDir", ",", "datalistFile", ",", 
          "expttype", ",", "exptid"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
        "Jobid", ",", "PDFname", ",", "FigureType", ",", "FigureFlag", ",", 
         "ExptidType", ",", "ExptidFlag", ",", "CorrelationArgType", ",", 
         "CorrelationArgFlag", ",", "UserArgName", ",", "UserArgValue", ",", 
         "\[IndentingNewLine]", "XQfigureXrange", ",", "XQfigureYrange", ",", 
         "Hist1figureNbin", ",", "Hist1figureXrange", ",", 
         "Hist1figureYrange", ",", "\[IndentingNewLine]", "ColorSeperator", 
         ",", "\[IndentingNewLine]", "Size", ",", "HighlightType", ",", 
         "HighlightMode", ",", "HighlightMode1", ",", "HighlightMode2", ",", 
         "\[IndentingNewLine]", "UserArgFunction", 
         RowBox[{"(*", "20171116", "*)"}], ",", "\[IndentingNewLine]", 
         "JobDescription", ",", "ColorPaletterange"}], "\[IndentingNewLine]", 
        "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Print", "[", "\"\<begin function\>\"", "]"}], ";", "\n", 
        RowBox[{"(*", 
         RowBox[{"set", " ", "input", " ", "arguments"}], " ", "*)"}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"set", " ", "method", " ", "of", " ", 
           RowBox[{"(", 
            RowBox[{"x", ",", "Q"}], ")"}], " ", "points"}], ",", " ", 
          RowBox[{"options", ":", " ", "\"\<samept\>\""}], ",", " ", 
          "\"\<grid\>\"", ",", " ", "\"\<sameptgrid\>\""}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "sameptgrid", " ", "is", " ", "figures", " ", "of", " ", 
          "comparison", " ", "of", " ", "samept", " ", "data", " ", "and", 
          " ", "grid", " ", "data"}], "*)"}], "\n", 
        RowBox[{"PDFxQSelectMethod", "=", "\"\<samept\>\""}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<method to search (x,Q) points that dominate the process: \>\"", 
          ",", "PDFxQSelectMethod"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"set", " ", "input", " ", "arguments"}], " ", "*)"}], "\n", 
        "\n", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"set", " ", "config", " ", "file", " ", "path"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"configDir", "=", 
         RowBox[{
          RowBox[{"Directory", "[", "]"}], "<>", "\"\</\>\""}]}], ";", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"NotebookDirectory", "[", "]"}], ";"}], "*)"}], 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"DirectoryName", "[", "$InputFileName", "]"}], ";"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"configfilename", "=", "\"\<config1.txt\>\""}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<reading arguments from \>\"", ",", "configfilename"}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"20170301", ":", " ", 
            RowBox[{
            "new", " ", "config", " ", "file", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
              "runfunc", ",", "figureDir", ",", "dummy1", ",", "dummy2", ",", 
               "PDFname", ",", "dummy3", ",", "datalistFile", ",", "expttype",
                ",", "exptid"}], "}"}]}]}], "=", "\[IndentingNewLine]", 
           RowBox[{"readcorrconfigfile", "[", 
            RowBox[{"configDir", ",", "configfilename"}], "]"}]}], ";"}], 
         "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"new", " ", "config", " ", "file"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "20171109", " ", "use", " ", "readcorrconfigfile5", " ", "for", " ", 
          "new", " ", "highlight", " ", "range", " ", "convention"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Jobid", ",", "JobDescription", 
           RowBox[{"(*", "20171128", "*)"}], ",", "PDFname", ",", 
           "FigureType", ",", "FigureFlag", ",", "ExptidType", ",", 
           "ExptidFlag", ",", "CorrelationArgType", ",", "CorrelationArgFlag",
            ",", 
           RowBox[{"(*", 
            RowBox[{"UserArgName", ",", "UserArgValue", ","}], "*)"}], 
           "\[IndentingNewLine]", "XQfigureXrange", ",", "XQfigureYrange", 
           ",", "ColorPaletterange", 
           RowBox[{"(*", "20171128", "*)"}], ",", "Hist1figureNbin", ",", 
           RowBox[{"(*", 
            RowBox[{"Hist1figureXrange", ",", 
             RowBox[{"(*", "Hist1figureYrange", "*)"}], "dummy12", ","}], 
            "*)"}], "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"ColorSeperator", ","}], "*)"}], "\[IndentingNewLine]", 
           "Size", ",", "HighlightType", ",", "HighlightMode", ",", 
           "HighlightMode1", ",", "HighlightMode2"}], "}"}], "=", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", "readcorrconfigfile4", "*)"}], 
         RowBox[{"readcorrconfigfile6", "[", 
          RowBox[{"configDir", ",", "configfilename"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<input arguments: \>\"", ",", 
          RowBox[{"(*", "readcorrconfigfile4", "*)"}], 
          RowBox[{"readcorrconfigfile6", "[", 
           RowBox[{"configDir", ",", "configfilename"}], "]"}]}], " ", "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", "\"\<\>\"", "]"}], ";", 
        RowBox[{"(*", "space", "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"check", " ", "format", " ", "of", " ", "arguments"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", "xyrange", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"XQfigureXrange", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<auto\>\""}], ",", 
          RowBox[{
           RowBox[{"XQfigureXrange", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "=", 
           SuperscriptBox["10", 
            RowBox[{"-", "6"}]]}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"XQfigureXrange", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "\"\<auto\>\""}], ",", 
          RowBox[{
           RowBox[{"XQfigureXrange", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "=", "1"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"XQfigureYrange", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<auto\>\""}], ",", 
          RowBox[{
           RowBox[{"XQfigureYrange", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "=", "1.3"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"XQfigureYrange", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "\"\<auto\>\""}], ",", 
          RowBox[{
           RowBox[{"XQfigureYrange", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "=", "1200"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"Hist1figureNbin", "\[Equal]", "\"\<auto\>\""}], ",", 
            RowBox[{"Hist1figureNbin", "=", "5"}]}], "]"}], ";"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Hist1figureXrange", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<auto\>\""}], 
            ",", 
            RowBox[{
             RowBox[{"Hist1figureXrange", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "=", 
             SuperscriptBox["10", 
              RowBox[{"-", "6"}]]}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Hist1figureXrange", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "\"\<auto\>\""}], 
            ",", 
            RowBox[{
             RowBox[{"Hist1figureXrange", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "=", "1"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Hist1figureYrange", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<auto\>\""}], 
            ",", 
            RowBox[{
             RowBox[{"Hist1figureYrange", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "=", "1.3"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Hist1figureYrange", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "\"\<auto\>\""}], 
            ",", 
            RowBox[{
             RowBox[{"Hist1figureYrange", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "=", "1200"}]}], "]"}], ";"}], 
         "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
          "bar", " ", "seperator", " ", "input", " ", "has", " ", "only", " ",
            "3", " ", "elements"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Length", "[", "ColorSeperator", "]"}], "\[NotEqual]", 
             "3"}], ",", 
            RowBox[{
             RowBox[{
             "Print", "[", 
              "\"\<color seperator percentage should be three numbers\>\"", 
              "]"}], ";", 
             RowBox[{"Abort", "[", "]"}]}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
            "should", " ", "be", " ", "small", " ", "to", " ", "large"}], ",",
             " ", 
            RowBox[{"ex", ":", " ", "30"}], ",", " ", "50", ",", " ", "70"}], 
           "*)"}], "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Sort", "[", "ColorSeperator", "]"}], "\[NotEqual]", 
             "ColorSeperator"}], ",", 
            RowBox[{
             RowBox[{
             "Print", "[", 
              "\"\<color seperator percentage should from small to large\>\"",
               "]"}], ";", 
             RowBox[{"Abort", "[", "]"}]}]}], "]"}], ";"}], 
         "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
          "should", " ", "in", " ", "0", "%", " ", "to", " ", "100", "%"}], 
          ",", " ", 
          RowBox[{"ex", ":", " ", "35"}], ",", "55", ",", 
          RowBox[{"77.5", ";", " ", "35"}], ",", "76", ",", 
          RowBox[{"140.5", " ", "is", " ", "illegal"}]}], "*)"}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"size", ":", " ", 
           RowBox[{"if", " ", "highlight", " ", "mode"}]}], ",", " ", 
          RowBox[{"set", " ", "size", " ", "as", " ", "small"}], ",", " ", 
          RowBox[{
           RowBox[{"can", "'"}], "t", " ", "set", " ", "here"}], ",", " ", 
          RowBox[{
          "need", " ", "to", " ", "set", " ", "when", " ", "reading", " ", 
           "highlight", " ", "mode", " ", "of", " ", "a", " ", "figure", " ", 
           "type"}]}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"for", " ", "PDFname"}], ",", " ", 
          RowBox[{
          "test", " ", "whether", " ", "it", " ", "is", " ", "in", " ", 
           "quickdata"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"PDFname", "\[Equal]", "\"\<CT14NNLO\>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{"printprocessbyPDFsetquicksavemode", "[", 
              RowBox[{
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"quickdatacorr", "[", 
                   RowBox[{"[", 
                    RowBox[{"iexpt", ",", "1"}], "]"}], "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"\"\<exptinfo\>\"", ",", "\"\<exptid\>\""}], "]"}],
                   "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"iexpt", ",", "1", ",", 
                   RowBox[{"Length", "[", "quickdatacorr", "]"}]}], "}"}]}], 
                "]"}], ",", "datalistFile"}], "]"}], "*)"}], "\"\<dummy\>\"", 
            ",", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{
              "Print", "[", "\"\<error, the PDFset is not CT14NNLO\>\"", 
               "]"}], ";", 
              RowBox[{"Exit", "[", "]"}], ";"}], "*)"}], "\"\<dummy\>\""}], 
           RowBox[{"(*", 
            RowBox[{"20170426", ":", " ", 
             RowBox[{
             "begin", " ", "to", " ", "input", " ", "other", " ", 
              "PDFsets"}]}], "*)"}], "\[IndentingNewLine]", "]"}], ";"}], 
         "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"data", " ", "information", " ", 
          RowBox[{"(", 
           RowBox[{"files", ",", " ", "directory", ",", " ", "etc"}], ")"}], 
          " ", "of", " ", "figures", " ", "that", " ", "will", " ", "be", " ",
           "plotted"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"read", " ", 
          RowBox[{"plotdata_config", ".", "txt"}], " ", "to", " ", "get", " ",
           "arguments", " ", "of", " ", "plot", " ", "data", " ", "setting"}],
          "*)"}], "\[IndentingNewLine]", 
        RowBox[{
        "plotdataconfigfilename", "=", "\"\<plotdata_config.txt\>\""}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"datalistFile", ",", 
           RowBox[{"(*", "FxQGridDir", "*)"}], "dummy1", ",", 
           RowBox[{"(*", "FxQGridFile", "*)"}], "dummy2", ",", 
           RowBox[{"(*", "FxQSameptDir", "*)"}], "dummy3", ",", 
           RowBox[{"(*", "FxQSameptFile", "*)"}], "dummy4", ",", 
           "CorrDataDir", ",", "CorrDataFile", ",", 
           RowBox[{"(*", "GridNx", "*)"}], "dummy5", ",", 
           RowBox[{"(*", "GridNQ", "*)"}], "dummy6"}], "}"}], "=", 
         "\[IndentingNewLine]", 
         RowBox[{"readplotdataconfigfile", "[", 
          RowBox[{"configDir", ",", "plotdataconfigfilename"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<input arguments for read plot data: \>\"", ",", 
          RowBox[{"readplotdataconfigfile", "[", 
           RowBox[{"configDir", ",", "plotdataconfigfilename"}], "]"}]}], " ",
          "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
          "if", " ", "path", " ", "setting", " ", "is", " ", "default"}], ",",
           " ", 
          RowBox[{
          "set", " ", "it", " ", "as", " ", "in", " ", "quick_data", " ", 
           "directory"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"quickdataDir", "=", "\"\<../quick_data/\>\""}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"datalistFile", "\[Equal]", "\"\<default\>\""}], ",", 
          RowBox[{"datalistFile", "=", "\"\<./dat16lisformathematica\>\""}]}],
          "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"FxQGridDir", "\[Equal]", "\"\<default\>\""}], ",", 
            RowBox[{"FxQGridDir", "=", "quickdataDir"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"FxQGridFile", "\[Equal]", "\"\<default\>\""}], ",", 
            RowBox[{"FxQGridFile", "=", 
             RowBox[{
             "\"\<fxQ_grid_\>\"", "<>", "PDFname", "<>", "\"\<_x\>\"", "<>", 
              RowBox[{"ToString", "[", "GridNx", "]"}], "<>", "\"\<_Q\>\"", "<>", 
              RowBox[{"ToString", "[", "GridNQ", "]"}], "<>", 
              "\"\<.dat\>\""}]}]}], "]"}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"FxQSameptDir", "\[Equal]", "\"\<default\>\""}], ",", 
            RowBox[{"FxQSameptDir", "=", "quickdataDir"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"FxQSameptFile", "\[Equal]", "\"\<default\>\""}], ",", 
            RowBox[{"FxQSameptFile", "=", 
             RowBox[{
             "\"\<fxQ_samept_\>\"", "<>", "PDFname", "<>", 
              "\"\<.dat\>\""}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"CorrDataDir", "\[Equal]", "\"\<default\>\""}], ",", 
          RowBox[{"CorrDataDir", "=", "quickdataDir"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"CorrDataFile", "\[Equal]", "\"\<default\>\""}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"PDFxQSelectMethod", "==", "\"\<samept\>\""}], ",", 
             RowBox[{"CorrDataFile", "=", 
              RowBox[{
              "\"\<samept_data_\>\"", "<>", "PDFname", "<>", 
               "\"\<.dat\>\""}]}]}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"PDFxQSelectMethod", "==", "\"\<grid\>\""}], ",", 
             RowBox[{"CorrDataFile", "=", 
              RowBox[{
              "\"\<grid_data_\>\"", "<>", "PDFname", "<>", "\"\<_x\>\"", "<>", 
               RowBox[{"ToString", "[", "GridNx", "]"}], "<>", "\"\<_Q\>\"", "<>", 
               RowBox[{"ToString", "[", "GridNQ", "]"}], "<>", 
               "\"\<.dat\>\""}]}]}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"PDFxQSelectMethod", "==", "\"\<xgrid\>\""}], ",", 
             RowBox[{"CorrDataFile", "=", 
              RowBox[{
              "\"\<xgrid_data_\>\"", "<>", "PDFname", "<>", "\"\<_x\>\"", "<>", 
               RowBox[{"ToString", "[", "GridNx", "]"}], "<>", 
               "\"\<.dat\>\""}]}]}], "]"}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"PDFxQSelectMethod", "==", "\"\<sameptgrid\>\""}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"CorrDataFileSamept", "=", 
               RowBox[{
               "\"\<samept_data_\>\"", "<>", "PDFname", "<>", 
                "\"\<.dat\>\""}]}], ";", 
              RowBox[{"CorrDataFileGrid", "=", 
               RowBox[{
               "\"\<xgrid_data_\>\"", "<>", "PDFname", "<>", "\"\<_x\>\"", "<>", 
                RowBox[{"ToString", "[", "GridNx", "]"}], "<>", 
                "\"\<.dat\>\""}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
           "\"\<dummy\>\""}]}], "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"for", " ", "arguments", " ", "which", " ", "we", " ", 
           RowBox[{"don", "'"}], "t", " ", "want", " ", "not", " ", "show", 
           " ", "on", " ", "web", " ", "version"}], ",", " ", 
          RowBox[{
          "we", " ", "setup", " ", "them", " ", "is", " ", "web", " ", 
           "version", " ", "mathematica", " ", "as", " ", "internal", " ", 
           "variable"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"datalistFile", "=", "\"\<./dat16lisformathematica\>\""}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"expttype", "=", "\"\<multi\>\""}], ";"}], 
         "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", "exptid", ";", 
        
        RowBox[{"(*", 
         RowBox[{
         "it", " ", "will", " ", "equal", " ", "to", " ", "exptlist"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"figureDir", "=", "\"\<../plots/\>\""}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "read", " ", "data", " ", "from", " ", "data", " ", "package"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "decide", " ", "which", " ", "data", " ", "file", " ", "to", " ", 
          "read", " ", "bassed", " ", "on", " ", "PDFname"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"quickdataDir", "=", "\"\<../quick_data/\>\""}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"CorrDataDir", "=", "quickdataDir"}], ";"}], 
         "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"correlationdatapackage", "=", 
           RowBox[{
           "quickdataDir", "<>", "PDFname", "<>", 
            "\"\<_correlation_data.dat\>\""}]}], ";"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"Nx", "=", "80"}], ";", 
          RowBox[{"NQ", "=", "25"}], ";"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"20171101", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{"\"\<file status: \>\"", ",", 
             RowBox[{"FileExistsQ", "[", 
              RowBox[{
              "CorrDataDir", "<>", "\"\<corr_samept_data_\>\"", "<>", 
               "PDFname", "<>", "\"\<.dat\>\""}], "]"}]}], " ", "]"}]}], 
          ";"}], "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<present directory:\\n\>\"", ",", 
          RowBox[{"Directory", "[", "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<quick correlation data:\\n\>\"", ",", 
          RowBox[{"FileNames", "[", 
           RowBox[{
           "CorrDataDir", "<>", "\"\<*samept_data_\>\"", "<>", "PDFname", 
            "<>", "\"\<*\>\""}], "]"}]}], " ", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", "\"\<\>\"", "]"}], ";", 
        RowBox[{"(*", "space", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"FileExistsQ", "[", "correlationdatapackage", "]"}], 
             "\[Equal]", "True"}], ",", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{"<<", "correlationdatapackage"}], "*)"}], 
            RowBox[{
             RowBox[{"Get", "[", "correlationdatapackage", "]"}], ";", 
             RowBox[{
             "Print", "[", "\"\<loading quick correlation data...\>\"", 
              "]"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Print", "[", 
              RowBox[{
              "\"\<error, the correlation data of PDFname \>\"", ",", 
               "PDFname", ",", "\"\<does not exist in quick database\>\""}], 
              "]"}], ";", 
             RowBox[{"Abort", "[", "]"}]}]}], "\[IndentingNewLine]", "]"}], 
          ";"}], "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"20170226", ":", " ", 
           RowBox[{"for", " ", "quick", " ", "save", " ", "mode"}]}], ",", 
          " ", 
          RowBox[{
          "correlation", " ", "data", " ", "are", " ", "loaded", " ", "from", 
           " ", 
           RowBox[{"a", " ", ".", "m"}], " ", "package"}], ",", " ", 
          RowBox[{"so", " ", "reading", " ", "experimental", " ", "id", " ", 
           RowBox[{"from", " ", ".", "dta"}], " ", "files", " ", "are", " ", 
           "replaced", " ", "by", " ", "reading", " ", "package"}]}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"myPDFsetdtafile", "=", 
           RowBox[{
            RowBox[{"FileNames", "[", 
             RowBox[{"myPDFsetDir", "<>", "\"\<*dta\>\""}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "*)"}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
          "set", " ", "dta", " ", "Dir", " ", "you", " ", "want", " ", "to", 
           " ", "read", " ", "data"}], ",", " ", 
          RowBox[{
           RowBox[{"it", "'"}], "s", " ", "the", " ", "PDFset", " ", "Dir", 
           " ", "you", " ", "choose"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"20170226", ":", " ", 
          RowBox[{
           RowBox[{"don", "'"}], "t", " ", "need", " ", "to", " ", "load", 
           " ", "dta", " ", "file", " ", "for", " ", "expt", " ", 
           "information", " ", "and", " ", "data"}]}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"DtaDir", "=", "myPDFsetDir"}], ";"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"experiments", " ", "you", " ", "choose"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"processes", "=", 
           RowBox[{"{", 
            RowBox[{
            "PDISNC", ",", "NDISCC", ",", "PDISNCCC", ",", "PVBPZ", ",", 
             "PVBPW", ",", "PJP", ",", "hDISNC", ",", "hDISCC", ",", 
             "hVBPZ"}], "}"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"exptlistAll", "=", 
           RowBox[{"processes", "//", "Flatten"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"exptlistProtonNeutron", "=", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "PDISNC", ",", "NDISCC", ",", "PDISNCCC", ",", "PVBPZ", ",", 
              "PVBPW", ",", "PJP"}], "}"}], "//", "Flatten"}]}], ";"}], 
         "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"20170301", ":", " ", 
          RowBox[{
          "exptid", " ", "read", " ", "by", " ", "new", " ", "config"}]}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"exptlist", "=", "exptlistAll"}], ";"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", "\"\<read experimental id\>\"", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"exptlist", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "check", " ", "argument", " ", "inputs", " ", "are", " ", 
          "correct"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Nexpt1", "=", 
         RowBox[{"Length", "[", "ExptidType", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Nexpt2", "=", 
         RowBox[{"Length", "[", "ExptidFlag", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"Nexpt1", "!=", "Nexpt2"}], ",", 
          RowBox[{
           RowBox[{
           "Print", "[", 
            "\"\<configure file error, # of exptid is different with # of \
exptidflag\>\"", "]"}], ";", 
           RowBox[{"Abort", "[", "]"}]}]}], " ", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"ExptidFlag", "[", 
               RowBox[{"[", "iexpt", "]"}], "]"}], "\[NotEqual]", "0"}], " ", 
             "&&", 
             RowBox[{
              RowBox[{"ExptidFlag", "[", 
               RowBox[{"[", "iexpt", "]"}], "]"}], "\[NotEqual]", "1"}]}], 
            ",", 
            RowBox[{
             RowBox[{
             "Print", "[", 
              "\"\<configure file error, exptidflag is not 1 or 0\>\"", "]"}],
              ";", 
             RowBox[{"Abort", "[", "]"}]}]}], " ", "]"}], 
          "\[IndentingNewLine]", ",", 
          RowBox[{"{", 
           RowBox[{"iexpt", ",", "1", ",", 
            RowBox[{"Length", "[", "ExptidType", "]"}]}], "}"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"it", " ", "flag", " ", "is", " ", "on"}], ",", " ", 
          RowBox[{
          "add", " ", "that", " ", "exptid", " ", "into", " ", "exptlist"}]}],
          "*)"}], 
        RowBox[{"(*", 
         RowBox[{"20170410", ":", " ", 
          RowBox[{"exptlist", " ", 
           RowBox[{"doesn", "'"}], "t", " ", "mean", " ", "the", " ", "expts",
            " ", "of", " ", "final", " ", "made", " ", "figure", " ", 
           "because", " ", "quick_data", " ", "does", " ", "not", " ", "must",
            " ", "have", " ", "all", " ", "expts"}]}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"ExptidFlag", "[", 
              RowBox[{"[", "iexpt", "]"}], "]"}], "\[Equal]", "1"}], ",", 
            RowBox[{"exptlist", "=", 
             RowBox[{"Append", "[", 
              RowBox[{"exptlist", ",", 
               RowBox[{"ExptidType", "[", 
                RowBox[{"[", "iexpt", "]"}], "]"}]}], " ", "]"}]}]}], " ", 
           "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"iexpt", ",", "1", ",", 
            RowBox[{"Length", "[", "ExptidType", "]"}]}], "}"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"if", " ", "version", " ", "2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"LoopExptBool", "==", "True"}], ";"}], ")"}]}], ",", " ", 
          RowBox[{
           RowBox[{"select", " ", "only", " ", "n"}], "-", 
           RowBox[{
           "th", " ", "expt", " ", "in", " ", "the", " ", "loop"}]}]}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"LoopExptBool", "==", "True"}], ",", 
          RowBox[{"exptlist", "=", 
           RowBox[{"{", 
            RowBox[{"exptlist", "[", 
             RowBox[{"[", "irun", "]"}], "]"}], "}"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"20170301", ":", " ", "exptid"}], " ", "=", " ", 
          "exptlist"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"exptid", " ", "=", " ", "exptlist"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<selected Expt IDs = \>\"", ",", "exptid"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", "\"\<\>\"", "]"}], ";", 
        RowBox[{"(*", "space", "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\n", "\n", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "**", "**", "**", "**", "**", "**", "**", "**", "**", "RUN", "**", "**",
           "**", "**", "**", "**", "**", "**", "**"}], "*******)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"read", " ", "experiments", " ", "info", " ", 
          RowBox[{"(", 
           RowBox[{"expt", " ", "names"}], ")"}]}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"lisTable", "="}], "*)"}], 
        RowBox[{"ReadLisFile", "[", "datalistFile", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"correlation", ",", " ", 
          RowBox[{"dr", "*", "correlation"}], ",", " ", 
          RowBox[{"deltaR", " ", "calculation"}]}], " ", "*)"}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{"calculate", " ", "correlation"}], "*)"}], "\n", 
         RowBox[{
          RowBox[{"corrfxQdtaobsclass", "=", "quickdatacorr"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
           "get", " ", "some", " ", "data", " ", "from", " ", "package"}], 
           "*)"}], "\[IndentingNewLine]", 
          RowBox[{"residualclass", "=", "\"\<unset\>\""}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"theoryerrorclass", "=", "\"\<unset\>\""}], ";", "\n", 
          RowBox[{"expterrorclass", "\"\<unset\>\""}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"FigureFlag", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "1"}], ",", 
            RowBox[{"expterrorclass", "=", "quickdataexpterror"}]}], "]"}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"FigureFlag", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", "1"}], " ", "||", 
             " ", 
             RowBox[{
              RowBox[{"CorrelationArgFlag", "[", 
               RowBox[{"[", 
                RowBox[{"-", "1"}], "]"}], "]"}], "\[Equal]", "1"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"residualclass", "=", "quickdataresidual"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{
              "check", " ", "user", " ", "define", " ", "mode", " ", "has", 
               " ", "Nset", " ", "#", " ", "of", " ", "value"}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"Datamethods", "[", 
                  RowBox[{"[", "\"\<getNcolumn\>\"", "]"}], "]"}], "[", 
                 RowBox[{"residualclass", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], " ", "]"}], "\[Equal]", 
                RowBox[{
                 RowBox[{"Length", "[", "UserArgValue", "]"}], "+", "2"}]}], 
               ",", "\[IndentingNewLine]", 
               RowBox[{"Print", "[", 
                RowBox[{"\"\<#user value is correct, Nset = \>\"", ",", 
                 RowBox[{"Length", "[", "UserArgValue", "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Print", "[", 
                RowBox[{
                "\"\<error, #user value is different, it should be \>\"", ",", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Datamethods", "[", 
                    RowBox[{"[", "\"\<getNcolumn\>\"", "]"}], "]"}], "[", 
                   RowBox[{"residualclass", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], " ", "]"}], "-", "2"}]}], 
                "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
             "\[IndentingNewLine]", "\"\<dummy\>\""}]}], 
           "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", "*)"}],
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "read", " ", "data", " ", "from", " ", "quick_data", " ", 
          "directory"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"export", " ", "into", " ", "files"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"save", " ", "f", 
          RowBox[{"(", 
           RowBox[{"x", ",", " ", "Q"}], ")"}], " ", "grid", " ", 
          RowBox[{"into", " ", ".", "dat"}], " ", "file"}], "*)"}], 
        "\[IndentingNewLine]", "corrdataclass", ";", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
         "expterrordataclass", ",", "residualdataclass", ",", "dRdataclass"}],
          "}"}], ";", "\[IndentingNewLine]", "dRcorrdataclass", ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"CorrDataDir", "=", "\"\<default\>\""}], ";", 
          RowBox[{"CorrDataFile", "=", "\"\<default\>\""}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"x", ",", "Q"}], ")"}], " ", "points", " ", "sets", " ", 
            "as", " ", "position", " ", "at", " ", "max", " ", "of", " ", 
            "corr"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"CorrDataDir", "\[Equal]", "\"\<default\>\""}], ",", 
            RowBox[{"CorrDataDir", "=", "quickdataDir"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"CorrDataFile", "\[Equal]", "\"\<default\>\""}], ",", 
            RowBox[{"CorrDataFile", "=", 
             RowBox[{
             "\"\<samept_data_\>\"", "<>", "PDFname", "<>", 
              "\"\<.dat\>\""}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Print", "[", "\"\<filenames of plotted data:\>\"", "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<Directory: \>\"", ",", "CorrDataDir"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"20171101", " ", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{"\"\<corrdataclass: \>\"", ",", 
             RowBox[{"\"\<corr_\>\"", "<>", "CorrDataFile"}], ",", 
             "\"\<\\nexpterrordataclass: \>\"", ",", 
             RowBox[{"\"\<expterror_\>\"", "<>", "CorrDataFile"}], ",", 
             "\"\<\\nresidualdataclass: \>\"", ",", 
             RowBox[{"\"\<residual_\>\"", "<>", "CorrDataFile"}], ",", 
             "\"\<\\ndRdataclass: \>\"", ",", 
             RowBox[{"\"\<dR_\>\"", "<>", "CorrDataFile"}], ",", 
             "\"\<\\ndRcorrdataclass: \>\"", ",", 
             RowBox[{"\"\<dRcorr_\>\"", "<>", "CorrDataFile"}], ",", 
             "\"\<\\nresidualNsetdataclass: \>\"", ",", 
             RowBox[{"\"\<residualNset_\>\"", "<>", "CorrDataFile"}], ",", 
             "\"\<\\n\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"20171101", " ", "change", "  ", "data", " ", "format"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<residualNsetclass: \>\"", ",", 
          RowBox[{"\"\<residualNset_\>\"", "<>", "CorrDataFile"}], ",", 
          "\"\<\\nfxQsamept2class: \>\"", ",", 
          RowBox[{"\"\<fxQNset_\>\"", "<>", "CorrDataFile"}], ",", 
          "\"\<\\ndtacentralclass: \>\"", ",", 
          RowBox[{"\"\<dtacentral_\>\"", "<>", "CorrDataFile"}], ",", 
          "\"\<\\n\>\""}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "20171124", " ", "check", " ", "whether", " ", "plotted", " ", 
          "data", " ", "files", " ", "exist"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"FileExistsQ", "[", 
            RowBox[{"(", 
             RowBox[{
             "CorrDataDir", "<>", "\"\<residualNset_\>\"", "<>", 
              "CorrDataFile"}], ")"}], "]"}], "\[Equal]", "False"}], ",", 
          RowBox[{
           RowBox[{"Print", "[", 
            RowBox[{"\"\<error, file \>\"", ",", 
             RowBox[{"(", 
              RowBox[{
              "CorrDataDir", "<>", "\"\<residualNset_\>\"", "<>", 
               "CorrDataFile"}], ")"}], ",", "\"\< doesn't exist\>\""}], 
            "]"}], ";", 
           RowBox[{"Abort", "[", "]"}]}]}], " ", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"FileExistsQ", "[", 
            RowBox[{"(", 
             RowBox[{
             "CorrDataDir", "<>", "\"\<fxQNset_\>\"", "<>", "CorrDataFile"}], 
             ")"}], "]"}], "\[Equal]", "False"}], ",", 
          RowBox[{
           RowBox[{"Print", "[", 
            RowBox[{"\"\<error, file \>\"", ",", 
             RowBox[{"(", 
              RowBox[{
              "CorrDataDir", "<>", "\"\<fxQNset_\>\"", "<>", "CorrDataFile"}],
               ")"}], ",", "\"\< doesn't exist\>\""}], "]"}], ";", 
           RowBox[{"Abort", "[", "]"}]}]}], " ", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"FileExistsQ", "[", 
            RowBox[{"(", 
             RowBox[{
             "CorrDataDir", "<>", "\"\<dtacentral_\>\"", "<>", 
              "CorrDataFile"}], ")"}], "]"}], "\[Equal]", "False"}], ",", 
          RowBox[{
           RowBox[{"Print", "[", 
            RowBox[{"\"\<error, file \>\"", ",", 
             RowBox[{"(", 
              RowBox[{
              "CorrDataDir", "<>", "\"\<dtacentral_\>\"", "<>", 
               "CorrDataFile"}], ")"}], ",", "\"\< doesn't exist\>\""}], 
            "]"}], ";", 
           RowBox[{"Abort", "[", "]"}]}]}], " ", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "read", " ", "correlation", " ", "data", " ", "of", " ", "grid"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"20171101", ":", " ", 
           RowBox[{"change", " ", "data", " ", "file", " ", "format"}], ":", 
           " ", 
           RowBox[{"fxQ", " ", 
            RowBox[{"Nset", ":", " ", 
             RowBox[{"[", 
              RowBox[{"[", 
               RowBox[{"iexpt", ",", "iflavour"}], "]"}], "]"}]}]}]}], ",", 
          " ", 
          RowBox[{
           RowBox[{"[", 
            RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "=", 
           RowBox[{"LF", "[", 
            RowBox[{"x", ",", "Q", ",", 
             RowBox[{"f", 
              SubscriptBox[
               RowBox[{"(", 
                RowBox[{"x", ",", "Q"}], ")"}], "1"]}], ",", "...", ",", 
             RowBox[{"f", 
              SubscriptBox[
               RowBox[{"(", 
                RowBox[{"x", ",", "Q"}], ")"}], "N"]}]}], "]"}]}], ",", " ", 
          RowBox[{"residual", " ", 
           RowBox[{"Nset", ":", " ", 
            RowBox[{"[", 
             RowBox[{"[", "iexpt", "]"}], "]"}]}]}], ",", " ", 
          RowBox[{"LF", "[", 
           RowBox[{"x", ",", "Q", ",", 
            SubscriptBox["r", "1"], ",", "...", ",", 
            SubscriptBox["r", "N"]}], "]"}], ",", " ", 
          RowBox[{"dtacentralclass", ":", " ", 
           RowBox[{"[", 
            RowBox[{"[", "iexpt", "]"}], "]"}]}], ",", " ", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"LF", "[", 
              RowBox[{
               SubscriptBox["val", "1"], ",", 
               SubscriptBox["val", "2"], ",", 
               RowBox[{"...", 
                SubscriptBox["val", "l"]}], ",", "x", ",", "Q"}], "]"}], 
             "\[IndentingNewLine]", "corrdataclass"}], "=", 
            RowBox[{"Import", "[", 
             RowBox[{
              RowBox[{
              "CorrDataDir", "<>", "\"\<corr_\>\"", "<>", "CorrDataFile"}], 
              ",", "\"\<ExpressionML\>\""}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"expterrordataclass", "=", 
            RowBox[{"Import", "[", 
             RowBox[{
              RowBox[{
              "CorrDataDir", "<>", "\"\<expterror_\>\"", "<>", 
               "CorrDataFile"}], ",", "\"\<ExpressionML\>\""}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"residualdataclass", "=", 
            RowBox[{"Import", "[", 
             RowBox[{
              RowBox[{
              "CorrDataDir", "<>", "\"\<residual_\>\"", "<>", 
               "CorrDataFile"}], ",", "\"\<ExpressionML\>\""}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"dRdataclass", "=", 
            RowBox[{"Import", "[", 
             RowBox[{
              RowBox[{
              "CorrDataDir", "<>", "\"\<dR_\>\"", "<>", "CorrDataFile"}], 
              ",", "\"\<ExpressionML\>\""}], "]"}]}], ";"}]}], 
         "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "read", " ", "dR", "*", "correlation", " ", "data", " ", "of", " ", 
          "grid"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"dRcorrdataclass", "=", 
           RowBox[{"Import", "[", 
            RowBox[{
             RowBox[{
             "CorrDataDir", "<>", "\"\<dRcorr_\>\"", "<>", "CorrDataFile"}], 
             ",", "\"\<ExpressionML\>\""}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"residualNsetdataclass", "=", 
           RowBox[{"Import", "[", 
            RowBox[{
             RowBox[{
             "CorrDataDir", "<>", "\"\<residualNset_\>\"", "<>", 
              "CorrDataFile"}], ",", "\"\<ExpressionML\>\""}], "]"}]}], ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"corrfxQdtaobsclass", ">>", 
           RowBox[{"(", 
            RowBox[{
            "CorrDataDir", "<>", "\"\<corr_\>\"", "<>", "CorrDataFile"}], 
            ")"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"dRcorrfxQdtaobsclass", ">>", 
           RowBox[{"(", 
            RowBox[{
            "CorrDataDir", "<>", "\"\<dRcorr_\>\"", "<>", "CorrDataFile"}], 
            ")"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"expterrorclass", ">>", 
           RowBox[{"(", 
            RowBox[{
            "CorrDataDir", "<>", "\"\<expterror_\>\"", "<>", "CorrDataFile"}],
             ")"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"residualclass", ">>", 
           RowBox[{"(", 
            RowBox[{
            "CorrDataDir", "<>", "\"\<residual_\>\"", "<>", "CorrDataFile"}], 
            ")"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"deltaRclass", ">>", 
           RowBox[{"(", 
            RowBox[{
            "CorrDataDir", "<>", "\"\<dR_\>\"", "<>", "CorrDataFile"}], 
            ")"}]}], ";"}], "\[IndentingNewLine]", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
         "residualNsetclass", ",", "fxQsamept2class", ",", 
          "dtacentralclass"}], "}"}], ";", "\[IndentingNewLine]", 
        RowBox[{"residualNsetclass", "=", 
         RowBox[{"Get", "[", 
          RowBox[{"(", 
           RowBox[{
           "CorrDataDir", "<>", "\"\<residualNset_\>\"", "<>", 
            "CorrDataFile"}], ")"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"save", " ", "Nset", " ", "of", " ", "fxQ"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"fxQsamept2class", "=", 
         RowBox[{"Get", "[", 
          RowBox[{"(", 
           RowBox[{
           "CorrDataDir", "<>", "\"\<fxQNset_\>\"", "<>", "CorrDataFile"}], 
           ")"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"dtacentralclass", "=", 
         RowBox[{"Get", "[", 
          RowBox[{"(", 
           RowBox[{
           "CorrDataDir", "<>", "\"\<dtacentral_\>\"", "<>", "CorrDataFile"}],
            ")"}], "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]",
         "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"set", " ", "fmax"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"fmax", "=", 
           RowBox[{"Length", "[", 
            RowBox[{"corrdataclass", "[", 
             RowBox[{"[", "1", "]"}], "]"}], " ", "]"}]}], ";"}], 
         "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"fmax", "=", 
         RowBox[{"Length", "[", 
          RowBox[{"fxQsamept2class", "[", 
           RowBox[{"[", "1", "]"}], "]"}], " ", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", "\"\<Dimensions of plotted data\>\"", "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
           "20171101", " ", "change", "  ", "data", " ", "format", 
            "\[IndentingNewLine]", "\"\<corrdataclass: \>\""}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Dimensions", "[", "corrdataclass", "]"}], ",", 
           "\[IndentingNewLine]", "\"\<dRcorrdataclass: \>\"", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Dimensions", "[", "dRcorrdataclass", "]"}], ",", 
           "\[IndentingNewLine]", 
           "\"\<{expterrordataclass,residualdataclass,dRdataclass}: \>\"", 
           ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"Dimensions", "[", "#", "]"}], "&"}], "/@", 
            RowBox[{"{", 
             RowBox[{
             "expterrordataclass", ",", "residualdataclass", ",", 
              "dRdataclass"}], "}"}]}], ","}], "\[IndentingNewLine]", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{
         "\"\<{residual Nset class}: \>\"", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"Dimensions", "[", "#", "]"}], "&"}], "/@", 
           RowBox[{"{", "residualNsetclass", "}"}]}], ",", 
          "\[IndentingNewLine]", "\"\<{fxQ samept class}: \>\"", ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"Dimensions", "[", "#", "]"}], "&"}], "/@", 
           RowBox[{"{", "fxQsamept2class", "}"}]}], ",", 
          "\[IndentingNewLine]", "\"\<{dta central class}: \>\"", ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"Dimensions", "[", "#", "]"}], "&"}], "/@", 
           RowBox[{"{", "dtacentralclass", "}"}]}]}], "\[IndentingNewLine]", 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", "\"\<\>\"", "]"}], ";", 
        RowBox[{"(*", "space", "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
          "20171127", " ", "for", " ", "fraction", " ", "number", " ", 
           "input"}], ",", " ", 
          RowBox[{
          "transfer", " ", "them", " ", "to", " ", "numerical", " ", 
           "number"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"ToNumericTime", "=", "\[IndentingNewLine]", 
         RowBox[{"AbsoluteTiming", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Table", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"fxQsamept2class", "[", 
                RowBox[{"[", 
                 RowBox[{"iexpt", ",", "iflavour"}], "]"}], "]"}], "[", 
               RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "=", 
              RowBox[{
               RowBox[{
                RowBox[{"fxQsamept2class", "[", 
                 RowBox[{"[", 
                  RowBox[{"iexpt", ",", "iflavour"}], "]"}], "]"}], "[", 
                RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "/.", 
               RowBox[{
                RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
                RowBox[{"LF", "@@", 
                 RowBox[{"(", 
                  RowBox[{"N", "[", 
                   RowBox[{"{", "a", "}"}], "]"}], ")"}]}]}]}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"iexpt", ",", 
               RowBox[{"Length", "[", "fxQsamept2class", "]"}]}], "}"}], ",", 
             
             RowBox[{"{", 
              RowBox[{"iflavour", ",", 
               RowBox[{"Length", "[", 
                RowBox[{"fxQsamept2class", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], " ", "]"}]}], "}"}]}], 
            "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Table", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"residualNsetclass", "[", 
                RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
               RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "=", 
              RowBox[{
               RowBox[{
                RowBox[{"residualNsetclass", "[", 
                 RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "/.", 
               RowBox[{
                RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
                RowBox[{"LF", "@@", 
                 RowBox[{"(", 
                  RowBox[{"N", "[", 
                   RowBox[{"{", "a", "}"}], "]"}], ")"}]}]}]}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"iexpt", ",", 
               RowBox[{"Length", "[", "fxQsamept2class", "]"}]}], "}"}]}], 
            "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
           "\"\<dummy\>\""}], "\[IndentingNewLine]", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<fraction numbers in data transfer to numerical numbers, time = \
\>\"", ",", "ToNumericTime", ",", "\"\< seconds\>\""}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", "\"\<\>\"", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
          "set", " ", "expeiments", " ", "by", " ", "selecting", " ", "expt", 
           " ", "data", " ", "whose", " ", "ID", " ", "are", " ", "in", " ", 
           "the", " ", 
           RowBox[{"config1", ".", "txt"}], " ", "into", " ", 
           "corrdataclassfinal"}], ",", " ", "..."}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"residualNsetclassfinal", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"fxQsamept2classfinal", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"dtacentralclassfinal", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"expttakeindex", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"exptlistfinal", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"logfile", "=", "\"\<error_massage.log\>\""}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "make", " ", "index", " ", "of", " ", "data", " ", "with", " ", 
          "the", " ", "same", " ", "expt", " ", "id", " ", "as", " ", 
          "exptlist"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"residualNsetclass", "[", 
                RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
               RowBox[{"[", 
                RowBox[{"\"\<exptinfo\>\"", ",", "\"\<exptid\>\""}], "]"}], 
               "]"}], "==", 
              RowBox[{"exptlist", "[", 
               RowBox[{"[", "iexptlist", "]"}], "]"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"expttakeindex", "=", 
               RowBox[{"Append", "[", 
                RowBox[{"expttakeindex", ",", "iexpt"}], "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{"make", " ", "exptlistfinal"}], "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{"exptlistfinal", "=", 
               RowBox[{"Append", "[", 
                RowBox[{"exptlistfinal", ",", 
                 RowBox[{"exptlist", "[", 
                  RowBox[{"[", "iexptlist", "]"}], "]"}]}], " ", "]"}]}], 
              ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
           "\[IndentingNewLine]", "\"\<dummy\>\""}], "\[IndentingNewLine]", 
          ",", 
          RowBox[{"{", 
           RowBox[{"iexptlist", ",", "1", ",", 
            RowBox[{"Length", "[", "exptlist", "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"iexpt", ",", "1", ",", 
            RowBox[{"Length", "[", "residualNsetclass", "]"}]}], "}"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "expttakeindex", ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "print", " ", "error", " ", "message", " ", "for", " ", "exptids", 
          " ", "exptlist", " ", 
          RowBox[{"don", "'"}], "t", " ", "appear", " ", "in", " ", 
          "database"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"exptlistnotfound", "=", 
         RowBox[{"Complement", "[", 
          RowBox[{"exptlist", ",", "exptlistfinal"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "exptlistnotfound", "]"}], "\[NotEqual]", 
           "0"}], ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<the exptid = \>\"", ",", "exptlistnotfound", ",", 
            "\"\< are not found in database\>\""}], "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "pick", " ", "the", " ", "data", " ", "of", " ", "experiments", " ", 
          "for", " ", "plot"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"residualNsetclassfinal", "=", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"residualNsetclass", "[", 
            RowBox[{"[", 
             RowBox[{"expttakeindex", "[", 
              RowBox[{"[", "iexpttakeindex", "]"}], "]"}], " ", "]"}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"iexpttakeindex", ",", "1", ",", 
             RowBox[{"Length", "[", "expttakeindex", "]"}]}], "}"}]}], 
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"fxQsamept2classfinal", "=", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"fxQsamept2class", "[", 
            RowBox[{"[", 
             RowBox[{"expttakeindex", "[", 
              RowBox[{"[", "iexpttakeindex", "]"}], "]"}], " ", "]"}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"iexpttakeindex", ",", "1", ",", 
             RowBox[{"Length", "[", "expttakeindex", "]"}]}], "}"}]}], 
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"dtacentralclassfinal", "=", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"dtacentralclass", "[", 
            RowBox[{"[", 
             RowBox[{"expttakeindex", "[", 
              RowBox[{"[", "iexpttakeindex", "]"}], "]"}], " ", "]"}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"iexpttakeindex", ",", "1", ",", 
             RowBox[{"Length", "[", "expttakeindex", "]"}]}], "}"}]}], 
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{
        "Print", "[", 
         "\"\<check whether the selected expts are also in the plotted data \
files\>\"", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<expt list: \>\"", ",", "exptlist"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<expt list in the ./quick_data: \>\"", ",", "exptlistfinal"}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"for", " ", "run_loopexpts", 
           RowBox[{"_v4", ".", 
            RowBox[{"nb", ":", " ", 
             RowBox[{
             "users", " ", "want", " ", "to", " ", "generate", " ", "figures",
               " ", "of", " ", "all", " ", "Expt", " ", "ID", " ", "in", " ", 
              "the", " ", 
              RowBox[{"config1", ".", "txt"}]}]}]}]}], ",", " ", 
          RowBox[{"so", " ", "we", " ", 
           RowBox[{"don", "'"}], "t", " ", "want", " ", "the", " ", "program",
            " ", "breaks", " ", "down", " ", "when", " ", "some", " ", "Expt",
            " ", "IDs", " ", "in", " ", 
           RowBox[{"config", ".", "txt"}], " ", "are", " ", "not", " ", "in", 
           " ", "data", " ", "files"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
          "when", " ", "we", " ", "find", " ", "exptlistfinal", " ", 
           "contains", " ", "no", " ", "expt", " ", "ID"}], ",", " ", 
          RowBox[{"we", " ", "skip", " ", "this", " ", "loop"}]}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "exptlistfinal", "]"}], "\[Equal]", "0"}], 
          ",", 
          RowBox[{
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<All Expt IDs in \>\"", ",", "configfilename", ",", 
             "\"\< are not in data files\>\""}], "]"}], ";", 
           RowBox[{"Return", "[", "\"\<end Quicksaveplot\>\"", "]"}]}]}], " ",
          "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", "\"\<\>\"", "]"}], ";", 
        RowBox[{"(*", "space", "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"test", " ", "corrfxQdtaobsclassfinal"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{
        "Print", "[", 
         "\"\<Dimensions of data of selected and available expts\>\"", "]"}], 
        ";", "\n", 
        RowBox[{"Print", "[", "\[IndentingNewLine]", 
         RowBox[{"(*", "\[IndentingNewLine]", 
          RowBox[{"\"\<corrdataclass: \>\"", ",", "\[IndentingNewLine]", 
           RowBox[{"Dimensions", "[", "corrdataclass", "]"}], ",", 
           "\[IndentingNewLine]", "\"\<dRcorrdataclass: \>\"", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Dimensions", "[", "dRcorrdataclass", "]"}], ",", 
           "\[IndentingNewLine]", 
           "\"\<{expterrordataclass,residualdataclass,dRdataclass}: \>\"", 
           ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"Dimensions", "[", "#", "]"}], "&"}], "/@", 
            RowBox[{"{", 
             RowBox[{
             "expterrordataclass", ",", "residualdataclass", ",", 
              "dRdataclass"}], "}"}]}], ","}], "\[IndentingNewLine]", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{
         "\"\<{residualNsetclassfinal}: \>\"", ",", "\[IndentingNewLine]", 
          RowBox[{"residualNsetclassfinal", "//", "Dimensions"}], ",", 
          "\[IndentingNewLine]", "\"\<{fxQsamept2classfinal}: \>\"", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"fxQsamept2classfinal", "//", "Dimensions"}], ",", 
          "\[IndentingNewLine]", "\"\<{dtacentralclassfinal}: \>\"", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"dtacentralclassfinal", "//", "Dimensions"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", "\"\<\>\"", "]"}], ";", 
        RowBox[{"(*", "space", "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "20191119", " ", "need", " ", "all", " ", "expt", " ", "fxQ", " ", 
          "info"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"fxQDatabaselist", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"fxQsamept2class", "[", 
             RowBox[{"[", 
              RowBox[{"iexpt", ",", "iflavour"}], "]"}], "]"}], "[", 
            RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"iexpt", ",", 
             RowBox[{
              RowBox[{"Dimensions", "[", "fxQsamept2class", "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"iflavour", ",", 
             RowBox[{
              RowBox[{"Dimensions", "[", "fxQsamept2class", "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"fxQDatabaseExptlist", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"fxQsamept2class", "[", 
             RowBox[{"[", 
              RowBox[{"iexpt", ",", "1"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{"\"\<exptinfo\>\"", ",", "\"\<exptid\>\""}], "]"}], 
            "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"iexpt", ",", 
             RowBox[{
              RowBox[{"Dimensions", "[", "fxQsamept2class", "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"clear", " ", "residualNsetclass"}], ",", " ", 
          "fxQsamept2class", ",", " ", "dtacentralclass"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"Clear", "[", "residualNsetclass", "]"}], ";", 
        RowBox[{"Clear", "[", "fxQsamept2class", "]"}], ";", 
        RowBox[{"Clear", "[", "dtacentralclass", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "20171217", " ", "define", " ", "global", " ", "variable", " ", 
          "for", " ", "username"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"UserNameGlobal", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "append", " ", "user", " ", "defined", " ", "values", " ", "into", 
          " ", "f", 
          RowBox[{"(", 
           RowBox[{"x", ",", "Q"}], ")"}], " ", "as", " ", "new", " ", 
          "flavour", " ", "index"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"CorrelationArgFlag", "[", 
            RowBox[{"[", 
             RowBox[{"-", "1"}], "]"}], "]"}], "\[Equal]", "1"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"setup", " ", "pdf", " ", "function"}], ",", " ", 
            RowBox[{
            "so", " ", "that", " ", "hessian", " ", "method", " ", "function",
              " ", "could", " ", "work"}]}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"(*", "\[IndentingNewLine]", 
           RowBox[{"pdfResetCTEQ", ";", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{"generate", " ", "a", " ", "pdf", " ", "space"}], "*)"}],
             "\[IndentingNewLine]", 
            RowBox[{"pdfFamilyParseCTEQ", "[", "\"\<Dummy\>\"", "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"ifamily", "=", "1"}], ";", " ", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{
              "IniDir", "=", 
               "\"\<//users//nadolsky//share//lhapdf//6.1.5//share/LHAPDF//\
CT14nnlo//pds//\>\""}], ";"}], " ", "*)"}], "\[IndentingNewLine]", 
            RowBox[{"PdsDir", "=", "\[IndentingNewLine]", 
             RowBox[{"pdfFamilyParseCTEQ", "[", 
              RowBox[{
               RowBox[{
               "\"\<../fakePDFset/\>\"", "<>", "PDFname", "<>", "\"\</\>\"", 
                "<>", "\"\<*pds\>\""}], ",", "ifamily"}], "]"}]}], ";"}], 
           "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"20171116", ":", " ", 
             RowBox[{
             "for", " ", "new", " ", "convention", " ", "of", " ", "user", 
              " ", "define", " ", "function"}], ":", " ", 
             RowBox[{"read", " ", 
              RowBox[{"it", "'"}], "s", " ", "library", " ", "first"}]}], ",",
             " ", 
            RowBox[{
            "then", " ", "define", " ", "global", " ", "variable", " ", "for",
              " ", "List", " ", "data", " ", "of", " ", "f", 
             RowBox[{"(", 
              RowBox[{"x", ",", "Q"}], ")"}]}]}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"Get", "[", "\"\<user_define_function.m\>\"", "]"}], 
            ";"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"fxQlist", "=", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"fxQsamept2classfinal", "[", 
                RowBox[{"[", 
                 RowBox[{"iexpt", ",", "iflavour"}], "]"}], "]"}], "[", 
               RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"iexpt", ",", 
                RowBox[{
                 RowBox[{"Dimensions", "[", "fxQsamept2classfinal", "]"}], 
                 "[", 
                 RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"iflavour", ",", 
                RowBox[{
                 RowBox[{"Dimensions", "[", "fxQsamept2classfinal", "]"}], 
                 "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"20171109", ":", " ", 
             RowBox[{"seperate", " ", "user", " ", "difine", " ", 
              RowBox[{"function", "/", "data"}], " ", "IO", " ", "and", " ", 
              "configure", " ", "file"}]}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"userfuncfilename", "=", "\"\<user_func.txt\>\""}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<reading user functions from \>\"", ",", "userfuncfilename"}],
             "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"20171119", " ", "new", " ", "user", " ", "function", " ", 
             RowBox[{"format", ":", " ", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"user", " ", "name", " ", "1"}], ",", " ", 
                  RowBox[{"user", " ", "function", " ", "1"}]}], "}"}], ",", 
                " ", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"user", " ", "name", " ", "2"}], ",", " ", 
                   RowBox[{"user", " ", "function", " ", "2"}]}], "}"}], 
                 "..."}]}], "}"}]}]}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"{", 
             RowBox[{"UserArgName", ",", "UserArgFunction"}], "}"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"UserArgFunction", "=", 
            RowBox[{"(*", "ReadUserFunctionV2", "*)"}], 
            RowBox[{"ReadUserFunctionV3", "[", 
             RowBox[{"configDir", ",", "userfuncfilename"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"UserArgName", "=", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"#", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "&"}], "/@", 
              "UserArgFunction"}], ")"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"UserArgFunction", "=", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"#", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", 
              "UserArgFunction"}], ")"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
            "20171217", " ", "define", " ", "global", " ", "variable", " ", 
             "for", " ", "username"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"UserNameGlobal", "=", "UserArgName"}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{"\"\<function names: \>\"", ",", "UserArgName"}], "]"}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"20171116", ":", " ", 
             RowBox[{
             "new", " ", "convention", " ", "of", " ", "user", " ", "define", 
              " ", "function", " ", "and", " ", "new", " ", "way", " ", "to", 
              " ", "add", " ", "it", " ", "as", " ", "new", " ", 
              "flavour"}]}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"20171119", " ", "new", " ", "user", " ", "function", " ", 
             RowBox[{"format", ":", " ", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"user", " ", "name", " ", "1"}], ",", " ", 
                  RowBox[{"user", " ", "function", " ", "1"}]}], "}"}], ",", 
                " ", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"user", " ", "name", " ", "2"}], ",", " ", 
                   RowBox[{"user", " ", "function", " ", "2"}]}], "}"}], 
                 "..."}]}], "}"}]}]}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"fxQdataNewFlavour", " ", 
             RowBox[{"format", ":", " ", 
              RowBox[{"[", 
               RowBox[{"[", 
                RowBox[{"ifunc", ",", "iexpt"}], "]"}], "]"}]}]}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"new", " ", "flavour"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"fxQdataNewFlavour", "=", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"UDFToClass", "[", 
               RowBox[{
                RowBox[{"UserArgFunction", "[", 
                 RowBox[{"[", "ifunc", "]"}], "]"}], ",", 
                "fxQsamept2classfinal"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"ifunc", ",", 
                RowBox[{"Length", "[", "UserArgFunction", "]"}]}], "}"}]}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
            "add", " ", "new", " ", "flavour", " ", "to", " ", "fxQ", " ", 
             "class", " ", "for", " ", "each", " ", "expt", " ", "ID"}], 
            "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Table", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"fxQsamept2classfinal", "[", 
                RowBox[{"[", "iexpt", "]"}], "]"}], "=", 
               RowBox[{"Append", "[", 
                RowBox[{
                 RowBox[{"fxQsamept2classfinal", "[", 
                  RowBox[{"[", "iexpt", "]"}], "]"}], ",", 
                 RowBox[{"fxQdataNewFlavour", "[", 
                  RowBox[{"[", 
                   RowBox[{"ifunc", ",", "iexpt"}], "]"}], "]"}]}], " ", 
                "]"}]}], ";", "\[IndentingNewLine]", "\"\<dummy\>\""}], 
             "\[IndentingNewLine]", ",", 
             RowBox[{"{", 
              RowBox[{"iexpt", ",", 
               RowBox[{"Length", "[", "fxQsamept2classfinal", "]"}]}], "}"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"ifunc", ",", 
               RowBox[{"Length", "[", "UserArgFunction", "]"}]}], "}"}]}], 
            "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
             "20171119", " ", "bebause", " ", "CorrelationArgFlag", " ", "is",
               " ", "flavour", " ", "index"}], ",", " ", 
             RowBox[{
             "there", " ", "should", " ", "be", " ", "#", " ", "of", " ", 
              "user", " ", "function", " ", "indece", " ", "for", " ", "all", 
              " ", "user", " ", "functions"}], ",", " ", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
              "#", " ", "of", " ", "CorrelationArgFlag", " ", "should", " ", 
               "be", " ", "Nflavour"}], " ", "+", " ", 
              RowBox[{"#", " ", "of", " ", "user", " ", "functions"}]}]}], 
            " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"CorrelationArgFlag", "=", 
            RowBox[{"Join", "[", 
             RowBox[{"CorrelationArgFlag", ",", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"CorrelationArgFlag", "[", 
                 RowBox[{"[", 
                  RowBox[{"-", "1"}], "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"ifunc", ",", 
                  RowBox[{
                   RowBox[{"Length", "[", "UserArgFunction", "]"}], "-", 
                   "1"}]}], "}"}]}], "]"}]}], " ", "]"}]}], ";", 
           "\[IndentingNewLine]", "\"\<dummy\>\""}]}], "\[IndentingNewLine]", 
         
         RowBox[{"(*", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"fxQsamept2classfinal", "=", 
            RowBox[{
             RowBox[{
              RowBox[{"Append", "[", 
               RowBox[{
                RowBox[{"fxQsamept2classfinal", "[", 
                 RowBox[{"[", "#", "]"}], "]"}], ",", 
                RowBox[{"fxQdataNewFlavour", "[", 
                 RowBox[{"[", "#", "]"}], "]"}]}], " ", "]"}], "&"}], "/@", 
             RowBox[{"Range", "[", 
              RowBox[{"fxQsamept2classfinal", "//", "Length"}], "]"}]}]}], 
           ";"}], "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"(*", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
           "check", " ", "the", " ", "#", " ", "of", " ", "user", " ", 
            "define", " ", "values", " ", "is", " ", "the", " ", "same", " ", 
            "as", " ", "#", " ", "of", " ", "PDF", " ", "replicas"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"Length", "[", "UserArgValue", "]"}], "\[NotEqual]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"Datamethods", "[", 
                  RowBox[{"[", "\"\<getNcolumn\>\"", "]"}], "]"}], "[", 
                 RowBox[{"fxQsamept2classfinal", "[", 
                  RowBox[{"[", 
                   RowBox[{"1", ",", "1"}], "]"}], "]"}], " ", "]"}], "-", 
                "2"}], ")"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
              "Print", "[", 
               "\"\<error, the # of user-defined values should be the same as \
# of PDF relicas (Nset)\>\"", "]"}], ";", "\[IndentingNewLine]", 
              RowBox[{"Print", "[", 
               RowBox[{"\"\<Nset = \>\"", ",", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Datamethods", "[", 
                    RowBox[{"[", "\"\<getNcolumn\>\"", "]"}], "]"}], "[", 
                   RowBox[{"fxQsamept2classfinal", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], " ", "]"}], "-", 
                  "2"}], ")"}]}], " ", "]"}], ";", "\[IndentingNewLine]", 
              RowBox[{"Print", "[", 
               RowBox[{"\"\<#user-defined values = \>\"", ",", " ", 
                RowBox[{"Length", "[", "UserArgValue", "]"}]}], " ", "]"}], 
              ";", "\[IndentingNewLine]", 
              RowBox[{"Abort", "[", "]"}]}]}], " ", "\[IndentingNewLine]", 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
            "append", " ", "data", " ", "of", " ", "uservalue", " ", "to", 
             " ", "fxQsamept2classfinal", " ", "for", " ", "each", " ", 
             "expt", " ", "ID"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Table", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"tmpclass", "=", 
               RowBox[{"fxQsamept2classfinal", "[", 
                RowBox[{"[", 
                 RowBox[{"iexpt", ",", "1"}], "]"}], "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"tmpclass", "[", 
                RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "=", 
               RowBox[{
                RowBox[{"tmpclass", "[", 
                 RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "/.", 
                RowBox[{
                 RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
                 RowBox[{"LF", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                   RowBox[{"Sequence", "@@", "UserArgValue"}]}], "]"}]}]}]}], 
              ";", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"fxQsamept2classfinal", "[", 
                RowBox[{"[", "iexpt", "]"}], "]"}], "=", 
               RowBox[{"Append", "[", 
                RowBox[{
                 RowBox[{"fxQsamept2classfinal", "[", 
                  RowBox[{"[", "iexpt", "]"}], "]"}], ",", "tmpclass"}], 
                "]"}]}], ";", "\[IndentingNewLine]", "tmpclass"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"iexpt", ",", "1", ",", 
               RowBox[{"Length", "[", "fxQsamept2classfinal", "]"}]}], 
              "}"}]}], "\[IndentingNewLine]", "]"}], ";"}], 
          "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"fmax", "=", 
         RowBox[{"Length", "[", 
          RowBox[{"fxQsamept2classfinal", "[", 
           RowBox[{"[", "1", "]"}], "]"}], " ", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<total #flavours: \>\"", ",", "fmax"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", "\"\<\>\"", "]"}], ";", 
        RowBox[{"(*", "space", "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", "20171217", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
          "if", " ", "any", " ", "values", " ", "of", " ", "points", " ", 
           "for", " ", "each", " ", "flavour", " ", "are", " ", "0"}], ",", 
          " ", "Indeterminate", ",", " ", 
          RowBox[{"or", " ", "ComplexInfinity"}], ",", " ", 
          RowBox[{
          "give", " ", "values", " ", "in", " ", "all", " ", "replicas", " ", 
           "of", " ", "that", " ", "point", " ", "0"}]}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "this", " ", "step", " ", "should", " ", "be", " ", "prior", " ", 
          "to", " ", "the", " ", "calculation", " ", "of", " ", 
          "observables"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
        "Print", "[", 
         "\"\<search broken points (0, ComplexInfinity, Indeterminate in any \
replica) for all points of f(x,Q), then set the values of broken points as \
0\>\"", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", "\"\<\>\"", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"fxQsamept2classfinal", "[", 
              RowBox[{"[", 
               RowBox[{"iexpt", ",", 
                RowBox[{"flavour", "+", "6"}]}], "]"}], "]"}], "[", 
             RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "=", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"fxQsamept2classfinal", "[", 
               RowBox[{"[", 
                RowBox[{"iexpt", ",", 
                 RowBox[{"flavour", "+", "6"}]}], "]"}], "]"}], "[", 
              RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "/.", 
             RowBox[{
              RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
              "\[IndentingNewLine]", 
              RowBox[{"If", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"IntersectingQ", "[", 
                 RowBox[{
                  RowBox[{"{", "a", "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                   "0", ",", "0.0", ",", "ComplexInfinity", ",", 
                    "Indeterminate"}], "}"}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"LF", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", "a", "}"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"{", "a", "}"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], ",", 
                  RowBox[{"Sequence", "@@", 
                   RowBox[{"Table", "[", 
                    RowBox[{"0.0", ",", 
                    RowBox[{"{", 
                    RowBox[{"iset", ",", 
                    RowBox[{
                    RowBox[{"Length", "[", 
                    RowBox[{"{", "a", "}"}], "]"}], "-", "2"}]}], "}"}]}], 
                    "]"}]}]}], " ", "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"LF", "[", "a", "]"}]}], " ", "\[IndentingNewLine]", 
               "]"}]}]}]}], ";", "\[IndentingNewLine]", "\"\<dummy\>\""}], 
          "\[IndentingNewLine]", ",", 
          RowBox[{"{", 
           RowBox[{"iexpt", ",", 
            RowBox[{"Length", "[", "fxQsamept2classfinal", "]"}]}], "}"}], 
          ",", 
          RowBox[{"{", 
           RowBox[{"flavour", ",", 
            RowBox[{"-", "5"}], ",", 
            RowBox[{
             RowBox[{"-", "5"}], "+", "fmax", "-", "1"}]}], "}"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", "test", " ", "*)"}], 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"Print", "[", 
           RowBox[{"\"\<flavours switch: \>\"", ",", "CorrelationArgFlag"}], 
           "]"}], ";", 
          RowBox[{"Abort", "[", "]"}], ";"}], "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "calculate", " ", "observables", " ", "for", " ", "plots", " ", 
          "from", " ", "PDF", " ", "data", " ", "and", " ", "residual", " ", 
          "data", " ", "of", " ", "all", " ", "replicas"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"observables", ":", " ", "correlation", ":", " ", 
           RowBox[{"corr", 
            RowBox[{"(", 
             RowBox[{
              SubscriptBox["r", "i"], ",", 
              RowBox[{"f", 
               RowBox[{"(", 
                RowBox[{"x", ",", "\[Mu]"}], ")"}]}]}], ")"}]}]}], ",", " ", 
          RowBox[{"sensitivity", ":", " ", 
           RowBox[{
            SubscriptBox["\[Delta]r", "i"], "*", "corr", 
            RowBox[{"(", 
             RowBox[{
              SubscriptBox["r", "i"], ",", 
              RowBox[{"f", 
               RowBox[{"(", 
                RowBox[{"x", ",", "\[Mu]"}], ")"}]}]}], ")"}]}]}], ",", " ", 
          RowBox[{"central", " ", "values", " ", "of", " ", 
           RowBox[{"residuals", ":", " ", 
            SubscriptBox["r", "i"]}]}], ",", " ", 
          RowBox[{"uncertainties", " ", "of", " ", 
           RowBox[{"residuals", ":", " ", 
            SubscriptBox["\[Delta]r", "i"]}]}], ",", " ", 
          RowBox[{"expt", " ", "error", " ", 
           RowBox[{"ratio", ":", " ", 
            RowBox[{
             SubscriptBox["\[Sigma]", "i"], "/", 
             SubscriptBox["D", "i"]}]}]}]}], "*)"}], "\[IndentingNewLine]", 
        "corrdataclassfinal", ";", "\[IndentingNewLine]", 
        "dRcorrdataclassfinal", ";", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
         "expterrordataclassfinal", ",", "residualdataclassfinal", ",", 
          "dRdataclassfinal"}], "}"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"calculate", " ", "correlation"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"ti", "=", 
         RowBox[{"AbsoluteTime", "[", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"corrdataclassfinal", "=", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"corrfxQdtaobs", "[", 
            RowBox[{
             RowBox[{"residualNsetclassfinal", "[", 
              RowBox[{"[", "iexpt", "]"}], "]"}], ",", 
             RowBox[{"fxQsamept2classfinal", "[", 
              RowBox[{"[", 
               RowBox[{"iexpt", ",", 
                RowBox[{"flavour", "+", "6"}]}], "]"}], "]"}]}], " ", "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"iexpt", ",", "1", ",", 
             RowBox[{"Length", "[", "residualNsetclassfinal", "]"}]}], "}"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"flavour", ",", 
             RowBox[{"-", "5"}], ",", 
             RowBox[{
              RowBox[{"-", "5"}], "+", "fmax", "-", "1"}]}], "}"}]}], 
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"calculate", " ", "dr", "*", "correlation"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"dRcorrdataclassfinal", "=", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"dRcorrfxQdtaobs", "[", 
            RowBox[{
             RowBox[{"residualNsetclassfinal", "[", 
              RowBox[{"[", "iexpt", "]"}], "]"}], ",", 
             RowBox[{"fxQsamept2classfinal", "[", 
              RowBox[{"[", 
               RowBox[{"iexpt", ",", 
                RowBox[{"flavour", "+", "6"}]}], "]"}], "]"}]}], " ", "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"iexpt", ",", "1", ",", 
             RowBox[{"Length", "[", "residualNsetclassfinal", "]"}]}], "}"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"flavour", ",", 
             RowBox[{"-", "5"}], ",", 
             RowBox[{
              RowBox[{"-", "5"}], "+", "fmax", "-", "1"}]}], "}"}]}], 
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"calculate", " ", "dr"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"dRdataclassfinal", "=", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"getdeltaRclass", "[", 
            RowBox[{"residualNsetclassfinal", "[", 
             RowBox[{"[", "iexpt", "]"}], "]"}], " ", "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"iexpt", ",", "1", ",", 
             RowBox[{"Length", "[", "residualNsetclassfinal", "]"}]}], 
            "}"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "20171213", " ", "redefine", " ", "sensitivity", " ", "as", " ", 
          RowBox[{"(", 
           RowBox[{"\[Delta]r", "/", "r"}], ")"}], "*", "Corr", 
          RowBox[{"(", 
           RowBox[{
            SubscriptBox["r", "i"], ",", 
            RowBox[{"f", 
             SubscriptBox[
              RowBox[{"(", 
               RowBox[{"x", ",", "Q"}], ")"}], "i"]}]}], ")"}]}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Npt", "=", 
            RowBox[{
             RowBox[{
              RowBox[{"dRcorrdataclassfinal", "[", 
               RowBox[{"[", 
                RowBox[{"iexpt", ",", 
                 RowBox[{"flavour", "+", "6"}]}], "]"}], "]"}], "[", 
              RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "//", "Length"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"(*", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{"calculate", " ", "the", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SubscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox["\[Chi]", "2"], ")"}], "ID"], "/", 
                 SubscriptBox["Npt", "ID"]}], ")"}], "0.5"]}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"iRawdataResidual", "=", 
              RowBox[{
               RowBox[{"Position", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"dtacentralclassfinal", "[", 
                   RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                  RowBox[{"[", "\"\<label\>\"", "]"}], "]"}], ",", 
                 "\"\<ReducedChi2\>\""}], "]"}], "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"RawNpt", "=", 
              RowBox[{
               RowBox[{
                RowBox[{"dtacentralclassfinal", "[", 
                 RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "//", "Length"}]}],
              ";", "\[IndentingNewLine]", 
             RowBox[{"TotalRawChi2", "=", 
              RowBox[{"Sum", "[", 
               RowBox[{
                RowBox[{"Abs", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"dtacentralclassfinal", "[", 
                    RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                   RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"irawpt", ",", "iRawdataResidual"}], "]"}], "]"}], 
                 " ", "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"irawpt", ",", "RawNpt"}], "}"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"SensNormalize", "=", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"TotalRawChi2", "/", "RawNpt"}], ")"}], "0.5"]}], 
             ";"}], "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"20180420", ":", " ", 
             RowBox[{
             "replace", " ", "the", " ", "calculation", " ", "of", " ", "the",
               " ", "rms", " ", "of", " ", "residual", " ", "by", " ", "the", 
              " ", "function"}]}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"SensNormalize", "=", 
            RowBox[{"GetResidualRMS", "[", 
             RowBox[{
              RowBox[{"residualNsetclassfinal", "[", 
               RowBox[{"[", "iexpt", "]"}], "]"}], ",", 
              RowBox[{"dtacentralclassfinal", "[", 
               RowBox[{"[", "iexpt", "]"}], "]"}]}], " ", "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"Table", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"dRcorrdataclassfinal", "[", 
                  RowBox[{"[", 
                   RowBox[{"iexpt", ",", 
                    RowBox[{"flavour", "+", "6"}]}], "]"}], "]"}], "[", 
                 RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{"ipt", ",", "3"}], "]"}], "]"}], "=", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"dRcorrdataclassfinal", "[", 
                    RowBox[{"[", 
                    RowBox[{"iexpt", ",", 
                    RowBox[{"flavour", "+", "6"}]}], "]"}], "]"}], "[", 
                   RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"ipt", ",", "3"}], "]"}], "]"}], "/", 
                 "\[IndentingNewLine]", 
                 RowBox[{"(*", 
                  RowBox[{
                   RowBox[{"prevent", " ", "the", " ", 
                    RowBox[{"dr", "/", "r"}], " ", "blow", " ", "up", " ", 
                    "when", " ", "r"}], " ", "=", " ", "0"}], "*)"}], 
                 "\[IndentingNewLine]", 
                 RowBox[{"(*", 
                  RowBox[{
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"residualdataclassfinal", "[", 
                    RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                    RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"ipt", ",", "3"}], "]"}], "]"}], "\[NotEqual]", 
                    "0.0"}], ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"residualdataclassfinal", "[", 
                    RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                    RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"ipt", ",", "3"}], "]"}], "]"}], ",", 
                    SuperscriptBox["10.0", 
                    RowBox[{"-", "8"}]]}], "]"}], ")"}], "*)"}], 
                 "\[IndentingNewLine]", 
                 RowBox[{"(*", 
                  RowBox[{"total", " ", 
                   RowBox[{"chi", "^", "2"}], " ", "for", " ", "the", " ", 
                   "experiment"}], "*)"}], "\[IndentingNewLine]", 
                 RowBox[{"(", "SensNormalize", ")"}]}], "\[IndentingNewLine]",
                 ")"}]}], ";", "\[IndentingNewLine]", "\"\<dummy\>\""}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"ipt", ",", "Npt"}], "}"}]}], "\[IndentingNewLine]", 
            "]"}], " ", ";", "\[IndentingNewLine]", "\"\<dummy\>\""}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"iexpt", ",", "1", ",", 
            RowBox[{"Length", "[", "residualNsetclassfinal", "]"}]}], "}"}], 
          ",", 
          RowBox[{"{", 
           RowBox[{"flavour", ",", 
            RowBox[{"-", "5"}], ",", 
            RowBox[{
             RowBox[{"-", "5"}], "+", "fmax", "-", "1"}]}], "}"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "calculate", " ", "central", " ", "value", " ", "of", " ", 
          "residual"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"select", " ", "x"}], ",", " ", "Q", ",", " ", 
          RowBox[{"central", " ", "value", " ", "of", " ", "residual", " ", 
           RowBox[{"(", 
            RowBox[{"iset", "==", "1"}], ")"}]}]}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"residualdataclassfinal", "=", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"Datamethods", "[", 
             RowBox[{"[", "\"\<take\>\"", "]"}], "]"}], "[", 
            RowBox[{
             RowBox[{"residualNsetclassfinal", "[", 
              RowBox[{"[", "iexpt", "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "3"}], "}"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"iexpt", ",", "1", ",", 
             RowBox[{"Length", "[", "residualNsetclassfinal", "]"}]}], 
            "}"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "test", " ", "print", " ", "normalization", " ", "for", " ", 
          "residuals"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"NormalizeIDs", "=", "\[IndentingNewLine]", 
           RowBox[{"Table", "[", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{"calculate", " ", "the", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SubscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox["\[Chi]", "2"], ")"}], "ID"], "/", 
                 SubscriptBox["Npt", "ID"]}], ")"}], "0.5"]}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"iRawdataResidual", "=", 
               RowBox[{
                RowBox[{"Position", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"dtacentralclassfinal", "[", 
                    RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                   RowBox[{"[", "\"\<label\>\"", "]"}], "]"}], ",", 
                  "\"\<ReducedChi2\>\""}], "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"RawNpt", "=", 
               RowBox[{
                RowBox[{
                 RowBox[{"dtacentralclassfinal", "[", 
                  RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                 RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "//", 
                "Length"}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"TotalRawChi2", "=", 
               RowBox[{"Sum", "[", 
                RowBox[{
                 RowBox[{"Abs", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"dtacentralclassfinal", "[", 
                    RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                    RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
                   RowBox[{"[", 
                    RowBox[{"irawpt", ",", "iRawdataResidual"}], "]"}], "]"}],
                   " ", "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"irawpt", ",", "RawNpt"}], "}"}]}], "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"SensNormalize", "=", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"TotalRawChi2", "/", "RawNpt"}], ")"}], "0.5"]}], 
              ";", "\[IndentingNewLine]", "SensNormalize"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"iexpt", ",", "1", ",", 
               RowBox[{"Length", "[", "residualNsetclassfinal", "]"}]}], 
              "}"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Print", "[", "\[IndentingNewLine]", 
           RowBox[{"Table", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"residualNsetclassfinal", "[", 
                 RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{"\"\<exptinfo\>\"", ",", "\"\<exptid\>\""}], "]"}], 
                "]"}], ",", 
               RowBox[{"NormalizeIDs", "[", 
                RowBox[{"[", "iexpt", "]"}], "]"}]}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"iexpt", ",", "1", ",", 
               RowBox[{"Length", "[", "residualNsetclassfinal", "]"}]}], 
              "}"}]}], "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", 
           "]"}], ";"}], "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]",
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "test", " ", "the", " ", "time", " ", "of", " ", "the", " ", 
          "correlation", " ", "value", " ", "calculation"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"tf", "=", 
         RowBox[{"AbsoluteTime", "[", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"GetCorrvalueTime", "=", 
         RowBox[{"tf", "-", "ti"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"NCorrval", "=", "\[IndentingNewLine]", 
         RowBox[{"Sum", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"Datamethods", "[", 
             RowBox[{"[", "\"\<getNpt\>\"", "]"}], "]"}], "[", 
            RowBox[{"corrdataclassfinal", "[", 
             RowBox[{"[", 
              RowBox[{"iexpt", ",", 
               RowBox[{"flavour", "+", "6"}]}], "]"}], "]"}], " ", "]"}], ",",
            "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"iexpt", ",", "1", ",", 
             RowBox[{"Length", "[", "residualNsetclassfinal", "]"}]}], "}"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"flavour", ",", 
             RowBox[{"-", "5"}], ",", 
             RowBox[{
              RowBox[{"-", "5"}], "+", "fmax", "-", "1"}]}], "}"}]}], 
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
        "Print", "[", 
         "\"\<The time for calculating statistical quantities used in \
plotting\>\"", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<total number of correlation & sensitivity value calculations is \
\>\"", ",", "NCorrval"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<average time of one correlation + sensitivity value \
calculations is roughly \>\"", ",", 
          RowBox[{"GetCorrvalueTime", "/", "NCorrval"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<time of calculating all observable data (correlation + \
sensitivity + ...)  values is \>\"", ",", "GetCorrvalueTime"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", "\"\<\>\"", "]"}], ";", 
        RowBox[{"(*", "space", "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "calculate", " ", "experimental", " ", "error", " ", "ratio"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "check", " ", "columns", " ", "used", " ", "to", " ", "extract", " ", 
          RowBox[{
           SubscriptBox["\[Sigma]", "i"], "/", 
           SubscriptBox["D", "i"]}], " ", "is", " ", "correct", " ", 
          RowBox[{"(", 
           RowBox[{"check", " ", "the", " ", "labels", " ", "are", " \[InvisibleSpace]", 
            RowBox[{"(", 
             RowBox[{"x", ",", "Q", ",", 
              RowBox[{"TotErr", "/", "Exp"}]}], ")"}]}], " ", ")"}]}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "check", " ", "whether", " ", "the", " ", "elements", " ", "used", 
          " ", "to", " ", "calculate", " ", "Expt", " ", 
          RowBox[{"error", "/", "expt"}], " ", "are", " ", "correct"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"ExpIndex", "=", "4"}], ";", 
        RowBox[{"ExpErrIndex", "=", "6"}], ";", 
        RowBox[{"XIndex", "=", 
         RowBox[{"-", "3"}]}], ";", 
        RowBox[{"QIndex", "=", 
         RowBox[{"-", "2"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
        "Print", "[", 
         "\"\<begin to calculate \!\(\*SubscriptBox[\(\[Sigma]\), \(i\)]\)/\!\
\(\*SubscriptBox[\(D\), \(i\)]\) from data, labels of indexes used for each \
experiment:\>\"", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", "\"\<\>\"", "]"}], ";", 
        RowBox[{"(*", "space", "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Print", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"dtacentralclassfinal", "[", 
              RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"\"\<exptinfo\>\"", ",", "\"\<exptid\>\""}], "]"}], 
             "]"}], ",", "\"\<: (\>\"", ",", 
            RowBox[{
             RowBox[{
              RowBox[{"dtacentralclassfinal", "[", 
               RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
              RowBox[{"[", "\"\<label\>\"", "]"}], "]"}], "[", 
             RowBox[{"[", "XIndex", "]"}], "]"}], ",", "\"\<, \>\"", ",", 
            RowBox[{
             RowBox[{
              RowBox[{"dtacentralclassfinal", "[", 
               RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
              RowBox[{"[", "\"\<label\>\"", "]"}], "]"}], "[", 
             RowBox[{"[", "QIndex", "]"}], "]"}], ",", "\"\<, \>\"", ",", 
            RowBox[{
             RowBox[{
              RowBox[{"dtacentralclassfinal", "[", 
               RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
              RowBox[{"[", "\"\<label\>\"", "]"}], "]"}], "[", 
             RowBox[{"[", "ExpErrIndex", "]"}], "]"}], ",", "\"\</\>\"", ",", 
            " ", 
            RowBox[{
             RowBox[{
              RowBox[{"dtacentralclassfinal", "[", 
               RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
              RowBox[{"[", "\"\<label\>\"", "]"}], "]"}], "[", 
             RowBox[{"[", "ExpIndex", "]"}], "]"}], ",", "\"\< )\>\""}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"iexpt", ",", "1", ",", 
            RowBox[{"Length", "[", "residualNsetclassfinal", "]"}]}], "}"}]}],
          " ", "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"extract", " ", 
          RowBox[{"(", 
           RowBox[{"x", ",", " ", "Q", ",", " ", 
            RowBox[{"ExpErrIndex", "/", "ExpIndex"}]}], ")"}]}], "*)"}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"expterrordataclassfinal", "=", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"tmpdataclass", "=", 
             RowBox[{"dtacentralclassfinal", "[", 
              RowBox[{"[", "iexpt", "]"}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"tmpdataclass", "[", 
              RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "=", 
             RowBox[{
              RowBox[{"tmpdataclass", "[", 
               RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "/.", 
              RowBox[{
               RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
               RowBox[{"LF", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"{", "a", "}"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"-", "3"}], "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"{", "a", "}"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"-", "2"}], "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", "a", "}"}], "[", 
                   RowBox[{"[", "ExpErrIndex", "]"}], "]"}], "/", 
                  RowBox[{
                   RowBox[{"{", "a", "}"}], "[", 
                   RowBox[{"[", "ExpIndex", "]"}], "]"}]}]}], " ", 
                "]"}]}]}]}], ";", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"tmpdataclass", "[", 
              RowBox[{"[", "\"\<label\>\"", "]"}], "]"}], "=", 
             RowBox[{"{", 
              RowBox[{
              "\"\<x\>\"", ",", "\"\<Q\>\"", ",", 
               "\"\<expterror/exptcentral\>\""}], "}"}]}], ";", 
            "\[IndentingNewLine]", "tmpdataclass"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"iexpt", ",", "1", ",", 
             RowBox[{"Length", "[", "residualNsetclassfinal", "]"}]}], 
            "}"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "print", " ", "dimensions", " ", "of", " ", "calculated", " ", 
          "observables"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Print", "[", "\"\<data of final expts\>\"", "]"}], ";", "\n", 
        RowBox[{"Print", "[", "\[IndentingNewLine]", 
         RowBox[{"\"\<corrdataclass: \>\"", ",", "\[IndentingNewLine]", 
          RowBox[{"Dimensions", "[", "corrdataclassfinal", "]"}], ",", 
          "\[IndentingNewLine]", "\"\<dRcorrdataclass: \>\"", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Dimensions", "[", "dRcorrdataclassfinal", "]"}], ",", 
          "\[IndentingNewLine]", 
          "\"\<{expterrordataclass,residualdataclass,dRdataclass}: \>\"", ",",
           "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"Dimensions", "[", "#", "]"}], "&"}], "/@", 
           RowBox[{"{", 
            RowBox[{
            "expterrordataclassfinal", ",", "residualdataclassfinal", ",", 
             "dRdataclassfinal"}], "}"}]}]}], "\[IndentingNewLine]", "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", "\"\<\>\"", "]"}], ";", 
        RowBox[{"(*", "space", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", "*)"}], "\n", 
        RowBox[{"(*", 
         RowBox[{"test", " ", "abort"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Abort", "[", "]"}], ";"}], "\[IndentingNewLine]", "*)"}], 
        "\n", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"test", " ", 
           RowBox[{"plot2", ":", " ", 
            RowBox[{
            "bug", " ", "comes", " ", "from", " ", "plotcorrelation7"}]}]}], 
          ",", " ", 
          RowBox[{
          "there", " ", "is", " ", "a", " ", "global", " ", "various", " ", 
           "p2", " ", "cover", " ", "the", " ", "used", " ", "variable"}]}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"plot2", "=", 
           RowBox[{"processdataplotsmultiexp5percentage", "[", 
            RowBox[{"(*", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"expterrorclassfinal", "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{"expterrorclassfinal", "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{"expterrorclassfinal", "[", 
                RowBox[{"[", "3", "]"}], "]"}], ",", 
               RowBox[{"expterrorclassfinal", "[", 
                RowBox[{"[", "4", "]"}], "]"}], ",", 
               RowBox[{"expterrorclassfinal", "[", 
                RowBox[{"[", "5", "]"}], "]"}]}], "}"}], "*)"}], 
            RowBox[{"expterrorclassfinal", ",", 
             RowBox[{"readcorrconfigfile4", "[", 
              RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "2", 
             ",", 
             RowBox[{"-", "5"}]}], " ", "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"Print", "[", "plot2", "]"}], ";"}], "\[IndentingNewLine]", 
         "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"save", " ", "to", " ", "eps"}], ",", " ", 
          RowBox[{"png", " ", "and", " ", "pdf", " ", "file"}]}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"**", "**", "**", "**", "**", "**", "**"}], "*******)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"save", " ", "figure", " ", "files", " ", "into", " ", 
          RowBox[{
          "saveparentpath", "<>", "pdfnameexpttypeDir", "<>", "exptidDir"}], 
          " ", "or", " ", 
          RowBox[{"saveparentpath", "<>", "jobpath"}]}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "set", " ", "dir", " ", "for", " ", "saved", " ", "figures"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"saveparentpath", "=", "figureDir"}], ";", 
        RowBox[{
        "(*", "\"\</home/botingw/code/pdf_correlation/code/mathematica/\>\"", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"make", " ", "name", " ", "of", " ", "subdir", 
          RowBox[{"(", "s", ")"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"pdfnameexpttypeDir", "=", 
           RowBox[{
           "PDFname", "<>", "\"\<_\>\"", "<>", "expttype", "<>", 
            "\"\</\>\""}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"20170313", ":", " ", 
          RowBox[{"use", " ", "job", " ", "dir"}]}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"jobpath", "=", 
         RowBox[{"\"\<Jobs/\>\"", "<>", 
          RowBox[{"ToString", "[", "Jobid", "]"}], "<>", "\"\</\>\""}]}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"if", " ", "version", " ", "2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"LoopExptBool", "==", "True"}], ";"}], ")"}]}], ",", " ", 
          RowBox[{
           RowBox[{
           "put", " ", "the", " ", "produced", " ", "figures", " ", "under", 
            " ", "the", " ", "folder", " ", "with", " ", 
            RowBox[{"it", "'"}], "s", " ", "name"}], "=", 
           RowBox[{"Expt", " ", "ID"}]}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"exptidDir", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ToString", "[", 
             RowBox[{"exptid", "[", 
              RowBox[{"[", "iexpt", "]"}], "]"}], " ", "]"}], "<>", 
            "\"\<_\>\""}], ",", 
           RowBox[{"{", 
            RowBox[{"iexpt", ",", "1", ",", 
             RowBox[{"Length", "[", "exptid", "]"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"exptidDir", "=", 
         RowBox[{"StringJoin", "[", "exptidDir", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"exptidDir", "=", 
         RowBox[{
          RowBox[{"StringDrop", "[", 
           RowBox[{"exptidDir", ",", 
            RowBox[{"-", "1"}]}], "]"}], "<>", "\"\</\>\""}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"LoopExptBool", "==", "True"}], ",", 
          RowBox[{"jobpath", "=", 
           RowBox[{"jobpath", "<>", "exptidDir"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"if", " ", "expttype"}], " ", "=", " ", "single"}], ",", 
          "multi", ",", " ", 
          RowBox[{"set", " ", "exptidDir", " ", "as", " ", 
           RowBox[{"exptid", ":", " ", 
            RowBox[{
             RowBox[{"id1_id2", "_."}], ".."}]}]}]}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"exptidDir", "=", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"ToString", "[", 
               RowBox[{"exptid", "[", 
                RowBox[{"[", "iexpt", "]"}], "]"}], " ", "]"}], "<>", 
              "\"\<_\>\""}], ",", 
             RowBox[{"{", 
              RowBox[{"iexpt", ",", "1", ",", 
               RowBox[{"Length", "[", "exptid", "]"}]}], "}"}]}], "]"}]}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"exptidDir", "=", 
           RowBox[{"StringJoin", "[", "exptidDir", "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"exptidDir", "=", 
           RowBox[{
            RowBox[{"StringDrop", "[", 
             RowBox[{"exptidDir", ",", 
              RowBox[{"-", "1"}]}], "]"}], "<>", "\"\</\>\""}]}], ";"}], 
         "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"set", " ", "observables"}], ",", " ", 
          RowBox[{"different", " ", "kinds", " ", "of", " ", "plot"}], ",", 
          " ", 
          RowBox[{
          "available", " ", "extension", " ", "of", " ", "output", " ", 
           "files"}]}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"obsname", "=", 
         RowBox[{"{", 
          RowBox[{
          "\"\<xQbyexpt\>\"", ",", "\"\<expt_error_ratio\>\"", ",", 
           "\"\<residual\>\"", ",", "\"\<dr\>\"", ",", "\"\<corrdr\>\"", ",", 
           "\"\<corr\>\""}], "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"representationname", "=", 
         RowBox[{"{", 
          RowBox[{
          "\"\<xQ-1\>\"", ",", "\"\<xQ+1\>\"", ",", "\"\<hist-1\>\"", ",", 
           "\"\<hist+1\>\"", ",", "\"\<legend\>\"", ",", "\"\<xQ\>\"", ",", 
           "\"\<info-1\>\"", ",", "\"\<info+1\>\""}], "}"}]}], ";", 
        RowBox[{"(*", 
         RowBox[{"20171201", " ", "change", " ", "filename", " ", "format"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"extensionname", "=", 
         RowBox[{"{", 
          RowBox[{
          "\"\<.eps\>\"", ",", "\"\<.png\>\"", ",", "\"\<.pdf\>\"", ",", 
           "\"\<.jpg\>\""}], "}"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
          "if", " ", "directory", " ", "does", " ", "not", " ", "exist"}], 
          ",", " ", 
          RowBox[{"create", " ", "it"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"DirectoryQ", "[", 
            RowBox[{"saveparentpath", "<>", 
             RowBox[{"(*", 
              RowBox[{"pdfnameexpttypeDir", "<>", "exptidDir"}], "*)"}], 
             "jobpath"}], "]"}], "\[Equal]", "False"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"CreateDirectory", "[", 
            RowBox[{"saveparentpath", "<>", 
             RowBox[{"(*", 
              RowBox[{"pdfnameexpttypeDir", "<>", "exptidDir"}], "*)"}], 
             "jobpath"}], "]"}], ";", "\[IndentingNewLine]", 
           "\"\<dummy\>\""}]}], "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"20171119", ":", " ", 
          RowBox[{
          "select", " ", "export", " ", "figure", " ", "format", " ", "by", 
           " ", "Branch", " ", "Mode"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"iext", "=", 
         RowBox[{"Switch", "[", 
          RowBox[{"BranchMode", ",", "1", ",", 
           RowBox[{"{", "1", "}"}], ",", "2", ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "3"}], "}"}], ",", "3", ",", 
           RowBox[{"{", "4", "}"}], ",", "_", ",", 
           RowBox[{
            RowBox[{
            "Print", "[", "\"\<error, BranchMode should be 1, 2, 3\>\"", 
             "]"}], ";", 
            RowBox[{"Abort", "[", "]"}]}]}], " ", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"iext", "=", "2"}], ";"}], "*)"}], 
        RowBox[{"(*", 
         RowBox[{"export", " ", "eps"}], "*)"}], 
        RowBox[{"(*", 
         RowBox[{"20171105", ":", " ", 
          RowBox[{
           RowBox[{"use", " ", ".", "png"}], " ", "for", " ", "python", " ", 
           "script", " ", "interface", " ", "version"}]}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"imgresol", "=", "144"}], ";", 
        RowBox[{"(*", 
         RowBox[{"image", " ", "resolution"}], "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "corrdataclassfinal", ";", "\[IndentingNewLine]", 
        "dRcorrdataclassfinal", ";", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
         "expterrordataclassfinal", ",", "residualdataclassfinal", ",", 
          "dRdataclassfinal"}], "}"}], ";", "\[IndentingNewLine]", 
        "residualNsetdataclassfinal", ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", "\[IndentingNewLine]", 
         RowBox[{"Nflavour", "=", 
          RowBox[{
           RowBox[{"corrdataclassfinal", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "//", "Length"}]}], 
         "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"FigureFlag", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "1"}], " ", "||", 
            " ", 
            RowBox[{
             RowBox[{"FigureFlag", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
             RowBox[{"-", "1"}]}]}], ")"}], ",", 
          RowBox[{"processdatatotsv", "[", 
           RowBox[{
            RowBox[{"readcorrconfigfile6", "[", 
             RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "2", 
            ",", "0"}], "]"}]}], " ", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"FigureFlag", "[", 
              RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", "1"}], " ", "||", 
            " ", 
            RowBox[{
             RowBox[{"FigureFlag", "[", 
              RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", 
             RowBox[{"-", "1"}]}]}], ")"}], ",", 
          RowBox[{"processdatatotsv", "[", 
           RowBox[{
            RowBox[{"readcorrconfigfile6", "[", 
             RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "3", 
            ",", "0"}], "]"}]}], " ", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"FigureFlag", "[", 
              RowBox[{"[", "4", "]"}], "]"}], "\[Equal]", "1"}], " ", "||", 
            " ", 
            RowBox[{
             RowBox[{"FigureFlag", "[", 
              RowBox[{"[", "4", "]"}], "]"}], "\[Equal]", 
             RowBox[{"-", "1"}]}]}], ")"}], ",", 
          RowBox[{"processdatatotsv", "[", 
           RowBox[{
            RowBox[{"readcorrconfigfile6", "[", 
             RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "4", 
            ",", "0"}], "]"}]}], " ", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"CorrelationArgFlag", "[", 
               RowBox[{"[", 
                RowBox[{"#", "+", "6"}], "]"}], "]"}], "\[Equal]", "1"}], " ",
              "&&", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"FigureFlag", "[", 
                 RowBox[{"[", "5", "]"}], "]"}], "\[Equal]", "1"}], " ", "||",
                " ", 
               RowBox[{
                RowBox[{"FigureFlag", "[", 
                 RowBox[{"[", "5", "]"}], "]"}], "\[Equal]", 
                RowBox[{"-", "1"}]}]}], ")"}]}], ",", 
            RowBox[{"processdatatotsv", "[", 
             RowBox[{
              RowBox[{"readcorrconfigfile6", "[", 
               RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "5", 
              ",", "#"}], "]"}]}], " ", "]"}], "&"}], "/@", 
         RowBox[{"Range", "[", 
          RowBox[{
           RowBox[{"-", "5"}], ",", 
           RowBox[{
            RowBox[{"-", "5"}], "+", "fmax", "-", "1"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"CorrelationArgFlag", "[", 
               RowBox[{"[", 
                RowBox[{"#", "+", "6"}], "]"}], "]"}], "\[Equal]", "1"}], " ",
              "&&", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"FigureFlag", "[", 
                 RowBox[{"[", "6", "]"}], "]"}], "\[Equal]", "1"}], " ", "||",
                " ", 
               RowBox[{
                RowBox[{"FigureFlag", "[", 
                 RowBox[{"[", "6", "]"}], "]"}], "\[Equal]", 
                RowBox[{"-", "1"}]}]}], ")"}]}], ",", 
            RowBox[{"processdatatotsv", "[", 
             RowBox[{
              RowBox[{"readcorrconfigfile6", "[", 
               RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "6", 
              ",", "#"}], "]"}]}], " ", "]"}], "&"}], "/@", 
         RowBox[{"Range", "[", 
          RowBox[{
           RowBox[{"-", "5"}], ",", 
           RowBox[{
            RowBox[{"-", "5"}], "+", "fmax", "-", "1"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"20171124", " ", "print", " ", "final", " ", "info"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<The job is finished.All figures are in\>\"", ",", 
          RowBox[{"saveparentpath", "<>", "jobpath"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Print", "[", 
           RowBox[{"\"\<search figures under\>\"", ",", 
            RowBox[{"saveparentpath", "<>", "jobpath"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Print", "[", 
           RowBox[{"\"\<extension = \>\"", ",", 
            RowBox[{
             RowBox[{
              RowBox[{"extensionname", "[", 
               RowBox[{"[", "#", "]"}], "]"}], "&"}], "/@", "iext"}]}], " ", 
           "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<total #flavour for check = \>\"", ",", "CorrelationArgFlag"}],
            "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{
          "Print", "[", 
           "\"\<epspdfcat: combine several eps files into a PDF file using \
LaTeX\>\"", "]"}], ";"}], "\[IndentingNewLine]", "*)"}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\"\<complete the function\>\""}]}], "\[IndentingNewLine]", "]"}]}], 
    ";"}], "\n"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.692723648488598*^9, 3.692723656238858*^9}, {
   3.692724530213889*^9, 3.692724537777619*^9}, {3.6927245869877567`*^9, 
   3.692724611750757*^9}, {3.692724694012382*^9, 3.692724694516695*^9}, {
   3.6927248228546143`*^9, 3.6927248742476254`*^9}, {3.692726352475533*^9, 
   3.692726460529402*^9}, {3.692726503468624*^9, 3.69272650534301*^9}, {
   3.6933119701642237`*^9, 3.693311972894825*^9}, {3.69331461390936*^9, 
   3.693314614124537*^9}, {3.693316093645349*^9, 3.6933160959790573`*^9}, {
   3.693653206302556*^9, 3.6936532106134987`*^9}, {3.693939625505322*^9, 
   3.693939656334466*^9}, {3.693942641369175*^9, 3.6939427050773563`*^9}, {
   3.6939430977466087`*^9, 3.693943156993147*^9}, {3.69655860408397*^9, 
   3.6965586399105797`*^9}, {3.696680796628357*^9, 3.6966808769283667`*^9}, {
   3.6966905986088877`*^9, 3.6966906015575037`*^9}, {3.6968303816187687`*^9, 
   3.696830405964432*^9}, 3.696830451414171*^9, {3.6968304832955847`*^9, 
   3.696830577226272*^9}, {3.6968311626158457`*^9, 3.696831163722234*^9}, {
   3.6970768789183807`*^9, 3.697076887616562*^9}, {3.69707848487141*^9, 
   3.697078591210807*^9}, {3.697078764057641*^9, 3.6970788395483007`*^9}, {
   3.697079471643612*^9, 3.697079472537709*^9}, {3.697079508582533*^9, 
   3.6970796061789*^9}, {3.697079637519354*^9, 3.697079704206859*^9}, {
   3.697079744180998*^9, 3.697079850511104*^9}, 3.69708009114454*^9, {
   3.697080605349367*^9, 3.6970806091324453`*^9}, {3.697080917436017*^9, 
   3.697080920859625*^9}, {3.6970814709326363`*^9, 3.697081510033683*^9}, {
   3.6970817029250097`*^9, 3.6970817058735943`*^9}, {3.69708174981524*^9, 
   3.697081750811051*^9}, {3.697082776875799*^9, 3.697082781051053*^9}, {
   3.697083062247024*^9, 3.6970830692485647`*^9}, {3.697138742323319*^9, 
   3.697138771015585*^9}, {3.6971390075105133`*^9, 3.6971390249980097`*^9}, {
   3.697139765916954*^9, 3.697140011115527*^9}, {3.6971401201276407`*^9, 
   3.69714015841426*^9}, {3.697140215538045*^9, 3.6971402462786617`*^9}, {
   3.697140329638941*^9, 3.6971404532947083`*^9}, {3.697140550118216*^9, 
   3.6971406924417267`*^9}, {3.69714112371637*^9, 3.697141142012652*^9}, {
   3.697141668563136*^9, 3.69714169228379*^9}, {3.697142121669072*^9, 
   3.697142131910977*^9}, {3.697154211586882*^9, 3.697154220941998*^9}, {
   3.6971542725272083`*^9, 3.697154293058907*^9}, {3.6971546429166737`*^9, 
   3.697154687209687*^9}, {3.697154912165421*^9, 3.697154961078877*^9}, {
   3.697155009671788*^9, 3.697155038476575*^9}, {3.697155359397155*^9, 
   3.697155363593137*^9}, {3.6971556848644867`*^9, 3.697155692079138*^9}, {
   3.697222247488604*^9, 3.697222290746934*^9}, {3.6972860122902603`*^9, 
   3.697286048602767*^9}, {3.69728615691158*^9, 3.697286217626849*^9}, {
   3.6972946096828327`*^9, 3.697294612528249*^9}, {3.69729558423606*^9, 
   3.697295715434699*^9}, {3.697296765727755*^9, 3.697296773423441*^9}, {
   3.697400476382049*^9, 3.697400660242959*^9}, {3.697400697837544*^9, 
   3.697400736773443*^9}, {3.6974007992262897`*^9, 3.697400921956421*^9}, {
   3.697401171407124*^9, 3.697401203002494*^9}, {3.697401478783388*^9, 
   3.6974014977251167`*^9}, {3.6974015288478537`*^9, 
   3.6974016225692577`*^9}, {3.697401662135783*^9, 3.697401941604968*^9}, 
   3.697402052620207*^9, {3.697402667412176*^9, 3.697402669299849*^9}, {
   3.697402707268697*^9, 3.697402830563102*^9}, {3.697403001740428*^9, 
   3.697403006792362*^9}, {3.697403066485817*^9, 3.697403089438408*^9}, {
   3.697403169141343*^9, 3.697403169300745*^9}, {3.6974032548169127`*^9, 
   3.697403262806226*^9}, {3.6974033835136833`*^9, 3.697403398164859*^9}, {
   3.697403693896372*^9, 3.697403714480401*^9}, {3.697403871140098*^9, 
   3.697403896676878*^9}, {3.697403927677313*^9, 3.697403929215707*^9}, {
   3.697404002181491*^9, 3.697404033811108*^9}, {3.6974040697871723`*^9, 
   3.697404076605229*^9}, {3.697404138798005*^9, 3.697404209757766*^9}, 
   3.697404305029789*^9, {3.697404412745449*^9, 3.6974044182263203`*^9}, {
   3.6974056664941263`*^9, 3.69740570015322*^9}, {3.697405740989566*^9, 
   3.697405810296575*^9}, {3.6974103097470083`*^9, 3.697410317039926*^9}, {
   3.697417807503504*^9, 3.697417816382893*^9}, {3.6975559116468773`*^9, 
   3.697555921952511*^9}, {3.6975565546674*^9, 3.697556606785534*^9}, {
   3.697556638316646*^9, 3.697556707402018*^9}, {3.6975567433400784`*^9, 
   3.697556753810347*^9}, {3.69755733249146*^9, 3.697557380535098*^9}, {
   3.697557518986594*^9, 3.697557560771634*^9}, {3.69755759992305*^9, 
   3.6975576002906*^9}, {3.697557694178874*^9, 3.697557695865241*^9}, {
   3.697558205114801*^9, 3.697558236061026*^9}, {3.69755827015271*^9, 
   3.697558502197757*^9}, {3.697558722719071*^9, 3.697558722991253*^9}, {
   3.697558962576949*^9, 3.697558972125186*^9}, {3.6975592583456984`*^9, 
   3.6975592703327713`*^9}, {3.697559603274172*^9, 3.697559615031126*^9}, {
   3.697559875534439*^9, 3.6975598960997133`*^9}, {3.6975599848149347`*^9, 
   3.697560165958386*^9}, {3.697560496083321*^9, 3.6975605006610937`*^9}, {
   3.697560945249696*^9, 3.6975610303265123`*^9}, {3.6978335880846443`*^9, 
   3.6978336116978207`*^9}, {3.6978370047888603`*^9, 3.697837037379693*^9}, {
   3.697837070503273*^9, 3.697837201261754*^9}, {3.697837479536602*^9, 
   3.697837603942915*^9}, {3.6978376417111063`*^9, 3.6978377343395967`*^9}, {
   3.697886701400988*^9, 3.6978867422842083`*^9}, {3.697886811750001*^9, 
   3.6978870113471746`*^9}, {3.697888160205917*^9, 3.697888192122485*^9}, 
   3.6978886509163933`*^9, {3.697888811917552*^9, 3.697888836155066*^9}, {
   3.697888915375636*^9, 3.6978889245968*^9}, {3.6978921169715548`*^9, 
   3.697892142699376*^9}, {3.697892245272468*^9, 3.697892265316698*^9}, {
   3.697895431695013*^9, 3.697895434728279*^9}, {3.697896340488986*^9, 
   3.6978963617738047`*^9}, {3.697899702354683*^9, 3.6978997073217297`*^9}, {
   3.6978997570611753`*^9, 3.6978998573973923`*^9}, {3.697899895969203*^9, 
   3.69789992969068*^9}, 3.697900002552608*^9, {3.6979003709838667`*^9, 
   3.69790038433469*^9}, {3.697900577230777*^9, 3.697900599476684*^9}, {
   3.697900692900959*^9, 3.697900823597556*^9}, {3.697900887234622*^9, 
   3.6979008900711403`*^9}, {3.697901103834797*^9, 3.6979011144389877`*^9}, {
   3.6979021104041567`*^9, 3.6979021174016027`*^9}, {3.697902851146566*^9, 
   3.697902936225397*^9}, 3.697903060044847*^9, {3.697903116968381*^9, 
   3.697903121709342*^9}, {3.6979032754399557`*^9, 3.697903276591189*^9}, {
   3.697996584040292*^9, 3.697996593331482*^9}, {3.698071337312834*^9, 
   3.698071341847207*^9}, 3.6980716298814917`*^9, {3.6980721641926537`*^9, 
   3.698072167008778*^9}, {3.698161423522284*^9, 3.6981614462900743`*^9}, {
   3.698161540279511*^9, 3.698161595744443*^9}, {3.698161636191758*^9, 
   3.698161725062221*^9}, {3.6981617687110033`*^9, 3.698161803374731*^9}, {
   3.698161887018663*^9, 3.69816192282675*^9}, {3.698161958371101*^9, 
   3.6981619925231113`*^9}, {3.698162026031312*^9, 3.698162074028681*^9}, {
   3.6981657267132397`*^9, 3.6981657310598*^9}, {3.698165786091655*^9, 
   3.6981658056351223`*^9}, {3.698165849545231*^9, 3.698165919924782*^9}, {
   3.698169528215746*^9, 3.6981695559881477`*^9}, {3.698169612230535*^9, 
   3.698169613475706*^9}, {3.6981697014096317`*^9, 3.698169769733567*^9}, 
   3.698170071674176*^9, {3.698170222070361*^9, 3.698170273553499*^9}, {
   3.6981707322196083`*^9, 3.698170740532178*^9}, {3.698170811888246*^9, 
   3.698170812034443*^9}, {3.6981708480788527`*^9, 3.6981708499989557`*^9}, {
   3.698170976523417*^9, 3.698170980113942*^9}, {3.6981712680480824`*^9, 
   3.69817132556627*^9}, {3.698171357706958*^9, 3.698171383464563*^9}, {
   3.698171426987818*^9, 3.698171457874702*^9}, 3.698171798143113*^9, {
   3.6981719612953672`*^9, 3.698172006952753*^9}, {3.698172138846099*^9, 
   3.698172146148446*^9}, {3.698172178650379*^9, 3.6981722258393583`*^9}, {
   3.69817228656448*^9, 3.698172290421266*^9}, {3.698172584936687*^9, 
   3.698172645282847*^9}, {3.698172692128703*^9, 3.698172694407916*^9}, {
   3.698173088133802*^9, 3.698173096660006*^9}, {3.6981733812693377`*^9, 
   3.69817338136504*^9}, {3.698173532115452*^9, 3.698173541691969*^9}, {
   3.698173575241938*^9, 3.698173584822556*^9}, {3.698173815288653*^9, 
   3.698173822031045*^9}, {3.698174275990417*^9, 3.698174315836672*^9}, {
   3.698174788518158*^9, 3.698174789913475*^9}, {3.698174912608736*^9, 
   3.698174980867828*^9}, {3.698175053098505*^9, 3.698175079356299*^9}, {
   3.698175171115746*^9, 3.698175172284082*^9}, {3.698175217131351*^9, 
   3.698175226770488*^9}, {3.698175391240275*^9, 3.698175403248673*^9}, {
   3.698175460678995*^9, 3.698175499403681*^9}, {3.69817553997309*^9, 
   3.698175556623143*^9}, {3.698175644116884*^9, 3.6981756505334063`*^9}, {
   3.698175706111665*^9, 3.6981757164951973`*^9}, {3.69817585515648*^9, 
   3.698175859447098*^9}, {3.698175900793294*^9, 3.698175906769639*^9}, {
   3.698175939876513*^9, 3.6981759835847387`*^9}, {3.698176038710297*^9, 
   3.698176047052271*^9}, {3.698176090615123*^9, 3.6981761259048853`*^9}, {
   3.698176160222315*^9, 3.698176163802479*^9}, {3.698176901614978*^9, 
   3.698176904246009*^9}, {3.698177037531947*^9, 3.698177165116879*^9}, {
   3.698177240672209*^9, 3.6981772435059566`*^9}, {3.698177296222597*^9, 
   3.698177376635*^9}, {3.698177414827533*^9, 3.6981775051078157`*^9}, 
   3.698177633996216*^9, {3.698177692298443*^9, 3.6981777236975718`*^9}, {
   3.69817820570249*^9, 3.698178229088004*^9}, {3.698178326322247*^9, 
   3.698178337686069*^9}, {3.698178376942813*^9, 3.698178391302638*^9}, {
   3.69817843428864*^9, 3.698178448188026*^9}, {3.698178486447935*^9, 
   3.69817849052114*^9}, {3.6981786070612993`*^9, 3.69817861880812*^9}, {
   3.698178672817665*^9, 3.698178713654771*^9}, {3.698183704324995*^9, 
   3.6981837191677303`*^9}, {3.698185307618744*^9, 3.698185313766013*^9}, {
   3.698185371925268*^9, 3.698185388436612*^9}, {3.698185418783613*^9, 
   3.698185419791635*^9}, {3.698186013196486*^9, 3.698186013893758*^9}, {
   3.698186094057954*^9, 3.6981860948604803`*^9}, {3.698186202953641*^9, 
   3.698186279283292*^9}, {3.6981863137626133`*^9, 3.6981863498565474`*^9}, {
   3.698186487767766*^9, 3.698186488677528*^9}, {3.6981868024539137`*^9, 
   3.698186995225019*^9}, {3.698375374155635*^9, 3.698375388391355*^9}, {
   3.698375481678948*^9, 3.698375481801426*^9}, {3.69837600317898*^9, 
   3.698376003870861*^9}, {3.6983764126863537`*^9, 3.698376415516151*^9}, {
   3.698376483123497*^9, 3.6983765172376947`*^9}, {3.698376554890914*^9, 
   3.698376569245541*^9}, {3.698376612274609*^9, 3.6983766165984*^9}, {
   3.6983773936606293`*^9, 3.698377550214871*^9}, {3.6983775966181927`*^9, 
   3.6983776546827583`*^9}, {3.698377697591744*^9, 3.698377778858807*^9}, {
   3.698377897472526*^9, 3.698377995892112*^9}, {3.6983781537069063`*^9, 
   3.698378176992009*^9}, {3.698378208594558*^9, 3.698378216223559*^9}, {
   3.698378287910985*^9, 3.698378347050434*^9}, {3.6983783774576483`*^9, 
   3.698378379103231*^9}, {3.698378961801875*^9, 3.698379086636891*^9}, {
   3.698379185097292*^9, 3.6983792371495047`*^9}, {3.698379274152958*^9, 
   3.698379323956073*^9}, {3.698379446741404*^9, 3.698379592497773*^9}, {
   3.6983796226445503`*^9, 3.69837973146275*^9}, {3.698379773989316*^9, 
   3.698379813399626*^9}, {3.698422130188918*^9, 3.698422185811975*^9}, 
   3.69842222139403*^9, 3.6984223644484053`*^9, {3.698422649928307*^9, 
   3.698422653584572*^9}, {3.698422759452343*^9, 3.698422767844452*^9}, {
   3.698422858743147*^9, 3.698422859714566*^9}, {3.698422906859548*^9, 
   3.698422921261602*^9}, {3.69842295139184*^9, 3.6984229601552763`*^9}, {
   3.698423000559868*^9, 3.698423050016955*^9}, {3.698423125951791*^9, 
   3.6984231701302843`*^9}, {3.698423512900033*^9, 3.6984235252759438`*^9}, {
   3.6984235907916822`*^9, 3.6984235999841223`*^9}, {3.698423637283904*^9, 
   3.698423638463047*^9}, {3.698423696061852*^9, 3.698423798128016*^9}, {
   3.698423895752602*^9, 3.6984239143236113`*^9}, {3.6984239572218227`*^9, 
   3.698424013604312*^9}, {3.698424152110713*^9, 3.6984242108865423`*^9}, {
   3.698424640916594*^9, 3.698424703222928*^9}, {3.698425236501338*^9, 
   3.698425241702427*^9}, {3.698425312887843*^9, 3.6984253306654873`*^9}, {
   3.698425370103011*^9, 3.698425534046015*^9}, {3.698426334951508*^9, 
   3.698426356689186*^9}, 3.698427303040491*^9, {3.6984345648966913`*^9, 
   3.6984346363603888`*^9}, {3.698434687418271*^9, 3.698434739263241*^9}, {
   3.698434960685013*^9, 3.698434974961977*^9}, {3.698435034075223*^9, 
   3.6984350705105057`*^9}, {3.698435120776404*^9, 3.6984351322506313`*^9}, {
   3.698435229223077*^9, 3.69843523276132*^9}, {3.698496568796444*^9, 
   3.698496607636848*^9}, {3.6984966623147593`*^9, 3.698496795834756*^9}, {
   3.698496832965817*^9, 3.6984968961638327`*^9}, {3.6984970070681553`*^9, 
   3.698497007641251*^9}, {3.6984970587122993`*^9, 3.6984970863940353`*^9}, 
   3.69849714080025*^9, {3.6984971722337027`*^9, 3.6984971821369*^9}, {
   3.698497234689015*^9, 3.698497279786778*^9}, {3.698497721880156*^9, 
   3.6984977586704197`*^9}, {3.698497800291216*^9, 3.69849782897654*^9}, {
   3.698497896345314*^9, 3.698497952819976*^9}, {3.698498099342456*^9, 
   3.698498218417438*^9}, {3.698498251210842*^9, 3.698498318974228*^9}, {
   3.698498368945421*^9, 3.698498417266086*^9}, {3.698498464087495*^9, 
   3.698498472972783*^9}, {3.6984985071261177`*^9, 3.698498543393721*^9}, {
   3.698498574601891*^9, 3.698498618036139*^9}, {3.698498878890766*^9, 
   3.698498974996151*^9}, {3.698499943888091*^9, 3.6984999862180147`*^9}, {
   3.698500039380684*^9, 3.698500060991892*^9}, {3.698500296113984*^9, 
   3.698500297958454*^9}, {3.698500351901705*^9, 3.698500356984885*^9}, {
   3.698500428859589*^9, 3.6985004394480867`*^9}, {3.698500480455682*^9, 
   3.698500494407383*^9}, {3.6985006619139853`*^9, 3.6985007401492023`*^9}, {
   3.698500812610276*^9, 3.698500824072425*^9}, {3.698500884416847*^9, 
   3.698500916349101*^9}, {3.6985009871156054`*^9, 3.698501025815914*^9}, {
   3.698501097798208*^9, 3.6985011095001717`*^9}, {3.698501171569806*^9, 
   3.6985011784868727`*^9}, {3.69850133025955*^9, 3.698501397362928*^9}, {
   3.698504558196309*^9, 3.698504629295352*^9}, {3.698504690759542*^9, 
   3.698504725030435*^9}, {3.6985048610094423`*^9, 3.698504868049876*^9}, {
   3.698504922529729*^9, 3.698504983182766*^9}, {3.698505013265264*^9, 
   3.6985051510092173`*^9}, {3.698505318094695*^9, 3.698505342289236*^9}, {
   3.698505391909754*^9, 3.698505392009137*^9}, {3.698505518998989*^9, 
   3.698505549405963*^9}, {3.698505632809449*^9, 3.698505649621396*^9}, {
   3.6985056970428123`*^9, 3.698505717674914*^9}, {3.6985057803345327`*^9, 
   3.6985058463122377`*^9}, {3.6985059103796864`*^9, 3.698505913548465*^9}, 
   3.6985060997858*^9, {3.6985061368326807`*^9, 3.6985061499027567`*^9}, {
   3.698506183802936*^9, 3.698506183979107*^9}, {3.6985066795543623`*^9, 
   3.6985067117845078`*^9}, {3.698506747178562*^9, 3.69850679025176*^9}, {
   3.698506837379848*^9, 3.698506859069729*^9}, {3.698506894774612*^9, 
   3.698506909028596*^9}, {3.698507002902429*^9, 3.6985071014064903`*^9}, {
   3.69850734083961*^9, 3.698507348968281*^9}, {3.698507399522592*^9, 
   3.6985074275264378`*^9}, {3.6985075294360733`*^9, 3.698507608250091*^9}, {
   3.698507647637692*^9, 3.6985076943071203`*^9}, {3.698508057614543*^9, 
   3.698508377302964*^9}, {3.698508467466371*^9, 3.698508467562771*^9}, {
   3.6985085255057583`*^9, 3.698508560401816*^9}, {3.698509240094328*^9, 
   3.698509251004244*^9}, {3.698509281500942*^9, 3.6985093099425*^9}, {
   3.698510661926887*^9, 3.6985106855263844`*^9}, {3.69851108500737*^9, 
   3.698511089406443*^9}, 3.698511150013969*^9, {3.698512078036865*^9, 
   3.6985124380448837`*^9}, 3.6985134783165407`*^9, {3.698513965632573*^9, 
   3.698513970599959*^9}, {3.698514457541904*^9, 3.698514458666573*^9}, {
   3.698515184364903*^9, 3.698515194855057*^9}, {3.698515420391387*^9, 
   3.6985154818835506`*^9}, {3.698515850103076*^9, 3.69851589386024*^9}, {
   3.698515982883314*^9, 3.698516032230871*^9}, {3.698517354529791*^9, 
   3.6985174425736647`*^9}, {3.698594812397932*^9, 3.698595017681079*^9}, {
   3.698595071527205*^9, 3.698595224293602*^9}, {3.6985952640290003`*^9, 
   3.698595270045404*^9}, {3.698595383509328*^9, 3.698595409769446*^9}, {
   3.698595571245247*^9, 3.698595574658671*^9}, {3.698595671017033*^9, 
   3.698595672528543*^9}, {3.6985957163508*^9, 3.6985957727292356`*^9}, {
   3.698596554688429*^9, 3.698596600451806*^9}, {3.69859664651615*^9, 
   3.698596681396489*^9}, {3.698603387024642*^9, 3.698603398092396*^9}, {
   3.6986437460067043`*^9, 3.698643794006505*^9}, {3.698644731753346*^9, 
   3.6986447392924957`*^9}, {3.698645131331957*^9, 3.6986451854952583`*^9}, {
   3.698645609424526*^9, 3.6986456157993183`*^9}, {3.698645953684476*^9, 
   3.698645964830656*^9}, {3.6986752359122553`*^9, 3.698675312968587*^9}, {
   3.698677369597822*^9, 3.698677389568874*^9}, {3.6986776024792633`*^9, 
   3.6986776131258183`*^9}, {3.6986777618002443`*^9, 3.698677771846245*^9}, {
   3.698976815333543*^9, 3.698976887438642*^9}, {3.698977041939784*^9, 
   3.698977057265069*^9}, {3.698978239912632*^9, 3.698978277250681*^9}, {
   3.698978369755589*^9, 3.6989783986916513`*^9}, {3.698978769009664*^9, 
   3.698978788643612*^9}, {3.6989789831445932`*^9, 3.698978983469986*^9}, 
   3.698982300432041*^9, {3.698983796879025*^9, 3.698983799749288*^9}, {
   3.698984103204665*^9, 3.698984104510377*^9}, {3.698984214187005*^9, 
   3.698984239846623*^9}, {3.698984482306733*^9, 3.698984495886298*^9}, {
   3.698984570719895*^9, 3.698984575335476*^9}, {3.698984676292613*^9, 
   3.69898467884112*^9}, {3.698984848499816*^9, 3.69898485843489*^9}, {
   3.6989850619199963`*^9, 3.698985172149876*^9}, {3.698985465891712*^9, 
   3.698985492123137*^9}, {3.6989856237008677`*^9, 3.698985632173436*^9}, {
   3.698985832975917*^9, 3.698985836655061*^9}, {3.698986086670496*^9, 
   3.698986086767561*^9}, {3.699108131767274*^9, 3.699108143880109*^9}, 
   3.699108322655871*^9, 3.6991084383653316`*^9, {3.699113671344336*^9, 
   3.699113675602439*^9}, {3.699113708277372*^9, 3.699113819835918*^9}, {
   3.6991142539321327`*^9, 3.699114257534837*^9}, {3.699114378331626*^9, 
   3.699114414883988*^9}, {3.699118260825739*^9, 3.6991182651064777`*^9}, {
   3.6997146471863203`*^9, 3.6997147069160757`*^9}, {3.699714773054997*^9, 
   3.699714796014769*^9}, {3.699714833886188*^9, 3.699714884003749*^9}, {
   3.699714930103491*^9, 3.6997149333666487`*^9}, {3.699714963610683*^9, 
   3.6997149665064497`*^9}, {3.699718635041913*^9, 3.69971873519379*^9}, {
   3.699718767296932*^9, 3.699718937150714*^9}, {3.6997218031928053`*^9, 
   3.699721809291904*^9}, {3.700576798254157*^9, 3.700576807204111*^9}, 
   3.700576994656827*^9, {3.700577127492188*^9, 3.7005771450662403`*^9}, {
   3.700856424114493*^9, 3.700856512733164*^9}, {3.700856721510928*^9, 
   3.7008567247049503`*^9}, {3.700856977130435*^9, 3.700856990074864*^9}, {
   3.700857022066639*^9, 3.700857068964971*^9}, {3.70085711279653*^9, 
   3.7008571445161057`*^9}, {3.700857252845189*^9, 3.7008574868231363`*^9}, {
   3.700857741961318*^9, 3.700857847338152*^9}, {3.7008580892926817`*^9, 
   3.700858281442284*^9}, {3.7008587323046427`*^9, 3.700858743049624*^9}, {
   3.700859079009516*^9, 3.7008591440793943`*^9}, {3.7022827016062307`*^9, 
   3.702282725186412*^9}, {3.702283656459311*^9, 3.7022837402623253`*^9}, {
   3.702284225249275*^9, 3.702284264204466*^9}, {3.702284381896797*^9, 
   3.702284397562743*^9}, 3.7022845116922092`*^9, {3.702284670737721*^9, 
   3.702284673895072*^9}, {3.702284743192176*^9, 3.702284819606019*^9}, {
   3.702284915484323*^9, 3.702284937302918*^9}, {3.702285040948885*^9, 
   3.702285059065847*^9}, {3.703210061145794*^9, 3.703210194595612*^9}, {
   3.703210354155658*^9, 3.70321042029907*^9}, {3.703210457504456*^9, 
   3.703210491007218*^9}, {3.703210567521886*^9, 3.703210657535472*^9}, {
   3.703212116263042*^9, 3.703212145102297*^9}, {3.703212180930471*^9, 
   3.703212198170203*^9}, {3.703212266034836*^9, 3.7032122709175043`*^9}, {
   3.703212308579755*^9, 3.7032123827055893`*^9}, {3.703212414361137*^9, 
   3.703212583714033*^9}, {3.7032126190239153`*^9, 3.703212641090941*^9}, {
   3.70321389287853*^9, 3.70321389409584*^9}, 3.7032139244996433`*^9, {
   3.7032140869230747`*^9, 3.70321423222677*^9}, {3.7032143131706543`*^9, 
   3.703214320212666*^9}, {3.7032143853125553`*^9, 3.703214398823906*^9}, {
   3.703214478357448*^9, 3.70321448124111*^9}, {3.703214539802897*^9, 
   3.703214562333995*^9}, {3.703214654425705*^9, 3.703214695362774*^9}, {
   3.7032150586029*^9, 3.703215126718226*^9}, {3.703215193384273*^9, 
   3.703215232456133*^9}, {3.703215312180965*^9, 3.7032155483416567`*^9}, {
   3.70321559347147*^9, 3.703215595193327*^9}, {3.7032157335223303`*^9, 
   3.703215741843009*^9}, {3.7032157865242367`*^9, 3.703215809203005*^9}, {
   3.7032158512765083`*^9, 3.7032160147254477`*^9}, {3.7032162855504923`*^9, 
   3.703216306927647*^9}, {3.7032165670055*^9, 3.703216579050796*^9}, {
   3.70321730361217*^9, 3.7032173444180527`*^9}, {3.703217431319765*^9, 
   3.703217443278096*^9}, 3.703217523826235*^9, {3.703217563386284*^9, 
   3.703217567231889*^9}, {3.703217648553754*^9, 3.7032176539844093`*^9}, {
   3.703218130604484*^9, 3.703218157644577*^9}, {3.703218323775071*^9, 
   3.7032183651260433`*^9}, {3.703218512922668*^9, 3.703218517109384*^9}, {
   3.7032185626284323`*^9, 3.703218566120389*^9}, {3.7032190733591957`*^9, 
   3.703219119889312*^9}, {3.703219191833766*^9, 3.7032192334256*^9}, {
   3.703220675570663*^9, 3.703220698296678*^9}, 3.7032208417605677`*^9, 
   3.703220873707135*^9, {3.703221516911208*^9, 3.703221550673723*^9}, {
   3.70322158718178*^9, 3.703221651975253*^9}, {3.7032223503800592`*^9, 
   3.703222405644689*^9}, {3.703222444712462*^9, 3.703222478194214*^9}, {
   3.703222517831664*^9, 3.703222652461401*^9}, {3.703222698114142*^9, 
   3.703222750958495*^9}, {3.703222804934175*^9, 3.70322294602733*^9}, {
   3.703226789712873*^9, 3.703226794839857*^9}, {3.703275222547058*^9, 
   3.7032752839706783`*^9}, {3.7032753342321043`*^9, 3.703275556085435*^9}, {
   3.703276636806147*^9, 3.7032766380431767`*^9}, {3.703276889251028*^9, 
   3.703276900078492*^9}, {3.703299977999363*^9, 3.703300024855564*^9}, {
   3.703300056869525*^9, 3.703300095195971*^9}, {3.703307013457649*^9, 
   3.703307023522627*^9}, {3.703485612299582*^9, 3.703485656505014*^9}, {
   3.703485706915516*^9, 3.703485820093699*^9}, {3.70348589132543*^9, 
   3.7034859168771343`*^9}, {3.703485961308949*^9, 3.703485979453567*^9}, {
   3.703486015752334*^9, 3.7034860801353807`*^9}, {3.7034861160844584`*^9, 
   3.7034861924527082`*^9}, {3.703486234622744*^9, 3.7034862835304747`*^9}, {
   3.703486319046224*^9, 3.7034864152666273`*^9}, {3.70348646755464*^9, 
   3.7034864942014103`*^9}, {3.7034865570764017`*^9, 
   3.7034865580579977`*^9}, {3.703487009376289*^9, 3.703487012230529*^9}, {
   3.7034906120075274`*^9, 3.703490666950856*^9}, {3.703490772675468*^9, 
   3.7034908061779547`*^9}, 3.703490883846033*^9, {3.703490945937525*^9, 
   3.703490972143693*^9}, 3.703491125145754*^9, {3.70349116791306*^9, 
   3.7034911731473503`*^9}, {3.7034912645515614`*^9, 3.703491269410746*^9}, {
   3.7034918808013897`*^9, 3.703491904560238*^9}, {3.703491972876707*^9, 
   3.703491977672883*^9}, {3.703492038336172*^9, 3.703492044787225*^9}, {
   3.703492950559244*^9, 3.703492963078898*^9}, {3.7037921205760508`*^9, 
   3.7037921682391148`*^9}, {3.703816979967037*^9, 3.703816997531898*^9}, {
   3.703817431352235*^9, 3.703817455664521*^9}, {3.703817994675737*^9, 
   3.7038180202701283`*^9}, {3.7038243139176292`*^9, 3.703824346450218*^9}, {
   3.703824422314323*^9, 3.7038244257548656`*^9}, {3.703824484681532*^9, 
   3.703824507534832*^9}, {3.703824555837049*^9, 3.7038245979050283`*^9}, {
   3.703824640355279*^9, 3.703824750764669*^9}, {3.703824985695075*^9, 
   3.7038250025186357`*^9}, {3.705297340669058*^9, 3.7052973479867773`*^9}, {
   3.705641191293248*^9, 3.705641194481386*^9}, {3.70564140572546*^9, 
   3.70564141478055*^9}, 3.70667952758817*^9, {3.706679728138695*^9, 
   3.706679767160454*^9}, {3.706679862447678*^9, 3.706679873981298*^9}, {
   3.70668006346471*^9, 3.7066800648182507`*^9}, {3.708405885402691*^9, 
   3.7084059245805473`*^9}, {3.713040946383614*^9, 3.713040947291451*^9}, {
   3.713050425051447*^9, 3.713050837948689*^9}, {3.713050907929318*^9, 
   3.713050916782485*^9}, {3.713100864933536*^9, 3.7131008775710573`*^9}, {
   3.713101035321125*^9, 3.7131010357316027`*^9}, {3.713101196313941*^9, 
   3.713101200622054*^9}, {3.7131012802824917`*^9, 3.713101294611589*^9}, {
   3.713101409382761*^9, 3.713101456351602*^9}, {3.713101555678117*^9, 
   3.713101562080645*^9}, {3.713101626167685*^9, 3.7131016295751457`*^9}, {
   3.713101793352305*^9, 3.713101913423128*^9}, 3.713126731952744*^9, {
   3.713126784154566*^9, 3.71312694459575*^9}, {3.713127126732226*^9, 
   3.713127166435614*^9}, {3.713127198100656*^9, 3.713127243780387*^9}, {
   3.713127453300911*^9, 3.713127492749344*^9}, {3.7131275389350243`*^9, 
   3.7131275621544456`*^9}, {3.713794038312829*^9, 3.713794073861084*^9}, {
   3.713794107398052*^9, 3.7137941161890087`*^9}, {3.718577996012239*^9, 
   3.718577997249798*^9}, {3.718578127446313*^9, 3.718578141502624*^9}, {
   3.718578172365573*^9, 3.718578172952261*^9}, {3.71857856896961*^9, 
   3.718578820160582*^9}, {3.718578859574028*^9, 3.718578864556776*^9}, {
   3.7185791851677427`*^9, 3.71857932965168*^9}, {3.718579359893834*^9, 
   3.718579452639666*^9}, {3.718579508892652*^9, 3.718579580941701*^9}, {
   3.718580961881772*^9, 3.718580971727888*^9}, {3.718581958379775*^9, 
   3.718581992219285*^9}, {3.7185820689988203`*^9, 3.7185820703135967`*^9}, {
   3.718582646324396*^9, 3.718582662568303*^9}, {3.718583113970621*^9, 
   3.718583134485256*^9}, 3.71858346132001*^9, {3.718583753883135*^9, 
   3.718583791882905*^9}, {3.718583839093934*^9, 3.718583918192165*^9}, {
   3.7185843339795094`*^9, 3.718584335324819*^9}, {3.71858441508184*^9, 
   3.718584536076253*^9}, {3.718584566662129*^9, 3.7185846263131104`*^9}, {
   3.718584714127007*^9, 3.718584715341508*^9}, {3.718584819840084*^9, 
   3.718584844789818*^9}, {3.718585458769403*^9, 3.718585515628504*^9}, {
   3.718585555190572*^9, 3.718585556512698*^9}, {3.718585631480072*^9, 
   3.718585636532922*^9}, 3.718585688243203*^9, {3.718585739016941*^9, 
   3.7185857439823647`*^9}, {3.718585797129773*^9, 3.7185861562288637`*^9}, {
   3.718586191468759*^9, 3.718586213717264*^9}, {3.718586260668893*^9, 
   3.718586292651198*^9}, {3.718586344299746*^9, 3.718586381220055*^9}, {
   3.718586447399105*^9, 3.718586617580353*^9}, {3.718586724086689*^9, 
   3.718586725048263*^9}, {3.71858688887393*^9, 3.718586889960091*^9}, {
   3.718586943103283*^9, 3.718587027117132*^9}, {3.71858706657755*^9, 
   3.718587067331624*^9}, {3.718587150408016*^9, 3.718587155553392*^9}, {
   3.718587201122858*^9, 3.718587255182831*^9}, {3.718587311424903*^9, 
   3.71858735689682*^9}, {3.7185873946432533`*^9, 3.71858741140026*^9}, {
   3.718587455525942*^9, 3.718587489903543*^9}, {3.7185875323553743`*^9, 
   3.7185875851687603`*^9}, {3.718587811424769*^9, 3.718587813647833*^9}, {
   3.718588091493516*^9, 3.718588181002096*^9}, {3.718588226551621*^9, 
   3.718588228952043*^9}, {3.7185883375303907`*^9, 3.718588422204445*^9}, {
   3.718588452521462*^9, 3.71858847200653*^9}, {3.718588521916143*^9, 
   3.7185885722029467`*^9}, {3.718588604901615*^9, 3.718588783145256*^9}, {
   3.718588955827167*^9, 3.718589104109877*^9}, {3.7185893117714787`*^9, 
   3.718589330009605*^9}, {3.718589389761904*^9, 3.718589420967039*^9}, {
   3.718589651549136*^9, 3.7185898635110903`*^9}, {3.718589897240336*^9, 
   3.718589934064864*^9}, {3.7185900265650682`*^9, 3.718590077500935*^9}, 
   3.7185901389145603`*^9, {3.718590244726322*^9, 3.7185902727403927`*^9}, {
   3.718590334610241*^9, 3.718590378803029*^9}, {3.718590490792447*^9, 
   3.718590498191843*^9}, 3.7185905731309433`*^9, {3.718590624970055*^9, 
   3.718590672224592*^9}, {3.71859082889655*^9, 3.71859086978759*^9}, {
   3.718593815267283*^9, 3.718594226499176*^9}, {3.718594507393808*^9, 
   3.7185945557891397`*^9}, {3.7187310863370237`*^9, 3.718731086709087*^9}, {
   3.7187647526019173`*^9, 3.718764817783593*^9}, {3.718764872142952*^9, 
   3.71876492094729*^9}, 3.718764957723377*^9, {3.718767573838018*^9, 
   3.718767658075205*^9}, {3.7187679652835493`*^9, 3.7187680266567574`*^9}, {
   3.7187684016665707`*^9, 3.718768470384042*^9}, {3.718768833481686*^9, 
   3.71876887044412*^9}, {3.718808739186594*^9, 3.718808752963402*^9}, {
   3.718888769012989*^9, 3.718888776291359*^9}, {3.718888813039979*^9, 
   3.7188888347105217`*^9}, {3.7191682880653963`*^9, 3.719168486644665*^9}, {
   3.719207544605268*^9, 3.719207580446541*^9}, {3.7192076255467377`*^9, 
   3.719207727610173*^9}, {3.71922319822689*^9, 3.719223272947831*^9}, {
   3.719223676311833*^9, 3.719223680518045*^9}, {3.719223715456728*^9, 
   3.71922377511484*^9}, {3.7192243521680927`*^9, 3.71922441441114*^9}, {
   3.719719826272235*^9, 3.7197198428515244`*^9}, {3.71971993950781*^9, 
   3.7197199647824697`*^9}, {3.719720018499489*^9, 3.719720062796444*^9}, {
   3.719723263989764*^9, 3.719723294307708*^9}, {3.719723325163702*^9, 
   3.7197233365670757`*^9}, {3.719723874969639*^9, 3.719723876583626*^9}, {
   3.719724014609786*^9, 3.719724017068183*^9}, {3.7197244069131727`*^9, 
   3.719724410204555*^9}, {3.719730505910645*^9, 3.719730550164165*^9}, {
   3.719820409601569*^9, 3.719820415463545*^9}, {3.719820523434355*^9, 
   3.719820576625688*^9}, {3.719820612679702*^9, 3.719820762729148*^9}, {
   3.719820801311043*^9, 3.7198208370611057`*^9}, {3.719820900747322*^9, 
   3.719820934843779*^9}, {3.7198209671454353`*^9, 3.7198209674522667`*^9}, 
   3.719821145687022*^9, {3.719821420408655*^9, 3.7198214237781*^9}, 
   3.719821553811953*^9, {3.71982160207454*^9, 3.719821627372719*^9}, {
   3.7198418192346773`*^9, 3.719841821709997*^9}, {3.720125120438141*^9, 
   3.7201251517340717`*^9}, {3.720125290197815*^9, 3.7201253719917507`*^9}, {
   3.720125403280842*^9, 3.720125433501101*^9}, {3.7201254974774237`*^9, 
   3.7201255293866262`*^9}, {3.720125660542984*^9, 3.72012567045085*^9}, {
   3.720125704751367*^9, 3.720125722017599*^9}, {3.720126410537282*^9, 
   3.720126568065445*^9}, {3.7201266479341288`*^9, 3.720126752756585*^9}, {
   3.720126786276251*^9, 3.720126852940604*^9}, {3.720127280848507*^9, 
   3.7201272899796762`*^9}, {3.720127668684454*^9, 3.720127676820612*^9}, {
   3.720128211008894*^9, 3.720128378571059*^9}, {3.720128417795745*^9, 
   3.720128450654731*^9}, {3.720129767939829*^9, 3.7201298790946302`*^9}, 
   3.720129919475862*^9, {3.720130763972334*^9, 3.720130766909677*^9}, {
   3.720132271773704*^9, 3.720132271959683*^9}, {3.720134601154746*^9, 
   3.720134661618143*^9}, {3.720134743181528*^9, 3.720134745578936*^9}, {
   3.720134779514123*^9, 3.720134794167775*^9}, {3.72013549697681*^9, 
   3.7201354982560883`*^9}, {3.7201401178403*^9, 3.720140136415535*^9}, {
   3.720140172663629*^9, 3.720140274250806*^9}, {3.7201583860604877`*^9, 
   3.7201584105646267`*^9}, {3.7201584504477577`*^9, 3.720158550718916*^9}, {
   3.72015859644345*^9, 3.720158597347568*^9}, {3.7201586602415133`*^9, 
   3.720158663180543*^9}, {3.720187779513043*^9, 3.7201878022563868`*^9}, {
   3.720187854909893*^9, 3.720187938536921*^9}, {3.720187983407918*^9, 
   3.72018799531752*^9}, {3.720188036758748*^9, 3.720188173462185*^9}, {
   3.720188220802463*^9, 3.7201882906395063`*^9}, {3.720188414320525*^9, 
   3.720188414401454*^9}, {3.720190634471434*^9, 3.720190679390073*^9}, {
   3.720496036459051*^9, 3.720496078358732*^9}, 3.720496116335381*^9, {
   3.720496155471931*^9, 3.7204961982692947`*^9}, {3.72049622930107*^9, 
   3.7204962683972588`*^9}, {3.7204964168319387`*^9, 3.720496427572462*^9}, {
   3.720496467091717*^9, 3.7204964717735033`*^9}, {3.72049655262749*^9, 
   3.7204965801536303`*^9}, {3.720496631820567*^9, 3.720496651212453*^9}, {
   3.720496765849388*^9, 3.720496768036757*^9}, {3.720496941606946*^9, 
   3.7204969506005*^9}, {3.720497134408205*^9, 3.720497137378545*^9}, {
   3.7204989309466457`*^9, 3.720498960488061*^9}, {3.720499217054837*^9, 
   3.720499401772831*^9}, {3.720499448309854*^9, 3.720499692731138*^9}, {
   3.720499782753607*^9, 3.720499806448019*^9}, 3.720500198604187*^9, {
   3.7205002379115753`*^9, 3.720500327722035*^9}, {3.720500362362422*^9, 
   3.720500462988636*^9}, 3.720500516433715*^9, {3.720500661366385*^9, 
   3.72050070127861*^9}, {3.72050073191108*^9, 3.720500742745679*^9}, {
   3.7205007871448317`*^9, 3.720500805245406*^9}, {3.720504315409494*^9, 
   3.720504364883593*^9}, {3.720504438256044*^9, 3.720504450968804*^9}, {
   3.7205046616519213`*^9, 3.72050473893876*^9}, {3.720504815031844*^9, 
   3.720504850413177*^9}, {3.720504896204495*^9, 3.720504904551264*^9}, {
   3.720504943464755*^9, 3.720504948778654*^9}, {3.720505201136302*^9, 
   3.720505240362459*^9}, {3.720806590331317*^9, 3.7208066007330227`*^9}, {
   3.72080665580669*^9, 3.7208066760875607`*^9}, {3.720806722048184*^9, 
   3.720806752379045*^9}, {3.7208068526642447`*^9, 3.720807067538368*^9}, {
   3.720807155661963*^9, 3.7208072644684057`*^9}, {3.720807311359111*^9, 
   3.7208073144157457`*^9}, {3.720807522613291*^9, 3.7208075227798967`*^9}, {
   3.720815800656952*^9, 3.720815831066862*^9}, {3.720892342195641*^9, 
   3.72089234530066*^9}, {3.720892396335464*^9, 3.720892397800613*^9}, {
   3.720892528085842*^9, 3.720892547535356*^9}, {3.7209074686755238`*^9, 
   3.7209075077703753`*^9}, {3.720907910282495*^9, 3.720907928854025*^9}, {
   3.720909032139823*^9, 3.7209090430137*^9}, {3.720909362595223*^9, 
   3.72090941824601*^9}, {3.721099695602344*^9, 3.721099789037011*^9}, {
   3.7210998227677526`*^9, 3.7210998631173687`*^9}, {3.721099973888606*^9, 
   3.721100027764372*^9}, {3.7211000759926643`*^9, 3.7211000790060863`*^9}, {
   3.72110024414112*^9, 3.721100338046299*^9}, {3.721100382515109*^9, 
   3.7211004052902117`*^9}, {3.721100444209115*^9, 3.721100444740703*^9}, {
   3.721100583368725*^9, 3.7211006373298407`*^9}, {3.7211007425111856`*^9, 
   3.721100762511444*^9}, {3.7211015031306887`*^9, 3.721101523368342*^9}, {
   3.72110162392717*^9, 3.721101625169517*^9}, {3.7211016978104143`*^9, 
   3.721101744404365*^9}, {3.721102991596204*^9, 3.721103130800581*^9}, {
   3.721180661934567*^9, 3.721180668774828*^9}, {3.721180778803093*^9, 
   3.7211808100411453`*^9}, {3.7211808436923313`*^9, 3.721180867482699*^9}, {
   3.7211809502403708`*^9, 3.721180967299738*^9}, {3.721181003813274*^9, 
   3.721181056074355*^9}, {3.721181102059873*^9, 3.721181346445735*^9}, {
   3.7211814314257393`*^9, 3.7211814789843884`*^9}, {3.721181558798315*^9, 
   3.721181561939355*^9}, {3.721181601110537*^9, 3.721181603479048*^9}, {
   3.721181646388462*^9, 3.7211816464722567`*^9}, {3.721181711978013*^9, 
   3.721181740714385*^9}, {3.721272500436763*^9, 3.721272544579126*^9}, {
   3.72127260235786*^9, 3.721272637491596*^9}, {3.7212726758705177`*^9, 
   3.721272764937173*^9}, {3.721272845529642*^9, 3.721272899503397*^9}, {
   3.7212729686634398`*^9, 3.721272981242354*^9}, {3.721273031693192*^9, 
   3.72127306780855*^9}, {3.721273105853896*^9, 3.721273107158139*^9}, 
   3.72127759069549*^9, {3.721277648625936*^9, 3.7212776644954777`*^9}, {
   3.721277706754142*^9, 3.7212778267535686`*^9}, {3.721277861045415*^9, 
   3.721277861180058*^9}, {3.721277901918043*^9, 3.721277991511662*^9}, {
   3.721278036691929*^9, 3.721278062622614*^9}, {3.7212781246194153`*^9, 
   3.7212781370569143`*^9}, {3.7212781904730873`*^9, 3.721278242732971*^9}, {
   3.7212801731607513`*^9, 3.721280201482726*^9}, {3.721281257521946*^9, 
   3.72128148728472*^9}, {3.721281531185316*^9, 3.721281540456684*^9}, {
   3.721281578811001*^9, 3.721281685147482*^9}, {3.7212819872057867`*^9, 
   3.7212820287863617`*^9}, {3.72128260366103*^9, 3.721282664899791*^9}, 
   3.721283017408242*^9, {3.721285464180559*^9, 3.721285501811294*^9}, {
   3.721285556871171*^9, 3.721285581980863*^9}, {3.7212858170694113`*^9, 
   3.721285971904544*^9}, {3.721286110237678*^9, 3.721286298096999*^9}, {
   3.721286337922305*^9, 3.721286340996254*^9}, {3.7212871552591143`*^9, 
   3.721287336346035*^9}, {3.7212873944366693`*^9, 3.721287499234024*^9}, {
   3.721866586585868*^9, 3.721866589246059*^9}, 3.7218666252364807`*^9, {
   3.721866656621852*^9, 3.721866662935678*^9}, {3.7218672571542463`*^9, 
   3.721867339694625*^9}, {3.721868112526416*^9, 3.721868219058934*^9}, {
   3.721868589230863*^9, 3.7218686045328007`*^9}, {3.722187251156015*^9, 
   3.72218737754681*^9}, {3.722188346118885*^9, 3.722188446441803*^9}, {
   3.722188484358138*^9, 3.72218849310223*^9}, {3.722188532169084*^9, 
   3.722188608394795*^9}, {3.7221893578859262`*^9, 3.722189388758943*^9}, {
   3.722189460606269*^9, 3.722189469350396*^9}, {3.722190476672078*^9, 
   3.722190489546247*^9}, {3.7221928060990133`*^9, 3.722192826707264*^9}, {
   3.722192880173223*^9, 3.722192982862637*^9}, {3.722193774513465*^9, 
   3.7221937818964367`*^9}, {3.722193823640695*^9, 3.722194056087824*^9}, {
   3.7221940934272137`*^9, 3.7221943367741528`*^9}, {3.722194944817461*^9, 
   3.722194953753779*^9}, {3.722195137230544*^9, 3.722195150845585*^9}, {
   3.722195203787665*^9, 3.7221952069146423`*^9}, {3.722195425904056*^9, 
   3.722195426869128*^9}, {3.722195699689514*^9, 3.722195703328363*^9}, {
   3.722196197627597*^9, 3.7221962385195427`*^9}, 3.722196514685987*^9, {
   3.72219810719036*^9, 3.722198111276355*^9}, {3.722481976182379*^9, 
   3.722482002753481*^9}, {3.7224820710449123`*^9, 3.722482083579872*^9}, {
   3.722482115887939*^9, 3.722482117525282*^9}, {3.722482153066833*^9, 
   3.7224823082074823`*^9}, {3.722484071065114*^9, 3.7224841220454397`*^9}, {
   3.722484191815386*^9, 3.722484216329543*^9}, {3.7224842605195513`*^9, 
   3.7224844604806633`*^9}, {3.722484524016872*^9, 3.722484527909824*^9}, 
   3.722485661936167*^9, {3.722489138828289*^9, 3.722489197943172*^9}, {
   3.722870087292502*^9, 3.7228700891794033`*^9}, {3.722870184962388*^9, 
   3.722870192479313*^9}, 3.722870287087727*^9, {3.722870317339653*^9, 
   3.722870331354762*^9}, {3.722870368720214*^9, 3.722870414765877*^9}, {
   3.722870455872838*^9, 3.722870486058367*^9}, {3.722870636991967*^9, 
   3.7228706934305267`*^9}, {3.7228708086613197`*^9, 3.722870852098856*^9}, {
   3.722870894116682*^9, 3.722870919674242*^9}, {3.722870979107388*^9, 
   3.722871021071739*^9}, {3.7228716545819407`*^9, 3.72287165635183*^9}, {
   3.722871725585058*^9, 3.722871793850863*^9}, 3.725791789317979*^9, 
   3.725791821668289*^9, 3.7257918558560266`*^9, {3.7257918983202133`*^9, 
   3.725791920913968*^9}, 3.725883657357359*^9, 3.727713618699637*^9, {
   3.7277136978507767`*^9, 3.727713775607119*^9}, {3.727714064490971*^9, 
   3.727714306759591*^9}, {3.731953090182572*^9, 3.731953101334646*^9}, {
   3.7320171688192253`*^9, 3.732017169216604*^9}, {3.733291932083651*^9, 
   3.733291939608404*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["control runfunc you want to run", "Section",
 CellChangeTimes->{{3.696088116543365*^9, 3.696088139969136*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"configDir", "=", 
     RowBox[{"NotebookDirectory", "[", "]"}]}], ";"}], "*)"}], 
  RowBox[{"(*", 
   RowBox[{"DirectoryName", "[", "$InputFileName", "]"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"configfilename", "=", "\"\<config_pdf_resolution_test.txt\>\""}],
     ";"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"configfilename", "=", "\"\<config1.txt\>\""}], ";"}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"web", " ", 
    RowBox[{"version", ":", " ", 
     RowBox[{"only", " ", "run", " ", "the", " ", "quick", " ", "mode"}]}]}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "run", " ", "the", " ", "function", " ", "to", " ", "draw", " ", "all", 
    " ", "experimental", " ", "data", " ", "togather"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"If", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"LoopExptBool", "\[Equal]", "False"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"timefunc", "=", "\[IndentingNewLine]", 
       RowBox[{"AbsoluteTiming", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Quicksaveplot", "[", "]"}], ";"}], "\[IndentingNewLine]", 
        "]"}]}]}], "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]",
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{
     "\"\<total time to run is \>\"", ",", "timefunc", ",", 
      "\"\< seconds\>\""}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"if", " ", "version", " ", "2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"LoopExptBool", "==", "True"}], ";"}], ")"}]}], ",", " ", 
     RowBox[{
     "run", " ", "a", " ", "loop", " ", "to", " ", "draw", " ", "every", " ", 
      "experimental", " ", "data", " ", "seperately"}]}], "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"LoopExptBool", "==", "True"}], ",", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"configDir", "=", 
         RowBox[{"NotebookDirectory", "[", "]"}]}], ";"}], "*)"}], 
      RowBox[{"(*", 
       RowBox[{"DirectoryName", "[", "$InputFileName", "]"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
        "configfilename", "=", "\"\<config_pdf_resolution_test.txt\>\""}], 
        ";"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"configDir", "=", 
        RowBox[{
         RowBox[{"Directory", "[", "]"}], "<>", "\"\</\>\""}]}], ";", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"NotebookDirectory", "[", "]"}], ";"}], "*)"}], 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"DirectoryName", "[", "$InputFileName", "]"}], ";"}], "*)"}],
        "\[IndentingNewLine]", 
       RowBox[{"configfilename", "=", "\"\<config1.txt\>\""}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{"web", " ", 
         RowBox[{"version", ":", " ", 
          RowBox[{
          "only", " ", "run", " ", "the", " ", "quick", " ", "mode"}]}]}], 
        "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
        "read", " ", "#", " ", "of", " ", "expts", " ", "in", " ", "config", 
         " ", "file"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"20171109", ":", " ", 
           RowBox[{"for", " ", "readcorrconfigfile4", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
             "dummy", ",", "dummy", ",", "dummy", ",", "dummy", ",", 
              "ExptidType", ",", "ExptidFlag", ",", "dummy", ",", "dummy", 
              ",", "dummy", ",", "dummy", ",", "\[IndentingNewLine]", "dummy",
               ",", "dummy", ",", "dummy", ",", "dummy", ",", 
              RowBox[{"(*", "Hist1figureYrange", "*)"}], "dummy", ",", 
              "\[IndentingNewLine]", "dummy", ",", "\[IndentingNewLine]", 
              "dummy", ",", "dummy", ",", "dummy", ",", "dummy", ",", 
              "dummy"}], "}"}]}]}], "=", "\[IndentingNewLine]", 
          RowBox[{"readcorrconfigfile4", "[", 
           RowBox[{"configDir", ",", "configfilename"}], "]"}]}], ";"}], 
        "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{"20171109", ":", " ", 
         RowBox[{"for", " ", "readcorrconfigfile5"}]}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"dummy", ",", "dummy", 
          RowBox[{"(*", "20171128", "*)"}], ",", "dummy", ",", "dummy", ",", 
          "dummy", ",", "ExptidType", ",", "ExptidFlag", ",", "dummy", ",", 
          "dummy", ",", 
          RowBox[{"(*", 
           RowBox[{"dummy", ",", "dummy", ","}], "*)"}], 
          "\[IndentingNewLine]", "dummy", ",", "dummy", ",", 
          RowBox[{"(*", "ColorPaletterange", "*)"}], 
          RowBox[{"(*", "20171128", "*)"}], "dummy", ",", "dummy", ",", 
          RowBox[{"(*", 
           RowBox[{"dummy", ",", 
            RowBox[{"(*", "Hist1figureYrange", "*)"}], "dummy", ","}], "*)"}],
           "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{"dummy", ","}], "*)"}], "\[IndentingNewLine]", "dummy", 
          ",", "dummy", ",", "dummy", ",", "dummy", ",", "dummy"}], "}"}], 
        "=", "\[IndentingNewLine]", 
        RowBox[{"readcorrconfigfile6", "[", 
         RowBox[{"configDir", ",", "configfilename"}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"Lexpt", "=", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Table", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ExptidFlag", "[", 
             RowBox[{"[", "iexpt", "]"}], "]"}], "\[Equal]", "1"}], ",", 
           RowBox[{"Lexpt", "=", 
            RowBox[{"Append", "[", 
             RowBox[{"Lexpt", ",", 
              RowBox[{"ExptidType", "[", 
               RowBox[{"[", "iexpt", "]"}], "]"}]}], " ", "]"}]}]}], " ", 
          "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"iexpt", ",", "1", ",", 
           RowBox[{"Length", "[", "ExptidType", "]"}]}], "}"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{"web", " ", 
         RowBox[{"version", ":", " ", 
          RowBox[{
          "only", " ", "run", " ", "the", " ", "quick", " ", "mode"}]}]}], 
        "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
         "loop", " ", "for", " ", "all", " ", "expts", " ", "in", " ", 
          "config", " ", "file"}], ",", " ", 
         RowBox[{
         "plot", " ", "figures", " ", "of", " ", "expts", " ", "one", " ", 
          "by", " ", "one"}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"Table", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"timefunc", "=", "\[IndentingNewLine]", 
           RowBox[{"AbsoluteTiming", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Quicksaveplot", "[", "]"}], ";"}], 
            "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<total running time is \>\"", ",", "timefunc", ",", 
            "\"\< seconds\>\""}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"irun", "==", 
             RowBox[{"Length", "[", "Lexpt", "]"}]}], ",", 
            RowBox[{
             RowBox[{"Print", "[", "\"\<all processes are done\>\"", "]"}], 
             ";", 
             RowBox[{"Abort", "[", "]"}]}]}], "]"}], ";", 
          "\[IndentingNewLine]", "\"\<dummy\>\""}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"irun", ",", "1", ",", 
           RowBox[{"Length", "[", "Lexpt", "]"}]}], "}"}]}], "\n", "]"}]}]}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";"}]}]}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJwd0l1IU3EABfDhQ1QEXRNc9mBTiNKbbMIetrWVt5aObW4V9uGDlqsZRis1
itCHObhpOY0WrEhdmg6560OvH02dNaUcDqkbyqCalPoS1rUoBDFa0f/s4fB7
PoeTZbt8zJ4ikUhySOC3tEVP6JbINHL5D2DDcp0PZtDFD2FsNqMbnq92c3DZ
wheOEw2jnUVQI7WZYW/z/FEYq/dUQV3gzkWoVfpqYNjTWwvVqrJGGM12JPUb
2GfTxJ/ShSC8kJigdrlFRph8tw32zFj3wBcpJ/bCyetyq4+ousYnzVQX0F1E
ql+bB2VbS0pgmyNyHL6JVDSME2kh2wU35ptzXxLXV4ZpGB/7E31N/MvKZqBA
sZp9LSKzWz6ig8J9tRGKLe5iWOeYf6olNo+k9UG9XppZQFynX+2EW04ptU3E
SlORDvJqoeMmsdvl9MMP/YuMolVkFLGhg5B/f0CmuC0yVzt9WdBGsYfh2tyj
Qmi41DQA7UF2EHY4939qI/5KrfoMB6dXje3Eu31yM0z3HvoYIHqj9XH4Nvwk
fbVdZH6YTDtg5e+lUlhebS2HZ/ytPs1jkeEM57qgXnmSg0dy9Tys5W4EYSQ0
NAG3WxI5/mHSd+Bf0qmvoaX4c/If99oXaAlJVqDr3ux3OLVwOmQYFZkaai6p
3RnYsHmM7KlKbIJho7cilXglr+cs/A/UH19M
  "]],

Cell[CellGroupData[{

Cell[BoxData["\<\"begin function\"\>"], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333156877650137`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"method to search (x,Q) points that dominate the process: \"\>",
    "\[InvisibleSpace]", "\<\"samept\"\>"}],
  SequenceForm[
  "method to search (x,Q) points that dominate the process: ", "samept"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315687784733*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"reading arguments from \"\>", 
   "\[InvisibleSpace]", "\<\"config1.txt\"\>"}],
  SequenceForm["reading arguments from ", "config1.txt"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333156878048267`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"input arguments: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"CT14HERA2NNLONoJetall_tsv\"\>", 
     ",", "\<\" CT14HERA2_no_jet\"\>", ",", "\<\"CT14HERA2NNLONoJet\"\>", ",", 
     RowBox[{"{", 
      RowBox[{"\<\"1\"\>", ",", "\<\"2\"\>", ",", "\<\"3\"\>", 
       ",", "\<\"4\"\>", ",", "\<\"5\"\>", ",", "\<\"6\"\>", 
       ",", "\<\"7\"\>"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "701", ",", "702", ",", "703", ",", "159", ",", "160", ",", "101", ",", 
       "102", ",", "103", ",", "104", ",", "106", ",", "108", ",", "109", ",",
        "110", ",", "111", ",", "124", ",", "125", ",", "126", ",", "127", 
       ",", "147", ",", "201", ",", "203", ",", "204", ",", "225", ",", "227",
        ",", "231", ",", "234", ",", "260", ",", "261", ",", "504", ",", 
       "514", ",", "145", ",", "169", ",", "267", ",", "268", ",", "535", ",",
        "240", ",", "241", ",", "281", ",", "265", ",", "266", ",", "538", 
       ",", "245", ",", "246", ",", "247", ",", "248", ",", "542", ",", "544",
        ",", "249", ",", "250", ",", "565", ",", "566", ",", "567", ",", 
       "568", ",", "545", ",", "252", ",", "253", ",", "254", ",", "255", ",",
        "191", ",", "192", ",", "193", ",", "194"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"bb\"\>", ",", "\<\"cb\"\>", ",", "\<\"sb\"\>", 
       ",", "\<\"db\"\>", ",", "\<\"ub\"\>", ",", "\<\"g\"\>", 
       ",", "\<\"u\"\>", ",", "\<\"d\"\>", ",", "\<\"s\"\>", ",", "\<\"c\"\>",
        ",", "\<\"b\"\>", ",", "\<\"user\"\>"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"auto\"\>", ",", "\<\"auto\"\>"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "6000"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "2.4`"}], "}"}], ",", "100", ",", "\<\"tiny\"\>", ",", 
     RowBox[{"{", 
      RowBox[{"\<\"1\"\>", ",", "\<\"2\"\>", ",", "\<\"3\"\>", 
       ",", "\<\"4\"\>", ",", "\<\"5\"\>", ",", "\<\"6\"\>", 
       ",", "\<\"7\"\>"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0.`", ",", "0.`"}], "}"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0.2`", ",", "100"}], "}"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1000"}], "}"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"1", ",", "500"}], "}"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0.25`", ",", "500"}], "}"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0.7`", ",", "1.`"}], "}"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0.`", ",", "0.`"}], "}"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0.`", ",", "0.`"}], "}"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0.`", ",", "0.`"}], "}"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0.`", ",", "0.`"}], "}"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0.`", ",", "0.`"}], "}"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0.`", ",", "0.`"}], "}"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0.`", ",", "0.`"}], "}"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0.`", ",", "0.`"}], "}"}], "}"}]}], "}"}]}], "}"}]}],
  SequenceForm[
  "input arguments: ", {
   "CT14HERA2NNLONoJetall_tsv", " CT14HERA2_no_jet", "CT14HERA2NNLONoJet", {
    "1", "2", "3", "4", "5", "6", "7"}, {1, 1, 1, 1, 1, 1, 0}, {701, 702, 703,
     159, 160, 101, 102, 103, 104, 106, 108, 109, 110, 111, 124, 125, 126, 
    127, 147, 201, 203, 204, 225, 227, 231, 234, 260, 261, 504, 514, 145, 169,
     267, 268, 535, 240, 241, 281, 265, 266, 538, 245, 246, 247, 248, 542, 
    544, 249, 250, 565, 566, 567, 568, 545, 252, 253, 254, 255, 191, 192, 193,
     194}, {0, 0, 0, 0, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
    1, 1, 0, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0,
     0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0}, {
    "bb", "cb", "sb", "db", "ub", "g", "u", "d", "s", "c", "b", "user"}, {0, 
    0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1}, {"auto", "auto"}, {1, 6000}, {0, 2.4}, 
    100, "tiny", {"1", "2", "3", "4", "5", "6", "7"}, {1, 1, 1, 1, 1, 1, 
    0}, {{{0., 0.}}, {{0.2, 100}}, {{1, 1000}}, {{1, 500}}, {{0.25, 500}}, {{
     0.7, 1.}}, {{0., 0.}}}, {{{0., 0.}}, {{0., 0.}}, {{0., 0.}}, {{0., 
    0.}}, {{0., 0.}}, {{0., 0.}}, {{0., 0.}}}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333156878262167`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315687851013*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"input arguments for read plot data: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"dat170928lisformathematica\"\>", ",", "\<\"default\"\>", 
     ",", "\<\"default\"\>", ",", "\<\"default\"\>", ",", "\<\"default\"\>", 
     ",", "\<\"default\"\>", ",", "\<\"default\"\>", ",", "10", ",", "5"}], 
    "}"}]}],
  SequenceForm[
  "input arguments for read plot data: ", {
   "dat170928lisformathematica", "default", "default", "default", "default", 
    "default", "default", 10, 5}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315687872505*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"present directory:\\n\"\>", 
   "\[InvisibleSpace]", \
"\<\"/home/botingw/Downloads/Sean_20171114/PDFsense-0320_for_sens_ranking_\
copy/bin_parrel22_nojet_tsv\"\>"}],
  SequenceForm[
  "present directory:\n", 
   "/home/botingw/Downloads/Sean_20171114/PDFsense-0320_for_sens_ranking_copy/\
bin_parrel22_nojet_tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315687893838*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"quick correlation data:\\n\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"../quick_data/dtacentral_samept_data_CT14HERA2NNLONoJet.dat\"\
\>", ",", "\<\"../quick_data/fxQNset_samept_data_CT14HERA2NNLONoJet.dat\"\>", 
     ",", "\<\"../quick_data/metadata_samept_data_CT14HERA2NNLONoJet.dat\"\>",
      ",", "\<\"../quick_data/residualNset_samept_data_CT14HERA2NNLONoJet.dat\
\"\>"}], "}"}]}],
  SequenceForm[
  "quick correlation data:\n", {
   "../quick_data/dtacentral_samept_data_CT14HERA2NNLONoJet.dat", 
    "../quick_data/fxQNset_samept_data_CT14HERA2NNLONoJet.dat", 
    "../quick_data/metadata_samept_data_CT14HERA2NNLONoJet.dat", 
    "../quick_data/residualNset_samept_data_CT14HERA2NNLONoJet.dat"}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315687915052*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315687939105*^9}],

Cell[BoxData["\<\"read experimental id\"\>"], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315687958766*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"selected Expt IDs = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "160", ",", "101", ",", "102", ",", "104", ",", "108", ",", "109", ",", 
     "110", ",", "111", ",", "124", ",", "125", ",", "126", ",", "127", ",", 
     "147", ",", "201", ",", "203", ",", "204", ",", "225", ",", "227", ",", 
     "234", ",", "260", ",", "261", ",", "145", ",", "169", ",", "267", ",", 
     "268", ",", "240", ",", "241", ",", "281", ",", "266", ",", "247", ",", 
     "565", ",", "253"}], "}"}]}],
  SequenceForm[
  "selected Expt IDs = ", {160, 101, 102, 104, 108, 109, 110, 111, 124, 125, 
   126, 127, 147, 201, 203, 204, 225, 227, 234, 260, 261, 145, 169, 267, 268, 
   240, 241, 281, 266, 247, 565, 253}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333156879790277`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.73331568800136*^9}],

Cell[BoxData["\<\"filenames of plotted data:\"\>"], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315688060479*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Directory: \"\>", 
   "\[InvisibleSpace]", "\<\"../quick_data/\"\>"}],
  SequenceForm["Directory: ", "../quick_data/"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315688082078*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"residualNsetclass: \"\>", 
   "\[InvisibleSpace]", \
"\<\"residualNset_samept_data_CT14HERA2NNLONoJet.dat\"\>", 
   "\[InvisibleSpace]", "\<\"\\nfxQsamept2class: \"\>", 
   "\[InvisibleSpace]", "\<\"fxQNset_samept_data_CT14HERA2NNLONoJet.dat\"\>", 
   "\[InvisibleSpace]", "\<\"\\ndtacentralclass: \"\>", 
   "\[InvisibleSpace]", \
"\<\"dtacentral_samept_data_CT14HERA2NNLONoJet.dat\"\>", 
   "\[InvisibleSpace]", "\<\"\\n\"\>"}],
  SequenceForm[
  "residualNsetclass: ", "residualNset_samept_data_CT14HERA2NNLONoJet.dat", 
   "\nfxQsamept2class: ", "fxQNset_samept_data_CT14HERA2NNLONoJet.dat", 
   "\ndtacentralclass: ", "dtacentral_samept_data_CT14HERA2NNLONoJet.dat", 
   "\n"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315688102312*^9}],

Cell[BoxData["\<\"Dimensions of plotted data\"\>"], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315695385241*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"{residual Nset class}: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"{", "48", "}"}], "}"}], 
   "\[InvisibleSpace]", "\<\"{fxQ samept class}: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"48", ",", "11"}], "}"}], "}"}], 
   "\[InvisibleSpace]", "\<\"{dta central class}: \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"{", 
    RowBox[{"{", "48", "}"}], "}"}]}],
  SequenceForm[
  "{residual Nset class}: ", {{48}}, "{fxQ samept class}: ", {{48, 11}}, 
   "{dta central class}: ", {{48}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315695412772*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333156954345627`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"fraction numbers in data transfer to numerical numbers, time = \
\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.590426`", ",", "\<\"dummy\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm[
  "fraction numbers in data transfer to numerical numbers, time = ", {
   0.590426, "dummy"}, " seconds"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315695974925*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315696002728*^9}],

Cell[BoxData["\<\"check whether the selected expts are also in the plotted \
data files\"\>"], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333156960712833`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"expt list: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "160", ",", "101", ",", "102", ",", "104", ",", "108", ",", "109", ",", 
     "110", ",", "111", ",", "124", ",", "125", ",", "126", ",", "127", ",", 
     "147", ",", "201", ",", "203", ",", "204", ",", "225", ",", "227", ",", 
     "234", ",", "260", ",", "261", ",", "145", ",", "169", ",", "267", ",", 
     "268", ",", "240", ",", "241", ",", "281", ",", "266", ",", "247", ",", 
     "565", ",", "253"}], "}"}]}],
  SequenceForm[
  "expt list: ", {160, 101, 102, 104, 108, 109, 110, 111, 124, 125, 126, 127, 
   147, 201, 203, 204, 225, 227, 234, 260, 261, 145, 169, 267, 268, 240, 241, 
   281, 266, 247, 565, 253}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315696096737*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"expt list in the ./quick_data: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "160", ",", "101", ",", "102", ",", "104", ",", "108", ",", "109", ",", 
     "110", ",", "111", ",", "124", ",", "125", ",", "126", ",", "127", ",", 
     "147", ",", "201", ",", "203", ",", "204", ",", "225", ",", "227", ",", 
     "234", ",", "260", ",", "261", ",", "145", ",", "169", ",", "267", ",", 
     "268", ",", "240", ",", "241", ",", "281", ",", "266", ",", "247", ",", 
     "565", ",", "253"}], "}"}]}],
  SequenceForm[
  "expt list in the ./quick_data: ", {160, 101, 102, 104, 108, 109, 110, 111, 
   124, 125, 126, 127, 147, 201, 203, 204, 225, 227, 234, 260, 261, 145, 169, 
   267, 268, 240, 241, 281, 266, 247, 565, 253}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333156961221743`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315696147781*^9}],

Cell[BoxData["\<\"Dimensions of data of selected and available expts\"\>"], \
"Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315696175212*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"{residualNsetclassfinal}: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "32", "}"}], 
   "\[InvisibleSpace]", "\<\"{fxQsamept2classfinal}: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"32", ",", "11"}], "}"}], 
   "\[InvisibleSpace]", "\<\"{dtacentralclassfinal}: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "32", "}"}]}],
  SequenceForm[
  "{residualNsetclassfinal}: ", {32}, "{fxQsamept2classfinal}: ", {32, 11}, 
   "{dtacentralclassfinal}: ", {32}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333156962043543`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315696230672*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"reading user functions from \"\>", 
   "\[InvisibleSpace]", "\<\"user_func.txt\"\>"}],
  SequenceForm["reading user functions from ", "user_func.txt"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315696255094*^9}]
}, Open  ]],

Cell[BoxData[
 TemplateBox[{
  "Power","infy",
   "\"Infinite expression \\!\\(\\*FractionBox[\\\"1\\\", \\\"0.`\\\"]\\) \
encountered.\"",2,28,25,25913773499101206936,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.722871203742743*^9, 3.722871246365102*^9}, 
   3.722871828534135*^9, 3.725883676935253*^9, 3.725890975207891*^9, 
   3.725896417859623*^9, 3.7259888269528217`*^9, 3.727715631069846*^9, 
   3.727716132471698*^9, 3.7290043459731827`*^9, 3.729004861713086*^9, 
   3.731953135823557*^9, 3.732017191772119*^9, 3.732018240935522*^9, 
   3.733292619034684*^9, 3.7332932336676493`*^9, 3.733293461005706*^9, 
   3.733315696487114*^9}],

Cell[BoxData[
 TemplateBox[{
  "Power","infy",
   "\"Infinite expression \\!\\(\\*FractionBox[\\\"1\\\", \\\"0.`\\\"]\\) \
encountered.\"",2,28,26,25913773499101206936,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.722871203742743*^9, 3.722871246365102*^9}, 
   3.722871828534135*^9, 3.725883676935253*^9, 3.725890975207891*^9, 
   3.725896417859623*^9, 3.7259888269528217`*^9, 3.727715631069846*^9, 
   3.727716132471698*^9, 3.7290043459731827`*^9, 3.729004861713086*^9, 
   3.731953135823557*^9, 3.732017191772119*^9, 3.732018240935522*^9, 
   3.733292619034684*^9, 3.7332932336676493`*^9, 3.733293461005706*^9, 
   3.733315696609757*^9}],

Cell[BoxData[
 TemplateBox[{
  "Power","infy",
   "\"Infinite expression \\!\\(\\*FractionBox[\\\"1\\\", \\\"0.`\\\"]\\) \
encountered.\"",2,28,27,25913773499101206936,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.722871203742743*^9, 3.722871246365102*^9}, 
   3.722871828534135*^9, 3.725883676935253*^9, 3.725890975207891*^9, 
   3.725896417859623*^9, 3.7259888269528217`*^9, 3.727715631069846*^9, 
   3.727716132471698*^9, 3.7290043459731827`*^9, 3.729004861713086*^9, 
   3.731953135823557*^9, 3.732017191772119*^9, 3.732018240935522*^9, 
   3.733292619034684*^9, 3.7332932336676493`*^9, 3.733293461005706*^9, 
   3.733315696690893*^9}],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"Power\\\", \\\"::\\\", \
\\\"infy\\\"}], \\\"MessageName\\\"]\\) will be suppressed during this \
calculation.\"",2,28,28,25913773499101206936,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.722871203742743*^9, 3.722871246365102*^9}, 
   3.722871828534135*^9, 3.725883676935253*^9, 3.725890975207891*^9, 
   3.725896417859623*^9, 3.7259888269528217`*^9, 3.727715631069846*^9, 
   3.727716132471698*^9, 3.7290043459731827`*^9, 3.729004861713086*^9, 
   3.731953135823557*^9, 3.732017191772119*^9, 3.732018240935522*^9, 
   3.733292619034684*^9, 3.7332932336676493`*^9, 3.733293461005706*^9, 
   3.733315696769052*^9}],

Cell[BoxData[
 TemplateBox[{
  "Infinity","indet",
   "\"Indeterminate expression \\!\\(\\*RowBox[{\\\"0.`\\\", \\\" \\\", \
\\\"ComplexInfinity\\\"}]\\) encountered.\"",2,28,29,25913773499101206936,
   "New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.722871203742743*^9, 3.722871246365102*^9}, 
   3.722871828534135*^9, 3.725883676935253*^9, 3.725890975207891*^9, 
   3.725896417859623*^9, 3.7259888269528217`*^9, 3.727715631069846*^9, 
   3.727716132471698*^9, 3.7290043459731827`*^9, 3.729004861713086*^9, 
   3.731953135823557*^9, 3.732017191772119*^9, 3.732018240935522*^9, 
   3.733292619034684*^9, 3.7332932336676493`*^9, 3.733293461005706*^9, 
   3.7333156969050083`*^9}],

Cell[BoxData[
 TemplateBox[{
  "Infinity","indet",
   "\"Indeterminate expression \\!\\(\\*RowBox[{\\\"0.`\\\", \\\" \\\", \
\\\"ComplexInfinity\\\"}]\\) encountered.\"",2,28,30,25913773499101206936,
   "New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.722871203742743*^9, 3.722871246365102*^9}, 
   3.722871828534135*^9, 3.725883676935253*^9, 3.725890975207891*^9, 
   3.725896417859623*^9, 3.7259888269528217`*^9, 3.727715631069846*^9, 
   3.727716132471698*^9, 3.7290043459731827`*^9, 3.729004861713086*^9, 
   3.731953135823557*^9, 3.732017191772119*^9, 3.732018240935522*^9, 
   3.733292619034684*^9, 3.7332932336676493`*^9, 3.733293461005706*^9, 
   3.733315697024159*^9}],

Cell[BoxData[
 TemplateBox[{
  "Infinity","indet",
   "\"Indeterminate expression \\!\\(\\*RowBox[{\\\"0.`\\\", \\\" \\\", \
\\\"ComplexInfinity\\\"}]\\) encountered.\"",2,28,31,25913773499101206936,
   "New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.722871203742743*^9, 3.722871246365102*^9}, 
   3.722871828534135*^9, 3.725883676935253*^9, 3.725890975207891*^9, 
   3.725896417859623*^9, 3.7259888269528217`*^9, 3.727715631069846*^9, 
   3.727716132471698*^9, 3.7290043459731827`*^9, 3.729004861713086*^9, 
   3.731953135823557*^9, 3.732017191772119*^9, 3.732018240935522*^9, 
   3.733292619034684*^9, 3.7332932336676493`*^9, 3.733293461005706*^9, 
   3.7333156971614237`*^9}],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"Infinity\\\", \
\\\"::\\\", \\\"indet\\\"}], \\\"MessageName\\\"]\\) will be suppressed \
during this calculation.\"",2,28,32,25913773499101206936,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.722871203742743*^9, 3.722871246365102*^9}, 
   3.722871828534135*^9, 3.725883676935253*^9, 3.725890975207891*^9, 
   3.725896417859623*^9, 3.7259888269528217`*^9, 3.727715631069846*^9, 
   3.727716132471698*^9, 3.7290043459731827`*^9, 3.729004861713086*^9, 
   3.731953135823557*^9, 3.732017191772119*^9, 3.732018240935522*^9, 
   3.733292619034684*^9, 3.7332932336676493`*^9, 3.733293461005706*^9, 
   3.733315697313774*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"function names: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\" sig(H0), 7 TeV\"\>", ",", "\<\" sig(H0), 8 TeV\"\>", 
     ",", "\<\" sig(H0), 14 TeV\"\>", ",", "\<\" s+(x,mu)\"\>", 
     ",", "\<\" u_val(x,mu)\"\>", ",", "\<\" d_val(x,mu)\"\>", 
     ",", "\<\" db/ub(x,mu)\"\>", ",", "\<\" d/u(x,mu)\"\>", 
     ",", "\<\" g/(ub+db+sb)(x,mu)\"\>", ",", "\<\" g(0.01,mH)\"\>"}], "}"}]}],
  SequenceForm[
  "function names: ", {
   " sig(H0), 7 TeV", " sig(H0), 8 TeV", " sig(H0), 14 TeV", " s+(x,mu)", 
    " u_val(x,mu)", " d_val(x,mu)", " db/ub(x,mu)", " d/u(x,mu)", 
    " g/(ub+db+sb)(x,mu)", " g(0.01,mH)"}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315697514914*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"total #flavours: \"\>", "\[InvisibleSpace]", "21"}],
  SequenceForm["total #flavours: ", 21],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315699020255*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315699043108*^9}],

Cell[BoxData["\<\"search broken points (0, ComplexInfinity, Indeterminate in \
any replica) for all points of f(x,Q), then set the values of broken points \
as 0\"\>"], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315699066968*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315699094046*^9}],

Cell[BoxData["\<\"The time for calculating statistical quantities used in \
plotting\"\>"], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315761807249*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"total number of correlation & sensitivity value calculations \
is \"\>", "\[InvisibleSpace]", "72324"}],
  SequenceForm[
  "total number of correlation & sensitivity value calculations is ", 72324],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315761835738*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"average time of one correlation + sensitivity value \
calculations is roughly \"\>", "\[InvisibleSpace]", 
   "0.00084782159449145511863312330860382713`8.239131905108586"}],
  SequenceForm[
  "average time of one correlation + sensitivity value calculations is \
roughly ", 0.00084782159449145511863312330860382713`8.239131905108586],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315761865757*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"time of calculating all observable data (correlation + \
sensitivity + ...)  values is \"\>", "\[InvisibleSpace]", 
   "61.317849`8.239131905108586"}],
  SequenceForm[
  "time of calculating all observable data (correlation + sensitivity + ...)  \
values is ", 61.317849`8.239131905108586],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315761895236*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315761923214*^9}],

Cell[BoxData["\<\"begin to calculate \\!\\(\\*SubscriptBox[\\(\[Sigma]\\), \
\\(i\\)]\\)/\\!\\(\\*SubscriptBox[\\(D\\), \\(i\\)]\\) from data, labels of \
indexes used for each experiment:\"\>"], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315761957588*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333157619882603`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "160", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[160, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315762017761*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "101", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[101, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315762047333*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "102", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[102, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315762076436*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "104", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[104, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333157621915827`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "108", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[108, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315762220303*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "109", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[109, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315762247924*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "110", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[110, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315762285262*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "111", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[111, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315762324395*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "124", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[124, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315762353553*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "125", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[125, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315762383009*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "126", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[126, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315762413823*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "127", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[127, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.73331576245238*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "147", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[147, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333157624981194`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "201", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[201, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333157625441227`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "203", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[203, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315762595038*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "204", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[204, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315762641796*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "225", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[225, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315762685094*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "227", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[227, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315762727415*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "234", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[234, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315762770697*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "260", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[260, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315762813695*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "261", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[261, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315762859741*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "145", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[145, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333157629095373`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "169", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[169, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315762959693*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "267", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[267, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333157630057592`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "268", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[268, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333157630489407`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "240", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[240, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333157630914383`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "241", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[241, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315763136891*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "281", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[281, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315763268056*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "266", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[266, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315763297628*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "247", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[247, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333157633270473`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "565", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[565, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315763420438*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "253", "\[InvisibleSpace]", "\<\": (\"\>", "\[InvisibleSpace]", "\<\"x\"\>",
    "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"Q\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", "\<\"TotErr\"\>", 
   "\[InvisibleSpace]", "\<\"/\"\>", "\[InvisibleSpace]", "\<\"Exp\"\>", 
   "\[InvisibleSpace]", "\<\" )\"\>"}],
  SequenceForm[253, ": (", "x", ", ", "Q", ", ", "TotErr", "/", "Exp", " )"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315763475956*^9}],

Cell[BoxData["\<\"data of final expts\"\>"], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315763525824*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"corrdataclass: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"32", ",", "21"}], "}"}], 
   "\[InvisibleSpace]", "\<\"dRcorrdataclass: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"32", ",", "21"}], "}"}], 
   "\[InvisibleSpace]", \
"\<\"{expterrordataclass,residualdataclass,dRdataclass}: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "32", "}"}]}], "}"}]}],
  SequenceForm[
  "corrdataclass: ", {32, 21}, "dRcorrdataclass: ", {32, 21}, 
   "{expterrordataclass,residualdataclass,dRdataclass}: ", {{32}, {32}, {32}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315763711842*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315763753447*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315763781123*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/expt_error_1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/expt_error_1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333157656949368`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", "3444", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315766445273*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {32}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315766482149*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315766507908*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/expt_error_1_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/expt_error_1_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315769283882*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333157701736307`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333157737959013`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "54"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 54}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315805109375*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {32}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.73331580513629*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315805162291*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_1_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_1_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315807937943*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333158334032288`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", "\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/dr_1.tsv\
\"\>"}],
  SequenceForm[
  "now writing file: ", "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/dr_1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333158369746857`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", "3444", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315837738463*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {32}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333158377666807`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315837793559*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/dr_1_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/dr_1_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333158405361958`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315842677719*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f-2.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f-2.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333158477113943`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333158727760363`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333158728265953`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315872877977*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv\"\
\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv"],
  
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733315916429677*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {3444, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316009398901*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2943", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {2943, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316009554295*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.73331600969672*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316036858634*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f-1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f-1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316051385839*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316075021509*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316075082095*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316075134501*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv\"\
\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv"],
  
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316075183967*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {3444, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316075211052*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2943", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {2943, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316075237753*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316075264271*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333160808382607`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f0.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f0.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316084809569*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333161024846373`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316102537714*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316102570635*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv\"\
\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv"],
  
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316102595921*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {3444, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316102621442*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2943", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {2943, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316102646996*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316102672069*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333161086963387`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333161128890753`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.73331613025194*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316130284964*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333161303456573`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv\"\
\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv"],
  
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316130396823*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {3444, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333161304493217`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2943", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {2943, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316130511086*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316130568915*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316135715466*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f2.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f2.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316139753373*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316157829837*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333161578668222`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316157895595*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv\"\
\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv"],
  
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.73331615792706*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {3444, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316157956098*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2943", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {2943, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316157986755*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333161580166597`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316163681542*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f3.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f3.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333161677706623`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316186252757*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316186329486*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316186383226*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv\"\
\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv"],
  
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333161864690933`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {3444, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333161865500317`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2943", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {2943, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316186836892*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316186937765*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316191821673*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f4.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f4.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316195996685*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333162145760593`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316214620278*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316214647031*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv\"\
\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv"],
  
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316214678276*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {3444, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316214737585*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2943", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {2943, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316214774392*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316214839904*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316221251828*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f5.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f5.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316225625929*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316244393825*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316244419518*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316244445362*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv\"\
\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv"],
  
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316244475521*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {3444, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333162445018997`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2943", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {2943, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333162445279293`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333162445538197`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316250069683*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f6.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f6.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.73331625439927*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316273584941*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316273614916*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316273644758*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv\"\
\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv"],
  
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316273674411*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {3444, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333162737032223`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2943", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {2943, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316273731175*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333162737596807`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.73331627959134*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f7.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f7.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316284034519*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316303178186*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333163032482233`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316303314941*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv\"\
\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv"],
  
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333163033776712`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {3444, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316303454904*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2943", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {2943, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316303499384*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316303644912*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316309576439*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f8.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f8.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316313990491*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333163334075327`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333163334600973`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.73331633349329*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv\"\
\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv"],
  
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316333568934*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {3444, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316333692382*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2943", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {2943, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333163337988462`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316334009691*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316339809148*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f9.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f9.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316344589745*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316366458548*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333163664983597`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316366536771*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv\"\
\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv"],
  
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316366589177*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {3444, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333163666550903`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2943", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {2943, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316366722952*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316366764686*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316373498988*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f10.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f10.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316378385107*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316400184101*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316400295794*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333164004173822`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv\"\
\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv"],
  
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316400531577*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {3444, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316400733329*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2943", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {2943, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316400770713*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316400834137*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316407687592*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f11.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f11.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316412458663*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316433372382*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316433403949*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316433430558*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv\"\
\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv"],
  
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316433457757*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {3444, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316433485662*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2943", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {2943, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316433513603*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316433543291*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333164401874523`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f12.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f12.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333164458901377`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316467556608*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333164676217613`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316467683284*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv\"\
\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv"],
  
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316467761943*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {3444, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316467846137*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2943", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {2943, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316468042899*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316468092943*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333164743922787`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f13.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f13.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316479376898*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.73331650276338*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316502867701*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333165029610167`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv\"\
\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv"],
  
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316503099579*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {3444, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316503362762*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2943", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {2943, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316503398539*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316503441556*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316509472455*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f14.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f14.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316514525104*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333165365223513`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.73331653657064*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316536600913*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv\"\
\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv"],
  
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333165366407413`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {3444, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333165366694717`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2943", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {2943, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316536697894*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316536739118*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316543814122*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f15.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corrdr_1_f15.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316549250095*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316572055477*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3444", ",", "54"}], "}"}]}],
  SequenceForm["dim: ", {3444, 54}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.73331657212325*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316572169496*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv\"\
\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/residual_all_norm_1_RawData.tsv"],
  
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316572254797*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {3444, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316572351942*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2943", ",", "54"}], "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {2943, 54}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333165725589113`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333165725901546`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316579575102*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f-2.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f-2.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333165848932257`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316607795505*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333166078729763`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316607922245*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333166159787073`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f-1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f-1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333166212963667`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316643947802*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316644011138*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316644074356*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.73331665130726*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f0.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f0.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316656522513*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316680844452*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316680885375*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316680925131*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316687595674*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333166930239477`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316718231167*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316718261922*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333167182926073`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316725584363*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f2.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f2.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316731304346*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316756207206*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333167562546663`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333167563071203`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316762742536*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f3.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f3.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333167684177*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316792139789*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316792168207*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316792197755*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333168000052834`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f4.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f4.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316805901527*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316831283846*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316831338982*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316831403034*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316838717374*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f5.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f5.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333168447544518`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316870986147*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316871067153*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316871094428*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333168780851803`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f6.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f6.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316883926916*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316909646693*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333169096746063`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316909702433*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316917697658*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f7.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f7.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333169238510113`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.73331694980873*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316949847329*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316949877968*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316957448374*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f8.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f8.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333169631700363`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333169907734423`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316990800441*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733316990827326*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333169987507563`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f9.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f9.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317005405917*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317033084903*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317033148313*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333170331809883`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317041012188*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f10.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f10.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317047006914*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317076098239*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317076166185*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333170762216187`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317083634458*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f11.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f11.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317090327166*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317119285819*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317119312326*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317119339052*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317127320546*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f12.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f12.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333171337347937`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317169078701*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333171691165648`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317169147599*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333171788694763`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f13.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f13.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317185498787*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333172157143393`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333172157747097`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317215830667*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333172239735737`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f14.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f14.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317231205617*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317269944109*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333172700341387`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333172701115427`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317279838203*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f15.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/corr_1_f15.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317288302463*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3445", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3444", ",", "27"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{3445, 6}, {3444, 27}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317323488509*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "32", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{32}, {}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333173235549088`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317323625452*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"The job is finished.All figures are in\"\>", 
   "\[InvisibleSpace]", "\<\"../plots/Jobs/CT14HERA2NNLONoJetall_tsv/\"\>"}],
  SequenceForm[
  "The job is finished.All figures are in", 
   "../plots/Jobs/CT14HERA2NNLONoJetall_tsv/"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.7333173313233128`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"total time to run is \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"1643.854359`", ",", "Null"}], "}"}], 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["total time to run is ", {1643.854359, Null}, " seconds"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.705641716973477*^9, {3.7066810155231953`*^9, 3.7066810268211517`*^9}, {
   3.706681087998925*^9, 3.706681117204805*^9}, 3.706718901759952*^9, 
   3.7067189615171843`*^9, 3.706719654451104*^9, 3.7067210090325527`*^9, {
   3.712425487131472*^9, 3.7124254875384007`*^9}, 3.712425679237727*^9, 
   3.713103093837731*^9, 3.7131077524630413`*^9, 3.713122132543722*^9, {
   3.718582018803974*^9, 3.7185820190749807`*^9}, 3.71858215727393*^9, 
   3.7185826773635187`*^9, 3.71858314451373*^9, 3.718583299840135*^9, {
   3.7185833518481693`*^9, 3.718583352952313*^9}, 3.7185834874469643`*^9, {
   3.718583977522849*^9, 3.71858399445778*^9}, 3.7185846413553534`*^9, 
   3.718584678275239*^9, {3.718584726088975*^9, 3.718584735538019*^9}, 
   3.718584853565544*^9, 3.718586691588801*^9, 3.718586732000256*^9, 
   3.7185868564361362`*^9, 3.718586899142942*^9, 3.718587033905143*^9, 
   3.718587097664572*^9, 3.718587271179943*^9, 3.718587427428846*^9, 
   3.718587471793132*^9, 3.718587592152619*^9, 3.718588826267419*^9, 
   3.718590404799026*^9, 3.718590512056129*^9, 3.718590593370265*^9, 
   3.718590682750617*^9, 3.718590879284062*^9, 3.718594595708943*^9, 
   3.718594760178735*^9, 3.718729153114052*^9, 3.718729383975026*^9, {
   3.7187680568894243`*^9, 3.718768082234054*^9}, 3.7187681197814283`*^9, 
   3.718768478860787*^9, 3.71876890608897*^9, {3.718808782865555*^9, 
   3.718808809891294*^9}, 3.719168620950762*^9, 3.719223552714665*^9, 
   3.7192238091978493`*^9, 3.719224090556876*^9, 3.7192244471519547`*^9, 
   3.71922471769869*^9, 3.719225161795362*^9, 3.719225479889759*^9, 
   3.719225651104065*^9, {3.7192257540486393`*^9, 3.719225773852426*^9}, 
   3.7192258275428534`*^9, 3.719225883747613*^9, 3.7192260147980967`*^9, 
   3.7192263462241707`*^9, 3.719226420690154*^9, 3.719226740121841*^9, 
   3.719226785627398*^9, 3.719226841966628*^9, 3.719230589885284*^9, {
   3.71973103720149*^9, 3.719731054311469*^9}, 3.719736239491105*^9, 
   3.7197367280750093`*^9, 3.719737043689108*^9, 3.719737272351984*^9, {
   3.719821233049357*^9, 3.7198212436599693`*^9}, {3.7198212753321877`*^9, 
   3.719821299924855*^9}, 3.719821446691802*^9, 3.71982150826369*^9, 
   3.719821711667348*^9, 3.719824654835642*^9, 3.719824867431961*^9, 
   3.719839914327566*^9, 3.7198415991578503`*^9, 3.719842063657852*^9, 
   3.720127307045537*^9, 3.7201276335005302`*^9, 3.720127690245071*^9, 
   3.720127924935685*^9, 3.720127965812646*^9, 3.72012808323481*^9, {
   3.7201281301081963`*^9, 3.720128159105509*^9}, 3.7201298884420147`*^9, 
   3.720129930701754*^9, 3.720130683260289*^9, 3.720130774026244*^9, 
   3.720130972166757*^9, 3.7201311888731823`*^9, 3.7201323033779182`*^9, 
   3.720132703030181*^9, 3.720134342879169*^9, 3.720134929269953*^9, 
   3.7201355077504797`*^9, 3.720135703633864*^9, 3.720138462064021*^9, 
   3.720138523786791*^9, 3.720144340805602*^9, 3.720144499874096*^9, 
   3.720144696686846*^9, {3.72014481114571*^9, 3.7201448316932383`*^9}, 
   3.720145504803864*^9, 3.72014679845291*^9, {3.7201471697951097`*^9, 
   3.7201471979691668`*^9}, 3.7201472714278173`*^9, 3.7201473213907433`*^9, 
   3.720147580024667*^9, 3.7201476887806*^9, 3.720147837026362*^9, 
   3.7201479728524857`*^9, 3.720148172134897*^9, 3.720148303445035*^9, 
   3.7201484759414883`*^9, 3.720148579350546*^9, 3.720188318539423*^9, 
   3.7201883601689034`*^9, 3.7201884566096163`*^9, 3.720190504703163*^9, 
   3.720190537505706*^9, {3.7204959294832373`*^9, 3.7204959383498173`*^9}, 
   3.720496955780155*^9, 3.720497163563643*^9, 3.720497228253377*^9, 
   3.720500848671658*^9, 3.720504204639629*^9, 3.7205044624109287`*^9, 
   3.720504960678718*^9, 3.7205052673852673`*^9, 3.7206282929285393`*^9, 
   3.720628373984622*^9, 3.720680304649989*^9, 3.7206806672325983`*^9, 
   3.72068077412641*^9, 3.7206810175241413`*^9, 3.7207136966822968`*^9, 
   3.720807328715253*^9, 3.7208075324778757`*^9, 3.7208075640828533`*^9, 
   3.720807926513534*^9, 3.720814154704399*^9, 3.720814662967558*^9, 
   3.720892628183921*^9, 3.7208927240189238`*^9, 3.720892778692464*^9, 
   3.7208934513450527`*^9, {3.721090660703964*^9, 3.721090660939762*^9}, 
   3.721090881287731*^9, 3.7210912841160803`*^9, 3.721096194311511*^9, 
   3.7210963958436413`*^9, 3.7211007963032913`*^9, 3.7211015804329767`*^9, 
   3.7211031490898123`*^9, 3.7211419139582777`*^9, 3.721181850980823*^9, 
   3.721240107313986*^9, 3.721282043485059*^9, 3.721282672823937*^9, 
   3.721284650985763*^9, 3.721286606280889*^9, 3.72128753316397*^9, 
   3.721862890038486*^9, 3.7218674043747997`*^9, 3.721868302711959*^9, 
   3.721868457818322*^9, 3.7218686231263323`*^9, 3.722188786395206*^9, 
   3.722189398735173*^9, 3.7221894796830378`*^9, 3.722190500193001*^9, 
   3.72219441945301*^9, 3.72219482652124*^9, 3.722195469753118*^9, 
   3.722196542607415*^9, 3.7224749859088*^9, 3.722476365786519*^9, 
   3.722484545410962*^9, 3.722485248541235*^9, 3.7224856731250668`*^9, 
   3.722489517275852*^9, 3.722489548358988*^9, {3.722871183508823*^9, 
   3.72287123926915*^9}, 3.722871821095745*^9, 3.7258836677233953`*^9, 
   3.725890967152112*^9, 3.725896408974031*^9, 3.725988817826098*^9, 
   3.727715622077557*^9, 3.7277161241638107`*^9, 3.729004336602708*^9, 
   3.729004853475699*^9, 3.731953126491243*^9, 3.732017182211685*^9, 
   3.732018226096036*^9, 3.733292609168376*^9, 3.733293225165059*^9, 
   3.7332934455461197`*^9, 3.733317331563686*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Others", "Section",
 CellChangeTimes->{{3.718582737703863*^9, 3.7185827386609793`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"residualNsetclass", "//", "Dimensions"}]], "Input",
 CellChangeTimes->{{3.7185833889884443`*^9, 3.718583392962083*^9}}],

Cell[BoxData[
 RowBox[{"{", "3", "}"}]], "Output",
 CellChangeTimes->{3.718583393753964*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"residualNsetclass", "//", "Dimensions"}], "\[IndentingNewLine]", 
 RowBox[{"FileExistsQ", "[", 
  RowBox[{"(", 
   RowBox[{
   "CorrDataDir", "<>", "\"\<residualNset_\>\"", "<>", "CorrDataFile"}], 
   ")"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"residualNsetclass", "=", 
  RowBox[{"Get", "[", 
   RowBox[{"(", 
    RowBox[{
    "CorrDataDir", "<>", "\"\<residualNset_\>\"", "<>", "CorrDataFile"}], 
    ")"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"residualNsetclass", "//", "Dimensions"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"residualNsetclass", "[", 
   RowBox[{"[", "1", "]"}], "]"}], "[", 
  RowBox[{"[", "\"\<label\>\"", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"filetmp", "=", 
  RowBox[{
  "CorrDataDir", "<>", "\"\<residualNset_\>\"", "<>", 
   "CorrDataFile"}]}], "\[IndentingNewLine]", 
 RowBox[{"Directory", "[", "]"}], "\[IndentingNewLine]", 
 RowBox[{"AbsoluteTiming", "[", 
  RowBox[{"tmpvariable", 
   RowBox[{"<<", "filetmp"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"tmpvariable", "//", "Dimensions"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmpvariable", "=", 
   RowBox[{"Get", "[", "filetmp", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"fxQsamept2class", "=", 
  RowBox[{"Get", "[", 
   RowBox[{"(", 
    RowBox[{"CorrDataDir", "<>", "\"\<fxQNset_\>\"", "<>", "CorrDataFile"}], 
    ")"}], "]"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.7185827012799788`*^9, 3.7185827015210867`*^9}, {
  3.718582745289925*^9, 3.718582751055685*^9}, {3.718582786587476*^9, 
  3.7185829808483553`*^9}, {3.718583021932905*^9, 3.7185830297002363`*^9}, {
  3.718583060313352*^9, 3.718583073029866*^9}, {3.7185832578160353`*^9, 
  3.7185832594974947`*^9}}],

Cell[BoxData[
 RowBox[{"{", "3", "}"}]], "Output",
 CellChangeTimes->{
  3.7185827517283163`*^9, {3.71858279450562*^9, 3.718582842971446*^9}, 
   3.718582874816217*^9, 3.718582906115293*^9, {3.7185829687128487`*^9, 
   3.718582981762981*^9}, 3.71858303297885*^9, 3.718583073986182*^9, 
   3.718583264339563*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.7185827517283163`*^9, {3.71858279450562*^9, 3.718582842971446*^9}, 
   3.718582874816217*^9, 3.718582906115293*^9, {3.7185829687128487`*^9, 
   3.718582981762981*^9}, 3.71858303297885*^9, 3.718583073986182*^9, 
   3.7185832643411503`*^9}],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   FrameBox[GridBox[{
      {
       ItemBox[
        TagBox[
         RowBox[{"{", 
          TemplateBox[{"1"},
           "OutputSizeLimit`Skeleton",
           DisplayFunction->(FrameBox[
             RowBox[{"\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
             Background -> GrayLevel[0.75], 
             BaseStyle -> {
              "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
               ShowStringCharacters -> False}, BaselinePosition -> Baseline, 
             ContentPadding -> False, FrameMargins -> {{1, 1}, {1, 2}}, 
             FrameStyle -> None, RoundingRadius -> 7]& )], "}"}],
         Short[#, 5]& ],
        BaseStyle->{Deployed -> False},
        StripOnInput->False]},
      {GridBox[{
         {
          TagBox[
           TooltipBox[
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource[
                "FEStrings", "sizeBriefExplanation"], StandardForm],
               ImageSizeCache->{74., {2., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarCategory",
             StripOnInput->False],
            StyleBox[
             DynamicBox[
              ToBoxes[
               FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
               StandardForm]], DynamicUpdating -> True, StripOnInput -> 
             False]],
           Annotation[#, 
            Style[
             Dynamic[
              FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"]], 
             DynamicUpdating -> True], "Tooltip"]& ], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{67., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{67., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 83, 25817366188515133254, 5/2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{73., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{73., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 83, 25817366188515133254, 5 2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{56., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{56., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 83, 25817366188515133254, Infinity],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{100., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{100., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           ButtonFunction:>FrontEndExecute[{
              FrontEnd`SetOptions[
              FrontEnd`$FrontEnd, 
               FrontEnd`PreferencesSettings -> {"Page" -> "Evaluation"}], 
              FrontEnd`FrontEndToken["PreferencesDialog"]}],
           Evaluator->None,
           Method->"Preemptive"]}
        },
        AutoDelete->False,
        FrameStyle->GrayLevel[0.85],
        GridBoxDividers->{"Columns" -> {False, {True}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
        GridBoxSpacings->{"Columns" -> {{2}}}]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], 
         Offset[1.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Background->RGBColor[0.9657, 0.9753, 0.9802],
    FrameMargins->{{12, 12}, {0, 15}},
    FrameStyle->GrayLevel[0.85],
    RoundingRadius->5,
    StripOnInput->False],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  Out[83]]], "Output",
 CellChangeTimes->{
  3.7185827517283163`*^9, {3.71858279450562*^9, 3.718582842971446*^9}, 
   3.718582874816217*^9, 3.718582906115293*^9, {3.7185829687128487`*^9, 
   3.718582981762981*^9}, 3.71858303297885*^9, 3.718583073986182*^9, 
   3.718583264579995*^9}],

Cell[BoxData[
 RowBox[{"{", "3", "}"}]], "Output",
 CellChangeTimes->{
  3.7185827517283163`*^9, {3.71858279450562*^9, 3.718582842971446*^9}, 
   3.718582874816217*^9, 3.718582906115293*^9, {3.7185829687128487`*^9, 
   3.718582981762981*^9}, 3.71858303297885*^9, 3.718583073986182*^9, 
   3.718583264581792*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"x\"\>", ",", "\<\"Q\"\>", ",", "\<\"1\"\>", ",", "\<\"2\"\>", 
   ",", "\<\"3\"\>", ",", "\<\"4\"\>", ",", "\<\"5\"\>", ",", "\<\"6\"\>", 
   ",", "\<\"7\"\>", ",", "\<\"8\"\>", ",", "\<\"9\"\>", ",", "\<\"10\"\>", 
   ",", "\<\"11\"\>", ",", "\<\"12\"\>", ",", "\<\"13\"\>", ",", "\<\"14\"\>",
    ",", "\<\"15\"\>", ",", "\<\"16\"\>", ",", "\<\"17\"\>", 
   ",", "\<\"18\"\>", ",", "\<\"19\"\>", ",", "\<\"20\"\>", ",", "\<\"21\"\>",
    ",", "\<\"22\"\>", ",", "\<\"23\"\>", ",", "\<\"24\"\>", 
   ",", "\<\"25\"\>", ",", "\<\"26\"\>", ",", "\<\"27\"\>", ",", "\<\"28\"\>",
    ",", "\<\"29\"\>", ",", "\<\"30\"\>", ",", "\<\"31\"\>", 
   ",", "\<\"32\"\>", ",", "\<\"33\"\>", ",", "\<\"34\"\>", ",", "\<\"35\"\>",
    ",", "\<\"36\"\>", ",", "\<\"37\"\>", ",", "\<\"38\"\>", 
   ",", "\<\"39\"\>", ",", "\<\"40\"\>", ",", "\<\"41\"\>", ",", "\<\"42\"\>",
    ",", "\<\"43\"\>", ",", "\<\"44\"\>", ",", "\<\"45\"\>", 
   ",", "\<\"46\"\>", ",", "\<\"47\"\>", ",", "\<\"48\"\>", ",", "\<\"49\"\>",
    ",", "\<\"50\"\>", ",", "\<\"51\"\>", ",", "\<\"52\"\>", 
   ",", "\<\"53\"\>", ",", "\<\"54\"\>", ",", "\<\"55\"\>", ",", "\<\"56\"\>",
    ",", "\<\"57\"\>"}], "}"}]], "Output",
 CellChangeTimes->{
  3.7185827517283163`*^9, {3.71858279450562*^9, 3.718582842971446*^9}, 
   3.718582874816217*^9, 3.718582906115293*^9, {3.7185829687128487`*^9, 
   3.718582981762981*^9}, 3.71858303297885*^9, 3.718583073986182*^9, 
   3.718583264584137*^9}],

Cell[BoxData["\<\"../quick_data/residualNset_samept_data_CT14HERA2NNLO.dat\"\>\
"], "Output",
 CellChangeTimes->{
  3.7185827517283163`*^9, {3.71858279450562*^9, 3.718582842971446*^9}, 
   3.718582874816217*^9, 3.718582906115293*^9, {3.7185829687128487`*^9, 
   3.718582981762981*^9}, 3.71858303297885*^9, 3.718583073986182*^9, 
   3.7185832645857162`*^9}],

Cell[BoxData["\<\"/home/botingw/code/pdf_correlation/code/math_corr_datasets/\
Run/mathscript_v24_eg/bin\"\>"], "Output",
 CellChangeTimes->{
  3.7185827517283163`*^9, {3.71858279450562*^9, 3.718582842971446*^9}, 
   3.718582874816217*^9, 3.718582906115293*^9, {3.7185829687128487`*^9, 
   3.718582981762981*^9}, 3.71858303297885*^9, 3.718583073986182*^9, 
   3.718583264587234*^9}],

Cell[BoxData[
 TemplateBox[{
  "Get","noopen",
   "\"Cannot open \\!\\(\\*RowBox[{\\\"\\\\\\\"filetmp\\\\\\\"\\\"}]\\).\"",2,
   88,31,25817366188515133254,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.718582968969265*^9, 3.718582982017915*^9}, 
   3.718583033237151*^9, 3.718583074231762*^9, 3.718583264594611*^9}],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   FrameBox[GridBox[{
      {
       ItemBox[
        TagBox[
         RowBox[{"{", 
          RowBox[{"0.003393`", ",", 
           RowBox[{"{", 
            TemplateBox[{"1"},
             "OutputSizeLimit`Skeleton",
             DisplayFunction->(FrameBox[
               
               RowBox[{
                "\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
               Background -> GrayLevel[0.75], 
               BaseStyle -> {
                "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                 ShowStringCharacters -> False}, BaselinePosition -> Baseline,
                ContentPadding -> False, FrameMargins -> {{1, 1}, {1, 2}}, 
               FrameStyle -> None, RoundingRadius -> 7]& )], "}"}]}], "}"}],
         Short[#, 5]& ],
        BaseStyle->{Deployed -> False},
        StripOnInput->False]},
      {GridBox[{
         {
          TagBox[
           TooltipBox[
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource[
                "FEStrings", "sizeBriefExplanation"], StandardForm],
               ImageSizeCache->{74., {2., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarCategory",
             StripOnInput->False],
            StyleBox[
             DynamicBox[
              ToBoxes[
               FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
               StandardForm]], DynamicUpdating -> True, StripOnInput -> 
             False]],
           Annotation[#, 
            Style[
             Dynamic[
              FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"]], 
             DynamicUpdating -> True], "Tooltip"]& ], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{67., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 88, 25817366188515133254, 5/2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{73., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 88, 25817366188515133254, 5 2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{56., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 88, 25817366188515133254, Infinity],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{100., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           ButtonFunction:>FrontEndExecute[{
              FrontEnd`SetOptions[
              FrontEnd`$FrontEnd, 
               FrontEnd`PreferencesSettings -> {"Page" -> "Evaluation"}], 
              FrontEnd`FrontEndToken["PreferencesDialog"]}],
           Evaluator->None,
           Method->"Preemptive"]}
        },
        AutoDelete->False,
        FrameStyle->GrayLevel[0.85],
        GridBoxDividers->{"Columns" -> {False, {True}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
        GridBoxSpacings->{"Columns" -> {{2}}}]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], 
         Offset[1.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Background->RGBColor[0.9657, 0.9753, 0.9802],
    FrameMargins->{{12, 12}, {0, 15}},
    FrameStyle->GrayLevel[0.85],
    RoundingRadius->5,
    StripOnInput->False],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  Out[88]]], "Output",
 CellChangeTimes->{
  3.7185827517283163`*^9, {3.71858279450562*^9, 3.718582842971446*^9}, 
   3.718582874816217*^9, 3.718582906115293*^9, {3.7185829687128487`*^9, 
   3.718582981762981*^9}, 3.71858303297885*^9, 3.718583073986182*^9, 
   3.718583264780093*^9}],

Cell[BoxData[
 RowBox[{"{", "3", "}"}]], "Output",
 CellChangeTimes->{
  3.7185827517283163`*^9, {3.71858279450562*^9, 3.718582842971446*^9}, 
   3.718582874816217*^9, 3.718582906115293*^9, {3.7185829687128487`*^9, 
   3.718582981762981*^9}, 3.71858303297885*^9, 3.718583073986182*^9, 
   3.718583264781581*^9}],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   FrameBox[GridBox[{
      {
       ItemBox[
        TagBox[
         RowBox[{"{", 
          TemplateBox[{"1"},
           "OutputSizeLimit`Skeleton",
           DisplayFunction->(FrameBox[
             RowBox[{"\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
             Background -> GrayLevel[0.75], 
             BaseStyle -> {
              "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
               ShowStringCharacters -> False}, BaselinePosition -> Baseline, 
             ContentPadding -> False, FrameMargins -> {{1, 1}, {1, 2}}, 
             FrameStyle -> None, RoundingRadius -> 7]& )], "}"}],
         Short[#, 5]& ],
        BaseStyle->{Deployed -> False},
        StripOnInput->False]},
      {GridBox[{
         {
          TagBox[
           TooltipBox[
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource[
                "FEStrings", "sizeBriefExplanation"], StandardForm],
               ImageSizeCache->{74., {2., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarCategory",
             StripOnInput->False],
            StyleBox[
             DynamicBox[
              ToBoxes[
               FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
               StandardForm]], DynamicUpdating -> True, StripOnInput -> 
             False]],
           Annotation[#, 
            Style[
             Dynamic[
              FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"]], 
             DynamicUpdating -> True], "Tooltip"]& ], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{67., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 90, 25817366188515133254, 5/2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{73., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 90, 25817366188515133254, 5 2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{56., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 90, 25817366188515133254, Infinity],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{100., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           ButtonFunction:>FrontEndExecute[{
              FrontEnd`SetOptions[
              FrontEnd`$FrontEnd, 
               FrontEnd`PreferencesSettings -> {"Page" -> "Evaluation"}], 
              FrontEnd`FrontEndToken["PreferencesDialog"]}],
           Evaluator->None,
           Method->"Preemptive"]}
        },
        AutoDelete->False,
        FrameStyle->GrayLevel[0.85],
        GridBoxDividers->{"Columns" -> {False, {True}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
        GridBoxSpacings->{"Columns" -> {{2}}}]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], 
         Offset[1.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Background->RGBColor[0.9657, 0.9753, 0.9802],
    FrameMargins->{{12, 12}, {0, 15}},
    FrameStyle->GrayLevel[0.85],
    RoundingRadius->5,
    StripOnInput->False],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  Out[90]]], "Output",
 CellChangeTimes->{
  3.7185827517283163`*^9, {3.71858279450562*^9, 3.718582842971446*^9}, 
   3.718582874816217*^9, 3.718582906115293*^9, {3.7185829687128487`*^9, 
   3.718582981762981*^9}, 3.71858303297885*^9, 3.718583073986182*^9, 
   3.7185832650257998`*^9}],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   FrameBox[GridBox[{
      {
       ItemBox[
        TagBox[
         RowBox[{"{", 
          TemplateBox[{"1"},
           "OutputSizeLimit`Skeleton",
           DisplayFunction->(FrameBox[
             RowBox[{"\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
             Background -> GrayLevel[0.75], 
             BaseStyle -> {
              "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
               ShowStringCharacters -> False}, BaselinePosition -> Baseline, 
             ContentPadding -> False, FrameMargins -> {{1, 1}, {1, 2}}, 
             FrameStyle -> None, RoundingRadius -> 7]& )], "}"}],
         Short[#, 5]& ],
        BaseStyle->{Deployed -> False},
        StripOnInput->False]},
      {GridBox[{
         {
          TagBox[
           TooltipBox[
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource[
                "FEStrings", "sizeBriefExplanation"], StandardForm],
               ImageSizeCache->{74., {2., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarCategory",
             StripOnInput->False],
            StyleBox[
             DynamicBox[
              ToBoxes[
               FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
               StandardForm]], DynamicUpdating -> True, StripOnInput -> 
             False]],
           Annotation[#, 
            Style[
             Dynamic[
              FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"]], 
             DynamicUpdating -> True], "Tooltip"]& ], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{67., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 91, 25817366188515133254, 5/2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{73., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 91, 25817366188515133254, 5 2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{56., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 91, 25817366188515133254, Infinity],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{100., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           ButtonFunction:>FrontEndExecute[{
              FrontEnd`SetOptions[
              FrontEnd`$FrontEnd, 
               FrontEnd`PreferencesSettings -> {"Page" -> "Evaluation"}], 
              FrontEnd`FrontEndToken["PreferencesDialog"]}],
           Evaluator->None,
           Method->"Preemptive"]}
        },
        AutoDelete->False,
        FrameStyle->GrayLevel[0.85],
        GridBoxDividers->{"Columns" -> {False, {True}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
        GridBoxSpacings->{"Columns" -> {{2}}}]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], 
         Offset[1.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Background->RGBColor[0.9657, 0.9753, 0.9802],
    FrameMargins->{{12, 12}, {0, 15}},
    FrameStyle->GrayLevel[0.85],
    RoundingRadius->5,
    StripOnInput->False],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  Out[91]]], "Output",
 CellChangeTimes->{
  3.7185827517283163`*^9, {3.71858279450562*^9, 3.718582842971446*^9}, 
   3.718582874816217*^9, 3.718582906115293*^9, {3.7185829687128487`*^9, 
   3.718582981762981*^9}, 3.71858303297885*^9, 3.718583073986182*^9, 
   3.718583268104512*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"expterrordataclass", "[", 
  RowBox[{"[", "1", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.713103218001856*^9, 3.713103229048256*^9}}],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"label\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\<\"x\"\>", ",", "\<\"Q\"\>", 
      ",", "\<\"expterror/exptcentral\"\>"}], "}"}]}], ",", 
   RowBox[{"\<\"data\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"LF", "[", 
       RowBox[{"0.101`", ",", "2.328`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "2.328`", ",", "0.101`", ",", "0.324`", ",", "0.107412`", ",", 
            "0.109768`", ",", "0.01322`", ",", "0.979`", ",", "0.12`", ",", 
            "0.032`", ",", 
            RowBox[{"-", "0.0001853`"}], ",", "0.1076`", ",", "0.01322`", ",",
             "0.03`", ",", "0", ",", "0.101`", ",", "2.328`", ",", 
            "0.1639939485627839`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "2.328`", ",", "0.101`", ",", "0.324`", ",", "0.107412`", ",", 
            "0.109768`", ",", "0.01322`", ",", "0.979`", ",", "0.12`", ",", 
            "0.032`", ",", 
            RowBox[{"-", "0.0001853`"}], ",", "0.1076`", ",", "0.01322`", ",",
             "0.03`", ",", "0", ",", "0.101`", ",", "2.328`", ",", 
            "0.1639939485627839`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpIndex", "\[RightDoubleBracket]"}]]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.167`", ",", "2.994`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "2.994`", ",", "0.167`", ",", "0.324`", ",", "0.0827406`", ",", 
            "0.0804053`", ",", "0.009422`", ",", "1.029`", ",", "0.117`", ",", 
            RowBox[{"-", "0.061`"}], ",", 
            RowBox[{"-", "0.0001357`"}], ",", "0.08288`", ",", "0.009422`", 
            ",", 
            RowBox[{"-", "0.07`"}], ",", "0", ",", "0.167`", ",", "2.994`", 
            ",", 
            RowBox[{"-", "0.2626512417745698`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "2.994`", ",", "0.167`", ",", "0.324`", ",", "0.0827406`", ",", 
            "0.0804053`", ",", "0.009422`", ",", "1.029`", ",", "0.117`", ",", 
            RowBox[{"-", "0.061`"}], ",", 
            RowBox[{"-", "0.0001357`"}], ",", "0.08288`", ",", "0.009422`", 
            ",", 
            RowBox[{"-", "0.07`"}], ",", "0", ",", "0.167`", ",", "2.994`", 
            ",", 
            RowBox[{"-", "0.2626512417745698`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpIndex", "\[RightDoubleBracket]"}]]}], 
       "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.326`", ",", "4.182`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "4.182`", ",", "0.326`", ",", "0.324`", ",", "0.0373734`", ",", 
            "0.0376151`", ",", "0.004629`", ",", "0.994`", ",", "0.123`", ",",
             "0.003`", ",", 
            RowBox[{"-", "0.00006349`"}], ",", "0.03744`", ",", "0.004629`", 
            ",", "0.`", ",", "0", ",", "0.326`", ",", "4.182`", ",", 
            "0.03782674443724292`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "4.182`", ",", "0.326`", ",", "0.324`", ",", "0.0373734`", ",", 
            "0.0376151`", ",", "0.004629`", ",", "0.994`", ",", "0.123`", ",",
             "0.003`", ",", 
            RowBox[{"-", "0.00006349`"}], ",", "0.03744`", ",", "0.004629`", 
            ",", "0.`", ",", "0", ",", "0.326`", ",", "4.182`", ",", 
            "0.03782674443724292`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpIndex", "\[RightDoubleBracket]"}]]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.057`", ",", "2.295`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "2.295`", ",", "0.057`", ",", "0.558`", ",", "0.138091`", ",", 
            "0.142289`", ",", "0.01381`", ",", "0.971`", ",", "0.097`", ",", 
            "0.092`", ",", 
            RowBox[{"-", "0.0002402`"}], ",", "0.1383`", ",", "0.01381`", ",",
             "0.08`", ",", "0", ",", "0.057`", ",", "2.295`", ",", 
            "0.2888486603910205`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "2.295`", ",", "0.057`", ",", "0.558`", ",", "0.138091`", ",", 
            "0.142289`", ",", "0.01381`", ",", "0.971`", ",", "0.097`", ",", 
            "0.092`", ",", 
            RowBox[{"-", "0.0002402`"}], ",", "0.1383`", ",", "0.01381`", ",",
             "0.08`", ",", "0", ",", "0.057`", ",", "2.295`", ",", 
            "0.2888486603910205`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpIndex", "\[RightDoubleBracket]"}]]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.101`", ",", "3.055`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "3.055`", ",", "0.101`", ",", "0.558`", ",", "0.129145`", ",", 
            "0.114851`", ",", "0.01291`", ",", "1.124`", ",", "0.112`", ",", 
            RowBox[{"-", "1.226`"}], ",", 
            RowBox[{"-", "0.0001939`"}], ",", "0.1293`", ",", "0.01291`", ",", 
            RowBox[{"-", "1.26`"}], ",", "0", ",", "0.101`", ",", "3.055`", 
            ",", 
            RowBox[{"-", "1.119209914794733`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "3.055`", ",", "0.101`", ",", "0.558`", ",", "0.129145`", ",", 
            "0.114851`", ",", "0.01291`", ",", "1.124`", ",", "0.112`", ",", 
            RowBox[{"-", "1.226`"}], ",", 
            RowBox[{"-", "0.0001939`"}], ",", "0.1293`", ",", "0.01291`", ",", 
            RowBox[{"-", "1.26`"}], ",", "0", ",", "0.101`", ",", "3.055`", 
            ",", 
            RowBox[{"-", "1.119209914794733`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpIndex", "\[RightDoubleBracket]"}]]}], 
       "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.167`", ",", "3.928`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "3.928`", ",", "0.167`", ",", "0.558`", ",", "0.0821926`", ",", 
            "0.0824972`", ",", "0.008227`", ",", "0.996`", ",", "0.1`", ",", 
            "0.001`", ",", 
            RowBox[{"-", "0.0001392`"}], ",", "0.08233`", ",", "0.008227`", 
            ",", "0.`", ",", "0", ",", "0.167`", ",", "3.928`", ",", 
            "0.020323325635104684`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "3.928`", ",", "0.167`", ",", "0.558`", ",", "0.0821926`", ",", 
            "0.0824972`", ",", "0.008227`", ",", "0.996`", ",", "0.1`", ",", 
            "0.001`", ",", 
            RowBox[{"-", "0.0001392`"}], ",", "0.08233`", ",", "0.008227`", 
            ",", "0.`", ",", "0", ",", "0.167`", ",", "3.928`", ",", 
            "0.020323325635104684`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpIndex", "\[RightDoubleBracket]"}]]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.326`", ",", "5.489`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "5.489`", ",", "0.326`", ",", "0.558`", ",", "0.0385662`", ",", 
            "0.0376445`", ",", "0.004266`", ",", "1.024`", ",", "0.113`", ",", 
            RowBox[{"-", "0.047`"}], ",", 
            RowBox[{"-", "0.00006354`"}], ",", "0.03863`", ",", "0.004266`", 
            ",", 
            RowBox[{"-", "0.05`"}], ",", "0", ",", "0.326`", ",", "5.489`", 
            ",", 
            RowBox[{"-", "0.2310126582278482`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "5.489`", ",", "0.326`", ",", "0.558`", ",", "0.0385662`", ",", 
            "0.0376445`", ",", "0.004266`", ",", "1.024`", ",", "0.113`", ",", 
            RowBox[{"-", "0.047`"}], ",", 
            RowBox[{"-", "0.00006354`"}], ",", "0.03863`", ",", "0.004266`", 
            ",", 
            RowBox[{"-", "0.05`"}], ",", "0", ",", "0.326`", ",", "5.489`", 
            ",", 
            RowBox[{"-", "0.2310126582278482`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpIndex", "\[RightDoubleBracket]"}]]}], 
       "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.057`", ",", "2.698`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "2.698`", ",", "0.057`", ",", "0.771`", ",", "0.134378`", ",", 
            "0.142103`", ",", "0.01297`", ",", "0.946`", ",", "0.091`", ",", 
            "0.355`", ",", 
            RowBox[{"-", "0.0002398`"}], ",", "0.1346`", ",", "0.01297`", ",",
             "0.33`", ",", "0", ",", "0.057`", ",", "2.698`", ",", 
            "0.5784888203546653`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "2.698`", ",", "0.057`", ",", "0.771`", ",", "0.134378`", ",", 
            "0.142103`", ",", "0.01297`", ",", "0.946`", ",", "0.091`", ",", 
            "0.355`", ",", 
            RowBox[{"-", "0.0002398`"}], ",", "0.1346`", ",", "0.01297`", ",",
             "0.33`", ",", "0", ",", "0.057`", ",", "2.698`", ",", 
            "0.5784888203546653`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpIndex", "\[RightDoubleBracket]"}]]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.101`", ",", "3.592`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "3.592`", ",", "0.101`", ",", "0.771`", ",", "0.12174`", ",", 
            "0.114716`", ",", "0.01295`", ",", "1.061`", ",", "0.113`", ",", 
            RowBox[{"-", "0.294`"}], ",", 
            RowBox[{"-", "0.0001936`"}], ",", "0.1219`", ",", "0.01295`", ",", 
            RowBox[{"-", "0.31`"}], ",", "0", ",", "0.101`", ",", "3.592`", 
            ",", 
            RowBox[{"-", "0.5547490347490344`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "3.592`", ",", "0.101`", ",", "0.771`", ",", "0.12174`", ",", 
            "0.114716`", ",", "0.01295`", ",", "1.061`", ",", "0.113`", ",", 
            RowBox[{"-", "0.294`"}], ",", 
            RowBox[{"-", "0.0001936`"}], ",", "0.1219`", ",", "0.01295`", ",", 
            RowBox[{"-", "0.31`"}], ",", "0", ",", "0.101`", ",", "3.592`", 
            ",", 
            RowBox[{"-", "0.5547490347490344`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpIndex", "\[RightDoubleBracket]"}]]}], 
       "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.167`", ",", "4.618`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "4.618`", ",", "0.167`", ",", "0.771`", ",", "0.0971157`", ",", 
            "0.082014`", ",", "0.01152`", ",", "1.184`", ",", "0.14`", ",", 
            RowBox[{"-", "1.718`"}], ",", 
            RowBox[{"-", "0.0001384`"}], ",", "0.09725`", ",", "0.01152`", 
            ",", 
            RowBox[{"-", "1.75`"}], ",", "0", ",", "0.167`", ",", "4.618`", 
            ",", 
            RowBox[{"-", "1.3225694444444445`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "4.618`", ",", "0.167`", ",", "0.771`", ",", "0.0971157`", ",", 
            "0.082014`", ",", "0.01152`", ",", "1.184`", ",", "0.14`", ",", 
            RowBox[{"-", "1.718`"}], ",", 
            RowBox[{"-", "0.0001384`"}], ",", "0.09725`", ",", "0.01152`", 
            ",", 
            RowBox[{"-", "1.75`"}], ",", "0", ",", "0.167`", ",", "4.618`", 
            ",", 
            RowBox[{"-", "1.3225694444444445`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpIndex", "\[RightDoubleBracket]"}]]}], 
       "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.326`", ",", "6.452`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "6.452`", ",", "0.326`", ",", "0.771`", ",", "0.0317358`", ",", 
            "0.03714`", ",", "0.004135`", ",", "0.854`", ",", "0.111`", ",", 
            "1.708`", ",", 
            RowBox[{"-", "0.00006269`"}], ",", "0.0318`", ",", "0.004135`", 
            ",", "1.67`", ",", "0", ",", "0.326`", ",", "6.452`", ",", 
            "1.2914147521160817`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "6.452`", ",", "0.326`", ",", "0.771`", ",", "0.0317358`", ",", 
            "0.03714`", ",", "0.004135`", ",", "0.854`", ",", "0.111`", ",", 
            "1.708`", ",", 
            RowBox[{"-", "0.00006269`"}], ",", "0.0318`", ",", "0.004135`", 
            ",", "1.67`", ",", "0", ",", "0.326`", ",", "6.452`", ",", 
            "1.2914147521160817`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpIndex", "\[RightDoubleBracket]"}]]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.057`", ",", "2.457`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "2.457`", ",", "0.057`", ",", "0.324`", ",", "0.140098`", ",", 
            "0.167589`", ",", "0.01466`", ",", "0.836`", ",", "0.087`", ",", 
            "3.516`", ",", 
            RowBox[{"-", "0.0002829`"}], ",", "0.1404`", ",", "0.01466`", ",",
             "3.44`", ",", "0", ",", "0.057`", ",", "2.457`", ",", 
            "1.8546384720327413`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "2.457`", ",", "0.057`", ",", "0.324`", ",", "0.140098`", ",", 
            "0.167589`", ",", "0.01466`", ",", "0.836`", ",", "0.087`", ",", 
            "3.516`", ",", 
            RowBox[{"-", "0.0002829`"}], ",", "0.1404`", ",", "0.01466`", ",",
             "3.44`", ",", "0", ",", "0.057`", ",", "2.457`", ",", 
            "1.8546384720327413`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpIndex", "\[RightDoubleBracket]"}]]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.101`", ",", "3.271`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "3.271`", ",", "0.101`", ",", "0.324`", ",", "0.131837`", ",", 
            "0.127951`", ",", "0.01263`", ",", "1.03`", ",", "0.099`", ",", 
            RowBox[{"-", "0.095`"}], ",", 
            RowBox[{"-", "0.000216`"}], ",", "0.1321`", ",", "0.01263`", ",", 
            
            RowBox[{"-", "0.11`"}], ",", "0", ",", "0.101`", ",", "3.271`", 
            ",", 
            RowBox[{"-", "0.32850356294536703`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "3.271`", ",", "0.101`", ",", "0.324`", ",", "0.131837`", ",", 
            "0.127951`", ",", "0.01263`", ",", "1.03`", ",", "0.099`", ",", 
            RowBox[{"-", "0.095`"}], ",", 
            RowBox[{"-", "0.000216`"}], ",", "0.1321`", ",", "0.01263`", ",", 
            
            RowBox[{"-", "0.11`"}], ",", "0", ",", "0.101`", ",", "3.271`", 
            ",", 
            RowBox[{"-", "0.32850356294536703`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpIndex", "\[RightDoubleBracket]"}]]}], 
       "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.167`", ",", "4.206`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "4.206`", ",", "0.167`", ",", "0.324`", ",", "0.0866541`", ",", 
            "0.0882022`", ",", "0.008575`", ",", "0.982`", ",", "0.097`", ",",
             "0.033`", ",", 
            RowBox[{"-", "0.0001489`"}], ",", "0.0868`", ",", "0.008575`", 
            ",", "0.03`", ",", "0", ",", "0.167`", ",", "4.206`", ",", 
            "0.16352186588921194`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "4.206`", ",", "0.167`", ",", "0.324`", ",", "0.0866541`", ",", 
            "0.0882022`", ",", "0.008575`", ",", "0.982`", ",", "0.097`", ",",
             "0.033`", ",", 
            RowBox[{"-", "0.0001489`"}], ",", "0.0868`", ",", "0.008575`", 
            ",", "0.03`", ",", "0", ",", "0.167`", ",", "4.206`", ",", 
            "0.16352186588921194`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpIndex", "\[RightDoubleBracket]"}]]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.326`", ",", "5.877`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "5.877`", ",", "0.326`", ",", "0.324`", ",", "0.0403706`", ",", 
            "0.038528`", ",", "0.004327`", ",", "1.048`", ",", "0.112`", ",", 
            
            RowBox[{"-", "0.181`"}], ",", 
            RowBox[{"-", "0.00006503`"}], ",", "0.04044`", ",", "0.004327`", 
            ",", 
            RowBox[{"-", "0.19`"}], ",", "0", ",", "0.326`", ",", "5.877`", 
            ",", 
            RowBox[{"-", "0.44187658886064174`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "5.877`", ",", "0.326`", ",", "0.324`", ",", "0.0403706`", ",", 
            "0.038528`", ",", "0.004327`", ",", "1.048`", ",", "0.112`", ",", 
            
            RowBox[{"-", "0.181`"}], ",", 
            RowBox[{"-", "0.00006503`"}], ",", "0.04044`", ",", "0.004327`", 
            ",", 
            RowBox[{"-", "0.19`"}], ",", "0", ",", "0.326`", ",", "5.877`", 
            ",", 
            RowBox[{"-", "0.44187658886064174`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpIndex", "\[RightDoubleBracket]"}]]}], 
       "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.057`", ",", "3.225`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "3.225`", ",", "0.057`", ",", "0.558`", ",", "0.178635`", ",", 
            "0.173132`", ",", "0.01756`", ",", "1.032`", ",", "0.101`", ",", 
            RowBox[{"-", "0.098`"}], ",", 
            RowBox[{"-", "0.0002922`"}], ",", "0.1789`", ",", "0.01756`", ",", 
            RowBox[{"-", "0.11`"}], ",", "0", ",", "0.057`", ",", "3.225`", 
            ",", 
            RowBox[{"-", "0.32847380410022753`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "3.225`", ",", "0.057`", ",", "0.558`", ",", "0.178635`", ",", 
            "0.173132`", ",", "0.01756`", ",", "1.032`", ",", "0.101`", ",", 
            RowBox[{"-", "0.098`"}], ",", 
            RowBox[{"-", "0.0002922`"}], ",", "0.1789`", ",", "0.01756`", ",", 
            RowBox[{"-", "0.11`"}], ",", "0", ",", "0.057`", ",", "3.225`", 
            ",", 
            RowBox[{"-", "0.32847380410022753`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpIndex", "\[RightDoubleBracket]"}]]}], 
       "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.101`", ",", "4.293`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "4.293`", ",", "0.101`", ",", "0.558`", ",", "0.15107`", ",", 
            "0.129894`", ",", "0.01525`", ",", "1.163`", ",", "0.117`", ",", 
            RowBox[{"-", "1.928`"}], ",", 
            RowBox[{"-", "0.0002192`"}], ",", "0.1513`", ",", "0.01525`", ",", 
            RowBox[{"-", "1.97`"}], ",", "0", ",", "0.101`", ",", "4.293`", 
            ",", 
            RowBox[{"-", "1.4036721311475395`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "4.293`", ",", "0.101`", ",", "0.558`", ",", "0.15107`", ",", 
            "0.129894`", ",", "0.01525`", ",", "1.163`", ",", "0.117`", ",", 
            RowBox[{"-", "1.928`"}], ",", 
            RowBox[{"-", "0.0002192`"}], ",", "0.1513`", ",", "0.01525`", ",", 
            RowBox[{"-", "1.97`"}], ",", "0", ",", "0.101`", ",", "4.293`", 
            ",", 
            RowBox[{"-", "1.4036721311475395`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpIndex", "\[RightDoubleBracket]"}]]}], 
       "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.167`", ",", "5.52`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "5.52`", ",", "0.167`", ",", "0.558`", ",", "0.0957695`", ",", 
            "0.0878361`", ",", "0.009852`", ",", "1.09`", ",", "0.112`", ",", 
            
            RowBox[{"-", "0.648`"}], ",", 
            RowBox[{"-", "0.0001483`"}], ",", "0.09592`", ",", "0.009852`", 
            ",", 
            RowBox[{"-", "0.67`"}], ",", "0", ",", "0.167`", ",", "5.52`", 
            ",", 
            RowBox[{"-", "0.820533901745839`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "5.52`", ",", "0.167`", ",", "0.558`", ",", "0.0957695`", ",", 
            "0.0878361`", ",", "0.009852`", ",", "1.09`", ",", "0.112`", ",", 
            
            RowBox[{"-", "0.648`"}], ",", 
            RowBox[{"-", "0.0001483`"}], ",", "0.09592`", ",", "0.009852`", 
            ",", 
            RowBox[{"-", "0.67`"}], ",", "0", ",", "0.167`", ",", "5.52`", 
            ",", 
            RowBox[{"-", "0.820533901745839`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpIndex", "\[RightDoubleBracket]"}]]}], 
       "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.326`", ",", "7.712`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "7.712`", ",", "0.326`", ",", "0.558`", ",", "0.036935`", ",", 
            "0.0375991`", ",", "0.004393`", ",", "0.982`", ",", "0.117`", ",",
             "0.023`", ",", 
            RowBox[{"-", "0.00006346`"}], ",", "0.037`", ",", "0.004393`", 
            ",", "0.02`", ",", "0", ",", "0.326`", ",", "7.712`", ",", 
            "0.13637605281129186`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "7.712`", ",", "0.326`", ",", "0.558`", ",", "0.036935`", ",", 
            "0.0375991`", ",", "0.004393`", ",", "0.982`", ",", "0.117`", ",",
             "0.023`", ",", 
            RowBox[{"-", "0.00006346`"}], ",", "0.037`", ",", "0.004393`", 
            ",", "0.02`", ",", "0", ",", "0.326`", ",", "7.712`", ",", 
            "0.13637605281129186`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpIndex", "\[RightDoubleBracket]"}]]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.021`", ",", "2.301`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "2.301`", ",", "0.021`", ",", "0.771`", ",", "0.208861`", ",", 
            "0.201174`", ",", "0.0199`", ",", "1.038`", ",", "0.099`", ",", 
            RowBox[{"-", "0.149`"}], ",", 
            RowBox[{"-", "0.0003395`"}], ",", "0.2092`", ",", "0.0199`", ",", 
            
            RowBox[{"-", "0.16`"}], ",", "0", ",", "0.021`", ",", "2.301`", 
            ",", 
            RowBox[{"-", "0.4033165829145731`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "2.301`", ",", "0.021`", ",", "0.771`", ",", "0.208861`", ",", 
            "0.201174`", ",", "0.0199`", ",", "1.038`", ",", "0.099`", ",", 
            RowBox[{"-", "0.149`"}], ",", 
            RowBox[{"-", "0.0003395`"}], ",", "0.2092`", ",", "0.0199`", ",", 
            
            RowBox[{"-", "0.16`"}], ",", "0", ",", "0.021`", ",", "2.301`", 
            ",", 
            RowBox[{"-", "0.4033165829145731`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpIndex", "\[RightDoubleBracket]"}]]}], 
       "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.057`", ",", "3.791`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "3.791`", ",", "0.057`", ",", "0.771`", ",", "0.151439`", ",", 
            "0.170563`", ",", "0.01368`", ",", "0.888`", ",", "0.08`", ",", 
            "1.954`", ",", 
            RowBox[{"-", "0.0002879`"}], ",", "0.1517`", ",", "0.01368`", ",",
             "1.9`", ",", "0", ",", "0.057`", ",", "3.791`", ",", 
            "1.3788742690058473`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "3.791`", ",", "0.057`", ",", "0.771`", ",", "0.151439`", ",", 
            "0.170563`", ",", "0.01368`", ",", "0.888`", ",", "0.08`", ",", 
            "1.954`", ",", 
            RowBox[{"-", "0.0002879`"}], ",", "0.1517`", ",", "0.01368`", ",",
             "1.9`", ",", "0", ",", "0.057`", ",", "3.791`", ",", 
            "1.3788742690058473`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpIndex", "\[RightDoubleBracket]"}]]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.101`", ",", "5.046`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "5.046`", ",", "0.101`", ",", "0.771`", ",", "0.125491`", ",", 
            "0.127914`", ",", "0.01261`", ",", "0.981`", ",", "0.099`", ",", 
            "0.037`", ",", 
            RowBox[{"-", "0.0002159`"}], ",", "0.1257`", ",", "0.01261`", ",",
             "0.03`", ",", "0", ",", "0.101`", ",", "5.046`", ",", 
            "0.17557494052339365`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "5.046`", ",", "0.101`", ",", "0.771`", ",", "0.125491`", ",", 
            "0.127914`", ",", "0.01261`", ",", "0.981`", ",", "0.099`", ",", 
            "0.037`", ",", 
            RowBox[{"-", "0.0002159`"}], ",", "0.1257`", ",", "0.01261`", ",",
             "0.03`", ",", "0", ",", "0.101`", ",", "5.046`", ",", 
            "0.17557494052339365`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpIndex", "\[RightDoubleBracket]"}]]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.167`", ",", "6.488`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "6.488`", ",", "0.167`", ",", "0.771`", ",", "0.0979811`", ",", 
            "0.086285`", ",", "0.01121`", ",", "1.136`", ",", "0.13`", ",", 
            RowBox[{"-", "1.089`"}], ",", 
            RowBox[{"-", "0.0001456`"}], ",", "0.09813`", ",", "0.01121`", 
            ",", 
            RowBox[{"-", "1.12`"}], ",", "0", ",", "0.167`", ",", "6.488`", 
            ",", 
            RowBox[{"-", "1.0566458519179298`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "6.488`", ",", "0.167`", ",", "0.771`", ",", "0.0979811`", ",", 
            "0.086285`", ",", "0.01121`", ",", "1.136`", ",", "0.13`", ",", 
            RowBox[{"-", "1.089`"}], ",", 
            RowBox[{"-", "0.0001456`"}], ",", "0.09813`", ",", "0.01121`", 
            ",", 
            RowBox[{"-", "1.12`"}], ",", "0", ",", "0.167`", ",", "6.488`", 
            ",", 
            RowBox[{"-", "1.0566458519179298`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpIndex", "\[RightDoubleBracket]"}]]}], 
       "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.326`", ",", "9.065`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "9.065`", ",", "0.326`", ",", "0.771`", ",", "0.03772`", ",", 
            "0.036732`", ",", "0.005012`", ",", "1.027`", ",", "0.136`", ",", 
            
            RowBox[{"-", "0.039`"}], ",", 
            RowBox[{"-", "0.000062`"}], ",", "0.03778`", ",", "0.005012`", 
            ",", 
            RowBox[{"-", "0.04`"}], ",", "0", ",", "0.326`", ",", "9.065`", 
            ",", 
            RowBox[{"-", "0.20909816440542706`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "9.065`", ",", "0.326`", ",", "0.771`", ",", "0.03772`", ",", 
            "0.036732`", ",", "0.005012`", ",", "1.027`", ",", "0.136`", ",", 
            
            RowBox[{"-", "0.039`"}], ",", 
            RowBox[{"-", "0.000062`"}], ",", "0.03778`", ",", "0.005012`", 
            ",", 
            RowBox[{"-", "0.04`"}], ",", "0", ",", "0.326`", ",", "9.065`", 
            ",", 
            RowBox[{"-", "0.20909816440542706`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpIndex", "\[RightDoubleBracket]"}]]}], 
       "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.057`", ",", "2.925`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "2.925`", ",", "0.057`", ",", "0.324`", ",", "0.202019`", ",", 
            "0.18382`", ",", "0.02183`", ",", "1.099`", ",", "0.119`", ",", 
            RowBox[{"-", "0.695`"}], ",", 
            RowBox[{"-", "0.0003103`"}], ",", "0.2023`", ",", "0.02183`", ",", 
            RowBox[{"-", "0.72`"}], ",", "0", ",", "0.057`", ",", "2.925`", 
            ",", 
            RowBox[{"-", "0.846541456710948`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "2.925`", ",", "0.057`", ",", "0.324`", ",", "0.202019`", ",", 
            "0.18382`", ",", "0.02183`", ",", "1.099`", ",", "0.119`", ",", 
            RowBox[{"-", "0.695`"}], ",", 
            RowBox[{"-", "0.0003103`"}], ",", "0.2023`", ",", "0.02183`", ",", 
            RowBox[{"-", "0.72`"}], ",", "0", ",", "0.057`", ",", "2.925`", 
            ",", 
            RowBox[{"-", "0.846541456710948`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpIndex", "\[RightDoubleBracket]"}]]}], 
       "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.101`", ",", "3.894`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "3.894`", ",", "0.101`", ",", "0.324`", ",", "0.13905`", ",", 
            "0.135621`", ",", "0.01429`", ",", "1.025`", ",", "0.105`", ",", 
            RowBox[{"-", "0.058`"}], ",", 
            RowBox[{"-", "0.0002289`"}], ",", "0.1393`", ",", "0.01429`", ",", 
            RowBox[{"-", "0.07`"}], ",", "0", ",", "0.101`", ",", "3.894`", 
            ",", 
            RowBox[{"-", "0.25745276417074986`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "3.894`", ",", "0.101`", ",", "0.324`", ",", "0.13905`", ",", 
            "0.135621`", ",", "0.01429`", ",", "1.025`", ",", "0.105`", ",", 
            RowBox[{"-", "0.058`"}], ",", 
            RowBox[{"-", "0.0002289`"}], ",", "0.1393`", ",", "0.01429`", ",", 
            RowBox[{"-", "0.07`"}], ",", "0", ",", "0.101`", ",", "3.894`", 
            ",", 
            RowBox[{"-", "0.25745276417074986`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpIndex", "\[RightDoubleBracket]"}]]}], 
       "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.167`", ",", "5.007`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "5.007`", ",", "0.167`", ",", "0.324`", ",", "0.101731`", ",", 
            "0.0908187`", ",", "0.01043`", ",", "1.12`", ",", "0.115`", ",", 
            RowBox[{"-", "1.095`"}], ",", 
            RowBox[{"-", "0.0001533`"}], ",", "0.1019`", ",", "0.01043`", ",", 
            RowBox[{"-", "1.13`"}], ",", "0", ",", "0.167`", ",", "5.007`", 
            ",", 
            RowBox[{"-", "1.0624448705656762`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "5.007`", ",", "0.167`", ",", "0.324`", ",", "0.101731`", ",", 
            "0.0908187`", ",", "0.01043`", ",", "1.12`", ",", "0.115`", ",", 
            RowBox[{"-", "1.095`"}], ",", 
            RowBox[{"-", "0.0001533`"}], ",", "0.1019`", ",", "0.01043`", ",", 
            RowBox[{"-", "1.13`"}], ",", "0", ",", "0.167`", ",", "5.007`", 
            ",", 
            RowBox[{"-", "1.0624448705656762`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpIndex", "\[RightDoubleBracket]"}]]}], 
       "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.326`", ",", "6.996`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "6.996`", ",", "0.326`", ",", "0.324`", ",", "0.0393817`", ",", 
            "0.0384638`", ",", "0.004563`", ",", "1.024`", ",", "0.119`", ",", 
            RowBox[{"-", "0.04`"}], ",", 
            RowBox[{"-", "0.00006492`"}], ",", "0.03945`", ",", "0.004563`", 
            ",", 
            RowBox[{"-", "0.05`"}], ",", "0", ",", "0.326`", ",", "6.996`", 
            ",", 
            RowBox[{"-", "0.21612973920666217`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "6.996`", ",", "0.326`", ",", "0.324`", ",", "0.0393817`", ",", 
            "0.0384638`", ",", "0.004563`", ",", "1.024`", ",", "0.119`", ",", 
            RowBox[{"-", "0.04`"}], ",", 
            RowBox[{"-", "0.00006492`"}], ",", "0.03945`", ",", "0.004563`", 
            ",", 
            RowBox[{"-", "0.05`"}], ",", "0", ",", "0.326`", ",", "6.996`", 
            ",", 
            RowBox[{"-", "0.21612973920666217`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpIndex", "\[RightDoubleBracket]"}]]}], 
       "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.021`", ",", "2.33`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "2.33`", ",", "0.021`", ",", "0.558`", ",", "0.228372`", ",", 
            "0.237381`", ",", "0.02686`", ",", "0.962`", ",", "0.113`", ",", 
            "0.113`", ",", 
            RowBox[{"-", "0.0004007`"}], ",", "0.2288`", ",", "0.02686`", ",",
             "0.1`", ",", "0", ",", "0.021`", ",", "2.33`", ",", 
            "0.31947133283693246`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "2.33`", ",", "0.021`", ",", "0.558`", ",", "0.228372`", ",", 
            "0.237381`", ",", "0.02686`", ",", "0.962`", ",", "0.113`", ",", 
            "0.113`", ",", 
            RowBox[{"-", "0.0004007`"}], ",", "0.2288`", ",", "0.02686`", ",",
             "0.1`", ",", "0", ",", "0.021`", ",", "2.33`", ",", 
            "0.31947133283693246`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpIndex", "\[RightDoubleBracket]"}]]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.057`", ",", "3.839`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "3.839`", ",", "0.057`", ",", "0.558`", ",", "0.190578`", ",", 
            "0.186796`", ",", "0.02207`", ",", "1.02`", ",", "0.118`", ",", 
            RowBox[{"-", "0.029`"}], ",", 
            RowBox[{"-", "0.0003153`"}], ",", "0.1909`", ",", "0.02207`", ",", 
            RowBox[{"-", "0.03`"}], ",", "0", ",", "0.057`", ",", "3.839`", 
            ",", 
            RowBox[{"-", "0.18595378341640223`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "3.839`", ",", "0.057`", ",", "0.558`", ",", "0.190578`", ",", 
            "0.186796`", ",", "0.02207`", ",", "1.02`", ",", "0.118`", ",", 
            RowBox[{"-", "0.029`"}], ",", 
            RowBox[{"-", "0.0003153`"}], ",", "0.1909`", ",", "0.02207`", ",", 
            RowBox[{"-", "0.03`"}], ",", "0", ",", "0.057`", ",", "3.839`", 
            ",", 
            RowBox[{"-", "0.18595378341640223`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpIndex", "\[RightDoubleBracket]"}]]}], 
       "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.101`", ",", "5.11`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "5.11`", ",", "0.101`", ",", "0.558`", ",", "0.131357`", ",", 
            "0.135675`", ",", "0.01474`", ",", "0.968`", ",", "0.109`", ",", 
            "0.086`", ",", 
            RowBox[{"-", "0.000229`"}], ",", "0.1316`", ",", "0.01474`", ",", 
            "0.08`", ",", "0", ",", "0.101`", ",", "5.11`", ",", 
            "0.2764586160108545`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "5.11`", ",", "0.101`", ",", "0.558`", ",", "0.131357`", ",", 
            "0.135675`", ",", "0.01474`", ",", "0.968`", ",", "0.109`", ",", 
            "0.086`", ",", 
            RowBox[{"-", "0.000229`"}], ",", "0.1316`", ",", "0.01474`", ",", 
            "0.08`", ",", "0", ",", "0.101`", ",", "5.11`", ",", 
            "0.2764586160108545`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpIndex", "\[RightDoubleBracket]"}]]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.167`", ",", "6.571`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "6.571`", ",", "0.167`", ",", "0.558`", ",", "0.084606`", ",", 
            "0.0894838`", ",", "0.00987`", ",", "0.945`", ",", "0.11`", ",", 
            "0.244`", ",", 
            RowBox[{"-", "0.000151`"}], ",", "0.08476`", ",", "0.00987`", ",",
             "0.23`", ",", "0", ",", "0.167`", ",", "6.571`", ",", 
            "0.4786018237082067`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "6.571`", ",", "0.167`", ",", "0.558`", ",", "0.084606`", ",", 
            "0.0894838`", ",", "0.00987`", ",", "0.945`", ",", "0.11`", ",", 
            "0.244`", ",", 
            RowBox[{"-", "0.000151`"}], ",", "0.08476`", ",", "0.00987`", ",",
             "0.23`", ",", "0", ",", "0.167`", ",", "6.571`", ",", 
            "0.4786018237082067`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpIndex", "\[RightDoubleBracket]"}]]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.326`", ",", "9.181`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "9.181`", ",", "0.326`", ",", "0.558`", ",", "0.0384336`", ",", 
            "0.037221`", ",", "0.005036`", ",", "1.033`", ",", "0.135`", ",", 
            
            RowBox[{"-", "0.058`"}], ",", 
            RowBox[{"-", "0.00006282`"}], ",", "0.0385`", ",", "0.005036`", 
            ",", 
            RowBox[{"-", "0.06`"}], ",", "0", ",", "0.326`", ",", "9.181`", 
            ",", 
            RowBox[{"-", "0.2539714058776812`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "9.181`", ",", "0.326`", ",", "0.558`", ",", "0.0384336`", ",", 
            "0.037221`", ",", "0.005036`", ",", "1.033`", ",", "0.135`", ",", 
            
            RowBox[{"-", "0.058`"}], ",", 
            RowBox[{"-", "0.00006282`"}], ",", "0.0385`", ",", "0.005036`", 
            ",", 
            RowBox[{"-", "0.06`"}], ",", "0", ",", "0.326`", ",", "9.181`", 
            ",", 
            RowBox[{"-", "0.2539714058776812`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpIndex", "\[RightDoubleBracket]"}]]}], 
       "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.021`", ",", "2.739`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "2.739`", ",", "0.021`", ",", "0.771`", ",", "0.218222`", ",", 
            "0.231083`", ",", "0.02599`", ",", "0.944`", ",", "0.112`", ",", 
            "0.245`", ",", 
            RowBox[{"-", "0.00039`"}], ",", "0.2186`", ",", "0.02599`", ",", 
            "0.23`", ",", "0", ",", "0.021`", ",", "2.739`", ",", 
            "0.48030011542901196`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "2.739`", ",", "0.021`", ",", "0.771`", ",", "0.218222`", ",", 
            "0.231083`", ",", "0.02599`", ",", "0.944`", ",", "0.112`", ",", 
            "0.245`", ",", 
            RowBox[{"-", "0.00039`"}], ",", "0.2186`", ",", "0.02599`", ",", 
            "0.23`", ",", "0", ",", "0.021`", ",", "2.739`", ",", 
            "0.48030011542901196`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpIndex", "\[RightDoubleBracket]"}]]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.057`", ",", "4.512`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "4.512`", ",", "0.057`", ",", "0.771`", ",", "0.161976`", ",", 
            "0.182943`", ",", "0.01672`", ",", "0.885`", ",", "0.091`", ",", 
            "1.572`", ",", 
            RowBox[{"-", "0.0003088`"}], ",", "0.1623`", ",", "0.01672`", ",",
             "1.53`", ",", "0", ",", "0.057`", ",", "4.512`", ",", 
            "1.2346291866028705`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "4.512`", ",", "0.057`", ",", "0.771`", ",", "0.161976`", ",", 
            "0.182943`", ",", "0.01672`", ",", "0.885`", ",", "0.091`", ",", 
            "1.572`", ",", 
            RowBox[{"-", "0.0003088`"}], ",", "0.1623`", ",", "0.01672`", ",",
             "1.53`", ",", "0", ",", "0.057`", ",", "4.512`", ",", 
            "1.2346291866028705`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpIndex", "\[RightDoubleBracket]"}]]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.101`", ",", "6.007`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "6.007`", ",", "0.101`", ",", "0.771`", ",", "0.122702`", ",", 
            "0.132738`", ",", "0.01256`", ",", "0.924`", ",", "0.095`", ",", 
            "0.638`", ",", 
            RowBox[{"-", "0.000224`"}], ",", "0.1229`", ",", "0.01256`", ",", 
            "0.61`", ",", "0", ",", "0.101`", ",", "6.007`", ",", 
            "0.7832802547770701`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "6.007`", ",", "0.101`", ",", "0.771`", ",", "0.122702`", ",", 
            "0.132738`", ",", "0.01256`", ",", "0.924`", ",", "0.095`", ",", 
            "0.638`", ",", 
            RowBox[{"-", "0.000224`"}], ",", "0.1229`", ",", "0.01256`", ",", 
            "0.61`", ",", "0", ",", "0.101`", ",", "6.007`", ",", 
            "0.7832802547770701`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpIndex", "\[RightDoubleBracket]"}]]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.167`", ",", "7.724`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "7.724`", ",", "0.167`", ",", "0.771`", ",", "0.0987503`", ",", 
            "0.0875281`", ",", "0.01285`", ",", "1.128`", ",", "0.147`", ",", 
            
            RowBox[{"-", "0.763`"}], ",", 
            RowBox[{"-", "0.0001477`"}], ",", "0.0989`", ",", "0.01285`", ",", 
            RowBox[{"-", "0.78`"}], ",", "0", ",", "0.167`", ",", "7.724`", 
            ",", 
            RowBox[{"-", "0.8849727626459146`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "7.724`", ",", "0.167`", ",", "0.771`", ",", "0.0987503`", ",", 
            "0.0875281`", ",", "0.01285`", ",", "1.128`", ",", "0.147`", ",", 
            
            RowBox[{"-", "0.763`"}], ",", 
            RowBox[{"-", "0.0001477`"}], ",", "0.0989`", ",", "0.01285`", ",", 
            RowBox[{"-", "0.78`"}], ",", "0", ",", "0.167`", ",", "7.724`", 
            ",", 
            RowBox[{"-", "0.8849727626459146`"}]}], "}"}], 
          "\[LeftDoubleBracket]", "ExpIndex", "\[RightDoubleBracket]"}]]}], 
       "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.326`", ",", "10.79`", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "10.79`", ",", "0.326`", ",", "0.771`", ",", "0.0354568`", ",", 
            "0.0362572`", ",", "0.005713`", ",", "0.978`", ",", "0.158`", ",",
             "0.02`", ",", 
            RowBox[{"-", "0.0000612`"}], ",", "0.03552`", ",", "0.005713`", 
            ",", "0.02`", ",", "0", ",", "0.326`", ",", "10.79`", ",", 
            "0.12903903378260115`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpErrIndex", "\[RightDoubleBracket]"}], 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "10.79`", ",", "0.326`", ",", "0.771`", ",", "0.0354568`", ",", 
            "0.0362572`", ",", "0.005713`", ",", "0.978`", ",", "0.158`", ",",
             "0.02`", ",", 
            RowBox[{"-", "0.0000612`"}], ",", "0.03552`", ",", "0.005713`", 
            ",", "0.02`", ",", "0", ",", "0.326`", ",", "10.79`", ",", 
            "0.12903903378260115`"}], "}"}], "\[LeftDoubleBracket]", 
          "ExpIndex", "\[RightDoubleBracket]"}]]}], "]"}]}], "}"}]}], ",", 
   RowBox[{"\<\"exptinfo\"\>", "\[Rule]", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"\<\"exptid\"\>", "\[Rule]", "124"}], ",", 
      RowBox[{"\<\"exptname\"\>", "\[Rule]", "\<\"NuTvNuChXN\"\>"}], ",", 
      RowBox[{"\<\"feyndiagram\"\>", "\[Rule]", "\<\"unset\"\>"}]}], 
     "\[RightAssociation]"}]}], ",", 
   RowBox[{"\<\"PDFinfo\"\>", "\[Rule]", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"\<\"PDFname\"\>", "\[Rule]", "\<\"CT14HERA2NNLO\"\>"}], ",", 
      RowBox[{"\<\"PDFsetmethod\"\>", "\[Rule]", "\<\"Hessian\"\>"}], ",", 
      RowBox[{"\<\"Nset\"\>", "\[Rule]", "\<\"unset\"\>"}], ",", 
      RowBox[{"\<\"iset\"\>", "\[Rule]", "\<\"unset\"\>"}], ",", 
      RowBox[{"\<\"flavour\"\>", "\[Rule]", "\<\"unset\"\>"}]}], 
     "\[RightAssociation]"}]}], ",", 
   RowBox[{"\<\"rawdata\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "124", ",", "\<\"NuTvNuChXN\"\>", 
      ",", "\<\"     Q          x         y          Exp      Th./Norm     \
TotErr     EXP/FIT  ERR/FIT    ChiSq  Shift    ShiftedData  UnCorErr  \
ReducedChi2  lob/lio\"\>", ",", "1.`", ",", "38", 
      ",", "\<\"R^2, r(k) =    0.000  -0.017\"\>", ",", 
      RowBox[{"-", "2.27713`"}], 
      ",", "\<\"R^2, r(k) =    0.000  -0.017\"\>"}], "}"}]}]}], 
  "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{3.71310323141978*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dimensions", "[", "residualdataclassfinal", "]"}]], "Input",
 CellChangeTimes->{{3.703512590876244*^9, 3.703512594217373*^9}, 
   3.708406433117675*^9}],

Cell[BoxData[
 RowBox[{"{", "2", "}"}]], "Output",
 CellChangeTimes->{3.703512595220912*^9, 3.7038127546297398`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"residualdataclassfinal", "[", 
   RowBox[{"[", "2", "]"}], "]"}], "[", 
  RowBox[{"[", 
   RowBox[{"\"\<exptinfo\>\"", ",", "\"\<exptid\>\""}], "]"}], "]"}]], "Input",\

 CellChangeTimes->{{3.703512599948867*^9, 3.70351262173845*^9}, {
   3.7035126578006477`*^9, 3.70351266064822*^9}, {3.7038127610521584`*^9, 
   3.7038127611300592`*^9}, 3.708406433712925*^9}],

Cell[BoxData["240"], "Output",
 CellChangeTimes->{{3.7035126067025547`*^9, 3.7035126242576733`*^9}, {
  3.7035126584686813`*^9, 3.703512661092311*^9}, {3.703812757084943*^9, 
  3.703812761731882*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"residualdataclass", "[", 
     RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
    RowBox[{"[", 
     RowBox[{"\"\<exptinfo\>\"", ",", "\"\<exptid\>\""}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"iexpt", ",", "1", ",", 
     RowBox[{"Length", "[", "residualdataclass", "]"}]}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.7035127531052094`*^9, 3.703512789635133*^9}, {
  3.708406434198492*^9, 3.708406434223507*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"124", ",", "240"}], "}"}]], "Output",
 CellChangeTimes->{{3.7035127619338303`*^9, 3.703512790479237*^9}, 
   3.703812764245825*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", 
  RowBox[{"{", 
   RowBox[{
   "159", ",", "159", ",", "159", ",", "159", ",", "159", ",", "159", ",", 
    "159", ",", "159", ",", "159", ",", "159", ",", "159", ",", "159", ",", 
    "159", ",", "159", ",", "159", ",", "159", ",", "159", ",", "159", ",", 
    "159", ",", "159", ",", "159", ",", "159", ",", "159", ",", "159", ",", 
    "159", ",", "159", ",", "159", ",", "159", ",", "159", ",", "159", ",", 
    "159", ",", "159", ",", "159", ",", "159", ",", "159", ",", "159", ",", 
    "159"}], "}"}], "]"}]], "Input",
 NumberMarks->False],

Cell[BoxData["37"], "Output",
 CellChangeTimes->{3.703512835042647*^9, 3.703812766471324*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"expterrordataclass", "[", 
      RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"\"\<exptinfo\>\"", ",", "\"\<exptid\>\""}], "]"}], "]"}], ",", 
    
    RowBox[{"{", 
     RowBox[{"iexpt", ",", "1", ",", 
      RowBox[{"Length", "[", "expterrordataclass", "]"}]}], "}"}]}], "]"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.703512816210446*^9, 3.703512845799972*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"124", ",", "240"}], "}"}]], "Output",
 CellChangeTimes->{{3.703512828417624*^9, 3.703512846498397*^9}, 
   3.703812768484911*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dimensions", "[", 
  RowBox[{"Flatten", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Datamethods", "[", 
           RowBox[{"[", "\"\<take\>\"", "]"}], "]"}], "[", 
          RowBox[{
           RowBox[{"corrfxQdtaobsclassin", "[", 
            RowBox[{"[", 
             RowBox[{"iexpt", ",", 
              RowBox[{"flavourin", "+", "6"}]}], "]"}], "]"}], ",", "2"}], 
          "]"}], "[", 
         RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "/.", 
        RowBox[{"LF", "->", "LF1"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"iexpt", ",", "1", ",", 
         RowBox[{"Length", "[", "corrfxQdtaobsclassin", "]"}]}], "}"}]}], 
      "]"}], "}"}], ",", "1"}], "]"}], " ", "]"}]], "Input",
 CellChangeTimes->{{3.703815419228178*^9, 3.703815443435267*^9}, 
   3.703815551256584*^9}],

Cell[BoxData[
 RowBox[{"{", "0", "}"}]], "Output",
 CellChangeTimes->{
  3.70381538569119*^9, {3.7038154283949203`*^9, 3.703815444132656*^9}, 
   3.703815553786756*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Datamethods", "[", 
       RowBox[{"[", "\"\<take\>\"", "]"}], "]"}], "[", 
      RowBox[{
       RowBox[{"corrdataclassfinal", "[", 
        RowBox[{"[", 
         RowBox[{"iexpt", ",", 
          RowBox[{"0", "+", "6"}]}], "]"}], "]"}], ",", "2"}], "]"}], "[", 
     RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "/.", 
    RowBox[{"LF", "->", "LF1"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"iexpt", ",", "1", ",", 
     RowBox[{"Length", "[", "corrdataclassfinal", "]"}]}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.703812375085343*^9, 3.703812402105011*^9}, {
   3.703814386961656*^9, 3.7038144325441847`*^9}, 3.7038155700695143`*^9, {
   3.7038156136028*^9, 3.703815640295471*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"LF1", "[", 
      RowBox[{"0.101`", ",", "2.328`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.167`", ",", "2.994`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.326`", ",", "4.182`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.057`", ",", "2.295`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.101`", ",", "3.055`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.167`", ",", "3.928`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.326`", ",", "5.489`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.057`", ",", "2.698`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.101`", ",", "3.592`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.167`", ",", "4.618`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.326`", ",", "6.452`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.057`", ",", "2.457`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.101`", ",", "3.271`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.167`", ",", "4.206`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.326`", ",", "5.877`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.057`", ",", "3.225`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.101`", ",", "4.293`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.167`", ",", "5.52`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.326`", ",", "7.712`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.021`", ",", "2.301`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.057`", ",", "3.791`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.101`", ",", "5.046`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.167`", ",", "6.488`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.326`", ",", "9.065`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.057`", ",", "2.925`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.101`", ",", "3.894`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.167`", ",", "5.007`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.326`", ",", "6.996`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.021`", ",", "2.33`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.057`", ",", "3.839`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.101`", ",", "5.11`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.167`", ",", "6.571`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.326`", ",", "9.181`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.021`", ",", "2.739`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.057`", ",", "4.512`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.101`", ",", "6.007`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.167`", ",", "7.724`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.326`", ",", "10.79`"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"LF1", "[", 
      RowBox[{"0.1175701401447711`", ",", "91.19`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.19384039085587917`", ",", "91.19`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.3195887755249146`", ",", "91.19`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.5269128120849352`", ",", "91.19`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.10364583360278702`", ",", "80.39`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.17088309048036107`", ",", "80.39`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.2817385860779459`", ",", "80.39`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.4645083996436884`", ",", "80.39`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.7658448789114248`", ",", "80.39`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.10364583360278702`", ",", "80.39`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.17088309048036107`", ",", "80.39`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.2817385860779459`", ",", "80.39`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.4645083996436884`", ",", "80.39`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.7658448789114248`", ",", "80.39`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.0014434485730087467`", ",", "91.19`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.0008754958152482544`", ",", "91.19`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.0005310150543981736`", ",", "91.19`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.00032207691126146415`", ",", "91.19`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.0012724951286782887`", ",", "80.39`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.0007718073098783549`", ",", "80.39`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.00046812479683155147`", ",", "80.39`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.0002839320418500834`", ",", "80.39`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.0001722134886568861`", ",", "80.39`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.0012724951286782887`", ",", "80.39`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.0007718073098783549`", ",", "80.39`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.00046812479683155147`", ",", "80.39`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.0002839320418500834`", ",", "80.39`"}], "]"}], ",", 
     RowBox[{"LF1", "[", 
      RowBox[{"0.0001722134886568861`", ",", "80.39`"}], "]"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.7038156152030573`*^9, 3.703815641286148*^9}}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"corrdataclassfinal", "[", 
    RowBox[{"[", 
     RowBox[{"iexpt", ",", 
      RowBox[{"0", "+", "6"}]}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"iexpt", ",", "1", ",", 
     RowBox[{"Length", "[", "corrdataclassfinal", "]"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Flatten", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"corrdataclassfinal", "[", 
       RowBox[{"[", 
        RowBox[{"iexpt", ",", 
         RowBox[{"0", "+", "6"}]}], "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"iexpt", ",", "1", ",", 
        RowBox[{"Length", "[", "corrdataclassfinal", "]"}]}], "}"}]}], "]"}], 
    "}"}], ",", "1"}], "]"}]}], "Input",
 CellChangeTimes->{
  3.703815627714407*^9, {3.703815698340437*^9, 3.703815754938662*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ExptIDtoName", "[", 
  RowBox[{"{", 
   RowBox[{"124", ",", "240"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.703819167995679*^9, 3.703819184340763*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"124", ",", "240"}], "}"}], 
   "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {124, 240}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{3.703819185220069*^9}],

Cell[BoxData["\<\"None\"\>"], "Output",
 CellChangeTimes->{{3.703819177312697*^9, 3.703819185222415*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"processdataplotsmultiexp6percentage", "[", 
  RowBox[{
   RowBox[{"{", "corrdataclassfinal", "}"}], ",", 
   RowBox[{"readcorrconfigfile4", "[", 
    RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "6", ",", "0"}],
   "]"}]], "Input",
 CellChangeTimes->{{3.704572172466009*^9, 3.704572232394021*^9}, {
  3.704573939104335*^9, 3.704573939210553*^9}, {3.706719414960906*^9, 
  3.706719419528761*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"expts: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"{", "225", "}"}], "}"}]}],
  SequenceForm["expts: ", {{225}}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7045721792143917`*^9, 3.7045722329866943`*^9}, {
   3.704573939785892*^9, 3.70457394984086*^9}, 3.705296756459104*^9, 
   3.7052969610719852`*^9, 3.705297162646308*^9, 3.7052973119508123`*^9, {
   3.706719409489635*^9, 3.706719420030642*^9}, 3.706721179278132*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", "225", 
   "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", 225, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7045721792143917`*^9, 3.7045722329866943`*^9}, {
   3.704573939785892*^9, 3.70457394984086*^9}, 3.705296756459104*^9, 
   3.7052969610719852`*^9, 3.705297162646308*^9, 3.7052973119508123`*^9, {
   3.706719409489635*^9, 3.706719420030642*^9}, 3.7067211794216633`*^9}],

Cell[BoxData["\<\"making table of experiments included in plots\"\>"], "Print",
 CellChangeTimes->{{3.7045721792143917`*^9, 3.7045722329866943`*^9}, {
   3.704573939785892*^9, 3.70457394984086*^9}, 3.705296756459104*^9, 
   3.7052969610719852`*^9, 3.705297162646308*^9, 3.7052973119508123`*^9, {
   3.706719409489635*^9, 3.706719420030642*^9}, 3.706721179424611*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     TagBox[
      GraphicsBox[{InsetBox[
         GraphicsBox[{{{{}, {{}, 
              {GrayLevel[1], PointSize[0.012833333333333334`], 
               AbsoluteThickness[1.6], 
               StyleBox[PointBox[{{0.00001, 2.}, {0.99, 1200.}}],
                FontFamily->"Helvetica"]}, {}}, {}, {}, {{}, {}}}, {
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.6167765548632014, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.8067765548632013, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.408776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.999776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.213776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.908776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.058776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.3087765548632015, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.632776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.416776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.217776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.189776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.027776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.003776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.410776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.808776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.600776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.800776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.908776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1587765548632012, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.584776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.308776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}}}, {}},
          AspectRatio->1,
          Axes->False,
          AxesLabel->{None, None},
          AxesOrigin->{0, 2.329076679826786},
          BaseStyle->{FontFamily -> "Helvetica", 16},
          DisplayFunction->Identity,
          Epilog->{{
             InsetBox[
              FormBox[
               StyleBox["\"Npt: 22\"", 16, 
                GrayLevel[0], StripOnInput -> False], TraditionalForm], 
              Scaled[{0.1, 0.9}]], 
             InsetBox[
              FormBox[
               StyleBox["\"highlighted range:\\n{0.7, 1.}\"", 16, 
                GrayLevel[0], StripOnInput -> False], TraditionalForm], 
              Scaled[{0.2, 0.7}]]}, {{
              InsetBox[
               FormBox[
                StyleBox["\"Npt: 22\"", 16, 
                 GrayLevel[0], StripOnInput -> False], TraditionalForm], 
               Scaled[{0.1, 0.9}]], 
              InsetBox[
               FormBox[
                StyleBox["\"highlighted range:\\n{0.7, 1.}\"", 16, 
                 GrayLevel[0], StripOnInput -> False], TraditionalForm], 
               Scaled[{0.2, 0.7}]]}}},
          Frame->True,
          FrameLabel->{
            FormBox[
             StyleBox["\"x\"", 18, 
              GrayLevel[0], StripOnInput -> False], TraditionalForm], 
            FormBox[
             StyleBox["\"\[Mu] [GeV]\"", 18, 
              GrayLevel[0], StripOnInput -> False], TraditionalForm]},
          FrameTicks->{{{-13.815510557964274`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.512925464970229`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.210340371976182, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.605170185988091, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.3025850929940455`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
              FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
             0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.791759469228055, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.302585092994046, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.0943445622221, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.248495242049359, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.382026634673881, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.499809670330265, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.605170185988092, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.703782474656201, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.991464547107982, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.396929655216146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.551080335043404, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.684611727667927, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.802394763324311, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.006367567650246, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.294049640102028, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.699514748210191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.987196820661973, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.104979856318357, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.210340371976184, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.308952660644293`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.596634733096073`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.002099841204238`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.156250521031495`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.289781913656018`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.407564949312402`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}}, {{-13.815510557964274`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.512925464970229`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.210340371976182, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.605170185988091, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.3025850929940455`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
              FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
             0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.791759469228055, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.302585092994046, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.0943445622221, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.248495242049359, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.382026634673881, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.499809670330265, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.605170185988092, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.703782474656201, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.991464547107982, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.396929655216146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.551080335043404, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.684611727667927, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.802394763324311, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.006367567650246, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.294049640102028, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.699514748210191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.987196820661973, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.104979856318357, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.210340371976184, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.308952660644293`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.596634733096073`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.002099841204238`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.156250521031495`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.289781913656018`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.407564949312402`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}}, {{-13.815510557964274`, 
              FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
              FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
              FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
              FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
              FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm]}, {0., 
              FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
              FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
              FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
              FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
              FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
              FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
              FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
              FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
              FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
              FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
              FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
              FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
              FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
              FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
              FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
              FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
              FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
              FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
              FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
              FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
              FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
              FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
              FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
              FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
              FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
              FormBox["\"\"", TraditionalForm]}}, {{-13.815510557964274`, 
              FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
              FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
              FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
              FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
              FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm]}, {0., 
              FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
              FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
              FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
              FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
              FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
              FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
              FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
              FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
              FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
              FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
              FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
              FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
              FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
              FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
              FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
              FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
              FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
              FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
              FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
              FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
              FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
              FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
              FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
              FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
              FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
              FormBox["\"\"", TraditionalForm]}}},
          FrameTicksStyle->GrayLevel[0],
          GridLines->{None, None},
          GridLinesStyle->Directive[
            GrayLevel[0.5, 0.4]],
          ImagePadding->All,
          ImageSize->{{600}, {600}},
          Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& )}},
          PlotLabel->None,
          
          PlotRange->{{-11.512925464970229`, 0}, {2.302585092994046, 
            7.600902459542082}},
          PlotRangeClipping->True,
          PlotRangePadding->{{0, 0}, {0, 0}},
          Ticks->{Automatic, Automatic}], Scaled[{0.5, 0.5}], Center, 
         Scaled[{1, 1}]], InsetBox[
         TemplateBox[{FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   StyleBox[
                   "\"\"", {FontSize -> 14, FontFamily -> "Arial"}, 
                    Background -> Automatic, StripOnInput -> False]}, {
                   GraphicsBox[{{}, {}, 
                    
                    RasterBox[{{{0., 0., 0.7}}, {{0., 0.5, 0.75}}, {{0., 0.75,
                     0.75}}, {{0.9352941176470588, 0.9450980392156862, 
                    0.8392156862745098}}, {{0.75, 0.75, 0.}}, {{0.75, 
                    0.5500000000000002, 0.}}, {{0.7, 0., 0.}}}, {{
                    Rational[-15, 2], 
                    Rational[-175, 2]}, {
                    Rational[15, 2], 
                    Rational[175, 2]}}], {Antialiasing -> False, 
                    AbsoluteThickness[0.1], 
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]], 
                    LineBox[
                    NCache[{{
                    Rational[15, 2], 
                    Rational[-175, 2]}, {
                    Rational[-15, 2], 
                    Rational[-175, 2]}, {
                    Rational[-15, 2], 
                    Rational[175, 2]}, {
                    Rational[15, 2], 
                    Rational[175, 2]}, {
                    Rational[15, 2], 
                    Rational[-175, 2]}}, {{7.5, -87.5}, {-7.5, -87.5}, {-7.5, 
                    87.5}, {7.5, 87.5}, {7.5, -87.5}}]]}, {
                    CapForm[None], {}}, {Antialiasing -> False, 
                    StyleBox[
                    LineBox[{{7.5, -87.5}, {7.5, 87.5}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.5, -62.5}, 
                    Offset[{4., 0}, {7.5, -62.5}]}, {{7.5, -37.5}, 
                    Offset[{4., 0}, {7.5, -37.5}]}, {{7.5, -12.5}, 
                    Offset[{4., 0}, {7.5, -12.5}]}, {{7.5, 12.5}, 
                    Offset[{4., 0}, {7.5, 12.5}]}, {{7.5, 37.5}, 
                    Offset[{4., 0}, {7.5, 37.5}]}, {{7.5, 62.5}, 
                    Offset[{4., 0}, {7.5, 62.5}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-0.85\"", -0.85, AutoDelete -> True],
                     NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -62.5}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-0.70\"", -0.7, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -37.5}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-0.50\"", -0.5, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -12.5}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"0.50\"", 0.5, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 12.5}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"0.70\"", 0.7, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 37.5}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"0.85\"", 0.85, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 62.5}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1], FontSize -> 14]}, StripOnInput -> 
                    False]}, {}}, {
                    Directive[
                    Opacity[1], FontSize -> 14]}, StripOnInput -> False], 
                    "GraphicsLabel", StripOnInput -> False]}, "GraphicsTicks",
                     StripOnInput -> False], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                    Scaled[0.02], PlotRange -> All, Frame -> True, 
                    FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                    Opacity[0], FrameTicksStyle -> Opacity[0], 
                    ImageSize -> {Automatic, 175}, BaseStyle -> {}, 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}]}}, 
                 GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontSize -> 14, FontFamily -> "Arial"}, Background -> Automatic, 
             StripOnInput -> False], TraditionalForm]},
          "BarLegend",
          DisplayFunction->(#& ),
          InterpretationFunction:>(RowBox[{"BarLegend", "[", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0., 0., 0.7], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0., 0.4666666666666667], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "RGBColor[0., 0., 0.7]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0., 0., 0.7]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0., 0., 0.7], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0., 0.5, 0.75], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0., 0.33333333333333337`, 0.5], FrameTicks -> 
                    None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "RGBColor[0., 0.5, 0.75]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0., 0.5, 0.75]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0., 0.5, 0.75], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0., 0.75, 0.75], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0.5, 0.5], FrameTicks -> 
                    None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "RGBColor[0., 0.75, 0.75]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0., 0.75, 0.75]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0., 0.75, 0.75], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[
                    0.9352941176470588, 0.9450980392156862, 
                    0.8392156862745098], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.6235294117647059, 0.6300653594771242, 
                    0.5594771241830065], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                    "RGBColor[0.9352941176470588, 0.9450980392156862, \
0.8392156862745098]"], Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.9352941176470588, 0.9450980392156862, 
                    0.8392156862745098]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[
                    0.9352941176470588, 0.9450980392156862, 
                    0.8392156862745098], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.75, 0.75, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.5, 0.5, 0.], FrameTicks -> 
                    None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "RGBColor[0.75, 0.75, 0.]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.75, 0.75, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.75, 0.75, 0.], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.75, 0.55, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.5, 0.3666666666666667, 0.],
                     FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "RGBColor[0.75, 0.55, 0.]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.75, 0.55, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.75, 0.55, 0.], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0., 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.4666666666666667, 0., 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "RGBColor[0.7, 0., 0.]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0., 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0., 0.], Editable -> False, Selectable -> 
                    False]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "1"}], ",", 
                   RowBox[{"-", "0.85`"}], ",", 
                   RowBox[{"-", "0.7`"}], ",", 
                   RowBox[{"-", "0.5`"}], ",", "0.5`", ",", "0.7`", ",", 
                   "0.85`", ",", "1"}], "}"}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"{", 
                   RowBox[{"FontSize", "\[Rule]", "14"}], "}"}]}], ",", 
               RowBox[{"LegendLabel", "\[Rule]", "\"\""}], ",", 
               RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
               RowBox[{"LegendMarkerSize", "\[Rule]", 
                 RowBox[{"{", "}"}]}], ",", 
               RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
               RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
               RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], 
             "]"}]& )], Scaled[{1., 0.5}], ImageScaled[{0, 0.5}],
         BaseStyle->{FontSize -> Larger},
         FormatType->StandardForm]},
       AspectRatio->1,
       Axes->False,
       AxesLabel->{None, None},
       AxesOrigin->{0, 2.329076679826786},
       BaseStyle->{FontFamily -> "Helvetica", 16},
       DisplayFunction->Identity,
       Frame->False,
       FrameLabel->{
         FormBox[
          StyleBox["\"x\"", 18, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         FormBox[
          StyleBox["\"\[Mu] [GeV]\"", 18, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm]},
       FrameTicks->{{{-13.815510557964274`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.02375108873622, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.86960040890896, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.512925464970229`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.903487552536127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.721165995742174, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.567015315914915, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.433483923290392, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.315700887634009, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.210340371976182, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-8.111728083308073, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.824046010856292, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.600902459542082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.418580902748127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.264430222920869, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.013115794639964, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-6.907755278982137, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.809142990314028, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.521460917862246, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.298317366548036, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.115995809754082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.961845129926823, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.710530701645918, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.605170185988091, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.506557897319982, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.995732273553991, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.659260036932778, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.3025850929940455`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-1.203972804325936, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.916290731874155, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
           FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
          0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.302585092994046, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.605170185988092, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.907755278982137, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.210340371976184, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}}, {{-13.815510557964274`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.02375108873622, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.86960040890896, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.512925464970229`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.903487552536127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.721165995742174, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.567015315914915, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.433483923290392, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.315700887634009, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.210340371976182, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-8.111728083308073, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.824046010856292, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.600902459542082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.418580902748127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.264430222920869, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.013115794639964, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-6.907755278982137, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.809142990314028, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.521460917862246, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.298317366548036, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.115995809754082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.961845129926823, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.710530701645918, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.605170185988091, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.506557897319982, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.995732273553991, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.659260036932778, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.3025850929940455`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-1.203972804325936, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.916290731874155, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
           FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
          0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.302585092994046, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.605170185988092, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.907755278982137, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.210340371976184, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}}, {{-13.815510557964274`, 
           FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
           FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
           FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
           FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
           FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
           FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
           FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
           FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
           FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
           FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
           FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
           FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
           FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
           FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
           FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
           FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
           FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
           FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
           FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
           FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
           FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
           FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
           FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm]}, {0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
           FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm]}}, {{-13.815510557964274`, 
           FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
           FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
           FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
           FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
           FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
           FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
           FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
           FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
           FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
           FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
           FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
           FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
           FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
           FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
           FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
           FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
           FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
           FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
           FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
           FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
           FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
           FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
           FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm]}, {0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
           FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm]}}},
       FrameTicksStyle->GrayLevel[0],
       ImagePadding->All,
       ImageSize->{{600}, {600}},
       Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
             (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
              Part[#, 1]], 
             (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
              Part[#, 2]]}& ), "CopiedValueFunction" -> ({
             (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
              Part[#, 1]], 
             (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
              Part[#, 2]]}& )}},
       PlotLabel->FormBox[
         StyleBox["\"\"", 24, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm],
       PlotRange->Automatic,
       PlotRangeClipping->False,
       PlotRangePadding->{{0, 0}, {0, 0}},
       Ticks->{Automatic, Automatic}],
      InterpretTemplate[Legended[
        Graphics[{{{}, {{{}, {
              Hue[0.67, 0.6, 0.6], 
              Directive[
               PointSize[0.012833333333333334`], 
               AbsoluteThickness[1.6], FontFamily -> "Helvetica", 
               GrayLevel[1]], 
              
              Point[{{0.00001, 2.}, {0.99, 
               1200.}}]}, {}}}, {}, {}, {{}, {}}}, {
           Style[
            Text[
            "\[FilledCircle]", {-2.6167765548632014`, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.8067765548632013`, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-2.408776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-2.999776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-2.213776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-4.908776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-5.058776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-5.3087765548632015`, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-4.632776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-4.416776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-3.217776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-4.189776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-2.027776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-4.003776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-3.410776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-3.808776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-3.600776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-1.800776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-0.908776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1587765548632012`, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-1.584776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-1.308776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]]}}, {
         Frame -> True, 
          FrameTicks -> {{{-13.815510557964274`, 
              "\!\(\*SuperscriptBox[\(10\), \(-6\)]\)", {0.02, 
              0.}}, {-13.122363377404328`, "", {
              0.01, 0}}, {-12.716898269296165`, "", {
              0.01, 0}}, {-12.429216196844383`, "", {
              0.01, 0}}, {-12.206072645530174`, "", {
              0.01, 0}}, {-12.02375108873622, "", {
              0.01, 0}}, {-11.86960040890896, "", {
              0.01, 0}}, {-11.736069016284437`, "", {
              0.01, 0}}, {-11.618285980628055`, "", {
              0.01, 0}}, {-11.512925464970229`, 
              "\!\(\*SuperscriptBox[\(10\), \(-5\)]\)", {0.02, 
              0.}}, {-10.819778284410283`, "", {
              0.01, 0}}, {-10.414313176302118`, "", {
              0.01, 0}}, {-10.126631103850338`, "", {
              0.01, 0}}, {-9.903487552536127, "", {
              0.01, 0}}, {-9.721165995742174, "", {
              0.01, 0}}, {-9.567015315914915, "", {
              0.01, 0}}, {-9.433483923290392, "", {
              0.01, 0}}, {-9.315700887634009, "", {
              0.01, 0}}, {-9.210340371976182, 
              "\!\(\*SuperscriptBox[\(10\), \(-4\)]\)", {0.02, 
              0.}}, {-8.517193191416238, "", {0.01, 0}}, {-8.111728083308073, 
              "", {0.01, 0}}, {-7.824046010856292, "", {
              0.01, 0}}, {-7.600902459542082, "", {
              0.01, 0}}, {-7.418580902748127, "", {
              0.01, 0}}, {-7.264430222920869, "", {
              0.01, 0}}, {-7.1308988302963465`, "", {
              0.01, 0}}, {-7.013115794639964, "", {
              0.01, 0}}, {-6.907755278982137, 
              "\!\(\*SuperscriptBox[\(10\), \(-3\)]\)", {0.02, 
              0.}}, {-6.214608098422191, "", {0.01, 0}}, {-5.809142990314028, 
              "", {0.01, 0}}, {-5.521460917862246, "", {
              0.01, 0}}, {-5.298317366548036, "", {
              0.01, 0}}, {-5.115995809754082, "", {
              0.01, 0}}, {-4.961845129926823, "", {
              0.01, 0}}, {-4.8283137373023015`, "", {
              0.01, 0}}, {-4.710530701645918, "", {
              0.01, 0}}, {-4.605170185988091, 
              "\!\(\*SuperscriptBox[\(10\), \(-2\)]\)", {0.02, 
              0.}}, {-3.912023005428146, "", {0.01, 0}}, {-3.506557897319982, 
              "", {0.01, 0}}, {-3.2188758248682006`, "", {
              0.01, 0}}, {-2.995732273553991, "", {
              0.01, 0}}, {-2.8134107167600364`, "", {
              0.01, 0}}, {-2.659260036932778, "", {
              0.01, 0}}, {-2.5257286443082556`, "", {
              0.01, 0}}, {-2.4079456086518722`, "", {
              0.01, 0}}, {-2.3025850929940455`, 
              "\!\(\*SuperscriptBox[\(10\), \(-1\)]\)", {0.02, 
              0.}}, {-1.6094379124341003`, "", {
              0.01, 0}}, {-1.203972804325936, "", {
              0.01, 0}}, {-0.916290731874155, "", {
              0.01, 0}}, {-0.6931471805599453, "", {
              0.01, 0}}, {-0.5108256237659905, "", {
              0.01, 0}}, {-0.3566749439387323, "", {
              0.01, 0}}, {-0.2231435513142097, "", {
              0.01, 0}}, {-0.10536051565782628`, "", {0.01, 0}}, {
             0., "1", {0.02, 0.}}, {0.6931471805599453, "", {0.01, 0}}, {
             1.0986122886681098`, "", {0.01, 0}}, {
             1.3862943611198906`, "", {0.01, 0}}, {
             1.6094379124341003`, "", {0.01, 0}}, {
             1.791759469228055, "", {0.01, 0}}, {
             1.9459101490553132`, "", {0.01, 0}}, {
             2.0794415416798357`, "", {0.01, 0}}, {
             2.1972245773362196`, "", {0.01, 0}}, {
             2.302585092994046, "\!\(\*SuperscriptBox[\(10\), \(1\)]\)", {
              0.02, 0.}}, {2.995732273553991, "", {0.01, 0}}, {
             3.4011973816621555`, "", {0.01, 0}}, {
             3.6888794541139363`, "", {0.01, 0}}, {
             3.912023005428146, "", {0.01, 0}}, {
             4.0943445622221, "", {0.01, 0}}, {
             4.248495242049359, "", {0.01, 0}}, {
             4.382026634673881, "", {0.01, 0}}, {
             4.499809670330265, "", {0.01, 0}}, {
             4.605170185988092, "\!\(\*SuperscriptBox[\(10\), \(2\)]\)", {
              0.02, 0.}}, {5.298317366548036, "", {0.01, 0}}, {
             5.703782474656201, "", {0.01, 0}}, {
             5.991464547107982, "", {0.01, 0}}, {
             6.214608098422191, "", {0.01, 0}}, {
             6.396929655216146, "", {0.01, 0}}, {
             6.551080335043404, "", {0.01, 0}}, {
             6.684611727667927, "", {0.01, 0}}, {
             6.802394763324311, "", {0.01, 0}}, {
             6.907755278982137, "\!\(\*SuperscriptBox[\(10\), \(3\)]\)", {
              0.02, 0.}}, {7.600902459542082, "", {0.01, 0}}, {
             8.006367567650246, "", {0.01, 0}}, {
             8.294049640102028, "", {0.01, 0}}, {
             8.517193191416238, "", {0.01, 0}}, {
             8.699514748210191, "", {0.01, 0}}, {
             8.85366542803745, "", {0.01, 0}}, {
             8.987196820661973, "", {0.01, 0}}, {
             9.104979856318357, "", {0.01, 0}}, {
             9.210340371976184, "\!\(\*SuperscriptBox[\(10\), \(4\)]\)", {
              0.02, 0.}}, {9.903487552536127, "", {0.01, 0}}, {
             10.308952660644293`, "", {0.01, 0}}, {
             10.596634733096073`, "", {0.01, 0}}, {
             10.819778284410283`, "", {0.01, 0}}, {
             11.002099841204238`, "", {0.01, 0}}, {
             11.156250521031495`, "", {0.01, 0}}, {
             11.289781913656018`, "", {0.01, 0}}, {
             11.407564949312402`, "", {0.01, 0}}}, {{-13.815510557964274`, 
              "\!\(\*SuperscriptBox[\(10\), \(-6\)]\)", {0.02, 
              0.}}, {-13.122363377404328`, "", {
              0.01, 0}}, {-12.716898269296165`, "", {
              0.01, 0}}, {-12.429216196844383`, "", {
              0.01, 0}}, {-12.206072645530174`, "", {
              0.01, 0}}, {-12.02375108873622, "", {
              0.01, 0}}, {-11.86960040890896, "", {
              0.01, 0}}, {-11.736069016284437`, "", {
              0.01, 0}}, {-11.618285980628055`, "", {
              0.01, 0}}, {-11.512925464970229`, 
              "\!\(\*SuperscriptBox[\(10\), \(-5\)]\)", {0.02, 
              0.}}, {-10.819778284410283`, "", {
              0.01, 0}}, {-10.414313176302118`, "", {
              0.01, 0}}, {-10.126631103850338`, "", {
              0.01, 0}}, {-9.903487552536127, "", {
              0.01, 0}}, {-9.721165995742174, "", {
              0.01, 0}}, {-9.567015315914915, "", {
              0.01, 0}}, {-9.433483923290392, "", {
              0.01, 0}}, {-9.315700887634009, "", {
              0.01, 0}}, {-9.210340371976182, 
              "\!\(\*SuperscriptBox[\(10\), \(-4\)]\)", {0.02, 
              0.}}, {-8.517193191416238, "", {0.01, 0}}, {-8.111728083308073, 
              "", {0.01, 0}}, {-7.824046010856292, "", {
              0.01, 0}}, {-7.600902459542082, "", {
              0.01, 0}}, {-7.418580902748127, "", {
              0.01, 0}}, {-7.264430222920869, "", {
              0.01, 0}}, {-7.1308988302963465`, "", {
              0.01, 0}}, {-7.013115794639964, "", {
              0.01, 0}}, {-6.907755278982137, 
              "\!\(\*SuperscriptBox[\(10\), \(-3\)]\)", {0.02, 
              0.}}, {-6.214608098422191, "", {0.01, 0}}, {-5.809142990314028, 
              "", {0.01, 0}}, {-5.521460917862246, "", {
              0.01, 0}}, {-5.298317366548036, "", {
              0.01, 0}}, {-5.115995809754082, "", {
              0.01, 0}}, {-4.961845129926823, "", {
              0.01, 0}}, {-4.8283137373023015`, "", {
              0.01, 0}}, {-4.710530701645918, "", {
              0.01, 0}}, {-4.605170185988091, 
              "\!\(\*SuperscriptBox[\(10\), \(-2\)]\)", {0.02, 
              0.}}, {-3.912023005428146, "", {0.01, 0}}, {-3.506557897319982, 
              "", {0.01, 0}}, {-3.2188758248682006`, "", {
              0.01, 0}}, {-2.995732273553991, "", {
              0.01, 0}}, {-2.8134107167600364`, "", {
              0.01, 0}}, {-2.659260036932778, "", {
              0.01, 0}}, {-2.5257286443082556`, "", {
              0.01, 0}}, {-2.4079456086518722`, "", {
              0.01, 0}}, {-2.3025850929940455`, 
              "\!\(\*SuperscriptBox[\(10\), \(-1\)]\)", {0.02, 
              0.}}, {-1.6094379124341003`, "", {
              0.01, 0}}, {-1.203972804325936, "", {
              0.01, 0}}, {-0.916290731874155, "", {
              0.01, 0}}, {-0.6931471805599453, "", {
              0.01, 0}}, {-0.5108256237659905, "", {
              0.01, 0}}, {-0.3566749439387323, "", {
              0.01, 0}}, {-0.2231435513142097, "", {
              0.01, 0}}, {-0.10536051565782628`, "", {0.01, 0}}, {
             0., "1", {0.02, 0.}}, {0.6931471805599453, "", {0.01, 0}}, {
             1.0986122886681098`, "", {0.01, 0}}, {
             1.3862943611198906`, "", {0.01, 0}}, {
             1.6094379124341003`, "", {0.01, 0}}, {
             1.791759469228055, "", {0.01, 0}}, {
             1.9459101490553132`, "", {0.01, 0}}, {
             2.0794415416798357`, "", {0.01, 0}}, {
             2.1972245773362196`, "", {0.01, 0}}, {
             2.302585092994046, "\!\(\*SuperscriptBox[\(10\), \(1\)]\)", {
              0.02, 0.}}, {2.995732273553991, "", {0.01, 0}}, {
             3.4011973816621555`, "", {0.01, 0}}, {
             3.6888794541139363`, "", {0.01, 0}}, {
             3.912023005428146, "", {0.01, 0}}, {
             4.0943445622221, "", {0.01, 0}}, {
             4.248495242049359, "", {0.01, 0}}, {
             4.382026634673881, "", {0.01, 0}}, {
             4.499809670330265, "", {0.01, 0}}, {
             4.605170185988092, "\!\(\*SuperscriptBox[\(10\), \(2\)]\)", {
              0.02, 0.}}, {5.298317366548036, "", {0.01, 0}}, {
             5.703782474656201, "", {0.01, 0}}, {
             5.991464547107982, "", {0.01, 0}}, {
             6.214608098422191, "", {0.01, 0}}, {
             6.396929655216146, "", {0.01, 0}}, {
             6.551080335043404, "", {0.01, 0}}, {
             6.684611727667927, "", {0.01, 0}}, {
             6.802394763324311, "", {0.01, 0}}, {
             6.907755278982137, "\!\(\*SuperscriptBox[\(10\), \(3\)]\)", {
              0.02, 0.}}, {7.600902459542082, "", {0.01, 0}}, {
             8.006367567650246, "", {0.01, 0}}, {
             8.294049640102028, "", {0.01, 0}}, {
             8.517193191416238, "", {0.01, 0}}, {
             8.699514748210191, "", {0.01, 0}}, {
             8.85366542803745, "", {0.01, 0}}, {
             8.987196820661973, "", {0.01, 0}}, {
             9.104979856318357, "", {0.01, 0}}, {
             9.210340371976184, "\!\(\*SuperscriptBox[\(10\), \(4\)]\)", {
              0.02, 0.}}, {9.903487552536127, "", {0.01, 0}}, {
             10.308952660644293`, "", {0.01, 0}}, {
             10.596634733096073`, "", {0.01, 0}}, {
             10.819778284410283`, "", {0.01, 0}}, {
             11.002099841204238`, "", {0.01, 0}}, {
             11.156250521031495`, "", {0.01, 0}}, {
             11.289781913656018`, "", {0.01, 0}}, {
             11.407564949312402`, "", {0.01, 0}}}, {{-13.815510557964274`, 
              ""}, {-13.122363377404328`, ""}, {-12.716898269296165`, 
              ""}, {-12.429216196844383`, ""}, {-12.206072645530174`, 
              ""}, {-12.02375108873622, ""}, {-11.86960040890896, 
              ""}, {-11.736069016284437`, ""}, {-11.618285980628055`, 
              ""}, {-11.512925464970229`, ""}, {-10.819778284410283`, 
              ""}, {-10.414313176302118`, ""}, {-10.126631103850338`, 
              ""}, {-9.903487552536127, ""}, {-9.721165995742174, 
              ""}, {-9.567015315914915, ""}, {-9.433483923290392, 
              ""}, {-9.315700887634009, ""}, {-9.210340371976182, 
              ""}, {-8.517193191416238, ""}, {-8.111728083308073, 
              ""}, {-7.824046010856292, ""}, {-7.600902459542082, 
              ""}, {-7.418580902748127, ""}, {-7.264430222920869, 
              ""}, {-7.1308988302963465`, ""}, {-7.013115794639964, 
              ""}, {-6.907755278982137, ""}, {-6.214608098422191, 
              ""}, {-5.809142990314028, ""}, {-5.521460917862246, 
              ""}, {-5.298317366548036, ""}, {-5.115995809754082, 
              ""}, {-4.961845129926823, ""}, {-4.8283137373023015`, 
              ""}, {-4.710530701645918, ""}, {-4.605170185988091, 
              ""}, {-3.912023005428146, ""}, {-3.506557897319982, 
              ""}, {-3.2188758248682006`, ""}, {-2.995732273553991, 
              ""}, {-2.8134107167600364`, ""}, {-2.659260036932778, 
              ""}, {-2.5257286443082556`, ""}, {-2.4079456086518722`, 
              ""}, {-2.3025850929940455`, ""}, {-1.6094379124341003`, 
              ""}, {-1.203972804325936, ""}, {-0.916290731874155, 
              ""}, {-0.6931471805599453, ""}, {-0.5108256237659905, 
              ""}, {-0.3566749439387323, ""}, {-0.2231435513142097, 
              ""}, {-0.10536051565782628`, ""}, {0., ""}, {
             0.6931471805599453, ""}, {1.0986122886681098`, ""}, {
             1.3862943611198906`, ""}, {1.6094379124341003`, ""}, {
             1.791759469228055, ""}, {1.9459101490553132`, ""}, {
             2.0794415416798357`, ""}, {2.1972245773362196`, ""}, {
             2.302585092994046, ""}, {2.995732273553991, ""}, {
             3.4011973816621555`, ""}, {3.6888794541139363`, ""}, {
             3.912023005428146, ""}, {4.0943445622221, ""}, {
             4.248495242049359, ""}, {4.382026634673881, ""}, {
             4.499809670330265, ""}, {4.605170185988092, ""}, {
             5.298317366548036, ""}, {5.703782474656201, ""}, {
             5.991464547107982, ""}, {6.214608098422191, ""}, {
             6.396929655216146, ""}, {6.551080335043404, ""}, {
             6.684611727667927, ""}, {6.802394763324311, ""}, {
             6.907755278982137, ""}, {7.600902459542082, ""}, {
             8.006367567650246, ""}, {8.294049640102028, ""}, {
             8.517193191416238, ""}, {8.699514748210191, ""}, {
             8.85366542803745, ""}, {8.987196820661973, ""}, {
             9.104979856318357, ""}, {9.210340371976184, ""}, {
             9.903487552536127, ""}, {10.308952660644293`, ""}, {
             10.596634733096073`, ""}, {10.819778284410283`, ""}, {
             11.002099841204238`, ""}, {11.156250521031495`, ""}, {
             11.289781913656018`, ""}, {
             11.407564949312402`, ""}}, {{-13.815510557964274`, 
              ""}, {-13.122363377404328`, ""}, {-12.716898269296165`, 
              ""}, {-12.429216196844383`, ""}, {-12.206072645530174`, 
              ""}, {-12.02375108873622, ""}, {-11.86960040890896, 
              ""}, {-11.736069016284437`, ""}, {-11.618285980628055`, 
              ""}, {-11.512925464970229`, ""}, {-10.819778284410283`, 
              ""}, {-10.414313176302118`, ""}, {-10.126631103850338`, 
              ""}, {-9.903487552536127, ""}, {-9.721165995742174, 
              ""}, {-9.567015315914915, ""}, {-9.433483923290392, 
              ""}, {-9.315700887634009, ""}, {-9.210340371976182, 
              ""}, {-8.517193191416238, ""}, {-8.111728083308073, 
              ""}, {-7.824046010856292, ""}, {-7.600902459542082, 
              ""}, {-7.418580902748127, ""}, {-7.264430222920869, 
              ""}, {-7.1308988302963465`, ""}, {-7.013115794639964, 
              ""}, {-6.907755278982137, ""}, {-6.214608098422191, 
              ""}, {-5.809142990314028, ""}, {-5.521460917862246, 
              ""}, {-5.298317366548036, ""}, {-5.115995809754082, 
              ""}, {-4.961845129926823, ""}, {-4.8283137373023015`, 
              ""}, {-4.710530701645918, ""}, {-4.605170185988091, 
              ""}, {-3.912023005428146, ""}, {-3.506557897319982, 
              ""}, {-3.2188758248682006`, ""}, {-2.995732273553991, 
              ""}, {-2.8134107167600364`, ""}, {-2.659260036932778, 
              ""}, {-2.5257286443082556`, ""}, {-2.4079456086518722`, 
              ""}, {-2.3025850929940455`, ""}, {-1.6094379124341003`, 
              ""}, {-1.203972804325936, ""}, {-0.916290731874155, 
              ""}, {-0.6931471805599453, ""}, {-0.5108256237659905, 
              ""}, {-0.3566749439387323, ""}, {-0.2231435513142097, 
              ""}, {-0.10536051565782628`, ""}, {0., ""}, {
             0.6931471805599453, ""}, {1.0986122886681098`, ""}, {
             1.3862943611198906`, ""}, {1.6094379124341003`, ""}, {
             1.791759469228055, ""}, {1.9459101490553132`, ""}, {
             2.0794415416798357`, ""}, {2.1972245773362196`, ""}, {
             2.302585092994046, ""}, {2.995732273553991, ""}, {
             3.4011973816621555`, ""}, {3.6888794541139363`, ""}, {
             3.912023005428146, ""}, {4.0943445622221, ""}, {
             4.248495242049359, ""}, {4.382026634673881, ""}, {
             4.499809670330265, ""}, {4.605170185988092, ""}, {
             5.298317366548036, ""}, {5.703782474656201, ""}, {
             5.991464547107982, ""}, {6.214608098422191, ""}, {
             6.396929655216146, ""}, {6.551080335043404, ""}, {
             6.684611727667927, ""}, {6.802394763324311, ""}, {
             6.907755278982137, ""}, {7.600902459542082, ""}, {
             8.006367567650246, ""}, {8.294049640102028, ""}, {
             8.517193191416238, ""}, {8.699514748210191, ""}, {
             8.85366542803745, ""}, {8.987196820661973, ""}, {
             9.104979856318357, ""}, {9.210340371976184, ""}, {
             9.903487552536127, ""}, {10.308952660644293`, ""}, {
             10.596634733096073`, ""}, {10.819778284410283`, ""}, {
             11.002099841204238`, ""}, {11.156250521031495`, ""}, {
             11.289781913656018`, ""}, {11.407564949312402`, ""}}}, Axes -> 
          False, PlotLabel -> Style["", 24, 
            GrayLevel[0]], FrameLabel -> {
            Style["x", 18, 
             GrayLevel[0]], 
            Style["\[Mu] [GeV]", 18, 
             GrayLevel[0]]}, FrameTicksStyle -> GrayLevel[0], 
          ImageSize -> {{600}, {600}}, AspectRatio -> 1, DisplayFunction -> 
          Identity, PlotRangePadding -> {{0, 0}, {0, 0}}, 
          AxesOrigin -> {0, 2.329076679826786}, 
          PlotRange -> {{-11.512925464970229`, 0}, {2.302585092994046, 
            7.600902459542082}}, PlotRangeClipping -> True, ImagePadding -> 
          All, DisplayFunction -> Identity, AspectRatio -> 1, 
          Axes -> {True, True}, AxesLabel -> {None, None}, 
          AxesOrigin -> {0, 2.329076679826786}, DisplayFunction :> Identity, 
          Epilog -> {{
             Text[
              Style["Npt: 22", 16, 
               GrayLevel[0]], 
              Scaled[{0.1, 0.9}]], 
             Text[
              Style["highlighted range:\n{0.7, 1.}", 16, 
               GrayLevel[0]], 
              Scaled[{0.2, 0.7}]]}, {{
              Text[
               Style["Npt: 22", 16, 
                GrayLevel[0]], 
               Scaled[{0.1, 0.9}]], 
              Text[
               Style["highlighted range:\n{0.7, 1.}", 16, 
                GrayLevel[0]], 
               Scaled[{0.2, 0.7}]]}}}, 
          Frame -> {{False, False}, {False, False}}, 
          FrameLabel -> {{None, None}, {None, None}}, 
          FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
          GridLines -> {None, None}, GridLinesStyle -> Directive[
            GrayLevel[0.5, 0.4]], 
          Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& )}}, 
          PlotRange -> {{-11.512925464970229`, 0}, {2.302585092994046, 
            7.600902459542082}}, PlotRangeClipping -> True, 
          PlotRangePadding -> {{0, 0}, {0, 0}}, 
          Ticks -> {Automatic, Automatic}}], 
        Placed[
         Unevaluated[
          BarLegend[{{
             RGBColor[0., 0., 0.7], 
             RGBColor[0., 0.5, 0.75], 
             RGBColor[0., 0.75, 0.75], 
             RGBColor[
             0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
             RGBColor[0.75, 0.75, 0.], 
             RGBColor[0.75, 0.55, 0.], 
             RGBColor[0.7, 0., 0.]}, {-1, 1}}, {-1, -0.85, -0.7, -0.5, 0.5, 
            0.7, 0.85, 1}, LabelStyle -> {FontSize -> 14}, LegendLabel -> "", 
           LegendLayout -> "Column", LegendMarkerSize -> {}, 
           Charting`TickAnnotations -> None, Charting`TickSide -> Right, 
           ColorFunctionScaling -> True]], {1., 0.5}, Identity]]& ],
      AutoDelete->True,
      Editable->True,
      SelectWithContents->False,
      Selectable->True], ",", 
     TagBox[GridBox[{
        {
         InterpretationBox[Cell[BoxData[
           FormBox[
            
            StyleBox["\<\"Corr( g(x,\[Mu]), r(x,\[Mu])) for dataset of \
CT14HERA2NNLO\\n\\n\"\>",
             StripOnInput->False,
             FontSize->24], TextForm]], "InlineText"],
          Text[
           Style[
           "Corr( g(x,\[Mu]), r(x,\[Mu])) for dataset of CT14HERA2NNLO\n\n", 
            FontSize -> 24]]], "\[SpanFromLeft]"},
        {"\<\"Data Sets\"\>", ""},
        {"\<\"None(225)\"\>", ""}
       },
       AutoDelete->False,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{14}}},
       GridBoxItemStyle->{"Columns" -> {{
            Directive[FontSize -> 18, 
             GrayLevel[0]]}}, "Rows" -> {{
            Directive[FontSize -> 18, 
             GrayLevel[0]]}}}],
      "Grid"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     GraphicsBox[{
       {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
        EdgeForm[{Opacity[0.392], Thickness[Small]}], {}, 
        {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
         EdgeForm[{Opacity[0.392], Thickness[Small]}], 
         RectangleBox[{-0.1, 0}, {-0.05, 12},
          RoundingRadius->0], RectangleBox[{-0.05, 0}, {0., 1},
          RoundingRadius->0], RectangleBox[{0., 0}, {0.05, 2},
          RoundingRadius->0], RectangleBox[{0.05, 0}, {0.1, 2},
          RoundingRadius->0], 
         RectangleBox[{0.1, 0}, {0.15000000000000002, 5},
          RoundingRadius->0]}, {}, {}}, {{}, {}, {}, {}, {}}},
      AspectRatio->1,
      Axes->False,
      AxesLabel->{None, None},
      AxesOrigin->{-1.04, 0.},
      BaseStyle->{FontSize -> 16},
      Epilog->{{{
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[1, 0, 0], StripOnInput -> False], 
            TraditionalForm], {-0.7, 11.819999999999999`}], 
          StyleBox[
           LineBox[{{-0.7, 0.}, {-0.7, 11.399999999999999`}}], 
           RGBColor[1, 0, 0], StripOnInput -> False]}, {
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[1, 0, 0], StripOnInput -> False], TraditionalForm], {
           0.7, 11.34}], 
          StyleBox[
           LineBox[{{0.7, 0.}, {0.7, 11.399999999999999`}}], 
           RGBColor[1, 0, 0], StripOnInput -> False]}}, 
        InsetBox[
         FormBox[
          StyleBox["\"Npt: 22\"", 16, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         Scaled[{0.1, 0.9}]]},
      Frame->True,
      FrameLabel->{
        FormBox[
         StyleBox["\"Corr( g(x,\[Mu]), r(x,\[Mu]))\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm], 
        FormBox[
         StyleBox["\"#points\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm]},
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImageSize->{{600}, {600}},
      PlotLabel->FormBox[
        StyleBox["\"\"", 24, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{-1, 1}, {0., 12}},
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}], ",", 
     GraphicsBox[{
       {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
        EdgeForm[{Opacity[0.5319999999999999], Thickness[Small]}], {}, 
        {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
         EdgeForm[{Opacity[0.5319999999999999], Thickness[Small]}], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{0., 0}, {0.05, 3}, "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{64., 89.10000000000001}, {129.36607142857144`, 
              232.00000000000003`}}],
            StatusArea[#, 3]& ,
            TagBoxNote->"3"],
           StyleBox["3", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[3, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{0.05, 0}, {0.1, 14}, "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{88.60000000000001, 
              113.70000000000002`}, {-245.12500000000003`, 
              232.00000000000003`}}],
            StatusArea[#, 14]& ,
            TagBoxNote->"14"],
           StyleBox["14", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[14, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              
              RectangleBox[{0.1, 0}, {0.15000000000000002`, 5}, 
               "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{113.20000000000002`, 138.3}, {
              61.27678571428572, 232.00000000000003`}}],
            StatusArea[#, 5]& ,
            TagBoxNote->"5"],
           StyleBox["5", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[5, {}], "Tooltip"]& ]}, {}, {}}, {{}, {}, {}}},
      AspectRatio->1,
      Axes->False,
      AxesLabel->{None, None},
      AxesOrigin->{-0.02, 0.},
      BaseStyle->{FontSize -> 16},
      Epilog->{{{
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[1, 0, 0], StripOnInput -> False], TraditionalForm], {
           0.7, 13.789999999999997`}], 
          StyleBox[
           LineBox[{{0.7, 0.}, {0.7, 13.299999999999999`}}], 
           RGBColor[1, 0, 0], StripOnInput -> False]}}, 
        InsetBox[
         FormBox[
          StyleBox["\"Npt: 22\"", 16, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         Scaled[{0.1, 0.9}]]},
      Frame->True,
      FrameLabel->{
        FormBox[
         StyleBox["\"| Corr( g(x,\[Mu]), r(x,\[Mu])) |\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm], 
        FormBox[
         StyleBox["\"#points\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm]},
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImageSize->{{600}, {600}},
      PlotLabel->FormBox[
        StyleBox["\"\"", 24, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{0, 1}, {0., 14}},
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.704572179700823*^9, 3.704572233427433*^9}, {
   3.704573940234397*^9, 3.704573950337249*^9}, 3.705296762277156*^9, 
   3.705296961640155*^9, 3.705297163196748*^9, 3.705297312502198*^9, {
   3.706719409915805*^9, 3.706719420640914*^9}, 3.706721179702704*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"processdataplotsmultiexp6percentage", "[", 
  RowBox[{
   RowBox[{"{", "dRcorrdataclassfinal", "}"}], ",", 
   RowBox[{"readcorrconfigfile4", "[", 
    RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "5", ",", "3"}],
   "]"}]], "Input",
 CellChangeTimes->{
  3.704086904629675*^9, {3.704086964897149*^9, 3.704087047582033*^9}, {
   3.7040872386353273`*^9, 3.70408727469156*^9}, {3.704573921710326*^9, 
   3.704573926838719*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"expts: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"240", ",", "241", ",", "281", ",", "266"}], "}"}], "}"}]}],
  SequenceForm["expts: ", {{240, 241, 281, 266}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7040869073482943`*^9, {3.704086965664288*^9, 3.7040869844809732`*^9}, {
   3.7040870439398613`*^9, 3.704087048263638*^9}, {3.704087216103746*^9, 
   3.7040872752562513`*^9}, 3.704087744153722*^9, 3.7040883119383173`*^9, 
   3.704572056944736*^9, 3.704572258100731*^9, {3.7045739149781847`*^9, 
   3.7045739273968563`*^9}, 3.70457396244825*^9, {3.705297169516844*^9, 
   3.7052971771205387`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", "240", 
   "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", 240, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7040869073482943`*^9, {3.704086965664288*^9, 3.7040869844809732`*^9}, {
   3.7040870439398613`*^9, 3.704087048263638*^9}, {3.704087216103746*^9, 
   3.7040872752562513`*^9}, 3.704087744153722*^9, 3.7040883119383173`*^9, 
   3.704572056944736*^9, 3.704572258100731*^9, {3.7045739149781847`*^9, 
   3.7045739273968563`*^9}, 3.70457396244825*^9, {3.705297169516844*^9, 
   3.705297177258333*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", "241", 
   "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", 241, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7040869073482943`*^9, {3.704086965664288*^9, 3.7040869844809732`*^9}, {
   3.7040870439398613`*^9, 3.704087048263638*^9}, {3.704087216103746*^9, 
   3.7040872752562513`*^9}, 3.704087744153722*^9, 3.7040883119383173`*^9, 
   3.704572056944736*^9, 3.704572258100731*^9, {3.7045739149781847`*^9, 
   3.7045739273968563`*^9}, 3.70457396244825*^9, {3.705297169516844*^9, 
   3.705297177261693*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", "281", 
   "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", 281, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7040869073482943`*^9, {3.704086965664288*^9, 3.7040869844809732`*^9}, {
   3.7040870439398613`*^9, 3.704087048263638*^9}, {3.704087216103746*^9, 
   3.7040872752562513`*^9}, 3.704087744153722*^9, 3.7040883119383173`*^9, 
   3.704572056944736*^9, 3.704572258100731*^9, {3.7045739149781847`*^9, 
   3.7045739273968563`*^9}, 3.70457396244825*^9, {3.705297169516844*^9, 
   3.705297177264587*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", "266", 
   "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", 266, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7040869073482943`*^9, {3.704086965664288*^9, 3.7040869844809732`*^9}, {
   3.7040870439398613`*^9, 3.704087048263638*^9}, {3.704087216103746*^9, 
   3.7040872752562513`*^9}, 3.704087744153722*^9, 3.7040883119383173`*^9, 
   3.704572056944736*^9, 3.704572258100731*^9, {3.7045739149781847`*^9, 
   3.7045739273968563`*^9}, 3.70457396244825*^9, {3.705297169516844*^9, 
   3.705297177267666*^9}}],

Cell[BoxData["\<\"making table of experiments included in plots\"\>"], "Print",
 CellChangeTimes->{
  3.7040869073482943`*^9, {3.704086965664288*^9, 3.7040869844809732`*^9}, {
   3.7040870439398613`*^9, 3.704087048263638*^9}, {3.704087216103746*^9, 
   3.7040872752562513`*^9}, 3.704087744153722*^9, 3.7040883119383173`*^9, 
   3.704572056944736*^9, 3.704572258100731*^9, {3.7045739149781847`*^9, 
   3.7045739273968563`*^9}, 3.70457396244825*^9, {3.705297169516844*^9, 
   3.7052971772715*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     TagBox[
      GraphicsBox[{InsetBox[
         GraphicsBox[{{{{}, {{}, 
              {GrayLevel[1], PointSize[0.012833333333333334`], 
               AbsoluteThickness[1.6], 
               StyleBox[PointBox[{{0.00001, 2.}, {0.99, 1200.}}],
                FontFamily->"Helvetica"]}, {}}, {}, {}, {{}, {}}}, {
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.4917756376975806, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-8.040720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.16677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.583809961884693, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.140720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-8.166775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.7417756376975806, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.540720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.66677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.2667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.9667756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.2667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-8.666775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-8.166775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.666775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.4938099618846934, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.26677563769758056, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.093809961884693, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.1138099618846935, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1407201860918759, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.4938099618846934, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.540720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2938099618846937, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.2167756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.6407201860918759, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.6407201860918759, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.0938099618846935, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.166775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.733809961884694, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.293809961884693, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.040720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-8.666775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.0938099618846935, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.293809961884693, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-8.666775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.566775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.2667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.8938099618846933, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.8938099618846933, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-8.166775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.293809961884693, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.666775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.493809961884693, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.8038099618846937, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.093809961884693, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.66677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.766775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.093809961884693, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.893809961884693, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.293809961884693, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.3667756376975806, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.4938099618846934, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.16677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.6938099618846936, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.66677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.666775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.366775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.5667756376975808, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.8938099618846936, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.26677563769758056, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.26677563769758056, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.966775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.6938099618846936, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.16677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.7667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.6538099618846934, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.16677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.191775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.716775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.9667756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.966775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2738099618846935, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.16677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.766775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.441775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.366775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.566775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.625]}}}, {}},
          AspectRatio->1,
          Axes->False,
          AxesLabel->{None, None},
          AxesOrigin->{0, 2.322145208021187},
          BaseStyle->{FontFamily -> "Helvetica", 16},
          DisplayFunction->Identity,
          Epilog->{{
             InsetBox[
              FormBox[
               StyleBox["\"Npt: 86\"", 16, 
                GrayLevel[0], StripOnInput -> False], TraditionalForm], 
              Scaled[{0.1, 0.9}]], 
             InsetBox[
              FormBox[
               StyleBox["\"highlighted range:\\n{0.7, 100.}\"", 16, 
                GrayLevel[0], StripOnInput -> False], TraditionalForm], 
              Scaled[{0.2, 0.7}]]}, {{
              InsetBox[
               FormBox[
                StyleBox["\"Npt: 86\"", 16, 
                 GrayLevel[0], StripOnInput -> False], TraditionalForm], 
               Scaled[{0.1, 0.9}]], 
              InsetBox[
               FormBox[
                StyleBox["\"highlighted range:\\n{0.7, 100.}\"", 16, 
                 GrayLevel[0], StripOnInput -> False], TraditionalForm], 
               Scaled[{0.2, 0.7}]]}}},
          Frame->True,
          FrameLabel->{
            FormBox[
             StyleBox["\"x\"", 18, 
              GrayLevel[0], StripOnInput -> False], TraditionalForm], 
            FormBox[
             StyleBox["\"\[Mu] [GeV]\"", 18, 
              GrayLevel[0], StripOnInput -> False], TraditionalForm]},
          FrameTicks->{{{-13.815510557964274`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.512925464970229`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.210340371976182, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.605170185988091, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.3025850929940455`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
              FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
             0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.791759469228055, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.302585092994046, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.0943445622221, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.248495242049359, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.382026634673881, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.499809670330265, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.605170185988092, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.703782474656201, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.991464547107982, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.396929655216146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.551080335043404, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.684611727667927, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.802394763324311, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.006367567650246, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.294049640102028, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.699514748210191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.987196820661973, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.104979856318357, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.210340371976184, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.308952660644293`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.596634733096073`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.002099841204238`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.156250521031495`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.289781913656018`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.407564949312402`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}}, {{-13.815510557964274`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.512925464970229`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.210340371976182, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.605170185988091, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.3025850929940455`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
              FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
             0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.791759469228055, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.302585092994046, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.0943445622221, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.248495242049359, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.382026634673881, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.499809670330265, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.605170185988092, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.703782474656201, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.991464547107982, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.396929655216146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.551080335043404, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.684611727667927, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.802394763324311, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.006367567650246, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.294049640102028, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.699514748210191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.987196820661973, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.104979856318357, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.210340371976184, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.308952660644293`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.596634733096073`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.002099841204238`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.156250521031495`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.289781913656018`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.407564949312402`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}}, {{-13.815510557964274`, 
              FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
              FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
              FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
              FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
              FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm]}, {0., 
              FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
              FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
              FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
              FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
              FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
              FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
              FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
              FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
              FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
              FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
              FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
              FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
              FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
              FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
              FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
              FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
              FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
              FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
              FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
              FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
              FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
              FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
              FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
              FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
              FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
              FormBox["\"\"", TraditionalForm]}}, {{-13.815510557964274`, 
              FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
              FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
              FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
              FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
              FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm]}, {0., 
              FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
              FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
              FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
              FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
              FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
              FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
              FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
              FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
              FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
              FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
              FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
              FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
              FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
              FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
              FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
              FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
              FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
              FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
              FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
              FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
              FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
              FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
              FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
              FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
              FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
              FormBox["\"\"", TraditionalForm]}}},
          GridLines->{None, None},
          GridLinesStyle->Directive[
            GrayLevel[0.5, 0.4]],
          ImagePadding->All,
          ImageSize->{{600}, {600}},
          Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& )}},
          PlotLabel->None,
          
          PlotRange->{{-11.512925464970229`, 0}, {2.302585092994046, 
            6.214608098422191}},
          PlotRangeClipping->True,
          PlotRangePadding->{{0, 0}, {0, 0}},
          Ticks->{Automatic, Automatic}], Scaled[{0.5, 0.5}], Center, 
         Scaled[{1, 1}]], InsetBox[
         TemplateBox[{FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   StyleBox[
                   "\"\"", {FontSize -> 14, FontFamily -> "Arial"}, 
                    Background -> Automatic, StripOnInput -> False]}, {
                   GraphicsBox[{{}, {}, 
                    
                    RasterBox[{{{0., 0., 0.7}}, {{0., 0.35, 0.7}}, {{0., 0.7, 
                    0.7}}, {{0.9352941176470588, 0.9450980392156862, 
                    0.8392156862745098}}, {{0.7, 0.56, 0.}}, {{0.7, 
                    0.2800000000000002, 0.}}, {{0.7, 0., 0.}}}, {{
                    Rational[-15, 2], 
                    Rational[-175, 2]}, {
                    Rational[15, 2], 
                    Rational[175, 2]}}], {Antialiasing -> False, 
                    AbsoluteThickness[0.1], 
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]], 
                    LineBox[
                    NCache[{{
                    Rational[15, 2], 
                    Rational[-175, 2]}, {
                    Rational[-15, 2], 
                    Rational[-175, 2]}, {
                    Rational[-15, 2], 
                    Rational[175, 2]}, {
                    Rational[15, 2], 
                    Rational[175, 2]}, {
                    Rational[15, 2], 
                    Rational[-175, 2]}}, {{7.5, -87.5}, {-7.5, -87.5}, {-7.5, 
                    87.5}, {7.5, 87.5}, {7.5, -87.5}}]]}, {
                    CapForm[None], {}}, {Antialiasing -> False, 
                    StyleBox[
                    LineBox[{{7.5, -87.5}, {7.5, 87.5}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.5, -62.5}, 
                    Offset[{4., 0}, {7.5, -62.5}]}, {{
                    7.5, -37.49999999999999}, 
                    Offset[{4., 0}, {7.5, -37.49999999999999}]}, {{
                    7.5, -12.5}, 
                    Offset[{4., 0}, {7.5, -12.5}]}, {{7.5, 12.5}, 
                    Offset[{4., 0}, {7.5, 12.5}]}, {{7.5, 37.49999999999999}, 
                    
                    Offset[{4., 0}, {7.5, 37.49999999999999}]}, {{7.5, 62.5}, 
                    
                    Offset[{4., 0}, {7.5, 62.5}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-0.85\"", -0.85, AutoDelete -> True],
                     NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -62.5}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-0.70\"", -0.7, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -37.49999999999999}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-0.50\"", -0.5, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -12.5}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"0.50\"", 0.5, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 12.5}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"0.70\"", 0.7, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 37.49999999999999}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"0.85\"", 0.85, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 62.5}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1], FontSize -> 14]}, StripOnInput -> 
                    False]}, {}}, {
                    Directive[
                    Opacity[1], FontSize -> 14]}, StripOnInput -> False], 
                    "GraphicsLabel", StripOnInput -> False]}, "GraphicsTicks",
                     StripOnInput -> False], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                    Scaled[0.02], PlotRange -> All, Frame -> True, 
                    FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                    Opacity[0], FrameTicksStyle -> Opacity[0], 
                    ImageSize -> {Automatic, 175}, BaseStyle -> {}, 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}]}}, 
                 GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontSize -> 14, FontFamily -> "Arial"}, Background -> Automatic, 
             StripOnInput -> False], TraditionalForm]},
          "BarLegend",
          DisplayFunction->(#& ),
          InterpretationFunction:>(RowBox[{"BarLegend", "[", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0., 0., 0.7], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0., 0.4666666666666667], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "RGBColor[0., 0., 0.7]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0., 0., 0.7]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0., 0., 0.7], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0., 0.35, 0.7], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0., 0.23333333333333334`, 0.4666666666666667], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "RGBColor[0., 0.35, 0.7]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0., 0.35, 0.7]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0., 0.35, 0.7], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0., 0.7, 0.7], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0., 0.4666666666666667, 0.4666666666666667], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "RGBColor[0., 0.7, 0.7]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0., 0.7, 0.7]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0., 0.7, 0.7], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[
                    0.9352941176470588, 0.9450980392156862, 
                    0.8392156862745098], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.6235294117647059, 0.6300653594771242, 
                    0.5594771241830065], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                    "RGBColor[0.9352941176470588, 0.9450980392156862, \
0.8392156862745098]"], Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.9352941176470588, 0.9450980392156862, 
                    0.8392156862745098]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[
                    0.9352941176470588, 0.9450980392156862, 
                    0.8392156862745098], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0.56, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.4666666666666667, 0.3733333333333334, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "RGBColor[0.7, 0.56, 0.]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0.56, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0.56, 0.], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0.28, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.4666666666666667, 0.1866666666666667, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "RGBColor[0.7, 0.28, 0.]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0.28, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0.28, 0.], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0., 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.4666666666666667, 0., 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "RGBColor[0.7, 0., 0.]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0., 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0., 0.], Editable -> False, Selectable -> 
                    False]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "100"}], ",", "100"}], "}"}]}], "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "100"}], ",", 
                   RowBox[{"-", "0.85`"}], ",", 
                   RowBox[{"-", "0.7`"}], ",", 
                   RowBox[{"-", "0.5`"}], ",", "0.5`", ",", "0.7`", ",", 
                   "0.85`", ",", "100"}], "}"}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"{", 
                   RowBox[{"FontSize", "\[Rule]", "14"}], "}"}]}], ",", 
               RowBox[{"LegendLabel", "\[Rule]", "\"\""}], ",", 
               RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
               RowBox[{"LegendMarkerSize", "\[Rule]", 
                 RowBox[{"{", "}"}]}], ",", 
               RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
               RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
               RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], 
             "]"}]& )], Scaled[{1., 0.5}], ImageScaled[{0, 0.5}],
         BaseStyle->{FontSize -> Larger},
         FormatType->StandardForm]},
       AspectRatio->1,
       Axes->False,
       AxesLabel->{None, None},
       AxesOrigin->{0, 2.322145208021187},
       BaseStyle->{FontFamily -> "Helvetica", 16},
       DisplayFunction->Identity,
       Frame->False,
       FrameLabel->{
         FormBox[
          StyleBox["\"x\"", 18, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         FormBox[
          StyleBox["\"\[Mu] [GeV]\"", 18, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm]},
       FrameTicks->{{{-13.815510557964274`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.02375108873622, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.86960040890896, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.512925464970229`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.903487552536127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.721165995742174, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.567015315914915, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.433483923290392, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.315700887634009, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.210340371976182, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-8.111728083308073, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.824046010856292, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.600902459542082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.418580902748127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.264430222920869, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.013115794639964, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-6.907755278982137, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.809142990314028, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.521460917862246, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.298317366548036, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.115995809754082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.961845129926823, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.710530701645918, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.605170185988091, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.506557897319982, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.995732273553991, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.659260036932778, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.3025850929940455`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-1.203972804325936, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.916290731874155, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
           FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
          0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.302585092994046, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.605170185988092, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.907755278982137, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.210340371976184, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}}, {{-13.815510557964274`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.02375108873622, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.86960040890896, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.512925464970229`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.903487552536127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.721165995742174, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.567015315914915, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.433483923290392, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.315700887634009, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.210340371976182, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-8.111728083308073, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.824046010856292, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.600902459542082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.418580902748127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.264430222920869, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.013115794639964, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-6.907755278982137, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.809142990314028, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.521460917862246, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.298317366548036, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.115995809754082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.961845129926823, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.710530701645918, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.605170185988091, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.506557897319982, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.995732273553991, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.659260036932778, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.3025850929940455`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-1.203972804325936, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.916290731874155, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
           FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
          0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.302585092994046, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.605170185988092, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.907755278982137, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.210340371976184, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}}, {{-13.815510557964274`, 
           FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
           FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
           FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
           FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
           FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
           FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
           FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
           FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
           FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
           FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
           FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
           FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
           FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
           FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
           FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
           FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
           FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
           FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
           FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
           FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
           FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
           FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
           FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm]}, {0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
           FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm]}}, {{-13.815510557964274`, 
           FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
           FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
           FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
           FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
           FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
           FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
           FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
           FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
           FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
           FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
           FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
           FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
           FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
           FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
           FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
           FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
           FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
           FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
           FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
           FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
           FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
           FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
           FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm]}, {0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
           FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm]}}},
       ImagePadding->All,
       ImageSize->{{600}, {600}},
       Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
             (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
              Part[#, 1]], 
             (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
              Part[#, 2]]}& ), "CopiedValueFunction" -> ({
             (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
              Part[#, 1]], 
             (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
              Part[#, 2]]}& )}},
       PlotLabel->FormBox[
         StyleBox["\"\"", 24, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm],
       PlotRange->Automatic,
       PlotRangeClipping->False,
       PlotRangePadding->{{0, 0}, {0, 0}},
       Ticks->{Automatic, Automatic}],
      InterpretTemplate[Legended[
        Graphics[{{{}, {{{}, {
              Hue[0.67, 0.6, 0.6], 
              Directive[
               PointSize[0.012833333333333334`], 
               AbsoluteThickness[1.6], FontFamily -> "Helvetica", 
               GrayLevel[1]], 
              
              Point[{{0.00001, 2.}, {0.99, 
               1200.}}]}, {}}}, {}, {}, {{}, {}}}, {
           Style[
            Text[
            "\[FilledCircle]", {-2.4917756376975806`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-8.040720186091876, 4.512945241945574}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-7.16677563769758, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-4.583809961884693, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-2.140720186091876, 4.512945241945574}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-8.166775637697581, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.7417756376975806`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-6.540720186091876, 4.512945241945574}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-0.7667756376975805, 4.386889790339869}],
             5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-7.66677563769758, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7667756376975805`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.2667756376975805`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2667756376975805`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.9667756376975807`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.2667756376975805`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-8.666775637697581, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7667756376975805`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-8.166775637697581, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-6.666775637697581, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.4938099618846934`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.26677563769758056`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-5.093809961884693, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-6.1138099618846935`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1407201860918759`, 4.512945241945574}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7667756376975805`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-3.4938099618846934`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-7.540720186091876, 4.512945241945574}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2938099618846937`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.2167756376975807`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2667756376975805`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-0.6407201860918759, 4.512945241945574}],
             5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.6407201860918759`, 4.512945241945574}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.0938099618846935`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-3.166775637697581, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-5.733809961884694, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-4.293809961884693, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-7.040720186091876, 4.512945241945574}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-8.666775637697581, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-3.0938099618846935`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-3.293809961884693, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-8.666775637697581, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-5.566775637697581, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.2667756376975805`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-3.8938099618846933`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.8938099618846933`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-8.166775637697581, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-5.293809961884693, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-6.666775637697581, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-5.493809961884693, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.8038099618846937`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-4.093809961884693, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-7.66677563769758, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-0.7667756376975805, 4.386889790339869}],
             5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-5.766775637697581, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-1.093809961884693, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-4.893809961884693, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2667756376975805`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-2.293809961884693, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-3.3667756376975806`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.4938099618846934`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-7.16677563769758, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-3.6938099618846936`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-7.66677563769758, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-6.666775637697581, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-5.366775637697581, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-3.5667756376975808`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-0.8938099618846936, 4.386889790339869}],
             5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.26677563769758056`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.26677563769758056`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-5.966775637697581, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.6938099618846936`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-0.7667756376975805, 4.386889790339869}],
             5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-7.16677563769758, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-3.7667756376975805`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-0.6538099618846934, 4.386889790339869}],
             5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-5.16677563769758, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-6.191775637697581, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-6.716775637697581, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-3.9667756376975807`, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-4.966775637697581, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-0.2738099618846935, 4.386889790339869}],
             5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-4.16677563769758, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-4.766775637697581, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-6.441775637697581, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-4.366775637697581, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-4.566775637697581, 4.386889790339869}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]]}}, {
         Frame -> True, 
          FrameTicks -> {{{-13.815510557964274`, 
              "\!\(\*SuperscriptBox[\(10\), \(-6\)]\)", {0.02, 
              0.}}, {-13.122363377404328`, "", {
              0.01, 0}}, {-12.716898269296165`, "", {
              0.01, 0}}, {-12.429216196844383`, "", {
              0.01, 0}}, {-12.206072645530174`, "", {
              0.01, 0}}, {-12.02375108873622, "", {
              0.01, 0}}, {-11.86960040890896, "", {
              0.01, 0}}, {-11.736069016284437`, "", {
              0.01, 0}}, {-11.618285980628055`, "", {
              0.01, 0}}, {-11.512925464970229`, 
              "\!\(\*SuperscriptBox[\(10\), \(-5\)]\)", {0.02, 
              0.}}, {-10.819778284410283`, "", {
              0.01, 0}}, {-10.414313176302118`, "", {
              0.01, 0}}, {-10.126631103850338`, "", {
              0.01, 0}}, {-9.903487552536127, "", {
              0.01, 0}}, {-9.721165995742174, "", {
              0.01, 0}}, {-9.567015315914915, "", {
              0.01, 0}}, {-9.433483923290392, "", {
              0.01, 0}}, {-9.315700887634009, "", {
              0.01, 0}}, {-9.210340371976182, 
              "\!\(\*SuperscriptBox[\(10\), \(-4\)]\)", {0.02, 
              0.}}, {-8.517193191416238, "", {0.01, 0}}, {-8.111728083308073, 
              "", {0.01, 0}}, {-7.824046010856292, "", {
              0.01, 0}}, {-7.600902459542082, "", {
              0.01, 0}}, {-7.418580902748127, "", {
              0.01, 0}}, {-7.264430222920869, "", {
              0.01, 0}}, {-7.1308988302963465`, "", {
              0.01, 0}}, {-7.013115794639964, "", {
              0.01, 0}}, {-6.907755278982137, 
              "\!\(\*SuperscriptBox[\(10\), \(-3\)]\)", {0.02, 
              0.}}, {-6.214608098422191, "", {0.01, 0}}, {-5.809142990314028, 
              "", {0.01, 0}}, {-5.521460917862246, "", {
              0.01, 0}}, {-5.298317366548036, "", {
              0.01, 0}}, {-5.115995809754082, "", {
              0.01, 0}}, {-4.961845129926823, "", {
              0.01, 0}}, {-4.8283137373023015`, "", {
              0.01, 0}}, {-4.710530701645918, "", {
              0.01, 0}}, {-4.605170185988091, 
              "\!\(\*SuperscriptBox[\(10\), \(-2\)]\)", {0.02, 
              0.}}, {-3.912023005428146, "", {0.01, 0}}, {-3.506557897319982, 
              "", {0.01, 0}}, {-3.2188758248682006`, "", {
              0.01, 0}}, {-2.995732273553991, "", {
              0.01, 0}}, {-2.8134107167600364`, "", {
              0.01, 0}}, {-2.659260036932778, "", {
              0.01, 0}}, {-2.5257286443082556`, "", {
              0.01, 0}}, {-2.4079456086518722`, "", {
              0.01, 0}}, {-2.3025850929940455`, 
              "\!\(\*SuperscriptBox[\(10\), \(-1\)]\)", {0.02, 
              0.}}, {-1.6094379124341003`, "", {
              0.01, 0}}, {-1.203972804325936, "", {
              0.01, 0}}, {-0.916290731874155, "", {
              0.01, 0}}, {-0.6931471805599453, "", {
              0.01, 0}}, {-0.5108256237659905, "", {
              0.01, 0}}, {-0.3566749439387323, "", {
              0.01, 0}}, {-0.2231435513142097, "", {
              0.01, 0}}, {-0.10536051565782628`, "", {0.01, 0}}, {
             0., "1", {0.02, 0.}}, {0.6931471805599453, "", {0.01, 0}}, {
             1.0986122886681098`, "", {0.01, 0}}, {
             1.3862943611198906`, "", {0.01, 0}}, {
             1.6094379124341003`, "", {0.01, 0}}, {
             1.791759469228055, "", {0.01, 0}}, {
             1.9459101490553132`, "", {0.01, 0}}, {
             2.0794415416798357`, "", {0.01, 0}}, {
             2.1972245773362196`, "", {0.01, 0}}, {
             2.302585092994046, "\!\(\*SuperscriptBox[\(10\), \(1\)]\)", {
              0.02, 0.}}, {2.995732273553991, "", {0.01, 0}}, {
             3.4011973816621555`, "", {0.01, 0}}, {
             3.6888794541139363`, "", {0.01, 0}}, {
             3.912023005428146, "", {0.01, 0}}, {
             4.0943445622221, "", {0.01, 0}}, {
             4.248495242049359, "", {0.01, 0}}, {
             4.382026634673881, "", {0.01, 0}}, {
             4.499809670330265, "", {0.01, 0}}, {
             4.605170185988092, "\!\(\*SuperscriptBox[\(10\), \(2\)]\)", {
              0.02, 0.}}, {5.298317366548036, "", {0.01, 0}}, {
             5.703782474656201, "", {0.01, 0}}, {
             5.991464547107982, "", {0.01, 0}}, {
             6.214608098422191, "", {0.01, 0}}, {
             6.396929655216146, "", {0.01, 0}}, {
             6.551080335043404, "", {0.01, 0}}, {
             6.684611727667927, "", {0.01, 0}}, {
             6.802394763324311, "", {0.01, 0}}, {
             6.907755278982137, "\!\(\*SuperscriptBox[\(10\), \(3\)]\)", {
              0.02, 0.}}, {7.600902459542082, "", {0.01, 0}}, {
             8.006367567650246, "", {0.01, 0}}, {
             8.294049640102028, "", {0.01, 0}}, {
             8.517193191416238, "", {0.01, 0}}, {
             8.699514748210191, "", {0.01, 0}}, {
             8.85366542803745, "", {0.01, 0}}, {
             8.987196820661973, "", {0.01, 0}}, {
             9.104979856318357, "", {0.01, 0}}, {
             9.210340371976184, "\!\(\*SuperscriptBox[\(10\), \(4\)]\)", {
              0.02, 0.}}, {9.903487552536127, "", {0.01, 0}}, {
             10.308952660644293`, "", {0.01, 0}}, {
             10.596634733096073`, "", {0.01, 0}}, {
             10.819778284410283`, "", {0.01, 0}}, {
             11.002099841204238`, "", {0.01, 0}}, {
             11.156250521031495`, "", {0.01, 0}}, {
             11.289781913656018`, "", {0.01, 0}}, {
             11.407564949312402`, "", {0.01, 0}}}, {{-13.815510557964274`, 
              "\!\(\*SuperscriptBox[\(10\), \(-6\)]\)", {0.02, 
              0.}}, {-13.122363377404328`, "", {
              0.01, 0}}, {-12.716898269296165`, "", {
              0.01, 0}}, {-12.429216196844383`, "", {
              0.01, 0}}, {-12.206072645530174`, "", {
              0.01, 0}}, {-12.02375108873622, "", {
              0.01, 0}}, {-11.86960040890896, "", {
              0.01, 0}}, {-11.736069016284437`, "", {
              0.01, 0}}, {-11.618285980628055`, "", {
              0.01, 0}}, {-11.512925464970229`, 
              "\!\(\*SuperscriptBox[\(10\), \(-5\)]\)", {0.02, 
              0.}}, {-10.819778284410283`, "", {
              0.01, 0}}, {-10.414313176302118`, "", {
              0.01, 0}}, {-10.126631103850338`, "", {
              0.01, 0}}, {-9.903487552536127, "", {
              0.01, 0}}, {-9.721165995742174, "", {
              0.01, 0}}, {-9.567015315914915, "", {
              0.01, 0}}, {-9.433483923290392, "", {
              0.01, 0}}, {-9.315700887634009, "", {
              0.01, 0}}, {-9.210340371976182, 
              "\!\(\*SuperscriptBox[\(10\), \(-4\)]\)", {0.02, 
              0.}}, {-8.517193191416238, "", {0.01, 0}}, {-8.111728083308073, 
              "", {0.01, 0}}, {-7.824046010856292, "", {
              0.01, 0}}, {-7.600902459542082, "", {
              0.01, 0}}, {-7.418580902748127, "", {
              0.01, 0}}, {-7.264430222920869, "", {
              0.01, 0}}, {-7.1308988302963465`, "", {
              0.01, 0}}, {-7.013115794639964, "", {
              0.01, 0}}, {-6.907755278982137, 
              "\!\(\*SuperscriptBox[\(10\), \(-3\)]\)", {0.02, 
              0.}}, {-6.214608098422191, "", {0.01, 0}}, {-5.809142990314028, 
              "", {0.01, 0}}, {-5.521460917862246, "", {
              0.01, 0}}, {-5.298317366548036, "", {
              0.01, 0}}, {-5.115995809754082, "", {
              0.01, 0}}, {-4.961845129926823, "", {
              0.01, 0}}, {-4.8283137373023015`, "", {
              0.01, 0}}, {-4.710530701645918, "", {
              0.01, 0}}, {-4.605170185988091, 
              "\!\(\*SuperscriptBox[\(10\), \(-2\)]\)", {0.02, 
              0.}}, {-3.912023005428146, "", {0.01, 0}}, {-3.506557897319982, 
              "", {0.01, 0}}, {-3.2188758248682006`, "", {
              0.01, 0}}, {-2.995732273553991, "", {
              0.01, 0}}, {-2.8134107167600364`, "", {
              0.01, 0}}, {-2.659260036932778, "", {
              0.01, 0}}, {-2.5257286443082556`, "", {
              0.01, 0}}, {-2.4079456086518722`, "", {
              0.01, 0}}, {-2.3025850929940455`, 
              "\!\(\*SuperscriptBox[\(10\), \(-1\)]\)", {0.02, 
              0.}}, {-1.6094379124341003`, "", {
              0.01, 0}}, {-1.203972804325936, "", {
              0.01, 0}}, {-0.916290731874155, "", {
              0.01, 0}}, {-0.6931471805599453, "", {
              0.01, 0}}, {-0.5108256237659905, "", {
              0.01, 0}}, {-0.3566749439387323, "", {
              0.01, 0}}, {-0.2231435513142097, "", {
              0.01, 0}}, {-0.10536051565782628`, "", {0.01, 0}}, {
             0., "1", {0.02, 0.}}, {0.6931471805599453, "", {0.01, 0}}, {
             1.0986122886681098`, "", {0.01, 0}}, {
             1.3862943611198906`, "", {0.01, 0}}, {
             1.6094379124341003`, "", {0.01, 0}}, {
             1.791759469228055, "", {0.01, 0}}, {
             1.9459101490553132`, "", {0.01, 0}}, {
             2.0794415416798357`, "", {0.01, 0}}, {
             2.1972245773362196`, "", {0.01, 0}}, {
             2.302585092994046, "\!\(\*SuperscriptBox[\(10\), \(1\)]\)", {
              0.02, 0.}}, {2.995732273553991, "", {0.01, 0}}, {
             3.4011973816621555`, "", {0.01, 0}}, {
             3.6888794541139363`, "", {0.01, 0}}, {
             3.912023005428146, "", {0.01, 0}}, {
             4.0943445622221, "", {0.01, 0}}, {
             4.248495242049359, "", {0.01, 0}}, {
             4.382026634673881, "", {0.01, 0}}, {
             4.499809670330265, "", {0.01, 0}}, {
             4.605170185988092, "\!\(\*SuperscriptBox[\(10\), \(2\)]\)", {
              0.02, 0.}}, {5.298317366548036, "", {0.01, 0}}, {
             5.703782474656201, "", {0.01, 0}}, {
             5.991464547107982, "", {0.01, 0}}, {
             6.214608098422191, "", {0.01, 0}}, {
             6.396929655216146, "", {0.01, 0}}, {
             6.551080335043404, "", {0.01, 0}}, {
             6.684611727667927, "", {0.01, 0}}, {
             6.802394763324311, "", {0.01, 0}}, {
             6.907755278982137, "\!\(\*SuperscriptBox[\(10\), \(3\)]\)", {
              0.02, 0.}}, {7.600902459542082, "", {0.01, 0}}, {
             8.006367567650246, "", {0.01, 0}}, {
             8.294049640102028, "", {0.01, 0}}, {
             8.517193191416238, "", {0.01, 0}}, {
             8.699514748210191, "", {0.01, 0}}, {
             8.85366542803745, "", {0.01, 0}}, {
             8.987196820661973, "", {0.01, 0}}, {
             9.104979856318357, "", {0.01, 0}}, {
             9.210340371976184, "\!\(\*SuperscriptBox[\(10\), \(4\)]\)", {
              0.02, 0.}}, {9.903487552536127, "", {0.01, 0}}, {
             10.308952660644293`, "", {0.01, 0}}, {
             10.596634733096073`, "", {0.01, 0}}, {
             10.819778284410283`, "", {0.01, 0}}, {
             11.002099841204238`, "", {0.01, 0}}, {
             11.156250521031495`, "", {0.01, 0}}, {
             11.289781913656018`, "", {0.01, 0}}, {
             11.407564949312402`, "", {0.01, 0}}}, {{-13.815510557964274`, 
              ""}, {-13.122363377404328`, ""}, {-12.716898269296165`, 
              ""}, {-12.429216196844383`, ""}, {-12.206072645530174`, 
              ""}, {-12.02375108873622, ""}, {-11.86960040890896, 
              ""}, {-11.736069016284437`, ""}, {-11.618285980628055`, 
              ""}, {-11.512925464970229`, ""}, {-10.819778284410283`, 
              ""}, {-10.414313176302118`, ""}, {-10.126631103850338`, 
              ""}, {-9.903487552536127, ""}, {-9.721165995742174, 
              ""}, {-9.567015315914915, ""}, {-9.433483923290392, 
              ""}, {-9.315700887634009, ""}, {-9.210340371976182, 
              ""}, {-8.517193191416238, ""}, {-8.111728083308073, 
              ""}, {-7.824046010856292, ""}, {-7.600902459542082, 
              ""}, {-7.418580902748127, ""}, {-7.264430222920869, 
              ""}, {-7.1308988302963465`, ""}, {-7.013115794639964, 
              ""}, {-6.907755278982137, ""}, {-6.214608098422191, 
              ""}, {-5.809142990314028, ""}, {-5.521460917862246, 
              ""}, {-5.298317366548036, ""}, {-5.115995809754082, 
              ""}, {-4.961845129926823, ""}, {-4.8283137373023015`, 
              ""}, {-4.710530701645918, ""}, {-4.605170185988091, 
              ""}, {-3.912023005428146, ""}, {-3.506557897319982, 
              ""}, {-3.2188758248682006`, ""}, {-2.995732273553991, 
              ""}, {-2.8134107167600364`, ""}, {-2.659260036932778, 
              ""}, {-2.5257286443082556`, ""}, {-2.4079456086518722`, 
              ""}, {-2.3025850929940455`, ""}, {-1.6094379124341003`, 
              ""}, {-1.203972804325936, ""}, {-0.916290731874155, 
              ""}, {-0.6931471805599453, ""}, {-0.5108256237659905, 
              ""}, {-0.3566749439387323, ""}, {-0.2231435513142097, 
              ""}, {-0.10536051565782628`, ""}, {0., ""}, {
             0.6931471805599453, ""}, {1.0986122886681098`, ""}, {
             1.3862943611198906`, ""}, {1.6094379124341003`, ""}, {
             1.791759469228055, ""}, {1.9459101490553132`, ""}, {
             2.0794415416798357`, ""}, {2.1972245773362196`, ""}, {
             2.302585092994046, ""}, {2.995732273553991, ""}, {
             3.4011973816621555`, ""}, {3.6888794541139363`, ""}, {
             3.912023005428146, ""}, {4.0943445622221, ""}, {
             4.248495242049359, ""}, {4.382026634673881, ""}, {
             4.499809670330265, ""}, {4.605170185988092, ""}, {
             5.298317366548036, ""}, {5.703782474656201, ""}, {
             5.991464547107982, ""}, {6.214608098422191, ""}, {
             6.396929655216146, ""}, {6.551080335043404, ""}, {
             6.684611727667927, ""}, {6.802394763324311, ""}, {
             6.907755278982137, ""}, {7.600902459542082, ""}, {
             8.006367567650246, ""}, {8.294049640102028, ""}, {
             8.517193191416238, ""}, {8.699514748210191, ""}, {
             8.85366542803745, ""}, {8.987196820661973, ""}, {
             9.104979856318357, ""}, {9.210340371976184, ""}, {
             9.903487552536127, ""}, {10.308952660644293`, ""}, {
             10.596634733096073`, ""}, {10.819778284410283`, ""}, {
             11.002099841204238`, ""}, {11.156250521031495`, ""}, {
             11.289781913656018`, ""}, {
             11.407564949312402`, ""}}, {{-13.815510557964274`, 
              ""}, {-13.122363377404328`, ""}, {-12.716898269296165`, 
              ""}, {-12.429216196844383`, ""}, {-12.206072645530174`, 
              ""}, {-12.02375108873622, ""}, {-11.86960040890896, 
              ""}, {-11.736069016284437`, ""}, {-11.618285980628055`, 
              ""}, {-11.512925464970229`, ""}, {-10.819778284410283`, 
              ""}, {-10.414313176302118`, ""}, {-10.126631103850338`, 
              ""}, {-9.903487552536127, ""}, {-9.721165995742174, 
              ""}, {-9.567015315914915, ""}, {-9.433483923290392, 
              ""}, {-9.315700887634009, ""}, {-9.210340371976182, 
              ""}, {-8.517193191416238, ""}, {-8.111728083308073, 
              ""}, {-7.824046010856292, ""}, {-7.600902459542082, 
              ""}, {-7.418580902748127, ""}, {-7.264430222920869, 
              ""}, {-7.1308988302963465`, ""}, {-7.013115794639964, 
              ""}, {-6.907755278982137, ""}, {-6.214608098422191, 
              ""}, {-5.809142990314028, ""}, {-5.521460917862246, 
              ""}, {-5.298317366548036, ""}, {-5.115995809754082, 
              ""}, {-4.961845129926823, ""}, {-4.8283137373023015`, 
              ""}, {-4.710530701645918, ""}, {-4.605170185988091, 
              ""}, {-3.912023005428146, ""}, {-3.506557897319982, 
              ""}, {-3.2188758248682006`, ""}, {-2.995732273553991, 
              ""}, {-2.8134107167600364`, ""}, {-2.659260036932778, 
              ""}, {-2.5257286443082556`, ""}, {-2.4079456086518722`, 
              ""}, {-2.3025850929940455`, ""}, {-1.6094379124341003`, 
              ""}, {-1.203972804325936, ""}, {-0.916290731874155, 
              ""}, {-0.6931471805599453, ""}, {-0.5108256237659905, 
              ""}, {-0.3566749439387323, ""}, {-0.2231435513142097, 
              ""}, {-0.10536051565782628`, ""}, {0., ""}, {
             0.6931471805599453, ""}, {1.0986122886681098`, ""}, {
             1.3862943611198906`, ""}, {1.6094379124341003`, ""}, {
             1.791759469228055, ""}, {1.9459101490553132`, ""}, {
             2.0794415416798357`, ""}, {2.1972245773362196`, ""}, {
             2.302585092994046, ""}, {2.995732273553991, ""}, {
             3.4011973816621555`, ""}, {3.6888794541139363`, ""}, {
             3.912023005428146, ""}, {4.0943445622221, ""}, {
             4.248495242049359, ""}, {4.382026634673881, ""}, {
             4.499809670330265, ""}, {4.605170185988092, ""}, {
             5.298317366548036, ""}, {5.703782474656201, ""}, {
             5.991464547107982, ""}, {6.214608098422191, ""}, {
             6.396929655216146, ""}, {6.551080335043404, ""}, {
             6.684611727667927, ""}, {6.802394763324311, ""}, {
             6.907755278982137, ""}, {7.600902459542082, ""}, {
             8.006367567650246, ""}, {8.294049640102028, ""}, {
             8.517193191416238, ""}, {8.699514748210191, ""}, {
             8.85366542803745, ""}, {8.987196820661973, ""}, {
             9.104979856318357, ""}, {9.210340371976184, ""}, {
             9.903487552536127, ""}, {10.308952660644293`, ""}, {
             10.596634733096073`, ""}, {10.819778284410283`, ""}, {
             11.002099841204238`, ""}, {11.156250521031495`, ""}, {
             11.289781913656018`, ""}, {11.407564949312402`, ""}}}, Axes -> 
          False, PlotLabel -> Style["", 24, 
            GrayLevel[0]], FrameLabel -> {
            Style["x", 18, 
             GrayLevel[0]], 
            Style["\[Mu] [GeV]", 18, 
             GrayLevel[0]]}, ImageSize -> {{600}, {600}}, AspectRatio -> 1, 
          DisplayFunction -> Identity, PlotRangePadding -> {{0, 0}, {0, 0}}, 
          AxesOrigin -> {0, 2.322145208021187}, 
          PlotRange -> {{-11.512925464970229`, 0}, {2.302585092994046, 
            6.214608098422191}}, PlotRangeClipping -> True, ImagePadding -> 
          All, DisplayFunction -> Identity, AspectRatio -> 1, 
          Axes -> {True, True}, AxesLabel -> {None, None}, 
          AxesOrigin -> {0, 2.322145208021187}, DisplayFunction :> Identity, 
          Epilog -> {{
             Text[
              Style["Npt: 86", 16, 
               GrayLevel[0]], 
              Scaled[{0.1, 0.9}]], 
             Text[
              Style["highlighted range:\n{0.7, 100.}", 16, 
               GrayLevel[0]], 
              Scaled[{0.2, 0.7}]]}, {{
              Text[
               Style["Npt: 86", 16, 
                GrayLevel[0]], 
               Scaled[{0.1, 0.9}]], 
              Text[
               Style["highlighted range:\n{0.7, 100.}", 16, 
                GrayLevel[0]], 
               Scaled[{0.2, 0.7}]]}}}, 
          Frame -> {{False, False}, {False, False}}, 
          FrameLabel -> {{None, None}, {None, None}}, 
          FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
          GridLines -> {None, None}, GridLinesStyle -> Directive[
            GrayLevel[0.5, 0.4]], 
          Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& )}}, 
          PlotRange -> {{-11.512925464970229`, 0}, {2.302585092994046, 
            6.214608098422191}}, PlotRangeClipping -> True, 
          PlotRangePadding -> {{0, 0}, {0, 0}}, 
          Ticks -> {Automatic, Automatic}}], 
        Placed[
         Unevaluated[
          BarLegend[{{
             RGBColor[0., 0., 0.7], 
             RGBColor[0., 0.35, 0.7], 
             RGBColor[0., 0.7, 0.7], 
             RGBColor[
             0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
             RGBColor[0.7, 0.56, 0.], 
             RGBColor[0.7, 0.28, 0.], 
             RGBColor[0.7, 0., 0.]}, {-100, 100}}, {-100, -0.85, -0.7, -0.5, 
            0.5, 0.7, 0.85, 100}, LabelStyle -> {FontSize -> 14}, LegendLabel -> 
           "", LegendLayout -> "Column", LegendMarkerSize -> {}, 
           Charting`TickAnnotations -> None, Charting`TickSide -> Right, 
           ColorFunctionScaling -> True]], {1., 0.5}, Identity]]& ],
      AutoDelete->True,
      Editable->True,
      SelectWithContents->False,
      Selectable->True], ",", 
     TagBox[GridBox[{
        {
         InterpretationBox[Cell[BoxData[
           FormBox[
            
            StyleBox["\<\"Sensitivity to s(x,\[Mu]), CT14HERA2NNLO\\n\\n\"\>",
             
             StripOnInput->False,
             FontSize->24], TextForm]], "InlineText"],
          Text[
           Style[
           "Sensitivity to s(x,\[Mu]), CT14HERA2NNLO\n\n", FontSize -> 24]]], 
         "\[SpanFromLeft]", "\[SpanFromLeft]"},
        {"\<\"Data Sets\"\>", "", ""},
        {"\<\"None(240)\"\>", "\<\"None(241)\"\>", "\<\"None(281)\"\>"},
        {"\<\"None(266)\"\>", "", ""}
       },
       AutoDelete->False,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{14}}},
       GridBoxItemStyle->{"Columns" -> {{
            Directive[FontSize -> 18, 
             GrayLevel[0]]}}, "Rows" -> {{
            Directive[FontSize -> 18, 
             GrayLevel[0]]}}}],
      "Grid"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     GraphicsBox[{
       {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
        EdgeForm[{Opacity[0.5459999999999999], Thickness[Small]}], {}, 
        {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
         EdgeForm[{Opacity[0.5459999999999999], Thickness[Small]}], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{-0.5, 0}, {-0.4, 5}, "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{186.99999999999994`, 212.09999999999997`}, {
              165.30208333333337`, 232.00000000000003`}}],
            StatusArea[#, 5]& ,
            TagBoxNote->"5"],
           StyleBox["5", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[5, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              
              RectangleBox[{-0.4, 0}, {-0.30000000000000004`, 2}, 
               "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{211.59999999999997`, 236.69999999999993`}, {
              205.02083333333337`, 232.00000000000003`}}],
            StatusArea[#, 2]& ,
            TagBoxNote->"2"],
           StyleBox["2", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[2, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              
              RectangleBox[{-0.30000000000000004`, 0}, {-0.2, 1}, 
               "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{236.19999999999993`, 261.29999999999995`}, {
              218.26041666666669`, 232.00000000000003`}}],
            StatusArea[#, 1]& ,
            TagBoxNote->"1"],
           StyleBox["1", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[1, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{-0.2, 0}, {-0.1, 3}, "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{260.79999999999995`, 285.8999999999999}, {
              191.78125000000003`, 232.00000000000003`}}],
            StatusArea[#, 3]& ,
            TagBoxNote->"3"],
           StyleBox["3", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[3, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{-0.1, 0}, {0., 23}, "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{285.3999999999999, 
              310.49999999999994`}, {-73.0104166666666, 232.00000000000003`}}],
            StatusArea[#, 23]& ,
            TagBoxNote->"23"],
           StyleBox["23", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[23, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{0., 0}, {0.1, 36}, "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{309.99999999999994`, 
              335.09999999999997`}, {-245.12499999999991`, 
              232.00000000000003`}}],
            StatusArea[#, 36]& ,
            TagBoxNote->"36"],
           StyleBox["36", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[36, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{0.1, 0}, {0.2, 7}, "RoundingRadius" -> 0]},
             ImageSizeCache->{{334.59999999999997`, 359.69999999999993`}, {
              138.82291666666669`, 232.00000000000003`}}],
            StatusArea[#, 7]& ,
            TagBoxNote->"7"],
           StyleBox["7", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[7, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              
              RectangleBox[{0.2, 0}, {0.30000000000000004`, 4}, 
               "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{359.19999999999993`, 384.29999999999995`}, {
              178.54166666666669`, 232.00000000000003`}}],
            StatusArea[#, 4]& ,
            TagBoxNote->"4"],
           StyleBox["4", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[4, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              
              RectangleBox[{0.30000000000000004`, 0}, {0.4, 3}, 
               "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{383.79999999999995`, 408.8999999999999}, {
              191.78125000000003`, 232.00000000000003`}}],
            StatusArea[#, 3]& ,
            TagBoxNote->"3"],
           StyleBox["3", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[3, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{0.4, 0}, {0.5, 2}, "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{408.3999999999999, 433.49999999999994`}, {
              205.02083333333337`, 232.00000000000003`}}],
            StatusArea[#, 2]& ,
            TagBoxNote->"2"],
           StyleBox["2", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[2, {}], 
           "Tooltip"]& ]}, {}, {}}, {{}, {}, {}, {}, {}, {}, {}, {}, {}, {}}},
      
      AspectRatio->1,
      Axes->False,
      AxesLabel->{None, None},
      AxesOrigin->{-1.04, 0.},
      BaseStyle->{FontSize -> 16},
      Epilog->{{{
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[1, 0, 0], StripOnInput -> False], TraditionalForm], {-1,
             35.46}], 
          StyleBox[
           LineBox[{{-1, 0.}, {-1, 34.199999999999996`}}], 
           RGBColor[1, 0, 0], StripOnInput -> False]}, {
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[1, 0, 0], StripOnInput -> False], TraditionalForm], {
           1, 34.019999999999996`}], 
          StyleBox[
           LineBox[{{1, 0.}, {1, 34.199999999999996`}}], 
           RGBColor[1, 0, 0], StripOnInput -> False]}}, 
        InsetBox[
         FormBox[
          StyleBox["\"Npt: 86\"", 16, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         Scaled[{0.1, 0.9}]]},
      Frame->True,
      FrameLabel->{
        FormBox[
         StyleBox["\"Sensitivity to s(x,\[Mu]), CT14HERA2NNLO\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm], 
        FormBox[
         StyleBox["\"#points\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm]},
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImageSize->{{600}, {600}},
      PlotLabel->FormBox[
        StyleBox["\"\"", 24, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{-1., 1.}, {0., 36}},
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}], ",", 
     GraphicsBox[{
       {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
        EdgeForm[{Opacity[0.616], Thickness[Small]}], {}, 
        {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
         EdgeForm[{Opacity[0.616], Thickness[Small]}], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{0., 0}, {0.1, 59}, "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{64., 
              113.70000000000002`}, {-245.12500000000003`, 
              232.00000000000003`}}],
            StatusArea[#, 59]& ,
            TagBoxNote->"59"],
           StyleBox["59", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[59, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{0.1, 0}, {0.2, 10}, "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{113.20000000000002`, 162.90000000000003`}, {
              150.71610169491527`, 232.00000000000003`}}],
            StatusArea[#, 10]& ,
            TagBoxNote->"10"],
           StyleBox["10", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[10, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              
              RectangleBox[{0.2, 0}, {0.30000000000000004`, 5}, 
               "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{162.40000000000003`, 212.10000000000005`}, {
              191.10805084745766`, 232.00000000000003`}}],
            StatusArea[#, 5]& ,
            TagBoxNote->"5"],
           StyleBox["5", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[5, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              
              RectangleBox[{0.30000000000000004`, 0}, {0.4, 5}, 
               "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{211.60000000000005`, 261.30000000000007`}, {
              191.10805084745766`, 232.00000000000003`}}],
            StatusArea[#, 5]& ,
            TagBoxNote->"5"],
           StyleBox["5", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[5, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{0.4, 0}, {0.5, 7}, "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{260.80000000000007`, 310.50000000000006`}, {
              174.9512711864407, 232.00000000000003`}}],
            StatusArea[#, 7]& ,
            TagBoxNote->"7"],
           StyleBox["7", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[7, {}], "Tooltip"]& ]}, {}, {}}, {{}, {}, {}, {}, {}}},
      AspectRatio->1,
      Axes->False,
      AxesLabel->{None, None},
      AxesOrigin->{-0.02, 0.},
      BaseStyle->{FontSize -> 16},
      Epilog->{{{
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[1, 0, 0], StripOnInput -> False], TraditionalForm], {
           1, 58.114999999999995`}], 
          StyleBox[
           LineBox[{{1, 0.}, {1, 56.05}}], 
           RGBColor[1, 0, 0], StripOnInput -> False]}}, 
        InsetBox[
         FormBox[
          StyleBox["\"Npt: 86\"", 16, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         Scaled[{0.1, 0.9}]]},
      Frame->True,
      FrameLabel->{
        FormBox[
         StyleBox["\"| Sensitivity to s(x,\[Mu]), CT14HERA2NNLO |\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm], 
        FormBox[
         StyleBox["\"#points\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm]},
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImageSize->{{600}, {600}},
      PlotLabel->FormBox[
        StyleBox["\"\"", 24, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{0., 1.}, {0., 59}},
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.704086907726718*^9, {3.704086966021594*^9, 3.704086984824479*^9}, {
   3.704087044297085*^9, 3.70408704860987*^9}, {3.7040872164965563`*^9, 
   3.70408727562838*^9}, 3.704087744538776*^9, 3.7040883123707047`*^9, 
   3.704572057433338*^9, 3.704572258652215*^9, {3.704573915549471*^9, 
   3.704573928051589*^9}, 3.704573962941943*^9, {3.705297170060492*^9, 
   3.7052971776244707`*^9}}]
}, Open  ]],

Cell[BoxData["residualdataclassfinal"], "Input",
 CellChangeTimes->{3.708406434398141*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"\"\<label\>\"", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<x\>\"", ",", "\"\<Q\>\"", ",", "\"\<residual\>\""}], 
        "}"}]}], ",", 
      RowBox[{"\"\<data\>\"", "\[Rule]", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"\"\<exptinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<exptid\>\"", "\[Rule]", "225"}], ",", 
         RowBox[{"\"\<exptname\>\"", "\[Rule]", "\"\<cdfLasy\>\""}], ",", 
         RowBox[{"\"\<feyndiagram\>\"", "\[Rule]", "\"\<unset\>\""}]}], 
        "\[RightAssociation]"}]}], ",", 
      RowBox[{"\"\<PDFinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<PDFname\>\"", "\[Rule]", "\"\<CT14HERA2NNLO\>\""}], ",", 
         RowBox[{"\"\<PDFsetmethod\>\"", "\[Rule]", "\"\<Hessian\>\""}], ",", 
         
         RowBox[{"\"\<Nset\>\"", "\[Rule]", "57"}], ",", 
         RowBox[{"\"\<iset\>\"", "\[Rule]", "\"\<unset\>\""}], ",", 
         RowBox[{"\"\<flavour\>\"", "\[Rule]", 
          RowBox[{"-", "5"}]}]}], "\[RightAssociation]"}]}]}], 
     "\[RightAssociation]"}], ",", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"\"\<label\>\"", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<x\>\"", ",", "\"\<Q\>\"", ",", "\"\<residual\>\""}], 
        "}"}]}], ",", 
      RowBox[{"\"\<data\>\"", "\[Rule]", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"\"\<exptinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<exptid\>\"", "\[Rule]", "225"}], ",", 
         RowBox[{"\"\<exptname\>\"", "\[Rule]", "\"\<cdfLasy\>\""}], ",", 
         RowBox[{"\"\<feyndiagram\>\"", "\[Rule]", "\"\<unset\>\""}]}], 
        "\[RightAssociation]"}]}], ",", 
      RowBox[{"\"\<PDFinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<PDFname\>\"", "\[Rule]", "\"\<CT14HERA2NNLO\>\""}], ",", 
         RowBox[{"\"\<PDFsetmethod\>\"", "\[Rule]", "\"\<Hessian\>\""}], ",", 
         
         RowBox[{"\"\<Nset\>\"", "\[Rule]", "57"}], ",", 
         RowBox[{"\"\<iset\>\"", "\[Rule]", "\"\<unset\>\""}], ",", 
         RowBox[{"\"\<flavour\>\"", "\[Rule]", 
          RowBox[{"-", "4"}]}]}], "\[RightAssociation]"}]}]}], 
     "\[RightAssociation]"}], ",", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"\"\<label\>\"", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<x\>\"", ",", "\"\<Q\>\"", ",", "\"\<residual\>\""}], 
        "}"}]}], ",", 
      RowBox[{"\"\<data\>\"", "\[Rule]", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"\"\<exptinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<exptid\>\"", "\[Rule]", "225"}], ",", 
         RowBox[{"\"\<exptname\>\"", "\[Rule]", "\"\<cdfLasy\>\""}], ",", 
         RowBox[{"\"\<feyndiagram\>\"", "\[Rule]", "\"\<unset\>\""}]}], 
        "\[RightAssociation]"}]}], ",", 
      RowBox[{"\"\<PDFinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<PDFname\>\"", "\[Rule]", "\"\<CT14HERA2NNLO\>\""}], ",", 
         RowBox[{"\"\<PDFsetmethod\>\"", "\[Rule]", "\"\<Hessian\>\""}], ",", 
         
         RowBox[{"\"\<Nset\>\"", "\[Rule]", "57"}], ",", 
         RowBox[{"\"\<iset\>\"", "\[Rule]", "\"\<unset\>\""}], ",", 
         RowBox[{"\"\<flavour\>\"", "\[Rule]", 
          RowBox[{"-", "3"}]}]}], "\[RightAssociation]"}]}]}], 
     "\[RightAssociation]"}], ",", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"\"\<label\>\"", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<x\>\"", ",", "\"\<Q\>\"", ",", "\"\<residual\>\""}], 
        "}"}]}], ",", 
      RowBox[{"\"\<data\>\"", "\[Rule]", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"\"\<exptinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<exptid\>\"", "\[Rule]", "225"}], ",", 
         RowBox[{"\"\<exptname\>\"", "\[Rule]", "\"\<cdfLasy\>\""}], ",", 
         RowBox[{"\"\<feyndiagram\>\"", "\[Rule]", "\"\<unset\>\""}]}], 
        "\[RightAssociation]"}]}], ",", 
      RowBox[{"\"\<PDFinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<PDFname\>\"", "\[Rule]", "\"\<CT14HERA2NNLO\>\""}], ",", 
         RowBox[{"\"\<PDFsetmethod\>\"", "\[Rule]", "\"\<Hessian\>\""}], ",", 
         
         RowBox[{"\"\<Nset\>\"", "\[Rule]", "57"}], ",", 
         RowBox[{"\"\<iset\>\"", "\[Rule]", "\"\<unset\>\""}], ",", 
         RowBox[{"\"\<flavour\>\"", "\[Rule]", 
          RowBox[{"-", "2"}]}]}], "\[RightAssociation]"}]}]}], 
     "\[RightAssociation]"}], ",", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"\"\<label\>\"", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<x\>\"", ",", "\"\<Q\>\"", ",", "\"\<residual\>\""}], 
        "}"}]}], ",", 
      RowBox[{"\"\<data\>\"", "\[Rule]", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"\"\<exptinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<exptid\>\"", "\[Rule]", "225"}], ",", 
         RowBox[{"\"\<exptname\>\"", "\[Rule]", "\"\<cdfLasy\>\""}], ",", 
         RowBox[{"\"\<feyndiagram\>\"", "\[Rule]", "\"\<unset\>\""}]}], 
        "\[RightAssociation]"}]}], ",", 
      RowBox[{"\"\<PDFinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<PDFname\>\"", "\[Rule]", "\"\<CT14HERA2NNLO\>\""}], ",", 
         RowBox[{"\"\<PDFsetmethod\>\"", "\[Rule]", "\"\<Hessian\>\""}], ",", 
         
         RowBox[{"\"\<Nset\>\"", "\[Rule]", "57"}], ",", 
         RowBox[{"\"\<iset\>\"", "\[Rule]", "\"\<unset\>\""}], ",", 
         RowBox[{"\"\<flavour\>\"", "\[Rule]", 
          RowBox[{"-", "1"}]}]}], "\[RightAssociation]"}]}]}], 
     "\[RightAssociation]"}], ",", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"\"\<label\>\"", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<x\>\"", ",", "\"\<Q\>\"", ",", "\"\<residual\>\""}], 
        "}"}]}], ",", 
      RowBox[{"\"\<data\>\"", "\[Rule]", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"\"\<exptinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<exptid\>\"", "\[Rule]", "225"}], ",", 
         RowBox[{"\"\<exptname\>\"", "\[Rule]", "\"\<cdfLasy\>\""}], ",", 
         RowBox[{"\"\<feyndiagram\>\"", "\[Rule]", "\"\<unset\>\""}]}], 
        "\[RightAssociation]"}]}], ",", 
      RowBox[{"\"\<PDFinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<PDFname\>\"", "\[Rule]", "\"\<CT14HERA2NNLO\>\""}], ",", 
         RowBox[{"\"\<PDFsetmethod\>\"", "\[Rule]", "\"\<Hessian\>\""}], ",", 
         
         RowBox[{"\"\<Nset\>\"", "\[Rule]", "57"}], ",", 
         RowBox[{"\"\<iset\>\"", "\[Rule]", "\"\<unset\>\""}], ",", 
         RowBox[{"\"\<flavour\>\"", "\[Rule]", "0"}]}], 
        "\[RightAssociation]"}]}]}], "\[RightAssociation]"}], ",", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"\"\<label\>\"", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<x\>\"", ",", "\"\<Q\>\"", ",", "\"\<residual\>\""}], 
        "}"}]}], ",", 
      RowBox[{"\"\<data\>\"", "\[Rule]", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"\"\<exptinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<exptid\>\"", "\[Rule]", "225"}], ",", 
         RowBox[{"\"\<exptname\>\"", "\[Rule]", "\"\<cdfLasy\>\""}], ",", 
         RowBox[{"\"\<feyndiagram\>\"", "\[Rule]", "\"\<unset\>\""}]}], 
        "\[RightAssociation]"}]}], ",", 
      RowBox[{"\"\<PDFinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<PDFname\>\"", "\[Rule]", "\"\<CT14HERA2NNLO\>\""}], ",", 
         RowBox[{"\"\<PDFsetmethod\>\"", "\[Rule]", "\"\<Hessian\>\""}], ",", 
         
         RowBox[{"\"\<Nset\>\"", "\[Rule]", "57"}], ",", 
         RowBox[{"\"\<iset\>\"", "\[Rule]", "\"\<unset\>\""}], ",", 
         RowBox[{"\"\<flavour\>\"", "\[Rule]", "1"}]}], 
        "\[RightAssociation]"}]}]}], "\[RightAssociation]"}], ",", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"\"\<label\>\"", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<x\>\"", ",", "\"\<Q\>\"", ",", "\"\<residual\>\""}], 
        "}"}]}], ",", 
      RowBox[{"\"\<data\>\"", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"LF", "[", 
          RowBox[{
          "0.17256153384559803`", ",", "80.39`", ",", "1.971732954545455`"}], 
          "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.1855112310794266`", ",", "80.39`", ",", "1.971732954545455`"}], 
          "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.19917645454180155`", ",", "80.39`", ",", "1.971732954545455`"}], 
          "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.21358308834796036`", ",", "80.39`", ",", "1.971732954545455`"}], 
          "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.22875747653402578`", ",", "80.39`", ",", "1.971732954545455`"}], 
          "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.2447264230570053`", ",", "80.39`", ",", "1.971732954545455`"}], 
          "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.261517191794792`", ",", "80.39`", ",", "1.971732954545455`"}], 
          "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.16030193864596357`", ",", "80.39`", ",", 
           RowBox[{"-", "0.13771569433032135`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.17256153384559803`", ",", "80.39`", ",", 
           RowBox[{"-", "0.13771569433032135`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.1855112310794266`", ",", "80.39`", ",", 
           RowBox[{"-", "0.13771569433032135`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.19917645454180155`", ",", "80.39`", ",", 
           RowBox[{"-", "0.13771569433032135`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.21358308834796036`", ",", "80.39`", ",", 
           RowBox[{"-", "0.13771569433032135`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.22875747653402578`", ",", "80.39`", ",", 
           RowBox[{"-", "0.13771569433032135`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.2447264230570053`", ",", "80.39`", ",", 
           RowBox[{"-", "0.13771569433032135`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.261517191794792`", ",", "80.39`", ",", 
           RowBox[{"-", "0.13771569433032135`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.2791575065461639`", ",", "80.39`", ",", 
           RowBox[{"-", "0.13771569433032135`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.29767555103078436`", ",", "80.39`", ",", 
           RowBox[{"-", "0.13771569433032135`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.3170999688892017`", ",", "80.39`", ",", 
           RowBox[{"-", "0.13771569433032135`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.33745986368284964`", ",", "80.39`", ",", 
           RowBox[{"-", "0.13771569433032135`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.17256153384559803`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.1855112310794266`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.19917645454180155`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.21358308834796036`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.22875747653402578`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.2447264230570053`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.261517191794792`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.2791575065461639`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.29767555103078436`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.3170999688892017`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.33745986368284964`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.35878479889404674`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.38110479792599694`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.17256153384559803`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.1855112310794266`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.19917645454180155`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.21358308834796036`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.22875747653402578`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.2447264230570053`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.261517191794792`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.2791575065461639`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.29767555103078436`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.3170999688892017`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.33745986368284964`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.35878479889404674`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.38110479792599694`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.4044503441027893`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.1855112310794266`", ",", "80.39`", ",", "0.0921636917718761`"}], 
          "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.19917645454180155`", ",", "80.39`", ",", "0.0921636917718761`"}],
           "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.21358308834796036`", ",", "80.39`", ",", "0.0921636917718761`"}],
           "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.22875747653402578`", ",", "80.39`", ",", "0.0921636917718761`"}],
           "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.2447264230570053`", ",", "80.39`", ",", "0.0921636917718761`"}], 
          "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.261517191794792`", ",", "80.39`", ",", "0.0921636917718761`"}], 
          "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.2791575065461639`", ",", "80.39`", ",", "0.0921636917718761`"}], 
          "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.29767555103078436`", ",", "80.39`", ",", "0.0921636917718761`"}],
           "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.3170999688892017`", ",", "80.39`", ",", "0.0921636917718761`"}], 
          "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.33745986368284964`", ",", "80.39`", ",", "0.0921636917718761`"}],
           "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.35878479889404674`", ",", "80.39`", ",", "0.0921636917718761`"}],
           "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.38110479792599694`", ",", "80.39`", ",", "0.0921636917718761`"}],
           "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.4044503441027893`", ",", "80.39`", ",", "0.0921636917718761`"}], 
          "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.42885238066939807`", ",", "80.39`", ",", "0.0921636917718761`"}],
           "]"}]}], "}"}]}], ",", 
      RowBox[{"\"\<exptinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<exptid\>\"", "\[Rule]", "225"}], ",", 
         RowBox[{"\"\<exptname\>\"", "\[Rule]", "\"\<cdfLasy\>\""}], ",", 
         RowBox[{"\"\<feyndiagram\>\"", "\[Rule]", "\"\<unset\>\""}]}], 
        "\[RightAssociation]"}]}], ",", 
      RowBox[{"\"\<PDFinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<PDFname\>\"", "\[Rule]", "\"\<CT14HERA2NNLO\>\""}], ",", 
         RowBox[{"\"\<PDFsetmethod\>\"", "\[Rule]", "\"\<Hessian\>\""}], ",", 
         
         RowBox[{"\"\<Nset\>\"", "\[Rule]", "57"}], ",", 
         RowBox[{"\"\<iset\>\"", "\[Rule]", "\"\<unset\>\""}], ",", 
         RowBox[{"\"\<flavour\>\"", "\[Rule]", "2"}]}], 
        "\[RightAssociation]"}]}]}], "\[RightAssociation]"}], ",", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"\"\<label\>\"", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<x\>\"", ",", "\"\<Q\>\"", ",", "\"\<residual\>\""}], 
        "}"}]}], ",", 
      RowBox[{"\"\<data\>\"", "\[Rule]", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"\"\<exptinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<exptid\>\"", "\[Rule]", "225"}], ",", 
         RowBox[{"\"\<exptname\>\"", "\[Rule]", "\"\<cdfLasy\>\""}], ",", 
         RowBox[{"\"\<feyndiagram\>\"", "\[Rule]", "\"\<unset\>\""}]}], 
        "\[RightAssociation]"}]}], ",", 
      RowBox[{"\"\<PDFinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<PDFname\>\"", "\[Rule]", "\"\<CT14HERA2NNLO\>\""}], ",", 
         RowBox[{"\"\<PDFsetmethod\>\"", "\[Rule]", "\"\<Hessian\>\""}], ",", 
         
         RowBox[{"\"\<Nset\>\"", "\[Rule]", "57"}], ",", 
         RowBox[{"\"\<iset\>\"", "\[Rule]", "\"\<unset\>\""}], ",", 
         RowBox[{"\"\<flavour\>\"", "\[Rule]", "3"}]}], 
        "\[RightAssociation]"}]}]}], "\[RightAssociation]"}], ",", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"\"\<label\>\"", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<x\>\"", ",", "\"\<Q\>\"", ",", "\"\<residual\>\""}], 
        "}"}]}], ",", 
      RowBox[{"\"\<data\>\"", "\[Rule]", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"\"\<exptinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<exptid\>\"", "\[Rule]", "225"}], ",", 
         RowBox[{"\"\<exptname\>\"", "\[Rule]", "\"\<cdfLasy\>\""}], ",", 
         RowBox[{"\"\<feyndiagram\>\"", "\[Rule]", "\"\<unset\>\""}]}], 
        "\[RightAssociation]"}]}], ",", 
      RowBox[{"\"\<PDFinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<PDFname\>\"", "\[Rule]", "\"\<CT14HERA2NNLO\>\""}], ",", 
         RowBox[{"\"\<PDFsetmethod\>\"", "\[Rule]", "\"\<Hessian\>\""}], ",", 
         
         RowBox[{"\"\<Nset\>\"", "\[Rule]", "57"}], ",", 
         RowBox[{"\"\<iset\>\"", "\[Rule]", "\"\<unset\>\""}], ",", 
         RowBox[{"\"\<flavour\>\"", "\[Rule]", "4"}]}], 
        "\[RightAssociation]"}]}]}], "\[RightAssociation]"}], ",", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"\"\<label\>\"", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<x\>\"", ",", "\"\<Q\>\"", ",", "\"\<residual\>\""}], 
        "}"}]}], ",", 
      RowBox[{"\"\<data\>\"", "\[Rule]", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"\"\<exptinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<exptid\>\"", "\[Rule]", "225"}], ",", 
         RowBox[{"\"\<exptname\>\"", "\[Rule]", "\"\<cdfLasy\>\""}], ",", 
         RowBox[{"\"\<feyndiagram\>\"", "\[Rule]", "\"\<unset\>\""}]}], 
        "\[RightAssociation]"}]}], ",", 
      RowBox[{"\"\<PDFinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<PDFname\>\"", "\[Rule]", "\"\<CT14HERA2NNLO\>\""}], ",", 
         RowBox[{"\"\<PDFsetmethod\>\"", "\[Rule]", "\"\<Hessian\>\""}], ",", 
         
         RowBox[{"\"\<Nset\>\"", "\[Rule]", "57"}], ",", 
         RowBox[{"\"\<iset\>\"", "\[Rule]", "\"\<unset\>\""}], ",", 
         RowBox[{"\"\<flavour\>\"", "\[Rule]", "5"}]}], 
        "\[RightAssociation]"}]}]}], "\[RightAssociation]"}], ",", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"\"\<label\>\"", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<x\>\"", ",", "\"\<Q\>\"", ",", "\"\<residual\>\""}], 
        "}"}]}], ",", 
      RowBox[{"\"\<data\>\"", "\[Rule]", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"\"\<exptinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<exptid\>\"", "\[Rule]", "225"}], ",", 
         RowBox[{"\"\<exptname\>\"", "\[Rule]", "\"\<cdfLasy\>\""}], ",", 
         RowBox[{"\"\<feyndiagram\>\"", "\[Rule]", "\"\<unset\>\""}]}], 
        "\[RightAssociation]"}]}], ",", 
      RowBox[{"\"\<PDFinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<PDFname\>\"", "\[Rule]", "\"\<CT14HERA2NNLO\>\""}], ",", 
         RowBox[{"\"\<PDFsetmethod\>\"", "\[Rule]", "\"\<Hessian\>\""}], ",", 
         
         RowBox[{"\"\<Nset\>\"", "\[Rule]", "57"}], ",", 
         RowBox[{"\"\<iset\>\"", "\[Rule]", "\"\<unset\>\""}], ",", 
         RowBox[{"\"\<flavour\>\"", "\[Rule]", 
          RowBox[{"-", "5"}]}]}], "\[RightAssociation]"}]}]}], 
     "\[RightAssociation]"}], ",", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"\"\<label\>\"", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<x\>\"", ",", "\"\<Q\>\"", ",", "\"\<residual\>\""}], 
        "}"}]}], ",", 
      RowBox[{"\"\<data\>\"", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"LF", "[", 
          RowBox[{
          "0.19917645454180155`", ",", "80.39`", ",", "1.971732954545455`"}], 
          "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.21358308834796036`", ",", "80.39`", ",", "1.971732954545455`"}], 
          "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.22875747653402578`", ",", "80.39`", ",", "1.971732954545455`"}], 
          "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.2447264230570053`", ",", "80.39`", ",", "1.971732954545455`"}], 
          "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.261517191794792`", ",", "80.39`", ",", "1.971732954545455`"}], 
          "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.1855112310794266`", ",", "80.39`", ",", 
           RowBox[{"-", "0.13771569433032135`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.19917645454180155`", ",", "80.39`", ",", 
           RowBox[{"-", "0.13771569433032135`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.21358308834796036`", ",", "80.39`", ",", 
           RowBox[{"-", "0.13771569433032135`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.22875747653402578`", ",", "80.39`", ",", 
           RowBox[{"-", "0.13771569433032135`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.2447264230570053`", ",", "80.39`", ",", 
           RowBox[{"-", "0.13771569433032135`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.261517191794792`", ",", "80.39`", ",", 
           RowBox[{"-", "0.13771569433032135`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.2791575065461639`", ",", "80.39`", ",", 
           RowBox[{"-", "0.13771569433032135`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.29767555103078436`", ",", "80.39`", ",", 
           RowBox[{"-", "0.13771569433032135`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.3170999688892017`", ",", "80.39`", ",", 
           RowBox[{"-", "0.13771569433032135`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.33745986368284964`", ",", "80.39`", ",", 
           RowBox[{"-", "0.13771569433032135`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.1855112310794266`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.19917645454180155`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.21358308834796036`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.22875747653402578`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.2447264230570053`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.261517191794792`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.2791575065461639`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.29767555103078436`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.3170999688892017`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.33745986368284964`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.35878479889404674`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.38110479792599694`", ",", "80.39`", ",", 
           RowBox[{"-", "0.433294117647059`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.1855112310794266`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.19917645454180155`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.21358308834796036`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.22875747653402578`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.2447264230570053`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.261517191794792`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.2791575065461639`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.29767555103078436`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.3170999688892017`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.33745986368284964`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.35878479889404674`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.38110479792599694`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{"0.4044503441027893`", ",", "80.39`", ",", 
           RowBox[{"-", "0.8482809123649461`"}]}], "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.19917645454180155`", ",", "80.39`", ",", "0.0921636917718761`"}],
           "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.21358308834796036`", ",", "80.39`", ",", "0.0921636917718761`"}],
           "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.22875747653402578`", ",", "80.39`", ",", "0.0921636917718761`"}],
           "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.2447264230570053`", ",", "80.39`", ",", "0.0921636917718761`"}], 
          "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.261517191794792`", ",", "80.39`", ",", "0.0921636917718761`"}], 
          "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.2791575065461639`", ",", "80.39`", ",", "0.0921636917718761`"}], 
          "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.29767555103078436`", ",", "80.39`", ",", "0.0921636917718761`"}],
           "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.3170999688892017`", ",", "80.39`", ",", "0.0921636917718761`"}], 
          "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.33745986368284964`", ",", "80.39`", ",", "0.0921636917718761`"}],
           "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.35878479889404674`", ",", "80.39`", ",", "0.0921636917718761`"}],
           "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.38110479792599694`", ",", "80.39`", ",", "0.0921636917718761`"}],
           "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.4044503441027893`", ",", "80.39`", ",", "0.0921636917718761`"}], 
          "]"}], ",", 
         RowBox[{"LF", "[", 
          RowBox[{
          "0.42885238066939807`", ",", "80.39`", ",", "0.0921636917718761`"}],
           "]"}]}], "}"}]}], ",", 
      RowBox[{"\"\<exptinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<exptid\>\"", "\[Rule]", "225"}], ",", 
         RowBox[{"\"\<exptname\>\"", "\[Rule]", "\"\<cdfLasy\>\""}], ",", 
         RowBox[{"\"\<feyndiagram\>\"", "\[Rule]", "\"\<unset\>\""}]}], 
        "\[RightAssociation]"}]}], ",", 
      RowBox[{"\"\<PDFinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<PDFname\>\"", "\[Rule]", "\"\<CT14HERA2NNLO\>\""}], ",", 
         RowBox[{"\"\<PDFsetmethod\>\"", "\[Rule]", "\"\<Hessian\>\""}], ",", 
         
         RowBox[{"\"\<Nset\>\"", "\[Rule]", "57"}], ",", 
         RowBox[{"\"\<iset\>\"", "\[Rule]", "\"\<unset\>\""}], ",", 
         RowBox[{"\"\<flavour\>\"", "\[Rule]", 
          RowBox[{"-", "5"}]}]}], "\[RightAssociation]"}]}]}], 
     "\[RightAssociation]"}], ",", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"\"\<label\>\"", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<x\>\"", ",", "\"\<Q\>\"", ",", "\"\<residual\>\""}], 
        "}"}]}], ",", 
      RowBox[{"\"\<data\>\"", "\[Rule]", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"\"\<exptinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<exptid\>\"", "\[Rule]", "225"}], ",", 
         RowBox[{"\"\<exptname\>\"", "\[Rule]", "\"\<cdfLasy\>\""}], ",", 
         RowBox[{"\"\<feyndiagram\>\"", "\[Rule]", "\"\<unset\>\""}]}], 
        "\[RightAssociation]"}]}], ",", 
      RowBox[{"\"\<PDFinfo\>\"", "\[Rule]", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{"\"\<PDFname\>\"", "\[Rule]", "\"\<CT14HERA2NNLO\>\""}], ",", 
         RowBox[{"\"\<PDFsetmethod\>\"", "\[Rule]", "\"\<Hessian\>\""}], ",", 
         
         RowBox[{"\"\<Nset\>\"", "\[Rule]", "57"}], ",", 
         RowBox[{"\"\<iset\>\"", "\[Rule]", "\"\<unset\>\""}], ",", 
         RowBox[{"\"\<flavour\>\"", "\[Rule]", 
          RowBox[{"-", "5"}]}]}], "\[RightAssociation]"}]}]}], 
     "\[RightAssociation]"}]}], "}"}], "}"}]], "Input",
 CellChangeTimes->{{3.708406434536499*^9, 3.7084064369867887`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"processdataplotsmultiexp6percentage", "[", 
  RowBox[{
   RowBox[{"{", "residualdataclassfinal", "}"}], ",", 
   RowBox[{"readcorrconfigfile4", "[", 
    RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "3", ",", "1"}],
   "]"}]], "Input",
 CellChangeTimes->{{3.704087858713697*^9, 3.704087868699787*^9}, 
   3.708406437138114*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"expts: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"{", "225", "}"}], "}"}]}],
  SequenceForm["expts: ", {{225}}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.704087863792622*^9, 3.7040878692227917`*^9}, 
   3.704087933497631*^9, 3.7040879960256433`*^9, {3.704088285532628*^9, 
   3.704088305711231*^9}, 3.704572010137682*^9, 3.7045739735958242`*^9, 
   3.7052971859714413`*^9, 3.706719445534246*^9, 3.706721168602799*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", "225", 
   "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", 225, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.704087863792622*^9, 3.7040878692227917`*^9}, 
   3.704087933497631*^9, 3.7040879960256433`*^9, {3.704088285532628*^9, 
   3.704088305711231*^9}, 3.704572010137682*^9, 3.7045739735958242`*^9, 
   3.7052971859714413`*^9, 3.706719445534246*^9, 3.706721168721198*^9}],

Cell[BoxData["\<\"making table of experiments included in plots\"\>"], "Print",
 CellChangeTimes->{{3.704087863792622*^9, 3.7040878692227917`*^9}, 
   3.704087933497631*^9, 3.7040879960256433`*^9, {3.704088285532628*^9, 
   3.704088305711231*^9}, 3.704572010137682*^9, 3.7045739735958242`*^9, 
   3.7052971859714413`*^9, 3.706719445534246*^9, 3.706721168724249*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     TagBox[
      GraphicsBox[{InsetBox[
         GraphicsBox[{{{{}, {{}, 
              {GrayLevel[1], PointSize[0.012833333333333334`], 
               AbsoluteThickness[1.6], 
               StyleBox[PointBox[{{0.00001, 2.}, {0.99, 1200.}}],
                FontFamily->"Helvetica"]}, {}}, {}, {}, {{}, {}}}, {
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.3087765548632015, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.908776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.632776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.584776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.189776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.027776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.908776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.308776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.217776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.999776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.600776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.6167765548632014, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.058776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0., 0.75, 0.75], 
              
              StyleBox[
               InsetBox["\<\"\[FilledCircle]\"\>", 
                {-1.1587765548632012, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.003776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.213776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.808776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.408776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.410776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.8067765548632013, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.416776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.800776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}}}, {}},
          AspectRatio->1,
          Axes->False,
          AxesLabel->{None, None},
          AxesOrigin->{0, 2.329076679826786},
          BaseStyle->{FontFamily -> "Helvetica", 16},
          DisplayFunction->Identity,
          Epilog->{{
             InsetBox[
              FormBox[
               StyleBox["\"Npt: 22\"", 16, 
                GrayLevel[0], StripOnInput -> False], TraditionalForm], 
              Scaled[{0.1, 0.9}]], 
             InsetBox[
              FormBox[
               StyleBox["\"highlighted range:\\n{2., 100.}\"", 16, 
                GrayLevel[0], StripOnInput -> False], TraditionalForm], 
              Scaled[{0.2, 0.7}]]}, {{
              InsetBox[
               FormBox[
                StyleBox["\"Npt: 22\"", 16, 
                 GrayLevel[0], StripOnInput -> False], TraditionalForm], 
               Scaled[{0.1, 0.9}]], 
              InsetBox[
               FormBox[
                StyleBox["\"highlighted range:\\n{2., 100.}\"", 16, 
                 GrayLevel[0], StripOnInput -> False], TraditionalForm], 
               Scaled[{0.2, 0.7}]]}}},
          Frame->True,
          FrameLabel->{
            FormBox[
             StyleBox["\"x\"", 18, 
              GrayLevel[0], StripOnInput -> False], TraditionalForm], 
            FormBox[
             StyleBox["\"\[Mu] [GeV]\"", 18, 
              GrayLevel[0], StripOnInput -> False], TraditionalForm]},
          FrameTicks->{{{-13.815510557964274`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.512925464970229`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.210340371976182, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.605170185988091, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.3025850929940455`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
              FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
             0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.791759469228055, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.302585092994046, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.0943445622221, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.248495242049359, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.382026634673881, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.499809670330265, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.605170185988092, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.703782474656201, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.991464547107982, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.396929655216146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.551080335043404, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.684611727667927, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.802394763324311, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.006367567650246, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.294049640102028, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.699514748210191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.987196820661973, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.104979856318357, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.210340371976184, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.308952660644293`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.596634733096073`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.002099841204238`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.156250521031495`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.289781913656018`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.407564949312402`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}}, {{-13.815510557964274`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.512925464970229`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.210340371976182, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.605170185988091, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.3025850929940455`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
              FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
             0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.791759469228055, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.302585092994046, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.0943445622221, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.248495242049359, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.382026634673881, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.499809670330265, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.605170185988092, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.703782474656201, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.991464547107982, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.396929655216146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.551080335043404, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.684611727667927, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.802394763324311, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.006367567650246, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.294049640102028, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.699514748210191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.987196820661973, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.104979856318357, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.210340371976184, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.308952660644293`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.596634733096073`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.002099841204238`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.156250521031495`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.289781913656018`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.407564949312402`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}}, {{-13.815510557964274`, 
              FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
              FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
              FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
              FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
              FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm]}, {0., 
              FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
              FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
              FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
              FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
              FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
              FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
              FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
              FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
              FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
              FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
              FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
              FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
              FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
              FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
              FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
              FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
              FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
              FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
              FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
              FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
              FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
              FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
              FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
              FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
              FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
              FormBox["\"\"", TraditionalForm]}}, {{-13.815510557964274`, 
              FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
              FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
              FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
              FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
              FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm]}, {0., 
              FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
              FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
              FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
              FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
              FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
              FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
              FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
              FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
              FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
              FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
              FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
              FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
              FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
              FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
              FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
              FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
              FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
              FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
              FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
              FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
              FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
              FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
              FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
              FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
              FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
              FormBox["\"\"", TraditionalForm]}}},
          FrameTicksStyle->GrayLevel[0],
          GridLines->{None, None},
          GridLinesStyle->Directive[
            GrayLevel[0.5, 0.4]],
          ImagePadding->All,
          ImageSize->{{600}, {600}},
          Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& )}},
          PlotLabel->None,
          
          PlotRange->{{-11.512925464970229`, 0}, {2.302585092994046, 
            7.600902459542082}},
          PlotRangeClipping->True,
          PlotRangePadding->{{0, 0}, {0, 0}},
          Ticks->{Automatic, Automatic}], Scaled[{0.5, 0.5}], Center, 
         Scaled[{1, 1}]], InsetBox[
         TemplateBox[{FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   StyleBox[
                   "\"\"", {FontSize -> 14, FontFamily -> "Arial"}, 
                    Background -> Automatic, StripOnInput -> False]}, {
                   GraphicsBox[{{}, {}, 
                    
                    RasterBox[{{{0., 0., 0.7}}, {{0., 0.5, 0.75}}, {{0., 0.75,
                     0.75}}, {{0.9352941176470588, 0.9450980392156862, 
                    0.8392156862745098}}, {{0.75, 0.75, 0.}}, {{0.75, 
                    0.5500000000000002, 0.}}, {{0.7, 0., 0.}}}, {{
                    Rational[-15, 2], 
                    Rational[-175, 2]}, {
                    Rational[15, 2], 
                    Rational[175, 2]}}], {Antialiasing -> False, 
                    AbsoluteThickness[0.1], 
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]], 
                    LineBox[
                    NCache[{{
                    Rational[15, 2], 
                    Rational[-175, 2]}, {
                    Rational[-15, 2], 
                    Rational[-175, 2]}, {
                    Rational[-15, 2], 
                    Rational[175, 2]}, {
                    Rational[15, 2], 
                    Rational[175, 2]}, {
                    Rational[15, 2], 
                    Rational[-175, 2]}}, {{7.5, -87.5}, {-7.5, -87.5}, {-7.5, 
                    87.5}, {7.5, 87.5}, {7.5, -87.5}}]]}, {
                    CapForm[None], {}}, {Antialiasing -> False, 
                    StyleBox[
                    LineBox[{{7.5, -87.5}, {7.5, 87.5}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.5, -62.5}, 
                    Offset[{4., 0}, {7.5, -62.5}]}, {{
                    7.5, -37.49999999999999}, 
                    Offset[{4., 0}, {7.5, -37.49999999999999}]}, {{
                    7.5, -12.5}, 
                    Offset[{4., 0}, {7.5, -12.5}]}, {{7.5, 12.5}, 
                    Offset[{4., 0}, {7.5, 12.5}]}, {{7.5, 37.49999999999999}, 
                    
                    Offset[{4., 0}, {7.5, 37.49999999999999}]}, {{7.5, 62.5}, 
                    
                    Offset[{4., 0}, {7.5, 62.5}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-5.0\"", -5., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -62.5}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-2.0\"", -2., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -37.49999999999999}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-0.5\"", -0.5, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -12.5}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"0.5\"", 0.5, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 12.5}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"2.0\"", 2., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 37.49999999999999}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"5.0\"", 5., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 62.5}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1], FontSize -> 14]}, StripOnInput -> 
                    False]}, {}}, {
                    Directive[
                    Opacity[1], FontSize -> 14]}, StripOnInput -> False], 
                    "GraphicsLabel", StripOnInput -> False]}, "GraphicsTicks",
                     StripOnInput -> False], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                    Scaled[0.02], PlotRange -> All, Frame -> True, 
                    FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                    Opacity[0], FrameTicksStyle -> Opacity[0], 
                    ImageSize -> {Automatic, 175}, BaseStyle -> {}, 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}]}}, 
                 GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontSize -> 14, FontFamily -> "Arial"}, Background -> Automatic, 
             StripOnInput -> False], TraditionalForm]},
          "BarLegend",
          DisplayFunction->(#& ),
          InterpretationFunction:>(RowBox[{"BarLegend", "[", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0., 0., 0.7], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0., 0.4666666666666667], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0., 0., 0.7]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0., 0., 0.7]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0., 0., 0.7], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0., 0.5, 0.75], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0., 0.33333333333333337`, 0.5], FrameTicks -> 
                    None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0., 0.5, 0.75]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0., 0.5, 0.75]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0., 0.5, 0.75], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0., 0.75, 0.75], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0.5, 0.5], FrameTicks -> 
                    None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0., 0.75, 0.75]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0., 0.75, 0.75]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0., 0.75, 0.75], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[
                    0.9352941176470588, 0.9450980392156862, 
                    0.8392156862745098], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.6235294117647059, 0.6300653594771242, 
                    0.5594771241830065], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.9352941176470588, 0.9450980392156862, \
0.8392156862745098]"], Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.9352941176470588, 0.9450980392156862, 
                    0.8392156862745098]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[
                    0.9352941176470588, 0.9450980392156862, 
                    0.8392156862745098], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.75, 0.75, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.5, 0.5, 0.], FrameTicks -> 
                    None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.75, 0.75, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.75, 0.75, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.75, 0.75, 0.], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.75, 0.55, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.5, 0.3666666666666667, 0.],
                     FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.75, 0.55, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.75, 0.55, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.75, 0.55, 0.], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0., 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.4666666666666667, 0., 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0., 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0., 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0., 0.], Editable -> False, Selectable -> 
                    False]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "100"}], ",", "100"}], "}"}]}], "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "100"}], ",", 
                   RowBox[{"-", "5.`"}], ",", 
                   RowBox[{"-", "2.`"}], ",", 
                   RowBox[{"-", "0.5`"}], ",", "0.5`", ",", "2.`", ",", "5.`",
                    ",", "100"}], "}"}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"{", 
                   RowBox[{"FontSize", "\[Rule]", "14"}], "}"}]}], ",", 
               RowBox[{"LegendLabel", "\[Rule]", "\"\""}], ",", 
               RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
               RowBox[{"LegendMarkerSize", "\[Rule]", 
                 RowBox[{"{", "}"}]}], ",", 
               RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
               RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
               RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], 
             "]"}]& )], Scaled[{1., 0.5}], ImageScaled[{0, 0.5}],
         BaseStyle->{FontSize -> Larger},
         FormatType->StandardForm]},
       AspectRatio->1,
       Axes->False,
       AxesLabel->{None, None},
       AxesOrigin->{0, 2.329076679826786},
       BaseStyle->{FontFamily -> "Helvetica", 16},
       DisplayFunction->Identity,
       Frame->False,
       FrameLabel->{
         FormBox[
          StyleBox["\"x\"", 18, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         FormBox[
          StyleBox["\"\[Mu] [GeV]\"", 18, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm]},
       FrameTicks->{{{-13.815510557964274`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.02375108873622, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.86960040890896, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.512925464970229`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.903487552536127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.721165995742174, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.567015315914915, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.433483923290392, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.315700887634009, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.210340371976182, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-8.111728083308073, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.824046010856292, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.600902459542082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.418580902748127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.264430222920869, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.013115794639964, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-6.907755278982137, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.809142990314028, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.521460917862246, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.298317366548036, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.115995809754082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.961845129926823, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.710530701645918, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.605170185988091, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.506557897319982, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.995732273553991, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.659260036932778, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.3025850929940455`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-1.203972804325936, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.916290731874155, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
           FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
          0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.302585092994046, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.605170185988092, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.907755278982137, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.210340371976184, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}}, {{-13.815510557964274`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.02375108873622, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.86960040890896, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.512925464970229`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.903487552536127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.721165995742174, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.567015315914915, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.433483923290392, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.315700887634009, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.210340371976182, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-8.111728083308073, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.824046010856292, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.600902459542082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.418580902748127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.264430222920869, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.013115794639964, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-6.907755278982137, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.809142990314028, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.521460917862246, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.298317366548036, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.115995809754082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.961845129926823, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.710530701645918, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.605170185988091, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.506557897319982, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.995732273553991, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.659260036932778, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.3025850929940455`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-1.203972804325936, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.916290731874155, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
           FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
          0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.302585092994046, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.605170185988092, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.907755278982137, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.210340371976184, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}}, {{-13.815510557964274`, 
           FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
           FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
           FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
           FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
           FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
           FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
           FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
           FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
           FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
           FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
           FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
           FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
           FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
           FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
           FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
           FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
           FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
           FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
           FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
           FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
           FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
           FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
           FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm]}, {0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
           FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm]}}, {{-13.815510557964274`, 
           FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
           FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
           FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
           FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
           FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
           FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
           FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
           FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
           FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
           FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
           FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
           FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
           FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
           FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
           FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
           FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
           FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
           FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
           FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
           FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
           FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
           FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
           FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm]}, {0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
           FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm]}}},
       FrameTicksStyle->GrayLevel[0],
       ImagePadding->All,
       ImageSize->{{600}, {600}},
       Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
             (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
              Part[#, 1]], 
             (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
              Part[#, 2]]}& ), "CopiedValueFunction" -> ({
             (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
              Part[#, 1]], 
             (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
              Part[#, 2]]}& )}},
       PlotLabel->FormBox[
         StyleBox["\"\"", 24, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm],
       PlotRange->Automatic,
       PlotRangeClipping->False,
       PlotRangePadding->{{0, 0}, {0, 0}},
       Ticks->{Automatic, Automatic}],
      InterpretTemplate[Legended[
        Graphics[{{{}, {{{}, {
              Hue[0.67, 0.6, 0.6], 
              Directive[
               PointSize[0.012833333333333334`], 
               AbsoluteThickness[1.6], FontFamily -> "Helvetica", 
               GrayLevel[1]], 
              
              Point[{{0.00001, 2.}, {0.99, 
               1200.}}]}, {}}}, {}, {}, {{}, {}}}, {
           Style[
            Text[
            "\[FilledCircle]", {-5.3087765548632015`, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-0.908776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-4.632776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-1.584776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-4.189776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-2.027776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-4.908776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-1.308776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-3.217776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-2.999776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-3.600776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.6167765548632014`, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-5.058776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1587765548632012`, 4.386765389021055}], 
            5.625, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledCircle]", {-4.003776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-2.213776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-3.808776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledCircle]", {-2.408776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledCircle]", {-3.410776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.8067765548632013`, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-4.416776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-1.800776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]]}}, {
         Frame -> True, 
          FrameTicks -> {{{-13.815510557964274`, 
              "\!\(\*SuperscriptBox[\(10\), \(-6\)]\)", {0.02, 
              0.}}, {-13.122363377404328`, "", {
              0.01, 0}}, {-12.716898269296165`, "", {
              0.01, 0}}, {-12.429216196844383`, "", {
              0.01, 0}}, {-12.206072645530174`, "", {
              0.01, 0}}, {-12.02375108873622, "", {
              0.01, 0}}, {-11.86960040890896, "", {
              0.01, 0}}, {-11.736069016284437`, "", {
              0.01, 0}}, {-11.618285980628055`, "", {
              0.01, 0}}, {-11.512925464970229`, 
              "\!\(\*SuperscriptBox[\(10\), \(-5\)]\)", {0.02, 
              0.}}, {-10.819778284410283`, "", {
              0.01, 0}}, {-10.414313176302118`, "", {
              0.01, 0}}, {-10.126631103850338`, "", {
              0.01, 0}}, {-9.903487552536127, "", {
              0.01, 0}}, {-9.721165995742174, "", {
              0.01, 0}}, {-9.567015315914915, "", {
              0.01, 0}}, {-9.433483923290392, "", {
              0.01, 0}}, {-9.315700887634009, "", {
              0.01, 0}}, {-9.210340371976182, 
              "\!\(\*SuperscriptBox[\(10\), \(-4\)]\)", {0.02, 
              0.}}, {-8.517193191416238, "", {0.01, 0}}, {-8.111728083308073, 
              "", {0.01, 0}}, {-7.824046010856292, "", {
              0.01, 0}}, {-7.600902459542082, "", {
              0.01, 0}}, {-7.418580902748127, "", {
              0.01, 0}}, {-7.264430222920869, "", {
              0.01, 0}}, {-7.1308988302963465`, "", {
              0.01, 0}}, {-7.013115794639964, "", {
              0.01, 0}}, {-6.907755278982137, 
              "\!\(\*SuperscriptBox[\(10\), \(-3\)]\)", {0.02, 
              0.}}, {-6.214608098422191, "", {0.01, 0}}, {-5.809142990314028, 
              "", {0.01, 0}}, {-5.521460917862246, "", {
              0.01, 0}}, {-5.298317366548036, "", {
              0.01, 0}}, {-5.115995809754082, "", {
              0.01, 0}}, {-4.961845129926823, "", {
              0.01, 0}}, {-4.8283137373023015`, "", {
              0.01, 0}}, {-4.710530701645918, "", {
              0.01, 0}}, {-4.605170185988091, 
              "\!\(\*SuperscriptBox[\(10\), \(-2\)]\)", {0.02, 
              0.}}, {-3.912023005428146, "", {0.01, 0}}, {-3.506557897319982, 
              "", {0.01, 0}}, {-3.2188758248682006`, "", {
              0.01, 0}}, {-2.995732273553991, "", {
              0.01, 0}}, {-2.8134107167600364`, "", {
              0.01, 0}}, {-2.659260036932778, "", {
              0.01, 0}}, {-2.5257286443082556`, "", {
              0.01, 0}}, {-2.4079456086518722`, "", {
              0.01, 0}}, {-2.3025850929940455`, 
              "\!\(\*SuperscriptBox[\(10\), \(-1\)]\)", {0.02, 
              0.}}, {-1.6094379124341003`, "", {
              0.01, 0}}, {-1.203972804325936, "", {
              0.01, 0}}, {-0.916290731874155, "", {
              0.01, 0}}, {-0.6931471805599453, "", {
              0.01, 0}}, {-0.5108256237659905, "", {
              0.01, 0}}, {-0.3566749439387323, "", {
              0.01, 0}}, {-0.2231435513142097, "", {
              0.01, 0}}, {-0.10536051565782628`, "", {0.01, 0}}, {
             0., "1", {0.02, 0.}}, {0.6931471805599453, "", {0.01, 0}}, {
             1.0986122886681098`, "", {0.01, 0}}, {
             1.3862943611198906`, "", {0.01, 0}}, {
             1.6094379124341003`, "", {0.01, 0}}, {
             1.791759469228055, "", {0.01, 0}}, {
             1.9459101490553132`, "", {0.01, 0}}, {
             2.0794415416798357`, "", {0.01, 0}}, {
             2.1972245773362196`, "", {0.01, 0}}, {
             2.302585092994046, "\!\(\*SuperscriptBox[\(10\), \(1\)]\)", {
              0.02, 0.}}, {2.995732273553991, "", {0.01, 0}}, {
             3.4011973816621555`, "", {0.01, 0}}, {
             3.6888794541139363`, "", {0.01, 0}}, {
             3.912023005428146, "", {0.01, 0}}, {
             4.0943445622221, "", {0.01, 0}}, {
             4.248495242049359, "", {0.01, 0}}, {
             4.382026634673881, "", {0.01, 0}}, {
             4.499809670330265, "", {0.01, 0}}, {
             4.605170185988092, "\!\(\*SuperscriptBox[\(10\), \(2\)]\)", {
              0.02, 0.}}, {5.298317366548036, "", {0.01, 0}}, {
             5.703782474656201, "", {0.01, 0}}, {
             5.991464547107982, "", {0.01, 0}}, {
             6.214608098422191, "", {0.01, 0}}, {
             6.396929655216146, "", {0.01, 0}}, {
             6.551080335043404, "", {0.01, 0}}, {
             6.684611727667927, "", {0.01, 0}}, {
             6.802394763324311, "", {0.01, 0}}, {
             6.907755278982137, "\!\(\*SuperscriptBox[\(10\), \(3\)]\)", {
              0.02, 0.}}, {7.600902459542082, "", {0.01, 0}}, {
             8.006367567650246, "", {0.01, 0}}, {
             8.294049640102028, "", {0.01, 0}}, {
             8.517193191416238, "", {0.01, 0}}, {
             8.699514748210191, "", {0.01, 0}}, {
             8.85366542803745, "", {0.01, 0}}, {
             8.987196820661973, "", {0.01, 0}}, {
             9.104979856318357, "", {0.01, 0}}, {
             9.210340371976184, "\!\(\*SuperscriptBox[\(10\), \(4\)]\)", {
              0.02, 0.}}, {9.903487552536127, "", {0.01, 0}}, {
             10.308952660644293`, "", {0.01, 0}}, {
             10.596634733096073`, "", {0.01, 0}}, {
             10.819778284410283`, "", {0.01, 0}}, {
             11.002099841204238`, "", {0.01, 0}}, {
             11.156250521031495`, "", {0.01, 0}}, {
             11.289781913656018`, "", {0.01, 0}}, {
             11.407564949312402`, "", {0.01, 0}}}, {{-13.815510557964274`, 
              "\!\(\*SuperscriptBox[\(10\), \(-6\)]\)", {0.02, 
              0.}}, {-13.122363377404328`, "", {
              0.01, 0}}, {-12.716898269296165`, "", {
              0.01, 0}}, {-12.429216196844383`, "", {
              0.01, 0}}, {-12.206072645530174`, "", {
              0.01, 0}}, {-12.02375108873622, "", {
              0.01, 0}}, {-11.86960040890896, "", {
              0.01, 0}}, {-11.736069016284437`, "", {
              0.01, 0}}, {-11.618285980628055`, "", {
              0.01, 0}}, {-11.512925464970229`, 
              "\!\(\*SuperscriptBox[\(10\), \(-5\)]\)", {0.02, 
              0.}}, {-10.819778284410283`, "", {
              0.01, 0}}, {-10.414313176302118`, "", {
              0.01, 0}}, {-10.126631103850338`, "", {
              0.01, 0}}, {-9.903487552536127, "", {
              0.01, 0}}, {-9.721165995742174, "", {
              0.01, 0}}, {-9.567015315914915, "", {
              0.01, 0}}, {-9.433483923290392, "", {
              0.01, 0}}, {-9.315700887634009, "", {
              0.01, 0}}, {-9.210340371976182, 
              "\!\(\*SuperscriptBox[\(10\), \(-4\)]\)", {0.02, 
              0.}}, {-8.517193191416238, "", {0.01, 0}}, {-8.111728083308073, 
              "", {0.01, 0}}, {-7.824046010856292, "", {
              0.01, 0}}, {-7.600902459542082, "", {
              0.01, 0}}, {-7.418580902748127, "", {
              0.01, 0}}, {-7.264430222920869, "", {
              0.01, 0}}, {-7.1308988302963465`, "", {
              0.01, 0}}, {-7.013115794639964, "", {
              0.01, 0}}, {-6.907755278982137, 
              "\!\(\*SuperscriptBox[\(10\), \(-3\)]\)", {0.02, 
              0.}}, {-6.214608098422191, "", {0.01, 0}}, {-5.809142990314028, 
              "", {0.01, 0}}, {-5.521460917862246, "", {
              0.01, 0}}, {-5.298317366548036, "", {
              0.01, 0}}, {-5.115995809754082, "", {
              0.01, 0}}, {-4.961845129926823, "", {
              0.01, 0}}, {-4.8283137373023015`, "", {
              0.01, 0}}, {-4.710530701645918, "", {
              0.01, 0}}, {-4.605170185988091, 
              "\!\(\*SuperscriptBox[\(10\), \(-2\)]\)", {0.02, 
              0.}}, {-3.912023005428146, "", {0.01, 0}}, {-3.506557897319982, 
              "", {0.01, 0}}, {-3.2188758248682006`, "", {
              0.01, 0}}, {-2.995732273553991, "", {
              0.01, 0}}, {-2.8134107167600364`, "", {
              0.01, 0}}, {-2.659260036932778, "", {
              0.01, 0}}, {-2.5257286443082556`, "", {
              0.01, 0}}, {-2.4079456086518722`, "", {
              0.01, 0}}, {-2.3025850929940455`, 
              "\!\(\*SuperscriptBox[\(10\), \(-1\)]\)", {0.02, 
              0.}}, {-1.6094379124341003`, "", {
              0.01, 0}}, {-1.203972804325936, "", {
              0.01, 0}}, {-0.916290731874155, "", {
              0.01, 0}}, {-0.6931471805599453, "", {
              0.01, 0}}, {-0.5108256237659905, "", {
              0.01, 0}}, {-0.3566749439387323, "", {
              0.01, 0}}, {-0.2231435513142097, "", {
              0.01, 0}}, {-0.10536051565782628`, "", {0.01, 0}}, {
             0., "1", {0.02, 0.}}, {0.6931471805599453, "", {0.01, 0}}, {
             1.0986122886681098`, "", {0.01, 0}}, {
             1.3862943611198906`, "", {0.01, 0}}, {
             1.6094379124341003`, "", {0.01, 0}}, {
             1.791759469228055, "", {0.01, 0}}, {
             1.9459101490553132`, "", {0.01, 0}}, {
             2.0794415416798357`, "", {0.01, 0}}, {
             2.1972245773362196`, "", {0.01, 0}}, {
             2.302585092994046, "\!\(\*SuperscriptBox[\(10\), \(1\)]\)", {
              0.02, 0.}}, {2.995732273553991, "", {0.01, 0}}, {
             3.4011973816621555`, "", {0.01, 0}}, {
             3.6888794541139363`, "", {0.01, 0}}, {
             3.912023005428146, "", {0.01, 0}}, {
             4.0943445622221, "", {0.01, 0}}, {
             4.248495242049359, "", {0.01, 0}}, {
             4.382026634673881, "", {0.01, 0}}, {
             4.499809670330265, "", {0.01, 0}}, {
             4.605170185988092, "\!\(\*SuperscriptBox[\(10\), \(2\)]\)", {
              0.02, 0.}}, {5.298317366548036, "", {0.01, 0}}, {
             5.703782474656201, "", {0.01, 0}}, {
             5.991464547107982, "", {0.01, 0}}, {
             6.214608098422191, "", {0.01, 0}}, {
             6.396929655216146, "", {0.01, 0}}, {
             6.551080335043404, "", {0.01, 0}}, {
             6.684611727667927, "", {0.01, 0}}, {
             6.802394763324311, "", {0.01, 0}}, {
             6.907755278982137, "\!\(\*SuperscriptBox[\(10\), \(3\)]\)", {
              0.02, 0.}}, {7.600902459542082, "", {0.01, 0}}, {
             8.006367567650246, "", {0.01, 0}}, {
             8.294049640102028, "", {0.01, 0}}, {
             8.517193191416238, "", {0.01, 0}}, {
             8.699514748210191, "", {0.01, 0}}, {
             8.85366542803745, "", {0.01, 0}}, {
             8.987196820661973, "", {0.01, 0}}, {
             9.104979856318357, "", {0.01, 0}}, {
             9.210340371976184, "\!\(\*SuperscriptBox[\(10\), \(4\)]\)", {
              0.02, 0.}}, {9.903487552536127, "", {0.01, 0}}, {
             10.308952660644293`, "", {0.01, 0}}, {
             10.596634733096073`, "", {0.01, 0}}, {
             10.819778284410283`, "", {0.01, 0}}, {
             11.002099841204238`, "", {0.01, 0}}, {
             11.156250521031495`, "", {0.01, 0}}, {
             11.289781913656018`, "", {0.01, 0}}, {
             11.407564949312402`, "", {0.01, 0}}}, {{-13.815510557964274`, 
              ""}, {-13.122363377404328`, ""}, {-12.716898269296165`, 
              ""}, {-12.429216196844383`, ""}, {-12.206072645530174`, 
              ""}, {-12.02375108873622, ""}, {-11.86960040890896, 
              ""}, {-11.736069016284437`, ""}, {-11.618285980628055`, 
              ""}, {-11.512925464970229`, ""}, {-10.819778284410283`, 
              ""}, {-10.414313176302118`, ""}, {-10.126631103850338`, 
              ""}, {-9.903487552536127, ""}, {-9.721165995742174, 
              ""}, {-9.567015315914915, ""}, {-9.433483923290392, 
              ""}, {-9.315700887634009, ""}, {-9.210340371976182, 
              ""}, {-8.517193191416238, ""}, {-8.111728083308073, 
              ""}, {-7.824046010856292, ""}, {-7.600902459542082, 
              ""}, {-7.418580902748127, ""}, {-7.264430222920869, 
              ""}, {-7.1308988302963465`, ""}, {-7.013115794639964, 
              ""}, {-6.907755278982137, ""}, {-6.214608098422191, 
              ""}, {-5.809142990314028, ""}, {-5.521460917862246, 
              ""}, {-5.298317366548036, ""}, {-5.115995809754082, 
              ""}, {-4.961845129926823, ""}, {-4.8283137373023015`, 
              ""}, {-4.710530701645918, ""}, {-4.605170185988091, 
              ""}, {-3.912023005428146, ""}, {-3.506557897319982, 
              ""}, {-3.2188758248682006`, ""}, {-2.995732273553991, 
              ""}, {-2.8134107167600364`, ""}, {-2.659260036932778, 
              ""}, {-2.5257286443082556`, ""}, {-2.4079456086518722`, 
              ""}, {-2.3025850929940455`, ""}, {-1.6094379124341003`, 
              ""}, {-1.203972804325936, ""}, {-0.916290731874155, 
              ""}, {-0.6931471805599453, ""}, {-0.5108256237659905, 
              ""}, {-0.3566749439387323, ""}, {-0.2231435513142097, 
              ""}, {-0.10536051565782628`, ""}, {0., ""}, {
             0.6931471805599453, ""}, {1.0986122886681098`, ""}, {
             1.3862943611198906`, ""}, {1.6094379124341003`, ""}, {
             1.791759469228055, ""}, {1.9459101490553132`, ""}, {
             2.0794415416798357`, ""}, {2.1972245773362196`, ""}, {
             2.302585092994046, ""}, {2.995732273553991, ""}, {
             3.4011973816621555`, ""}, {3.6888794541139363`, ""}, {
             3.912023005428146, ""}, {4.0943445622221, ""}, {
             4.248495242049359, ""}, {4.382026634673881, ""}, {
             4.499809670330265, ""}, {4.605170185988092, ""}, {
             5.298317366548036, ""}, {5.703782474656201, ""}, {
             5.991464547107982, ""}, {6.214608098422191, ""}, {
             6.396929655216146, ""}, {6.551080335043404, ""}, {
             6.684611727667927, ""}, {6.802394763324311, ""}, {
             6.907755278982137, ""}, {7.600902459542082, ""}, {
             8.006367567650246, ""}, {8.294049640102028, ""}, {
             8.517193191416238, ""}, {8.699514748210191, ""}, {
             8.85366542803745, ""}, {8.987196820661973, ""}, {
             9.104979856318357, ""}, {9.210340371976184, ""}, {
             9.903487552536127, ""}, {10.308952660644293`, ""}, {
             10.596634733096073`, ""}, {10.819778284410283`, ""}, {
             11.002099841204238`, ""}, {11.156250521031495`, ""}, {
             11.289781913656018`, ""}, {
             11.407564949312402`, ""}}, {{-13.815510557964274`, 
              ""}, {-13.122363377404328`, ""}, {-12.716898269296165`, 
              ""}, {-12.429216196844383`, ""}, {-12.206072645530174`, 
              ""}, {-12.02375108873622, ""}, {-11.86960040890896, 
              ""}, {-11.736069016284437`, ""}, {-11.618285980628055`, 
              ""}, {-11.512925464970229`, ""}, {-10.819778284410283`, 
              ""}, {-10.414313176302118`, ""}, {-10.126631103850338`, 
              ""}, {-9.903487552536127, ""}, {-9.721165995742174, 
              ""}, {-9.567015315914915, ""}, {-9.433483923290392, 
              ""}, {-9.315700887634009, ""}, {-9.210340371976182, 
              ""}, {-8.517193191416238, ""}, {-8.111728083308073, 
              ""}, {-7.824046010856292, ""}, {-7.600902459542082, 
              ""}, {-7.418580902748127, ""}, {-7.264430222920869, 
              ""}, {-7.1308988302963465`, ""}, {-7.013115794639964, 
              ""}, {-6.907755278982137, ""}, {-6.214608098422191, 
              ""}, {-5.809142990314028, ""}, {-5.521460917862246, 
              ""}, {-5.298317366548036, ""}, {-5.115995809754082, 
              ""}, {-4.961845129926823, ""}, {-4.8283137373023015`, 
              ""}, {-4.710530701645918, ""}, {-4.605170185988091, 
              ""}, {-3.912023005428146, ""}, {-3.506557897319982, 
              ""}, {-3.2188758248682006`, ""}, {-2.995732273553991, 
              ""}, {-2.8134107167600364`, ""}, {-2.659260036932778, 
              ""}, {-2.5257286443082556`, ""}, {-2.4079456086518722`, 
              ""}, {-2.3025850929940455`, ""}, {-1.6094379124341003`, 
              ""}, {-1.203972804325936, ""}, {-0.916290731874155, 
              ""}, {-0.6931471805599453, ""}, {-0.5108256237659905, 
              ""}, {-0.3566749439387323, ""}, {-0.2231435513142097, 
              ""}, {-0.10536051565782628`, ""}, {0., ""}, {
             0.6931471805599453, ""}, {1.0986122886681098`, ""}, {
             1.3862943611198906`, ""}, {1.6094379124341003`, ""}, {
             1.791759469228055, ""}, {1.9459101490553132`, ""}, {
             2.0794415416798357`, ""}, {2.1972245773362196`, ""}, {
             2.302585092994046, ""}, {2.995732273553991, ""}, {
             3.4011973816621555`, ""}, {3.6888794541139363`, ""}, {
             3.912023005428146, ""}, {4.0943445622221, ""}, {
             4.248495242049359, ""}, {4.382026634673881, ""}, {
             4.499809670330265, ""}, {4.605170185988092, ""}, {
             5.298317366548036, ""}, {5.703782474656201, ""}, {
             5.991464547107982, ""}, {6.214608098422191, ""}, {
             6.396929655216146, ""}, {6.551080335043404, ""}, {
             6.684611727667927, ""}, {6.802394763324311, ""}, {
             6.907755278982137, ""}, {7.600902459542082, ""}, {
             8.006367567650246, ""}, {8.294049640102028, ""}, {
             8.517193191416238, ""}, {8.699514748210191, ""}, {
             8.85366542803745, ""}, {8.987196820661973, ""}, {
             9.104979856318357, ""}, {9.210340371976184, ""}, {
             9.903487552536127, ""}, {10.308952660644293`, ""}, {
             10.596634733096073`, ""}, {10.819778284410283`, ""}, {
             11.002099841204238`, ""}, {11.156250521031495`, ""}, {
             11.289781913656018`, ""}, {11.407564949312402`, ""}}}, Axes -> 
          False, PlotLabel -> Style["", 24, 
            GrayLevel[0]], FrameLabel -> {
            Style["x", 18, 
             GrayLevel[0]], 
            Style["\[Mu] [GeV]", 18, 
             GrayLevel[0]]}, FrameTicksStyle -> GrayLevel[0], 
          ImageSize -> {{600}, {600}}, AspectRatio -> 1, DisplayFunction -> 
          Identity, PlotRangePadding -> {{0, 0}, {0, 0}}, 
          AxesOrigin -> {0, 2.329076679826786}, 
          PlotRange -> {{-11.512925464970229`, 0}, {2.302585092994046, 
            7.600902459542082}}, PlotRangeClipping -> True, ImagePadding -> 
          All, DisplayFunction -> Identity, AspectRatio -> 1, 
          Axes -> {True, True}, AxesLabel -> {None, None}, 
          AxesOrigin -> {0, 2.329076679826786}, DisplayFunction :> Identity, 
          Epilog -> {{
             Text[
              Style["Npt: 22", 16, 
               GrayLevel[0]], 
              Scaled[{0.1, 0.9}]], 
             Text[
              Style["highlighted range:\n{2., 100.}", 16, 
               GrayLevel[0]], 
              Scaled[{0.2, 0.7}]]}, {{
              Text[
               Style["Npt: 22", 16, 
                GrayLevel[0]], 
               Scaled[{0.1, 0.9}]], 
              Text[
               Style["highlighted range:\n{2., 100.}", 16, 
                GrayLevel[0]], 
               Scaled[{0.2, 0.7}]]}}}, 
          Frame -> {{False, False}, {False, False}}, 
          FrameLabel -> {{None, None}, {None, None}}, 
          FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
          GridLines -> {None, None}, GridLinesStyle -> Directive[
            GrayLevel[0.5, 0.4]], 
          Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& )}}, 
          PlotRange -> {{-11.512925464970229`, 0}, {2.302585092994046, 
            7.600902459542082}}, PlotRangeClipping -> True, 
          PlotRangePadding -> {{0, 0}, {0, 0}}, 
          Ticks -> {Automatic, Automatic}}], 
        Placed[
         Unevaluated[
          BarLegend[{{
             RGBColor[0., 0., 0.7], 
             RGBColor[0., 0.5, 0.75], 
             RGBColor[0., 0.75, 0.75], 
             RGBColor[
             0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
             RGBColor[0.75, 0.75, 0.], 
             RGBColor[0.75, 0.55, 0.], 
             RGBColor[0.7, 0., 0.]}, {-100, 100}}, {-100, -5., -2., -0.5, 0.5,
             2., 5., 100}, LabelStyle -> {FontSize -> 14}, LegendLabel -> "", 
           LegendLayout -> "Column", LegendMarkerSize -> {}, 
           Charting`TickAnnotations -> None, Charting`TickSide -> Right, 
           ColorFunctionScaling -> True]], {1., 0.5}, Identity]]& ],
      AutoDelete->True,
      Editable->True,
      SelectWithContents->False,
      Selectable->True], ",", 
     TagBox[GridBox[{
        {
         InterpretationBox[Cell[BoxData[
           FormBox[
            
            StyleBox["\<\"Residue(central value) for dataset of CT14HERA2NNLO\
\\n\\n\"\>",
             StripOnInput->False,
             FontSize->24], TextForm]], "InlineText"],
          Text[
           Style[
           "Residue(central value) for dataset of CT14HERA2NNLO\n\n", 
            FontSize -> 24]]], "\[SpanFromLeft]"},
        {"\<\"Data Sets\"\>", ""},
        {"\<\"None(225)\"\>", ""}
       },
       AutoDelete->False,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{14}}},
       GridBoxItemStyle->{"Columns" -> {{
            Directive[FontSize -> 18, 
             GrayLevel[0]]}}, "Rows" -> {{
            Directive[FontSize -> 18, 
             GrayLevel[0]]}}}],
      "Grid"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     GraphicsBox[{
       {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
        EdgeForm[{Opacity[0.294], Thickness[Small]}], {}, 
        {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
         EdgeForm[{Opacity[0.294], Thickness[Small]}], 
         RectangleBox[{-0.9500000000000001, 0}, {-0.9, 2},
          RoundingRadius->0], 
         RectangleBox[{-0.8500000000000001, 0}, {-0.8, 2},
          RoundingRadius->0], RectangleBox[{-0.5, 0}, {-0.45, 2},
          RoundingRadius->0], RectangleBox[{-0.45, 0}, {-0.4, 2},
          RoundingRadius->0], RectangleBox[{-0.25, 0}, {-0.2, 2},
          RoundingRadius->0], 
         RectangleBox[{-0.15000000000000002, 0}, {-0.1, 2},
          RoundingRadius->0], RectangleBox[{0.05, 0}, {0.1, 2},
          RoundingRadius->0], RectangleBox[{0.4, 0}, {0.45, 2},
          RoundingRadius->0], RectangleBox[{0.9, 0}, {0.9500000000000001, 2},
          RoundingRadius->0], 
         RectangleBox[{1.4000000000000001, 0}, {1.4500000000000002, 2},
          RoundingRadius->0], RectangleBox[{1.9500000000000002, 0}, {2., 2},
          
          RoundingRadius->
           0]}, {}, {}}, {{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}}},
      AspectRatio->1,
      Axes->False,
      AxesLabel->{None, None},
      AxesOrigin->{-1.4091570247933871`, 0.},
      BaseStyle->{FontSize -> 16},
      Epilog->{{{
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[1, 0, 0], StripOnInput -> False], TraditionalForm], {-1,
             1.9699999999999998`}], 
          StyleBox[
           LineBox[{{-1, 0.}, {-1, 1.9}}], 
           RGBColor[1, 0, 0], StripOnInput -> False]}, {
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[1, 0, 0], StripOnInput -> False], TraditionalForm], {
           1, 1.89}], 
          StyleBox[
           LineBox[{{1, 0.}, {1, 1.9}}], 
           RGBColor[1, 0, 0], StripOnInput -> False]}}, 
        InsetBox[
         FormBox[
          StyleBox["\"Npt: 22\"", 16, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         Scaled[{0.1, 0.9}]]},
      Frame->True,
      FrameLabel->{
        FormBox[
         StyleBox["\"Residue(central value)\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm], 
        FormBox[
         StyleBox["\"#points\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm]},
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImageSize->{{600}, {600}},
      PlotLabel->FormBox[
        StyleBox["\"\"", 24, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{-1.3549586776859492`, 1.3549586776859492`}, {0., 2}},
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}], ",", 
     GraphicsBox[{
       {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
        EdgeForm[{Opacity[0.48999999999999994`], Thickness[Small]}], {}, 
        {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
         EdgeForm[{Opacity[0.48999999999999994`], Thickness[Small]}], 
         RectangleBox[{0.05, 0}, {0.1, 2},
          RoundingRadius->0], 
         RectangleBox[{0.1, 0}, {0.15000000000000002, 2},
          RoundingRadius->0], RectangleBox[{0.2, 0}, {0.25, 2},
          RoundingRadius->0], RectangleBox[{0.4, 0}, {0.45, 4},
          RoundingRadius->0], RectangleBox[{0.45, 0}, {0.5, 2},
          RoundingRadius->0], RectangleBox[{0.8, 0}, {0.8500000000000001, 2},
          RoundingRadius->0], RectangleBox[{0.9, 0}, {0.9500000000000001, 4},
          RoundingRadius->0], 
         RectangleBox[{1.4000000000000001, 0}, {1.4500000000000002, 2},
          RoundingRadius->0], RectangleBox[{1.9500000000000002, 0}, {2., 2},
          RoundingRadius->0]}, {}, {}}, {{}, {}, {}, {}, {}, {}, {}, {}, {}}},
      
      AspectRatio->1,
      Axes->False,
      AxesLabel->{None, None},
      AxesOrigin->{-0.027099173553718985`, 0.},
      BaseStyle->{FontSize -> 16},
      Epilog->{{{
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[1, 0, 0], StripOnInput -> False], TraditionalForm], {
           1, 3.9399999999999995`}], 
          StyleBox[
           LineBox[{{1, 0.}, {1, 3.8}}], 
           RGBColor[1, 0, 0], StripOnInput -> False]}}, 
        InsetBox[
         FormBox[
          StyleBox["\"Npt: 22\"", 16, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         Scaled[{0.1, 0.9}]]},
      Frame->True,
      FrameLabel->{
        FormBox[
         StyleBox["\"| Residue(central value) |\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm], 
        FormBox[
         StyleBox["\"#points\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm]},
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImageSize->{{600}, {600}},
      PlotLabel->FormBox[
        StyleBox["\"\"", 24, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{0., 1.3549586776859492`}, {0., 4}},
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.7040878641743717`*^9, 3.7040878695724688`*^9}, 
   3.7040879338412247`*^9, 3.704087996374346*^9, {3.7040882859151087`*^9, 
   3.704088306056404*^9}, 3.704572010611328*^9, 3.7045739741261187`*^9, 
   3.705297186525153*^9, 3.706719446326619*^9, 3.706721168990787*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{"p234", "[", 
   RowBox[{"[", 
    RowBox[{"1", ",", "1"}], "]"}], "]"}], " ", "]"}]], "Input",
 CellChangeTimes->{{3.7040893748800087`*^9, 3.7040894269973288`*^9}}],

Cell[BoxData[
 TagBox[
  GraphicsBox[{InsetBox[
     GraphicsBox[{{{{}, {{}, 
          {GrayLevel[1], PointSize[0.012833333333333334`], AbsoluteThickness[
           1.6], 
           StyleBox[PointBox[{{0.00001, 2.}, {0.99, 1200.}}],
            FontFamily->"Helvetica"]}, {}}, {}, {}, {{}, {}}}, {
         {RGBColor[
          0.7470323428571428, 0.6201665142857145, 0.2124675428571429], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.361775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->6.580664472600277]}, 
         {RGBColor[
          0.7946375999999999, 0.7904570285714286, 0.4094384000000003], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.151775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.7946375999999999, 0.7904570285714286, 0.4094384000000003], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.9417756376975808, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.731775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.521775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.2567756376975807, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          
          StyleBox[
           InsetBox["\<\"\[FilledCircle]\"\>", {-3.021775637697581, 4.386889790339869}]
            ,
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.836775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.7946375999999999, 0.7904570285714286, 0.4094384000000003], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.621775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.7470323428571428, 0.6201665142857145, 0.2124675428571429], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.4017756376975807, 4.386889790339869}],
           StripOnInput->False,
           FontSize->6.339384156473448]}, 
         {RGBColor[
          0.7470323428571428, 0.6201665142857145, 0.2124675428571429], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.126775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->7.1239414166052555`]}, 
         {RGBColor[
          0.6820284571428572, 0.3238536000000004, 0.15835314285714291`], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.140720186091876, 4.512945241945574}],
           StripOnInput->False,
           FontSize->8.892877785268496]}, 
         {RGBColor[
          0.7470323428571428, 0.6201665142857145, 0.2124675428571429], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.740720186091876, 4.512945241945574}],
           StripOnInput->False,
           FontSize->5.784998802184959]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.3407201860918763, 4.512945241945574}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.940720186091876, 4.512945241945574}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.540720186091876, 4.512945241945574}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.140720186091876, 4.512945241945574}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.740720186091876, 4.512945241945574}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1407201860918759, 4.512945241945574}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.6820284571428572, 0.3238536000000004, 0.15835314285714291`], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.361775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->8.246915478316648]}, 
         {RGBColor[
          0.6820284571428572, 0.3238536000000004, 0.15835314285714291`], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.151775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->9.1970740059586]}, 
         {RGBColor[
          0.6820284571428572, 0.3238536000000004, 0.15835314285714291`], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.9417756376975808, 4.386889790339869}],
           StripOnInput->False,
           FontSize->8.05573313096209]}, 
         {RGBColor[
          0.7946375999999999, 0.7904570285714286, 0.4094384000000003], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.731775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.521775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.2567756376975807, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.021775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.7470323428571428, 0.6201665142857145, 0.2124675428571429], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.836775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.823255565997711]}, 
         {RGBColor[
          0.6820284571428572, 0.3238536000000004, 0.15835314285714291`], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.621775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->7.624117653390969]}, 
         {RGBColor[
          0.6820284571428572, 0.3238536000000004, 0.15835314285714291`], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.4017756376975807, 4.386889790339869}],
           StripOnInput->False,
           FontSize->12.876991890929105`]}, 
         {RGBColor[
          0.6820284571428572, 0.3238536000000004, 0.15835314285714291`], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.126775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->13.125000000000002`]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.361775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.151775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.9417756376975808, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.731775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.521775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.2567756376975807, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.021775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          
          StyleBox[
           InsetBox["\<\"\[FilledCircle]\"\>", {-2.836775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.7946375999999999, 0.7904570285714286, 0.4094384000000003], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.621775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.7946375999999999, 0.7904570285714286, 0.4094384000000003], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.4017756376975807, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.7470323428571428, 0.6201665142857145, 0.2124675428571429], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.126775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->6.597606907858373]}, 
         {RGBColor[
          0.7470323428571428, 0.6201665142857145, 0.2124675428571429], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.571775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->6.580664472600277]}, 
         {RGBColor[
          0.7946375999999999, 0.7904570285714286, 0.4094384000000003], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.781775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.7946375999999999, 0.7904570285714286, 0.4094384000000003], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.991775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.201775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.4117756376975805, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.676775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.9117756376975805, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.09677563769758, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.7946375999999999, 0.7904570285714286, 0.4094384000000003], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.311775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.7470323428571428, 0.6201665142857145, 0.2124675428571429], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.531775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->6.339384156473448]}, 
         {RGBColor[
          0.7470323428571428, 0.6201665142857145, 0.2124675428571429], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.806775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->7.1239414166052555`]}, 
         {RGBColor[
          0.6820284571428572, 0.3238536000000004, 0.15835314285714291`], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.540720186091876, 4.512945241945574}],
           StripOnInput->False,
           FontSize->8.892877785268496]}, 
         {RGBColor[
          0.7470323428571428, 0.6201665142857145, 0.2124675428571429], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.940720186091876, 4.512945241945574}],
           StripOnInput->False,
           FontSize->5.784998802184959]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.340720186091876, 4.512945241945574}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.740720186091876, 4.512945241945574}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.140720186091876, 4.512945241945574}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.540720186091876, 4.512945241945574}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.940720186091876, 4.512945241945574}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.540720186091876, 4.512945241945574}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.6820284571428572, 0.3238536000000004, 0.15835314285714291`], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.571775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->8.246915478316648]}, 
         {RGBColor[
          0.6820284571428572, 0.3238536000000004, 0.15835314285714291`], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.781775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->9.1970740059586]}, 
         {RGBColor[
          0.6820284571428572, 0.3238536000000004, 0.15835314285714291`], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.991775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->8.05573313096209]}, 
         {RGBColor[
          0.7946375999999999, 0.7904570285714286, 0.4094384000000003], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.201775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.4117756376975805, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.676775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.9117756376975805, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.7470323428571428, 0.6201665142857145, 0.2124675428571429], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.09677563769758, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.823255565997711]}, 
         {RGBColor[
          0.6820284571428572, 0.3238536000000004, 0.15835314285714291`], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.311775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->7.624117653390969]}, 
         {RGBColor[
          0.6820284571428572, 0.3238536000000004, 0.15835314285714291`], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.531775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->12.876991890929105`]}, 
         {RGBColor[
          0.6820284571428572, 0.3238536000000004, 0.15835314285714291`], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.806775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->13.125000000000002`]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.571775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.781775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.991775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.201775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.4117756376975805, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.676775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.9117756376975805, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.09677563769758, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.7946375999999999, 0.7904570285714286, 0.4094384000000003], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.311775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.7946375999999999, 0.7904570285714286, 0.4094384000000003], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.531775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.7470323428571428, 0.6201665142857145, 0.2124675428571429], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.806775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->6.597606907858373]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.140720186091876, 4.512945241945574}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.6407201860918759, 4.512945241945574}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1407201860918759, 4.512945241945574}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.6407201860918759, 4.512945241945574}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.2667756376975805, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7667756376975805, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2667756376975805, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7667756376975805, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.26677563769758056, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.2667756376975805, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7667756376975805, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2667756376975805, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7667756376975805, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.26677563769758056, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.540720186091876, 4.512945241945574}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.040720186091876, 4.512945241945574}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          
          StyleBox[
           InsetBox["\<\"\[FilledCircle]\"\>", 
            {-7.540720186091876, 4.512945241945574}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-8.040720186091876, 4.512945241945574}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.666775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.16677563769758, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.66677563769758, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-8.166775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-8.666775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.666775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.16677563769758, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.66677563769758, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-8.166775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}, 
         {RGBColor[
          0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
          StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-8.666775637697581, 4.386889790339869}],
           StripOnInput->False,
           FontSize->5.625]}}}, {}},
      AspectRatio->1,
      Axes->False,
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      BaseStyle->{FontFamily -> "Helvetica", 16},
      DisplayFunction->Identity,
      Epilog->{{
         InsetBox[
          FormBox[
           StyleBox["\"Npt: 110\"", 16, 
            GrayLevel[0], StripOnInput -> False], TraditionalForm], 
          Scaled[{0.1, 0.9}]], 
         InsetBox[
          FormBox[
           StyleBox["\"highlighted range:\\n{0.7, 1.3028}\"", 16, 
            GrayLevel[0], StripOnInput -> False], TraditionalForm], 
          Scaled[{0.2, 0.7}]]}, {{
          InsetBox[
           FormBox[
            StyleBox["\"Npt: 110\"", 16, 
             GrayLevel[0], StripOnInput -> False], TraditionalForm], 
           Scaled[{0.1, 0.9}]], 
          InsetBox[
           FormBox[
            StyleBox["\"highlighted range:\\n{0.7, 1.3028}\"", 16, 
             GrayLevel[0], StripOnInput -> False], TraditionalForm], 
           Scaled[{0.2, 0.7}]]}}},
      Frame->True,
      FrameLabel->{
        FormBox[
         StyleBox["\"x\"", 18, StripOnInput -> False], TraditionalForm], 
        FormBox[
         StyleBox["\"\[Mu] [GeV]\"", 18, StripOnInput -> False], 
         TraditionalForm]},
      FrameTicks->{{{-13.815510557964274`, 
          FormBox[
          "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
           TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.716898269296165`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.429216196844383`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.206072645530174`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.02375108873622, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.86960040890896, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.736069016284437`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.618285980628055`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.512925464970229`, 
          FormBox[
          "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
           TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-10.414313176302118`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-10.126631103850338`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.903487552536127, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.721165995742174, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.567015315914915, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.433483923290392, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.315700887634009, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.210340371976182, 
          FormBox[
          "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
           TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-8.111728083308073, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.824046010856292, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.600902459542082, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.418580902748127, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.264430222920869, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.1308988302963465`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.013115794639964, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-6.907755278982137, 
          FormBox[
          "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
           TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.809142990314028, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.521460917862246, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.298317366548036, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.115995809754082, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.961845129926823, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.8283137373023015`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.710530701645918, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.605170185988091, 
          FormBox[
          "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
           TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.506557897319982, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.2188758248682006`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.995732273553991, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.8134107167600364`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.659260036932778, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.5257286443082556`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.4079456086518722`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.3025850929940455`, 
          FormBox[
          "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
           TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-1.203972804325936, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.916290731874155, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.6931471805599453, 
          
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.5108256237659905, 
          
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.3566749439387323, 
          
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.2231435513142097, 
          
          FormBox["\"\"", TraditionalForm], {
          0.01, 0}}, {-0.10536051565782628`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
          FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {0.6931471805599453, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         1.0986122886681098`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         1.3862943611198906`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         1.6094379124341003`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.791759469228055, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         1.9459101490553132`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         2.0794415416798357`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         2.1972245773362196`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.302585092994046, 
          FormBox[
          "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
           TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         3.4011973816621555`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         3.6888794541139363`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.912023005428146, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.0943445622221, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.248495242049359, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.382026634673881, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.499809670330265, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.605170185988092, 
          FormBox[
          "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
           TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.703782474656201, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.991464547107982, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.214608098422191, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.396929655216146, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.551080335043404, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.684611727667927, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.802394763324311, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.907755278982137, 
          FormBox[
          "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
           TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.006367567650246, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.294049640102028, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.517193191416238, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.699514748210191, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.987196820661973, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.104979856318357, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.210340371976184, 
          FormBox[
          "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
           TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         10.308952660644293`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         10.596634733096073`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         10.819778284410283`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         11.002099841204238`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         11.156250521031495`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         11.289781913656018`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         11.407564949312402`, 
          FormBox["\"\"", TraditionalForm], {
          0.01, 0}}}, {{-13.815510557964274`, 
          FormBox[
          "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
           TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.716898269296165`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.429216196844383`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.206072645530174`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.02375108873622, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.86960040890896, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.736069016284437`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.618285980628055`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.512925464970229`, 
          FormBox[
          "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
           TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-10.414313176302118`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-10.126631103850338`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.903487552536127, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.721165995742174, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.567015315914915, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.433483923290392, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.315700887634009, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.210340371976182, 
          FormBox[
          "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
           TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-8.111728083308073, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.824046010856292, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.600902459542082, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.418580902748127, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.264430222920869, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.1308988302963465`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.013115794639964, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-6.907755278982137, 
          FormBox[
          "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
           TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.809142990314028, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.521460917862246, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.298317366548036, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.115995809754082, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.961845129926823, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.8283137373023015`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.710530701645918, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.605170185988091, 
          FormBox[
          "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
           TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.506557897319982, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.2188758248682006`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.995732273553991, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.8134107167600364`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.659260036932778, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.5257286443082556`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.4079456086518722`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.3025850929940455`, 
          FormBox[
          "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
           TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-1.203972804325936, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.916290731874155, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.6931471805599453, 
          
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.5108256237659905, 
          
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.3566749439387323, 
          
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.2231435513142097, 
          
          FormBox["\"\"", TraditionalForm], {
          0.01, 0}}, {-0.10536051565782628`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
          FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {0.6931471805599453, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         1.0986122886681098`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         1.3862943611198906`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         1.6094379124341003`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.791759469228055, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         1.9459101490553132`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         2.0794415416798357`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         2.1972245773362196`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.302585092994046, 
          FormBox[
          "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
           TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         3.4011973816621555`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         3.6888794541139363`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.912023005428146, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.0943445622221, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.248495242049359, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.382026634673881, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.499809670330265, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.605170185988092, 
          FormBox[
          "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
           TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.703782474656201, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.991464547107982, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.214608098422191, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.396929655216146, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.551080335043404, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.684611727667927, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.802394763324311, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.907755278982137, 
          FormBox[
          "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
           TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.006367567650246, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.294049640102028, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.517193191416238, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.699514748210191, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.987196820661973, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.104979856318357, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.210340371976184, 
          FormBox[
          "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
           TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         10.308952660644293`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         10.596634733096073`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         10.819778284410283`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         11.002099841204238`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         11.156250521031495`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         11.289781913656018`, 
          FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
         11.407564949312402`, 
          FormBox["\"\"", TraditionalForm], {
          0.01, 0}}}, {{-13.815510557964274`, 
          FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
          FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
          FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
          FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
          FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
          FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
          FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
          FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
          FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
          FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
          FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
          FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
          FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
          FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
          FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
          FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
          FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
          FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
          FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
          FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
          FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
          FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
          FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
          FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
          FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
          FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
          FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
          FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
          FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
          FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
          FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
          FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
          FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
          FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
          FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
          FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
          FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
          FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
          FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
          FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
          FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
          FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
          FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
          FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
          FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
          FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
          FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
          FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
          FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
          FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
          FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
          FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
          FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
          FormBox["\"\"", TraditionalForm]}, {0., 
          FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
          FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
          FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
          FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
          FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
          FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
          FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
          FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
          FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
          FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
          FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
          FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
          FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
          FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
          FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
          FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
          FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
          FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
          FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
          FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
          FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
          FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
          FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
          FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
          FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
          FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
          FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
          FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
          FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
          FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
          FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
          FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
          FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
          FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
          FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
          FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
          FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
          FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
          FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
          FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
          FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
          FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
          FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
          FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
          FormBox["\"\"", TraditionalForm]}}, {{-13.815510557964274`, 
          FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
          FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
          FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
          FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
          FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
          FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
          FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
          FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
          FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
          FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
          FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
          FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
          FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
          FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
          FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
          FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
          FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
          FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
          FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
          FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
          FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
          FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
          FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
          FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
          FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
          FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
          FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
          FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
          FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
          FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
          FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
          FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
          FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
          FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
          FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
          FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
          FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
          FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
          FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
          FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
          FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
          FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
          FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
          FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
          FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
          FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
          FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
          FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
          FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
          FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
          FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
          FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
          FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
          FormBox["\"\"", TraditionalForm]}, {0., 
          FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
          FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
          FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
          FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
          FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
          FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
          FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
          FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
          FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
          FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
          FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
          FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
          FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
          FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
          FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
          FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
          FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
          FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
          FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
          FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
          FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
          FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
          FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
          FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
          FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
          FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
          FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
          FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
          FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
          FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
          FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
          FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
          FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
          FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
          FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
          FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
          FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
          FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
          FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
          FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
          FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
          FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
          FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
          FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
          FormBox["\"\"", TraditionalForm]}}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->{{600}, {600}},
      Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
             Part[#, 1]], 
            (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
             Part[#, 1]], 
            (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
             Part[#, 2]]}& )}},
      PlotLabel->None,
      PlotRange->{{-11.512925464970229`, 0}, {0., 7.600902459542082}},
      PlotRangeClipping->True,
      PlotRangePadding->{{0, 0}, {0, 0}},
      Ticks->{Automatic, Automatic}], Scaled[{0.5, 0.5}], Center, 
     Scaled[{1, 1}]], InsetBox[
     TemplateBox[{FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               StyleBox[
               "\"\"", {FontSize -> 14, FontFamily -> "Arial"}, Background -> 
                Automatic, StripOnInput -> False]}, {
               GraphicsBox[{{}, {}, 
                 
                 RasterBox[{{{0.23216034285714277`, 0.3378795428571428, 
                  0.7518702857142857}}, {{0.4490731428571427, 
                  0.5238090285714285, 0.766888}}, {{0.6824363428571429, 
                  0.7085274285714285, 0.7886763428571428}}, {{
                  0.8705882352941177, 0.8901960784313725, 
                  0.6784313725490196}}, {{0.7946375999999999, 
                  0.7904570285714286, 0.4094384000000003}}, {{
                  0.7470323428571428, 0.6201665142857146, 
                  0.21246754285714303`}}, {{0.6820284571428572, 
                  0.3238536000000004, 0.15835314285714291`}}}, {{
                    Rational[-15, 2], 
                    Rational[-175, 2]}, {
                    Rational[15, 2], 
                    Rational[175, 2]}}], {Antialiasing -> False, 
                  AbsoluteThickness[0.1], 
                  Directive[
                   Opacity[0.3], 
                   GrayLevel[0]], 
                  LineBox[
                   NCache[{{
                    Rational[15, 2], 
                    Rational[-175, 2]}, {
                    Rational[-15, 2], 
                    Rational[-175, 2]}, {
                    Rational[-15, 2], 
                    Rational[175, 2]}, {
                    Rational[15, 2], 
                    Rational[175, 2]}, {
                    Rational[15, 2], 
                    Rational[-175, 2]}}, {{7.5, -87.5}, {-7.5, -87.5}, {-7.5, 
                    87.5}, {7.5, 87.5}, {7.5, -87.5}}]]}, {
                  CapForm[None], {}}, {Antialiasing -> False, 
                  StyleBox[
                   LineBox[{{7.5, -87.5}, {7.5, 87.5}}], 
                   Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                  StyleBox[
                   StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.5, -62.5}, 
                    Offset[{4., 0}, {7.5, -62.5}]}, {{
                    7.5, -37.49999999999999}, 
                    Offset[{4., 0}, {7.5, -37.49999999999999}]}, {{
                    7.5, -12.5}, 
                    Offset[{4., 0}, {7.5, -12.5}]}, {{7.5, 12.5}, 
                    Offset[{4., 0}, {7.5, 12.5}]}, {{7.5, 37.49999999999999}, 
                    
                    Offset[{4., 0}, {7.5, 37.49999999999999}]}, {{7.5, 62.5}, 
                    
                    Offset[{4., 0}, {7.5, 62.5}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-0.85\"", -0.85, AutoDelete -> True],
                     NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -62.5}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-0.70\"", -0.7, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -37.49999999999999}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-0.50\"", -0.5, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -12.5}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"0.50\"", 0.5, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 12.5}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"0.70\"", 0.7, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 37.49999999999999}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"0.85\"", 0.85, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 62.5}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1], FontSize -> 14]}, StripOnInput -> 
                    False]}, {}}, {
                    Directive[
                    Opacity[1], FontSize -> 14]}, StripOnInput -> False], 
                    "GraphicsLabel", StripOnInput -> False]}, "GraphicsTicks",
                     StripOnInput -> False], 
                   Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                Scaled[0.02], PlotRange -> All, Frame -> True, 
                FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                Opacity[0], FrameTicksStyle -> Opacity[0], 
                ImageSize -> {Automatic, 175}, BaseStyle -> {}, 
                BaseStyle -> {FontFamily -> "Helvetica", 16}]}}, 
             GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Grid"], 
           Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontSize -> 14, FontFamily -> "Arial"}, Background -> Automatic, 
         StripOnInput -> False], TraditionalForm]},
      "BarLegend",
      DisplayFunction->(#& ),
      InterpretationFunction:>(RowBox[{"BarLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[
                    0.23216034285714277`, 0.3378795428571428, 
                    0.7518702857142857], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.15477356190476185`, 0.22525302857142854`, 
                    0.5012468571428572], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.23216034285714277, 0.3378795428571428, \
0.7518702857142857]"], Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[
                    0.23216034285714277`, 0.3378795428571428, 
                    0.7518702857142857]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[
                    0.23216034285714277`, 0.3378795428571428, 
                    0.7518702857142857], Editable -> False, Selectable -> 
                    False], ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[
                    0.4490731428571427, 0.5238090285714285, 0.766888], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.29938209523809517`, 0.34920601904761905`, 
                    0.5112586666666668], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.4490731428571427, 0.5238090285714285, \
0.766888]"], Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[
                    0.4490731428571427, 0.5238090285714285, 0.766888]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[
                    0.4490731428571427, 0.5238090285714285, 0.766888], 
                    Editable -> False, Selectable -> False], ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[
                    0.6824363428571429, 0.7085274285714285, 
                    0.7886763428571428], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.454957561904762, 0.472351619047619, 0.5257842285714286],
                     FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.6824363428571429, 0.7085274285714285, \
0.7886763428571428]"], Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[
                    0.6824363428571429, 0.7085274285714285, 
                    0.7886763428571428]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[
                    0.6824363428571429, 0.7085274285714285, 
                    0.7886763428571428], Editable -> False, Selectable -> 
                    False], ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[
                    0.8705882352941177, 0.8901960784313725, 
                    0.6784313725490196], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.5803921568627451, 0.5934640522875817, 
                    0.45228758169934646`], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.8705882352941177, 0.8901960784313725, \
0.6784313725490196]"], Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[
                    0.8705882352941177, 0.8901960784313725, 
                    0.6784313725490196]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[
                    0.8705882352941177, 0.8901960784313725, 
                    0.6784313725490196], Editable -> False, Selectable -> 
                    False], ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[
                    0.7946375999999999, 0.7904570285714286, 
                    0.4094384000000003], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.5297584, 0.5269713523809525, 0.27295893333333354`], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7946375999999999, 0.7904570285714286, \
0.4094384000000003]"], Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[
                    0.7946375999999999, 0.7904570285714286, 
                    0.4094384000000003]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[
                    0.7946375999999999, 0.7904570285714286, 
                    0.4094384000000003], Editable -> False, Selectable -> 
                    False], ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[
                    0.7470323428571428, 0.6201665142857145, 
                    0.2124675428571429], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.4980215619047619, 0.413444342857143, 
                    0.1416450285714286], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    
                    "RGBColor[0.7470323428571428, 0.6201665142857145, \
0.2124675428571429]"], Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[
                    0.7470323428571428, 0.6201665142857145, 
                    0.2124675428571429]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[
                    0.7470323428571428, 0.6201665142857145, 
                    0.2124675428571429], Editable -> False, Selectable -> 
                    False], ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[
                    0.6820284571428572, 0.3238536000000004, 
                    0.15835314285714291`], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.45468563809523815`, 0.21590240000000027`, 
                    0.10556876190476194`], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.6820284571428572, 0.3238536000000004, \
0.15835314285714291]"], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[
                    0.6820284571428572, 0.3238536000000004, 
                    0.15835314285714291`]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[
                    0.6820284571428572, 0.3238536000000004, 
                    0.15835314285714291`], Editable -> False, Selectable -> 
                    False]}], "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "100"}], ",", "100"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{
               RowBox[{"-", "100"}], ",", 
               RowBox[{"-", "0.85`"}], ",", 
               RowBox[{"-", "0.7`"}], ",", 
               RowBox[{"-", "0.5`"}], ",", "0.5`", ",", "0.7`", ",", "0.85`", 
               ",", "100"}], "}"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"FontSize", "\[Rule]", "14"}], "}"}]}], ",", 
           RowBox[{"LegendLabel", "\[Rule]", "\"\""}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
           RowBox[{"LegendMarkerSize", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
           RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
           RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], "]"}]& )], 
     Scaled[{1., 0.5}], ImageScaled[{0, 0.5}],
     BaseStyle->{FontSize -> Larger},
     FormatType->StandardForm]},
   AspectRatio->1,
   Axes->False,
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   BaseStyle->{FontFamily -> "Helvetica", 16},
   DisplayFunction->Identity,
   Frame->False,
   FrameLabel->{
     FormBox[
      StyleBox["\"x\"", 18, StripOnInput -> False], TraditionalForm], 
     FormBox[
      StyleBox["\"\[Mu] [GeV]\"", 18, StripOnInput -> False], 
      TraditionalForm]},
   FrameTicks->{{{-13.815510557964274`, 
       FormBox[
       "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
        TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.716898269296165`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.429216196844383`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.02375108873622, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.86960040890896, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.736069016284437`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.618285980628055`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.512925464970229`, 
       FormBox[
       "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
        TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-10.414313176302118`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-10.126631103850338`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.721165995742174, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.567015315914915, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.433483923290392, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.315700887634009, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.210340371976182, 
       FormBox[
       "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
        TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-8.111728083308073, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.824046010856292, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.418580902748127, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.264430222920869, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.1308988302963465`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.013115794639964, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-6.907755278982137, 
       FormBox[
       "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
        TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.809142990314028, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.521460917862246, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.115995809754082, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.961845129926823, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.8283137373023015`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.710530701645918, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.605170185988091, 
       FormBox[
       "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
        TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.506557897319982, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.2188758248682006`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.995732273553991, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.8134107167600364`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.659260036932778, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.5257286443082556`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.4079456086518722`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.3025850929940455`, 
       FormBox[
       "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
        TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-1.203972804325936, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.916290731874155, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.6931471805599453, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.5108256237659905, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.3566749439387323, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.2231435513142097, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.10536051565782628`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
       FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {0.6931471805599453, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.0986122886681098`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.3862943611198906`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.6094379124341003`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.791759469228055, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.9459101490553132`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.0794415416798357`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.1972245773362196`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.302585092994046, 
       FormBox[
       "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
        TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.4011973816621555`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.6888794541139363`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.912023005428146, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.0943445622221, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.248495242049359, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.382026634673881, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.499809670330265, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.605170185988092, 
       FormBox[
       "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
        TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.907755278982137, 
       FormBox[
       "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
        TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.210340371976184, 
       FormBox[
       "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
        TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}}, {{-13.815510557964274`, 
       
       FormBox[
       "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
        TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.716898269296165`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.429216196844383`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.02375108873622, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.86960040890896, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.736069016284437`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.618285980628055`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.512925464970229`, 
       FormBox[
       "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
        TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-10.414313176302118`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-10.126631103850338`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.721165995742174, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.567015315914915, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.433483923290392, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.315700887634009, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.210340371976182, 
       FormBox[
       "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
        TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-8.111728083308073, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.824046010856292, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.418580902748127, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.264430222920869, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.1308988302963465`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.013115794639964, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-6.907755278982137, 
       FormBox[
       "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
        TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.809142990314028, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.521460917862246, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.115995809754082, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.961845129926823, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.8283137373023015`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.710530701645918, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.605170185988091, 
       FormBox[
       "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
        TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.506557897319982, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.2188758248682006`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.995732273553991, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.8134107167600364`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.659260036932778, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.5257286443082556`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.4079456086518722`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.3025850929940455`, 
       FormBox[
       "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
        TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-1.203972804325936, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.916290731874155, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.6931471805599453, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.5108256237659905, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.3566749439387323, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.2231435513142097, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.10536051565782628`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
       FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {0.6931471805599453, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.0986122886681098`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.3862943611198906`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.6094379124341003`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.791759469228055, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.9459101490553132`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.0794415416798357`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.1972245773362196`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.302585092994046, 
       FormBox[
       "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
        TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.4011973816621555`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.6888794541139363`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.912023005428146, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.0943445622221, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.248495242049359, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.382026634673881, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.499809670330265, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.605170185988092, 
       FormBox[
       "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
        TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.907755278982137, 
       FormBox[
       "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
        TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.210340371976184, 
       FormBox[
       "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
        TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.01, 0}}}, {{-13.815510557964274`, 
       
       FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
       FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
       FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
       FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
       FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
       FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
       FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
       FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
       FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
       FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
       FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
       FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
       FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
       FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
       FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
       FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
       FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
       FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
       FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
       FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
       FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
       FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
       FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
       FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
       FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
       FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
       FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
       FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
       FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
       FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
       FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
       FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
       FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
       FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
       FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
       FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
       FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
       FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
       FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
       FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
       FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
       FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
       FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
       FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
       FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
       FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
       FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
       FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
       FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
       FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
       FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
       FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
       FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
       FormBox["\"\"", TraditionalForm]}, {0., 
       FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
       FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
       FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
       FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
       FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
       FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
       FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
       FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
       FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
       FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
       FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
       FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
       FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
       FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
       FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
       FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
       FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
       FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
       FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
       FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
       FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm]}}, {{-13.815510557964274`, 
       FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
       FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
       FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
       FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
       FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
       FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
       FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
       FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
       FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
       FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
       FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
       FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
       FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
       FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
       FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
       FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
       FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
       FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
       FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
       FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
       FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
       FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
       FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
       FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
       FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
       FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
       FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
       FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
       FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
       FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
       FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
       FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
       FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
       FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
       FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
       FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
       FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
       FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
       FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
       FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
       FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
       FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
       FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
       FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
       FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
       FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
       FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
       FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
       FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
       FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
       FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
       FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
       FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
       FormBox["\"\"", TraditionalForm]}, {0., 
       FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
       FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
       FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
       FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
       FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
       FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
       FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
       FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
       FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
       FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
       FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
       FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
       FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
       FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
       FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
       FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
       FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
       FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
       FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
       FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
       FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm]}}},
   ImagePadding->All,
   ImageSize->{{600}, {600}},
   Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
         (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
          Part[#, 1]], 
         (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
          Part[#, 2]]}& ), "CopiedValueFunction" -> ({
         (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
          Part[#, 1]], 
         (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
          Part[#, 2]]}& )}},
   PlotLabel->FormBox[
     StyleBox["\"\"", 24, StripOnInput -> False], TraditionalForm],
   PlotRange->Automatic,
   PlotRangeClipping->False,
   PlotRangePadding->{{0, 0}, {0, 0}},
   Ticks->{Automatic, Automatic}],
  InterpretTemplate[Legended[
    Graphics[{{{}, {{{}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           PointSize[0.012833333333333334`], 
           AbsoluteThickness[1.6], FontFamily -> "Helvetica", 
           GrayLevel[1]], 
          Point[{{0.00001, 2.}, {0.99, 1200.}}]}, {}}}, {}, {}, {{}, {}}}, {
       Style[
        Text["\[FilledCircle]", {-4.361775637697581, 4.386889790339869}], 
        6.580664472600277, 
        RGBColor[0.7470323428571428, 0.6201665142857145, 0.2124675428571429]], 
       Style[
        Text["\[FilledCircle]", {-4.151775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.7946375999999999, 0.7904570285714286, 0.4094384000000003]], 
       Style[
        Text["\[FilledCircle]", {-3.9417756376975808`, 4.386889790339869}], 
        5.625, 
        RGBColor[0.7946375999999999, 0.7904570285714286, 0.4094384000000003]], 
       Style[
        Text["\[FilledCircle]", {-3.731775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-3.521775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-3.2567756376975807`, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-3.021775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-2.836775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-2.621775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.7946375999999999, 0.7904570285714286, 0.4094384000000003]], 
       Style[
        Text["\[FilledCircle]", {-2.4017756376975807`, 4.386889790339869}], 
        6.339384156473448, 
        RGBColor[0.7470323428571428, 0.6201665142857145, 0.2124675428571429]], 
       Style[
        Text["\[FilledCircle]", {-2.126775637697581, 4.386889790339869}], 
        7.1239414166052555`, 
        RGBColor[0.7470323428571428, 0.6201665142857145, 0.2124675428571429]], 
       Style[
        Text["\[FilledCircle]", {-4.140720186091876, 4.512945241945574}], 
        8.892877785268496, 
        RGBColor[
        0.6820284571428572, 0.3238536000000004, 0.15835314285714291`]], 
       Style[
        Text["\[FilledCircle]", {-3.740720186091876, 4.512945241945574}], 
        5.784998802184959, 
        RGBColor[0.7470323428571428, 0.6201665142857145, 0.2124675428571429]], 
       Style[
        Text["\[FilledCircle]", {-3.3407201860918763`, 4.512945241945574}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-2.940720186091876, 4.512945241945574}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-2.540720186091876, 4.512945241945574}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-2.140720186091876, 4.512945241945574}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-1.740720186091876, 4.512945241945574}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-1.1407201860918759`, 4.512945241945574}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-4.361775637697581, 4.386889790339869}], 
        8.246915478316648, 
        RGBColor[
        0.6820284571428572, 0.3238536000000004, 0.15835314285714291`]], 
       Style[
        Text["\[FilledCircle]", {-4.151775637697581, 4.386889790339869}], 
        9.1970740059586, 
        RGBColor[
        0.6820284571428572, 0.3238536000000004, 0.15835314285714291`]], 
       Style[
        Text["\[FilledCircle]", {-3.9417756376975808`, 4.386889790339869}], 
        8.05573313096209, 
        RGBColor[
        0.6820284571428572, 0.3238536000000004, 0.15835314285714291`]], 
       Style[
        Text["\[FilledCircle]", {-3.731775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.7946375999999999, 0.7904570285714286, 0.4094384000000003]], 
       Style[
        Text["\[FilledCircle]", {-3.521775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-3.2567756376975807`, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-3.021775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-2.836775637697581, 4.386889790339869}], 
        5.823255565997711, 
        RGBColor[0.7470323428571428, 0.6201665142857145, 0.2124675428571429]], 
       Style[
        Text["\[FilledCircle]", {-2.621775637697581, 4.386889790339869}], 
        7.624117653390969, 
        RGBColor[
        0.6820284571428572, 0.3238536000000004, 0.15835314285714291`]], 
       Style[
        Text["\[FilledCircle]", {-2.4017756376975807`, 4.386889790339869}], 
        12.876991890929105`, 
        RGBColor[
        0.6820284571428572, 0.3238536000000004, 0.15835314285714291`]], 
       Style[
        Text["\[FilledCircle]", {-2.126775637697581, 4.386889790339869}], 
        13.125000000000002`, 
        RGBColor[
        0.6820284571428572, 0.3238536000000004, 0.15835314285714291`]], 
       Style[
        Text["\[FilledCircle]", {-4.361775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-4.151775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-3.9417756376975808`, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-3.731775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-3.521775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-3.2567756376975807`, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-3.021775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-2.836775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-2.621775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.7946375999999999, 0.7904570285714286, 0.4094384000000003]], 
       Style[
        Text["\[FilledCircle]", {-2.4017756376975807`, 4.386889790339869}], 
        5.625, 
        RGBColor[0.7946375999999999, 0.7904570285714286, 0.4094384000000003]], 
       Style[
        Text["\[FilledCircle]", {-2.126775637697581, 4.386889790339869}], 
        6.597606907858373, 
        RGBColor[0.7470323428571428, 0.6201665142857145, 0.2124675428571429]], 
       Style[
        Text["\[FilledCircle]", {-4.571775637697581, 4.386889790339869}], 
        6.580664472600277, 
        RGBColor[0.7470323428571428, 0.6201665142857145, 0.2124675428571429]], 
       Style[
        Text["\[FilledCircle]", {-4.781775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.7946375999999999, 0.7904570285714286, 0.4094384000000003]], 
       Style[
        Text["\[FilledCircle]", {-4.991775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.7946375999999999, 0.7904570285714286, 0.4094384000000003]], 
       Style[
        Text["\[FilledCircle]", {-5.201775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-5.4117756376975805`, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-5.676775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-5.9117756376975805`, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-6.09677563769758, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-6.311775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.7946375999999999, 0.7904570285714286, 0.4094384000000003]], 
       Style[
        Text["\[FilledCircle]", {-6.531775637697581, 4.386889790339869}], 
        6.339384156473448, 
        RGBColor[0.7470323428571428, 0.6201665142857145, 0.2124675428571429]], 
       Style[
        Text["\[FilledCircle]", {-6.806775637697581, 4.386889790339869}], 
        7.1239414166052555`, 
        RGBColor[0.7470323428571428, 0.6201665142857145, 0.2124675428571429]], 
       Style[
        Text["\[FilledCircle]", {-4.540720186091876, 4.512945241945574}], 
        8.892877785268496, 
        RGBColor[
        0.6820284571428572, 0.3238536000000004, 0.15835314285714291`]], 
       Style[
        Text["\[FilledCircle]", {-4.940720186091876, 4.512945241945574}], 
        5.784998802184959, 
        RGBColor[0.7470323428571428, 0.6201665142857145, 0.2124675428571429]], 
       Style[
        Text["\[FilledCircle]", {-5.340720186091876, 4.512945241945574}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-5.740720186091876, 4.512945241945574}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-6.140720186091876, 4.512945241945574}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-6.540720186091876, 4.512945241945574}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-6.940720186091876, 4.512945241945574}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-7.540720186091876, 4.512945241945574}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-4.571775637697581, 4.386889790339869}], 
        8.246915478316648, 
        RGBColor[
        0.6820284571428572, 0.3238536000000004, 0.15835314285714291`]], 
       Style[
        Text["\[FilledCircle]", {-4.781775637697581, 4.386889790339869}], 
        9.1970740059586, 
        RGBColor[
        0.6820284571428572, 0.3238536000000004, 0.15835314285714291`]], 
       Style[
        Text["\[FilledCircle]", {-4.991775637697581, 4.386889790339869}], 
        8.05573313096209, 
        RGBColor[
        0.6820284571428572, 0.3238536000000004, 0.15835314285714291`]], 
       Style[
        Text["\[FilledCircle]", {-5.201775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.7946375999999999, 0.7904570285714286, 0.4094384000000003]], 
       Style[
        Text["\[FilledCircle]", {-5.4117756376975805`, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-5.676775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-5.9117756376975805`, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-6.09677563769758, 4.386889790339869}], 
        5.823255565997711, 
        RGBColor[0.7470323428571428, 0.6201665142857145, 0.2124675428571429]], 
       Style[
        Text["\[FilledCircle]", {-6.311775637697581, 4.386889790339869}], 
        7.624117653390969, 
        RGBColor[
        0.6820284571428572, 0.3238536000000004, 0.15835314285714291`]], 
       Style[
        Text["\[FilledCircle]", {-6.531775637697581, 4.386889790339869}], 
        12.876991890929105`, 
        RGBColor[
        0.6820284571428572, 0.3238536000000004, 0.15835314285714291`]], 
       Style[
        Text["\[FilledCircle]", {-6.806775637697581, 4.386889790339869}], 
        13.125000000000002`, 
        RGBColor[
        0.6820284571428572, 0.3238536000000004, 0.15835314285714291`]], 
       Style[
        Text["\[FilledCircle]", {-4.571775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-4.781775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-4.991775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-5.201775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-5.4117756376975805`, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-5.676775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-5.9117756376975805`, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-6.09677563769758, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-6.311775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.7946375999999999, 0.7904570285714286, 0.4094384000000003]], 
       Style[
        Text["\[FilledCircle]", {-6.531775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.7946375999999999, 0.7904570285714286, 0.4094384000000003]], 
       Style[
        Text["\[FilledCircle]", {-6.806775637697581, 4.386889790339869}], 
        6.597606907858373, 
        RGBColor[0.7470323428571428, 0.6201665142857145, 0.2124675428571429]], 
       Style[
        Text["\[FilledCircle]", {-2.140720186091876, 4.512945241945574}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-1.6407201860918759`, 4.512945241945574}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-1.1407201860918759`, 4.512945241945574}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-0.6407201860918759, 4.512945241945574}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-2.2667756376975805`, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-1.7667756376975805`, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-1.2667756376975805`, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-0.7667756376975805, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-0.26677563769758056`, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-2.2667756376975805`, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-1.7667756376975805`, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-1.2667756376975805`, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-0.7667756376975805, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-0.26677563769758056`, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-6.540720186091876, 4.512945241945574}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-7.040720186091876, 4.512945241945574}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-7.540720186091876, 4.512945241945574}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-8.040720186091876, 4.512945241945574}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-6.666775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-7.16677563769758, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-7.66677563769758, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-8.166775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-8.666775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-6.666775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-7.16677563769758, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-7.66677563769758, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-8.166775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196]], 
       Style[
        Text["\[FilledCircle]", {-8.666775637697581, 4.386889790339869}], 
        5.625, 
        RGBColor[
        0.8705882352941177, 0.8901960784313725, 0.6784313725490196]]}}, {
     Frame -> True, 
      FrameTicks -> {{{-13.815510557964274`, 
          "\!\(\*SuperscriptBox[\(10\), \(-6\)]\)", {0.02, 
          0.}}, {-13.122363377404328`, "", {0.01, 0}}, {-12.716898269296165`, 
          "", {0.01, 0}}, {-12.429216196844383`, "", {
          0.01, 0}}, {-12.206072645530174`, "", {
          0.01, 0}}, {-12.02375108873622, "", {0.01, 0}}, {-11.86960040890896,
           "", {0.01, 0}}, {-11.736069016284437`, "", {
          0.01, 0}}, {-11.618285980628055`, "", {
          0.01, 0}}, {-11.512925464970229`, 
          "\!\(\*SuperscriptBox[\(10\), \(-5\)]\)", {0.02, 
          0.}}, {-10.819778284410283`, "", {0.01, 0}}, {-10.414313176302118`, 
          "", {0.01, 0}}, {-10.126631103850338`, "", {
          0.01, 0}}, {-9.903487552536127, "", {0.01, 0}}, {-9.721165995742174,
           "", {0.01, 0}}, {-9.567015315914915, "", {
          0.01, 0}}, {-9.433483923290392, "", {0.01, 0}}, {-9.315700887634009,
           "", {0.01, 0}}, {-9.210340371976182, 
          "\!\(\*SuperscriptBox[\(10\), \(-4\)]\)", {0.02, 
          0.}}, {-8.517193191416238, "", {0.01, 0}}, {-8.111728083308073, 
          "", {0.01, 0}}, {-7.824046010856292, "", {
          0.01, 0}}, {-7.600902459542082, "", {0.01, 0}}, {-7.418580902748127,
           "", {0.01, 0}}, {-7.264430222920869, "", {
          0.01, 0}}, {-7.1308988302963465`, "", {
          0.01, 0}}, {-7.013115794639964, "", {0.01, 0}}, {-6.907755278982137,
           "\!\(\*SuperscriptBox[\(10\), \(-3\)]\)", {0.02, 
          0.}}, {-6.214608098422191, "", {0.01, 0}}, {-5.809142990314028, 
          "", {0.01, 0}}, {-5.521460917862246, "", {
          0.01, 0}}, {-5.298317366548036, "", {0.01, 0}}, {-5.115995809754082,
           "", {0.01, 0}}, {-4.961845129926823, "", {
          0.01, 0}}, {-4.8283137373023015`, "", {
          0.01, 0}}, {-4.710530701645918, "", {0.01, 0}}, {-4.605170185988091,
           "\!\(\*SuperscriptBox[\(10\), \(-2\)]\)", {0.02, 
          0.}}, {-3.912023005428146, "", {0.01, 0}}, {-3.506557897319982, 
          "", {0.01, 0}}, {-3.2188758248682006`, "", {
          0.01, 0}}, {-2.995732273553991, "", {
          0.01, 0}}, {-2.8134107167600364`, "", {
          0.01, 0}}, {-2.659260036932778, "", {
          0.01, 0}}, {-2.5257286443082556`, "", {
          0.01, 0}}, {-2.4079456086518722`, "", {
          0.01, 0}}, {-2.3025850929940455`, 
          "\!\(\*SuperscriptBox[\(10\), \(-1\)]\)", {0.02, 
          0.}}, {-1.6094379124341003`, "", {0.01, 0}}, {-1.203972804325936, 
          "", {0.01, 0}}, {-0.916290731874155, "", {
          0.01, 0}}, {-0.6931471805599453, "", {
          0.01, 0}}, {-0.5108256237659905, "", {
          0.01, 0}}, {-0.3566749439387323, "", {
          0.01, 0}}, {-0.2231435513142097, "", {
          0.01, 0}}, {-0.10536051565782628`, "", {0.01, 0}}, {
         0., "1", {0.02, 0.}}, {0.6931471805599453, "", {0.01, 0}}, {
         1.0986122886681098`, "", {0.01, 0}}, {
         1.3862943611198906`, "", {0.01, 0}}, {
         1.6094379124341003`, "", {0.01, 0}}, {
         1.791759469228055, "", {0.01, 0}}, {
         1.9459101490553132`, "", {0.01, 0}}, {
         2.0794415416798357`, "", {0.01, 0}}, {
         2.1972245773362196`, "", {0.01, 0}}, {
         2.302585092994046, "\!\(\*SuperscriptBox[\(10\), \(1\)]\)", {0.02, 
          0.}}, {2.995732273553991, "", {0.01, 0}}, {
         3.4011973816621555`, "", {0.01, 0}}, {
         3.6888794541139363`, "", {0.01, 0}}, {
         3.912023005428146, "", {0.01, 0}}, {
         4.0943445622221, "", {0.01, 0}}, {
         4.248495242049359, "", {0.01, 0}}, {
         4.382026634673881, "", {0.01, 0}}, {
         4.499809670330265, "", {0.01, 0}}, {
         4.605170185988092, "\!\(\*SuperscriptBox[\(10\), \(2\)]\)", {0.02, 
          0.}}, {5.298317366548036, "", {0.01, 0}}, {
         5.703782474656201, "", {0.01, 0}}, {
         5.991464547107982, "", {0.01, 0}}, {
         6.214608098422191, "", {0.01, 0}}, {
         6.396929655216146, "", {0.01, 0}}, {
         6.551080335043404, "", {0.01, 0}}, {
         6.684611727667927, "", {0.01, 0}}, {
         6.802394763324311, "", {0.01, 0}}, {
         6.907755278982137, "\!\(\*SuperscriptBox[\(10\), \(3\)]\)", {0.02, 
          0.}}, {7.600902459542082, "", {0.01, 0}}, {
         8.006367567650246, "", {0.01, 0}}, {
         8.294049640102028, "", {0.01, 0}}, {
         8.517193191416238, "", {0.01, 0}}, {
         8.699514748210191, "", {0.01, 0}}, {
         8.85366542803745, "", {0.01, 0}}, {
         8.987196820661973, "", {0.01, 0}}, {
         9.104979856318357, "", {0.01, 0}}, {
         9.210340371976184, "\!\(\*SuperscriptBox[\(10\), \(4\)]\)", {0.02, 
          0.}}, {9.903487552536127, "", {0.01, 0}}, {
         10.308952660644293`, "", {0.01, 0}}, {
         10.596634733096073`, "", {0.01, 0}}, {
         10.819778284410283`, "", {0.01, 0}}, {
         11.002099841204238`, "", {0.01, 0}}, {
         11.156250521031495`, "", {0.01, 0}}, {
         11.289781913656018`, "", {0.01, 0}}, {
         11.407564949312402`, "", {0.01, 0}}}, {{-13.815510557964274`, 
          "\!\(\*SuperscriptBox[\(10\), \(-6\)]\)", {0.02, 
          0.}}, {-13.122363377404328`, "", {0.01, 0}}, {-12.716898269296165`, 
          "", {0.01, 0}}, {-12.429216196844383`, "", {
          0.01, 0}}, {-12.206072645530174`, "", {
          0.01, 0}}, {-12.02375108873622, "", {0.01, 0}}, {-11.86960040890896,
           "", {0.01, 0}}, {-11.736069016284437`, "", {
          0.01, 0}}, {-11.618285980628055`, "", {
          0.01, 0}}, {-11.512925464970229`, 
          "\!\(\*SuperscriptBox[\(10\), \(-5\)]\)", {0.02, 
          0.}}, {-10.819778284410283`, "", {0.01, 0}}, {-10.414313176302118`, 
          "", {0.01, 0}}, {-10.126631103850338`, "", {
          0.01, 0}}, {-9.903487552536127, "", {0.01, 0}}, {-9.721165995742174,
           "", {0.01, 0}}, {-9.567015315914915, "", {
          0.01, 0}}, {-9.433483923290392, "", {0.01, 0}}, {-9.315700887634009,
           "", {0.01, 0}}, {-9.210340371976182, 
          "\!\(\*SuperscriptBox[\(10\), \(-4\)]\)", {0.02, 
          0.}}, {-8.517193191416238, "", {0.01, 0}}, {-8.111728083308073, 
          "", {0.01, 0}}, {-7.824046010856292, "", {
          0.01, 0}}, {-7.600902459542082, "", {0.01, 0}}, {-7.418580902748127,
           "", {0.01, 0}}, {-7.264430222920869, "", {
          0.01, 0}}, {-7.1308988302963465`, "", {
          0.01, 0}}, {-7.013115794639964, "", {0.01, 0}}, {-6.907755278982137,
           "\!\(\*SuperscriptBox[\(10\), \(-3\)]\)", {0.02, 
          0.}}, {-6.214608098422191, "", {0.01, 0}}, {-5.809142990314028, 
          "", {0.01, 0}}, {-5.521460917862246, "", {
          0.01, 0}}, {-5.298317366548036, "", {0.01, 0}}, {-5.115995809754082,
           "", {0.01, 0}}, {-4.961845129926823, "", {
          0.01, 0}}, {-4.8283137373023015`, "", {
          0.01, 0}}, {-4.710530701645918, "", {0.01, 0}}, {-4.605170185988091,
           "\!\(\*SuperscriptBox[\(10\), \(-2\)]\)", {0.02, 
          0.}}, {-3.912023005428146, "", {0.01, 0}}, {-3.506557897319982, 
          "", {0.01, 0}}, {-3.2188758248682006`, "", {
          0.01, 0}}, {-2.995732273553991, "", {
          0.01, 0}}, {-2.8134107167600364`, "", {
          0.01, 0}}, {-2.659260036932778, "", {
          0.01, 0}}, {-2.5257286443082556`, "", {
          0.01, 0}}, {-2.4079456086518722`, "", {
          0.01, 0}}, {-2.3025850929940455`, 
          "\!\(\*SuperscriptBox[\(10\), \(-1\)]\)", {0.02, 
          0.}}, {-1.6094379124341003`, "", {0.01, 0}}, {-1.203972804325936, 
          "", {0.01, 0}}, {-0.916290731874155, "", {
          0.01, 0}}, {-0.6931471805599453, "", {
          0.01, 0}}, {-0.5108256237659905, "", {
          0.01, 0}}, {-0.3566749439387323, "", {
          0.01, 0}}, {-0.2231435513142097, "", {
          0.01, 0}}, {-0.10536051565782628`, "", {0.01, 0}}, {
         0., "1", {0.02, 0.}}, {0.6931471805599453, "", {0.01, 0}}, {
         1.0986122886681098`, "", {0.01, 0}}, {
         1.3862943611198906`, "", {0.01, 0}}, {
         1.6094379124341003`, "", {0.01, 0}}, {
         1.791759469228055, "", {0.01, 0}}, {
         1.9459101490553132`, "", {0.01, 0}}, {
         2.0794415416798357`, "", {0.01, 0}}, {
         2.1972245773362196`, "", {0.01, 0}}, {
         2.302585092994046, "\!\(\*SuperscriptBox[\(10\), \(1\)]\)", {0.02, 
          0.}}, {2.995732273553991, "", {0.01, 0}}, {
         3.4011973816621555`, "", {0.01, 0}}, {
         3.6888794541139363`, "", {0.01, 0}}, {
         3.912023005428146, "", {0.01, 0}}, {
         4.0943445622221, "", {0.01, 0}}, {
         4.248495242049359, "", {0.01, 0}}, {
         4.382026634673881, "", {0.01, 0}}, {
         4.499809670330265, "", {0.01, 0}}, {
         4.605170185988092, "\!\(\*SuperscriptBox[\(10\), \(2\)]\)", {0.02, 
          0.}}, {5.298317366548036, "", {0.01, 0}}, {
         5.703782474656201, "", {0.01, 0}}, {
         5.991464547107982, "", {0.01, 0}}, {
         6.214608098422191, "", {0.01, 0}}, {
         6.396929655216146, "", {0.01, 0}}, {
         6.551080335043404, "", {0.01, 0}}, {
         6.684611727667927, "", {0.01, 0}}, {
         6.802394763324311, "", {0.01, 0}}, {
         6.907755278982137, "\!\(\*SuperscriptBox[\(10\), \(3\)]\)", {0.02, 
          0.}}, {7.600902459542082, "", {0.01, 0}}, {
         8.006367567650246, "", {0.01, 0}}, {
         8.294049640102028, "", {0.01, 0}}, {
         8.517193191416238, "", {0.01, 0}}, {
         8.699514748210191, "", {0.01, 0}}, {
         8.85366542803745, "", {0.01, 0}}, {
         8.987196820661973, "", {0.01, 0}}, {
         9.104979856318357, "", {0.01, 0}}, {
         9.210340371976184, "\!\(\*SuperscriptBox[\(10\), \(4\)]\)", {0.02, 
          0.}}, {9.903487552536127, "", {0.01, 0}}, {
         10.308952660644293`, "", {0.01, 0}}, {
         10.596634733096073`, "", {0.01, 0}}, {
         10.819778284410283`, "", {0.01, 0}}, {
         11.002099841204238`, "", {0.01, 0}}, {
         11.156250521031495`, "", {0.01, 0}}, {
         11.289781913656018`, "", {0.01, 0}}, {
         11.407564949312402`, "", {0.01, 0}}}, {{-13.815510557964274`, 
          ""}, {-13.122363377404328`, ""}, {-12.716898269296165`, 
          ""}, {-12.429216196844383`, ""}, {-12.206072645530174`, 
          ""}, {-12.02375108873622, ""}, {-11.86960040890896, 
          ""}, {-11.736069016284437`, ""}, {-11.618285980628055`, 
          ""}, {-11.512925464970229`, ""}, {-10.819778284410283`, 
          ""}, {-10.414313176302118`, ""}, {-10.126631103850338`, 
          ""}, {-9.903487552536127, ""}, {-9.721165995742174, 
          ""}, {-9.567015315914915, ""}, {-9.433483923290392, 
          ""}, {-9.315700887634009, ""}, {-9.210340371976182, 
          ""}, {-8.517193191416238, ""}, {-8.111728083308073, 
          ""}, {-7.824046010856292, ""}, {-7.600902459542082, 
          ""}, {-7.418580902748127, ""}, {-7.264430222920869, 
          ""}, {-7.1308988302963465`, ""}, {-7.013115794639964, 
          ""}, {-6.907755278982137, ""}, {-6.214608098422191, 
          ""}, {-5.809142990314028, ""}, {-5.521460917862246, 
          ""}, {-5.298317366548036, ""}, {-5.115995809754082, 
          ""}, {-4.961845129926823, ""}, {-4.8283137373023015`, 
          ""}, {-4.710530701645918, ""}, {-4.605170185988091, 
          ""}, {-3.912023005428146, ""}, {-3.506557897319982, 
          ""}, {-3.2188758248682006`, ""}, {-2.995732273553991, 
          ""}, {-2.8134107167600364`, ""}, {-2.659260036932778, 
          ""}, {-2.5257286443082556`, ""}, {-2.4079456086518722`, 
          ""}, {-2.3025850929940455`, ""}, {-1.6094379124341003`, 
          ""}, {-1.203972804325936, ""}, {-0.916290731874155, 
          ""}, {-0.6931471805599453, ""}, {-0.5108256237659905, 
          ""}, {-0.3566749439387323, ""}, {-0.2231435513142097, 
          ""}, {-0.10536051565782628`, ""}, {0., ""}, {
         0.6931471805599453, ""}, {1.0986122886681098`, ""}, {
         1.3862943611198906`, ""}, {1.6094379124341003`, ""}, {
         1.791759469228055, ""}, {1.9459101490553132`, ""}, {
         2.0794415416798357`, ""}, {2.1972245773362196`, ""}, {
         2.302585092994046, ""}, {2.995732273553991, ""}, {
         3.4011973816621555`, ""}, {3.6888794541139363`, ""}, {
         3.912023005428146, ""}, {4.0943445622221, ""}, {
         4.248495242049359, ""}, {4.382026634673881, ""}, {
         4.499809670330265, ""}, {4.605170185988092, ""}, {
         5.298317366548036, ""}, {5.703782474656201, ""}, {
         5.991464547107982, ""}, {6.214608098422191, ""}, {
         6.396929655216146, ""}, {6.551080335043404, ""}, {
         6.684611727667927, ""}, {6.802394763324311, ""}, {
         6.907755278982137, ""}, {7.600902459542082, ""}, {
         8.006367567650246, ""}, {8.294049640102028, ""}, {
         8.517193191416238, ""}, {8.699514748210191, ""}, {
         8.85366542803745, ""}, {8.987196820661973, ""}, {
         9.104979856318357, ""}, {9.210340371976184, ""}, {
         9.903487552536127, ""}, {10.308952660644293`, ""}, {
         10.596634733096073`, ""}, {10.819778284410283`, ""}, {
         11.002099841204238`, ""}, {11.156250521031495`, ""}, {
         11.289781913656018`, ""}, {
         11.407564949312402`, ""}}, {{-13.815510557964274`, 
          ""}, {-13.122363377404328`, ""}, {-12.716898269296165`, 
          ""}, {-12.429216196844383`, ""}, {-12.206072645530174`, 
          ""}, {-12.02375108873622, ""}, {-11.86960040890896, 
          ""}, {-11.736069016284437`, ""}, {-11.618285980628055`, 
          ""}, {-11.512925464970229`, ""}, {-10.819778284410283`, 
          ""}, {-10.414313176302118`, ""}, {-10.126631103850338`, 
          ""}, {-9.903487552536127, ""}, {-9.721165995742174, 
          ""}, {-9.567015315914915, ""}, {-9.433483923290392, 
          ""}, {-9.315700887634009, ""}, {-9.210340371976182, 
          ""}, {-8.517193191416238, ""}, {-8.111728083308073, 
          ""}, {-7.824046010856292, ""}, {-7.600902459542082, 
          ""}, {-7.418580902748127, ""}, {-7.264430222920869, 
          ""}, {-7.1308988302963465`, ""}, {-7.013115794639964, 
          ""}, {-6.907755278982137, ""}, {-6.214608098422191, 
          ""}, {-5.809142990314028, ""}, {-5.521460917862246, 
          ""}, {-5.298317366548036, ""}, {-5.115995809754082, 
          ""}, {-4.961845129926823, ""}, {-4.8283137373023015`, 
          ""}, {-4.710530701645918, ""}, {-4.605170185988091, 
          ""}, {-3.912023005428146, ""}, {-3.506557897319982, 
          ""}, {-3.2188758248682006`, ""}, {-2.995732273553991, 
          ""}, {-2.8134107167600364`, ""}, {-2.659260036932778, 
          ""}, {-2.5257286443082556`, ""}, {-2.4079456086518722`, 
          ""}, {-2.3025850929940455`, ""}, {-1.6094379124341003`, 
          ""}, {-1.203972804325936, ""}, {-0.916290731874155, 
          ""}, {-0.6931471805599453, ""}, {-0.5108256237659905, 
          ""}, {-0.3566749439387323, ""}, {-0.2231435513142097, 
          ""}, {-0.10536051565782628`, ""}, {0., ""}, {
         0.6931471805599453, ""}, {1.0986122886681098`, ""}, {
         1.3862943611198906`, ""}, {1.6094379124341003`, ""}, {
         1.791759469228055, ""}, {1.9459101490553132`, ""}, {
         2.0794415416798357`, ""}, {2.1972245773362196`, ""}, {
         2.302585092994046, ""}, {2.995732273553991, ""}, {
         3.4011973816621555`, ""}, {3.6888794541139363`, ""}, {
         3.912023005428146, ""}, {4.0943445622221, ""}, {
         4.248495242049359, ""}, {4.382026634673881, ""}, {
         4.499809670330265, ""}, {4.605170185988092, ""}, {
         5.298317366548036, ""}, {5.703782474656201, ""}, {
         5.991464547107982, ""}, {6.214608098422191, ""}, {
         6.396929655216146, ""}, {6.551080335043404, ""}, {
         6.684611727667927, ""}, {6.802394763324311, ""}, {
         6.907755278982137, ""}, {7.600902459542082, ""}, {
         8.006367567650246, ""}, {8.294049640102028, ""}, {
         8.517193191416238, ""}, {8.699514748210191, ""}, {
         8.85366542803745, ""}, {8.987196820661973, ""}, {
         9.104979856318357, ""}, {9.210340371976184, ""}, {
         9.903487552536127, ""}, {10.308952660644293`, ""}, {
         10.596634733096073`, ""}, {10.819778284410283`, ""}, {
         11.002099841204238`, ""}, {11.156250521031495`, ""}, {
         11.289781913656018`, ""}, {11.407564949312402`, ""}}}, Axes -> False,
       PlotLabel -> Style["", 24], FrameLabel -> {
        Style["x", 18], 
        Style["\[Mu] [GeV]", 18]}, ImageSize -> {{600}, {600}}, AspectRatio -> 
      1, DisplayFunction -> Identity, PlotRangePadding -> {{0, 0}, {0, 0}}, 
      AxesOrigin -> {0, 0}, 
      PlotRange -> {{-11.512925464970229`, 0}, {0., 7.600902459542082}}, 
      PlotRangeClipping -> True, ImagePadding -> All, DisplayFunction -> 
      Identity, AspectRatio -> 1, Axes -> {True, True}, 
      AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
      Identity, Epilog -> {{
         Text[
          Style["Npt: 110", 16, 
           GrayLevel[0]], 
          Scaled[{0.1, 0.9}]], 
         Text[
          Style["highlighted range:\n{0.7, 1.3028}", 16, 
           GrayLevel[0]], 
          Scaled[{0.2, 0.7}]]}, {{
          Text[
           Style["Npt: 110", 16, 
            GrayLevel[0]], 
           Scaled[{0.1, 0.9}]], 
          Text[
           Style["highlighted range:\n{0.7, 1.3028}", 16, 
            GrayLevel[0]], 
           Scaled[{0.2, 0.7}]]}}}, Frame -> {{False, False}, {False, False}}, 
      FrameLabel -> {{None, None}, {None, None}}, 
      FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
      GridLines -> {None, None}, GridLinesStyle -> Directive[
        GrayLevel[0.5, 0.4]], 
      Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
             Part[#, 1]], 
            (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
             Part[#, 1]], 
            (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
             Part[#, 2]]}& )}}, 
      PlotRange -> {{-11.512925464970229`, 0}, {0., 7.600902459542082}}, 
      PlotRangeClipping -> True, PlotRangePadding -> {{0, 0}, {0, 0}}, 
      Ticks -> {Automatic, Automatic}}], 
    Placed[
     Unevaluated[
      BarLegend[{{
         RGBColor[
         0.23216034285714277`, 0.3378795428571428, 0.7518702857142857], 
         RGBColor[0.4490731428571427, 0.5238090285714285, 0.766888], 
         RGBColor[0.6824363428571429, 0.7085274285714285, 0.7886763428571428], 
         RGBColor[0.8705882352941177, 0.8901960784313725, 0.6784313725490196], 
         RGBColor[0.7946375999999999, 0.7904570285714286, 0.4094384000000003], 
         RGBColor[0.7470323428571428, 0.6201665142857145, 0.2124675428571429], 
         RGBColor[
         0.6820284571428572, 0.3238536000000004, 
          0.15835314285714291`]}, {-100, 100}}, {-100, -0.85, -0.7, -0.5, 0.5,
         0.7, 0.85, 100}, LabelStyle -> {FontSize -> 14}, LegendLabel -> "", 
       LegendLayout -> "Column", LegendMarkerSize -> {}, 
       Charting`TickAnnotations -> None, Charting`TickSide -> Right, 
       ColorFunctionScaling -> True]], {1., 0.5}, Identity]]& ],
  AutoDelete->True,
  Editable->True,
  SelectWithContents->False,
  Selectable->True]], "Output",
 CellChangeTimes->{{3.704089383133833*^9, 3.704089410092823*^9}, 
   3.704572145028105*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"processdataplotsmultiexp6percentage", "[", 
  RowBox[{
   RowBox[{"{", "dRdataclassfinal", "}"}], ",", 
   RowBox[{"readcorrconfigfile4", "[", 
    RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "4", ",", "1"}],
   "]"}]], "Input",
 CellChangeTimes->{{3.704572485217753*^9, 3.704572489023514*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"expts: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"{", "225", "}"}], "}"}]}],
  SequenceForm["expts: ", {{225}}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.704572486118052*^9, 3.7045724895932627`*^9}, 
   3.704574002993277*^9, 3.70529720152955*^9, 3.7067211430913563`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", "225", 
   "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", 225, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.704572486118052*^9, 3.7045724895932627`*^9}, 
   3.704574002993277*^9, 3.70529720152955*^9, 3.7067211432625628`*^9}],

Cell[BoxData["\<\"making table of experiments included in plots\"\>"], "Print",
 CellChangeTimes->{{3.704572486118052*^9, 3.7045724895932627`*^9}, 
   3.704574002993277*^9, 3.70529720152955*^9, 3.706721143265707*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     TagBox[
      GraphicsBox[{InsetBox[
         GraphicsBox[{{{{}, {{}, 
              {GrayLevel[1], PointSize[0.012833333333333334`], 
               AbsoluteThickness[1.6], 
               StyleBox[PointBox[{{0.00001, 2.}, {0.99, 1200.}}],
                FontFamily->"Helvetica"]}, {}}, {}, {}, {{}, {}}}, {
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.217776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[
              0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.999776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.410776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.8067765548632013, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.189776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.027776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.416776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.800776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.908776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.308776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.600776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.6167765548632014, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.058776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1587765548632012, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.808776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.408776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.003776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.213776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-4.632776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.584776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-5.3087765548632015, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.908776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->5.625]}}}, {}},
          AspectRatio->1,
          Axes->False,
          AxesLabel->{None, None},
          AxesOrigin->{0, 2.329076679826786},
          BaseStyle->{FontFamily -> "Helvetica", 16},
          DisplayFunction->Identity,
          Epilog->{{
             InsetBox[
              FormBox[
               StyleBox["\"Npt: 22\"", 16, 
                GrayLevel[0], StripOnInput -> False], TraditionalForm], 
              Scaled[{0.1, 0.9}]], 
             InsetBox[
              FormBox[
               StyleBox["\"highlighted range:\\n{2., 100.}\"", 16, 
                GrayLevel[0], StripOnInput -> False], TraditionalForm], 
              Scaled[{0.2, 0.7}]]}, {{
              InsetBox[
               FormBox[
                StyleBox["\"Npt: 22\"", 16, 
                 GrayLevel[0], StripOnInput -> False], TraditionalForm], 
               Scaled[{0.1, 0.9}]], 
              InsetBox[
               FormBox[
                StyleBox["\"highlighted range:\\n{2., 100.}\"", 16, 
                 GrayLevel[0], StripOnInput -> False], TraditionalForm], 
               Scaled[{0.2, 0.7}]]}}},
          Frame->True,
          FrameLabel->{
            FormBox[
             StyleBox["\"x\"", 18, 
              GrayLevel[0], StripOnInput -> False], TraditionalForm], 
            FormBox[
             StyleBox["\"\[Mu] [GeV]\"", 18, 
              GrayLevel[0], StripOnInput -> False], TraditionalForm]},
          FrameTicks->{{{-13.815510557964274`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.512925464970229`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.210340371976182, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.605170185988091, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.3025850929940455`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
              FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
             0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.791759469228055, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.302585092994046, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.0943445622221, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.248495242049359, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.382026634673881, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.499809670330265, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.605170185988092, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.703782474656201, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.991464547107982, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.396929655216146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.551080335043404, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.684611727667927, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.802394763324311, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.006367567650246, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.294049640102028, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.699514748210191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.987196820661973, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.104979856318357, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.210340371976184, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.308952660644293`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.596634733096073`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.002099841204238`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.156250521031495`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.289781913656018`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.407564949312402`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}}, {{-13.815510557964274`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.512925464970229`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.210340371976182, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.605170185988091, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.3025850929940455`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
              FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
             0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.791759469228055, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.302585092994046, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.0943445622221, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.248495242049359, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.382026634673881, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.499809670330265, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.605170185988092, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.703782474656201, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.991464547107982, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.396929655216146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.551080335043404, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.684611727667927, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.802394763324311, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.006367567650246, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.294049640102028, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.699514748210191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.987196820661973, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.104979856318357, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.210340371976184, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.308952660644293`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.596634733096073`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.002099841204238`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.156250521031495`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.289781913656018`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.407564949312402`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}}, {{-13.815510557964274`, 
              FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
              FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
              FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
              FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
              FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm]}, {0., 
              FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
              FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
              FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
              FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
              FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
              FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
              FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
              FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
              FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
              FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
              FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
              FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
              FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
              FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
              FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
              FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
              FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
              FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
              FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
              FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
              FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
              FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
              FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
              FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
              FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
              FormBox["\"\"", TraditionalForm]}}, {{-13.815510557964274`, 
              FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
              FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
              FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
              FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
              FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm]}, {0., 
              FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
              FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
              FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
              FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
              FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
              FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
              FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
              FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
              FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
              FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
              FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
              FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
              FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
              FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
              FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
              FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
              FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
              FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
              FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
              FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
              FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
              FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
              FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
              FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
              FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
              FormBox["\"\"", TraditionalForm]}}},
          FrameTicksStyle->GrayLevel[0],
          GridLines->{None, None},
          GridLinesStyle->Directive[
            GrayLevel[0.5, 0.4]],
          ImagePadding->All,
          ImageSize->{{600}, {600}},
          Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& )}},
          PlotLabel->None,
          
          PlotRange->{{-11.512925464970229`, 0}, {2.302585092994046, 
            7.600902459542082}},
          PlotRangeClipping->True,
          PlotRangePadding->{{0, 0}, {0, 0}},
          Ticks->{Automatic, Automatic}], Scaled[{0.5, 0.5}], Center, 
         Scaled[{1, 1}]], InsetBox[
         TemplateBox[{FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   StyleBox[
                   "\"\"", {FontSize -> 14, FontFamily -> "Arial"}, 
                    Background -> Automatic, StripOnInput -> False]}, {
                   GraphicsBox[{{}, {}, 
                    
                    RasterBox[{{{0., 0., 0.7}}, {{0., 0.5, 0.75}}, {{0., 0.75,
                     0.75}}, {{0.9352941176470588, 0.9450980392156862, 
                    0.8392156862745098}}, {{0.75, 0.75, 0.}}, {{0.75, 
                    0.5500000000000002, 0.}}, {{0.7, 0., 0.}}}, {{
                    Rational[-15, 2], 
                    Rational[-175, 2]}, {
                    Rational[15, 2], 
                    Rational[175, 2]}}], {Antialiasing -> False, 
                    AbsoluteThickness[0.1], 
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]], 
                    LineBox[
                    NCache[{{
                    Rational[15, 2], 
                    Rational[-175, 2]}, {
                    Rational[-15, 2], 
                    Rational[-175, 2]}, {
                    Rational[-15, 2], 
                    Rational[175, 2]}, {
                    Rational[15, 2], 
                    Rational[175, 2]}, {
                    Rational[15, 2], 
                    Rational[-175, 2]}}, {{7.5, -87.5}, {-7.5, -87.5}, {-7.5, 
                    87.5}, {7.5, 87.5}, {7.5, -87.5}}]]}, {
                    CapForm[None], {}}, {Antialiasing -> False, 
                    StyleBox[
                    LineBox[{{7.5, -87.5}, {7.5, 87.5}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.5, -62.5}, 
                    Offset[{4., 0}, {7.5, -62.5}]}, {{
                    7.5, -37.49999999999999}, 
                    Offset[{4., 0}, {7.5, -37.49999999999999}]}, {{
                    7.5, -12.5}, 
                    Offset[{4., 0}, {7.5, -12.5}]}, {{7.5, 12.5}, 
                    Offset[{4., 0}, {7.5, 12.5}]}, {{7.5, 37.49999999999999}, 
                    
                    Offset[{4., 0}, {7.5, 37.49999999999999}]}, {{7.5, 62.5}, 
                    
                    Offset[{4., 0}, {7.5, 62.5}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-5.0\"", -5., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -62.5}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-2.0\"", -2., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -37.49999999999999}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-0.5\"", -0.5, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -12.5}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"0.5\"", 0.5, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 12.5}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"2.0\"", 2., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 37.49999999999999}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"5.0\"", 5., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 62.5}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1], FontSize -> 14]}, StripOnInput -> 
                    False]}, {}}, {
                    Directive[
                    Opacity[1], FontSize -> 14]}, StripOnInput -> False], 
                    "GraphicsLabel", StripOnInput -> False]}, "GraphicsTicks",
                     StripOnInput -> False], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                    Scaled[0.02], PlotRange -> All, Frame -> True, 
                    FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                    Opacity[0], FrameTicksStyle -> Opacity[0], 
                    ImageSize -> {Automatic, 175}, BaseStyle -> {}, 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}]}}, 
                 GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontSize -> 14, FontFamily -> "Arial"}, Background -> Automatic, 
             StripOnInput -> False], TraditionalForm]},
          "BarLegend",
          DisplayFunction->(#& ),
          InterpretationFunction:>(RowBox[{"BarLegend", "[", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0., 0., 0.7], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0., 0.4666666666666667], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0., 0., 0.7]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0., 0., 0.7]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0., 0., 0.7], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0., 0.5, 0.75], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0., 0.33333333333333337`, 0.5], FrameTicks -> 
                    None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0., 0.5, 0.75]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0., 0.5, 0.75]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0., 0.5, 0.75], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0., 0.75, 0.75], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0.5, 0.5], FrameTicks -> 
                    None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0., 0.75, 0.75]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0., 0.75, 0.75]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0., 0.75, 0.75], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[
                    0.9352941176470588, 0.9450980392156862, 
                    0.8392156862745098], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.6235294117647059, 0.6300653594771242, 
                    0.5594771241830065], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.9352941176470588, 0.9450980392156862, \
0.8392156862745098]"], Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.9352941176470588, 0.9450980392156862, 
                    0.8392156862745098]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[
                    0.9352941176470588, 0.9450980392156862, 
                    0.8392156862745098], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.75, 0.75, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.5, 0.5, 0.], FrameTicks -> 
                    None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.75, 0.75, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.75, 0.75, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.75, 0.75, 0.], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.75, 0.55, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.5, 0.3666666666666667, 0.],
                     FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.75, 0.55, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.75, 0.55, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.75, 0.55, 0.], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0., 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.4666666666666667, 0., 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0., 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0., 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0., 0.], Editable -> False, Selectable -> 
                    False]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "100"}], ",", "100"}], "}"}]}], "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "100"}], ",", 
                   RowBox[{"-", "5.`"}], ",", 
                   RowBox[{"-", "2.`"}], ",", 
                   RowBox[{"-", "0.5`"}], ",", "0.5`", ",", "2.`", ",", "5.`",
                    ",", "100"}], "}"}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"{", 
                   RowBox[{"FontSize", "\[Rule]", "14"}], "}"}]}], ",", 
               RowBox[{"LegendLabel", "\[Rule]", "\"\""}], ",", 
               RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
               RowBox[{"LegendMarkerSize", "\[Rule]", 
                 RowBox[{"{", "}"}]}], ",", 
               RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
               RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
               RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], 
             "]"}]& )], Scaled[{1., 0.5}], ImageScaled[{0, 0.5}],
         BaseStyle->{FontSize -> Larger},
         FormatType->StandardForm]},
       AspectRatio->1,
       Axes->False,
       AxesLabel->{None, None},
       AxesOrigin->{0, 2.329076679826786},
       BaseStyle->{FontFamily -> "Helvetica", 16},
       DisplayFunction->Identity,
       Frame->False,
       FrameLabel->{
         FormBox[
          StyleBox["\"x\"", 18, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         FormBox[
          StyleBox["\"\[Mu] [GeV]\"", 18, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm]},
       FrameTicks->{{{-13.815510557964274`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.02375108873622, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.86960040890896, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.512925464970229`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.903487552536127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.721165995742174, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.567015315914915, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.433483923290392, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.315700887634009, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.210340371976182, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-8.111728083308073, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.824046010856292, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.600902459542082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.418580902748127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.264430222920869, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.013115794639964, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-6.907755278982137, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.809142990314028, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.521460917862246, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.298317366548036, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.115995809754082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.961845129926823, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.710530701645918, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.605170185988091, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.506557897319982, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.995732273553991, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.659260036932778, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.3025850929940455`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-1.203972804325936, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.916290731874155, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
           FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
          0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.302585092994046, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.605170185988092, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.907755278982137, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.210340371976184, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}}, {{-13.815510557964274`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.02375108873622, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.86960040890896, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.512925464970229`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.903487552536127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.721165995742174, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.567015315914915, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.433483923290392, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.315700887634009, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.210340371976182, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-8.111728083308073, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.824046010856292, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.600902459542082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.418580902748127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.264430222920869, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.013115794639964, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-6.907755278982137, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.809142990314028, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.521460917862246, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.298317366548036, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.115995809754082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.961845129926823, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.710530701645918, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.605170185988091, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.506557897319982, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.995732273553991, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.659260036932778, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.3025850929940455`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-1.203972804325936, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.916290731874155, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
           FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
          0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.302585092994046, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.605170185988092, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.907755278982137, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.210340371976184, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}}, {{-13.815510557964274`, 
           FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
           FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
           FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
           FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
           FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
           FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
           FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
           FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
           FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
           FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
           FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
           FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
           FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
           FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
           FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
           FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
           FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
           FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
           FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
           FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
           FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
           FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
           FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm]}, {0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
           FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm]}}, {{-13.815510557964274`, 
           FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
           FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
           FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
           FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
           FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
           FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
           FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
           FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
           FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
           FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
           FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
           FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
           FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
           FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
           FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
           FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
           FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
           FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
           FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
           FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
           FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
           FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
           FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm]}, {0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
           FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm]}}},
       FrameTicksStyle->GrayLevel[0],
       ImagePadding->All,
       ImageSize->{{600}, {600}},
       Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
             (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
              Part[#, 1]], 
             (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
              Part[#, 2]]}& ), "CopiedValueFunction" -> ({
             (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
              Part[#, 1]], 
             (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
              Part[#, 2]]}& )}},
       PlotLabel->FormBox[
         StyleBox["\"\"", 24, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm],
       PlotRange->Automatic,
       PlotRangeClipping->False,
       PlotRangePadding->{{0, 0}, {0, 0}},
       Ticks->{Automatic, Automatic}],
      InterpretTemplate[Legended[
        Graphics[{{{}, {{{}, {
              Hue[0.67, 0.6, 0.6], 
              Directive[
               PointSize[0.012833333333333334`], 
               AbsoluteThickness[1.6], FontFamily -> "Helvetica", 
               GrayLevel[1]], 
              
              Point[{{0.00001, 2.}, {0.99, 
               1200.}}]}, {}}}, {}, {}, {{}, {}}}, {
           Style[
            Text["\[FilledCircle]", {-3.217776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-2.999776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[
            0.9352941176470588, 0.9450980392156862, 0.8392156862745098]], 
           Style[
            Text["\[FilledCircle]", {-3.410776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.8067765548632013`, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-4.189776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-2.027776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-4.416776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-1.800776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-4.908776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-1.308776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-3.600776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.6167765548632014`, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-5.058776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1587765548632012`, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-3.808776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-2.408776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-4.003776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-2.213776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-4.632776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-1.584776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-5.3087765548632015`, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-0.908776554863201, 4.386765389021055}], 
            5.625, 
            RGBColor[0.75, 0.75, 0.]]}}, {
         Frame -> True, 
          FrameTicks -> {{{-13.815510557964274`, 
              "\!\(\*SuperscriptBox[\(10\), \(-6\)]\)", {0.02, 
              0.}}, {-13.122363377404328`, "", {
              0.01, 0}}, {-12.716898269296165`, "", {
              0.01, 0}}, {-12.429216196844383`, "", {
              0.01, 0}}, {-12.206072645530174`, "", {
              0.01, 0}}, {-12.02375108873622, "", {
              0.01, 0}}, {-11.86960040890896, "", {
              0.01, 0}}, {-11.736069016284437`, "", {
              0.01, 0}}, {-11.618285980628055`, "", {
              0.01, 0}}, {-11.512925464970229`, 
              "\!\(\*SuperscriptBox[\(10\), \(-5\)]\)", {0.02, 
              0.}}, {-10.819778284410283`, "", {
              0.01, 0}}, {-10.414313176302118`, "", {
              0.01, 0}}, {-10.126631103850338`, "", {
              0.01, 0}}, {-9.903487552536127, "", {
              0.01, 0}}, {-9.721165995742174, "", {
              0.01, 0}}, {-9.567015315914915, "", {
              0.01, 0}}, {-9.433483923290392, "", {
              0.01, 0}}, {-9.315700887634009, "", {
              0.01, 0}}, {-9.210340371976182, 
              "\!\(\*SuperscriptBox[\(10\), \(-4\)]\)", {0.02, 
              0.}}, {-8.517193191416238, "", {0.01, 0}}, {-8.111728083308073, 
              "", {0.01, 0}}, {-7.824046010856292, "", {
              0.01, 0}}, {-7.600902459542082, "", {
              0.01, 0}}, {-7.418580902748127, "", {
              0.01, 0}}, {-7.264430222920869, "", {
              0.01, 0}}, {-7.1308988302963465`, "", {
              0.01, 0}}, {-7.013115794639964, "", {
              0.01, 0}}, {-6.907755278982137, 
              "\!\(\*SuperscriptBox[\(10\), \(-3\)]\)", {0.02, 
              0.}}, {-6.214608098422191, "", {0.01, 0}}, {-5.809142990314028, 
              "", {0.01, 0}}, {-5.521460917862246, "", {
              0.01, 0}}, {-5.298317366548036, "", {
              0.01, 0}}, {-5.115995809754082, "", {
              0.01, 0}}, {-4.961845129926823, "", {
              0.01, 0}}, {-4.8283137373023015`, "", {
              0.01, 0}}, {-4.710530701645918, "", {
              0.01, 0}}, {-4.605170185988091, 
              "\!\(\*SuperscriptBox[\(10\), \(-2\)]\)", {0.02, 
              0.}}, {-3.912023005428146, "", {0.01, 0}}, {-3.506557897319982, 
              "", {0.01, 0}}, {-3.2188758248682006`, "", {
              0.01, 0}}, {-2.995732273553991, "", {
              0.01, 0}}, {-2.8134107167600364`, "", {
              0.01, 0}}, {-2.659260036932778, "", {
              0.01, 0}}, {-2.5257286443082556`, "", {
              0.01, 0}}, {-2.4079456086518722`, "", {
              0.01, 0}}, {-2.3025850929940455`, 
              "\!\(\*SuperscriptBox[\(10\), \(-1\)]\)", {0.02, 
              0.}}, {-1.6094379124341003`, "", {
              0.01, 0}}, {-1.203972804325936, "", {
              0.01, 0}}, {-0.916290731874155, "", {
              0.01, 0}}, {-0.6931471805599453, "", {
              0.01, 0}}, {-0.5108256237659905, "", {
              0.01, 0}}, {-0.3566749439387323, "", {
              0.01, 0}}, {-0.2231435513142097, "", {
              0.01, 0}}, {-0.10536051565782628`, "", {0.01, 0}}, {
             0., "1", {0.02, 0.}}, {0.6931471805599453, "", {0.01, 0}}, {
             1.0986122886681098`, "", {0.01, 0}}, {
             1.3862943611198906`, "", {0.01, 0}}, {
             1.6094379124341003`, "", {0.01, 0}}, {
             1.791759469228055, "", {0.01, 0}}, {
             1.9459101490553132`, "", {0.01, 0}}, {
             2.0794415416798357`, "", {0.01, 0}}, {
             2.1972245773362196`, "", {0.01, 0}}, {
             2.302585092994046, "\!\(\*SuperscriptBox[\(10\), \(1\)]\)", {
              0.02, 0.}}, {2.995732273553991, "", {0.01, 0}}, {
             3.4011973816621555`, "", {0.01, 0}}, {
             3.6888794541139363`, "", {0.01, 0}}, {
             3.912023005428146, "", {0.01, 0}}, {
             4.0943445622221, "", {0.01, 0}}, {
             4.248495242049359, "", {0.01, 0}}, {
             4.382026634673881, "", {0.01, 0}}, {
             4.499809670330265, "", {0.01, 0}}, {
             4.605170185988092, "\!\(\*SuperscriptBox[\(10\), \(2\)]\)", {
              0.02, 0.}}, {5.298317366548036, "", {0.01, 0}}, {
             5.703782474656201, "", {0.01, 0}}, {
             5.991464547107982, "", {0.01, 0}}, {
             6.214608098422191, "", {0.01, 0}}, {
             6.396929655216146, "", {0.01, 0}}, {
             6.551080335043404, "", {0.01, 0}}, {
             6.684611727667927, "", {0.01, 0}}, {
             6.802394763324311, "", {0.01, 0}}, {
             6.907755278982137, "\!\(\*SuperscriptBox[\(10\), \(3\)]\)", {
              0.02, 0.}}, {7.600902459542082, "", {0.01, 0}}, {
             8.006367567650246, "", {0.01, 0}}, {
             8.294049640102028, "", {0.01, 0}}, {
             8.517193191416238, "", {0.01, 0}}, {
             8.699514748210191, "", {0.01, 0}}, {
             8.85366542803745, "", {0.01, 0}}, {
             8.987196820661973, "", {0.01, 0}}, {
             9.104979856318357, "", {0.01, 0}}, {
             9.210340371976184, "\!\(\*SuperscriptBox[\(10\), \(4\)]\)", {
              0.02, 0.}}, {9.903487552536127, "", {0.01, 0}}, {
             10.308952660644293`, "", {0.01, 0}}, {
             10.596634733096073`, "", {0.01, 0}}, {
             10.819778284410283`, "", {0.01, 0}}, {
             11.002099841204238`, "", {0.01, 0}}, {
             11.156250521031495`, "", {0.01, 0}}, {
             11.289781913656018`, "", {0.01, 0}}, {
             11.407564949312402`, "", {0.01, 0}}}, {{-13.815510557964274`, 
              "\!\(\*SuperscriptBox[\(10\), \(-6\)]\)", {0.02, 
              0.}}, {-13.122363377404328`, "", {
              0.01, 0}}, {-12.716898269296165`, "", {
              0.01, 0}}, {-12.429216196844383`, "", {
              0.01, 0}}, {-12.206072645530174`, "", {
              0.01, 0}}, {-12.02375108873622, "", {
              0.01, 0}}, {-11.86960040890896, "", {
              0.01, 0}}, {-11.736069016284437`, "", {
              0.01, 0}}, {-11.618285980628055`, "", {
              0.01, 0}}, {-11.512925464970229`, 
              "\!\(\*SuperscriptBox[\(10\), \(-5\)]\)", {0.02, 
              0.}}, {-10.819778284410283`, "", {
              0.01, 0}}, {-10.414313176302118`, "", {
              0.01, 0}}, {-10.126631103850338`, "", {
              0.01, 0}}, {-9.903487552536127, "", {
              0.01, 0}}, {-9.721165995742174, "", {
              0.01, 0}}, {-9.567015315914915, "", {
              0.01, 0}}, {-9.433483923290392, "", {
              0.01, 0}}, {-9.315700887634009, "", {
              0.01, 0}}, {-9.210340371976182, 
              "\!\(\*SuperscriptBox[\(10\), \(-4\)]\)", {0.02, 
              0.}}, {-8.517193191416238, "", {0.01, 0}}, {-8.111728083308073, 
              "", {0.01, 0}}, {-7.824046010856292, "", {
              0.01, 0}}, {-7.600902459542082, "", {
              0.01, 0}}, {-7.418580902748127, "", {
              0.01, 0}}, {-7.264430222920869, "", {
              0.01, 0}}, {-7.1308988302963465`, "", {
              0.01, 0}}, {-7.013115794639964, "", {
              0.01, 0}}, {-6.907755278982137, 
              "\!\(\*SuperscriptBox[\(10\), \(-3\)]\)", {0.02, 
              0.}}, {-6.214608098422191, "", {0.01, 0}}, {-5.809142990314028, 
              "", {0.01, 0}}, {-5.521460917862246, "", {
              0.01, 0}}, {-5.298317366548036, "", {
              0.01, 0}}, {-5.115995809754082, "", {
              0.01, 0}}, {-4.961845129926823, "", {
              0.01, 0}}, {-4.8283137373023015`, "", {
              0.01, 0}}, {-4.710530701645918, "", {
              0.01, 0}}, {-4.605170185988091, 
              "\!\(\*SuperscriptBox[\(10\), \(-2\)]\)", {0.02, 
              0.}}, {-3.912023005428146, "", {0.01, 0}}, {-3.506557897319982, 
              "", {0.01, 0}}, {-3.2188758248682006`, "", {
              0.01, 0}}, {-2.995732273553991, "", {
              0.01, 0}}, {-2.8134107167600364`, "", {
              0.01, 0}}, {-2.659260036932778, "", {
              0.01, 0}}, {-2.5257286443082556`, "", {
              0.01, 0}}, {-2.4079456086518722`, "", {
              0.01, 0}}, {-2.3025850929940455`, 
              "\!\(\*SuperscriptBox[\(10\), \(-1\)]\)", {0.02, 
              0.}}, {-1.6094379124341003`, "", {
              0.01, 0}}, {-1.203972804325936, "", {
              0.01, 0}}, {-0.916290731874155, "", {
              0.01, 0}}, {-0.6931471805599453, "", {
              0.01, 0}}, {-0.5108256237659905, "", {
              0.01, 0}}, {-0.3566749439387323, "", {
              0.01, 0}}, {-0.2231435513142097, "", {
              0.01, 0}}, {-0.10536051565782628`, "", {0.01, 0}}, {
             0., "1", {0.02, 0.}}, {0.6931471805599453, "", {0.01, 0}}, {
             1.0986122886681098`, "", {0.01, 0}}, {
             1.3862943611198906`, "", {0.01, 0}}, {
             1.6094379124341003`, "", {0.01, 0}}, {
             1.791759469228055, "", {0.01, 0}}, {
             1.9459101490553132`, "", {0.01, 0}}, {
             2.0794415416798357`, "", {0.01, 0}}, {
             2.1972245773362196`, "", {0.01, 0}}, {
             2.302585092994046, "\!\(\*SuperscriptBox[\(10\), \(1\)]\)", {
              0.02, 0.}}, {2.995732273553991, "", {0.01, 0}}, {
             3.4011973816621555`, "", {0.01, 0}}, {
             3.6888794541139363`, "", {0.01, 0}}, {
             3.912023005428146, "", {0.01, 0}}, {
             4.0943445622221, "", {0.01, 0}}, {
             4.248495242049359, "", {0.01, 0}}, {
             4.382026634673881, "", {0.01, 0}}, {
             4.499809670330265, "", {0.01, 0}}, {
             4.605170185988092, "\!\(\*SuperscriptBox[\(10\), \(2\)]\)", {
              0.02, 0.}}, {5.298317366548036, "", {0.01, 0}}, {
             5.703782474656201, "", {0.01, 0}}, {
             5.991464547107982, "", {0.01, 0}}, {
             6.214608098422191, "", {0.01, 0}}, {
             6.396929655216146, "", {0.01, 0}}, {
             6.551080335043404, "", {0.01, 0}}, {
             6.684611727667927, "", {0.01, 0}}, {
             6.802394763324311, "", {0.01, 0}}, {
             6.907755278982137, "\!\(\*SuperscriptBox[\(10\), \(3\)]\)", {
              0.02, 0.}}, {7.600902459542082, "", {0.01, 0}}, {
             8.006367567650246, "", {0.01, 0}}, {
             8.294049640102028, "", {0.01, 0}}, {
             8.517193191416238, "", {0.01, 0}}, {
             8.699514748210191, "", {0.01, 0}}, {
             8.85366542803745, "", {0.01, 0}}, {
             8.987196820661973, "", {0.01, 0}}, {
             9.104979856318357, "", {0.01, 0}}, {
             9.210340371976184, "\!\(\*SuperscriptBox[\(10\), \(4\)]\)", {
              0.02, 0.}}, {9.903487552536127, "", {0.01, 0}}, {
             10.308952660644293`, "", {0.01, 0}}, {
             10.596634733096073`, "", {0.01, 0}}, {
             10.819778284410283`, "", {0.01, 0}}, {
             11.002099841204238`, "", {0.01, 0}}, {
             11.156250521031495`, "", {0.01, 0}}, {
             11.289781913656018`, "", {0.01, 0}}, {
             11.407564949312402`, "", {0.01, 0}}}, {{-13.815510557964274`, 
              ""}, {-13.122363377404328`, ""}, {-12.716898269296165`, 
              ""}, {-12.429216196844383`, ""}, {-12.206072645530174`, 
              ""}, {-12.02375108873622, ""}, {-11.86960040890896, 
              ""}, {-11.736069016284437`, ""}, {-11.618285980628055`, 
              ""}, {-11.512925464970229`, ""}, {-10.819778284410283`, 
              ""}, {-10.414313176302118`, ""}, {-10.126631103850338`, 
              ""}, {-9.903487552536127, ""}, {-9.721165995742174, 
              ""}, {-9.567015315914915, ""}, {-9.433483923290392, 
              ""}, {-9.315700887634009, ""}, {-9.210340371976182, 
              ""}, {-8.517193191416238, ""}, {-8.111728083308073, 
              ""}, {-7.824046010856292, ""}, {-7.600902459542082, 
              ""}, {-7.418580902748127, ""}, {-7.264430222920869, 
              ""}, {-7.1308988302963465`, ""}, {-7.013115794639964, 
              ""}, {-6.907755278982137, ""}, {-6.214608098422191, 
              ""}, {-5.809142990314028, ""}, {-5.521460917862246, 
              ""}, {-5.298317366548036, ""}, {-5.115995809754082, 
              ""}, {-4.961845129926823, ""}, {-4.8283137373023015`, 
              ""}, {-4.710530701645918, ""}, {-4.605170185988091, 
              ""}, {-3.912023005428146, ""}, {-3.506557897319982, 
              ""}, {-3.2188758248682006`, ""}, {-2.995732273553991, 
              ""}, {-2.8134107167600364`, ""}, {-2.659260036932778, 
              ""}, {-2.5257286443082556`, ""}, {-2.4079456086518722`, 
              ""}, {-2.3025850929940455`, ""}, {-1.6094379124341003`, 
              ""}, {-1.203972804325936, ""}, {-0.916290731874155, 
              ""}, {-0.6931471805599453, ""}, {-0.5108256237659905, 
              ""}, {-0.3566749439387323, ""}, {-0.2231435513142097, 
              ""}, {-0.10536051565782628`, ""}, {0., ""}, {
             0.6931471805599453, ""}, {1.0986122886681098`, ""}, {
             1.3862943611198906`, ""}, {1.6094379124341003`, ""}, {
             1.791759469228055, ""}, {1.9459101490553132`, ""}, {
             2.0794415416798357`, ""}, {2.1972245773362196`, ""}, {
             2.302585092994046, ""}, {2.995732273553991, ""}, {
             3.4011973816621555`, ""}, {3.6888794541139363`, ""}, {
             3.912023005428146, ""}, {4.0943445622221, ""}, {
             4.248495242049359, ""}, {4.382026634673881, ""}, {
             4.499809670330265, ""}, {4.605170185988092, ""}, {
             5.298317366548036, ""}, {5.703782474656201, ""}, {
             5.991464547107982, ""}, {6.214608098422191, ""}, {
             6.396929655216146, ""}, {6.551080335043404, ""}, {
             6.684611727667927, ""}, {6.802394763324311, ""}, {
             6.907755278982137, ""}, {7.600902459542082, ""}, {
             8.006367567650246, ""}, {8.294049640102028, ""}, {
             8.517193191416238, ""}, {8.699514748210191, ""}, {
             8.85366542803745, ""}, {8.987196820661973, ""}, {
             9.104979856318357, ""}, {9.210340371976184, ""}, {
             9.903487552536127, ""}, {10.308952660644293`, ""}, {
             10.596634733096073`, ""}, {10.819778284410283`, ""}, {
             11.002099841204238`, ""}, {11.156250521031495`, ""}, {
             11.289781913656018`, ""}, {
             11.407564949312402`, ""}}, {{-13.815510557964274`, 
              ""}, {-13.122363377404328`, ""}, {-12.716898269296165`, 
              ""}, {-12.429216196844383`, ""}, {-12.206072645530174`, 
              ""}, {-12.02375108873622, ""}, {-11.86960040890896, 
              ""}, {-11.736069016284437`, ""}, {-11.618285980628055`, 
              ""}, {-11.512925464970229`, ""}, {-10.819778284410283`, 
              ""}, {-10.414313176302118`, ""}, {-10.126631103850338`, 
              ""}, {-9.903487552536127, ""}, {-9.721165995742174, 
              ""}, {-9.567015315914915, ""}, {-9.433483923290392, 
              ""}, {-9.315700887634009, ""}, {-9.210340371976182, 
              ""}, {-8.517193191416238, ""}, {-8.111728083308073, 
              ""}, {-7.824046010856292, ""}, {-7.600902459542082, 
              ""}, {-7.418580902748127, ""}, {-7.264430222920869, 
              ""}, {-7.1308988302963465`, ""}, {-7.013115794639964, 
              ""}, {-6.907755278982137, ""}, {-6.214608098422191, 
              ""}, {-5.809142990314028, ""}, {-5.521460917862246, 
              ""}, {-5.298317366548036, ""}, {-5.115995809754082, 
              ""}, {-4.961845129926823, ""}, {-4.8283137373023015`, 
              ""}, {-4.710530701645918, ""}, {-4.605170185988091, 
              ""}, {-3.912023005428146, ""}, {-3.506557897319982, 
              ""}, {-3.2188758248682006`, ""}, {-2.995732273553991, 
              ""}, {-2.8134107167600364`, ""}, {-2.659260036932778, 
              ""}, {-2.5257286443082556`, ""}, {-2.4079456086518722`, 
              ""}, {-2.3025850929940455`, ""}, {-1.6094379124341003`, 
              ""}, {-1.203972804325936, ""}, {-0.916290731874155, 
              ""}, {-0.6931471805599453, ""}, {-0.5108256237659905, 
              ""}, {-0.3566749439387323, ""}, {-0.2231435513142097, 
              ""}, {-0.10536051565782628`, ""}, {0., ""}, {
             0.6931471805599453, ""}, {1.0986122886681098`, ""}, {
             1.3862943611198906`, ""}, {1.6094379124341003`, ""}, {
             1.791759469228055, ""}, {1.9459101490553132`, ""}, {
             2.0794415416798357`, ""}, {2.1972245773362196`, ""}, {
             2.302585092994046, ""}, {2.995732273553991, ""}, {
             3.4011973816621555`, ""}, {3.6888794541139363`, ""}, {
             3.912023005428146, ""}, {4.0943445622221, ""}, {
             4.248495242049359, ""}, {4.382026634673881, ""}, {
             4.499809670330265, ""}, {4.605170185988092, ""}, {
             5.298317366548036, ""}, {5.703782474656201, ""}, {
             5.991464547107982, ""}, {6.214608098422191, ""}, {
             6.396929655216146, ""}, {6.551080335043404, ""}, {
             6.684611727667927, ""}, {6.802394763324311, ""}, {
             6.907755278982137, ""}, {7.600902459542082, ""}, {
             8.006367567650246, ""}, {8.294049640102028, ""}, {
             8.517193191416238, ""}, {8.699514748210191, ""}, {
             8.85366542803745, ""}, {8.987196820661973, ""}, {
             9.104979856318357, ""}, {9.210340371976184, ""}, {
             9.903487552536127, ""}, {10.308952660644293`, ""}, {
             10.596634733096073`, ""}, {10.819778284410283`, ""}, {
             11.002099841204238`, ""}, {11.156250521031495`, ""}, {
             11.289781913656018`, ""}, {11.407564949312402`, ""}}}, Axes -> 
          False, PlotLabel -> Style["", 24, 
            GrayLevel[0]], FrameLabel -> {
            Style["x", 18, 
             GrayLevel[0]], 
            Style["\[Mu] [GeV]", 18, 
             GrayLevel[0]]}, FrameTicksStyle -> GrayLevel[0], 
          ImageSize -> {{600}, {600}}, AspectRatio -> 1, DisplayFunction -> 
          Identity, PlotRangePadding -> {{0, 0}, {0, 0}}, 
          AxesOrigin -> {0, 2.329076679826786}, 
          PlotRange -> {{-11.512925464970229`, 0}, {2.302585092994046, 
            7.600902459542082}}, PlotRangeClipping -> True, ImagePadding -> 
          All, DisplayFunction -> Identity, AspectRatio -> 1, 
          Axes -> {True, True}, AxesLabel -> {None, None}, 
          AxesOrigin -> {0, 2.329076679826786}, DisplayFunction :> Identity, 
          Epilog -> {{
             Text[
              Style["Npt: 22", 16, 
               GrayLevel[0]], 
              Scaled[{0.1, 0.9}]], 
             Text[
              Style["highlighted range:\n{2., 100.}", 16, 
               GrayLevel[0]], 
              Scaled[{0.2, 0.7}]]}, {{
              Text[
               Style["Npt: 22", 16, 
                GrayLevel[0]], 
               Scaled[{0.1, 0.9}]], 
              Text[
               Style["highlighted range:\n{2., 100.}", 16, 
                GrayLevel[0]], 
               Scaled[{0.2, 0.7}]]}}}, 
          Frame -> {{False, False}, {False, False}}, 
          FrameLabel -> {{None, None}, {None, None}}, 
          FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
          GridLines -> {None, None}, GridLinesStyle -> Directive[
            GrayLevel[0.5, 0.4]], 
          Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& )}}, 
          PlotRange -> {{-11.512925464970229`, 0}, {2.302585092994046, 
            7.600902459542082}}, PlotRangeClipping -> True, 
          PlotRangePadding -> {{0, 0}, {0, 0}}, 
          Ticks -> {Automatic, Automatic}}], 
        Placed[
         Unevaluated[
          BarLegend[{{
             RGBColor[0., 0., 0.7], 
             RGBColor[0., 0.5, 0.75], 
             RGBColor[0., 0.75, 0.75], 
             RGBColor[
             0.9352941176470588, 0.9450980392156862, 0.8392156862745098], 
             RGBColor[0.75, 0.75, 0.], 
             RGBColor[0.75, 0.55, 0.], 
             RGBColor[0.7, 0., 0.]}, {-100, 100}}, {-100, -5., -2., -0.5, 0.5,
             2., 5., 100}, LabelStyle -> {FontSize -> 14}, LegendLabel -> "", 
           LegendLayout -> "Column", LegendMarkerSize -> {}, 
           Charting`TickAnnotations -> None, Charting`TickSide -> Right, 
           ColorFunctionScaling -> True]], {1., 0.5}, Identity]]& ],
      AutoDelete->True,
      Editable->True,
      SelectWithContents->False,
      Selectable->True], ",", 
     TagBox[GridBox[{
        {
         InterpretationBox[Cell[BoxData[
           FormBox[
            
            StyleBox["\<\"PDF error \[Delta]r for residues, \
CT14HERA2NNLO\\n\\n\"\>",
             StripOnInput->False,
             FontSize->24], TextForm]], "InlineText"],
          Text[
           Style[
           "PDF error \[Delta]r for residues, CT14HERA2NNLO\n\n", FontSize -> 
            24]]], "\[SpanFromLeft]"},
        {"\<\"Data Sets\"\>", ""},
        {"\<\"None(225)\"\>", ""}
       },
       AutoDelete->False,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{14}}},
       GridBoxItemStyle->{"Columns" -> {{
            Directive[FontSize -> 18, 
             GrayLevel[0]]}}, "Rows" -> {{
            Directive[FontSize -> 18, 
             GrayLevel[0]]}}}],
      "Grid"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     GraphicsBox[{
       {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
        EdgeForm[Opacity[0.]], {}, 
        {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
         EdgeForm[Opacity[0.]], 
         RectangleBox[{0.15000000000000002, 0}, {0.2, 2},
          RoundingRadius->0], 
         RectangleBox[{0.55, 0}, {0.6000000000000001, 4},
          RoundingRadius->0], RectangleBox[{0.75, 0}, {0.8, 4},
          RoundingRadius->0], RectangleBox[{0.8, 0}, {0.8500000000000001, 2},
          RoundingRadius->0], RectangleBox[{0.8500000000000001, 0}, {0.9, 2},
          RoundingRadius->0], RectangleBox[{0.9, 0}, {0.9500000000000001, 4},
          RoundingRadius->0], RectangleBox[{1.05, 0}, {1.1, 2},
          RoundingRadius->0], 
         RectangleBox[{1.1500000000000001, 0}, {1.2000000000000002, 2},
          RoundingRadius->0]}, {}, {}}, {{}, {}, {}, {}, {}, {}, {}, {}}},
      AspectRatio->1,
      Axes->False,
      AxesLabel->{None, None},
      AxesOrigin->{-2.621637615362619, 0.},
      BaseStyle->{FontSize -> 16},
      Epilog->{{{
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[1, 0, 0], StripOnInput -> False], TraditionalForm], {-1,
             3.9399999999999995`}], 
          StyleBox[
           LineBox[{{-1, 0.}, {-1, 3.8}}], 
           RGBColor[1, 0, 0], StripOnInput -> False]}, {
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[1, 0, 0], StripOnInput -> False], TraditionalForm], {
           1, 3.78}], 
          StyleBox[
           LineBox[{{1, 0.}, {1, 3.8}}], 
           RGBColor[1, 0, 0], StripOnInput -> False]}}, 
        InsetBox[
         FormBox[
          StyleBox["\"Npt: 22\"", 16, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         Scaled[{0.1, 0.9}]]},
      Frame->True,
      FrameLabel->{
        FormBox[
         StyleBox["\"PDF error \[Delta]r for residues, CT14HERA2NNLO\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm], 
        FormBox[
         StyleBox["\"#points\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm]},
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImageSize->{{600}, {600}},
      PlotLabel->FormBox[
        StyleBox["\"\"", 24, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{-2.5208053993871333`, 2.5208053993871333`}, {0., 4}},
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}], ",", 
     GraphicsBox[{
       {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
        EdgeForm[{Opacity[0.32899999999999996`], Thickness[Small]}], {}, 
        {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
         EdgeForm[{Opacity[0.32899999999999996`], Thickness[Small]}], 
         RectangleBox[{0.15000000000000002, 0}, {0.2, 2},
          RoundingRadius->0], 
         RectangleBox[{0.55, 0}, {0.6000000000000001, 4},
          RoundingRadius->0], RectangleBox[{0.75, 0}, {0.8, 4},
          RoundingRadius->0], RectangleBox[{0.8, 0}, {0.8500000000000001, 2},
          RoundingRadius->0], RectangleBox[{0.8500000000000001, 0}, {0.9, 2},
          RoundingRadius->0], RectangleBox[{0.9, 0}, {0.9500000000000001, 4},
          RoundingRadius->0], RectangleBox[{1.05, 0}, {1.1, 2},
          RoundingRadius->0], 
         RectangleBox[{1.1500000000000001, 0}, {1.2000000000000002, 2},
          RoundingRadius->0]}, {}, {}}, {{}, {}, {}, {}, {}, {}, {}, {}}},
      AspectRatio->1,
      Axes->False,
      AxesLabel->{None, None},
      AxesOrigin->{-0.05041610798774267, 0.},
      BaseStyle->{FontSize -> 16},
      Epilog->{{{
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[1, 0, 0], StripOnInput -> False], TraditionalForm], {
           1, 3.9399999999999995`}], 
          StyleBox[
           LineBox[{{1, 0.}, {1, 3.8}}], 
           RGBColor[1, 0, 0], StripOnInput -> False]}}, 
        InsetBox[
         FormBox[
          StyleBox["\"Npt: 22\"", 16, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         Scaled[{0.1, 0.9}]]},
      Frame->True,
      FrameLabel->{
        FormBox[
         StyleBox[
         "\"| PDF error \[Delta]r for residues, CT14HERA2NNLO |\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm], 
        FormBox[
         StyleBox["\"#points\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm]},
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImageSize->{{600}, {600}},
      PlotLabel->FormBox[
        StyleBox["\"\"", 24, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{0., 2.5208053993871333`}, {0., 4}},
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.704572486507091*^9, 3.7045724899618587`*^9}, 
   3.7045740035696774`*^9, 3.705297202044278*^9, 3.706721143534464*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"processdataplotsmultiexp6percentage", "[", 
  RowBox[{
   RowBox[{"{", "expterrordataclassfinal", "}"}], ",", 
   RowBox[{"readcorrconfigfile4", "[", 
    RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "2", ",", "0"}],
   "]"}]], "Input",
 CellChangeTimes->{{3.704572662795372*^9, 3.704572665461622*^9}}],

Cell[BoxData[
 TemplateBox[{
  "ReadList","readn",
   "\"Invalid real number found when reading from \
\\!\\(\\*RowBox[{\\\"StringToStream\\\", \\\"[\\\", \\\"\\\\\\\"unset\\\\\\\"\
\\\", \\\"]\\\"}]\\).\"",2,214,131,25830776631720876154,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7207193543814487`*^9}],

Cell[BoxData[
 TemplateBox[{
  "Read","readn",
   "\"Invalid real number found when reading from \
\\!\\(\\*RowBox[{\\\"StringToStream\\\", \\\"[\\\", \\\"\\\\\\\"unset\\\\\\\"\
\\\", \\\"]\\\"}]\\).\"",2,214,132,25830776631720876154,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7207193549858723`*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","partw",
   "\"Part \\!\\(\\*RowBox[{\\\"2\\\"}]\\) of \\!\\(\\*RowBox[{\\\"{\\\", \
\\\"$Failed\\\", \\\"}\\\"}]\\) does not exist.\"",2,214,133,
   25830776631720876154,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.720719355577011*^9}],

Cell[BoxData[
 TemplateBox[{
  "Read","readn",
   "\"Invalid real number found when reading from \
\\!\\(\\*RowBox[{\\\"StringToStream\\\", \\\"[\\\", \\\"\\\\\\\"unset\\\\\\\"\
\\\", \\\"]\\\"}]\\).\"",2,214,134,25830776631720876154,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.720719356033862*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","partw",
   "\"Part \\!\\(\\*RowBox[{\\\"2\\\"}]\\) of \\!\\(\\*RowBox[{\\\"{\\\", \
\\\"$Failed\\\", \\\"}\\\"}]\\) does not exist.\"",2,214,135,
   25830776631720876154,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7207193566015377`*^9}],

Cell[BoxData[
 TemplateBox[{
  "Read","readn",
   "\"Invalid real number found when reading from \
\\!\\(\\*RowBox[{\\\"StringToStream\\\", \\\"[\\\", \\\"\\\\\\\"unset\\\\\\\"\
\\\", \\\"]\\\"}]\\).\"",2,214,136,25830776631720876154,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.720719357043153*^9}],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"Read\\\", \\\"::\\\", \
\\\"readn\\\"}], \\\"MessageName\\\"]\\) will be suppressed during this \
calculation.\"",2,214,137,25830776631720876154,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.720719357481635*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","partw",
   "\"Part \\!\\(\\*RowBox[{\\\"2\\\"}]\\) of \\!\\(\\*RowBox[{\\\"{\\\", \
\\\"$Failed\\\", \\\"}\\\"}]\\) does not exist.\"",2,214,138,
   25830776631720876154,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.720719358070209*^9}],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"Part\\\", \\\"::\\\", \
\\\"partw\\\"}], \\\"MessageName\\\"]\\) will be suppressed during this \
calculation.\"",2,214,139,25830776631720876154,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.72071935851359*^9}],

Cell[BoxData[
 TemplateBox[{
  "ReadList","readn",
   "\"Invalid real number found when reading from \
\\!\\(\\*RowBox[{\\\"StringToStream\\\", \\\"[\\\", \\\"\\\\\\\"unset\\\\\\\"\
\\\", \\\"]\\\"}]\\).\"",2,214,140,25830776631720876154,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.720719358957662*^9}],

Cell[BoxData[
 TemplateBox[{
  "ReadList","readn",
   "\"Invalid real number found when reading from \
\\!\\(\\*RowBox[{\\\"StringToStream\\\", \\\"[\\\", \\\"\\\\\\\"unset\\\\\\\"\
\\\", \\\"]\\\"}]\\).\"",2,214,141,25830776631720876154,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7207193594590054`*^9}],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"ReadList\\\", \
\\\"::\\\", \\\"readn\\\"}], \\\"MessageName\\\"]\\) will be suppressed \
during this calculation.\"",2,214,142,25830776631720876154,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.720719359851096*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"expts: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{
     "101", ",", "125", ",", "126", ",", "127", ",", "225", ",", "227", ",", 
      "261", ",", "268", ",", "240", ",", "241", ",", "281"}], "}"}], "}"}]}],
  
  SequenceForm[
  "expts: ", {{101, 125, 126, 127, 225, 227, 261, 268, 240, 241, 281}}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.704572642962475*^9, 3.70457266604574*^9}, 
   3.704574022943048*^9, 3.705297209501274*^9, 3.720719359869751*^9}],

Cell[BoxData["\<\"error, highlight mode should be 0, 1, 2\"\>"], "Print",
 CellChangeTimes->{{3.704572642962475*^9, 3.70457266604574*^9}, 
   3.704574022943048*^9, 3.705297209501274*^9, 3.7207193598811293`*^9}]
}, Open  ]],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{{3.704572643037259*^9, 3.704572666421587*^9}, 
   3.704574023351861*^9, 3.70529720990858*^9, 3.720719359893544*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<testreso.eps\>\"", ",", 
   RowBox[{
    RowBox[{"processdataplotsmultiexp6percentage", "[", 
     RowBox[{
      RowBox[{"{", "expterrordataclassfinal", "}"}], ",", 
      RowBox[{"readcorrconfigfile4", "[", 
       RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "2", ",", 
      "0"}], "]"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
   RowBox[{"ImageResolution", "\[Rule]", "imgresol"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7052974153571177`*^9, 3.7052974670396643`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"expts: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"240", ",", "241", ",", "281", ",", "266"}], "}"}], "}"}]}],
  SequenceForm["expts: ", {{240, 241, 281, 266}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.705297478762969*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", "240", 
   "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", 240, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{3.705297478896123*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", "241", 
   "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", 241, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{3.705297478899947*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", "281", 
   "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", 281, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{3.705297478903347*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", "266", 
   "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", 266, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{3.705297478907044*^9}],

Cell[BoxData["\<\"making table of experiments included in plots\"\>"], "Print",
 CellChangeTimes->{3.705297478910404*^9}]
}, Open  ]],

Cell[BoxData["\<\"testreso.eps\"\>"], "Output",
 CellChangeTimes->{3.705297482305735*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"imgresol", "=", "144"}]], "Input",
 CellChangeTimes->{{3.705297474074667*^9, 3.705297475139554*^9}}],

Cell[BoxData["144"], "Output",
 CellChangeTimes->{{3.7052974716000223`*^9, 3.7052974758047733`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NotebookDirectory", "[", "]"}]], "Input"],

Cell[BoxData["\<\"/home/botingw/code/pdf_correlation/code/math_corr_datasets/\
mathscript_v21_copy1/bin/\"\>"], "Output",
 CellChangeTimes->{3.705640767777927*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Directory", "[", "]"}]], "Input",
 CellChangeTimes->{{3.705640769989254*^9, 3.705640773155861*^9}}],

Cell[BoxData["\<\"/home/botingw/code/pdf_correlation/code/math_corr_datasets/\
mathscript_v21_copy1/bin\"\>"], "Output",
 CellChangeTimes->{3.7056407741894207`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"readcorrconfigfile4", "[", 
  RowBox[{"configDir", ",", "configfilename"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"457", ",", "\<\"2017.0518.0238.-0500_ct14nn-new\"\>", ",", 
   RowBox[{"{", 
    RowBox[{"\<\"1\"\>", ",", "\<\"2\"\>", ",", "\<\"3\"\>", ",", "\<\"4\"\>",
      ",", "\<\"5\"\>", ",", "\<\"6\"\>", ",", "\<\"7\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0"}],
     "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "701", ",", "702", ",", "703", ",", "159", ",", "101", ",", "102", ",", 
     "103", ",", "104", ",", "106", ",", "108", ",", "109", ",", "110", ",", 
     "111", ",", "124", ",", "125", ",", "126", ",", "127", ",", "147", ",", 
     "201", ",", "203", ",", "204", ",", "225", ",", "227", ",", "231", ",", 
     "234", ",", "260", ",", "261", ",", "504", ",", "514", ",", "145", ",", 
     "169", ",", "267", ",", "268", ",", "535", ",", "240", ",", "241", ",", 
     "281", ",", "265", ",", "266", ",", "538", ",", "245", ",", "246", ",", 
     "247", ",", "542", ",", "544", ",", "249", ",", "250", ",", "565", ",", 
     "566", ",", "567", ",", "568"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
     ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"bb\"\>", ",", "\<\"cb\"\>", ",", "\<\"sb\"\>", 
     ",", "\<\"db\"\>", ",", "\<\"ub\"\>", ",", "\<\"g\"\>", ",", "\<\"u\"\>",
      ",", "\<\"d\"\>", ",", "\<\"s\"\>", ",", "\<\"c\"\>", ",", "\<\"b\"\>", 
     ",", "\<\"q6\"\>", ",", "\<\"q7\"\>", ",", "\<\"q8\"\>", 
     ",", "\<\"user\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1",
      ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0"}], 
    "}"}], ",", "\<\" sigma_Higgs (pb)\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
    "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.014`", ",", "0.012`", ",",
      "0.012`", ",", "0.012`", ",", "0.032`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.015`", ",", "0.012`", ",", "0.012`", ",", 
     "0.052`", ",", "0.012`", ",", "0.012`", ",", "0.022`", ",", "0.012`", 
     ",", "0.0432`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", 
     "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", 
     "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.022`", ",", "0.012`", ",", "0.012`", ",", 
     "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", 
     "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.012`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.00001`", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"10.`", ",", "2000.`"}], "}"}], ",", "\<\"auto\"\>", ",", 
   RowBox[{"{", 
    RowBox[{"\<\"auto\"\>", ",", "\<\"auto\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "\<\"auto\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"50", ",", "70", ",", "85"}], "}"}], ",", "\<\"tiny\"\>", ",", 
   RowBox[{"{", 
    RowBox[{"\<\"1\"\>", ",", "\<\"2\"\>", ",", "\<\"3\"\>", ",", "\<\"4\"\>",
      ",", "\<\"5\"\>", ",", "\<\"6\"\>", ",", "\<\"7\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "2", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1"}],
     "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.5`", ",", "0.75`", ",", "0.`", ",", "0.15`", ",", "0.7`", ",", "100.`",
      ",", "0.7`", ",", "100.`", ",", "0.7`", ",", "100.`", ",", "0.7`", ",", 
     "1.`", ",", "0.45`", ",", "0.75`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "50", ",", "86.55`", ",", "85", ",", "100", ",", "85", ",", "100", ",", 
     "85", ",", "100", ",", "50", ",", "85", ",", "50", ",", "85", ",", "50", 
     ",", "85"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.7056408623881063`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"readcorrconfigfile4", "[", 
  RowBox[{
   RowBox[{"NotebookDirectory", "[", "]"}], ",", "configfilename"}], 
  "]"}]], "Input",
 CellChangeTimes->{3.705640870140546*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"457", ",", "\<\"2017.0518.0238.-0500_ct14nn-new\"\>", ",", 
   RowBox[{"{", 
    RowBox[{"\<\"1\"\>", ",", "\<\"2\"\>", ",", "\<\"3\"\>", ",", "\<\"4\"\>",
      ",", "\<\"5\"\>", ",", "\<\"6\"\>", ",", "\<\"7\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0"}],
     "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "701", ",", "702", ",", "703", ",", "159", ",", "101", ",", "102", ",", 
     "103", ",", "104", ",", "106", ",", "108", ",", "109", ",", "110", ",", 
     "111", ",", "124", ",", "125", ",", "126", ",", "127", ",", "147", ",", 
     "201", ",", "203", ",", "204", ",", "225", ",", "227", ",", "231", ",", 
     "234", ",", "260", ",", "261", ",", "504", ",", "514", ",", "145", ",", 
     "169", ",", "267", ",", "268", ",", "535", ",", "240", ",", "241", ",", 
     "281", ",", "265", ",", "266", ",", "538", ",", "245", ",", "246", ",", 
     "247", ",", "542", ",", "544", ",", "249", ",", "250", ",", "565", ",", 
     "566", ",", "567", ",", "568"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
     ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"bb\"\>", ",", "\<\"cb\"\>", ",", "\<\"sb\"\>", 
     ",", "\<\"db\"\>", ",", "\<\"ub\"\>", ",", "\<\"g\"\>", ",", "\<\"u\"\>",
      ",", "\<\"d\"\>", ",", "\<\"s\"\>", ",", "\<\"c\"\>", ",", "\<\"b\"\>", 
     ",", "\<\"q6\"\>", ",", "\<\"q7\"\>", ",", "\<\"q8\"\>", 
     ",", "\<\"user\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1",
      ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0"}], 
    "}"}], ",", "\<\" sigma_Higgs (pb)\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
    "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.014`", ",", "0.012`", ",",
      "0.012`", ",", "0.012`", ",", "0.032`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.015`", ",", "0.012`", ",", "0.012`", ",", 
     "0.052`", ",", "0.012`", ",", "0.012`", ",", "0.022`", ",", "0.012`", 
     ",", "0.0432`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", 
     "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", 
     "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.022`", ",", "0.012`", ",", "0.012`", ",", 
     "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", 
     "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.012`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.00001`", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"10.`", ",", "2000.`"}], "}"}], ",", "\<\"auto\"\>", ",", 
   RowBox[{"{", 
    RowBox[{"\<\"auto\"\>", ",", "\<\"auto\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "\<\"auto\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"50", ",", "70", ",", "85"}], "}"}], ",", "\<\"tiny\"\>", ",", 
   RowBox[{"{", 
    RowBox[{"\<\"1\"\>", ",", "\<\"2\"\>", ",", "\<\"3\"\>", ",", "\<\"4\"\>",
      ",", "\<\"5\"\>", ",", "\<\"6\"\>", ",", "\<\"7\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "2", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1"}],
     "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.5`", ",", "0.75`", ",", "0.`", ",", "0.15`", ",", "0.7`", ",", "100.`",
      ",", "0.7`", ",", "100.`", ",", "0.7`", ",", "100.`", ",", "0.7`", ",", 
     "1.`", ",", "0.45`", ",", "0.75`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "50", ",", "86.55`", ",", "85", ",", "100", ",", "85", ",", "100", ",", 
     "85", ",", "100", ",", "50", ",", "85", ",", "50", ",", "85", ",", "50", 
     ",", "85"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.705640871344658*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"readcorrconfigfile4", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Directory", "[", "]"}], "<>", "\"\</\>\""}], ",", 
   "configfilename"}], "]"}]], "Input",
 CellChangeTimes->{{3.7056408952239923`*^9, 3.705640906826042*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"457", ",", "\<\"2017.0518.0238.-0500_ct14nn-new\"\>", ",", 
   RowBox[{"{", 
    RowBox[{"\<\"1\"\>", ",", "\<\"2\"\>", ",", "\<\"3\"\>", ",", "\<\"4\"\>",
      ",", "\<\"5\"\>", ",", "\<\"6\"\>", ",", "\<\"7\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0"}],
     "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "701", ",", "702", ",", "703", ",", "159", ",", "101", ",", "102", ",", 
     "103", ",", "104", ",", "106", ",", "108", ",", "109", ",", "110", ",", 
     "111", ",", "124", ",", "125", ",", "126", ",", "127", ",", "147", ",", 
     "201", ",", "203", ",", "204", ",", "225", ",", "227", ",", "231", ",", 
     "234", ",", "260", ",", "261", ",", "504", ",", "514", ",", "145", ",", 
     "169", ",", "267", ",", "268", ",", "535", ",", "240", ",", "241", ",", 
     "281", ",", "265", ",", "266", ",", "538", ",", "245", ",", "246", ",", 
     "247", ",", "542", ",", "544", ",", "249", ",", "250", ",", "565", ",", 
     "566", ",", "567", ",", "568"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
     ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"bb\"\>", ",", "\<\"cb\"\>", ",", "\<\"sb\"\>", 
     ",", "\<\"db\"\>", ",", "\<\"ub\"\>", ",", "\<\"g\"\>", ",", "\<\"u\"\>",
      ",", "\<\"d\"\>", ",", "\<\"s\"\>", ",", "\<\"c\"\>", ",", "\<\"b\"\>", 
     ",", "\<\"q6\"\>", ",", "\<\"q7\"\>", ",", "\<\"q8\"\>", 
     ",", "\<\"user\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1",
      ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0"}], 
    "}"}], ",", "\<\" sigma_Higgs (pb)\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
    "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.014`", ",", "0.012`", ",",
      "0.012`", ",", "0.012`", ",", "0.032`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.015`", ",", "0.012`", ",", "0.012`", ",", 
     "0.052`", ",", "0.012`", ",", "0.012`", ",", "0.022`", ",", "0.012`", 
     ",", "0.0432`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", 
     "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", 
     "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.022`", ",", "0.012`", ",", "0.012`", ",", 
     "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", 
     "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.012`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.00001`", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"10.`", ",", "2000.`"}], "}"}], ",", "\<\"auto\"\>", ",", 
   RowBox[{"{", 
    RowBox[{"\<\"auto\"\>", ",", "\<\"auto\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "\<\"auto\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"50", ",", "70", ",", "85"}], "}"}], ",", "\<\"tiny\"\>", ",", 
   RowBox[{"{", 
    RowBox[{"\<\"1\"\>", ",", "\<\"2\"\>", ",", "\<\"3\"\>", ",", "\<\"4\"\>",
      ",", "\<\"5\"\>", ",", "\<\"6\"\>", ",", "\<\"7\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "2", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1"}],
     "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.5`", ",", "0.75`", ",", "0.`", ",", "0.15`", ",", "0.7`", ",", "100.`",
      ",", "0.7`", ",", "100.`", ",", "0.7`", ",", "100.`", ",", "0.7`", ",", 
     "1.`", ",", "0.45`", ",", "0.75`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "50", ",", "86.55`", ",", "85", ",", "100", ",", "85", ",", "100", ",", 
     "85", ",", "100", ",", "50", ",", "85", ",", "50", ",", "85", ",", "50", 
     ",", "85"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.70564089706194*^9, 3.705640912550149*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"FileNames", "[", 
  RowBox[{"Directory", "[", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"FileNames", "[", 
  RowBox[{
   RowBox[{"Directory", "[", "]"}], "<>", "\"\</\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.705640928019115*^9, 3.7056409522184267`*^9}}],

Cell[BoxData[
 RowBox[{"{", \
"\<\"/home/botingw/code/pdf_correlation/code/math_corr_datasets/mathscript_\
v21_copy1/bin\"\>", "}"}]], "Output",
 CellChangeTimes->{3.705640960051484*^9}],

Cell[BoxData[
 RowBox[{"{", \
"\<\"/home/botingw/code/pdf_correlation/code/math_corr_datasets/mathscript_\
v21_copy1/bin\"\>", "}"}]], "Output",
 CellChangeTimes->{3.705640960054117*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"testnewindex", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{
     "CorrDataDir", "<>", "\"\<expterror_\>\"", "<>", "CorrDataFile"}], ",", 
     "\"\<ExpressionML\>\""}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.692723648488598*^9, 3.692723656238858*^9}, {
   3.692724530213889*^9, 3.692724537777619*^9}, {3.6927245869877567`*^9, 
   3.692724611750757*^9}, {3.692724694012382*^9, 3.692724694516695*^9}, {
   3.6927248228546143`*^9, 3.6927248742476254`*^9}, {3.692726352475533*^9, 
   3.692726460529402*^9}, {3.692726503468624*^9, 3.69272650534301*^9}, {
   3.6933119701642237`*^9, 3.693311972894825*^9}, {3.69331461390936*^9, 
   3.693314614124537*^9}, {3.693316093645349*^9, 3.6933160959790573`*^9}, {
   3.693653206302556*^9, 3.6936532106134987`*^9}, {3.693939625505322*^9, 
   3.693939656334466*^9}, {3.693942641369175*^9, 3.6939427050773563`*^9}, {
   3.6939430977466087`*^9, 3.693943156993147*^9}, {3.69655860408397*^9, 
   3.6965586399105797`*^9}, {3.696680796628357*^9, 3.6966808769283667`*^9}, {
   3.6966905986088877`*^9, 3.6966906015575037`*^9}, {3.6968303816187687`*^9, 
   3.696830405964432*^9}, 3.696830451414171*^9, {3.6968304832955847`*^9, 
   3.696830577226272*^9}, {3.6968311626158457`*^9, 3.696831163722234*^9}, {
   3.6970768789183807`*^9, 3.697076887616562*^9}, {3.69707848487141*^9, 
   3.697078591210807*^9}, {3.697078764057641*^9, 3.6970788395483007`*^9}, {
   3.697079471643612*^9, 3.697079472537709*^9}, {3.697079508582533*^9, 
   3.6970796061789*^9}, {3.697079637519354*^9, 3.697079704206859*^9}, {
   3.697079744180998*^9, 3.697079850511104*^9}, 3.69708009114454*^9, {
   3.697080605349367*^9, 3.6970806091324453`*^9}, {3.697080917436017*^9, 
   3.697080920859625*^9}, {3.6970814709326363`*^9, 3.697081510033683*^9}, {
   3.6970817029250097`*^9, 3.6970817058735943`*^9}, {3.69708174981524*^9, 
   3.697081750811051*^9}, {3.697082776875799*^9, 3.697082781051053*^9}, {
   3.697083062247024*^9, 3.6970830692485647`*^9}, {3.697138742323319*^9, 
   3.697138771015585*^9}, {3.6971390075105133`*^9, 3.6971390249980097`*^9}, {
   3.697139765916954*^9, 3.697140011115527*^9}, {3.6971401201276407`*^9, 
   3.69714015841426*^9}, {3.697140215538045*^9, 3.6971402462786617`*^9}, {
   3.697140329638941*^9, 3.6971404532947083`*^9}, {3.697140550118216*^9, 
   3.6971406924417267`*^9}, {3.69714112371637*^9, 3.697141142012652*^9}, {
   3.697141668563136*^9, 3.69714169228379*^9}, {3.697142121669072*^9, 
   3.697142131910977*^9}, {3.697154211586882*^9, 3.697154220941998*^9}, {
   3.6971542725272083`*^9, 3.697154293058907*^9}, {3.6971546429166737`*^9, 
   3.697154687209687*^9}, {3.697154912165421*^9, 3.697154961078877*^9}, {
   3.697155009671788*^9, 3.697155038476575*^9}, {3.697155359397155*^9, 
   3.697155363593137*^9}, {3.6971556848644867`*^9, 3.697155692079138*^9}, {
   3.697222247488604*^9, 3.697222290746934*^9}, {3.6972860122902603`*^9, 
   3.697286048602767*^9}, {3.69728615691158*^9, 3.697286217626849*^9}, {
   3.6972946096828327`*^9, 3.697294612528249*^9}, {3.69729558423606*^9, 
   3.697295715434699*^9}, {3.697296765727755*^9, 3.697296773423441*^9}, {
   3.697400476382049*^9, 3.697400660242959*^9}, {3.697400697837544*^9, 
   3.697400736773443*^9}, {3.6974007992262897`*^9, 3.697400921956421*^9}, {
   3.697401171407124*^9, 3.697401203002494*^9}, {3.697401478783388*^9, 
   3.6974014977251167`*^9}, {3.6974015288478537`*^9, 
   3.6974016225692577`*^9}, {3.697401662135783*^9, 3.697401941604968*^9}, 
   3.697402052620207*^9, {3.697402667412176*^9, 3.697402669299849*^9}, {
   3.697402707268697*^9, 3.697402830563102*^9}, {3.697403001740428*^9, 
   3.697403006792362*^9}, {3.697403066485817*^9, 3.697403089438408*^9}, {
   3.697403169141343*^9, 3.697403169300745*^9}, {3.6974032548169127`*^9, 
   3.697403262806226*^9}, {3.6974033835136833`*^9, 3.697403398164859*^9}, {
   3.697403693896372*^9, 3.697403714480401*^9}, {3.697403871140098*^9, 
   3.697403896676878*^9}, {3.697403927677313*^9, 3.697403929215707*^9}, {
   3.697404002181491*^9, 3.697404033811108*^9}, {3.6974040697871723`*^9, 
   3.697404076605229*^9}, {3.697404138798005*^9, 3.697404209757766*^9}, 
   3.697404305029789*^9, {3.697404412745449*^9, 3.6974044182263203`*^9}, {
   3.6974056664941263`*^9, 3.69740570015322*^9}, {3.697405740989566*^9, 
   3.697405810296575*^9}, {3.6974103097470083`*^9, 3.697410317039926*^9}, {
   3.697417807503504*^9, 3.697417816382893*^9}, {3.6975559116468773`*^9, 
   3.697555921952511*^9}, {3.6975565546674*^9, 3.697556606785534*^9}, {
   3.697556638316646*^9, 3.697556707402018*^9}, {3.6975567433400784`*^9, 
   3.697556753810347*^9}, {3.69755733249146*^9, 3.697557380535098*^9}, {
   3.697557518986594*^9, 3.697557560771634*^9}, {3.69755759992305*^9, 
   3.6975576002906*^9}, {3.697557694178874*^9, 3.697557695865241*^9}, {
   3.697558205114801*^9, 3.697558236061026*^9}, {3.69755827015271*^9, 
   3.697558502197757*^9}, {3.697558722719071*^9, 3.697558722991253*^9}, {
   3.697558962576949*^9, 3.697558972125186*^9}, {3.6975592583456984`*^9, 
   3.6975592703327713`*^9}, {3.697559603274172*^9, 3.697559615031126*^9}, {
   3.697559875534439*^9, 3.6975598960997133`*^9}, {3.6975599848149347`*^9, 
   3.697560165958386*^9}, {3.697560496083321*^9, 3.6975605006610937`*^9}, {
   3.697560945249696*^9, 3.6975610303265123`*^9}, {3.6978335880846443`*^9, 
   3.6978336116978207`*^9}, {3.6978370047888603`*^9, 3.697837037379693*^9}, {
   3.697837070503273*^9, 3.697837201261754*^9}, {3.697837479536602*^9, 
   3.697837603942915*^9}, {3.6978376417111063`*^9, 3.6978377343395967`*^9}, {
   3.697886701400988*^9, 3.6978867422842083`*^9}, {3.697886811750001*^9, 
   3.6978870113471746`*^9}, {3.697888160205917*^9, 3.697888192122485*^9}, 
   3.6978886509163933`*^9, {3.697888811917552*^9, 3.697888836155066*^9}, {
   3.697888915375636*^9, 3.6978889245968*^9}, {3.6978921169715548`*^9, 
   3.697892142699376*^9}, {3.697892245272468*^9, 3.697892265316698*^9}, {
   3.697895431695013*^9, 3.697895434728279*^9}, {3.697896340488986*^9, 
   3.6978963617738047`*^9}, {3.697899702354683*^9, 3.6978997073217297`*^9}, {
   3.6978997570611753`*^9, 3.6978998573973923`*^9}, {3.697899895969203*^9, 
   3.69789992969068*^9}, 3.697900002552608*^9, {3.6979003709838667`*^9, 
   3.69790038433469*^9}, {3.697900577230777*^9, 3.697900599476684*^9}, {
   3.697900692900959*^9, 3.697900823597556*^9}, {3.697900887234622*^9, 
   3.6979008900711403`*^9}, {3.697901103834797*^9, 3.6979011144389877`*^9}, {
   3.6979021104041567`*^9, 3.6979021174016027`*^9}, {3.697902851146566*^9, 
   3.697902936225397*^9}, 3.697903060044847*^9, {3.697903116968381*^9, 
   3.697903121709342*^9}, {3.6979032754399557`*^9, 3.697903276591189*^9}, {
   3.697996584040292*^9, 3.697996593331482*^9}, {3.698071337312834*^9, 
   3.698071341847207*^9}, 3.6980716298814917`*^9, {3.6980721641926537`*^9, 
   3.698072167008778*^9}, {3.698161423522284*^9, 3.6981614462900743`*^9}, {
   3.698161540279511*^9, 3.698161595744443*^9}, {3.698161636191758*^9, 
   3.698161725062221*^9}, {3.6981617687110033`*^9, 3.698161803374731*^9}, {
   3.698161887018663*^9, 3.69816192282675*^9}, {3.698161958371101*^9, 
   3.6981619925231113`*^9}, {3.698162026031312*^9, 3.698162074028681*^9}, {
   3.6981657267132397`*^9, 3.6981657310598*^9}, {3.698165786091655*^9, 
   3.6981658056351223`*^9}, {3.698165849545231*^9, 3.698165919924782*^9}, {
   3.698169528215746*^9, 3.6981695559881477`*^9}, {3.698169612230535*^9, 
   3.698169613475706*^9}, {3.6981697014096317`*^9, 3.698169769733567*^9}, 
   3.698170071674176*^9, {3.698170222070361*^9, 3.698170273553499*^9}, {
   3.6981707322196083`*^9, 3.698170740532178*^9}, {3.698170811888246*^9, 
   3.698170812034443*^9}, {3.6981708480788527`*^9, 3.6981708499989557`*^9}, {
   3.698170976523417*^9, 3.698170980113942*^9}, {3.6981712680480824`*^9, 
   3.69817132556627*^9}, {3.698171357706958*^9, 3.698171383464563*^9}, {
   3.698171426987818*^9, 3.698171457874702*^9}, 3.698171798143113*^9, {
   3.6981719612953672`*^9, 3.698172006952753*^9}, {3.698172138846099*^9, 
   3.698172146148446*^9}, {3.698172178650379*^9, 3.6981722258393583`*^9}, {
   3.69817228656448*^9, 3.698172290421266*^9}, {3.698172584936687*^9, 
   3.698172645282847*^9}, {3.698172692128703*^9, 3.698172694407916*^9}, {
   3.698173088133802*^9, 3.698173096660006*^9}, {3.6981733812693377`*^9, 
   3.69817338136504*^9}, {3.698173532115452*^9, 3.698173541691969*^9}, {
   3.698173575241938*^9, 3.698173584822556*^9}, {3.698173815288653*^9, 
   3.698173822031045*^9}, {3.698174275990417*^9, 3.698174315836672*^9}, {
   3.698174788518158*^9, 3.698174789913475*^9}, {3.698174912608736*^9, 
   3.698174980867828*^9}, {3.698175053098505*^9, 3.698175079356299*^9}, {
   3.698175171115746*^9, 3.698175172284082*^9}, {3.698175217131351*^9, 
   3.698175226770488*^9}, {3.698175391240275*^9, 3.698175403248673*^9}, {
   3.698175460678995*^9, 3.698175499403681*^9}, {3.69817553997309*^9, 
   3.698175556623143*^9}, {3.698175644116884*^9, 3.6981756505334063`*^9}, {
   3.698175706111665*^9, 3.6981757164951973`*^9}, {3.69817585515648*^9, 
   3.698175859447098*^9}, {3.698175900793294*^9, 3.698175906769639*^9}, {
   3.698175939876513*^9, 3.6981759835847387`*^9}, {3.698176038710297*^9, 
   3.698176047052271*^9}, {3.698176090615123*^9, 3.6981761259048853`*^9}, {
   3.698176160222315*^9, 3.698176163802479*^9}, {3.698176901614978*^9, 
   3.698176904246009*^9}, {3.698177037531947*^9, 3.698177165116879*^9}, {
   3.698177240672209*^9, 3.6981772435059566`*^9}, {3.698177296222597*^9, 
   3.698177376635*^9}, {3.698177414827533*^9, 3.6981775051078157`*^9}, 
   3.698177633996216*^9, {3.698177692298443*^9, 3.6981777236975718`*^9}, {
   3.69817820570249*^9, 3.698178229088004*^9}, {3.698178326322247*^9, 
   3.698178337686069*^9}, {3.698178376942813*^9, 3.698178391302638*^9}, {
   3.69817843428864*^9, 3.698178448188026*^9}, {3.698178486447935*^9, 
   3.69817849052114*^9}, {3.6981786070612993`*^9, 3.69817861880812*^9}, {
   3.698178672817665*^9, 3.698178713654771*^9}, {3.698183704324995*^9, 
   3.6981837191677303`*^9}, {3.698185307618744*^9, 3.698185313766013*^9}, {
   3.698185371925268*^9, 3.698185388436612*^9}, {3.698185418783613*^9, 
   3.698185419791635*^9}, {3.698186013196486*^9, 3.698186013893758*^9}, {
   3.698186094057954*^9, 3.6981860948604803`*^9}, {3.698186202953641*^9, 
   3.698186279283292*^9}, {3.6981863137626133`*^9, 3.6981863498565474`*^9}, {
   3.698186487767766*^9, 3.698186488677528*^9}, {3.6981868024539137`*^9, 
   3.698186995225019*^9}, {3.698375374155635*^9, 3.698375388391355*^9}, {
   3.698375481678948*^9, 3.698375481801426*^9}, {3.69837600317898*^9, 
   3.698376003870861*^9}, {3.6983764126863537`*^9, 3.698376415516151*^9}, {
   3.698376483123497*^9, 3.6983765172376947`*^9}, {3.698376554890914*^9, 
   3.698376569245541*^9}, {3.698376612274609*^9, 3.6983766165984*^9}, {
   3.6983773936606293`*^9, 3.698377550214871*^9}, {3.6983775966181927`*^9, 
   3.6983776546827583`*^9}, {3.698377697591744*^9, 3.698377778858807*^9}, {
   3.698377897472526*^9, 3.698377995892112*^9}, {3.6983781537069063`*^9, 
   3.698378176992009*^9}, {3.698378208594558*^9, 3.698378216223559*^9}, {
   3.698378287910985*^9, 3.698378347050434*^9}, {3.6983783774576483`*^9, 
   3.698378379103231*^9}, {3.698378961801875*^9, 3.698379086636891*^9}, {
   3.698379185097292*^9, 3.6983792371495047`*^9}, {3.698379274152958*^9, 
   3.698379323956073*^9}, {3.698379446741404*^9, 3.698379592497773*^9}, {
   3.6983796226445503`*^9, 3.69837973146275*^9}, {3.698379773989316*^9, 
   3.698379813399626*^9}, {3.698422130188918*^9, 3.698422185811975*^9}, 
   3.69842222139403*^9, 3.6984223644484053`*^9, {3.698422649928307*^9, 
   3.698422653584572*^9}, {3.698422759452343*^9, 3.698422767844452*^9}, {
   3.698422858743147*^9, 3.698422859714566*^9}, {3.698422906859548*^9, 
   3.698422921261602*^9}, {3.69842295139184*^9, 3.6984229601552763`*^9}, {
   3.698423000559868*^9, 3.698423050016955*^9}, {3.698423125951791*^9, 
   3.6984231701302843`*^9}, {3.698423512900033*^9, 3.6984235252759438`*^9}, {
   3.6984235907916822`*^9, 3.6984235999841223`*^9}, {3.698423637283904*^9, 
   3.698423638463047*^9}, {3.698423696061852*^9, 3.698423798128016*^9}, {
   3.698423895752602*^9, 3.6984239143236113`*^9}, {3.6984239572218227`*^9, 
   3.698424013604312*^9}, {3.698424152110713*^9, 3.6984242108865423`*^9}, {
   3.698424640916594*^9, 3.698424703222928*^9}, {3.698425236501338*^9, 
   3.698425241702427*^9}, {3.698425312887843*^9, 3.6984253306654873`*^9}, {
   3.698425370103011*^9, 3.698425534046015*^9}, {3.698426334951508*^9, 
   3.698426356689186*^9}, 3.698427303040491*^9, {3.6984345648966913`*^9, 
   3.6984346363603888`*^9}, {3.698434687418271*^9, 3.698434739263241*^9}, {
   3.698434960685013*^9, 3.698434974961977*^9}, {3.698435034075223*^9, 
   3.6984350705105057`*^9}, {3.698435120776404*^9, 3.6984351322506313`*^9}, {
   3.698435229223077*^9, 3.69843523276132*^9}, {3.698496568796444*^9, 
   3.698496607636848*^9}, {3.6984966623147593`*^9, 3.698496795834756*^9}, {
   3.698496832965817*^9, 3.6984968961638327`*^9}, {3.6984970070681553`*^9, 
   3.698497007641251*^9}, {3.6984970587122993`*^9, 3.6984970863940353`*^9}, 
   3.69849714080025*^9, {3.6984971722337027`*^9, 3.6984971821369*^9}, {
   3.698497234689015*^9, 3.698497279786778*^9}, {3.698497721880156*^9, 
   3.6984977586704197`*^9}, {3.698497800291216*^9, 3.69849782897654*^9}, {
   3.698497896345314*^9, 3.698497952819976*^9}, {3.698498099342456*^9, 
   3.698498218417438*^9}, {3.698498251210842*^9, 3.698498318974228*^9}, {
   3.698498368945421*^9, 3.698498417266086*^9}, {3.698498464087495*^9, 
   3.698498472972783*^9}, {3.6984985071261177`*^9, 3.698498543393721*^9}, {
   3.698498574601891*^9, 3.698498618036139*^9}, {3.698498878890766*^9, 
   3.698498974996151*^9}, {3.698499943888091*^9, 3.6984999862180147`*^9}, {
   3.698500039380684*^9, 3.698500060991892*^9}, {3.698500296113984*^9, 
   3.698500297958454*^9}, {3.698500351901705*^9, 3.698500356984885*^9}, {
   3.698500428859589*^9, 3.6985004394480867`*^9}, {3.698500480455682*^9, 
   3.698500494407383*^9}, {3.6985006619139853`*^9, 3.6985007401492023`*^9}, {
   3.698500812610276*^9, 3.698500824072425*^9}, {3.698500884416847*^9, 
   3.698500916349101*^9}, {3.6985009871156054`*^9, 3.698501025815914*^9}, {
   3.698501097798208*^9, 3.6985011095001717`*^9}, {3.698501171569806*^9, 
   3.6985011784868727`*^9}, {3.69850133025955*^9, 3.698501397362928*^9}, {
   3.698504558196309*^9, 3.698504629295352*^9}, {3.698504690759542*^9, 
   3.698504725030435*^9}, {3.6985048610094423`*^9, 3.698504868049876*^9}, {
   3.698504922529729*^9, 3.698504983182766*^9}, {3.698505013265264*^9, 
   3.6985051510092173`*^9}, {3.698505318094695*^9, 3.698505342289236*^9}, {
   3.698505391909754*^9, 3.698505392009137*^9}, {3.698505518998989*^9, 
   3.698505549405963*^9}, {3.698505632809449*^9, 3.698505649621396*^9}, {
   3.6985056970428123`*^9, 3.698505717674914*^9}, {3.6985057803345327`*^9, 
   3.6985058463122377`*^9}, {3.6985059103796864`*^9, 3.698505913548465*^9}, 
   3.6985060997858*^9, {3.6985061368326807`*^9, 3.6985061499027567`*^9}, {
   3.698506183802936*^9, 3.698506183979107*^9}, {3.6985066795543623`*^9, 
   3.6985067117845078`*^9}, {3.698506747178562*^9, 3.69850679025176*^9}, {
   3.698506837379848*^9, 3.698506859069729*^9}, {3.698506894774612*^9, 
   3.698506909028596*^9}, {3.698507002902429*^9, 3.6985071014064903`*^9}, {
   3.69850734083961*^9, 3.698507348968281*^9}, {3.698507399522592*^9, 
   3.6985074275264378`*^9}, {3.6985075294360733`*^9, 3.698507608250091*^9}, {
   3.698507647637692*^9, 3.6985076943071203`*^9}, {3.698508057614543*^9, 
   3.698508377302964*^9}, {3.698508467466371*^9, 3.698508467562771*^9}, {
   3.6985085255057583`*^9, 3.698508560401816*^9}, {3.698509240094328*^9, 
   3.698509251004244*^9}, {3.698509281500942*^9, 3.6985093099425*^9}, {
   3.698510661926887*^9, 3.6985106855263844`*^9}, {3.69851108500737*^9, 
   3.698511089406443*^9}, 3.698511150013969*^9, {3.698512078036865*^9, 
   3.6985124380448837`*^9}, 3.6985134783165407`*^9, {3.698513965632573*^9, 
   3.698513970599959*^9}, {3.698514457541904*^9, 3.698514458666573*^9}, {
   3.698515184364903*^9, 3.698515194855057*^9}, {3.698515420391387*^9, 
   3.6985154818835506`*^9}, {3.698515850103076*^9, 3.69851589386024*^9}, {
   3.698515982883314*^9, 3.698516032230871*^9}, {3.698517354529791*^9, 
   3.6985174425736647`*^9}, {3.698594812397932*^9, 3.698595017681079*^9}, {
   3.698595071527205*^9, 3.698595224293602*^9}, {3.6985952640290003`*^9, 
   3.698595270045404*^9}, {3.698595383509328*^9, 3.698595409769446*^9}, {
   3.698595571245247*^9, 3.698595574658671*^9}, {3.698595671017033*^9, 
   3.698595672528543*^9}, {3.6985957163508*^9, 3.6985957727292356`*^9}, {
   3.698596554688429*^9, 3.698596600451806*^9}, {3.69859664651615*^9, 
   3.698596681396489*^9}, {3.698603387024642*^9, 3.698603398092396*^9}, {
   3.6986437460067043`*^9, 3.698643794006505*^9}, {3.698644731753346*^9, 
   3.6986447392924957`*^9}, {3.698645131331957*^9, 3.6986451854952583`*^9}, {
   3.698645609424526*^9, 3.6986456157993183`*^9}, {3.698645953684476*^9, 
   3.698645964830656*^9}, {3.6986752359122553`*^9, 3.698675312968587*^9}, {
   3.698677369597822*^9, 3.698677389568874*^9}, {3.6986776024792633`*^9, 
   3.6986776131258183`*^9}, {3.6986777618002443`*^9, 3.698677771846245*^9}, {
   3.698976815333543*^9, 3.698976887438642*^9}, {3.698977041939784*^9, 
   3.698977057265069*^9}, {3.698978239912632*^9, 3.698978277250681*^9}, {
   3.698978369755589*^9, 3.6989783986916513`*^9}, {3.698978769009664*^9, 
   3.698978788643612*^9}, {3.6989789831445932`*^9, 3.698978983469986*^9}, 
   3.698982300432041*^9, {3.698983796879025*^9, 3.698983799749288*^9}, {
   3.698984103204665*^9, 3.698984104510377*^9}, {3.698984214187005*^9, 
   3.698984239846623*^9}, {3.698984482306733*^9, 3.698984495886298*^9}, {
   3.698984570719895*^9, 3.698984575335476*^9}, {3.698984676292613*^9, 
   3.69898467884112*^9}, {3.698984848499816*^9, 3.69898485843489*^9}, {
   3.6989850619199963`*^9, 3.698985172149876*^9}, {3.698985465891712*^9, 
   3.698985492123137*^9}, {3.6989856237008677`*^9, 3.698985632173436*^9}, {
   3.698985832975917*^9, 3.698985836655061*^9}, {3.698986086670496*^9, 
   3.698986086767561*^9}, {3.699108131767274*^9, 3.699108143880109*^9}, 
   3.699108322655871*^9, 3.6991084383653316`*^9, {3.699113671344336*^9, 
   3.699113675602439*^9}, {3.699113708277372*^9, 3.699113819835918*^9}, {
   3.6991142539321327`*^9, 3.699114257534837*^9}, {3.699114378331626*^9, 
   3.699114414883988*^9}, {3.699118260825739*^9, 3.6991182651064777`*^9}, {
   3.6997146471863203`*^9, 3.6997147069160757`*^9}, {3.699714773054997*^9, 
   3.699714796014769*^9}, {3.699714833886188*^9, 3.699714884003749*^9}, {
   3.699714930103491*^9, 3.6997149333666487`*^9}, {3.699714963610683*^9, 
   3.6997149665064497`*^9}, {3.699718635041913*^9, 3.69971873519379*^9}, {
   3.699718767296932*^9, 3.699718937150714*^9}, {3.6997218031928053`*^9, 
   3.699721809291904*^9}, {3.700576798254157*^9, 3.700576807204111*^9}, 
   3.700576994656827*^9, {3.700577127492188*^9, 3.7005771450662403`*^9}, {
   3.700856424114493*^9, 3.700856512733164*^9}, {3.700856721510928*^9, 
   3.7008567247049503`*^9}, {3.700856977130435*^9, 3.700856990074864*^9}, {
   3.700857022066639*^9, 3.700857068964971*^9}, {3.70085711279653*^9, 
   3.7008571445161057`*^9}, {3.700857252845189*^9, 3.7008574868231363`*^9}, {
   3.700857741961318*^9, 3.700857847338152*^9}, {3.7008580892926817`*^9, 
   3.700858281442284*^9}, {3.7008587323046427`*^9, 3.700858743049624*^9}, {
   3.700859079009516*^9, 3.7008591440793943`*^9}, {3.7022827016062307`*^9, 
   3.702282725186412*^9}, {3.702283656459311*^9, 3.7022837402623253`*^9}, {
   3.702284225249275*^9, 3.702284264204466*^9}, {3.702284381896797*^9, 
   3.702284397562743*^9}, 3.7022845116922092`*^9, {3.702284670737721*^9, 
   3.702284673895072*^9}, {3.702284743192176*^9, 3.702284819606019*^9}, {
   3.702284915484323*^9, 3.702284937302918*^9}, {3.702285040948885*^9, 
   3.702285059065847*^9}, {3.703210061145794*^9, 3.703210194595612*^9}, {
   3.703210354155658*^9, 3.70321042029907*^9}, {3.703210457504456*^9, 
   3.703210491007218*^9}, {3.703210567521886*^9, 3.703210657535472*^9}, {
   3.703212116263042*^9, 3.703212145102297*^9}, {3.703212180930471*^9, 
   3.703212198170203*^9}, {3.703212266034836*^9, 3.7032122709175043`*^9}, {
   3.703212308579755*^9, 3.7032123827055893`*^9}, {3.703212414361137*^9, 
   3.703212583714033*^9}, {3.7032126190239153`*^9, 3.703212641090941*^9}, {
   3.70321389287853*^9, 3.70321389409584*^9}, 3.7032139244996433`*^9, {
   3.7032140869230747`*^9, 3.70321423222677*^9}, {3.7032143131706543`*^9, 
   3.703214320212666*^9}, {3.7032143853125553`*^9, 3.703214398823906*^9}, {
   3.703214478357448*^9, 3.70321448124111*^9}, {3.703214539802897*^9, 
   3.703214562333995*^9}, {3.703214654425705*^9, 3.703214695362774*^9}, {
   3.7032150586029*^9, 3.703215126718226*^9}, {3.703215193384273*^9, 
   3.703215232456133*^9}, {3.703215312180965*^9, 3.7032155483416567`*^9}, {
   3.70321559347147*^9, 3.703215595193327*^9}, {3.7032157335223303`*^9, 
   3.703215741843009*^9}, {3.7032157865242367`*^9, 3.703215809203005*^9}, {
   3.7032158512765083`*^9, 3.7032160147254477`*^9}, {3.7032162855504923`*^9, 
   3.703216306927647*^9}, {3.7032165670055*^9, 3.703216579050796*^9}, {
   3.70321730361217*^9, 3.7032173444180527`*^9}, {3.703217431319765*^9, 
   3.703217443278096*^9}, 3.703217523826235*^9, {3.703217563386284*^9, 
   3.703217567231889*^9}, {3.703217648553754*^9, 3.7032176539844093`*^9}, {
   3.703218130604484*^9, 3.703218157644577*^9}, {3.703218323775071*^9, 
   3.7032183651260433`*^9}, {3.703218512922668*^9, 3.703218517109384*^9}, {
   3.7032185626284323`*^9, 3.703218566120389*^9}, {3.7032190733591957`*^9, 
   3.703219119889312*^9}, {3.703219191833766*^9, 3.7032192334256*^9}, {
   3.703220675570663*^9, 3.703220698296678*^9}, 3.7032208417605677`*^9, 
   3.703220873707135*^9, {3.703221516911208*^9, 3.703221550673723*^9}, {
   3.70322158718178*^9, 3.703221651975253*^9}, {3.7032223503800592`*^9, 
   3.703222405644689*^9}, {3.703222444712462*^9, 3.703222478194214*^9}, {
   3.703222517831664*^9, 3.703222652461401*^9}, {3.703222698114142*^9, 
   3.703222750958495*^9}, {3.703222804934175*^9, 3.70322294602733*^9}, {
   3.703226789712873*^9, 3.703226794839857*^9}, {3.703275222547058*^9, 
   3.7032752839706783`*^9}, {3.7032753342321043`*^9, 3.703275556085435*^9}, {
   3.703276636806147*^9, 3.7032766380431767`*^9}, {3.703276889251028*^9, 
   3.703276900078492*^9}, {3.703299977999363*^9, 3.703300024855564*^9}, {
   3.703300056869525*^9, 3.703300095195971*^9}, {3.703307013457649*^9, 
   3.703307023522627*^9}, {3.703485612299582*^9, 3.703485656505014*^9}, {
   3.703485706915516*^9, 3.703485820093699*^9}, {3.70348589132543*^9, 
   3.7034859168771343`*^9}, {3.703485961308949*^9, 3.703485979453567*^9}, {
   3.703486015752334*^9, 3.7034860801353807`*^9}, {3.7034861160844584`*^9, 
   3.7034861924527082`*^9}, {3.703486234622744*^9, 3.7034862835304747`*^9}, {
   3.703486319046224*^9, 3.7034864152666273`*^9}, {3.70348646755464*^9, 
   3.7034864942014103`*^9}, {3.7034865570764017`*^9, 
   3.7034865580579977`*^9}, {3.703487009376289*^9, 3.703487012230529*^9}, {
   3.7034906120075274`*^9, 3.703490666950856*^9}, {3.703490772675468*^9, 
   3.7034908061779547`*^9}, 3.703490883846033*^9, {3.703490945937525*^9, 
   3.703490972143693*^9}, 3.703491125145754*^9, {3.70349116791306*^9, 
   3.7034911731473503`*^9}, {3.7034912645515614`*^9, 3.703491269410746*^9}, {
   3.7034918808013897`*^9, 3.703491904560238*^9}, {3.703491972876707*^9, 
   3.703491977672883*^9}, {3.703492038336172*^9, 3.703492044787225*^9}, {
   3.703492950559244*^9, 3.703492963078898*^9}, {3.7037921205760508`*^9, 
   3.7037921682391148`*^9}, {3.703816979967037*^9, 3.703816997531898*^9}, {
   3.703817431352235*^9, 3.703817455664521*^9}, {3.703817994675737*^9, 
   3.7038180202701283`*^9}, {3.7038243139176292`*^9, 3.703824346450218*^9}, {
   3.703824422314323*^9, 3.7038244257548656`*^9}, {3.703824484681532*^9, 
   3.703824507534832*^9}, {3.703824555837049*^9, 3.7038245979050283`*^9}, {
   3.703824640355279*^9, 3.703824750764669*^9}, {3.703824985695075*^9, 
   3.7038250025186357`*^9}, {3.705297340669058*^9, 3.7052973479867773`*^9}, {
   3.705641191293248*^9, 3.705641194481386*^9}, {3.70564140572546*^9, 
   3.70564141478055*^9}, 3.70667952758817*^9, {3.706679728138695*^9, 
   3.706679767160454*^9}, {3.706679862447678*^9, 3.706679873981298*^9}, {
   3.70668006346471*^9, 3.7066800648182507`*^9}, {3.708405885402691*^9, 
   3.7084059245805473`*^9}, {3.713040946383614*^9, 3.713040947291451*^9}, {
   3.713050425051447*^9, 3.713050837948689*^9}, {3.713050907929318*^9, 
   3.713050916782485*^9}, {3.713100864933536*^9, 3.7131008775710573`*^9}, {
   3.713101035321125*^9, 3.7131010357316027`*^9}, {3.713101196313941*^9, 
   3.713101200622054*^9}, {3.7131012802824917`*^9, 3.713101294611589*^9}, {
   3.713101409382761*^9, 3.713101456351602*^9}, {3.713101555678117*^9, 
   3.713101562080645*^9}, {3.713101626167685*^9, 3.7131016295751457`*^9}, {
   3.713101793352305*^9, 3.713101913423128*^9}, {3.713103820960643*^9, 
   3.713103828892241*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"testnewindex", "[", 
  RowBox[{"[", "1", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.713103851169917*^9, 3.713103856173855*^9}, {
  3.713110594161643*^9, 3.7131105956326427`*^9}}],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"label\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\<\"x\"\>", ",", "\<\"Q\"\>", 
      ",", "\<\"expterror/exptcentral\"\>"}], "}"}]}], ",", 
   RowBox[{"\<\"data\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"LF", "[", 
       RowBox[{"0.101`", ",", "2.328`", ",", "0.12307749599672292`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.167`", ",", "2.994`", ",", "0.1138739627220494`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.326`", ",", "4.182`", ",", "0.12385814509785034`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.057`", ",", "2.295`", ",", "0.10000651744139734`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.101`", ",", "3.055`", ",", "0.09996515544542954`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.167`", ",", "3.928`", ",", "0.10009416906144834`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.326`", ",", "5.489`", ",", "0.11061499447702909`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.057`", ",", "2.698`", ",", "0.09651877539478189`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.101`", ",", "3.592`", ",", "0.10637424018399869`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.167`", ",", "4.618`", ",", "0.11862139695229505`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.326`", ",", "6.452`", ",", "0.13029449391538891`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.057`", ",", "2.457`", ",", "0.10464103698839383`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.101`", ",", "3.271`", ",", "0.09580011681091044`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.167`", ",", "4.206`", ",", "0.09895665640748678`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.326`", ",", "5.877`", ",", "0.10718195914848924`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.057`", ",", "3.225`", ",", "0.09830100484227615`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.101`", ",", "4.293`", ",", "0.10094658105514`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.167`", ",", "5.52`", ",", "0.10287199995823305`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.326`", ",", "7.712`", ",", "0.1189386760525247`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.021`", ",", "2.301`", ",", "0.09527867816394636`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.057`", ",", "3.791`", ",", "0.09033340156762788`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.101`", ",", "5.046`", ",", "0.10048529376608681`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.167`", ",", "6.488`", ",", "0.11440981985301246`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.326`", ",", "9.065`", ",", "0.13287380699893955`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.057`", ",", "2.925`", ",", "0.10805914295190057`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.101`", ",", "3.894`", ",", "0.1027687882056814`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.167`", ",", "5.007`", ",", "0.10252528727723112`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.326`", ",", "6.996`", ",", "0.11586599867451126`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.021`", ",", "2.33`", ",", "0.11761511919149457`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.057`", ",", "3.839`", ",", "0.11580560190578136`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.101`", ",", "5.11`", ",", "0.11221328136300311`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.167`", ",", "6.571`", ",", "0.11665839302177151`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.326`", ",", "9.181`", ",", "0.13103118104991465`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.021`", ",", "2.739`", ",", "0.11909889928604815`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.057`", ",", "4.512`", ",", "0.10322516916086331`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.101`", ",", "6.007`", ",", "0.10236181969324053`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.167`", ",", "7.724`", ",", "0.13012618695841938`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.326`", ",", "10.79`", ",", "0.16112565149703303`"}], 
       "]"}]}], "}"}]}], ",", 
   RowBox[{"\<\"exptinfo\"\>", "\[Rule]", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"\<\"exptid\"\>", "\[Rule]", "124"}], ",", 
      RowBox[{"\<\"exptname\"\>", "\[Rule]", "\<\"NuTvNuChXN\"\>"}], ",", 
      RowBox[{"\<\"feyndiagram\"\>", "\[Rule]", "\<\"unset\"\>"}]}], 
     "\[RightAssociation]"}]}], ",", 
   RowBox[{"\<\"PDFinfo\"\>", "\[Rule]", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"\<\"PDFname\"\>", "\[Rule]", "\<\"CT14HERA2NNLO\"\>"}], ",", 
      RowBox[{"\<\"PDFsetmethod\"\>", "\[Rule]", "\<\"Hessian\"\>"}], ",", 
      RowBox[{"\<\"Nset\"\>", "\[Rule]", "\<\"unset\"\>"}], ",", 
      RowBox[{"\<\"iset\"\>", "\[Rule]", "\<\"unset\"\>"}], ",", 
      RowBox[{"\<\"flavour\"\>", "\[Rule]", "\<\"unset\"\>"}]}], 
     "\[RightAssociation]"}]}], ",", 
   RowBox[{"\<\"rawdata\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "124", ",", "\<\"NuTvNuChXN\"\>", 
      ",", "\<\"     Q          x         y          Exp      Th./Norm     \
TotErr     EXP/FIT  ERR/FIT    ChiSq  Shift    ShiftedData  UnCorErr  \
ReducedChi2  lob/lio\"\>", ",", "1.`", ",", "38", 
      ",", "\<\"R^2, r(k) =    0.000  -0.017\"\>", ",", 
      RowBox[{"-", "2.27713`"}], 
      ",", "\<\"R^2, r(k) =    0.000  -0.017\"\>"}], "}"}]}]}], 
  "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{
  3.713107984416409*^9, 3.713109730005739*^9, {3.713110592193491*^9, 
   3.713110596340478*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["CorrDataDir"], "Input"],

Cell[BoxData["\<\"../quick_data/\"\>"], "Output",
 CellChangeTimes->{3.713109942516527*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Get", "[", "\"\<corr_proj_funcs.m\>\"", "]"}]], "Input",
 EmphasizeSyntaxErrors->True],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"present directory: \"\>", 
   "\[InvisibleSpace]", \
"\<\"/home/botingw/Downloads/Sean_20171114/xqplotter_user_func_debug/\
xqplotter-master/bin\"\>"}],
  SequenceForm[
  "present directory: ", 
   "/home/botingw/Downloads/Sean_20171114/xqplotter_user_func_debug/xqplotter-\
master/bin"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.719195464287657*^9, {3.719195515846785*^9, 3.719195524248579*^9}, 
   3.7191955811614113`*^9, 3.719207301926614*^9, 3.719214614283125*^9, 
   3.719220247836667*^9, 3.719220372859996*^9, 3.719220706184227*^9, 
   3.7192216041170197`*^9, 3.7192218011834993`*^9, {3.71922199897379*^9, 
   3.7192220165750427`*^9}, 3.719222179536129*^9, 3.7192223193848133`*^9, 
   3.71922265197404*^9, 3.719222861567883*^9, 3.719737683800893*^9, 
   3.719738006598235*^9, 3.719739106896452*^9, 3.719749857188211*^9, 
   3.719751056206092*^9, 3.7206317480549*^9, 3.72063207623596*^9, 
   3.7206326342268744`*^9, 3.720632699419353*^9, 3.720635546301261*^9, 
   3.7206359037891073`*^9, {3.720636259460347*^9, 3.7206362865757923`*^9}, 
   3.720636500938936*^9, 3.720636643229628*^9, 3.7206367164298677`*^9, 
   3.720636762595199*^9, 3.720637303310954*^9, 3.720719708009441*^9, 
   3.720719830839265*^9, 3.7207199065811996`*^9, 3.720720856080785*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"loading \"\>", 
   "\[InvisibleSpace]", "\<\"../lib/pdfParsePDS2013.m\"\>"}],
  SequenceForm["loading ", "../lib/pdfParsePDS2013.m"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.719195464287657*^9, {3.719195515846785*^9, 3.719195524248579*^9}, 
   3.7191955811614113`*^9, 3.719207301926614*^9, 3.719214614283125*^9, 
   3.719220247836667*^9, 3.719220372859996*^9, 3.719220706184227*^9, 
   3.7192216041170197`*^9, 3.7192218011834993`*^9, {3.71922199897379*^9, 
   3.7192220165750427`*^9}, 3.719222179536129*^9, 3.7192223193848133`*^9, 
   3.71922265197404*^9, 3.719222861567883*^9, 3.719737683800893*^9, 
   3.719738006598235*^9, 3.719739106896452*^9, 3.719749857188211*^9, 
   3.719751056206092*^9, 3.7206317480549*^9, 3.72063207623596*^9, 
   3.7206326342268744`*^9, 3.720632699419353*^9, 3.720635546301261*^9, 
   3.7206359037891073`*^9, {3.720636259460347*^9, 3.7206362865757923`*^9}, 
   3.720636500938936*^9, 3.720636643229628*^9, 3.7206367164298677`*^9, 
   3.720636762595199*^9, 3.720637303310954*^9, 3.720719708009441*^9, 
   3.720719830839265*^9, 3.7207199065811996`*^9, 3.72072085609725*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"loading \"\>", 
   "\[InvisibleSpace]", "\<\"../lib/dtareadbotingw2016.m\"\>"}],
  SequenceForm["loading ", "../lib/dtareadbotingw2016.m"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.719195464287657*^9, {3.719195515846785*^9, 3.719195524248579*^9}, 
   3.7191955811614113`*^9, 3.719207301926614*^9, 3.719214614283125*^9, 
   3.719220247836667*^9, 3.719220372859996*^9, 3.719220706184227*^9, 
   3.7192216041170197`*^9, 3.7192218011834993`*^9, {3.71922199897379*^9, 
   3.7192220165750427`*^9}, 3.719222179536129*^9, 3.7192223193848133`*^9, 
   3.71922265197404*^9, 3.719222861567883*^9, 3.719737683800893*^9, 
   3.719738006598235*^9, 3.719739106896452*^9, 3.719749857188211*^9, 
   3.719751056206092*^9, 3.7206317480549*^9, 3.72063207623596*^9, 
   3.7206326342268744`*^9, 3.720632699419353*^9, 3.720635546301261*^9, 
   3.7206359037891073`*^9, {3.720636259460347*^9, 3.7206362865757923`*^9}, 
   3.720636500938936*^9, 3.720636643229628*^9, 3.7206367164298677`*^9, 
   3.720636762595199*^9, 3.720637303310954*^9, 3.720719708009441*^9, 
   3.720719830839265*^9, 3.7207199065811996`*^9, 3.720720856110736*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"processdataplotsmultiexp7percentage", "[", 
  RowBox[{
   RowBox[{"{", "expterrordataclassfinal", "}"}], ",", 
   RowBox[{"readcorrconfigfile6", "[", 
    RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "2", ",", 
   "flavour"}], "]"}]], "Input",
 CellChangeTimes->{{3.71919551174898*^9, 3.719195511877761*^9}, {
  3.719220702618123*^9, 3.7192207100139933`*^9}, {3.721143574801838*^9, 
  3.7211435749543657`*^9}}],

Cell[BoxData["\<\"making table of experiments included in plots\"\>"], "Print",
 CellChangeTimes->{
  3.719195583767926*^9, 3.7192146164394283`*^9, 3.719220374995569*^9, 
   3.719220711692421*^9, 3.7192216066130733`*^9, 3.719221803186294*^9, {
   3.7192220008563433`*^9, 3.719222019063471*^9}, 3.719222181578391*^9, 
   3.719222321320393*^9, 3.719222654232679*^9, {3.71922284636096*^9, 
   3.719222863983947*^9}, 3.719737686485701*^9, 3.719738008944006*^9, 
   3.7197390774488497`*^9, 3.71973910920641*^9, 3.719739226763857*^9, 
   3.719749860267557*^9, 3.719750950337542*^9, 3.719751058481391*^9, 
   3.72063145271108*^9, 3.720631758422649*^9, 3.720632079259794*^9, 
   3.720632636381469*^9, 3.720632701624323*^9, 3.7206355487384853`*^9, 
   3.720635905942521*^9, 3.7206366452614937`*^9, 3.7206373065172243`*^9, 
   3.720719373408517*^9, 3.720719426639636*^9, 3.7207194970512257`*^9, 
   3.720719711399683*^9, 3.720719832770178*^9, 3.720719908588035*^9, 
   3.72072001136694*^9, 3.7207203506327553`*^9, 3.720720859279674*^9, {
   3.7211435702040033`*^9, 3.721143575941353*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     TagBox[
      GraphicsBox[{InsetBox[
         GraphicsBox[{{{{}, {{}, 
              {GrayLevel[1], PointSize[0.012833333333333334`], 
               AbsoluteThickness[1.6], 
               StyleBox[PointBox[{{0.00001, 2.}, {0.99, 1200.}}],
                FontFamily->"Helvetica"]}, {}}, {}, {}, {{}, {}}}, {
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {26.659279813908125, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-35.34072018609188, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {25.659279813908125, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-34.34072018609188, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {27.659279813908125, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-36.34072018609188, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {28.659279813908125, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[EmptySquare]\"\>", {-37.34072018609188, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {24.659279813908125, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-33.34072018609188, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {29.659279813908125, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-38.34072018609188, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {30.659279813908125, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-39.34072018609188, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {31.659279813908125, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-40.34072018609188, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[EmptySquare]\"\>", 
                {32.65927981390812, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-41.34072018609188, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {33.65927981390812, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-42.34072018609188, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {44.53322436230242, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-53.46677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {55.53322436230242, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-64.46677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {54.53322436230242, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-63.46677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {45.53322436230242, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-54.46677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {34.65927981390812, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-43.34072018609188, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {43.53322436230242, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-52.46677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {46.53322436230242, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-55.46677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {56.53322436230242, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-65.46677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {47.53322436230242, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-56.46677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {57.53322436230242, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-66.46677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {42.53322436230242, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-51.46677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {53.53322436230242, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-62.46677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {51.53322436230242, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-60.46677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {49.53322436230242, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-58.46677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {50.53322436230242, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-59.46677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {58.53322436230242, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-67.46677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {60.53322436230242, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-69.46677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {61.53322436230242, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-70.46677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {62.53322436230242, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-71.46677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {48.53322436230242, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-57.46677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {59.53322436230242, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-68.46677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[EmptySquare]\"\>", {52.53322436230242, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-61.46677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 0.7476353658440151}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {63.53322436230242, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-72.46677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 0.9658425107034028}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {35.65927981390812, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[EmptySquare]\"\>", {-44.34072018609188, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.4967170423699816}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.4003070303221032, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.800307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.4967170423699816}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.6888794541139363, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 0.9666035457477442}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.4967170423699816}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 0.848868055556721}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 0.9658425107034028}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.6003070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.600307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.6888794541139363, 0.9673640020581556}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 1.2184672504763885}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 0.7466879474879751}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 1.3480731482996928}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.4967170423699816}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 0.7499999921527281}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 0.9666035457477442}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 0.849723487602042}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.6888794541139363, 0.8505781885087738}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.4967170423699816}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 1.094604267270571}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 0.9673640020581556}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 0.849723487602042}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.9003070303221032, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.300307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.045554398052668, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.382026634673881, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 0.9673640020581556}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.491779868965868}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.3504080825554816}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.0942695392339727}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.4886252922173524}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 0.9658425107034028}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.6888794541139363, 1.0942695392339727}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 1.2190584417439767}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.348592493935879}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.0935997468445653}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 0.848868055556721}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 1.4967170423699816}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.2166915767337108}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.3003070303221036, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.900307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.045554398052668, 0.9604989865384754}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 0.849723487602042}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.5003070303221033, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.7003070303221035, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.1003070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.100307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 0.9707789171582248}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 1.0962762288705619}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.9003070303221032, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.300307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.4913298239537713}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.6395790693460872}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7003070303221035, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.500307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.0942695392339727}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 1.4772770088317615}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.5340676054093236}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.349630376748299}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 0.848868055556721}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.4915548717773834}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.5340676054093236}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.094604267270571}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.100307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.100307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.8947332418642159, 1.7316555451583497}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.9567332418642156, 1.7316555451583497}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.4913298239537713}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.2158025560795132}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 0.8514321595256585}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.094604267270571}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.4913298239537713}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.9334277163102163, 1.8389610707123492}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.7034277163102165, 1.8389610707123492}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.300307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.900307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.0942695392339727}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.500307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.7003070303221035, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.4913298239537713}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7901109564601341, 1.6272778305624314}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.270110956460134, 1.6272778305624314}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.640548907459153}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.5340676054093236}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 1.4967170423699816}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.64113035916659}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.5340676054093236}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.9735293151671945, 1.9198594718553708}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.5015293151671947, 1.9198594718553708}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.2181715237257489}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.045554398052668, 0.8514321595256585}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.382026634673881, 0.8441500540964727}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {19.659279813908125, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-28.340720186091875, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.227214785969269}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.6409365794934714}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {21.659279813908125, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-30.340720186091875, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.5340676054093236}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.6358850824489488}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.4913298239537713}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 1.3321021320364639}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 0.9658425107034028}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4917756376975806, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-6.441775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {20.659279813908125, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-29.340720186091875, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {22.659279813908125, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-31.340720186091875, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {18.659279813908125, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-27.340720186091875, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.6389967146756448}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0275338341178306, 1.9768549529047348}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.333533834117831, 1.9768549529047348}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.349630376748299}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.095273387402595}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 0.849723487602042}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.6304163188192922}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.640548907459153}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.007592890280941}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.7417756376975806, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-6.191775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 0.965080896043587}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.7828868907244566}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.783559272662715}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.227214785969269}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.7840632625935846}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {37.65927981390812, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-46.34072018609188, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.9667756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.966775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.5340676054093236}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.082841223761632, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.188841223761632, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.227214785969269}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {38.65927981390812, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-47.34072018609188, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.9753070303221036, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.225307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.166775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.766775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3667756376975806, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.566775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.7253070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.475307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.2253070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.975307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.9753070303221036, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.225307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {39.65927981390812, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-48.34072018609188, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 0.849723487602042}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.227214785969269}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.2253070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.975307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.2253070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.975307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {36.65927981390812, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-45.34072018609188, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.227214785969269}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.4920048155420047}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.4753070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.725307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.4967170423699816}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.7253070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.475307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.5340676054093236}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5362515787163986, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.4122515787164, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.8503070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.350307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.7667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.16677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {23.659279813908125, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-32.34072018609188, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.4753070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.725307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2167756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledDiamond]\"\>", 
                {-6.716775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.4122515787163992, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.536251578716398, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.9753070303221036, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.225307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.0935997468445653}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.2862515787163986, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.662251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.7837272975307907}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.662251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.286251578716398, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.7862515787163986, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.1622515787164, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.2253070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.975307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.5340676054093236}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.64113035916659}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.9667756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.966775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.3504080825554816}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.926290362185661}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.4753070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.725307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.227214785969269}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.5340676054093236}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.2253070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.975307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.5667756376975808, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.366775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.4753070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.725307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.0362515787163986, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.912251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[Times]\"\>", {-1.9122515787163992, 4.512945241945574}]
                ,
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.036251578716398, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1197926521647825, 2.065596134857783}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.0637926521647825, 2.065596134857783}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.1622515787163992, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.786251578716398, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.8503070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.350307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.5340676054093236}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.9245405804618736}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.893934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.493934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.4753070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.725307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.9245405804618736}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.5340676054093236}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.5340676054093236}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.4938099618846934, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.8938099618846933, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.036251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.912251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6938099618846936, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.6938099618846936, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.366775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.566775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.7822140563845235}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.9251241812954787}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.9122515787163991, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.0362515787164, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5780906770930101, 1.5432981099295553}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.65009067709301, 1.5432981099295553}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.5340676054093236}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.293809961884693, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.093809961884693, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.16677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.766775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.659260036932778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.5340676054093236}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.5340676054093236}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7167756376975808, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.21677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.007592890280941}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.5362515787163986, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.4122515787164, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.773934884315503}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.662251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.286251578716398, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7167756376975808, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.21677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.7862515787163986, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.1622515787164, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.4122515787163992, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.536251578716398, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.931632482576383, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316324825763833, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.931632482576383, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316324825763833, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.8417756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.091775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.8417756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.091775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.5917756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.341775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324035882469876, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132403588246988, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324035882469876, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132403588246988, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111425593016979, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.611425593016979, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111425593016979, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.611425593016979, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.7253070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.475307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6042429605294894, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1042429605294894, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8467330387898968, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346733038789897, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyDiamond]\"\>", 
                {-1.8467330387898968, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346733038789897, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.659260036932778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.931632482576383, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316324825763833, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.018874035651734, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.518874035651734, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743197990830097, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6743197990830097, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324035882469876, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132403588246988, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743197990830097, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6743197990830097, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.018874035651734, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.518874035651734, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743197990830097, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6743197990830097, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111425593016979, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.611425593016979, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {40.65927981390812, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-49.34072018609188, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7620499515598584, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262049951559858, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6042429605294894, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1042429605294894, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.196377287787253, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8467330387898968, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346733038789897, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.3417756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.591775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.7862515787163987, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.162251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.751635164117833, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251635164117833, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743197990830097, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6743197990830097, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.751635164117833, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251635164117833, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5168907011251433, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.0168907011251433, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5168907011251433, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.0168907011251433, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.162251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.786251578716398, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.7847348542910906}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.018874035651734, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.518874035651734, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7620499515598584, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262049951559858, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.924832423452417}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1279291781552085, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9519291781552084, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.751635164117833, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251635164117833, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5168907011251433, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.0168907011251433, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2862515787163986, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.662251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324035882469876, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132403588246988, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020169119255751, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520169119255751, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020169119255751, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520169119255751, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.083934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.303934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.5340676054093236}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111425593016979, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.611425593016979, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.659260036932778, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.9122515787163992, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.036251578716398, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820072438863218, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.182007243886322, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1227139907010775, 2.182674796321488}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.8267139907010774, 2.182674796321488}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.5340676054093236}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5270116125934994, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0270116125934994, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820072438863218, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.182007243886322, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.409260036932778, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.909260036932778, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020169119255751, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520169119255751, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743197990830097, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6743197990830097, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.751635164117833, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251635164117833, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.409260036932778, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.909260036932778, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2787201860918764, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.402720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7620499515598584, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262049951559858, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.4027201860918759, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.278720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.931632482576383, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316324825763833, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.659260036932778, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.5287201860918762, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.152720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.036251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-6.912251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.751635164117833, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251635164117833, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.409260036932778, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.909260036932778, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5168907011251433, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.0168907011251433, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324035882469876, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132403588246988, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6064531542733356, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.106453154273336, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6064531542733356, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.106453154273336, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6064531542733356, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.106453154273336, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.227214785969269}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5270116125934994, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0270116125934994, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.1527201860918759, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.528720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.6527201860918759, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.028720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047161811815076, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.8047161811815076, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743197990830097, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6743197990830097, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020169119255751, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520169119255751, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.8800803260850696, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.3800803260850696, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.751635164117833, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251635164117833, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.8800803260850696, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.3800803260850696, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.2917089186300228}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.018874035651734, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.518874035651734, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.5917756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.341775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.1622515787163992, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.786251578716398, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0917756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.841775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.8800803260850696, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.3800803260850696, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6064531542733356, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.106453154273336, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047161811815076, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.8047161811815076, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.3003070303221036, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.900307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.5003070303221033, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.7003070303221035, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.3417756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.591775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.1003070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.100307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0287201860918764, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.652720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.7787201860918762, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.902720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0917756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.841775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.5003070303221033, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.7003070303221035, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.500307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.7003070303221035, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020169119255751, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520169119255751, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047161811815076, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.8047161811815076, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.9003070303221032, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.300307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0917756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.841775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.3003070303221036, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.900307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 2.075684492802124}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.9003070303221032, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.300307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.500307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.7003070303221035, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.100307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.100307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820072438863218, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.182007243886322, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.1003070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.100307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6042429605294894, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1042429605294894, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7003070303221035, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.500307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.3417756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.591775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7003070303221035, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.500307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.452179964132715, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.952179964132715, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.6003070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.600307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.409260036932778, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.909260036932778, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5168907011251433, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.0168907011251433, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4797014486341915, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797014486341915, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6064531542733356, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.106453154273336, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4797014486341915, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797014486341915, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4797014486341915, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797014486341915, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.9003070303221032, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.300307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8467330387898968, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346733038789897, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.162251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-6.786251578716398, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.300307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.900307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.100307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.100307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.9027201860918759, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.778720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.4913298239537713}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.5340676054093236}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.9003070303221032, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.300307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.3417756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.591775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.300307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.900307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.6003070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.600307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6064531542733356, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.106453154273336, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.206735772821304, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706735772821304, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.8800803260850696, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.3800803260850696, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.206735772821304, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706735772821304, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751462948262976, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.2514629482629758, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751462948262976, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.2514629482629758, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.1603343472961065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324035882469876, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132403588246988, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.227214785969269}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.227214785969269}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0938099618846935, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.293809961884693, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.227214785969269}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.227214785969269}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.191191469961203}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.4122057429043917}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.206735772821304, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706735772821304, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751462948262976, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.2514629482629758, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.4226262903672808}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.452179964132715, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.952179964132715, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.902720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.778720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.927891643552635}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111425593016979, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.611425593016979, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.2809338454620642}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.2140221401789375}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.322289031143978}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.3358072689741225, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.835807268974122, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020169119255751, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520169119255751, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.3358072689741225, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.835807268974122, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4797014486341915, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797014486341915, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.3358072689741225, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.835807268974122, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0362515787163986, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.912251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.64113035916659}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.662251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.2862515787164, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047161811815076, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.8047161811815076, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 1.4967170423699816}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 2.073423469354273}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0917756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.841775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4797014486341915, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797014486341915, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.8800803260850696, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.3800803260850696, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.0289048762432895}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.303934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.0839343632035074, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.1499389158334503}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.227214785969269}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.703934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.683934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.409260036932778, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.909260036932778, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.286251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.662251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7787201860918762, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.902720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.5432981099295553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3796406197516198, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8796406197516198, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751462948262976, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.2514629482629758, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.3358072689741225, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.835807268974122, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.0598714603516792}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0287201860918764, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.652720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4797014486341915, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797014486341915, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.483934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.9039343632035077, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 2.075308010398229}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.35030703032210353, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.850307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.5539252025038417}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 2.28401370740861}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.286251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-6.662251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.4534856106602139}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5270116125934994, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0270116125934994, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8938099618846933, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.4938099618846934, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.8800803260850696, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.3800803260850696, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.5340676054093236}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.9122515787163991, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.0362515787164, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1025055612125312, 2.2648832258100344}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.682505561212531, 2.2648832258100344}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5168907011251433, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.0168907011251433, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.018486244188825}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.5340676054093236}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7620499515598584, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262049951559858, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.206735772821304, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706735772821304, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.6744763086133228}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.4003070303221032, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.800307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 1.6384140206706175}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.4003070303221032, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.800307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.3358072689741225, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.835807268974122, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.152720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.528720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.3358072689741225, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.835807268974122, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 0.898534010284896}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.5432981099295553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.018874035651734, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.518874035651734, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751462948262976, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.2514629482629758, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {41.65927981390812, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-50.34072018609188, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.4122057429043917}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.785741396902492}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 2.0766877534832147}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.6527201860918759, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.028720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047161811815076, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.8047161811815076, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.8177545102789887, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.3177545102789887, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.4017756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.531775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.2567756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.676775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.836775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.09677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.2167756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.71677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.4017756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.531775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.902704363179782}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.9417756376975808, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[Times]\"\>", {-4.991775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3796406197516198, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8796406197516198, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.151775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.781775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.621775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.311775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.3407201860918763, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.340720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 0.9290095042819297}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.621775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.311775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.196377287787253, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.5362515787163987, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.412251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.740720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.940720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.521775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.4117756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.731775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.201775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.2567756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.676775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.140720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.540720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.126775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.806775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.940720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.740720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.35030703032210353, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.850307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.322289031143978}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.9417756376975808, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.991775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.361775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.571775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.6744763086133228}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.68510181635509}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.836775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.09677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.017754510278989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.1177545102789885, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.0177545102789884, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.1177545102789885, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.6939343632035078, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.6939343632035078, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.4017756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.531775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.621775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.311775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.151775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.781775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.361775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.571775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.0654001544619962}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.731775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.201775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.227214785969269}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.521775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.4117756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.2809338454620642}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.5845302767279155}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 2.2927367569392314}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.8056623743970464}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.126775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.806775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.1966460289394751}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.540720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.140720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.5340676054093236}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.917754510278989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.2177545102789886, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.227214785969269}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7862515787163987, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.162251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.836775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.09677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 2.647592232065096}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.126775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.806775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.35030703032210353, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.850307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.4753070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.725307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.2567756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.676775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 0.9345235001352147}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.227214785969269}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.4226262903672808}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751462948262976, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.2514629482629758, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.021775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.9117756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3079303552881687, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8079303552881685, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.9267273296385394}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.8177545102789887, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.317754510278989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 2.253709925211909}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.295731171742312, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.041731171742312, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.717754510278989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.417754510278989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.3281354469463584}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.6177545102789885, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.5177545102789884, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.021775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.9117756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0677442045680727, 2.3456445824544927}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.5557442045680727, 2.3456445824544927}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.0281898243715637}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.3177545102789887, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.8177545102789887, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.2167756376975807, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.71677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.117754510278989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.017754510278989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9517395362418175, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7957395362418174, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.617754510278989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.517754510278989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.4534856106602139}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.7177545102789888, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.417754510278988, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.417754510278989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.7177545102789886, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 0.766397642299538}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 0.8028980445190645}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.191191469961203}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.8056623743970464}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.1499389158334503}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.9177545102789888, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.217754510278989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5177545102789884, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.617754510278989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.2917089186300228}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.227214785969269}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9316022156830935, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.657602215683094, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.825050624991675, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.761050624991675, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 0.8977193462887197}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7447395362418174, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0027395362418177, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7310506249916748, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8550506249916747, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.409260036932778, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.909260036932778, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.5539252025038417}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.5845302767279155}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5287201860918762, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.152720186091877, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1534763793552227, 1.4906543764441336}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1794763793552225, 1.4906543764441336}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0644216224248022, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.686421622424802, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 0.7975071958841882}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 2.647592232065096}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.1597073880279205}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.2177545102789886, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.917754510278989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.206735772821304, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706735772821304, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.9368694044031642}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.8162894669713328}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.140720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.540720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8819167234078878, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.415916723407888, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 0.766397642299538}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.010828981280643, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.4288289812806427, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.0598714603516792}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9058289812806428, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.5338289812806427, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.931632482576383, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316324825763833, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.3492515787163989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.5992515787164, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.5340676054093236}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0202266596212073, 1.4929040961781488}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.308226659621207, 1.4929040961781488}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820072438863218, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.182007243886322, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.4590800308455383}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6547395362418175, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0927395362418175, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.715777948205427}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9715151471242033, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.951515147124203, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.120743179218757, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9947431792187573, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.68510181635509}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6666819660425423, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.2526819660425423, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.144222799920162}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.2667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.666775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 2.0759354023505483}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9957431792187569, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.119743179218757, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.5177545102789887, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.6177545102789885, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.452179964132715, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.952179964132715, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4938099618846934, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.893809961884693, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8058289812806427, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.633828981280643, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4117654245995248, 1.5973653311998313}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7077654245995246, 1.5973653311998313}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7143890962226553, 1.9387416595767009}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7223890962226553, 1.9387416595767009}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.7409075149860491, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.240907514986049, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111425593016979, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.611425593016979, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.995732273553991, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.5340676054093236}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0380506249916748, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.548050624991675, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.7409075149860491, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.240907514986049, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 1.9254158540407285}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.2908841763152323}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111425593016979, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.611425593016979, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6644114819959424, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164411481995942, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6644114819959424, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164411481995942, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.931632482576383, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316324825763833, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.018874035651734, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.518874035651734, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.2756420910162956}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.227214785969269}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.9368694044031642}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.018874035651734, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.518874035651734, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8467330387898968, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346733038789897, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6416022156830935, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9476022156830934, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.1603343472961065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 0.8055826098897335}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8192083653998068, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3192083653998066, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7832599069543554, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.5172599069543553, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8192083653998068, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3192083653998066, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.931632482576383, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316324825763833, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7797109156908187, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.3277109156908184, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2647917677447573, 1.5953389880545987}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8587917677447576, 1.5953389880545987}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047161811815076, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.8047161811815076, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8992510730733434, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3992510730733434, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047161811815076, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.8047161811815076, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.4177545102789888, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.717754510278988, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.412251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-6.536251578716398, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.995732273553991, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8992510730733434, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3992510730733434, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.9809291040876105, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809291040876102, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.206735772821304, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706735772821304, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.206735772821304, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706735772821304, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.409260036932778, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.909260036932778, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 0.9364854391596744}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7620499515598584, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262049951559858, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.995732273553991, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7626819660425422, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1566819660425423, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8467330387898968, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346733038789897, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5897499532269226, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0897499532269226, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.5377270648801}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.409260036932778, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.909260036932778, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.2787201860918764, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.402720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0640794724197806, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640794724197806, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.406587064387653}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5897499532269226, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0897499532269226, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1213890962226554, 1.9387416595767009}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3153890962226553, 1.9387416595767009}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6268289812806428, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8128289812806426, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.521775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.4117756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.214608098422191, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6969167234078879, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6009167234078876, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5168907011251433, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.0168907011251433, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820072438863218, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.182007243886322, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 2.647592232065096}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5168907011251433, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.0168907011251433, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.0654001544619962}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5560506249916749, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.030050624991675, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3079303552881687, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8079303552881685, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1484668646973284, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.648466864697328, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.571283042360924, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7620499515598584, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262049951559858, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 2.647592232065096}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.9809291040876105, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809291040876102, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5169274935268733, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.016927493526873, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0602174805403115, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.1102174805403116, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1525014380048455, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.4305014380048457, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 2.647592232065096}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9846048970696881, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3186048970696884, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.662251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.2862515787164, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.8002235476401844}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.715777948205427}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6042429605294894, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1042429605294894, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8038099618846937, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.583809961884693, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324035882469876, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132403588246988, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.669026703845758}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8584777201525995, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3144777201525994, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820072438863218, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.182007243886322, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.3177545102789887, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.817754510278989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.1966460289394751}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324035882469876, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132403588246988, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.878743179218757, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.2367431792187573, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.5902550930173265}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 2.296667619230008}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2738099618846935, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-6.1138099618846935, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0640794724197806, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640794724197806, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.2406373244969853, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7406373244969853, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.9474803442248305}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.1308988302963465, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5169274935268733, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.016927493526873, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9542174805403115, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.216217480540312, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2177545102789886, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.917754510278989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5270116125934994, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0270116125934994, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6042429605294894, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1042429605294894, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.1177545102789888, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.017754510278989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 1.0678093795130645}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.8162894669713328}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9291484471914904, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.11914844719149, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.408776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.808776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.719319793360441}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111425593016979, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.611425593016979, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.018486244188825}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 0.9345235001352147}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7461484471914903, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3021484471914904, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.744604469176456, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 2.0680013515372804}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8999819897673833, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.423981989767383, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0338000182722134, 2.418588768750352}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.4438000182722135, 2.418588768750352}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.227214785969269}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.018874035651734, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.518874035651734, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.607650686531799, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 0.9290095042819297}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5826819660425423, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.3366819660425424, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334569144331189, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834569144331189, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1484668646973284, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.648466864697328, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047161811815076, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.8047161811815076, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.931632482576383, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316324825763833, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.452179964132715, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.952179964132715, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.445929943787544, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.945929943787544, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7649588271331155, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.4029588271331153, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.409260036932778, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.909260036932778, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 2.414126467726953}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.9313764735639716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.206735772821304, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706735772821304, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.227214785969269}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 0.8028980445190645}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5270116125934994, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0270116125934994, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8343339837855921, 2.131796772013764}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.2163339837855918, 2.131796772013764}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5704216224248023, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1804216224248023, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751462948262976, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.2514629482629758, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.227214785969269}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6307311717423119, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.706731171742312, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751462948262976, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.2514629482629758, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.3281354469463584}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4307829160924542, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.4590800308455383}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6407201860918759, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.040720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.227214785969269}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5168907011251433, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.0168907011251433, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8467330387898968, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346733038789897, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6538099618846934, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-5.733809961884694, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3796406197516198, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8796406197516198, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.0289048762432895}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.230191621853512, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.700191621853512, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0943516949315049, 1.6937790608678513}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.832351694931505, 1.6937790608678513}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.893934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.493934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4298793241355137, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9298793241355137, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8440602747220977, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.900060274722098, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.8503070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.350307030322103, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.2406373244969853, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7406373244969853, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.445929943787544, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.945929943787544, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0889167234078876, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.208916723407888, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5472709425975442, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.895270942597544, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6787431792187568, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.436743179218757, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.021775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.9117756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.452179964132715, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.952179964132715, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.213776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.003776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.101092789211817, 0.7802418874108791}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7620499515598584, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262049951559858, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324035882469876, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132403588246988, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.2667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-6.666775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.600902459542082, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2025753415836864, 2.0095554142156695}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0925753415836867, 2.0095554142156695}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334569144331189, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834569144331189, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6792174805403116, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.491217480540312, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0177545102789889, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.1177545102789885, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.8002235476401844}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3079303552881687, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8079303552881685, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7909819897673834, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.5329819897673835, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.4219027885872582}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.991464547107982, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.8800803260850696, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.3800803260850696, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.669026703845758}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.0281898243715637}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6126048970696883, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6906048970696883, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.412251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.536251578716398, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.8800803260850696, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.3800803260850696, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.298317366548036, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.16677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.49106027472209773, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.2530602747220976, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 1.1990607599649155}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3767294095441613, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8767294095441613, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1867395362418174, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.5607395362418175, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.7409075149860491, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.240907514986049, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3796406197516198, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8796406197516198, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820072438863218, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.182007243886322, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.53523983979334, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.03523983979334, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.1308988302963465, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.1308988302963465, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.16677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.5377270648801}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8192083653998068, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3192083653998066, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6644114819959424, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164411481995942, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.032286541628237, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.238485302016438, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7384853020164377, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1407201860918759, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.540720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.2030071867437115, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1301484471914902, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9181484471914902, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4307829160924542, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4298793241355137, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9298793241355137, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.9417756376975808, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.991775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.2667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-6.666775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5992174805403118, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.5712174805403114, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 2.0624225365102413}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.238485302016438, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7384853020164377, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.9177545102789888, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.217754510278989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.406587064387653}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751462948262976, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.2514629482629758, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.151775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.781775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6042429605294894, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1042429605294894, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.40272018609187604, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.278720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3767294095441613, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8767294095441613, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.731775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.201775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.9313764735639716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.5902550930173265}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6621484471914904, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3861484471914904, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.740720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.940720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.8470364847178946}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3079303552881687, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8079303552881685, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4816022156830936, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1076022156830936, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.8470364847178946}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020169119255751, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520169119255751, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 2.647592232065096}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 0.898534010284896}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8992510730733434, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3992510730733434, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0301484471914903, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0181484471914906, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.3754861624032872}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 0.8977193462887197}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.53523983979334, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.03523983979334, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0052369104845442, 2.498151876538021}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.3132369104845443, 2.498151876538021}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1682174805403114, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0022174805403115, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020169119255751, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520169119255751, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.600902459542082, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5897499532269226, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0897499532269226, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 2.0680013515372804}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.6167765548632014, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.600776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4307829160924542, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 2.075809955445786}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.9474803442248305}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.47282898128064277, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.966828981280643, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6939819897673835, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.629981989767383, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.45995169862006674, 2.004179057179289}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.845951698620067, 2.004179057179289}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1699988878712817, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6699988878712817, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5270116125934994, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0270116125934994, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.16677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3092881287486289, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8092881287486289, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5015151471242032, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.4215151471242033, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.642660088414177, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1426600884141767, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.9809291040876105, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809291040876102, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 2.1992225799988927}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.140720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-6.540720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.1597073880279205}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.5067405141957577}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.238485302016438, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7384853020164377, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.642660088414177, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1426600884141767, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5212174805403116, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6492174805403117, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 0.8055826098897335}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 2.078566158643882}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.8800803260850696, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.3800803260850696, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5342599069543554, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7662599069543554, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5079643144302738, 2.134166441369082}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.5379643144302735, 2.134166441369082}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3092881287486289, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8092881287486289, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5169274935268733, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.016927493526873, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 2.0624225365102413}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.452179964132715, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.952179964132715, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.66677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.0678093795130645}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.721515815839451}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.7693434299437227}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0640794724197806, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640794724197806, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4307829160924542, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.102583303777579, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.602583303777579, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.763023770664052, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263023770664052, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 2.193662685769859}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0938099618846935, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.293809961884693, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 0.766397642299538}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.111728083308073, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.900464386136271}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.763023770664052, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263023770664052, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.2908841763152323}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.3524072174927233, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.031563461435372}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.638025369286013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1484668646973284, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.648466864697328, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1699988878712817, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6699988878712817, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047161811815076, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.8047161811815076, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.1627481478062465}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 0.9364854391596744}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2435614550482985, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.7435614550482983, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.995732273553991, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.900464386136271}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.2756420910162956}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2369512814530277, 1.9401794743463283}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.196951281453028, 1.9401794743463283}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3796406197516198, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8796406197516198, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.047189562170502, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.456731171742312, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.880731171742312, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.1627481478062465}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.886637726631229, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.3866377266312284, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.031563461435372}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.2406373244969853, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7406373244969853, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5917109156908188, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.5157109156908186, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 0.7975071958841882}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0363197520242107, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5363197520242107, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.8177545102789887, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.317754510278989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.445929943787544, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.945929943787544, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020169119255751, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520169119255751, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.3428059215206005, 2.6490076604684267}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.3754861624032872}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 2.193662685769859}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.361775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.571775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.7693434299437227}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.571283042360924, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.227214785969269}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 2.2976730486330252}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.293947899598382}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.600902459542082, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5828222252951392, 1.5933085305042167}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.5448222252951394, 1.5933085305042167}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5821484471914904, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.4661484471914905, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.5067405141957577}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.166775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.102583303777579, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.602583303777579, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.638025369286013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.721515815839451}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.4219027885872582}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0126784475265938, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.5126784475265938, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.886637726631229, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.3866377266312284, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2435614550482985, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.7435614550482983, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.1990607599649155}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.369191621853512, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.5611916218535122, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3079303552881687, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8079303552881685, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324035882469876, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132403588246988, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.719319793360441}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 1.3302529702362658}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.605170185988091, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5067250150625199, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.60472501506252, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334569144331189, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834569144331189, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5168907011251433, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.0168907011251433, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2789588271331154, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8889588271331152, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.179500146995422, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.679500146995422, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.409260036932778, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.909260036932778, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.144222799920162}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.502290170873972, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.5532907518110994}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9712643014359971, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.471264301435997, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 2.078566158643882}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 2.3243465847755584}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3796406197516198, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8796406197516198, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.293947899598382}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.66677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.214608098422191, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.3524072174927233, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751462948262976, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.2514629482629758, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047161811815076, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.8047161811815076, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.710818829244043, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1108188292440433, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8200181212090352, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2200181212090353, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6123787564307905, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0123787564307904, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2361484471914903, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8121484471914904, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4298793241355137, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9298793241355137, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 0.7802418874108791}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3767294095441613, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8767294095441613, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.424802725718295}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4945957207744072, 5.886104031450156}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.894595720774407, 5.886104031450156}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9000608288825716, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3000608288825717, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0363197520242107, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5363197520242107, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.3326298365341978}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.227214785969269}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.744604469176456, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.560886452648562, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.6608864526485623, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.238485302016438, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7384853020164377, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3254849243813491, 1.776645831418007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.4354849243813494, 1.776645831418007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.238485302016438, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7384853020164377, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.8800803260850696, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.3800803260850696, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3892352051165808, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.789235205116581, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9870722058722012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3870722058722014, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7177545102789886, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.417754510278988, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.2030071867437115, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.101092789211817, 0.911479174876933}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.310886452648562, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.9108864526485623, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.206735772821304, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706735772821304, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 2.330200260027019}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111425593016979, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.611425593016979, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.6177545102789884, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.517754510278989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0126784475265938, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.5126784475265938, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1569280563711404, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569280563711404, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.179500146995422, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.679500146995422, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 2.1992225799988927}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.53523983979334, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.03523983979334, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2939250253122558, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.693925025312256, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4492174805403117, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7212174805403113, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.199705077879927, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0823823856765262, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.482382385676526, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.584776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.632776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.1308988302963465, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.1687119638680197, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.7687119638680198, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.424802725718295}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2069136483226262, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6069136483226263, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1148124723039907, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6148124723039907, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.906544110754825, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4065441107548249, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4187119638680197, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.5187119638680198, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6005077093724622, 1.4996230464268938}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.714507709372462, 1.4996230464268938}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.710818829244043, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1108188292440433, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8200181212090352, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2200181212090353, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020169119255751, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520169119255751, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1877429013343526, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5877429013343525, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8639343632035077, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-4.523934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.8526977673331346}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.863232841258714, 0.8333438110532289}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4170602747220977, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.327060274722098, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.018874035651734, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.518874035651734, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.1850957485562468}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9870722058722012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3870722058722014, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.6888794541139363, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6123787564307905, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0123787564307904, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9000608288825716, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3000608288825717, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 0.9925107577855641}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.642660088414177, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1426600884141767, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.984131361875511, 7.003065458786462}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6042429605294894, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1042429605294894, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.0232043801967814, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.6232043801967815, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1699988878712817, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6699988878712817, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4361484471914903, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6121484471914904, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1078227456783951, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5078227456783952, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9712643014359971, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.471264301435997, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.957577403480815, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.935344432243678, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.235344432243678, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.5532907518110994}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4945957207744072, 5.886104031450156}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.894595720774407, 5.886104031450156}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.305525936990736, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.705525936990736, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.170932950247736}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0823823856765262, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.482382385676526, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.931632482576383, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316324825763833, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.9782390361706734}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.4365120772805082}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.437751649736401, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3892352051165808, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.789235205116581, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3092881287486289, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8092881287486289, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.9782390361706734}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.298317366548036, 2.6490076604684267}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1877429013343526, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5877429013343525, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-8.166775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4108864526485623, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.810886452648562, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.027776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.189776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.1167795926235586}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.227214785969269}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 0.8307328435125084}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.403677882205863, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.3681303904922195}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 6.684611727667927}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3982709425975442, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.044270942597544, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.618595850218866}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.4569857892424236}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8870722058722011, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.487072205872201, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1569280563711404, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569280563711404, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.0519532126861397, 7.55171221535131}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5519532126861397, 7.55171221535131}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2732043801967814, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.373204380196781, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8592388343623163, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2592388343623164, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.305525936990736, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.705525936990736, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.809142990314028, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1148124723039907, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6148124723039907, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0005772153247978, 6.380122536899765}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4005772153247977, 6.380122536899765}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3205753415836865, 2.0095554142156695}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9745753415836864, 2.0095554142156695}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2687119638680198, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.6687119638680197, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.763023770664052, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263023770664052, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2939250253122558, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.693925025312256, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.8440512773405471, 7.759614150696903}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.344051277340547, 7.759614150696903}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.7929254558680243}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 2.209811692841691}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.6108369333478076}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0823823856765262, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.482382385676526, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.6407201860918759, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.040720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.359436906950008}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.7083778602890038}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", 
                NCache[{-2.945732273553991, Log[400]}, {-2.945732273553991, 
                 5.991464547107982}]],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", 
                NCache[{-3.0457322735539907`, Log[
                  400]}, {-3.0457322735539907`, 5.991464547107982}]],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390573296152587, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.8390573296152586, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9870722058722012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3870722058722014, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6441274547453708, 5.736572297479192}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0441274547453707, 5.736572297479192}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4939343632035076, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.893934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.5067405141957577}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8625151471242033, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.060515147124203, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7459101490553133, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.145910149055313, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8467330387898968, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346733038789897, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5362515787163987, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.412251578716399, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.227214785969269}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.102583303777579, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.602583303777579, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.1232043801967815, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.5232043801967814, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 0.8989410935390421}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\[FivePointedStar]", 
                NCache[{-2.8957322735539908`, Log[
                  400]}, {-2.8957322735539908`, 5.991464547107982}]],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\[FivePointedStar]", 
                NCache[{-3.095732273553991, Log[400]}, {-3.095732273553991, 
                 5.991464547107982}]],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7433654852060263, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[EmptySquare]\"\>", 
                {-2.3433654852060264, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2069136483226262, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6069136483226263, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5517541346143557, 5.8289456176102075}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9517541346143557, 5.8289456176102075}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.995732273553991, 5.991464547107982}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.3302529702362658}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8192083653998068, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3192083653998066, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyDiamond]\"\>", 
                {-2.4390573296152587, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.8390573296152586, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.906544110754825, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4065441107548249, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.2787091504399533}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.1407201860918759, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.540720186091876, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\[FivePointedStar]", 
                NCache[{-2.7957322735539907`, Log[
                  400]}, {-2.7957322735539907`, 5.991464547107982}]],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\[FivePointedStar]", 
                NCache[{-3.195732273553991, Log[400]}, {-3.195732273553991, 
                 5.991464547107982}]],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 2.3243465847755584}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9870722058722012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.3870722058722014, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 0.911479174876933}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", 
                NCache[{-2.7957322735539907`, Log[
                  400]}, {-2.7957322735539907`, 5.991464547107982}]],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", 
                NCache[{-3.195732273553991, Log[400]}, {-3.195732273553991, 
                 5.991464547107982}]],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.7710464276305133}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.3608864526485625, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.860886452648562, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9933654852060263, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.0933654852060264, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8089819897673833, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.5149819897673833, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.90372738933488, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3037273893348802, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.7409075149860491, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.240907514986049, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.0732944806838198}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8992510730733434, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3992510730733434, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.622553707074063, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.8353444322436783, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.335344432243678, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1078227456783951, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5078227456783952, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7620499515598584, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262049951559858, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4405284995041312, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8405284995041313, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 1.9838938336679197}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\[FivePointedStar]", 
                NCache[{-2.7957322735539907`, Log[
                  400]}, {-2.7957322735539907`, 5.991464547107982}]],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\[FivePointedStar]", 
                NCache[{-3.195732273553991, Log[400]}, {-3.195732273553991, 
                 5.991464547107982}]],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.886637726631229, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.3866377266312284, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4081562175498282, 1.860974538249528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.184156217549828, 1.860974538249528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5188816629409656, 1.6882490928583902}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.4188816629409655, 1.6882490928583902}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.0519532126861397, 7.55171221535131}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5519532126861397, 7.55171221535131}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.9908343976300943, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4908343976300942, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2435614550482985, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.7435614550482983, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.9809291040876105, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809291040876102, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.719319793360441}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.556451816951096}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.064388689064227, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2643886890642269, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.7027460895677522}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 0.766397642299538}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", 
                NCache[{-2.845732273553991, Log[400]}, {-2.845732273553991, 
                 5.991464547107982}]],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", 
                NCache[{-3.1457322735539908`, Log[
                  400]}, {-3.1457322735539908`, 5.991464547107982}]],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.1370722058722014, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2370722058722015, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.421883011611913, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9643886890642268, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.364388689064227, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1643886890642268, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1643886890642268, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.3608864526485625, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.860886452648562, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8433654852060264, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2433654852060263, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.2100378816850887, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.7100378816850887, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0640794724197806, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640794724197806, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.21871196386802, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.7187119638680195, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 1.721694594779768}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6039459499562811, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2039459499562812, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.800776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.416776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1699988878712817, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6699988878712817, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 2.4561641809223462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.305525936990736, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.705525936990736, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1877429013343526, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5877429013343525, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.631199404215613}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 1.8526977673331346}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6644114819959424, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164411481995942, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.310037881685089, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6100378816850887, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9699046142222073, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1699046142222074, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.957577403480815, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1327329565011985, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3327329565011987, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.340445040947149, 6.040254711277414}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7404450409471488, 6.040254711277414}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6284916128036233, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.928491612803623, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1484668646973284, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.648466864697328, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.6843598389513597}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 1.9838938336679197}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8938099618846936, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-5.493809961884693, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2327329565011986, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2327329565011986, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.947976107508692, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.0966102859974367}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.2600378816850886, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.660037881685089, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0327329565011987, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4327329565011986, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.605170185988091, 2.9290581402859983}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 1.721694594779768}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5932080094425167, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.993208009442517, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7812206985481321, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2812206985481318, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2780506249916748, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.308050624991675, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.8699543168131119}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.5634107167600364, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.0634107167600364, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0005772153247978, 6.380122536899765}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4005772153247977, 6.380122536899765}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390573296152587, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.8390573296152586, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820072438863218, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.182007243886322, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9870722058722012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3870722058722014, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5932080094425167, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.993208009442517, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8699046142222073, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2699046142222075, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0363197520242107, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5363197520242107, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.5257286443082556, 6.461468176353717}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.3452119160186606}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.2406373244969853, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7406373244969853, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.9453385571563557}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8014485402144619, 6.579251212010101}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.201448540214462, 6.579251212010101}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.073204380196781, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.573204380196781, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0823823856765262, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.482382385676526, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8592388343623163, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2592388343623164, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", 
                NCache[{-2.845732273553991, Log[400]}, {-2.845732273553991, 
                 5.991464547107982}]],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", 
                NCache[{-3.1457322735539908`, Log[
                  400]}, {-3.1457322735539908`, 5.991464547107982}]],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1877429013343526, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5877429013343525, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\[FivePointedStar]", 
                NCache[{-2.7957322735539907`, Log[
                  400]}, {-2.7957322735539907`, 5.991464547107982}]],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\[FivePointedStar]", 
                NCache[{-3.195732273553991, Log[400]}, {-3.195732273553991, 
                 5.991464547107982}]],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.8826660279157308}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8539459499562811, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9539459499562812, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8643886890642268, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4643886890642268, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0699046142222073, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0699046142222073, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.885344432243678, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.285344432243678, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5897499532269226, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0897499532269226, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\[FivePointedStar]", 
                NCache[{-2.695732273553991, Log[400]}, {-2.695732273553991, 
                 5.991464547107982}]],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\[FivePointedStar]", 
                NCache[{-3.295732273553991, Log[400]}, {-3.295732273553991, 
                 5.991464547107982}]],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.246332151443247}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.863232841258714, 0.8458682675776092}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.3524072174927233, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledUpTriangle]\"\>", 
                {-0.8440512773405471, 7.759614150696903}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.344051277340547, 7.759614150696903}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.5284916128036232, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.028491612803624, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.21871196386802, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.7187119638680195, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.5087859235779435}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.249473262741422, 6.131226489483141}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6494732627414221, 6.131226489483141}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4677395362418175, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.2797395362418174, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2712460051465098, 2.187174241482718}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.67124600514651, 2.187174241482718}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3025850929940455, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3712460051465096, 2.187174241482718}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5712460051465098, 2.187174241482718}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.5299617109323036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4266819660425425, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.492681966042542, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.9908343976300943, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4908343976300942, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 2.0427775573082445}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334569144331189, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834569144331189, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.863232841258714, 1.007592890280941}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7039459499562812, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.103945949956281, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6042429605294894, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1042429605294894, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.457653856741544, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.057653856741544, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.179500146995422, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.679500146995422, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.9295125067557753, 7.674152921281675}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4295125067557752, 7.674152921281675}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5219819897673834, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.801981989767383, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2643886890642269, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.064388689064227, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.0190537003695233, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.319053700369523, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.2739459499983132, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.573945949998313, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.6134107167600362, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.013410716760036, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3774777201525994, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7954777201525993, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.6634107167600365, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.9634107167600363, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.318354083132957, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.718354083132957, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7459101490553133, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.145910149055313, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0126784475265938, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.5126784475265938, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2939484557648162, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6939484557648161, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.995732273553991, 5.991464547107982}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4712460051465097, 2.187174241482718}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4712460051465097, 2.187174241482718}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.1151705891340815}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3327329565011987, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1327329565011985, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3409606377618708, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7409606377618707, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.393948455764816, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5939484557648163, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8467330387898968, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346733038789897, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.7333680090865, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledUpTriangle]\"\>", 
                {-0.4307829160924542, 1.5904589458362974}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6441274547453708, 5.736572297479192}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.044127454745371, 5.736572297479192}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5932080094425167, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9932080094425166, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 2.330200260027019}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9327329565011986, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5327329565011987, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.106093061740368, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.506093061740368, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4298793241355137, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9298793241355137, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2060930617403678, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.406093061740368, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.246332151443247}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 1.5904589458362974}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7699046142222074, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.369904614222207, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9370722058722014, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.437072205872201, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.635344432243678, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.535344432243678, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.5087859235779435}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.303934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-4.0839343632035074, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 0.8450095298691913}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4183540831329569, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.618354083132957, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.707653856741544, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8076538567415439, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.430789601006442}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.907755278982137, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.199705077879927, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.0100378816850886, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.910037881685089, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.305525936990736, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.705525936990736, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.377692565480851}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1660916538023711, 6.214608098422191}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.566091653802371, 6.214608098422191}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.461401833606696}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.90372738933488, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3037273893348802, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3498366164619773, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.8498366164619773, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4409606377618707, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6409606377618708, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4126022156830935, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.1766022156830935, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.8526203100656485, 7.751045117971802}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3526203100656484, 7.751045117971802}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1877429013343526, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5877429013343525, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5517541346143557, 5.8289456176102075}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9517541346143559, 5.8289456176102075}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 1.0420419371797154}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.9837562915454279}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.53523983979334, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.03523983979334, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.5922917535991299}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5270116125934994, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0270116125934994, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.578491612803623, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.9784916128036234, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.21572018609187613, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.465720186091875, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 1.8526977673331346}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3060930617403679, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3060930617403679, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5169274935268733, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.016927493526873, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.305525936990736, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.705525936990736, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.6888794541139363, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.5102244577722903, 6.476972362889683}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4939484557648162, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4939484557648162, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6888794541139363, 5.298317366548036}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3653223785019062, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7653223785019063, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1939484557648161, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.793948455764816, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1712460051465097, 2.187174241482718}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7712460051465098, 2.187174241482718}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0823823856765262, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.482382385676526, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8563881178525805, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0563881178525807, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 1.2172838183856083}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.4498366164619774, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.749836616461977, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1872423621695702, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3872423621695704, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.227214785969269}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390573296152587, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.8390573296152586, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.073204380196781, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.573204380196781, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.377692565480851}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390573296152587, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.8390573296152586, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1699046142222074, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9699046142222073, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7563881178525805, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1563881178525806, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3145530131008705, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9145530131008708, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5712460051465098, 2.187174241482718}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3712460051465096, 2.187174241482718}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.0215475632609334}],\

               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.557653856741544, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.957653856741544, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.6960880245566355, 6.684611727667927}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0960880245566356, 6.684611727667927}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.518354083132957, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.518354083132957, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0872423621695702, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4872423621695703, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2409606377618707, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8409606377618706, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 2.044332364566268}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9870722058722012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3870722058722014, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2183540831329567, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8183540831329568, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4847815821812238, 2.135349173618132}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5587815821812239, 2.135349173618132}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.8643901602629624}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.642660088414177, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1426600884141767, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7933654852060263, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.293365485206026, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.1151705891340815}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4405284995041312, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8405284995041316, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.7959101490553133, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.095910149055313, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3634107167600362, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.2634107167600366, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2872423621695703, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2872423621695703, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 2.217136131161563}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.8283137373023015, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1148124723039907, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6148124723039907, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.399836616461977, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.799836616461977, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1687404467842484, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3687404467842483, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0891306126662428, 6.29156913955832}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4891306126662427, 6.29156913955832}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0687404467842483, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4687404467842484, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.8526203100656485, 7.751045117971802}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3526203100656484, 7.751045117971802}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.406093061740368, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2060930617403678, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5932080094425167, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9932080094425166, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.465322378501906, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6653223785019062, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.1100378816850887, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.8100378816850884, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1569280563711404, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569280563711404, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9712643014359971, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.471264301435997, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 2.2044208442068145}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.3428059215206005, 3.2386784521643803}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.452179964132715, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.952179964132715, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.265322378501906, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8653223785019062, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2687404467842482, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2687404467842482, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5932080094425167, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.993208009442517, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5939484557648163, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.393948455764816, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0060930617403678, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.606093061740368, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8592388343623163, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2592388343623164, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.735344432243678, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.435344432243678, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", 
                {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.622553707074063, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5409606377618708, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5409606377618708, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.283414346005772, 5.703782474656201}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.8283137373023015, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 0.986935571443487}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8014485402144619, 6.579251212010101}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.201448540214462, 6.579251212010101}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 0.7622067164914399}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.763023770664052, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263023770664052, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7198422131452975, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2198422131452975, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.173945949998313, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.673945949998313, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.133013715385442}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.445929943787544, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.945929943787544, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.6563881178525806, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2563881178525806, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.103158068297152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.3284916128036235, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.228491612803624, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6888794541139363, 2.9290581402859983}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.0794415416798357, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.5645530131008705, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6645530131008706, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5600995097294433, 2.423031246069913}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9080995097294433, 2.423031246069913}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3481484471914902, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7001484471914903, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.623934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-4.763934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.35851514712420324, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.564515147124203, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020169119255751, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520169119255751, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.8800803260850696, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.3800803260850696, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 0.9034081060431414}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 2.4561641809223462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.916173685255404, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.216173685255404, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", 
                NCache[{-2.595732273553991, Log[400]}, {-2.595732273553991, 
                 5.991464547107982}]],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", 
                NCache[{-3.3957322735539908`, Log[
                  400]}, {-3.3957322735539908`, 5.991464547107982}]],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3949588271331155, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7729588271331156, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9370722058722014, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.437072205872201, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.9190537003695232, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.419053700369523, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 0.8206605008589049}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3892599069543555, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9112599069543554, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.886637726631229, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.3866377266312284, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.227214785969269}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.36696431443027355, 2.134166441369082}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6789643144302735, 2.134166441369082}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4337250150625197, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.67772501506252, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.149836616461977, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.0498366164619775, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4327329565011986, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0327329565011987, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7812206985481321, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2812206985481318, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.1759065198095775, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7759065198095778, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 0.9403978072173882}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751462948262976, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.2514629482629758, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9837700970084164, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3837700970084166, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7459101490553133, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.145910149055313, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.7327358312823078, 7.8709295967551425}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2327358312823076, 7.8709295967551425}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3796406197516198, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8796406197516198, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324035882469876, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132403588246988, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.8067765548632013, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.410776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.6772785424354564, 6.309918278226516}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.223945949998313, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.623945949998313, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.364388689064227, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9643886890642268, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6539459499562812, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.153945949956281, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.4284916128036236, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.128491612803623, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3687404467842483, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1687404467842484, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.4145530131008706, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8145530131008707, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.227214785969269}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9563881178525806, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9563881178525806, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.6959101490553132, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.195910149055313, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3872423621695704, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1872423621695702, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 2.1094856630282126}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3657109156908187, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.7417109156908186, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7643886890642269, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.564388689064227, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.9908343976300943, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4908343976300942, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 1.8728785205128469}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4422780540451929, 1.501852701754163}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.868278054045193, 1.501852701754163}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0126784475265938, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.5126784475265938, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9872423621695702, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5872423621695704, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3169145435369547, 6.063785208687608}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7169145435369548, 6.063785208687608}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5168907011251433, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.0168907011251433, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 1.8359358315608838}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5932080094425167, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9932080094425166, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 1.5473497201206787}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 1.0868770324496888}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.969053700369523, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.369053700369523, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.6135885922613586, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.9135885922613587, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390573296152587, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.8390573296152586, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 1.0511712140679732}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3425014380048456, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.240501438004846, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9687404467842483, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5687404467842483, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.697559683024319, 2.4265710727750367}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7635596830243192, 2.4265710727750367}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5653223785019061, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5653223785019061, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.1151415906193203}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.4865920824352545}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3767294095441613, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8767294095441613, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.305525936990736, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.705525936990736, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.0497721232486361}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.618354083132957, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4183540831329569, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.5135885922613588, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.0135885922613586, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-4.199705077879927, 0.7997569156182036}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.7459101490553133, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.145910149055313, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.815475995845371}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.5894782894983773, 6.7912214627261855}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9894782894983774, 6.7912214627261855}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.67124600514651, 2.187174241482718}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2712460051465098, 2.187174241482718}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.8344641259578687, 6.152732694704104}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.1866231659908228}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.4407825464039603}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.556451816951096}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.0939343632035077, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.293934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.6699046142222073, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4699046142222072, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.3563504847468186}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.409260036932778, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.909260036932778, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6409606377618708, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4409606377618707, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3079303552881687, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8079303552881685, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 0.9566646260124284}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.8161736852554045, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.3161736852554045, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6123787564307905, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0123787564307904, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6888794541139363, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.03072450996508, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6307245099650798, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 2.209811692841691}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.4634107167600363, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.163410716760036, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1877429013343526, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5877429013343525, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.5841201044498106}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.2299329059954676}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.756895550682775, 1.589235205116581}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.378895550682775, 1.589235205116581}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.906544110754825, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4065441107548249, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.671097292820828}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.4259065198095775, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.5259065198095776, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 1.3147983594148207}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.6960880245566355, 6.684611727667927}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0960880245566356, 6.684611727667927}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.26677563769758056, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-8.666775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.973945949998313, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.8739459499983133, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.3964921860963366}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 0.9489515141137035}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8327329565011986, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6327329565011985, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.2158025560795132}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.506093061740368, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.106093061740368, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3615155310269236, 1.9416152247724325}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0695155310269238, 1.9416152247724325}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.5859645562484583}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047161811815076, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.8047161811815076, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.4146388341290332}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.7535382564078572}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.507653856741544, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.0076538567415443, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.6397713603489157}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7933654852060263, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.293365485206026, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2069136483226262, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6069136483226263, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.873422039839551, 6.507277712385012}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.273422039839551, 6.507277712385012}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 2.378619779270043}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.1614822520160453}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0823823856765262, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.482382385676526, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.719319793360441}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.418580902748128, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1569280563711404, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569280563711404, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.34773953624181747, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.3997395362418175, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6939484557648161, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2939484557648162, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3079303552881687, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8079303552881685, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.4971646699513146}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2807245099650797, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3807245099650798, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.2742448573112677}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.2876820724517809, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2759065198095776, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6759065198095777, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.5635885922613586, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.9635885922613587, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.4420193761824103, 3.2386784521643803}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 0.7802418874108791}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.590292464849665, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.590292464849665, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3092881287486289, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8092881287486289, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6653223785019062, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.465322378501906, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.659173264105291, 7.944492163932159}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.159173264105291, 7.944492163932159}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.523226215615035}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.744604469176456, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.4395981331422016}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.166775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.8661736852554043, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.266173685255405, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.7327358312823078, 7.8709295967551425}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2327358312823076, 7.8709295967551425}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.103934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-4.283934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5159020590539893, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7159020590539897, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.719319793360441}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4902924648496652, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.690292464849665, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5227665977411036, 5.857933154483459}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9227665977411035, 5.857933154483459}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.238485302016438, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7384853020164377, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 0.9858167945227654}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.763023770664052, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263023770664052, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.505701672608481, 2.0844290831908747}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6397016726084812, 2.0844290831908747}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.26677563769758056, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.666775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 1.1684492482568893}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.206735772821304, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706735772821304, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.719053700369523, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.619053700369523, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6159020590539896, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6159020590539896, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6265596830243191, 2.4265710727750367}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8345596830243192, 2.4265710727750367}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 0.880041599199034}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.2098554674840916}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.5554040239416147}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9870722058722012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3870722058722014, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0190692593864348, 2.570319527636131}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1550692593864347, 2.570319527636131}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.1975522365230131}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.7218733417638885}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.2792657883613672}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.3259065198095779, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.6259065198095777, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.8118888405232207}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.9782390361706734}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.642660088414177, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1426600884141767, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111425593016979, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.611425593016979, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2935151471242034, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.629515147124203, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4932133776377856, 2.4239173781615704}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9732133776377854, 2.4239173781615704}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.391511302188447}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.718354083132957, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.318354083132957, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1699988878712817, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6699988878712817, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.2259065198095778, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.7259065198095775, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.890459085159213, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.490459085159213, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.227214785969269}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.9809291040876105, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809291040876102, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 1.173410498743296}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.886637726631229, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.3866377266312284, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 2.2086040295231517}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.53523983979334, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.03523983979334, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3368289812806429, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1028289812806427, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7159020590539897, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5159020590539893, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4159020590539895, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8159020590539896, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.9521761906339596}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5177545102789891, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.6177545102789885, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.6526889544284153}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.3282528397426234}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.5047438413194347}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7755419870490041, 2.418588768750352}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.701541987049004, 2.418588768750352}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6161736852554043, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.516173685255405, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0640794724197806, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640794724197806, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334569144331189, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834569144331189, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.42254198704900425, 2.418588768750352}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0545419870490043, 2.418588768750352}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 0.9150900112976361}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.558002204858551}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7198422131452975, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2198422131452975, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1078227456783951, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5078227456783952, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1484668646973284, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.648466864697328, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.690292464849665, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4902924648496652, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4872423621695703, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0872423621695702, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.8140100781628747}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0712460051465096, 2.187174241482718}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8712460051465098, 2.187174241482718}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.140459085159213, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.240459085159213, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.390292464849665, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7902924648496652, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 0.9411784473819341}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.2406373244969853, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7406373244969853, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.018874035651734, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.518874035651734, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.184789984909162}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.4312677267626217}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5691769728675407, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7691769728675406, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.227214785969269}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5421847808531843, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7421847808531843, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0563881178525807, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8563881178525805, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4298793241355137, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9298793241355137, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9000608288825716, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3000608288825717, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0126784475265938, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.5126784475265938, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6421847808531844, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6421847808531844, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4405284995041312, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8405284995041313, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.437937594271729}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 2.04225875055212}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.31795882713311546, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8499588271331153, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1183540831329568, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9183540831329569, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3645530131008707, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8645530131008707, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5897888252912907, 2.506341930508065}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.711788825291291, 2.506341930508065}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-8.05031945517943, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-9.567015315914915, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.249836616461977, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.949836616461977, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.002290482491421}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.7859090555498793}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.6305150837187388, 2.827905162910489}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0305150837187387, 2.827905162910489}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8992510730733434, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3992510730733434, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4421847808531842, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8421847808531844, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4687404467842484, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0687404467842483, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2712709425975442, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1712709425975443, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2699046142222075, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8699046142222073, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4691769728675406, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8691769728675407, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.1307245099650798, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[EmptySquare]\"\>", {-1.53072450996508, 6.249975242259483}]
                ,
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8504328557048056, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6284328557048058, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.6397713603489157}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.495910149055313, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.395910149055313, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9060930617403679, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7060930617403678, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6539459499562812, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.153945949956281, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.931632482576383, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316324825763833, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7606265456942067, 6.620073206530356}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1606265456942064, 6.620073206530356}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-8.955698153602603, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.7378311272024993}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.28242162242480234, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.4684216224248026, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1699988878712817, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6699988878712817, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7409606377618707, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3409606377618708, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7421847808531843, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5421847808531843, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.102583303777579, 7.501082124259871}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.602583303777579, 7.501082124259871}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6691769728675407, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6691769728675407, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.0600378816850884, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.860037881685089, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.893934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.493934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.5894782894983773, 6.7912214627261855}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9894782894983774, 6.7912214627261855}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8200181212090352, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2200181212090353, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-7.523941418405954, 1.497835735852798}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.4931471805599453, 6.887552571664617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8931471805599454, 6.887552571664617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.4847813078345447}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1409606377618706, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9409606377618707, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1148124723039907, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6148124723039907, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.746910914291219, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.346910914291219, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2938099618846937, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-5.093809961884693, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.2759065198095776, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.6759065198095777, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.36787413308781153, 2.421256622711544}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.1038741330878117, 2.421256622711544}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.093948455764816, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8939484557648163, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.206735772821304, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706735772821304, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.3492515787163989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.5992515787164, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7305150837187386, 2.827905162910489}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9305150837187387, 2.827905162910489}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6939343632035078, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.6939343632035078, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8467330387898968, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346733038789897, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.25730031649136037, 2.0028304393079956}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0513003164913606, 2.0028304393079956}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5992998630578766, 8.004365564979574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0992998630578765, 8.004365564979574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3677423471738785, 1.4973884086254774}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.951742347173879, 1.4973884086254774}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8192083653998068, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3192083653998066, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5983254625819578, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.798325462581958, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.7161736852554044, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.416173685255404, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.5563881178525807, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3563881178525805, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1569280563711404, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569280563711404, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7691769728675406, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5691769728675407, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.8440512773405471, 7.759614150696903}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.344051277340547, 7.759614150696903}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.712716261887602}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7653223785019063, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3653223785019062, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9969109142912191, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.096910914291219, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7902924648496652, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.390292464849665, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.340445040947149, 6.040254711277414}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7404450409471488, 6.040254711277414}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.2876820724517809, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0176716486840978, 6.363028103540465}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4176716486840977, 6.363028103540465}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.5305150837187386, 2.827905162910489}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1305150837187385, 2.827905162910489}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\[FivePointedStar]", 
                {-1.698325462581958, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.698325462581958, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5270116125934994, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0270116125934994, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.203855757707185, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.503855757707186, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8421847808531844, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4421847808531842, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.3784916128036233, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.178491612803623, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.3135885922613586, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.2135885922613587, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.3524072174927233, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.3136238093329616, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.8136238093329614, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.5779472453427295}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.710818829244043, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.110818829244043, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.6888794541139363, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8159020590539896, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4159020590539895, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7620499515598584, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262049951559858, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-4.045554398052668, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.1780394222994315}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2259065198095778, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7259065198095775, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.2876820724517809, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.8843386505211481}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.7409075149860491, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.240907514986049, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6067395362418175, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.1407395362418176, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.908776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.3087765548632015, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.498325462581958, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8983254625819581, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.2253070303221034, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.975307030322104, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.073945949998313, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.773945949998313, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.990459085159213, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3904590851592131, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.103855757707185, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.603855757707185, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.606138360410137, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.206138360410137, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.41775451027898897, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.717754510278989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.23151514712420335, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.691515147124203, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.507653856741544, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.0076538567415443, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-7.819058469345253, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.29769484070258256, 1.6114359150967734}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.7936948407025826, 1.6114359150967734}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-4.382026634673881, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.32260489706968826, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.980604897069688, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.685344432243678, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.485344432243678, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.8561383604101369, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.956138360410137, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820072438863218, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.182007243886322, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.5774952330910239, 8.026170194946426}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.077495233091024, 8.026170194946426}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0126784475265938, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.5126784475265938, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 2.1122716862705384}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.102762968495368, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.4027629684953677, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3159020590539894, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9159020590539897, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6644114819959424, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164411481995942, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9390042880724031, 2.414126467726953}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.547004288072403, 2.414126467726953}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.290292464849665, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.890292464849665, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 1.3045418592476314}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.153855757707185, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.553855757707185, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3421847808531844, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9421847808531845, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5234214787151759, 2.50470927708418}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7814214787151759, 2.50470927708418}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.002762968495368, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.5027629684953678, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.102583303777579, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.602583303777579, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.798325462581958, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5983254625819578, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6042429605294894, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1042429605294894, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.21915621754982811, 1.860974538249528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.373156217549828, 1.860974538249528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.886637726631229, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.3866377266312284, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.90372738933488, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3037273893348802, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.659173264105291, 7.944492163932159}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.159173264105291, 7.944492163932159}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.6675181235106251}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.6592740514339194, 6.721425700790643}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0592740514339192, 6.721425700790643}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8687404467842482, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6687404467842482, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8691769728675407, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4691769728675406, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.30933398378559207, 2.131796772013764}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.741333983785592, 2.131796772013764}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.763023770664052, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263023770664052, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-8.685611843041201, 0.9360933591703348}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1569280563711404, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569280563711404, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6123787564307905, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0123787564307904, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2279670575204586, 6.152732694704104}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6279670575204586, 6.152732694704104}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.540287605670424, 8.063377822367027}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.040287605670424, 8.063377822367027}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.46009543862310287, 2.512035317176253}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.830095438623103, 2.512035317176253}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3691769728675405, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9691769728675406, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.965852822566973}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.42390493433755033, 8.1797604936999}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9239049343375502, 8.1797604936999}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2790506249916749, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.307050624991675, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8872423621695703, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6872423621695702, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.26677563769758056, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.666775637697581, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2227395362418174, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.5247395362418175, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5270116125934994, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0270116125934994, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0184328557048057, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4604328557048056, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.25152092754512073, 2.130609828254235}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8015209275451207, 2.130609828254235}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.398325462581958, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.998325462581958, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-7.284632930238389, 1.6094379124341003}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5897499532269226, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0897499532269226, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.819053700369523, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.519053700369523, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.642660088414177, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1426600884141767, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3034088163044134, 1.5107219394949427}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.9894088163044135, 1.5107219394949427}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.903855757707185, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.803855757707185, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.08072450996508, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.58072450996508, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4628691807704128, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0628691807704127, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.719319793360441}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.846910914291219, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2469109142912191, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7128691807704127, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.8128691807704128, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\[FivePointedStar]", {-0.8305150837187387, 2.827905162910489}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8305150837187387, 2.827905162910489}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.6094379124341003, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.017383521085972, 0.986935571443487}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.0600378816850884, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.860037881685089, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.53523983979334, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.03523983979334, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-4.045554398052668, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[CircleMinus]\"\>", 
                {-3.666173685255404, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.466173685255405, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6740596707737887, 1.9300710850255671}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7800596707737888, 1.9300710850255671}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0259065198095776, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.9259065198095777, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.4829948090959271, 6.897704943128636}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8829948090959272, 6.897704943128636}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6731916218535121, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.257191621853512, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.48159105267523294, 8.122074375362217}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.981591052675233, 8.122074375362217}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3645530131008707, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8645530131008707, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5227665977411036, 5.857933154483459}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9227665977411035, 5.857933154483459}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-6.214608098422191, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.445929943787544, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.945929943787544, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1563881178525806, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7563881178525805, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.452179964132715, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.952179964132715, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5574102454351726, 1.8687205103641833}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.019410245435173, 1.8687205103641833}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.09925157871639893, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.849251578716398, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.55932086581535, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.95932086581535, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.3784916128036233, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.178491612803623, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.24532803008106102, 2.424802725718295}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.219328030081061, 2.424802725718295}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4298793241355137, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9298793241355137, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.102583303777579, 7.501082124259871}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.602583303777579, 7.501082124259871}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0363197520242107, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5363197520242107, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.003855757707186, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.703855757707185, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.017383521085972, 0.7347688552507647}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.50932086581535, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.00932086581535, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-7.600902459542082, 1.6094379124341003}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4372277352570912, 2.0149030205422647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8472277352570914, 2.0149030205422647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.413410716760036, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.2134107167600363, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8983254625819581, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.498325462581958, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.6941466808930288}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.42390493433755033, 8.1797604936999}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9239049343375502, 8.1797604936999}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-5.298317366548036, 2.6490076604684267}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.995732273553991, 3.8004208288468435}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.39598343210629744, 6.984716320118266}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7959834321062975, 6.984716320118266}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.017383521085972, 0.8385453832493022}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.21482898128064304, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.2248289812806425, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.30265191133381086, 2.419478844465545}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.1726519113338107, 2.419478844465545}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.33587546767674265, 2.502255288122613}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9738754676767425, 2.502255288122613}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1268709406490898, 6.253828811575473}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5268709406490897, 6.253828811575473}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.397978879261335, 2.498151876538021}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9199788792613353, 2.498151876538021}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-8.403864506109235, 1.0698698198024557}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0527629684953679, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.4527629684953678, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.32035202312325517, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9203520231232553, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.3136238093329616, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.8136238093329614, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.9910270779881722}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.6592740514339194, 6.721425700790643}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0592740514339192, 6.721425700790643}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.308776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.908776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334569144331189, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834569144331189, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.6093208658153495, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.909320865815349, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 1.3982229319851645}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7045014380048455, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8785014380048457, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7620499515598584, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262049951559858, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.251047211711865}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.807796846925679}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.706138360410137, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.106138360410137, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.5107219394949427}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 1.1464496180822696}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.1921026317554486}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.9980550336767947}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.4890765557629164}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.739076112448345}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.30932086581535, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.20932086581535, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.8424288832756998}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.406587064387653}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.4337237600891445, 6.946975992135418}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8337237600891445, 6.946975992135418}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5102709425975442, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.932270942597544, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.251619457793289}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9404590851592131, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.440459085159213, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.8839343632035077, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-5.503934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.555615105736594}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.4305150837187387, 2.827905162910489}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2305150837187386, 2.827905162910489}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.18260024713539286, 2.136530508663963}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.858600247135393, 2.136530508663963}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.236923904465622}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.8146618624453594}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3892352051165808, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.789235205116581, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.2406373244969853, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7406373244969853, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 1.2499017362143359}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0363197520242107, 7.56734567601324}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5363197520242107, 7.56734567601324}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.238485302016438, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7384853020164377, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 0.9991602096964498}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.2581768583394481}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.19447772015259945, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9784777201525996, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5703520231232552, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.6703520231232553, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.340512168464763}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.6444188813293459}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyUpTriangle]\"\>", 
                {-5.298317366548036, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.1026043099376472}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.685344432243678, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.485344432243678, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7173448322214127, 2.5087859235779435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5793448322214125, 2.5087859235779435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2259065198095778, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7259065198095775, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.5959101490553134, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.295910149055313, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.4958211856471328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6063667205716478, 2.5877640352277083}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5323667205716478, 2.5877640352277083}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.738772150727949, 1.803358605071407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9687721507279492, 1.803358605071407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1484668646973284, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.648466864697328, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7812206985481321, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2812206985481318, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3796406197516198, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8796406197516198, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.963188584855586}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-4.3428059215206005, 2.6490076604684267}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.896419739771488}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.8204414117014135, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.3204414117014134, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-6.214608098422191, 1.6094379124341003}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.6587993419718245}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 2.066736169182282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.409320865815349, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.1093208658153495, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.5102803409008818}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.666173685255404, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.466173685255405, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.23950770937246224, 1.4996230464268938}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.075507709372462, 1.4996230464268938}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 2.215282764591249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9305150837187387, 2.827905162910489}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7305150837187386, 2.827905162910489}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 0.9543569326806114}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.199836616461977, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.999836616461977, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.6591800043289144}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.953855757707185, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.753855757707186, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.7479817218821596}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 0.6951451832226183}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.9204414117014135, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.2204414117014133, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.878196476740593, 1.7776605448485534}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.3136238093329616, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.8136238093329614, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5749085737794912, 2.020222182019865}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6989085737794913, 2.020222182019865}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.41818208557969155, 2.6019486702196644}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6921820855796914, 2.6019486702196644}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7969109142912192, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2969109142912192, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.9809291040876105, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809291040876102, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.20091672340788796, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0969167234078876, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5628691807704129, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9628691807704128, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.36140843158277425, 2.599722324216582}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7534084315827743, 2.599722324216582}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1038991427182467, 2.413231613081109}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3838991427182468, 2.413231613081109}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.4420193761824103, 3.2386784521643803}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.999776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.217776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-7.1308988302963465, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9192315758708453, 6.461468176353717}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3192315758708453, 6.461468176353717}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.3593208658153495, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.159320865815349, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2569588271331155, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9109588271331153, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.452179964132715, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.952179964132715, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.18776553100876345, 7.1929342212158}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.5877655310087636, 7.1929342212158}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8762388061002749, 2.503891949699081}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4302388061002749, 2.503891949699081}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2739488299021849, 2.5771819258971713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8859488299021847, 2.5771819258971713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.083934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.303934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.23392757277192572, 7.146772179452637}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.6339275727719259, 7.146772179452637}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.03647223662121282, 7.24422751560335}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.6364722366212128, 7.24422751560335}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.08072450996508, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.58072450996508, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.28533549351760507, 2.4997952622817508}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.029335493517605, 2.4997952622817508}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.3136238093329616, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.8136238093329614, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.8027629684953678, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.702762968495368, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.18763844305879254, 2.6224923127405635}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8816384430587925, 2.6224923127405635}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7970954386231031, 2.512035317176253}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.493095438623103, 2.512035317176253}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.23872501506251992, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.8727250150625196, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5396397452642098, 2.5974910105351463}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5796397452642097, 2.5974910105351463}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 0.9329511727672622}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-4.3428059215206005, 3.2386784521643803}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6527888252912907, 2.506341930508065}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6487888252912908, 2.506341930508065}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.093809961884693, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-5.293809961884693, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.249473262741422, 6.131226489483141}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6494732627414221, 6.131226489483141}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.529318843261892, 1.9033008439609624}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.102583303777579, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.602583303777579, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.21482267929402327, 2.519308076505333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.060822679294023, 2.519308076505333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8766948407025825, 1.6114359150967734}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.2146948407025824, 1.6114359150967734}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.953855757707185, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.753855757707186, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.7409075149860491, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.240907514986049, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.6561383604101372, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.156138360410137, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0363197520242107, 7.56734567601324}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5363197520242107, 7.56734567601324}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-8.532306829226286, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.3593208658153495, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.159320865815349, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.28647223662121285, 7.24422751560335}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.3864722366212129, 7.24422751560335}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1148124723039907, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6148124723039907, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8235151471242033, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0995151471242033, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.42035202312325515, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.8203520231232553, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9712643014359971, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.471264301435997, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.6972978603872035, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.9972978603872036, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.18609950972944322, 2.423031246069913}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.282099509729443, 2.423031246069913}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.5972978603872036, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0972978603872034, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.023945949998313, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.823945949998313, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9404590851592131, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.440459085159213, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.8704414117014133, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.2704414117014133, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.4135885922613587, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.1135885922613586, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.15446974274289163, 2.5756610130564646}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0084697427428915, 2.5756610130564646}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9314163895611922, 1.534714366238164}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.313416389561192, 1.534714366238164}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6746151233923356, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4626151233923357, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1699988878712817, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6699988878712817, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.253235454499315, 8.350429973538136}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.753235454499315, 8.350429973538136}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.1453949783402653, 2.432735777459091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.303394978340265, 2.432735777459091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2667756376975805, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.66677563769758, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7503999213758159, 2.5817308344235403}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4003999213758158, 2.5817308344235403}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3138716117510684, 2.5862591440482876}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8278716117510683, 2.5862591440482876}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.47340843158277435, 2.599722324216582}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6414084315827742, 2.599722324216582}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8026151233923355, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3346151233923356, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111425593016979, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.611425593016979, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.1587765548632012, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.058776554863201, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.31775451027898877, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.817754510278989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.199705077879927, 0.755182571479398}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5128691807704129, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0128691807704129, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3839343632035077, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-5.003934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1880444412935667, 2.3850863145057892}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3560444412935668, 2.3850863145057892}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3117849953272924, 2.6993457604720636}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6037849953272925, 2.6993457604720636}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820072438863218, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.182007243886322, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3796406197516198, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8796406197516198, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.906544110754825, 7.697121317282625}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4065441107548249, 7.697121317282625}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.6204414117014133, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.5204414117014136, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9712643014359971, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.471264301435997, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.6472978603872035, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0472978603872034, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.102583303777579, 7.501082124259871}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.602583303777579, 7.501082124259871}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.906544110754825, 7.697121317282625}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4065441107548249, 7.697121317282625}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8440512773405471, 7.759614150696903}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.344051277340547, 7.759614150696903}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3079303552881687, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8079303552881685, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0363197520242107, 7.56734567601324}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5363197520242107, 7.56734567601324}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7812206985481321, 7.822444729489319}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2812206985481318, 7.822444729489319}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6042429605294894, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1042429605294894, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8440512773405471, 7.759614150696903}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.344051277340547, 7.759614150696903}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.018874035651734, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.518874035651734, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.238485302016438, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7384853020164377, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9712643014359971, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.471264301435997, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7198422131452975, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2198422131452975, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7812206985481321, 7.822444729489319}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2812206985481318, 7.822444729489319}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5270116125934994, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0270116125934994, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.153934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-5.233934363203508, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.4339343632035078, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.9539343632035076, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1699988878712817, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6699988878712817, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.906544110754825, 7.697121317282625}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4065441107548249, 7.697121317282625}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7198422131452975, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2198422131452975, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->6.]}}}, {}},
          AspectRatio->1.,
          Axes->False,
          AxesLabel->{None, None},
          AxesOrigin->{0, 0},
          BaseStyle->{FontFamily -> "Helvetica", 16},
          DisplayFunction->Identity,
          Epilog->{{
             InsetBox[
              FormBox[
               StyleBox["\"Npt: 3966\"", 16, 
                GrayLevel[0], StripOnInput -> False], TraditionalForm], 
              Scaled[{0.1, 0.9}]]}, {{
              InsetBox[
               FormBox[
                StyleBox["\"Npt: 3966\"", 16, 
                 GrayLevel[0], StripOnInput -> False], TraditionalForm], 
               Scaled[{0.1, 0.9}]]}}},
          Frame->True,
          FrameLabel->{
            FormBox[
             StyleBox["\"x\"", 18, 
              GrayLevel[0], StripOnInput -> False], TraditionalForm], 
            FormBox[
             StyleBox["\"\[Mu] [GeV]\"", 18, 
              GrayLevel[0], StripOnInput -> False], TraditionalForm]},
          FrameTicks->{{{-13.815510557964274`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.512925464970229`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.210340371976182, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.605170185988091, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.3025850929940455`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
              FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
             0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.791759469228055, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.302585092994046, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.0943445622221, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.248495242049359, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.382026634673881, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.499809670330265, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.605170185988092, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.703782474656201, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.991464547107982, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.396929655216146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.551080335043404, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.684611727667927, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.802394763324311, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.006367567650246, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.294049640102028, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.699514748210191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.987196820661973, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.104979856318357, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.210340371976184, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.308952660644293`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.596634733096073`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.002099841204238`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.156250521031495`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.289781913656018`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.407564949312402`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}}, {{-13.815510557964274`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.512925464970229`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.210340371976182, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.605170185988091, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.3025850929940455`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
              FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
             0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.791759469228055, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.302585092994046, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.0943445622221, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.248495242049359, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.382026634673881, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.499809670330265, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.605170185988092, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.703782474656201, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.991464547107982, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.396929655216146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.551080335043404, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.684611727667927, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.802394763324311, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.006367567650246, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.294049640102028, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.699514748210191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.987196820661973, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.104979856318357, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.210340371976184, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.308952660644293`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.596634733096073`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.002099841204238`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.156250521031495`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.289781913656018`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.407564949312402`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}}, {{-13.815510557964274`, 
              FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
              FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
              FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
              FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
              FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm]}, {0., 
              FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
              FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
              FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
              FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
              FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
              FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
              FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
              FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
              FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
              FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
              FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
              FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
              FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
              FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
              FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
              FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
              FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
              FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
              FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
              FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
              FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
              FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
              FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
              FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
              FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
              FormBox["\"\"", TraditionalForm]}}, {{-13.815510557964274`, 
              FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
              FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
              FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
              FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
              FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm]}, {0., 
              FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
              FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
              FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
              FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
              FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
              FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
              FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
              FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
              FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
              FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
              FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
              FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
              FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
              FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
              FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
              FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
              FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
              FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
              FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
              FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
              FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
              FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
              FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
              FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
              FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
              FormBox["\"\"", TraditionalForm]}}},
          FrameTicksStyle->GrayLevel[0],
          
          GridLines->
           NCache[{{-16.11809565095832, -13.815510557964274`, \
-11.512925464970229`, -9.210340371976182, -6.907755278982137, \
-4.605170185988091, -2.3025850929940455`}, {
              Log[10], 
              Log[50], 
              Log[100], 
              Log[500], 
              Log[1000], 
              Log[5000], 
              Log[
              10000]}}, {{-16.11809565095832, -13.815510557964274`, \
-11.512925464970229`, -9.210340371976182, -6.907755278982137, \
-4.605170185988091, -2.3025850929940455`}, {2.302585092994046, 
            3.912023005428146, 4.605170185988092, 6.214608098422191, 
            6.907755278982137, 8.517193191416238, 9.210340371976184}}],
          GridLinesStyle->Directive[
            Dashing[{Small, Small}]],
          ImagePadding->All,
          ImageSize->{{600}, {600}},
          Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& 
                )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& )}},
          PlotLabel->None,
          PlotRange->NCache[{{-Log[100000], 0}, {0, 
              Log[6000]}}, {{-11.512925464970229`, 0}, {
             0, 8.699514748210191}}],
          PlotRangeClipping->True,
          PlotRangePadding->{{0, 0}, {0, 0}},
          Ticks->{Automatic, Automatic}], Scaled[{0.5, 0.5}], Center, 
         Scaled[{1, 1}]], InsetBox[
         TemplateBox[{FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   StyleBox["\"\"", {FontSize -> 14, 
                    GrayLevel[0], FontFamily -> "Arial"}, Background -> 
                    Automatic, StripOnInput -> False]}, {
                   GraphicsBox[{{}, {}, 
                    
                    RasterBox[{{{0., 0.7, 0.}}, {{0., 0.7, 0.}}, {{0.75, 0.75,
                     0.}}, {{0.75, 0.5499999999999997, 0.}}, {{0.7, 0., 
                    0.}}, {{0.7, 0., 0.}}}, {{
                    Rational[-15, 2], -75}, {
                    Rational[15, 2], 75}}], {Antialiasing -> False, 
                    AbsoluteThickness[0.1], 
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]], 
                    LineBox[
                    NCache[{{
                    Rational[15, 2], -75}, {
                    Rational[-15, 2], -75}, {
                    Rational[-15, 2], 75}, {
                    Rational[15, 2], 75}, {
                    Rational[15, 2], -75}}, {{
                    7.5, -75}, {-7.5, -75}, {-7.5, 75}, {7.5, 75}, {
                    7.5, -75}}]]}, {
                    CapForm[None], {}}, {Antialiasing -> False, 
                    StyleBox[
                    
                    LineBox[{{7.499999999999999, -74.99999999999999}, {
                    7.499999999999999, 74.99999999999999}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.499999999999999, -50.}, 
                    Offset[{4., 0}, {7.499999999999999, -50.}]}, {{
                    7.499999999999999, -24.999999999999993`}, 
                    
                    Offset[{4., 0}, {
                    7.499999999999999, -24.999999999999993`}]}, {{
                    7.499999999999999, 9.44554760954415*^-15}, 
                    
                    Offset[{4., 0}, {7.499999999999999, 
                    9.44554760954415*^-15}]}, {{7.499999999999999, 
                    24.999999999999986`}, 
                    
                    Offset[{4., 0}, {7.499999999999999, 
                    24.999999999999986`}]}, {{7.499999999999999, 
                    49.99999999999998}, 
                    
                    Offset[{4., 0}, {7.499999999999999, 
                    49.99999999999998}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox["0", TraditionalForm], 
                    Offset[{7., 0.}, {7.499999999999999, -50.}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"0.375\"", 0.375, AutoDelete -> True],
                     NumberForm[#, {
                    DirectedInfinity[1], 3}]& ], TraditionalForm], 
                    
                    Offset[{7., 0.}, {
                    7.499999999999999, -24.999999999999993`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"0.750\"", 0.75, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}]& ], TraditionalForm], 
                    
                    Offset[{7., 0.}, {7.499999999999999, 
                    9.44554760954415*^-15}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"1.500\"", 1.5, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}]& ], TraditionalForm], 
                    
                    Offset[{7., 0.}, {7.499999999999999, 
                    24.999999999999986`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    "\"3.003\"", 3.0029999999999997`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.499999999999999, 49.99999999999998}], 
                    
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1], FontSize -> 14, 
                    GrayLevel[0]]}, StripOnInput -> False]}, {}}, {
                    Directive[
                    Opacity[1], FontSize -> 14, 
                    GrayLevel[0]]}, StripOnInput -> False], "GraphicsLabel", 
                    StripOnInput -> False]}, "GraphicsTicks", StripOnInput -> 
                    False], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                    Scaled[0.02], PlotRange -> All, Frame -> True, 
                    FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                    Opacity[0], FrameTicksStyle -> Opacity[0], 
                    ImageSize -> {Automatic, 150}, BaseStyle -> {}, 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}]}}, 
                 GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontSize -> 14, 
              GrayLevel[0], FontFamily -> "Arial"}, Background -> Automatic, 
             StripOnInput -> False], TraditionalForm]},
          "BarLegend",
          DisplayFunction->(#& ),
          InterpretationFunction:>(RowBox[{"BarLegend", "[", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0, 0.7, 0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0.4666666666666667, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0, 0.7, 0]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0, 0.7, 0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0, 0.7, 0], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0, 0.7, 0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0.4666666666666667, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0, 0.7, 0]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0, 0.7, 0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0, 0.7, 0], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.75, 0.75, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.5, 0.5, 0.], FrameTicks -> 
                    None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.75, 0.75, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.75, 0.75, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.75, 0.75, 0.], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.75, 0.55, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.5, 0.3666666666666667, 0.],
                     FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.75, 0.55, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.75, 0.55, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.75, 0.55, 0.], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0., 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.4666666666666667, 0., 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0., 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0., 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0., 0.], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0., 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.4666666666666667, 0., 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0., 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0., 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0., 0.], Editable -> False, Selectable -> 
                    False]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "0.0030029999999999996`"}], ",", 
                    "3.0060029999999998`"}], "}"}]}], "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.0030029999999999996`"}], ",", "0", ",", 
                   "0.375`", ",", "0.75`", ",", "1.5`", ",", 
                   "3.0029999999999997`", ",", "3.0060029999999998`"}], "}"}],
                ",", 
               RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"FontSize", "\[Rule]", "14"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False]}], 
                   "}"}]}], ",", 
               RowBox[{"LegendLabel", "\[Rule]", "\"\""}], ",", 
               RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
               RowBox[{"LegendMarkerSize", "\[Rule]", 
                 RowBox[{"{", "}"}]}], ",", 
               RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
               RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
               RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], 
             "]"}]& )], Scaled[{1., 0.5}], ImageScaled[{0, 0.5}],
         BaseStyle->{FontSize -> Larger},
         FormatType->StandardForm]},
       AspectRatio->1.,
       Axes->False,
       AxesLabel->{None, None},
       AxesOrigin->{0, 0},
       BaseStyle->{FontFamily -> "Helvetica", 16},
       DisplayFunction->Identity,
       Frame->False,
       FrameLabel->{
         FormBox[
          StyleBox["\"x\"", 18, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         FormBox[
          StyleBox["\"\[Mu] [GeV]\"", 18, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm]},
       FrameTicks->{{{-13.815510557964274`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.02375108873622, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.86960040890896, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.512925464970229`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.903487552536127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.721165995742174, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.567015315914915, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.433483923290392, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.315700887634009, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.210340371976182, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-8.111728083308073, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.824046010856292, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.600902459542082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.418580902748127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.264430222920869, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.013115794639964, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-6.907755278982137, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.809142990314028, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.521460917862246, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.298317366548036, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.115995809754082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.961845129926823, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.710530701645918, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.605170185988091, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.506557897319982, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.995732273553991, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.659260036932778, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.3025850929940455`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-1.203972804325936, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.916290731874155, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
           FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
          0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.302585092994046, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.605170185988092, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.907755278982137, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.210340371976184, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}}, {{-13.815510557964274`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.02375108873622, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.86960040890896, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.512925464970229`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.903487552536127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.721165995742174, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.567015315914915, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.433483923290392, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.315700887634009, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.210340371976182, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-8.111728083308073, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.824046010856292, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.600902459542082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.418580902748127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.264430222920869, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.013115794639964, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-6.907755278982137, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.809142990314028, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.521460917862246, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.298317366548036, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.115995809754082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.961845129926823, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.710530701645918, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.605170185988091, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.506557897319982, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.995732273553991, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.659260036932778, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.3025850929940455`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-1.203972804325936, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.916290731874155, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
           FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
          0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.302585092994046, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.605170185988092, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.907755278982137, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.210340371976184, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}}, {{-13.815510557964274`, 
           FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
           FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
           FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
           FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
           FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
           FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
           FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
           FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
           FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
           FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
           FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
           FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
           FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
           FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
           FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
           FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
           FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
           FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
           FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
           FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
           FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
           FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
           FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm]}, {0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
           FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm]}}, {{-13.815510557964274`, 
           FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
           FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
           FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
           FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
           FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
           FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
           FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
           FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
           FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
           FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
           FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
           FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
           FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
           FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
           FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
           FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
           FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
           FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
           FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
           FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
           FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
           FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
           FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm]}, {0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
           FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm]}}},
       FrameTicksStyle->GrayLevel[0],
       ImagePadding->All,
       ImageSize->{{600}, {600}},
       Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
             (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
              Part[#, 1]], 
             (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
              Part[#, 2]]}& ), "CopiedValueFunction" -> ({
             (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
              Part[#, 1]], 
             (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
              Part[#, 2]]}& )}},
       PlotLabel->FormBox[
         StyleBox[
         "\"|\\!\\(\\*SubscriptBox[\\(\[Sigma]\\), \
\\(i\\)]\\)/\\!\\(\\*SubscriptBox[\\(D\\), \\(i\\)]\\)|, CT14NNLO\"", 24, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm],
       PlotRange->Automatic,
       PlotRangeClipping->False,
       PlotRangePadding->{{0, 0}, {0, 0}},
       Ticks->{Automatic, Automatic},
       ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]],
      InterpretTemplate[Legended[
        Graphics[{{{}, {{{}, {
              Hue[0.67, 0.6, 0.6], 
              Directive[
               PointSize[0.012833333333333334`], 
               AbsoluteThickness[1.6], FontFamily -> "Helvetica", 
               GrayLevel[1]], 
              
              Point[{{0.00001, 2.}, {0.99, 
               1200.}}]}, {}}}, {}, {}, {{}, {}}}, {
           Style[
            Text["\[EmptySquare]", {26.659279813908125`, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-35.34072018609188, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {25.659279813908125`, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-34.34072018609188, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {27.659279813908125`, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-36.34072018609188, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {28.659279813908125`, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-37.34072018609188, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {24.659279813908125`, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-33.34072018609188, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {29.659279813908125`, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-38.34072018609188, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {30.659279813908125`, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-39.34072018609188, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {31.659279813908125`, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-40.34072018609188, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {32.65927981390812, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-41.34072018609188, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {33.65927981390812, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-42.34072018609188, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {44.53322436230242, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-53.46677563769758, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {55.53322436230242, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-64.46677563769758, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {54.53322436230242, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-63.46677563769758, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {45.53322436230242, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-54.46677563769758, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {34.65927981390812, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-43.34072018609188, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {43.53322436230242, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-52.46677563769758, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {46.53322436230242, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-55.46677563769758, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {56.53322436230242, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-65.46677563769758, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {47.53322436230242, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-56.46677563769758, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {57.53322436230242, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-66.46677563769758, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {42.53322436230242, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-51.46677563769758, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {53.53322436230242, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-62.46677563769758, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {51.53322436230242, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-60.46677563769758, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {49.53322436230242, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-58.46677563769758, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {50.53322436230242, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-59.46677563769758, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {58.53322436230242, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-67.46677563769758, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {60.53322436230242, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-69.46677563769758, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {61.53322436230242, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-70.46677563769758, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {62.53322436230242, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-71.46677563769758, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {48.53322436230242, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-57.46677563769758, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {59.53322436230242, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-68.46677563769758, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {52.53322436230242, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-61.46677563769758, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 0.7476353658440151}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 1.0360274134764884`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {63.53322436230242, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-72.46677563769758, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.0794415416798357`, 1.266384064447333}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 0.9658425107034028}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {35.65927981390812, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-44.34072018609188, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.0360274134764884`}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.4967170423699816`}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.266384064447333}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 0.7485818874480459}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.0498221244986778`, 1.266384064447333}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 0.8060293376166178}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.4003070303221032`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.800307030322104, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 1.4967170423699816`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.6888794541139363`, 0.7485818874480459}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 0.9666035457477442}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 1.4967170423699816`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-2.995732273553991, 0.848868055556721}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 0.9658425107034028}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.266384064447333}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.6003070303221034`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.600307030322103, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.6888794541139363`, 0.9673640020581556}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 1.2184672504763885`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 0.7466879474879751}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 1.3480731482996928`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.4967170423699816`}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 0.7485818874480459}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 0.7499999921527281}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 0.8060293376166178}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.0360274134764884`}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.7268653293100646`}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 0.9666035457477442}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-2.659260036932778, 0.849723487602042}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.6888794541139363`, 0.8505781885087738}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 1.4967170423699816`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-2.995732273553991, 1.094604267270571}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.2909841813155656`, 1.266384064447333}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.7268653293100646`}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 0.9673640020581556}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 0.849723487602042}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.9003070303221032`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.300307030322103, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.045554398052668, 0.7485818874480459}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.382026634673881, 0.7485818874480459}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.090999490513565}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 0.9673640020581556}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.215506040139609}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.491779868965868}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 0.7485818874480459}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.3504080825554816`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.0942695392339727`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.4886252922173524`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 0.9658425107034028}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.6888794541139363`, 1.0942695392339727`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 1.0360274134764884`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.7985076962177716, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 1.2190584417439767`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 1.0360274134764884`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.348592493935879}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.0935997468445653`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.0498221244986778`, 2.187398683184928}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 0.848868055556721}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.7985076962177716, 1.4967170423699816`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.2166915767337108`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.3003070303221036`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.900307030322104, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.045554398052668, 0.9604989865384754}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 0.849723487602042}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 0.8060293376166178}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.5003070303221033`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.7003070303221035`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.9572739077056285`}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.1003070303221034`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.100307030322104, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.599387576580599}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 0.9707789171582248}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 1.0962762288705619`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.7985076962177716, 1.266384064447333}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.9003070303221032`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.300307030322103, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.9572739077056285`}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.4913298239537713`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.6395790693460872`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7003070303221035`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.500307030322103, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.0942695392339727`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.215506040139609}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 1.4772770088317615`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.5340676054093236`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.349630376748299}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 0.848868055556721}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.4915548717773834`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.5340676054093236`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.094604267270571}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.215506040139609}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.7985076962177716, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 0.8060293376166178}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 1.7406415980494447`}]
            , 3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.100307030322103, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.100307030322104, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.8947332418642159, 1.7316555451583497`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.9567332418642156`, 1.7316555451583497`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.4913298239537713`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.2158025560795132`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.8805331812814825`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 0.8514321595256585}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.8122154777954373`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-1.491654876777717, 1.094604267270571}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 0.7485818874480459}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.599387576580599}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.4913298239537713`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.7406415980494447`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.9334277163102163, 1.8389610707123492`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.7034277163102165`, 1.8389610707123492`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.215506040139609}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.599387576580599}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.300307030322103, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.900307030322104, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.0942695392339727`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.500307030322103, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.7003070303221035`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.090999490513565}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.7985076962177716, 2.187398683184928}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.599387576580599}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 1.0360274134764884`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.4913298239537713`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7901109564601341, 1.6272778305624314`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-3.270110956460134, 1.6272778305624314`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.640548907459153}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 0.7485818874480459}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.599387576580599}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.5340676054093236`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.9510398268753117`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.5978370007556204, 1.4967170423699816`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.5978370007556204, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-1.491654876777717, 1.64113035916659}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.5340676054093236`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.9735293151671945, 1.9198594718553708`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.5015293151671947`, 1.9198594718553708`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.6661962462527091`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.2181715237257489`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.045554398052668, 0.8514321595256585}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.382026634673881, 0.8441500540964727}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.7406415980494447`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {19.659279813908125`, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-28.340720186091875`, 4.512945241945574}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.227214785969269}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.6409365794934714`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {21.659279813908125`, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-30.340720186091875`, 4.512945241945574}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.0845133642886082`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.5340676054093236`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.6358850824489488`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 2.090999490513565}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.090999490513565}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 2.090999490513565}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 2.187398683184928}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.4913298239537713`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 0.8060293376166178}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 1.3321021320364639`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 0.9658425107034028}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4917756376975806`, 4.386889790339869}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-6.441775637697581, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {20.659279813908125`, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-29.340720186091875`, 4.512945241945574}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {22.659279813908125`, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-31.340720186091875`, 4.512945241945574}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.2909841813155656`, 2.187398683184928}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.215506040139609}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {18.659279813908125`, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-27.340720186091875`, 4.512945241945574}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.6389967146756448`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.4722426732562555`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0275338341178306`, 1.9768549529047348`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.333533834117831, 1.9768549529047348`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.349630376748299}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.095273387402595}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.6661962462527091`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.599387576580599}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.599387576580599}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-1.491654876777717, 0.849723487602042}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.0845133642886082`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.6304163188192922`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.7817091333745536`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.5257286443082556`, 1.266384064447333}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 1.599387576580599}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.6661962462527091`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.640548907459153}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.007592890280941}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 0.7485818874480459}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 1.0360274134764884`}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.7417756376975806`, 4.386889790339869}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-6.191775637697581, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.7406415980494447`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.090999490513565}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 0.965080896043587}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.6661962462527091`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.5978370007556204, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.7828868907244566`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.599387576580599}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.599387576580599}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-1.491654876777717, 1.783559272662715}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.7406415980494447`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 2.227214785969269}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.599387576580599}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.1637756145745228`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.599387576580599}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.7840632625935846`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 2.0215475632609334`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {37.65927981390812, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-46.34072018609188, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.6661962462527091`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.9667756376975807`, 4.386889790339869}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-5.966775637697581, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.5340676054093236`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.082841223761632, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.188841223761632, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.227214785969269}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.7985076962177716, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.0845133642886082`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.2919836816486494`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.2319770007355333`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.090999490513565}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {38.65927981390812, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-47.34072018609188, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.9753070303221036`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.225307030322104, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.3540294005326152`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-3.166775637697581, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-5.766775637697581, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.7406415980494447`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.2319770007355333`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3667756376975806`, 4.386889790339869}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-5.566775637697581, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.7253070303221034`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.475307030322103, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.2253070303221034`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.975307030322103, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.5978370007556204, 2.187398683184928}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 1.416581053724763}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.9753070303221036`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.225307030322104, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.7406415980494447`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.416581053724763}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {39.65927981390812, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-48.34072018609188, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.7406415980494447`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 0.849723487602042}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.227214785969269}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.2253070303221034`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.975307030322104, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.599387576580599}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.2253070303221034`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.975307030322103, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {36.65927981390812, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-45.34072018609188, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.227214785969269}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.4920048155420047`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.2919836816486494`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.4753070303221034`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.725307030322103, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 1.599387576580599}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 1.4967170423699816`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.416581053724763}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.7253070303221034`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.475307030322103, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.5340676054093236`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.5362515787163986`, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.4122515787164, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.6661962462527091`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.416581053724763}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-0.8503070303221034, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-8.350307030322103, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.7667756376975805`, 4.386889790339869}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-5.16677563769758, 4.386889790339869}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {23.659279813908125`, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-32.34072018609188, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.4753070303221034`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.725307030322103, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2167756376975807`, 4.386889790339869}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-6.716775637697581, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.4122515787163992`, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.536251578716398, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.9753070303221036`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.225307030322104, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.0935997468445653`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.2862515787163986`, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.662251578716399, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.7837272975307907`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.662251578716399, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.286251578716398, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.4307829160924542, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.7862515787163986`, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.1622515787164, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.2253070303221034`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.975307030322104, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.416581053724763}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.5340676054093236`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-0.7985076962177716, 1.64113035916659}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.090999490513565}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-2.659260036932778, 1.416581053724763}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.9667756376975807`, 4.386889790339869}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-4.966775637697581, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.659260036932778, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.3504080825554816`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.926290362185661}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.4753070303221034`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.725307030322104, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.227214785969269}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.3540294005326152`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.5340676054093236`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.2253070303221034`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.975307030322103, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.5667756376975808`, 4.386889790339869}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-5.366775637697581, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.4722426732562555`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.416581053724763}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.4753070303221034`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.725307030322104, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.0362515787163986`, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.912251578716399, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.9122515787163992`, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.036251578716398, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1197926521647825`, 2.065596134857783}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.0637926521647825`, 2.065596134857783}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.7406415980494447`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 1.266384064447333}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.6661962462527091`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 0.8060293376166178}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.1622515787163992`, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.786251578716398, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-0.8503070303221034, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-8.350307030322103, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.5340676054093236`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.7406415980494447`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.3540294005326152`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.2319770007355333`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.9245405804618736`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.893934363203508, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.493934363203508, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.4753070303221034`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.725307030322104, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.2919836816486494`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.9245405804618736`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.5340676054093236`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.416581053724763}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.5340676054093236`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.4938099618846934`, 4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.8938099618846933`, 4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.6661962462527091`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.036251578716399, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.912251578716399, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6938099618846936`, 4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.6938099618846936`, 4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 1.599387576580599}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-4.366775637697581, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-4.566775637697581, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.416581053724763}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 1.416581053724763}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.7822140563845235`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.491654876777717, 1.416581053724763}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.2319770007355333`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.9251241812954787`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-0.9122515787163991, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-8.0362515787164, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5780906770930101, 1.5432981099295553`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-3.65009067709301, 1.5432981099295553`}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.5340676054093236`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 2.0215475632609334`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.293809961884693, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-4.093809961884693, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-4.16677563769758, 4.386889790339869}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-4.766775637697581, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.659260036932778, 1.4722426732562555`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 2.187398683184928}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.5340676054093236`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.2919836816486494`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.5340676054093236`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 2.090999490513565}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.462149662665384}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7167756376975808, 
             4.386889790339869}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.21677563769758, 4.386889790339869}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-2.659260036932778, 1.007592890280941}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.659260036932778, 1.0845133642886082`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.5362515787163986`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-7.4122515787164, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.773934884315503}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.662251578716399, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-7.286251578716398, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7167756376975808, 
             4.386889790339869}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.21677563769758, 4.386889790339869}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.7862515787163986`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-7.1622515787164, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.4307829160924542, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.3540294005326152`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.491654876777717, 2.090999490513565}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.4722426732562555`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.4122515787163992`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-7.536251578716398, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.931632482576383, 6.672032945461067}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316324825763833`, 6.672032945461067}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.931632482576383, 6.672032945461067}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316324825763833`, 6.672032945461067}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.8417756376975807`, 
             4.386889790339869}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.091775637697581, 4.386889790339869}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.7406415980494447`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.8417756376975807`, 
             4.386889790339869}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.091775637697581, 4.386889790339869}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.5917756376975807`, 
             4.386889790339869}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.341775637697581, 4.386889790339869}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324035882469876`, 5.971261839790462}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132403588246988, 5.971261839790462}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324035882469876`, 5.971261839790462}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132403588246988, 5.971261839790462}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111425593016979, 6.492239835020471}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.611425593016979, 6.492239835020471}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111425593016979, 6.492239835020471}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.611425593016979, 6.492239835020471}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.7253070303221034`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.475307030322103, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6042429605294894`, 6.999422467507961}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1042429605294894`, 6.999422467507961}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8467330387898968`, 6.756932389247553}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346733038789897, 6.756932389247553}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.416581053724763}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8467330387898968`, 6.756932389247553}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346733038789897, 6.756932389247553}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.659260036932778, 1.416581053724763}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.931632482576383, 6.672032945461067}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316324825763833`, 6.672032945461067}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 1.599387576580599}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.018874035651734, 6.584791392385716}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.518874035651734, 6.584791392385716}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 1.599387576580599}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743197990830097`, 5.429345628954441}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6743197990830097`, 5.429345628954441}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324035882469876`, 5.971261839790462}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132403588246988, 5.971261839790462}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743197990830097`, 5.429345628954441}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6743197990830097`, 5.429345628954441}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.018874035651734, 6.584791392385716}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.518874035651734, 6.584791392385716}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743197990830097`, 5.429345628954441}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6743197990830097`, 5.429345628954441}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111425593016979, 6.492239835020471}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.611425593016979, 6.492239835020471}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {40.65927981390812, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-49.34072018609188, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.416581053724763}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7620499515598584`, 6.841615476477592}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262049951559858, 6.841615476477592}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6042429605294894`, 6.999422467507961}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1042429605294894`, 6.999422467507961}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-4.196377287787253, 0.8060293376166178}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8467330387898968`, 6.756932389247553}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346733038789897, 6.756932389247553}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.3417756376975807`, 
             4.386889790339869}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.591775637697581, 4.386889790339869}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-0.7862515787163987, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-8.162251578716399, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.751635164117833, 4.852030263919617}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251635164117833, 4.852030263919617}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743197990830097`, 5.429345628954441}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6743197990830097`, 5.429345628954441}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.751635164117833, 4.852030263919617}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251635164117833, 4.852030263919617}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5168907011251433`, 6.0867747269123065`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.0168907011251433`, 6.0867747269123065`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5168907011251433`, 6.0867747269123065`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.0168907011251433`, 6.0867747269123065`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.162251578716399, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.786251578716398, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.7847348542910906`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.018874035651734, 6.584791392385716}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.518874035651734, 6.584791392385716}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.4722426732562555`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7620499515598584`, 6.841615476477592}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262049951559858, 6.841615476477592}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.3540294005326152`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.924832423452417}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1279291781552085`, 2.1174596088673567`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9519291781552084`, 2.1174596088673567`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.751635164117833, 4.852030263919617}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251635164117833, 4.852030263919617}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5168907011251433`, 6.0867747269123065`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.0168907011251433`, 6.0867747269123065`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.2862515787163986`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-7.662251578716399, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324035882469876`, 5.971261839790462}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132403588246988, 5.971261839790462}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020169119255751, 5.583496308781699}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520169119255751, 5.583496308781699}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020169119255751, 5.583496308781699}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520169119255751, 5.583496308781699}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.083934363203508, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.303934363203508, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.5340676054093236`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111425593016979, 6.492239835020471}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.611425593016979, 6.492239835020471}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.659260036932778, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.659260036932778, 1.0845133642886082`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.9122515787163992`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-7.036251578716398, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820072438863218`, 6.921658184151129}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.182007243886322, 6.921658184151129}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1227139907010775`, 2.182674796321488}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.8267139907010774`, 2.182674796321488}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.5340676054093236`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.491654876777717, 1.599387576580599}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5270116125934994`, 7.076653815443951}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0270116125934994`, 7.076653815443951}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820072438863218`, 6.921658184151129}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.182007243886322, 6.921658184151129}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.5978370007556204, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.409260036932778, 6.194405391104672}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.909260036932778, 6.194405391104672}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020169119255751, 5.583496308781699}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520169119255751, 5.583496308781699}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743197990830097`, 5.429345628954441}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6743197990830097`, 5.429345628954441}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.751635164117833, 4.852030263919617}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251635164117833, 4.852030263919617}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.409260036932778, 6.194405391104672}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.909260036932778, 6.194405391104672}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2787201860918764`, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.402720186091876, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7620499515598584`, 6.841615476477592}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262049951559858, 6.841615476477592}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.4027201860918759`, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.278720186091876, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.931632482576383, 6.672032945461067}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316324825763833`, 6.672032945461067}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 2.1587147225743437`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.659260036932778, 1.1637756145745228`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.5287201860918762`, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.152720186091876, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.599387576580599}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.036251578716399, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-6.912251578716399, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.416581053724763}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.751635164117833, 4.852030263919617}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251635164117833, 4.852030263919617}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.409260036932778, 6.194405391104672}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.909260036932778, 6.194405391104672}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5168907011251433`, 6.0867747269123065`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.0168907011251433`, 6.0867747269123065`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324035882469876`, 5.971261839790462}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132403588246988, 5.971261839790462}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6064531542733356`, 4.997212273764115}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-4.106453154273336, 4.997212273764115}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6064531542733356`, 4.997212273764115}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-4.106453154273336, 4.997212273764115}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6064531542733356`, 4.997212273764115}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-4.106453154273336, 4.997212273764115}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.227214785969269}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5270116125934994`, 7.076653815443951}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0270116125934994`, 7.076653815443951}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.090999490513565}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.659260036932778, 1.0845133642886082`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.2919836816486494`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.1527201860918759`, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.528720186091876, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.6527201860918759`, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.028720186091876, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047161811815076`, 6.298949246855942}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.8047161811815076`, 6.298949246855942}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743197990830097`, 5.429345628954441}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6743197990830097`, 5.429345628954441}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020169119255751, 5.583496308781699}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520169119255751, 5.583496308781699}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.8800803260850696`, 5.723585101952381}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.3800803260850696`, 5.723585101952381}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.751635164117833, 4.852030263919617}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251635164117833, 4.852030263919617}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.8800803260850696`, 5.723585101952381}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.3800803260850696`, 5.723585101952381}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.599387576580599}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.416581053724763}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.2917089186300228`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.4722426732562555`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.018874035651734, 6.584791392385716}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.518874035651734, 6.584791392385716}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.2919836816486494`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.5917756376975807`, 
             4.386889790339869}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.341775637697581, 4.386889790339869}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.1622515787163992`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-7.786251578716398, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0917756376975807`, 
             4.386889790339869}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.841775637697581, 4.386889790339869}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.8800803260850696`, 5.723585101952381}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.3800803260850696`, 5.723585101952381}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6064531542733356`, 4.997212273764115}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-4.106453154273336, 4.997212273764115}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047161811815076`, 6.298949246855942}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.8047161811815076`, 6.298949246855942}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.3003070303221036`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.900307030322104, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.5003070303221033`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.7003070303221035`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.3417756376975807`, 
             4.386889790339869}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.591775637697581, 4.386889790339869}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.1003070303221034`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.100307030322104, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0287201860918764`, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.652720186091876, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.7787201860918762`, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.902720186091876, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0917756376975807`, 
             4.386889790339869}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.841775637697581, 4.386889790339869}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.5003070303221033`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.7003070303221035`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.500307030322103, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.7003070303221035`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.726509584019938}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020169119255751, 5.583496308781699}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520169119255751, 5.583496308781699}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047161811815076`, 6.298949246855942}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.8047161811815076`, 6.298949246855942}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.4307829160924542, 2.187398683184928}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.9003070303221032`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.300307030322103, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0917756376975807`, 
             4.386889790339869}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.841775637697581, 4.386889790339869}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.3003070303221036`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.900307030322104, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 2.075684492802124}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.9003070303221032`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.300307030322103, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.500307030322103, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.7003070303221035`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.2909841813155656`, 1.726509584019938}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.100307030322103, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.100307030322104, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820072438863218`, 6.921658184151129}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.182007243886322, 6.921658184151129}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.1003070303221034`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.100307030322104, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6042429605294894`, 6.999422467507961}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1042429605294894`, 6.999422467507961}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7003070303221035`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.500307030322103, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.3417756376975807`, 
             4.386889790339869}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.591775637697581, 4.386889790339869}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7003070303221035`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.500307030322103, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.452179964132715, 7.151485463904735}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.952179964132715, 7.151485463904735}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.6003070303221034`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.600307030322103, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.409260036932778, 6.194405391104672}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.909260036932778, 6.194405391104672}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5168907011251433`, 6.0867747269123065`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.0168907011251433`, 6.0867747269123065`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4797014486341915`, 5.123963979403259}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797014486341915`, 5.123963979403259}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6064531542733356`, 4.997212273764115}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-4.106453154273336, 4.997212273764115}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4797014486341915`, 5.123963979403259}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797014486341915`, 5.123963979403259}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4797014486341915`, 5.123963979403259}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797014486341915`, 5.123963979403259}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.9003070303221032`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.300307030322103, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8467330387898968`, 6.756932389247553}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346733038789897, 6.756932389247553}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.162251578716399, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-6.786251578716398, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.300307030322103, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.900307030322104, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.100307030322103, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.100307030322104, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.9027201860918759`, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.778720186091876, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.4913298239537713`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.5340676054093236`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.9003070303221032`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.300307030322103, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.3417756376975807`, 
             4.386889790339869}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.591775637697581, 4.386889790339869}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.300307030322103, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.900307030322104, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.6003070303221034`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.600307030322103, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6064531542733356`, 4.997212273764115}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-4.106453154273336, 4.997212273764115}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.206735772821304, 6.396929655216146}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706735772821304, 6.396929655216146}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.8800803260850696`, 5.723585101952381}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.3800803260850696`, 5.723585101952381}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.206735772821304, 6.396929655216146}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706735772821304, 6.396929655216146}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751462948262976, 5.8522024797744745`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.2514629482629758`, 5.8522024797744745`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751462948262976, 5.8522024797744745`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.2514629482629758`, 5.8522024797744745`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.1603343472961065`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324035882469876`, 5.971261839790462}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132403588246988, 5.971261839790462}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.227214785969269}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.491654876777717, 2.227214785969269}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0938099618846935`, 4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-4.293809961884693, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.227214785969269}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.090999490513565}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.227214785969269}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.191191469961203}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.4722426732562555`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.4122057429043917`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.206735772821304, 6.396929655216146}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706735772821304, 6.396929655216146}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751462948262976, 5.8522024797744745`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.2514629482629758`, 5.8522024797744745`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.7406415980494447`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.0498221244986778`, 1.726509584019938}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.4226262903672808`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.452179964132715, 7.151485463904735}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.952179964132715, 7.151485463904735}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.902720186091876, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.778720186091876, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.927891643552635}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111425593016979, 6.492239835020471}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.611425593016979, 6.492239835020471}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.2809338454620642`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 1.416581053724763}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.2140221401789375`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.322289031143978}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.3358072689741225`, 5.267858159063328}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.835807268974122, 5.267858159063328}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020169119255751, 5.583496308781699}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520169119255751, 5.583496308781699}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.3358072689741225`, 5.267858159063328}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.835807268974122, 5.267858159063328}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4797014486341915`, 5.123963979403259}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797014486341915`, 5.123963979403259}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.3358072689741225`, 5.267858159063328}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.835807268974122, 5.267858159063328}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.0362515787163986`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-7.912251578716399, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.3749057545736716`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-0.5978370007556204, 1.64113035916659}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-0.662251578716399, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-8.2862515787164, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047161811815076`, 6.298949246855942}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.8047161811815076`, 6.298949246855942}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 1.4967170423699816`}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-1.491654876777717, 2.073423469354273}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0917756376975807`, 
             4.386889790339869}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.841775637697581, 4.386889790339869}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2909841813155656`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4797014486341915`, 5.123963979403259}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797014486341915`, 5.123963979403259}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.8800803260850696`, 5.723585101952381}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.3800803260850696`, 5.723585101952381}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.0289048762432895`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 1.599387576580599}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.303934363203508, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.0839343632035074`, 
             4.386765389021055}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.1499389158334503`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.227214785969269}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.703934363203508, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.683934363203508, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.462149662665384}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.409260036932778, 6.194405391104672}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.909260036932778, 6.194405391104672}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.5824869781268642`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.286251578716399, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.662251578716399, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.8805331812814825`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7787201860918762, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.902720186091876, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.2909841813155656`, 1.497835735852798}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.5432981099295553`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.3796406197516198`, 7.22402480828583}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.8796406197516198`, 7.22402480828583}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751462948262976, 5.8522024797744745`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.2514629482629758`, 5.8522024797744745`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.3358072689741225`, 5.267858159063328}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.835807268974122, 5.267858159063328}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.497835735852798}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.0598714603516792`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.8122154777954373`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0287201860918764`, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.652720186091876, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4797014486341915`, 5.123963979403259}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797014486341915`, 5.123963979403259}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.483934363203508, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.9039343632035077`, 
             4.386765389021055}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 2.075308010398229}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-0.35030703032210353`, 4.386889790339869}], 6., 
            
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-8.850307030322103, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.9569913819232716`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 2.0719132752590443`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.5539252025038417`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 2.28401370740861}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.462149662665384}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.286251578716399, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-6.662251578716399, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.4534856106602139`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5270116125934994`, 7.076653815443951}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0270116125934994`, 7.076653815443951}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8938099618846933`, 4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.4938099618846934`, 4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.8800803260850696`, 5.723585101952381}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.3800803260850696`, 5.723585101952381}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.7147984280919266`, 1.726509584019938}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.5340676054093236`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.9122515787163991, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-8.0362515787164, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1025055612125312`, 2.2648832258100344`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.682505561212531, 2.2648832258100344`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5168907011251433`, 6.0867747269123065`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.0168907011251433`, 6.0867747269123065`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 1.018486244188825}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.5340676054093236`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7620499515598584`, 6.841615476477592}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262049951559858, 6.841615476477592}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.7406415980494447`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.206735772821304, 6.396929655216146}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706735772821304, 6.396929655216146}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.6744763086133228`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.4003070303221032`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.800307030322104, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 1.6384140206706175`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.4003070303221032`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.800307030322104, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.3358072689741225`, 5.267858159063328}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.835807268974122, 5.267858159063328}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.152720186091876, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.528720186091876, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.3358072689741225`, 5.267858159063328}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.835807268974122, 5.267858159063328}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.3540294005326152`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 0.898534010284896}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.5432981099295553`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.018874035651734, 6.584791392385716}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.518874035651734, 6.584791392385716}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.7147984280919266`, 1.497835735852798}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.9661128563728327`, 1.726509584019938}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.2669476034873244`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 1.416581053724763}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.6661962462527091`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751462948262976, 5.8522024797744745`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.2514629482629758`, 5.8522024797744745`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {41.65927981390812, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-50.34072018609188, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2909841813155656`, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.4122057429043917`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.9661128563728327`, 1.497835735852798}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.785741396902492}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.3749057545736716`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 2.0766877534832147`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.6527201860918759, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.028720186091876, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047161811815076`, 6.298949246855942}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.8047161811815076`, 6.298949246855942}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.8177545102789887`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.3177545102789887`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.4017756376975807`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.531775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.2567756376975807`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.676775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.836775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.09677563769758, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.2167756376975807, 
             4.386889790339869}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.71677563769758, 4.386889790339869}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.4307829160924542, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.0498221244986778`, 1.497835735852798}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.4017756376975807`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.531775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 1.416581053724763}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.902704363179782}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.9417756376975808`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.991775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.3796406197516198`, 7.22402480828583}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.8796406197516198`, 7.22402480828583}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.151775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.781775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.621775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.311775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.3407201860918763`, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.340720186091876, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.2919836816486494`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2072749131897207`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 0.9290095042819297}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.621775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.311775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-4.196377287787253, 1.0360274134764884`}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-0.5362515787163987, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-8.412251578716399, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.740720186091876, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.940720186091876, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.521775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.4117756376975805`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.731775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.201775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.2567756376975807`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.676775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.140720186091876, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.540720186091876, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.126775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.806775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.940720186091876, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.740720186091876, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.4722426732562555`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-0.35030703032210353`, 4.386889790339869}], 6., 
            
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-8.850307030322103, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 1.322289031143978}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.9417756376975808`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.991775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.361775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.571775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.6744763086133228`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 1.68510181635509}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.462149662665384}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.836775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.09677563769758, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.017754510278989, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-4.1177545102789885`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.0177545102789884`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.1177545102789885`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.6939343632035078`, 
             4.386765389021055}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.6939343632035078`, 
             4.386765389021055}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.4017756376975807`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.531775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.621775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.311775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7985076962177716, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.151775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.781775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.361775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.571775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.0654001544619962`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.731775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.201775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.227214785969269}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.521775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.4117756376975805`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.2809338454620642`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.5845302767279155`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 2.2927367569392314`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.8056623743970464`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.126775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.806775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.1966460289394751`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.540720186091876, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.140720186091876, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.5340676054093236`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.917754510278989, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.2177545102789886`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.227214785969269}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.7862515787163987, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-8.162251578716399, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 2.1872864686305826`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.836775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.09677563769758, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.5978370007556204, 2.647592232065096}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.126775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.806775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-0.35030703032210353`, 4.386889790339869}], 6., 
            
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-8.850307030322103, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.4753070303221034`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.725307030322103, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.2567756376975807`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.676775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 0.9345235001352147}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.227214785969269}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.4226262903672808`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751462948262976, 5.8522024797744745`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.2514629482629758`, 5.8522024797744745`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.021775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.9117756376975805`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3079303552881687`, 7.295735072749282}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8079303552881685`, 7.295735072749282}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.9267273296385394`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.8177545102789887`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-4.317754510278989, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 2.253709925211909}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.3749057545736716`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2909841813155656`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.295731171742312, 1.4883995840570443`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.041731171742312, 1.4883995840570443`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.717754510278989, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.417754510278989, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.3281354469463584`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.6177545102789885`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.5177545102789884`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.021775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.9117756376975805`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0677442045680727`, 2.3456445824544927`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.5557442045680727`, 2.3456445824544927`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             1.0281898243715637`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.3177545102789887`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.8177545102789887`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.2167756376975807, 
             4.386889790339869}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.71677563769758, 4.386889790339869}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.117754510278989, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-4.017754510278989, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9517395362418175, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7957395362418174`, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.617754510278989, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-4.517754510278989, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7985076962177716, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.4534856106602139`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7985076962177716, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.7177545102789888`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-4.417754510278988, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.417754510278989, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.7177545102789886`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 0.766397642299538}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.5978370007556204, 1.726509584019938}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.4079456086518722`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 0.8028980445190645}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 1.191191469961203}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.3749057545736716`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.8056623743970464`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.1499389158334503`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.9177545102789888`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-4.217754510278989, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.5978370007556204, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.5177545102789884`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.617754510278989, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.2917089186300228`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.227214785969269}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9316022156830935, 1.8625285401162623`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.657602215683094, 1.8625285401162623`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.825050624991675, 1.864080130807681}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.761050624991675, 1.864080130807681}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             0.8977193462887197}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.5824869781268642`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7447395362418174, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0027395362418177`, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 1.7833912195575383`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.3749057545736716`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.7310506249916748, 1.864080130807681}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8550506249916747`, 1.864080130807681}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 1.416581053724763}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.462149662665384}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 1.0335402919243948`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.409260036932778, 6.194405391104672}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.909260036932778, 6.194405391104672}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.462149662665384}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.5539252025038417`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.5845302767279155`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5287201860918762, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.152720186091877, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 2.4176979000945504`}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1534763793552227`, 1.4906543764441336`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1794763793552225`, 1.4906543764441336`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0644216224248022`, 1.7817091333745536`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.686421622424802, 1.7817091333745536`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 0.7975071958841882}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.0498221244986778`, 2.647592232065096}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             1.1597073880279205`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.2177545102789886`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.917754510278989, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.206735772821304, 6.396929655216146}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706735772821304, 6.396929655216146}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.462149662665384}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.9368694044031642`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.8162894669713328`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.4079456086518722`, 1.497835735852798}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.140720186091876, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.540720186091876, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8819167234078878, 2.0082140323914683`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.415916723407888, 2.0082140323914683`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 0.766397642299538}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.010828981280643, 1.937301774518713}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.4288289812806427`, 1.937301774518713}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.0598714603516792`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.9058289812806428, 1.937301774518713}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5338289812806427`, 1.937301774518713}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.931632482576383, 6.672032945461067}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316324825763833`, 6.672032945461067}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-0.3492515787163989, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-8.5992515787164, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.5340676054093236`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0202266596212073`, 1.4929040961781488`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.308226659621207, 1.4929040961781488`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.5824869781268642`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820072438863218`, 6.921658184151129}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.182007243886322, 6.921658184151129}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.4590800308455383`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6547395362418175, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0927395362418175`, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.715777948205427}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9715151471242033, 1.6956156086751528`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.951515147124203, 1.6956156086751528`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.120743179218757, 1.599387576580599}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9947431792187573`, 1.599387576580599}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.68510181635509}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6666819660425423, 1.6974487897568136`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.2526819660425423`, 1.6974487897568136`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 1.144222799920162}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.2667756376975805`, 4.386889790339869}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-6.666775637697581, 4.386889790339869}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 2.0759354023505483`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.9957431792187569, 1.599387576580599}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-3.119743179218757, 1.599387576580599}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.2072749131897207`, 1.726509584019938}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 1.599387576580599}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.5177545102789887`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-4.6177545102789885`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.452179964132715, 7.151485463904735}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.952179964132715, 7.151485463904735}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.7406415980494447`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4938099618846934`, 4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-4.893809961884693, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.8058289812806427, 1.937301774518713}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.633828981280643, 1.937301774518713}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4117654245995248`, 1.5973653311998313`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7077654245995246`, 1.5973653311998313`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7143890962226553, 1.9387416595767009`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7223890962226553`, 1.9387416595767009`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.7409075149860491`, 6.862757913051401}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.240907514986049, 6.862757913051401}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111425593016979, 6.492239835020471}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.611425593016979, 6.492239835020471}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 1.2669476034873244`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.995732273553991, 1.2669476034873244`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.5340676054093236`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0380506249916748`, 1.864080130807681}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.548050624991675, 1.864080130807681}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.7409075149860491`, 6.862757913051401}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.240907514986049, 6.862757913051401}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 1.9254158540407285`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             1.2908841763152323`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111425593016979, 6.492239835020471}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.611425593016979, 6.492239835020471}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6644114819959424`, 6.939253946041508}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164411481995942, 6.939253946041508}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6644114819959424`, 6.939253946041508}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164411481995942, 6.939253946041508}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.931632482576383, 6.672032945461067}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316324825763833`, 6.672032945461067}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.018874035651734, 6.584791392385716}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.518874035651734, 6.584791392385716}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.0335402919243948`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             1.2756420910162956`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.227214785969269}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.9368694044031642`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 1.599387576580599}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.018874035651734, 6.584791392385716}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.518874035651734, 6.584791392385716}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8467330387898968`, 6.756932389247553}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346733038789897, 6.756932389247553}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6416022156830935, 1.8625285401162623`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9476022156830934`, 1.8625285401162623`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.1603343472961065`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             0.8055826098897335}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8192083653998068`, 6.784457062637643}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3192083653998066`, 6.784457062637643}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7832599069543554, 2.0068708488450007`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5172599069543553`, 2.0068708488450007`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8192083653998068`, 6.784457062637643}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3192083653998066`, 6.784457062637643}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.931632482576383, 6.672032945461067}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316324825763833`, 6.672032945461067}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7797109156908187, 1.6034198401085373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.3277109156908184`, 1.6034198401085373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2647917677447573`, 1.5953389880545987`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8587917677447576`, 1.5953389880545987`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047161811815076`, 6.298949246855942}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.8047161811815076`, 6.298949246855942}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8992510730733434`, 6.704414354964107}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3992510730733434`, 6.704414354964107}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047161811815076`, 6.298949246855942}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.8047161811815076`, 6.298949246855942}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.4177545102789888`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-4.717754510278988, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.412251578716399, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-6.536251578716398, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.995732273553991, 1.0335402919243948`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8992510730733434`, 6.704414354964107}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3992510730733434`, 6.704414354964107}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.7985076962177716, 1.497835735852798}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.9809291040876105`, 6.62273632394984}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809291040876102`, 6.62273632394984}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.206735772821304, 6.396929655216146}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706735772821304, 6.396929655216146}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.206735772821304, 6.396929655216146}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706735772821304, 6.396929655216146}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.409260036932778, 6.194405391104672}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.909260036932778, 6.194405391104672}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.462149662665384}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             0.9364854391596744}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.7985076962177716, 1.726509584019938}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7620499515598584`, 6.841615476477592}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262049951559858, 6.841615476477592}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.995732273553991, 0.8046885552928528}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7626819660425422, 1.6974487897568136`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1566819660425423`, 1.6974487897568136`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8467330387898968`, 6.756932389247553}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346733038789897, 6.756932389247553}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5897499532269226`, 7.013915474810528}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0897499532269226`, 7.013915474810528}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 1.5377270648801}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.409260036932778, 6.194405391104672}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.909260036932778, 6.194405391104672}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.2787201860918764`, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.402720186091876, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0640794724197806`, 6.539585955617669}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640794724197806`, 6.539585955617669}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 1.406587064387653}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5897499532269226`, 7.013915474810528}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0897499532269226`, 7.013915474810528}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1213890962226554`, 1.9387416595767009`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3153890962226553`, 1.9387416595767009`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 1.599387576580599}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 1.416581053724763}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.6268289812806428, 1.937301774518713}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8128289812806426`, 1.937301774518713}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.521775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.4117756376975805`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-6.214608098422191, 2.0471765810925606`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6969167234078879, 2.0082140323914683`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6009167234078876`, 2.0082140323914683`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5168907011251433`, 
             6.0867747269123065`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.0168907011251433`, 
             6.0867747269123065`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820072438863218`, 6.921658184151129}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.182007243886322, 6.921658184151129}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.7985076962177716, 2.647592232065096}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5168907011251433`, 
             6.0867747269123065`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.0168907011251433`, 
             6.0867747269123065`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.0654001544619962`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5560506249916749, 1.864080130807681}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-3.030050624991675, 1.864080130807681}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3079303552881687`, 7.295735072749282}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8079303552881685`, 7.295735072749282}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1484668646973284`, 6.455198563340122}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.648466864697328, 6.455198563340122}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-6.571283042360924, 1.7328937163610187`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7620499515598584`, 6.841615476477592}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262049951559858, 6.841615476477592}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.5978370007556204, 2.647592232065096}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.9809291040876105`, 6.62273632394984}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809291040876102`, 6.62273632394984}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.5978370007556204, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5169274935268733`, 7.086737934510577}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.016927493526873, 7.086737934510577}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0602174805403115`, 2.0719132752590443`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.1102174805403116`, 2.0719132752590443`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1525014380048455`, 1.8656293177945105`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.4305014380048457`, 1.8656293177945105`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.7985076962177716, 2.647592232065096}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.4722426732562555`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.9846048970696881, 2.005525858729668}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3186048970696884`, 2.005525858729668}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.662251578716399, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-8.2862515787164, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             1.8002235476401844`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 1.715777948205427}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6042429605294894`, 6.999422467507961}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1042429605294894`, 6.999422467507961}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8038099618846937`, 4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-4.583809961884693, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324035882469876`, 5.971261839790462}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132403588246988, 5.971261839790462}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 1.669026703845758}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.2072749131897207`, 1.497835735852798}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7985076962177716, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8584777201525995, 2.0706530356467567`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3144777201525994`, 2.0706530356467567`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820072438863218`, 6.921658184151129}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.182007243886322, 6.921658184151129}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.3177545102789887`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-4.817754510278989, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.1966460289394751`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324035882469876`, 5.971261839790462}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132403588246988, 5.971261839790462}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.878743179218757, 1.599387576580599}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.2367431792187573`, 1.599387576580599}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.5902550930173265`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 2.296667619230008}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2738099618846935, 4.386889790339869}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-6.1138099618846935`, 4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0640794724197806`, 6.539585955617669}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640794724197806`, 6.539585955617669}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.2406373244969853`, 6.363028103540465}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7406373244969853`, 6.363028103540465}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.9474803442248305`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-7.1308988302963465`, 1.445270566220188}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5169274935268733`, 7.086737934510577}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.016927493526873, 7.086737934510577}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9542174805403115, 2.0719132752590443`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.216217480540312, 2.0719132752590443`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.2177545102789886`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-4.917754510278989, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5270116125934994`, 7.076653815443951}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0270116125934994`, 7.076653815443951}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6042429605294894`, 6.999422467507961}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1042429605294894`, 6.999422467507961}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.1177545102789888`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-5.017754510278989, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             1.0678093795130645`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 1.416581053724763}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.8162894669713328`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9291484471914904, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.11914844719149, 2.1329823086078656`}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-2.408776554863201, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-3.808776554863201, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.719319793360441}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111425593016979, 6.492239835020471}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.611425593016979, 6.492239835020471}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.018486244188825}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             0.9345235001352147}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7461484471914903, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3021484471914904`, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-5.744604469176456, 2.0471765810925606`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             2.0680013515372804`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8999819897673833, 1.4951487660319727`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.423981989767383, 1.4951487660319727`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0338000182722134`, 2.418588768750352}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.4438000182722135`, 2.418588768750352}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.3540294005326152`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.227214785969269}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.018874035651734, 6.584791392385716}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.518874035651734, 6.584791392385716}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-6.607650686531799, 1.445270566220188}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             0.9290095042819297}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5826819660425423, 1.6974487897568136`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.3366819660425424`, 1.6974487897568136`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334569144331189, 6.269096283706261}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834569144331189, 6.269096283706261}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1484668646973284`, 6.455198563340122}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.648466864697328, 6.455198563340122}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047161811815076`, 6.298949246855942}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.8047161811815076`, 6.298949246855942}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.931632482576383, 6.672032945461067}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316324825763833`, 6.672032945461067}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.452179964132715, 7.151485463904735}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.952179964132715, 7.151485463904735}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.445929943787544, 7.157735484249907}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.945929943787544, 7.157735484249907}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7649588271331155, 2.0731719286662407`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.4029588271331153`, 2.0731719286662407`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.409260036932778, 6.194405391104672}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.909260036932778, 6.194405391104672}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.2909841813155656`, 2.414126467726953}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             1.9313764735639716`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 0.8046885552928528}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.206735772821304, 6.396929655216146}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706735772821304, 6.396929655216146}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.227214785969269}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             0.8028980445190645}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5270116125934994`, 7.076653815443951}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0270116125934994`, 7.076653815443951}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.8343339837855921, 2.131796772013764}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.2163339837855918`, 2.131796772013764}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5704216224248023, 1.7817091333745536`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1804216224248023`, 1.7817091333745536`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751462948262976, 5.8522024797744745`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.2514629482629758`, 
             5.8522024797744745`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.227214785969269}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6307311717423119`, 1.4883995840570443`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.706731171742312, 1.4883995840570443`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2909841813155656`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751462948262976, 5.8522024797744745`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.2514629482629758`, 
             5.8522024797744745`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.3281354469463584`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.5978370007556204, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.4307829160924542, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.4590800308455383`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6407201860918759`, 
             4.512945241945574}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.040720186091876, 
             4.512945241945574}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.227214785969269}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5168907011251433`, 
             6.0867747269123065`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.0168907011251433`, 
             6.0867747269123065`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8467330387898968`, 6.756932389247553}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346733038789897, 6.756932389247553}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.6538099618846934, 4.386889790339869}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-5.733809961884694, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3796406197516198`, 7.22402480828583}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8796406197516198`, 7.22402480828583}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.0289048762432895`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.230191621853512, 1.691939133945844}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.700191621853512, 1.691939133945844}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0943516949315049`, 1.6937790608678513`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.832351694931505, 1.6937790608678513`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.893934363203508, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.493934363203508, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4298793241355137`, 6.173786103901937}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9298793241355137`, 6.173786103901937}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8440602747220977, 1.7850704810772584`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.900060274722098, 1.7850704810772584`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-0.8503070303221034, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-8.350307030322103, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.2406373244969853`, 6.363028103540465}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7406373244969853`, 6.363028103540465}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.445929943787544, 7.157735484249907}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.945929943787544, 7.157735484249907}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0889167234078876`, 2.0082140323914683`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.208916723407888, 2.0082140323914683`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5472709425975442, 1.9358598132018119`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.895270942597544, 1.9358598132018119`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.6787431792187568, 1.599387576580599}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-3.436743179218757, 1.599387576580599}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.021775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.9117756376975805`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.452179964132715, 7.151485463904735}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.952179964132715, 7.151485463904735}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-2.213776554863201, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-4.003776554863201, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.101092789211817, 0.7802418874108791}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7620499515598584`, 6.841615476477592}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262049951559858, 6.841615476477592}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324035882469876`, 5.971261839790462}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132403588246988, 5.971261839790462}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.2667756376975805`, 
             4.386889790339869}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-6.666775637697581, 
             4.386889790339869}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-7.600902459542082, 1.2424239907001886`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2025753415836864`, 2.0095554142156695`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0925753415836867`, 2.0095554142156695`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.7406415980494447`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334569144331189, 6.269096283706261}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834569144331189, 6.269096283706261}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6792174805403116, 2.0719132752590443`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.491217480540312, 2.0719132752590443`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.0177545102789889`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-5.1177545102789885`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.8002235476401844`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3079303552881687`, 7.295735072749282}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8079303552881685`, 7.295735072749282}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7909819897673834, 1.4951487660319727`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.5329819897673835`, 1.4951487660319727`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             1.4219027885872582`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-5.991464547107982, 1.445270566220188}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.8800803260850696`, 5.723585101952381}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.3800803260850696`, 5.723585101952381}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.669026703845758}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.0281898243715637`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.6126048970696883, 2.005525858729668}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6906048970696883`, 2.005525858729668}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.412251578716399, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.536251578716398, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.8800803260850696`, 5.723585101952381}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.3800803260850696`, 5.723585101952381}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-5.298317366548036, 2.0471765810925606`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7667756376975805`, 
             4.386889790339869}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.16677563769758, 
             4.386889790339869}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.49106027472209773`, 1.7850704810772584`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.2530602747220976`, 1.7850704810772584`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             1.1990607599649155`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3767294095441613`, 7.226936018493289}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8767294095441613`, 7.226936018493289}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1867395362418174`, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5607395362418175`, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.3749057545736716`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.7409075149860491`, 6.862757913051401}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.240907514986049, 6.862757913051401}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3796406197516198`, 7.22402480828583}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8796406197516198`, 7.22402480828583}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820072438863218`, 6.921658184151129}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.182007243886322, 6.921658184151129}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.53523983979334, 6.068425588244111}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.03523983979334, 6.068425588244111}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-7.1308988302963465`, 1.2424239907001886`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-7.1308988302963465`, 1.7328937163610187`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7667756376975805`, 
             4.386889790339869}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.16677563769758, 
             4.386889790339869}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 1.5377270648801}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8192083653998068`, 6.784457062637643}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3192083653998066`, 6.784457062637643}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6644114819959424`, 6.939253946041508}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164411481995942, 6.939253946041508}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-6.032286541628237, 1.7328937163610187`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.238485302016438, 7.365180126021013}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7384853020164377`, 7.365180126021013}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1407201860918759`, 
             4.512945241945574}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.540720186091876, 
             4.512945241945574}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-5.2030071867437115`, 2.3933394562625097`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1301484471914902`, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9181484471914902`, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.4307829160924542, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4298793241355137`, 6.173786103901937}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9298793241355137`, 6.173786103901937}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.9417756376975808`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.991775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.2667756376975805`, 
             4.386889790339869}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-6.666775637697581, 
             4.386889790339869}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5992174805403118, 2.0719132752590443`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5712174805403114`, 2.0719132752590443`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             2.0624225365102413`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.238485302016438, 7.365180126021013}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7384853020164377`, 7.365180126021013}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.9177545102789888, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-5.217754510278989, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.406587064387653}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751462948262976, 5.8522024797744745`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.2514629482629758`, 
             5.8522024797744745`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.151775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.781775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6042429605294894`, 6.999422467507961}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1042429605294894`, 6.999422467507961}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.40272018609187604`, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.278720186091876, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3767294095441613`, 7.226936018493289}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8767294095441613`, 7.226936018493289}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.731775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.201775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.9313764735639716`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.5902550930173265`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6621484471914904, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3861484471914904`, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.740720186091876, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.940720186091876, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.8470364847178946`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3079303552881687`, 7.295735072749282}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8079303552881685`, 7.295735072749282}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4816022156830936, 1.8625285401162623`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1076022156830936`, 1.8625285401162623`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.8470364847178946`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020169119255751, 5.583496308781699}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520169119255751, 5.583496308781699}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.4307829160924542, 2.647592232065096}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             0.898534010284896}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8992510730733434`, 6.704414354964107}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3992510730733434`, 6.704414354964107}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0301484471914903`, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0181484471914906`, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.5824869781268642`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.3754861624032872`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             0.8977193462887197}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.53523983979334, 6.068425588244111}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.03523983979334, 6.068425588244111}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0052369104845442`, 2.498151876538021}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.3132369104845443`, 2.498151876538021}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1682174805403114`, 2.0719132752590443`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0022174805403115`, 2.0719132752590443`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.3749057545736716`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.4079456086518722`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020169119255751, 5.583496308781699}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520169119255751, 5.583496308781699}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-7.600902459542082, 0.973049065692764}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5897499532269226`, 7.013915474810528}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0897499532269226`, 7.013915474810528}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.462149662665384}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             2.0680013515372804`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.6167765548632014`, 4.386765389021055}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-3.600776554863201, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.4307829160924542, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 2.075809955445786}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.9474803442248305`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.47282898128064277`, 1.937301774518713}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.966828981280643, 1.937301774518713}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6939819897673835, 1.4951487660319727`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.629981989767383, 1.4951487660319727`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2072749131897207`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.45995169862006674`, 2.004179057179289}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.845951698620067, 2.004179057179289}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1699988878712817`, 7.433666540166168}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6699988878712817`, 7.433666540166168}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5270116125934994`, 7.076653815443951}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0270116125934994`, 7.076653815443951}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7667756376975805`, 4.386889790339869}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-7.16677563769758, 4.386889790339869}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3092881287486289`, 7.294377299288821}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8092881287486289`, 7.294377299288821}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5015151471242032, 1.6956156086751528`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.4215151471242033`, 1.6956156086751528`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.642660088414177, 5.961005339623274}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1426600884141767`, 5.961005339623274}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.9809291040876105`, 6.62273632394984}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809291040876102`, 6.62273632394984}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             2.1992225799988927`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.140720186091876, 
             4.512945241945574}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-6.540720186091876, 
             4.512945241945574}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.1597073880279205`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.5067405141957577`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.238485302016438, 7.365180126021013}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7384853020164377`, 7.365180126021013}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.642660088414177, 5.961005339623274}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1426600884141767`, 5.961005339623274}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5212174805403116, 2.0719132752590443`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6492174805403117`, 2.0719132752590443`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             0.8055826098897335}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 2.078566158643882}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.8800803260850696`, 5.723585101952381}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.3800803260850696`, 5.723585101952381}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5342599069543554, 2.0068708488450007`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7662599069543554`, 2.0068708488450007`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5079643144302738, 2.134166441369082}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5379643144302735`, 2.134166441369082}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3092881287486289`, 7.294377299288821}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8092881287486289`, 7.294377299288821}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5169274935268733`, 7.086737934510577}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.016927493526873, 7.086737934510577}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             2.0624225365102413`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.452179964132715, 7.151485463904735}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.952179964132715, 7.151485463904735}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2667756376975805`, 
             4.386889790339869}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.66677563769758, 
             4.386889790339869}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.0678093795130645`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 1.721515815839451}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.7693434299437227`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0640794724197806`, 6.539585955617669}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640794724197806`, 6.539585955617669}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.4307829160924542, 1.726509584019938}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.102583303777579, 7.501082124259871}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.602583303777579, 7.501082124259871}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.763023770664052, 5.840641657373398}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263023770664052, 5.840641657373398}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 2.193662685769859}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0938099618846935`, 4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-3.293809961884693, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             0.766397642299538}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-8.111728083308073, 0.973049065692764}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.900464386136271}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.763023770664052, 5.840641657373398}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263023770664052, 5.840641657373398}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.4079456086518722`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.2908841763152323`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.462149662665384}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.0794415416798357`, 2.187398683184928}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.3524072174927233`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.031563461435372}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.5824869781268642`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2072749131897207`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.638025369286013}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1484668646973284`, 6.455198563340122}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.648466864697328, 6.455198563340122}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1699988878712817`, 7.433666540166168}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6699988878712817`, 7.433666540166168}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047161811815076`, 6.298949246855942}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.8047161811815076`, 6.298949246855942}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 
             2.1627481478062465`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             0.9364854391596744}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2435614550482985`, 7.360103972989152}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.7435614550482983`, 7.360103972989152}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.995732273553991, 1.497835735852798}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 1.900464386136271}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.2756420910162956`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2369512814530277`, 1.9401794743463283`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.196951281453028, 1.9401794743463283`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3796406197516198`, 7.22402480828583}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8796406197516198`, 7.22402480828583}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-8.047189562170502, 1.2424239907001886`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.456731171742312, 1.4883995840570443`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.880731171742312, 1.4883995840570443`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.1627481478062465`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.886637726631229, 5.717027701406222}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.3866377266312284`, 5.717027701406222}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 1.497835735852798}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 2.031563461435372}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.2406373244969853`, 6.363028103540465}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7406373244969853`, 6.363028103540465}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5917109156908188, 1.6034198401085373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.5157109156908186`, 1.6034198401085373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             0.7975071958841882}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0363197520242107`, 7.56734567601324}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5363197520242107`, 7.56734567601324}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.8177545102789887, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-5.317754510278989, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.4079456086518722`, 1.726509584019938}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.445929943787544, 7.157735484249907}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.945929943787544, 7.157735484249907}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020169119255751, 5.583496308781699}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520169119255751, 5.583496308781699}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-4.3428059215206005`, 2.6490076604684267`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 
             1.3754861624032872`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             2.193662685769859}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.361775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.571775637697581, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 
             1.7693434299437227`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-6.571283042360924, 2.0471765810925606`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.227214785969269}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 2.2976730486330252`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 2.293947899598382}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-7.600902459542082, 1.445270566220188}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5828222252951392`, 1.5933085305042167`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5448222252951394`, 1.5933085305042167`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5821484471914904, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.4661484471914905`, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 
             1.5067405141957577`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7667756376975805, 
             4.386889790339869}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.166775637697581, 
             4.386889790339869}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.102583303777579, 7.501082124259871}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.602583303777579, 7.501082124259871}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 1.638025369286013}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.721515815839451}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.4219027885872582`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0126784475265938`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.5126784475265938`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.886637726631229, 5.717027701406222}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.3866377266312284`, 5.717027701406222}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2435614550482985`, 7.360103972989152}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.7435614550482983`, 7.360103972989152}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.1990607599649155`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.369191621853512, 1.691939133945844}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5611916218535122`, 1.691939133945844}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3079303552881687`, 7.295735072749282}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8079303552881685`, 7.295735072749282}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324035882469876`, 5.971261839790462}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132403588246988, 5.971261839790462}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.719319793360441}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             1.3302529702362658`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.605170185988091, 2.3933394562625097`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5067250150625199, 1.601405740736836}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-3.60472501506252, 1.601405740736836}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334569144331189, 6.269096283706261}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834569144331189, 6.269096283706261}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5168907011251433`, 
             6.0867747269123065`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.0168907011251433`, 
             6.0867747269123065`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2789588271331154`, 2.0731719286662407`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8889588271331152`, 2.0731719286662407`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.179500146995422, 7.424165281042028}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.679500146995422, 7.424165281042028}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.409260036932778, 6.194405391104672}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.909260036932778, 6.194405391104672}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.144222799920162}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.462149662665384}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-6.502290170873972, 1.2424239907001886`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             1.5532907518110994`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9712643014359971, 
             7.6324011266014535`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.471264301435997, 7.6324011266014535`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             2.078566158643882}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             2.3243465847755584`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.3796406197516198`, 7.22402480828583}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.8796406197516198`, 7.22402480828583}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.293947899598382}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2667756376975805`, 
             4.386889790339869}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.66677563769758, 
             4.386889790339869}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-6.214608098422191, 2.3933394562625097`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.3524072174927233`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751462948262976, 5.8522024797744745`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.2514629482629758`, 
             5.8522024797744745`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047161811815076`, 6.298949246855942}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.8047161811815076`, 6.298949246855942}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.710818829244043, 5.66988092298052}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1108188292440433`, 5.66988092298052}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8200181212090352`, 5.560681631015528}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2200181212090353`, 5.560681631015528}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6123787564307905`, 5.768320995793772}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0123787564307904`, 5.768320995793772}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.462149662665384}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2361484471914903`, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8121484471914904`, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4298793241355137`, 6.173786103901937}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9298793241355137`, 6.173786103901937}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 
             0.7802418874108791}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3767294095441613`, 7.226936018493289}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8767294095441613`, 7.226936018493289}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 2.424802725718295}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.5978370007556204, 1.497835735852798}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4945957207744072`, 5.886104031450156}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.894595720774407, 5.886104031450156}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9000608288825716`, 5.480638923341991}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3000608288825717`, 5.480638923341991}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0363197520242107`, 7.56734567601324}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5363197520242107`, 7.56734567601324}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.864704011147587, 1.3326298365341978`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.227214785969269}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-5.744604469176456, 1.7328937163610187`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.560886452648562, 4.969813299576001}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.6608864526485623`, 4.969813299576001}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.238485302016438, 7.365180126021013}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7384853020164377`, 7.365180126021013}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3254849243813491`, 1.776645831418007}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.4354849243813494`, 1.776645831418007}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 1.599387576580599}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.238485302016438, 7.365180126021013}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7384853020164377`, 7.365180126021013}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.8800803260850696`, 5.723585101952381}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.3800803260850696`, 5.723585101952381}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3892352051165808`, 5.991464547107982}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.789235205116581, 5.991464547107982}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9870722058722012`, 5.393627546352362}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3870722058722014`, 5.393627546352362}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.7177545102789886, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-5.417754510278988, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-5.2030071867437115`, 1.7328937163610187`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.101092789211817, 0.911479174876933}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.310886452648562, 4.969813299576001}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.9108864526485623`, 4.969813299576001}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.206735772821304, 6.396929655216146}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706735772821304, 6.396929655216146}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 2.330200260027019}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111425593016979, 6.492239835020471}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.611425593016979, 6.492239835020471}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.6177545102789884, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-5.517754510278989, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0126784475265938`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.5126784475265938`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1569280563711404`, 5.44673737166631}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569280563711404`, 5.44673737166631}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.179500146995422, 7.424165281042028}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.679500146995422, 7.424165281042028}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             2.1992225799988927`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.53523983979334, 6.068425588244111}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.03523983979334, 6.068425588244111}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2939250253122558`, 6.0867747269123065`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.693925025312256, 6.0867747269123065`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4492174805403117, 2.0719132752590443`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7212174805403113`, 2.0719132752590443`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.199705077879927, 4.787491742782046}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0823823856765262`, 5.298317366548036}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.482382385676526, 5.298317366548036}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-1.584776554863201, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-4.632776554863201, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-7.1308988302963465`, 0.973049065692764}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.1687119638680197`, 5.111987788356544}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.7687119638680198`, 5.111987788356544}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.424802725718295}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2069136483226262`, 6.173786103901937}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6069136483226263`, 6.173786103901937}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1148124723039907`, 7.488852955733459}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6148124723039907`, 7.488852955733459}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.906544110754825, 7.697121317282625}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4065441107548249`, 7.697121317282625}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.4187119638680197`, 5.111987788356544}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.5187119638680198`, 5.111987788356544}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6005077093724622, 1.4996230464268938`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.714507709372462, 1.4996230464268938`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.710818829244043, 5.66988092298052}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1108188292440433`, 5.66988092298052}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8200181212090352`, 5.560681631015528}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2200181212090353`, 5.560681631015528}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020169119255751, 5.583496308781699}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520169119255751, 5.583496308781699}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1877429013343526`, 5.19295685089021}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5877429013343525`, 5.19295685089021}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8639343632035077`, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-4.523934363203508, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.8526977673331346`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.863232841258714, 0.8333438110532289}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.6661962462527091`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4170602747220977, 1.7850704810772584`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.327060274722098, 1.7850704810772584`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.018874035651734, 6.584791392385716}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.518874035651734, 6.584791392385716}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.1850957485562468`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9870722058722012`, 5.393627546352362}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3870722058722014`, 5.393627546352362}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.6888794541139363`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6123787564307905`, 5.768320995793772}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0123787564307904`, 5.768320995793772}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9000608288825716`, 5.480638923341991}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3000608288825717`, 5.480638923341991}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 0.9925107577855641}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.642660088414177, 5.961005339623274}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1426600884141767`, 5.961005339623274}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-1.984131361875511, 7.003065458786462}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6042429605294894`, 6.999422467507961}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1042429605294894`, 6.999422467507961}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.0232043801967814`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.6232043801967815`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1699988878712817`, 7.433666540166168}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6699988878712817`, 7.433666540166168}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4361484471914903, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6121484471914904`, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1078227456783951`, 6.272877006546167}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5078227456783952`, 6.272877006546167}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9712643014359971, 
             7.6324011266014535`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.471264301435997, 7.6324011266014535`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-7.957577403480815, 0.8046885552928528}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.935344432243678, 5.768320995793772}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.235344432243678, 5.768320995793772}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.5532907518110994`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4945957207744072`, 5.886104031450156}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.894595720774407, 5.886104031450156}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.305525936990736, 5.075173815233827}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.705525936990736, 5.075173815233827}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 1.170932950247736}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0823823856765262`, 5.298317366548036}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.482382385676526, 5.298317366548036}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.931632482576383, 6.672032945461067}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316324825763833`, 6.672032945461067}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.9782390361706734`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.3749057545736716`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.4365120772805082`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-6.437751649736401, 0.973049065692764}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3892352051165808`, 5.991464547107982}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.789235205116581, 5.991464547107982}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3092881287486289`, 7.294377299288821}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8092881287486289`, 7.294377299288821}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.9782390361706734`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-5.298317366548036, 2.6490076604684267`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1877429013343526`, 5.19295685089021}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5877429013343525`, 5.19295685089021}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 1.599387576580599}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.7667756376975805, 4.386889790339869}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-8.166775637697581, 4.386889790339869}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.4108864526485623`, 4.969813299576001}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.810886452648562, 4.969813299576001}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-2.027776554863201, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-4.189776554863201, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.1167795926235586`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.227214785969269}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 0.8307328435125084}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-5.403677882205863, 1.445270566220188}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.3681303904922195`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 6.684611727667927}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3982709425975442, 1.9358598132018119`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.044270942597544, 1.9358598132018119`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.618595850218866}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.4569857892424236`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.8870722058722011`, 5.393627546352362}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.487072205872201, 5.393627546352362}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1569280563711404`, 5.44673737166631}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569280563711404`, 5.44673737166631}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.0519532126861397`, 7.55171221535131}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5519532126861397`, 7.55171221535131}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2732043801967814`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.373204380196781, 5.2574953720277815`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8592388343623163`, 5.521460917862246}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2592388343623164`, 5.521460917862246}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.305525936990736, 5.075173815233827}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.705525936990736, 5.075173815233827}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-5.809142990314028, 1.2424239907001886`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1148124723039907`, 7.488852955733459}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6148124723039907`, 7.488852955733459}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0005772153247978`, 6.380122536899765}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4005772153247977`, 6.380122536899765}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3205753415836865`, 2.0095554142156695`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9745753415836864`, 2.0095554142156695`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.2687119638680198`, 5.111987788356544}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.6687119638680197`, 5.111987788356544}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.763023770664052, 5.840641657373398}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263023770664052, 5.840641657373398}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2939250253122558`, 6.0867747269123065`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.693925025312256, 6.0867747269123065`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.7406415980494447`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.8440512773405471, 7.759614150696903}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.344051277340547, 7.759614150696903}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.7929254558680243`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 2.209811692841691}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.6108369333478076`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0823823856765262`, 5.298317366548036}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.482382385676526, 5.298317366548036}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.6407201860918759, 
             4.512945241945574}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.040720186091876, 
             4.512945241945574}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.359436906950008}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.7083778602890038`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.945732273553991, 
              Log[400]}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-3.0457322735539907`, 
              Log[400]}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390573296152587`, 4.941642422609304}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.8390573296152586`, 4.941642422609304}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9870722058722012`, 5.393627546352362}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3870722058722014`, 5.393627546352362}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6441274547453708`, 5.736572297479192}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0441274547453707`, 5.736572297479192}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4939343632035076`, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.893934363203508, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.864704011147587, 1.5067405141957577`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8625151471242033, 1.6956156086751528`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.060515147124203, 1.6956156086751528`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7459101490553133`, 5.634789603169249}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.145910149055313, 5.634789603169249}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8467330387898968`, 6.756932389247553}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346733038789897, 6.756932389247553}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.5362515787163987, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-8.412251578716399, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.227214785969269}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.102583303777579, 7.501082124259871}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.602583303777579, 7.501082124259871}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.1232043801967815`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.5232043801967814`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 0.8989410935390421}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[$CellContext`\[FivePointedStar], {-2.8957322735539908`, 
              Log[400]}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[$CellContext`\[FivePointedStar], {-3.095732273553991, 
              Log[400]}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.7433654852060263`, 5.537334267018537}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.3433654852060264`, 5.537334267018537}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2069136483226262`, 6.173786103901937}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6069136483226263`, 6.173786103901937}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5517541346143557`, 5.8289456176102075`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9517541346143557`, 5.8289456176102075`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-2.995732273553991, 5.991464547107982}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.3302529702362658`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8192083653998068`, 6.784457062637643}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3192083653998066`, 6.784457062637643}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390573296152587`, 4.941642422609304}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.8390573296152586`, 4.941642422609304}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.906544110754825, 7.697121317282625}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4065441107548249`, 7.697121317282625}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.2787091504399533`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.1407201860918759`, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.540720186091876, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[$CellContext`\[FivePointedStar], {-2.7957322735539907`, 
              Log[400]}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[$CellContext`\[FivePointedStar], {-3.195732273553991, 
              Log[400]}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             2.3243465847755584`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.9870722058722012`, 5.393627546352362}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.3870722058722014`, 5.393627546352362}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 0.911479174876933}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.7957322735539907`, 
              Log[400]}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-3.195732273553991, 
              Log[400]}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.7710464276305133`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.3608864526485625`, 4.969813299576001}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.860886452648562, 4.969813299576001}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.9933654852060263`, 5.537334267018537}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.0933654852060264`, 5.537334267018537}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8089819897673833`, 1.4951487660319727`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5149819897673833`, 1.4951487660319727`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.90372738933488, 6.476972362889683}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3037273893348802`, 6.476972362889683}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.7409075149860491`, 6.862757913051401}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.240907514986049, 6.862757913051401}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.864704011147587, 1.0732944806838198`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8992510730733434`, 6.704414354964107}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3992510730733434`, 6.704414354964107}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-8.622553707074063, 0.8046885552928528}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.8353444322436783`, 5.768320995793772}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.335344432243678, 5.768320995793772}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1078227456783951`, 6.272877006546167}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5078227456783952`, 6.272877006546167}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7620499515598584`, 6.841615476477592}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262049951559858, 6.841615476477592}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4405284995041312`, 5.940171252720432}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8405284995041313`, 5.940171252720432}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             1.9838938336679197`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[$CellContext`\[FivePointedStar], {-2.7957322735539907`, 
              Log[400]}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[$CellContext`\[FivePointedStar], {-3.195732273553991, 
              Log[400]}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.886637726631229, 5.717027701406222}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.3866377266312284`, 5.717027701406222}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4081562175498282, 1.860974538249528}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-3.184156217549828, 1.860974538249528}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5188816629409656`, 1.6882490928583902`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.4188816629409655`, 1.6882490928583902`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.0519532126861397`, 7.55171221535131}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5519532126861397`, 7.55171221535131}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.9908343976300943, 7.6128310304073565`}],
             5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4908343976300942`, 
             7.6128310304073565`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2435614550482985`, 7.360103972989152}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.7435614550482983`, 7.360103972989152}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.9809291040876105`, 6.62273632394984}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809291040876102`, 6.62273632394984}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.719319793360441}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 2.556451816951096}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.064388689064227, 
             2.494031557565001}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2643886890642269`, 
             2.494031557565001}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.7027460895677522`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             0.766397642299538}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.845732273553991, 
              Log[400]}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-3.1457322735539908`, 
              Log[400]}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.1370722058722014`, 5.393627546352362}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.2370722058722015`, 5.393627546352362}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-8.421883011611913, 1.2424239907001886`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9643886890642268, 
             2.494031557565001}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.364388689064227, 
             2.494031557565001}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1643886890642268`, 
             2.494031557565001}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1643886890642268`, 
             2.494031557565001}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.3608864526485625`, 4.969813299576001}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.860886452648562, 4.969813299576001}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.8433654852060264`, 5.537334267018537}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.2433654852060263`, 5.537334267018537}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.2100378816850887`, 5.393627546352362}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.7100378816850887`, 5.393627546352362}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0640794724197806`, 6.539585955617669}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640794724197806`, 6.539585955617669}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.21871196386802, 5.111987788356544}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.7187119638680195`, 5.111987788356544}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 1.721694594779768}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.6039459499562811`, 5.676753802268282}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.2039459499562812`, 5.676753802268282}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-1.800776554863201, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-4.416776554863201, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1699988878712817`, 7.433666540166168}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6699988878712817`, 7.433666540166168}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             2.4561641809223462`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.305525936990736, 5.075173815233827}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.705525936990736, 5.075173815233827}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1877429013343526`, 5.19295685089021}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5877429013343525`, 5.19295685089021}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.631199404215613}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             1.8526977673331346`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6644114819959424`, 6.939253946041508}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164411481995942, 6.939253946041508}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.310037881685089, 5.393627546352362}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.6100378816850887`, 5.393627546352362}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9699046142222073, 
             2.58851563240702}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1699046142222074`, 
             2.58851563240702}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-7.957577403480815, 1.445270566220188}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1327329565011985`, 
             2.425687290128029}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3327329565011987`, 
             2.425687290128029}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.340445040947149, 6.040254711277414}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7404450409471488`, 6.040254711277414}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.6284916128036233`, 5.075173815233827}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.928491612803623, 5.075173815233827}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1484668646973284`, 6.455198563340122}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.648466864697328, 6.455198563340122}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.6843598389513597`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             1.9838938336679197`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.8938099618846936, 4.386889790339869}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-5.493809961884693, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2327329565011986`, 
             2.425687290128029}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2327329565011986`, 
             2.425687290128029}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-8.947976107508692, 0.973049065692764}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.0966102859974367`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.2600378816850886`, 5.393627546352362}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.660037881685089, 5.393627546352362}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0327329565011987`, 
             2.425687290128029}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4327329565011986`, 
             2.425687290128029}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.605170185988091, 2.9290581402859983`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             1.721694594779768}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5932080094425167`, 4.787491742782046}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.993208009442517, 4.787491742782046}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7812206985481321, 7.822444729489319}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2812206985481318`, 7.822444729489319}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2780506249916748`, 1.864080130807681}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.308050624991675, 1.864080130807681}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.8699543168131119`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.5634107167600364`, 6.040254711277414}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.0634107167600364`, 6.040254711277414}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0005772153247978`, 6.380122536899765}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4005772153247977`, 6.380122536899765}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390573296152587`, 4.941642422609304}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.8390573296152586`, 4.941642422609304}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820072438863218`, 6.921658184151129}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.182007243886322, 6.921658184151129}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9870722058722012`, 5.393627546352362}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3870722058722014`, 5.393627546352362}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5932080094425167`, 4.787491742782046}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.993208009442517, 4.787491742782046}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8699046142222073, 
             2.58851563240702}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2699046142222075`, 
             2.58851563240702}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0363197520242107`, 7.56734567601324}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5363197520242107`, 7.56734567601324}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.5257286443082556`, 6.461468176353717}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.864704011147587, 1.3452119160186606`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.2406373244969853`, 6.363028103540465}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7406373244969853`, 6.363028103540465}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.9453385571563557`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8014485402144619, 6.579251212010101}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.201448540214462, 6.579251212010101}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.073204380196781, 5.2574953720277815`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.573204380196781, 5.2574953720277815`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0823823856765262`, 5.298317366548036}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.482382385676526, 5.298317366548036}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8592388343623163`, 5.521460917862246}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2592388343623164`, 5.521460917862246}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.845732273553991, 
              Log[400]}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-3.1457322735539908`, 
              Log[400]}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1877429013343526`, 5.19295685089021}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5877429013343525`, 5.19295685089021}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[$CellContext`\[FivePointedStar], {-2.7957322735539907`, 
              Log[400]}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[$CellContext`\[FivePointedStar], {-3.195732273553991, 
              Log[400]}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.8826660279157308`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.8539459499562811`, 5.676753802268282}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.9539459499562812`, 5.676753802268282}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8643886890642268, 
             2.494031557565001}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4643886890642268`, 
             2.494031557565001}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0699046142222073`, 
             2.58851563240702}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0699046142222073`, 
             2.58851563240702}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.885344432243678, 5.768320995793772}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.285344432243678, 5.768320995793772}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5897499532269226`, 7.013915474810528}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0897499532269226`, 7.013915474810528}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[$CellContext`\[FivePointedStar], {-2.695732273553991, 
              Log[400]}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[$CellContext`\[FivePointedStar], {-3.295732273553991, 
              Log[400]}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 2.246332151443247}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.863232841258714, 0.8458682675776092}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.3524072174927233`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.8440512773405471, 7.759614150696903}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.344051277340547, 7.759614150696903}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.5284916128036232`, 5.075173815233827}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.028491612803624, 5.075173815233827}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.21871196386802, 5.111987788356544}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.7187119638680195`, 5.111987788356544}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.5087859235779435`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.249473262741422, 6.131226489483141}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6494732627414221`, 6.131226489483141}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4677395362418175`, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.2797395362418174`, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2712460051465098`, 
             2.187174241482718}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.67124600514651, 
             2.187174241482718}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.3025850929940455`, 6.684611727667927}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3712460051465096`, 
             2.187174241482718}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5712460051465098`, 
             2.187174241482718}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.5299617109323036`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4266819660425425, 1.6974487897568136`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.492681966042542, 1.6974487897568136`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.9908343976300943, 7.6128310304073565`}],
             5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4908343976300942`, 
             7.6128310304073565`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 2.0427775573082445`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334569144331189, 6.269096283706261}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834569144331189, 6.269096283706261}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.863232841258714, 1.007592890280941}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.7039459499562812`, 5.676753802268282}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.103945949956281, 5.676753802268282}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6042429605294894`, 6.999422467507961}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1042429605294894`, 6.999422467507961}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.3749057545736716`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.457653856741544, 5.823045895483019}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.057653856741544, 5.823045895483019}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.179500146995422, 7.424165281042028}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.679500146995422, 7.424165281042028}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.9295125067557753, 7.674152921281675}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4295125067557752`, 7.674152921281675}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5219819897673834, 1.4951487660319727`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.801981989767383, 1.4951487660319727`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2643886890642269`, 
             2.494031557565001}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.064388689064227, 
             2.494031557565001}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.0190537003695233`, 6.684611727667927}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.319053700369523, 6.684611727667927}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.2739459499983132`, 6.429719478039138}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.573945949998313, 6.429719478039138}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.6134107167600362`, 6.040254711277414}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.013410716760036, 6.040254711277414}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3774777201525994, 2.0706530356467567`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7954777201525993`, 2.0706530356467567`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.6634107167600365`, 6.040254711277414}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.9634107167600363`, 6.040254711277414}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.318354083132957, 
             2.1400661634962708`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.718354083132957, 
             2.1400661634962708`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7459101490553133`, 5.634789603169249}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.145910149055313, 5.634789603169249}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0126784475265938`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.5126784475265938`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2939484557648162`, 
             2.1644717908644115`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6939484557648161`, 
             2.1644717908644115`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.995732273553991, 5.991464547107982}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4712460051465097`, 
             2.187174241482718}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4712460051465097`, 
             2.187174241482718}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             2.1151705891340815`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3327329565011987`, 
             2.425687290128029}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1327329565011985`, 
             2.425687290128029}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3409606377618708`, 
             2.1174596088673567`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7409606377618707`, 
             2.1174596088673567`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.393948455764816, 
             2.1644717908644115`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5939484557648163`, 
             2.1644717908644115`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 1.726509584019938}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8467330387898968`, 6.756932389247553}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346733038789897, 6.756932389247553}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.7333680090865, 6.253828811575473}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             1.5904589458362974`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6441274547453708`, 5.736572297479192}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.044127454745371, 5.736572297479192}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5932080094425167`, 4.787491742782046}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9932080094425166`, 4.787491742782046}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             2.330200260027019}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9327329565011986, 
             2.425687290128029}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5327329565011987`, 
             2.425687290128029}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.106093061740368, 
             2.3523271848888596`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.506093061740368, 
             2.3523271848888596`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4298793241355137`, 6.173786103901937}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9298793241355137`, 6.173786103901937}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2060930617403678`, 
             2.3523271848888596`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.406093061740368, 
             2.3523271848888596`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.246332151443247}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             1.5904589458362974`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7699046142222074, 
             2.58851563240702}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.369904614222207, 
             2.58851563240702}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.9370722058722014`, 5.393627546352362}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.437072205872201, 5.393627546352362}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.635344432243678, 5.768320995793772}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.535344432243678, 5.768320995793772}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             2.5087859235779435`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.303934363203508, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-4.0839343632035074`, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 0.8450095298691913}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4183540831329569`, 
             2.1400661634962708`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.618354083132957, 
             2.1400661634962708`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.707653856741544, 5.823045895483019}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.8076538567415439`, 5.823045895483019}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.430789601006442}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-6.907755278982137, 0.8046885552928528}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.199705077879927, 2.0471765810925606`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.0100378816850886`, 5.393627546352362}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.910037881685089, 5.393627546352362}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.305525936990736, 5.075173815233827}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.705525936990736, 5.075173815233827}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.377692565480851}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1660916538023711`, 6.214608098422191}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.566091653802371, 6.214608098422191}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.461401833606696}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.462149662665384}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.90372738933488, 6.476972362889683}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3037273893348802`, 6.476972362889683}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.3498366164619773`, 6.253828811575473}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.8498366164619773`, 6.253828811575473}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4409606377618707`, 
             2.1174596088673567`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6409606377618708`, 
             2.1174596088673567`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4126022156830935`, 1.8625285401162623`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.1766022156830935`, 1.8625285401162623`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.8526203100656485, 7.751045117971802}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3526203100656484`, 7.751045117971802}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1877429013343526`, 5.19295685089021}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5877429013343525`, 5.19295685089021}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5517541346143557`, 5.8289456176102075`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9517541346143559`, 5.8289456176102075`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 
             1.0420419371797154`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.9837562915454279`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.53523983979334, 6.068425588244111}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.03523983979334, 6.068425588244111}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.5922917535991299`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5270116125934994`, 7.076653815443951}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0270116125934994`, 7.076653815443951}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.578491612803623, 5.075173815233827}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.9784916128036234`, 5.075173815233827}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.21572018609187613`, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.465720186091875, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             1.8526977673331346`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3060930617403679`, 
             2.3523271848888596`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3060930617403679`, 
             2.3523271848888596`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5169274935268733`, 7.086737934510577}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.016927493526873, 7.086737934510577}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.305525936990736, 5.075173815233827}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.705525936990736, 5.075173815233827}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.6888794541139363`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.5102244577722903`, 6.476972362889683}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.4079456086518722`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4939484557648162`, 
             2.1644717908644115`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4939484557648162`, 
             2.1644717908644115`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.6888794541139363`, 5.298317366548036}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3653223785019062`, 
             2.0930978681273213`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7653223785019063`, 
             2.0930978681273213`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1939484557648161`, 
             2.1644717908644115`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.793948455764816, 
             2.1644717908644115`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1712460051465097`, 
             2.187174241482718}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7712460051465098`, 
             2.187174241482718}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0823823856765262`, 5.298317366548036}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.482382385676526, 5.298317366548036}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8563881178525805, 
             2.702032128776647}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0563881178525807`, 
             2.702032128776647}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             1.2172838183856083`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.4498366164619774`, 6.253828811575473}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.749836616461977, 6.253828811575473}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1872423621695702`, 
             2.3711778844596574`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3872423621695704`, 
             2.3711778844596574`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.227214785969269}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390573296152587`, 4.941642422609304}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.8390573296152586`, 4.941642422609304}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.073204380196781, 5.2574953720277815`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.573204380196781, 5.2574953720277815`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 2.377692565480851}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390573296152587`, 4.941642422609304}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.8390573296152586`, 4.941642422609304}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.462149662665384}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1699046142222074`, 
             2.58851563240702}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9699046142222073, 
             2.58851563240702}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7563881178525805, 
             2.702032128776647}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1563881178525806`, 
             2.702032128776647}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.3145530131008705`, 5.966146739123692}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.9145530131008708`, 5.966146739123692}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.5824869781268642`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5712460051465098`, 
             2.187174241482718}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3712460051465096`, 
             2.187174241482718}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.557653856741544, 5.823045895483019}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.957653856741544, 5.823045895483019}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.6960880245566355, 6.684611727667927}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0960880245566356`, 6.684611727667927}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.518354083132957, 
             2.1400661634962708`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.518354083132957, 
             2.1400661634962708`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0872423621695702`, 
             2.3711778844596574`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4872423621695703`, 
             2.3711778844596574`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2409606377618707`, 
             2.1174596088673567`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8409606377618706`, 
             2.1174596088673567`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 2.044332364566268}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9870722058722012`, 5.393627546352362}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3870722058722014`, 5.393627546352362}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2183540831329567`, 
             2.1400661634962708`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8183540831329568`, 
             2.1400661634962708`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4847815821812238`, 2.135349173618132}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5587815821812239`, 2.135349173618132}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.8643901602629624`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.642660088414177, 5.961005339623274}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1426600884141767`, 5.961005339623274}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.7933654852060263`, 5.537334267018537}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.293365485206026, 5.537334267018537}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.1151705891340815`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4405284995041312`, 5.940171252720432}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8405284995041316`, 5.940171252720432}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.7959101490553133`, 6.907755278982137}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.095910149055313, 6.907755278982137}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.3634107167600362`, 6.040254711277414}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.2634107167600366`, 6.040254711277414}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2872423621695703`, 
             2.3711778844596574`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2872423621695703`, 
             2.3711778844596574`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 2.217136131161563}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-4.8283137373023015`, 2.0471765810925606`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1148124723039907`, 7.488852955733459}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6148124723039907`, 7.488852955733459}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.399836616461977, 6.253828811575473}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.799836616461977, 6.253828811575473}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1687404467842484`, 
             2.3896797998449792`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3687404467842483`, 
             2.3896797998449792`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.0891306126662428`, 6.29156913955832}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.4891306126662427`, 6.29156913955832}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0687404467842483`, 
             2.3896797998449792`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4687404467842484`, 
             2.3896797998449792`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.8526203100656485, 7.751045117971802}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3526203100656484`, 7.751045117971802}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.406093061740368, 
             2.3523271848888596`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2060930617403678`, 
             2.3523271848888596`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5932080094425167`, 4.787491742782046}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9932080094425166`, 4.787491742782046}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.465322378501906, 
             2.0930978681273213`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6653223785019062`, 
             2.0930978681273213`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.1100378816850887`, 5.393627546352362}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.8100378816850884`, 5.393627546352362}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1569280563711404`, 5.44673737166631}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569280563711404`, 5.44673737166631}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9712643014359971, 
             7.6324011266014535`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.471264301435997, 7.6324011266014535`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 2.2044208442068145`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.5824869781268642`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-4.3428059215206005`, 3.2386784521643803`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.452179964132715, 7.151485463904735}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.952179964132715, 7.151485463904735}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.265322378501906, 
             2.0930978681273213`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8653223785019062`, 
             2.0930978681273213`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2687404467842482`, 
             2.3896797998449792`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2687404467842482`, 
             2.3896797998449792`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5932080094425167`, 4.787491742782046}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.993208009442517, 4.787491742782046}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5939484557648163`, 
             2.1644717908644115`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.393948455764816, 
             2.1644717908644115`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0060930617403678`, 
             2.3523271848888596`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.606093061740368, 
             2.3523271848888596`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8592388343623163`, 5.521460917862246}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2592388343623164`, 5.521460917862246}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.735344432243678, 5.768320995793772}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.435344432243678, 5.768320995793772}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-8.622553707074063, 0.973049065692764}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5409606377618708`, 
             2.1174596088673567`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5409606377618708`, 
             2.1174596088673567`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.283414346005772, 5.703782474656201}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-4.8283137373023015`, 1.7328937163610187`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.462149662665384}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             0.986935571443487}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8014485402144619, 6.579251212010101}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.201448540214462, 6.579251212010101}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             0.7622067164914399}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.763023770664052, 5.840641657373398}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263023770664052, 5.840641657373398}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7198422131452975, 
             7.8838232148921525`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2198422131452975`, 
             7.8838232148921525`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.173945949998313, 6.429719478039138}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.673945949998313, 6.429719478039138}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 1.133013715385442}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.445929943787544, 7.157735484249907}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.945929943787544, 7.157735484249907}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.6563881178525806, 
             2.702032128776647}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2563881178525806`, 
             2.702032128776647}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.103158068297152}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.3284916128036235`, 5.075173815233827}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.228491612803624, 5.075173815233827}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-3.6888794541139363`, 2.9290581402859983`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.0794415416798357`, 6.907755278982137}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.5645530131008705`, 5.966146739123692}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.6645530131008706`, 5.966146739123692}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5600995097294433, 2.423031246069913}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9080995097294433`, 2.423031246069913}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3481484471914902`, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7001484471914903`, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.623934363203508, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-4.763934363203508, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.35851514712420324`, 1.6956156086751528`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.564515147124203, 1.6956156086751528`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020169119255751, 5.583496308781699}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520169119255751, 5.583496308781699}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.8800803260850696`, 5.723585101952381}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.3800803260850696`, 5.723585101952381}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 0.9034081060431414}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             2.4561641809223462`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.916173685255404, 4.787491742782046}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.216173685255404, 4.787491742782046}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.595732273553991, 
              Log[400]}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-3.3957322735539908`, 
              Log[400]}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3949588271331155`, 2.0731719286662407`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7729588271331156`, 2.0731719286662407`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.9370722058722014`, 5.393627546352362}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.437072205872201, 5.393627546352362}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.9190537003695232`, 6.684611727667927}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.419053700369523, 6.684611727667927}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             0.8206605008589049}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3892599069543555, 2.0068708488450007`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9112599069543554`, 2.0068708488450007`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.886637726631229, 5.717027701406222}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.3866377266312284`, 5.717027701406222}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.227214785969269}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.36696431443027355`, 2.134166441369082}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6789643144302735`, 2.134166441369082}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4337250150625197, 1.601405740736836}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-3.67772501506252, 1.601405740736836}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.149836616461977, 6.253828811575473}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.0498366164619775`, 6.253828811575473}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4327329565011986`, 
             2.425687290128029}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0327329565011987`, 
             2.425687290128029}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7812206985481321, 7.822444729489319}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2812206985481318`, 7.822444729489319}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.1759065198095775`, 6.104793232414985}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.7759065198095778`, 6.104793232414985}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 0.9403978072173882}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751462948262976, 5.8522024797744745`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.2514629482629758`, 
             5.8522024797744745`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9837700970084164, 6.396929655216146}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3837700970084166`, 6.396929655216146}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7459101490553133`, 5.634789603169249}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.145910149055313, 5.634789603169249}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.7327358312823078, 7.8709295967551425`}],
             5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2327358312823076`, 
             7.8709295967551425`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3796406197516198`, 7.22402480828583}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8796406197516198`, 7.22402480828583}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324035882469876`, 5.971261839790462}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132403588246988, 5.971261839790462}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.8067765548632013`, 4.386765389021055}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-3.410776554863201, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.6772785424354564`, 6.309918278226516}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.223945949998313, 6.429719478039138}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.623945949998313, 6.429719478039138}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.364388689064227, 
             2.494031557565001}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9643886890642268, 
             2.494031557565001}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.6539459499562812`, 5.676753802268282}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.153945949956281, 5.676753802268282}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.4284916128036236`, 5.075173815233827}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.128491612803623, 5.075173815233827}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2072749131897207`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3687404467842483`, 
             2.3896797998449792`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1687404467842484`, 
             2.3896797998449792`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.4145530131008706`, 5.966146739123692}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.8145530131008707`, 5.966146739123692}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.227214785969269}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9563881178525806, 
             2.702032128776647}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9563881178525806, 
             2.702032128776647}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.6959101490553132`, 6.907755278982137}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.195910149055313, 6.907755278982137}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3872423621695704`, 
             2.3711778844596574`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1872423621695702`, 
             2.3711778844596574`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             2.1094856630282126`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3657109156908187, 1.6034198401085373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.7417109156908186`, 1.6034198401085373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7643886890642269, 
             2.494031557565001}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.564388689064227, 
             2.494031557565001}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.9908343976300943, 7.6128310304073565`}],
             5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4908343976300942`, 
             7.6128310304073565`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             1.8728785205128469`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4422780540451929, 1.501852701754163}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-3.868278054045193, 1.501852701754163}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0126784475265938`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.5126784475265938`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9872423621695702, 
             2.3711778844596574`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5872423621695704`, 
             2.3711778844596574`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3169145435369547`, 6.063785208687608}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7169145435369548`, 6.063785208687608}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5168907011251433`, 
             6.0867747269123065`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.0168907011251433`, 
             6.0867747269123065`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             1.8359358315608838`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5932080094425167`, 4.787491742782046}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9932080094425166`, 4.787491742782046}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             1.5473497201206787`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 1.0868770324496888`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.969053700369523, 6.684611727667927}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.369053700369523, 6.684611727667927}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.6135885922613586`, 7.090076835776092}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.9135885922613587`, 7.090076835776092}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390573296152587`, 4.941642422609304}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.8390573296152586`, 4.941642422609304}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             1.0511712140679732`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3425014380048456, 1.8656293177945105`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.240501438004846, 1.8656293177945105`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9687404467842483, 
             2.3896797998449792`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5687404467842483`, 
             2.3896797998449792`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.697559683024319, 2.4265710727750367`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7635596830243192`, 2.4265710727750367`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5653223785019061`, 
             2.0930978681273213`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5653223785019061`, 
             2.0930978681273213`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.1151415906193203`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.4865920824352545`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3767294095441613`, 7.226936018493289}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8767294095441613`, 7.226936018493289}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.305525936990736, 5.075173815233827}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.705525936990736, 5.075173815233827}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.0497721232486361`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.618354083132957, 
             2.1400661634962708`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4183540831329569`, 
             2.1400661634962708`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.5135885922613588`, 7.090076835776092}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.0135885922613586`, 7.090076835776092}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-4.199705077879927, 0.7997569156182036}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.7459101490553133`, 6.907755278982137}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.145910149055313, 6.907755278982137}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.815475995845371}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.5894782894983773, 6.7912214627261855`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9894782894983774, 6.7912214627261855`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.67124600514651, 
             2.187174241482718}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2712460051465098`, 
             2.187174241482718}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.8344641259578687`, 6.152732694704104}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.1866231659908228`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.4407825464039603`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.556451816951096}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.0939343632035077`, 
             4.386765389021055}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.293934363203508, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.6699046142222073, 
             2.58851563240702}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4699046142222072`, 
             2.58851563240702}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.3563504847468186`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.409260036932778, 6.194405391104672}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.909260036932778, 6.194405391104672}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6409606377618708`, 
             2.1174596088673567`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4409606377618707`, 
             2.1174596088673567`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3079303552881687`, 7.295735072749282}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8079303552881685`, 7.295735072749282}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 0.9566646260124284}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.8161736852554045`, 4.787491742782046}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.3161736852554045`, 4.787491742782046}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6123787564307905`, 5.768320995793772}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0123787564307904`, 5.768320995793772}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-3.6888794541139363`, 2.3933394562625097`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.03072450996508, 6.249975242259483}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.6307245099650798`, 6.249975242259483}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             2.209811692841691}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.4634107167600363`, 6.040254711277414}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.163410716760036, 6.040254711277414}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1877429013343526`, 5.19295685089021}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5877429013343525`, 5.19295685089021}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.5841201044498106`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.2299329059954676`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.756895550682775, 1.589235205116581}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.378895550682775, 1.589235205116581}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.906544110754825, 7.697121317282625}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4065441107548249`, 7.697121317282625}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 1.671097292820828}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.4259065198095775`, 6.104793232414985}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.5259065198095776`, 6.104793232414985}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 1.3147983594148207`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.6960880245566355, 6.684611727667927}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0960880245566356`, 6.684611727667927}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.26677563769758056`, 4.386889790339869}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-8.666775637697581, 4.386889790339869}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.973945949998313, 6.429719478039138}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.8739459499983133`, 6.429719478039138}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.3964921860963366`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 0.9489515141137035}],
             5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8327329565011986, 
             2.425687290128029}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6327329565011985`, 
             2.425687290128029}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.2158025560795132`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.506093061740368, 
             2.3523271848888596`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.106093061740368, 
             2.3523271848888596`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3615155310269236`, 1.9416152247724325`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0695155310269238`, 1.9416152247724325`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.5859645562484583`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047161811815076`, 6.298949246855942}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.8047161811815076`, 6.298949246855942}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.4146388341290332`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.7535382564078572`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.507653856741544, 5.823045895483019}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.0076538567415443`, 5.823045895483019}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             2.6397713603489157`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.7933654852060263`, 5.537334267018537}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.293365485206026, 5.537334267018537}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2069136483226262`, 6.173786103901937}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6069136483226263`, 6.173786103901937}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.873422039839551, 6.507277712385012}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.273422039839551, 6.507277712385012}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 2.378619779270043}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.1614822520160453`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0823823856765262`, 5.298317366548036}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.482382385676526, 5.298317366548036}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.719319793360441}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-7.418580902748128, 1.7328937163610187`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1569280563711404`, 5.44673737166631}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569280563711404`, 5.44673737166631}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.34773953624181747`, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.3997395362418175`, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6939484557648161`, 
             2.1644717908644115`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2939484557648162`, 
             2.1644717908644115`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3079303552881687`, 7.295735072749282}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8079303552881685`, 7.295735072749282}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.4971646699513146`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.2807245099650797`, 6.249975242259483}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.3807245099650798`, 6.249975242259483}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.2742448573112677`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.2876820724517809, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.2759065198095776`, 6.104793232414985}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.6759065198095777`, 6.104793232414985}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.5635885922613586`, 7.090076835776092}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.9635885922613587`, 7.090076835776092}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-3.4420193761824103`, 3.2386784521643803`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 0.7802418874108791}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.590292464849665, 
             2.0681277817795625`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.590292464849665, 
             2.0681277817795625`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3092881287486289`, 7.294377299288821}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8092881287486289`, 7.294377299288821}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6653223785019062`, 
             2.0930978681273213`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.465322378501906, 
             2.0930978681273213`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.2669476034873244`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.659173264105291, 7.944492163932159}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.159173264105291, 7.944492163932159}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.523226215615035}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-5.744604469176456, 2.3933394562625097`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.4395981331422016`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7667756376975805, 
             4.386889790339869}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.166775637697581, 
             4.386889790339869}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.8661736852554043`, 4.787491742782046}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.266173685255405, 4.787491742782046}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.7327358312823078, 7.8709295967551425`}],
             5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2327358312823076`, 
             7.8709295967551425`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.103934363203508, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-4.283934363203508, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5159020590539893`, 
             2.0425181875752383`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7159020590539897`, 
             2.0425181875752383`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.719319793360441}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4902924648496652`, 
             2.0681277817795625`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.690292464849665, 
             2.0681277817795625`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5227665977411036`, 5.857933154483459}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9227665977411035`, 5.857933154483459}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.238485302016438, 7.365180126021013}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7384853020164377`, 7.365180126021013}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 0.9858167945227654}],
             5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.763023770664052, 5.840641657373398}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263023770664052, 5.840641657373398}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.505701672608481, 2.0844290831908747`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6397016726084812`, 2.0844290831908747`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.26677563769758056`, 
             4.386889790339869}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.666775637697581, 
             4.386889790339869}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 1.1684492482568893`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.206735772821304, 6.396929655216146}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706735772821304, 6.396929655216146}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.719053700369523, 6.684611727667927}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.619053700369523, 6.684611727667927}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6159020590539896`, 
             2.0425181875752383`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6159020590539896`, 
             2.0425181875752383`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6265596830243191, 2.4265710727750367`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8345596830243192`, 2.4265710727750367`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 0.880041599199034}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.2098554674840916`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.5554040239416147`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9870722058722012`, 5.393627546352362}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3870722058722014`, 5.393627546352362}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0190692593864348`, 2.570319527636131}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1550692593864347`, 2.570319527636131}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.1975522365230131`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.7218733417638885`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.2792657883613672`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.3259065198095779`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.6259065198095777`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.8118888405232207`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.9782390361706734`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.642660088414177, 5.961005339623274}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1426600884141767`, 5.961005339623274}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111425593016979, 6.492239835020471}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.611425593016979, 6.492239835020471}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2935151471242034, 1.6956156086751528`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.629515147124203, 1.6956156086751528`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4932133776377856, 2.4239173781615704`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9732133776377854`, 2.4239173781615704`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.391511302188447}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.718354083132957, 
             2.1400661634962708`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.318354083132957, 
             2.1400661634962708`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1699988878712817`, 7.433666540166168}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6699988878712817`, 7.433666540166168}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.2259065198095778`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.7259065198095775`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.890459085159213, 6.39024066706535}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.490459085159213, 6.39024066706535}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.227214785969269}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.9809291040876105`, 6.62273632394984}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809291040876102`, 6.62273632394984}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 1.173410498743296}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.886637726631229, 5.717027701406222}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.3866377266312284`, 5.717027701406222}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             2.2086040295231517`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.53523983979334, 6.068425588244111}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.03523983979334, 6.068425588244111}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.3368289812806429, 1.937301774518713}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1028289812806427`, 1.937301774518713}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7159020590539897`, 
             2.0425181875752383`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5159020590539893`, 
             2.0425181875752383`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4159020590539895`, 
             2.0425181875752383`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8159020590539896`, 
             2.0425181875752383`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.9521761906339596`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.5177545102789891, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-5.6177545102789885`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.6526889544284153`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.3282528397426234`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.5047438413194347`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.7755419870490041, 2.418588768750352}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.701541987049004, 2.418588768750352}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.6161736852554043`, 4.787491742782046}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.516173685255405, 4.787491742782046}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0640794724197806`, 6.539585955617669}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640794724197806`, 6.539585955617669}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334569144331189, 6.269096283706261}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834569144331189, 6.269096283706261}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.42254198704900425`, 2.418588768750352}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0545419870490043`, 2.418588768750352}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 0.9150900112976361}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.558002204858551}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7198422131452975, 
             7.8838232148921525`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2198422131452975`, 
             7.8838232148921525`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1078227456783951`, 6.272877006546167}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5078227456783952`, 6.272877006546167}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1484668646973284`, 6.455198563340122}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.648466864697328, 6.455198563340122}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.690292464849665, 
             2.0681277817795625`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4902924648496652`, 
             2.0681277817795625`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4872423621695703`, 
             2.3711778844596574`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0872423621695702`, 
             2.3711778844596574`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.8140100781628747`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0712460051465096`, 
             2.187174241482718}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8712460051465098`, 
             2.187174241482718}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.140459085159213, 6.39024066706535}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.240459085159213, 6.39024066706535}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.390292464849665, 
             2.0681277817795625`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7902924648496652`, 
             2.0681277817795625`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             0.9411784473819341}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.2406373244969853`, 6.363028103540465}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7406373244969853`, 6.363028103540465}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.018874035651734, 6.584791392385716}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.518874035651734, 6.584791392385716}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.184789984909162}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.4312677267626217`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5691769728675407`, 
             1.9892432737616872`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7691769728675406`, 
             1.9892432737616872`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.227214785969269}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5421847808531843`, 
             2.0162354657760435`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7421847808531843`, 
             2.0162354657760435`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0563881178525807`, 
             2.702032128776647}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8563881178525805, 
             2.702032128776647}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4298793241355137`, 6.173786103901937}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9298793241355137`, 6.173786103901937}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9000608288825716`, 5.480638923341991}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3000608288825717`, 5.480638923341991}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0126784475265938`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.5126784475265938`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6421847808531844`, 
             2.0162354657760435`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6421847808531844`, 
             2.0162354657760435`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4405284995041312`, 5.940171252720432}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8405284995041313`, 5.940171252720432}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.437937594271729}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 2.04225875055212}],
             5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.31795882713311546`, 2.0731719286662407`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8499588271331153`, 2.0731719286662407`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1183540831329568`, 
             2.1400661634962708`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9183540831329569`, 
             2.1400661634962708`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.3645530131008707`, 5.966146739123692}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.8645530131008707`, 5.966146739123692}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5897888252912907, 2.506341930508065}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.711788825291291, 2.506341930508065}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-8.05031945517943, 1.2424239907001886`}],
             5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-9.567015315914915, 0.8046885552928528}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.249836616461977, 6.253828811575473}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.949836616461977, 6.253828811575473}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.002290482491421}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.7859090555498793`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.6305150837187388, 
             2.827905162910489}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0305150837187387`, 
             2.827905162910489}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8992510730733434`, 6.704414354964107}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3992510730733434`, 6.704414354964107}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4421847808531842`, 
             2.0162354657760435`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8421847808531844`, 
             2.0162354657760435`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4687404467842484`, 
             2.3896797998449792`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0687404467842483`, 
             2.3896797998449792`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2712709425975442, 1.9358598132018119`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1712709425975443`, 1.9358598132018119`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2699046142222075`, 
             2.58851563240702}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8699046142222073, 
             2.58851563240702}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4691769728675406`, 
             1.9892432737616872`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8691769728675407`, 
             1.9892432737616872`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.1307245099650798`, 6.249975242259483}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.53072450996508, 6.249975242259483}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8504328557048056, 2.4176979000945504`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6284328557048058`, 2.4176979000945504`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.6397713603489157`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.495910149055313, 6.907755278982137}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.395910149055313, 6.907755278982137}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9060930617403679, 
             2.3523271848888596`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7060930617403678`, 
             2.3523271848888596`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.6539459499562812`, 5.676753802268282}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.153945949956281, 5.676753802268282}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.931632482576383, 6.672032945461067}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316324825763833`, 6.672032945461067}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.7606265456942067, 6.620073206530356}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1606265456942064`, 6.620073206530356}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-8.955698153602603, 0.8046885552928528}],
             5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.7378311272024993`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.28242162242480234`, 1.7817091333745536`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.4684216224248026`, 1.7817091333745536`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1699988878712817`, 7.433666540166168}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6699988878712817`, 7.433666540166168}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7409606377618707`, 
             2.1174596088673567`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3409606377618708`, 
             2.1174596088673567`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7421847808531843`, 
             2.0162354657760435`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5421847808531843`, 
             2.0162354657760435`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.102583303777579, 7.501082124259871}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.602583303777579, 7.501082124259871}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6691769728675407`, 
             1.9892432737616872`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6691769728675407`, 
             1.9892432737616872`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.0600378816850884`, 5.393627546352362}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.860037881685089, 5.393627546352362}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.893934363203508, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.493934363203508, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.5894782894983773, 6.7912214627261855`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9894782894983774, 6.7912214627261855`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8200181212090352`, 5.560681631015528}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2200181212090353`, 5.560681631015528}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-7.523941418405954, 1.497835735852798}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.4931471805599453, 6.887552571664617}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8931471805599454, 6.887552571664617}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.4847813078345447`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1409606377618706`, 
             2.1174596088673567`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9409606377618707`, 
             2.1174596088673567`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1148124723039907`, 7.488852955733459}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6148124723039907`, 7.488852955733459}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.746910914291219, 6.5337888379333435`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.346910914291219, 6.5337888379333435`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2938099618846937`, 4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-5.093809961884693, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.2759065198095776`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.6759065198095777`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.36787413308781153`, 2.421256622711544}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.1038741330878117`, 2.421256622711544}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.093948455764816, 
             2.1644717908644115`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8939484557648163`, 
             2.1644717908644115`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.206735772821304, 6.396929655216146}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706735772821304, 6.396929655216146}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.3492515787163989, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-8.5992515787164, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7305150837187386, 
             2.827905162910489}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9305150837187387, 
             2.827905162910489}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6939343632035078`, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.6939343632035078`, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8467330387898968`, 6.756932389247553}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346733038789897, 6.756932389247553}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.25730031649136037`, 2.0028304393079956`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0513003164913606`, 2.0028304393079956`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5992998630578766, 8.004365564979574}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0992998630578765`, 8.004365564979574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3677423471738785, 1.4973884086254774`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.951742347173879, 1.4973884086254774`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8192083653998068`, 6.784457062637643}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3192083653998066`, 6.784457062637643}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5983254625819578`, 
             1.9600947840472698`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.798325462581958, 
             1.9600947840472698`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.7161736852554044`, 4.787491742782046}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.416173685255404, 4.787491742782046}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.5563881178525807, 
             2.702032128776647}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3563881178525805`, 
             2.702032128776647}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1569280563711404`, 5.44673737166631}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569280563711404`, 5.44673737166631}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7691769728675406`, 
             1.9892432737616872`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5691769728675407`, 
             1.9892432737616872`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.8440512773405471, 7.759614150696903}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.344051277340547, 7.759614150696903}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.712716261887602}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7653223785019063`, 
             2.0930978681273213`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3653223785019062`, 
             2.0930978681273213`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.9969109142912191, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.096910914291219, 6.5337888379333435`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7902924648496652`, 
             2.0681277817795625`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.390292464849665, 
             2.0681277817795625`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.340445040947149, 6.040254711277414}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7404450409471488`, 6.040254711277414}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.2876820724517809, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0176716486840978`, 6.363028103540465}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4176716486840977`, 6.363028103540465}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.5305150837187386, 
             2.827905162910489}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1305150837187385`, 
             2.827905162910489}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.698325462581958, 
             1.9600947840472698`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.698325462581958, 
             1.9600947840472698`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5270116125934994`, 7.076653815443951}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0270116125934994`, 7.076653815443951}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.203855757707185, 4.499809670330265}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.503855757707186, 4.499809670330265}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8421847808531844`, 
             2.0162354657760435`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4421847808531842`, 
             2.0162354657760435`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 0.8046885552928528}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.3784916128036233`, 5.075173815233827}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.178491612803623, 5.075173815233827}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.3135885922613586`, 7.090076835776092}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.2135885922613587`, 7.090076835776092}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.3749057545736716`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-3.3524072174927233`, 1.497835735852798}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.3136238093329616, 8.290041618704489}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.8136238093329614, 8.290041618704489}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.5779472453427295`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.710818829244043, 5.66988092298052}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.110818829244043, 5.66988092298052}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.6888794541139363`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8159020590539896`, 
             2.0425181875752383`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4159020590539895`, 
             2.0425181875752383`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7620499515598584`, 6.841615476477592}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262049951559858, 6.841615476477592}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-4.045554398052668, 1.0335402919243948`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 1.7268653293100646`}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.1780394222994315`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.2259065198095778`, 6.104793232414985}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.7259065198095775`, 6.104793232414985}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.2876820724517809, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.8843386505211481`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.7409075149860491`, 6.862757913051401}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.240907514986049, 6.862757913051401}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6067395362418175`, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.1407395362418176`, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-0.908776554863201, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-5.3087765548632015`, 4.386765389021055}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.498325462581958, 
             1.9600947840472698`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8983254625819581`, 
             1.9600947840472698`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.2253070303221034`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.975307030322104, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.073945949998313, 6.429719478039138}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.773945949998313, 6.429719478039138}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.990459085159213, 6.39024066706535}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.3904590851592131`, 6.39024066706535}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.462149662665384}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.103855757707185, 4.499809670330265}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.603855757707185, 4.499809670330265}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.606138360410137, 6.674561391814426}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.206138360410137, 6.674561391814426}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.41775451027898897`, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-5.717754510278989, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.23151514712420335`, 1.6956156086751528`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.691515147124203, 1.6956156086751528`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.507653856741544, 5.823045895483019}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.0076538567415443`, 5.823045895483019}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-7.819058469345253, 
             1.3540294005326152`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.29769484070258256`, 1.6114359150967734`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.7936948407025826`, 1.6114359150967734`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.5824869781268642`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-4.382026634673881, 0.8046885552928528}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.32260489706968826`, 2.005525858729668}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.980604897069688, 2.005525858729668}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.685344432243678, 5.768320995793772}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.485344432243678, 5.768320995793772}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.8561383604101369, 6.674561391814426}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.956138360410137, 6.674561391814426}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820072438863218`, 6.921658184151129}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.182007243886322, 6.921658184151129}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.5774952330910239, 8.026170194946426}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.077495233091024, 8.026170194946426}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0126784475265938`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.5126784475265938`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 2.1122716862705384`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.102762968495368, 7.600902459542082}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.4027629684953677`, 7.600902459542082}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3159020590539894`, 
             2.0425181875752383`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9159020590539897`, 
             2.0425181875752383`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6644114819959424`, 6.939253946041508}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164411481995942, 6.939253946041508}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.9390042880724031, 2.414126467726953}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.547004288072403, 2.414126467726953}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.290292464849665, 
             2.0681277817795625`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.890292464849665, 
             2.0681277817795625`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 
             1.3045418592476314`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.153855757707185, 4.499809670330265}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.553855757707185, 4.499809670330265}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3421847808531844`, 
             2.0162354657760435`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9421847808531845`, 
             2.0162354657760435`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5234214787151759, 2.50470927708418}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.7814214787151759`, 2.50470927708418}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.002762968495368, 7.600902459542082}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.5027629684953678`, 7.600902459542082}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.102583303777579, 7.501082124259871}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.602583303777579, 7.501082124259871}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.798325462581958, 
             1.9600947840472698`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5983254625819578`, 
             1.9600947840472698`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6042429605294894`, 6.999422467507961}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1042429605294894`, 6.999422467507961}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.21915621754982811`, 1.860974538249528}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-3.373156217549828, 1.860974538249528}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.886637726631229, 5.717027701406222}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.3866377266312284`, 5.717027701406222}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.90372738933488, 6.476972362889683}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3037273893348802`, 6.476972362889683}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.659173264105291, 7.944492163932159}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.159173264105291, 7.944492163932159}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.6675181235106251`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.6592740514339194, 6.721425700790643}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0592740514339192`, 6.721425700790643}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8687404467842482, 
             2.3896797998449792`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6687404467842482`, 
             2.3896797998449792`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8691769728675407`, 
             1.9892432737616872`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4691769728675406`, 
             1.9892432737616872`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.30933398378559207`, 2.131796772013764}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.741333983785592, 2.131796772013764}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.763023770664052, 5.840641657373398}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263023770664052, 5.840641657373398}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-8.685611843041201, 0.9360933591703348}],
             5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1569280563711404`, 5.44673737166631}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569280563711404`, 5.44673737166631}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6123787564307905`, 5.768320995793772}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0123787564307904`, 5.768320995793772}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2279670575204586`, 6.152732694704104}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6279670575204586`, 6.152732694704104}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.540287605670424, 8.063377822367027}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.040287605670424, 8.063377822367027}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.46009543862310287`, 2.512035317176253}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.830095438623103, 2.512035317176253}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3691769728675405`, 
             1.9892432737616872`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9691769728675406`, 
             1.9892432737616872`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.965852822566973}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.42390493433755033`, 8.1797604936999}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9239049343375502, 8.1797604936999}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2790506249916749, 1.864080130807681}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-3.307050624991675, 1.864080130807681}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8872423621695703, 
             2.3711778844596574`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6872423621695702`, 
             2.3711778844596574`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.26677563769758056`, 
             4.386889790339869}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.666775637697581, 
             4.386889790339869}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2227395362418174, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.5247395362418175`, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5270116125934994`, 7.076653815443951}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0270116125934994`, 7.076653815443951}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0184328557048057`, 2.4176979000945504`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4604328557048056`, 2.4176979000945504`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.25152092754512073`, 2.130609828254235}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8015209275451207`, 2.130609828254235}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.398325462581958, 
             1.9600947840472698`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.998325462581958, 
             1.9600947840472698`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-7.284632930238389, 
             1.6094379124341003`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5897499532269226`, 7.013915474810528}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0897499532269226`, 7.013915474810528}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.819053700369523, 6.684611727667927}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.519053700369523, 6.684611727667927}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.642660088414177, 5.961005339623274}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1426600884141767`, 5.961005339623274}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3034088163044134, 1.5107219394949427`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.9894088163044135`, 1.5107219394949427`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.903855757707185, 4.499809670330265}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.803855757707185, 4.499809670330265}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.08072450996508, 6.249975242259483}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.58072450996508, 6.249975242259483}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.4628691807704128, 6.81783057145415}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.0628691807704127`, 6.81783057145415}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.719319793360441}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.846910914291219, 6.5337888379333435`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2469109142912191`, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.7128691807704127, 6.81783057145415}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.8128691807704128, 6.81783057145415}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8305150837187387, 
             2.827905162910489}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8305150837187387, 
             2.827905162910489}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.6094379124341003`, 7.3777589082278725`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.017383521085972, 0.986935571443487}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.0600378816850884`, 5.393627546352362}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.860037881685089, 5.393627546352362}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.53523983979334, 6.068425588244111}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.03523983979334, 6.068425588244111}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-4.045554398052668, 0.8046885552928528}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.666173685255404, 4.787491742782046}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.466173685255405, 4.787491742782046}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6740596707737887`, 1.9300710850255671`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7800596707737888`, 1.9300710850255671`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.0259065198095776`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.9259065198095777`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.4829948090959271, 6.897704943128636}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8829948090959272, 6.897704943128636}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6731916218535121`, 1.691939133945844}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.257191621853512, 1.691939133945844}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.48159105267523294`, 
             8.122074375362217}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.981591052675233, 8.122074375362217}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.3645530131008707`, 5.966146739123692}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.8645530131008707`, 5.966146739123692}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5227665977411036`, 5.857933154483459}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9227665977411035`, 5.857933154483459}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-6.214608098422191, 2.0471765810925606`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.445929943787544, 7.157735484249907}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.945929943787544, 7.157735484249907}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1563881178525806`, 
             2.702032128776647}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7563881178525805, 
             2.702032128776647}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.452179964132715, 7.151485463904735}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.952179964132715, 7.151485463904735}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5574102454351726`, 1.8687205103641833`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.019410245435173, 1.8687205103641833`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-0.09925157871639893, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-8.849251578716398, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.55932086581535, 4.0943445622221}], 4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.95932086581535, 4.0943445622221}], 4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.3784916128036233`, 5.075173815233827}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.178491612803623, 5.075173815233827}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.24532803008106102`, 2.424802725718295}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.219328030081061, 2.424802725718295}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4298793241355137`, 6.173786103901937}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9298793241355137`, 6.173786103901937}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.102583303777579, 7.501082124259871}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.602583303777579, 7.501082124259871}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0363197520242107`, 7.56734567601324}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5363197520242107`, 7.56734567601324}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.003855757707186, 4.499809670330265}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.703855757707185, 4.499809670330265}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.017383521085972, 0.7347688552507647}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.50932086581535, 4.0943445622221}], 4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-5.00932086581535, 4.0943445622221}], 4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-7.600902459542082, 1.6094379124341003`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4372277352570912`, 2.0149030205422647`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8472277352570914`, 2.0149030205422647`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.413410716760036, 6.040254711277414}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.2134107167600363`, 6.040254711277414}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8983254625819581`, 
             1.9600947840472698`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.498325462581958, 
             1.9600947840472698`}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.6941466808930288}], 6., 
            
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.42390493433755033`, 8.1797604936999}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9239049343375502, 8.1797604936999}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-5.298317366548036, 2.6490076604684267`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.995732273553991, 3.8004208288468435`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.39598343210629744`, 6.984716320118266}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.7959834321062975, 6.984716320118266}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.017383521085972, 0.8385453832493022}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.21482898128064304`, 1.937301774518713}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.2248289812806425`, 1.937301774518713}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.30265191133381086`, 2.419478844465545}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.1726519113338107`, 2.419478844465545}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.33587546767674265`, 2.502255288122613}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9738754676767425`, 2.502255288122613}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1268709406490898`, 6.253828811575473}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5268709406490897`, 6.253828811575473}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.397978879261335, 2.498151876538021}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9199788792613353`, 2.498151876538021}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-8.403864506109235, 
             1.0698698198024557`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.0527629684953679`, 7.600902459542082}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.4527629684953678`, 7.600902459542082}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.32035202312325517`, 6.960347729101308}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.9203520231232553, 6.960347729101308}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.3136238093329616, 8.290041618704489}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.8136238093329614, 8.290041618704489}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.9910270779881722}], 6., 
            
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.6592740514339194, 6.721425700790643}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0592740514339192`, 6.721425700790643}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-1.308776554863201, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-4.908776554863201, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334569144331189, 6.269096283706261}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834569144331189, 6.269096283706261}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.6093208658153495`, 4.0943445622221}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.909320865815349, 4.0943445622221}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 1.3982229319851645`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7045014380048455`, 1.8656293177945105`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8785014380048457`, 1.8656293177945105`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7620499515598584`, 6.841615476477592}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262049951559858, 6.841615476477592}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.251047211711865}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.807796846925679}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.706138360410137, 6.674561391814426}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.106138360410137, 6.674561391814426}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.5107219394949427`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 1.1464496180822696`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.1921026317554486`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.9980550336767947}], 6., 
            
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.4890765557629164`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.739076112448345}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.30932086581535, 4.0943445622221}], 4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-5.20932086581535, 4.0943445622221}], 4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.8424288832756998}], 6., 
            
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.406587064387653}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.4337237600891445, 6.946975992135418}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8337237600891445, 6.946975992135418}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5102709425975442`, 1.9358598132018119`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.932270942597544, 1.9358598132018119`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.251619457793289}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.9404590851592131, 6.39024066706535}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.440459085159213, 6.39024066706535}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.8839343632035077, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-5.503934363203508, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.555615105736594}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.4305150837187387, 
             2.827905162910489}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2305150837187386`, 
             2.827905162910489}], 4., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.18260024713539286`, 2.136530508663963}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.858600247135393, 2.136530508663963}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.236923904465622}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.8146618624453594`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3892352051165808`, 5.991464547107982}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.789235205116581, 5.991464547107982}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.2406373244969853`, 6.363028103540465}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7406373244969853`, 6.363028103540465}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 1.2499017362143359`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.0363197520242107`, 7.56734567601324}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.5363197520242107`, 7.56734567601324}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.238485302016438, 7.365180126021013}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7384853020164377`, 7.365180126021013}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 0.9991602096964498}], 6., 
            
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.2581768583394481`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.19447772015259945`, 2.0706530356467567`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9784777201525996`, 2.0706530356467567`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.5703520231232552, 6.960347729101308}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.6703520231232553, 6.960347729101308}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.340512168464763}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.6444188813293459`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-5.298317366548036, 2.0471765810925606`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.1026043099376472`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.685344432243678, 5.768320995793772}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.485344432243678, 5.768320995793772}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7173448322214127, 2.5087859235779435`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5793448322214125`, 2.5087859235779435`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.2259065198095778`, 6.104793232414985}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.7259065198095775`, 6.104793232414985}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.5959101490553134`, 6.907755278982137}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.295910149055313, 6.907755278982137}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.4958211856471328`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6063667205716478, 2.5877640352277083`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5323667205716478`, 2.5877640352277083`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.738772150727949, 1.803358605071407}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9687721507279492`, 1.803358605071407}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1484668646973284`, 6.455198563340122}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.648466864697328, 6.455198563340122}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7812206985481321, 7.822444729489319}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2812206985481318`, 7.822444729489319}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3796406197516198`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8796406197516198`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.963188584855586}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-4.3428059215206005`, 
             2.6490076604684267`}], 5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.896419739771488}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-0.8204414117014135, 7.783224016336037}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-1.3204414117014134`, 7.783224016336037}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-6.214608098422191, 1.6094379124341003`}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.6587993419718245`}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 2.066736169182282}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-4.409320865815349, 4.0943445622221}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-5.1093208658153495`, 4.0943445622221}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.5102803409008818`}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-3.666173685255404, 4.787491742782046}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-4.466173685255405, 4.787491742782046}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.23950770937246224`, 1.4996230464268938`}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-4.075507709372462, 1.4996230464268938`}], 5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 2.215282764591249}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9305150837187387, 
             2.827905162910489}], 4., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7305150837187386, 
             2.827905162910489}], 4., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 0.9543569326806114}], 6., 
            
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-2.199836616461977, 6.253828811575473}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-2.999836616461977, 6.253828811575473}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.6591800043289144`}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.9510398268753117`}], 5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-3.953855757707185, 4.499809670330265}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-4.753855757707186, 4.499809670330265}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.7479817218821596`}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 0.6951451832226183}], 6., 
            
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-0.9204414117014135, 7.783224016336037}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-1.2204414117014133`, 7.783224016336037}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.878196476740593, 
             1.7776605448485534`}], 5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.3136238093329616, 8.290041618704489}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.8136238093329614, 8.290041618704489}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5749085737794912`, 2.020222182019865}], 5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6989085737794913`, 2.020222182019865}], 5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.41818208557969155`, 2.6019486702196644`}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6921820855796914`, 2.6019486702196644`}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7969109142912192, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2969109142912192`, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.9809291040876105`, 6.62273632394984}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809291040876102`, 6.62273632394984}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.20091672340788796`, 2.0082140323914683`}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0969167234078876`, 2.0082140323914683`}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.5628691807704129, 6.81783057145415}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.9628691807704128, 6.81783057145415}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.36140843158277425`, 2.599722324216582}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7534084315827743`, 2.599722324216582}], 5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1038991427182467`, 2.413231613081109}], 5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3838991427182468`, 2.413231613081109}], 5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.4420193761824103`, 
             3.2386784521643803`}], 5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-2.999776554863201, 4.386765389021055}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-3.217776554863201, 4.386765389021055}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-7.1308988302963465`, 
             1.2424239907001886`}], 5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9192315758708453, 6.461468176353717}],
             6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3192315758708453`, 6.461468176353717}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-4.3593208658153495`, 4.0943445622221}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-5.159320865815349, 4.0943445622221}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2569588271331155, 2.0731719286662407`}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9109588271331153`, 2.0731719286662407`}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.452179964132715, 7.151485463904735}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.952179964132715, 7.151485463904735}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.18776553100876345`, 7.1929342212158}],
             6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.5877655310087636, 7.1929342212158}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-0.8762388061002749, 2.503891949699081}],
             5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4302388061002749`, 2.503891949699081}], 5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2739488299021849, 2.5771819258971713`}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8859488299021847`, 2.5771819258971713`}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.083934363203508, 4.386765389021055}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.303934363203508, 4.386765389021055}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.23392757277192572`, 7.146772179452637}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.6339275727719259, 7.146772179452637}],
             6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.03647223662121282, 7.24422751560335}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.6364722366212128, 7.24422751560335}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.08072450996508, 6.249975242259483}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.58072450996508, 6.249975242259483}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.28533549351760507`, 2.4997952622817508`}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.029335493517605, 2.4997952622817508`}], 5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.3136238093329616, 8.290041618704489}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.8136238093329614, 8.290041618704489}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-0.8027629684953678, 7.600902459542082}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-1.702762968495368, 7.600902459542082}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.18763844305879254`, 2.6224923127405635`}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8816384430587925`, 2.6224923127405635`}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-0.7970954386231031, 2.512035317176253}],
             5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-1.493095438623103, 2.512035317176253}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.23872501506251992`, 1.601405740736836}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.8727250150625196`, 1.601405740736836}], 5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5396397452642098, 2.5974910105351463`}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5796397452642097`, 2.5974910105351463`}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 0.9329511727672622}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-4.3428059215206005`, 
             3.2386784521643803`}], 5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-0.6527888252912907, 2.506341930508065}],
             5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6487888252912908`, 2.506341930508065}], 5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-1.093809961884693, 4.386889790339869}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-5.293809961884693, 4.386889790339869}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.249473262741422, 6.131226489483141}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6494732627414221`, 6.131226489483141}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.529318843261892, 
             1.9033008439609624`}], 5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.102583303777579, 7.501082124259871}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.602583303777579, 7.501082124259871}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.21482267929402327`, 2.519308076505333}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-2.060822679294023, 2.519308076505333}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8766948407025825`, 1.6114359150967734`}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.2146948407025824`, 1.6114359150967734`}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-3.953855757707185, 4.499809670330265}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-4.753855757707186, 4.499809670330265}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.7409075149860491`, 6.862757913051401}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.240907514986049, 6.862757913051401}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.6561383604101372, 6.674561391814426}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.156138360410137, 6.674561391814426}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.0363197520242107`, 7.56734567601324}],
             6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.5363197520242107`, 7.56734567601324}],
             6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-8.532306829226286, 1.2424239907001886`}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-4.3593208658153495`, 4.0943445622221}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-5.159320865815349, 4.0943445622221}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.28647223662121285`, 7.24422751560335}],
             6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.3864722366212129, 7.24422751560335}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1148124723039907`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6148124723039907`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8235151471242033`, 1.6956156086751528`}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0995151471242033`, 1.6956156086751528`}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.42035202312325515`, 6.960347729101308}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.8203520231232553, 6.960347729101308}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9712643014359971, 7.6324011266014535`}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.471264301435997, 7.6324011266014535`}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-0.6972978603872035, 8.006367567650246}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-0.9972978603872036, 8.006367567650246}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.18609950972944322`, 2.423031246069913}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-2.282099509729443, 2.423031246069913}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-0.5972978603872036, 8.006367567650246}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-1.0972978603872034`, 8.006367567650246}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-2.023945949998313, 6.429719478039138}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-2.823945949998313, 6.429719478039138}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.9404590851592131, 6.39024066706535}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.440459085159213, 6.39024066706535}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-0.8704414117014133, 7.783224016336037}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-1.2704414117014133`, 7.783224016336037}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-1.4135885922613587`, 7.090076835776092}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-2.1135885922613586`, 7.090076835776092}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.15446974274289163`, 2.5756610130564646`}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0084697427428915`, 2.5756610130564646`}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9314163895611922`, 1.534714366238164}], 5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-2.313416389561192, 1.534714366238164}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-0.6746151233923356, 2.58851563240702}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-1.4626151233923357`, 2.58851563240702}],
             5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1699988878712817`, 7.433666540166168}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6699988878712817`, 7.433666540166168}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.253235454499315, 8.350429973538136}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.753235454499315, 8.350429973538136}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-0.1453949783402653, 2.432735777459091}],
             5., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledSquare]", {-2.303394978340265, 2.432735777459091}], 
            5., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2667756376975805`, 4.386889790339869}], 
            3.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledCircle]", {-7.66677563769758, 4.386889790339869}], 
            3.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7503999213758159, 2.5817308344235403`}], 
            5., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4003999213758158`, 2.5817308344235403`}], 
            5., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3138716117510684, 2.5862591440482876`}], 
            5., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8278716117510683`, 2.5862591440482876`}], 
            5., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.47340843158277435`, 2.599722324216582}], 
            5., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6414084315827742`, 2.599722324216582}], 5., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledSquare]", {-0.8026151233923355, 2.58851563240702}], 
            5., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledSquare]", {-1.3346151233923356`, 2.58851563240702}],
             5., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111425593016979, 6.492239835020471}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.611425593016979, 6.492239835020471}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.1587765548632012`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-5.058776554863201, 4.386765389021055}],
             4.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.31775451027898877`, 4.512945241945574}], 
            5.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-5.817754510278989, 4.512945241945574}], 
            5.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.199705077879927, 0.755182571479398}],
             4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.5128691807704129, 6.81783057145415}], 
            6.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.0128691807704129`, 6.81783057145415}], 
            6.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3839343632035077`, 4.386765389021055}],
             4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-5.003934363203508, 4.386765389021055}], 
            4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1880444412935667`, 2.3850863145057892`}], 
            5., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3560444412935668`, 2.3850863145057892`}], 
            5., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3117849953272924, 2.6993457604720636`}], 
            5., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6037849953272925`, 2.6993457604720636`}], 
            5., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820072438863218`, 6.921658184151129}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.182007243886322, 6.921658184151129}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.3796406197516198`, 7.22402480828583}],
             6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.8796406197516198`, 7.22402480828583}],
             6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.906544110754825, 7.697121317282625}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4065441107548249`, 7.697121317282625}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-0.6204414117014133, 7.783224016336037}], 
            4.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-1.5204414117014136`, 7.783224016336037}],
             4.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9712643014359971, 7.6324011266014535`}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.471264301435997, 7.6324011266014535`}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-0.6472978603872035, 8.006367567650246}], 
            4.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-1.0472978603872034`, 8.006367567650246}],
             4.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.102583303777579, 7.501082124259871}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.602583303777579, 7.501082124259871}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.906544110754825, 7.697121317282625}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4065441107548249`, 7.697121317282625}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8440512773405471, 7.759614150696903}],
             6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.344051277340547, 7.759614150696903}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3079303552881687`, 7.295735072749282}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8079303552881685`, 7.295735072749282}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.0363197520242107`, 7.56734567601324}],
             6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.5363197520242107`, 7.56734567601324}],
             6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.7812206985481321, 7.822444729489319}],
             6., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2812206985481318`, 7.822444729489319}], 6., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6042429605294894`, 6.999422467507961}], 6., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1042429605294894`, 6.999422467507961}], 6., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8440512773405471, 7.759614150696903}],
             6., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.344051277340547, 7.759614150696903}], 
            6., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.018874035651734, 6.584791392385716}], 
            6., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.518874035651734, 6.584791392385716}], 
            6., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.238485302016438, 7.365180126021013}], 
            6., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7384853020164377`, 7.365180126021013}], 6., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9712643014359971, 7.6324011266014535`}], 
            6., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.471264301435997, 7.6324011266014535`}], 6., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.7198422131452975, 7.8838232148921525`}], 
            6., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2198422131452975`, 7.8838232148921525`}], 
            6., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.7812206985481321, 7.822444729489319}],
             6., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2812206985481318`, 7.822444729489319}], 6., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5270116125934994`, 7.076653815443951}], 6., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0270116125934994`, 7.076653815443951}], 6., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.153934363203508, 4.386765389021055}], 
            4.25, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-5.233934363203508, 4.386765389021055}], 
            4.25, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.4339343632035078`, 
             4.386765389021055}], 4.25, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.9539343632035076`, 
             4.386765389021055}], 4.25, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1699988878712817`, 7.433666540166168}], 6., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6699988878712817`, 7.433666540166168}], 6., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.906544110754825, 7.697121317282625}], 
            6., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4065441107548249`, 7.697121317282625}], 6., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.7198422131452975, 7.8838232148921525`}], 
            6., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2198422131452975`, 7.8838232148921525`}], 
            6., 
            RGBColor[1, 0, 0]]}}, {
         Frame -> True, 
          FrameTicks -> {{{-13.815510557964274`, 
              "\!\(\*SuperscriptBox[\(10\), \(-6\)]\)", {0.02, 
              0.}}, {-13.122363377404328`, "", {
              0.01, 0}}, {-12.716898269296165`, "", {
              0.01, 0}}, {-12.429216196844383`, "", {
              0.01, 0}}, {-12.206072645530174`, "", {
              0.01, 0}}, {-12.02375108873622, "", {
              0.01, 0}}, {-11.86960040890896, "", {
              0.01, 0}}, {-11.736069016284437`, "", {
              0.01, 0}}, {-11.618285980628055`, "", {
              0.01, 0}}, {-11.512925464970229`, 
              "\!\(\*SuperscriptBox[\(10\), \(-5\)]\)", {0.02, 
              0.}}, {-10.819778284410283`, "", {
              0.01, 0}}, {-10.414313176302118`, "", {
              0.01, 0}}, {-10.126631103850338`, "", {
              0.01, 0}}, {-9.903487552536127, "", {
              0.01, 0}}, {-9.721165995742174, "", {
              0.01, 0}}, {-9.567015315914915, "", {
              0.01, 0}}, {-9.433483923290392, "", {
              0.01, 0}}, {-9.315700887634009, "", {
              0.01, 0}}, {-9.210340371976182, 
              "\!\(\*SuperscriptBox[\(10\), \(-4\)]\)", {0.02, 
              0.}}, {-8.517193191416238, "", {0.01, 0}}, {-8.111728083308073, 
              "", {0.01, 0}}, {-7.824046010856292, "", {
              0.01, 0}}, {-7.600902459542082, "", {
              0.01, 0}}, {-7.418580902748127, "", {
              0.01, 0}}, {-7.264430222920869, "", {
              0.01, 0}}, {-7.1308988302963465`, "", {
              0.01, 0}}, {-7.013115794639964, "", {
              0.01, 0}}, {-6.907755278982137, 
              "\!\(\*SuperscriptBox[\(10\), \(-3\)]\)", {0.02, 
              0.}}, {-6.214608098422191, "", {0.01, 0}}, {-5.809142990314028, 
              "", {0.01, 0}}, {-5.521460917862246, "", {
              0.01, 0}}, {-5.298317366548036, "", {
              0.01, 0}}, {-5.115995809754082, "", {
              0.01, 0}}, {-4.961845129926823, "", {
              0.01, 0}}, {-4.8283137373023015`, "", {
              0.01, 0}}, {-4.710530701645918, "", {
              0.01, 0}}, {-4.605170185988091, 
              "\!\(\*SuperscriptBox[\(10\), \(-2\)]\)", {0.02, 
              0.}}, {-3.912023005428146, "", {0.01, 0}}, {-3.506557897319982, 
              "", {0.01, 0}}, {-3.2188758248682006`, "", {
              0.01, 0}}, {-2.995732273553991, "", {
              0.01, 0}}, {-2.8134107167600364`, "", {
              0.01, 0}}, {-2.659260036932778, "", {
              0.01, 0}}, {-2.5257286443082556`, "", {
              0.01, 0}}, {-2.4079456086518722`, "", {
              0.01, 0}}, {-2.3025850929940455`, 
              "\!\(\*SuperscriptBox[\(10\), \(-1\)]\)", {0.02, 
              0.}}, {-1.6094379124341003`, "", {
              0.01, 0}}, {-1.203972804325936, "", {
              0.01, 0}}, {-0.916290731874155, "", {
              0.01, 0}}, {-0.6931471805599453, "", {
              0.01, 0}}, {-0.5108256237659905, "", {
              0.01, 0}}, {-0.3566749439387323, "", {
              0.01, 0}}, {-0.2231435513142097, "", {
              0.01, 0}}, {-0.10536051565782628`, "", {0.01, 0}}, {
             0., "1", {0.02, 0.}}, {0.6931471805599453, "", {0.01, 0}}, {
             1.0986122886681098`, "", {0.01, 0}}, {
             1.3862943611198906`, "", {0.01, 0}}, {
             1.6094379124341003`, "", {0.01, 0}}, {
             1.791759469228055, "", {0.01, 0}}, {
             1.9459101490553132`, "", {0.01, 0}}, {
             2.0794415416798357`, "", {0.01, 0}}, {
             2.1972245773362196`, "", {0.01, 0}}, {
             2.302585092994046, "\!\(\*SuperscriptBox[\(10\), \(1\)]\)", {
              0.02, 0.}}, {2.995732273553991, "", {0.01, 0}}, {
             3.4011973816621555`, "", {0.01, 0}}, {
             3.6888794541139363`, "", {0.01, 0}}, {
             3.912023005428146, "", {0.01, 0}}, {
             4.0943445622221, "", {0.01, 0}}, {
             4.248495242049359, "", {0.01, 0}}, {
             4.382026634673881, "", {0.01, 0}}, {
             4.499809670330265, "", {0.01, 0}}, {
             4.605170185988092, "\!\(\*SuperscriptBox[\(10\), \(2\)]\)", {
              0.02, 0.}}, {5.298317366548036, "", {0.01, 0}}, {
             5.703782474656201, "", {0.01, 0}}, {
             5.991464547107982, "", {0.01, 0}}, {
             6.214608098422191, "", {0.01, 0}}, {
             6.396929655216146, "", {0.01, 0}}, {
             6.551080335043404, "", {0.01, 0}}, {
             6.684611727667927, "", {0.01, 0}}, {
             6.802394763324311, "", {0.01, 0}}, {
             6.907755278982137, "\!\(\*SuperscriptBox[\(10\), \(3\)]\)", {
              0.02, 0.}}, {7.600902459542082, "", {0.01, 0}}, {
             8.006367567650246, "", {0.01, 0}}, {
             8.294049640102028, "", {0.01, 0}}, {
             8.517193191416238, "", {0.01, 0}}, {
             8.699514748210191, "", {0.01, 0}}, {
             8.85366542803745, "", {0.01, 0}}, {
             8.987196820661973, "", {0.01, 0}}, {
             9.104979856318357, "", {0.01, 0}}, {
             9.210340371976184, "\!\(\*SuperscriptBox[\(10\), \(4\)]\)", {
              0.02, 0.}}, {9.903487552536127, "", {0.01, 0}}, {
             10.308952660644293`, "", {0.01, 0}}, {
             10.596634733096073`, "", {0.01, 0}}, {
             10.819778284410283`, "", {0.01, 0}}, {
             11.002099841204238`, "", {0.01, 0}}, {
             11.156250521031495`, "", {0.01, 0}}, {
             11.289781913656018`, "", {0.01, 0}}, {
             11.407564949312402`, "", {0.01, 0}}}, {{-13.815510557964274`, 
              "\!\(\*SuperscriptBox[\(10\), \(-6\)]\)", {0.02, 
              0.}}, {-13.122363377404328`, "", {
              0.01, 0}}, {-12.716898269296165`, "", {
              0.01, 0}}, {-12.429216196844383`, "", {
              0.01, 0}}, {-12.206072645530174`, "", {
              0.01, 0}}, {-12.02375108873622, "", {
              0.01, 0}}, {-11.86960040890896, "", {
              0.01, 0}}, {-11.736069016284437`, "", {
              0.01, 0}}, {-11.618285980628055`, "", {
              0.01, 0}}, {-11.512925464970229`, 
              "\!\(\*SuperscriptBox[\(10\), \(-5\)]\)", {0.02, 
              0.}}, {-10.819778284410283`, "", {
              0.01, 0}}, {-10.414313176302118`, "", {
              0.01, 0}}, {-10.126631103850338`, "", {
              0.01, 0}}, {-9.903487552536127, "", {
              0.01, 0}}, {-9.721165995742174, "", {
              0.01, 0}}, {-9.567015315914915, "", {
              0.01, 0}}, {-9.433483923290392, "", {
              0.01, 0}}, {-9.315700887634009, "", {
              0.01, 0}}, {-9.210340371976182, 
              "\!\(\*SuperscriptBox[\(10\), \(-4\)]\)", {0.02, 
              0.}}, {-8.517193191416238, "", {0.01, 0}}, {-8.111728083308073, 
              "", {0.01, 0}}, {-7.824046010856292, "", {
              0.01, 0}}, {-7.600902459542082, "", {
              0.01, 0}}, {-7.418580902748127, "", {
              0.01, 0}}, {-7.264430222920869, "", {
              0.01, 0}}, {-7.1308988302963465`, "", {
              0.01, 0}}, {-7.013115794639964, "", {
              0.01, 0}}, {-6.907755278982137, 
              "\!\(\*SuperscriptBox[\(10\), \(-3\)]\)", {0.02, 
              0.}}, {-6.214608098422191, "", {0.01, 0}}, {-5.809142990314028, 
              "", {0.01, 0}}, {-5.521460917862246, "", {
              0.01, 0}}, {-5.298317366548036, "", {
              0.01, 0}}, {-5.115995809754082, "", {
              0.01, 0}}, {-4.961845129926823, "", {
              0.01, 0}}, {-4.8283137373023015`, "", {
              0.01, 0}}, {-4.710530701645918, "", {
              0.01, 0}}, {-4.605170185988091, 
              "\!\(\*SuperscriptBox[\(10\), \(-2\)]\)", {0.02, 
              0.}}, {-3.912023005428146, "", {0.01, 0}}, {-3.506557897319982, 
              "", {0.01, 0}}, {-3.2188758248682006`, "", {
              0.01, 0}}, {-2.995732273553991, "", {
              0.01, 0}}, {-2.8134107167600364`, "", {
              0.01, 0}}, {-2.659260036932778, "", {
              0.01, 0}}, {-2.5257286443082556`, "", {
              0.01, 0}}, {-2.4079456086518722`, "", {
              0.01, 0}}, {-2.3025850929940455`, 
              "\!\(\*SuperscriptBox[\(10\), \(-1\)]\)", {0.02, 
              0.}}, {-1.6094379124341003`, "", {
              0.01, 0}}, {-1.203972804325936, "", {
              0.01, 0}}, {-0.916290731874155, "", {
              0.01, 0}}, {-0.6931471805599453, "", {
              0.01, 0}}, {-0.5108256237659905, "", {
              0.01, 0}}, {-0.3566749439387323, "", {
              0.01, 0}}, {-0.2231435513142097, "", {
              0.01, 0}}, {-0.10536051565782628`, "", {0.01, 0}}, {
             0., "1", {0.02, 0.}}, {0.6931471805599453, "", {0.01, 0}}, {
             1.0986122886681098`, "", {0.01, 0}}, {
             1.3862943611198906`, "", {0.01, 0}}, {
             1.6094379124341003`, "", {0.01, 0}}, {
             1.791759469228055, "", {0.01, 0}}, {
             1.9459101490553132`, "", {0.01, 0}}, {
             2.0794415416798357`, "", {0.01, 0}}, {
             2.1972245773362196`, "", {0.01, 0}}, {
             2.302585092994046, "\!\(\*SuperscriptBox[\(10\), \(1\)]\)", {
              0.02, 0.}}, {2.995732273553991, "", {0.01, 0}}, {
             3.4011973816621555`, "", {0.01, 0}}, {
             3.6888794541139363`, "", {0.01, 0}}, {
             3.912023005428146, "", {0.01, 0}}, {
             4.0943445622221, "", {0.01, 0}}, {
             4.248495242049359, "", {0.01, 0}}, {
             4.382026634673881, "", {0.01, 0}}, {
             4.499809670330265, "", {0.01, 0}}, {
             4.605170185988092, "\!\(\*SuperscriptBox[\(10\), \(2\)]\)", {
              0.02, 0.}}, {5.298317366548036, "", {0.01, 0}}, {
             5.703782474656201, "", {0.01, 0}}, {
             5.991464547107982, "", {0.01, 0}}, {
             6.214608098422191, "", {0.01, 0}}, {
             6.396929655216146, "", {0.01, 0}}, {
             6.551080335043404, "", {0.01, 0}}, {
             6.684611727667927, "", {0.01, 0}}, {
             6.802394763324311, "", {0.01, 0}}, {
             6.907755278982137, "\!\(\*SuperscriptBox[\(10\), \(3\)]\)", {
              0.02, 0.}}, {7.600902459542082, "", {0.01, 0}}, {
             8.006367567650246, "", {0.01, 0}}, {
             8.294049640102028, "", {0.01, 0}}, {
             8.517193191416238, "", {0.01, 0}}, {
             8.699514748210191, "", {0.01, 0}}, {
             8.85366542803745, "", {0.01, 0}}, {
             8.987196820661973, "", {0.01, 0}}, {
             9.104979856318357, "", {0.01, 0}}, {
             9.210340371976184, "\!\(\*SuperscriptBox[\(10\), \(4\)]\)", {
              0.02, 0.}}, {9.903487552536127, "", {0.01, 0}}, {
             10.308952660644293`, "", {0.01, 0}}, {
             10.596634733096073`, "", {0.01, 0}}, {
             10.819778284410283`, "", {0.01, 0}}, {
             11.002099841204238`, "", {0.01, 0}}, {
             11.156250521031495`, "", {0.01, 0}}, {
             11.289781913656018`, "", {0.01, 0}}, {
             11.407564949312402`, "", {0.01, 0}}}, {{-13.815510557964274`, 
              ""}, {-13.122363377404328`, ""}, {-12.716898269296165`, 
              ""}, {-12.429216196844383`, ""}, {-12.206072645530174`, 
              ""}, {-12.02375108873622, ""}, {-11.86960040890896, 
              ""}, {-11.736069016284437`, ""}, {-11.618285980628055`, 
              ""}, {-11.512925464970229`, ""}, {-10.819778284410283`, 
              ""}, {-10.414313176302118`, ""}, {-10.126631103850338`, 
              ""}, {-9.903487552536127, ""}, {-9.721165995742174, 
              ""}, {-9.567015315914915, ""}, {-9.433483923290392, 
              ""}, {-9.315700887634009, ""}, {-9.210340371976182, 
              ""}, {-8.517193191416238, ""}, {-8.111728083308073, 
              ""}, {-7.824046010856292, ""}, {-7.600902459542082, 
              ""}, {-7.418580902748127, ""}, {-7.264430222920869, 
              ""}, {-7.1308988302963465`, ""}, {-7.013115794639964, 
              ""}, {-6.907755278982137, ""}, {-6.214608098422191, 
              ""}, {-5.809142990314028, ""}, {-5.521460917862246, 
              ""}, {-5.298317366548036, ""}, {-5.115995809754082, 
              ""}, {-4.961845129926823, ""}, {-4.8283137373023015`, 
              ""}, {-4.710530701645918, ""}, {-4.605170185988091, 
              ""}, {-3.912023005428146, ""}, {-3.506557897319982, 
              ""}, {-3.2188758248682006`, ""}, {-2.995732273553991, 
              ""}, {-2.8134107167600364`, ""}, {-2.659260036932778, 
              ""}, {-2.5257286443082556`, ""}, {-2.4079456086518722`, 
              ""}, {-2.3025850929940455`, ""}, {-1.6094379124341003`, 
              ""}, {-1.203972804325936, ""}, {-0.916290731874155, 
              ""}, {-0.6931471805599453, ""}, {-0.5108256237659905, 
              ""}, {-0.3566749439387323, ""}, {-0.2231435513142097, 
              ""}, {-0.10536051565782628`, ""}, {0., ""}, {
             0.6931471805599453, ""}, {1.0986122886681098`, ""}, {
             1.3862943611198906`, ""}, {1.6094379124341003`, ""}, {
             1.791759469228055, ""}, {1.9459101490553132`, ""}, {
             2.0794415416798357`, ""}, {2.1972245773362196`, ""}, {
             2.302585092994046, ""}, {2.995732273553991, ""}, {
             3.4011973816621555`, ""}, {3.6888794541139363`, ""}, {
             3.912023005428146, ""}, {4.0943445622221, ""}, {
             4.248495242049359, ""}, {4.382026634673881, ""}, {
             4.499809670330265, ""}, {4.605170185988092, ""}, {
             5.298317366548036, ""}, {5.703782474656201, ""}, {
             5.991464547107982, ""}, {6.214608098422191, ""}, {
             6.396929655216146, ""}, {6.551080335043404, ""}, {
             6.684611727667927, ""}, {6.802394763324311, ""}, {
             6.907755278982137, ""}, {7.600902459542082, ""}, {
             8.006367567650246, ""}, {8.294049640102028, ""}, {
             8.517193191416238, ""}, {8.699514748210191, ""}, {
             8.85366542803745, ""}, {8.987196820661973, ""}, {
             9.104979856318357, ""}, {9.210340371976184, ""}, {
             9.903487552536127, ""}, {10.308952660644293`, ""}, {
             10.596634733096073`, ""}, {10.819778284410283`, ""}, {
             11.002099841204238`, ""}, {11.156250521031495`, ""}, {
             11.289781913656018`, ""}, {
             11.407564949312402`, ""}}, {{-13.815510557964274`, 
              ""}, {-13.122363377404328`, ""}, {-12.716898269296165`, 
              ""}, {-12.429216196844383`, ""}, {-12.206072645530174`, 
              ""}, {-12.02375108873622, ""}, {-11.86960040890896, 
              ""}, {-11.736069016284437`, ""}, {-11.618285980628055`, 
              ""}, {-11.512925464970229`, ""}, {-10.819778284410283`, 
              ""}, {-10.414313176302118`, ""}, {-10.126631103850338`, 
              ""}, {-9.903487552536127, ""}, {-9.721165995742174, 
              ""}, {-9.567015315914915, ""}, {-9.433483923290392, 
              ""}, {-9.315700887634009, ""}, {-9.210340371976182, 
              ""}, {-8.517193191416238, ""}, {-8.111728083308073, 
              ""}, {-7.824046010856292, ""}, {-7.600902459542082, 
              ""}, {-7.418580902748127, ""}, {-7.264430222920869, 
              ""}, {-7.1308988302963465`, ""}, {-7.013115794639964, 
              ""}, {-6.907755278982137, ""}, {-6.214608098422191, 
              ""}, {-5.809142990314028, ""}, {-5.521460917862246, 
              ""}, {-5.298317366548036, ""}, {-5.115995809754082, 
              ""}, {-4.961845129926823, ""}, {-4.8283137373023015`, 
              ""}, {-4.710530701645918, ""}, {-4.605170185988091, 
              ""}, {-3.912023005428146, ""}, {-3.506557897319982, 
              ""}, {-3.2188758248682006`, ""}, {-2.995732273553991, 
              ""}, {-2.8134107167600364`, ""}, {-2.659260036932778, 
              ""}, {-2.5257286443082556`, ""}, {-2.4079456086518722`, 
              ""}, {-2.3025850929940455`, ""}, {-1.6094379124341003`, 
              ""}, {-1.203972804325936, ""}, {-0.916290731874155, 
              ""}, {-0.6931471805599453, ""}, {-0.5108256237659905, 
              ""}, {-0.3566749439387323, ""}, {-0.2231435513142097, 
              ""}, {-0.10536051565782628`, ""}, {0., ""}, {
             0.6931471805599453, ""}, {1.0986122886681098`, ""}, {
             1.3862943611198906`, ""}, {1.6094379124341003`, ""}, {
             1.791759469228055, ""}, {1.9459101490553132`, ""}, {
             2.0794415416798357`, ""}, {2.1972245773362196`, ""}, {
             2.302585092994046, ""}, {2.995732273553991, ""}, {
             3.4011973816621555`, ""}, {3.6888794541139363`, ""}, {
             3.912023005428146, ""}, {4.0943445622221, ""}, {
             4.248495242049359, ""}, {4.382026634673881, ""}, {
             4.499809670330265, ""}, {4.605170185988092, ""}, {
             5.298317366548036, ""}, {5.703782474656201, ""}, {
             5.991464547107982, ""}, {6.214608098422191, ""}, {
             6.396929655216146, ""}, {6.551080335043404, ""}, {
             6.684611727667927, ""}, {6.802394763324311, ""}, {
             6.907755278982137, ""}, {7.600902459542082, ""}, {
             8.006367567650246, ""}, {8.294049640102028, ""}, {
             8.517193191416238, ""}, {8.699514748210191, ""}, {
             8.85366542803745, ""}, {8.987196820661973, ""}, {
             9.104979856318357, ""}, {9.210340371976184, ""}, {
             9.903487552536127, ""}, {10.308952660644293`, ""}, {
             10.596634733096073`, ""}, {10.819778284410283`, ""}, {
             11.002099841204238`, ""}, {11.156250521031495`, ""}, {
             11.289781913656018`, ""}, {11.407564949312402`, ""}}}, Axes -> 
          False, PlotLabel -> 
          Style["|\!\(\*SubscriptBox[\(\[Sigma]\), \
\(i\)]\)/\!\(\*SubscriptBox[\(D\), \(i\)]\)|, CT14NNLO", 24, 
            GrayLevel[0]], FrameLabel -> {
            Style["x", 18, 
             GrayLevel[0]], 
            Style["\[Mu] [GeV]", 18, 
             GrayLevel[0]]}, FrameTicksStyle -> GrayLevel[0], 
          ImageSize -> {{600}, {600}}, AspectRatio -> 1., 
          GridLines -> {{-16.11809565095832, -13.815510557964274`, \
-11.512925464970229`, -9.210340371976182, -6.907755278982137, \
-4.605170185988091, -2.3025850929940455`}, {
             Log[10], 
             Log[50], 
             Log[100], 
             Log[500], 
             Log[1000], 
             Log[5000], 
             Log[10000]}}, GridLinesStyle -> Directive[
            Dashing[{Small, Small}]], PlotRangeClipping -> True, 
          DisplayFunction -> Identity, PlotRangePadding -> {{0, 0}, {0, 0}}, 
          AxesOrigin -> {0, 0}, PlotRange -> {{-Log[100000], 0}, {0, 
             Log[6000]}}, PlotRangeClipping -> True, ImagePadding -> All, 
          DisplayFunction -> Identity, AspectRatio -> 1, Axes -> {True, True},
           AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
          Identity, Epilog -> {{
             Text[
              Style["Npt: 3966", 16, 
               GrayLevel[0]], 
              Scaled[{0.1, 0.9}]]}, {{
              Text[
               Style["Npt: 3966", 16, 
                GrayLevel[0]], 
               Scaled[{0.1, 0.9}]]}}}, 
          Frame -> {{False, False}, {False, False}}, 
          FrameLabel -> {{None, None}, {None, None}}, 
          FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
          GridLines -> {None, None}, GridLinesStyle -> Directive[
            GrayLevel[0.5, 0.4]], 
          Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 
                 2][#]& )[
                 Part[#, 2]]}& )}}, PlotRange -> {{-Log[100000], 0}, {0, 
             Log[6000]}}, PlotRangeClipping -> True, 
          PlotRangePadding -> {{0, 0}, {0, 0}}, 
          Ticks -> {Automatic, Automatic}}], 
        Placed[
         Unevaluated[
          BarLegend[{{
             RGBColor[0, 0.7, 0], 
             RGBColor[0, 0.7, 0], 
             RGBColor[0.75, 0.75, 0.], 
             RGBColor[0.75, 0.55, 0.], 
             RGBColor[0.7, 0., 0.], 
             RGBColor[0.7, 0., 0.]}, {-0.0030029999999999996`, 
            3.0060029999999998`}}, {-0.0030029999999999996`, 0, 0.375, 0.75, 
            1.5, 3.0029999999999997`, 3.0060029999999998`}, 
           LabelStyle -> {FontSize -> 14, 
             GrayLevel[0]}, LegendLabel -> "", LegendLayout -> "Column", 
           LegendMarkerSize -> {}, Charting`TickAnnotations -> None, 
           Charting`TickSide -> Right, ColorFunctionScaling -> True]], {1., 
         0.5}, Identity]]& ],
      AutoDelete->True,
      Editable->True,
      SelectWithContents->False,
      Selectable->True], ",", 
     TagBox[GridBox[{
        {
         InterpretationBox[Cell[BoxData[
           FormBox[
            
            StyleBox["\<\"|\\!\\(\\*SubscriptBox[\\(\[Sigma]\\), \\(i\\)]\\)/\
\\!\\(\\*SubscriptBox[\\(D\\), \\(i\\)]\\)|, CT14NNLO\\n\\n\"\>",
             StripOnInput->False,
             FontSize->24], TextForm]], "InlineText"],
          Text[
           Style[
           "|\!\(\*SubscriptBox[\(\[Sigma]\), \(i\)]\)/\!\(\*SubscriptBox[\(D\
\), \(i\)]\)|, CT14NNLO\n\n", FontSize -> 24]]], "\[SpanFromLeft]", 
         "\[SpanFromLeft]"},
        {"\<\"Data Sets\"\>", "", ""},
        {"\<\"\[FilledCircle]BcdF2pCor(101)\"\>", \
"\<\"\[FilledSquare]BcdF2dCor(102)\"\>", \
"\<\"\[FilledDiamond]NmcRatCor(104)\"\>"},
        {"\<\"\[FilledUpTriangle]cdhswf2(108)\"\>", \
"\<\"\[FilledDownTriangle]cdhswf3(109)\"\>", \
"\<\"\[EmptyCircle]ccfrf2.mi(110)\"\>"},
        {"\<\"\[EmptySquare]ccfrf3.md(111)\"\>", \
"\<\"\[EmptyDiamond]NuTvNuChXN(124)\"\>", \
"\<\"\[EmptyUpTriangle]NuTvNbChXN(125)\"\>"},
        {"\<\"\[EmptyDownTriangle]CcfrNuChXN(126)\"\>", \
"\<\"\[Times]CcfrNbChXN(127)\"\>", "\<\"\[CircleMinus]Hn1X0c(147)\"\>"},
        {"\<\"\[FivePointedStar]e605(201)\"\>", \
"\<\"\[FilledCircle]e866f(203)\"\>", "\<\"\[FilledSquare]e866ppxf(204)\"\>"},
        {"\<\"\[FilledDiamond]cdfLasy(225)\"\>", \
"\<\"\[FilledUpTriangle]cdfLasy2(227)\"\>", \
"\<\"\[FilledDownTriangle]d02Masy1(234)\"\>"},
        {"\<\"\[EmptyCircle]ZyD02a(260)\"\>", \
"\<\"\[EmptySquare]cdf2jtCor2(504)\"\>", "\<\"\[EmptyDiamond]d02jtCor2(514)\"\
\>"},
        {"\<\"\[EmptyUpTriangle]Hn+9900x0b(145)\"\>", "\<\"\
\[EmptyDownTriangle]H1FL10(169)\"\>", "\<\"\[Times]ATL7_WZ(268)\"\>"},
        {"\<\"\[CircleMinus]ATL7jtR6(535)\"\>", \
"\<\"\[FivePointedStar]LHCb7_WZ1(240)\"\>", \
"\<\"\[FilledCircle]LHCb7Wasy1(241)\"\>"},
        {"\<\"\[FilledSquare]d02Easy5(281)\"\>", \
"\<\"\[FilledDiamond]CMS7Masy2(266)\"\>", \
"\<\"\[FilledUpTriangle]CMS7jtR7v2(538)\"\>"},
        {"\<\"\[FilledDownTriangle]LHCb7ZWrap(245)\"\>", \
"\<\"\[EmptyCircle]LHCb8Zeer(246)\"\>", "\<\"\[EmptySquare]ATL7ZW(248)\"\>"},
        {"\<\"\[EmptyDiamond]CMS7jtR7y6(542)\"\>", \
"\<\"\[EmptyUpTriangle]ATL7jtR6u(544)\"\>", \
"\<\"\[EmptyDownTriangle]CMS8Wxa(249)\"\>"},
        {"\<\"\[Times]LHCb8WZ(250)\"\>", \
"\<\"\[CircleMinus]ATL8ttpt(565)\"\>", "\<\"\[FivePointedStar]ATL8ttya(566)\"\
\>"},
        {"\<\"\[FilledCircle]ATL8ttmtt(567)\"\>", \
"\<\"\[FilledSquare]ATL8ttytt(568)\"\>", ""},
        {
         InterpretationBox[Cell[BoxData[
           FormBox[
            StyleBox["\<\"\"\>",
             StripOnInput->False,
             FontSize->16], TextForm]], "InlineText"],
          Text[
           Style["", FontSize -> 16]]], "\[SpanFromLeft]", "\[SpanFromLeft]"}
       },
       AutoDelete->False,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{14}}},
       GridBoxItemStyle->{"Columns" -> {{
            Directive[FontSize -> 18, 
             GrayLevel[0]]}}, "Rows" -> {{
            Directive[FontSize -> 18, 
             GrayLevel[0]]}}}],
      "Grid"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     GraphicsBox[{
       {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
        EdgeForm[{Opacity[0.33599999999999997`], Thickness[Small]}], {}, 
        {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
         EdgeForm[{Opacity[0.33599999999999997`], Thickness[Small]}], 
         RectangleBox[{0., 0}, {0.06, 1643},
          RoundingRadius->0], RectangleBox[{0.06, 0}, {0.12, 976},
          RoundingRadius->0], RectangleBox[{0.12, 0}, {0.18, 625},
          RoundingRadius->0], RectangleBox[{0.18, 0}, {0.24, 268},
          RoundingRadius->0], RectangleBox[{0.24, 0}, {0.3, 106},
          RoundingRadius->0], RectangleBox[{0.3, 0}, {0.36, 101},
          RoundingRadius->0], RectangleBox[{0.36, 0}, {0.42, 56},
          RoundingRadius->0], RectangleBox[{0.42, 0}, {0.48, 36},
          RoundingRadius->0], RectangleBox[{0.48, 0}, {0.54, 27},
          RoundingRadius->0], RectangleBox[{0.54, 0}, {0.6, 15},
          RoundingRadius->0], 
         RectangleBox[{0.6, 0}, {0.6599999999999999, 18},
          RoundingRadius->0], 
         RectangleBox[{0.6599999999999999, 0}, {0.72, 12},
          RoundingRadius->0], RectangleBox[{0.72, 0}, {0.78, 10},
          RoundingRadius->0], RectangleBox[{0.78, 0}, {0.84, 6},
          RoundingRadius->0], 
         RectangleBox[{0.84, 0}, {0.8999999999999999, 8},
          RoundingRadius->0], 
         RectangleBox[{0.8999999999999999, 0}, {0.96, 3},
          RoundingRadius->0], RectangleBox[{0.96, 0}, {1.02, 4},
          RoundingRadius->0], RectangleBox[{1.02, 0}, {1.08, 2},
          RoundingRadius->0], RectangleBox[{1.08, 0}, {1.14, 8},
          RoundingRadius->0], RectangleBox[{1.2, 0}, {1.26, 4},
          RoundingRadius->0], RectangleBox[{1.5, 0}, {1.56, 2},
          RoundingRadius->0], RectangleBox[{2.04, 0}, {2.1, 2},
          RoundingRadius->0], 
         RectangleBox[{2.2199999999999998, 0}, {2.28, 2},
          RoundingRadius->0], 
         RectangleBox[{2.58, 0}, {2.6399999999999997, 2},
          RoundingRadius->0], RectangleBox[{2.94, 0}, {3., 2},
          RoundingRadius->0], RectangleBox[{3.9, 0}, {3.96, 2},
          RoundingRadius->0], RectangleBox[{3.96, 0}, {4.02, 2},
          RoundingRadius->0], RectangleBox[{4.68, 0}, {4.74, 4},
          RoundingRadius->0], RectangleBox[{7.319999999999999, 0}, {7.38, 2},
          RoundingRadius->0], RectangleBox[{8.64, 0}, {8.7, 2},
          RoundingRadius->0], RectangleBox[{10.2, 0}, {10.26, 2},
          RoundingRadius->0], RectangleBox[{11.7, 0}, {11.76, 2},
          RoundingRadius->0], 
         RectangleBox[{14.879999999999999, 0}, {14.94, 2},
          RoundingRadius->0], RectangleBox[{15., 0}, {15.059999999999999, 2},
          RoundingRadius->0], RectangleBox[{15.78, 0}, {15.84, 2},
          RoundingRadius->0], RectangleBox[{23.52, 0}, {23.58, 2},
          RoundingRadius->0], RectangleBox[{23.939999999999998, 0}, {24., 2},
          RoundingRadius->0], RectangleBox[{1824.78, 0}, {1824.84, 2},
          
          RoundingRadius->
           0]}, {}, {}}, {{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}}},
      AspectRatio->1,
      Axes->False,
      AxesLabel->{None, None},
      AxesOrigin->{-3.12, 0.},
      BaseStyle->{FontSize -> 16},
      Epilog->{{
         Thickness[Large], {
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[0.7, 0., 0.], StripOnInput -> False], 
            TraditionalForm], {-0.1, 1618.3549999999998`}], 
          StyleBox[
           LineBox[{{-0.1, 0.}, {-0.1, 1560.85}}], 
           RGBColor[0.7, 0., 0.], StripOnInput -> False]}, {
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[0.7, 0., 0.], StripOnInput -> False], 
            TraditionalForm], {0.1, 1552.6349999999998`}], 
          StyleBox[
           LineBox[{{0.1, 0.}, {0.1, 1560.85}}], 
           RGBColor[0.7, 0., 0.], StripOnInput -> False]}}, {
         Thickness[Large], 
         StyleBox[
          LineBox[{{0., 0.}, {0., 0.}}], 
          RGBColor[0., 0., 0.7], StripOnInput -> False]}, 
        InsetBox[
         FormBox[
          StyleBox["\"Npt: 3966\"", 16, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         Scaled[{0.1, 0.9}]]},
      Frame->True,
      FrameLabel->{
        FormBox[
         StyleBox[
         "\"|\\!\\(\\*SubscriptBox[\\(\[Sigma]\\), \
\\(i\\)]\\)/\\!\\(\\*SubscriptBox[\\(D\\), \\(i\\)]\\)|\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm], 
        FormBox[
         StyleBox["\"#points\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm]},
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImageSize->{{600}, {600}},
      PlotLabel->FormBox[
        StyleBox[
        "\"|\\!\\(\\*SubscriptBox[\\(\[Sigma]\\), \
\\(i\\)]\\)/\\!\\(\\*SubscriptBox[\\(D\\), \\(i\\)]\\)|, CT14NNLO\"", 24, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{-3., 3.}, {0., 1643}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}], ",", 
     GraphicsBox[{
       {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
        EdgeForm[{Opacity[0.33599999999999997`], Thickness[Small]}], {}, 
        {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
         EdgeForm[{Opacity[0.33599999999999997`], Thickness[Small]}], 
         RectangleBox[{0., 0}, {0.06, 1643},
          RoundingRadius->0], RectangleBox[{0.06, 0}, {0.12, 976},
          RoundingRadius->0], RectangleBox[{0.12, 0}, {0.18, 625},
          RoundingRadius->0], RectangleBox[{0.18, 0}, {0.24, 268},
          RoundingRadius->0], RectangleBox[{0.24, 0}, {0.3, 106},
          RoundingRadius->0], RectangleBox[{0.3, 0}, {0.36, 101},
          RoundingRadius->0], RectangleBox[{0.36, 0}, {0.42, 56},
          RoundingRadius->0], RectangleBox[{0.42, 0}, {0.48, 36},
          RoundingRadius->0], RectangleBox[{0.48, 0}, {0.54, 27},
          RoundingRadius->0], RectangleBox[{0.54, 0}, {0.6, 15},
          RoundingRadius->0], 
         RectangleBox[{0.6, 0}, {0.6599999999999999, 18},
          RoundingRadius->0], 
         RectangleBox[{0.6599999999999999, 0}, {0.72, 12},
          RoundingRadius->0], RectangleBox[{0.72, 0}, {0.78, 10},
          RoundingRadius->0], RectangleBox[{0.78, 0}, {0.84, 6},
          RoundingRadius->0], 
         RectangleBox[{0.84, 0}, {0.8999999999999999, 8},
          RoundingRadius->0], 
         RectangleBox[{0.8999999999999999, 0}, {0.96, 3},
          RoundingRadius->0], RectangleBox[{0.96, 0}, {1.02, 4},
          RoundingRadius->0], RectangleBox[{1.02, 0}, {1.08, 2},
          RoundingRadius->0], RectangleBox[{1.08, 0}, {1.14, 8},
          RoundingRadius->0], RectangleBox[{1.2, 0}, {1.26, 4},
          RoundingRadius->0], RectangleBox[{1.5, 0}, {1.56, 2},
          RoundingRadius->0], RectangleBox[{2.04, 0}, {2.1, 2},
          RoundingRadius->0], 
         RectangleBox[{2.2199999999999998, 0}, {2.28, 2},
          RoundingRadius->0], 
         RectangleBox[{2.58, 0}, {2.6399999999999997, 2},
          RoundingRadius->0], RectangleBox[{2.94, 0}, {3., 2},
          RoundingRadius->0], RectangleBox[{3.9, 0}, {3.96, 2},
          RoundingRadius->0], RectangleBox[{3.96, 0}, {4.02, 2},
          RoundingRadius->0], RectangleBox[{4.68, 0}, {4.74, 4},
          RoundingRadius->0], RectangleBox[{7.319999999999999, 0}, {7.38, 2},
          RoundingRadius->0], RectangleBox[{8.64, 0}, {8.7, 2},
          RoundingRadius->0], RectangleBox[{10.2, 0}, {10.26, 2},
          RoundingRadius->0], RectangleBox[{11.7, 0}, {11.76, 2},
          RoundingRadius->0], 
         RectangleBox[{14.879999999999999, 0}, {14.94, 2},
          RoundingRadius->0], RectangleBox[{15., 0}, {15.059999999999999, 2},
          RoundingRadius->0], RectangleBox[{15.78, 0}, {15.84, 2},
          RoundingRadius->0], RectangleBox[{23.52, 0}, {23.58, 2},
          RoundingRadius->0], RectangleBox[{23.939999999999998, 0}, {24., 2},
          RoundingRadius->0], RectangleBox[{1824.78, 0}, {1824.84, 2},
          
          RoundingRadius->
           0]}, {}, {}}, {{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}}},
      AspectRatio->1,
      Axes->False,
      AxesLabel->{None, None},
      AxesOrigin->{-0.06, 0.},
      BaseStyle->{FontSize -> 16},
      Epilog->{{
         Thickness[Large], {
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[0.7, 0., 0.], StripOnInput -> False], 
            TraditionalForm], {0.1, 1618.3549999999998`}], 
          StyleBox[
           LineBox[{{0.1, 0.}, {0.1, 1560.85}}], 
           RGBColor[0.7, 0., 0.], StripOnInput -> False]}}, {
         Thickness[Large], 
         StyleBox[
          LineBox[{{0., 0.}, {0., 0.}}], 
          RGBColor[0., 0., 0.7], StripOnInput -> False]}, 
        InsetBox[
         FormBox[
          StyleBox["\"Npt: 3966\"", 16, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         Scaled[{0.1, 0.9}]]},
      Frame->True,
      FrameLabel->{
        FormBox[
         StyleBox[
         "\"|\\!\\(\\*SubscriptBox[\\(\[Sigma]\\), \
\\(i\\)]\\)/\\!\\(\\*SubscriptBox[\\(D\\), \\(i\\)]\\)|\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm], 
        FormBox[
         StyleBox["\"#points\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm]},
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImageSize->{{600}, {600}},
      PlotLabel->FormBox[
        StyleBox[
        "\"|\\!\\(\\*SubscriptBox[\\(\[Sigma]\\), \
\\(i\\)]\\)/\\!\\(\\*SubscriptBox[\\(D\\), \\(i\\)]\\)|, CT14NNLO\"", 24, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{0., 3.}, {0., 1643}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}]}], "}"}], ",", 
   RowBox[{"{", "xQplotcorr2$4354591", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.721143582480946*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"processdataplotsmultiexp7percentage", "[", 
  RowBox[{
   RowBox[{"{", "residualdataclassfinal", "}"}], ",", 
   RowBox[{"readcorrconfigfile6", "[", 
    RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "3", ",", 
   "flavour"}], "]"}]], "Input",
 CellChangeTimes->{{3.719195591349831*^9, 3.719195591457168*^9}, {
  3.719222888598423*^9, 3.719222888691361*^9}, {3.721098183809052*^9, 
  3.721098183963562*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     TagBox[
      GraphicsBox[{InsetBox[
         GraphicsBox[{{{{}, {{}, 
              {GrayLevel[1], PointSize[0.012833333333333334`], 
               AbsoluteThickness[1.6], 
               StyleBox[PointBox[{{0.00001, 2.}, {0.99, 1200.}}],
                FontFamily->"Helvetica"]}, {}}, {}, {}, {{}, {}}}, {
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {29.659169363220833, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-38.34104853637971, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.4420193761824103, 3.2386784521643803}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.4028303297599902, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.278818960372969, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.194022473472768, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.793961892783255, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.907755278982137, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0302996484860225, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0181583132629375, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.666335489679042, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.466278187121473, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1796054478776414, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6798603767306461, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.4122057429043917}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.8424288832756998}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.391511302188447}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.0738571633859353, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.5732134108799993, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5782126424678459, 1.5432981099295553}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.6504282677396835, 1.5432981099295553}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.8179208722379223, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.317867774075151, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.3681303904922195}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.038175919864279, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.548102073285148, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7756596021344095, 2.418588768750352}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.701553201341906, 2.418588768750352}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.6888794541139363, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5692561228012685, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7696066645869217, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 0.8055826098897335}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.5047438413194347}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.11206147220931, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 0.849723487602042}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5064301623598713, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1062413158326008, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 0.7476353658440151}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4405393759722864, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8407396514497736, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 0.7466879474879751}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.741256487054948, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.9407951330603375, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.2533450600473311, 8.350429973538136}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7533219035960154, 8.350429973538136}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5235731965884932, 2.50470927708418}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7820071777853768, 2.50470927708418}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.5107219394949427}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.283414346005772, 5.703782474656201}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.5787702314339063, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.978697138696139, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.4420193761824103, 3.2386784521643803}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9715392061046336, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9515240188896708, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9689006821464524, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5687759307152107, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.609379030762146, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.909388227079972, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.6409365794934714}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.144222799920162}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9001713499942718, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.424056675808238, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.622553707074063, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.2876820724517809, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.6527732864216721, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.028919972120757, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 1.094604267270571}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.3178664036290963, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.817847430944174, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 2.377692565480851}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.2908841763152323}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.5859645562484583}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9038682118755978, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3037931396081468, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.7963700817857382, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.096384262410148, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.8420006856648017, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.091798316674432, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.5902550930173265}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.669026703845758}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7672619976276676, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.166785108860756, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 0.9364854391596744}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4409617624621989, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6414447085691868, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0277811079075183, 1.9768549529047348}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.333559897293476, 1.9768549529047348}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.816462081868427, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4159291662495814, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3983669423541598, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9987836386623814, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8787541283454292, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.2367852454117685, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2669126040998102, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.666828609658249, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.0654001544619962}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6888794541139363, 5.298317366548036}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7159101569446171, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5159475693467614, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.607650686531799, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.7317869551252127, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.201916872261721, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 1.8359358315608838}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7903190923122189, 1.6272778305624314}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.270169119255751, 1.6272778305624314}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.995732273553991, 5.991464547107982}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.3039860739096736, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.083998270167957, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.6888794541139363, 1.0942695392339727}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 0.9858167945227654}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.8162894669713328}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.5565205830281202, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3567355588783463, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.863232841258714, 0.8333438110532289}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.6854573524495757, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.4854489341097463, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3208812225716584, 2.0095554142156695}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9747212309094329, 2.0095554142156695}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.045554398052668, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.908818717035454, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.3089739467365655, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.595748829015065, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.395911377232918, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.3524072174927233, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.26683423993894284, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-8.666853965970644, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.820158943749753, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.220083871482302, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5186835491656363, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5186835491656363, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.8526977673331346}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.817803785159501, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.317908016313041, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.640548907459153}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.6094379124341003, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0202633222571333, 1.4929040961781488}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.3082536360194172, 1.4929040961781488}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 0.965080896043587}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 2.0427775573082445}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.59947470469731, 8.004365564979574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0993125337825032, 8.004365564979574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8598242001421843, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2595256035335987, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5177604746590787, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.6178619668786562, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.3524072174927233, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8598242001421843, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2595256035335987, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.9178457348969196, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.2178763245351174, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.898454207899018, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4983438649285135, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.154094566627875, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.554477071672573, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 0.9489515141137035}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.5432981099295553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.8469979053782056, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.247228312996893, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.3428059215206005, 2.6490076604684267}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 1.0678093795130645}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.377606779979768, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7955707986317053, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7655070980839893, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3657077275115024, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.56019682034536, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.959419502711985, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.2098554674840916}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2808538486618937, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3811078344325904, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.430629081771714, 2.827905162910489}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2306590695884416, 2.827905162910489}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.468806782694355, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.068859330518762, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.721515815839451}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 1.173410498743296}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.236923904465622}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 1.3147983594148207}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1689274625831354, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3688474475161698, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2437536743377806, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.744112815760702, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 0.9364854391596744}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2854179707987138, 2.4997952622817508}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.029509172931627, 2.4997952622817508}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.4365120772805082}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.1597073880279205}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 2.0680013515372804}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.3452119160186606}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.5920892740994874, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.341928551227046, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.8505029913361519, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.350408373771412, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2824955457644808, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.4686200579795896, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2184098521237055, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8189251373008244, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.8706006059570394, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.2704687956143002, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.366940997255841, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.566911473871001, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6792442753909539, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.491327217590923, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 1.3982229319851645}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5832829549572491, 1.5933085305042167}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.5449114637250294, 1.5933085305042167}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.615959129424366, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.615959129424366, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.395133309787095, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.77313400510489, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8195418502405067, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.319222734147069, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.33589240475620386, 2.502255288122613}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.974001029221839, 2.502255288122613}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1304126012179074, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9186841628017217, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.9782390361706734}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.991464547107982, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.529318843261892, 1.9033008439609624}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.06016413371338, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.860379772276308, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.2140221401789375}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8457617469776957, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.145857732131629, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2942622756733968, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.694451286761057, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.4958211856471328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4240364936935998, 8.1797604936999}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9240709191931175, 8.1797604936999}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.362224007377702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.57270299585059, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.3137876703331426, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.409603402444116, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.2136588837996443, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.1093512670354135, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.9180031958023054, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.217869048507598, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.2255369822417765, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.975450465015525, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.0218709311636855, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.911914268349973, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.483987072728617, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.904054835778969, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.9782390361706734}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.9696906777207166, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3691523372661587, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4182464424728975, 2.6019486702196644}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", {-1.6922761907431048, 2.6019486702196644}],\

               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.742398039690331, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.542246662893777, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.46013250945047257, 2.512035317176253}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8307082193666298, 2.512035317176253}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.836849948493799, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.0968250627658085, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 2.1094856630282126}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4307829160924542, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.2262184132732556, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.725971728690052, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.4146938356415886, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8146187633741377, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.5136732904497212, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.0136538011418326, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.5100594684538216}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6969544189028993, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6009911288088023, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.287354413264987, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.287354413264987, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8042369907391675, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.584387646805562, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.0281898243715637}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.3418458069473482, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.592214878401959, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.309519943887134, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.209391157353635, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.166915255056936, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.76686592498839, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.3281354469463584}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.984131361875511, 7.003065458786462}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2173252490432223, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-6.717134919373487, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7987840841650193, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.598497972395766, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.2602187884025833, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.660097652688484, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.995732273553991, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.71869489837105, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3186357126460757, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.953887209526845, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.7539022397884905, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6745099091778153, 1.9300710850255671}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.780226233414382, 1.9300710850255671}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.199705077879927, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 0.6951451832226183}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.1406850650900175, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2406367886975274, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.0738571633859353, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.5732134108799993, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.2581768583394481}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.359873830032749, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.159425367681418, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.6675181235106251}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.084253098677058, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.30432512701003, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6691879168398742, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6691879168398742, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.76705723517796, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.166938288491657, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2453891602615295, 2.424802725718295}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.220083871482302, 2.424802725718295}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2942622756733968, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.694451286761057, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 2.0766877534832147}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-7.1308988302963465, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.4126383364594925, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.536426440357718, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5828588266658222, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.336815122732887, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.3418458069473482, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.592214878401959, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.618595850218866}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 0.8450095298691913}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.437751649736401, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.1760334356366946, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7760829898430475, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 2.647592232065096}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.6139480679119864, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.9139271032022627, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 1.5473497201206787}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.5288035062673013, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.028556821684098, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6414447085691868, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4409617624621989, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.430789601006442}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.000759888500605, 6.380122536899765}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4007990473227723, 6.380122536899765}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3670139217339117, 2.134048091170708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6790255220615937, 2.134048091170708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4460443655256647, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.946310229076653, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4422299934501939, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8426317996018116, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 0.9991602096964498}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6654793033177253, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4653375684603434, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.4018530946527146, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.532062329207643, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.5077842587076005, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.007679175452945, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5629964960949002, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9631203192309531, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.5845302767279155}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.132893222644984, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3329431856228962, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4159291662495814, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.816462081868427, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9904756300635316, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3907040696085906, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 2.215282764591249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.715777948205427}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.3524072174927233, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.082935809283102, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.1892564076870427, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.3137523001849649, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.813734143549063, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1214715828141923, 1.9387416595767009}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3154677188250594, 1.9387416595767009}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.8183088044615916, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.318488613869894, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.9251241812954787}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.815475995845371}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6445470895476684, 5.736572297479192}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.044846896915337, 5.736572297479192}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.666335489679042, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.466278187121473, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.44238846221276223, 1.501852701754163}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.868484703413663, 1.501852701754163}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.382026634673881, 0.8441500540964727}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7109170813839543, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1111386284230904, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.170932950247736}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.522010001878903, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.411934093335004, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.2756420910162956}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7696066645869217, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5692561228012685, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 2.4561641809223462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.6624240079171049, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.286478374605709, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8505029913361519, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6286207318508743, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.94874563428772, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.931658209005277, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.657689841763261, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.6393849888020524}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.904054835778969, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.803865056899991, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 0.898534010284896}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.7333680090865, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.406587064387653}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5918549290780729, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.5159350591325786, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.741015208534465, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.940782792197422, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 0.848868055556721}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.161367091078508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.064355904261795, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640797356921787, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.418781887396557, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.51875303057183, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6218266343535928, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.312220927289192, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.4847813078345447}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.4938666711595117, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.894183087299815, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4947708374559745, 5.886104031450156}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8951219822232084, 5.886104031450156}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.359436906950008}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8250798518207709, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7611345721946656, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.770028224895903, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3700273886560186, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.349630376748299}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-7.600902459542082, 1.6094379124341003}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.1029215602562081, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.4028303297599902, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4714166145367258, 2.187174241482718}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4714166145367258, 2.187174241482718}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3063747379440172, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3063747379440172, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 1.0962762288705619}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0645007590393418, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.26443077336305, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 0.8202202631234213}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2761851384398606, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6761120457020933, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1535965970008693, 1.4906543764441336}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1796551117149194, 1.4906543764441336}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.8665717425242287, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.266557384867768, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 0.9329511727672622}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.7418655495969406, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-6.191868611452702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.1597073880279205}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 1.3045418592476314}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.5639866495301828, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.9639722918737217, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.322289031143978}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.5539252025038417}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 0.849723487602042}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.995732273553991, 5.991464547107982}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.1780394222994315}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.25154302583590776, 2.130609828254235}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8016468498397944, 2.130609828254235}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 1.2184672504763885}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.3504080825554816}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.6939993778795506, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.694093021166824, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 0.986935571443487}],\

               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.251619457793289}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.631199404215613}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1208578976154293, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9949325933834268, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7607838292757566, 6.620073206530356}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.160913314865489, 6.620073206530356}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.2876820724517809, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.15218556191195, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.781788039865368, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9405834244431995, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.4405393759722864, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5104979645791967, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.932401799030521, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9329283730271782, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5329399414613754, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3257638613798584, 1.776645831418007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.435545220250276, 1.776645831418007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.5102244577722903, 6.476972362889683}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0288996762568094, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.652827532407001, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.363503507963463, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.2636117187095923, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.064355904261795, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640797356921787, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.7828868907244566}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5366522427084526, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.412267540691536, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1409980051645476, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.540748536722336, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.406587064387653}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.885443919659868, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.2855499581361935, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.6700167631710908, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4701108472130011, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7145751279735658, 1.9387416595767009}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7225041580723603, 1.9387416595767009}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0029385385998273, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.502828177375842, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.5177707239082765, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.617850239145466, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-7.284632930238389, 1.6094379124341003}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 2.0680013515372804}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.44926026810783587, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7212874278842305, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.4407825464039603}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.360956006320375, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.8610265707016995, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.21678878567620194, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.716864386545305, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              
              StyleBox[
               InsetBox["\<\"\[FilledCircle]\"\>", 
                {-0.2876820724517809, 2.719319793360441}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.5377270648801}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-6.214608098422191, 1.6094379124341003}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.144222799920162}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.2756420910162956}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0339487753423875, 2.418588768750352}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.443923473956527, 2.418588768750352}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2977324083052823, 1.6114359150967734}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.7937956240634962, 1.6114359150967734}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6269849783062765, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8129108417183852, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.4588475538015993}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.4126383364594925, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.536426440357718, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.342468881579861, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9428149441480107, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.463458318582131, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.1634411179801, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3093333199837622, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8097197946050478, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.019664337643975, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3191210616341453, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.2030071867437115, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.200028504668954, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.9999411183280458, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.2672179491567546, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-6.667164814064207, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.1850957485562468}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.0966102859974367}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.1269525243508878, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.807005375881994, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.2158025560795132}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 0.9403978072173882}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.2908841763152323}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.376740148315079, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8773173575897015, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.5305182571117267, 2.827905162910489}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1307223425863433, 2.827905162910489}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.322289031143978}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.8205261098897758, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.3205066205818874, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.564942672547549, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.664950622364359, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.4588475538015993}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.9782390361706734}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.0279882600909205, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.190415030972834, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.995732273553991, 3.8004208288468435}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.293897511853923, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-5.093908213290077, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9372477759766606, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4371455863897404, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1542307124311217, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-5.234028876665675, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6126737964100685, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6907507040241487, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.900458886151396, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3005870903313728, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.5532907518110994}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5228016057745537, 5.857933154483459}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.922779731666459, 5.857933154483459}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-4.3428059215206005, 3.2386784521643803}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.68510181635509}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5159475693467614, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7159101569446171, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.219163484854973, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.7188583998188136, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0328245481301066, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4329667693183212, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7178497932003172, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.417776806585365, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.6397713603489157}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.8162894669713328}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.412288358086009, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-6.536881615643591, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4405393759722864, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8407396514497736, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.746403767507258, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.1464364105041143, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8016236568960291, 6.579251212010101}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2016421889876536, 6.579251212010101}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.067986095126349, 2.3456445824544927}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.5558971455060706, 2.3456445824544927}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.2499926428748753, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.9499943818801375, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.4753441779534016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.725332537920259, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-4.045554398052668, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.575036485716768, 2.020222182019865}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6993626199620875, 2.020222182019865}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6445470895476684, 5.736572297479192}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.044846896915337, 5.736572297479192}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.184789984909162}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2654936609741865, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8656213178265104, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.719319793360441}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.5974734304916628, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0975128932248088, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.598497972395766, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7987840841650193, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4876628555081794, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.087375656742122, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.7317869551252127, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.201916872261721, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.437937594271729}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5906161581935125, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5906161581935125, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.3137523001849649, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.813734143549063, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 2.0624225365102413}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.0794415416798357, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.957577403480815, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.1413169453979233, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.541030999190403, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1080567474961094, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5082360319251331, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.140807436632442, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.541256860244439, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.5532907518110994}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9699552564598479, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1702157075278026, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.555615105736594}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-4.382026634673881, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.219163484854973, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.7188583998188136, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3186357126460757, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.71869489837105, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.7218733417638885}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.1966460289394751}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.6444188813293459}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.698815723585317, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.698815723585317, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.421661504957182}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.9353900445478294, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.235513466021224, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 2.075308010398229}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.2917089186300228}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.382026634673881, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.3504089023600859, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.850570223130148, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7174398731289899, 2.5087859235779435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5793937910857236, 2.5087859235779435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.8344641259578687, 6.152732694704104}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.659260036932778, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.137918471438812, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2377341206744292, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.585233223737283, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.632849755094834, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.2792657883613672}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.957577403480815, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 2.296667619230008}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.4532518292447716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5404260935422814, 8.063377822367027}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0404377246170375, 8.063377822367027}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 1.2499017362143359}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 2.04225875055212}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9519179095173061, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7958982916754054, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6544352783648362, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.1541650878757723, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.502290170873972, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.8470364847178946}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-8.403864506109235, 1.0698698198024557}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.669026703845758}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.2157956136516715, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.466024904841838, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.509860006183766, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.009386074695824, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.7317869551252127, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.201916872261721, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.104394898075602, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.604170685655008, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4850103340590484, 2.135349173618132}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.559220196273483, 2.135349173618132}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 1.4772770088317615}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3585338134237321, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.5645401798583287, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {31.659225875646104, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-40.340943771488284, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 0.9150900112976361}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.5377270648801}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.417771502803163, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.7181023127908395, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0923241675108497, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.841967538444134, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1702157075278026, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9699552564598479, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.744604469176456, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.739076112448345}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.1966460289394751}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 0.9543569326806114}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.017773404430871, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.117899907528199, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 2.2044208442068145}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.074653024948039, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.7740297600361856, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.902704363179782}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.5432981099295553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2669126040998102, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.666828609658249, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4240364936935998, 8.1797604936999}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9240709191931175, 8.1797604936999}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 2.4561641809223462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.2788685663767296, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.402746540537711, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.6772785424354564, 6.309918278226516}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.719319793360441}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.7790406968202803, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.902767737471098, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.100765130025024, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.10045059841862, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.4961092271270973, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3960170377865984, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 2.1992225799988927}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyDownTriangle]\"\>", 
                {-2.864704011147587, 1.2158025560795132}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.369240606554063, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9696906777207166, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.719319793360441}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.18777640747691846, 7.1929342212158}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.5878866699024524, 7.1929342212158}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              
              StyleBox[
               InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 2.075809955445786}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.8843386505211481}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3649243353836982, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.864975531559314, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.3492738284584218, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.599488434143067, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.9313764735639716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7667937207282438, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.166888494485349, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3943265328171548, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.594056810395798, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8584936331479384, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.314556464775266, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.6843598389513597}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.8947738884119054, 1.7316555451583497}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.9568962497687927, 1.7316555451583497}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-7.819058469345253, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.378751192832325, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.178596114669692, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 1.8728785205128469}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0808706071919527, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.5808504555821878, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.8029620465671519, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.7031992922485748, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 0.8307328435125084}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.1151705891340815}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.622553707074063, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9969586349416099, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0969137320325284, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0923241675108497, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.841967538444134, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.9474803442248305}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.1409980051645476, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.540748536722336, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.5539252025038417}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.3428059215206005, 3.2386784521643803}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.773934884315503}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.204382667431038, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.504420282887948, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.9474803442248305}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.8826660279157308}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.9999411183280458, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.2178763245351174, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.26443077336305, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0645007590393418, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8701230510291479, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.270112606830481, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.6564295976247825, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.256670593326385, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 2.1992225799988927}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.1026043099376472}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2180717287054377, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.91782824451005, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9542522381612738, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.2164073967529934, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.0940068428223313, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.2941383093687477, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.426283369336254, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.5260163042950279, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.3302529702362658}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.66341149948383, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.9634587130036953, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.3178883284558303, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.8178684794407625, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.9453385571563557}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.214608098422191, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.0281898243715637}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 2.217027204632399}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.3286906908754075, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.228790658775024, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.06016413371338, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.860379772276308, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.2101638842661795, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.710307401527557, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.7027460895677522}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.9245405804618736}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.1308988302963465, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2282654968949804, 6.152732694704104}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6281111776997217, 6.152732694704104}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.5779472453427295}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1874435023747254, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3874950816964096, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-6.214608098422191, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.605170185988091, 2.9290581402859983}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.6744763086133228}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.8958869385842747, 5.991464547107982}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-3.0957736277342174, 5.991464547107982}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.3563504847468186}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.9177918580004223, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.2178439823981595, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3171415024315738, 6.063785208687608}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7170231231140378, 6.063785208687608}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.5845302767279155}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7435408969575807, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.3434070875143007, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.8505029913361519, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.350408373771412, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.9837562915454279}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.2876820724517809, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8328691237350826, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6332184410995039, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 2.0624225365102413}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.6179742434563866, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.518075479137158, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9405834244431995, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.4405393759722864, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5173146235582946, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.017406150760383, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.7181373293574413, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.4178610876830975, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.6528674703614363, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.0287936073591935, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5901256014017275, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0898959995836948, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5601909533113197, 2.423031246069913}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9085180298382507, 2.423031246069913}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.696151689580244, 6.684611727667927}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0963149296194261, 6.684611727667927}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6163727633271883, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.51624397679369, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.6204544951665047, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.5205117032396989, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 2.253709925211909}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2026403590921573, 2.0095554142156695}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0931348688118385, 2.0095554142156695}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.3407610128583247, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.340807418168989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.6168849633501186, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.600868576791223, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2651392395634233, 1.5953389880545987}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.858931232061846, 1.5953389880545987}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.697356025334, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.9975007872996983, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3035404883862389, 1.5107219394949427}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.989444152396731, 1.5107219394949427}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2496677635880655, 6.131226489483141}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6497392092076262, 6.131226489483141}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7109170813839543, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1111386284230904, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1564532883579597, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7565130561817651, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.927891643552635}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.0942695392339727}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.941966881801218, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.991862608772972, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.2256240518579173, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.975391927697949, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6287255312941893, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.9286606465811693, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6941476808935289, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.6302332586812027, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2361517026901712, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8121662790057176, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.2917089186300228}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 1.1990607599649155}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2330583852210326, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2330583852210326, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.2787091504399533}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9038682118755978, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3037931396081468, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.1269525243508878, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.807005375881994, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.410950117672171, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.810913836561449, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0939462278827174, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.294015757351168, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.6593256320844346, 7.944492163932159}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1593181637855046, 7.944492163932159}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 2.078566158643882}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.9736550492637259, 1.9198594718553708}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.5016459737922982, 1.9198594718553708}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.8944568674663975, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.494523665901028, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.3101690833145914, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6100682736896466, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.421661504957182}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.2761851384398606, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.6761120457020933, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.556451816951096}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.421883011611913, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.377692565480851}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.389499492068839, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.094604267270571}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6667000105450971, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.252691173362931, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.023439351564551, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.623341473175256, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.953887209526845, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.7539022397884905, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3657077275115024, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7655070980839893, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0942219403668167, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8944568674663975, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6218266343535928, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.312220927289192, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 0.8055826098897335}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.1308988302963465, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.045554398052668, 0.8514321595256585}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.721515815839451}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.741256487054948, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3413209954771594, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3180038323381698, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8500747011316276, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 2.3243465847755584}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.3524072174927233, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.612442421454399, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0129050178795915, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7627116439458544, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.156840433948748, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.878196476740593, 1.7776605448485534}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.6888794541139363, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 1.8526977673331346}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.2030071867437115, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.9267273296385394}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.6960857191597725, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.196424897165655, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 2.414126467726953}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3998672158005996, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.800001029850119, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6906479678596436, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4903224315439383, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.6623114020411685, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.286383733136742, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3688474475161698, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1689274625831354, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.48175237628028356, 8.122074375362217}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9816295731824954, 8.122074375362217}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.6474092888860916, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0475390184841091, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.6593256320844346, 7.944492163932159}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1593181637855046, 7.944492163932159}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.4138711288901251, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.1136189934814222, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.7177975525570903, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.4179367056664534, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.133013715385442}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.613467558616262, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.01348899514325, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.9165331609060323, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.216512196196308, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3482281603134343, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7004573108212688, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.536314386533157, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.412382827063892, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.9670073137609054, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.966857671750368, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.9334368907091256, 1.8389610707123492}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.703510521060178, 1.8389610707123492}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.1862091035211472, 2.423031246069913}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.282782465697866, 2.423031246069913}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8627499649461253, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0605908459024875, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9372477759766606, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4371455863897404, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.21678878567620194, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.716864386545305, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.359873830032749, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.159425367681418, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.004138294335951, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.703886158927249, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.3960099493374092, 6.984716320118266}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7960662345677868, 6.984716320118266}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.894078619827491, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.49397078181451, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.05211045501669, 7.55171221535131}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.552112845814831, 7.55171221535131}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1409980051645476, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9414202437824613, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.491779868965868}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.3281354469463584}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.7822140563845235}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.5902550930173265}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3617968895195032, 1.9416152247724325}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.069887328875024, 1.9416152247724325}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.786359562282124, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.162319869424133, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.1269525243508878, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.807005375881994, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 1.1684492482568893}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4599740936085572, 2.004179057179289}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8461060995981784, 2.004179057179289}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.101092789211817, 0.911479174876933}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.117766656001504, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.017939231019695, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.9910270779881722}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.735370011757173, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.4354783156390294, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.103158068297152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2262184132732556, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.725971728690052, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3027280306570521, 2.419478844465545}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.1733127572899065, 2.419478844465545}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.4226262903672808}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5173146235582946, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.017406150760383, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.599292605088321, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.571249159610065, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.3089630181835672, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.908846148194222, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 0.848868055556721}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.9980550336767947}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.7837272975307907}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9306432380985556, 2.827905162910489}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7306413849875258, 2.827905162910489}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 2.330200260027019}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.8195418502405067, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.5191254931746836, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.606235808570649, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2063088641234838, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2942622756733968, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.694451286761057, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.2739976361421332, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.5740001929819547, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.5841201044498106}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.764428382564909, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5644645467913691, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.8146618624453594}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 0.7499999921527281}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.269044801069651, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.269044801069651, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5898688311064436, 2.506341930508065}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7120245012092015, 2.506341930508065}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.7479817218821596}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8442026554799011, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9002402920947703, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8997902134417601, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3993162819538174, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.110245660342752, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.810369351701646, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.2864827918762988, 7.24422751560335}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.3865452232556535, 7.24422751560335}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7048480972387587, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.878625402249717, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.298317366548036, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.617843933216061, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.517955942272351, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.095273387402595}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3413209954771594, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.741256487054948, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6747180450915782, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.462743533283297, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 0.9707789171582248}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.659260036932778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 0.9654617758806044}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1184069159962893, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9186841628017217, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.4226262903672808}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.4753441779534016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.725332537920259, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4118173183509766, 1.5973653311998313}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7078502210995437, 1.5973653311998313}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.424802725718295}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0700248318161971, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0700248318161971, 2.58851563240702}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.246332151443247}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.2256240518579173, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.975391927697949, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.523226215615035}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.4135166537013273, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.213639558072954, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.963188584855586}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 2.209811692841691}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.900458886151396, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3005870903313728, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.941966881801218, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.991862608772972, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8643301620628905, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-4.524512282970637, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6788498758591209, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.4370318346713713, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.251047211711865}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.3504089023600859, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.850570223130148, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.9754419516613513, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.225346881840062, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0108761743640229, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.428942281870568, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.6888794541139363, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2149273965428693, 2.519308076505333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0612087734187763, 2.519308076505333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.340556469446037, 6.040254711277414}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7406861990440543, 6.040254711277414}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.168283961917429, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0024805005437076, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.378751192832325, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.178596114669692, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.695775840226822, 5.991464547107982}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-3.2957568692041583, 5.991464547107982}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.3504080825554816}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6266106567597011, 2.4265710727750367}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8350845939664286, 2.4265710727750367}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5901256014017275, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0898959995836948, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 2.193662685769859}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.2568373311553196, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.676945820702642, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 2.066736169182282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.863232841258714, 0.8458682675776092}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.6407445017668969, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.040959012419865, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1230074455028314, 2.1825620503943153}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.8269722249837996, 2.1825620503943153}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 2.3243465847755584}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3478567954878509, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.399798360748448, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.565421027017326, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.565421027017326, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.246332151443247}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.017383521085972, 0.7347688552507647}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.567015866357096, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.366810362993337, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2395270305647338, 1.4996230464268938}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.0757190980989355, 1.4996230464268938}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.1498640059763816, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.049977288406387, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2790527457537265, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.3071607397357723, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.8505029913361519, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.350408373771412, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8566077297129814, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0564152399683213, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6888794541139363, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 2.647592232065096}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.558002204858551}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.571283042360924, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.6744763086133228}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5705756281717647, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1806171127511105, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.6593256320844346, 6.721425700790643}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0592954262911594, 6.721425700790643}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.4532518292447716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6888794541139363, 2.9290581402859983}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8940401229393353, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-5.493845750829273, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.995732273553991, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1279381180499384, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.95263269481614, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.23395175003081314, 7.146772179452637}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.6339353209280992, 7.146772179452637}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.369240606554063, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.5612262966614128, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.6854573524495757, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.4854489341097463, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.6409365794934714}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 1.2190584417439767}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.1151705891340815}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8773173575897015, 1.6114359150967734}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.215490386143112, 1.6114359150967734}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7813228714636707, 7.822444729489319}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2815740503494875, 7.822444729489319}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.064355904261795, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640797356921787, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.7710464276305133}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.0935997468445653}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7573580425107227, 1.589235205116581}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3789263262507685, 1.589235205116581}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5901256014017275, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0898959995836948, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.0102369597568726, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.9105241293044104, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.912572089444803, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.036270701217564, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.461401833606696}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.7378311272024993}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4375876555074412, 2.0149030205422647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8476951015583583, 2.0149030205422647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.785741396902492}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2262184132732556, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.725971728690052, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.9368694044031642}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.820158943749753, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.220083871482302, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4307829160924542, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.196377287787253, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0181583132629375, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.117817918407743, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.068859330518762, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.468806782694355, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0177699008240089, 6.363028103540465}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4179914478631452, 6.363028103540465}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.469241281940817, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.869504817852908, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4728877844255986, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.966950472128539, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 1.1464496180822696}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5173146235582946, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.017406150760383, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.293947899598382}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.6389967146756448}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7672619976276676, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.166785108860756, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9058454740126164, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.5338868320097188, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.5960282255241827, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.296603021316498, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.0678093795130645}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.166995202991212, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.767041814295392, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0261055978813616, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.926205565780978, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.795734531747094, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1958919884778254, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8734707346912269, 6.507277712385012}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2736802167507564, 6.507277712385012}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 1.9254158540407285}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.965852822566973}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.9313764735639716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.362224007377702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.57270299585059, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.6591800043289144}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.606941032235513, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.1413169453979233, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4184044150381243, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6184786570862495, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1644316297054034, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1644316297054034, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.746969987257452, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3470736479666092, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2669126040998102, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.666828609658249, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.4890765557629164}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.031563461435372}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.5774997570339834, 8.026170194946426}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.0776338822829181, 8.026170194946426}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7565130561817651, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1564532883579597, 2.702032128776647}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9192952408944538, 6.461468176353717}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3193836558372638, 6.461468176353717}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.612442421454399, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0129050178795915, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.26683423993894284, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.666853965970644, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.493987758524193, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.894183087299815, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.835485924411894, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.3354096411241523, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.0365602553118024, 7.24422751560335}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.636577829072051, 7.24422751560335}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-5.298317366548036, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.42266213293668586, 2.418588768750352}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0549440700794483, 2.418588768750352}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 2.2976730486330252}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 0.9925107577855641}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.4971646699513146}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.48175237628028356, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.107781777362614, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.836849948493799, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.0968250627658085, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.4312677267626217}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.257346872655708, 2.0028304393079956}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0514564223263525, 2.0028304393079956}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.640548907459153}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5561717255328675, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.030116700415822, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.793961892783255, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2936253516225737, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.4146388341290332}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.6305480388034254, 2.827905162910489}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0305798782762827, 2.827905162910489}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4947708374559745, 5.886104031450156}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8951219822232084, 5.886104031450156}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.1921026317554486}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.715777948205427}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.887460350206278, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6873994539038122, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3649243353836982, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.864975531559314, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2437536743377806, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.744112815760702, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.993630885266725, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.0939462278827174, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.273910668367863, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-6.113858195322049, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2010151992412087, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0971007679422797, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.6304163188192922}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.186787979571835, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.5608378214218233, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.293947899598382}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.196377287787253, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 2.2086040295231517}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.9205497887945385, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.2207799226423173, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9390477189967712, 2.414126467726953}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5474025215146479, 2.414126467726953}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.896419739771488}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.279055610450292, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.402871609042948, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8689301605143175, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6691879168398742, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7832907304129113, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.517264565896126, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.0732944806838198}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.191191469961203}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.694451286761057, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2942622756733968, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1150465951315345, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6149530931222105, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.348592493935879}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.7929254558680243}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.6593256320844346, 6.721425700790643}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0592954262911594, 6.721425700790643}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.1866231659908228}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 1.0868770324496888}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3426311639367969, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.2406103170142067, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.552112845814831, 5.8289456176102075}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9519282213808764, 5.8289456176102075}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.746403767507258, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1464364105041143, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.795734531747094, 5.991464547107982}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-3.1958919884778254, 5.991464547107982}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.5257286443082556, 6.461468176353717}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 2.209811692841691}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.8002235476401844}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.168928708181372, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.768756076219605, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.214574215671332, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.004138294335951, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2149273965428693, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.224893897193764, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 0.849723487602042}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.4286713586629105, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.12893600699172, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3874950816964096, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1874435023747254, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.031563461435372}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6240440648234626, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-4.76404869105558, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.389499492068839, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6184786570862495, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4184044150381243, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 2.073423469354273}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.987249820814649, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5876764206525877, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.362224007377702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.57270299585059, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7199019178687649, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2201021862558195, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.612442421454399, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0129050178795915, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.4753441779534016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.725332537920259, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5473167323484057, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8953440995227226, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6005679992668521, 1.4996230464268938}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.7148128361404407, 1.4996230464268938}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4082690354408987, 1.860974538249528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.184232881424661, 1.860974538249528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.418747583305227, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.0841264243165862, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.304161419150561, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.605170185988091, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.6354040111173562, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.5356434782150785, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-4.2845370133966245, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3716028123769008, 2.187174241482718}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5716605481000705, 2.187174241482718}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.563430511492267, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.0635829404621653, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3329431856228962, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.132893222644984, 2.425687290128029}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.21927603978772048, 1.860974538249528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.3731931852525583, 1.860974538249528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 0.8977193462887197}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.4915548717773834}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 1.0420419371797154}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 0.9669838461896731}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.199705077879927, 0.755182571479398}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2371849385320495, 1.9401794743463283}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.197324582336553, 1.9401794743463283}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1080567474961094, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5082360319251331, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.1625110145183415, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.786268646522262, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7650729201315343, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.403068631572368, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3893457262282811, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.91139112512024, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3498863661120586, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.8499018253424513, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1880994551696458, 2.3850863145057892}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3563472847519384, 2.3850863145057892}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5901256014017275, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0898959995836948, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.2672179491567546, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-6.667164814064207, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.809142990314028, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.3204807842031671, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9205497887945385, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.7083778602890038}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.9910142780700916, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4912105310694506, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 2.330200260027019}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.8002235476401844}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3149043650332175, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9146052992269007, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.46298829435183064, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.063052113269559, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.8906229851255774, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.4907663827166018, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.4886252922173524}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.22276862160913655, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.525061368884541, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3678803477808931, 1.4973884086254774}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.9518038754399907, 1.4973884086254774}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.424802725718295}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.41779075779880137, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.717779984300055, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 6.684611727667927}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.863232841258714, 1.007592890280941}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.66442222076686, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164563795096671, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.719319793360441}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6548884684428551, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0929041853062644, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.6378309869353183}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.028748427364318, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.653113060608557, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.571283042360924, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.377692565480851}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7813228714636707, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              
              StyleBox[
               InsetBox["\<\"\[FilledUpTriangle]\"\>", 
                {-1.2815740503494875, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.8470364847178946}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.174191878225647, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.674083651538937, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2783372196147982, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.308100273682156, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6734432424100127, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.2576117273513145, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6977577931176286, 2.4265710727750367}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7637552728184576, 2.4265710727750367}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.4018530946527146, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.532062329207643, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8058680506240641, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6338708029279587, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8644101099971662, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4644721421839146, 2.494031557565001}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8238695231462887, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0996442489973552, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.366795954944823, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.566981433164056, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.5920892740994874, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.341928551227046, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 0.9654617758806044}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 0.8977193462887197}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 0.911479174876933}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8016236568960291, 6.579251212010101}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2016421889876536, 6.579251212010101}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8598242001421843, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2595256035335987, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4460443655256647, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.946310229076653, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7797949872856175, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.327853987437946, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.0654001544619962}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 2.044332364566268}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5413120833865, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5413120833865, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4653375684603434, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6654793033177253, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.199705077879927, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.836849948493799, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.0968250627658085, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.0218709311636855, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.911914268349973, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 1.5904589458362974}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.552112845814831, 5.8289456176102075}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9519282213808764, 5.8289456176102075}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.4338645826298623, 6.946975992135418}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8337895103624113, 6.946975992135418}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.1499389158334503}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.7254100886865211, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.475327636634016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3118381623295401, 2.6993457604720636}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6039529822035308, 2.6993457604720636}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5015355768588979, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.421604191439818, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 0.9411784473819341}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 1.0511712140679732}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.6409365794934714}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.746403767507258, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1464364105041143, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6939993778795506, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.694093021166824, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4361820807702249, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.612240146256234, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.7042981934580606, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.683996966534062, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.8283137373023015, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.3504089023600859, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.850570223130148, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2069773133462347, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.606941032235513, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.191191469961203}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-4.045554398052668, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.66442222076686, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164563795096671, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4943251053335957, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4943251053335957, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.900464386136271}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.101092789211817, 0.7802418874108791}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.2568373311553196, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.676945820702642, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.071483621279857, 2.187174241482718}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8714522381373035, 2.187174241482718}],
               StripOnInput->False,
               FontSize->4.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.4122057429043917}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.7859090555498793}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9038682118755978, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3037931396081468, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.449925680892755, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.7499665442035015, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.2742448573112677}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.68510181635509}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3138891646209549, 2.5862591440482876}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.82821600623867, 2.5862591440482876}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.294616923344869, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.0941445822194344, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2496677635880655, 6.131226489483141}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6497392092076262, 6.131226489483141}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7168253079145225, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.2170885989659, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.746403767507258, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1464364105041143, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.4179914478631452, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.7177791303707455, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1270117631898076, 6.253828811575473}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5269366909223567, 6.253828811575473}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8540604954254345, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9540431322855023, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.2246985543369746, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.6240307955986357, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.8056623743970464}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5129946410508307, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.013077000561847, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.4018530946527146, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.532062329207643, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.556451816951096}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.793961892783255, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2936253516225737, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.557794679282262, 1.8687205103641833}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.019664337643975, 1.8687205103641833}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.47352983902229373, 2.599722324216582}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6414447085691868, 2.599722324216582}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.1499389158334503}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.5366522427084526, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.412267540691536, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.007592890280941}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.719252778441307, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.6190782472999463, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 2.075684492802124}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.6888794541139363, 0.8505781885087738}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.6888794541139363, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.0942695392339727}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.1627481478062465}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.131032179924221, 6.249975242259483}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.531088946023124, 6.249975242259483}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3645328693383778, 2.494031557565001}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.96443110720209, 2.494031557565001}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1150465951315345, 7.488852955733459}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6149530931222105, 7.488852955733459}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.1589994386832048, 4.386765389021055}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.058828136697741, 4.386765389021055}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.1413169453979233, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-6.541030999190403, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.416581053724763}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.6378309869353183}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8344803566765893, 2.131796772013764}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.2164073967529934, 2.131796772013764}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.090999490513565}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5178502387029551, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.61797181824309, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.15218556191195, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.781788039865368, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.9296292963133357, 7.674152921281675}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4296194858582643, 7.674152921281675}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4088348928367562, 4.386765389021055}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.809015255353917, 4.386765389021055}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-4.3428059215206005, 2.6490076604684267}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.002290482491421}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.96443110720209, 2.494031557565001}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3645328693383778, 2.494031557565001}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.5895081458004594, 6.7912214627261855}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9896682016789307, 6.7912214627261855}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.49331319868135953, 2.4239173781615704}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.973281345851445, 2.4239173781615704}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.26683423993894284, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.666853965970644, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.599387576580599}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9317114296555002, 1.534714366238164}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3134438363289216, 1.534714366238164}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.2299329059954676}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.506518858426259}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.087375656742122, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4876628555081794, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5213811377055073, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.64930970607961, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.0598714603516792}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 0.849723487602042}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.1627481478062465}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.340512168464763}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2303167796655379, 1.691939133945844}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7002308520500784, 1.691939133945844}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.2672179491567546, 4.386889790339869}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.667164814064207, 4.386889790339869}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.7693434299437227}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6713133161521878, 2.187174241482718}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.271538123821702, 2.187174241482718}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1080567474961094, 6.272877006546167}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5082360319251331, 6.272877006546167}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 1.2172838183856083}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7969533492855345, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2971851860481147, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7199019178687649, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2201021862558195, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.599387576580599}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.8643901602629624}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.659260036932778, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.539739633930633, 2.5974910105351463}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.579879110192556, 2.5974910105351463}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6424777665123005, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6424777665123005, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8438952236485835, 5.537334267018537}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2433732333621994, 5.537334267018537}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.0497721232486361}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.8056623743970464}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7199019178687649, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2201021862558195, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.924832423452417}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.75, 0.75], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", 
                {-1.7147984280919266, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.8699543168131119}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2739976361421332, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.030860186617291, 6.249975242259483}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.3732221725934863, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6311724045801064, 6.249975242259483}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4203757208439185, 6.960347729101308}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.8205261098897758, 6.960347729101308}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.66442222076686, 6.939253946041508}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164563795096671, 6.939253946041508}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.1167795926235586}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.9368694044031642}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.816258383443767, 4.787491742782046}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.3162388941358785, 4.787491742782046}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.1990607599649155}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7505644514298959, 2.5817308344235403}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4007990473227723, 2.5817308344235403}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.599387576580599}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0918353043890858, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.84195543139986, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.064355904261795, 6.539585955617669}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640797356921787, 6.539585955617669}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              
              StyleBox[
               InsetBox["\<\"\[FilledCircle]\"\>", 
                {-1.7147984280919266, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7062324201086008, 6.674561391814426}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.1062413158326008, 6.674561391814426}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.6108369333478076}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9958752112169974, 1.599387576580599}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1199358770132974, 1.599387576580599}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.599387576580599}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.900464386136271}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.600902459542082, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8027388571900397, 2.58851563240702}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.1454883067486056, 2.432735777459091}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3348410795309749, 2.58851563240702}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.30348549823721, 2.432735777459091}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.05211045501669, 7.55171221535131}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.552112845814831, 7.55171221535131}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.6587993419718245}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.017383521085972, 0.8385453832493022}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.974001029221839, 6.429719478039138}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.874045755297392, 6.429719478039138}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.9754419516613513, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.225346881840062, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2069773133462347, 6.173786103901937}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.606941032235513, 6.173786103901937}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5173146235582946, 7.086737934510577}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.017406150760383, 7.086737934510577}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2063088641234838, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.40649706843741, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.271538123821702, 2.187174241482718}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6713133161521878, 2.187174241482718}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.458005208673891, 5.823045895483019}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.0580715159436433, 5.823045895483019}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6544352783648362, 5.676753802268282}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.1541650878757723, 5.676753802268282}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.49314943875304795, 6.887552571664617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8933068954837797, 6.887552571664617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.5077842587076005, 5.823045895483019}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.007679175452945, 5.823045895483019}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8997902134417601, 6.704414354964107}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3993162819538174, 6.704414354964107}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.406587064387653}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 1.5904589458362974}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.389499492068839, 5.991464547107982}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 5.991464547107982}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.23876493221716663, 1.601405740736836}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.872802292274865, 1.601405740736836}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 2.1122716862705384}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {43.533197060661976, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-52.467202900682494, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.6623114020411685, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.286383733136742, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.152962883418191, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.5287678617828835, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.7847348542910906}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.27128392664214473, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.171276846068922, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.1177951080848836, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.017810977845351, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 0.898534010284896}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.5554040239416147}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 0.761739972025557}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2437536743377806, 7.360103972989152}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.744112815760702, 7.360103972989152}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2409826299598365, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8413699697813894, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.8118888405232207}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.376740148315079, 7.226936018493289}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8773173575897015, 7.226936018493289}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.2809338454620642}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 2.078566158643882}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.7693434299437227}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 2.647592232065096}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9840343839606746, 6.396929655216146}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3838972365201692, 6.396929655216146}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.416581053724763}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.1151415906193203}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              
              StyleBox[
               InsetBox["\<\"\[FilledCircle]\"\>", 
                {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.1975522365230131}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.18260159600127354, 2.136530508663963}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8587568185269134, 2.136530508663963}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7789229575813493, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.902818692021688, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 1.3302529702362658}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.2862680470527663, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.662352421858305, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-7.523941418405954, 1.497835735852798}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.3754861624032872}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.6397713603489157}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.6526889544284153}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.671097292820828}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.4342248948774405, 4.386765389021055}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.95401869367736, 4.386765389021055}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4307829160924542, 1.726509584019938}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {45.533180029480455, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-54.46678982836, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.2256240518579173, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.975391927697949, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3025850929940455, 6.684611727667927}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.017383521085972, 0.986935571443487}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.19455609446229716, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9784819201474635, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.100426344668657, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.100386954332169, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.594056810395798, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3943265328171548, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0177699008240089, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.117830825699811, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1150465951315345, 7.488852955733459}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6149530931222105, 7.488852955733459}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 2.647592232065096}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.090999490513565}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.3964921860963366}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.1625110145183415, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.786268646522262, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4571461020918417, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8807977354618917, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 0.9666035457477442}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0564152399683213, 2.702032128776647}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8566077297129814, 2.702032128776647}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.506518858426259}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6529653909271136, 2.506341930508065}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7448616162466241, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6492187824459448, 2.506341930508065}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0027568884909557, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.298317366548036, 2.6490076604684267}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.15218556191195, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.781788039865368, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.1308988302963465, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.340556469446037, 6.040254711277414}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7406861990440543, 6.040254711277414}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.493879571799828, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.893919494400295, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.4920048155420047}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8763491247812073, 2.503891949699081}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4304552569056603, 2.503891949699081}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.1603343472961065}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.2255369822417765, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.975450465015525, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.3420861064555702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.5919427181706105, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.6936470556015963}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 0.9666035457477442}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.542246662893777, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.742398039690331, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.227106951818089}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.416581053724763}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.7535382564078572}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 0.9345235001352147}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5716605481000705, 2.187174241482718}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3716028123769008, 2.187174241482718}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0186003506987251, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4605869657017456, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4983438649285135, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.898454207899018, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.600902459542082, 1.445270566220188}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.316022308134559, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.915963072687361, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2740421867477461, 2.5771819258971713}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8865098057738656, 2.5771819258971713}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.693851481702397, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.694093021166824, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8426317996018116, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4422299934501939, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.317800258800526, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.8180773925856184, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.0935997468445653}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8997902134417601, 6.704414354964107}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3993162819538174, 6.704414354964107}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.8563722416629115, 6.674561391814426}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9563317814113389, 6.674561391814426}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.617854196524514, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.51796702860799, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.227106951818089}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.090999490513565}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6218266343535928, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.312220927289192, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 0.9345235001352147}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7912011210353335, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.5332441625824873, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7168253079145225, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.2170885989659, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8821308802274503, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.4159777803491362, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 1.9838938336679197}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 1.721694594779768}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 1.8526977673331346}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 0.7975071958841882}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0891571298973546, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.209094749906707, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", 
                {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 0.848868055556721}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.3282528397426234}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.9122987106046175, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.036311444023319, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.528780009416646, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.152761077153482, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.279055610450292, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8891518152367044, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.2166915767337108}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.522010001878903, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.411934093335004, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.919365593833201, 6.684611727667927}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.419118909249997, 6.684611727667927}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 2.193662685769859}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3678803477808931, 2.421256622711544}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.104554242494911, 2.421256622711544}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 2.28401370740861}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.36154392105023625, 2.599722324216582}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7538858167999734, 2.599722324216582}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.036482917202561, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.912330925723864, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4405393759722864, 5.940171252720432}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8407396514497736, 5.940171252720432}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5228016057745537, 5.857933154483459}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.922779731666459, 5.857933154483459}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.506518858426259}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.5299617109323036}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.0241960674538575, 6.429719478039138}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.823966230699553, 6.429719478039138}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1026203100656484, 2.2648832258100344}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.6825463842547386, 2.2648832258100344}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.7867719277170158, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.1622605067393605, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.4395981331422016}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2569588998089404, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9110235456270366, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.599387576580599}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3039860739096736, 4.386765389021055}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-4.083998270167957, 4.386765389021055}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.941966881801218, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.991862608772972, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.15455075984859803, 2.5756610130564646}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0091694886945044, 2.5756610130564646}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.540842282118304, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.140893060599911, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5059792040658704, 2.0843046973458237}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6398971199188088, 2.0843046973458237}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-8.532306829226286, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1796054478776414, 7.424165281042028}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6798603767306461, 7.424165281042028}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              
              StyleBox[
               InsetBox["\<\"\[EmptySquare]\"\>", 
                {-1.0808706071919527, 6.249975242259483}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.5808504555821878, 6.249975242259483}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4338645826298623, 1.601405740736836}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.6777417097034806, 1.601405740736836}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.4569857892424236}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6622300779252237, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3861841168703593, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0891571298973546, 6.29156913955832}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.489435120039404, 6.29156913955832}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-5.298317366548036, 2.6490076604684267}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.640928579525471, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.040829633207479, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 1.3480731482996928}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.8069317506623275, 4.386765389021055}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.4109447331170353, 4.386765389021055}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.708153885373258, 5.823045895483019}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8078888511579385, 5.823045895483019}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.9521761906339596}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.36571568859088144, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.741858378904823, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.995732273553991, 1.497835735852798}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 0.766397642299538}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4903224315439383, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6906479678596436, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0053952069569758, 2.498151876538021}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.313415715707318, 2.498151876538021}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.712716261887602}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.1603343472961065}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.094604267270571}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 1.9838938336679197}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.9910142780700916, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4912105310694506, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.2255369822417765, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.975450465015525, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.744604469176456, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.227106951818089}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0604498275737608, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.110313205346923, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.100426344668657, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.100386954332169, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8195418502405067, 6.784457062637643}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.319222734147069, 6.784457062637643}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7042981934580606, 5.676753802268282}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.104554242494911, 5.676753802268282}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7672619976276676, 4.386889790339869}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.166785108860756, 4.386889790339869}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1150465951315345, 7.488852955733459}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6149530931222105, 7.488852955733459}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 2.2927367569392314}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 2.187398683184928}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.2181715237257489}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 2.187398683184928}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8871696540327132, 5.393627546352362}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4871090733432, 5.393627546352362}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.0942695392339727}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.795734531747094, 5.991464547107982}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-3.1958919884778254, 5.991464547107982}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.8140100781628747}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.40649706843741, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2063088641234838, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.8442026554799011, 7.759614150696903}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.344384958042681, 7.759614150696903}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 0.9290095042819297}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 0.766397642299538}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.6562368265398482, 6.674561391814426}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.1564532883579597, 6.674561391814426}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.8442026554799011, 7.759614150696903}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.344384958042681, 7.759614150696903}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.599387576580599}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.349630376748299}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.4865920824352545}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.719319793360441}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.783559272662715}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5068336024964532, 1.601405740736836}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.604906020337758, 1.601405740736836}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.599387576580599}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 0.9034081060431414}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6064191770501212, 2.5877640352277083}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5324768712979722, 2.5877640352277083}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3983901944362025, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0442924641693683, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.8283137373023015, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7310567536331655, 1.864080130807681}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8551011438142453, 1.864080130807681}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {63.53307909765005, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-72.46692041972995, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7667937207282438, 4.386889790339869}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-8.166888494485349, 4.386889790339869}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.1308988302963465, 1.445270566220188}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.7329280505717899, 7.8709295967551425}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2330583852210326, 7.8709295967551425}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 1.266384064447333}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              
              StyleBox[
               InsetBox["\<\"\[FilledUpTriangle]\"\>", 
                {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5901256014017275, 7.013915474810528}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0898959995836948, 7.013915474810528}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.696151689580244, 6.684611727667927}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0963149296194261, 6.684611727667927}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.945799904805782, 5.991464547107982}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.045763207159556, 5.991464547107982}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.03270329512458, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.3326298365341978}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2315538186741798, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.6916833814466705, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 1.721694594779768}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7129418078881248, 6.81783057145415}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.8130574772325029, 6.81783057145415}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0940068428223313, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.293868803909631, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.3420861064555702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.5919427181706105, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.797175250983993, 2.512035317176253}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4934342366777942, 2.512035317176253}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.462149662665384}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3903023825174294, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7903604483143476, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.0218709311636855, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.911914268349973, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.3137523001849649, 8.290041618704489}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.813734143549063, 8.290041618704489}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.744604469176456, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.9031380572114442, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.779362064213738, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.0598714603516792}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.8528465593176202, 7.751045117971802}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3528595850336531, 7.751045117971802}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8195418502405067, 6.784457062637643}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.319222734147069, 6.784457062637643}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.6358850824489488}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.5, 0.75], 
              
              StyleBox[
               InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.2319770007355333}],\

               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4918104261047946, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-6.442136248054226, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 0.7802418874108791}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5703987153008919, 6.960347729101308}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.6704076935904559, 6.960347729101308}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.6409365794934714}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5342648554997536, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.766368110426725, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 0.9654617758806044}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1663559407546291, 6.214608098422191}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5663784229736533, 6.214608098422191}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.7254100886865211, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.475327636634016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.7840632625935846}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.9754419516613513, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.225346881840062, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9293759714228106, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.119430549896199, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-8.685611843041201, 0.9360933591703348}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4911864085136422, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.253208503948706, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.064355904261795, 6.539585955617669}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640797356921787, 6.539585955617669}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4171835010623628, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.327296573822621, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1041274693562197, 2.413231613081109}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3842963584572177, 2.413231613081109}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.3137523001849649, 8.290041618704489}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.813734143549063, 8.290041618704489}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.462149662665384}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 0.7802418874108791}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.893897967672723, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.49397078181451, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2069773133462347, 6.173786103901937}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.606941032235513, 6.173786103901937}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.995732273553991, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {30.65922057962004, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-39.34081340913477, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 0.9566646260124284}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4460443655256647, 7.157735484249907}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.946310229076653, 7.157735484249907}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7306413849875258, 2.827905162910489}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9306432380985556, 2.827905162910489}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.522010001878903, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.411934093335004, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 1.3321021320364639}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.09926800165866902, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.849872629798755, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 2.647592232065096}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.599387576580599}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.599387576580599}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 0.9669838461896731}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0645007590393418, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6864844231876495, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4126383364594925, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.176833887688485, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7463370090740643, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.5609672964009644, 4.969813299576001}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.6609757937162812, 4.969813299576001}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-8.05031945517943, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5191402744533198, 1.6882490928583902}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.418894215394429, 1.6882490928583902}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7667937207282438, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.166888494485349, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.403677882205863, 1.445270566220188}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.045554398052668, 0.9604989865384754}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 2.647592232065096}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1715056141884346, 2.187174241482718}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.771368779580321, 2.187174241482718}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 2.187398683184928}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.8420006856648017, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.091798316674432, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.090999490513565}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.820158943749753, 5.560681631015528}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.220083871482302, 5.560681631015528}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.007592890280941}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5079962967558309, 2.134048091170708}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.538054293998892, 2.134048091170708}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.416581053724763}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8997902134417601, 6.704414354964107}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3993162819538174, 6.704414354964107}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1796054478776414, 7.424165281042028}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6798603767306461, 7.424165281042028}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.475392057419415, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.725433722188183, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.612442421454399, 5.768320995793772}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0129050178795915, 5.768320995793772}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4307829160924542, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.153303390278291, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.529318843261892, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.48304834276654407, 6.897704943128636}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8830977645183911, 6.897704943128636}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 0.8028980445190645}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.599387576580599}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.5087859235779435}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 0.8028980445190645}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 0.7975071958841882}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9565920286476808, 2.702032128776647}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9565920286476808, 2.702032128776647}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.18765575838465653, 2.6224923127405635}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.881903019081021, 2.6224923127405635}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.795734531747094, 5.991464547107982}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-3.1958919884778254, 5.991464547107982}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1199380753828623, 2.065596134857783}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.064355904261795, 2.065596134857783}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4460443655256647, 7.157735484249907}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.946310229076653, 7.157735484249907}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 0.9290095042819297}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.7164562218841706, 4.787491742782046}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.416204086475468, 4.787491742782046}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.600902459542082, 0.973049065692764}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.8528465593176202, 7.751045117971802}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3528595850336531, 7.751045117971802}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.3492738284584218, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.599488434143067, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8442026554799011, 7.759614150696903}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.344384958042681, 7.759614150696903}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.290620611051608, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8904754421672127, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.018486244188825}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1526461771605954, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.4305321073246677, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.8012039280560548, 4.386765389021055}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.417032243872697, 4.386765389021055}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.376740148315079, 7.226936018493289}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8773173575897015, 7.226936018493289}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.5005758256424344, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.700587583759682, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.218243944560295, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.9180410777537094, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.8840655845794182, 4.386765389021055}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-5.504112279527633, 4.386765389021055}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7109170813839543, 5.66988092298052}],\

               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1111386284230904, 5.66988092298052}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.0289048762432895}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 0.849723487602042}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5823216254710607, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.466163406970865, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0939232991819783, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-5.293927018246744, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4679383501604009, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.279845606024556, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 0.880041599199034}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.5087859235779435}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.966950472128539, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.966967075507594, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4267908948229169, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.4929837772928636, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.599387576580599}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.2809338454620642}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0918353043890858, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.84195543139986, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.3261404383001434, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.6260755535871236, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6039529822035308, 5.676753802268282}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2045513527226803, 5.676753802268282}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.090999490513565}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7813228714636707, 7.822444729489319}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2815740503494875, 7.822444729489319}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.3754861624032872}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.599387576580599}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4329667693183212, 2.425687290128029}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0328245481301066, 2.425687290128029}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 0.766397642299538}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3093333199837622, 7.294377299288821}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8097197946050478, 7.294377299288821}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.047189562170502, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.7867719277170158, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.1622605067393605, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 0.8989410935390421}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3226876816505963, 2.005525858729668}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9806466361359503, 2.005525858729668}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.6888794541139363, 0.9669838461896731}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.9910142780700916, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4912105310694506, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7389772837890856, 1.803358605071407}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.968974088653865, 1.803358605071407}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.3109197297841035, 4.969813299576001}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.9110235456270366, 4.969813299576001}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 0.9654617758806044}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {33.65905864326737, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-42.34081632550436, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.100426344668657, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.100386954332169, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.900458886151396, 5.480638923341991}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3005870903313728, 5.480638923341991}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3842963584572177, 4.386765389021055}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-5.0040073078060345, 4.386765389021055}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.7254100886865211, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.475327636634016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.809109107563168, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.515036014769512, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0191543673333943, 2.570319527636131}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.155182640156504, 2.570319527636131}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 1.6384140206706175}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.5895081458004594, 6.7912214627261855}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9896682016789307, 6.7912214627261855}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.416581053724763}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.557794679282262, 5.823045895483019}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9582864201233687, 5.823045895483019}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.036382052219389, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-6.912265434460023, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-9.567158183262826, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.462149662665384}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.926290362185661}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.000759888500605, 6.380122536899765}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4007990473227723, 6.380122536899765}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {54.53306059828793, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-63.46698269688735, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.599387576580599}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.66442222076686, 6.939253946041508}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164563795096671, 6.939253946041508}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.500810170663849, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.70036037299184, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.018486244188825}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3093333199837622, 7.294377299288821}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8097197946050478, 7.294377299288821}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8305718564716175, 2.827905162910489}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8305718564716175, 2.827905162910489}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7813228714636707, 7.822444729489319}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2815740503494875, 7.822444729489319}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {48.53243313825843, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-57.46750061412042, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.162823150618887, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-6.786422993814612, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {53.53269402275044, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-62.46685674510361, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.900588627802483, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.30031936921871, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4460443655256647, 7.157735484249907}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.946310229076653, 7.157735484249907}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 0.766397642299538}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7199019178687649, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2201021862558195, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.807796846925679}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.869504817852908, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.469241281940817, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.39809235377875135, 2.498151876538021}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9200474895295858, 2.498151876538021}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.984837274409265, 2.005525858729668}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.318612854071243, 2.005525858729668}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.940865372113151, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.740861482897622, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.0289048762432895}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0529699307894087, 7.600902459542082}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.4528616053920038, 7.600902459542082}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.29356601561075557, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.6298561136644754, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.894078619827491, 4.386765389021055}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.49397078181451, 4.386765389021055}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7813228714636707, 7.822444729489319}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2815740503494875, 7.822444729489319}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1062413158326008, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5064301623598713, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9063404010209869, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7064996252772315, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.006215439402142, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.606442403454302, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 2.0759354023505483}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.66442222076686, 6.939253946041508}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164563795096671, 6.939253946041508}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.5922917535991299}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2862680470527663, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.662352421858305, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6539264674066639, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-5.7340355178272215, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.8442026554799011, 7.759614150696903}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.344384958042681, 7.759614150696903}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.036482917202561, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.912330925723864, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.2568373311553196, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.676945820702642, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2960880932337415, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0417762120553977, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8457617469776957, 5.991464547107982}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.145857732131629, 5.991464547107982}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.214608098422191, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.9245405804618736}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.094520670764856, 1.6937790608678513}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.832423655941967, 1.6937790608678513}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.300630996469888, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.900346940202133, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.9028810449642375, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.7788336680347445, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.33687231664255274, 1.937301774518713}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1028721491118945, 1.937301774518713}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.500810170663849, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.70036037299184, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6311724045801064, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.706800981701778, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.100765130025024, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.10045059841862, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {55.53283243663866, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-64.46739506232224, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.416581053724763}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 0.8514321595256585}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4028684822608984, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.278964002683987, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.9122987106046175, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.036311444023319, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-4.199705077879927, 0.7997569156182036}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.376740148315079, 7.226936018493289}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8773173575897015, 7.226936018493289}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.659260036932778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3093333199837622, 7.294377299288821}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8097197946050478, 7.294377299288821}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {28.659210940300113, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-37.34075273404506, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1150465951315345, 7.488852955733459}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6149530931222105, 7.488852955733459}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.416581053724763}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.6624240079171049, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.286478374605709, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.2867117438377558, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-6.662458923026794, 4.512945241945574}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.162823150618887, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.786422993814612, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {49.53294194921661, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-58.4670151515563, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.536314386533157, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.412382827063892, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8442026554799011, 7.759614150696903}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.344384958042681, 7.759614150696903}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-8.955698153602603, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.270112606830481, 2.58851563240702}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8701230510291479, 2.58851563240702}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.269150316907808, 5.111987788356544}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.66873333872526, 5.111987788356544}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {46.532892678517214, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-55.46685482648658, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5288198871382693, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.152897360346143, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.6003175012993283, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.60100614381313, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6416938989710297, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9477043045434095, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8195418502405067, 6.784457062637643}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.319222734147069, 6.784457062637643}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.912572089444803, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.036270701217564, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.412288358086009, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.536881615643591, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.360956006320375, 4.969813299576001}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.8610265707016995, 4.969813299576001}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.100765130025024, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.10045059841862, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8195418502405067, 6.784457062637643}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.319222734147069, 6.784457062637643}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.1236024374656055, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.5232317641096684, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.786359562282124, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.162319869424133, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.5005758256424344, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.700587583759682, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.7329280505717899, 7.8709295967551425}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2330583852210326, 7.8709295967551425}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {40.65907381386164, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-49.34073194467232, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.036382052219389, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              
              StyleBox[
               InsetBox["\<\"\[Times]\"\>", 
                {-6.912265434460023, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7903604483143476, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3903023825174294, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->8.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {47.5330791022475, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-56.46701553651661, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {61.533219681767186, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-70.4670522818902, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.30938249943111995, 2.131796772013764}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7414001807837645, 2.131796772013764}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {23.65924810609463, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-32.34077434210908, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.475392057419415, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.725433722188183, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {38.65927591460964, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-47.34086951027008, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.2867117438377558, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.662458923026794, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5220551057175394, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.802272141469027, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {41.659220767303175, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-50.341331645288825, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {26.659217674124136, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-35.340845982694816, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {22.659269939882257, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-31.34091993726656, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8997902134417601, 6.704414354964107}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3993162819538174, 6.704414354964107}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {60.532988401609, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-69.46689851604965, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              
              StyleBox[
               InsetBox["\<\"\[EmptySquare]\"\>", 
                {25.65917758484673, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-34.340745544411554, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {56.53320628572335, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-65.466905183977, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.700547258981618, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.500433550670171, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.5005758256424344, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.700587583759682, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {59.53313730582369, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-68.46724388757043, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {34.65922254798655, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-43.340988541359216, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.475392057419415, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.725433722188183, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.900588627802483, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.30031936921871, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {42.533071381326664, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-51.46677778703915, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.900422093749666, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.300710797475603, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {58.533130928172234, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-67.46691559681179, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.700547258981618, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.500433550670171, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.6003175012993283, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.60100614381313, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.3003570667360838, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.9005275521158795, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.400308181522661, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.8006962066887295, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {39.65916255296606, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-48.341370727608414, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.300630996469888, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.900346940202133, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.400308181522661, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.8006962066887295, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {37.65893624683973, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-46.34085167560773, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.700547258981618, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.500433550670171, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.900588627802483, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.30031936921871, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {36.659239911113445, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-45.34120604098636, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {32.658841234778905, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-41.34127116323533, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {27.65863628296152, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-36.34119244432727, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {44.53301831071528, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-53.46678887337479, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {35.65915017536031, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-44.34079097851618, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {24.65920066242087, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-33.34092227159292, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.900422093749666, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.300710797475603, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.500810170663849, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.70036037299184, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {52.5331258380735, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-61.467195171508536, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.6003175012993283, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.60100614381313, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {21.65896696234039, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-30.340822850069564, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {62.53305077013809, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-71.46678568954108, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {57.53313665775977, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-66.46748299707936, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.900422093749666, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.300710797475603, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.3003570667360838, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.9005275521158795, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {20.659260506970497, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-29.340832002509437, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.300630996469888, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.900346940202133, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {19.659054974995634, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-28.340907620492793, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {18.658909932684615, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-27.341341040814093, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {51.5331737695268, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-60.466869255317796, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.3003570667360838, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.9005275521158795, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.400308181522661, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.8006962066887295, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {50.53312123843283, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0, 0, 1], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-59.467094916063616, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}}}, {}},
          AspectRatio->1.,
          Axes->False,
          AxesLabel->{None, None},
          AxesOrigin->{0, 0},
          BaseStyle->{FontFamily -> "Helvetica", 16},
          DisplayFunction->Identity,
          Epilog->{{
             InsetBox[
              FormBox[
               StyleBox["\"Npt: 3966\"", 16, 
                GrayLevel[0], StripOnInput -> False], TraditionalForm], 
              Scaled[{0.1, 0.9}]], 
             InsetBox[
              FormBox[
               StyleBox["\"highlighted range:\\n{{-100, -1}, {1, 100}}\"", 16, 
                GrayLevel[0], StripOnInput -> False], TraditionalForm], 
              Scaled[{0.2, 0.7}]]}, {{
              InsetBox[
               FormBox[
                StyleBox["\"Npt: 3966\"", 16, 
                 GrayLevel[0], StripOnInput -> False], TraditionalForm], 
               Scaled[{0.1, 0.9}]], 
              InsetBox[
               FormBox[
                StyleBox[
                "\"highlighted range:\\n{{-100, -1}, {1, 100}}\"", 16, 
                 GrayLevel[0], StripOnInput -> False], TraditionalForm], 
               Scaled[{0.2, 0.7}]]}}},
          Frame->True,
          FrameLabel->{
            FormBox[
             StyleBox["\"x\"", 18, 
              GrayLevel[0], StripOnInput -> False], TraditionalForm], 
            FormBox[
             StyleBox["\"\[Mu] [GeV]\"", 18, 
              GrayLevel[0], StripOnInput -> False], TraditionalForm]},
          FrameTicks->{{{-13.815510557964274`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.512925464970229`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.210340371976182, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.605170185988091, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.3025850929940455`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
              FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
             0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.791759469228055, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.302585092994046, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.0943445622221, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.248495242049359, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.382026634673881, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.499809670330265, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.605170185988092, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.703782474656201, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.991464547107982, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.396929655216146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.551080335043404, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.684611727667927, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.802394763324311, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.006367567650246, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.294049640102028, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.699514748210191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.987196820661973, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.104979856318357, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.210340371976184, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.308952660644293`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.596634733096073`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.002099841204238`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.156250521031495`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.289781913656018`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.407564949312402`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}}, {{-13.815510557964274`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.512925464970229`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.210340371976182, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.605170185988091, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.3025850929940455`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
              FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
             0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.791759469228055, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.302585092994046, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.0943445622221, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.248495242049359, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.382026634673881, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.499809670330265, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.605170185988092, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.703782474656201, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.991464547107982, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.396929655216146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.551080335043404, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.684611727667927, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.802394763324311, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.006367567650246, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.294049640102028, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.699514748210191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.987196820661973, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.104979856318357, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.210340371976184, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.308952660644293`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.596634733096073`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.002099841204238`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.156250521031495`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.289781913656018`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.407564949312402`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}}, {{-13.815510557964274`, 
              FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
              FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
              FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
              FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
              FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm]}, {0., 
              FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
              FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
              FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
              FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
              FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
              FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
              FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
              FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
              FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
              FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
              FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
              FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
              FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
              FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
              FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
              FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
              FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
              FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
              FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
              FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
              FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
              FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
              FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
              FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
              FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
              FormBox["\"\"", TraditionalForm]}}, {{-13.815510557964274`, 
              FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
              FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
              FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
              FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
              FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm]}, {0., 
              FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
              FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
              FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
              FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
              FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
              FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
              FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
              FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
              FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
              FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
              FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
              FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
              FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
              FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
              FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
              FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
              FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
              FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
              FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
              FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
              FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
              FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
              FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
              FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
              FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
              FormBox["\"\"", TraditionalForm]}}},
          FrameTicksStyle->GrayLevel[0],
          
          GridLines->
           NCache[{{-16.11809565095832, -13.815510557964274`, \
-11.512925464970229`, -9.210340371976182, -6.907755278982137, \
-4.605170185988091, -2.3025850929940455`}, {
              Log[10], 
              Log[50], 
              Log[100], 
              Log[500], 
              Log[1000], 
              Log[5000], 
              Log[
              10000]}}, {{-16.11809565095832, -13.815510557964274`, \
-11.512925464970229`, -9.210340371976182, -6.907755278982137, \
-4.605170185988091, -2.3025850929940455`}, {2.302585092994046, 
            3.912023005428146, 4.605170185988092, 6.214608098422191, 
            6.907755278982137, 8.517193191416238, 9.210340371976184}}],
          GridLinesStyle->Directive[
            Dashing[{Small, Small}]],
          ImagePadding->All,
          ImageSize->{{600}, {600}},
          Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& )}},
          PlotLabel->None,
          PlotRange->NCache[{{-Log[100000], 0}, {0, 
              Log[6000]}}, {{-11.512925464970229`, 0}, {
             0, 8.699514748210191}}],
          PlotRangeClipping->True,
          PlotRangePadding->{{0, 0}, {0, 0}},
          Ticks->{Automatic, Automatic}], Scaled[{0.5, 0.5}], Center, 
         Scaled[{1, 1}]], InsetBox[
         TemplateBox[{FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   StyleBox["\"\"", {FontSize -> 14, 
                    GrayLevel[0], FontFamily -> "Arial"}, Background -> 
                    Automatic, StripOnInput -> False]}, {
                   GraphicsBox[{{}, {}, 
                    
                    RasterBox[{{{0., 0., 0.7}}, {{0., 0., 0.7}}, {{0., 0.5, 
                    0.75}}, {{0., 0.75, 0.75}}, {{0., 0.7, 0.}}, {{0.75, 0.75,
                     0.}}, {{0.75, 0.55, 0.}}, {{0.7, 0., 0.}}, {{0.7, 0., 
                    0.}}}, {{
                    Rational[-15, 2], 
                    Rational[-225, 2]}, {
                    Rational[15, 2], 
                    Rational[225, 2]}}], {Antialiasing -> False, 
                    AbsoluteThickness[0.1], 
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]], 
                    LineBox[
                    NCache[{{
                    Rational[15, 2], 
                    Rational[-225, 2]}, {
                    Rational[-15, 2], 
                    Rational[-225, 2]}, {
                    Rational[-15, 2], 
                    Rational[225, 2]}, {
                    Rational[15, 2], 
                    Rational[225, 2]}, {
                    Rational[15, 2], 
                    Rational[-225, 2]}}, {{
                    7.5, -112.5}, {-7.5, -112.5}, {-7.5, 112.5}, {7.5, 
                    112.5}, {7.5, -112.5}}]]}, {
                    CapForm[None], {}}, {Antialiasing -> False, 
                    StyleBox[
                    
                    LineBox[{{7.500000000000001, -112.50000000000001`}, {
                    7.500000000000001, 112.50000000000001`}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.500000000000001, -87.50000000000001}, 
                    Offset[{4., 0}, {
                    7.500000000000001, -87.50000000000001}]}, {{
                    7.500000000000001, -62.50000000000003}, 
                    
                    Offset[{4., 0}, {
                    7.500000000000001, -62.50000000000003}]}, {{
                    7.500000000000001, -37.50000000000003}, 
                    
                    Offset[{4., 0}, {
                    7.500000000000001, -37.50000000000003}]}, {{
                    7.500000000000001, -12.500000000000025`}, 
                    
                    Offset[{4., 0}, {
                    7.500000000000001, -12.500000000000025`}]}, {{
                    7.500000000000001, 12.49999999999997}, 
                    
                    Offset[{4., 0}, {7.500000000000001, 
                    12.49999999999997}]}, {{7.500000000000001, 
                    37.499999999999964`}, 
                    
                    Offset[{4., 0}, {7.500000000000001, 
                    37.499999999999964`}]}, {{7.500000000000001, 
                    62.49999999999997}, 
                    
                    Offset[{4., 0}, {7.500000000000001, 
                    62.49999999999997}]}, {{7.500000000000001, 
                    87.49999999999996}, 
                    
                    Offset[{4., 0}, {7.500000000000001, 
                    87.49999999999996}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-3.0000\"", -3., AutoDelete -> True],
                     NumberForm[#, {
                    DirectedInfinity[1], 4}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, -87.50000000000001}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-2.0000\"", -2., AutoDelete -> True],
                     NumberForm[#, {
                    DirectedInfinity[1], 4}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, -62.50000000000003}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    "\"-1.3333\"", -1.3333333333333333`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, -37.50000000000003}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    "\"-0.8889\"", -0.8888888888888888, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}]& ], TraditionalForm], 
                    
                    Offset[{7., 0.}, {
                    7.500000000000001, -12.500000000000025`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    "\"0.8889\"", 0.8888888888888888, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, 12.49999999999997}], 
                    
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    "\"1.3333\"", 1.3333333333333333`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}]& ], TraditionalForm], 
                    
                    Offset[{7., 0.}, {7.500000000000001, 
                    37.499999999999964`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"2.0000\"", 2., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, 62.49999999999997}], 
                    
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    "\"3.0030\"", 3.0029999999999997`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, 87.49999999999996}], 
                    
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1], FontSize -> 14, 
                    GrayLevel[0]]}, StripOnInput -> False]}, {}}, {
                    Directive[
                    Opacity[1], FontSize -> 14, 
                    GrayLevel[0]]}, StripOnInput -> False], "GraphicsLabel", 
                    StripOnInput -> False]}, "GraphicsTicks", StripOnInput -> 
                    False], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                    Scaled[0.02], PlotRange -> All, Frame -> True, 
                    FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                    Opacity[0], FrameTicksStyle -> Opacity[0], 
                    ImageSize -> {Automatic, 225}, BaseStyle -> {}, 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}]}}, 
                 GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontSize -> 14, 
              GrayLevel[0], FontFamily -> "Arial"}, Background -> Automatic, 
             StripOnInput -> False], TraditionalForm]},
          "BarLegend",
          DisplayFunction->(#& ),
          InterpretationFunction:>(RowBox[{"BarLegend", "[", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0., 0., 0.7], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0., 0.4666666666666667], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0., 0., 0.7]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0., 0., 0.7]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0., 0., 0.7], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0., 0., 0.7], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0., 0.4666666666666667], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0., 0., 0.7]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0., 0., 0.7]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0., 0., 0.7], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0., 0.5, 0.75], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0., 0.33333333333333337`, 0.5], FrameTicks -> 
                    None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0., 0.5, 0.75]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0., 0.5, 0.75]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0., 0.5, 0.75], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0., 0.75, 0.75], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0.5, 0.5], FrameTicks -> 
                    None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0., 0.75, 0.75]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0., 0.75, 0.75]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0., 0.75, 0.75], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0, 0.7, 0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0.4666666666666667, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0, 0.7, 0]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0, 0.7, 0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0, 0.7, 0], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.75, 0.75, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.5, 0.5, 0.], FrameTicks -> 
                    None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.75, 0.75, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.75, 0.75, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.75, 0.75, 0.], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.75, 0.55, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.5, 0.3666666666666667, 0.],
                     FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.75, 0.55, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.75, 0.55, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.75, 0.55, 0.], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0., 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.4666666666666667, 0., 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0., 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0., 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0., 0.], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0., 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.4666666666666667, 0., 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0., 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0., 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0., 0.], Editable -> False, Selectable -> 
                    False]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "3.006003`"}], ",", "3.009003`"}], "}"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "3.006003`"}], ",", 
                   RowBox[{"-", "3.`"}], ",", 
                   RowBox[{"-", "2.`"}], ",", 
                   RowBox[{"-", "1.3333333333333333`"}], ",", 
                   RowBox[{"-", "0.8888888888888888`"}], ",", 
                   "0.8888888888888888`", ",", "1.3333333333333333`", ",", 
                   "2.`", ",", "3.0029999999999997`", ",", "3.009003`"}], 
                 "}"}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"FontSize", "\[Rule]", "14"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False]}], 
                   "}"}]}], ",", 
               RowBox[{"LegendLabel", "\[Rule]", "\"\""}], ",", 
               RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
               RowBox[{"LegendMarkerSize", "\[Rule]", 
                 RowBox[{"{", "}"}]}], ",", 
               RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
               RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
               RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], 
             "]"}]& )], Scaled[{1., 0.5}], ImageScaled[{0, 0.5}],
         BaseStyle->{FontSize -> Larger},
         FormatType->StandardForm]},
       AspectRatio->1.,
       Axes->False,
       AxesLabel->{None, None},
       AxesOrigin->{0, 0},
       BaseStyle->{FontFamily -> "Helvetica", 16},
       DisplayFunction->Identity,
       Frame->False,
       FrameLabel->{
         FormBox[
          StyleBox["\"x\"", 18, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         FormBox[
          StyleBox["\"\[Mu] [GeV]\"", 18, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm]},
       FrameTicks->{{{-13.815510557964274`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.02375108873622, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.86960040890896, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.512925464970229`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.903487552536127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.721165995742174, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.567015315914915, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.433483923290392, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.315700887634009, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.210340371976182, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-8.111728083308073, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.824046010856292, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.600902459542082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.418580902748127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.264430222920869, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.013115794639964, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-6.907755278982137, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.809142990314028, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.521460917862246, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.298317366548036, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.115995809754082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.961845129926823, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.710530701645918, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.605170185988091, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.506557897319982, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.995732273553991, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.659260036932778, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.3025850929940455`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-1.203972804325936, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.916290731874155, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
           FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
          0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.302585092994046, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.605170185988092, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.907755278982137, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.210340371976184, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}}, {{-13.815510557964274`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.02375108873622, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.86960040890896, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.512925464970229`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.903487552536127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.721165995742174, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.567015315914915, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.433483923290392, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.315700887634009, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.210340371976182, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-8.111728083308073, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.824046010856292, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.600902459542082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.418580902748127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.264430222920869, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.013115794639964, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-6.907755278982137, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.809142990314028, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.521460917862246, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.298317366548036, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.115995809754082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.961845129926823, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.710530701645918, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.605170185988091, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.506557897319982, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.995732273553991, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.659260036932778, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.3025850929940455`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-1.203972804325936, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.916290731874155, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
           FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
          0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.302585092994046, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.605170185988092, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.907755278982137, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.210340371976184, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}}, {{-13.815510557964274`, 
           FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
           FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
           FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
           FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
           FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
           FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
           FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
           FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
           FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
           FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
           FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
           FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
           FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
           FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
           FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
           FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
           FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
           FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
           FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
           FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
           FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
           FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
           FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm]}, {0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
           FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm]}}, {{-13.815510557964274`, 
           FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
           FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
           FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
           FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
           FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
           FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
           FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
           FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
           FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
           FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
           FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
           FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
           FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
           FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
           FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
           FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
           FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
           FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
           FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
           FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
           FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
           FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
           FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm]}, {0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
           FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm]}}},
       FrameTicksStyle->GrayLevel[0],
       ImagePadding->All,
       ImageSize->{{600}, {600}},
       Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
             (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
              Part[#, 1]], 
             (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
              Part[#, 2]]}& ), "CopiedValueFunction" -> ({
             (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
              Part[#, 1]], 
             (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
              Part[#, 2]]}& )}},
       PlotLabel->FormBox[
         StyleBox[
         "\"\\!\\(\\*SubscriptBox[\\(r\\), \\(i\\)]\\) (Residual), \
CT14NNLO\"", 24, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm],
       PlotRange->Automatic,
       PlotRangeClipping->False,
       PlotRangePadding->{{0, 0}, {0, 0}},
       Ticks->{Automatic, Automatic},
       ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]],
      InterpretTemplate[Legended[
        Graphics[{{{}, {{{}, {
              Hue[0.67, 0.6, 0.6], 
              Directive[
               PointSize[0.012833333333333334`], 
               AbsoluteThickness[1.6], FontFamily -> "Helvetica", 
               GrayLevel[1]], 
              
              Point[{{0.00001, 2.}, {0.99, 
               1200.}}]}, {}}}, {}, {}, {{}, {}}}, {
           Style[
            Text["\[EmptySquare]", {29.659169363220833`, 4.512945241945574}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-38.34104853637971, 4.512945241945574}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.4420193761824103`, 
             3.2386784521643803`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.4028303297599902`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.278818960372969, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.527397202097891, 7.076653815443951}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0272286702329017`, 7.076653815443951}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.194022473472768, 
             2.1644717908644115`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.793961892783255, 
             2.1644717908644115`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-6.907755278982137, 0.8046885552928528}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 1.599387576580599}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 1.497835735852798}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047875165492457`, 6.298949246855942}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.804781390061982, 6.298949246855942}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.5338519254775054`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.4722426732562555`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.3540294005326152`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0302996484860225`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0181583132629375`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.2072749131897207`, 6.396929655216146}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706800981701778, 6.396929655216146}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 2.090999490513565}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.666335489679042, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.466278187121473, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1796054478776414`, 7.424165281042028}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6798603767306461`, 7.424165281042028}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.4122057429043917`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.8424288832756998}], 6., 
            
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.391511302188447}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.0738571633859353`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.5732134108799993`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5782126424678459, 1.5432981099295553`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-3.6504282677396835`, 1.5432981099295553`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.036482917202561, 7.56734567601324}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.5366522427084526`, 7.56734567601324}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4524341636244356`, 7.151485463904735}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.95263269481614, 7.151485463904735}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.8179208722379223`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.317867774075151, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.3681303904922195`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.038175919864279, 1.864080130807681}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.548102073285148, 1.864080130807681}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4092798316650086`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.9093711079059474`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7756596021344095, 2.418588768750352}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.701553201341906, 2.418588768750352}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.0845133642886082`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.6888794541139363`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.0498221244986778`, 1.266384064447333}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.4079456086518722`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5692561228012685`, 
             1.9892432737616872`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7696066645869217`, 
             1.9892432737616872`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             0.8055826098897335}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020229905154391, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520318812570019, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.5047438413194347`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-8.11206147220931, 0.973049065692764}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-2.659260036932778, 0.849723487602042}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5064301623598713`, 
             2.3523271848888596`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1062413158326008`, 
             2.3523271848888596`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 0.7476353658440151}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4405393759722864`, 5.940171252720432}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8407396514497736`, 5.940171252720432}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 0.7466879474879751}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.741256487054948, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.9407951330603375`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.2533450600473311, 8.350429973538136}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7533219035960154, 8.350429973538136}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.5824869781268642`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.4722426732562555`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5235731965884932, 2.50470927708418}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.7820071777853768`, 2.50470927708418}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.5107219394949427`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.283414346005772, 5.703782474656201}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.9661128563728327`, 1.497835735852798}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.5787702314339063`, 5.075173815233827}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.978697138696139, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-3.4420193761824103`, 3.2386784521643803`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 1.7833912195575383`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9715392061046336, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9515240188896708`, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9689006821464524, 
             2.3896797998449792`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5687759307152107`, 
             2.3896797998449792`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.609379030762146, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.909388227079972, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.6409365794934714`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.144222799920162}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9001713499942718, 1.4951487660319727`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.424056675808238, 1.4951487660319727`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-8.622553707074063, 0.8046885552928528}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.2876820724517809, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.6527732864216721, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.028919972120757, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-2.995732273553991, 1.094604267270571}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.3178664036290963, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-5.817847430944174, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 2.377692565480851}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.2908841763152323`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.5859645562484583`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.462149662665384}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9038682118755978, 6.476972362889683}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3037931396081468`, 6.476972362889683}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.7963700817857382`, 6.907755278982137}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.096384262410148, 6.907755278982137}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.8420006856648017`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.091798316674432, 4.386889790339869}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.5902550930173265`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.669026703845758}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7672619976276676`, 
             4.386889790339869}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.166785108860756, 
             4.386889790339869}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751531979714171, 5.8522024797744745`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.25165731439258, 5.8522024797744745`}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             0.9364854391596744}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4409617624621989`, 
             2.1174596088673567`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6414447085691868`, 
             2.1174596088673567`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0277811079075183`, 1.9768549529047348`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.333559897293476, 1.9768549529047348`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.816462081868427, 
             2.0425181875752383`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4159291662495814`, 
             2.0425181875752383`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3983669423541598`, 
             1.9600947840472698`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9987836386623814`, 
             1.9600947840472698`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.8787541283454292, 1.599387576580599}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.2367852454117685`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2669126040998102`, 
             4.386889790339869}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.666828609658249, 
             4.386889790339869}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 0.8060293376166178}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.0654001544619962`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.6888794541139363`, 5.298317366548036}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7159101569446171`, 
             2.0425181875752383`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5159475693467614`, 
             2.0425181875752383`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.527397202097891, 7.076653815443951}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0272286702329017`, 7.076653815443951}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.2669476034873244`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-6.607650686531799, 1.445270566220188}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.7317869551252127`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.201916872261721, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4524341636244356`, 7.151485463904735}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.95263269481614, 7.151485463904735}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             1.8359358315608838`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7903190923122189, 1.6272778305624314`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-3.270169119255751, 1.6272778305624314`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7625890919282752`, 6.841615476477592}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262403303361214, 6.841615476477592}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9065879564127699, 7.697121317282625}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.406905315024015, 7.697121317282625}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-2.995732273553991, 5.991464547107982}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 2.227106951818089}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.3039860739096736`, 
             4.386765389021055}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.083998270167957, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7985076962177716, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.6888794541139363`, 1.0942695392339727`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 0.9858167945227654}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.4722426732562555`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.8162894669713328`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 1.266384064447333}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.5565205830281202, 
             2.702032128776647}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3567355588783463`, 
             2.702032128776647}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.863232841258714, 0.8333438110532289}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.6854573524495757`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.4854489341097463`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9065879564127699, 7.697121317282625}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.406905315024015, 7.697121317282625}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.4911047254722358`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3208812225716584`, 2.0095554142156695`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9747212309094329`, 2.0095554142156695`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.2072749131897207`, 1.497835735852798}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.880084850028029, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.380218975276964, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.045554398052668, 0.7485818874480459}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-0.908818717035454, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-5.3089739467365655`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.595748829015065, 5.991464547107982}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.395911377232918, 5.991464547107982}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.3524072174927233`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.26683423993894284`, 4.386889790339869}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-8.666853965970644, 4.386889790339869}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.9661128563728327`, 1.726509584019938}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.820158943749753, 5.560681631015528}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.220083871482302, 5.560681631015528}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5186835491656363`, 
             2.1400661634962708`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5186835491656363`, 
             2.1400661634962708`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.8526977673331346`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.817803785159501, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-5.317908016313041, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.640548907459153}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.6094379124341003`, 7.3777589082278725`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0202633222571333`, 1.4929040961781488`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.3082536360194172`, 1.4929040961781488`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 0.965080896043587}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 2.0427775573082445`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.59947470469731, 8.004365564979574}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0993125337825032`, 8.004365564979574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8598242001421843`, 5.521460917862246}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2595256035335987`, 5.521460917862246}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.5177604746590787`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.6178619668786562`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.3524072174927233`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8598242001421843`, 5.521460917862246}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2595256035335987`, 5.521460917862246}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.4307829160924542, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.9178457348969196`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.2178763245351174`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.898454207899018, 
             1.9600947840472698`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4983438649285135`, 
             1.9600947840472698`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.154094566627875, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.554477071672573, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2909841813155656`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2909841813155656`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.4307829160924542, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 0.9489515141137035}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.5432981099295553`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.8469979053782056, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.247228312996893, 6.5337888379333435`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111964733385396, 6.492239835020471}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6115589009134488`, 6.492239835020471}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-4.3428059215206005`, 2.6490076604684267`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             1.0678093795130645`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.377606779979768, 2.0706530356467567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7955707986317053`, 2.0706530356467567`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7655070980839893`, 
             2.0930978681273213`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3657077275115024`, 
             2.0930978681273213`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.56019682034536, 4.0943445622221}], 4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.959419502711985, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.2098554674840916`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2808538486618937`, 6.249975242259483}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.3811078344325904`, 6.249975242259483}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.430629081771714, 
             2.827905162910489}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2306590695884416`, 
             2.827905162910489}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.468806782694355, 
             2.3896797998449792`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.068859330518762, 
             2.3896797998449792`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.721515815839451}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 1.173410498743296}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.236923904465622}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 1.3147983594148207`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1689274625831354`, 
             2.3896797998449792`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[$CellContext`\[FivePointedStar], {-1.3688474475161698`, 
             2.3896797998449792`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2437536743377806`, 7.360103972989152}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.744112815760702, 7.360103972989152}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 0.7485818874480459}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             0.9364854391596744}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2854179707987138, 2.4997952622817508`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.029509172931627, 2.4997952622817508`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.4365120772805082`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.1597073880279205`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             2.0680013515372804`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.491654876777717, 1.599387576580599}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.864704011147587, 1.3452119160186606`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2072749131897207`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.5920892740994874`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.341928551227046, 4.386889790339869}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-0.8505029913361519, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-8.350408373771412, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2824955457644808, 1.7817091333745536`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.4686200579795896`, 1.7817091333745536`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2184098521237055`, 
             2.1400661634962708`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8189251373008244`, 
             2.1400661634962708`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.527397202097891, 7.076653815443951}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0272286702329017`, 7.076653815443951}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.8706006059570394, 7.783224016336037}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.2704687956143002`, 7.783224016336037}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.366940997255841, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.566911473871001, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6792442753909539, 2.0719132752590443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.491327217590923, 2.0719132752590443`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 1.3982229319851645`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5832829549572491`, 1.5933085305042167`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5449114637250294`, 1.5933085305042167`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.615959129424366, 
             2.0425181875752383`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.615959129424366, 
             2.0425181875752383`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.395133309787095, 2.0731719286662407`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.77313400510489, 2.0731719286662407`}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6044503709230613`, 6.999422467507961}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 6.999422467507961}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8195418502405067`, 6.784457062637643}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.319222734147069, 6.784457062637643}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.3540294005326152`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.33589240475620386`, 2.502255288122613}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.974001029221839, 2.502255288122613}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1304126012179074`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9186841628017217`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.9782390361706734`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.416581053724763}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.991464547107982, 1.445270566220188}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.529318843261892, 
             1.9033008439609624`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.06016413371338, 5.393627546352362}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.860379772276308, 5.393627546352362}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.2140221401789375`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7985076962177716, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9065879564127699, 7.697121317282625}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.406905315024015, 7.697121317282625}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111964733385396, 6.492239835020471}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6115589009134488`, 6.492239835020471}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 1.2669476034873244`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8457617469776957`, 5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.145857732131629, 5.991464547107982}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2942622756733968`, 6.0867747269123065`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.694451286761057, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.4958211856471328`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.5338519254775054`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4240364936935998, 8.1797604936999}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9240709191931175, 8.1797604936999}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.362224007377702, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.57270299585059, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.3137876703331426`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.409603402444116, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.2136588837996443`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.1093512670354135`, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.9180031958023054`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.217869048507598, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.2255369822417765`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.975450465015525, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.0218709311636855`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.911914268349973, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 0.8060293376166178}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.483987072728617, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.904054835778969, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.9782390361706734`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.9317114296555002`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316692464055834`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.9696906777207166`, 6.684611727667927}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.3691523372661587`, 6.684611727667927}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4182464424728975, 2.6019486702196644`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6922761907431048`, 2.6019486702196644`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.742398039690331, 
             2.0162354657760435`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.542246662893777, 
             2.0162354657760435`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.46013250945047257`, 2.512035317176253}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8307082193666298`, 2.512035317176253}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.836849948493799, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.0968250627658085`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             2.1094856630282126`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.4307829160924542, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.2262184132732556`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.725971728690052, 7.3777589082278725`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.4146938356415886`, 5.966146739123692}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.8146187633741377`, 5.966146739123692}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.5136732904497212`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.0136538011418326`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.5100594684538216`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.5338519254775054`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 0.8060293376166178}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6969544189028993, 2.0082140323914683`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6009911288088023`, 2.0082140323914683`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4092798316650086`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.9093711079059474`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.287354413264987, 
             2.3711778844596574`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.287354413264987, 
             2.3711778844596574`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8042369907391675`, 4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-4.584387646805562, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             1.0281898243715637`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.3418458069473482`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.592214878401959, 4.386889790339869}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.4079456086518722`, 1.726509584019938}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2072749131897207`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.309519943887134, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.209391157353635, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.166915255056936, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.76686592498839, 4.386889790339869}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.3281354469463584`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-1.984131361875511, 7.003065458786462}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2173252490432223`, 4.386889790339869}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-6.717134919373487, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7987840841650193`, 
             1.9600947840472698`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.598497972395766, 
             1.9600947840472698`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.5978370007556204, 1.497835735852798}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.2602187884025833`, 5.393627546352362}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.660097652688484, 5.393627546352362}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.995732273553991, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.71869489837105, 
             2.1400661634962708`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3186357126460757`, 
             2.1400661634962708`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.953887209526845, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.7539022397884905`, 4.499809670330265}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6745099091778153`, 1.9300710850255671`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.780226233414382, 1.9300710850255671`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.199705077879927, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 0.6951451832226183}], 6., 
            
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.1406850650900175`, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2406367886975274`, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.0738571633859353`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.5732134108799993`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.2581768583394481`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9065879564127699, 7.697121317282625}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.406905315024015, 7.697121317282625}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.359873830032749, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.159425367681418, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.6675181235106251`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.084253098677058, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.30432512701003, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6691879168398742`, 
             1.9892432737616872`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6691879168398742`, 
             1.9892432737616872`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 1.599387576580599}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-3.76705723517796, 4.386889790339869}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-5.166938288491657, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.462149662665384}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2453891602615295, 2.424802725718295}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.220083871482302, 2.424802725718295}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2942622756733968`, 
             2.1644717908644115`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.694451286761057, 
             2.1644717908644115`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2072749131897207`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 2.0766877534832147`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3799147541558516`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8799351601317804`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-7.1308988302963465`, 
             1.2424239907001886`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.2909841813155656`, 1.266384064447333}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.4126383364594925`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.536426440357718, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.3799147541558516`, 7.22402480828583}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.8799351601317804`, 7.22402480828583}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.5978370007556204, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5828588266658222, 1.6974487897568136`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.336815122732887, 1.6974487897568136`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.3418458069473482`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.592214878401959, 4.386889790339869}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9317114296555002`, 6.672032945461067}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316692464055834`, 6.672032945461067}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.462149662665384}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.618595850218866}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 0.8450095298691913}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-6.437751649736401, 0.973049065692764}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 0.7485818874480459}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.1760334356366946`, 6.104793232414985}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.7760829898430475`, 6.104793232414985}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7985076962177716, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.7985076962177716, 2.647592232065096}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.6139480679119864`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.9139271032022627`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.2919836816486494`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.4079456086518722`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.7147984280919266`, 1.497835735852798}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.266384064447333}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             1.5473497201206787`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.5288035062673013`, 5.075173815233827}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.028556821684098, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6414447085691868`, 
             2.1174596088673567`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4409617624621989`, 
             2.1174596088673567`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.430789601006442}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.215506040139609}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.000759888500605, 6.380122536899765}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4007990473227723`, 6.380122536899765}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.3670139217339117, 2.134048091170708}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6790255220615937`, 2.134048091170708}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4460443655256647`, 7.157735484249907}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.946310229076653, 7.157735484249907}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4422299934501939`, 
             2.0162354657760435`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8426317996018116`, 
             2.0162354657760435`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 0.9991602096964498}], 6., 
            
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020229905154391, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520318812570019, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6654793033177253`, 
             2.0930978681273213`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4653375684603434`, 
             2.0930978681273213`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.4018530946527146`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.532062329207643, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.4079456086518722`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.5077842587076005`, 5.823045895483019}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.007679175452945, 5.823045895483019}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.5629964960949002, 6.81783057145415}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.9631203192309531, 6.81783057145415}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.5845302767279155`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.132893222644984, 
             2.425687290128029}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3329431856228962`, 
             2.425687290128029}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8470607850131444`, 6.756932389247553}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346745988779815, 6.756932389247553}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047875165492457`, 6.298949246855942}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.804781390061982, 6.298949246855942}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4159291662495814`, 
             2.0425181875752383`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.816462081868427, 
             2.0425181875752383`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.9904756300635316, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.3907040696085906`, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 2.215282764591249}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 1.715777948205427}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.3524072174927233`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.082935809283102, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.1892564076870427`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.3137523001849649, 8.290041618704489}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.813734143549063, 8.290041618704489}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1214715828141923`, 1.9387416595767009`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3154677188250594`, 1.9387416595767009`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.0794415416798357`, 2.187398683184928}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751531979714171, 5.8522024797744745`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.25165731439258, 5.8522024797744745`}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.8183088044615916`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.318488613869894, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.9251241812954787`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.815475995845371}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6445470895476684`, 5.736572297479192}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.044846896915337, 5.736572297479192}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.0498221244986778`, 2.187398683184928}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.2072749131897207`, 6.396929655216146}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706800981701778, 6.396929655216146}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.666335489679042, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.466278187121473, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.44238846221276223`, 1.501852701754163}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.868484703413663, 1.501852701754163}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020229905154391, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520318812570019, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.382026634673881, 0.8441500540964727}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.7109170813839543`, 5.66988092298052}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1111386284230904`, 5.66988092298052}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 1.170932950247736}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.522010001878903, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.411934093335004, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             1.2756420910162956`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7696066645869217`, 
             1.9892432737616872`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5692561228012685`, 
             1.9892432737616872`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.9317114296555002`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316692464055834`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7625890919282752`, 6.841615476477592}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262403303361214, 6.841615476477592}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             2.4561641809223462`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.6624240079171049, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-8.286478374605709, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8505029913361519, 2.4176979000945504`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6286207318508743`, 2.4176979000945504`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-8.94874563428772, 0.973049065692764}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.931658209005277, 1.8625285401162623`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.657689841763261, 1.8625285401162623`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.6393849888020524`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.904054835778969, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.803865056899991, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047875165492457`, 6.298949246855942}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.804781390061982, 6.298949246855942}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             0.898534010284896}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.7333680090865, 6.253828811575473}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.406587064387653}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820086052689358`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1821389399181785`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5918549290780729, 1.6034198401085373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.5159350591325786`, 1.6034198401085373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.741015208534465, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.940782792197422, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-2.995732273553991, 0.848868055556721}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.161367091078508}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.064355904261795, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640797356921787`, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.418781887396557, 5.111987788356544}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.51875303057183, 5.111987788356544}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.3799147541558516`, 7.22402480828583}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.8799351601317804`, 7.22402480828583}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6218266343535928`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.312220927289192, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.516892795645856, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.016955910005618, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.4847813078345447`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.4938666711595117`, 4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.894183087299815, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4947708374559745`, 5.886104031450156}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8951219822232084`, 5.886104031450156}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.4911047254722358`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.359436906950008}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.4911047254722358`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.8250798518207709, 1.864080130807681}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7611345721946656`, 1.864080130807681}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.7268653293100646`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.770028224895903, 
             2.58851563240702}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3700273886560186`, 
             2.58851563240702}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.349630376748299}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-7.600902459542082, 1.6094379124341003`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.1029215602562081`, 7.600902459542082}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.4028303297599902`, 7.600902459542082}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2072749131897207`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4714166145367258`, 
             2.187174241482718}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4714166145367258`, 
             2.187174241482718}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3063747379440172`, 
             2.3523271848888596`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3063747379440172`, 
             2.3523271848888596`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 1.0962762288705619`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0645007590393418`, 
             2.494031557565001}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.26443077336305, 
             2.494031557565001}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 0.8060293376166178}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             0.8202202631234213}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2761851384398606`, 6.104793232414985}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.6761120457020933`, 6.104793232414985}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1535965970008693`, 1.4906543764441336`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1796551117149194`, 1.4906543764441336`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4524341636244356`, 7.151485463904735}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.95263269481614, 7.151485463904735}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.8665717425242287`, 4.787491742782046}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.266557384867768, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 0.9329511727672622}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.7418655495969406`, 4.386889790339869}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-6.191868611452702, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             1.1597073880279205`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 
             1.3045418592476314`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.5639866495301828`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.9639722918737217`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.322289031143978}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.5539252025038417`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 0.849723487602042}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.995732273553991, 5.991464547107982}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.1780394222994315`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.25154302583590776`, 2.130609828254235}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8016468498397944`, 2.130609828254235}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 1.2184672504763885`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.3504080825554816`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.6939993778795506`, 
             4.386765389021055}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.694093021166824, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             0.986935571443487}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.251619457793289}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 2.4176979000945504`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.631199404215613}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1208578976154293`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9949325933834268`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.7607838292757566, 6.620073206530356}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.160913314865489, 6.620073206530356}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.2876820724517809, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.15218556191195, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.781788039865368, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.9405834244431995, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.4405393759722864`, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5104979645791967`, 1.9358598132018119`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.932401799030521, 1.9358598132018119`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9329283730271782, 
             2.425687290128029}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5329399414613754`, 
             2.425687290128029}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3257638613798584`, 1.776645831418007}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.435545220250276, 1.776645831418007}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.5102244577722903`, 6.476972362889683}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0288996762568094`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.652827532407001, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.227106951818089}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.363503507963463, 6.040254711277414}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.2636117187095923`, 6.040254711277414}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.064355904261795, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640797356921787`, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.7828868907244566`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5366522427084526`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.412267540691536, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1409980051645476`, 
             4.512945241945574}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.540748536722336, 
             4.512945241945574}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 1.406587064387653}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.885443919659868, 5.768320995793772}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.2855499581361935`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.6700167631710908, 
             2.58851563240702}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4701108472130011`, 
             2.58851563240702}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7145751279735658, 1.9387416595767009`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7225041580723603`, 1.9387416595767009`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.0029385385998273`, 7.600902459542082}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.502828177375842, 7.600902459542082}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111964733385396, 6.492239835020471}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6115589009134488`, 6.492239835020471}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 1.599387576580599}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.5177707239082765`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.617850239145466, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-7.284632930238389, 
             1.6094379124341003`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             2.0680013515372804`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.726509584019938}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.44926026810783587`, 2.0719132752590443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7212874278842305`, 2.0719132752590443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.4407825464039603`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4092798316650086`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.9093711079059474`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.360956006320375, 4.969813299576001}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.8610265707016995`, 4.969813299576001}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.516892795645856, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.016955910005618, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.21678878567620194`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.716864386545305, 4.386889790339869}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.719319793360441}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 1.5377270648801}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-6.214608098422191, 1.6094379124341003`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 1.144222799920162}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.2756420910162956`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0339487753423875`, 2.418588768750352}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-1.443923473956527, 2.418588768750352}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2977324083052823, 1.6114359150967734`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.7937956240634962`, 1.6114359150967734`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.6269849783062765, 1.937301774518713}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8129108417183852`, 1.937301774518713}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.4588475538015993`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0189110419398038`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5188771693591536`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.4126383364594925`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-7.536426440357718, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.342468881579861, 
             2.0162354657760435`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9428149441480107`, 
             2.0162354657760435`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.416581053724763}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.463458318582131, 6.040254711277414}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.1634411179801, 6.040254711277414}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3093333199837622`, 7.294377299288821}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8097197946050478`, 7.294377299288821}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.019664337643975, 6.684611727667927}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.3191210616341453`, 6.684611727667927}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-5.2030071867437115`, 1.7328937163610187`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.200028504668954, 6.253828811575473}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.9999411183280458`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.2672179491567546`, 
             4.386889790339869}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-6.667164814064207, 
             4.386889790339869}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.1850957485562468`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.0966102859974367`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9712750402069146, 
             7.6324011266014535`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4714166145367258`, 
             7.6324011266014535`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.1269525243508878`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.807005375881994, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.2158025560795132`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 0.9403978072173882}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.0498221244986778`, 1.497835735852798}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             1.2908841763152323`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.376740148315079, 7.226936018493289}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8773173575897015`, 7.226936018493289}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.5305182571117267, 
             2.827905162910489}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1307223425863433`, 
             2.827905162910489}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.7985076962177716, 1.4964931534179662`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 1.322289031143978}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.8205261098897758, 7.783224016336037}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.3205066205818874`, 7.783224016336037}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.564942672547549, 5.966146739123692}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.664950622364359, 5.966146739123692}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.4588475538015993`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.9782390361706734`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.0279882600909205`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.190415030972834, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.995732273553991, 3.8004208288468435`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.293897511853923, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-5.093908213290077, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.9372477759766606`, 5.393627546352362}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.4371455863897404`, 5.393627546352362}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1542307124311217`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-5.234028876665675, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.6126737964100685, 2.005525858729668}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6907507040241487`, 2.005525858729668}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.900458886151396, 5.480638923341991}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3005870903313728`, 5.480638923341991}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.5532907518110994`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047875165492457`, 6.298949246855942}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.804781390061982, 6.298949246855942}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5228016057745537`, 5.857933154483459}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.922779731666459, 5.857933154483459}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.2319770007355333`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.7985076962177716, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-4.3428059215206005`, 
             3.2386784521643803`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.5338519254775054`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 1.68510181635509}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5159475693467614`, 
             2.0425181875752383`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7159101569446171`, 
             2.0425181875752383`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.219163484854973, 5.111987788356544}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.7188583998188136`, 5.111987788356544}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0328245481301066`, 
             2.425687290128029}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4329667693183212`, 
             2.425687290128029}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.7178497932003172, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-5.417776806585365, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.6397713603489157`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.880084850028029, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.380218975276964, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.8162894669713328`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.412288358086009, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-6.536881615643591, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4405393759722864`, 5.940171252720432}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8407396514497736`, 5.940171252720432}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.2072749131897207`, 6.396929655216146}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706800981701778, 6.396929655216146}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.746403767507258, 6.907755278982137}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.1464364105041143`, 6.907755278982137}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8016236568960291, 6.579251212010101}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2016421889876536`, 6.579251212010101}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.7985076962177716, 2.187398683184928}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.067986095126349, 2.3456445824544927`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.5558971455060706`, 2.3456445824544927`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.2499926428748753`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.9499943818801375`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.4753441779534016`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.725332537920259, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7985076962177716, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-4.045554398052668, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.575036485716768, 2.020222182019865}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6993626199620875`, 2.020222182019865}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6445470895476684`, 5.736572297479192}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.044846896915337, 5.736572297479192}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.184789984909162}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2654936609741865`, 
             2.0930978681273213`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8656213178265104`, 
             2.0930978681273213`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.719319793360441}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.5974734304916628, 8.006367567650246}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.0975128932248088`, 8.006367567650246}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.598497972395766, 
             1.9600947840472698`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7987840841650193`, 
             1.9600947840472698`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4876628555081794`, 
             2.3711778844596574`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.087375656742122, 
             2.3711778844596574`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.7317869551252127`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.201916872261721, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.437937594271729}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5906161581935125`, 
             2.0681277817795625`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5906161581935125`, 
             2.0681277817795625`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.3137523001849649, 8.290041618704489}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.813734143549063, 8.290041618704489}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             2.0624225365102413`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2909841813155656`, 1.497835735852798}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.0794415416798357`, 6.907755278982137}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-2.659260036932778, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-7.957577403480815, 0.8046885552928528}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.1413169453979233`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.541030999190403, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1080567474961094`, 6.272877006546167}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5082360319251331`, 6.272877006546167}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.140807436632442, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.541256860244439, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.266384064447333}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.5257286443082556`, 1.266384064447333}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             1.5532907518110994`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9699552564598479, 
             2.58851563240702}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1702157075278026`, 
             2.58851563240702}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.555615105736594}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751531979714171, 5.8522024797744745`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.25165731439258, 5.8522024797744745`}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-4.382026634673881, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.219163484854973, 5.111987788356544}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.7188583998188136`, 5.111987788356544}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7625890919282752`, 6.841615476477592}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262403303361214, 6.841615476477592}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3186357126460757`, 
             2.1400661634962708`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.71869489837105, 
             2.1400661634962708`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.7218733417638885`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.1966460289394751`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.6444188813293459`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.698815723585317, 
             1.9600947840472698`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.698815723585317, 
             1.9600947840472698`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 1.421661504957182}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.9353900445478294`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.235513466021224, 5.768320995793772}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 2.075308010398229}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.2917089186300228`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.382026634673881, 0.7485818874480459}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-0.3504089023600859, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-8.850570223130148, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7174398731289899, 2.5087859235779435`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5793937910857236`, 2.5087859235779435`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.8344641259578687`, 6.152732694704104}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.659260036932778, 1.0845133642886082`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.137918471438812, 5.393627546352362}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.2377341206744292`, 5.393627546352362}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-1.585233223737283, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.632849755094834, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.2792657883613672`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-7.957577403480815, 1.445270566220188}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 1.4964931534179662`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 2.296667619230008}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.4532518292447716`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.5978370007556204, 1.726509584019938}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5404260935422814, 8.063377822367027}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0404377246170375`, 8.063377822367027}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.462149662665384}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 1.2499017362143359`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 2.04225875055212}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9519179095173061, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7958982916754054`, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.6544352783648362`, 5.676753802268282}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.1541650878757723`, 5.676753802268282}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-6.502290170873972, 1.2424239907001886`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.491654876777717, 1.416581053724763}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.8470364847178946`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-8.403864506109235, 
             1.0698698198024557`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 1.669026703845758}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.2157956136516715, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.466024904841838, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.509860006183766, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.009386074695824, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.7317869551252127`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.201916872261721, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.104394898075602, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.604170685655008, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4850103340590484`, 2.135349173618132}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.559220196273483, 2.135349173618132}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.2319770007355333`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 1.4772770088317615`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3585338134237321, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.5645401798583287`, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {31.659225875646104`, 4.512945241945574}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-40.340943771488284`, 4.512945241945574}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4524341636244356`, 7.151485463904735}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.95263269481614, 7.151485463904735}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.5978370007556204, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.7406415980494447`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.090999490513565}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 0.9150900112976361}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 1.5377270648801}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.417771502803163, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.7181023127908395`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0923241675108497`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.841967538444134, 4.386889790339869}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1702157075278026`, 
             2.58851563240702}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9699552564598479, 
             2.58851563240702}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.744604469176456, 1.7328937163610187`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 2.0215475632609334`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.739076112448345}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.1966460289394751`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 0.9543569326806114}], 6., 
            
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.017773404430871, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.117899907528199, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 2.2044208442068145`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.074653024948039, 6.429719478039138}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.7740297600361856`, 6.429719478039138}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.902704363179782}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.5432981099295553`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2669126040998102`, 
             4.386889790339869}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.666828609658249, 
             4.386889790339869}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4240364936935998, 8.1797604936999}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9240709191931175, 8.1797604936999}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             2.4561641809223462`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.2788685663767296`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.402746540537711, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.5824869781268642`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.6772785424354564`, 6.309918278226516}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.719319793360441}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.036482917202561, 7.56734567601324}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5366522427084526`, 7.56734567601324}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.7790406968202803`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.902767737471098, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.100765130025024, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.10045059841862, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.4961092271270973`, 6.907755278982137}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.3960170377865984`, 6.907755278982137}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             2.1992225799988927`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.2158025560795132`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.369240606554063, 
             1.9892432737616872`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9696906777207166`, 
             1.9892432737616872`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.719319793360441}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.18777640747691846`, 7.1929342212158}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.5878866699024524, 7.1929342212158}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 2.075809955445786}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.8843386505211481`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.3649243353836982`, 5.966146739123692}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.864975531559314, 5.966146739123692}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.3492738284584218, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-8.599488434143067, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.4911047254722358`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.9313764735639716`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7667937207282438, 
             4.386889790339869}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.166888494485349, 
             4.386889790339869}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 2.1587147225743437`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3943265328171548`, 
             2.1644717908644115`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.594056810395798, 
             2.1644717908644115`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8584936331479384, 2.0706530356467567`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.314556464775266, 2.0706530356467567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.6843598389513597`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 1.0335402919243948`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.8947738884119054, 1.7316555451583497`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.9568962497687927`, 1.7316555451583497`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.880084850028029, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.380218975276964, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-7.819058469345253, 
             1.3540294005326152`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.378751192832325, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.178596114669692, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2909841813155656`, 1.726509584019938}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             1.8728785205128469`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.0808706071919527`, 6.249975242259483}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.5808504555821878`, 6.249975242259483}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.8029620465671519, 7.600902459542082}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.7031992922485748`, 7.600902459542082}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.215506040139609}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.7985076962177716, 1.497835735852798}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 0.8307328435125084}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.1151705891340815`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-8.622553707074063, 0.973049065692764}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.9969586349416099, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0969137320325284`, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3082228256997352`, 7.295735072749282}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.808498793232353, 7.295735072749282}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0923241675108497`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.841967538444134, 4.386889790339869}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.9474803442248305`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.1409980051645476`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.540748536722336, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.5539252025038417`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-4.3428059215206005`, 3.2386784521643803`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.773934884315503}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.204382667431038, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.504420282887948, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.8122154777954373`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.9474803442248305`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.8826660279157308`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.9999411183280458`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.2178763245351174`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.9317114296555002`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316692464055834`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.3540294005326152`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.26443077336305, 
             2.494031557565001}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0645007590393418`, 
             2.494031557565001}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8701230510291479, 
             2.58851563240702}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.270112606830481, 
             2.58851563240702}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.987774353154012, 5.393627546352362}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.3871630694693433`, 5.393627546352362}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.6564295976247825, 
             2.702032128776647}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.256670593326385, 
             2.702032128776647}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             2.1992225799988927`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 1.0360274134764884`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.0794415416798357`, 1.266384064447333}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.1026043099376472`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3799147541558516`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8799351601317804`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.2180717287054377`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.91782824451005, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9542522381612738, 2.0719132752590443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.2164073967529934`, 2.0719132752590443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.0940068428223313`, 
             4.386765389021055}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.2941383093687477`, 
             4.386765389021055}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.426283369336254, 6.104793232414985}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.5260163042950279`, 6.104793232414985}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.3302529702362658`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.66341149948383, 6.040254711277414}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.9634587130036953`, 6.040254711277414}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.3178883284558303`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.8178684794407625`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.9453385571563557`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-6.214608098422191, 2.3933394562625097`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.0281898243715637`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.7985076962177716, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.227106951818089}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.9572739077056285`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 2.217027204632399}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.3286906908754075`, 5.075173815233827}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.228790658775024, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.06016413371338, 5.393627546352362}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.860379772276308, 5.393627546352362}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.2101638842661795`, 5.393627546352362}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.710307401527557, 5.393627546352362}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.7027460895677522`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.9245405804618736`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.516892795645856, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.016955910005618, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-7.1308988302963465`, 1.2424239907001886`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2282654968949804`, 6.152732694704104}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6281111776997217`, 6.152732694704104}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.9510398268753117`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.5779472453427295`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1874435023747254`, 
             2.3711778844596574`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3874950816964096`, 
             2.3711778844596574`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-6.214608098422191, 2.0471765810925606`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.605170185988091, 2.9290581402859983`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.6744763086133228`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.8958869385842747`, 
             5.991464547107982}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-3.0957736277342174`, 
             5.991464547107982}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.3563504847468186`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.9177918580004223, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-5.2178439823981595`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3171415024315738`, 6.063785208687608}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7170231231140378`, 6.063785208687608}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.5845302767279155`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.7435408969575807`, 5.537334267018537}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.3434070875143007`, 5.537334267018537}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-0.8505029913361519, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-8.350408373771412, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.9837562915454279`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.2876820724517809, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8328691237350826, 
             2.425687290128029}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6332184410995039`, 
             2.425687290128029}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             2.0624225365102413`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.6179742434563866`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.518075479137158, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.9405834244431995, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.4405393759722864`, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0189110419398038`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5188771693591536`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5173146235582946`, 7.086737934510577}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.017406150760383, 7.086737934510577}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.7181373293574413`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.4178610876830975`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.6528674703614363`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.0287936073591935`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5901256014017275`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0898959995836948`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5601909533113197, 2.423031246069913}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9085180298382507`, 2.423031246069913}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.696151689580244, 6.684611727667927}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0963149296194261`, 6.684611727667927}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.6163727633271883`, 4.787491742782046}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.51624397679369, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.6204544951665047, 7.783224016336037}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.5205117032396989`, 7.783224016336037}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 2.253709925211909}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2026403590921573`, 2.0095554142156695`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0931348688118385`, 2.0095554142156695`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.659260036932778, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3082228256997352`, 7.295735072749282}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.808498793232353, 7.295735072749282}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.462149662665384}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.3407610128583247`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.340807418168989, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.0498221244986778`, 1.726509584019938}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.6168849633501186`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-3.600868576791223, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2651392395634233`, 1.5953389880545987`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.858931232061846, 1.5953389880545987`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.697356025334, 8.006367567650246}], 4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.9975007872996983, 8.006367567650246}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3035404883862389, 1.5107219394949427`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.989444152396731, 1.5107219394949427`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2496677635880655`, 6.131226489483141}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6497392092076262`, 6.131226489483141}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.7109170813839543`, 5.66988092298052}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1111386284230904`, 5.66988092298052}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.7985076962177716, 1.726509584019938}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1564532883579597`, 
             2.702032128776647}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7565130561817651, 
             2.702032128776647}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.927891643552635}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.6661962462527091`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.462149662665384}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.4079456086518722`, 1.497835735852798}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.0942695392339727`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.941966881801218, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.991862608772972, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.2256240518579173`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.975391927697949, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.5824869781268642`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.6287255312941893`, 5.075173815233827}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.9286606465811693`, 5.075173815233827}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6941476808935289, 1.4951487660319727`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.6302332586812027`, 1.4951487660319727`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2361517026901712`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8121662790057176`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.2917089186300228`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             1.1990607599649155`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2330583852210326`, 
             2.425687290128029}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2330583852210326`, 
             2.425687290128029}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.2787091504399533`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9038682118755978, 6.476972362889683}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3037931396081468`, 6.476972362889683}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.1269525243508878`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.807005375881994, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.410950117672171, 4.969813299576001}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.810913836561449, 4.969813299576001}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0939462278827174`, 4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-4.294015757351168, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.6593256320844346, 7.944492163932159}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1593181637855046`, 7.944492163932159}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 2.078566158643882}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.9736550492637259, 1.9198594718553708`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.5016459737922982`, 1.9198594718553708`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.8944568674663975`, 
             4.386765389021055}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.494523665901028, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.3101690833145914`, 5.393627546352362}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.6100682736896466`, 5.393627546352362}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.421661504957182}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324790142551358`, 5.971261839790462}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132468797127462, 5.971261839790462}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.2761851384398606`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.6761120457020933`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.556451816951096}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-8.421883011611913, 1.2424239907001886`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 2.377692565480851}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.5824869781268642`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.6661962462527091`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.227106951818089}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.389499492068839, 5.991464547107982}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 5.991464547107982}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.5824869781268642`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-1.491654876777717, 1.094604267270571}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.090999490513565}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6667000105450971, 1.6974487897568136`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.252691173362931, 1.6974487897568136`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.023439351564551, 5.2574953720277815`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.623341473175256, 5.2574953720277815`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4092798316650086`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.9093711079059474`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.953887209526845, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.7539022397884905`, 4.499809670330265}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3657077275115024`, 
             2.0930978681273213`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7655070980839893`, 
             2.0930978681273213`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0942219403668167`, 
             2.1644717908644115`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8944568674663975`, 
             2.1644717908644115`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6218266343535928`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.312220927289192, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             0.8055826098897335}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.462149662665384}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-7.1308988302963465`, 0.973049065692764}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.045554398052668, 0.8514321595256585}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 1.721515815839451}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.741256487054948, 
             2.1174596088673567`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3413209954771594`, 
             2.1174596088673567`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3180038323381698, 2.0731719286662407`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8500747011316276`, 2.0731719286662407`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             2.3243465847755584`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.0845133642886082`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-3.3524072174927233`, 1.497835735852798}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.612442421454399, 5.768320995793772}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0129050178795915`, 5.768320995793772}], 6.,
             
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.215506040139609}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7627116439458544, 1.6974487897568136`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.156840433948748, 1.6974487897568136`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.878196476740593, 
             1.7776605448485534`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.6888794541139363`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             1.8526977673331346`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.8805331812814825`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-5.2030071867437115`, 2.3933394562625097`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.9267273296385394`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.6960857191597725`, 6.907755278982137}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.196424897165655, 6.907755278982137}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.416581053724763}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2909841813155656`, 2.414126467726953}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.3998672158005996`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.800001029850119, 6.253828811575473}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8470607850131444`, 6.756932389247553}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346745988779815, 6.756932389247553}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6906479678596436`, 
             2.0681277817795625`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4903224315439383`, 
             2.0681277817795625`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.462149662665384}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.6623114020411685`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.286383733136742, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3688474475161698`, 
             2.3896797998449792`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1689274625831354`, 
             2.3896797998449792`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.5824869781268642`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.48175237628028356`, 
             8.122074375362217}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9816295731824954, 8.122074375362217}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.6474092888860916, 8.006367567650246}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.0475390184841091`, 8.006367567650246}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.6593256320844346, 7.944492163932159}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1593181637855046`, 7.944492163932159}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.4138711288901251`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.1136189934814222`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.7177975525570903`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.4179367056664534`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 1.133013715385442}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.613467558616262, 6.040254711277414}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.01348899514325, 6.040254711277414}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324790142551358`, 5.971261839790462}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132468797127462, 5.971261839790462}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.9165331609060323`, 4.787491742782046}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.216512196196308, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3482281603134343`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7004573108212688`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3799147541558516`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8799351601317804`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.536314386533157, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-8.412382827063892, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.9670073137609054`, 4.386889790339869}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.966857671750368, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.462149662665384}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9317114296555002`, 6.672032945461067}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316692464055834`, 6.672032945461067}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.0360274134764884`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.9334368907091256, 1.8389610707123492`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.703510521060178, 1.8389610707123492`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.1862091035211472, 2.423031246069913}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.282782465697866, 2.423031246069913}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8627499649461253, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0605908459024875`, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.9372477759766606`, 5.393627546352362}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.4371455863897404`, 5.393627546352362}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.21678878567620194`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.716864386545305, 4.386889790339869}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.359873830032749, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.159425367681418, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.004138294335951, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.703886158927249, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.3960099493374092, 6.984716320118266}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.7960662345677868, 6.984716320118266}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.894078619827491, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.49397078181451, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047875165492457`, 6.298949246855942}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.804781390061982, 6.298949246855942}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyUpTriangle]", {-1.05211045501669, 7.55171221535131}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.552112845814831, 7.55171221535131}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1409980051645476`, 
             2.1174596088673567`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9414202437824613`, 
             2.1174596088673567`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.5978370007556204, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.491779868965868}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.3281354469463584`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.7822140563845235`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.5902550930173265`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3617968895195032`, 1.9416152247724325`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.069887328875024, 1.9416152247724325`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.786359562282124, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-8.162319869424133, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.1269525243508878`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.807005375881994, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 1.1684492482568893`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4599740936085572, 2.004179057179289}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8461060995981784`, 2.004179057179289}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.101092789211817, 0.911479174876933}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.117766656001504, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.017939231019695, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.9910270779881722}], 6., 
            
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.735370011757173, 5.768320995793772}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.4354783156390294`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.103158068297152}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2262184132732556`, 6.104793232414985}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.725971728690052, 6.104793232414985}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.3027280306570521, 2.419478844465545}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.1733127572899065`, 2.419478844465545}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.4226262903672808`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5173146235582946`, 7.086737934510577}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.017406150760383, 7.086737934510577}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.599292605088321, 2.0719132752590443`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.571249159610065, 2.0719132752590443`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.3089630181835672`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.908846148194222, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 0.848868055556721}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.7147984280919266`, 1.726509584019938}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.9980550336767947}], 6., 
            
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.7837272975307907`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9306432380985556, 
             2.827905162910489}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7306413849875258, 
             2.827905162910489}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             2.330200260027019}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.8195418502405067`, 6.684611727667927}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.5191254931746836`, 6.684611727667927}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.606235808570649, 6.674561391814426}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2063088641234838`, 6.674561391814426}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2942622756733968`, 6.0867747269123065`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.694451286761057, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.2739976361421332`, 6.429719478039138}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.5740001929819547`, 6.429719478039138}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.5841201044498106`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.4911047254722358`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.764428382564909, 
             2.494031557565001}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5644645467913691`, 
             2.494031557565001}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.8146618624453594`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 0.7499999921527281}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.269044801069651, 
             2.3896797998449792`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.269044801069651, 
             2.3896797998449792`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5898688311064436, 2.506341930508065}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7120245012092015`, 2.506341930508065}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.7479817218821596`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8442026554799011, 1.7850704810772584`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9002402920947703`, 1.7850704810772584`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8997902134417601`, 6.704414354964107}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3993162819538174`, 6.704414354964107}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.462149662665384}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.110245660342752, 5.393627546352362}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.810369351701646, 5.393627546352362}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.2864827918762988, 7.24422751560335}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.3865452232556535, 7.24422751560335}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7048480972387587`, 1.8656293177945105`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.878625402249717, 1.8656293177945105`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.298317366548036, 2.0471765810925606`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.227106951818089}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.617843933216061, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.517955942272351, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.095273387402595}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3413209954771594`, 
             2.1174596088673567`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.741256487054948, 
             2.1174596088673567`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751531979714171, 5.8522024797744745`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.25165731439258, 5.8522024797744745`}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.6747180450915782, 2.58851563240702}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.462743533283297, 2.58851563240702}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 0.9707789171582248}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.659260036932778, 1.416581053724763}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 0.9654617758806044}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 1.416581053724763}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1184069159962893`, 
             2.1400661634962708`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9186841628017217`, 
             2.1400661634962708`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.4226262903672808`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.4753441779534016`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.725332537920259, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4118173183509766`, 1.5973653311998313`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7078502210995437`, 1.5973653311998313`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.497835735852798}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 2.424802725718295}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0700248318161971`, 
             2.58851563240702}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0700248318161971`, 
             2.58851563240702}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.246332151443247}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.2256240518579173`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.975391927697949, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.523226215615035}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.4135166537013273`, 6.040254711277414}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.213639558072954, 6.040254711277414}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.963188584855586}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             2.209811692841691}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324790142551358`, 5.971261839790462}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132468797127462, 5.971261839790462}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.900458886151396, 5.480638923341991}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3005870903313728`, 5.480638923341991}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1026203100656484`, 7.501082124259871}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6029589463363911`, 7.501082124259871}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.941966881801218, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.991862608772972, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2909841813155656`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8643301620628905`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-4.524512282970637, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.6788498758591209, 1.599387576580599}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.4370318346713713`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8470607850131444`, 6.756932389247553}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346745988779815, 6.756932389247553}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.251047211711865}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-0.3504089023600859, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-8.850570223130148, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.9754419516613513`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.225346881840062, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.4079456086518722`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0108761743640229`, 1.937301774518713}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.428942281870568, 1.937301774518713}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.6888794541139363`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7625890919282752`, 6.841615476477592}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262403303361214, 6.841615476477592}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2149273965428693, 2.519308076505333}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0612087734187763`, 2.519308076505333}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.340556469446037, 6.040254711277414}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7406861990440543`, 6.040254711277414}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.168283961917429, 2.0719132752590443`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0024805005437076`, 2.0719132752590443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.378751192832325, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.178596114669692, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[$CellContext`\[FivePointedStar], {-2.695775840226822, 
             5.991464547107982}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-3.2957568692041583`, 
             5.991464547107982}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.3504080825554816`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.462149662665384}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.491654876777717, 2.227106951818089}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.5978370007556204, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6266106567597011, 2.4265710727750367`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8350845939664286`, 2.4265710727750367`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5901256014017275`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0898959995836948`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 2.193662685769859}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.527397202097891, 7.076653815443951}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0272286702329017`, 7.076653815443951}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.2568373311553196`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.676945820702642, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 2.066736169182282}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.863232841258714, 0.8458682675776092}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.6407445017668969, 
             4.512945241945574}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.040959012419865, 
             4.512945241945574}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1230074455028314`, 2.1825620503943153`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.8269722249837996`, 2.1825620503943153`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             2.3243465847755584`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3478567954878509, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.399798360748448, 1.7833912195575383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.565421027017326, 
             2.0930978681273213`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.565421027017326, 
             2.0930978681273213`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 2.246332151443247}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.017383521085972, 0.7347688552507647}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-3.567015866357096, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-5.366810362993337, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2395270305647338, 1.4996230464268938`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-4.0757190980989355`, 1.4996230464268938`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.1498640059763816`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.049977288406387, 6.253828811575473}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2790527457537265, 1.864080130807681}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.3071607397357723`, 1.864080130807681}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-0.8505029913361519, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-8.350408373771412, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8566077297129814, 
             2.702032128776647}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0564152399683213`, 
             2.702032128776647}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-3.6888794541139363`, 2.3933394562625097`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.5978370007556204, 2.647592232065096}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.558002204858551}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-6.571283042360924, 1.7328937163610187`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.6744763086133228`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.238564249095555, 7.365180126021013}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7389772837890856`, 7.365180126021013}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5705756281717647, 1.7817091333745536`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1806171127511105`, 1.7817091333745536`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0189110419398038`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5188771693591536`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.6593256320844346, 6.721425700790643}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0592954262911594`, 6.721425700790643}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.4532518292447716`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-3.6888794541139363`, 2.9290581402859983`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.8940401229393353, 4.386889790339869}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-5.493845750829273, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.995732273553991, 1.2669476034873244`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1279381180499384`, 2.1174596088673567`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-1.95263269481614, 2.1174596088673567`}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.23395175003081314`, 7.146772179452637}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.6339353209280992, 7.146772179452637}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.369240606554063, 1.691939133945844}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5612262966614128`, 1.691939133945844}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.6854573524495757`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.4854489341097463`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.090999490513565}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.6409365794934714`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 1.2190584417439767`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.9569913819232716`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             2.1151705891340815`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8773173575897015`, 1.6114359150967734`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.215490386143112, 1.6114359150967734`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.7813228714636707, 7.822444729489319}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2815740503494875`, 7.822444729489319}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.064355904261795, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640797356921787`, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.215506040139609}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.7710464276305133`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 1.726509584019938}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.0935997468445653`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7573580425107227`, 1.589235205116581}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3789263262507685`, 1.589235205116581}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.6661962462527091`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3082228256997352`, 7.295735072749282}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.808498793232353, 7.295735072749282}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.2319770007355333`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5901256014017275`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0898959995836948`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.0102369597568726`, 5.393627546352362}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.9105241293044104`, 5.393627546352362}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.912572089444803, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-7.036270701217564, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.461401833606696}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.7378311272024993`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4375876555074412`, 2.0149030205422647`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8476951015583583`, 2.0149030205422647`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.785741396902492}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2262184132732556`, 6.104793232414985}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.725971728690052, 6.104793232414985}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.9368694044031642`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.820158943749753, 5.560681631015528}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.220083871482302, 5.560681631015528}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.4307829160924542, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.196377287787253, 1.0360274134764884`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.0181583132629375`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.117817918407743, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.068859330518762, 
             2.3896797998449792`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.468806782694355, 
             2.3896797998449792`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0177699008240089`, 6.363028103540465}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4179914478631452`, 6.363028103540465}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.469241281940817, 
             1.9892432737616872`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.869504817852908, 
             1.9892432737616872`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4728877844255986, 1.937301774518713}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.966950472128539, 1.937301774518713}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 1.1464496180822696`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5173146235582946`, 7.086737934510577}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.017406150760383, 7.086737934510577}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 2.293947899598382}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.6389967146756448`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[$CellContext`\[FivePointedStar], {-1.7672619976276676`, 
             4.386889790339869}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.166785108860756, 
             4.386889790339869}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.9058454740126164, 1.937301774518713}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5338868320097188`, 1.937301774518713}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.5960282255241827`, 6.907755278982137}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.296603021316498, 6.907755278982137}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 1.4964931534179662`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.8805331812814825`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6044503709230613`, 6.999422467507961}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 6.999422467507961}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.0678093795130645`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-3.166995202991212, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-5.767041814295392, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820086052689358`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1821389399181785`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.0261055978813616`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.926205565780978, 7.3777589082278725`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.795734531747094, 5.991464547107982}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1958919884778254`, 5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.527397202097891, 7.076653815443951}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0272286702329017`, 7.076653815443951}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8734707346912269, 6.507277712385012}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2736802167507564`, 6.507277712385012}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 1.9254158540407285`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.7817091333745536`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.5824869781268642`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.965852822566973}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             1.9313764735639716`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.362224007377702, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.57270299585059, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.6591800043289144`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.606941032235513, 1.7833912195575383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.1413169453979233`, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4184044150381243`, 
             2.1400661634962708`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6184786570862495`, 
             2.1400661634962708`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1644316297054034`, 
             2.494031557565001}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1644316297054034`, 
             2.494031557565001}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.746969987257452, 6.5337888379333435`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.3470736479666092`, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2669126040998102`, 4.386889790339869}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-7.666828609658249, 4.386889790339869}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.4890765557629164`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820086052689358`, 6.921658184151129}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1821389399181785`, 6.921658184151129}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 2.031563461435372}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.5774997570339834, 8.026170194946426}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.0776338822829181`, 8.026170194946426}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7565130561817651, 
             2.702032128776647}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1564532883579597`, 
             2.702032128776647}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 1.0360274134764884`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9192952408944538, 6.461468176353717}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3193836558372638`, 6.461468176353717}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.612442421454399, 5.768320995793772}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0129050178795915`, 5.768320995793772}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.26683423993894284`, 
             4.386889790339869}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.666853965970644, 
             4.386889790339869}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.493987758524193, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.894183087299815, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.835485924411894, 5.768320995793772}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.3354096411241523`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.0365602553118024, 7.24422751560335}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.636577829072051, 7.24422751560335}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-5.298317366548036, 2.0471765810925606`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.42266213293668586`, 2.418588768750352}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0549440700794483`, 2.418588768750352}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 0.8060293376166178}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 2.2976730486330252`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 0.9925107577855641}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.4971646699513146`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.48175237628028356`, 1.8625285401162623`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.107781777362614, 1.8625285401162623`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.836849948493799, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.0968250627658085`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.1637756145745228`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.4312677267626217`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.257346872655708, 2.0028304393079956`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0514564223263525`, 2.0028304393079956`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.640548907459153}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5561717255328675, 1.864080130807681}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.030116700415822, 1.864080130807681}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.5338519254775054`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.793961892783255, 5.537334267018537}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.2936253516225737`, 5.537334267018537}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.4146388341290332`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 1.0360274134764884`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.6305480388034254, 
             2.827905162910489}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0305798782762827`, 
             2.827905162910489}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4947708374559745`, 5.886104031450156}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8951219822232084`, 5.886104031450156}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.1921026317554486`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.715777948205427}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.887460350206278, 
             2.3711778844596574`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6873994539038122`, 
             2.3711778844596574`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.3649243353836982`, 5.966146739123692}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.864975531559314, 5.966146739123692}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2437536743377806`, 7.360103972989152}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.744112815760702, 7.360103972989152}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.993630885266725, 5.537334267018537}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.0939462278827174`, 5.537334267018537}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1026203100656484`, 7.501082124259871}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6029589463363911`, 7.501082124259871}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.273910668367863, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-6.113858195322049, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2010151992412087, 2.0082140323914683`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0971007679422797`, 2.0082140323914683`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.6304163188192922`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.186787979571835, 1.7833912195575383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5608378214218233`, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.293947899598382}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.196377287787253, 0.8060293376166178}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             2.2086040295231517`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.9205497887945385, 7.783224016336037}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.2207799226423173`, 7.783224016336037}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.9390477189967712, 2.414126467726953}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5474025215146479`, 2.414126467726953}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.6661962462527091`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.215506040139609}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.896419739771488}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.279055610450292, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.402871609042948, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8689301605143175, 
             2.3896797998449792`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6691879168398742`, 
             2.3896797998449792`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1702157075278026`, 7.433666540166168}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6702500518308578`, 7.433666540166168}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7832907304129113, 2.0068708488450007`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.517264565896126, 2.0068708488450007`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 2.1872864686305826`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.864704011147587, 1.0732944806838198`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 1.191191469961203}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.694451286761057, 
             2.1644717908644115`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2942622756733968`, 
             2.1644717908644115`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1150465951315345`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6149530931222105`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.348592493935879}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.7929254558680243`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.6593256320844346, 6.721425700790643}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0592954262911594`, 6.721425700790643}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.1866231659908228`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 1.0868770324496888`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.2669476034873244`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3426311639367969, 1.8656293177945105`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.2406103170142067`, 1.8656293177945105`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.552112845814831, 5.8289456176102075`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9519282213808764`, 5.8289456176102075`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.746403767507258, 5.634789603169249}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1464364105041143`, 5.634789603169249}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.795734531747094, 
             5.991464547107982}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-3.1958919884778254`, 
             5.991464547107982}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.5257286443082556`, 6.461468176353717}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 2.209811692841691}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.8002235476401844`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751531979714171, 5.8522024797744745`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.25165731439258, 5.8522024797744745`}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.168928708181372, 5.111987788356544}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.768756076219605, 5.111987788356544}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-2.214574215671332, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.004138294335951, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2149273965428693, 1.937301774518713}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.224893897193764, 1.937301774518713}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-1.491654876777717, 0.849723487602042}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.4286713586629105`, 5.075173815233827}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.12893600699172, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3874950816964096`, 
             2.3711778844596574`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1874435023747254`, 
             2.3711778844596574`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.031563461435372}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.6661962462527091`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6240440648234626`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-4.76404869105558, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.389499492068839, 5.991464547107982}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 5.991464547107982}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6184786570862495`, 
             2.1400661634962708`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4184044150381243`, 
             2.1400661634962708`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0189110419398038`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5188771693591536`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.7268653293100646`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-1.491654876777717, 2.073423469354273}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.987249820814649, 
             2.3711778844596574`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5876764206525877`, 
             2.3711778844596574`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.362224007377702, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.57270299585059, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.7199019178687649, 7.8838232148921525`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2201021862558195`, 7.8838232148921525`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.612442421454399, 5.768320995793772}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0129050178795915`, 5.768320995793772}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.4753441779534016`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.725332537920259, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5473167323484057, 1.9358598132018119`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8953440995227226`, 1.9358598132018119`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6005679992668521, 1.4996230464268938`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.7148128361404407`, 1.4996230464268938`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4082690354408987, 1.860974538249528}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.184232881424661, 1.860974538249528}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-7.418747583305227, 1.7328937163610187`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.0841264243165862`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.304161419150561, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.605170185988091, 2.3933394562625097`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.6354040111173562`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.5356434782150785`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-4.2845370133966245`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[$CellContext`\[FivePointedStar], {-1.3716028123769008`, 
             2.187174241482718}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5716605481000705`, 
             2.187174241482718}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 1.599387576580599}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.563430511492267, 6.040254711277414}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.0635829404621653`, 6.040254711277414}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3329431856228962`, 
             2.425687290128029}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.132893222644984, 
             2.425687290128029}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.21927603978772048`, 1.860974538249528}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.3731931852525583`, 1.860974538249528}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             0.8977193462887197}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.4915548717773834`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 
             1.0420419371797154`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 0.9669838461896731}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.199705077879927, 0.755182571479398}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1702157075278026`, 7.433666540166168}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6702500518308578`, 7.433666540166168}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2371849385320495`, 1.9401794743463283`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.197324582336553, 1.9401794743463283`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1080567474961094`, 6.272877006546167}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5082360319251331`, 6.272877006546167}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.1625110145183415`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-7.786268646522262, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7650729201315343, 2.0731719286662407`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.403068631572368, 2.0731719286662407`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 1.416581053724763}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3893457262282811, 2.0068708488450007`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.91139112512024, 2.0068708488450007`}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.2072749131897207`, 6.396929655216146}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706800981701778, 6.396929655216146}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.3498863661120586`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.8499018253424513`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1880994551696458`, 2.3850863145057892`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3563472847519384`, 2.3850863145057892`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5901256014017275`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0898959995836948`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.2672179491567546`, 
             4.386889790339869}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-6.667164814064207, 
             4.386889790339869}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.809142990314028, 1.2424239907001886`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.3204807842031671, 6.960347729101308}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.9205497887945385, 6.960347729101308}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.7083778602890038`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.9910142780700916, 7.6128310304073565`}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4912105310694506`, 
             7.6128310304073565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820086052689358`, 6.921658184151129}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1821389399181785`, 6.921658184151129}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 2.330200260027019}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             1.8002235476401844`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.3149043650332175`, 5.966146739123692}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.9146052992269007`, 5.966146739123692}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3082228256997352`, 7.295735072749282}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.808498793232353, 7.295735072749282}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.46298829435183064`, 6.81783057145415}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.063052113269559, 6.81783057145415}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.8906229851255774, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.4907663827166018`, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.4886252922173524`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.22276862160913655`, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.525061368884541, 1.7833912195575383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 2.090999490513565}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3678803477808931, 1.4973884086254774`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.9518038754399907`, 1.4973884086254774`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.424802725718295}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3082228256997352`, 7.295735072749282}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.808498793232353, 7.295735072749282}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.41779075779880137`, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-5.717779984300055, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 6.684611727667927}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.863232841258714, 1.007592890280941}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.66442222076686, 6.939253946041508}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164563795096671, 6.939253946041508}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.719319793360441}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6548884684428551, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0929041853062644`, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.6378309869353183`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.028748427364318, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.653113060608557, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.462149662665384}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-6.571283042360924, 2.0471765810925606`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.377692565480851}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7813228714636707, 7.822444729489319}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2815740503494875`, 7.822444729489319}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.8470364847178946`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.5338519254775054`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.174191878225647, 6.429719478039138}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.674083651538937, 6.429719478039138}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2783372196147982`, 1.864080130807681}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.308100273682156, 1.864080130807681}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6734432424100127`, 1.691939133945844}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.2576117273513145`, 1.691939133945844}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6977577931176286, 2.4265710727750367`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7637552728184576`, 2.4265710727750367`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.4018530946527146`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.532062329207643, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.3540294005326152`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.8058680506240641, 1.937301774518713}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6338708029279587`, 1.937301774518713}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8644101099971662, 
             2.494031557565001}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4644721421839146`, 
             2.494031557565001}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8238695231462887`, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0996442489973552`, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-3.366795954944823, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-5.566981433164056, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.5920892740994874`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.341928551227046, 4.386889790339869}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 0.9654617758806044}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             0.8977193462887197}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.462149662665384}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6044503709230613`, 6.999422467507961}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 6.999422467507961}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 0.911479174876933}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8016236568960291, 6.579251212010101}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2016421889876536`, 6.579251212010101}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1026203100656484`, 7.501082124259871}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6029589463363911`, 7.501082124259871}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8598242001421843`, 5.521460917862246}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2595256035335987`, 5.521460917862246}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.9317114296555002`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316692464055834`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820086052689358`, 6.921658184151129}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1821389399181785`, 6.921658184151129}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.238564249095555, 7.365180126021013}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7389772837890856`, 7.365180126021013}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4460443655256647`, 7.157735484249907}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.946310229076653, 7.157735484249907}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7797949872856175, 1.6034198401085373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.327853987437946, 1.6034198401085373`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.0654001544619962`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 2.044332364566268}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5413120833865, 
             2.1174596088673567`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5413120833865, 
             2.1174596088673567`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9712750402069146, 7.6324011266014535`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4714166145367258`, 7.6324011266014535`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4653375684603434`, 
             2.0930978681273213`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6654793033177253`, 
             2.0930978681273213`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.199705077879927, 2.0471765810925606`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.836849948493799, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.0968250627658085`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.880084850028029, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.380218975276964, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.0218709311636855`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.911914268349973, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             1.5904589458362974`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.552112845814831, 5.8289456176102075`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9519282213808764`, 5.8289456176102075`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.4338645826298623, 6.946975992135418}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8337895103624113, 6.946975992135418}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.1499389158334503`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.7254100886865211`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.475327636634016, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3118381623295401, 2.6993457604720636`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6039529822035308`, 2.6993457604720636`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.2072749131897207`, 1.726509584019938}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5015355768588979, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.421604191439818, 1.6956156086751528`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             0.9411784473819341}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8470607850131444`, 6.756932389247553}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346745988779815, 6.756932389247553}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             1.0511712140679732`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 1.7268653293100646`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.6409365794934714`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.5978370007556204, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.746403767507258, 5.634789603169249}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1464364105041143`, 5.634789603169249}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6939993778795506`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.694093021166824, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8470607850131444`, 6.756932389247553}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346745988779815, 6.756932389247553}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.4722426732562555`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4361820807702249, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.612240146256234, 2.1329823086078656`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2909841813155656`, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4524341636244356`, 7.151485463904735}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.95263269481614, 7.151485463904735}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.090999490513565}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.4307829160924542, 2.187398683184928}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.8122154777954373`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.7042981934580606`, 
             4.386765389021055}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.683996966534062, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-4.8283137373023015`, 2.0471765810925606`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 1.0360274134764884`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-0.3504089023600859, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-8.850570223130148, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.0335402919243948`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4524341636244356`, 7.151485463904735}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.95263269481614, 7.151485463904735}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2069773133462347`, 6.173786103901937}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.606941032235513, 6.173786103901937}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.191191469961203}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-4.045554398052668, 1.0335402919243948`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.4964931534179662`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.66442222076686, 6.939253946041508}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164563795096671, 6.939253946041508}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4943251053335957`, 
             2.1644717908644115`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4943251053335957`, 
             2.1644717908644115`}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 1.900464386136271}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.101092789211817, 0.7802418874108791}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.2568373311553196`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.676945820702642, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.071483621279857, 
             2.187174241482718}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8714522381373035`, 
             2.187174241482718}], 4., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.4122057429043917`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.7859090555498793`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.491654876777717, 2.090999490513565}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1702157075278026`, 7.433666540166168}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6702500518308578`, 7.433666540166168}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9038682118755978, 6.476972362889683}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3037931396081468`, 6.476972362889683}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.449925680892755, 6.253828811575473}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.7499665442035015`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.2742448573112677`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.68510181635509}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3138891646209549, 2.5862591440482876`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.82821600623867, 2.5862591440482876`}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.294616923344869, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-4.0941445822194344`, 4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2496677635880655`, 6.131226489483141}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6497392092076262`, 6.131226489483141}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7168253079145225, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.2170885989659, 4.386889790339869}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.746403767507258, 5.634789603169249}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1464364105041143`, 5.634789603169249}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.4179914478631452`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.7177791303707455`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1702157075278026`, 7.433666540166168}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6702500518308578`, 7.433666540166168}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.3799147541558516`, 7.22402480828583}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.8799351601317804`, 7.22402480828583}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.527397202097891, 7.076653815443951}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0272286702329017`, 7.076653815443951}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1270117631898076`, 6.253828811575473}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5269366909223567`, 6.253828811575473}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.8540604954254345`, 5.676753802268282}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.9540431322855023`, 5.676753802268282}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.5978370007556204, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.2246985543369746`, 6.429719478039138}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.6240307955986357`, 6.429719478039138}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.8056623743970464`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.5129946410508307, 6.81783057145415}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.013077000561847, 6.81783057145415}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.4018530946527146`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.532062329207643, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 2.556451816951096}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.793961892783255, 5.537334267018537}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.2936253516225737`, 5.537334267018537}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.557794679282262, 1.8687205103641833`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.019664337643975, 1.8687205103641833`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3082228256997352`, 7.295735072749282}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.808498793232353, 7.295735072749282}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.47352983902229373`, 2.599722324216582}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6414447085691868`, 2.599722324216582}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.1499389158334503`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7625890919282752`, 6.841615476477592}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262403303361214, 6.841615476477592}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.5366522427084526`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-7.412267540691536, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.007592890280941}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.719252778441307, 6.684611727667927}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.6190782472999463`, 6.684611727667927}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 2.075684492802124}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3799147541558516`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8799351601317804`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.2909841813155656`, 2.187398683184928}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.6888794541139363`, 0.8505781885087738}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 2.0719132752590443`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.6888794541139363`, 0.7485818874480459}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.2919836816486494`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.0942695392339727`}], 
            9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.2919836816486494`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.1627481478062465`}], 8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.131032179924221, 6.249975242259483}], 
            13., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.531088946023124, 6.249975242259483}], 
            13., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3645328693383778`, 
             2.494031557565001}], 8., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.96443110720209, 
             2.494031557565001}], 8., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1150465951315345`, 7.488852955733459}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6149530931222105`, 7.488852955733459}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8805331812814825`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.5338519254775054`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.1589994386832048`, 4.386765389021055}], 
            9., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledDiamond]", {-5.058828136697741, 4.386765389021055}],
             9., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.1413169453979233`, 
             4.512945241945574}], 8., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-6.541030999190403, 
             4.512945241945574}], 8., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 1.416581053724763}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8805331812814825`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 
             1.6378309869353183`}], 8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-0.8344803566765893, 2.131796772013764}],
             10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.2164073967529934`, 2.131796772013764}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.0215475632609334`}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.4722426732562555`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.9510398268753117`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.090999490513565}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-0.5178502387029551, 4.512945241945574}], 
            10.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-5.61797181824309, 4.512945241945574}], 
            10.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-4.15218556191195, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-4.781788039865368, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.9296292963133357, 7.674152921281675}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4296194858582643`, 7.674152921281675}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4088348928367562`, 4.386765389021055}], 
            9., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledDiamond]", {-3.809015255353917, 4.386765389021055}],
             9., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-4.3428059215206005`, 
             2.6490076604684267`}], 11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.0215475632609334`}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.002290482491421}], 11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8805331812814825`}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.96443110720209, 
             2.494031557565001}], 8., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3645328693383778`, 
             2.494031557565001}], 8., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.3540294005326152`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.4964931534179662`}],
             10.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1026203100656484`, 7.501082124259871}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6029589463363911`, 7.501082124259871}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.5895081458004594, 6.7912214627261855`}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9896682016789307, 6.7912214627261855`}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.49331319868135953`, 2.4239173781615704`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.973281345851445, 2.4239173781615704`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 0.7485818874480459}], 9., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.26683423993894284`, 
             4.386889790339869}], 8., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.666853965970644, 
             4.386889790339869}], 8., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.599387576580599}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8805331812814825`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9317114296555002`, 1.534714366238164}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3134438363289216`, 1.534714366238164}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.9510398268753117`}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.8805331812814825`}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.2299329059954676`}], 11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 1.506518858426259}], 
            8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.2319770007355333`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.087375656742122, 
             2.3711778844596574`}], 8., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4876628555081794`, 
             2.3711778844596574`}], 8., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5213811377055073, 2.0719132752590443`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-2.64930970607961, 2.0719132752590443`}],
             10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.0598714603516792`}], 8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 0.849723487602042}], 
            9., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 
             2.1627481478062465`}], 8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.340512168464763}], 12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2303167796655379`, 1.691939133945844}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7002308520500784`, 1.691939133945844}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.516892795645856, 6.0867747269123065`}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.016955910005618, 6.0867747269123065`}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.2672179491567546`, 4.386889790339869}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledCircle]", {-6.667164814064207, 4.386889790339869}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 
             1.7693434299437227`}], 8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6713133161521878`, 
             2.187174241482718}], 8., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.271538123821702, 
             2.187174241482718}], 8., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.9510398268753117`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1080567474961094`, 6.272877006546167}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5082360319251331`, 6.272877006546167}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             1.2172838183856083`}], 11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7969533492855345, 6.5337888379333435`}], 
            13., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2971851860481147`, 6.5337888379333435`}], 
            13., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.7199019178687649, 7.8838232148921525`}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2201021862558195`, 7.8838232148921525`}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111964733385396, 6.492239835020471}], 
            8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6115589009134488`, 6.492239835020471}],
             8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.599387576580599}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.7406415980494447`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.036482917202561, 7.56734567601324}], 
            8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5366522427084526`, 7.56734567601324}], 
            8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.8643901602629624`}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.659260036932778, 1.0845133642886082`}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.659260036932778, 1.1637756145745228`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.539739633930633, 2.5974910105351463`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.579879110192556, 2.5974910105351463`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6424777665123005`, 
             2.0162354657760435`}], 8., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6424777665123005`, 
             2.0162354657760435`}], 8., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.8438952236485835`, 5.537334267018537}],
             13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.2433732333621994`, 5.537334267018537}],
             13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.9510398268753117`}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.0497721232486361`}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.2975725511705014`}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.8056623743970464`}], 8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.5338519254775054`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7199019178687649, 
             7.8838232148921525`}], 8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2201021862558195`, 
             7.8838232148921525`}], 8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.1637756145745228`}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.924832423452417}], 
            9., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.7406415980494447`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.8699543168131119`}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2739976361421332`, 5.2574953720277815`}], 
            13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.030860186617291, 6.249975242259483}], 
            13., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.3732221725934863`, 5.2574953720277815`}], 
            13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.6311724045801064`, 6.249975242259483}],
             13., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-0.4203757208439185, 6.960347729101308}], 
            13., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-0.8205261098897758, 6.960347729101308}], 
            13., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0189110419398038`, 6.584791392385716}],
             8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5188771693591536`, 6.584791392385716}],
             8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 1.7268653293100646`}], 
            10.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.66442222076686, 6.939253946041508}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164563795096671, 6.939253946041508}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.1167795926235586`}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.9510398268753117`}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1026203100656484`, 7.501082124259871}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6029589463363911`, 7.501082124259871}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.9368694044031642`}], 8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.1587147225743437`}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-3.816258383443767, 4.787491742782046}], 
            9., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-4.3162388941358785`, 4.787491742782046}],
             9., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.2975725511705014`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.1990607599649155`}], 8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7505644514298959, 2.5817308344235403`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4007990473227723`, 2.5817308344235403`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.599387576580599}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.0215475632609334`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0918353043890858`, 
             4.386889790339869}], 8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.84195543139986, 4.386889790339869}], 
            8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324790142551358`, 5.971261839790462}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132468797127462, 5.971261839790462}], 
            8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.064355904261795, 6.539585955617669}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640797356921787`, 6.539585955617669}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.3540294005326152`}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.7062324201086008, 6.674561391814426}], 
            13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.1062413158326008`, 6.674561391814426}],
             13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.6108369333478076`}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-0.9958752112169974, 1.599387576580599}],
             10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1199358770132974`, 1.599387576580599}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.9510398268753117`}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 1.599387576580599}],
             10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.900464386136271}], 8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-7.600902459542082, 1.2424239907001886`}],
             9., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-0.8027388571900397, 2.58851563240702}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-0.1454883067486056, 2.432735777459091}],
             10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-1.3348410795309749`, 2.58851563240702}],
             10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-2.30348549823721, 2.432735777459091}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyUpTriangle]", {-1.05211045501669, 7.55171221535131}],
             11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.552112845814831, 7.55171221535131}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.6587993419718245`}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-4.017383521085972, 0.8385453832493022}], 12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.1587147225743437`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-1.974001029221839, 6.429719478039138}], 
            9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-2.874045755297392, 6.429719478039138}], 
            9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-1.9754419516613513`, 4.386889790339869}], 12., 
            
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-7.225346881840062, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2069773133462347`, 6.173786103901937}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.606941032235513, 6.173786103901937}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5173146235582946`, 7.086737934510577}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.017406150760383, 7.086737934510577}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2063088641234838`, 
             2.3523271848888596`}], 8., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.40649706843741, 
             2.3523271848888596`}], 8., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.271538123821702, 
             2.187174241482718}], 8., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6713133161521878`, 
             2.187174241482718}], 8., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-1.527397202097891, 7.076653815443951}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0272286702329017`, 7.076653815443951}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.9510398268753117`}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.9510398268753117`}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.458005208673891, 5.823045895483019}], 
            13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.0580715159436433`, 5.823045895483019}],
             13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.6544352783648362`, 5.676753802268282}],
             13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.1541650878757723`, 5.676753802268282}],
             13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.49314943875304795`, 6.887552571664617}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8933068954837797, 6.887552571664617}],
             12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.5077842587076005`, 5.823045895483019}],
             13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.007679175452945, 5.823045895483019}], 
            13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8997902134417601`, 6.704414354964107}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3993162819538174`, 6.704414354964107}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.659260036932778, 1.0845133642886082`}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.406587064387653}], 12., 
            
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1702157075278026`, 7.433666540166168}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6702500518308578`, 7.433666540166168}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             1.5904589458362974`}], 8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-1.389499492068839, 5.991464547107982}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 5.991464547107982}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.880084850028029, 5.723585101952381}], 
            8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.380218975276964, 5.723585101952381}], 
            8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.5338519254775054`}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.3540294005326152`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.7406415980494447`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.23876493221716663`, 1.601405740736836}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-3.872802292274865, 1.601405740736836}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.090999490513565}],
             7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 2.1122716862705384`}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {43.533197060661976`, 4.386889790339869}], 
            13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-52.467202900682494`, 4.386889790339869}],
             13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-1.6623114020411685`, 4.512945241945574}],
             10.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-7.286383733136742, 4.512945241945574}], 
            10.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.152962883418191, 4.512945241945574}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.5287678617828835`, 
             4.512945241945574}], 8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.7847348542910906`}], 
            9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.27128392664214473`, 1.9358598132018119`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.171276846068922, 1.9358598132018119`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-1.1177951080848836`, 4.512945241945574}],
             10.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-5.017810977845351, 4.512945241945574}], 
            10.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6044503709230613`, 6.999422467507961}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.104554242494911, 6.999422467507961}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 0.898534010284896}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.5554040239416147`}], 11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             0.761739972025557}], 11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2437536743377806`, 7.360103972989152}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.744112815760702, 7.360103972989152}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8122154777954373`}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2409826299598365`, 
             2.1174596088673567`}], 8., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8413699697813894`, 
             2.1174596088673567`}], 8., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.8118888405232207`}], 11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820086052689358`, 6.921658184151129}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1821389399181785`, 6.921658184151129}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.376740148315079, 7.226936018493289}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8773173575897015`, 7.226936018493289}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.2809338454620642`}], 8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             2.078566158643882}], 8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.7693434299437227`}], 8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-1.0498221244986778`, 2.647592232065096}],
             10.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9840343839606746, 6.396929655216146}],
             12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3838972365201692`, 6.396929655216146}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 1.416581053724763}],
             10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.1151415906193203`}], 11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.0215475632609334`}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.1975522365230131`}], 11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.18260159600127354`, 2.136530508663963}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8587568185269134`, 2.136530508663963}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8122154777954373`}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7789229575813493, 
             4.512945241945574}], 8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.902818692021688, 4.512945241945574}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.2919836816486494`}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.2919836816486494`}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             1.3302529702362658`}], 8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.1587147225743437`}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-1.2862680470527663`, 4.512945241945574}], 12., 
            
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-7.662352421858305, 4.512945241945574}], 12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-7.523941418405954, 1.497835735852798}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 
             1.3754861624032872`}], 8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             2.6397713603489157`}], 8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.6526889544284153`}], 11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.2975725511705014`}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 1.671097292820828}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.4342248948774405`, 
             4.386765389021055}], 8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.95401869367736, 4.386765389021055}], 
            8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.4307829160924542, 1.726509584019938}], 
            13., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {45.533180029480455`, 4.386889790339869}], 
            13., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-54.46678982836, 4.386889790339869}], 13., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-2.2256240518579173`, 4.386889790339869}], 12., 
            
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-6.975391927697949, 4.386889790339869}], 12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.2975725511705014`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.2319770007355333`}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-2.3025850929940455`, 6.684611727667927}],
             9., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.227106951818089}],
             10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-4.017383521085972, 0.986935571443487}], 12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8470607850131444`, 6.756932389247553}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346745988779815, 6.756932389247553}], 
            8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.19455609446229716`, 2.0706530356467567`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9784819201474635`, 2.0706530356467567`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.100426344668657, 4.386889790339869}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.100386954332169, 4.386889790339869}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.594056810395798, 
             2.1644717908644115`}], 8., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3943265328171548`, 
             2.1644717908644115`}], 8., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-1.0177699008240089`, 4.512945241945574}],
             10.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-5.117830825699811, 4.512945241945574}], 
            10.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1150465951315345`, 7.488852955733459}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6149530931222105`, 7.488852955733459}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.5978370007556204, 2.647592232065096}], 
            13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 2.090999490513565}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.6661962462527091`}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.3964921860963366`}], 11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-1.1625110145183415`, 4.512945241945574}], 12., 
            
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-7.786268646522262, 4.512945241945574}], 12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4571461020918417`, 1.4883995840570443`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8807977354618917`, 1.4883995840570443`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 0.9666035457477442}], 
            9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0564152399683213`, 
             2.702032128776647}], 8., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8566077297129814, 
             2.702032128776647}], 8., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6044503709230613`, 6.999422467507961}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.104554242494911, 6.999422467507961}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.506518858426259}], 8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-0.6529653909271136, 2.506341930508065}],
             10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7448616162466241, 1.7833912195575383`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6492187824459448`, 2.506341930508065}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0027568884909557`, 1.7833912195575383`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.9510398268753117`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-5.298317366548036, 2.6490076604684267`}],
             9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-4.15218556191195, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-4.781788039865368, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[CircleMinus]", {-7.1308988302963465`, 1.7328937163610187`}], 
            9., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-1.340556469446037, 6.040254711277414}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7406861990440543`, 6.040254711277414}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-1.493879571799828, 4.386889790339869}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-4.893919494400295, 4.386889790339869}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.4920048155420047`}], 
            9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-0.8763491247812073, 2.503891949699081}],
             10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4304552569056603`, 2.503891949699081}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8122154777954373`}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.9510398268753117`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.1603343472961065`}], 8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.4722426732562555`}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-1.2255369822417765`, 4.386889790339869}], 12., 
            
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-7.975450465015525, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.0215475632609334`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.3420861064555702`, 
             4.386889790339869}], 8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.5919427181706105`, 
             4.386889790339869}], 8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.6936470556015963}], 12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.2919836816486494`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 0.9666035457477442}], 9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 1.4964931534179662`}],
             10.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.542246662893777, 
             2.0162354657760435`}], 8., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.742398039690331, 
             2.0162354657760435`}], 8., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.227106951818089}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 1.416581053724763}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.2919836816486494`}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.7535382564078572`}], 11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             0.9345235001352147}], 8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5716605481000705`, 
             2.187174241482718}], 8., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3716028123769008`, 
             2.187174241482718}], 8., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0186003506987251`, 2.4176979000945504`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4605869657017456`, 2.4176979000945504`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4983438649285135`, 
             1.9600947840472698`}], 8., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.898454207899018, 
             1.9600947840472698`}], 8., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-7.600902459542082, 1.445270566220188}], 
            9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.316022308134559, 
             2.0425181875752383`}], 8., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.915963072687361, 
             2.0425181875752383`}], 8., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.6661962462527091`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2740421867477461, 2.5771819258971713`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8865098057738656`, 2.5771819258971713`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.6661962462527091`}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-2.693851481702397, 4.386889790339869}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-3.694093021166824, 4.386889790339869}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.2975725511705014`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.5338519254775054`}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8426317996018116`, 
             2.0162354657760435`}], 8., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4422299934501939`, 
             2.0162354657760435`}], 8., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-2.317800258800526, 4.512945241945574}], 
            10.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-3.8180773925856184`, 4.512945241945574}],
             10.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9712750402069146, 7.6324011266014535`}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4714166145367258`, 7.6324011266014535`}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.0935997468445653`}], 
            9., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7625890919282752`, 6.841615476477592}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262403303361214, 6.841615476477592}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8997902134417601`, 6.704414354964107}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3993162819538174`, 6.704414354964107}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-0.8563722416629115, 6.674561391814426}], 
            13., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-0.9563317814113389, 6.674561391814426}], 
            13., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8122154777954373`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-0.617854196524514, 4.512945241945574}], 
            10.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-5.51796702860799, 4.512945241945574}], 
            10.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.227106951818089}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.090999490513565}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-2.6218266343535928`, 4.386889790339869}], 12., 
            
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-6.312220927289192, 4.386889790339869}], 12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8122154777954373`}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 0.7485818874480459}], 9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 0.9345235001352147}], 
            8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7912011210353335, 1.4951487660319727`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.5332441625824873`, 1.4951487660319727`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7168253079145225, 
             4.386889790339869}], 8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.2170885989659, 4.386889790339869}], 
            8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.2319770007355333`}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 1.4964931534179662`}], 
            10.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8821308802274503, 2.0082140323914683`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.4159777803491362`, 2.0082140323914683`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.7406415980494447`}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             1.9838938336679197`}], 8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             1.721694594779768}], 8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             1.8526977673331346`}], 8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             0.7975071958841882}], 8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0891571298973546`, 2.0082140323914683`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.209094749906707, 2.0082140323914683`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8122154777954373`}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.1587147225743437`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.2975725511705014`}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            11.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 0.848868055556721}], 
            9., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.3282528397426234`}], 11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.1587147225743437`}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9065879564127699, 7.697121317282625}], 
            8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.406905315024015, 7.697121317282625}], 
            8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-0.9122987106046175, 4.512945241945574}], 12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-8.036311444023319, 4.512945241945574}], 12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.528780009416646, 4.512945241945574}],
             8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.152761077153482, 4.512945241945574}],
             8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.279055610450292, 2.0731719286662407`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8891518152367044`, 2.0731719286662407`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.3749057545736716`}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.2166915767337108`}], 
            9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-3.522010001878903, 4.386889790339869}], 12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-5.411934093335004, 4.386889790339869}], 12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-1.919365593833201, 6.684611727667927}], 
            9., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-2.419118909249997, 6.684611727667927}], 
            9., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.9510398268753117`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             2.193662685769859}], 8.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-0.3678803477808931, 2.421256622711544}],
             10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-2.104554242494911, 2.421256622711544}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.2975725511705014`}], 
            7.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.7406415980494447`}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 2.28401370740861}], 9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.36154392105023625`, 2.599722324216582}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7538858167999734`, 2.599722324216582}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-1.036482917202561, 4.512945241945574}], 12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-7.912330925723864, 4.512945241945574}], 12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4405393759722864`, 5.940171252720432}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8407396514497736`, 5.940171252720432}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5228016057745537`, 5.857933154483459}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-1.922779731666459, 5.857933154483459}], 
            12., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.7406415980494447`}], 
            10., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 1.506518858426259}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.5299617109323036`}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.2975725511705014`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-2.0241960674538575`, 6.429719478039138}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-2.823966230699553, 6.429719478039138}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-1.238564249095555, 7.365180126021013}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7389772837890856`, 7.365180126021013}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1026203100656484`, 2.2648832258100344`}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.6825463842547386`, 2.2648832258100344`}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820086052689358`, 6.921658184151129}],
             8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1821389399181785`, 6.921658184151129}],
             8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-1.7867719277170158`, 4.512945241945574}],
             10.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-7.1622605067393605`, 4.512945241945574}],
             10.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.2919836816486494`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.4395981331422016`}], 11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-1.527397202097891, 7.076653815443951}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0272286702329017`, 7.076653815443951}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2569588998089404, 2.0731719286662407`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9110235456270366`, 2.0731719286662407`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.599387576580599}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3039860739096736`, 4.386765389021055}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-4.083998270167957, 4.386765389021055}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-3.941966881801218, 4.386889790339869}], 12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[Times]", {-4.991862608772972, 4.386889790339869}], 12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6044503709230613`, 6.999422467507961}],
             8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 6.999422467507961}], 
            8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.15455075984859803`, 2.5756610130564646`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0091694886945044`, 2.5756610130564646`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[Times]", {-2.540842282118304, 4.512945241945574}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-6.140893060599911, 4.512945241945574}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1026203100656484`, 7.501082124259871}],
             8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6029589463363911`, 7.501082124259871}],
             8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.238564249095555, 7.365180126021013}], 
            8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7389772837890856`, 7.365180126021013}],
             8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.1637756145745228`}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5059792040658704`, 2.0843046973458237`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6398971199188088`, 2.0843046973458237`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-8.532306829226286, 1.2424239907001886`}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9712750402069146, 
             7.6324011266014535`}], 8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4714166145367258`, 
             7.6324011266014535`}], 8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9712750402069146, 7.6324011266014535`}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4714166145367258`, 7.6324011266014535`}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1796054478776414`, 7.424165281042028}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6798603767306461`, 7.424165281042028}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.0808706071919527`, 6.249975242259483}],
             13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.5808504555821878`, 6.249975242259483}],
             13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.3540294005326152`}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.416581053724763}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6044503709230613`, 6.999422467507961}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.104554242494911, 6.999422467507961}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledSquare]", {-0.4338645826298623, 1.601405740736836}],
             10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.6777417097034806`, 1.601405740736836}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.4569857892424236`}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6044503709230613`, 6.999422467507961}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 6.999422467507961}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6622300779252237, 2.1329823086078656`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3861841168703593`, 2.1329823086078656`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-1.0891571298973546`, 6.29156913955832}],
             12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-1.489435120039404, 6.29156913955832}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-5.298317366548036, 2.6490076604684267`}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.640928579525471, 
             4.512945241945574}], 8., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.040829633207479, 
             4.512945241945574}], 8., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 1.3480731482996928`}], 
            9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.8069317506623275`, 4.386765389021055}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.4109447331170353`, 4.386765389021055}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.708153885373258, 5.823045895483019}], 
            13., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.8078888511579385`, 5.823045895483019}],
             13., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.4911047254722358`}], 
            9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.9521761906339596`}], 11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.6661962462527091`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1026203100656484`, 7.501082124259871}],
             8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6029589463363911`, 7.501082124259871}],
             8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 0.8060293376166178}], 
            10.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.238564249095555, 7.365180126021013}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7389772837890856`, 7.365180126021013}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8470607850131444`, 6.756932389247553}],
             8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346745988779815, 6.756932389247553}], 
            8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020229905154391, 5.583496308781699}], 
            8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520318812570019, 5.583496308781699}], 
            8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-1.036482917202561, 7.56734567601324}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-1.5366522427084526`, 7.56734567601324}],
             12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.36571568859088144`, 1.6034198401085373`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.741858378904823, 1.6034198401085373`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.995732273553991, 1.497835735852798}], 
            13., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 0.766397642299538}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4903224315439383`, 
             2.0681277817795625`}], 8., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6906479678596436`, 
             2.0681277817795625`}], 8., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.1587147225743437`}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0053952069569758`, 2.498151876538021}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledCircle]", {-1.313415715707318, 2.498151876538021}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.712716261887602}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.1603343472961065`}], 8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.094604267270571}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             1.9838938336679197`}], 8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.9910142780700916, 7.6128310304073565`}],
             11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4912105310694506`, 
             7.6128310304073565`}], 11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[Times]", {-1.2255369822417765`, 4.386889790339869}], 12., 
            
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-7.975450465015525, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.227106951818089}],
             10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-5.744604469176456, 2.0471765810925606`}],
             9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.227106951818089}],
             7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0604498275737608`, 2.0719132752590443`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.110313205346923, 2.0719132752590443`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.100426344668657, 4.386889790339869}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.100386954332169, 4.386889790339869}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8195418502405067`, 6.784457062637643}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.319222734147069, 6.784457062637643}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.7042981934580606`, 5.676753802268282}],
             13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.104554242494911, 5.676753802268282}], 
            13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7672619976276676`, 4.386889790339869}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledCircle]", {-7.166785108860756, 4.386889790339869}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1150465951315345`, 7.488852955733459}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6149530931222105`, 7.488852955733459}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.9510398268753117`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 2.2927367569392314`}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.2919836816486494`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.0215475632609334`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 2.187398683184928}], 
            10.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.0215475632609334`}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.2181715237257489`}], 
            9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 2.187398683184928}], 
            10.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.2919836816486494`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.9510398268753117`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 0.7485818874480459}], 
            9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.2919836816486494`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.8871696540327132`, 5.393627546352362}],
             13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.4871090733432, 5.393627546352362}], 
            13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.4722426732562555`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.0942695392339727`}], 
            9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.795734531747094, 
             5.991464547107982}], 8., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-3.1958919884778254`, 
             5.991464547107982}], 8., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.8140100781628747`}], 11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4524341636244356`, 7.151485463904735}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.95263269481614, 7.151485463904735}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.40649706843741, 
             2.3523271848888596`}], 8., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2063088641234838`, 
             2.3523271848888596`}], 8., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7625890919282752`, 6.841615476477592}],
             8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262403303361214, 6.841615476477592}], 
            8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8470607850131444`, 6.756932389247553}],
             8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.8442026554799011, 7.759614150696903}], 
            8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346745988779815, 6.756932389247553}], 
            8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.344384958042681, 7.759614150696903}], 
            8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             0.9290095042819297}], 8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.1587147225743437`}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.0215475632609334`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             0.766397642299538}], 8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.6562368265398482, 6.674561391814426}], 
            13., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.1564532883579597`, 6.674561391814426}],
             13., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.036482917202561, 7.56734567601324}], 
            8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5366522427084526`, 7.56734567601324}], 
            8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.8442026554799011, 7.759614150696903}], 
            8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.344384958042681, 7.759614150696903}], 
            8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.599387576580599}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.349630376748299}], 
            9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8122154777954373`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8805331812814825`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.4865920824352545`}], 11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.719319793360441}],
             7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[FilledDiamond]", {-1.491654876777717, 1.783559272662715}],
             9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-0.5068336024964532, 1.601405740736836}],
             10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledSquare]", {-3.604906020337758, 1.601405740736836}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 1.599387576580599}],
             7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 0.9034081060431414}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6064191770501212, 2.5877640352277083`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5324768712979722`, 2.5877640352277083`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8805331812814825`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3983901944362025, 1.9358598132018119`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0442924641693683`, 1.9358598132018119`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[CircleMinus]", {-4.8283137373023015`, 1.7328937163610187`}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8805331812814825`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledSquare]", {-0.7310567536331655, 1.864080130807681}],
             10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8551011438142453`, 1.864080130807681}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {63.53307909765005, 4.386889790339869}], 
            13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-72.46692041972995, 4.386889790339869}], 
            13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledCircle]", {-0.7667937207282438, 4.386889790339869}],
             7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledCircle]", {-8.166888494485349, 4.386889790339869}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-7.1308988302963465`, 1.445270566220188}],
             9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.7329280505717899, 7.8709295967551425`}],
             11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2330583852210326`, 
             7.8709295967551425`}], 11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.2072749131897207`, 6.396929655216146}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706800981701778, 6.396929655216146}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-0.7985076962177716, 1.266384064447333}], 
            10.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.0215475632609334`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.090999490513565}],
             10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111964733385396, 6.492239835020471}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6115589009134488`, 6.492239835020471}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5901256014017275`, 7.013915474810528}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0898959995836948`, 7.013915474810528}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.696151689580244, 6.684611727667927}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0963149296194261`, 6.684611727667927}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.9317114296555002`, 6.672032945461067}],
             8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316692464055834`, 6.672032945461067}],
             8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-2.945799904805782, 5.991464547107982}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-3.045763207159556, 5.991464547107982}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-6.03270329512458, 1.7328937163610187`}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.864704011147587, 1.3326298365341978`}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2315538186741798, 1.6956156086751528`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.6916833814466705`, 1.6956156086751528`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 1.721694594779768}], 
            8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-0.7129418078881248, 6.81783057145415}], 
            13., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-0.8130574772325029, 6.81783057145415}], 
            13., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.090999490513565}],
             7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0940068428223313`, 4.386889790339869}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-3.293868803909631, 4.386889790339869}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 2.0215475632609334`}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.3420861064555702`, 
             4.386889790339869}], 8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.5919427181706105`, 
             4.386889790339869}], 8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.1587147225743437`}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-0.797175250983993, 2.512035317176253}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4934342366777942`, 2.512035317176253}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.462149662665384}],
             7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3903023825174294`, 
             2.0681277817795625`}], 8., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7903604483143476`, 
             2.0681277817795625`}], 8., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1702157075278026`, 7.433666540166168}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6702500518308578`, 7.433666540166168}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.8122154777954373`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7625890919282752`, 6.841615476477592}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262403303361214, 6.841615476477592}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-3.0218709311636855`, 4.386889790339869}], 12., 
            
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-5.911914268349973, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.3137523001849649, 8.290041618704489}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.813734143549063, 8.290041618704489}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-5.744604469176456, 2.3933394562625097`}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.9031380572114442`, 
             4.512945241945574}], 8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.779362064213738, 4.512945241945574}],
             8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.0598714603516792`}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.3540294005326152`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1702157075278026`, 7.433666540166168}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6702500518308578`, 7.433666540166168}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.8528465593176202, 7.751045117971802}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3528595850336531`, 7.751045117971802}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8195418502405067`, 6.784457062637643}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.319222734147069, 6.784457062637643}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.6358850824489488`}], 
            9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.2319770007355333`}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9065879564127699, 7.697121317282625}],
             12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-1.406905315024015, 7.697121317282625}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4918104261047946`, 4.386889790339869}], 
            9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[FilledDiamond]", {-6.442136248054226, 4.386889790339869}],
             9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.2975725511705014`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 0.7802418874108791}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.5703987153008919, 6.960347729101308}], 
            13., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-0.6704076935904559, 6.960347729101308}], 
            13., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.090999490513565}],
             10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.516892795645856, 6.0867747269123065`}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.016955910005618, 6.0867747269123065`}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.6409365794934714`}], 
            9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.5338519254775054`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5342648554997536, 2.0068708488450007`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.766368110426725, 2.0068708488450007`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.3491115699921747`}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 0.9654617758806044}], 9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1663559407546291`, 6.214608098422191}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5663784229736533`, 6.214608098422191}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.7406415980494447`}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.227106951818089}],
             10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[Times]", {-1.7254100886865211`, 4.386889790339869}], 12., 
            
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[Times]", {-7.475327636634016, 4.386889790339869}], 12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.7840632625935846`}], 
            9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[Times]", {-1.9754419516613513`, 4.386889790339869}], 12., 
            
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-7.225346881840062, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.5338519254775054`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9293759714228106, 2.1329823086078656`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.119430549896199, 2.1329823086078656`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-8.685611843041201, 0.9360933591703348}],
             11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4911864085136422, 1.7850704810772584`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.253208503948706, 1.7850704810772584`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.064355904261795, 6.539585955617669}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640797356921787`, 6.539585955617669}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4171835010623628, 1.7850704810772584`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.327296573822621, 1.7850704810772584`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 0.7485818874480459}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9712750402069146, 
             7.6324011266014535`}], 8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4714166145367258`, 
             7.6324011266014535`}], 8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.1587147225743437`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1041274693562197`, 2.413231613081109}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3842963584572177`, 2.413231613081109}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.0215475632609334`}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.3137523001849649, 8.290041618704489}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.813734143549063, 8.290041618704489}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.462149662665384}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8805331812814825`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 1.0360274134764884`}],
             10.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8122154777954373`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.7985076962177716, 1.9572739077056285`}], 
            10.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 
             0.7802418874108791}], 8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-2.893897967672723, 4.386889790339869}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledSquare]", {-3.49397078181451, 4.386889790339869}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2069773133462347`, 6.173786103901937}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-1.606941032235513, 6.173786103901937}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.3540294005326152`}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8805331812814825`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.995732273553991, 1.0335402919243948`}],
             13., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {30.65922057962004, 4.512945241945574}], 
            13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-39.34081340913477, 4.512945241945574}], 
            13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 0.9566646260124284}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4460443655256647`, 7.157735484249907}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.946310229076653, 7.157735484249907}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7306413849875258, 
             2.827905162910489}], 8., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9306432380985556, 
             2.827905162910489}], 8., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9317114296555002`, 6.672032945461067}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316692464055834`, 6.672032945461067}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[Times]", {-3.522010001878903, 4.386889790339869}], 12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[Times]", {-5.411934093335004, 4.386889790339869}], 12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4524341636244356`, 7.151485463904735}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.95263269481614, 7.151485463904735}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 1.3321021320364639`}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.527397202097891, 7.076653815443951}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0272286702329017`, 7.076653815443951}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[Times]", {-0.09926800165866902, 4.512945241945574}], 12., 
            
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-8.849872629798755, 4.512945241945574}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.7985076962177716, 2.647592232065096}], 
            13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 1.599387576580599}],
             7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.3540294005326152`}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.599387576580599}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 0.9669838461896731}], 
            9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0645007590393418`, 1.7817091333745536`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6864844231876495`, 1.7817091333745536`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.090999490513565}],
             7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4126383364594925`, 1.8625285401162623`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.176833887688485, 1.8625285401162623`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.8122154777954373`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7463370090740643, 2.1329823086078656`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 2.1329823086078656`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-2.5609672964009644`, 4.969813299576001}],
             13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.6609757937162812`, 4.969813299576001}],
             13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-8.05031945517943, 1.2424239907001886`}],
             11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5191402744533198`, 1.6882490928583902`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.418894215394429, 1.6882490928583902`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7667937207282438, 
             4.386889790339869}], 8., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.166888494485349, 
             4.386889790339869}], 8., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-5.403677882205863, 1.445270566220188}], 
            9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.045554398052668, 0.9604989865384754}], 9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.3749057545736716`}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-0.4307829160924542, 2.647592232065096}], 
            10.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1715056141884346`, 
             2.187174241482718}], 8., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.771368779580321, 
             2.187174241482718}], 8., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-0.5978370007556204, 2.187398683184928}], 
            10.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.8420006856648017`, 
             4.386889790339869}], 8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.091798316674432, 4.386889790339869}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.090999490513565}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.3540294005326152`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.820158943749753, 5.560681631015528}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.220083871482302, 5.560681631015528}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.9572739077056285`}],
             10.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledCircle]", {-2.659260036932778, 1.007592890280941}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-0.5079962967558309, 2.134048091170708}],
             10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-2.538054293998892, 2.134048091170708}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.0215475632609334`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.8805331812814825`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.4722426732562555`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 1.416581053724763}],
             7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8997902134417601`, 6.704414354964107}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3993162819538174`, 6.704414354964107}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1796054478776414`, 7.424165281042028}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6798603767306461`, 7.424165281042028}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-2.475392057419415, 4.386889790339869}], 12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[Times]", {-6.725433722188183, 4.386889790339869}], 12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.2319770007355333`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.612442421454399, 5.768320995793772}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0129050178795915`, 5.768320995793772}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.4307829160924542, 1.9569913819232716`}], 
            13., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.090999490513565}],
             7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8122154777954373`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.153303390278291, 4.512945241945574}],
             8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.529318843261892, 4.512945241945574}],
             8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.48304834276654407`, 6.897704943128636}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8830977645183911, 6.897704943128636}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.7406415980494447`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             0.8028980445190645}], 8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.2919836816486494`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 1.599387576580599}],
             10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.5087859235779435`}], 8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 0.8028980445190645}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 0.7975071958841882}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9565920286476808, 
             2.702032128776647}], 8., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9565920286476808, 
             2.702032128776647}], 8., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.18765575838465653`, 2.6224923127405635`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.881903019081021, 2.6224923127405635`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.5338519254775054`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.5824869781268642`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.795734531747094, 
             5.991464547107982}], 8., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-3.1958919884778254`, 
             5.991464547107982}], 8., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1199380753828623`, 2.065596134857783}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[FilledCircle]", {-2.064355904261795, 2.065596134857783}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4460443655256647`, 7.157735484249907}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.946310229076653, 7.157735484249907}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 0.9290095042819297}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-3.7164562218841706`, 4.787491742782046}],
             9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-4.416204086475468, 4.787491742782046}], 
            9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.0215475632609334`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820086052689358`, 6.921658184151129}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1821389399181785`, 6.921658184151129}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-7.600902459542082, 0.973049065692764}], 
            9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.8528465593176202, 7.751045117971802}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3528595850336531`, 7.751045117971802}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[Times]", {-0.3492738284584218, 4.512945241945574}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-8.599488434143067, 4.512945241945574}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8442026554799011, 7.759614150696903}],
             12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-1.344384958042681, 7.759614150696903}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.290620611051608, 
             2.0681277817795625`}], 8., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8904754421672127`, 
             2.0681277817795625`}], 8., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.2975725511705014`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 1.018486244188825}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1526461771605954`, 1.8656293177945105`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.4305321073246677`, 1.8656293177945105`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.8012039280560548`, 4.386765389021055}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-4.417032243872697, 4.386765389021055}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.376740148315079, 7.226936018493289}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8773173575897015`, 7.226936018493289}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.2975725511705014`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.238564249095555, 7.365180126021013}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7389772837890856`, 7.365180126021013}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.5005758256424344`, 
             4.386889790339869}], 11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.700587583759682, 4.386889790339869}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-2.218243944560295, 4.512945241945574}], 
            10.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-3.9180410777537094`, 4.512945241945574}],
             10.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.8840655845794182, 4.386765389021055}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-5.504112279527633, 4.386765389021055}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.7109170813839543`, 5.66988092298052}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1111386284230904`, 5.66988092298052}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.0289048762432895`}], 8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.9510398268753117`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 0.849723487602042}], 
            9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5823216254710607, 2.1329823086078656`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.466163406970865, 2.1329823086078656`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.0845133642886082`}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.7406415980494447`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0939232991819783`, 4.386889790339869}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledSquare]", {-5.293927018246744, 4.386889790339869}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4679383501604009`, 1.7833912195575383`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.279845606024556, 1.7833912195575383`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 0.880041599199034}], 
            11.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             2.5087859235779435`}], 8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-2.966950472128539, 4.386889790339869}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-5.966967075507594, 4.386889790339869}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.3540294005326152`}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4267908948229169, 1.6974487897568136`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.4929837772928636`, 1.6974487897568136`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.5338519254775054`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 1.599387576580599}],
             7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.4722426732562555`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.2809338454620642`}], 8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0918353043890858`, 
             4.386889790339869}], 8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.84195543139986, 4.386889790339869}], 
            8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.3261404383001434`, 7.3777589082278725`}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.6260755535871236`, 7.3777589082278725`}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.8805331812814825`}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.5338519254775054`}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.6039529822035308`, 5.676753802268282}],
             13., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-2.2045513527226803`, 5.676753802268282}],
             13., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.090999490513565}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.0215475632609334`}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7813228714636707, 7.822444729489319}], 
            8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2815740503494875`, 7.822444729489319}],
             8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.090999490513565}],
             7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.3754861624032872`}], 8.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.599387576580599}], 
            7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4329667693183212`, 
             2.425687290128029}], 8., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0328245481301066`, 
             2.425687290128029}], 8., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6044503709230613`, 6.999422467507961}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.104554242494911, 6.999422467507961}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.6661962462527091`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             0.766397642299538}], 8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3093333199837622`, 7.294377299288821}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8097197946050478`, 7.294377299288821}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.1587147225743437`}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.2975725511705014`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-8.047189562170502, 1.2424239907001886`}],
             9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-1.7867719277170158`, 4.512945241945574}], 12., 
            
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[Times]", {-7.1622605067393605`, 4.512945241945574}], 12., 
            
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 0.8989410935390421}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledSquare]", {-0.3226876816505963, 2.005525858729668}],
             10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9806466361359503`, 2.005525858729668}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.227106951818089}],
             7.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.0360274134764884`}],
             10.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.6888794541139363`, 0.9669838461896731}], 
            9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8470607850131444`, 6.756932389247553}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346745988779815, 6.756932389247553}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.9910142780700916, 7.6128310304073565`}],
             11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4912105310694506`, 
             7.6128310304073565`}], 11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.9510398268753117`}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7389772837890856`, 1.803358605071407}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-1.968974088653865, 1.803358605071407}], 
            10., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-1.036482917202561, 7.56734567601324}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.5366522427084526`, 7.56734567601324}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.3109197297841035`, 4.969813299576001}],
             13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.9110235456270366`, 4.969813299576001}],
             13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 0.9654617758806044}], 
            9., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {33.65905864326737, 4.512945241945574}], 
            13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-42.34081632550436, 4.512945241945574}], 
            13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 
            12., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.100426344668657, 4.386889790339869}], 
            11.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.100386954332169, 4.386889790339869}], 
            11.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptyDiamond]", {-1.900458886151396, 5.480638923341991}], 
            12., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3005870903313728`, 5.480638923341991}], 
            12., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.659260036932778, 1.1637756145745228`}], 
            7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3842963584572177`, 4.386765389021055}],
             8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-5.0040073078060345`, 4.386765389021055}],
             8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[Times]", {-1.7254100886865211`, 4.386889790339869}], 12., 
            
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[Times]", {-7.475327636634016, 4.386889790339869}], 12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.2975725511705014`}], 
            7.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.809109107563168, 1.4951487660319727`}], 
            10., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.515036014769512, 1.4951487660319727`}], 
            10., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1026203100656484`, 7.501082124259871}], 
            12., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6029589463363911`, 7.501082124259871}], 
            12., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820086052689358`, 6.921658184151129}],
             8.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1821389399181785`, 6.921658184151129}],
             8.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0191543673333943`, 2.570319527636131}], 
            7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[FilledCircle]", {-1.155182640156504, 2.570319527636131}], 
            7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 1.6384140206706175`}], 
            9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.5895081458004594, 6.7912214627261855`}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9896682016789307, 6.7912214627261855`}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.9510398268753117`}], 
            7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.416581053724763}], 
            7.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptySquare]", {-1.557794679282262, 5.823045895483019}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.9582864201233687`, 5.823045895483019}],
             13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyCircle]", {-2.036382052219389, 4.512945241945574}], 
            10.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptyCircle]", {-6.912265434460023, 4.512945241945574}], 
            10.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020229905154391, 5.583496308781699}], 
            8.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520318812570019, 5.583496308781699}], 
            8.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1702157075278026`, 7.433666540166168}],
             8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6702500518308578`, 7.433666540166168}],
             8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.1587147225743437`}], 
            10., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[CircleMinus]", {-9.567158183262826, 0.8046885552928528}], 
            9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.462149662665384}],
             7.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.926290362185661}], 
            9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.227106951818089}],
             7.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8805331812814825`}], 
            7.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptyDiamond]", {-1.000759888500605, 6.380122536899765}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4007990473227723`, 6.380122536899765}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {54.53306059828793, 4.386889790339869}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {-63.46698269688735, 4.386889790339869}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.599387576580599}], 
            10., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.66442222076686, 6.939253946041508}], 
            11.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164563795096671, 6.939253946041508}], 
            11.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.500810170663849, 4.386889790339869}], 
            11.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.70036037299184, 4.386889790339869}], 
            11.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.018486244188825}], 8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3093333199837622`, 7.294377299288821}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8097197946050478`, 7.294377299288821}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8305718564716175, 
             2.827905162910489}], 8., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8305718564716175, 
             2.827905162910489}], 8., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7813228714636707, 7.822444729489319}], 
            8.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2815740503494875`, 7.822444729489319}],
             8.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.4722426732562555`}], 
            7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.9510398268753117`}], 
            7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {48.53243313825843, 4.386889790339869}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {-57.46750061412042, 4.386889790339869}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyCircle]", {-2.162823150618887, 4.512945241945574}], 
            10.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptyCircle]", {-6.786422993814612, 4.512945241945574}], 
            10.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.4722426732562555`}], 
            10., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {53.53269402275044, 4.386889790339869}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {-62.46685674510361, 4.386889790339869}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.900588627802483, 4.386889790339869}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.30031936921871, 4.386889790339869}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.6661962462527091`}], 
            7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324790142551358`, 5.971261839790462}],
             8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132468797127462, 5.971261839790462}], 
            8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.7406415980494447`}], 
            10., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4460443655256647`, 7.157735484249907}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.946310229076653, 7.157735484249907}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 0.766397642299538}],
             8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.8805331812814825`}], 
            10., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7199019178687649, 
             7.8838232148921525`}], 8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2201021862558195`, 
             7.8838232148921525`}], 8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.7406415980494447`}], 
            10., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            11.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            11.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.807796846925679}], 12., 
            
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.6661962462527091`}], 
            10., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            11.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            11.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            11.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            11.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.869504817852908, 
             1.9892432737616872`}], 8., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.469241281940817, 
             1.9892432737616872`}], 8., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.39809235377875135`, 2.498151876538021}], 
            10., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9200474895295858`, 2.498151876538021}], 
            10., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[FilledSquare]", {-0.984837274409265, 2.005525858729668}], 
            10., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[FilledSquare]", {-2.318612854071243, 2.005525858729668}], 
            10., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            11.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            11.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[Times]", {-2.940865372113151, 4.512945241945574}], 12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[Times]", {-5.740861482897622, 4.512945241945574}], 12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4092798316650086`, 6.194405391104672}],
             8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.9093711079059474`, 6.194405391104672}],
             8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.4307829160924542, 2.4176979000945504`}], 
            10.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.0289048762432895`}], 8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[CircleMinus]", {-1.0529699307894087`, 7.600902459542082}],
             9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[CircleMinus]", {-1.4528616053920038`, 7.600902459542082}],
             9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.29356601561075557`, 1.6956156086751528`}], 
            10., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.6298561136644754`, 1.6956156086751528`}], 
            10., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.894078619827491, 4.386765389021055}],
             8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.49397078181451, 4.386765389021055}], 
            8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.6661962462527091`}], 
            7.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.2919836816486494`}], 
            10., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.238564249095555, 7.365180126021013}], 
            8.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7389772837890856`, 7.365180126021013}],
             8.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9317114296555002`, 6.672032945461067}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316692464055834`, 6.672032945461067}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.7813228714636707, 7.822444729489319}],
             12., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2815740503494875`, 7.822444729489319}], 
            12., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8122154777954373`}], 
            7.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.7406415980494447`}], 
            10., 
            RGBColor[0., 0., 0.7]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1062413158326008`, 
             2.3523271848888596`}], 8., 
            RGBColor[0., 0., 0.7]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5064301623598713`, 
             2.3523271848888596`}], 8., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7625890919282752`, 6.841615476477592}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262403303361214, 6.841615476477592}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9063404010209869, 
             2.3523271848888596`}], 8., 
            RGBColor[0., 0., 0.7]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7064996252772315`, 
             2.3523271848888596`}], 8., 
            RGBColor[0., 0., 0.7]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.006215439402142, 
             2.3523271848888596`}], 8., 
            RGBColor[0., 0., 0.7]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.606442403454302, 
             2.3523271848888596`}], 8., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 2.0759354023505483`}], 
            9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.66442222076686, 6.939253946041508}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164563795096671, 6.939253946041508}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.8805331812814825`}], 
            10., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 
            12., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 
            12., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.5922917535991299`}], 8.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.036482917202561, 7.56734567601324}], 
            8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5366522427084526`, 7.56734567601324}], 
            8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.7406415980494447`}], 
            7.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3799147541558516`, 7.22402480828583}], 
            8.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8799351601317804`, 7.22402480828583}], 
            8.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptyCircle]", {-1.2862680470527663`, 4.512945241945574}],
             10.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyCircle]", {-7.662352421858305, 4.512945241945574}], 
            10.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[FilledSquare]", {-0.6539264674066639, 4.386889790339869}],
             10., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledSquare]", {-5.7340355178272215`, 4.386889790339869}], 
            10., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.8442026554799011, 7.759614150696903}], 
            8.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.344384958042681, 7.759614150696903}], 
            8.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptyCircle]", {-1.036482917202561, 4.512945241945574}], 
            10.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyCircle]", {-7.912330925723864, 4.512945241945574}], 
            10.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.5978370007556204, 1.4964931534179662`}], 
            10.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[Times]", {-3.2568373311553196`, 4.386889790339869}], 12., 
            
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[Times]", {-5.676945820702642, 4.386889790339869}], 12., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2960880932337415`, 1.4883995840570443`}], 
            10., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0417762120553977`, 1.4883995840570443`}], 
            10., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7625890919282752`, 6.841615476477592}], 
            12., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262403303361214, 6.841615476477592}], 
            12., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.2319770007355333`}], 
            7.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8457617469776957`, 5.991464547107982}], 
            10., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[FilledSquare]", {-3.145857732131629, 5.991464547107982}], 
            10., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[CircleMinus]", {-6.214608098422191, 2.0471765810925606`}],
             9., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.9245405804618736`}], 
            9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.527397202097891, 7.076653815443951}], 
            12., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0272286702329017`, 7.076653815443951}], 
            12., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.094520670764856, 1.6937790608678513`}], 
            10., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.832423655941967, 1.6937790608678513`}], 
            10., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            12., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 
            12., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.300630996469888, 4.386889790339869}], 
            11.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.900346940202133, 4.386889790339869}], 
            11.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 2.0215475632609334`}], 
            10., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.9028810449642375, 
             4.512945241945574}], 8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.7788336680347445`, 
             4.512945241945574}], 8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.33687231664255274`, 1.937301774518713}], 
            10., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1028721491118945`, 1.937301774518713}], 
            10., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.500810170663849, 4.386889790339869}], 
            11.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.70036037299184, 4.386889790339869}], 
            11.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6311724045801064`, 1.4883995840570443`}], 
            10., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.706800981701778, 1.4883995840570443`}], 
            10., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.100765130025024, 4.386889790339869}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.10045059841862, 4.386889790339869}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {55.53283243663866, 4.386889790339869}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {-64.46739506232224, 4.386889790339869}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 1.416581053724763}],
             7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 0.8514321595256585}], 
            9., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4028684822608984, 
             4.512945241945574}], 8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.278964002683987, 4.512945241945574}],
             8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyCircle]", {-0.9122987106046175, 4.512945241945574}], 
            10.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyCircle]", {-8.036311444023319, 4.512945241945574}], 
            10.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.9510398268753117`}], 
            10., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-4.199705077879927, 0.7997569156182036}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.3749057545736716`}], 
            7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.376740148315079, 7.226936018493289}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8773173575897015`, 7.226936018493289}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.659260036932778, 1.4722426732562555`}], 
            10., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3093333199837622`, 7.294377299288821}], 
            11.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8097197946050478`, 7.294377299288821}], 
            11.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptySquare]", {28.659210940300113`, 4.512945241945574}], 
            13., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptySquare]", {-37.34075273404506, 4.512945241945574}], 
            13., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1150465951315345`, 7.488852955733459}], 
            11.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6149530931222105`, 7.488852955733459}], 
            11.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 1.416581053724763}],
             10., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[Times]", {-0.6624240079171049, 4.512945241945574}], 12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[Times]", {-8.286478374605709, 4.512945241945574}], 12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.238564249095555, 7.365180126021013}], 
            12., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7389772837890856`, 7.365180126021013}], 
            12., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptyCircle]", {-2.2867117438377558`, 4.512945241945574}],
             10.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptyCircle]", {-6.662458923026794, 4.512945241945574}], 
            10.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[Times]", {-2.162823150618887, 4.512945241945574}], 12., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[Times]", {-6.786422993814612, 4.512945241945574}], 12., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 
            12., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 
            12., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.6661962462527091`}], 
            10., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptySquare]", {49.53294194921661, 4.386889790339869}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {-58.4670151515563, 4.386889790339869}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 1.4964931534179662`}], 
            10.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[Times]", {-0.536314386533157, 4.512945241945574}], 12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[Times]", {-8.412382827063892, 4.512945241945574}], 12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.3540294005326152`}], 
            10., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3082228256997352`, 7.295735072749282}],
             8.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.808498793232353, 7.295735072749282}], 
            8.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8442026554799011, 7.759614150696903}],
             12., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptyDiamond]", {-1.344384958042681, 7.759614150696903}], 
            12., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            12., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            12., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-8.955698153602603, 0.8046885552928528}],
             11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.270112606830481, 
             2.58851563240702}], 8., 
            RGBColor[1, 0, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8701230510291479, 
             2.58851563240702}], 8., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.269150316907808, 5.111987788356544}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-2.66873333872526, 5.111987788356544}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            12., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            12., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9317114296555002`, 6.672032945461067}], 
            12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316692464055834`, 6.672032945461067}], 
            12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {46.532892678517214`, 4.386889790339869}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-55.46685482648658, 4.386889790339869}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5288198871382693, 
             4.512945241945574}], 8.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.152897360346143, 4.512945241945574}],
             8.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.6003175012993283`, 
             4.386889790339869}], 11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.60100614381313, 4.386889790339869}], 
            11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6416938989710297, 1.8625285401162623`}], 
            10., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9477043045434095`, 1.8625285401162623`}], 
            10., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8195418502405067`, 6.784457062637643}], 
            11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.319222734147069, 6.784457062637643}], 
            11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[Times]", {-1.912572089444803, 4.512945241945574}], 12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[Times]", {-7.036270701217564, 4.512945241945574}], 12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[Times]", {-2.412288358086009, 4.512945241945574}], 12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[Times]", {-6.536881615643591, 4.512945241945574}], 12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-2.360956006320375, 4.969813299576001}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-2.8610265707016995`, 4.969813299576001}],
             13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4524341636244356`, 7.151485463904735}], 
            12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptyDiamond]", {-1.95263269481614, 7.151485463904735}], 
            12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8470607850131444`, 6.756932389247553}], 
            12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346745988779815, 6.756932389247553}], 
            12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 
            12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 
            12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.100765130025024, 4.386889790339869}], 
            11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.10045059841862, 4.386889790339869}], 
            11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8195418502405067`, 6.784457062637643}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.319222734147069, 6.784457062637643}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.1236024374656055`, 5.2574953720277815`}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.5232317641096684`, 5.2574953720277815`}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[Times]", {-0.786359562282124, 4.512945241945574}], 12., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[Times]", {-8.162319869424133, 4.512945241945574}], 12., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.5005758256424344`, 
             4.386889790339869}], 11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.700587583759682, 4.386889790339869}], 
            11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.7329280505717899, 7.8709295967551425`}],
             11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2330583852210326`, 
             7.8709295967551425`}], 11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {40.65907381386164, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-49.34073194467232, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[Times]", {-2.036382052219389, 4.512945241945574}], 12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[Times]", {-6.912265434460023, 4.512945241945574}], 12., 
            RGBColor[0, 0, 1]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7903604483143476`, 
             2.0681277817795625`}], 8., 
            RGBColor[1, 0, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3903023825174294`, 
             2.0681277817795625`}], 8., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.3799147541558516`, 7.22402480828583}],
             12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptyDiamond]", {-1.8799351601317804`, 7.22402480828583}],
             12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {47.5330791022475, 4.386889790339869}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-56.46701553651661, 4.386889790339869}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {61.533219681767186`, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-70.4670522818902, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820086052689358`, 6.921658184151129}], 
            12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1821389399181785`, 6.921658184151129}], 
            12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.30938249943111995`, 2.131796772013764}], 
            10., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7414001807837645`, 2.131796772013764}], 
            10., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {23.65924810609463, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-32.34077434210908, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6044503709230613`, 6.999422467507961}], 
            12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptyDiamond]", {-2.104554242494911, 6.999422467507961}], 
            12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3082228256997352`, 7.295735072749282}], 
            12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptyDiamond]", {-1.808498793232353, 7.295735072749282}], 
            12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[Times]", {-2.475392057419415, 4.386889790339869}], 12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[Times]", {-6.725433722188183, 4.386889790339869}], 12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {38.65927591460964, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-47.34086951027008, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[Times]", {-2.2867117438377558`, 4.512945241945574}], 12., 
            
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[Times]", {-6.662458923026794, 4.512945241945574}], 12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5220551057175394, 1.4951487660319727`}], 
            10., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.802272141469027, 1.4951487660319727`}], 
            10., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {41.659220767303175`, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-50.341331645288825`, 4.512945241945574}],
             13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {26.659217674124136`, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-35.340845982694816`, 4.512945241945574}],
             13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {22.659269939882257`, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-31.34091993726656, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8997902134417601`, 6.704414354964107}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3993162819538174`, 6.704414354964107}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {60.532988401609, 4.386889790339869}], 13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-69.46689851604965, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {25.65917758484673, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-34.340745544411554`, 4.512945241945574}],
             13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {56.53320628572335, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-65.466905183977, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.700547258981618, 4.386889790339869}], 
            11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.500433550670171, 4.386889790339869}], 
            11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.5005758256424344`, 
             4.386889790339869}], 11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.700587583759682, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {59.53313730582369, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-68.46724388757043, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {34.65922254798655, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-43.340988541359216`, 4.512945241945574}],
             13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[Times]", {-2.475392057419415, 4.386889790339869}], 12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[Times]", {-6.725433722188183, 4.386889790339869}], 12., 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.900588627802483, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.30031936921871, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {42.533071381326664`, 4.386889790339869}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-51.46677778703915, 4.386889790339869}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.900422093749666, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.300710797475603, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {58.533130928172234`, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-67.46691559681179, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.700547258981618, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.500433550670171, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.6003175012993283`, 
             4.386889790339869}], 11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.60100614381313, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.3003570667360838`, 
             4.386889790339869}], 11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.9005275521158795`, 
             4.386889790339869}], 11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.400308181522661, 4.386889790339869}], 
            11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.8006962066887295`, 
             4.386889790339869}], 11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {39.65916255296606, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-48.341370727608414`, 4.512945241945574}],
             13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.300630996469888, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.900346940202133, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.400308181522661, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.8006962066887295`, 
             4.386889790339869}], 11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {37.65893624683973, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-46.34085167560773, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.700547258981618, 4.386889790339869}], 
            11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.500433550670171, 4.386889790339869}], 
            11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.900588627802483, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.30031936921871, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {36.659239911113445`, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-45.34120604098636, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {32.658841234778905`, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-41.34127116323533, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {27.65863628296152, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-36.34119244432727, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {44.53301831071528, 4.386889790339869}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-53.46678887337479, 4.386889790339869}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {35.65915017536031, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-44.34079097851618, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {24.65920066242087, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-33.34092227159292, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.900422093749666, 4.386889790339869}], 
            11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.300710797475603, 4.386889790339869}], 
            11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.500810170663849, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.70036037299184, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {52.5331258380735, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-61.467195171508536`, 4.386889790339869}],
             13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.6003175012993283`, 
             4.386889790339869}], 11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.60100614381313, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {21.65896696234039, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-30.340822850069564`, 4.512945241945574}],
             13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {62.53305077013809, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-71.46678568954108, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {57.53313665775977, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-66.46748299707936, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.900422093749666, 4.386889790339869}], 
            11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.300710797475603, 4.386889790339869}], 
            11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.3003570667360838`, 
             4.386889790339869}], 11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.9005275521158795`, 
             4.386889790339869}], 11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {20.659260506970497`, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-29.340832002509437`, 4.512945241945574}],
             13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.300630996469888, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.900346940202133, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {19.659054974995634`, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-28.340907620492793`, 4.512945241945574}],
             13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {18.658909932684615`, 4.512945241945574}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-27.341341040814093`, 4.512945241945574}],
             13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {51.5331737695268, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-60.466869255317796`, 4.386889790339869}],
             13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.3003570667360838`, 
             4.386889790339869}], 11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.9005275521158795`, 
             4.386889790339869}], 11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.400308181522661, 4.386889790339869}], 
            11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.8006962066887295`, 
             4.386889790339869}], 11.5, 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {50.53312123843283, 4.386889790339869}], 
            13., 
            RGBColor[0, 0, 1]], 
           Style[
            Text["\[EmptySquare]", {-59.467094916063616`, 4.386889790339869}],
             13., 
            RGBColor[0, 0, 1]]}}, {
         Frame -> True, 
          FrameTicks -> {{{-13.815510557964274`, 
              "\!\(\*SuperscriptBox[\(10\), \(-6\)]\)", {0.02, 
              0.}}, {-13.122363377404328`, "", {
              0.01, 0}}, {-12.716898269296165`, "", {
              0.01, 0}}, {-12.429216196844383`, "", {
              0.01, 0}}, {-12.206072645530174`, "", {
              0.01, 0}}, {-12.02375108873622, "", {
              0.01, 0}}, {-11.86960040890896, "", {
              0.01, 0}}, {-11.736069016284437`, "", {
              0.01, 0}}, {-11.618285980628055`, "", {
              0.01, 0}}, {-11.512925464970229`, 
              "\!\(\*SuperscriptBox[\(10\), \(-5\)]\)", {0.02, 
              0.}}, {-10.819778284410283`, "", {
              0.01, 0}}, {-10.414313176302118`, "", {
              0.01, 0}}, {-10.126631103850338`, "", {
              0.01, 0}}, {-9.903487552536127, "", {
              0.01, 0}}, {-9.721165995742174, "", {
              0.01, 0}}, {-9.567015315914915, "", {
              0.01, 0}}, {-9.433483923290392, "", {
              0.01, 0}}, {-9.315700887634009, "", {
              0.01, 0}}, {-9.210340371976182, 
              "\!\(\*SuperscriptBox[\(10\), \(-4\)]\)", {0.02, 
              0.}}, {-8.517193191416238, "", {0.01, 0}}, {-8.111728083308073, 
              "", {0.01, 0}}, {-7.824046010856292, "", {
              0.01, 0}}, {-7.600902459542082, "", {
              0.01, 0}}, {-7.418580902748127, "", {
              0.01, 0}}, {-7.264430222920869, "", {
              0.01, 0}}, {-7.1308988302963465`, "", {
              0.01, 0}}, {-7.013115794639964, "", {
              0.01, 0}}, {-6.907755278982137, 
              "\!\(\*SuperscriptBox[\(10\), \(-3\)]\)", {0.02, 
              0.}}, {-6.214608098422191, "", {0.01, 0}}, {-5.809142990314028, 
              "", {0.01, 0}}, {-5.521460917862246, "", {
              0.01, 0}}, {-5.298317366548036, "", {
              0.01, 0}}, {-5.115995809754082, "", {
              0.01, 0}}, {-4.961845129926823, "", {
              0.01, 0}}, {-4.8283137373023015`, "", {
              0.01, 0}}, {-4.710530701645918, "", {
              0.01, 0}}, {-4.605170185988091, 
              "\!\(\*SuperscriptBox[\(10\), \(-2\)]\)", {0.02, 
              0.}}, {-3.912023005428146, "", {0.01, 0}}, {-3.506557897319982, 
              "", {0.01, 0}}, {-3.2188758248682006`, "", {
              0.01, 0}}, {-2.995732273553991, "", {
              0.01, 0}}, {-2.8134107167600364`, "", {
              0.01, 0}}, {-2.659260036932778, "", {
              0.01, 0}}, {-2.5257286443082556`, "", {
              0.01, 0}}, {-2.4079456086518722`, "", {
              0.01, 0}}, {-2.3025850929940455`, 
              "\!\(\*SuperscriptBox[\(10\), \(-1\)]\)", {0.02, 
              0.}}, {-1.6094379124341003`, "", {
              0.01, 0}}, {-1.203972804325936, "", {
              0.01, 0}}, {-0.916290731874155, "", {
              0.01, 0}}, {-0.6931471805599453, "", {
              0.01, 0}}, {-0.5108256237659905, "", {
              0.01, 0}}, {-0.3566749439387323, "", {
              0.01, 0}}, {-0.2231435513142097, "", {
              0.01, 0}}, {-0.10536051565782628`, "", {0.01, 0}}, {
             0., "1", {0.02, 0.}}, {0.6931471805599453, "", {0.01, 0}}, {
             1.0986122886681098`, "", {0.01, 0}}, {
             1.3862943611198906`, "", {0.01, 0}}, {
             1.6094379124341003`, "", {0.01, 0}}, {
             1.791759469228055, "", {0.01, 0}}, {
             1.9459101490553132`, "", {0.01, 0}}, {
             2.0794415416798357`, "", {0.01, 0}}, {
             2.1972245773362196`, "", {0.01, 0}}, {
             2.302585092994046, "\!\(\*SuperscriptBox[\(10\), \(1\)]\)", {
              0.02, 0.}}, {2.995732273553991, "", {0.01, 0}}, {
             3.4011973816621555`, "", {0.01, 0}}, {
             3.6888794541139363`, "", {0.01, 0}}, {
             3.912023005428146, "", {0.01, 0}}, {
             4.0943445622221, "", {0.01, 0}}, {
             4.248495242049359, "", {0.01, 0}}, {
             4.382026634673881, "", {0.01, 0}}, {
             4.499809670330265, "", {0.01, 0}}, {
             4.605170185988092, "\!\(\*SuperscriptBox[\(10\), \(2\)]\)", {
              0.02, 0.}}, {5.298317366548036, "", {0.01, 0}}, {
             5.703782474656201, "", {0.01, 0}}, {
             5.991464547107982, "", {0.01, 0}}, {
             6.214608098422191, "", {0.01, 0}}, {
             6.396929655216146, "", {0.01, 0}}, {
             6.551080335043404, "", {0.01, 0}}, {
             6.684611727667927, "", {0.01, 0}}, {
             6.802394763324311, "", {0.01, 0}}, {
             6.907755278982137, "\!\(\*SuperscriptBox[\(10\), \(3\)]\)", {
              0.02, 0.}}, {7.600902459542082, "", {0.01, 0}}, {
             8.006367567650246, "", {0.01, 0}}, {
             8.294049640102028, "", {0.01, 0}}, {
             8.517193191416238, "", {0.01, 0}}, {
             8.699514748210191, "", {0.01, 0}}, {
             8.85366542803745, "", {0.01, 0}}, {
             8.987196820661973, "", {0.01, 0}}, {
             9.104979856318357, "", {0.01, 0}}, {
             9.210340371976184, "\!\(\*SuperscriptBox[\(10\), \(4\)]\)", {
              0.02, 0.}}, {9.903487552536127, "", {0.01, 0}}, {
             10.308952660644293`, "", {0.01, 0}}, {
             10.596634733096073`, "", {0.01, 0}}, {
             10.819778284410283`, "", {0.01, 0}}, {
             11.002099841204238`, "", {0.01, 0}}, {
             11.156250521031495`, "", {0.01, 0}}, {
             11.289781913656018`, "", {0.01, 0}}, {
             11.407564949312402`, "", {0.01, 0}}}, {{-13.815510557964274`, 
              "\!\(\*SuperscriptBox[\(10\), \(-6\)]\)", {0.02, 
              0.}}, {-13.122363377404328`, "", {
              0.01, 0}}, {-12.716898269296165`, "", {
              0.01, 0}}, {-12.429216196844383`, "", {
              0.01, 0}}, {-12.206072645530174`, "", {
              0.01, 0}}, {-12.02375108873622, "", {
              0.01, 0}}, {-11.86960040890896, "", {
              0.01, 0}}, {-11.736069016284437`, "", {
              0.01, 0}}, {-11.618285980628055`, "", {
              0.01, 0}}, {-11.512925464970229`, 
              "\!\(\*SuperscriptBox[\(10\), \(-5\)]\)", {0.02, 
              0.}}, {-10.819778284410283`, "", {
              0.01, 0}}, {-10.414313176302118`, "", {
              0.01, 0}}, {-10.126631103850338`, "", {
              0.01, 0}}, {-9.903487552536127, "", {
              0.01, 0}}, {-9.721165995742174, "", {
              0.01, 0}}, {-9.567015315914915, "", {
              0.01, 0}}, {-9.433483923290392, "", {
              0.01, 0}}, {-9.315700887634009, "", {
              0.01, 0}}, {-9.210340371976182, 
              "\!\(\*SuperscriptBox[\(10\), \(-4\)]\)", {0.02, 
              0.}}, {-8.517193191416238, "", {0.01, 0}}, {-8.111728083308073, 
              "", {0.01, 0}}, {-7.824046010856292, "", {
              0.01, 0}}, {-7.600902459542082, "", {
              0.01, 0}}, {-7.418580902748127, "", {
              0.01, 0}}, {-7.264430222920869, "", {
              0.01, 0}}, {-7.1308988302963465`, "", {
              0.01, 0}}, {-7.013115794639964, "", {
              0.01, 0}}, {-6.907755278982137, 
              "\!\(\*SuperscriptBox[\(10\), \(-3\)]\)", {0.02, 
              0.}}, {-6.214608098422191, "", {0.01, 0}}, {-5.809142990314028, 
              "", {0.01, 0}}, {-5.521460917862246, "", {
              0.01, 0}}, {-5.298317366548036, "", {
              0.01, 0}}, {-5.115995809754082, "", {
              0.01, 0}}, {-4.961845129926823, "", {
              0.01, 0}}, {-4.8283137373023015`, "", {
              0.01, 0}}, {-4.710530701645918, "", {
              0.01, 0}}, {-4.605170185988091, 
              "\!\(\*SuperscriptBox[\(10\), \(-2\)]\)", {0.02, 
              0.}}, {-3.912023005428146, "", {0.01, 0}}, {-3.506557897319982, 
              "", {0.01, 0}}, {-3.2188758248682006`, "", {
              0.01, 0}}, {-2.995732273553991, "", {
              0.01, 0}}, {-2.8134107167600364`, "", {
              0.01, 0}}, {-2.659260036932778, "", {
              0.01, 0}}, {-2.5257286443082556`, "", {
              0.01, 0}}, {-2.4079456086518722`, "", {
              0.01, 0}}, {-2.3025850929940455`, 
              "\!\(\*SuperscriptBox[\(10\), \(-1\)]\)", {0.02, 
              0.}}, {-1.6094379124341003`, "", {
              0.01, 0}}, {-1.203972804325936, "", {
              0.01, 0}}, {-0.916290731874155, "", {
              0.01, 0}}, {-0.6931471805599453, "", {
              0.01, 0}}, {-0.5108256237659905, "", {
              0.01, 0}}, {-0.3566749439387323, "", {
              0.01, 0}}, {-0.2231435513142097, "", {
              0.01, 0}}, {-0.10536051565782628`, "", {0.01, 0}}, {
             0., "1", {0.02, 0.}}, {0.6931471805599453, "", {0.01, 0}}, {
             1.0986122886681098`, "", {0.01, 0}}, {
             1.3862943611198906`, "", {0.01, 0}}, {
             1.6094379124341003`, "", {0.01, 0}}, {
             1.791759469228055, "", {0.01, 0}}, {
             1.9459101490553132`, "", {0.01, 0}}, {
             2.0794415416798357`, "", {0.01, 0}}, {
             2.1972245773362196`, "", {0.01, 0}}, {
             2.302585092994046, "\!\(\*SuperscriptBox[\(10\), \(1\)]\)", {
              0.02, 0.}}, {2.995732273553991, "", {0.01, 0}}, {
             3.4011973816621555`, "", {0.01, 0}}, {
             3.6888794541139363`, "", {0.01, 0}}, {
             3.912023005428146, "", {0.01, 0}}, {
             4.0943445622221, "", {0.01, 0}}, {
             4.248495242049359, "", {0.01, 0}}, {
             4.382026634673881, "", {0.01, 0}}, {
             4.499809670330265, "", {0.01, 0}}, {
             4.605170185988092, "\!\(\*SuperscriptBox[\(10\), \(2\)]\)", {
              0.02, 0.}}, {5.298317366548036, "", {0.01, 0}}, {
             5.703782474656201, "", {0.01, 0}}, {
             5.991464547107982, "", {0.01, 0}}, {
             6.214608098422191, "", {0.01, 0}}, {
             6.396929655216146, "", {0.01, 0}}, {
             6.551080335043404, "", {0.01, 0}}, {
             6.684611727667927, "", {0.01, 0}}, {
             6.802394763324311, "", {0.01, 0}}, {
             6.907755278982137, "\!\(\*SuperscriptBox[\(10\), \(3\)]\)", {
              0.02, 0.}}, {7.600902459542082, "", {0.01, 0}}, {
             8.006367567650246, "", {0.01, 0}}, {
             8.294049640102028, "", {0.01, 0}}, {
             8.517193191416238, "", {0.01, 0}}, {
             8.699514748210191, "", {0.01, 0}}, {
             8.85366542803745, "", {0.01, 0}}, {
             8.987196820661973, "", {0.01, 0}}, {
             9.104979856318357, "", {0.01, 0}}, {
             9.210340371976184, "\!\(\*SuperscriptBox[\(10\), \(4\)]\)", {
              0.02, 0.}}, {9.903487552536127, "", {0.01, 0}}, {
             10.308952660644293`, "", {0.01, 0}}, {
             10.596634733096073`, "", {0.01, 0}}, {
             10.819778284410283`, "", {0.01, 0}}, {
             11.002099841204238`, "", {0.01, 0}}, {
             11.156250521031495`, "", {0.01, 0}}, {
             11.289781913656018`, "", {0.01, 0}}, {
             11.407564949312402`, "", {0.01, 0}}}, {{-13.815510557964274`, 
              ""}, {-13.122363377404328`, ""}, {-12.716898269296165`, 
              ""}, {-12.429216196844383`, ""}, {-12.206072645530174`, 
              ""}, {-12.02375108873622, ""}, {-11.86960040890896, 
              ""}, {-11.736069016284437`, ""}, {-11.618285980628055`, 
              ""}, {-11.512925464970229`, ""}, {-10.819778284410283`, 
              ""}, {-10.414313176302118`, ""}, {-10.126631103850338`, 
              ""}, {-9.903487552536127, ""}, {-9.721165995742174, 
              ""}, {-9.567015315914915, ""}, {-9.433483923290392, 
              ""}, {-9.315700887634009, ""}, {-9.210340371976182, 
              ""}, {-8.517193191416238, ""}, {-8.111728083308073, 
              ""}, {-7.824046010856292, ""}, {-7.600902459542082, 
              ""}, {-7.418580902748127, ""}, {-7.264430222920869, 
              ""}, {-7.1308988302963465`, ""}, {-7.013115794639964, 
              ""}, {-6.907755278982137, ""}, {-6.214608098422191, 
              ""}, {-5.809142990314028, ""}, {-5.521460917862246, 
              ""}, {-5.298317366548036, ""}, {-5.115995809754082, 
              ""}, {-4.961845129926823, ""}, {-4.8283137373023015`, 
              ""}, {-4.710530701645918, ""}, {-4.605170185988091, 
              ""}, {-3.912023005428146, ""}, {-3.506557897319982, 
              ""}, {-3.2188758248682006`, ""}, {-2.995732273553991, 
              ""}, {-2.8134107167600364`, ""}, {-2.659260036932778, 
              ""}, {-2.5257286443082556`, ""}, {-2.4079456086518722`, 
              ""}, {-2.3025850929940455`, ""}, {-1.6094379124341003`, 
              ""}, {-1.203972804325936, ""}, {-0.916290731874155, 
              ""}, {-0.6931471805599453, ""}, {-0.5108256237659905, 
              ""}, {-0.3566749439387323, ""}, {-0.2231435513142097, 
              ""}, {-0.10536051565782628`, ""}, {0., ""}, {
             0.6931471805599453, ""}, {1.0986122886681098`, ""}, {
             1.3862943611198906`, ""}, {1.6094379124341003`, ""}, {
             1.791759469228055, ""}, {1.9459101490553132`, ""}, {
             2.0794415416798357`, ""}, {2.1972245773362196`, ""}, {
             2.302585092994046, ""}, {2.995732273553991, ""}, {
             3.4011973816621555`, ""}, {3.6888794541139363`, ""}, {
             3.912023005428146, ""}, {4.0943445622221, ""}, {
             4.248495242049359, ""}, {4.382026634673881, ""}, {
             4.499809670330265, ""}, {4.605170185988092, ""}, {
             5.298317366548036, ""}, {5.703782474656201, ""}, {
             5.991464547107982, ""}, {6.214608098422191, ""}, {
             6.396929655216146, ""}, {6.551080335043404, ""}, {
             6.684611727667927, ""}, {6.802394763324311, ""}, {
             6.907755278982137, ""}, {7.600902459542082, ""}, {
             8.006367567650246, ""}, {8.294049640102028, ""}, {
             8.517193191416238, ""}, {8.699514748210191, ""}, {
             8.85366542803745, ""}, {8.987196820661973, ""}, {
             9.104979856318357, ""}, {9.210340371976184, ""}, {
             9.903487552536127, ""}, {10.308952660644293`, ""}, {
             10.596634733096073`, ""}, {10.819778284410283`, ""}, {
             11.002099841204238`, ""}, {11.156250521031495`, ""}, {
             11.289781913656018`, ""}, {
             11.407564949312402`, ""}}, {{-13.815510557964274`, 
              ""}, {-13.122363377404328`, ""}, {-12.716898269296165`, 
              ""}, {-12.429216196844383`, ""}, {-12.206072645530174`, 
              ""}, {-12.02375108873622, ""}, {-11.86960040890896, 
              ""}, {-11.736069016284437`, ""}, {-11.618285980628055`, 
              ""}, {-11.512925464970229`, ""}, {-10.819778284410283`, 
              ""}, {-10.414313176302118`, ""}, {-10.126631103850338`, 
              ""}, {-9.903487552536127, ""}, {-9.721165995742174, 
              ""}, {-9.567015315914915, ""}, {-9.433483923290392, 
              ""}, {-9.315700887634009, ""}, {-9.210340371976182, 
              ""}, {-8.517193191416238, ""}, {-8.111728083308073, 
              ""}, {-7.824046010856292, ""}, {-7.600902459542082, 
              ""}, {-7.418580902748127, ""}, {-7.264430222920869, 
              ""}, {-7.1308988302963465`, ""}, {-7.013115794639964, 
              ""}, {-6.907755278982137, ""}, {-6.214608098422191, 
              ""}, {-5.809142990314028, ""}, {-5.521460917862246, 
              ""}, {-5.298317366548036, ""}, {-5.115995809754082, 
              ""}, {-4.961845129926823, ""}, {-4.8283137373023015`, 
              ""}, {-4.710530701645918, ""}, {-4.605170185988091, 
              ""}, {-3.912023005428146, ""}, {-3.506557897319982, 
              ""}, {-3.2188758248682006`, ""}, {-2.995732273553991, 
              ""}, {-2.8134107167600364`, ""}, {-2.659260036932778, 
              ""}, {-2.5257286443082556`, ""}, {-2.4079456086518722`, 
              ""}, {-2.3025850929940455`, ""}, {-1.6094379124341003`, 
              ""}, {-1.203972804325936, ""}, {-0.916290731874155, 
              ""}, {-0.6931471805599453, ""}, {-0.5108256237659905, 
              ""}, {-0.3566749439387323, ""}, {-0.2231435513142097, 
              ""}, {-0.10536051565782628`, ""}, {0., ""}, {
             0.6931471805599453, ""}, {1.0986122886681098`, ""}, {
             1.3862943611198906`, ""}, {1.6094379124341003`, ""}, {
             1.791759469228055, ""}, {1.9459101490553132`, ""}, {
             2.0794415416798357`, ""}, {2.1972245773362196`, ""}, {
             2.302585092994046, ""}, {2.995732273553991, ""}, {
             3.4011973816621555`, ""}, {3.6888794541139363`, ""}, {
             3.912023005428146, ""}, {4.0943445622221, ""}, {
             4.248495242049359, ""}, {4.382026634673881, ""}, {
             4.499809670330265, ""}, {4.605170185988092, ""}, {
             5.298317366548036, ""}, {5.703782474656201, ""}, {
             5.991464547107982, ""}, {6.214608098422191, ""}, {
             6.396929655216146, ""}, {6.551080335043404, ""}, {
             6.684611727667927, ""}, {6.802394763324311, ""}, {
             6.907755278982137, ""}, {7.600902459542082, ""}, {
             8.006367567650246, ""}, {8.294049640102028, ""}, {
             8.517193191416238, ""}, {8.699514748210191, ""}, {
             8.85366542803745, ""}, {8.987196820661973, ""}, {
             9.104979856318357, ""}, {9.210340371976184, ""}, {
             9.903487552536127, ""}, {10.308952660644293`, ""}, {
             10.596634733096073`, ""}, {10.819778284410283`, ""}, {
             11.002099841204238`, ""}, {11.156250521031495`, ""}, {
             11.289781913656018`, ""}, {11.407564949312402`, ""}}}, Axes -> 
          False, PlotLabel -> 
          Style["\!\(\*SubscriptBox[\(r\), \(i\)]\) (Residual), CT14NNLO", 24, 
            GrayLevel[0]], FrameLabel -> {
            Style["x", 18, 
             GrayLevel[0]], 
            Style["\[Mu] [GeV]", 18, 
             GrayLevel[0]]}, FrameTicksStyle -> GrayLevel[0], 
          ImageSize -> {{600}, {600}}, AspectRatio -> 1., 
          GridLines -> {{-16.11809565095832, -13.815510557964274`, \
-11.512925464970229`, -9.210340371976182, -6.907755278982137, \
-4.605170185988091, -2.3025850929940455`}, {
             Log[10], 
             Log[50], 
             Log[100], 
             Log[500], 
             Log[1000], 
             Log[5000], 
             Log[10000]}}, GridLinesStyle -> Directive[
            Dashing[{Small, Small}]], PlotRangeClipping -> True, 
          DisplayFunction -> Identity, PlotRangePadding -> {{0, 0}, {0, 0}}, 
          AxesOrigin -> {0, 0}, PlotRange -> {{-Log[100000], 0}, {0, 
             Log[6000]}}, PlotRangeClipping -> True, ImagePadding -> All, 
          DisplayFunction -> Identity, AspectRatio -> 1, Axes -> {True, True},
           AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
          Identity, Epilog -> {{
             Text[
              Style["Npt: 3966", 16, 
               GrayLevel[0]], 
              Scaled[{0.1, 0.9}]], 
             Text[
              Style["highlighted range:\n{{-100, -1}, {1, 100}}", 16, 
               GrayLevel[0]], 
              Scaled[{0.2, 0.7}]]}, {{
              Text[
               Style["Npt: 3966", 16, 
                GrayLevel[0]], 
               Scaled[{0.1, 0.9}]], 
              Text[
               Style["highlighted range:\n{{-100, -1}, {1, 100}}", 16, 
                GrayLevel[0]], 
               Scaled[{0.2, 0.7}]]}}}, 
          Frame -> {{False, False}, {False, False}}, 
          FrameLabel -> {{None, None}, {None, None}}, 
          FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
          GridLines -> {None, None}, GridLinesStyle -> Directive[
            GrayLevel[0.5, 0.4]], 
          Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& )}}, PlotRange -> {{-Log[100000], 0}, {0, 
             Log[6000]}}, PlotRangeClipping -> True, 
          PlotRangePadding -> {{0, 0}, {0, 0}}, 
          Ticks -> {Automatic, Automatic}}], 
        Placed[
         Unevaluated[
          BarLegend[{{
             RGBColor[0., 0., 0.7], 
             RGBColor[0., 0., 0.7], 
             RGBColor[0., 0.5, 0.75], 
             RGBColor[0., 0.75, 0.75], 
             RGBColor[0, 0.7, 0], 
             RGBColor[0.75, 0.75, 0.], 
             RGBColor[0.75, 0.55, 0.], 
             RGBColor[0.7, 0., 0.], 
             RGBColor[0.7, 0., 0.]}, {-3.006003, 
            3.009003}}, {-3.006003, -3., -2., -1.3333333333333333`, \
-0.8888888888888888, 0.8888888888888888, 1.3333333333333333`, 2., 
           3.0029999999999997`, 3.009003}, LabelStyle -> {FontSize -> 14, 
             GrayLevel[0]}, LegendLabel -> "", LegendLayout -> "Column", 
           LegendMarkerSize -> {}, Charting`TickAnnotations -> None, 
           Charting`TickSide -> Right, ColorFunctionScaling -> True]], {1., 
         0.5}, Identity]]& ],
      AutoDelete->True,
      Editable->True,
      SelectWithContents->False,
      Selectable->True], ",", 
     TagBox[GridBox[{
        {
         InterpretationBox[Cell[BoxData[
           FormBox[
            
            StyleBox["\<\"\\!\\(\\*SubscriptBox[\\(r\\), \\(i\\)]\\) \
(Residual), CT14NNLO\\n\\n\"\>",
             StripOnInput->False,
             FontSize->24], TextForm]], "InlineText"],
          Text[
           Style[
           "\!\(\*SubscriptBox[\(r\), \(i\)]\) (Residual), CT14NNLO\n\n", 
            FontSize -> 24]]], "\[SpanFromLeft]", "\[SpanFromLeft]"},
        {"\<\"Data Sets\"\>", "", ""},
        {"\<\"\[FilledCircle]BcdF2pCor(101)\"\>", \
"\<\"\[FilledSquare]BcdF2dCor(102)\"\>", \
"\<\"\[FilledDiamond]NmcRatCor(104)\"\>"},
        {"\<\"\[FilledUpTriangle]cdhswf2(108)\"\>", \
"\<\"\[FilledDownTriangle]cdhswf3(109)\"\>", \
"\<\"\[EmptyCircle]ccfrf2.mi(110)\"\>"},
        {"\<\"\[EmptySquare]ccfrf3.md(111)\"\>", \
"\<\"\[EmptyDiamond]NuTvNuChXN(124)\"\>", \
"\<\"\[EmptyUpTriangle]NuTvNbChXN(125)\"\>"},
        {"\<\"\[EmptyDownTriangle]CcfrNuChXN(126)\"\>", \
"\<\"\[Times]CcfrNbChXN(127)\"\>", "\<\"\[CircleMinus]Hn1X0c(147)\"\>"},
        {"\<\"\[FivePointedStar]e605(201)\"\>", \
"\<\"\[FilledCircle]e866f(203)\"\>", "\<\"\[FilledSquare]e866ppxf(204)\"\>"},
        {"\<\"\[FilledDiamond]cdfLasy(225)\"\>", \
"\<\"\[FilledUpTriangle]cdfLasy2(227)\"\>", \
"\<\"\[FilledDownTriangle]d02Masy1(234)\"\>"},
        {"\<\"\[EmptyCircle]ZyD02a(260)\"\>", \
"\<\"\[EmptySquare]cdf2jtCor2(504)\"\>", "\<\"\[EmptyDiamond]d02jtCor2(514)\"\
\>"},
        {"\<\"\[EmptyUpTriangle]Hn+9900x0b(145)\"\>", "\<\"\
\[EmptyDownTriangle]H1FL10(169)\"\>", "\<\"\[Times]ATL7_WZ(268)\"\>"},
        {"\<\"\[CircleMinus]ATL7jtR6(535)\"\>", \
"\<\"\[FivePointedStar]LHCb7_WZ1(240)\"\>", \
"\<\"\[FilledCircle]LHCb7Wasy1(241)\"\>"},
        {"\<\"\[FilledSquare]d02Easy5(281)\"\>", \
"\<\"\[FilledDiamond]CMS7Masy2(266)\"\>", \
"\<\"\[FilledUpTriangle]CMS7jtR7v2(538)\"\>"},
        {"\<\"\[FilledDownTriangle]LHCb7ZWrap(245)\"\>", \
"\<\"\[EmptyCircle]LHCb8Zeer(246)\"\>", "\<\"\[EmptySquare]ATL7ZW(248)\"\>"},
        {"\<\"\[EmptyDiamond]CMS7jtR7y6(542)\"\>", \
"\<\"\[EmptyUpTriangle]ATL7jtR6u(544)\"\>", \
"\<\"\[EmptyDownTriangle]CMS8Wxa(249)\"\>"},
        {"\<\"\[Times]LHCb8WZ(250)\"\>", \
"\<\"\[CircleMinus]ATL8ttpt(565)\"\>", "\<\"\[FivePointedStar]ATL8ttya(566)\"\
\>"},
        {"\<\"\[FilledCircle]ATL8ttmtt(567)\"\>", \
"\<\"\[FilledSquare]ATL8ttytt(568)\"\>", ""},
        {
         InterpretationBox[Cell[BoxData[
           FormBox[
            StyleBox["\<\"\"\>",
             StripOnInput->False,
             FontSize->16], TextForm]], "InlineText"],
          Text[
           Style["", FontSize -> 16]]], "\[SpanFromLeft]", "\[SpanFromLeft]"}
       },
       AutoDelete->False,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{14}}},
       GridBoxItemStyle->{"Columns" -> {{
            Directive[FontSize -> 18, 
             GrayLevel[0]]}}, "Rows" -> {{
            Directive[FontSize -> 18, 
             GrayLevel[0]]}}}],
      "Grid"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     GraphicsBox[{
       {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
        EdgeForm[Opacity[0.]], {}, 
        {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
         EdgeForm[Opacity[0.]], RectangleBox[{-15.42, 0}, {-15.36, 2},
          RoundingRadius->0], RectangleBox[{-14.82, 0}, {-14.76, 2},
          RoundingRadius->0], RectangleBox[{-14.1, 0}, {-14.04, 2},
          RoundingRadius->0], RectangleBox[{-13.86, 0}, {-13.8, 2},
          RoundingRadius->0], 
         RectangleBox[{-13.68, 0}, {-13.620000000000001, 2},
          RoundingRadius->0], RectangleBox[{-11.52, 0}, {-11.46, 4},
          RoundingRadius->0], RectangleBox[{-11.46, 0}, {-11.4, 2},
          RoundingRadius->0], RectangleBox[{-10.86, 0}, {-10.8, 2},
          RoundingRadius->0], RectangleBox[{-8.7, 0}, {-8.64, 2},
          RoundingRadius->0], RectangleBox[{-8.52, 0}, {-8.46, 2},
          RoundingRadius->0], RectangleBox[{-8.22, 0}, {-8.16, 4},
          RoundingRadius->0], RectangleBox[{-7.98, 0}, {-7.92, 2},
          RoundingRadius->0], RectangleBox[{-7.5, 0}, {-7.44, 2},
          RoundingRadius->0], 
         RectangleBox[{-6.960000000000001, 0}, {-6.9, 2},
          RoundingRadius->0], 
         RectangleBox[{-6.779999999999999, 0}, {-6.720000000000001, 2},
          RoundingRadius->0], 
         RectangleBox[{-6.540000000000001, 0}, {-6.48, 2},
          RoundingRadius->0], RectangleBox[{-6.24, 0}, {-6.18, 2},
          RoundingRadius->0], 
         RectangleBox[{-6.18, 0}, {-6.120000000000001, 2},
          RoundingRadius->0], 
         RectangleBox[{-5.76, 0}, {-5.700000000000001, 2},
          RoundingRadius->0], 
         RectangleBox[{-5.52, 0}, {-5.460000000000001, 2},
          RoundingRadius->0], 
         RectangleBox[{-5.34, 0}, {-5.280000000000001, 2},
          RoundingRadius->0], RectangleBox[{-4.74, 0}, {-4.68, 2},
          RoundingRadius->0], 
         RectangleBox[{-4.5600000000000005, 0}, {-4.5, 2},
          RoundingRadius->0], 
         RectangleBox[{-4.26, 0}, {-4.200000000000001, 2},
          RoundingRadius->0], 
         RectangleBox[{-4.200000000000001, 0}, {-4.140000000000001, 2},
          RoundingRadius->0], 
         RectangleBox[{-4.140000000000001, 0}, {-4.08, 2},
          RoundingRadius->0], RectangleBox[{-4.08, 0}, {-4.02, 2},
          RoundingRadius->0], 
         RectangleBox[{-3.9000000000000004, 0}, {-3.84, 8},
          RoundingRadius->0], 
         RectangleBox[{-3.84, 0}, {-3.780000000000001, 2},
          RoundingRadius->0], 
         RectangleBox[{-3.780000000000001, 0}, {-3.7200000000000006, 2},
          RoundingRadius->0], 
         RectangleBox[{-3.7200000000000006, 0}, {-3.66, 2},
          RoundingRadius->0], 
         RectangleBox[{-3.66, 0}, {-3.5999999999999996, 2},
          RoundingRadius->0], 
         RectangleBox[{-3.5999999999999996, 0}, {-3.540000000000001, 4},
          RoundingRadius->0], 
         RectangleBox[{-3.540000000000001, 0}, {-3.4800000000000004, 4},
          RoundingRadius->0], 
         RectangleBox[{-3.42, 0}, {-3.360000000000001, 2},
          RoundingRadius->0], 
         RectangleBox[{-3.360000000000001, 0}, {-3.3000000000000007, 8},
          RoundingRadius->0], 
         RectangleBox[{-3.3000000000000007, 0}, {-3.24, 8},
          RoundingRadius->0], 
         RectangleBox[{-3.24, 0}, {-3.1799999999999997, 2},
          RoundingRadius->0], 
         RectangleBox[{-3.1799999999999997, 0}, {-3.120000000000001, 2},
          RoundingRadius->0], 
         RectangleBox[{-3.120000000000001, 0}, {-3.0600000000000005, 4},
          RoundingRadius->0], 
         RectangleBox[{-3.0600000000000005, 0}, {-3., 1},
          RoundingRadius->0], 
         RectangleBox[{-3., 0}, {-2.9399999999999995, 10},
          RoundingRadius->0], 
         RectangleBox[{-2.9399999999999995, 0}, {-2.880000000000001, 8},
          RoundingRadius->0], 
         RectangleBox[{-2.880000000000001, 0}, {-2.8200000000000003, 2},
          RoundingRadius->0], 
         RectangleBox[{-2.8200000000000003, 0}, {-2.76, 1},
          RoundingRadius->0], 
         RectangleBox[{-2.76, 0}, {-2.700000000000001, 1},
          RoundingRadius->0], 
         RectangleBox[{-2.700000000000001, 0}, {-2.6400000000000006, 4},
          RoundingRadius->0], 
         RectangleBox[{-2.6400000000000006, 0}, {-2.58, 6},
          RoundingRadius->0], 
         RectangleBox[{-2.58, 0}, {-2.5199999999999996, 6},
          RoundingRadius->0], 
         RectangleBox[{-2.5199999999999996, 0}, {-2.460000000000001, 7},
          RoundingRadius->0], 
         RectangleBox[{-2.460000000000001, 0}, {-2.4000000000000004, 9},
          RoundingRadius->0], 
         RectangleBox[{-2.4000000000000004, 0}, {-2.34, 11},
          RoundingRadius->0], 
         RectangleBox[{-2.34, 0}, {-2.280000000000001, 2},
          RoundingRadius->0], 
         RectangleBox[{-2.280000000000001, 0}, {-2.2200000000000006, 8},
          RoundingRadius->0], 
         RectangleBox[{-2.2200000000000006, 0}, {-2.16, 1},
          RoundingRadius->0], 
         RectangleBox[{-2.16, 0}, {-2.0999999999999996, 8},
          RoundingRadius->0], 
         RectangleBox[{-2.0999999999999996, 0}, {-2.040000000000001, 9},
          RoundingRadius->0], 
         RectangleBox[{-2.040000000000001, 0}, {-1.9800000000000004, 17},
          RoundingRadius->0], 
         RectangleBox[{-1.9800000000000004, 0}, {-1.92, 13},
          RoundingRadius->0], 
         RectangleBox[{-1.92, 0}, {-1.8600000000000012, 16},
          RoundingRadius->0], 
         RectangleBox[{-1.8600000000000012, 0}, {-1.8000000000000007, 8},
          RoundingRadius->0], 
         RectangleBox[{-1.8000000000000007, 0}, {-1.7400000000000002, 23},
          RoundingRadius->0], 
         RectangleBox[{-1.7400000000000002, 0}, {-1.6799999999999997, 22},
          RoundingRadius->0], 
         RectangleBox[{-1.6799999999999997, 0}, {-1.620000000000001, 29},
          RoundingRadius->0], 
         RectangleBox[{-1.620000000000001, 0}, {-1.5600000000000005, 30},
          RoundingRadius->0], 
         RectangleBox[{-1.5600000000000005, 0}, {-1.5, 33},
          RoundingRadius->0], 
         RectangleBox[{-1.5, 0}, {-1.4400000000000013, 34},
          RoundingRadius->0], 
         RectangleBox[{-1.4400000000000013, 0}, {-1.3800000000000008, 43},
          RoundingRadius->0], 
         RectangleBox[{-1.3800000000000008, 0}, {-1.3200000000000003, 39},
          RoundingRadius->0], 
         RectangleBox[{-1.3200000000000003, 0}, {-1.2599999999999998, 41},
          RoundingRadius->0], 
         RectangleBox[{-1.2599999999999998, 0}, {-1.200000000000001, 43},
          RoundingRadius->0], 
         RectangleBox[{-1.200000000000001, 0}, {-1.1400000000000006, 48},
          RoundingRadius->0], 
         RectangleBox[{-1.1400000000000006, 0}, {-1.08, 69},
          RoundingRadius->0], 
         RectangleBox[{-1.08, 0}, {-1.0200000000000014, 42},
          RoundingRadius->0], 
         RectangleBox[{-1.0200000000000014, 0}, {-0.9600000000000009, 70},
          RoundingRadius->0], 
         RectangleBox[{-0.9600000000000009, 0}, {-0.9000000000000004, 62},
          RoundingRadius->0], 
         RectangleBox[{-0.9000000000000004, 0}, {-0.8399999999999999, 71},
          RoundingRadius->0], 
         RectangleBox[{-0.8399999999999999, 0}, {-0.7800000000000011, 53},
          RoundingRadius->0], 
         RectangleBox[{-0.7800000000000011, 0}, {-0.7200000000000006, 76},
          RoundingRadius->0], 
         RectangleBox[{-0.7200000000000006, 0}, {-0.6600000000000001, 60},
          RoundingRadius->0], 
         RectangleBox[{-0.6600000000000001, 0}, {-0.5999999999999996, 80},
          RoundingRadius->0], 
         RectangleBox[{-0.5999999999999996, 0}, {-0.5400000000000009, 88},
          RoundingRadius->0], 
         RectangleBox[{-0.5400000000000009, 0}, {-0.4800000000000004, 92},
          RoundingRadius->0], 
         RectangleBox[{-0.4800000000000004, 0}, {-0.41999999999999993, 91},
          RoundingRadius->0], 
         RectangleBox[{-0.41999999999999993, 0}, {-0.3600000000000012, 86},
          RoundingRadius->0], 
         RectangleBox[{-0.3600000000000012, 0}, {-0.3000000000000007, 102},
          RoundingRadius->0], 
         RectangleBox[{-0.3000000000000007, 0}, {-0.2400000000000002, 93},
          RoundingRadius->0], 
         RectangleBox[{-0.2400000000000002, 0}, {-0.17999999999999972, 81},
          RoundingRadius->0], 
         RectangleBox[{-0.17999999999999972, 0}, {-0.120000000000001, 101},
          RoundingRadius->0], 
         RectangleBox[{-0.120000000000001, 0}, {-0.0600000000000005, 67},
          RoundingRadius->0], 
         RectangleBox[{-0.0600000000000005, 0}, {0., 91},
          RoundingRadius->0], 
         RectangleBox[{0., 0}, {0.05999999999999872, 77},
          RoundingRadius->0], 
         RectangleBox[{0.05999999999999872, 0}, {0.11999999999999922, 82},
          RoundingRadius->0], 
         RectangleBox[{0.11999999999999922, 0}, {0.17999999999999972, 86},
          RoundingRadius->0], 
         RectangleBox[{0.17999999999999972, 0}, {0.2400000000000002, 71},
          RoundingRadius->0], 
         RectangleBox[{0.2400000000000002, 0}, {0.29999999999999893, 106},
          RoundingRadius->0], 
         RectangleBox[{0.29999999999999893, 0}, {0.35999999999999943, 69},
          RoundingRadius->0], 
         RectangleBox[{0.35999999999999943, 0}, {0.41999999999999993, 76},
          RoundingRadius->0], 
         RectangleBox[{0.41999999999999993, 0}, {0.47999999999999865, 69},
          RoundingRadius->0], 
         RectangleBox[{0.47999999999999865, 0}, {0.5399999999999991, 72},
          RoundingRadius->0], 
         RectangleBox[{0.5399999999999991, 0}, {0.5999999999999996, 84},
          RoundingRadius->0], 
         RectangleBox[{0.5999999999999996, 0}, {0.6599999999999984, 62},
          RoundingRadius->0], 
         RectangleBox[{0.6599999999999984, 0}, {0.7200000000000006, 64},
          RoundingRadius->0], 
         RectangleBox[{0.7200000000000006, 0}, {0.7799999999999994, 64},
          RoundingRadius->0], 
         RectangleBox[{0.7799999999999994, 0}, {0.8399999999999981, 66},
          RoundingRadius->0], 
         RectangleBox[{0.8399999999999981, 0}, {0.9000000000000004, 47},
          RoundingRadius->0], 
         RectangleBox[{0.9000000000000004, 0}, {0.9599999999999991, 65},
          RoundingRadius->0], 
         RectangleBox[{0.9599999999999991, 0}, {1.0199999999999978, 54},
          RoundingRadius->0], 
         RectangleBox[{1.0199999999999978, 0}, {1.08, 36},
          RoundingRadius->0], 
         RectangleBox[{1.08, 0}, {1.1399999999999988, 43},
          RoundingRadius->0], 
         RectangleBox[{1.1399999999999988, 0}, {1.200000000000001, 39},
          RoundingRadius->0], 
         RectangleBox[{1.200000000000001, 0}, {1.2599999999999998, 30},
          RoundingRadius->0], 
         RectangleBox[{1.2599999999999998, 0}, {1.3199999999999985, 24},
          RoundingRadius->0], 
         RectangleBox[{1.3199999999999985, 0}, {1.3800000000000008, 20},
          RoundingRadius->0], 
         RectangleBox[{1.3800000000000008, 0}, {1.4399999999999995, 37},
          RoundingRadius->0], 
         RectangleBox[{1.4399999999999995, 0}, {1.4999999999999982, 27},
          RoundingRadius->0], 
         RectangleBox[{1.4999999999999982, 0}, {1.5600000000000005, 28},
          RoundingRadius->0], 
         RectangleBox[{1.5600000000000005, 0}, {1.6199999999999992, 25},
          RoundingRadius->0], 
         RectangleBox[{1.6199999999999992, 0}, {1.679999999999998, 26},
          RoundingRadius->0], 
         RectangleBox[{1.679999999999998, 0}, {1.7400000000000002, 14},
          RoundingRadius->0], 
         RectangleBox[{1.7400000000000002, 0}, {1.799999999999999, 27},
          RoundingRadius->0], 
         RectangleBox[{1.799999999999999, 0}, {1.8600000000000012, 17},
          RoundingRadius->0], 
         RectangleBox[{1.8600000000000012, 0}, {1.92, 18},
          RoundingRadius->0], 
         RectangleBox[{1.92, 0}, {1.9799999999999986, 19},
          RoundingRadius->0], 
         RectangleBox[{1.9799999999999986, 0}, {2.040000000000001, 16},
          RoundingRadius->0], 
         RectangleBox[{2.040000000000001, 0}, {2.0999999999999996, 13},
          RoundingRadius->0], 
         RectangleBox[{2.0999999999999996, 0}, {2.1599999999999984, 13},
          RoundingRadius->0], 
         RectangleBox[{2.1599999999999984, 0}, {2.2200000000000006, 18},
          RoundingRadius->0], 
         RectangleBox[{2.2200000000000006, 0}, {2.2799999999999994, 12},
          RoundingRadius->0], 
         RectangleBox[{2.2799999999999994, 0}, {2.339999999999998, 13},
          RoundingRadius->0], 
         RectangleBox[{2.339999999999998, 0}, {2.4000000000000004, 8},
          RoundingRadius->0], 
         RectangleBox[{2.4000000000000004, 0}, {2.459999999999999, 7},
          RoundingRadius->0], 
         RectangleBox[{2.459999999999999, 0}, {2.519999999999998, 4},
          RoundingRadius->0], RectangleBox[{2.519999999999998, 0}, {2.58, 3},
          RoundingRadius->0], RectangleBox[{2.58, 0}, {2.639999999999999, 5},
          RoundingRadius->0], 
         RectangleBox[{2.639999999999999, 0}, {2.700000000000001, 7},
          RoundingRadius->0], RectangleBox[{2.700000000000001, 0}, {2.76, 4},
          RoundingRadius->0], 
         RectangleBox[{2.76, 0}, {2.8199999999999985, 6},
          RoundingRadius->0], 
         RectangleBox[{2.8199999999999985, 0}, {2.880000000000001, 3},
          RoundingRadius->0], 
         RectangleBox[{2.880000000000001, 0}, {2.9399999999999995, 5},
          RoundingRadius->0], 
         RectangleBox[{2.9399999999999995, 0}, {2.9999999999999982, 5},
          RoundingRadius->0], 
         RectangleBox[{2.9999999999999982, 0}, {3.0600000000000005, 4},
          RoundingRadius->0], 
         RectangleBox[{3.0600000000000005, 0}, {3.119999999999999, 2},
          RoundingRadius->0], RectangleBox[{3.179999999999998, 0}, {3.24, 2},
          RoundingRadius->0], RectangleBox[{3.24, 0}, {3.299999999999999, 2},
          RoundingRadius->0], 
         RectangleBox[{3.3599999999999977, 0}, {3.42, 2},
          RoundingRadius->0], 
         RectangleBox[{3.42, 0}, {3.4799999999999986, 2},
          RoundingRadius->0], 
         RectangleBox[{3.540000000000001, 0}, {3.5999999999999996, 2},
          RoundingRadius->0], 
         RectangleBox[{3.6599999999999984, 0}, {3.7200000000000006, 2},
          RoundingRadius->0], 
         RectangleBox[{3.7799999999999994, 0}, {3.839999999999998, 2},
          RoundingRadius->0], RectangleBox[{4.019999999999998, 0}, {4.08, 2},
          RoundingRadius->0], 
         RectangleBox[{4.380000000000001, 0}, {4.4399999999999995, 4},
          RoundingRadius->0], 
         RectangleBox[{4.499999999999998, 0}, {4.5600000000000005, 2},
          RoundingRadius->0], RectangleBox[{4.679999999999998, 0}, {4.74, 2},
          RoundingRadius->0], 
         RectangleBox[{5.159999999999998, 0}, {5.220000000000001, 2},
          RoundingRadius->0], RectangleBox[{5.519999999999998, 0}, {5.58, 2},
          RoundingRadius->0], 
         RectangleBox[{5.76, 0}, {5.8199999999999985, 2},
          RoundingRadius->0], 
         RectangleBox[{5.8199999999999985, 0}, {5.880000000000001, 2},
          RoundingRadius->0], 
         RectangleBox[{5.999999999999998, 0}, {6.0600000000000005, 4},
          RoundingRadius->0], 
         RectangleBox[{6.0600000000000005, 0}, {6.119999999999999, 2},
          RoundingRadius->0], RectangleBox[{6.359999999999998, 0}, {6.42, 2},
          RoundingRadius->0], RectangleBox[{6.42, 0}, {6.479999999999999, 2},
          RoundingRadius->0], 
         RectangleBox[{6.779999999999999, 0}, {6.839999999999998, 2},
          RoundingRadius->0], RectangleBox[{8.76, 0}, {8.819999999999999, 2},
          RoundingRadius->0], RectangleBox[{8.88, 0}, {8.94, 4},
          RoundingRadius->0], 
         RectangleBox[{11.039999999999997, 0}, {11.1, 2},
          RoundingRadius->0], 
         RectangleBox[{11.339999999999998, 0}, {11.4, 2},
          RoundingRadius->0], 
         RectangleBox[{13.26, 0}, {13.319999999999999, 2},
          RoundingRadius->0], 
         RectangleBox[{13.92, 0}, {13.979999999999999, 2},
          
          RoundingRadius->
           0]}, {}, {}}, {{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}}},
      AspectRatio->1,
      Axes->False,
      AxesLabel->{None, None},
      AxesOrigin->{-3.12, 0.},
      BaseStyle->{FontSize -> 16},
      Epilog->{{
         Thickness[Large], {
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[0.7, 0., 0.], StripOnInput -> False], 
            TraditionalForm], {-1, 104.41}], 
          StyleBox[
           LineBox[{{-1, 0.}, {-1, 100.69999999999999`}}], 
           RGBColor[0.7, 0., 0.], StripOnInput -> False]}, {
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[0.7, 0., 0.], StripOnInput -> False], 
            TraditionalForm], {1, 100.16999999999999`}], 
          StyleBox[
           LineBox[{{1, 0.}, {1, 100.69999999999999`}}], 
           RGBColor[0.7, 0., 0.], StripOnInput -> False]}}, {
         Thickness[Large], 
         StyleBox[
          LineBox[{{-100, 0.}, {-1, 0.}}], 
          RGBColor[0., 0., 0.7], StripOnInput -> False], 
         StyleBox[
          LineBox[{{1, 0.}, {100, 0.}}], 
          RGBColor[0., 0., 0.7], StripOnInput -> False]}, 
        InsetBox[
         FormBox[
          StyleBox["\"Npt: 3966\"", 16, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         Scaled[{0.1, 0.9}]]},
      Frame->True,
      FrameLabel->{
        FormBox[
         StyleBox[
         "\"\\!\\(\\*SubscriptBox[\\(r\\), \\(i\\)]\\) (Residual)\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm], 
        FormBox[
         StyleBox["\"#points\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm]},
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImageSize->{{600}, {600}},
      PlotLabel->FormBox[
        StyleBox[
        "\"\\!\\(\\*SubscriptBox[\\(r\\), \\(i\\)]\\) (Residual), CT14NNLO\"",
          24, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{-3., 3.}, {0., 106}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}], ",", 
     GraphicsBox[{
       {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
        EdgeForm[{Opacity[0.33599999999999997`], Thickness[Small]}], {}, 
        {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
         EdgeForm[{Opacity[0.33599999999999997`], Thickness[Small]}], 
         RectangleBox[{0., 0}, {0.06, 168},
          RoundingRadius->0], RectangleBox[{0.06, 0}, {0.12, 149},
          RoundingRadius->0], RectangleBox[{0.12, 0}, {0.18, 187},
          RoundingRadius->0], RectangleBox[{0.18, 0}, {0.24, 152},
          RoundingRadius->0], RectangleBox[{0.24, 0}, {0.3, 198},
          RoundingRadius->0], RectangleBox[{0.3, 0}, {0.36, 171},
          RoundingRadius->0], RectangleBox[{0.36, 0}, {0.42, 162},
          RoundingRadius->0], 
         RectangleBox[{0.42, 0}, {0.48000000000000004, 161},
          RoundingRadius->0], 
         RectangleBox[{0.48000000000000004, 0}, {0.54, 164},
          RoundingRadius->0], 
         RectangleBox[{0.54, 0}, {0.5999999999999999, 172},
          RoundingRadius->0], 
         RectangleBox[{0.5999999999999999, 0}, {0.6599999999999999, 142},
          RoundingRadius->0], 
         RectangleBox[{0.6599999999999999, 0}, {0.72, 124},
          RoundingRadius->0], RectangleBox[{0.72, 0}, {0.78, 140},
          RoundingRadius->0], 
         RectangleBox[{0.78, 0}, {0.8399999999999999, 119},
          RoundingRadius->0], 
         RectangleBox[{0.8399999999999999, 0}, {0.8999999999999999, 118},
          RoundingRadius->0], 
         RectangleBox[{0.8999999999999999, 0}, {0.96, 127},
          RoundingRadius->0], RectangleBox[{0.96, 0}, {1.02, 124},
          RoundingRadius->0], 
         RectangleBox[{1.02, 0}, {1.0799999999999998, 75},
          RoundingRadius->0], 
         RectangleBox[{1.0799999999999998, 0}, {1.14, 113},
          RoundingRadius->0], RectangleBox[{1.14, 0}, {1.2, 89},
          RoundingRadius->0], 
         RectangleBox[{1.2, 0}, {1.2599999999999998, 73},
          RoundingRadius->0], 
         RectangleBox[{1.2599999999999998, 0}, {1.3199999999999998, 63},
          RoundingRadius->0], 
         RectangleBox[{1.3199999999999998, 0}, {1.38, 61},
          RoundingRadius->0], RectangleBox[{1.38, 0}, {1.44, 79},
          RoundingRadius->0], RectangleBox[{1.44, 0}, {1.5, 62},
          RoundingRadius->0], 
         RectangleBox[{1.5, 0}, {1.5599999999999998, 60},
          RoundingRadius->0], 
         RectangleBox[{1.5599999999999998, 0}, {1.6199999999999999, 56},
          RoundingRadius->0], 
         RectangleBox[{1.6199999999999999, 0}, {1.68, 55},
          RoundingRadius->0], 
         RectangleBox[{1.68, 0}, {1.7399999999999998, 36},
          RoundingRadius->0], 
         RectangleBox[{1.7399999999999998, 0}, {1.7999999999999998, 50},
          RoundingRadius->0], 
         RectangleBox[{1.7999999999999998, 0}, {1.8599999999999999, 25},
          RoundingRadius->0], 
         RectangleBox[{1.8599999999999999, 0}, {1.92, 34},
          RoundingRadius->0], RectangleBox[{1.92, 0}, {1.98, 32},
          RoundingRadius->0], RectangleBox[{1.98, 0}, {2.04, 33},
          RoundingRadius->0], RectangleBox[{2.04, 0}, {2.1, 22},
          RoundingRadius->0], 
         RectangleBox[{2.1, 0}, {2.1599999999999997, 21},
          RoundingRadius->0], 
         RectangleBox[{2.1599999999999997, 0}, {2.2199999999999998, 19},
          RoundingRadius->0], 
         RectangleBox[{2.2199999999999998, 0}, {2.28, 20},
          RoundingRadius->0], RectangleBox[{2.28, 0}, {2.34, 15},
          RoundingRadius->0], RectangleBox[{2.34, 0}, {2.4, 19},
          RoundingRadius->0], RectangleBox[{2.4, 0}, {2.46, 16},
          RoundingRadius->0], RectangleBox[{2.46, 0}, {2.52, 11},
          RoundingRadius->0], 
         RectangleBox[{2.52, 0}, {2.5799999999999996, 9},
          RoundingRadius->0], 
         RectangleBox[{2.5799999999999996, 0}, {2.6399999999999997, 11},
          RoundingRadius->0], 
         RectangleBox[{2.6399999999999997, 0}, {2.6999999999999997, 11},
          RoundingRadius->0], 
         RectangleBox[{2.6999999999999997, 0}, {2.76, 5},
          RoundingRadius->0], RectangleBox[{2.76, 0}, {2.82, 7},
          RoundingRadius->0], RectangleBox[{2.82, 0}, {2.88, 5},
          RoundingRadius->0], RectangleBox[{2.88, 0}, {2.94, 13},
          RoundingRadius->0], RectangleBox[{2.94, 0}, {3., 15},
          RoundingRadius->0], RectangleBox[{3., 0}, {3.06, 5},
          RoundingRadius->0], 
         RectangleBox[{3.06, 0}, {3.1199999999999997, 6},
          RoundingRadius->0], 
         RectangleBox[{3.1199999999999997, 0}, {3.1799999999999997, 2},
          RoundingRadius->0], 
         RectangleBox[{3.1799999999999997, 0}, {3.2399999999999998, 4},
          RoundingRadius->0], 
         RectangleBox[{3.2399999999999998, 0}, {3.3, 10},
          RoundingRadius->0], RectangleBox[{3.3, 0}, {3.36, 8},
          RoundingRadius->0], RectangleBox[{3.36, 0}, {3.42, 4},
          RoundingRadius->0], RectangleBox[{3.42, 0}, {3.48, 2},
          RoundingRadius->0], 
         RectangleBox[{3.48, 0}, {3.5399999999999996, 4},
          RoundingRadius->0], 
         RectangleBox[{3.5399999999999996, 0}, {3.5999999999999996, 6},
          RoundingRadius->0], 
         RectangleBox[{3.5999999999999996, 0}, {3.6599999999999997, 2},
          RoundingRadius->0], 
         RectangleBox[{3.6599999999999997, 0}, {3.7199999999999998, 4},
          RoundingRadius->0], 
         RectangleBox[{3.7199999999999998, 0}, {3.78, 2},
          RoundingRadius->0], RectangleBox[{3.78, 0}, {3.84, 4},
          RoundingRadius->0], RectangleBox[{3.84, 0}, {3.9, 8},
          RoundingRadius->0], 
         RectangleBox[{4.0200000000000005, 0}, {4.08, 4},
          RoundingRadius->0], RectangleBox[{4.08, 0}, {4.140000000000001, 2},
          RoundingRadius->0], RectangleBox[{4.140000000000001, 0}, {4.2, 2},
          RoundingRadius->0], RectangleBox[{4.2, 0}, {4.260000000000001, 2},
          RoundingRadius->0], RectangleBox[{4.38, 0}, {4.44, 4},
          RoundingRadius->0], RectangleBox[{4.5, 0}, {4.5600000000000005, 4},
          RoundingRadius->0], RectangleBox[{4.680000000000001, 0}, {4.74, 4},
          RoundingRadius->0], RectangleBox[{5.16, 0}, {5.22, 2},
          RoundingRadius->0], RectangleBox[{5.28, 0}, {5.34, 2},
          RoundingRadius->0], 
         RectangleBox[{5.46, 0}, {5.5200000000000005, 2},
          RoundingRadius->0], 
         RectangleBox[{5.5200000000000005, 0}, {5.58, 2},
          RoundingRadius->0], RectangleBox[{5.7, 0}, {5.76, 2},
          RoundingRadius->0], RectangleBox[{5.76, 0}, {5.82, 2},
          RoundingRadius->0], RectangleBox[{5.82, 0}, {5.88, 2},
          RoundingRadius->0], RectangleBox[{6., 0}, {6.0600000000000005, 4},
          RoundingRadius->0], 
         RectangleBox[{6.0600000000000005, 0}, {6.12, 2},
          RoundingRadius->0], RectangleBox[{6.12, 0}, {6.180000000000001, 2},
          RoundingRadius->0], RectangleBox[{6.180000000000001, 0}, {6.24, 2},
          RoundingRadius->0], RectangleBox[{6.36, 0}, {6.42, 2},
          RoundingRadius->0], RectangleBox[{6.42, 0}, {6.48, 2},
          RoundingRadius->0], RectangleBox[{6.48, 0}, {6.54, 2},
          RoundingRadius->0], RectangleBox[{6.72, 0}, {6.78, 2},
          RoundingRadius->0], RectangleBox[{6.78, 0}, {6.84, 2},
          RoundingRadius->0], RectangleBox[{6.9, 0}, {6.96, 2},
          RoundingRadius->0], RectangleBox[{7.44, 0}, {7.5, 2},
          RoundingRadius->0], 
         RectangleBox[{7.92, 0}, {7.9799999999999995, 2},
          RoundingRadius->0], 
         RectangleBox[{8.159999999999998, 0}, {8.219999999999999, 4},
          RoundingRadius->0], RectangleBox[{8.459999999999999, 0}, {8.52, 2},
          RoundingRadius->0], RectangleBox[{8.639999999999999, 0}, {8.7, 2},
          RoundingRadius->0], RectangleBox[{8.76, 0}, {8.819999999999999, 2},
          RoundingRadius->0], RectangleBox[{8.879999999999999, 0}, {8.94, 4},
          RoundingRadius->0], 
         RectangleBox[{10.799999999999999, 0}, {10.86, 2},
          RoundingRadius->0], RectangleBox[{11.04, 0}, {11.1, 2},
          RoundingRadius->0], 
         RectangleBox[{11.34, 0}, {11.399999999999999, 2},
          RoundingRadius->0], 
         RectangleBox[{11.399999999999999, 0}, {11.459999999999999, 2},
          RoundingRadius->0], 
         RectangleBox[{11.459999999999999, 0}, {11.52, 4},
          RoundingRadius->0], 
         RectangleBox[{13.26, 0}, {13.319999999999999, 2},
          RoundingRadius->0], RectangleBox[{13.62, 0}, {13.68, 2},
          RoundingRadius->0], 
         RectangleBox[{13.799999999999999, 0}, {13.86, 2},
          RoundingRadius->0], 
         RectangleBox[{13.919999999999998, 0}, {13.979999999999999, 2},
          RoundingRadius->0], RectangleBox[{14.04, 0}, {14.1, 2},
          RoundingRadius->0], 
         RectangleBox[{14.76, 0}, {14.819999999999999, 2},
          RoundingRadius->0], 
         RectangleBox[{15.36, 0}, {15.419999999999998, 2},
          
          RoundingRadius->
           0]}, {}, {}}, {{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}}},
      AspectRatio->1,
      Axes->False,
      AxesLabel->{None, None},
      AxesOrigin->{-0.06, 0.},
      BaseStyle->{FontSize -> 16},
      Epilog->{{
         Thickness[Large], {
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[0.7, 0., 0.], StripOnInput -> False], 
            TraditionalForm], {1, 195.03}], 
          StyleBox[
           LineBox[{{1, 0.}, {1, 188.1}}], 
           RGBColor[0.7, 0., 0.], StripOnInput -> False]}}, {
         Thickness[Large], 
         StyleBox[
          LineBox[{{-100, 0.}, {-1, 0.}}], 
          RGBColor[0., 0., 0.7], StripOnInput -> False], 
         StyleBox[
          LineBox[{{1, 0.}, {100, 0.}}], 
          RGBColor[0., 0., 0.7], StripOnInput -> False]}, 
        InsetBox[
         FormBox[
          StyleBox["\"Npt: 3966\"", 16, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         Scaled[{0.1, 0.9}]]},
      Frame->True,
      FrameLabel->{
        FormBox[
         StyleBox[
         "\"| \\!\\(\\*SubscriptBox[\\(r\\), \\(i\\)]\\) (Residual) |\"", 18, 
          
          GrayLevel[0], StripOnInput -> False], TraditionalForm], 
        FormBox[
         StyleBox["\"#points\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm]},
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImageSize->{{600}, {600}},
      PlotLabel->FormBox[
        StyleBox[
        "\"| \\!\\(\\*SubscriptBox[\\(r\\), \\(i\\)]\\) (Residual) |, \
CT14NNLO\"", 24, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{0., 3.}, {0., 198}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.7191956024979877`*^9, 3.719214623271879*^9, {3.71922286902711*^9, 
   3.719222889946849*^9}, 3.719737023434102*^9, 3.719737625555809*^9, 
   3.719737707558442*^9, 3.719738018129553*^9, 3.719739064185793*^9, 
   3.719739118041876*^9, 3.719749875710147*^9, 3.719750938534638*^9, 
   3.7197510658125887`*^9, 3.720631858358884*^9, 3.720635580773979*^9, 
   3.720635920769545*^9, 3.720636649734619*^9, 3.720637315623788*^9, 
   3.7207193347496023`*^9, 3.7207195085500298`*^9, 3.72071992029032*^9, 
   3.720720337492098*^9, 3.720720867514657*^9, 3.7210981879209948`*^9, 
   3.7211439970215387`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"processdataplotsmultiexp7percentage", "[", 
  RowBox[{
   RowBox[{"{", "dRdataclassfinal", "}"}], ",", 
   RowBox[{"readcorrconfigfile6", "[", 
    RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "4", ",", 
   "flavour"}], "]"}]], "Input",
 CellChangeTimes->{{3.7191955947020893`*^9, 3.719195594763839*^9}, {
  3.7192228999450083`*^9, 3.719222900037197*^9}, {3.721098245434761*^9, 
  3.7210982456250687`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     TagBox[
      GraphicsBox[{InsetBox[
         GraphicsBox[{{{{}, {{}, 
              {GrayLevel[1], PointSize[0.012833333333333334`], 
               AbsoluteThickness[1.6], 
               StyleBox[PointBox[{{0.00001, 2.}, {0.99, 1200.}}],
                FontFamily->"Helvetica"]}, {}}, {}, {}, {{}, {}}}, {
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3118381623295401, 2.6993457604720636}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6039529822035308, 2.6993457604720636}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.15455075984859803, 2.5756610130564646}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0091694886945044, 2.5756610130564646}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8027388571900397, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3348410795309749, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9317114296555002, 1.534714366238164}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3134438363289216, 1.534714366238164}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-7.1308988302963465, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.957577403480815, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1880994551696458, 2.3850863145057892}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3563472847519384, 2.3850863145057892}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.47352983902229373, 2.599722324216582}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6414447085691868, 2.599722324216582}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7505644514298959, 2.5817308344235403}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4007990473227723, 2.5817308344235403}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.409603402444116, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.1093512670354135, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3138891646209549, 2.5862591440482876}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.82821600623867, 2.5862591440482876}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.4286713586629105, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.12893600699172, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.6474092888860916, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0475390184841091, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.6204544951665047, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.5205117032396989, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.1454883067486056, 2.432735777459091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.30348549823721, 2.432735777459091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.18765575838465653, 2.6224923127405635}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.881903019081021, 2.6224923127405635}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-5.298317366548036, 2.6490076604684267}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8238695231462887, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0996442489973552, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7389772837890856, 1.803358605071407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.968974088653865, 1.803358605071407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.56019682034536, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.959419502711985, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.622553707074063, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.6094379124341003, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-4.3428059215206005, 3.2386784521643803}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-6.214608098422191, 1.6094379124341003}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.0841264243165862, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.304161419150561, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.3286906908754075, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.228790658775024, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.004138294335951, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.703886158927249, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.666335489679042, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.466278187121473, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-4.3428059215206005, 2.6490076604684267}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2569588998089404, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9110235456270366, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-5.298317366548036, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.199705077879927, 0.755182571479398}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.2533450600473311, 8.350429973538136}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7533219035960154, 8.350429973538136}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.797175250983993, 2.512035317176253}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4934342366777942, 2.512035317176253}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.697356025334, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.9975007872996983, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-6.214608098422191, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.154094566627875, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.554477071672573, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.359873830032749, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.159425367681418, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.23876493221716663, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.872802292274865, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5129946410508307, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.013077000561847, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.7333680090865, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.5974734304916628, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0975128932248088, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6529653909271136, 2.506341930508065}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6492187824459448, 2.506341930508065}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.953887209526845, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.7539022397884905, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.5102244577722903, 6.476972362889683}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.3178664036290963, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.817847430944174, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.8665717425242287, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.266557384867768, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.104394898075602, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.604170685655008, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.298317366548036, 2.6490076604684267}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.378751192832325, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.178596114669692, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.4420193761824103, 3.2386784521643803}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.605170185988091, 2.9290581402859983}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.378751192832325, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.178596114669692, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9405834244431995, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.4405393759722864, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.309519943887134, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.209391157353635, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9904756300635316, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3907040696085906, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.529318843261892, 1.9033008439609624}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.36154392105023625, 2.599722324216582}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7538858167999734, 2.599722324216582}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.421883011611913, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.904054835778969, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.803865056899991, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.502290170873972, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-7.600902459542082, 1.6094379124341003}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-8.532306829226286, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.8706006059570394, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.2704687956143002, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.885443919659868, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.2855499581361935, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2262184132732556, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.725971728690052, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.06016413371338, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.860379772276308, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.539739633930633, 2.5974910105351463}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.579879110192556, 2.5974910105351463}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.218243944560295, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.9180410777537094, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.735370011757173, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.4354783156390294, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4240364936935998, 8.1797604936999}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9240709191931175, 8.1797604936999}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.317800258800526, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.8180773925856184, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.919365593833201, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.419118909249997, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1041274693562197, 2.413231613081109}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3842963584572177, 2.413231613081109}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.3428059215206005, 3.2386784521643803}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.468806782694355, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.068859330518762, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6747180450915782, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.462743533283297, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.8029620465671519, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.7031992922485748, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1062413158326008, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5064301623598713, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.2864827918762988, 7.24422751560335}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.3865452232556535, 7.24422751560335}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4876628555081794, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.087375656742122, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.613467558616262, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.01348899514325, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.137918471438812, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2377341206744292, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.1409980051645476, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.540748536722336, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.117766656001504, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.017939231019695, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5064301623598713, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1062413158326008, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.7479817218821596}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7813228714636707, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2815740503494875, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.9999411183280458, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.2178763245351174, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.087375656742122, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4876628555081794, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.4135166537013273, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.213639558072954, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.068859330518762, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.468806782694355, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.6593256320844346, 7.944492163932159}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1593181637855046, 7.944492163932159}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.418747583305227, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.6675181235106251}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8644101099971662, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4644721421839146, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.809142990314028, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.05211045501669, 7.55171221535131}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.552112845814831, 7.55171221535131}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.199705077879927, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.991464547107982, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.3137523001849649, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.813734143549063, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8438952236485835, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2433732333621994, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6163727633271883, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.51624397679369, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-4.382026634673881, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.3137523001849649, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.813734143549063, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 2.209811692841691}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5404260935422814, 8.063377822367027}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0404377246170375, 8.063377822367027}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1080567474961094, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5082360319251331, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9063404010209869, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7064996252772315, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.6772785424354564, 6.309918278226516}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8689301605143175, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6691879168398742, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9329283730271782, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5329399414613754, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.5787702314339063, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.978697138696139, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 2.209811692841691}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-4.045554398052668, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7042981934580606, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.104554242494911, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1150465951315345, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6149530931222105, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.006215439402142, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.606442403454302, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8773173575897015, 1.6114359150967734}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.215490386143112, 1.6114359150967734}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.8205261098897758, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.3205066205818874, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 2.1094856630282126}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.7164562218841706, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.416204086475468, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9689006821464524, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5687759307152107, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.7329280505717899, 7.8709295967551425}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2330583852210326, 7.8709295967551425}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6287255312941893, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.9286606465811693, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0181583132629375, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.117817918407743, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6888794541139363, 5.298317366548036}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.359873830032749, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.159425367681418, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2942622756733968, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.694451286761057, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.417771502803163, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.7181023127908395, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.9910142780700916, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4912105310694506, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.0218709311636855, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.911914268349973, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.987249820814649, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5876764206525877, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.59947470469731, 8.004365564979574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0993125337825032, 8.004365564979574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.4395981331422016}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.426283369336254, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.5260163042950279, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.953887209526845, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.7539022397884905, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.7963700817857382, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.096384262410148, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-4.045554398052668, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.5895081458004594, 6.7912214627261855}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9896682016789307, 6.7912214627261855}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.1862091035211472, 2.423031246069913}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.282782465697866, 2.423031246069913}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.9696906777207166, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3691523372661587, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.744604469176456, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.5288035062673013, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.028556821684098, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.957577403480815, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8763491247812073, 2.503891949699081}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4304552569056603, 2.503891949699081}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.974001029221839, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.874045755297392, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.6854573524495757, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.4854489341097463, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.214608098422191, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 2.330200260027019}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.9180031958023054, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.217869048507598, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.7859090555498793}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.900458886151396, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3005870903313728, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.640928579525471, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.040829633207479, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6064191770501212, 2.5877640352277083}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5324768712979722, 2.5877640352277083}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.9521761906339596}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 2.330200260027019}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4240364936935998, 8.1797604936999}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9240709191931175, 8.1797604936999}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.9782390361706734}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.18777640747691846, 7.1929342212158}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.5878866699024524, 7.1929342212158}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.907755278982137, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2149273965428693, 2.519308076505333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0612087734187763, 2.519308076505333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.0365602553118024, 7.24422751560335}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.636577829072051, 7.24422751560335}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.269150316907808, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.66873333872526, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.764428382564909, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5644645467913691, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.6700167631710908, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4701108472130011, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.9910142780700916, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4912105310694506, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.509860006183766, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.009386074695824, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.40649706843741, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2063088641234838, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 2.4561641809223462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.6354040111173562, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.5356434782150785, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.666335489679042, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.466278187121473, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9405834244431995, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.4405393759722864, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.49314943875304795, 6.887552571664617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8933068954837797, 6.887552571664617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.047189562170502, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.878196476740593, 1.7776605448485534}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.571283042360924, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0328245481301066, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4329667693183212, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.1413169453979233, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-6.541030999190403, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2069773133462347, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.606941032235513, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7199019178687649, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2201021862558195, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.9205497887945385, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.2207799226423173, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.8840655845794182, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-5.504112279527633, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5177604746590787, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.6178619668786562, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.816258383443767, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.3162388941358785, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 2.4561641809223462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5703987153008919, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.6704076935904559, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.8442026554799011, 7.759614150696903}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.344384958042681, 7.759614150696903}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 0.9566646260124284}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2010151992412087, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0971007679422797, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.66341149948383, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.9634587130036953, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.437751649736401, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3093333199837622, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8097197946050478, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.719319793360441}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.200028504668954, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.9999411183280458, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2063088641234838, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.40649706843741, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.6562368265398482, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.1564532883579597, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.1236024374656055, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.5232317641096684, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.8183088044615916, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.318488613869894, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7813228714636707, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2815740503494875, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.403677882205863, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.815475995845371}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.6593256320844346, 7.944492163932159}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1593181637855046, 7.944492163932159}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2395270305647338, 1.4996230464268938}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.0757190980989355, 1.4996230464268938}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2437536743377806, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.744112815760702, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.3960099493374092, 6.984716320118266}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7960662345677868, 6.984716320118266}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.376740148315079, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8773173575897015, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4405393759722864, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8407396514497736, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.0102369597568726, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.9105241293044104, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.03270329512458, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0808706071919527, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.5808504555821878, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.9837562915454279}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.290620611051608, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8904754421672127, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.7181373293574413, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.4178610876830975, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.719319793360441}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.631199404215613}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.283414346005772, 5.703782474656201}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1874435023747254, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3874950816964096, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1796054478776414, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6798603767306461, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.4138711288901251, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.1136189934814222, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.8344641259578687, 6.152732694704104}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.0218709311636855, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.911914268349973, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.19455609446229716, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9784819201474635, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 2.078566158643882}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.406587064387653}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.5859645562484583}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.995732273553991, 5.991464547107982}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7667937207282438, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.166888494485349, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.8140100781628747}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 1.3045418592476314}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7048480972387587, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.878625402249717, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.8118888405232207}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2761851384398606, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6761120457020933, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4203757208439185, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.8205261098897758, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.557794679282262, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9582864201233687, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.359436906950008}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.340512168464763}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.995732273553991, 5.991464547107982}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.3524072174927233, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.2030071867437115, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 2.078566158643882}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.5177707239082765, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.617850239145466, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.9782390361706734}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.5774997570339834, 8.026170194946426}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.0776338822829181, 8.026170194946426}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.721515815839451}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.3178883284558303, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.8178684794407625, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.2499926428748753, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.9499943818801375, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3688474475161698, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1689274625831354, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.563430511492267, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.0635829404621653, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 2.2086040295231517}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.8442026554799011, 7.759614150696903}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.344384958042681, 7.759614150696903}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.5554040239416147}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.900458886151396, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3005870903313728, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.41779075779880137, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.717779984300055, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.835485924411894, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.3354096411241523, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2854179707987138, 2.4997952622817508}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.029509172931627, 2.4997952622817508}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8328691237350826, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6332184410995039, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.719252778441307, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.6190782472999463, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.8283137373023015, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.074653024948039, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.7740297600361856, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.05211045501669, 7.55171221535131}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.552112845814831, 7.55171221535131}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.744604469176456, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.6179742434563866, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.518075479137158, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.6444188813293459}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 2.1992225799988927}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.887460350206278, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6873994539038122, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 2.1992225799988927}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.894078619827491, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.49397078181451, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.6526889544284153}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.617843933216061, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.517955942272351, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.575036485716768, 2.020222182019865}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6993626199620875, 2.020222182019865}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.696151689580244, 6.684611727667927}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0963149296194261, 6.684611727667927}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 2.3243465847755584}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1542307124311217, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-5.234028876665675, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.4958211856471328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.995732273553991, 3.8004208288468435}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.4179914478631452, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.7177791303707455, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.251047211711865}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.9353900445478294, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.235513466021224, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.1498640059763816, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.049977288406387, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.696151689580244, 6.684611727667927}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0963149296194261, 6.684611727667927}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7672619976276676, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.166785108860756, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.9165331609060323, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.216512196196308, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.019664337643975, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3191210616341453, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.8528465593176202, 7.751045117971802}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3528595850336531, 7.751045117971802}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.5922917535991299}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyCircle]\"\>", 
                {-2.5257286443082556, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.5100594684538216}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1689274625831354, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3688474475161698, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3998672158005996, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.800001029850119, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.4146388341290332}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              
              StyleBox[
               InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 2.3243465847755584}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.6854573524495757, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.4854489341097463, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.600902459542082, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0529699307894087, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.4528616053920038, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.1308988302963465, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.363503507963463, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.2636117187095923, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.4569857892424236}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 2.253709925211909}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.204382667431038, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.504420282887948, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.06016413371338, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.860379772276308, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3874950816964096, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1874435023747254, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.8528465593176202, 7.751045117971802}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3528595850336531, 7.751045117971802}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6713133161521878, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.271538123821702, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.719319793360441}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0940068428223313, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.293868803909631, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 0.766397642299538}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.741256487054948, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.9407951330603375, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3063747379440172, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3063747379440172, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.5532907518110994}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.8470364847178946}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2180717287054377, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.91782824451005, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.18260159600127354, 2.136530508663963}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8587568185269134, 2.136530508663963}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.1029215602562081, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.4028303297599902, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.556451816951096}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.896419739771488}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.9782390361706734}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.1866231659908228}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.6139480679119864, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.9139271032022627, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 2.04225875055212}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6734432424100127, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.2576117273513145, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7199019178687649, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2201021862558195, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.2672179491567546, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-6.667164814064207, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.6397713603489157}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0177699008240089, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.117830825699811, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.6888794541139363, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.0940068428223313, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.2941383093687477, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.7929254558680243}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4375876555074412, 2.0149030205422647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8476951015583583, 2.0149030205422647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.2098554674840916}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7813228714636707, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2815740503494875, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.564942672547549, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.664950622364359, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.6397713603489157}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.5565205830281202, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3567355588783463, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.606941032235513, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.1413169453979233, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.8526977673331346}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8016236568960291, 6.579251212010101}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2016421889876536, 6.579251212010101}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-7.284632930238389, 1.6094379124341003}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.236923904465622}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.4890765557629164}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2669126040998102, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.666828609658249, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.902704363179782}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7129418078881248, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.8130574772325029, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.5257286443082556, 6.461468176353717}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.1975522365230131}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1409980051645476, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.540748536722336, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.6843598389513597}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.556451816951096}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3027280306570521, 2.419478844465545}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.1733127572899065, 2.419478844465545}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.23395175003081314, 7.146772179452637}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.6339353209280992, 7.146772179452637}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.9910142780700916, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4912105310694506, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.316022308134559, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.915963072687361, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.4971646699513146}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.5895081458004594, 6.7912214627261855}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9896682016789307, 6.7912214627261855}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.0218709311636855, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.911914268349973, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9372477759766606, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4371455863897404, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.741256487054948, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3413209954771594, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.1921026317554486}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.287354413264987, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.287354413264987, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.3204807842031671, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9205497887945385, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1150465951315345, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6149530931222105, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.9474803442248305}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5716605481000705, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3716028123769008, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 2.647592232065096}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 2.193662685769859}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2669126040998102, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.666828609658249, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 2.075308010398229}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4329667693183212, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0328245481301066, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.3101690833145914, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6100682736896466, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6939993778795506, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.694093021166824, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.174191878225647, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.674083651538937, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-4.2845370133966245, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 2.193662685769859}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.7177975525570903, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.4179367056664534, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8540604954254345, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9540431322855023, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 2.073423469354273}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 2.0680013515372804}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.0241960674538575, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.823966230699553, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.463458318582131, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.1634411179801, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 6.684611727667927}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5104979645791967, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.932401799030521, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.9474803442248305}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.522010001878903, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.411934093335004, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.3492738284584218, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.599488434143067, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.064355904261795, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640797356921787, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.144222799920162}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.898454207899018, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4983438649285135, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.48304834276654407, 6.897704943128636}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8830977645183911, 6.897704943128636}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.1850957485562468}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.1308988302963465, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.594056810395798, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3943265328171548, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8627499649461253, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0605908459024875, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.430629081771714, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2306590695884416, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3893457262282811, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.91139112512024, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.2602187884025833, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.660097652688484, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.96443110720209, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3645328693383778, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.8442026554799011, 7.759614150696903}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.344384958042681, 7.759614150696903}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.410950117672171, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.810913836561449, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.8563722416629115, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9563317814113389, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.131032179924221, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.531088946023124, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.1177951080848836, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.017810977845351, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.8470364847178946}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.9177918580004223, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.2178439823981595, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.4342248948774405, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.95401869367736, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3903023825174294, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7903604483143476, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.184789984909162}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4571461020918417, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8807977354618917, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4182464424728975, 2.6019486702196644}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6922761907431048, 2.6019486702196644}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6184786570862495, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4184044150381243, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 0.9991602096964498}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.110245660342752, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.810369351701646, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.94874563428772, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.2581768583394481}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 2.0680013515372804}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.5841201044498106}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.71869489837105, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3186357126460757, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 0.9329511727672622}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.809109107563168, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.515036014769512, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2739976361421332, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.3732221725934863, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.3137876703331426, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.2136588837996443, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4983438649285135, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.898454207899018, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.817803785159501, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.317908016313041, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 1.173410498743296}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.269044801069651, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.269044801069651, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3035404883862389, 1.5107219394949427}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.989444152396731, 1.5107219394949427}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 2.0624225365102413}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4903224315439383, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6906479678596436, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.7218733417638885}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 0.898534010284896}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.22276862160913655, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.525061368884541, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5191402744533198, 1.6882490928583902}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.418894215394429, 1.6882490928583902}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.5902550930173265}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.437937594271729}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0029385385998273, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.502828177375842, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.924832423452417}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.721515815839451}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.9296292963133357, 7.674152921281675}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4296194858582643, 7.674152921281675}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.33589240475620386, 2.502255288122613}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.974001029221839, 2.502255288122613}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7655070980839893, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3657077275115024, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3025850929940455, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5228016057745537, 5.857933154483459}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.922779731666459, 5.857933154483459}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.369240606554063, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.5612262966614128, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.449925680892755, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.7499665442035015, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.618595850218866}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.5087859235779435}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.984131361875511, 7.003065458786462}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2069773133462347, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.606941032235513, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.2246985543369746, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.6240307955986357, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.793961892783255, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2936253516225737, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7174398731289899, 2.5087859235779435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5793937910857236, 2.5087859235779435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.523226215615035}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 0.9034081060431414}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.5532907518110994}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.719319793360441}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6906479678596436, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4903224315439383, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7672619976276676, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.166785108860756, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5178502387029551, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.61797181824309, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.2756420910162956}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.023439351564551, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.623341473175256, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6424777665123005, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6424777665123005, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.461401833606696}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6445470895476684, 5.736572297479192}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.044846896915337, 5.736572297479192}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9038682118755978, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3037931396081468, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 1.3302529702362658}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0261055978813616, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.926205565780978, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-7.523941418405954, 1.497835735852798}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.1760334356366946, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7760829898430475, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4943251053335957, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4943251053335957, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 2.647592232065096}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7667937207282438, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.166888494485349, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.4961092271270973, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3960170377865984, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 0.6951451832226183}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8457617469776957, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.145857732131629, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 1.2499017362143359}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.4146938356415886, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8146187633741377, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 0.7975071958841882}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.11206147220931, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.542246662893777, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.742398039690331, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.3563504847468186}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.522010001878903, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.411934093335004, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.609379030762146, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.909388227079972, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 2.0624225365102413}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.3964921860963366}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.715777948205427}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 0.8450095298691913}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2496677635880655, 6.131226489483141}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6497392092076262, 6.131226489483141}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 2.28401370740861}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.816462081868427, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4159291662495814, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.7535382564078572}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.2030071867437115, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.418781887396557, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.51875303057183, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6745099091778153, 1.9300710850255671}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.780226233414382, 1.9300710850255671}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.298317366548036, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.9313764735639716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.132893222644984, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3329431856228962, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.389499492068839, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.1026043099376472}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.694451286761057, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2942622756733968, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 1.5904589458362974}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.506518858426259}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2977324083052823, 1.6114359150967734}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.7937956240634962, 1.6114359150967734}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.3754861624032872}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7987840841650193, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.598497972395766, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7178497932003172, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.417776806585365, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.6378309869353183}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.7317869551252127, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.201916872261721, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.2792657883613672}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.557794679282262, 1.8687205103641833}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.019664337643975, 1.8687205103641833}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4714166145367258, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4714166145367258, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.424802725718295}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.7693434299437227}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.424802725718295}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.9178457348969196, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.2178763245351174, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6311724045801064, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.706800981701778, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6414447085691868, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4409617624621989, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.5087859235779435}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3716028123769008, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5716605481000705, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.48175237628028356, 8.122074375362217}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9816295731824954, 8.122074375362217}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4679383501604009, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.279845606024556, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8442026554799011, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9002402920947703, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.6593256320844346, 6.721425700790643}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0592954262911594, 6.721425700790643}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.369240606554063, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9696906777207166, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.552112845814831, 5.8289456176102075}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9519282213808764, 5.8289456176102075}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.9368694044031642}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.8162894669713328}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2790527457537265, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.3071607397357723, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 1.1464496180822696}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.000759888500605, 6.380122536899765}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4007990473227723, 6.380122536899765}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.9980550336767947}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.770028224895903, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3700273886560186, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6654793033177253, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4653375684603434, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.2788685663767296, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.402746540537711, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9969586349416099, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0969137320325284, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.6936470556015963}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9038682118755978, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3037931396081468, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.406587064387653}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 2.414126467726953}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 1.5904589458362974}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.5366522427084526, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.412267540691536, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.9313764735639716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.719319793360441}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.552112845814831, 5.8289456176102075}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9519282213808764, 5.8289456176102075}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8016236568960291, 6.579251212010101}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2016421889876536, 6.579251212010101}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.421661504957182}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.5902550930173265}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7573580425107227, 1.589235205116581}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3789263262507685, 1.589235205116581}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.8002235476401844}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.8179208722379223, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.317867774075151, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 1.721694594779768}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.2672179491567546, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-6.667164814064207, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.8283137373023015, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.5377270648801}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5901256014017275, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0898959995836948, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.412288358086009, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-6.536881615643591, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2783372196147982, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.308100273682156, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.565421027017326, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.565421027017326, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 2.044332364566268}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.5960282255241827, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.296603021316498, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.617854196524514, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.51796702860799, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 0.849723487602042}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.257346872655708, 2.0028304393079956}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0514564223263525, 2.0028304393079956}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.6623114020411685, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.286383733136742, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.8162894669713328}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.0935997468445653}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.669026703845758}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7969533492855345, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2971851860481147, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.377692565480851}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.8002235476401844}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.342468881579861, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9428149441480107, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.1151705891340815}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.293947899598382}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4405393759722864, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8407396514497736, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.1308988302963465, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.900464386136271}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 1.8526977673331346}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.2568373311553196, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.676945820702642, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.377692565480851}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.795734531747094, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-3.1958919884778254, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 1.721694594779768}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.017383521085972, 0.8385453832493022}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.622553707074063, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 1.8526977673331346}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.739076112448345}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 0.880041599199034}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.186787979571835, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.5608378214218233, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.2568373311553196, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.676945820702642, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.031563461435372}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 1.9838938336679197}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.421661504957182}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.26683423993894284, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.666853965970644, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1150465951315345, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6149530931222105, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.612442421454399, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0129050178795915, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 2.647592232065096}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.1627481478062465}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0942219403668167, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8944568674663975, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 0.9411784473819341}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.698815723585317, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.698815723585317, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3842963584572177, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-5.0040073078060345, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.293947899598382}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6888794541139363, 2.9290581402859983}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.9251241812954787}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.1151705891340815}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.1167795926235586}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.715777948205427}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.340556469446037, 6.040254711277414}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7406861990440543, 6.040254711277414}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.017773404430871, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.117899907528199, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4405393759722864, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8407396514497736, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.271538123821702, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6713133161521878, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.669026703845758}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.6587993419718245}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.9245405804618736}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2303167796655379, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7002308520500784, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.9368694044031642}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.26683423993894284, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.666853965970644, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.406587064387653}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3983901944362025, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0442924641693683, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 2.075684492802124}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.246332151443247}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.5377270648801}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.795734531747094, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1958919884778254, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-7.819058469345253, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 1.9838938336679197}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.836849948493799, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.0968250627658085, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3983669423541598, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9987836386623814, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3329431856228962, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.132893222644984, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.1308988302963465, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4126383364594925, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.176833887688485, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7607838292757566, 6.620073206530356}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.160913314865489, 6.620073206530356}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.4588475538015993}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.0289048762432895}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3226876816505963, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9806466361359503, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.605170185988091, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3498863661120586, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.8499018253424513, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.6888794541139363, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3943265328171548, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.594056810395798, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.246332151443247}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3180038323381698, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8500747011316276, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1715056141884346, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.771368779580321, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.4126383364594925, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.536426440357718, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3039860739096736, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-4.083998270167957, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.742398039690331, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.542246662893777, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.3261404383001434, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.6260755535871236, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 1.0420419371797154}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.773934884315503}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6691879168398742, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6691879168398742, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0177699008240089, 6.363028103540465}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4179914478631452, 6.363028103540465}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.612442421454399, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0129050178795915, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.3754861624032872}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.4588475538015993}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7159101569446171, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5159475693467614, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.1627481478062465}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.8195418502405067, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.5191254931746836, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.6378309869353183}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5186835491656363, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5186835491656363, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.5299617109323036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3645328693383778, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.96443110720209, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.7837272975307907}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5832829549572491, 1.5933085305042167}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.5449114637250294, 1.5933085305042167}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.25154302583590776, 2.130609828254235}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8016468498397944, 2.130609828254235}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.2140221401789375}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.598497972395766, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7987840841650193, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6445470895476684, 5.736572297479192}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.044846896915337, 5.736572297479192}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.2761851384398606, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.6761120457020933, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.571283042360924, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.719319793360441}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.1413169453979233, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.541030999190403, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.2756420910162956}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.493987758524193, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.894183087299815, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2453891602615295, 2.424802725718295}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.220083871482302, 2.424802725718295}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.7329280505717899, 7.8709295967551425}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2330583852210326, 7.8709295967551425}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.4338645826298623, 6.946975992135418}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8337895103624113, 6.946975992135418}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.8699543168131119}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.7693434299437227}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.900464386136271}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.522010001878903, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.411934093335004, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.820158943749753, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.220083871482302, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.46013250945047257, 2.512035317176253}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8307082193666298, 2.512035317176253}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.469241281940817, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.869504817852908, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.8069317506623275, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.4109447331170353, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0808706071919527, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.5808504555821878, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7696066645869217, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5692561228012685, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.3302529702362658}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9192952408944538, 6.461468176353717}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3193836558372638, 6.461468176353717}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.506518858426259}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2824955457644808, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.4686200579795896, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3171415024315738, 6.063785208687608}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7170231231140378, 6.063785208687608}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1409980051645476, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9414202437824613, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.607650686531799, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.294616923344869, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.0941445822194344, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5159475693467614, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7159101569446171, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2262184132732556, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.725971728690052, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3617968895195032, 1.9416152247724325}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.069887328875024, 1.9416152247724325}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3257638613798584, 1.776645831418007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.435545220250276, 1.776645831418007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.2876820724517809, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.2787091504399533}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.744604469176456, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.031563461435372}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.746403767507258, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.1464364105041143, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 0.9543569326806114}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.615959129424366, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.615959129424366, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.018486244188825}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.7822140563845235}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.8056623743970464}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5906161581935125, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5906161581935125, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4653375684603434, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6654793033177253, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.2568373311553196, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.676945820702642, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5235731965884932, 2.50470927708418}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7820071777853768, 2.50470927708418}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.783559272662715}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0891571298973546, 6.29156913955832}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.489435120039404, 6.29156913955832}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1184069159962893, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9186841628017217, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.412288358086009, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.536881615643591, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3478567954878509, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.399798360748448, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.600902459542082, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.214608098422191, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.144222799920162}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.3407610128583247, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.340807418168989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 0.9290095042819297}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6269849783062765, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8129108417183852, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2330583852210326, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2330583852210326, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.4865920824352545}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.2876820724517809, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3670139217339117, 2.134048091170708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6790255220615937, 2.134048091170708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.820158943749753, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.220083871482302, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1080567474961094, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5082360319251331, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2437536743377806, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.744112815760702, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0645007590393418, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6864844231876495, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.6591800043289144}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-9.567158183262826, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.7317869551252127, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.201916872261721, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.46298829435183064, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.063052113269559, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.3281354469463584}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6126737964100685, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6907507040241487, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4422299934501939, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8426317996018116, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.2908841763152323}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.600902459542082, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9840343839606746, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3838972365201692, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.6407445017668969, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.040959012419865, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2149273965428693, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.224893897193764, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.094520670764856, 1.6937790608678513}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.832423655941967, 1.6937790608678513}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8734707346912269, 6.507277712385012}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2736802167507564, 6.507277712385012}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2740421867477461, 2.5771819258971713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8865098057738656, 2.5771819258971713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.377606779979768, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7955707986317053, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-8.05031945517943, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4159291662495814, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.816462081868427, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.0279882600909205, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.190415030972834, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.9245405804618736}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.1603343472961065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 2.0766877534832147}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.007592890280941}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3426311639367969, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.2406103170142067, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.5639866495301828, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.9639722918737217, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.095273387402595}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.5845302767279155}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.5609672964009644, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.6609757937162812, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 1.3982229319851645}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.2908841763152323}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.09926800165866902, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.849872629798755, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7145751279735658, 1.9387416595767009}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7225041580723603, 1.9387416595767009}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.68510181635509}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.671097292820828}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8598242001421843, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2595256035335987, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4118173183509766, 1.5973653311998313}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7078502210995437, 1.5973653311998313}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.3524072174927233, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 2.2927367569392314}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.68510181635509}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7310567536331655, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8551011438142453, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5213811377055073, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.64930970607961, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 0.965080896043587}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.7828868907244566}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.362224007377702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.57270299585059, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5692561228012685, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7696066645869217, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 2.296667619230008}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.2739976361421332, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.5740001929819547, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 0.849723487602042}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5342648554997536, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.766368110426725, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8058680506240641, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6338708029279587, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2942622756733968, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.694451286761057, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2942622756733968, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.694451286761057, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4361820807702249, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.612240146256234, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9038682118755978, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3037931396081468, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.3281354469463584}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.941966881801218, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.991862608772972, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.2299329059954676}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7109170813839543, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1111386284230904, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.5047438413194347}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8643301620628905, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-4.524512282970637, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 1.1990607599649155}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.1966460289394751}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7109170813839543, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1111386284230904, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2651392395634233, 1.5953389880545987}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.858931232061846, 1.5953389880545987}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4947708374559745, 5.886104031450156}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8951219822232084, 5.886104031450156}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.44926026810783587, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7212874278842305, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3585338134237321, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.5645401798583287, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-8.403864506109235, 1.0698698198024557}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.0738571633859353, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.5732134108799993, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.926290362185661}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 0.7975071958841882}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4947708374559745, 5.886104031450156}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8951219822232084, 5.886104031450156}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.795734531747094, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-3.1958919884778254, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8250798518207709, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7611345721946656, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5413120833865, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5413120833865, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5473167323484057, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8953440995227226, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8426317996018116, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4422299934501939, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.1597073880279205}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0186003506987251, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4605869657017456, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.7867719277170158, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.1622605067393605, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.536314386533157, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.412382827063892, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8598242001421843, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2595256035335987, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.528780009416646, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.152761077153482, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4409617624621989, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6414447085691868, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.746403767507258, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1464364105041143, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.6960857191597725, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.196424897165655, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.5136732904497212, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.0136538011418326, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.2158025560795132}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.940865372113151, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.740861482897622, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4460443655256647, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.946310229076653, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.8056623743970464}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2808538486618937, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3811078344325904, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4082690354408987, 1.860974538249528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.184232881424661, 1.860974538249528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.0654001544619962}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 0.9150900112976361}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.017383521085972, 0.986935571443487}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.2262184132732556, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.725971728690052, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.2742448573112677}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.6108369333478076}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 0.911479174876933}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8598242001421843, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2595256035335987, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.5539252025038417}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.2876820724517809, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.2917089186300228}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 0.8514321595256585}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.7083778602890038}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.5845302767279155}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4599740936085572, 2.004179057179289}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8461060995981784, 2.004179057179289}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4184044150381243, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6184786570862495, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.15218556191195, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.781788039865368, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.836849948493799, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.0968250627658085, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.9910270779881722}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6240440648234626, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-4.76404869105558, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 0.766397642299538}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.6888794541139363, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.540842282118304, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.140893060599911, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 0.9654617758806044}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.33687231664255274, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1028721491118945, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.101092789211817, 0.911479174876933}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1080567474961094, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5082360319251331, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3186357126460757, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.71869489837105, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9519179095173061, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7958982916754054, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0645007590393418, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.26443077336305, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.8826660279157308}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.900458886151396, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3005870903313728, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.0497721232486361}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.6593256320844346, 6.721425700790643}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0592954262911594, 6.721425700790643}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.168928708181372, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.768756076219605, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 0.9345235001352147}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.4028303297599902, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.278818960372969, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.795734531747094, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-3.1958919884778254, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6888794541139363, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.640548907459153}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.746403767507258, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1464364105041143, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.1990607599649155}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.0598714603516792}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.8958869385842747, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-3.0957736277342174, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2496677635880655, 6.131226489483141}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6497392092076262, 6.131226489483141}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.708153885373258, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8078888511579385, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.0794415416798357, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.000759888500605, 6.380122536899765}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4007990473227723, 6.380122536899765}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8195418502405067, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.319222734147069, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.6744763086133228}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 2.2976730486330252}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1270117631898076, 6.253828811575473}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5269366909223567, 6.253828811575473}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4728877844255986, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.966950472128539, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.094604267270571}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1796054478776414, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6798603767306461, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 0.8028980445190645}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5079962967558309, 2.134048091170708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.538054293998892, 2.134048091170708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.6304163188192922}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1796054478776414, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6798603767306461, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.038175919864279, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.548102073285148, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.4226262903672808}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.7840632625935846}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.27128392664214473, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.171276846068922, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.48175237628028356, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.107781777362614, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6969544189028993, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6009911288088023, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.1966460289394751}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.349630376748299}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5629964960949002, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9631203192309531, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.0281898243715637}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.931658209005277, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.657689841763261, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 2.647592232065096}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3093333199837622, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8097197946050478, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3678803477808931, 1.4973884086254774}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.9518038754399907, 1.4973884086254774}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.199705077879927, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3657077275115024, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7655070980839893, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.993630885266725, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.0939462278827174, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.8469979053782056, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.247228312996893, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.6528674703614363, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.0287936073591935, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2862680470527663, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.662352421858305, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.1597073880279205}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.39809235377875135, 2.498151876538021}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9200474895295858, 2.498151876538021}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 2.215282764591249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5898688311064436, 2.506341930508065}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7120245012092015, 2.506341930508065}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.1499389158334503}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3649243353836982, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.864975531559314, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.3089630181835672, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.908846148194222, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.869504817852908, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.469241281940817, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.2181715237257489}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.071483621279857, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8714522381373035, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.6409365794934714}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2437536743377806, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.744112815760702, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.360956006320375, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.8610265707016995, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.21927603978772048, 1.860974538249528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.3731931852525583, 1.860974538249528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.599292605088321, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.571249159610065, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.5539252025038417}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.4532518292447716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.3504080825554816}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1526461771605954, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.4305321073246677, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.133013715385442}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 0.8028980445190645}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9390477189967712, 2.414126467726953}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5474025215146479, 2.414126467726953}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 0.9707789171582248}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.42266213293668586, 2.418588768750352}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0549440700794483, 2.418588768750352}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.194022473472768, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.793961892783255, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6218266343535928, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.312220927289192, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 0.8977193462887197}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1644316297054034, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1644316297054034, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1663559407546291, 6.214608098422191}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5663784229736533, 6.214608098422191}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 0.9345235001352147}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 0.766397642299538}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2069773133462347, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.606941032235513, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.0654001544619962}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.191191469961203}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9715392061046336, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9515240188896708, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2282654968949804, 6.152732694704104}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6281111776997217, 6.152732694704104}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.44238846221276223, 1.501852701754163}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.868484703413663, 1.501852701754163}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.094604267270571}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.927891643552635}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.612442421454399, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0129050178795915, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.8424288832756998}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 0.7802418874108791}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9058454740126164, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.5338868320097188, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 0.9290095042819297}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              
              StyleBox[
               InsetBox["\<\"\[FilledUpTriangle]\"\>", 
                {-2.5257286443082556, 1.0678093795130645}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.4532518292447716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.6409365794934714}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 0.9858167945227654}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.26443077336305, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0645007590393418, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.3137523001849649, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.813734143549063, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.6744763086133228}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6792442753909539, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.491327217590923, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0939462278827174, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.294015757351168, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.340556469446037, 6.040254711277414}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7406861990440543, 6.040254711277414}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.49331319868135953, 2.4239173781615704}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.973281345851445, 2.4239173781615704}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.746403767507258, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1464364105041143, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6544352783648362, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.1541650878757723, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 0.898534010284896}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7832907304129113, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.517264565896126, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6416938989710297, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9477043045434095, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.2101638842661795, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.710307401527557, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.1589994386832048, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.058828136697741, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7448616162466241, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0027568884909557, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.8012039280560548, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.417032243872697, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.555615105736594}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.6564295976247825, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.256670593326385, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.028748427364318, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.653113060608557, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2184098521237055, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8189251373008244, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.941966881801218, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.991862608772972, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6622300779252237, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3861841168703593, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.2158025560795132}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.017383521085972, 0.7347688552507647}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.153303390278291, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.529318843261892, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.7847348542910906}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.0281898243715637}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              
              StyleBox[
               InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.5432981099295553}],\

               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 1.3321021320364639}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7903604483143476, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3903023825174294, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.2867117438377558, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-6.662458923026794, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 1.0868770324496888}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.7790406968202803, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.902767737471098, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.640548907459153}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3678803477808931, 2.421256622711544}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.104554242494911, 2.421256622711544}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5561717255328675, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.030116700415822, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.0966102859974367}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5059792040658704, 2.0843046973458237}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6398971199188088, 2.0843046973458237}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.30938249943111995, 2.131796772013764}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7414001807837645, 2.131796772013764}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1564532883579597, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7565130561817651, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.9267273296385394}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 0.766397642299538}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3149043650332175, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9146052992269007, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.912572089444803, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.036270701217564, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3413209954771594, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.741256487054948, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.995732273553991, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.279055610450292, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.402871609042948, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.389499492068839, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6977577931176286, 2.4265710727750367}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7637552728184576, 2.4265710727750367}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.322289031143978}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.0678093795130645}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.018486244188825}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.4365120772805082}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2315538186741798, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.6916833814466705, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6266106567597011, 2.4265710727750367}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8350845939664286, 2.4265710727750367}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.6358850824489488}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.064355904261795, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640797356921787, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.606235808570649, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2063088641234838, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4307829160924542, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 2.0759354023505483}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8042369907391675, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", {-4.584387646805562, 4.386889790339869}]
                ,
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.6888794541139363, 1.0942695392339727}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 2.647592232065096}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.3681303904922195}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyUpTriangle]\"\>", 
                {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 0.8977193462887197}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.4420193761824103, 3.2386784521643803}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5173146235582946, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.017406150760383, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.0732944806838198}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.2809338454620642}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.6389967146756448}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.3428059215206005, 2.6490076604684267}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4338645826298623, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.6777417097034806, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.219163484854973, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.7188583998188136, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5823216254710607, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.466163406970865, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 0.9669838461896731}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.1406850650900175, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2406367886975274, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 2.066736169182282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7650729201315343, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.403068631572368, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 1.3147983594148207}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.293897511853923, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-5.093908213290077, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.3452119160186606}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.595748829015065, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.395911377232918, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.4915548717773834}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.4407825464039603}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.1499389158334503}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-8.685611843041201, 0.9360933591703348}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              
              StyleBox[
               InsetBox["\<\"\[FilledDownTriangle]\"\>", 
                {-2.5257286443082556, 0.9364854391596744}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.6168849633501186, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.600868576791223, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.1625110145183415, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.786268646522262, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.064355904261795, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640797356921787, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8871696540327132, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4871090733432, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8701230510291479, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.270112606830481, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.26683423993894284, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-8.666853965970644, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 0.9403978072173882}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 2.075809955445786}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.965852822566973}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.3524072174927233, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4267908948229169, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.4929837772928636, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.6409365794934714}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.820158943749753, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.220083871482302, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5366522427084526, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.412267540691536, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.4226262903672808}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.7317869551252127, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.201916872261721, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 1.1684492482568893}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.036382052219389, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-6.912265434460023, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.0598714603516792}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1208578976154293, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9949325933834268, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 0.9364854391596744}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.36571568859088144, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.741858378904823, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.4122057429043917}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2654936609741865, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8656213178265104, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.4122057429043917}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.9031380572114442, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.779362064213738, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.29356601561075557, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.6298561136644754, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4171835010623628, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.327296573822621, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.045554398052668, 0.9604989865384754}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7756596021344095, 2.418588768750352}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.701553201341906, 2.418588768750352}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.5432981099295553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.5305182571117267, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1307223425863433, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5705756281717647, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1806171127511105, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.5077842587076005, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.007679175452945, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.064355904261795, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640797356921787, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4307829160924542, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.322289031143978}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5601909533113197, 2.423031246069913}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9085180298382507, 2.423031246069913}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.558002204858551}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2371849385320495, 1.9401794743463283}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.197324582336553, 1.9401794743463283}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.6623114020411685, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.286383733136742, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3649243353836982, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.864975531559314, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.2809338454620642}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7062324201086008, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.1062413158326008, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.0289048762432895}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.6624240079171049, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.286478374605709, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1150465951315345, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6149530931222105, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.1151415906193203}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.064355904261795, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640797356921787, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3093333199837622, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyUpTriangle]\"\>", 
                {-1.8097197946050478, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.2157956136516715, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.466024904841838, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6548884684428551, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0929041853062644, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 0.8055826098897335}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.4920048155420047}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.162823150618887, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-6.786422993814612, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7109170813839543, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1111386284230904, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.2672179491567546, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.667164814064207, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6218266343535928, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.312220927289192, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.4018530946527146, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.532062329207643, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 2.647592232065096}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7627116439458544, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.156840433948748, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.4126383364594925, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.536426440357718, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.1603343472961065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2409826299598365, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8413699697813894, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.66442222076686, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164563795096671, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9958752112169974, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1199358770132974, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.191191469961203}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8821308802274503, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.4159777803491362, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.963188584855586}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7813228714636707, 7.822444729489319}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2815740503494875, 7.822444729489319}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1150465951315345, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6149530931222105, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4088348928367562, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.809015255353917, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.2917089186300228}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 0.848868055556721}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.893897967672723, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.49397078181451, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 0.8055826098897335}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.712716261887602}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.0738571633859353, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.5732134108799993, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 0.9489515141137035}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.15218556191195, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.781788039865368, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.894078619827491, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.49397078181451, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7463370090740643, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.785741396902492}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.045554398052668, 0.8514321595256585}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.214574215671332, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.004138294335951, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.2166915767337108}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.7867719277170158, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.1622605067393605, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0108761743640229, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.428942281870568, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.3137523001849649, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.813734143549063, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.101092789211817, 0.7802418874108791}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 1.4772770088317615}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.741015208534465, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.940782792197422, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.152962883418191, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.5287678617828835, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.3524072174927233, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.836849948493799, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.0968250627658085, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.348592493935879}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.2867117438377558, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.662458923026794, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.8146618624453594}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8787541283454292, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.2367852454117685, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4911864085136422, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.253208503948706, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8997902134417601, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3993162819538174, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8505029913361519, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6286207318508743, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2960880932337415, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0417762120553977, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.270112606830481, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8701230510291479, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.389499492068839, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.036482917202561, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.912330925723864, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5918549290780729, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.5159350591325786, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.0935997468445653}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8997902134417601, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3993162819538174, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4307829160924542, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.6393849888020524}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3093333199837622, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8097197946050478, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.4018530946527146, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.532062329207643, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.251619457793289}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.391511302188447}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.786359562282124, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.162319869424133, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8584936331479384, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.314556464775266, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 0.849723487602042}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8344803566765893, 2.131796772013764}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.2164073967529934, 2.131796772013764}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.585233223737283, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.632849755094834, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.458005208673891, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.0580715159436433, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.5107219394949427}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5828588266658222, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.336815122732887, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.376740148315079, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8773173575897015, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1214715828141923, 1.9387416595767009}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3154677188250594, 1.9387416595767009}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9699552564598479, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1702157075278026, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.362224007377702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.57270299585059, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.1269525243508878, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.807005375881994, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.0942695392339727}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6039529822035308, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2045513527226803, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5015355768588979, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.421604191439818, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.912572089444803, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.036270701217564, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6667000105450971, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.252691173362931, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.170932950247736}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.9122987106046175, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.036311444023319, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5173146235582946, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.017406150760383, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4307829160924542, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.612442421454399, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0129050178795915, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.349630376748299}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.8906229851255774, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.4907663827166018, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8442026554799011, 7.759614150696903}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.344384958042681, 7.759614150696903}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 0.9654617758806044}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.030860186617291, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6311724045801064, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.66442222076686, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164563795096671, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.66442222076686, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164563795096671, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.395133309787095, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.77313400510489, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.908818717035454, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.3089739467365655, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.4886252922173524}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3208812225716584, 2.0095554142156695}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9747212309094329, 2.0095554142156695}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.6409365794934714}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.376740148315079, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8773173575897015, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.1269525243508878, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.807005375881994, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.2862680470527663, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.662352421858305, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.984837274409265, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.318612854071243, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7797949872856175, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.327853987437946, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6005679992668521, 1.4996230464268938}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.7148128361404407, 1.4996230464268938}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.4938666711595117, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.894183087299815, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1702157075278026, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9699552564598479, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8195418502405067, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.319222734147069, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3482281603134343, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7004573108212688, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.3109197297841035, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.9110235456270366, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7199019178687649, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2201021862558195, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7199019178687649, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2201021862558195, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.219163484854973, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.7188583998188136, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.506518858426259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.002290482491421}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 1.9254158540407285}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 1.8728785205128469}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.162823150618887, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.786422993814612, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0923241675108497, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.841967538444134, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.036382052219389, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.912265434460023, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7912011210353335, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.5332441625824873, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.161367091078508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.007592890280941}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 0.9654617758806044}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.3418458069473482, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.592214878401959, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.3504080825554816}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9542522381612738, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", {-2.2164073967529934, 2.0719132752590443}]
                ,
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9306432380985556, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7306413849875258, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 0.9666035457477442}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6218266343535928, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.312220927289192, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5068336024964532, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.604906020337758, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0891571298973546, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.209094749906707, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5228016057745537, 5.857933154483459}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.922779731666459, 5.857933154483459}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 0.7802418874108791}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0918353043890858, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.84195543139986, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-8.955698153602603, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.8843386505211481}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.0942695392339727}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6788498758591209, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.4370318346713713, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.491779868965868}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 0.7499999921527281}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9293759714228106, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.119430549896199, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.376740148315079, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8773173575897015, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0288996762568094, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.652827532407001, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.103158068297152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.0942695392339727}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyDiamond]\"\>", 
                {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8195418502405067, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.319222734147069, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7813228714636707, 7.822444729489319}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2815740503494875, 7.822444729489319}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.5920892740994874, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.341928551227046, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 0.8989410935390421}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.6888794541139363, 0.9669838461896731}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.941966881801218, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.991862608772972, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5901256014017275, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0898959995836948, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.1625110145183415, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.786268646522262, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 1.8359358315608838}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5173146235582946, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.017406150760383, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.995732273553991, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.3282528397426234}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.362224007377702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.57270299585059, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 2.377692565480851}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9001713499942718, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.424056675808238, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1535965970008693, 1.4906543764441336}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1796551117149194, 1.4906543764441336}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.382026634673881, 0.8441500540964727}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 1.5473497201206787}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 1.0962762288705619}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.3420861064555702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.5919427181706105, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4460443655256647, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.946310229076653, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0700248318161971, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0700248318161971, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.746969987257452, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3470736479666092, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.7378311272024993}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4460443655256647, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.946310229076653, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7672619976276676, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.166785108860756, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6941476808935289, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.6302332586812027, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 1.094604267270571}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.140807436632442, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.541256860244439, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2026403590921573, 2.0095554142156695}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0931348688118385, 2.0095554142156695}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.6939993778795506, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.694093021166824, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 0.848868055556721}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0604498275737608, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.110313205346923, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.279055610450292, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8891518152367044, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.995732273553991, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5220551057175394, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.802272141469027, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0302996484860225, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0181583132629375, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0202633222571333, 1.4929040961781488}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.3082536360194172, 1.4929040961781488}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 1.2172838183856083}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.15218556191195, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.781788039865368, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.807796846925679}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2669126040998102, 4.386889790339869}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.666828609658249, 4.386889790339869}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4850103340590484, 2.135349173618132}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.559220196273483, 2.135349173618132}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7565130561817651, 2.702032128776647}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1564532883579597, 2.702032128776647}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.045554398052668, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7435408969575807, 5.537334267018537}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.3434070875143007, 5.537334267018537}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4460443655256647, 7.157735484249907}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.946310229076653, 7.157735484249907}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 0.8307328435125084}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4028684822608984, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.278964002683987, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.196377287787253, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 0.9666035457477442}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.945799904805782, 5.991464547107982}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.045763207159556, 5.991464547107982}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.995732273553991, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8457617469776957, 5.991464547107982}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.145857732131629, 5.991464547107982}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.9028810449642375, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.7788336680347445, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 2.1122716862705384}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.266384064447333}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 1.0511712140679732}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8442026554799011, 7.759614150696903}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.344384958042681, 7.759614150696903}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 2.2044208442068145}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7667937207282438, 4.386889790339869}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-8.166888494485349, 4.386889790339869}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5901256014017275, 7.013915474810528}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0898959995836948, 7.013915474810528}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9372477759766606, 5.393627546352362}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4371455863897404, 5.393627546352362}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 2.217027204632399}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.793961892783255, 5.537334267018537}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2936253516225737, 5.537334267018537}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.475392057419415, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.725433722188183, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.266384064447333}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.3326298365341978}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6544352783648362, 5.676753802268282}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.1541650878757723, 5.676753802268282}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 1.2190584417439767}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {41.659220767303175, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-50.341331645288825, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.8420006856648017, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.091798316674432, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0191543673333943, 2.570319527636131}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.155182640156504, 2.570319527636131}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.599387576580599}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8997902134417601, 6.704414354964107}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3993162819538174, 6.704414354964107}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              
              StyleBox[
               InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.527397202097891, 7.076653815443951}],\

               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.4847813078345447}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.483987072728617, 4.386765389021055}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.904054835778969, 4.386765389021055}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 0.849723487602042}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.168283961917429, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0024805005437076, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              
              StyleBox[
               InsetBox["\<\"\[FilledDiamond]\"\>", 
                {-2.995732273553991, 1.3480731482996928}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0564152399683213, 2.702032128776647}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8566077297129814, 2.702032128776647}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.6527732864216721, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.028919972120757, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.2256240518579173, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.975391927697949, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 0.8202202631234213}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.7254100886865211, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.475327636634016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8997902134417601, 6.704414354964107}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3993162819538174, 6.704414354964107}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 0.761739972025557}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 0.9669838461896731}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7789229575813493, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.902818692021688, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0923241675108497, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.841967538444134, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.3418458069473482, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.592214878401959, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyUpTriangle]\"\>", 
                {-1.8195418502405067, 6.784457062637643}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.319222734147069, 6.784457062637643}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.166995202991212, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.767041814295392, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.4753441779534016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.725332537920259, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.6888794541139363, 0.8505781885087738}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.695775840226822, 5.991464547107982}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-3.2957568692041583, 5.991464547107982}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 0.9925107577855641}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.3039860739096736, 4.386765389021055}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.083998270167957, 4.386765389021055}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5288198871382693, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.152897360346143, 4.512945241945574}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.196377287787253, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.4312677267626217}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 0.849723487602042}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.6305480388034254, 2.827905162910489}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0305798782762827, 2.827905162910489}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8195418502405067, 6.784457062637643}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.319222734147069, 6.784457062637643}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.659260036932778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.430789601006442}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.9453385571563557}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.659260036932778, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.9754419516613513, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.225346881840062, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 2.0427775573082445}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.5779472453427295}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5901256014017275, 7.013915474810528}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0898959995836948, 7.013915474810528}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.036482917202561, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.912330925723864, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 1.6384140206706175}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2361517026901712, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8121662790057176, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.66442222076686, 6.939253946041508}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164563795096671, 6.939253946041508}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 0.986935571443487}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.76705723517796, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.166938288491657, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1304126012179074, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9186841628017217, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.366795954944823, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.566981433164056, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.1780394222994315}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8566077297129814, 2.702032128776647}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0564152399683213, 2.702032128776647}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.863232841258714, 0.8458682675776092}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.7027460895677522}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.4018530946527146, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.532062329207643, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5173146235582946, 7.086737934510577}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.017406150760383, 7.086737934510577}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.693851481702397, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.694093021166824, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.659260036932778, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.7710464276305133}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.3420861064555702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.5919427181706105, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.8643901602629624}]
                ,
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.659260036932778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.1269525243508878, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.807005375881994, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8997902134417601, 6.704414354964107}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3993162819538174, 6.704414354964107}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.5077842587076005, 5.823045895483019}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.007679175452945, 5.823045895483019}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.360956006320375, 4.969813299576001}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.8610265707016995, 4.969813299576001}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4460443655256647, 7.157735484249907}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.946310229076653, 7.157735484249907}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.567015866357096, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.366810362993337, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.3492738284584218, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.599488434143067, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.475392057419415, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.725433722188183, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 1.2184672504763885}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.9122987106046175, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.036311444023319, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.8420006856648017, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.091798316674432, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {40.65907381386164, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-49.34073194467232, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.493879571799828, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.893919494400295, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5901256014017275, 7.013915474810528}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0898959995836948, 7.013915474810528}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0918353043890858, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.84195543139986, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.5920892740994874, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.341928551227046, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.863232841258714, 1.007592890280941}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.6888794541139363, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.536314386533157, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.412382827063892, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0939232991819783, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-5.293927018246744, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {39.65916255296606, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-48.341370727608414, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9565920286476808, 2.702032128776647}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9565920286476808, 2.702032128776647}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.382026634673881, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.966950472128539, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.966967075507594, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.475392057419415, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.725433722188183, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 0.848868055556721}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.266384064447333}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.2255369822417765, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.975450465015525, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-4.199705077879927, 0.7997569156182036}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.166915255056936, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.76686592498839, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.9670073137609054, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.966857671750368, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.6624240079171049, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.286478374605709, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.084253098677058, 4.386765389021055}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.30432512701003, 4.386765389021055}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {23.65924810609463, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-32.34077434210908, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 0.9654617758806044}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.786359562282124, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.162319869424133, 4.512945241945574}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.7418655495969406, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-6.191868611452702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.4753441779534016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.725332537920259, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8305718564716175, 2.827905162910489}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8305718564716175, 2.827905162910489}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.3504089023600859, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.850570223130148, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 0.7466879474879751}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.21678878567620194, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.716864386545305, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7306413849875258, 2.827905162910489}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9306432380985556, 2.827905162910489}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.3504089023600859, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.850570223130148, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.7254100886865211, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.475327636634016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.273910668367863, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-6.113858195322049, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.366940997255841, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.566911473871001, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0339487753423875, 2.418588768750352}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.443923473956527, 2.418588768750352}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.2256240518579173, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.975391927697949, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.3504089023600859, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.850570223130148, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->10.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.21678878567620194, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.716864386545305, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.2255369822417765, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.975450465015525, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.5005758256424344, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.700587583759682, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.9754419516613513, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.225346881840062, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.863232841258714, 0.8333438110532289}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5782126424678459, 1.5432981099295553}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.6504282677396835, 1.5432981099295553}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.2256240518579173, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.975391927697949, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0053952069569758, 2.498151876538021}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.313415715707318, 2.498151876538021}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {38.65927591460964, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-47.34086951027008, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.8505029913361519, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.350408373771412, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.067986095126349, 2.3456445824544927}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.5558971455060706, 2.3456445824544927}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.66442222076686, 6.939253946041508}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164563795096671, 6.939253946041508}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4918104261047946, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-6.442136248054226, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1026203100656484, 2.2648832258100344}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.6825463842547386, 2.2648832258100344}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.5005758256424344, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.700587583759682, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 0.7476353658440151}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8940401229393353, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-5.493845750829273, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1279381180499384, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.95263269481614, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2173252490432223, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-6.717134919373487, 4.386889790339869}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.8505029913361519, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.350408373771412, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7168253079145225, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.2170885989659, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1199380753828623, 2.065596134857783}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.064355904261795, 2.065596134857783}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.7042981934580606, 4.386765389021055}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.683996966534062, 4.386765389021055}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.8505029913361519, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.350408373771412, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.8944568674663975, 4.386765389021055}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.494523665901028, 4.386765389021055}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1230074455028314, 2.1825620503943153}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.8269722249837996, 2.1825620503943153}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {36.659239911113445, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-45.34120604098636, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {22.659269939882257, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-31.34091993726656, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7168253079145225, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.2170885989659, 4.386889790339869}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.082935809283102, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.1892564076870427, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {21.65896696234039, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-30.340822850069564, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6539264674066639, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-5.7340355178272215, 4.386889790339869}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {37.65893624683973, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-46.34085167560773, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.9754419516613513, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.225346881840062, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0277811079075183, 1.9768549529047348}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.333559897293476, 1.9768549529047348}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.9736550492637259, 1.9198594718553708}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.5016459737922982, 1.9198594718553708}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.3003570667360838, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.9005275521158795, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {59.53313730582369, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-68.46724388757043, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.9334368907091256, 1.8389610707123492}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.703510521060178, 1.8389610707123492}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {28.659210940300113, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-37.34075273404506, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.700547258981618, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.500433550670171, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.7254100886865211, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.475327636634016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {19.659054974995634, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-28.340907620492793, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.4753441779534016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.725332537920259, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {20.659260506970497, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-29.340832002509437, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {35.65915017536031, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-44.34079097851618, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.8947738884119054, 1.7316555451583497}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.9568962497687927, 1.7316555451583497}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.2255369822417765, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.975450465015525, 4.386889790339869}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7903190923122189, 1.6272778305624314}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.270169119255751, 1.6272778305624314}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.900588627802483, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.30031936921871, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {27.65863628296152, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-36.34119244432727, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {29.659169363220833, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-38.34104853637971, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {48.53243313825843, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-57.46750061412042, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.700547258981618, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.500433550670171, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {18.658909932684615, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-27.341341040814093, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.700547258981618, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.500433550670171, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.100426344668657, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.100386954332169, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.5005758256424344, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.700587583759682, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.3003570667360838, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.9005275521158795, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.3003570667360838, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.9005275521158795, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.100765130025024, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.10045059841862, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.900588627802483, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.30031936921871, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {57.53313665775977, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-66.46748299707936, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.900588627802483, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.30031936921871, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {30.65922057962004, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-39.34081340913477, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {26.659217674124136, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-35.340845982694816, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {58.533130928172234, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-67.46691559681179, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.100765130025024, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.10045059841862, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {46.532892678517214, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-55.46685482648658, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.100765130025024, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.10045059841862, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.900422093749666, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.300710797475603, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {56.53320628572335, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-65.466905183977, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {60.532988401609, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-69.46689851604965, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {25.65917758484673, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-34.340745544411554, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.100426344668657, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.100386954332169, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              
              StyleBox[
               InsetBox["\<\"\[EmptySquare]\"\>", {31.659225875646104, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-40.340943771488284, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {34.65922254798655, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-43.340988541359216, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {32.658841234778905, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-41.34127116323533, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {61.533219681767186, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-70.4670522818902, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {47.5330791022475, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-56.46701553651661, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {24.65920066242087, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-33.34092227159292, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.300630996469888, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.900346940202133, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {33.65905864326737, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-42.34081632550436, 4.512945241945574}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.300630996469888, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.900346940202133, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.300630996469888, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.900346940202133, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.6003175012993283, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.60100614381313, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {55.53283243663866, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-64.46739506232224, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {54.53306059828793, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-63.46698269688735, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.900422093749666, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.300710797475603, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.100426344668657, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.100386954332169, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {62.53305077013809, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-71.46678568954108, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {50.53312123843283, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-59.467094916063616, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.6003175012993283, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.60100614381313, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {43.533197060661976, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-52.467202900682494, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {49.53294194921661, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-58.4670151515563, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.900422093749666, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.300710797475603, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.500810170663849, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.70036037299184, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {63.53307909765005, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-72.46692041972995, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.500810170663849, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.70036037299184, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {44.53301831071528, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-53.46678887337479, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {53.53269402275044, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-62.46685674510361, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {45.533180029480455, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-54.46678982836, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.500810170663849, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.70036037299184, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {42.533071381326664, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-51.46677778703915, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.6003175012993283, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.60100614381313, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.400308181522661, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.8006962066887295, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {52.5331258380735, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-61.467195171508536, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.400308181522661, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.8006962066887295, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.400308181522661, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.8006962066887295, 4.386889790339869}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {51.5331737695268, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[1, 0, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-60.466869255317796, 4.386889790339869}],
               StripOnInput->False,
               FontSize->13.]}}}, {}},
          AspectRatio->1.,
          Axes->False,
          AxesLabel->{None, None},
          AxesOrigin->{0, 0},
          BaseStyle->{FontFamily -> "Helvetica", 16},
          DisplayFunction->Identity,
          Epilog->{{
             InsetBox[
              FormBox[
               StyleBox["\"Npt: 3966\"", 16, 
                GrayLevel[0], StripOnInput -> False], TraditionalForm], 
              Scaled[{0.1, 0.9}]], 
             InsetBox[
              FormBox[
               StyleBox["\"highlighted range:\\n{{1, 100}}\"", 16, 
                GrayLevel[0], StripOnInput -> False], TraditionalForm], 
              Scaled[{0.2, 0.7}]]}, {{
              InsetBox[
               FormBox[
                StyleBox["\"Npt: 3966\"", 16, 
                 GrayLevel[0], StripOnInput -> False], TraditionalForm], 
               Scaled[{0.1, 0.9}]], 
              InsetBox[
               FormBox[
                StyleBox["\"highlighted range:\\n{{1, 100}}\"", 16, 
                 GrayLevel[0], StripOnInput -> False], TraditionalForm], 
               Scaled[{0.2, 0.7}]]}}},
          Frame->True,
          FrameLabel->{
            FormBox[
             StyleBox["\"x\"", 18, 
              GrayLevel[0], StripOnInput -> False], TraditionalForm], 
            FormBox[
             StyleBox["\"\[Mu] [GeV]\"", 18, 
              GrayLevel[0], StripOnInput -> False], TraditionalForm]},
          FrameTicks->{{{-13.815510557964274`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.512925464970229`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.210340371976182, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.605170185988091, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.3025850929940455`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
              FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
             0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.791759469228055, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.302585092994046, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.0943445622221, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.248495242049359, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.382026634673881, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.499809670330265, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.605170185988092, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.703782474656201, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.991464547107982, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.396929655216146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.551080335043404, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.684611727667927, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.802394763324311, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.006367567650246, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.294049640102028, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.699514748210191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.987196820661973, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.104979856318357, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.210340371976184, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.308952660644293`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.596634733096073`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.002099841204238`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.156250521031495`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.289781913656018`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.407564949312402`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}}, {{-13.815510557964274`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.512925464970229`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.210340371976182, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.605170185988091, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.3025850929940455`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
              FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
             0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.791759469228055, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.302585092994046, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.0943445622221, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.248495242049359, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.382026634673881, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.499809670330265, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.605170185988092, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.703782474656201, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.991464547107982, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.396929655216146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.551080335043404, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.684611727667927, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.802394763324311, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.006367567650246, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.294049640102028, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.699514748210191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.987196820661973, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.104979856318357, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.210340371976184, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.308952660644293`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.596634733096073`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.002099841204238`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.156250521031495`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.289781913656018`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.407564949312402`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}}, {{-13.815510557964274`, 
              FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
              FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
              FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
              FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
              FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm]}, {0., 
              FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
              FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
              FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
              FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
              FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
              FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
              FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
              FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
              FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
              FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
              FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
              FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
              FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
              FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
              FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
              FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
              FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
              FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
              FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
              FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
              FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
              FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
              FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
              FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
              FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
              FormBox["\"\"", TraditionalForm]}}, {{-13.815510557964274`, 
              FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
              FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
              FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
              FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
              FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm]}, {0., 
              FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
              FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
              FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
              FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
              FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
              FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
              FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
              FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
              FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
              FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
              FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
              FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
              FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
              FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
              FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
              FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
              FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
              FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
              FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
              FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
              FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
              FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
              FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
              FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
              FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
              FormBox["\"\"", TraditionalForm]}}},
          FrameTicksStyle->GrayLevel[0],
          
          GridLines->
           NCache[{{-16.11809565095832, -13.815510557964274`, \
-11.512925464970229`, -9.210340371976182, -6.907755278982137, \
-4.605170185988091, -2.3025850929940455`}, {
              Log[10], 
              Log[50], 
              Log[100], 
              Log[500], 
              Log[1000], 
              Log[5000], 
              Log[
              10000]}}, {{-16.11809565095832, -13.815510557964274`, \
-11.512925464970229`, -9.210340371976182, -6.907755278982137, \
-4.605170185988091, -2.3025850929940455`}, {2.302585092994046, 
            3.912023005428146, 4.605170185988092, 6.214608098422191, 
            6.907755278982137, 8.517193191416238, 9.210340371976184}}],
          GridLinesStyle->Directive[
            Dashing[{Small, Small}]],
          ImagePadding->All,
          ImageSize->{{600}, {600}},
          Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& )}},
          PlotLabel->None,
          PlotRange->NCache[{{-Log[100000], 0}, {0, 
              Log[6000]}}, {{-11.512925464970229`, 0}, {
             0, 8.699514748210191}}],
          PlotRangeClipping->True,
          PlotRangePadding->{{0, 0}, {0, 0}},
          Ticks->{Automatic, Automatic}], Scaled[{0.5, 0.5}], Center, 
         Scaled[{1, 1}]], InsetBox[
         TemplateBox[{FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   StyleBox["\"\"", {FontSize -> 14, 
                    GrayLevel[0], FontFamily -> "Arial"}, Background -> 
                    Automatic, StripOnInput -> False]}, {
                   GraphicsBox[{{}, {}, 
                    
                    RasterBox[{{{0., 0.7, 0.}}, {{0., 0.7, 0.}}, {{0.75, 0.75,
                     0.}}, {{0.75, 0.5499999999999997, 0.}}, {{0.7, 0., 
                    0.}}, {{0.7, 0., 0.}}}, {{
                    Rational[-15, 2], -75}, {
                    Rational[15, 2], 75}}], {Antialiasing -> False, 
                    AbsoluteThickness[0.1], 
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]], 
                    LineBox[
                    NCache[{{
                    Rational[15, 2], -75}, {
                    Rational[-15, 2], -75}, {
                    Rational[-15, 2], 75}, {
                    Rational[15, 2], 75}, {
                    Rational[15, 2], -75}}, {{
                    7.5, -75}, {-7.5, -75}, {-7.5, 75}, {7.5, 75}, {
                    7.5, -75}}]]}, {
                    CapForm[None], {}}, {Antialiasing -> False, 
                    StyleBox[
                    LineBox[{{7.5, -75.}, {7.5, 75.}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.5, -50.}, 
                    Offset[{4., 0}, {7.5, -50.}]}, {{
                    7.5, -25.000000000000007`}, 
                    Offset[{4., 0}, {7.5, -25.000000000000007`}]}, {{
                    7.5, -9.454993157153694*^-15}, 
                    Offset[{4., 0}, {7.5, -9.454993157153694*^-15}]}, {{7.5, 
                    25.}, 
                    Offset[{4., 0}, {7.5, 25.}]}, {{7.5, 49.99999999999997}, 
                    Offset[{4., 0}, {7.5, 49.99999999999997}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox["0", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -50.}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    "\"0.8889\"", 0.8888888888888888, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -25.000000000000007`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    "\"1.3333\"", 1.3333333333333333`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -9.454993157153694*^-15}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"2.0000\"", 2., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 25.}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"3.0000\"", 3., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 49.99999999999997}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1], FontSize -> 14, 
                    GrayLevel[0]]}, StripOnInput -> False]}, {}}, {
                    Directive[
                    Opacity[1], FontSize -> 14, 
                    GrayLevel[0]]}, StripOnInput -> False], "GraphicsLabel", 
                    StripOnInput -> False]}, "GraphicsTicks", StripOnInput -> 
                    False], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                    Scaled[0.02], PlotRange -> All, Frame -> True, 
                    FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                    Opacity[0], FrameTicksStyle -> Opacity[0], 
                    ImageSize -> {Automatic, 150}, BaseStyle -> {}, 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}]}}, 
                 GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontSize -> 14, 
              GrayLevel[0], FontFamily -> "Arial"}, Background -> Automatic, 
             StripOnInput -> False], TraditionalForm]},
          "BarLegend",
          DisplayFunction->(#& ),
          InterpretationFunction:>(RowBox[{"BarLegend", "[", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0, 0.7, 0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0.4666666666666667, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0, 0.7, 0]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0, 0.7, 0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0, 0.7, 0], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0, 0.7, 0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0.4666666666666667, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0, 0.7, 0]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0, 0.7, 0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0, 0.7, 0], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.75, 0.75, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.5, 0.5, 0.], FrameTicks -> 
                    None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.75, 0.75, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.75, 0.75, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.75, 0.75, 0.], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.75, 0.55, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.5, 0.3666666666666667, 0.],
                     FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.75, 0.55, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.75, 0.55, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.75, 0.55, 0.], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0., 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.4666666666666667, 0., 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0., 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0., 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0., 0.], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0., 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.4666666666666667, 0., 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0., 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0., 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0., 0.], Editable -> False, Selectable -> 
                    False]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "0.003`"}], ",", "3.003`"}], "}"}]}], "}"}], 
               ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.003`"}], ",", "0", ",", 
                   "0.8888888888888888`", ",", "1.3333333333333333`", ",", 
                   "2.`", ",", "3.`", ",", "3.003`"}], "}"}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"FontSize", "\[Rule]", "14"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False]}], 
                   "}"}]}], ",", 
               RowBox[{"LegendLabel", "\[Rule]", "\"\""}], ",", 
               RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
               RowBox[{"LegendMarkerSize", "\[Rule]", 
                 RowBox[{"{", "}"}]}], ",", 
               RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
               RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
               RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], 
             "]"}]& )], Scaled[{1., 0.5}], ImageScaled[{0, 0.5}],
         BaseStyle->{FontSize -> Larger},
         FormatType->StandardForm]},
       AspectRatio->1.,
       Axes->False,
       AxesLabel->{None, None},
       AxesOrigin->{0, 0},
       BaseStyle->{FontFamily -> "Helvetica", 16},
       DisplayFunction->Identity,
       Frame->False,
       FrameLabel->{
         FormBox[
          StyleBox["\"x\"", 18, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         FormBox[
          StyleBox["\"\[Mu] [GeV]\"", 18, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm]},
       FrameTicks->{{{-13.815510557964274`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.02375108873622, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.86960040890896, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.512925464970229`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.903487552536127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.721165995742174, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.567015315914915, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.433483923290392, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.315700887634009, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.210340371976182, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-8.111728083308073, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.824046010856292, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.600902459542082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.418580902748127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.264430222920869, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.013115794639964, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-6.907755278982137, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.809142990314028, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.521460917862246, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.298317366548036, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.115995809754082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.961845129926823, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.710530701645918, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.605170185988091, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.506557897319982, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.995732273553991, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.659260036932778, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.3025850929940455`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-1.203972804325936, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.916290731874155, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
           FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
          0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.302585092994046, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.605170185988092, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.907755278982137, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.210340371976184, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}}, {{-13.815510557964274`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.02375108873622, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.86960040890896, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.512925464970229`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.903487552536127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.721165995742174, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.567015315914915, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.433483923290392, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.315700887634009, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.210340371976182, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-8.111728083308073, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.824046010856292, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.600902459542082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.418580902748127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.264430222920869, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.013115794639964, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-6.907755278982137, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.809142990314028, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.521460917862246, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.298317366548036, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.115995809754082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.961845129926823, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.710530701645918, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.605170185988091, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.506557897319982, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.995732273553991, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.659260036932778, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.3025850929940455`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-1.203972804325936, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.916290731874155, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
           FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
          0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.302585092994046, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.605170185988092, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.907755278982137, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.210340371976184, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}}, {{-13.815510557964274`, 
           FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
           FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
           FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
           FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
           FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
           FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
           FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
           FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
           FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
           FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
           FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
           FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
           FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
           FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
           FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
           FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
           FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
           FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
           FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
           FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
           FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
           FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
           FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm]}, {0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
           FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm]}}, {{-13.815510557964274`, 
           FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
           FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
           FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
           FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
           FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
           FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
           FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
           FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
           FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
           FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
           FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
           FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
           FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
           FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
           FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
           FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
           FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
           FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
           FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
           FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
           FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
           FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
           FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm]}, {0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
           FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm]}}},
       FrameTicksStyle->GrayLevel[0],
       ImagePadding->All,
       ImageSize->{{600}, {600}},
       Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
             (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
              Part[#, 1]], 
             (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
              Part[#, 2]]}& ), "CopiedValueFunction" -> ({
             (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
              Part[#, 1]], 
             (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
              Part[#, 2]]}& )}},
       PlotLabel->FormBox[
         StyleBox[
         "\"\\!\\(\\*SubscriptBox[\\(\[Delta]r\\), \\(i\\)]\\), CT14NNLO\"", 
          24, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm],
       PlotRange->Automatic,
       PlotRangeClipping->False,
       PlotRangePadding->{{0, 0}, {0, 0}},
       Ticks->{Automatic, Automatic},
       ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]],
      InterpretTemplate[Legended[
        Graphics[{{{}, {{{}, {
              Hue[0.67, 0.6, 0.6], 
              Directive[
               PointSize[0.012833333333333334`], 
               AbsoluteThickness[1.6], FontFamily -> "Helvetica", 
               GrayLevel[1]], 
              
              Point[{{0.00001, 2.}, {0.99, 
               1200.}}]}, {}}}, {}, {}, {{}, {}}}, {
           Style[
            Text[
            "\[FilledSquare]", {-0.3118381623295401, 2.6993457604720636`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6039529822035308`, 2.6993457604720636`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.15455075984859803`, 2.5756610130564646`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0091694886945044`, 2.5756610130564646`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.8027388571900397, 2.58851563240702}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.3348410795309749`, 2.58851563240702}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9317114296555002`, 1.534714366238164}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3134438363289216`, 1.534714366238164}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-7.1308988302963465`, 
             1.2424239907001886`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-7.957577403480815, 1.445270566220188}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1880994551696458`, 2.3850863145057892`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3563472847519384`, 2.3850863145057892`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.47352983902229373`, 2.599722324216582}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6414447085691868`, 2.599722324216582}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7505644514298959, 2.5817308344235403`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4007990473227723`, 2.5817308344235403`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.409603402444116, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.1093512670354135`, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3138891646209549, 2.5862591440482876`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.82821600623867, 2.5862591440482876`}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.4286713586629105`, 5.075173815233827}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.12893600699172, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.6474092888860916, 8.006367567650246}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.0475390184841091`, 8.006367567650246}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.6204544951665047, 7.783224016336037}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.5205117032396989`, 7.783224016336037}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.1454883067486056, 2.432735777459091}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.30348549823721, 2.432735777459091}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.18765575838465653`, 2.6224923127405635`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.881903019081021, 2.6224923127405635`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-5.298317366548036, 2.6490076604684267`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8238695231462887`, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0996442489973552`, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7389772837890856`, 1.803358605071407}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.968974088653865, 1.803358605071407}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.56019682034536, 4.0943445622221}], 4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.959419502711985, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-8.622553707074063, 0.973049065692764}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.6094379124341003`, 7.3777589082278725`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-4.3428059215206005`, 
             3.2386784521643803`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-6.214608098422191, 1.6094379124341003`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.0841264243165862`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.304161419150561, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.3286906908754075`, 5.075173815233827}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.228790658775024, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.004138294335951, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.703886158927249, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.666335489679042, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.466278187121473, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-4.3428059215206005`, 
             2.6490076604684267`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2569588998089404, 2.0731719286662407`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9110235456270366`, 2.0731719286662407`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-5.298317366548036, 2.0471765810925606`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.199705077879927, 0.755182571479398}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.2533450600473311, 8.350429973538136}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7533219035960154, 8.350429973538136}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.797175250983993, 2.512035317176253}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4934342366777942`, 2.512035317176253}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.697356025334, 8.006367567650246}], 4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.9975007872996983, 8.006367567650246}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-6.214608098422191, 2.0471765810925606`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.154094566627875, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.554477071672573, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 1.599387576580599}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.359873830032749, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.159425367681418, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.23876493221716663`, 1.601405740736836}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.872802292274865, 1.601405740736836}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.5129946410508307, 6.81783057145415}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.013077000561847, 6.81783057145415}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.7333680090865, 6.253828811575473}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.5974734304916628, 8.006367567650246}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.0975128932248088`, 8.006367567650246}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.6529653909271136, 2.506341930508065}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6492187824459448`, 2.506341930508065}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.953887209526845, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.7539022397884905`, 4.499809670330265}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.5102244577722903`, 6.476972362889683}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.3178664036290963, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-5.817847430944174, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.8665717425242287`, 4.787491742782046}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.266557384867768, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.104394898075602, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.604170685655008, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.298317366548036, 2.6490076604684267`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.378751192832325, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.178596114669692, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.4420193761824103`, 
             3.2386784521643803`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.605170185988091, 2.9290581402859983`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.378751192832325, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.178596114669692, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.9405834244431995, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.4405393759722864`, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.309519943887134, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.209391157353635, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.9904756300635316, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.3907040696085906`, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.529318843261892, 
             1.9033008439609624`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.36154392105023625`, 2.599722324216582}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7538858167999734`, 2.599722324216582}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-8.421883011611913, 1.2424239907001886`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.904054835778969, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.803865056899991, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-6.502290170873972, 1.2424239907001886`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-7.600902459542082, 1.6094379124341003`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-8.532306829226286, 1.2424239907001886`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.8706006059570394, 7.783224016336037}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.2704687956143002`, 7.783224016336037}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.885443919659868, 5.768320995793772}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.2855499581361935`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2262184132732556`, 6.104793232414985}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.725971728690052, 6.104793232414985}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.06016413371338, 5.393627546352362}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.860379772276308, 5.393627546352362}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.5338519254775054`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.539739633930633, 2.5974910105351463`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.579879110192556, 2.5974910105351463`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 1.599387576580599}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.218243944560295, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.9180410777537094`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.735370011757173, 5.768320995793772}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.4354783156390294`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4240364936935998, 8.1797604936999}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9240709191931175, 8.1797604936999}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.317800258800526, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.8180773925856184`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.919365593833201, 6.684611727667927}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.419118909249997, 6.684611727667927}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.1041274693562197`, 2.413231613081109}]
            , 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3842963584572177`, 2.413231613081109}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-4.3428059215206005`, 3.2386784521643803`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.468806782694355, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.068859330518762, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.6747180450915782, 2.58851563240702}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.462743533283297, 2.58851563240702}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.8029620465671519, 7.600902459542082}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.7031992922485748`, 7.600902459542082}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1062413158326008`, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5064301623598713`, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.2864827918762988, 7.24422751560335}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.3865452232556535, 7.24422751560335}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4876628555081794`, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.087375656742122, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.613467558616262, 6.040254711277414}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.01348899514325, 6.040254711277414}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.137918471438812, 5.393627546352362}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.2377341206744292`, 5.393627546352362}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.1409980051645476`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.540748536722336, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.117766656001504, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.017939231019695, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5064301623598713`, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1062413158326008`, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.7479817218821596`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7813228714636707, 7.822444729489319}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2815740503494875`, 7.822444729489319}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.9999411183280458`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.2178763245351174`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.087375656742122, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4876628555081794`, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.4135166537013273`, 6.040254711277414}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.213639558072954, 6.040254711277414}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.068859330518762, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.468806782694355, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 1.7268653293100646`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.6593256320844346, 7.944492163932159}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1593181637855046`, 7.944492163932159}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-7.418747583305227, 1.7328937163610187`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.6675181235106251`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8644101099971662, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4644721421839146`, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.809142990314028, 1.2424239907001886`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyUpTriangle]", {-1.05211045501669, 7.55171221535131}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.552112845814831, 7.55171221535131}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.199705077879927, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.991464547107982, 1.445270566220188}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.3137523001849649, 8.290041618704489}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.813734143549063, 8.290041618704489}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.8438952236485835`, 5.537334267018537}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.2433732333621994`, 5.537334267018537}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.6163727633271883`, 4.787491742782046}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.51624397679369, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-4.382026634673881, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.3137523001849649, 8.290041618704489}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.813734143549063, 8.290041618704489}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 2.209811692841691}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5404260935422814, 8.063377822367027}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0404377246170375`, 8.063377822367027}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1080567474961094`, 6.272877006546167}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5082360319251331`, 6.272877006546167}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9063404010209869, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7064996252772315`, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.6772785424354564`, 6.309918278226516}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8689301605143175, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6691879168398742`, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9329283730271782, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5329399414613754`, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.5787702314339063`, 5.075173815233827}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.978697138696139, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             2.209811692841691}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-4.045554398052668, 1.0335402919243948`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.7042981934580606`, 5.676753802268282}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.104554242494911, 5.676753802268282}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1150465951315345`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6149530931222105`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1026203100656484`, 7.501082124259871}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6029589463363911`, 7.501082124259871}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.006215439402142, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.606442403454302, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8773173575897015`, 1.6114359150967734`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.215490386143112, 1.6114359150967734`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.8205261098897758, 7.783224016336037}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.3205066205818874`, 7.783224016336037}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             2.1094856630282126`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.7164562218841706`, 4.787491742782046}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.416204086475468, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9689006821464524, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5687759307152107`, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.7329280505717899, 7.8709295967551425`}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2330583852210326`, 
             7.8709295967551425`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.6287255312941893`, 5.075173815233827}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.9286606465811693`, 5.075173815233827}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.0181583132629375`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.117817918407743, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.6888794541139363`, 5.298317366548036}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.359873830032749, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.159425367681418, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2942622756733968`, 6.0867747269123065`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.694451286761057, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.417771502803163, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.7181023127908395`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.9910142780700916, 7.6128310304073565`}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4912105310694506`, 
             7.6128310304073565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.0218709311636855`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.911914268349973, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.987249820814649, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5876764206525877`, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.59947470469731, 8.004365564979574}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0993125337825032`, 8.004365564979574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.4395981331422016`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.426283369336254, 6.104793232414985}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.5260163042950279`, 6.104793232414985}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.953887209526845, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.7539022397884905`, 4.499809670330265}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.7963700817857382`, 6.907755278982137}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.096384262410148, 6.907755278982137}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-4.045554398052668, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.5895081458004594, 6.7912214627261855`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9896682016789307, 6.7912214627261855`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.1862091035211472, 2.423031246069913}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.282782465697866, 2.423031246069913}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.9696906777207166`, 6.684611727667927}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.3691523372661587`, 6.684611727667927}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.744604469176456, 2.3933394562625097`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.5288035062673013`, 5.075173815233827}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.028556821684098, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-7.957577403480815, 0.8046885552928528}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.8763491247812073, 2.503891949699081}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4304552569056603`, 2.503891949699081}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.974001029221839, 6.429719478039138}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.874045755297392, 6.429719478039138}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 2.4176979000945504`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.6854573524495757`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.4854489341097463`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-6.214608098422191, 2.3933394562625097`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             2.330200260027019}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.9180031958023054`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.217869048507598, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.7859090555498793`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.900458886151396, 5.480638923341991}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3005870903313728`, 5.480638923341991}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.640928579525471, 
             4.512945241945574}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.040829633207479, 
             4.512945241945574}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6064191770501212, 2.5877640352277083`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5324768712979722`, 2.5877640352277083`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.9521761906339596`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 2.330200260027019}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4240364936935998, 8.1797604936999}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9240709191931175, 8.1797604936999}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.9782390361706734`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.18777640747691846`, 7.1929342212158}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.5878866699024524, 7.1929342212158}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 1.416581053724763}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-6.907755278982137, 0.8046885552928528}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.462149662665384}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2149273965428693, 2.519308076505333}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0612087734187763`, 2.519308076505333}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.0365602553118024, 7.24422751560335}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.636577829072051, 7.24422751560335}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.269150316907808, 5.111987788356544}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.66873333872526, 5.111987788356544}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.764428382564909, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5644645467913691`, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.6700167631710908, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4701108472130011`, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.9910142780700916, 7.6128310304073565`}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4912105310694506`, 
             7.6128310304073565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.509860006183766, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.009386074695824, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.40649706843741, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2063088641234838`, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             2.4561641809223462`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.6354040111173562`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.5356434782150785`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.666335489679042, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.466278187121473, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.9405834244431995, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.4405393759722864`, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.49314943875304795`, 6.887552571664617}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8933068954837797, 6.887552571664617}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-8.047189562170502, 1.2424239907001886`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.878196476740593, 
             1.7776605448485534`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.5824869781268642`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-6.571283042360924, 2.0471765810925606`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0328245481301066`, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4329667693183212`, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.1413169453979233`, 
             4.512945241945574}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-6.541030999190403, 
             4.512945241945574}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2069773133462347`, 6.173786103901937}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.606941032235513, 6.173786103901937}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7199019178687649, 
             7.8838232148921525`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2201021862558195`, 
             7.8838232148921525`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.9205497887945385, 7.783224016336037}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.2207799226423173`, 7.783224016336037}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.8840655845794182, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-5.504112279527633, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.5177604746590787`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.6178619668786562`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.227106951818089}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.816258383443767, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.3162388941358785`, 4.787491742782046}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             2.4561641809223462`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.5703987153008919, 6.960347729101308}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.6704076935904559, 6.960347729101308}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.8442026554799011, 7.759614150696903}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.344384958042681, 7.759614150696903}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 0.9566646260124284}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2010151992412087, 2.0082140323914683`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0971007679422797`, 2.0082140323914683`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.66341149948383, 6.040254711277414}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.9634587130036953`, 6.040254711277414}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-6.437751649736401, 0.973049065692764}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3093333199837622`, 7.294377299288821}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8097197946050478`, 7.294377299288821}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.719319793360441}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 1.416581053724763}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.4722426732562555`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.200028504668954, 6.253828811575473}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.9999411183280458`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2063088641234838`, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.40649706843741, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.6562368265398482, 6.674561391814426}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.1564532883579597`, 6.674561391814426}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.1236024374656055`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.5232317641096684`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.8183088044615916`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.318488613869894, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.227106951818089}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7813228714636707, 7.822444729489319}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2815740503494875`, 7.822444729489319}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.403677882205863, 1.445270566220188}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.815475995845371}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.462149662665384}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.6593256320844346, 7.944492163932159}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1593181637855046`, 7.944492163932159}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2395270305647338, 1.4996230464268938`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-4.0757190980989355`, 1.4996230464268938`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2437536743377806`, 7.360103972989152}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.744112815760702, 7.360103972989152}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.3960099493374092, 6.984716320118266}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.7960662345677868, 6.984716320118266}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.0794415416798357`, 2.187398683184928}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.6661962462527091`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.376740148315079, 7.226936018493289}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8773173575897015`, 7.226936018493289}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4405393759722864`, 5.940171252720432}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8407396514497736`, 5.940171252720432}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.0102369597568726`, 5.393627546352362}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.9105241293044104`, 5.393627546352362}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-6.03270329512458, 1.7328937163610187`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.0808706071919527`, 6.249975242259483}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.5808504555821878`, 6.249975242259483}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.9837562915454279`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.290620611051608, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8904754421672127`, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.7181373293574413`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.4178610876830975`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.719319793360441}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.631199404215613}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.283414346005772, 5.703782474656201}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1874435023747254`, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3874950816964096`, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1796054478776414`, 7.424165281042028}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6798603767306461`, 7.424165281042028}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.4138711288901251`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.1136189934814222`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.8344641259578687`, 6.152732694704104}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.0218709311636855`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.911914268349973, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.19455609446229716`, 2.0706530356467567`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9784819201474635`, 2.0706530356467567`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.9317114296555002`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316692464055834`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.090999490513565}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 2.078566158643882}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.406587064387653}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.5859645562484583`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.995732273553991, 5.991464547107982}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0189110419398038`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5188771693591536`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7667937207282438, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.166888494485349, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.8140100781628747`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 
             1.3045418592476314`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7048480972387587`, 1.8656293177945105`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.878625402249717, 1.8656293177945105`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.8118888405232207`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2761851384398606`, 6.104793232414985}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.6761120457020933`, 6.104793232414985}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.4203757208439185, 6.960347729101308}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.8205261098897758, 6.960347729101308}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.557794679282262, 5.823045895483019}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.9582864201233687`, 5.823045895483019}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 1.599387576580599}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.359436906950008}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.340512168464763}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 1.599387576580599}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-2.995732273553991, 5.991464547107982}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-3.3524072174927233`, 1.497835735852798}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-5.2030071867437115`, 2.3933394562625097`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.6661962462527091`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             2.078566158643882}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.5177707239082765`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.617850239145466, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.9782390361706734`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.5774997570339834, 8.026170194946426}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.0776338822829181`, 8.026170194946426}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.462149662665384}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.721515815839451}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.3178883284558303`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.8178684794407625`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.2499926428748753`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.9499943818801375`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3688474475161698`, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1689274625831354`, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.563430511492267, 6.040254711277414}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.0635829404621653`, 6.040254711277414}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 1.416581053724763}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             2.2086040295231517`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.8442026554799011, 7.759614150696903}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.344384958042681, 7.759614150696903}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.5554040239416147`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.900458886151396, 5.480638923341991}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3005870903313728`, 5.480638923341991}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.41779075779880137`, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-5.717779984300055, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.835485924411894, 5.768320995793772}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.3354096411241523`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2854179707987138, 2.4997952622817508`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.029509172931627, 2.4997952622817508`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 1.599387576580599}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8328691237350826, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6332184410995039`, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.719252778441307, 6.684611727667927}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.6190782472999463`, 6.684611727667927}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-4.8283137373023015`, 1.7328937163610187`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.074653024948039, 6.429719478039138}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.7740297600361856`, 6.429719478039138}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.2072749131897207`, 6.396929655216146}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706800981701778, 6.396929655216146}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyUpTriangle]", {-1.05211045501669, 7.55171221535131}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.552112845814831, 7.55171221535131}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.744604469176456, 1.7328937163610187`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.6179742434563866`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.518075479137158, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.6444188813293459`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             2.1992225799988927`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.887460350206278, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6873994539038122`, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             2.1992225799988927`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.894078619827491, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.49397078181451, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.6526889544284153`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.617843933216061, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.517955942272351, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.575036485716768, 2.020222182019865}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6993626199620875`, 2.020222182019865}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.696151689580244, 6.684611727667927}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0963149296194261`, 6.684611727667927}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.036482917202561, 7.56734567601324}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5366522427084526`, 7.56734567601324}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             2.3243465847755584`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1542307124311217`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-5.234028876665675, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.4958211856471328`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.995732273553991, 3.8004208288468435`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.4179914478631452`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.7177791303707455`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.251047211711865}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.462149662665384}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.9353900445478294`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.235513466021224, 5.768320995793772}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.1498640059763816`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.049977288406387, 6.253828811575473}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.696151689580244, 6.684611727667927}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0963149296194261`, 6.684611727667927}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7672619976276676`, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.166785108860756, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.9165331609060323`, 4.787491742782046}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.216512196196308, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.019664337643975, 6.684611727667927}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.3191210616341453`, 6.684611727667927}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.090999490513565}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.8528465593176202, 7.751045117971802}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3528595850336531`, 7.751045117971802}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820086052689358`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1821389399181785`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9065879564127699, 7.697121317282625}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.406905315024015, 7.697121317282625}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.5922917535991299`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.5100594684538216`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1689274625831354`, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3688474475161698`, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.462149662665384}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.3998672158005996`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.800001029850119, 6.253828811575473}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.4146388341290332`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             2.3243465847755584`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.8122154777954373`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.491654876777717, 2.227106951818089}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.880084850028029, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.380218975276964, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2072749131897207`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.6854573524495757`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.4854489341097463`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-7.600902459542082, 1.445270566220188}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.0529699307894087`, 7.600902459542082}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.4528616053920038`, 7.600902459542082}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-7.1308988302963465`, 1.7328937163610187`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.363503507963463, 6.040254711277414}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.2636117187095923`, 6.040254711277414}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.4569857892424236`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 2.253709925211909}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.204382667431038, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.504420282887948, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.06016413371338, 5.393627546352362}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.860379772276308, 5.393627546352362}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3874950816964096`, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1874435023747254`, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.8528465593176202, 7.751045117971802}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3528595850336531`, 7.751045117971802}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6713133161521878`, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.271538123821702, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751531979714171, 5.8522024797744745`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.25165731439258, 5.8522024797744745`}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.5338519254775054`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.719319793360441}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0940068428223313`, 4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.293868803909631, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 1.416581053724763}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.462149662665384}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             0.766397642299538}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.741256487054948, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.9407951330603375`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3063747379440172`, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3063747379440172`, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             1.5532907518110994`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.8470364847178946`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.2180717287054377`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.91782824451005, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.5824869781268642`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.18260159600127354`, 2.136530508663963}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8587568185269134`, 2.136530508663963}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.1029215602562081`, 7.600902459542082}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.4028303297599902`, 7.600902459542082}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.556451816951096}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.896419739771488}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.9782390361706734`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.1866231659908228`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.6139480679119864`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.9139271032022627`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 2.04225875055212}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6734432424100127`, 1.691939133945844}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.2576117273513145`, 1.691939133945844}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7199019178687649, 
             7.8838232148921525`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2201021862558195`, 
             7.8838232148921525`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.2672179491567546`, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-6.667164814064207, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             2.6397713603489157`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.0177699008240089`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-5.117830825699811, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.6888794541139363`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.0940068428223313`, 
             4.386765389021055}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.2941383093687477`, 
             4.386765389021055}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.7929254558680243`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4375876555074412`, 2.0149030205422647`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8476951015583583`, 2.0149030205422647`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.2098554674840916`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7813228714636707, 7.822444729489319}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2815740503494875`, 7.822444729489319}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.564942672547549, 5.966146739123692}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.664950622364359, 5.966146739123692}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 2.090999490513565}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.6397713603489157`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.5565205830281202, 
             2.702032128776647}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3567355588783463`, 
             2.702032128776647}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.606941032235513, 1.7833912195575383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.1413169453979233`, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.8526977673331346`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8016236568960291, 6.579251212010101}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2016421889876536`, 6.579251212010101}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-7.284632930238389, 
             1.6094379124341003`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.236923904465622}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.4890765557629164`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2669126040998102`, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.666828609658249, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 2.0719132752590443`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.902704363179782}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.7129418078881248, 6.81783057145415}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.8130574772325029, 6.81783057145415}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.5257286443082556`, 6.461468176353717}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.5824869781268642`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.1975522365230131`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1409980051645476`, 
             4.512945241945574}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.540748536722336, 
             4.512945241945574}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.6843598389513597`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 2.556451816951096}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.3027280306570521, 2.419478844465545}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.1733127572899065`, 2.419478844465545}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.23395175003081314`, 7.146772179452637}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.6339353209280992, 7.146772179452637}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.9910142780700916, 7.6128310304073565`}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4912105310694506`, 
             7.6128310304073565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.316022308134559, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.915963072687361, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.4971646699513146`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.5824869781268642`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.5895081458004594, 6.7912214627261855`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9896682016789307, 6.7912214627261855`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.0218709311636855`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.911914268349973, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.9372477759766606`, 5.393627546352362}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.4371455863897404`, 5.393627546352362}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.741256487054948, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[$CellContext`\[FivePointedStar], {-1.3413209954771594`, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.1921026317554486`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.287354413264987, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.287354413264987, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.3204807842031671, 6.960347729101308}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.9205497887945385, 6.960347729101308}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.5338519254775054`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1150465951315345`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6149530931222105`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.9474803442248305`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5716605481000705`, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3716028123769008`, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.4307829160924542, 2.647592232065096}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 2.193662685769859}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 1.599387576580599}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9712750402069146, 
             7.6324011266014535`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4714166145367258`, 
             7.6324011266014535`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.987774353154012, 5.393627546352362}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.3871630694693433`, 5.393627546352362}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2669126040998102`, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.666828609658249, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 2.075308010398229}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4329667693183212`, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0328245481301066`, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.3540294005326152`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.3101690833145914`, 5.393627546352362}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.6100682736896466`, 5.393627546352362}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.462149662665384}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751531979714171, 5.8522024797744745`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.25165731439258, 5.8522024797744745`}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 2.1587147225743437`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6939993778795506`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.694093021166824, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.4722426732562555`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.174191878225647, 6.429719478039138}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.674083651538937, 6.429719478039138}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-4.2845370133966245`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             2.193662685769859}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.7177975525570903`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.4179367056664534`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.8540604954254345`, 5.676753802268282}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.9540431322855023`, 5.676753802268282}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020229905154391, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520318812570019, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-1.491654876777717, 2.073423469354273}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             2.0680013515372804`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 2.0215475632609334`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047875165492457`, 6.298949246855942}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.804781390061982, 6.298949246855942}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.0241960674538575`, 6.429719478039138}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.823966230699553, 6.429719478039138}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.463458318582131, 6.040254711277414}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.1634411179801, 6.040254711277414}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 6.684611727667927}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5104979645791967`, 1.9358598132018119`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.932401799030521, 1.9358598132018119`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4092798316650086`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.9093711079059474`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.9474803442248305`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.2669476034873244`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.522010001878903, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.411934093335004, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.3492738284584218, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-8.599488434143067, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.064355904261795, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640797356921787`, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.144222799920162}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 1.599387576580599}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 1.416581053724763}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.898454207899018, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4983438649285135`, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.48304834276654407`, 6.897704943128636}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8830977645183911, 6.897704943128636}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.1850957485562468`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-7.1308988302963465`, 0.973049065692764}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.594056810395798, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3943265328171548`, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8627499649461253, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0605908459024875`, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.430629081771714, 
             2.827905162910489}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2306590695884416`, 
             2.827905162910489}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3893457262282811, 2.0068708488450007`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.91139112512024, 2.0068708488450007`}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.2602187884025833`, 5.393627546352362}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.660097652688484, 5.393627546352362}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.96443110720209, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3645328693383778`, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.8442026554799011, 7.759614150696903}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.344384958042681, 7.759614150696903}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.410950117672171, 4.969813299576001}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.810913836561449, 4.969813299576001}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.8563722416629115, 6.674561391814426}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.9563317814113389, 6.674561391814426}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.131032179924221, 6.249975242259483}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.531088946023124, 6.249975242259483}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.1177951080848836`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-5.017810977845351, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 2.187398683184928}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.8470364847178946`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.9177918580004223, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-5.2178439823981595`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.4342248948774405`, 
             4.386765389021055}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.95401869367736, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3903023825174294`, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7903604483143476`, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.184789984909162}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4571461020918417`, 1.4883995840570443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8807977354618917`, 1.4883995840570443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.491654876777717, 2.090999490513565}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4182464424728975, 2.6019486702196644`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6922761907431048`, 2.6019486702196644`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6184786570862495`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4184044150381243`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 0.9991602096964498}], 6., 
            
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.110245660342752, 5.393627546352362}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.810369351701646, 5.393627546352362}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.5978370007556204, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.227106951818089}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.5338519254775054`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-8.94874563428772, 0.973049065692764}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.2581768583394481`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.5824869781268642`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             2.0680013515372804`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.5841201044498106`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.71869489837105, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3186357126460757`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 0.9329511727672622}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 1.599387576580599}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.809109107563168, 1.4951487660319727`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.515036014769512, 1.4951487660319727`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2739976361421332`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.3732221725934863`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.3137876703331426`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.2136588837996443`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.4079456086518722`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.8805331812814825`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4983438649285135`, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.898454207899018, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.817803785159501, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-5.317908016313041, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 1.173410498743296}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 1.416581053724763}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.269044801069651, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.269044801069651, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.2919836816486494`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3035404883862389, 1.5107219394949427`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.989444152396731, 1.5107219394949427`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             2.0624225365102413`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4903224315439383`, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6906479678596436`, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.7218733417638885`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             0.898534010284896}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.22276862160913655`, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.525061368884541, 1.7833912195575383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5191402744533198`, 1.6882490928583902`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.418894215394429, 1.6882490928583902`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.416581053724763}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.4722426732562555`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.5902550930173265`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.437937594271729}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.0029385385998273`, 7.600902459542082}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.502828177375842, 7.600902459542082}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.924832423452417}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 1.721515815839451}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.9296292963133357, 7.674152921281675}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4296194858582643`, 7.674152921281675}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.33589240475620386`, 2.502255288122613}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.974001029221839, 2.502255288122613}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7655070980839893`, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3657077275115024`, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 1.599387576580599}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.3025850929940455`, 6.684611727667927}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5228016057745537`, 5.857933154483459}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.922779731666459, 5.857933154483459}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.369240606554063, 1.691939133945844}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5612262966614128`, 1.691939133945844}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.449925680892755, 6.253828811575473}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.7499665442035015`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.618595850218866}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             2.5087859235779435`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-1.984131361875511, 7.003065458786462}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2069773133462347`, 6.173786103901937}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.606941032235513, 6.173786103901937}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.2246985543369746`, 6.429719478039138}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.6240307955986357`, 6.429719478039138}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.462149662665384}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.793961892783255, 5.537334267018537}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.2936253516225737`, 5.537334267018537}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7174398731289899, 2.5087859235779435`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5793937910857236`, 2.5087859235779435`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.462149662665384}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.523226215615035}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 0.9034081060431414}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.5532907518110994`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.719319793360441}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6906479678596436`, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4903224315439383`, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7672619976276676`, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.166785108860756, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.5178502387029551, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-5.61797181824309, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.2756420910162956`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.023439351564551, 5.2574953720277815`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.623341473175256, 5.2574953720277815`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6424777665123005`, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6424777665123005`, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.491654876777717, 1.599387576580599}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.461401833606696}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6445470895476684`, 5.736572297479192}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.044846896915337, 5.736572297479192}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9038682118755978, 6.476972362889683}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3037931396081468`, 6.476972362889683}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.036482917202561, 7.56734567601324}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5366522427084526`, 7.56734567601324}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             1.3302529702362658`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.3540294005326152`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.0261055978813616`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.926205565780978, 7.3777589082278725`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-7.523941418405954, 1.497835735852798}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.1760334356366946`, 6.104793232414985}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.7760829898430475`, 6.104793232414985}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4943251053335957`, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4943251053335957`, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.0498221244986778`, 2.647592232065096}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7667937207282438, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.166888494485349, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.4961092271270973`, 6.907755278982137}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.3960170377865984`, 6.907755278982137}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 0.6951451832226183}], 6., 
            
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8457617469776957`, 5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.145857732131629, 5.991464547107982}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 1.2499017362143359`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.4146938356415886`, 5.966146739123692}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.8146187633741377`, 5.966146739123692}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             0.7975071958841882}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-8.11206147220931, 0.973049065692764}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.542246662893777, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.742398039690331, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.3563504847468186`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.522010001878903, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.411934093335004, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.609379030762146, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.909388227079972, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             2.0624225365102413`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.3964921860963366`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.715777948205427}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 0.8450095298691913}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2496677635880655`, 6.131226489483141}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6497392092076262`, 6.131226489483141}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 2.28401370740861}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.816462081868427, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4159291662495814`, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.7535382564078572`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-5.2030071867437115`, 1.7328937163610187`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0189110419398038`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5188771693591536`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.418781887396557, 5.111987788356544}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.51875303057183, 5.111987788356544}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6745099091778153`, 1.9300710850255671`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.780226233414382, 1.9300710850255671`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.298317366548036, 2.0471765810925606`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             1.9313764735639716`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.132893222644984, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3329431856228962`, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.389499492068839, 5.991464547107982}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 5.991464547107982}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.1026043099376472`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.694451286761057, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2942622756733968`, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             1.5904589458362974`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 1.506518858426259}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2977324083052823, 1.6114359150967734`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.7937956240634962`, 1.6114359150967734`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 
             1.3754861624032872`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7987840841650193`, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.598497972395766, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.4722426732562555`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.2072749131897207`, 6.396929655216146}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706800981701778, 6.396929655216146}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.7178497932003172, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-5.417776806585365, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 
             1.6378309869353183`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.090999490513565}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.2319770007355333`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.7317869551252127`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.201916872261721, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.090999490513565}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.2919836816486494`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.2792657883613672`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.557794679282262, 1.8687205103641833`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.019664337643975, 1.8687205103641833`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4714166145367258`, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4714166145367258`, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1702157075278026`, 7.433666540166168}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6702500518308578`, 7.433666540166168}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 2.424802725718295}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 
             1.7693434299437227`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.424802725718295}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.6661962462527091`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.2919836816486494`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.9178457348969196`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.2178763245351174`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6311724045801064`, 1.4883995840570443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.706800981701778, 1.4883995840570443`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6414447085691868`, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4409617624621989`, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.5087859235779435`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3716028123769008`, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5716605481000705`, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.48175237628028356`, 
             8.122074375362217}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9816295731824954, 8.122074375362217}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4679383501604009`, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.279845606024556, 1.7833912195575383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8442026554799011, 1.7850704810772584`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9002402920947703`, 1.7850704810772584`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.6593256320844346, 6.721425700790643}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0592954262911594`, 6.721425700790643}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.369240606554063, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9696906777207166`, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.552112845814831, 5.8289456176102075`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9519282213808764`, 5.8289456176102075`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.9368694044031642`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.8162894669713328`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2790527457537265, 1.864080130807681}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.3071607397357723`, 1.864080130807681}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 1.1464496180822696`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.000759888500605, 6.380122536899765}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4007990473227723`, 6.380122536899765}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.9980550336767947}], 6., 
            
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.770028224895903, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3700273886560186`, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2909841813155656`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6654793033177253`, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4653375684603434`, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.6661962462527091`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.880084850028029, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.380218975276964, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.2788685663767296`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.402746540537711, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.9969586349416099, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0969137320325284`, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.6936470556015963}], 6., 
            
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9038682118755978, 6.476972362889683}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3037931396081468`, 6.476972362889683}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.406587064387653}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.227106951818089}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2909841813155656`, 2.414126467726953}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             1.5904589458362974`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.5366522427084526`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-7.412267540691536, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.9313764735639716`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0189110419398038`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5188771693591536`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.719319793360441}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.416581053724763}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.552112845814831, 5.8289456176102075`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9519282213808764`, 5.8289456176102075`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9065879564127699, 7.697121317282625}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.406905315024015, 7.697121317282625}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8016236568960291, 6.579251212010101}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2016421889876536`, 6.579251212010101}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 1.421661504957182}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.5902550930173265`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111964733385396, 6.492239835020471}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6115589009134488`, 6.492239835020471}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7573580425107227`, 1.589235205116581}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3789263262507685`, 1.589235205116581}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             1.8002235476401844`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.8179208722379223`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.317867774075151, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.5978370007556204, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 1.721694594779768}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.2672179491567546`, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-6.667164814064207, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-4.8283137373023015`, 2.0471765810925606`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.4722426732562555`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 1.5377270648801}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5901256014017275`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0898959995836948`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.412288358086009, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-6.536881615643591, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2783372196147982`, 1.864080130807681}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.308100273682156, 1.864080130807681}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.565421027017326, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.565421027017326, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 2.044332364566268}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.7406415980494447`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7625890919282752`, 6.841615476477592}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262403303361214, 6.841615476477592}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.5960282255241827`, 6.907755278982137}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.296603021316498, 6.907755278982137}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.617854196524514, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-5.51796702860799, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 0.849723487602042}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.257346872655708, 2.0028304393079956`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0514564223263525`, 2.0028304393079956`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.6623114020411685`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-7.286383733136742, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.8162894669713328`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.0935997468445653`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 1.669026703845758}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7969533492855345, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2971851860481147`, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 2.377692565480851}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.8002235476401844`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.5338519254775054`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.342468881579861, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9428149441480107`, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.1151705891340815`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 2.293947899598382}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4405393759722864`, 5.940171252720432}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8407396514497736`, 5.940171252720432}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-7.1308988302963465`, 1.445270566220188}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 1.900464386136271}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             1.8526977673331346`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.2568373311553196`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.676945820702642, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 0.8060293376166178}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.462149662665384}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.377692565480851}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.795734531747094, 
             5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-3.1958919884778254`, 
             5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             1.721694594779768}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.017383521085972, 0.8385453832493022}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-8.622553707074063, 0.8046885552928528}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             1.8526977673331346`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.739076112448345}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 0.880041599199034}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.186787979571835, 1.7833912195575383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5608378214218233`, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.2072749131897207`, 6.396929655216146}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706800981701778, 6.396929655216146}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324790142551358`, 5.971261839790462}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132468797127462, 5.971261839790462}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.2568373311553196`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.676945820702642, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047875165492457`, 6.298949246855942}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.804781390061982, 6.298949246855942}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 2.031563461435372}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             1.9838938336679197`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.421661504957182}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.26683423993894284`, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.666853965970644, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1026203100656484`, 7.501082124259871}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6029589463363911`, 7.501082124259871}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1150465951315345`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6149530931222105`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.612442421454399, 5.768320995793772}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0129050178795915`, 5.768320995793772}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.7985076962177716, 2.647592232065096}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.090999490513565}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 
             2.1627481478062465`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0942219403668167`, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8944568674663975`, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             0.9411784473819341}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.698815723585317, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.698815723585317, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3842963584572177`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-5.0040073078060345`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.293947899598382}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.491654876777717, 1.416581053724763}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-3.6888794541139363`, 2.9290581402859983`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.9251241812954787`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             2.1151705891340815`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.1167795926235586`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8470607850131444`, 6.756932389247553}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346745988779815, 6.756932389247553}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 1.715777948205427}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.340556469446037, 6.040254711277414}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7406861990440543`, 6.040254711277414}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.017773404430871, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.117899907528199, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4405393759722864`, 5.940171252720432}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8407396514497736`, 5.940171252720432}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.271538123821702, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6713133161521878`, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.5978370007556204, 1.497835735852798}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.5824869781268642`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.669026703845758}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.6587993419718245`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.3540294005326152`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.9245405804618736`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820086052689358`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1821389399181785`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2303167796655379`, 1.691939133945844}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7002308520500784`, 1.691939133945844}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.9368694044031642`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.26683423993894284`, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.666853965970644, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 1.406587064387653}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3983901944362025, 1.9358598132018119`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0442924641693683`, 1.9358598132018119`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 2.075684492802124}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.5338519254775054`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.6661962462527091`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.246332151443247}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 1.5377270648801}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.795734531747094, 5.991464547107982}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1958919884778254`, 5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-7.819058469345253, 
             1.3540294005326152`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             1.9838938336679197`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.836849948493799, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.0968250627658085`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3983669423541598`, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9987836386623814`, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3329431856228962`, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.132893222644984, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.516892795645856, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.016955910005618, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-7.1308988302963465`, 1.2424239907001886`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.6661962462527091`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4126383364594925`, 1.8625285401162623`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.176833887688485, 1.8625285401162623`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.7607838292757566, 6.620073206530356}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.160913314865489, 6.620073206530356}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.4588475538015993`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.0289048762432895`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.3226876816505963, 2.005525858729668}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9806466361359503`, 2.005525858729668}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.605170185988091, 2.3933394562625097`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.3498863661120586`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.8499018253424513`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.6888794541139363`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3943265328171548`, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.594056810395798, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 2.246332151443247}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3180038323381698, 2.0731719286662407`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8500747011316276`, 2.0731719286662407`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.9317114296555002`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316692464055834`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1715056141884346`, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.771368779580321, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.4126383364594925`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-7.536426440357718, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3039860739096736`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-4.083998270167957, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.742398039690331, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.542246662893777, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.3540294005326152`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.3261404383001434`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.6260755535871236`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 
             1.0420419371797154`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.773934884315503}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6691879168398742`, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6691879168398742`, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0177699008240089`, 6.363028103540465}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4179914478631452`, 6.363028103540465}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.612442421454399, 5.768320995793772}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0129050178795915`, 5.768320995793772}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.3754861624032872`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.2919836816486494`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.4588475538015993`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7159101569446171`, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5159475693467614`, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.1627481478062465`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.659260036932778, 1.0845133642886082`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.8195418502405067`, 6.684611727667927}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.5191254931746836`, 6.684611727667927}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.6661962462527091`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.6378309869353183`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5186835491656363`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5186835491656363`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.5299617109323036`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3645328693383778`, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.96443110720209, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.7837272975307907`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5832829549572491`, 1.5933085305042167`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5449114637250294`, 1.5933085305042167`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1026203100656484`, 7.501082124259871}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6029589463363911`, 7.501082124259871}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.25154302583590776`, 2.130609828254235}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8016468498397944`, 2.130609828254235}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.2140221401789375`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.598497972395766, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7987840841650193`, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6445470895476684`, 5.736572297479192}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.044846896915337, 5.736572297479192}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.2761851384398606`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.6761120457020933`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-6.571283042360924, 1.7328937163610187`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.719319793360441}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.1413169453979233`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.541030999190403, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             1.2756420910162956`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.493987758524193, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.894183087299815, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2453891602615295, 2.424802725718295}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.220083871482302, 2.424802725718295}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.7329280505717899, 7.8709295967551425`}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2330583852210326`, 
             7.8709295967551425`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.4338645826298623, 6.946975992135418}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8337895103624113, 6.946975992135418}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.8699543168131119`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.7693434299437227`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.900464386136271}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.522010001878903, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.411934093335004, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.820158943749753, 5.560681631015528}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.220083871482302, 5.560681631015528}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.46013250945047257`, 2.512035317176253}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8307082193666298`, 2.512035317176253}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4092798316650086`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.9093711079059474`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.469241281940817, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.869504817852908, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9712750402069146, 
             7.6324011266014535`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4714166145367258`, 
             7.6324011266014535`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.8069317506623275`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.4109447331170353`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.0808706071919527`, 6.249975242259483}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.5808504555821878`, 6.249975242259483}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7696066645869217`, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5692561228012685`, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.3302529702362658`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9192952408944538, 6.461468176353717}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3193836558372638`, 6.461468176353717}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.506518858426259}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2824955457644808, 1.7817091333745536`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.4686200579795896`, 1.7817091333745536`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751531979714171, 5.8522024797744745`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.25165731439258, 5.8522024797744745`}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3171415024315738`, 6.063785208687608}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7170231231140378`, 6.063785208687608}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 1.726509584019938}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1409980051645476`, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9414202437824613`, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-6.607650686531799, 1.445270566220188}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.2919836816486494`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.294616923344869, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-4.0941445822194344`, 4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5159475693467614`, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7159101569446171`, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2262184132732556`, 6.104793232414985}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.725971728690052, 6.104793232414985}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3617968895195032`, 1.9416152247724325`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.069887328875024, 1.9416152247724325`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9065879564127699, 7.697121317282625}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.406905315024015, 7.697121317282625}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3257638613798584`, 1.776645831418007}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.435545220250276, 1.776645831418007}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.2876820724517809, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.2787091504399533`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.744604469176456, 2.0471765810925606`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.031563461435372}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.746403767507258, 6.907755278982137}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.1464364105041143`, 6.907755278982137}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 0.9543569326806114}], 6., 
            
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.615959129424366, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.615959129424366, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.018486244188825}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.5338519254775054`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.7822140563845235`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.8056623743970464`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5906161581935125`, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5906161581935125`, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4653375684603434`, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6654793033177253`, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.2568373311553196`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.676945820702642, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5235731965884932, 2.50470927708418}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.7820071777853768`, 2.50470927708418}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-1.491654876777717, 1.783559272662715}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.0891571298973546`, 6.29156913955832}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.489435120039404, 6.29156913955832}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1184069159962893`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9186841628017217`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 2.227106951818089}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.412288358086009, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.536881615643591, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3478567954878509, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.399798360748448, 1.7833912195575383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3799147541558516`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8799351601317804`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-7.600902459542082, 0.973049065692764}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-6.214608098422191, 2.0471765810925606`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 1.144222799920162}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.3407610128583247`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.340807418168989, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             0.9290095042819297}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.2072749131897207`, 6.396929655216146}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706800981701778, 6.396929655216146}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.6269849783062765, 1.937301774518713}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8129108417183852`, 1.937301774518713}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2330583852210326`, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2330583852210326`, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.4865920824352545`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.2876820724517809, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7985076962177716, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.3670139217339117, 2.134048091170708}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6790255220615937`, 2.134048091170708}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.820158943749753, 5.560681631015528}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.220083871482302, 5.560681631015528}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1080567474961094`, 6.272877006546167}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5082360319251331`, 6.272877006546167}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2437536743377806`, 7.360103972989152}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.744112815760702, 7.360103972989152}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0645007590393418`, 1.7817091333745536`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6864844231876495`, 1.7817091333745536`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.6591800043289144`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.416581053724763}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-9.567158183262826, 0.8046885552928528}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.5824869781268642`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.7317869551252127`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.201916872261721, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.46298829435183064`, 6.81783057145415}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.063052113269559, 6.81783057145415}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.3281354469463584`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.6126737964100685, 2.005525858729668}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6907507040241487`, 2.005525858729668}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4422299934501939`, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8426317996018116`, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.2319770007355333`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.2908841763152323`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-7.600902459542082, 1.2424239907001886`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9840343839606746, 6.396929655216146}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3838972365201692`, 6.396929655216146}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.6407445017668969, 
             4.512945241945574}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.040959012419865, 
             4.512945241945574}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2149273965428693, 1.937301774518713}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.224893897193764, 1.937301774518713}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.094520670764856, 1.6937790608678513`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.832423655941967, 1.6937790608678513`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8734707346912269, 6.507277712385012}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2736802167507564`, 6.507277712385012}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2740421867477461, 2.5771819258971713`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8865098057738656`, 2.5771819258971713`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.377606779979768, 2.0706530356467567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7955707986317053`, 2.0706530356467567`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-8.05031945517943, 1.2424239907001886`}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4159291662495814`, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.816462081868427, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.4722426732562555`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.0279882600909205`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.190415030972834, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.9245405804618736`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.462149662665384}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.1603343472961065`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111964733385396, 6.492239835020471}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6115589009134488`, 6.492239835020471}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 2.0766877534832147`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-2.659260036932778, 1.007592890280941}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.462149662665384}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3426311639367969, 1.8656293177945105`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.2406103170142067`, 1.8656293177945105`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.2072749131897207`, 6.396929655216146}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706800981701778, 6.396929655216146}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.880084850028029, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.380218975276964, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047875165492457`, 6.298949246855942}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.804781390061982, 6.298949246855942}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.5639866495301828`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.9639722918737217`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.095273387402595}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.5845302767279155`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.462149662665384}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.5609672964009644`, 4.969813299576001}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.6609757937162812`, 4.969813299576001}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 1.3982229319851645`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             1.2908841763152323`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-0.09926800165866902, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-8.849872629798755, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7145751279735658, 1.9387416595767009`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7225041580723603`, 1.9387416595767009`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111964733385396, 6.492239835020471}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6115589009134488`, 6.492239835020471}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.68510181635509}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 1.671097292820828}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8598242001421843`, 5.521460917862246}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2595256035335987`, 5.521460917862246}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4118173183509766`, 1.5973653311998313`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7078502210995437`, 1.5973653311998313`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.3524072174927233`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 2.2927367569392314`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 0.7485818874480459}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047875165492457`, 6.298949246855942}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.804781390061982, 6.298949246855942}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8470607850131444`, 6.756932389247553}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346745988779815, 6.756932389247553}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 1.68510181635509}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7310567536331655, 1.864080130807681}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8551011438142453`, 1.864080130807681}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751531979714171, 5.8522024797744745`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.25165731439258, 5.8522024797744745`}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5213811377055073, 2.0719132752590443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.64930970607961, 2.0719132752590443`}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 0.965080896043587}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.7985076962177716, 1.726509584019938}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.7985076962177716, 1.497835735852798}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.7828868907244566`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.362224007377702, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.57270299585059, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5692561228012685`, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7696066645869217`, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 2.296667619230008}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.9317114296555002`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316692464055834`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.2739976361421332`, 6.429719478039138}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.5740001929819547`, 6.429719478039138}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-1.491654876777717, 0.849723487602042}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5342648554997536, 2.0068708488450007`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.766368110426725, 2.0068708488450007`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.8058680506240641, 1.937301774518713}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6338708029279587`, 1.937301774518713}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2942622756733968`, 6.0867747269123065`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.694451286761057, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9712750402069146, 
             7.6324011266014535`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4714166145367258`, 
             7.6324011266014535`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2942622756733968`, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.694451286761057, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4361820807702249, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.612240146256234, 2.1329823086078656`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9038682118755978, 6.476972362889683}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3037931396081468`, 6.476972362889683}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.3281354469463584`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.941966881801218, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.991862608772972, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.2299329059954676`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 0.7485818874480459}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.7109170813839543`, 5.66988092298052}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1111386284230904`, 5.66988092298052}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.5047438413194347`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8643301620628905`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-4.524512282970637, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             1.1990607599649155`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.1966460289394751`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.7109170813839543`, 5.66988092298052}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1111386284230904`, 5.66988092298052}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2651392395634233`, 1.5953389880545987`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.858931232061846, 1.5953389880545987`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.7406415980494447`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4947708374559745`, 5.886104031450156}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8951219822232084`, 5.886104031450156}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.44926026810783587`, 2.0719132752590443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7212874278842305`, 2.0719132752590443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3585338134237321, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.5645401798583287`, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-8.403864506109235, 
             1.0698698198024557`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.0738571633859353`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.5732134108799993`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.0335402919243948`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.926290362185661}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 0.7975071958841882}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 1.4964931534179662`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4947708374559745`, 5.886104031450156}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8951219822232084`, 5.886104031450156}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.795734531747094, 
             5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-3.1958919884778254`, 
             5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.8250798518207709, 1.864080130807681}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7611345721946656`, 1.864080130807681}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5413120833865, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5413120833865, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.227106951818089}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.036482917202561, 7.56734567601324}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5366522427084526`, 7.56734567601324}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5473167323484057, 1.9358598132018119`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8953440995227226`, 1.9358598132018119`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8426317996018116`, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4422299934501939`, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.659260036932778, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.1597073880279205`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.5824869781268642`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.6661962462527091`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0186003506987251`, 2.4176979000945504`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4605869657017456`, 2.4176979000945504`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.7867719277170158`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-7.1622605067393605`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 2.090999490513565}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.536314386533157, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-8.412382827063892, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.3540294005326152`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8598242001421843`, 5.521460917862246}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2595256035335987`, 5.521460917862246}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.528780009416646, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.152761077153482, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4409617624621989`, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6414447085691868`, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.746403767507258, 5.634789603169249}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1464364105041143`, 5.634789603169249}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.6960857191597725`, 6.907755278982137}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.196424897165655, 6.907755278982137}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.5136732904497212`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.0136538011418326`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.2158025560795132`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.940865372113151, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.740861482897622, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4460443655256647`, 7.157735484249907}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.946310229076653, 7.157735484249907}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.2319770007355333`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.8056623743970464`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2808538486618937`, 6.249975242259483}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.3811078344325904`, 6.249975242259483}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3082228256997352`, 7.295735072749282}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.808498793232353, 7.295735072749282}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4082690354408987, 1.860974538249528}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.184232881424661, 1.860974538249528}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.0654001544619962`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 0.9150900112976361}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.017383521085972, 0.986935571443487}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.2262184132732556`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.725971728690052, 7.3777589082278725`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.2742448573112677`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.6108369333478076`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 0.911479174876933}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8598242001421843`, 5.521460917862246}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2595256035335987`, 5.521460917862246}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.659260036932778, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.5539252025038417`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.2876820724517809, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.2917089186300228`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 0.8514321595256585}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.7083778602890038`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.5845302767279155`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4599740936085572, 2.004179057179289}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8461060995981784`, 2.004179057179289}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4184044150381243`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6184786570862495`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.15218556191195, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.781788039865368, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.836849948493799, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.0968250627658085`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.4079456086518722`, 1.726509584019938}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.9910270779881722}], 6., 
            
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6044503709230613`, 6.999422467507961}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 6.999422467507961}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6240440648234626`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-4.76404869105558, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 0.766397642299538}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.7985076962177716, 2.187398683184928}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.6888794541139363`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.540842282118304, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.140893060599911, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 0.9654617758806044}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.33687231664255274`, 1.937301774518713}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1028721491118945`, 1.937301774518713}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.101092789211817, 0.911479174876933}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020229905154391, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520318812570019, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1080567474961094`, 6.272877006546167}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5082360319251331`, 6.272877006546167}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3186357126460757`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.71869489837105, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9519179095173061, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7958982916754054`, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0645007590393418`, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.26443077336305, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.516892795645856, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.016955910005618, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.8826660279157308`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.900458886151396, 5.480638923341991}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3005870903313728`, 5.480638923341991}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4092798316650086`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.9093711079059474`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.0497721232486361`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.090999490513565}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.6593256320844346, 6.721425700790643}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0592954262911594`, 6.721425700790643}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.168928708181372, 5.111987788356544}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.768756076219605, 5.111987788356544}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             0.9345235001352147}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.4028303297599902`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.278818960372969, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.880084850028029, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.380218975276964, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9317114296555002`, 6.672032945461067}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316692464055834`, 6.672032945461067}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.416581053724763}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.795734531747094, 
             5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-3.1958919884778254`, 
             5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.5257286443082556`, 1.266384064447333}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-3.6888794541139363`, 2.3933394562625097`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.640548907459153}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.527397202097891, 7.076653815443951}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0272286702329017`, 7.076653815443951}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.036482917202561, 7.56734567601324}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5366522427084526`, 7.56734567601324}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.746403767507258, 5.634789603169249}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1464364105041143`, 5.634789603169249}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.1990607599649155`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.0598714603516792`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.8958869385842747`, 
             5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-3.0957736277342174`, 
             5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 2.0215475632609334`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2496677635880655`, 6.131226489483141}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6497392092076262`, 6.131226489483141}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.708153885373258, 5.823045895483019}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.8078888511579385`, 5.823045895483019}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.0794415416798357`, 6.907755278982137}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4524341636244356`, 7.151485463904735}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.95263269481614, 7.151485463904735}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.000759888500605, 6.380122536899765}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4007990473227723`, 6.380122536899765}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8195418502405067`, 6.784457062637643}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.319222734147069, 6.784457062637643}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3799147541558516`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8799351601317804`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.6744763086133228`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 2.2976730486330252`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1270117631898076`, 6.253828811575473}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5269366909223567`, 6.253828811575473}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4728877844255986, 1.937301774518713}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.966950472128539, 1.937301774518713}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.094604267270571}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1796054478776414`, 7.424165281042028}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6798603767306461`, 7.424165281042028}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             0.8028980445190645}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.5338519254775054`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.2909841813155656`, 2.187398683184928}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5079962967558309, 2.134048091170708}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.538054293998892, 2.134048091170708}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.6304163188192922`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 2.090999490513565}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1796054478776414`, 7.424165281042028}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6798603767306461`, 7.424165281042028}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 0.7485818874480459}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.038175919864279, 1.864080130807681}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.548102073285148, 1.864080130807681}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.4226262903672808`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.7840632625935846`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.27128392664214473`, 1.9358598132018119`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.171276846068922, 1.9358598132018119`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.48175237628028356`, 1.8625285401162623`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.107781777362614, 1.8625285401162623`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4092798316650086`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.9093711079059474`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6969544189028993, 2.0082140323914683`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6009911288088023`, 2.0082140323914683`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.1966460289394751`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.349630376748299}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.5629964960949002, 6.81783057145415}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.9631203192309531, 6.81783057145415}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.0281898243715637`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.931658209005277, 1.8625285401162623`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.657689841763261, 1.8625285401162623`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.7985076962177716, 2.647592232065096}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3093333199837622`, 7.294377299288821}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8097197946050478`, 7.294377299288821}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3678803477808931, 1.4973884086254774`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.9518038754399907`, 1.4973884086254774`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.9572739077056285`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1026203100656484`, 7.501082124259871}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6029589463363911`, 7.501082124259871}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.199705077879927, 2.0471765810925606`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3657077275115024`, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7655070980839893`, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.993630885266725, 5.537334267018537}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.0939462278827174`, 5.537334267018537}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.8469979053782056, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.247228312996893, 6.5337888379333435`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.6661962462527091`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.9510398268753117`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.6528674703614363`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.0287936073591935`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 2.1872864686305826`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.2862680470527663`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-7.662352421858305, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             1.1597073880279205`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.39809235377875135`, 2.498151876538021}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9200474895295858`, 2.498151876538021}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 2.215282764591249}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5898688311064436, 2.506341930508065}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7120245012092015`, 2.506341930508065}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.1499389158334503`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.3649243353836982`, 5.966146739123692}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.864975531559314, 5.966146739123692}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.3089630181835672`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.908846148194222, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.869504817852908, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.469241281940817, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2072749131897207`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047875165492457`, 6.298949246855942}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.804781390061982, 6.298949246855942}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.2181715237257489`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2909841813155656`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.071483621279857, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8714522381373035`, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.6409365794934714`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2072749131897207`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2437536743377806`, 7.360103972989152}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.744112815760702, 7.360103972989152}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.516892795645856, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.016955910005618, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.360956006320375, 4.969813299576001}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.8610265707016995`, 4.969813299576001}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.9572739077056285`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.21927603978772048`, 1.860974538249528}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.3731931852525583`, 1.860974538249528}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.599292605088321, 2.0719132752590443`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.571249159610065, 2.0719132752590443`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.5539252025038417`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.4532518292447716`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.3504080825554816`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1526461771605954`, 1.8656293177945105`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.4305321073246677`, 1.8656293177945105`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 0.8060293376166178}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.4722426732562555`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 1.133013715385442}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.0845133642886082`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 0.8028980445190645}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.9390477189967712, 2.414126467726953}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5474025215146479`, 2.414126467726953}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 0.9707789171582248}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.42266213293668586`, 2.418588768750352}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0549440700794483`, 2.418588768750352}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.4307829160924542, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.194022473472768, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.793961892783255, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6218266343535928`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.312220927289192, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             0.8977193462887197}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1644316297054034`, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1644316297054034`, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1702157075278026`, 7.433666540166168}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6702500518308578`, 7.433666540166168}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1663559407546291`, 6.214608098422191}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5663784229736533`, 6.214608098422191}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 0.9345235001352147}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             0.766397642299538}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2069773133462347`, 6.173786103901937}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.606941032235513, 6.173786103901937}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.0654001544619962`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.215506040139609}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 2.187398683184928}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 1.191191469961203}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9715392061046336, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9515240188896708`, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.7817091333745536`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2282654968949804`, 6.152732694704104}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6281111776997217`, 6.152732694704104}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7625890919282752`, 6.841615476477592}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262403303361214, 6.841615476477592}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.44238846221276223`, 1.501852701754163}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.868484703413663, 1.501852701754163}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-1.491654876777717, 1.094604267270571}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751531979714171, 5.8522024797744745`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.25165731439258, 5.8522024797744745`}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.927891643552635}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3082228256997352`, 7.295735072749282}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.808498793232353, 7.295735072749282}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.4079456086518722`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.4911047254722358`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.612442421454399, 5.768320995793772}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0129050178795915`, 5.768320995793772}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.215506040139609}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.8424288832756998}], 6., 
            
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1702157075278026`, 7.433666540166168}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6702500518308578`, 7.433666540166168}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 
             0.7802418874108791}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.9058454740126164, 1.937301774518713}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5338868320097188`, 1.937301774518713}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.238564249095555, 7.365180126021013}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7389772837890856`, 7.365180126021013}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 0.9290095042819297}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1702157075278026`, 7.433666540166168}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6702500518308578`, 7.433666540166168}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             1.0678093795130645`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.4532518292447716`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.6409365794934714`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 0.9858167945227654}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.4911047254722358`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.6661962462527091`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8470607850131444`, 6.756932389247553}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346745988779815, 6.756932389247553}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.26443077336305, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[$CellContext`\[FivePointedStar], {-1.0645007590393418`, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.3540294005326152`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.3137523001849649, 8.290041618704489}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.813734143549063, 8.290041618704489}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.6744763086133228`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6792442753909539, 2.0719132752590443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.491327217590923, 2.0719132752590443`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.9510398268753117`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0939462278827174`, 4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-4.294015757351168, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.340556469446037, 6.040254711277414}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7406861990440543`, 6.040254711277414}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.49331319868135953`, 2.4239173781615704`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.973281345851445, 2.4239173781615704`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.746403767507258, 5.634789603169249}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1464364105041143`, 5.634789603169249}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.6544352783648362`, 5.676753802268282}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.1541650878757723`, 5.676753802268282}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820086052689358`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1821389399181785`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 0.898534010284896}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7832907304129113, 2.0068708488450007`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.517264565896126, 2.0068708488450007`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6416938989710297, 1.8625285401162623`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9477043045434095`, 1.8625285401162623`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.2101638842661795`, 5.393627546352362}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.710307401527557, 5.393627546352362}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.1589994386832048`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-5.058828136697741, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7448616162466241, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0027568884909557`, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.8012039280560548`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.417032243872697, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.555615105736594}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.6564295976247825, 
             2.702032128776647}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.256670593326385, 
             2.702032128776647}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.028748427364318, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.653113060608557, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2184098521237055`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8189251373008244`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.941966881801218, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.991862608772972, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6622300779252237, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3861841168703593`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1026203100656484`, 7.501082124259871}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6029589463363911`, 7.501082124259871}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.2158025560795132`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.5978370007556204, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.8122154777954373`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-2.659260036932778, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324790142551358`, 5.971261839790462}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132468797127462, 5.971261839790462}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.017383521085972, 0.7347688552507647}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.153303390278291, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.529318843261892, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.7847348542910906`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             1.0281898243715637`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.5432981099295553`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 1.3321021320364639`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7903604483143476`, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3903023825174294`, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.2867117438377558`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-6.662458923026794, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 1.0868770324496888`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.7790406968202803`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.902767737471098, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.640548907459153}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.3678803477808931, 2.421256622711544}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.104554242494911, 2.421256622711544}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5561717255328675, 1.864080130807681}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.030116700415822, 1.864080130807681}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.0966102859974367`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.880084850028029, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.380218975276964, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5059792040658704`, 2.0843046973458237`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6398971199188088`, 2.0843046973458237`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.7268653293100646`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.30938249943111995`, 2.131796772013764}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7414001807837645`, 2.131796772013764}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7985076962177716, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1564532883579597`, 
             2.702032128776647}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7565130561817651, 
             2.702032128776647}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.9267273296385394`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 0.766397642299538}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.3149043650332175`, 5.966146739123692}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.9146052992269007`, 5.966146739123692}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.912572089444803, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-7.036270701217564, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3413209954771594`, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.741256487054948, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.995732273553991, 1.497835735852798}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.279055610450292, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.402871609042948, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 1.497835735852798}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.5978370007556204, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7985076962177716, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.7268653293100646`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.389499492068839, 5.991464547107982}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 5.991464547107982}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6977577931176286, 2.4265710727750367`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7637552728184576`, 2.4265710727750367`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 1.322289031143978}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.0678093795130645`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.0498221244986778`, 1.497835735852798}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 1.018486244188825}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.4365120772805082`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2315538186741798, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.6916833814466705`, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6266106567597011, 2.4265710727750367`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8350845939664286`, 2.4265710727750367`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.6358850824489488`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.064355904261795, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640797356921787`, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.238564249095555, 7.365180126021013}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7389772837890856`, 7.365180126021013}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.606235808570649, 6.674561391814426}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2063088641234838`, 6.674561391814426}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.4307829160924542, 1.726509584019938}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.090999490513565}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324790142551358`, 5.971261839790462}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132468797127462, 5.971261839790462}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 2.0759354023505483`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.516892795645856, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.016955910005618, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8042369907391675`, 4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-4.584387646805562, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.6888794541139363`, 1.0942695392339727`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.5978370007556204, 2.647592232065096}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.3681303904922195`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.090999490513565}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             0.8977193462887197}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-3.4420193761824103`, 3.2386784521643803`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5173146235582946`, 7.086737934510577}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.017406150760383, 7.086737934510577}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.864704011147587, 1.0732944806838198`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.2809338454620642`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.6389967146756448`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7625890919282752`, 6.841615476477592}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262403303361214, 6.841615476477592}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-4.3428059215206005`, 2.6490076604684267`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.4911047254722358`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4338645826298623, 1.601405740736836}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.6777417097034806`, 1.601405740736836}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.219163484854973, 5.111987788356544}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.7188583998188136`, 5.111987788356544}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5823216254710607, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.466163406970865, 2.1329823086078656`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 0.9669838461896731}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.7985076962177716, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.1406850650900175`, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2406367886975274`, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7625890919282752`, 6.841615476477592}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262403303361214, 6.841615476477592}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 2.066736169182282}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7650729201315343, 2.0731719286662407`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.403068631572368, 2.0731719286662407`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 1.3147983594148207`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.8805331812814825`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.293897511853923, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-5.093908213290077, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324790142551358`, 5.971261839790462}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132468797127462, 5.971261839790462}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9065879564127699, 7.697121317282625}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.406905315024015, 7.697121317282625}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.864704011147587, 1.3452119160186606`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.595748829015065, 5.991464547107982}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.395911377232918, 5.991464547107982}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.4915548717773834`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.4407825464039603`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.2919836816486494`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2909841813155656`, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.215506040139609}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.2072749131897207`, 1.497835735852798}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820086052689358`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1821389399181785`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.1499389158334503`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-8.685611843041201, 0.9360933591703348}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             0.9364854391596744}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.6168849633501186`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-3.600868576791223, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 1.266384064447333}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.1625110145183415`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-7.786268646522262, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.064355904261795, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640797356921787`, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.8871696540327132`, 5.393627546352362}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.4871090733432, 5.393627546352362}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8701230510291479, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.270112606830481, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.26683423993894284`, 4.386889790339869}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-8.666853965970644, 4.386889790339869}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 0.9403978072173882}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 2.075809955445786}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.965852822566973}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.3524072174927233`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4267908948229169, 1.6974487897568136`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.4929837772928636`, 1.6974487897568136`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.6409365794934714`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.820158943749753, 5.560681631015528}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.220083871482302, 5.560681631015528}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5366522427084526`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.412267540691536, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.4226262903672808`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.462149662665384}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.7317869551252127`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.201916872261721, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 1.1684492482568893`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3799147541558516`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8799351601317804`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.036382052219389, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-6.912265434460023, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.0598714603516792`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1208578976154293`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9949325933834268`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             0.9364854391596744}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.36571568859088144`, 1.6034198401085373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.741858378904823, 1.6034198401085373`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.4122057429043917`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2654936609741865`, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8656213178265104`, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.4122057429043917`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.215506040139609}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.0360274134764884`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.9031380572114442`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.779362064213738, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.29356601561075557`, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.6298561136644754`, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4171835010623628, 1.7850704810772584`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.327296573822621, 1.7850704810772584`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.045554398052668, 0.9604989865384754}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7756596021344095, 2.418588768750352}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.701553201341906, 2.418588768750352}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.5432981099295553`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.5305182571117267, 
             2.827905162910489}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1307223425863433`, 
             2.827905162910489}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5705756281717647, 1.7817091333745536`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1806171127511105`, 1.7817091333745536`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.5077842587076005`, 5.823045895483019}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.007679175452945, 5.823045895483019}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.064355904261795, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640797356921787`, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.4307829160924542, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.322289031143978}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5601909533113197, 2.423031246069913}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9085180298382507`, 2.423031246069913}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.558002204858551}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2371849385320495`, 1.9401794743463283`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.197324582336553, 1.9401794743463283`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.6623114020411685`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.286383733136742, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.3649243353836982`, 5.966146739123692}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.864975531559314, 5.966146739123692}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.2809338454620642`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.7062324201086008, 6.674561391814426}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.1062413158326008`, 6.674561391814426}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4092798316650086`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.9093711079059474`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111964733385396, 6.492239835020471}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6115589009134488`, 6.492239835020471}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.0289048762432895`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.6624240079171049, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-8.286478374605709, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1150465951315345`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6149530931222105`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.4079456086518722`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.1151415906193203`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.238564249095555, 7.365180126021013}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7389772837890856`, 7.365180126021013}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.064355904261795, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640797356921787`, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3093333199837622`, 7.294377299288821}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8097197946050478`, 7.294377299288821}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.2157956136516715, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.466024904841838, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6548884684428551, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0929041853062644`, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             0.8055826098897335}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6044503709230613`, 6.999422467507961}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 6.999422467507961}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1702157075278026`, 7.433666540166168}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6702500518308578`, 7.433666540166168}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.227106951818089}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7985076962177716, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.4920048155420047`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.3540294005326152`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.162823150618887, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-6.786422993814612, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.2669476034873244`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.7109170813839543`, 5.66988092298052}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1111386284230904`, 5.66988092298052}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.2672179491567546`, 4.386889790339869}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-6.667164814064207, 4.386889790339869}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6218266343535928`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.312220927289192, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.4018530946527146`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.532062329207643, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.5978370007556204, 2.647592232065096}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7627116439458544, 1.6974487897568136`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.156840433948748, 1.6974487897568136`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.4126383364594925`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.536426440357718, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.1603343472961065`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2409826299598365`, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8413699697813894`, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.238564249095555, 7.365180126021013}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7389772837890856`, 7.365180126021013}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.66442222076686, 6.939253946041508}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164563795096671, 6.939253946041508}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.9958752112169974, 1.599387576580599}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1199358770132974`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.191191469961203}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8821308802274503, 2.0082140323914683`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.4159777803491362`, 2.0082140323914683`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.963188584855586}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.2909841813155656`, 1.266384064447333}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.7813228714636707, 7.822444729489319}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2815740503494875`, 7.822444729489319}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1150465951315345`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6149530931222105`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4088348928367562`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-3.809015255353917, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.2917089186300228`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 0.848868055556721}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.7985076962177716, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.893897967672723, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.49397078181451, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             0.8055826098897335}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.712716261887602}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020229905154391, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520318812570019, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.0738571633859353`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.5732134108799993`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 0.9489515141137035}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.15218556191195, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.781788039865368, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.894078619827491, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.49397078181451, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.9569913819232716`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7463370090740643, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.462149662665384}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.785741396902492}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.497835735852798}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0189110419398038`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5188771693591536`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.045554398052668, 0.8514321595256585}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-2.214574215671332, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.004138294335951, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.2166915767337108`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.7867719277170158`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.1622605067393605`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.2072749131897207`, 1.726509584019938}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0108761743640229`, 1.937301774518713}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.428942281870568, 1.937301774518713}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2909841813155656`, 1.497835735852798}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.7147984280919266`, 1.497835735852798}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.659260036932778, 1.0845133642886082`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.3137523001849649, 8.290041618704489}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.813734143549063, 8.290041618704489}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2909841813155656`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.101092789211817, 0.7802418874108791}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 1.4772770088317615`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.5978370007556204, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.741015208534465, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.940782792197422, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.152962883418191, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.5287678617828835`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.3524072174927233`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.836849948493799, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.0968250627658085`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.7147984280919266`, 1.726509584019938}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4524341636244356`, 7.151485463904735}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.95263269481614, 7.151485463904735}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.7985076962177716, 1.4964931534179662`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.348592493935879}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.2867117438377558`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.662458923026794, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.8146618624453594`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.8787541283454292, 1.599387576580599}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.2367852454117685`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4911864085136422, 1.7850704810772584`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.253208503948706, 1.7850704810772584`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8997902134417601`, 6.704414354964107}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3993162819538174`, 6.704414354964107}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8505029913361519, 2.4176979000945504`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6286207318508743`, 2.4176979000945504`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2960880932337415`, 1.4883995840570443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0417762120553977`, 1.4883995840570443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.4911047254722358`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.516892795645856, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.016955910005618, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.270112606830481, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8701230510291479, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.389499492068839, 5.991464547107982}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 5.991464547107982}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.036482917202561, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-7.912330925723864, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.527397202097891, 7.076653815443951}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0272286702329017`, 7.076653815443951}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.9317114296555002`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316692464055834`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5918549290780729, 1.6034198401085373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.5159350591325786`, 1.6034198401085373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.0935997468445653`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820086052689358`, 6.921658184151129}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1821389399181785`, 6.921658184151129}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020229905154391, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520318812570019, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6044503709230613`, 6.999422467507961}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 6.999422467507961}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3082228256997352`, 7.295735072749282}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.808498793232353, 7.295735072749282}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.238564249095555, 7.365180126021013}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7389772837890856`, 7.365180126021013}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8997902134417601`, 6.704414354964107}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3993162819538174`, 6.704414354964107}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 1.4964931534179662`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.4307829160924542, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.462149662665384}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.6393849888020524`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3093333199837622`, 7.294377299288821}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8097197946050478`, 7.294377299288821}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.5978370007556204, 1.726509584019938}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.4018530946527146`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.532062329207643, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.251619457793289}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.391511302188447}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.0498221244986778`, 1.726509584019938}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.527397202097891, 7.076653815443951}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0272286702329017`, 7.076653815443951}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.786359562282124, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-8.162319869424133, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8584936331479384, 2.0706530356467567`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.314556464775266, 2.0706530356467567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 0.849723487602042}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.5978370007556204, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.8344803566765893, 2.131796772013764}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.2164073967529934`, 2.131796772013764}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-1.585233223737283, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.632849755094834, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.458005208673891, 5.823045895483019}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.0580715159436433`, 5.823045895483019}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.5107219394949427`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 1.0360274134764884`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5828588266658222, 1.6974487897568136`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.336815122732887, 1.6974487897568136`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 1.0360274134764884`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8470607850131444`, 6.756932389247553}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346745988779815, 6.756932389247553}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.376740148315079, 7.226936018493289}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8773173575897015`, 7.226936018493289}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1214715828141923`, 1.9387416595767009`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3154677188250594`, 1.9387416595767009`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.215506040139609}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9699552564598479, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1702157075278026`, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8470607850131444`, 6.756932389247553}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346745988779815, 6.756932389247553}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.362224007377702, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.57270299585059, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.4911047254722358`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.1269525243508878`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.807005375881994, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.0942695392339727`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0189110419398038`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5188771693591536`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.6039529822035308`, 5.676753802268282}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.2045513527226803`, 5.676753802268282}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5015355768588979, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.421604191439818, 1.6956156086751528`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9712750402069146, 7.6324011266014535`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4714166145367258`, 7.6324011266014535`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820086052689358`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1821389399181785`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111964733385396, 6.492239835020471}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6115589009134488`, 6.492239835020471}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.912572089444803, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.036270701217564, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020229905154391, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520318812570019, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6667000105450971, 1.6974487897568136`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.252691173362931, 1.6974487897568136`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.2919836816486494`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3799147541558516`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8799351601317804`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 1.170932950247736}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.9122987106046175, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-8.036311444023319, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8470607850131444`, 6.756932389247553}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346745988779815, 6.756932389247553}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.0845133642886082`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 1.4964931534179662`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.4307829160924542, 2.187398683184928}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5173146235582946`, 7.086737934510577}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.017406150760383, 7.086737934510577}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.4964931534179662`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.4307829160924542, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.612442421454399, 5.768320995793772}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0129050178795915`, 5.768320995793772}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.349630376748299}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3082228256997352`, 7.295735072749282}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.808498793232353, 7.295735072749282}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2909841813155656`, 1.726509584019938}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.8906229851255774, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.4907663827166018`, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8442026554799011, 7.759614150696903}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.344384958042681, 7.759614150696903}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 0.9654617758806044}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.030860186617291, 6.249975242259483}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.6311724045801064`, 6.249975242259483}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.66442222076686, 6.939253946041508}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164563795096671, 6.939253946041508}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.66442222076686, 6.939253946041508}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164563795096671, 6.939253946041508}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.395133309787095, 2.0731719286662407`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.77313400510489, 2.0731719286662407`}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7625890919282752`, 6.841615476477592}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262403303361214, 6.841615476477592}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-0.908818717035454, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-5.3089739467365655`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.4079456086518722`, 1.497835735852798}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.4886252922173524`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3208812225716584`, 2.0095554142156695`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9747212309094329`, 2.0095554142156695`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.7985076962177716, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.6409365794934714`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.4911047254722358`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.9661128563728327`, 1.726509584019938}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.376740148315079, 7.226936018493289}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8773173575897015`, 7.226936018493289}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.1269525243508878`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.807005375881994, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.726509584019938}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.9661128563728327`, 1.497835735852798}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.2862680470527663`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.662352421858305, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.984837274409265, 2.005525858729668}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.318612854071243, 2.005525858729668}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7797949872856175, 1.6034198401085373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.327853987437946, 1.6034198401085373`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6005679992668521, 1.4996230464268938`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.7148128361404407`, 1.4996230464268938`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.4938666711595117`, 4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.894183087299815, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.7985076962177716, 1.266384064447333}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1702157075278026`, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9699552564598479, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8195418502405067`, 6.784457062637643}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.319222734147069, 6.784457062637643}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3482281603134343`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7004573108212688`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.266384064447333}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.3109197297841035`, 4.969813299576001}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.9110235456270366`, 4.969813299576001}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.7199019178687649, 7.8838232148921525`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2201021862558195`, 7.8838232148921525`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.7199019178687649, 7.8838232148921525`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2201021862558195`, 7.8838232148921525`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.219163484854973, 5.111987788356544}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.7188583998188136`, 5.111987788356544}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 1.506518858426259}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.002290482491421}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 1.9254158540407285`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.5978370007556204, 2.187398683184928}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.2319770007355333`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             1.8728785205128469`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.162823150618887, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.786422993814612, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0923241675108497`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.841967538444134, 4.386889790339869}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820086052689358`, 6.921658184151129}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1821389399181785`, 6.921658184151129}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.036382052219389, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.912265434460023, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 1.0360274134764884`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7912011210353335, 1.4951487660319727`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.5332441625824873`, 1.4951487660319727`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.161367091078508}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.007592890280941}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 0.9654617758806044}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.3418458069473482`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.592214878401959, 4.386889790339869}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.3504080825554816`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6044503709230613`, 6.999422467507961}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 6.999422467507961}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9542522381612738, 2.0719132752590443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.2164073967529934`, 2.0719132752590443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9306432380985556, 
             2.827905162910489}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7306413849875258, 
             2.827905162910489}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 0.9666035457477442}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 1.0360274134764884`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4524341636244356`, 7.151485463904735}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.95263269481614, 7.151485463904735}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6218266343535928`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.312220927289192, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5068336024964532, 1.601405740736836}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.604906020337758, 1.601405740736836}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0891571298973546`, 2.0082140323914683`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.209094749906707, 2.0082140323914683`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5228016057745537`, 5.857933154483459}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.922779731666459, 5.857933154483459}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.0845133642886082`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 0.7802418874108791}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0918353043890858`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.84195543139986, 4.386889790339869}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-8.955698153602603, 0.8046885552928528}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.8843386505211481`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.0942695392339727`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.6788498758591209, 1.599387576580599}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.4370318346713713`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.491779868965868}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 0.7485818874480459}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7625890919282752`, 6.841615476477592}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262403303361214, 6.841615476477592}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4524341636244356`, 7.151485463904735}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.95263269481614, 7.151485463904735}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 0.7499999921527281}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9293759714228106, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.119430549896199, 2.1329823086078656`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.376740148315079, 7.226936018493289}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8773173575897015`, 7.226936018493289}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0288996762568094`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.652827532407001, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3799147541558516`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8799351601317804`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.103158068297152}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.0942695392339727`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324790142551358`, 5.971261839790462}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132468797127462, 5.971261839790462}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8195418502405067`, 6.784457062637643}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.319222734147069, 6.784457062637643}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.7813228714636707, 7.822444729489319}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2815740503494875`, 7.822444729489319}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.5920892740994874`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.341928551227046, 4.386889790339869}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 0.8989410935390421}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.6888794541139363`, 0.9669838461896731}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.941966881801218, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.991862608772972, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5901256014017275`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0898959995836948`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.1625110145183415`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.786268646522262, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             1.8359358315608838`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5173146235582946`, 7.086737934510577}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.017406150760383, 7.086737934510577}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.995732273553991, 1.0335402919243948`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 1.7833912195575383`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.3282528397426234`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.362224007377702, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.57270299585059, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 2.377692565480851}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9001713499942718, 1.4951487660319727`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.424056675808238, 1.4951487660319727`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 0.7485818874480459}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 1.4964931534179662`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.4964931534179662`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 1.2669476034873244`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1535965970008693`, 1.4906543764441336`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1796551117149194`, 1.4906543764441336`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.382026634673881, 0.8441500540964727}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.9317114296555002`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316692464055834`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.5978370007556204, 1.4964931534179662`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             1.5473497201206787`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 1.0962762288705619`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.3420861064555702`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.5919427181706105`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4460443655256647`, 7.157735484249907}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.946310229076653, 7.157735484249907}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0700248318161971`, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0700248318161971`, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.746969987257452, 6.5337888379333435`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.3470736479666092`, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.7378311272024993`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4460443655256647`, 7.157735484249907}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.946310229076653, 7.157735484249907}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.4079456086518722`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7672619976276676`, 4.386889790339869}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-7.166785108860756, 4.386889790339869}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6941476808935289, 1.4951487660319727`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.6302332586812027`, 1.4951487660319727`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.0498221244986778`, 2.187398683184928}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.527397202097891, 7.076653815443951}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0272286702329017`, 7.076653815443951}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.4722426732562555`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-2.995732273553991, 1.094604267270571}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.140807436632442, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.541256860244439, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2026403590921573`, 2.0095554142156695`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0931348688118385`, 2.0095554142156695`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2072749131897207`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.6939993778795506`, 
             4.386765389021055}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.694093021166824, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 0.848868055556721}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0604498275737608`, 2.0719132752590443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.110313205346923, 2.0719132752590443`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.279055610450292, 2.0731719286662407`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8891518152367044`, 2.0731719286662407`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.995732273553991, 1.2669476034873244`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.4307829160924542, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5220551057175394, 1.4951487660319727`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.802272141469027, 1.4951487660319727`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.1637756145745228`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0302996484860225`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0181583132629375`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0202633222571333`, 1.4929040961781488`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.3082536360194172`, 1.4929040961781488`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             1.2172838183856083`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.15218556191195, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.781788039865368, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 1.4964931534179662`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.807796846925679}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2669126040998102`, 4.386889790339869}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-7.666828609658249, 4.386889790339869}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4850103340590484`, 2.135349173618132}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-1.559220196273483, 2.135349173618132}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7565130561817651, 
             2.702032128776647}], 10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1564532883579597`, 
             2.702032128776647}], 10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.045554398052668, 0.7485818874480459}], 9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.7435408969575807`, 5.537334267018537}],
             13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.3434070875143007`, 5.537334267018537}],
             13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4460443655256647`, 7.157735484249907}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.946310229076653, 7.157735484249907}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 0.8307328435125084}],
             12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4028684822608984, 
             4.512945241945574}], 8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.278964002683987, 4.512945241945574}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 1.7268653293100646`}], 
            10.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-4.196377287787253, 1.0360274134764884`}],
             10.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 0.9666035457477442}], 9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-2.945799904805782, 5.991464547107982}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-3.045763207159556, 5.991464547107982}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4524341636244356`, 7.151485463904735}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.95263269481614, 7.151485463904735}], 
            8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.995732273553991, 0.8046885552928528}], 
            13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8457617469776957`, 5.991464547107982}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-3.145857732131629, 5.991464547107982}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.4307829160924542, 1.7268653293100646`}], 
            10.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.9028810449642375, 
             4.512945241945574}], 8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.7788336680347445`, 
             4.512945241945574}], 8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 2.1122716862705384`}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.527397202097891, 7.076653815443951}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0272286702329017`, 7.076653815443951}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.036482917202561, 7.56734567601324}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.5366522427084526`, 7.56734567601324}],
             12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-1.0498221244986778`, 1.266384064447333}],
             10.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             1.0511712140679732`}], 11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3082228256997352`, 7.295735072749282}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.808498793232353, 7.295735072749282}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8442026554799011, 7.759614150696903}],
             12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.344384958042681, 7.759614150696903}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 2.2044208442068145`}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8470607850131444`, 6.756932389247553}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346745988779815, 6.756932389247553}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-0.7667937207282438, 4.386889790339869}],
             7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-8.166888494485349, 4.386889790339869}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5901256014017275`, 7.013915474810528}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0898959995836948`, 7.013915474810528}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 0.8060293376166178}], 
            10.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.9372477759766606`, 5.393627546352362}],
             13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.4371455863897404`, 5.393627546352362}],
             13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 2.217027204632399}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.793961892783255, 5.537334267018537}], 
            13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.2936253516225737`, 5.537334267018537}],
             13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-2.475392057419415, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-6.725433722188183, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9065879564127699, 7.697121317282625}],
             12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.406905315024015, 7.697121317282625}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.266384064447333}], 
            10.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.864704011147587, 1.3326298365341978`}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.6544352783648362`, 5.676753802268282}],
             13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.1541650878757723`, 5.676753802268282}],
             13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 1.2190584417439767`}], 
            9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {41.659220767303175`, 4.512945241945574}], 
            13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-50.341331645288825`, 4.512945241945574}],
             13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7625890919282752`, 6.841615476477592}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262403303361214, 6.841615476477592}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 1.0335402919243948`}],
             13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.8420006856648017`, 
             4.386889790339869}], 8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.091798316674432, 4.386889790339869}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0191543673333943`, 2.570319527636131}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-1.155182640156504, 2.570319527636131}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.599387576580599}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8997902134417601`, 6.704414354964107}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3993162819538174`, 6.704414354964107}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.527397202097891, 7.076653815443951}], 
            8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0272286702329017`, 7.076653815443951}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.4847813078345447`}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.483987072728617, 4.386765389021055}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.904054835778969, 4.386765389021055}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.5338519254775054`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 0.849723487602042}], 
            9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.168283961917429, 2.0719132752590443`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0024805005437076`, 2.0719132752590443`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 1.3480731482996928`}], 
            9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7625890919282752`, 6.841615476477592}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262403303361214, 6.841615476477592}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0564152399683213`, 
             2.702032128776647}], 10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8566077297129814, 
             2.702032128776647}], 10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.6527732864216721, 
             4.512945241945574}], 8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.028919972120757, 4.512945241945574}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-2.2256240518579173`, 4.386889790339869}], 12., 
            
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-6.975391927697949, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             0.8202202631234213}], 11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-1.7254100886865211`, 4.386889790339869}], 12., 
            
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-7.475327636634016, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8997902134417601`, 6.704414354964107}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3993162819538174`, 6.704414354964107}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             0.761739972025557}], 11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 0.9669838461896731}], 
            9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 1.7268653293100646`}], 
            10.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7789229575813493, 
             4.512945241945574}], 8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.902818692021688, 4.512945241945574}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0923241675108497`, 
             4.386889790339869}], 8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.841967538444134, 4.386889790339869}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.3418458069473482`, 
             4.386889790339869}], 8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.592214878401959, 4.386889790339869}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8195418502405067`, 6.784457062637643}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.319222734147069, 6.784457062637643}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8805331812814825`}], 
            7.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-3.166995202991212, 4.386889790339869}],
             9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-5.767041814295392, 4.386889790339869}],
             9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-1.4753441779534016`, 4.386889790339869}], 12., 
            
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-7.725332537920259, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.6888794541139363`, 0.8505781885087738}], 
            9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.695775840226822, 
             5.991464547107982}], 10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-3.2957568692041583`, 
             5.991464547107982}], 10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 0.9925107577855641}],
             12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.3039860739096736`, 
             4.386765389021055}], 8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.083998270167957, 4.386765389021055}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5288198871382693, 
             4.512945241945574}], 8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.152897360346143, 4.512945241945574}],
             8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 0.7485818874480459}], 9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-4.196377287787253, 0.8060293376166178}], 
            10.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.4312677267626217`}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-2.659260036932778, 0.849723487602042}],
             9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.6305480388034254, 
             2.827905162910489}], 10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0305798782762827`, 
             2.827905162910489}], 10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.0360274134764884`}],
             10.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8195418502405067`, 6.784457062637643}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.319222734147069, 6.784457062637643}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.659260036932778, 1.4722426732562555`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.430789601006442}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.9453385571563557`}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.659260036932778, 1.1637756145745228`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6044503709230613`, 6.999422467507961}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.104554242494911, 6.999422467507961}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9317114296555002`, 6.672032945461067}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316692464055834`, 6.672032945461067}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-1.9754419516613513`, 4.386889790339869}], 12., 
            
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-7.225346881840062, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 2.0427775573082445`}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.5779472453427295`}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5901256014017275`, 7.013915474810528}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0898959995836948`, 7.013915474810528}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-1.036482917202561, 4.512945241945574}], 12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-7.912330925723864, 4.512945241945574}], 12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 1.6384140206706175`}], 
            9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2361517026901712`, 2.1329823086078656`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8121662790057176`, 2.1329823086078656`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.66442222076686, 6.939253946041508}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164563795096671, 6.939253946041508}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             0.986935571443487}], 11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-3.76705723517796, 4.386889790339869}], 
            9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-5.166938288491657, 4.386889790339869}],
             9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1304126012179074`, 2.1329823086078656`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9186841628017217`, 2.1329823086078656`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-3.366795954944823, 4.386889790339869}],
             9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-5.566981433164056, 4.386889790339869}],
             9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.1780394222994315`}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8566077297129814, 
             2.702032128776647}], 10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0564152399683213`, 
             2.702032128776647}], 10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.863232841258714, 0.8458682675776092}],
             12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.7027460895677522`}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-2.4018530946527146`, 4.386889790339869}], 12., 
            
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-6.532062329207643, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5173146235582946`, 7.086737934510577}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.017406150760383, 7.086737934510577}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-2.693851481702397, 4.386889790339869}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-3.694093021166824, 4.386889790339869}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.659260036932778, 1.0845133642886082`}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.7710464276305133`}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.3420861064555702`, 
             4.386889790339869}], 8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.5919427181706105`, 
             4.386889790339869}], 8.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.8643901602629624`}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-2.659260036932778, 1.416581053724763}], 
            10., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-2.1269525243508878`, 4.386889790339869}], 12., 
            
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-6.807005375881994, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8997902134417601`, 6.704414354964107}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3993162819538174`, 6.704414354964107}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820086052689358`, 6.921658184151129}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1821389399181785`, 6.921658184151129}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.5077842587076005`, 5.823045895483019}],
             13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.007679175452945, 5.823045895483019}], 
            13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.360956006320375, 4.969813299576001}], 
            13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.8610265707016995`, 4.969813299576001}],
             13., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4460443655256647`, 7.157735484249907}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.946310229076653, 7.157735484249907}], 
            11.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 
            12., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-3.567015866357096, 4.386889790339869}],
             9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-5.366810362993337, 4.386889790339869}],
             9., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-0.3492738284584218, 4.512945241945574}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-8.599488434143067, 4.512945241945574}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1026203100656484`, 7.501082124259871}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6029589463363911`, 7.501082124259871}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-2.475392057419415, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-6.725433722188183, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 1.2184672504763885`}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-0.9122987106046175, 4.512945241945574}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-8.036311444023319, 4.512945241945574}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.8420006856648017`, 
             4.386889790339869}], 8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.091798316674432, 4.386889790339869}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {40.65907381386164, 4.512945241945574}], 
            13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-49.34073194467232, 4.512945241945574}], 
            13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledSquare]", {-1.493879571799828, 4.386889790339869}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledSquare]", {-4.893919494400295, 4.386889790339869}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5901256014017275`, 7.013915474810528}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0898959995836948`, 7.013915474810528}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0918353043890858`, 
             4.386889790339869}], 8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.84195543139986, 4.386889790339869}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.5920892740994874`, 
             4.386889790339869}], 8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.341928551227046, 4.386889790339869}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.863232841258714, 1.007592890280941}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9712750402069146, 7.6324011266014535`}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4714166145367258`, 7.6324011266014535`}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7625890919282752`, 6.841615476477592}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262403303361214, 6.841615476477592}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.6888794541139363`, 0.7485818874480459}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9065879564127699, 7.697121317282625}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.406905315024015, 7.697121317282625}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-0.536314386533157, 4.512945241945574}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-8.412382827063892, 4.512945241945574}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0939232991819783`, 4.386889790339869}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledSquare]", {-5.293927018246744, 4.386889790339869}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {39.65916255296606, 4.512945241945574}], 
            13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-48.341370727608414`, 4.512945241945574}],
             13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820086052689358`, 6.921658184151129}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1821389399181785`, 6.921658184151129}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.3799147541558516`, 7.22402480828583}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.8799351601317804`, 7.22402480828583}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6044503709230613`, 6.999422467507961}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.104554242494911, 6.999422467507961}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9565920286476808, 
             2.702032128776647}], 10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9565920286476808, 
             2.702032128776647}], 10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6044503709230613`, 6.999422467507961}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 6.999422467507961}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 0.8060293376166178}], 
            10.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.382026634673881, 0.7485818874480459}], 9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-2.966950472128539, 4.386889790339869}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-5.966967075507594, 4.386889790339869}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-2.475392057419415, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-6.725433722188183, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-2.995732273553991, 0.848868055556721}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8470607850131444`, 6.756932389247553}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346745988779815, 6.756932389247553}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.527397202097891, 7.076653815443951}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0272286702329017`, 7.076653815443951}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-2.0794415416798357`, 1.266384064447333}],
             10.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-1.2255369822417765`, 4.386889790339869}], 12., 
            
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-7.975450465015525, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-4.199705077879927, 0.7997569156182036}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-4.166915255056936, 4.386889790339869}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-4.76686592498839, 4.386889790339869}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.9670073137609054`, 4.386889790339869}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-4.966857671750368, 4.386889790339869}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-0.6624240079171049, 4.512945241945574}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-8.286478374605709, 4.512945241945574}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.084253098677058, 4.386765389021055}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.30432512701003, 4.386765389021055}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9712750402069146, 7.6324011266014535`}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4714166145367258`, 7.6324011266014535`}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8470607850131444`, 6.756932389247553}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346745988779815, 6.756932389247553}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {23.65924810609463, 4.512945241945574}], 
            13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-32.34077434210908, 4.512945241945574}], 
            13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 0.9654617758806044}], 9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 0.8060293376166178}], 
            10.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-0.786359562282124, 4.512945241945574}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-8.162319869424133, 4.512945241945574}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.7418655495969406`, 4.386889790339869}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-6.191868611452702, 4.386889790339869}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6044503709230613`, 6.999422467507961}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.104554242494911, 6.999422467507961}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.527397202097891, 7.076653815443951}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0272286702329017`, 7.076653815443951}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-1.4753441779534016`, 4.386889790339869}], 12., 
            
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-7.725332537920259, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8305718564716175, 
             2.827905162910489}], 10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8305718564716175, 
             2.827905162910489}], 10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-0.3504089023600859, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-8.850570223130148, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 0.8060293376166178}], 
            10.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 0.7466879474879751}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.21678878567620194`, 
             4.386889790339869}], 8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.716864386545305, 4.386889790339869}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7306413849875258, 
             2.827905162910489}], 10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9306432380985556, 
             2.827905162910489}], 10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.036482917202561, 7.56734567601324}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.5366522427084526`, 7.56734567601324}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-0.3504089023600859, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-8.850570223130148, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-1.7254100886865211`, 4.386889790339869}], 12., 
            
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-7.475327636634016, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4524341636244356`, 7.151485463904735}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.95263269481614, 7.151485463904735}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820086052689358`, 6.921658184151129}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1821389399181785`, 6.921658184151129}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledSquare]", {-0.273910668367863, 4.386889790339869}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledSquare]", {-6.113858195322049, 4.386889790339869}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-4.366940997255841, 4.386889790339869}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-4.566911473871001, 4.386889790339869}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1702157075278026`, 7.433666540166168}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6702500518308578`, 7.433666540166168}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0339487753423875`, 2.418588768750352}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledCircle]", {-1.443923473956527, 2.418588768750352}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-2.2256240518579173`, 4.386889790339869}], 12., 
            
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-6.975391927697949, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-0.3504089023600859, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-8.850570223130148, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.036482917202561, 7.56734567601324}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.5366522427084526`, 7.56734567601324}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4524341636244356`, 7.151485463904735}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.95263269481614, 7.151485463904735}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 1.0360274134764884`}], 
            10.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.21678878567620194`, 
             4.386889790339869}], 8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.716864386545305, 4.386889790339869}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-1.2255369822417765`, 4.386889790339869}], 12., 
            
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-7.975450465015525, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.5005758256424344`, 
             4.386889790339869}], 11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.700587583759682, 4.386889790339869}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-1.9754419516613513`, 4.386889790339869}], 12., 
            
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-7.225346881840062, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9317114296555002`, 6.672032945461067}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316692464055834`, 6.672032945461067}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.863232841258714, 0.8333438110532289}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1026203100656484`, 7.501082124259871}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6029589463363911`, 7.501082124259871}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5782126424678459, 1.5432981099295553`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-3.6504282677396835`, 1.5432981099295553`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.238564249095555, 7.365180126021013}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7389772837890856`, 7.365180126021013}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.3799147541558516`, 7.22402480828583}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.8799351601317804`, 7.22402480828583}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-2.2256240518579173`, 4.386889790339869}], 12., 
            
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-6.975391927697949, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0053952069569758`, 2.498151876538021}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledCircle]", {-1.313415715707318, 2.498151876538021}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7625890919282752`, 6.841615476477592}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262403303361214, 6.841615476477592}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {38.65927591460964, 4.512945241945574}], 
            13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-47.34086951027008, 4.512945241945574}], 
            13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1026203100656484`, 7.501082124259871}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6029589463363911`, 7.501082124259871}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-0.8505029913361519, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-8.350408373771412, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3082228256997352`, 7.295735072749282}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.808498793232353, 7.295735072749282}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1702157075278026`, 7.433666540166168}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6702500518308578`, 7.433666540166168}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.3799147541558516`, 7.22402480828583}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.8799351601317804`, 7.22402480828583}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1702157075278026`, 7.433666540166168}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6702500518308578`, 7.433666540166168}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.067986095126349, 2.3456445824544927`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.5558971455060706`, 2.3456445824544927`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.66442222076686, 6.939253946041508}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164563795096671, 6.939253946041508}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4918104261047946`, 4.386889790339869}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-6.442136248054226, 4.386889790339869}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1026203100656484`, 2.2648832258100344`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.6825463842547386`, 2.2648832258100344`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.5005758256424344`, 
             4.386889790339869}], 11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.700587583759682, 4.386889790339869}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 0.7476353658440151}], 9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledSquare]", {-0.8940401229393353, 4.386889790339869}],
             10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledSquare]", {-5.493845750829273, 4.386889790339869}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1279381180499384`, 2.1174596088673567`}], 
            7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledCircle]", {-1.95263269481614, 2.1174596088673567`}],
             7.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9317114296555002`, 6.672032945461067}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316692464055834`, 6.672032945461067}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3082228256997352`, 7.295735072749282}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.808498793232353, 7.295735072749282}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2173252490432223`, 4.386889790339869}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-6.717134919373487, 4.386889790339869}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-0.8505029913361519, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-8.350408373771412, 4.386889790339869}], 12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.238564249095555, 7.365180126021013}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7389772837890856`, 7.365180126021013}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7168253079145225, 
             4.386889790339869}], 8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.2170885989659, 4.386889790339869}], 
            8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8470607850131444`, 6.756932389247553}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346745988779815, 6.756932389247553}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1199380753828623`, 2.065596134857783}], 
            7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[FilledCircle]", {-2.064355904261795, 2.065596134857783}], 
            7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.7042981934580606`, 
             4.386765389021055}], 8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.683996966534062, 4.386765389021055}],
             8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4524341636244356`, 7.151485463904735}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.95263269481614, 7.151485463904735}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[Times]", {-0.8505029913361519, 4.386889790339869}], 12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[Times]", {-8.350408373771412, 4.386889790339869}], 12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.238564249095555, 7.365180126021013}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7389772837890856`, 7.365180126021013}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.8944568674663975`, 
             4.386765389021055}], 8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.494523665901028, 4.386765389021055}],
             8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9317114296555002`, 6.672032945461067}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316692464055834`, 6.672032945461067}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6044503709230613`, 6.999422467507961}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.104554242494911, 6.999422467507961}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1230074455028314`, 2.1825620503943153`}], 
            7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.8269722249837996`, 2.1825620503943153`}], 
            7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {36.659239911113445`, 4.512945241945574}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {-45.34120604098636, 4.512945241945574}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {22.659269939882257`, 4.512945241945574}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {-31.34091993726656, 4.512945241945574}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3082228256997352`, 7.295735072749282}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.808498793232353, 7.295735072749282}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7168253079145225, 
             4.386889790339869}], 8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.2170885989659, 4.386889790339869}], 
            8.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.082935809283102, 2.0215475632609334`}], 
            7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.1892564076870427`, 2.0215475632609334`}], 
            7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {21.65896696234039, 4.512945241945574}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {-30.340822850069564`, 4.512945241945574}],
             13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.527397202097891, 7.076653815443951}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0272286702329017`, 7.076653815443951}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[FilledSquare]", {-0.6539264674066639, 4.386889790339869}],
             10., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-5.7340355178272215`, 4.386889790339869}], 
            10., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {37.65893624683973, 4.512945241945574}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {-46.34085167560773, 4.512945241945574}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.527397202097891, 7.076653815443951}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0272286702329017`, 7.076653815443951}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4524341636244356`, 7.151485463904735}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.95263269481614, 7.151485463904735}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[Times]", {-1.9754419516613513`, 4.386889790339869}], 12., 
            
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[Times]", {-7.225346881840062, 4.386889790339869}], 12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0277811079075183`, 1.9768549529047348`}], 
            7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.333559897293476, 1.9768549529047348`}], 
            7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.9736550492637259, 1.9198594718553708`}], 
            7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.5016459737922982`, 1.9198594718553708`}], 
            7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.3003570667360838`, 
             4.386889790339869}], 11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.9005275521158795`, 
             4.386889790339869}], 11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.3799147541558516`, 7.22402480828583}],
             12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.8799351601317804`, 7.22402480828583}],
             12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {59.53313730582369, 4.386889790339869}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {-68.46724388757043, 4.386889790339869}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.9334368907091256, 1.8389610707123492`}], 
            7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.703510521060178, 1.8389610707123492`}], 
            7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {28.659210940300113`, 4.512945241945574}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {-37.34075273404506, 4.512945241945574}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6044503709230613`, 6.999422467507961}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.104554242494911, 6.999422467507961}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.700547258981618, 4.386889790339869}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.500433550670171, 4.386889790339869}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[Times]", {-1.7254100886865211`, 4.386889790339869}], 12., 
            
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[Times]", {-7.475327636634016, 4.386889790339869}], 12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {19.659054974995634`, 4.512945241945574}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {-28.340907620492793`, 4.512945241945574}],
             13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[Times]", {-1.4753441779534016`, 4.386889790339869}], 12., 
            
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[Times]", {-7.725332537920259, 4.386889790339869}], 12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {20.659260506970497`, 4.512945241945574}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-29.340832002509437`, 4.512945241945574}],
             13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {35.65915017536031, 4.512945241945574}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-44.34079097851618, 4.512945241945574}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.8947738884119054, 1.7316555451583497`}], 
            7.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.9568962497687927`, 1.7316555451583497`}], 
            7.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[Times]", {-1.2255369822417765`, 4.386889790339869}], 12., 
            
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[Times]", {-7.975450465015525, 4.386889790339869}], 12., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7903190923122189, 1.6272778305624314`}], 
            7.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-3.270169119255751, 1.6272778305624314`}], 
            7.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 
            12., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            12., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.900588627802483, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.30031936921871, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            12., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            12., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {27.65863628296152, 4.512945241945574}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-36.34119244432727, 4.512945241945574}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {29.659169363220833`, 4.512945241945574}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-38.34104853637971, 4.512945241945574}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 
            12., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 
            12., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {48.53243313825843, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-57.46750061412042, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.700547258981618, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.500433550670171, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {18.658909932684615`, 4.512945241945574}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-27.341341040814093`, 4.512945241945574}],
             13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.700547258981618, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.500433550670171, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.100426344668657, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.100386954332169, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.5005758256424344`, 
             4.386889790339869}], 11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.700587583759682, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.3003570667360838`, 
             4.386889790339869}], 11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.9005275521158795`, 
             4.386889790339869}], 11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.3003570667360838`, 
             4.386889790339869}], 11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.9005275521158795`, 
             4.386889790339869}], 11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.100765130025024, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.10045059841862, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.900588627802483, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.30031936921871, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {57.53313665775977, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-66.46748299707936, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.900588627802483, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.30031936921871, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {30.65922057962004, 4.512945241945574}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-39.34081340913477, 4.512945241945574}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {26.659217674124136`, 4.512945241945574}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-35.340845982694816`, 4.512945241945574}],
             13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {58.533130928172234`, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-67.46691559681179, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.100765130025024, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.10045059841862, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {46.532892678517214`, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-55.46685482648658, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.100765130025024, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.10045059841862, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.900422093749666, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.300710797475603, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {56.53320628572335, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-65.466905183977, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {60.532988401609, 4.386889790339869}], 13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-69.46689851604965, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {25.65917758484673, 4.512945241945574}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-34.340745544411554`, 4.512945241945574}],
             13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.100426344668657, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.100386954332169, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {31.659225875646104`, 4.512945241945574}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-40.340943771488284`, 4.512945241945574}],
             13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {34.65922254798655, 4.512945241945574}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-43.340988541359216`, 4.512945241945574}],
             13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {32.658841234778905`, 4.512945241945574}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-41.34127116323533, 4.512945241945574}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {61.533219681767186`, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-70.4670522818902, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {47.5330791022475, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-56.46701553651661, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {24.65920066242087, 4.512945241945574}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-33.34092227159292, 4.512945241945574}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.300630996469888, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.900346940202133, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {33.65905864326737, 4.512945241945574}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-42.34081632550436, 4.512945241945574}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.300630996469888, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.900346940202133, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.300630996469888, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.900346940202133, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.6003175012993283`, 
             4.386889790339869}], 11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.60100614381313, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {55.53283243663866, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-64.46739506232224, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {54.53306059828793, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-63.46698269688735, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.900422093749666, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.300710797475603, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.100426344668657, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.100386954332169, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {62.53305077013809, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-71.46678568954108, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {50.53312123843283, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-59.467094916063616`, 4.386889790339869}],
             13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.6003175012993283`, 
             4.386889790339869}], 11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.60100614381313, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {43.533197060661976`, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-52.467202900682494`, 4.386889790339869}],
             13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {49.53294194921661, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-58.4670151515563, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.900422093749666, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.300710797475603, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.500810170663849, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.70036037299184, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {63.53307909765005, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-72.46692041972995, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.500810170663849, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.70036037299184, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {44.53301831071528, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-53.46678887337479, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {53.53269402275044, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-62.46685674510361, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {45.533180029480455`, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-54.46678982836, 4.386889790339869}], 13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.500810170663849, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.70036037299184, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {42.533071381326664`, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-51.46677778703915, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.6003175012993283`, 
             4.386889790339869}], 11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.60100614381313, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.400308181522661, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.8006962066887295`, 
             4.386889790339869}], 11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {52.5331258380735, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-61.467195171508536`, 4.386889790339869}],
             13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.400308181522661, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.8006962066887295`, 
             4.386889790339869}], 11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.400308181522661, 4.386889790339869}], 
            11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.8006962066887295`, 
             4.386889790339869}], 11.5, 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {51.5331737695268, 4.386889790339869}], 
            13., 
            RGBColor[1, 0, 0]], 
           Style[
            Text["\[EmptySquare]", {-60.466869255317796`, 4.386889790339869}],
             13., 
            RGBColor[1, 0, 0]]}}, {
         Frame -> True, 
          FrameTicks -> {{{-13.815510557964274`, 
              "\!\(\*SuperscriptBox[\(10\), \(-6\)]\)", {0.02, 
              0.}}, {-13.122363377404328`, "", {
              0.01, 0}}, {-12.716898269296165`, "", {
              0.01, 0}}, {-12.429216196844383`, "", {
              0.01, 0}}, {-12.206072645530174`, "", {
              0.01, 0}}, {-12.02375108873622, "", {
              0.01, 0}}, {-11.86960040890896, "", {
              0.01, 0}}, {-11.736069016284437`, "", {
              0.01, 0}}, {-11.618285980628055`, "", {
              0.01, 0}}, {-11.512925464970229`, 
              "\!\(\*SuperscriptBox[\(10\), \(-5\)]\)", {0.02, 
              0.}}, {-10.819778284410283`, "", {
              0.01, 0}}, {-10.414313176302118`, "", {
              0.01, 0}}, {-10.126631103850338`, "", {
              0.01, 0}}, {-9.903487552536127, "", {
              0.01, 0}}, {-9.721165995742174, "", {
              0.01, 0}}, {-9.567015315914915, "", {
              0.01, 0}}, {-9.433483923290392, "", {
              0.01, 0}}, {-9.315700887634009, "", {
              0.01, 0}}, {-9.210340371976182, 
              "\!\(\*SuperscriptBox[\(10\), \(-4\)]\)", {0.02, 
              0.}}, {-8.517193191416238, "", {0.01, 0}}, {-8.111728083308073, 
              "", {0.01, 0}}, {-7.824046010856292, "", {
              0.01, 0}}, {-7.600902459542082, "", {
              0.01, 0}}, {-7.418580902748127, "", {
              0.01, 0}}, {-7.264430222920869, "", {
              0.01, 0}}, {-7.1308988302963465`, "", {
              0.01, 0}}, {-7.013115794639964, "", {
              0.01, 0}}, {-6.907755278982137, 
              "\!\(\*SuperscriptBox[\(10\), \(-3\)]\)", {0.02, 
              0.}}, {-6.214608098422191, "", {0.01, 0}}, {-5.809142990314028, 
              "", {0.01, 0}}, {-5.521460917862246, "", {
              0.01, 0}}, {-5.298317366548036, "", {
              0.01, 0}}, {-5.115995809754082, "", {
              0.01, 0}}, {-4.961845129926823, "", {
              0.01, 0}}, {-4.8283137373023015`, "", {
              0.01, 0}}, {-4.710530701645918, "", {
              0.01, 0}}, {-4.605170185988091, 
              "\!\(\*SuperscriptBox[\(10\), \(-2\)]\)", {0.02, 
              0.}}, {-3.912023005428146, "", {0.01, 0}}, {-3.506557897319982, 
              "", {0.01, 0}}, {-3.2188758248682006`, "", {
              0.01, 0}}, {-2.995732273553991, "", {
              0.01, 0}}, {-2.8134107167600364`, "", {
              0.01, 0}}, {-2.659260036932778, "", {
              0.01, 0}}, {-2.5257286443082556`, "", {
              0.01, 0}}, {-2.4079456086518722`, "", {
              0.01, 0}}, {-2.3025850929940455`, 
              "\!\(\*SuperscriptBox[\(10\), \(-1\)]\)", {0.02, 
              0.}}, {-1.6094379124341003`, "", {
              0.01, 0}}, {-1.203972804325936, "", {
              0.01, 0}}, {-0.916290731874155, "", {
              0.01, 0}}, {-0.6931471805599453, "", {
              0.01, 0}}, {-0.5108256237659905, "", {
              0.01, 0}}, {-0.3566749439387323, "", {
              0.01, 0}}, {-0.2231435513142097, "", {
              0.01, 0}}, {-0.10536051565782628`, "", {0.01, 0}}, {
             0., "1", {0.02, 0.}}, {0.6931471805599453, "", {0.01, 0}}, {
             1.0986122886681098`, "", {0.01, 0}}, {
             1.3862943611198906`, "", {0.01, 0}}, {
             1.6094379124341003`, "", {0.01, 0}}, {
             1.791759469228055, "", {0.01, 0}}, {
             1.9459101490553132`, "", {0.01, 0}}, {
             2.0794415416798357`, "", {0.01, 0}}, {
             2.1972245773362196`, "", {0.01, 0}}, {
             2.302585092994046, "\!\(\*SuperscriptBox[\(10\), \(1\)]\)", {
              0.02, 0.}}, {2.995732273553991, "", {0.01, 0}}, {
             3.4011973816621555`, "", {0.01, 0}}, {
             3.6888794541139363`, "", {0.01, 0}}, {
             3.912023005428146, "", {0.01, 0}}, {
             4.0943445622221, "", {0.01, 0}}, {
             4.248495242049359, "", {0.01, 0}}, {
             4.382026634673881, "", {0.01, 0}}, {
             4.499809670330265, "", {0.01, 0}}, {
             4.605170185988092, "\!\(\*SuperscriptBox[\(10\), \(2\)]\)", {
              0.02, 0.}}, {5.298317366548036, "", {0.01, 0}}, {
             5.703782474656201, "", {0.01, 0}}, {
             5.991464547107982, "", {0.01, 0}}, {
             6.214608098422191, "", {0.01, 0}}, {
             6.396929655216146, "", {0.01, 0}}, {
             6.551080335043404, "", {0.01, 0}}, {
             6.684611727667927, "", {0.01, 0}}, {
             6.802394763324311, "", {0.01, 0}}, {
             6.907755278982137, "\!\(\*SuperscriptBox[\(10\), \(3\)]\)", {
              0.02, 0.}}, {7.600902459542082, "", {0.01, 0}}, {
             8.006367567650246, "", {0.01, 0}}, {
             8.294049640102028, "", {0.01, 0}}, {
             8.517193191416238, "", {0.01, 0}}, {
             8.699514748210191, "", {0.01, 0}}, {
             8.85366542803745, "", {0.01, 0}}, {
             8.987196820661973, "", {0.01, 0}}, {
             9.104979856318357, "", {0.01, 0}}, {
             9.210340371976184, "\!\(\*SuperscriptBox[\(10\), \(4\)]\)", {
              0.02, 0.}}, {9.903487552536127, "", {0.01, 0}}, {
             10.308952660644293`, "", {0.01, 0}}, {
             10.596634733096073`, "", {0.01, 0}}, {
             10.819778284410283`, "", {0.01, 0}}, {
             11.002099841204238`, "", {0.01, 0}}, {
             11.156250521031495`, "", {0.01, 0}}, {
             11.289781913656018`, "", {0.01, 0}}, {
             11.407564949312402`, "", {0.01, 0}}}, {{-13.815510557964274`, 
              "\!\(\*SuperscriptBox[\(10\), \(-6\)]\)", {0.02, 
              0.}}, {-13.122363377404328`, "", {
              0.01, 0}}, {-12.716898269296165`, "", {
              0.01, 0}}, {-12.429216196844383`, "", {
              0.01, 0}}, {-12.206072645530174`, "", {
              0.01, 0}}, {-12.02375108873622, "", {
              0.01, 0}}, {-11.86960040890896, "", {
              0.01, 0}}, {-11.736069016284437`, "", {
              0.01, 0}}, {-11.618285980628055`, "", {
              0.01, 0}}, {-11.512925464970229`, 
              "\!\(\*SuperscriptBox[\(10\), \(-5\)]\)", {0.02, 
              0.}}, {-10.819778284410283`, "", {
              0.01, 0}}, {-10.414313176302118`, "", {
              0.01, 0}}, {-10.126631103850338`, "", {
              0.01, 0}}, {-9.903487552536127, "", {
              0.01, 0}}, {-9.721165995742174, "", {
              0.01, 0}}, {-9.567015315914915, "", {
              0.01, 0}}, {-9.433483923290392, "", {
              0.01, 0}}, {-9.315700887634009, "", {
              0.01, 0}}, {-9.210340371976182, 
              "\!\(\*SuperscriptBox[\(10\), \(-4\)]\)", {0.02, 
              0.}}, {-8.517193191416238, "", {0.01, 0}}, {-8.111728083308073, 
              "", {0.01, 0}}, {-7.824046010856292, "", {
              0.01, 0}}, {-7.600902459542082, "", {
              0.01, 0}}, {-7.418580902748127, "", {
              0.01, 0}}, {-7.264430222920869, "", {
              0.01, 0}}, {-7.1308988302963465`, "", {
              0.01, 0}}, {-7.013115794639964, "", {
              0.01, 0}}, {-6.907755278982137, 
              "\!\(\*SuperscriptBox[\(10\), \(-3\)]\)", {0.02, 
              0.}}, {-6.214608098422191, "", {0.01, 0}}, {-5.809142990314028, 
              "", {0.01, 0}}, {-5.521460917862246, "", {
              0.01, 0}}, {-5.298317366548036, "", {
              0.01, 0}}, {-5.115995809754082, "", {
              0.01, 0}}, {-4.961845129926823, "", {
              0.01, 0}}, {-4.8283137373023015`, "", {
              0.01, 0}}, {-4.710530701645918, "", {
              0.01, 0}}, {-4.605170185988091, 
              "\!\(\*SuperscriptBox[\(10\), \(-2\)]\)", {0.02, 
              0.}}, {-3.912023005428146, "", {0.01, 0}}, {-3.506557897319982, 
              "", {0.01, 0}}, {-3.2188758248682006`, "", {
              0.01, 0}}, {-2.995732273553991, "", {
              0.01, 0}}, {-2.8134107167600364`, "", {
              0.01, 0}}, {-2.659260036932778, "", {
              0.01, 0}}, {-2.5257286443082556`, "", {
              0.01, 0}}, {-2.4079456086518722`, "", {
              0.01, 0}}, {-2.3025850929940455`, 
              "\!\(\*SuperscriptBox[\(10\), \(-1\)]\)", {0.02, 
              0.}}, {-1.6094379124341003`, "", {
              0.01, 0}}, {-1.203972804325936, "", {
              0.01, 0}}, {-0.916290731874155, "", {
              0.01, 0}}, {-0.6931471805599453, "", {
              0.01, 0}}, {-0.5108256237659905, "", {
              0.01, 0}}, {-0.3566749439387323, "", {
              0.01, 0}}, {-0.2231435513142097, "", {
              0.01, 0}}, {-0.10536051565782628`, "", {0.01, 0}}, {
             0., "1", {0.02, 0.}}, {0.6931471805599453, "", {0.01, 0}}, {
             1.0986122886681098`, "", {0.01, 0}}, {
             1.3862943611198906`, "", {0.01, 0}}, {
             1.6094379124341003`, "", {0.01, 0}}, {
             1.791759469228055, "", {0.01, 0}}, {
             1.9459101490553132`, "", {0.01, 0}}, {
             2.0794415416798357`, "", {0.01, 0}}, {
             2.1972245773362196`, "", {0.01, 0}}, {
             2.302585092994046, "\!\(\*SuperscriptBox[\(10\), \(1\)]\)", {
              0.02, 0.}}, {2.995732273553991, "", {0.01, 0}}, {
             3.4011973816621555`, "", {0.01, 0}}, {
             3.6888794541139363`, "", {0.01, 0}}, {
             3.912023005428146, "", {0.01, 0}}, {
             4.0943445622221, "", {0.01, 0}}, {
             4.248495242049359, "", {0.01, 0}}, {
             4.382026634673881, "", {0.01, 0}}, {
             4.499809670330265, "", {0.01, 0}}, {
             4.605170185988092, "\!\(\*SuperscriptBox[\(10\), \(2\)]\)", {
              0.02, 0.}}, {5.298317366548036, "", {0.01, 0}}, {
             5.703782474656201, "", {0.01, 0}}, {
             5.991464547107982, "", {0.01, 0}}, {
             6.214608098422191, "", {0.01, 0}}, {
             6.396929655216146, "", {0.01, 0}}, {
             6.551080335043404, "", {0.01, 0}}, {
             6.684611727667927, "", {0.01, 0}}, {
             6.802394763324311, "", {0.01, 0}}, {
             6.907755278982137, "\!\(\*SuperscriptBox[\(10\), \(3\)]\)", {
              0.02, 0.}}, {7.600902459542082, "", {0.01, 0}}, {
             8.006367567650246, "", {0.01, 0}}, {
             8.294049640102028, "", {0.01, 0}}, {
             8.517193191416238, "", {0.01, 0}}, {
             8.699514748210191, "", {0.01, 0}}, {
             8.85366542803745, "", {0.01, 0}}, {
             8.987196820661973, "", {0.01, 0}}, {
             9.104979856318357, "", {0.01, 0}}, {
             9.210340371976184, "\!\(\*SuperscriptBox[\(10\), \(4\)]\)", {
              0.02, 0.}}, {9.903487552536127, "", {0.01, 0}}, {
             10.308952660644293`, "", {0.01, 0}}, {
             10.596634733096073`, "", {0.01, 0}}, {
             10.819778284410283`, "", {0.01, 0}}, {
             11.002099841204238`, "", {0.01, 0}}, {
             11.156250521031495`, "", {0.01, 0}}, {
             11.289781913656018`, "", {0.01, 0}}, {
             11.407564949312402`, "", {0.01, 0}}}, {{-13.815510557964274`, 
              ""}, {-13.122363377404328`, ""}, {-12.716898269296165`, 
              ""}, {-12.429216196844383`, ""}, {-12.206072645530174`, 
              ""}, {-12.02375108873622, ""}, {-11.86960040890896, 
              ""}, {-11.736069016284437`, ""}, {-11.618285980628055`, 
              ""}, {-11.512925464970229`, ""}, {-10.819778284410283`, 
              ""}, {-10.414313176302118`, ""}, {-10.126631103850338`, 
              ""}, {-9.903487552536127, ""}, {-9.721165995742174, 
              ""}, {-9.567015315914915, ""}, {-9.433483923290392, 
              ""}, {-9.315700887634009, ""}, {-9.210340371976182, 
              ""}, {-8.517193191416238, ""}, {-8.111728083308073, 
              ""}, {-7.824046010856292, ""}, {-7.600902459542082, 
              ""}, {-7.418580902748127, ""}, {-7.264430222920869, 
              ""}, {-7.1308988302963465`, ""}, {-7.013115794639964, 
              ""}, {-6.907755278982137, ""}, {-6.214608098422191, 
              ""}, {-5.809142990314028, ""}, {-5.521460917862246, 
              ""}, {-5.298317366548036, ""}, {-5.115995809754082, 
              ""}, {-4.961845129926823, ""}, {-4.8283137373023015`, 
              ""}, {-4.710530701645918, ""}, {-4.605170185988091, 
              ""}, {-3.912023005428146, ""}, {-3.506557897319982, 
              ""}, {-3.2188758248682006`, ""}, {-2.995732273553991, 
              ""}, {-2.8134107167600364`, ""}, {-2.659260036932778, 
              ""}, {-2.5257286443082556`, ""}, {-2.4079456086518722`, 
              ""}, {-2.3025850929940455`, ""}, {-1.6094379124341003`, 
              ""}, {-1.203972804325936, ""}, {-0.916290731874155, 
              ""}, {-0.6931471805599453, ""}, {-0.5108256237659905, 
              ""}, {-0.3566749439387323, ""}, {-0.2231435513142097, 
              ""}, {-0.10536051565782628`, ""}, {0., ""}, {
             0.6931471805599453, ""}, {1.0986122886681098`, ""}, {
             1.3862943611198906`, ""}, {1.6094379124341003`, ""}, {
             1.791759469228055, ""}, {1.9459101490553132`, ""}, {
             2.0794415416798357`, ""}, {2.1972245773362196`, ""}, {
             2.302585092994046, ""}, {2.995732273553991, ""}, {
             3.4011973816621555`, ""}, {3.6888794541139363`, ""}, {
             3.912023005428146, ""}, {4.0943445622221, ""}, {
             4.248495242049359, ""}, {4.382026634673881, ""}, {
             4.499809670330265, ""}, {4.605170185988092, ""}, {
             5.298317366548036, ""}, {5.703782474656201, ""}, {
             5.991464547107982, ""}, {6.214608098422191, ""}, {
             6.396929655216146, ""}, {6.551080335043404, ""}, {
             6.684611727667927, ""}, {6.802394763324311, ""}, {
             6.907755278982137, ""}, {7.600902459542082, ""}, {
             8.006367567650246, ""}, {8.294049640102028, ""}, {
             8.517193191416238, ""}, {8.699514748210191, ""}, {
             8.85366542803745, ""}, {8.987196820661973, ""}, {
             9.104979856318357, ""}, {9.210340371976184, ""}, {
             9.903487552536127, ""}, {10.308952660644293`, ""}, {
             10.596634733096073`, ""}, {10.819778284410283`, ""}, {
             11.002099841204238`, ""}, {11.156250521031495`, ""}, {
             11.289781913656018`, ""}, {
             11.407564949312402`, ""}}, {{-13.815510557964274`, 
              ""}, {-13.122363377404328`, ""}, {-12.716898269296165`, 
              ""}, {-12.429216196844383`, ""}, {-12.206072645530174`, 
              ""}, {-12.02375108873622, ""}, {-11.86960040890896, 
              ""}, {-11.736069016284437`, ""}, {-11.618285980628055`, 
              ""}, {-11.512925464970229`, ""}, {-10.819778284410283`, 
              ""}, {-10.414313176302118`, ""}, {-10.126631103850338`, 
              ""}, {-9.903487552536127, ""}, {-9.721165995742174, 
              ""}, {-9.567015315914915, ""}, {-9.433483923290392, 
              ""}, {-9.315700887634009, ""}, {-9.210340371976182, 
              ""}, {-8.517193191416238, ""}, {-8.111728083308073, 
              ""}, {-7.824046010856292, ""}, {-7.600902459542082, 
              ""}, {-7.418580902748127, ""}, {-7.264430222920869, 
              ""}, {-7.1308988302963465`, ""}, {-7.013115794639964, 
              ""}, {-6.907755278982137, ""}, {-6.214608098422191, 
              ""}, {-5.809142990314028, ""}, {-5.521460917862246, 
              ""}, {-5.298317366548036, ""}, {-5.115995809754082, 
              ""}, {-4.961845129926823, ""}, {-4.8283137373023015`, 
              ""}, {-4.710530701645918, ""}, {-4.605170185988091, 
              ""}, {-3.912023005428146, ""}, {-3.506557897319982, 
              ""}, {-3.2188758248682006`, ""}, {-2.995732273553991, 
              ""}, {-2.8134107167600364`, ""}, {-2.659260036932778, 
              ""}, {-2.5257286443082556`, ""}, {-2.4079456086518722`, 
              ""}, {-2.3025850929940455`, ""}, {-1.6094379124341003`, 
              ""}, {-1.203972804325936, ""}, {-0.916290731874155, 
              ""}, {-0.6931471805599453, ""}, {-0.5108256237659905, 
              ""}, {-0.3566749439387323, ""}, {-0.2231435513142097, 
              ""}, {-0.10536051565782628`, ""}, {0., ""}, {
             0.6931471805599453, ""}, {1.0986122886681098`, ""}, {
             1.3862943611198906`, ""}, {1.6094379124341003`, ""}, {
             1.791759469228055, ""}, {1.9459101490553132`, ""}, {
             2.0794415416798357`, ""}, {2.1972245773362196`, ""}, {
             2.302585092994046, ""}, {2.995732273553991, ""}, {
             3.4011973816621555`, ""}, {3.6888794541139363`, ""}, {
             3.912023005428146, ""}, {4.0943445622221, ""}, {
             4.248495242049359, ""}, {4.382026634673881, ""}, {
             4.499809670330265, ""}, {4.605170185988092, ""}, {
             5.298317366548036, ""}, {5.703782474656201, ""}, {
             5.991464547107982, ""}, {6.214608098422191, ""}, {
             6.396929655216146, ""}, {6.551080335043404, ""}, {
             6.684611727667927, ""}, {6.802394763324311, ""}, {
             6.907755278982137, ""}, {7.600902459542082, ""}, {
             8.006367567650246, ""}, {8.294049640102028, ""}, {
             8.517193191416238, ""}, {8.699514748210191, ""}, {
             8.85366542803745, ""}, {8.987196820661973, ""}, {
             9.104979856318357, ""}, {9.210340371976184, ""}, {
             9.903487552536127, ""}, {10.308952660644293`, ""}, {
             10.596634733096073`, ""}, {10.819778284410283`, ""}, {
             11.002099841204238`, ""}, {11.156250521031495`, ""}, {
             11.289781913656018`, ""}, {11.407564949312402`, ""}}}, Axes -> 
          False, PlotLabel -> 
          Style["\!\(\*SubscriptBox[\(\[Delta]r\), \(i\)]\), CT14NNLO", 24, 
            GrayLevel[0]], FrameLabel -> {
            Style["x", 18, 
             GrayLevel[0]], 
            Style["\[Mu] [GeV]", 18, 
             GrayLevel[0]]}, FrameTicksStyle -> GrayLevel[0], 
          ImageSize -> {{600}, {600}}, AspectRatio -> 1., 
          GridLines -> {{-16.11809565095832, -13.815510557964274`, \
-11.512925464970229`, -9.210340371976182, -6.907755278982137, \
-4.605170185988091, -2.3025850929940455`}, {
             Log[10], 
             Log[50], 
             Log[100], 
             Log[500], 
             Log[1000], 
             Log[5000], 
             Log[10000]}}, GridLinesStyle -> Directive[
            Dashing[{Small, Small}]], PlotRangeClipping -> True, 
          DisplayFunction -> Identity, PlotRangePadding -> {{0, 0}, {0, 0}}, 
          AxesOrigin -> {0, 0}, PlotRange -> {{-Log[100000], 0}, {0, 
             Log[6000]}}, PlotRangeClipping -> True, ImagePadding -> All, 
          DisplayFunction -> Identity, AspectRatio -> 1, Axes -> {True, True},
           AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
          Identity, Epilog -> {{
             Text[
              Style["Npt: 3966", 16, 
               GrayLevel[0]], 
              Scaled[{0.1, 0.9}]], 
             Text[
              Style["highlighted range:\n{{1, 100}}", 16, 
               GrayLevel[0]], 
              Scaled[{0.2, 0.7}]]}, {{
              Text[
               Style["Npt: 3966", 16, 
                GrayLevel[0]], 
               Scaled[{0.1, 0.9}]], 
              Text[
               Style["highlighted range:\n{{1, 100}}", 16, 
                GrayLevel[0]], 
               Scaled[{0.2, 0.7}]]}}}, 
          Frame -> {{False, False}, {False, False}}, 
          FrameLabel -> {{None, None}, {None, None}}, 
          FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
          GridLines -> {None, None}, GridLinesStyle -> Directive[
            GrayLevel[0.5, 0.4]], 
          Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& )}}, PlotRange -> {{-Log[100000], 0}, {0, 
             Log[6000]}}, PlotRangeClipping -> True, 
          PlotRangePadding -> {{0, 0}, {0, 0}}, 
          Ticks -> {Automatic, Automatic}}], 
        Placed[
         Unevaluated[
          BarLegend[{{
             RGBColor[0, 0.7, 0], 
             RGBColor[0, 0.7, 0], 
             RGBColor[0.75, 0.75, 0.], 
             RGBColor[0.75, 0.55, 0.], 
             RGBColor[0.7, 0., 0.], 
             RGBColor[0.7, 0., 0.]}, {-0.003, 3.003}}, {-0.003, 0, 
            0.8888888888888888, 1.3333333333333333`, 2., 3., 3.003}, 
           LabelStyle -> {FontSize -> 14, 
             GrayLevel[0]}, LegendLabel -> "", LegendLayout -> "Column", 
           LegendMarkerSize -> {}, Charting`TickAnnotations -> None, 
           Charting`TickSide -> Right, ColorFunctionScaling -> True]], {1., 
         0.5}, Identity]]& ],
      AutoDelete->True,
      Editable->True,
      SelectWithContents->False,
      Selectable->True], ",", 
     TagBox[GridBox[{
        {
         InterpretationBox[Cell[BoxData[
           FormBox[
            
            StyleBox["\<\"\\!\\(\\*SubscriptBox[\\(\[Delta]r\\), \\(i\\)]\\), \
CT14NNLO\\n\\n\"\>",
             StripOnInput->False,
             FontSize->24], TextForm]], "InlineText"],
          Text[
           Style[
           "\!\(\*SubscriptBox[\(\[Delta]r\), \(i\)]\), CT14NNLO\n\n", 
            FontSize -> 24]]], "\[SpanFromLeft]", "\[SpanFromLeft]"},
        {"\<\"Data Sets\"\>", "", ""},
        {"\<\"\[FilledCircle]BcdF2pCor(101)\"\>", \
"\<\"\[FilledSquare]BcdF2dCor(102)\"\>", \
"\<\"\[FilledDiamond]NmcRatCor(104)\"\>"},
        {"\<\"\[FilledUpTriangle]cdhswf2(108)\"\>", \
"\<\"\[FilledDownTriangle]cdhswf3(109)\"\>", \
"\<\"\[EmptyCircle]ccfrf2.mi(110)\"\>"},
        {"\<\"\[EmptySquare]ccfrf3.md(111)\"\>", \
"\<\"\[EmptyDiamond]NuTvNuChXN(124)\"\>", \
"\<\"\[EmptyUpTriangle]NuTvNbChXN(125)\"\>"},
        {"\<\"\[EmptyDownTriangle]CcfrNuChXN(126)\"\>", \
"\<\"\[Times]CcfrNbChXN(127)\"\>", "\<\"\[CircleMinus]Hn1X0c(147)\"\>"},
        {"\<\"\[FivePointedStar]e605(201)\"\>", \
"\<\"\[FilledCircle]e866f(203)\"\>", "\<\"\[FilledSquare]e866ppxf(204)\"\>"},
        {"\<\"\[FilledDiamond]cdfLasy(225)\"\>", \
"\<\"\[FilledUpTriangle]cdfLasy2(227)\"\>", \
"\<\"\[FilledDownTriangle]d02Masy1(234)\"\>"},
        {"\<\"\[EmptyCircle]ZyD02a(260)\"\>", \
"\<\"\[EmptySquare]cdf2jtCor2(504)\"\>", "\<\"\[EmptyDiamond]d02jtCor2(514)\"\
\>"},
        {"\<\"\[EmptyUpTriangle]Hn+9900x0b(145)\"\>", "\<\"\
\[EmptyDownTriangle]H1FL10(169)\"\>", "\<\"\[Times]ATL7_WZ(268)\"\>"},
        {"\<\"\[CircleMinus]ATL7jtR6(535)\"\>", \
"\<\"\[FivePointedStar]LHCb7_WZ1(240)\"\>", \
"\<\"\[FilledCircle]LHCb7Wasy1(241)\"\>"},
        {"\<\"\[FilledSquare]d02Easy5(281)\"\>", \
"\<\"\[FilledDiamond]CMS7Masy2(266)\"\>", \
"\<\"\[FilledUpTriangle]CMS7jtR7v2(538)\"\>"},
        {"\<\"\[FilledDownTriangle]LHCb7ZWrap(245)\"\>", \
"\<\"\[EmptyCircle]LHCb8Zeer(246)\"\>", "\<\"\[EmptySquare]ATL7ZW(248)\"\>"},
        {"\<\"\[EmptyDiamond]CMS7jtR7y6(542)\"\>", \
"\<\"\[EmptyUpTriangle]ATL7jtR6u(544)\"\>", \
"\<\"\[EmptyDownTriangle]CMS8Wxa(249)\"\>"},
        {"\<\"\[Times]LHCb8WZ(250)\"\>", \
"\<\"\[CircleMinus]ATL8ttpt(565)\"\>", "\<\"\[FivePointedStar]ATL8ttya(566)\"\
\>"},
        {"\<\"\[FilledCircle]ATL8ttmtt(567)\"\>", \
"\<\"\[FilledSquare]ATL8ttytt(568)\"\>", ""},
        {
         InterpretationBox[Cell[BoxData[
           FormBox[
            StyleBox["\<\"\"\>",
             StripOnInput->False,
             FontSize->16], TextForm]], "InlineText"],
          Text[
           Style["", FontSize -> 16]]], "\[SpanFromLeft]", "\[SpanFromLeft]"}
       },
       AutoDelete->False,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{14}}},
       GridBoxItemStyle->{"Columns" -> {{
            Directive[FontSize -> 18, 
             GrayLevel[0]]}}, "Rows" -> {{
            Directive[FontSize -> 18, 
             GrayLevel[0]]}}}],
      "Grid"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     GraphicsBox[{
       {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
        EdgeForm[{Opacity[0.33599999999999997`], Thickness[Small]}], {}, 
        {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
         EdgeForm[{Opacity[0.33599999999999997`], Thickness[Small]}], 
         RectangleBox[{0., 0}, {0.06, 38},
          RoundingRadius->0], RectangleBox[{0.06, 0}, {0.12, 80},
          RoundingRadius->0], RectangleBox[{0.12, 0}, {0.18, 192},
          RoundingRadius->0], RectangleBox[{0.18, 0}, {0.24, 292},
          RoundingRadius->0], RectangleBox[{0.24, 0}, {0.3, 305},
          RoundingRadius->0], RectangleBox[{0.3, 0}, {0.36, 360},
          RoundingRadius->0], RectangleBox[{0.36, 0}, {0.42, 417},
          RoundingRadius->0], RectangleBox[{0.42, 0}, {0.48, 345},
          RoundingRadius->0], RectangleBox[{0.48, 0}, {0.54, 268},
          RoundingRadius->0], RectangleBox[{0.54, 0}, {0.6, 230},
          RoundingRadius->0], 
         RectangleBox[{0.6, 0}, {0.6599999999999999, 183},
          RoundingRadius->0], 
         RectangleBox[{0.6599999999999999, 0}, {0.72, 130},
          RoundingRadius->0], RectangleBox[{0.72, 0}, {0.78, 112},
          RoundingRadius->0], RectangleBox[{0.78, 0}, {0.84, 132},
          RoundingRadius->0], 
         RectangleBox[{0.84, 0}, {0.8999999999999999, 87},
          RoundingRadius->0], 
         RectangleBox[{0.8999999999999999, 0}, {0.96, 58},
          RoundingRadius->0], RectangleBox[{0.96, 0}, {1.02, 58},
          RoundingRadius->0], RectangleBox[{1.02, 0}, {1.08, 61},
          RoundingRadius->0], RectangleBox[{1.08, 0}, {1.14, 30},
          RoundingRadius->0], RectangleBox[{1.14, 0}, {1.2, 35},
          RoundingRadius->0], RectangleBox[{1.2, 0}, {1.26, 40},
          RoundingRadius->0], 
         RectangleBox[{1.26, 0}, {1.3199999999999998, 46},
          RoundingRadius->0], 
         RectangleBox[{1.3199999999999998, 0}, {1.38, 31},
          RoundingRadius->0], RectangleBox[{1.38, 0}, {1.44, 22},
          RoundingRadius->0], RectangleBox[{1.44, 0}, {1.5, 23},
          RoundingRadius->0], RectangleBox[{1.5, 0}, {1.56, 14},
          RoundingRadius->0], 
         RectangleBox[{1.56, 0}, {1.6199999999999999, 28},
          RoundingRadius->0], 
         RectangleBox[{1.6199999999999999, 0}, {1.68, 28},
          RoundingRadius->0], RectangleBox[{1.68, 0}, {1.74, 21},
          RoundingRadius->0], 
         RectangleBox[{1.74, 0}, {1.7999999999999998, 15},
          RoundingRadius->0], 
         RectangleBox[{1.7999999999999998, 0}, {1.8599999999999999, 14},
          RoundingRadius->0], 
         RectangleBox[{1.8599999999999999, 0}, {1.92, 21},
          RoundingRadius->0], RectangleBox[{1.92, 0}, {1.98, 12},
          RoundingRadius->0], RectangleBox[{1.98, 0}, {2.04, 6},
          RoundingRadius->0], RectangleBox[{2.04, 0}, {2.1, 18},
          RoundingRadius->0], RectangleBox[{2.1, 0}, {2.16, 8},
          RoundingRadius->0], 
         RectangleBox[{2.16, 0}, {2.2199999999999998, 6},
          RoundingRadius->0], 
         RectangleBox[{2.2199999999999998, 0}, {2.28, 2},
          RoundingRadius->0], RectangleBox[{2.28, 0}, {2.34, 4},
          RoundingRadius->0], RectangleBox[{2.34, 0}, {2.4, 8},
          RoundingRadius->0], RectangleBox[{2.4, 0}, {2.46, 6},
          RoundingRadius->0], RectangleBox[{2.46, 0}, {2.52, 4},
          RoundingRadius->0], RectangleBox[{2.52, 0}, {2.58, 14},
          RoundingRadius->0], 
         RectangleBox[{2.6399999999999997, 0}, {2.6999999999999997, 10},
          RoundingRadius->0], 
         RectangleBox[{2.6999999999999997, 0}, {2.76, 4},
          RoundingRadius->0], RectangleBox[{2.76, 0}, {2.82, 4},
          RoundingRadius->0], RectangleBox[{2.82, 0}, {2.88, 2},
          RoundingRadius->0], RectangleBox[{2.88, 0}, {2.94, 2},
          RoundingRadius->0], RectangleBox[{2.94, 0}, {3., 2},
          RoundingRadius->0], RectangleBox[{3., 0}, {3.06, 12},
          RoundingRadius->0], RectangleBox[{3.06, 0}, {3.12, 4},
          RoundingRadius->0], 
         RectangleBox[{3.12, 0}, {3.1799999999999997, 6},
          RoundingRadius->0], 
         RectangleBox[{3.1799999999999997, 0}, {3.2399999999999998, 4},
          RoundingRadius->0], RectangleBox[{3.3, 0}, {3.36, 2},
          RoundingRadius->0], RectangleBox[{3.36, 0}, {3.42, 2},
          RoundingRadius->0], RectangleBox[{3.42, 0}, {3.48, 2},
          RoundingRadius->0], 
         RectangleBox[{3.5999999999999996, 0}, {3.6599999999999997, 4},
          RoundingRadius->0], RectangleBox[{3.78, 0}, {3.84, 6},
          RoundingRadius->0], RectangleBox[{3.84, 0}, {3.9, 2},
          RoundingRadius->0], RectangleBox[{4.26, 0}, {4.32, 2},
          RoundingRadius->0], 
         RectangleBox[{4.38, 0}, {4.4399999999999995, 2},
          RoundingRadius->0], RectangleBox[{4.56, 0}, {4.62, 4},
          RoundingRadius->0], RectangleBox[{4.68, 0}, {4.74, 4},
          RoundingRadius->0], 
         RectangleBox[{4.9799999999999995, 0}, {5.04, 2},
          RoundingRadius->0], RectangleBox[{5.04, 0}, {5.1, 2},
          RoundingRadius->0], RectangleBox[{5.1, 0}, {5.16, 2},
          RoundingRadius->0], RectangleBox[{5.16, 0}, {5.22, 6},
          RoundingRadius->0], RectangleBox[{5.22, 0}, {5.279999999999999, 4},
          RoundingRadius->0], RectangleBox[{5.46, 0}, {5.52, 2},
          RoundingRadius->0], RectangleBox[{5.52, 0}, {5.58, 2},
          RoundingRadius->0], RectangleBox[{5.64, 0}, {5.7, 2},
          RoundingRadius->0], RectangleBox[{5.819999999999999, 0}, {5.88, 2},
          RoundingRadius->0], 
         RectangleBox[{5.88, 0}, {5.9399999999999995, 4},
          RoundingRadius->0], RectangleBox[{6.24, 0}, {6.3, 2},
          RoundingRadius->0], 
         RectangleBox[{6.4799999999999995, 0}, {6.54, 4},
          RoundingRadius->0], RectangleBox[{6.72, 0}, {6.779999999999999, 2},
          RoundingRadius->0], 
         RectangleBox[{6.8999999999999995, 0}, {6.96, 2},
          RoundingRadius->0], RectangleBox[{7.26, 0}, {7.319999999999999, 2},
          RoundingRadius->0], RectangleBox[{7.319999999999999, 0}, {7.38, 2},
          RoundingRadius->0], 
         RectangleBox[{7.38, 0}, {7.4399999999999995, 2},
          RoundingRadius->0], RectangleBox[{7.739999999999999, 0}, {7.8, 2},
          RoundingRadius->0], 
         RectangleBox[{7.92, 0}, {7.9799999999999995, 2},
          RoundingRadius->0], 
         RectangleBox[{7.9799999999999995, 0}, {8.04, 2},
          RoundingRadius->0], RectangleBox[{8.04, 0}, {8.1, 2},
          RoundingRadius->0], RectangleBox[{8.1, 0}, {8.16, 2},
          RoundingRadius->0], RectangleBox[{8.16, 0}, {8.219999999999999, 2},
          RoundingRadius->0], RectangleBox[{8.28, 0}, {8.34, 2},
          RoundingRadius->0], RectangleBox[{8.459999999999999, 0}, {8.52, 4},
          RoundingRadius->0], RectangleBox[{8.64, 0}, {8.7, 2},
          RoundingRadius->0], RectangleBox[{8.879999999999999, 0}, {8.94, 2},
          RoundingRadius->0], RectangleBox[{9.36, 0}, {9.42, 2},
          RoundingRadius->0], RectangleBox[{9.66, 0}, {9.719999999999999, 4},
          RoundingRadius->0], RectangleBox[{10.02, 0}, {10.08, 2},
          RoundingRadius->0], RectangleBox[{12.12, 0}, {12.18, 2},
          RoundingRadius->0], RectangleBox[{12.18, 0}, {12.24, 2},
          RoundingRadius->0], RectangleBox[{12.42, 0}, {12.48, 2},
          RoundingRadius->0], RectangleBox[{12.48, 0}, {12.54, 2},
          
          RoundingRadius->
           0]}, {}, {}}, {{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}}},
      AspectRatio->1,
      Axes->False,
      AxesLabel->{None, None},
      AxesOrigin->{-3.12, 0.},
      BaseStyle->{FontSize -> 16},
      Epilog->{{
         Thickness[Large], {
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[0.7, 0., 0.], StripOnInput -> False], 
            TraditionalForm], {-1, 410.74499999999995`}], 
          StyleBox[
           LineBox[{{-1, 0.}, {-1, 396.15}}], 
           RGBColor[0.7, 0., 0.], StripOnInput -> False]}, {
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[0.7, 0., 0.], StripOnInput -> False], 
            TraditionalForm], {1, 394.06499999999994`}], 
          StyleBox[
           LineBox[{{1, 0.}, {1, 396.15}}], 
           RGBColor[0.7, 0., 0.], StripOnInput -> False]}}, {
         Thickness[Large], 
         StyleBox[
          LineBox[{{1, 0.}, {100, 0.}}], 
          RGBColor[0., 0., 0.7], StripOnInput -> False]}, 
        InsetBox[
         FormBox[
          StyleBox["\"Npt: 3966\"", 16, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         Scaled[{0.1, 0.9}]]},
      Frame->True,
      FrameLabel->{
        FormBox[
         StyleBox[
         "\"\\!\\(\\*SubscriptBox[\\(\[Delta]r\\), \\(i\\)]\\)\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm], 
        FormBox[
         StyleBox["\"#points\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm]},
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImageSize->{{600}, {600}},
      PlotLabel->FormBox[
        StyleBox[
        "\"\\!\\(\\*SubscriptBox[\\(\[Delta]r\\), \\(i\\)]\\), CT14NNLO\"", 
         24, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{-3., 3.}, {0., 417}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}], ",", 
     GraphicsBox[{
       {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
        EdgeForm[{Opacity[0.33599999999999997`], Thickness[Small]}], {}, 
        {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
         EdgeForm[{Opacity[0.33599999999999997`], Thickness[Small]}], 
         RectangleBox[{0., 0}, {0.06, 38},
          RoundingRadius->0], RectangleBox[{0.06, 0}, {0.12, 80},
          RoundingRadius->0], RectangleBox[{0.12, 0}, {0.18, 192},
          RoundingRadius->0], RectangleBox[{0.18, 0}, {0.24, 292},
          RoundingRadius->0], RectangleBox[{0.24, 0}, {0.3, 305},
          RoundingRadius->0], RectangleBox[{0.3, 0}, {0.36, 360},
          RoundingRadius->0], RectangleBox[{0.36, 0}, {0.42, 417},
          RoundingRadius->0], RectangleBox[{0.42, 0}, {0.48, 345},
          RoundingRadius->0], RectangleBox[{0.48, 0}, {0.54, 268},
          RoundingRadius->0], RectangleBox[{0.54, 0}, {0.6, 230},
          RoundingRadius->0], 
         RectangleBox[{0.6, 0}, {0.6599999999999999, 183},
          RoundingRadius->0], 
         RectangleBox[{0.6599999999999999, 0}, {0.72, 130},
          RoundingRadius->0], RectangleBox[{0.72, 0}, {0.78, 112},
          RoundingRadius->0], RectangleBox[{0.78, 0}, {0.84, 132},
          RoundingRadius->0], 
         RectangleBox[{0.84, 0}, {0.8999999999999999, 87},
          RoundingRadius->0], 
         RectangleBox[{0.8999999999999999, 0}, {0.96, 58},
          RoundingRadius->0], RectangleBox[{0.96, 0}, {1.02, 58},
          RoundingRadius->0], RectangleBox[{1.02, 0}, {1.08, 61},
          RoundingRadius->0], RectangleBox[{1.08, 0}, {1.14, 30},
          RoundingRadius->0], RectangleBox[{1.14, 0}, {1.2, 35},
          RoundingRadius->0], RectangleBox[{1.2, 0}, {1.26, 40},
          RoundingRadius->0], 
         RectangleBox[{1.26, 0}, {1.3199999999999998, 46},
          RoundingRadius->0], 
         RectangleBox[{1.3199999999999998, 0}, {1.38, 31},
          RoundingRadius->0], RectangleBox[{1.38, 0}, {1.44, 22},
          RoundingRadius->0], RectangleBox[{1.44, 0}, {1.5, 23},
          RoundingRadius->0], RectangleBox[{1.5, 0}, {1.56, 14},
          RoundingRadius->0], 
         RectangleBox[{1.56, 0}, {1.6199999999999999, 28},
          RoundingRadius->0], 
         RectangleBox[{1.6199999999999999, 0}, {1.68, 28},
          RoundingRadius->0], RectangleBox[{1.68, 0}, {1.74, 21},
          RoundingRadius->0], 
         RectangleBox[{1.74, 0}, {1.7999999999999998, 15},
          RoundingRadius->0], 
         RectangleBox[{1.7999999999999998, 0}, {1.8599999999999999, 14},
          RoundingRadius->0], 
         RectangleBox[{1.8599999999999999, 0}, {1.92, 21},
          RoundingRadius->0], RectangleBox[{1.92, 0}, {1.98, 12},
          RoundingRadius->0], RectangleBox[{1.98, 0}, {2.04, 6},
          RoundingRadius->0], RectangleBox[{2.04, 0}, {2.1, 18},
          RoundingRadius->0], RectangleBox[{2.1, 0}, {2.16, 8},
          RoundingRadius->0], 
         RectangleBox[{2.16, 0}, {2.2199999999999998, 6},
          RoundingRadius->0], 
         RectangleBox[{2.2199999999999998, 0}, {2.28, 2},
          RoundingRadius->0], RectangleBox[{2.28, 0}, {2.34, 4},
          RoundingRadius->0], RectangleBox[{2.34, 0}, {2.4, 8},
          RoundingRadius->0], RectangleBox[{2.4, 0}, {2.46, 6},
          RoundingRadius->0], RectangleBox[{2.46, 0}, {2.52, 4},
          RoundingRadius->0], RectangleBox[{2.52, 0}, {2.58, 14},
          RoundingRadius->0], 
         RectangleBox[{2.6399999999999997, 0}, {2.6999999999999997, 10},
          RoundingRadius->0], 
         RectangleBox[{2.6999999999999997, 0}, {2.76, 4},
          RoundingRadius->0], RectangleBox[{2.76, 0}, {2.82, 4},
          RoundingRadius->0], RectangleBox[{2.82, 0}, {2.88, 2},
          RoundingRadius->0], RectangleBox[{2.88, 0}, {2.94, 2},
          RoundingRadius->0], RectangleBox[{2.94, 0}, {3., 2},
          RoundingRadius->0], RectangleBox[{3., 0}, {3.06, 12},
          RoundingRadius->0], RectangleBox[{3.06, 0}, {3.12, 4},
          RoundingRadius->0], 
         RectangleBox[{3.12, 0}, {3.1799999999999997, 6},
          RoundingRadius->0], 
         RectangleBox[{3.1799999999999997, 0}, {3.2399999999999998, 4},
          RoundingRadius->0], RectangleBox[{3.3, 0}, {3.36, 2},
          RoundingRadius->0], RectangleBox[{3.36, 0}, {3.42, 2},
          RoundingRadius->0], RectangleBox[{3.42, 0}, {3.48, 2},
          RoundingRadius->0], 
         RectangleBox[{3.5999999999999996, 0}, {3.6599999999999997, 4},
          RoundingRadius->0], RectangleBox[{3.78, 0}, {3.84, 6},
          RoundingRadius->0], RectangleBox[{3.84, 0}, {3.9, 2},
          RoundingRadius->0], RectangleBox[{4.26, 0}, {4.32, 2},
          RoundingRadius->0], 
         RectangleBox[{4.38, 0}, {4.4399999999999995, 2},
          RoundingRadius->0], RectangleBox[{4.56, 0}, {4.62, 4},
          RoundingRadius->0], RectangleBox[{4.68, 0}, {4.74, 4},
          RoundingRadius->0], 
         RectangleBox[{4.9799999999999995, 0}, {5.04, 2},
          RoundingRadius->0], RectangleBox[{5.04, 0}, {5.1, 2},
          RoundingRadius->0], RectangleBox[{5.1, 0}, {5.16, 2},
          RoundingRadius->0], RectangleBox[{5.16, 0}, {5.22, 6},
          RoundingRadius->0], RectangleBox[{5.22, 0}, {5.279999999999999, 4},
          RoundingRadius->0], RectangleBox[{5.46, 0}, {5.52, 2},
          RoundingRadius->0], RectangleBox[{5.52, 0}, {5.58, 2},
          RoundingRadius->0], RectangleBox[{5.64, 0}, {5.7, 2},
          RoundingRadius->0], RectangleBox[{5.819999999999999, 0}, {5.88, 2},
          RoundingRadius->0], 
         RectangleBox[{5.88, 0}, {5.9399999999999995, 4},
          RoundingRadius->0], RectangleBox[{6.24, 0}, {6.3, 2},
          RoundingRadius->0], 
         RectangleBox[{6.4799999999999995, 0}, {6.54, 4},
          RoundingRadius->0], RectangleBox[{6.72, 0}, {6.779999999999999, 2},
          RoundingRadius->0], 
         RectangleBox[{6.8999999999999995, 0}, {6.96, 2},
          RoundingRadius->0], RectangleBox[{7.26, 0}, {7.319999999999999, 2},
          RoundingRadius->0], RectangleBox[{7.319999999999999, 0}, {7.38, 2},
          RoundingRadius->0], 
         RectangleBox[{7.38, 0}, {7.4399999999999995, 2},
          RoundingRadius->0], RectangleBox[{7.739999999999999, 0}, {7.8, 2},
          RoundingRadius->0], 
         RectangleBox[{7.92, 0}, {7.9799999999999995, 2},
          RoundingRadius->0], 
         RectangleBox[{7.9799999999999995, 0}, {8.04, 2},
          RoundingRadius->0], RectangleBox[{8.04, 0}, {8.1, 2},
          RoundingRadius->0], RectangleBox[{8.1, 0}, {8.16, 2},
          RoundingRadius->0], RectangleBox[{8.16, 0}, {8.219999999999999, 2},
          RoundingRadius->0], RectangleBox[{8.28, 0}, {8.34, 2},
          RoundingRadius->0], RectangleBox[{8.459999999999999, 0}, {8.52, 4},
          RoundingRadius->0], RectangleBox[{8.64, 0}, {8.7, 2},
          RoundingRadius->0], RectangleBox[{8.879999999999999, 0}, {8.94, 2},
          RoundingRadius->0], RectangleBox[{9.36, 0}, {9.42, 2},
          RoundingRadius->0], RectangleBox[{9.66, 0}, {9.719999999999999, 4},
          RoundingRadius->0], RectangleBox[{10.02, 0}, {10.08, 2},
          RoundingRadius->0], RectangleBox[{12.12, 0}, {12.18, 2},
          RoundingRadius->0], RectangleBox[{12.18, 0}, {12.24, 2},
          RoundingRadius->0], RectangleBox[{12.42, 0}, {12.48, 2},
          RoundingRadius->0], RectangleBox[{12.48, 0}, {12.54, 2},
          
          RoundingRadius->
           0]}, {}, {}}, {{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}}},
      AspectRatio->1,
      Axes->False,
      AxesLabel->{None, None},
      AxesOrigin->{-0.06, 0.},
      BaseStyle->{FontSize -> 16},
      Epilog->{{
         Thickness[Large], {
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[0.7, 0., 0.], StripOnInput -> False], 
            TraditionalForm], {1, 410.74499999999995`}], 
          StyleBox[
           LineBox[{{1, 0.}, {1, 396.15}}], 
           RGBColor[0.7, 0., 0.], StripOnInput -> False]}}, {
         Thickness[Large], 
         StyleBox[
          LineBox[{{1, 0.}, {100, 0.}}], 
          RGBColor[0., 0., 0.7], StripOnInput -> False]}, 
        InsetBox[
         FormBox[
          StyleBox["\"Npt: 3966\"", 16, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         Scaled[{0.1, 0.9}]]},
      Frame->True,
      FrameLabel->{
        FormBox[
         StyleBox[
         "\"\\!\\(\\*SubscriptBox[\\(\[Delta]r\\), \\(i\\)]\\)\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm], 
        FormBox[
         StyleBox["\"#points\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm]},
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImageSize->{{600}, {600}},
      PlotLabel->FormBox[
        StyleBox[
        "\"\\!\\(\\*SubscriptBox[\\(\[Delta]r\\), \\(i\\)]\\), CT14NNLO\"", 
         24, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{0., 3.}, {0., 417}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.721098248662283*^9, 3.7211435484608517`*^9, 
  3.721179266336603*^9, 3.721179357975485*^9, 3.721179427722766*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"processdataplotsmultiexp7percentage", "[", 
  RowBox[{
   RowBox[{"{", "dRcorrdataclassfinal", "}"}], ",", 
   RowBox[{"readcorrconfigfile6", "[", 
    RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "5", ",", "0"}],
   "]"}]], "Input",
 CellChangeTimes->{
  3.719195444302807*^9, {3.71919559728481*^9, 3.7191955973639812`*^9}, {
   3.7192229054700613`*^9, 3.719222905564239*^9}, {3.72109822792489*^9, 
   3.721098228076233*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     TagBox[
      GraphicsBox[{InsetBox[
         GraphicsBox[{{{{}, {{}, 
              {GrayLevel[1], PointSize[0.012833333333333334`], 
               AbsoluteThickness[1.6], 
               StyleBox[PointBox[{{0.00001, 2.}, {0.99, 1200.}}],
                FontFamily->"Helvetica"]}, {}}, {}, {}, {{}, {}}}, {
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3118381623295401, 2.6993457604720636}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6039529822035308, 2.6993457604720636}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.47352983902229373, 2.599722324216582}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3348410795309749, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3716028123769008, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3134438363289216, 1.534714366238164}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.18765575838465653, 2.6224923127405635}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.57270299585059, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3960170377865984, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.5922917535991299}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.15455075984859803, 2.5756610130564646}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2569588998089404, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8027388571900397, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7064996252772315, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0091694886945044, 2.5756610130564646}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 2.2976730486330252}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.797175250983993, 2.512035317176253}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6529653909271136, 2.506341930508065}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.33687231664255274, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3138891646209549, 2.5862591440482876}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.421883011611913, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.919365593833201, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.4886252922173524}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7505644514298959, 2.5817308344235403}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8701230510291479, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.517264565896126, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4422299934501939, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.1862091035211472, 2.423031246069913}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 1.0511712140679732}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4159291662495814, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.3205066205818874, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6266106567597011, 2.4265710727750367}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 1.2184672504763885}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0564152399683213, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.318612854071243, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6977577931176286, 2.4265710727750367}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.1454883067486056, 2.432735777459091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.199705077879927, 0.755182571479398}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.2672179491567546, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3645328693383778, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 2.296667619230008}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9329283730271782, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2149273965428693, 2.519308076505333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3528595850336531, 7.751045117971802}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.49397078181451, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4184044150381243, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.6564295976247825, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8627499649461253, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.539739633930633, 2.5974910105351463}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.5859645562484583}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.217869048507598, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5898688311064436, 2.506341930508065}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.764428382564909, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.809142990314028, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6414447085691868, 2.599722324216582}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.304161419150561, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.312220927289192, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.8528465593176202, 7.751045117971802}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1464364105041143, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.1564532883579597, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.694093021166824, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.4395981331422016}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.9139271032022627, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.536426440357718, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8763491247812073, 2.503891949699081}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1409980051645476, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4082690354408987, 1.860974538249528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3943265328171548, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1307223425863433, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.36154392105023625, 2.599722324216582}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.176833887688485, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", {-1.82821600623867, 2.5862591440482876}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.4854489341097463, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.6389967146756448}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7627116439458544, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.4018530946527146, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-7.1308988302963465, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.695775840226822, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", {-2.2576117273513145, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.676945820702642, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4007990473227723, 2.5817308344235403}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7756596021344095, 2.418588768750352}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3903023825174294, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6873994539038122, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", 
                {-1.3563472847519384, 2.3850863145057892}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.013077000561847, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.5299617109323036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.6854573524495757, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.7177791303707455, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1880994551696458, 2.3850863145057892}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6691879168398742, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4947708374559745, 5.886104031450156}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.911914268349973, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7174398731289899, 2.5087859235779435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.1136189934814222, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6064191770501212, 2.5877640352277083}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6747180450915782, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6149530931222105, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8644101099971662, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4182464424728975, 2.6019486702196644}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.807005375881994, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 2.2927367569392314}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5235731965884932, 2.50470927708418}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9715392061046336, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7042981934580606, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.218243944560295, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.894183087299815, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.18260159600127354, 2.136530508663963}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.2876820724517809, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.6003175012993283, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.300710797475603, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4409617624621989, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.257346872655708, 2.0028304393079956}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.312220927289192, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3005870903313728, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.836849948493799, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.159425367681418, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.40649706843741, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.06016413371338, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.19455609446229716, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.0966102859974367}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.532062329207643, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-5.504112279527633, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9689006821464524, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.881903019081021, 2.6224923127405635}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.0841264243165862, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.7027460895677522}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.781788039865368, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-5.234028876665675, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.8178684794407625, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.362224007377702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.256670593326385, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1062413158326008, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.0365602553118024, 7.24422751560335}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8701230510291479, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.3178664036290963, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8438952236485835, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.25154302583590776, 2.130609828254235}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2010151992412087, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.911914268349973, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0996442489973552, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4653375684603434, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.0941445822194344, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.9999411183280458, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\[FivePointedStar]", {-1.469241281940817, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.461401833606696}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.410950117672171, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3226876816505963, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2854179707987138, 2.4997952622817508}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.1269525243508878, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.8643901602629624}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.3286906908754075, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1564532883579597, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.475327636634016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.922779731666459, 5.857933154483459}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.017383521085972, 0.986935571443487}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.968974088653865, 1.803358605071407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.2876820724517809, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3983669423541598, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0129050178795915, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9699552564598479, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[Times]\"\>", 
                {-7.225346881840062, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2453891602615295, 2.424802725718295}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5716605481000705, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.30348549823721, 2.432735777459091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.017383521085972, 0.8385453832493022}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.770028224895903, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.104554242494911, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.41779075779880137, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.836849948493799, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.1413169453979233, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9317114296555002, 1.534714366238164}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-5.093908213290077, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3874950816964096, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3688474475161698, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.4159777803491362, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.522010001878903, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.318488613869894, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-42.34081632550436, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 2.0766877534832147}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.594056810395798, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3413209954771594, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6492187824459448, 2.506341930508065}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2496677635880655, 6.131226489483141}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.2178763245351174, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-4.382026634673881, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4903224315439383, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6667000105450971, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.3732221725934863, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.26683423993894284, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 2.28401370740861}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4934342366777942, 2.512035317176253}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 1.8359358315608838}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.463458318582131, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.225346881840062, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-6.541030999190403, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.2533450600473311, 8.350429973538136}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 2.075809955445786}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5705756281717647, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.987249820814649, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8328691237350826, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5601909533113197, 2.423031246069913}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.46013250945047257, 2.512035317176253}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8689301605143175, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.5356434782150785, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.7317869551252127, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0975128932248088, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.091798316674432, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.006215439402142, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.2568373311553196, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4943251053335957, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4943251053335957, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.228790658775024, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.9245405804618736}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4983438649285135, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledUpTriangle]\"\>", 
                {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.0968250627658085, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.468806782694355, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6713133161521878, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.5974734304916628, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.209094749906707, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3027280306570521, 2.419478844465545}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9063404010209869, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.735370011757173, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7538858167999734, 2.599722324216582}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3186357126460757, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.369240606554063, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5064301623598713, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.278818960372969, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.087375656742122, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3657077275115024, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 0.9654617758806044}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6338708029279587, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.348592493935879}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.15218556191195, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 2.253709925211909}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.3504080825554816}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.184789984909162}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.617850239145466, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.412288358086009, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.489435120039404, 6.29156913955832}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.746403767507258, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.5920892740994874, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.908846148194222, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4911864085136422, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5178502387029551, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.606442403454302, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.6094379124341003, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6218266343535928, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8773173575897015, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-57.46750061412042, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.579879110192556, 2.5974910105351463}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.33589240475620386, 2.502255288122613}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.197324582336553, 1.9401794743463283}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.2876820724517809, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.9334368907091256, 1.8389610707123492}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 0.9150900112976361}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4714166145367258, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4714166145367258, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.991862608772972, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 2.647592232065096}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4329667693183212, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.069887328875024, 1.9416152247724325}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.3681303904922195}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.9975007872996983, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 1.2172838183856083}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7813228714636707, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 2.0759354023505483}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4876628555081794, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4159291662495814, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.290620611051608, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9110235456270366, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.359873830032749, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.0218709311636855, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3657077275115024, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.270112606830481, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3716028123769008, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.271538123821702, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2740421867477461, 2.5771819258971713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4184044150381243, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-44.34079097851618, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-5.0040073078060345, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2306590695884416, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.215490386143112, 1.6114359150967734}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.2788685663767296, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3943265328171548, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-4.083998270167957, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3983901944362025, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-8.666853965970644, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7406861990440543, 6.040254711277414}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0564152399683213, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8807977354618917, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.6526889544284153}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.068859330518762, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.957577403480815, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.153303390278291, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3180038323381698, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.767041814295392, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.817847430944174, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.316022308134559, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-51.46677778703915, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.3302529702362658}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.6397713603489157}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.162823150618887, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.058828136697741, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2942622756733968, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7958982916754054, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5186835491656363, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5186835491656363, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-30.340822850069564, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3005870903313728, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.117817918407743, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 2.647592232065096}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.600868576791223, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.966967075507594, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.4178610876830975, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1041274693562197, 2.413231613081109}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.23876493221716663, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.719319793360441}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.4109447331170353, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.462743533283297, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7650729201315343, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9699552564598479, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.95401869367736, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.342468881579861, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3426311639367969, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4409617624621989, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7389772837890856, 1.803358605071407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.91782824451005, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.887460350206278, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4240364936935998, 8.1797604936999}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.5305182571117267, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.518075479137158, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 0.9654617758806044}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8442026554799011, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-4.045554398052668, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.96443110720209, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3329431856228962, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3842963584572177, 2.413231613081109}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0529699307894087, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.9267273296385394}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.49331319868135953, 2.4239173781615704}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.27128392664214473, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-4.2845370133966245, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.9999411183280458, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8344803566765893, 2.131796772013764}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5159475693467614, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7463370090740643, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6497392092076262, 6.131226489483141}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.666335489679042, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9519282213808764, 5.8289456176102075}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.137918471438812, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6009911288088023, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.1634411179801, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.941966881801218, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 1.9254158540407285}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0328245481301066, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6332184410995039, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5716605481000705, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 2.073423469354273}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8238695231462887, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-67.46691559681179, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5876764206525877, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.117766656001504, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1796054478776414, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4653375684603434, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.542246662893777, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.468806782694355, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.800001029850119, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.6700167631710908, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5064301623598713, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 0.848868055556721}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.540748536722336, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4876628555081794, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.002290482491421}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 1.3480731482996928}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.6358850824489488}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3186357126460757, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5687759307152107, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5324768712979722, 2.5877640352277083}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.271538123821702, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.40649706843741, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4903224315439383, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.719319793360441}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3893457262282811, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.0218709311636855, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8505029913361519, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-4.045554398052668, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-5.298317366548036, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.832423655941967, 1.6937790608678513}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 0.848868055556721}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.565421027017326, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.565421027017326, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 1.094604267270571}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.430629081771714, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.028748427364318, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.809015255353917, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9240709191931175, 8.1797604936999}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.4286713586629105, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0404377246170375, 8.063377822367027}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.3178883284558303, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.1975522365230131}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8476951015583583, 2.0149030205422647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.922779731666459, 5.857933154483459}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-69.46689851604965, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.2166915767337108}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4983438649285135, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.1622605067393605, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2942622756733968, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.4405393759722864, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.617854196524514, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.959419502711985, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.719319793360441}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.39809235377875135, 2.498151876538021}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.725332537920259, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.858931232061846, 1.5953389880545987}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4422299934501939, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.885443919659868, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[EmptySquare]\"\>", {-2.623341473175256, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8584936331479384, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.5087859235779435}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.4354783156390294, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.697356025334, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3700273886560186, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6039529822035308, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3413209954771594, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.683996966534062, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640797356921787, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.523226215615035}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5129946410508307, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.5177707239082765, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.927891643552635}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4304552569056603, 2.503891949699081}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2149273965428693, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9958752112169974, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.912572089444803, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-41.34127116323533, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.594056810395798, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6184786570862495, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.209391157353635, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.4865920824352545}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.932401799030521, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.48175237628028356, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5413120833865, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5413120833865, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[Times]\"\>", {-2.036382052219389, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.201916872261721, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 1.2499017362143359}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 1.5473497201206787}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.3089739467365655, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.694451286761057, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.1990607599649155}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.7740297600361856, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyDiamond]\"\>", 
                {-1.900458886151396, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3903023825174294, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2790527457537265, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.694451286761057, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.725971728690052, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7611345721946656, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.300710797475603, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8787541283454292, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 2.075308010398229}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.341928551227046, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.411934093335004, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8407396514497736, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.4179914478631452, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5269366909223567, 6.253828811575473}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.30938249943111995, 2.131796772013764}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.42266213293668586, 2.418588768750352}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.309519943887134, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2063088641234838, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.063052113269559, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.418781887396557, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.419118909249997, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.9782390361706734}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6622300779252237, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.8118888405232207}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.719319793360441}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.719319793360441}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.717779984300055, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-5.293927018246744, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-4.3428059215206005, 2.6490076604684267}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.094520670764856, 1.6937790608678513}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.8840655845794182, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.019664337643975, 1.8687205103641833}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.836849948493799, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.900458886151396, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.1413169453979233, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.017810977845351, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9519179095173061, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8821308802274503, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.5288035062673013, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.1625110145183415, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.117830825699811, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2330583852210326, 7.8709295967551425}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.378751192832325, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.360956006320375, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.2941383093687477, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.12893600699172, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.382026634673881, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.409603402444116, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.1093512670354135, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4571461020918417, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.810369351701646, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1564532883579597, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.220083871482302, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.100386954332169, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.541030999190403, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6184786570862495, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 1.4772770088317615}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7667937207282438, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.584387646805562, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4460443655256647, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6922761907431048, 2.6019486702196644}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.556451816951096}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.552112845814831, 7.55171221535131}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3567355588783463, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.6397713603489157}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.924832423452417}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6414447085691868, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.349630376748299}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7832907304129113, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.190415030972834, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1208578976154293, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.7822140563845235}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-47.34086951027008, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-35.340845982694816, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3688474475161698, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-4.76404869105558, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.5565205830281202, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.7539022397884905, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.863232841258714, 0.8458682675776092}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0129050178795915, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0931348688118385, 2.0095554142156695}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1874435023747254, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3678803477808931, 2.421256622711544}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5159475693467614, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.359873830032749, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3874950816964096, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.9251241812954787}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.771368779580321, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7178497932003172, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4644721421839146, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.9245405804618736}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0305798782762827, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.56019682034536, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.785741396902492}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.61797181824309, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5329399414613754, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0963149296194261, 6.684611727667927}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.017939231019695, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3063747379440172, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3063747379440172, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.377692565480851}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2942622756733968, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.312220927289192, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8058680506240641, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6906479678596436, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5828588266658222, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.66442222076686, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.795734531747094, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.279845606024556, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1542307124311217, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7225041580723603, 1.9387416595767009}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.51796702860799, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.282782465697866, 2.423031246069913}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.028556821684098, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.017383521085972, 0.7347688552507647}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2669126040998102, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0993125337825032, 8.004365564979574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", {-0.7448616162466241, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.9499943818801375, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6281111776997217, 6.152732694704104}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6548884684428551, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6993626199620875, 2.020222182019865}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 2.4561641809223462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4405393759722864, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.0935997468445653}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.666335489679042, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6713133161521878, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1689274625831354, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.213639558072954, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7199019178687649, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.502828177375842, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 2.075684492802124}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.469241281940817, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.6304163188192922}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0612087734187763, 2.519308076505333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.4405393759722864, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.494523665901028, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2377341206744292, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-53.46678887337479, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.902704363179782}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.317800258800526, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 2.647592232065096}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0191543673333943, 2.570319527636131}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5906161581935125, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5906161581935125, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6654793033177253, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.308100273682156, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.640928579525471, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 1.3982229319851645}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.2178439823981595, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.417776806585365, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.287354413264987, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.287354413264987, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8904754421672127, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6163727633271883, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9390477189967712, 2.414126467726953}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5692561228012685, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.200028504668954, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.878625402249717, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledDownTriangle]\"\>", 
                {-3.904054835778969, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.159425367681418, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2971851860481147, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.6179742434563866, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.26443077336305, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.995732273553991, 3.8004208288468435}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.4135166537013273, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2180717287054377, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.0968250627658085, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.377606779979768, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3670139217339117, 2.134048091170708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.6190782472999463, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.317908016313041, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.666828609658249, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.403068631572368, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6414447085691868, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8643301620628905, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5644645467913691, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 0.766397642299538}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.542246662893777, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.2101638842661795, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9058454740126164, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.458005208673891, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-8.166888494485349, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2942622756733968, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.1409980051645476, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.004138294335951, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3154677188250594, 1.9387416595767009}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.4028303297599902, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4912105310694506, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6424777665123005, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6424777665123005, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.2207799226423173, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4171835010623628, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.3420861064555702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9784819201474635, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.966950472128539, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3789263262507685, 1.589235205116581}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.911914268349973, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2069773133462347, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.9910142780700916, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-4.524512282970637, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1702157075278026, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7797949872856175, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.7847348542910906}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.5102244577722903, 6.476972362889683}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7903604483143476, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8250798518207709, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.974001029221839, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.0241960674538575, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.532062329207643, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6240440648234626, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1715056141884346, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.22276862160913655, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2433732333621994, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 0.7476353658440151}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7565130561817651, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.598497972395766, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 0.9654617758806044}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.71869489837105, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0181583132629375, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.7181373293574413, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.783559272662715}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.676945820702642, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", {-2.8587568185269134, 2.136530508663963}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.7329280505717899, 7.8709295967551425}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5793937910857236, 2.5087859235779435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0700248318161971, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0700248318161971, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-5.298317366548036, 2.6490076604684267}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.21678878567620194, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.6474092888860916, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.437937594271729}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-6.191868611452702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-4.3428059215206005, 3.2386784521643803}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164563795096671, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3478567954878509, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.417032243872697, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.4342248948774405, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.246332151443247}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.894078619827491, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.931658209005277, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.2867117438377558, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.872802292274865, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.466278187121473, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2173252490432223, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6792442753909539, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.083998270167957, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.068859330518762, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.874045755297392, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6445470895476684, 5.736572297479192}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 1.0868770324496888}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.566981433164056, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7533219035960154, 8.350429973538136}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 1.3045418592476314}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4329667693183212, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.7828868907244566}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3171415024315738, 6.063785208687608}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2437536743377806, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.0942695392339727}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.0678093795130645}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.5841201044498106}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-55.46685482648658, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.615959129424366, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.615959129424366, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.815475995845371}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.598497972395766, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0971007679422797, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.491327217590923, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4728877844255986, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.5087859235779435}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 0.7975071958841882}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 0.9666035457477442}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 1.6384140206706175}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.293868803909631, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.344384958042681, 7.759614150696903}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0645007590393418, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6654793033177253, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.269044801069651, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.269044801069651, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 2.1094856630282126}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.70036037299184, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1150465951315345, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2651392395634233, 1.5953389880545987}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5692561228012685, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.863232841258714, 1.007592890280941}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0940068428223313, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.604170685655008, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.091798316674432, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.975391927697949, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.029509172931627, 2.4997952622817508}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 1.1684492482568893}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.132893222644984, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-66.46748299707936, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9747212309094329, 2.0095554142156695}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.5191254931746836, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.087375656742122, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.05211045501669, 7.55171221535131}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0177699008240089, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.1151705891340815}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.773934884315503}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.7164562218841706, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.817803785159501, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.104394898075602, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-6.667164814064207, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6969544189028993, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.502290170873972, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.571249159610065, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 0.849723487602042}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.9180410777537094, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.6854573524495757, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.667164814064207, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1062413158326008, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2063088641234838, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.9180031958023054, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.9177918580004223, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3842963584572177, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.8183088044615916, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6906479678596436, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0942219403668167, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.742398039690331, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.286383733136742, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.5338868320097188, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", {-0.2395270305647338, 1.4996230464268938}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.3101690833145914, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.632849755094834, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.3492738284584218, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.21927603978772048, 1.860974538249528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.377692565480851}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.30432512701003, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.49397078181451, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.424802725718295}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.6407445017668969, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.719319793360441}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.657689841763261, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.1177951080848836, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.166785108860756, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0186003506987251, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4701108472130011, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.622553707074063, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.0940068428223313, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.3137876703331426, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.1866231659908228}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0475390184841091, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.904054835778969, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.7837272975307907}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.741256487054948, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.430789601006442}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.3524072174927233, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.6593256320844346, 7.944492163932159}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2824955457644808, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5561717255328675, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 0.766397642299538}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1409980051645476, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 1.8728785205128469}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-48.341370727608414, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.575036485716768, 2.020222182019865}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.666853965970644, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5823216254710607, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 0.849723487602042}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.71869489837105, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.926290362185661}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.5205117032396989, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.694093021166824, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.095273387402595}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1464364105041143, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7159101569446171, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.915963072687361, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.612442421454399, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.9407951330603375, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.1151705891340815}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.599488434143067, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4361820807702249, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.6204544951665047, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.4028303297599902, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.96443110720209, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.2164073967529934, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 0.761739972025557}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.953887209526845, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1184069159962893, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.246332151443247}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1689274625831354, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 2.3243465847755584}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.6393849888020524}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.9837562915454279}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.314556464775266, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 0.9364854391596744}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.7254100886865211, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7820071777853768, 2.50470927708418}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.6409365794934714}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.0102369597568726, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.7710464276305133}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 2.2086040295231517}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6907507040241487, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.8180773925856184, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7310567536331655, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.5808504555821878, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.741256487054948, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 1.3147983594148207}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 1.9838938336679197}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.995732273553991, 5.991464547107982}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-6.214608098422191, 1.6094379124341003}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.418747583305227, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2184098521237055, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2739976361421332, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3329431856228962, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 1.9838938336679197}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6691879168398742, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6691879168398742, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.298317366548036, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.194022473472768, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9306432380985556, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.554477071672573, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.694451286761057, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledDiamond]\"\>", 
                {-2.4079456086518722, 1.0942695392339727}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8307082193666298, 2.512035317176253}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1111386284230904, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.6843598389513597}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 2.209811692841691}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 1.8526977673331346}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2654936609741865, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyDiamond]\"\>", 
                {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.793961892783255, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7145751279735658, 1.9387416595767009}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 0.898534010284896}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.3504089023600859, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.515036014769512, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.4420193761824103, 3.2386784521643803}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9405834244431995, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.823966230699553, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.612442421454399, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2595256035335987, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 1.5904589458362974}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 1.1464496180822696}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.816258383443767, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.154094566627875, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.813734143549063, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 1.721694594779768}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.725971728690052, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.110313205346923, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8944568674663975, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.666853965970644, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.466278187121473, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3645328693383778, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-52.467202900682494, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7565130561817651, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.9980550336767947}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.780226233414382, 1.9300710850255671}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 0.9666035457477442}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5228016057745537, 5.857933154483459}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1874435023747254, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.974001029221839, 2.502255288122613}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.2636117187095923, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5015355768588979, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2862680470527663, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.953887209526845, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.803865056899991, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 1.3321021320364639}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5079962967558309, 2.134048091170708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 1.8526977673331346}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-56.46701553651661, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.44926026810783587, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.8012039280560548, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.725433722188183, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.9910270779881722}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7120245012092015, 2.506341930508065}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 0.8977193462887197}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.293947899598382}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.9782390361706734}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6126737964100685, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.0279882600909205, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.698815723585317, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.698815723585317, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7048480972387587, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.064355904261795, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.965852822566973}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.225346881840062, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7655070980839893, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.6888794541139363, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.349630376748299}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6788498758591209, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2330583852210326, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2330583852210326, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.2098554674840916}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.5532907518110994}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7655070980839893, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.5895081458004594, 6.7912214627261855}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1644316297054034, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1644316297054034, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.475327636634016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.2158025560795132}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 1.173410498743296}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.411934093335004, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.1733127572899065, 2.419478844465545}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 0.965080896043587}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 0.9403978072173882}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0645007590393418, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0024805005437076, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.3563504847468186}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.8526977673331346}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 0.7499999921527281}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.599292605088321, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.341928551227046, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2409826299598365, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7159101569446171, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 0.9290095042819297}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.8205261098897758, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6497392092076262, 6.131226489483141}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.402871609042948, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.6409365794934714}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5473167323484057, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7406861990440543, 6.040254711277414}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.898454207899018, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6864844231876495, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.166888494485349, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7109170813839543, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.418894215394429, 1.6882490928583902}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 1.721694594779768}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.178596114669692, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.7479817218821596}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5213811377055073, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9293759714228106, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.556451816951096}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.7539022397884905, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 0.8055826098897335}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.3407610128583247, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.860379772276308, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.040829633207479, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8891518152367044, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6269849783062765, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.294616923344869, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6939993778795506, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4599740936085572, 2.004179057179289}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.3137523001849649, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8865098057738656, 2.5771819258971713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1702157075278026, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8407396514497736, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.382026634673881, 0.8441500540964727}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.071483621279857, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.0281898243715637}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9565920286476808, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9565920286476808, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.094604267270571}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4605869657017456, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-46.34085167560773, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.421661504957182}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.6409365794934714}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 2.330200260027019}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.7181023127908395, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-5.493845750829273, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.5808504555821878, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 2.04225875055212}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.816462081868427, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.8283137373023015, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6416938989710297, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9038682118755978, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3585338134237321, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.428942281870568, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.1597073880279205}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7667937207282438, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.9005275521158795, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.640548907459153}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.094604267270571}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-6.113858195322049, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7637552728184576, 2.4265710727750367}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 2.647592232065096}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 1.5904589458362974}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 2.4561641809223462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-43.340988541359216, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.746403767507258, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.8442026554799011, 7.759614150696903}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0645007590393418, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.166995202991212, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.536314386533157, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.893919494400295, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.0968250627658085, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.528780009416646, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8189251373008244, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.631199404215613}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.2908841763152323}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5918549290780729, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.7859090555498793}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 2.193662685769859}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5474025215146479, 2.414126467726953}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9186841628017217, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8714522381373035, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.426283369336254, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2977324083052823, 1.6114359150967734}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.742398039690331, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.064355904261795, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.004138294335951, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.7840632625935846}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.412288358086009, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.640548907459153}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.1627481478062465}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.110245660342752, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.100426344668657, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8773173575897015, 1.6114359150967734}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.9031380572114442, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.703886158927249, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-6.667164814064207, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.6178619668786562, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3035404883862389, 1.5107219394949427}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.26443077336305, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3861841168703593, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.9521761906339596}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.6139480679119864, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.701553201341906, 2.418588768750352}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 2.330200260027019}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0328245481301066, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7696066645869217, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9542522381612738, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7672619976276676, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8016468498397944, 2.130609828254235}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-45.34120604098636, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.721515815839451}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.3354096411241523, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.4854489341097463, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7987840841650193, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.491779868965868}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7987840841650193, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8426317996018116, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0202633222571333, 1.4929040961781488}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5342648554997536, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4267908948229169, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.810913836561449, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9414202437824613, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.816462081868427, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.3089630181835672, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.612442421454399, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.045554398052668, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.64930970607961, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.2855499581361935, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9428149441480107, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9001713499942718, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8566077297129814, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 0.8028980445190645}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7002308520500784, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.155182640156504, 2.570319527636131}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.49397078181451, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.412267540691536, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0129050178795915, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.161367091078508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.91139112512024, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.592214878401959, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.694451286761057, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 0.9707789171582248}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.9205497887945385, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.869504817852908, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.8470364847178946}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.8699543168131119}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9696906777207166, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 2.078566158643882}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4375876555074412, 2.0149030205422647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 0.848868055556721}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 0.7466879474879751}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.132893222644984, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.77313400510489, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8598242001421843, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.9639722918737217, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7912011210353335, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.4753441779534016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8350845939664286, 2.4265710727750367}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.152761077153482, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.0289048762432895}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3193836558372638, 6.461468176353717}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5901256014017275, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.898454207899018, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.8706006059570394, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 0.849723487602042}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.51624397679369, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-6.442136248054226, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-4.199705077879927, 0.7997569156182036}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3039860739096736, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.5100594684538216}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.6623114020411685, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.5902550930173265}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.51875303057183, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6745099091778153, 1.9300710850255671}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0181583132629375, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9002402920947703, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5404260935422814, 8.063377822367027}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.417771502803163, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.768756076219605, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.038175919864279, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.612240146256234, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.7535382564078572}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.270112606830481, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7696066645869217, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.279055610450292, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.378751192832325, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.552112845814831, 5.8289456176102075}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3037931396081468, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 0.9345235001352147}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.7963700817857382, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.3865452232556535, 7.24422751560335}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.178596114669692, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.7867719277170158, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 2.2044208442068145}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6445470895476684, 5.736572297479192}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6790255220615937, 2.134048091170708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6398971199188088, 2.0843046973458237}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.416204086475468, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.031563461435372}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.706800981701778, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 2.209811692841691}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.538054293998892, 2.134048091170708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 0.8514321595256585}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.2499926428748753, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8129108417183852, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2960880932337415, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.294015757351168, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.820158943749753, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.4588475538015993}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.585233223737283, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 1.0420419371797154}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8566077297129814, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.0598714603516792}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.517955942272351, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.3204807842031671, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.6675181235106251}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.045554398052668, 0.9604989865384754}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-6.214608098422191, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6286207318508743, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.739076112448345}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 0.8202202631234213}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.0654001544619962}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.166785108860756, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7212874278842305, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9582864201233687, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.06016413371338, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.712716261887602}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 1.2190584417439767}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8500747011316276, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.6528674703614363, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.406587064387653}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2063088641234838, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.3281354469463584}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.7929254558680243}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.766368110426725, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.595748829015065, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9200474895295858, 2.498151876538021}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5366522427084526, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.1966460289394751}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.1589994386832048, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.6354040111173562, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.8069317506623275, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.5260163042950279, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7004573108212688, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.044846896915337, 5.736572297479192}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 2.0427775573082445}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.251047211711865}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.300710797475603, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.4365120772805082}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.074653024948039, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.500810170663849, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.66873333872526, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1593181637855046, 7.944492163932159}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.2864827918762988, 7.24422751560335}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.984837274409265, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.10045059841862, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.6936470556015963}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640797356921787, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 2.3243465847755584}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.700587583759682, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.3282528397426234}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.166938288491657, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.6562368265398482, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.466163406970865, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4307829160924542, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.2140221401789375}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.4915548717773834}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8042369907391675, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.548102073285148, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.2164073967529934, 2.131796772013764}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9186841628017217, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3907040696085906, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 2.044332364566268}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.424802725718295}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.6260755535871236, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4918104261047946, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.6888794541139363, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.119430549896199, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8413699697813894, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8551011438142453, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9405834244431995, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7955707986317053, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.894183087299815, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.978697138696139, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 0.849723487602042}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4307829160924542, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.558002204858551}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.841967538444134, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 0.9669838461896731}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9987836386623814, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0514564223263525, 2.0028304393079956}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.389499492068839, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.4305321073246677, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 2.0624225365102413}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0108761743640229, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.220083871482302, 2.424802725718295}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.893897967672723, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.220083871482302, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.900464386136271}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.366810362993337, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.1498640059763816, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 0.849723487602042}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-34.340745544411554, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.7083778602890038}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.715777948205427}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5104979645791967, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.694093021166824, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7672619976276676, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.4920048155420047}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4338645826298623, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.6409365794934714}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.3003570667360838, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4871090733432, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8121662790057176, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.036482917202561, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4405393759722864, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.036382052219389, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4307829160924542, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8656213178265104, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.4126383364594925, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.319222734147069, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9192952408944538, 6.461468176353717}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.9474803442248305}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.049977288406387, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.7333680090865, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.007679175452945, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.676945820702642, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-5.7340355178272215, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.435545220250276, 1.776645831418007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.0942695392339727}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.1603343472961065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 2.1992225799988927}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.5608378214218233, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6287255312941893, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.9453385571563557}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.4146388341290332}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.995732273553991, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.5077842587076005, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 2.1992225799988927}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.4179367056664534, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 0.9566646260124284}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.59947470469731, 8.004365564979574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-8.532306829226286, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2315538186741798, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.995732273553991, 5.991464547107982}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.975391927697949, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.466024904841838, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 2.377692565480851}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.9782390361706734}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.191191469961203}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.293947899598382}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.5612262966614128, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.7790406968202803, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.493987758524193, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9085180298382507, 2.423031246069913}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.973281345851445, 2.4239173781615704}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.7693434299437227}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1593181637855046, 7.944492163932159}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8540604954254345, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9519282213808764, 5.8289456176102075}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 0.911479174876933}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.44238846221276223, 1.501852701754163}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 1.0962762288705619}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8407396514497736, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7306413849875258, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.3524072174927233, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6218266343535928, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.0757190980989355, 1.4996230464268938}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.2568373311553196, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.363503507963463, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.103158068297152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 0.986935571443487}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9896682016789307, 6.7912214627261855}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.5366522427084526, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.8420006856648017, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.5787702314339063, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0923241675108497, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 2.1122716862705384}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0053952069569758, 2.498151876538021}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9806466361359503, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2303167796655379, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6218266343535928, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.716864386545305, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1111386284230904, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.100386954332169, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 2.215282764591249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.60100614381313, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.3504080825554816}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.266557384867768, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.1029215602562081, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.391511302188447}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7078502210995437, 1.5973653311998313}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.296603021316498, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.850570223130148, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6941476808935289, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.359436906950008}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.9110235456270366, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.0218709311636855, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledSquare]\"\>", {-2.5449114637250294, 1.5933085305042167}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5068336024964532, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.912572089444803, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8598242001421843, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.1627481478062465}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.6888794541139363, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4307829160924542, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5082360319251331, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.152962883418191, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.29356601561075557, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5177604746590787, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0898959995836948, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7414001807837645, 2.131796772013764}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0605908459024875, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.166785108860756, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6798603767306461, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.166888494485349, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-65.466905183977, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 2.193662685769859}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-50.341331645288825, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.293897511853923, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3678803477808931, 1.4973884086254774}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.4126383364594925, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.5919427181706105, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8016236568960291, 6.579251212010101}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.6305480388034254, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5663784229736533, 6.214608098422191}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.269150316907808, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.9910142780700916, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.26683423993894284, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.2862680470527663, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3093333199837622, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8195418502405067, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6005679992668521, 1.4996230464268938}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.5845302767279155}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8426317996018116, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-70.4670522818902, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9306432380985556, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.045554398052668, 0.8514321595256585}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 2.217027204632399}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.475327636634016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.6378309869353183}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.096384262410148, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 0.9669838461896731}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.8665717425242287, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.2867117438377558, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.6108369333478076}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0549440700794483, 2.418588768750352}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.5774997570339834, 8.026170194946426}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2815740503494875, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7672619976276676, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.031563461435372}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1535965970008693, 1.4906543764441336}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.235513466021224, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.900464386136271}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-49.34073194467232, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.606941032235513, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.940865372113151, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.376740148315079, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.4532518292447716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1464364105041143, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.6888794541139363, 1.0942695392339727}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.741256487054948, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.322289031143978}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.1308988302963465, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4947708374559745, 5.886104031450156}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8461060995981784, 2.004179057179289}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.2704687956143002, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.666828609658249, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2815740503494875, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.412267540691536, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.606941032235513, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.666828609658249, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.7693434299437227}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.9353900445478294, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.412382827063892, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.0935997468445653}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.6378309869353183}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.8162894669713328}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.4138711288901251, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.36571568859088144, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.9313764735639716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.350408373771412, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4240364936935998, 8.1797604936999}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.220083871482302, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.298317366548036, 2.6490076604684267}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2201021862558195, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5059792040658704, 2.0843046973458237}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 0.7802418874108791}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3998672158005996, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.84195543139986, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7903604483143476, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-72.46692041972995, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.2568373311553196, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.2917089186300228}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.144222799920162}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.3428059215206005, 3.2386784521643803}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.3754861624032872}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.224893897193764, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.8140100781628747}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.696151689580244, 6.684611727667927}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.991464547107982, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.506518858426259}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.793961892783255, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.2181715237257489}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.60100614381313, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.76686592498839, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.525061368884541, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.6623114020411685, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164563795096671, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.9105241293044104, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.2581768583394481}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7109170813839543, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9904756300635316, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4028684822608984, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.5554040239416147}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.2672179491567546, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.896419739771488}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.2255369822417765, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 2.078566158643882}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.0287936073591935, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.402746540537711, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.044846896915337, 5.736572297479192}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.975450465015525, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-38.34104853637971, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 2.066736169182282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.186787979571835, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.317867774075151, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.957577403480815, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.8424288832756998}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.6587993419718245}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.162823150618887, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2936253516225737, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.506518858426259}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.84195543139986, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.2672179491567546, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.2157956136516715, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6734432424100127, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.908818717035454, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.671097292820828}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.662352421858305, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 2.0680013515372804}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.6624240079171049, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.66442222076686, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.557794679282262, 1.8687205103641833}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.5047438413194347}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4007990473227723, 6.380122536899765}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.966857671750368, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.7418655495969406, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.2136588837996443, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.719252778441307, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.841967538444134, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7813228714636707, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.5919427181706105, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.2761851384398606, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.532062329207643, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 2.0624225365102413}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.725971728690052, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 0.9654617758806044}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.807005375881994, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6888794541139363, 2.9290581402859983}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-68.46724388757043, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.4569857892424236}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.4420193761824103, 3.2386784521643803}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-33.34092227159292, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-29.340832002509437, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.104554242494911, 2.421256622711544}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.03270329512458, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.869504817852908, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.2178763245351174, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2669126040998102, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9515240188896708, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.6444188813293459}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1111386284230904, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0442924641693683, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 2.414126467726953}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.606941032235513, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.68510181635509}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.214608098422191, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.46298829435183064, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.214574215671332, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.606941032235513, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.7867719277170158, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 0.9991602096964498}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.8826660279157308}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.2756420910162956}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.4971646699513146}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.721515815839451}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.5609672964009644, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.571283042360924, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.3071607397357723, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2262184132732556, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 2.0680013515372804}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.6591800043289144}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-6.536881615643591, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.366795954944823, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5288198871382693, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.1236024374656055, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.4226262903672808}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.8499018253424513, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8953440995227226, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.5539252025038417}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.3162388941358785, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.9286606465811693, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-7.600902459542082, 1.6094379124341003}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9540431322855023, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.0738571633859353, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6888794541139363, 5.298317366548036}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.8843386505211481}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-31.34091993726656, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.4958211856471328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.617843933216061, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.9313764735639716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8598242001421843, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.786359562282124, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.592214878401959, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.564942672547549, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.340512168464763}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.201916872261721, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7109170813839543, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.3754861624032872}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.8002235476401844}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-6.717134919373487, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.860379772276308, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.605170185988091, 2.9290581402859983}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.863232841258714, 0.8333438110532289}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6761120457020933, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8146187633741377, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8997902134417601, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.536881615643591, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.411934093335004, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.4890765557629164}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.500433550670171, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.493879571799828, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.3524072174927233, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.406587064387653}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.8002235476401844}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.849872629798755, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.018486244188825}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3498863661120586, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.1026043099376472}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-6.912265434460023, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.8283137373023015, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.8470364847178946}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.7031992922485748, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.5377270648801}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.0776338822829181, 8.026170194946426}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 0.6951451832226183}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.725332537920259, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.389499492068839, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.820158943749753, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 0.880041599199034}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.0136538011418326, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.540748536722336, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.6527732864216721, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8951219822232084, 5.886104031450156}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7760829898430475, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.09926800165866902, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.6761120457020933, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2201021862558195, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.835485924411894, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2262184132732556, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.2792657883613672}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.613467558616262, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.2158025560795132}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5220551057175394, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.5232317641096684, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.744112815760702, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-58.4670151515563, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.725433722188183, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.864975531559314, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.9122987106046175, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2783372196147982, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.669026703845758}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.9005275521158795, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.6704076935904559, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.8029620465671519, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.989444152396731, 1.5107219394949427}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.2030071867437115, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.4528616053920038, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.9754419516613513, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.6168849633501186, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.3452119160186606}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0302996484860225, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.01348899514325, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.975391927697949, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0939462278827174, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.700547258981618, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.7378311272024993}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.902767737471098, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.199705077879927, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.3137523001849649, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3617968895195032, 1.9416152247724325}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.036270701217564, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.559220196273483, 2.135349173618132}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.171276846068922, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1526461771605954, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5703987153008919, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3993162819538174, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.117899907528199, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.966950472128539, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.2742448573112677}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4088348928367562, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0339487753423875, 2.418588768750352}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.1625110145183415, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0898959995836948, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0288996762568094, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.9368694044031642}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9205497887945385, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.369240606554063, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.26683423993894284, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0898959995836948, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.196424897165655, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.664950622364359, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.286383733136742, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1028721491118945, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.5287678617828835, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.618595850218866}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.669026703845758}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.555615105736594}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.6593256320844346, 7.944492163932159}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6100682736896466, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.6240307955986357, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4912105310694506, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.475392057419415, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0891571298973546, 6.29156913955832}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.529318843261892, 1.9033008439609624}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.3524072174927233, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8305718564716175, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8305718564716175, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4126383364594925, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3691523372661587, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.376740148315079, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 2.647592232065096}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0, 0.7, 0], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.236923904465622}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.9474803442248305}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.7218733417638885}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9949325933834268, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.636577829072051, 7.24422751560335}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9240709191931175, 8.1797604936999}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4679383501604009, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.744604469176456, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.7177975525570903, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.557794679282262, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-32.34077434210908, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.340807418168989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.204382667431038, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-36.34119244432727, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.3418458069473482, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.605170185988091, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5191402744533198, 1.6882490928583902}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.725433722188183, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.813734143549063, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.7937956240634962, 1.6114359150967734}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.963188584855586}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.894078619827491, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.995732273553991, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.8195418502405067, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7435408969575807, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.017773404430871, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.653113060608557, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2016421889876536, 6.579251212010101}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.995732273553991, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.2406103170142067, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.5639866495301828, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-28.340907620492793, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.1921026317554486}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.820158943749753, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0604498275737608, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.3731931852525583, 1.860974538249528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.278964002683987, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.199705077879927, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.746403767507258, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9477043045434095, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-64.46739506232224, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.9178457348969196, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.907755278982137, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.522010001878903, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 0.9034081060431414}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0923241675108497, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 0.9543569326806114}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.4686200579795896, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.3492738284584218, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4118173183509766, 1.5973653311998313}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.4961092271270973, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.9368694044031642}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3025850929940455, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7306413849875258, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.040959012419865, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.283414346005772, 5.703782474656201}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6311724045801064, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0939232991819783, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7789229575813493, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0918353043890858, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-6.662458923026794, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0891571298973546, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.403677882205863, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.9696906777207166, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.1850957485562468}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.850570223130148, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.900458886151396, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1080567474961094, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.809109107563168, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.8146618624453594}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.166915255056936, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 2.647592232065096}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.047189562170502, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2815740503494875, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.779362064213738, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.443923473956527, 2.418588768750352}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              
              StyleBox[
               InsetBox["\<\"\[FilledDownTriangle]\"\>", 
                {-1.0498221244986778, 1.1499389158334503}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.0732944806838198}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.286478374605709, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.529318843261892, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8997902134417601, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.6888794541139363, 0.8505781885087738}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4850103340590484, 2.135349173618132}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.700587583759682, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.552112845814831, 5.8289456176102075}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.196377287787253, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 0.9329511727672622}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.552112845814831, 7.55171221535131}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-63.46698269688735, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.140893060599911, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.563430511492267, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.8344641259578687, 6.152732694704104}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.725332537920259, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.8056623743970464}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.5377270648801}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.399798360748448, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.536426440357718, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.536314386533157, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3257638613798584, 1.776645831418007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2595256035335987, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.5902550930173265}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-6.786422993814612, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.522010001878903, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.4407825464039603}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.184232881424661, 1.860974538249528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7573580425107227, 1.589235205116581}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.9028810449642375, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1214715828141923, 1.9387416595767009}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9840343839606746, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0027568884909557, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.715777948205427}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.8179208722379223, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.313415715707318, 2.498151876538021}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8097197946050478, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6544352783648362, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.6609757937162812, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.6888794541139363, 0.9669838461896731}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.2256240518579173, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.566911473871001, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.506518858426259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2669126040998102, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.993630885266725, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2016421889876536, 6.579251212010101}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.795734531747094, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.540842282118304, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 0.8450095298691913}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6149530931222105, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3649243353836982, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0029385385998273, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.995732273553991, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8195418502405067, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8940401229393353, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.084253098677058, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 0.9858167945227654}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.107781777362614, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.05211045501669, 7.55171221535131}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.5532907518110994}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3037931396081468, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3482281603134343, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.18777640747691846, 7.1929342212158}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.66341149948383, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8195418502405067, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.100765130025024, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.7042981934580606, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.6772785424354564, 6.309918278226516}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.49314943875304795, 6.887552571664617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              
              StyleBox[
               InsetBox["\<\"\[FilledUpTriangle]\"\>", 
                {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.3964921860963366}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.3261404383001434, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.807005375881994, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0417762120553977, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.786268646522262, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.708153885373258, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.5558971455060706, 2.3456445824544927}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.9634587130036953, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.864975531559314, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.9736550492637259, 1.9198594718553708}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.6888794541139363, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0808706071919527, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.716864386545305, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.406587064387653}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.8944568674663975, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8457617469776957, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.395133309787095, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0129050178795915, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0918353043890858, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.76705723517796, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.940782792197422, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.366940997255841, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9372477759766606, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.219163484854973, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.030116700415822, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.504420282887948, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.4847813078345447}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.567015866357096, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.8130574772325029, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.807796846925679}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.8162894669713328}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.2256240518579173, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.133013715385442}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6544352783648362, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.6744763086133228}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.2809338454620642}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.1622605067393605, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1150465951315345, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.5645401798583287, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.9670073137609054, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 0.7802418874108791}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.009386074695824, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.100386954332169, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.531088946023124, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2371849385320495, 1.9401794743463283}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.8006962066887295, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7129418078881248, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5173146235582946, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4179914478631452, 6.363028103540465}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.991862608772972, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.1151415906193203}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.6624240079171049, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5832829549572491, 1.5933085305042167}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.6825463842547386, 2.2648832258100344}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.509860006183766, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8933068954837797, 6.887552571664617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.344384958042681, 7.759614150696903}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7170231231140378, 6.063785208687608}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.795734531747094, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.475392057419415, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.8056623743970464}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7969533492855345, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.900422093749666, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2496677635880655, 6.131226489483141}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-37.34075273404506, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.0635829404621653, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7667937207282438, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3838972365201692, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.700587583759682, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.9518038754399907, 1.4973884086254774}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.5878866699024524, 7.1929342212158}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.2246985543369746, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.201916872261721, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.0497721232486361}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.019664337643975, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.7188583998188136, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.2170885989659, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.174191878225647, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.3039860739096736, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.4938666711595117, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.4122057429043917}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7199019178687649, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.5107219394949427}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.170932950247736}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.696151689580244, 6.684611727667927}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.612442421454399, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 0.9411784473819341}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.674083651538937, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.8442026554799011, 7.759614150696903}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.1167795926235586}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1199358770132974, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.2756420910162956}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.652827532407001, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.5432981099295553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              
              StyleBox[
               InsetBox["\<\"\[EmptySquare]\"\>", 
                {-2.0939462278827174, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4371455863897404, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.5257286443082556, 6.461468176353717}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.5920892740994874, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6149530931222105, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.437751649736401, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3528595850336531, 7.751045117971802}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2761851384398606, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.868484703413663, 1.501852701754163}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5082360319251331, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 0.9489515141137035}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8997902134417601, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.067986095126349, 2.3456445824544927}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164563795096671, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.4588475538015993}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.023439351564551, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.3418458069473482, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.3960099493374092, 6.984716320118266}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.6916833814466705, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.344384958042681, 7.759614150696903}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.319222734147069, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-27.341341040814093, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.2787091504399533}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.2602187884025833, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1150465951315345, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.662352421858305, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.251619457793289}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.500433550670171, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.036482917202561, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9563317814113389, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.8205261098897758, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.9165331609060323, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4203757208439185, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.1464364105041143, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6539264674066639, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3208812225716584, 2.0095554142156695}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.850570223130148, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8951219822232084, 5.886104031450156}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.744112815760702, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.5845302767279155}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.064355904261795, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0929041853062644, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.6939993778795506, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1270117631898076, 6.253828811575473}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.9754419516613513, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.273910668367863, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-40.340943771488284, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.662458923026794, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7960662345677868, 6.984716320118266}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.878196476740593, 1.7776605448485534}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.5960282255241827, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.3420861064555702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4912105310694506, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.036270701217564, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              
              StyleBox[
               InsetBox["\<\"\[FilledDownTriangle]\"\>", 
                {-0.7168253079145225, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7813228714636707, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.7317869551252127, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8078888511579385, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.007592890280941}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.8563722416629115, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.741015208534465, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.1760334356366946, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.8420006856648017, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.007679175452945, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1806171127511105, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.703510521060178, 1.8389610707123492}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 1.3302529702362658}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2437536743377806, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.4018530946527146, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3191210616341453, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.483987072728617, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.340556469446037, 6.040254711277414}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2069773133462347, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.144222799920162}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.2030071867437115, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0963149296194261, 6.684611727667927}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.912265434460023, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.8505029913361519, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3037931396081468, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3093333199837622, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.156840433948748, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.168928708181372, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.946310229076653, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-3.1958919884778254, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3093333199837622, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.8958869385842747, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.279055610450292, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.975450465015525, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0969137320325284, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.2299329059954676}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.9568962497687927, 1.7316555451583497}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.900422093749666, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9969586349416099, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.4312677267626217}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-71.46678568954108, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5173146235582946, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.68510181635509}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1304126012179074, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.6777417097034806, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.327296573822621, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.5779472453427295}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.2262184132732556, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-59.467094916063616, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.1413169453979233, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.786359562282124, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2595256035335987, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.168283961917429, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.7254100886865211, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2808538486618937, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2026403590921573, 2.0095554142156695}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.9122987106046175, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.216512196196308, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8195418502405067, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6888794541139363, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.5732134108799993, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.421661504957182}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}]
                ,
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.786422993814612, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5082360319251331, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.6298561136644754, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.395911377232918, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.8610265707016995, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.786268646522262, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.1269525243508878, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.3326298365341978}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4405393759722864, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.4907663827166018, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.6744763086133228}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.946310229076653, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.741858378904823, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.8947738884119054, 1.7316555451583497}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.30031936921871, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3149043650332175, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3811078344325904, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.000759888500605, 6.380122536899765}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640797356921787, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.4929837772928636, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.3281354469463584}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.475392057419415, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6798603767306461, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4296194858582643, 7.674152921281675}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.3504089023600859, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8773173575897015, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.152897360346143, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1958919884778254, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2437536743377806, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.795734531747094, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-39.34081340913477, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.1541650878757723, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.2367852454117685, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.8442026554799011, 7.759614150696903}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8016236568960291, 6.579251212010101}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0808706071919527, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.9910142780700916, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.781788039865368, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 0.7975071958841882}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.389499492068839, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.4146938356415886, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2069773133462347, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2361517026901712, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.7499665442035015, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.253208503948706, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.7788336680347445, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4007990473227723, 6.380122536899765}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.8528465593176202, 7.751045117971802}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.744604469176456, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.131032179924221, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.9754419516613513, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.740861482897622, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.30031936921871, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5228016057745537, 5.857933154483459}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 0.8989410935390421}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.8505029913361519, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3005870903313728, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.660097652688484, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.693851481702397, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1026203100656484, 2.2648832258100344}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.599488434143067, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0592954262911594, 6.721425700790643}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 0.766397642299538}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.1308988302963465, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.941966881801218, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.028919972120757, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0261055978813616, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.30031936921871, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.162319869424133, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.600902459542082, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.6504282677396835, 1.5432981099295553}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.8006962066887295, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.4753441779534016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.101092789211817, 0.911479174876933}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.145857732131629, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9146052992269007, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.4532518292447716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.7317869551252127, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.23395175003081314, 7.146772179452637}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.900588627802483, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.4018530946527146, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0277811079075183, 1.9768549529047348}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9372477759766606, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3470736479666092, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.1780394222994315}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.5539252025038417}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.5159350591325786, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3993162819538174, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5782126424678459, 1.5432981099295553}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8097197946050478, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.252691173362931, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.350408373771412, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.975450465015525, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.5895081458004594, 6.7912214627261855}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9038682118755978, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.219163484854973, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.336815122732887, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.1966460289394751}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.319222734147069, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1796551117149194, 1.4906543764441336}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.902818692021688, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1663559407546291, 6.214608098422191}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.6339353209280992, 7.146772179452637}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.8269722249837996, 2.1825620503943153}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.94874563428772, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2736802167507564, 6.507277712385012}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9896682016789307, 6.7912214627261855}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 0.8307328435125084}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.421604191439818, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.926205565780978, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.912330925723864, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8734707346912269, 6.507277712385012}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.7188583998188136, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.2739976361421332, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.412382827063892, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.66442222076686, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.8610265707016995, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.2908841763152323}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyDiamond]\"\>", 
                {-1.1080567474961094, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.5432981099295553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.3109197297841035, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.912330925723864, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.9005275521158795, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7168253079145225, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.744112815760702, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.7148128361404407, 1.4996230464268938}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.449925680892755, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.376740148315079, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-7.284632930238389, 1.6094379124341003}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.036311444023319, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.3504089023600859, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 6.684611727667927}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.2256240518579173, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.0738571633859353, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 1.1990607599649155}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.606235808570649, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8997902134417601, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.48175237628028356, 8.122074375362217}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 0.9290095042819297}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.7254100886865211, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.21678878567620194, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.5732134108799993, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.340556469446037, 6.040254711277414}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0592954262911594, 6.721425700790643}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.327853987437946, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5901256014017275, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8830977645183911, 6.897704943128636}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.57270299585059, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-3.1958919884778254, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.991862608772972, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 0.9925107577855641}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2282654968949804, 6.152732694704104}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.0654001544619962}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.3003570667360838, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.9296292963133357, 7.674152921281675}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.48304834276654407, 6.897704943128636}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-3.1958919884778254, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4371455863897404, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 0.898534010284896}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 0.8028980445190645}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-62.46685674510361, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.15218556191195, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.500433550670171, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.700547258981618, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 0.9345235001352147}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.319222734147069, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.746403767507258, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.604906020337758, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.2170885989659, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3649243353836982, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.5332441625824873, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.017406150760383, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.6003175012993283, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              
              StyleBox[
               InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.95263269481614, 7.151485463904735}],\

               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.984131361875511, 7.003065458786462}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.6960857191597725, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1279381180499384, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.1406850650900175, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.8505029913361519, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1796054478776414, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.4370318346713713, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5173146235582946, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.322289031143978}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.160913314865489, 6.620073206530356}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1199380753828623, 2.065596134857783}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.319222734147069, 6.784457062637643}]
                ,
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.082935809283102, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6798603767306461, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.5136732904497212, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640797356921787, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2406367886975274, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.1269525243508878, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              
              StyleBox[
               InsetBox["\<\"\[FilledUpTriangle]\"\>", 
                {-0.9816295731824954, 8.122074375362217}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.362224007377702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.710307401527557, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.0794415416798357, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.95263269481614, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.57270299585059, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.1541650878757723, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.11206147220931, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.4226262903672808}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.270169119255751, 1.6272778305624314}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0177699008240089, 6.363028103540465}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.0598714603516792}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.802272141469027, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.064355904261795, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.6593256320844346, 6.721425700790643}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.909388227079972, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.3082536360194172, 1.4929040961781488}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.424056675808238, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.900588627802483, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.4122057429043917}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.350408373771412, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.609379030762146, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\[FivePointedStar]", {-3.0957736277342174, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1230074455028314, 2.1825620503943153}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.1597073880279205}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164563795096671, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.5005758256424344, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1796054478776414, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2330583852210326, 7.8709295967551425}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.6302332586812027, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.5740001929819547, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.781788039865368, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.362224007377702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.946310229076653, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.60100614381313, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 1.0678093795130645}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.191191469961203}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7607838292757566, 6.620073206530356}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164563795096671, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8871696540327132, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.541256860244439, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8337895103624113, 6.946975992135418}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.140807436632442, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.018486244188825}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.3428059215206005, 2.6490076604684267}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3993162819538174, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-7.523941418405954, 1.497835735852798}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2045513527226803, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.0289048762432895}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8195418502405067, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.2255369822417765, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6149530931222105, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.10045059841862, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.6593256320844346, 6.721425700790643}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\[FivePointedStar]", {-3.2957568692041583, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.000759888500605, 6.380122536899765}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.1499389158334503}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1080567474961094, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9038682118755978, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.75, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.2809338454620642}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.5016459737922982, 1.9198594718553708}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.75, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 0.766397642299538}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.941966881801218, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.1603343472961065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.036311444023319, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.286478374605709, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.2917089186300228}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.4338645826298623, 6.946975992135418}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.1308988302963465, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.0281898243715637}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.1308988302963465, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3993162819538174, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7903190923122189, 1.6272778305624314}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyDownTriangle]\"\>", 
                {-3.5005758256424344, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4460443655256647, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.744604469176456, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640797356921787, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 0.9364854391596744}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 0.8977193462887197}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.607650686531799, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8097197946050478, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-9.567158183262826, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.4753441779534016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.600902459542082, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.101092789211817, 0.7802418874108791}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.064355904261795, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.15218556191195, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.571283042360924, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.100426344668657, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.622553707074063, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.7329280505717899, 7.8709295967551425}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.0580715159436433, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.162319869424133, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.3434070875143007, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.064355904261795, 2.065596134857783}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6311724045801064, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 0.8055826098897335}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-7.819058469345253, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyUpTriangle]\"\>", 
                {-1.8097197946050478, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4460443655256647, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8773173575897015, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.247228312996893, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.214608098422191, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.600902459542082, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.3137523001849649, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.2255369822417765, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2815740503494875, 7.822444729489319}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.030860186617291, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5901256014017275, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7199019178687649, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6149530931222105, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.813734143549063, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9631203192309531, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.66442222076686, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.900346940202133, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-8.05031945517943, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8997902134417601, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.017406150760383, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.360956006320375, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.333559897293476, 1.9768549529047348}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.793961892783255, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.8006962066887295, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5629964960949002, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-8.403864506109235, 1.0698698198024557}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.1892564076870427, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.017406150760383, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.5077842587076005, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.8469979053782056, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.400308181522661, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8773173575897015, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1150465951315345, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8457617469776957, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-60.466869255317796, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.344384958042681, 7.759614150696903}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2201021862558195, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1150465951315345, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.007592890280941}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.8906229851255774, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.1062413158326008, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.196377287787253, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7813228714636707, 7.822444729489319}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.3003570667360838, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0898959995836948, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3093333199837622, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.6003175012993283, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4460443655256647, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.813734143549063, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.5005758256424344, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.900422093749666, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5901256014017275, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2936253516225737, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0898959995836948, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.66442222076686, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.3137523001849649, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.659260036932778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7062324201086008, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5901256014017275, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.946310229076653, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3993162819538174, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.746969987257452, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.10045059841862, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.145857732131629, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.376740148315079, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-8.685611843041201, 0.9360933591703348}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.900588627802483, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.946310229076653, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              
              StyleBox[
               InsetBox["\<\"\[EmptyDownTriangle]\"\>", 
                {-4.900346940202133, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2201021862558195, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.300630996469888, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.017406150760383, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.945799904805782, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.659260036932778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8442026554799011, 7.759614150696903}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2815740503494875, 7.822444729489319}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.100765130025024, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.659260036932778, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.045763207159556, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5173146235582946, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7199019178687649, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.659260036932778, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4460443655256647, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.344384958042681, 7.759614150696903}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7813228714636707, 7.822444729489319}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-61.467195171508536, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.100426344668657, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-8.955698153602603, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.300630996469888, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.700547258981618, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8442026554799011, 7.759614150696903}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.100765130025024, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0.5, 0.75], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.900346940202133, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.400308181522661, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.70036037299184, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-54.46678982836, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.500810170663849, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.300630996469888, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.400308181522661, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.70036037299184, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.500810170663849, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0., 0., 0.7], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}}}, {}},
          AspectRatio->1.,
          Axes->False,
          AxesLabel->{None, None},
          AxesOrigin->{0, 0},
          BaseStyle->{FontFamily -> "Helvetica", 16},
          DisplayFunction->Identity,
          Epilog->{{
             InsetBox[
              FormBox[
               StyleBox["\"Npt: 3920\"", 16, 
                GrayLevel[0], StripOnInput -> False], TraditionalForm], 
              Scaled[{0.1, 0.9}]]}, {{
              InsetBox[
               FormBox[
                StyleBox["\"Npt: 3920\"", 16, 
                 GrayLevel[0], StripOnInput -> False], TraditionalForm], 
               Scaled[{0.1, 0.9}]]}}},
          Frame->True,
          FrameLabel->{
            FormBox[
             StyleBox["\"x\"", 18, 
              GrayLevel[0], StripOnInput -> False], TraditionalForm], 
            FormBox[
             StyleBox["\"\[Mu] [GeV]\"", 18, 
              GrayLevel[0], StripOnInput -> False], TraditionalForm]},
          FrameTicks->{{{-13.815510557964274`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.512925464970229`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.210340371976182, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.605170185988091, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.3025850929940455`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
              FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
             0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.791759469228055, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.302585092994046, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.0943445622221, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.248495242049359, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.382026634673881, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.499809670330265, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.605170185988092, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.703782474656201, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.991464547107982, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.396929655216146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.551080335043404, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.684611727667927, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.802394763324311, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.006367567650246, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.294049640102028, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.699514748210191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.987196820661973, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.104979856318357, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.210340371976184, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.308952660644293`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.596634733096073`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.002099841204238`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.156250521031495`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.289781913656018`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.407564949312402`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}}, {{-13.815510557964274`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.512925464970229`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.210340371976182, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.605170185988091, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.3025850929940455`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
              FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
             0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.791759469228055, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.302585092994046, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.0943445622221, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.248495242049359, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.382026634673881, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.499809670330265, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.605170185988092, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.703782474656201, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.991464547107982, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.396929655216146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.551080335043404, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.684611727667927, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.802394763324311, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.006367567650246, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.294049640102028, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.699514748210191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.987196820661973, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.104979856318357, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.210340371976184, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.308952660644293`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.596634733096073`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.002099841204238`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.156250521031495`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.289781913656018`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.407564949312402`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}}, {{-13.815510557964274`, 
              FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
              FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
              FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
              FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
              FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm]}, {0., 
              FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
              FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
              FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
              FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
              FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
              FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
              FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
              FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
              FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
              FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
              FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
              FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
              FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
              FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
              FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
              FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
              FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
              FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
              FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
              FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
              FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
              FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
              FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
              FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
              FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
              FormBox["\"\"", TraditionalForm]}}, {{-13.815510557964274`, 
              FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
              FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
              FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
              FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
              FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm]}, {0., 
              FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
              FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
              FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
              FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
              FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
              FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
              FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
              FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
              FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
              FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
              FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
              FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
              FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
              FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
              FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
              FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
              FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
              FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
              FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
              FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
              FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
              FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
              FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
              FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
              FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
              FormBox["\"\"", TraditionalForm]}}},
          FrameTicksStyle->GrayLevel[0],
          
          GridLines->
           NCache[{{-16.11809565095832, -13.815510557964274`, \
-11.512925464970229`, -9.210340371976182, -6.907755278982137, \
-4.605170185988091, -2.3025850929940455`}, {
              Log[10], 
              Log[50], 
              Log[100], 
              Log[500], 
              Log[1000], 
              Log[5000], 
              Log[
              10000]}}, {{-16.11809565095832, -13.815510557964274`, \
-11.512925464970229`, -9.210340371976182, -6.907755278982137, \
-4.605170185988091, -2.3025850929940455`}, {2.302585092994046, 
            3.912023005428146, 4.605170185988092, 6.214608098422191, 
            6.907755278982137, 8.517193191416238, 9.210340371976184}}],
          GridLinesStyle->Directive[
            Dashing[{Small, Small}]],
          ImagePadding->All,
          ImageSize->{{600}, {600}},
          Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& )}},
          PlotLabel->None,
          PlotRange->NCache[{{-Log[100000], 0}, {0, 
              Log[6000]}}, {{-11.512925464970229`, 0}, {
             0, 8.699514748210191}}],
          PlotRangeClipping->True,
          PlotRangePadding->{{0, 0}, {0, 0}},
          Ticks->{Automatic, Automatic}], Scaled[{0.5, 0.5}], Center, 
         Scaled[{1, 1}]], InsetBox[
         TemplateBox[{FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   StyleBox["\"\"", {FontSize -> 14, 
                    GrayLevel[0], FontFamily -> "Arial"}, Background -> 
                    Automatic, StripOnInput -> False]}, {
                   GraphicsBox[{{}, {}, 
                    
                    RasterBox[{{{0., 0., 0.7}}, {{0., 0., 0.7}}, {{0., 0.5, 
                    0.75}}, {{0., 0.75, 0.75}}, {{0., 0.7, 0.}}, {{0.75, 0.75,
                     0.}}, {{0.75, 0.55, 0.}}, {{0.7, 0., 0.}}, {{0.7, 0., 
                    0.}}}, {{
                    Rational[-15, 2], 
                    Rational[-225, 2]}, {
                    Rational[15, 2], 
                    Rational[225, 2]}}], {Antialiasing -> False, 
                    AbsoluteThickness[0.1], 
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]], 
                    LineBox[
                    NCache[{{
                    Rational[15, 2], 
                    Rational[-225, 2]}, {
                    Rational[-15, 2], 
                    Rational[-225, 2]}, {
                    Rational[-15, 2], 
                    Rational[225, 2]}, {
                    Rational[15, 2], 
                    Rational[225, 2]}, {
                    Rational[15, 2], 
                    Rational[-225, 2]}}, {{
                    7.5, -112.5}, {-7.5, -112.5}, {-7.5, 112.5}, {7.5, 
                    112.5}, {7.5, -112.5}}]]}, {
                    CapForm[None], {}}, {Antialiasing -> False, 
                    StyleBox[
                    LineBox[{{7.5, -112.49999999999999`}, {7.5, 
                    112.49999999999999`}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.5, -87.50000000000001}, 
                    Offset[{4., 0}, {7.5, -87.50000000000001}]}, {{
                    7.5, -62.500000000000014`}, 
                    Offset[{4., 0}, {7.5, -62.500000000000014`}]}, {{
                    7.5, -37.50000000000001}, 
                    Offset[{4., 0}, {7.5, -37.50000000000001}]}, {{
                    7.5, -12.500000000000021`}, 
                    Offset[{4., 0}, {7.5, -12.500000000000021`}]}, {{7.5, 
                    12.499999999999988`}, 
                    Offset[{4., 0}, {7.5, 12.499999999999988`}]}, {{7.5, 
                    37.49999999999999}, 
                    Offset[{4., 0}, {7.5, 37.49999999999999}]}, {{7.5, 
                    62.499999999999964`}, 
                    Offset[{4., 0}, {7.5, 62.499999999999964`}]}, {{7.5, 
                    87.49999999999997}, 
                    Offset[{4., 0}, {7.5, 87.49999999999997}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-3.0000\"", -3., AutoDelete -> True],
                     NumberForm[#, {
                    DirectedInfinity[1], 4}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -87.50000000000001}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-1.0000\"", -1., AutoDelete -> True],
                     NumberForm[#, {
                    DirectedInfinity[1], 4}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -62.500000000000014`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    "\"-0.3333\"", -0.3333333333333333, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -37.50000000000001}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    "\"-0.1111\"", -0.1111111111111111, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -12.500000000000021`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    "\"0.1111\"", 0.1111111111111111, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 12.499999999999988`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    "\"0.3333\"", 0.3333333333333333, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 37.49999999999999}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"1.0000\"", 1., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 62.499999999999964`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"3.0000\"", 3., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 87.49999999999997}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1], FontSize -> 14, 
                    GrayLevel[0]]}, StripOnInput -> False]}, {}}, {
                    Directive[
                    Opacity[1], FontSize -> 14, 
                    GrayLevel[0]]}, StripOnInput -> False], "GraphicsLabel", 
                    StripOnInput -> False]}, "GraphicsTicks", StripOnInput -> 
                    False], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                    Scaled[0.02], PlotRange -> All, Frame -> True, 
                    FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                    Opacity[0], FrameTicksStyle -> Opacity[0], 
                    ImageSize -> {Automatic, 225}, BaseStyle -> {}, 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}]}}, 
                 GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontSize -> 14, 
              GrayLevel[0], FontFamily -> "Arial"}, Background -> Automatic, 
             StripOnInput -> False], TraditionalForm]},
          "BarLegend",
          DisplayFunction->(#& ),
          InterpretationFunction:>(RowBox[{"BarLegend", "[", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0., 0., 0.7], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0., 0.4666666666666667], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0., 0., 0.7]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0., 0., 0.7]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0., 0., 0.7], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0., 0., 0.7], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0., 0.4666666666666667], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0., 0., 0.7]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0., 0., 0.7]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0., 0., 0.7], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0., 0.5, 0.75], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0., 0.33333333333333337`, 0.5], FrameTicks -> 
                    None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0., 0.5, 0.75]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0., 0.5, 0.75]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0., 0.5, 0.75], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0., 0.75, 0.75], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0.5, 0.5], FrameTicks -> 
                    None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0., 0.75, 0.75]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0., 0.75, 0.75]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0., 0.75, 0.75], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0, 0.7, 0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0.4666666666666667, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0, 0.7, 0]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0, 0.7, 0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0, 0.7, 0], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.75, 0.75, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.5, 0.5, 0.], FrameTicks -> 
                    None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.75, 0.75, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.75, 0.75, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.75, 0.75, 0.], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.75, 0.55, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.5, 0.3666666666666667, 0.],
                     FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.75, 0.55, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.75, 0.55, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.75, 0.55, 0.], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0., 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.4666666666666667, 0., 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0., 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0., 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0., 0.], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0., 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.4666666666666667, 0., 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0., 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0., 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0., 0.], Editable -> False, Selectable -> 
                    False]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "3.006`"}], ",", "3.006`"}], "}"}]}], "}"}], 
               ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "3.006`"}], ",", 
                   RowBox[{"-", "3.`"}], ",", 
                   RowBox[{"-", "1.`"}], ",", 
                   RowBox[{"-", "0.3333333333333333`"}], ",", 
                   RowBox[{"-", "0.1111111111111111`"}], ",", 
                   "0.1111111111111111`", ",", "0.3333333333333333`", ",", 
                   "1.`", ",", "3.`", ",", "3.006`"}], "}"}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"FontSize", "\[Rule]", "14"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False]}], 
                   "}"}]}], ",", 
               RowBox[{"LegendLabel", "\[Rule]", "\"\""}], ",", 
               RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
               RowBox[{"LegendMarkerSize", "\[Rule]", 
                 RowBox[{"{", "}"}]}], ",", 
               RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
               RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
               RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], 
             "]"}]& )], Scaled[{1., 0.5}], ImageScaled[{0, 0.5}],
         BaseStyle->{FontSize -> Larger},
         FormatType->StandardForm]},
       AspectRatio->1.,
       Axes->False,
       AxesLabel->{None, None},
       AxesOrigin->{0, 0},
       BaseStyle->{FontFamily -> "Helvetica", 16},
       DisplayFunction->Identity,
       Frame->False,
       FrameLabel->{
         FormBox[
          StyleBox["\"x\"", 18, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         FormBox[
          StyleBox["\"\[Mu] [GeV]\"", 18, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm]},
       FrameTicks->{{{-13.815510557964274`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.02375108873622, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.86960040890896, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.512925464970229`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.903487552536127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.721165995742174, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.567015315914915, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.433483923290392, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.315700887634009, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.210340371976182, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-8.111728083308073, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.824046010856292, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.600902459542082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.418580902748127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.264430222920869, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.013115794639964, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-6.907755278982137, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.809142990314028, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.521460917862246, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.298317366548036, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.115995809754082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.961845129926823, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.710530701645918, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.605170185988091, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.506557897319982, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.995732273553991, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.659260036932778, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.3025850929940455`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-1.203972804325936, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.916290731874155, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
           FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
          0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.302585092994046, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.605170185988092, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.907755278982137, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.210340371976184, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}}, {{-13.815510557964274`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.02375108873622, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.86960040890896, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.512925464970229`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.903487552536127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.721165995742174, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.567015315914915, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.433483923290392, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.315700887634009, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.210340371976182, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-8.111728083308073, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.824046010856292, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.600902459542082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.418580902748127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.264430222920869, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.013115794639964, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-6.907755278982137, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.809142990314028, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.521460917862246, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.298317366548036, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.115995809754082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.961845129926823, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.710530701645918, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.605170185988091, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.506557897319982, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.995732273553991, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.659260036932778, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.3025850929940455`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-1.203972804325936, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.916290731874155, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
           FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
          0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.302585092994046, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.605170185988092, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.907755278982137, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.210340371976184, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}}, {{-13.815510557964274`, 
           FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
           FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
           FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
           FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
           FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
           FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
           FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
           FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
           FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
           FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
           FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
           FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
           FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
           FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
           FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
           FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
           FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
           FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
           FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
           FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
           FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
           FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
           FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm]}, {0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
           FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm]}}, {{-13.815510557964274`, 
           FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
           FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
           FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
           FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
           FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
           FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
           FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
           FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
           FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
           FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
           FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
           FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
           FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
           FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
           FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
           FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
           FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
           FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
           FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
           FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
           FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
           FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
           FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm]}, {0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
           FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm]}}},
       FrameTicksStyle->GrayLevel[0],
       ImagePadding->All,
       ImageSize->{{600}, {600}},
       Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
             (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
              Part[#, 1]], 
             (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
              Part[#, 2]]}& ), "CopiedValueFunction" -> ({
             (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
              Part[#, 1]], 
             (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
              Part[#, 2]]}& )}},
       PlotLabel->FormBox[
         StyleBox["\"Sensitivity to g(x,\[Mu]), CT14NNLO\"", 24, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm],
       PlotRange->Automatic,
       PlotRangeClipping->False,
       PlotRangePadding->{{0, 0}, {0, 0}},
       Ticks->{Automatic, Automatic},
       ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]],
      InterpretTemplate[Legended[
        Graphics[{{{}, {{{}, {
              Hue[0.67, 0.6, 0.6], 
              Directive[
               PointSize[0.012833333333333334`], 
               AbsoluteThickness[1.6], FontFamily -> "Helvetica", 
               GrayLevel[1]], 
              
              Point[{{0.00001, 2.}, {0.99, 
               1200.}}]}, {}}}, {}, {}, {{}, {}}}, {
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262403303361214, 6.841615476477592}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3118381623295401, 2.6993457604720636`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6039529822035308`, 2.6993457604720636`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.47352983902229373`, 2.599722324216582}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.3348410795309749`, 2.58851563240702}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3716028123769008`, 
             2.187174241482718}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3134438363289216`, 1.534714366238164}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.18765575838465653`, 2.6224923127405635`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.57270299585059, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.3960170377865984`, 6.907755278982137}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.5922917535991299`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.3749057545736716`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.15455075984859803`, 2.5756610130564646`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.880084850028029, 5.723585101952381}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2569588998089404, 2.0731719286662407`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.8027388571900397, 2.58851563240702}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7064996252772315`, 
             2.3523271848888596`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0091694886945044`, 2.5756610130564646`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 2.2976730486330252`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.797175250983993, 2.512035317176253}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.6529653909271136, 2.506341930508065}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.416581053724763}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.33687231664255274`, 1.937301774518713}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3138891646209549, 2.5862591440482876`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-8.421883011611913, 1.2424239907001886`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.599387576580599}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.919365593833201, 6.684611727667927}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.4886252922173524`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7505644514298959, 2.5817308344235403`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8701230510291479, 
             2.58851563240702}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.517264565896126, 2.0068708488450007`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4422299934501939`, 
             2.0162354657760435`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.1862091035211472, 2.423031246069913}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             1.0511712140679732`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4159291662495814`, 
             2.0425181875752383`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.4722426732562555`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.3205066205818874`, 7.783224016336037}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.215506040139609}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6266106567597011, 2.4265710727750367`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 1.2184672504763885`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.227106951818089}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0564152399683213`, 
             2.702032128776647}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.318612854071243, 2.005525858729668}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6977577931176286, 2.4265710727750367`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.1454883067486056, 2.432735777459091}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.199705077879927, 0.755182571479398}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.2672179491567546`, 4.386889790339869}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3645328693383778`, 
             2.494031557565001}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 2.296667619230008}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9329283730271782, 
             2.425687290128029}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2149273965428693, 2.519308076505333}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3528595850336531`, 7.751045117971802}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.49397078181451, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4184044150381243`, 
             2.1400661634962708`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.6564295976247825, 
             2.702032128776647}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8627499649461253, 1.6956156086751528`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.539739633930633, 2.5974910105351463`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.5859645562484583`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 2.1587147225743437`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.516892795645856, 6.0867747269123065`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-4.217869048507598, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5898688311064436, 2.506341930508065}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.764428382564909, 
             2.494031557565001}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.2072749131897207`, 6.396929655216146}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-5.809142990314028, 1.2424239907001886`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6414447085691868`, 2.599722324216582}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.304161419150561, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.312220927289192, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.462149662665384}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.8528465593176202, 7.751045117971802}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1464364105041143`, 5.634789603169249}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.1564532883579597`, 6.674561391814426}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.694093021166824, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.4395981331422016`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.3749057545736716`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 2.0719132752590443`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.9139271032022627`, 7.090076835776092}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.536426440357718, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.8763491247812073, 2.503891949699081}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1409980051645476`, 
             4.512945241945574}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.090999490513565}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4082690354408987, 1.860974538249528}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3943265328171548`, 
             2.1644717908644115`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1307223425863433`, 
             2.827905162910489}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.36154392105023625`, 2.599722324216582}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.176833887688485, 1.8625285401162623`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.82821600623867, 2.5862591440482876`}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.4854489341097463`, 5.768320995793772}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.6389967146756448`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7627116439458544, 1.6974487897568136`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.491654876777717, 1.599387576580599}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.4018530946527146`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-7.1308988302963465`, 
             1.2424239907001886`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0189110419398038`, 6.584791392385716}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.695775840226822, 
             5.991464547107982}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.2576117273513145`, 1.691939133945844}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.676945820702642, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.227106951818089}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4007990473227723`, 2.5817308344235403`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.7756596021344095, 2.418588768750352}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3903023825174294`, 
             2.0681277817795625`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6873994539038122`, 
             2.3711778844596574`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.4079456086518722`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3563472847519384`, 2.3850863145057892`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.013077000561847, 6.81783057145415}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.5299617109323036`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.6854573524495757`, 5.768320995793772}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-4.7177791303707455`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1880994551696458`, 2.3850863145057892`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.5338519254775054`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6691879168398742`, 
             2.3896797998449792`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4947708374559745`, 5.886104031450156}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.911914268349973, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7174398731289899, 2.5087859235779435`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.1136189934814222`, 7.090076835776092}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6064191770501212, 2.5877640352277083`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.6747180450915782, 2.58851563240702}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6149530931222105`, 7.488852955733459}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8644101099971662, 
             2.494031557565001}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4182464424728975, 2.6019486702196644`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.807005375881994, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 2.2927367569392314`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5235731965884932, 2.50470927708418}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9715392061046336, 1.6956156086751528`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.7042981934580606`, 5.676753802268282}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.218243944560295, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.894183087299815, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.18260159600127354`, 2.136530508663963}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.2876820724517809, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.6003175012993283`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.300710797475603, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4409617624621989`, 
             2.1174596088673567`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.257346872655708, 2.0028304393079956`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.312220927289192, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.491654876777717, 2.227106951818089}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3005870903313728`, 5.480638923341991}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.836849948493799, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-5.159425367681418, 4.0943445622221}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.40649706843741, 
             2.3523271848888596`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.06016413371338, 5.393627546352362}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.19455609446229716`, 2.0706530356467567`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.0966102859974367`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.532062329207643, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-5.504112279527633, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9689006821464524, 
             2.3896797998449792`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6044503709230613`, 6.999422467507961}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.881903019081021, 2.6224923127405635`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.0841264243165862`, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.7027460895677522`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.659260036932778, 1.0845133642886082`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.781788039865368, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-5.234028876665675, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-4.8178684794407625`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.362224007377702, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.256670593326385, 
             2.702032128776647}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1062413158326008`, 
             2.3523271848888596`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.0365602553118024, 7.24422751560335}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8701230510291479, 
             2.58851563240702}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.3178664036290963, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.8438952236485835`, 5.537334267018537}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.25154302583590776`, 2.130609828254235}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2010151992412087, 2.0082140323914683`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.911914268349973, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0996442489973552`, 1.6956156086751528`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4653375684603434`, 
             2.0930978681273213`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-4.0941445822194344`, 4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.9999411183280458`, 6.253828811575473}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.469241281940817, 
             1.9892432737616872`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.9317114296555002`, 6.672032945461067}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.461401833606696}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.410950117672171, 4.969813299576001}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820086052689358`, 6.921658184151129}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.3226876816505963, 2.005525858729668}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2854179707987138, 2.4997952622817508`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.1269525243508878`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.8643901602629624`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.3286906908754075`, 5.075173815233827}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1564532883579597`, 
             2.702032128776647}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.475327636634016, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5366522427084526`, 7.56734567601324}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.090999490513565}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.922779731666459, 5.857933154483459}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.804781390061982, 6.298949246855942}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.215506040139609}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.227106951818089}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.017383521085972, 0.986935571443487}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.968974088653865, 1.803358605071407}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.2876820724517809, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3983669423541598`, 
             1.9600947840472698`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0129050178795915`, 5.768320995793772}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9699552564598479, 
             2.58851563240702}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.225346881840062, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2453891602615295, 2.424802725718295}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5716605481000705`, 
             2.187174241482718}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.30348549823721, 2.432735777459091}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.017383521085972, 0.8385453832493022}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 1.416581053724763}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.770028224895903, 
             2.58851563240702}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.104554242494911, 5.676753802268282}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.41779075779880137`, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.836849948493799, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.1413169453979233`, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 1.416581053724763}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9317114296555002`, 1.534714366238164}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316692464055834`, 6.672032945461067}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.3749057545736716`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-5.093908213290077, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3874950816964096`, 
             2.3711778844596574`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3688474475161698`, 
             2.3896797998449792`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.4159777803491362`, 2.0082140323914683`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.522010001878903, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-4.318488613869894, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-42.34081632550436, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 2.0766877534832147`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.594056810395798, 
             2.1644717908644115`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4714166145367258`, 
             7.6324011266014535`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3413209954771594`, 
             2.1174596088673567`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6492187824459448`, 2.506341930508065}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2496677635880655`, 6.131226489483141}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.2178763245351174`, 4.386765389021055}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-4.382026634673881, 0.8046885552928528}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4903224315439383`, 
             2.0681277817795625`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6667000105450971, 1.6974487897568136`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.3732221725934863`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.26683423993894284`, 
             4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 2.28401370740861}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4934342366777942`, 2.512035317176253}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             1.8359358315608838`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.463458318582131, 6.040254711277414}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.225346881840062, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-6.541030999190403, 
             4.512945241945574}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.2533450600473311, 8.350429973538136}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 2.075809955445786}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5705756281717647, 1.7817091333745536`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.987249820814649, 
             2.3711778844596574`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 2.090999490513565}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8328691237350826, 
             2.425687290128029}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5601909533113197, 2.423031246069913}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.46013250945047257`, 2.512035317176253}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8689301605143175, 
             2.3896797998449792`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.5356434782150785`, 5.768320995793772}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.7317869551252127`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.0975128932248088`, 8.006367567650246}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.462149662665384}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.091798316674432, 4.386889790339869}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.006215439402142, 
             2.3523271848888596`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.2072749131897207`, 6.396929655216146}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.2568373311553196`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4943251053335957`, 
             2.1644717908644115`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4943251053335957`, 
             2.1644717908644115`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.228790658775024, 5.075173815233827}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262403303361214, 6.841615476477592}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.9245405804618736`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4983438649285135`, 
             1.9600947840472698`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5188771693591536`, 6.584791392385716}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.0968250627658085`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.468806782694355, 
             2.3896797998449792`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6713133161521878`, 
             2.187174241482718}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-0.5974734304916628, 8.006367567650246}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.209094749906707, 2.0082140323914683`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.3027280306570521, 2.419478844465545}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.462149662665384}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9063404010209869, 
             2.3523271848888596`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.735370011757173, 5.768320995793772}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7538858167999734`, 2.599722324216582}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3186357126460757`, 
             2.1400661634962708`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.369240606554063, 
             1.9892432737616872`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5064301623598713`, 
             2.3523271848888596`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.278818960372969, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.087375656742122, 
             2.3711778844596574`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.227106951818089}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3657077275115024`, 
             2.0930978681273213`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 0.9654617758806044}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6338708029279587`, 1.937301774518713}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.348592493935879}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.15218556191195, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 2.253709925211909}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.3504080825554816`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.184789984909162}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-4.617850239145466, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.412288358086009, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.489435120039404, 6.29156913955832}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.746403767507258, 5.634789603169249}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.5920892740994874`, 
             4.386889790339869}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-4.908846148194222, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4911864085136422, 1.7850704810772584`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.5178502387029551, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.606442403454302, 
             2.3523271848888596`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.6094379124341003`, 7.3777589082278725`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.6218266343535928`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8773173575897015`, 7.226936018493289}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-57.46750061412042, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.579879110192556, 2.5974910105351463`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.090999490513565}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.33589240475620386`, 2.502255288122613}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.197324582336553, 1.9401794743463283`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.227106951818089}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.104554242494911, 6.999422467507961}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.2876820724517809, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 2.090999490513565}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.9334368907091256, 1.8389610707123492`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 0.9150900112976361}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4714166145367258`, 
             2.187174241482718}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4714166145367258`, 
             2.187174241482718}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.991862608772972, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.5978370007556204, 2.647592232065096}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4329667693183212`, 
             2.425687290128029}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.069887328875024, 1.9416152247724325`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.3681303904922195`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.3749057545736716`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-0.9975007872996983, 8.006367567650246}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             1.2172838183856083`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7813228714636707, 7.822444729489319}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 2.0759354023505483`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4876628555081794`, 
             2.3711778844596574`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4159291662495814`, 
             2.0425181875752383`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.290620611051608, 
             2.0681277817795625`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9110235456270366`, 2.0731719286662407`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.491654876777717, 2.090999490513565}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.359873830032749, 4.0943445622221}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.0218709311636855`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3657077275115024`, 
             2.0930978681273213`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.270112606830481, 
             2.58851563240702}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.4911047254722358`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3716028123769008`, 
             2.187174241482718}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.271538123821702, 
             2.187174241482718}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.9093711079059474`, 6.194405391104672}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.090999490513565}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.5338519254775054`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2740421867477461, 2.5771819258971713`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4184044150381243`, 
             2.1400661634962708`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-44.34079097851618, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-5.0040073078060345`, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2306590695884416`, 
             2.827905162910489}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.462149662665384}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.215490386143112, 1.6114359150967734`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 2.0215475632609334`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.2788685663767296`, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.4079456086518722`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.6661962462527091`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3943265328171548`, 
             2.1644717908644115`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-4.083998270167957, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3983901944362025, 1.9358598132018119`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 1.4964931534179662`}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-8.666853965970644, 4.386889790339869}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7406861990440543`, 6.040254711277414}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0564152399683213`, 
             2.702032128776647}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8807977354618917`, 1.4883995840570443`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.6526889544284153`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[$CellContext`\[FivePointedStar], {-1.068859330518762, 
             2.3896797998449792`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-7.957577403480815, 1.445270566220188}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.153303390278291, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3180038323381698, 2.0731719286662407`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-5.767041814295392, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-5.817847430944174, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.316022308134559, 
             2.0425181875752383`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.5824869781268642`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-51.46677778703915, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.3302529702362658`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             2.6397713603489157`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.162823150618887, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-5.058828136697741, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2942622756733968`, 
             2.1644717908644115`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7958982916754054`, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5186835491656363`, 
             2.1400661634962708`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5186835491656363`, 
             2.1400661634962708`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-30.340822850069564`, 4.512945241945574}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3005870903313728`, 5.480638923341991}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-4.117817918407743, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.0498221244986778`, 2.647592232065096}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-3.600868576791223, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-5.966967075507594, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-4.4178610876830975`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1041274693562197`, 2.413231613081109}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.23876493221716663`, 1.601405740736836}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.719319793360441}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.4109447331170353`, 4.386765389021055}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.462743533283297, 2.58851563240702}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7650729201315343, 2.0731719286662407`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9699552564598479, 
             2.58851563240702}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.95401869367736, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 2.227106951818089}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.342468881579861, 
             2.0162354657760435`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3426311639367969, 1.8656293177945105`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4409617624621989`, 
             2.1174596088673567`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7389772837890856`, 1.803358605071407}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-4.91782824451005, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.887460350206278, 
             2.3711778844596574`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0272286702329017`, 7.076653815443951}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 0.8046885552928528}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4240364936935998, 8.1797604936999}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.5305182571117267, 
             2.827905162910489}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-4.518075479137158, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 0.9654617758806044}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8442026554799011, 1.7850704810772584`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 5.991464547107982}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-4.045554398052668, 0.8046885552928528}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.96443110720209, 
             2.494031557565001}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3329431856228962`, 
             2.425687290128029}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.4722426732562555`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3842963584572177`, 2.413231613081109}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.0529699307894087`, 7.600902459542082}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.9267273296385394`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.49331319868135953`, 2.4239173781615704`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.27128392664214473`, 1.9358598132018119`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-4.2845370133966245`, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.9999411183280458`, 4.386765389021055}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.8344803566765893, 2.131796772013764}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5159475693467614`, 
             2.0425181875752383`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7463370090740643, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.5978370007556204, 2.187398683184928}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.880084850028029, 5.723585101952381}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6497392092076262`, 6.131226489483141}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.666335489679042, 4.787491742782046}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9519282213808764`, 5.8289456176102075`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.137918471438812, 5.393627546352362}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 1.599387576580599}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6009911288088023`, 2.0082140323914683`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.1634411179801, 6.040254711277414}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.941966881801218, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 1.9254158540407285`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0328245481301066`, 
             2.425687290128029}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1821389399181785`, 6.921658184151129}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6332184410995039`, 
             2.425687290128029}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5716605481000705`, 
             2.187174241482718}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-1.491654876777717, 2.073423469354273}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 1.726509584019938}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8238695231462887`, 1.6956156086751528`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.462149662665384}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-67.46691559681179, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5876764206525877`, 
             2.3711778844596574`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.117766656001504, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1796054478776414`, 7.424165281042028}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4653375684603434`, 
             2.0930978681273213`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.4911047254722358`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.542246662893777, 
             2.0162354657760435`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.227106951818089}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.468806782694355, 
             2.3896797998449792`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.800001029850119, 6.253828811575473}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2072749131897207`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.6700167631710908, 
             2.58851563240702}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5064301623598713`, 
             2.3523271848888596`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.462149662665384}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 0.848868055556721}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.540748536722336, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4876628555081794`, 
             2.3711778844596574`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.002290482491421}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 1.3480731482996928`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.6358850824489488`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3186357126460757`, 
             2.1400661634962708`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5687759307152107`, 
             2.3896797998449792`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5324768712979722`, 2.5877640352277083`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.271538123821702, 
             2.187174241482718}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.40649706843741, 
             2.3523271848888596`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4903224315439383`, 
             2.0681277817795625`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4092798316650086`, 6.194405391104672}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.719319793360441}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9317114296555002`, 6.672032945461067}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.227106951818089}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3893457262282811, 2.0068708488450007`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.0218709311636855`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8505029913361519, 2.4176979000945504`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-4.045554398052668, 1.0335402919243948`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-5.298317366548036, 2.0471765810925606`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.832423655941967, 1.6937790608678513`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-2.995732273553991, 0.848868055556721}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.565421027017326, 
             2.0930978681273213`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.565421027017326, 
             2.0930978681273213`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-2.995732273553991, 1.094604267270571}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.430629081771714, 
             2.827905162910489}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.028748427364318, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-3.809015255353917, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9240709191931175, 8.1797604936999}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.4286713586629105`, 5.075173815233827}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0404377246170375`, 8.063377822367027}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.3178883284558303`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.1975522365230131`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8476951015583583`, 2.0149030205422647`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.922779731666459, 5.857933154483459}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-69.46689851604965, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 1.266384064447333}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.2166915767337108`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4983438649285135`, 
             1.9600947840472698`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-7.1622605067393605`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2942622756733968`, 
             2.1644717908644115`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820086052689358`, 6.921658184151129}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.4405393759722864`, 6.39024066706535}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.617854196524514, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.416581053724763}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.959419502711985, 4.0943445622221}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.719319793360441}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.39809235377875135`, 2.498151876538021}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.725332537920259, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.4079456086518722`, 1.497835735852798}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.858931232061846, 1.5953389880545987`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.227106951818089}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4422299934501939`, 
             2.0162354657760435`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.885443919659868, 5.768320995793772}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.623341473175256, 5.2574953720277815`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8584936331479384, 2.0706530356467567`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             2.5087859235779435`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.4354783156390294`, 5.768320995793772}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-0.697356025334, 8.006367567650246}], 4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3700273886560186`, 
             2.58851563240702}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.6039529822035308`, 5.676753802268282}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 1.7833912195575383`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3413209954771594`, 
             2.1174596088673567`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.683996966534062, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640797356921787`, 6.539585955617669}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.523226215615035}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.5129946410508307, 6.81783057145415}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.5177707239082765`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.927891643552635}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4304552569056603`, 2.503891949699081}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2149273965428693, 1.937301774518713}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.9958752112169974, 1.599387576580599}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.912572089444803, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-41.34127116323533, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.594056810395798, 
             2.1644717908644115`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6184786570862495`, 
             2.1400661634962708`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-5.209391157353635, 4.0943445622221}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.4865920824352545`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.932401799030521, 1.9358598132018119`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.48175237628028356`, 1.8625285401162623`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.462149662665384}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5413120833865, 
             2.1174596088673567`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5413120833865, 
             2.1174596088673567`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.036382052219389, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.201916872261721, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 1.2499017362143359`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             1.5473497201206787`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-5.3089739467365655`, 4.386765389021055}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.694451286761057, 
             2.1644717908644115`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.1990607599649155`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.7740297600361856`, 6.429719478039138}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.900458886151396, 5.480638923341991}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3903023825174294`, 
             2.0681277817795625`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2790527457537265, 1.864080130807681}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.694451286761057, 6.0867747269123065`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.725971728690052, 7.3777589082278725`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7611345721946656`, 1.864080130807681}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.300710797475603, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.8787541283454292, 1.599387576580599}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 2.075308010398229}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.341928551227046, 4.386889790339869}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.411934093335004, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.227106951818089}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8407396514497736`, 5.940171252720432}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.4179914478631452`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5269366909223567`, 6.253828811575473}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.30938249943111995`, 2.131796772013764}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.42266213293668586`, 2.418588768750352}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.309519943887134, 4.0943445622221}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2063088641234838`, 
             2.3523271848888596`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.063052113269559, 6.81783057145415}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.418781887396557, 5.111987788356544}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.9510398268753117`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.419118909249997, 6.684611727667927}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.9782390361706734`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6622300779252237, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.462149662665384}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.3749057545736716`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.8118888405232207`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.719319793360441}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.4722426732562555`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.719319793360441}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-5.717779984300055, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-5.293927018246744, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.215506040139609}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-4.3428059215206005`, 
             2.6490076604684267`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324790142551358`, 5.971261839790462}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.094520670764856, 1.6937790608678513`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.8840655845794182, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.019664337643975, 1.8687205103641833`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.227106951818089}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.836849948493799, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.900458886151396, 5.480638923341991}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.1413169453979233`, 
             4.512945241945574}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.416581053724763}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.4079456086518722`, 1.726509584019938}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-5.017810977845351, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9519179095173061, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8821308802274503, 2.0082140323914683`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.5288035062673013`, 5.075173815233827}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.7817091333745536`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.1625110145183415`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-5.117830825699811, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2330583852210326`, 
             7.8709295967551425`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.378751192832325, 5.075173815233827}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.360956006320375, 4.969813299576001}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.3749057545736716`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.2941383093687477`, 
             4.386765389021055}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.12893600699172, 5.075173815233827}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.382026634673881, 0.7485818874480459}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.409603402444116, 4.0943445622221}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-5.1093512670354135`, 4.0943445622221}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4571461020918417`, 1.4883995840570443`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.810369351701646, 5.393627546352362}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346745988779815, 6.756932389247553}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.5824869781268642`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1564532883579597`, 
             2.702032128776647}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.220083871482302, 5.560681631015528}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.100386954332169, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.416581053724763}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.541030999190403, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6184786570862495`, 
             2.1400661634962708`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 1.4772770088317615`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7667937207282438, 
             4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-4.584387646805562, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4460443655256647`, 7.157735484249907}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6922761907431048`, 2.6019486702196644`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 2.556451816951096}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.4722426732562555`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.552112845814831, 7.55171221535131}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3567355588783463`, 
             2.702032128776647}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.6397713603489157`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.924832423452417}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6414447085691868`, 
             2.1174596088673567`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 1.599387576580599}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.349630376748299}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7832907304129113, 2.0068708488450007`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-4.190415030972834, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1208578976154293`, 1.599387576580599}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1821389399181785`, 6.921658184151129}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.7822140563845235`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-47.34086951027008, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-35.340845982694816`, 4.512945241945574}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316692464055834`, 6.672032945461067}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3688474475161698`, 
             2.3896797998449792`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-4.76404869105558, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.5565205830281202, 
             2.702032128776647}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.7539022397884905`, 4.499809670330265}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.863232841258714, 0.8458682675776092}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0129050178795915`, 5.768320995793772}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0931348688118385`, 2.0095554142156695`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4092798316650086`, 6.194405391104672}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1874435023747254`, 
             2.3711778844596574`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.3678803477808931, 2.421256622711544}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5159475693467614`, 
             2.0425181875752383`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.4079456086518722`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.359873830032749, 4.0943445622221}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3874950816964096`, 
             2.3711778844596574`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.9251241812954787`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7625890919282752`, 6.841615476477592}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.771368779580321, 
             2.187174241482718}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.7178497932003172, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4644721421839146`, 
             2.494031557565001}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.227106951818089}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.3749057545736716`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.9245405804618736`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0305798782762827`, 
             2.827905162910489}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.56019682034536, 4.0943445622221}], 4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.785741396902492}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-5.61797181824309, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5329399414613754`, 
             2.425687290128029}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0963149296194261`, 6.684611727667927}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-4.017939231019695, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.5824869781268642`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8470607850131444`, 6.756932389247553}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3063747379440172`, 
             2.3523271848888596`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3063747379440172`, 
             2.3523271848888596`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 2.377692565480851}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2942622756733968`, 6.0867747269123065`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.312220927289192, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.8058680506240641, 1.937301774518713}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6906479678596436`, 
             2.0681277817795625`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5828588266658222, 1.6974487897568136`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.66442222076686, 6.939253946041508}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.795734531747094, 
             5.991464547107982}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.279845606024556, 1.7833912195575383`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1542307124311217`, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7225041580723603`, 1.9387416595767009`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.227106951818089}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-5.51796702860799, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.282782465697866, 2.423031246069913}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.028556821684098, 5.075173815233827}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-4.017383521085972, 0.7347688552507647}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2669126040998102`, 
             4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0993125337825032`, 8.004365564979574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7448616162466241, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.9499943818801375`, 6.253828811575473}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6281111776997217`, 6.152732694704104}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6548884684428551, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6993626199620875`, 2.020222182019865}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 2.4176979000945504`}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 1.7268653293100646`}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.416581053724763}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             2.4561641809223462`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.462149662665384}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4405393759722864`, 5.940171252720432}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.0935997468445653`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.666335489679042, 4.787491742782046}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6713133161521878`, 
             2.187174241482718}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1689274625831354`, 
             2.3896797998449792`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.213639558072954, 6.040254711277414}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7199019178687649, 
             7.8838232148921525`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.502828177375842, 7.600902459542082}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 2.075684492802124}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751531979714171, 5.8522024797744745`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.469241281940817, 
             1.9892432737616872`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047875165492457`, 6.298949246855942}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.227106951818089}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 2.187398683184928}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2072749131897207`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.6304163188192922`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0612087734187763`, 2.519308076505333}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.4405393759722864`, 6.39024066706535}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.227106951818089}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.494523665901028, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.2377341206744292`, 5.393627546352362}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-53.46678887337479, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.902704363179782}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.317800258800526, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.7985076962177716, 2.647592232065096}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0191543673333943`, 2.570319527636131}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5906161581935125`, 
             2.0681277817795625`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5906161581935125`, 
             2.0681277817795625`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6654793033177253`, 
             2.0930978681273213`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.308100273682156, 1.864080130807681}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.640928579525471, 
             4.512945241945574}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 1.3982229319851645`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-5.2178439823981595`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-5.417776806585365, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.406905315024015, 7.697121317282625}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.287354413264987, 
             2.3711778844596574`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.287354413264987, 
             2.3711778844596574`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8904754421672127`, 
             2.0681277817795625`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.6163727633271883`, 4.787491742782046}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.9390477189967712, 2.414126467726953}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5692561228012685`, 
             1.9892432737616872`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.200028504668954, 6.253828811575473}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.878625402249717, 1.8656293177945105`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.904054835778969, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-5.159425367681418, 4.0943445622221}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2971851860481147`, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.6179742434563866`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.26443077336305, 
             2.494031557565001}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.995732273553991, 3.8004208288468435`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.4135166537013273`, 6.040254711277414}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.2180717287054377`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.0968250627658085`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.7406415980494447`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.377606779979768, 2.0706530356467567`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.3670139217339117, 2.134048091170708}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.6190782472999463`, 6.684611727667927}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-5.317908016313041, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111964733385396, 6.492239835020471}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-7.666828609658249, 4.386889790339869}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.403068631572368, 2.0731719286662407`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6414447085691868`, 
             2.1174596088673567`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8643301620628905`, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5644645467913691`, 
             2.494031557565001}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.7985076962177716, 2.187398683184928}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             0.766397642299538}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.542246662893777, 
             2.0162354657760435`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.2101638842661795`, 5.393627546352362}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.9058454740126164, 1.937301774518713}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.458005208673891, 5.823045895483019}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-8.166888494485349, 4.386889790339869}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2942622756733968`, 6.0867747269123065`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.1409980051645476`, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-4.004138294335951, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3154677188250594`, 1.9387416595767009`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.462149662665384}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.4028303297599902`, 7.600902459542082}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4912105310694506`, 
             7.6128310304073565`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6424777665123005`, 
             2.0162354657760435`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6424777665123005`, 
             2.0162354657760435`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.2207799226423173`, 7.783224016336037}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047875165492457`, 6.298949246855942}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4171835010623628, 1.7850704810772584`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.3420861064555702`, 
             4.386889790339869}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9784819201474635`, 2.0706530356467567`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-2.966950472128539, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3789263262507685`, 1.589235205116581}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6702500518308578`, 7.433666540166168}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.911914268349973, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.462149662665384}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2069773133462347`, 6.173786103901937}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.9910142780700916, 7.6128310304073565`}],
             5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.516892795645856, 6.0867747269123065`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-4.524512282970637, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1702157075278026`, 
             2.58851563240702}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7797949872856175, 1.6034198401085373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.7847348542910906`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.5102244577722903`, 6.476972362889683}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7903604483143476`, 
             2.0681277817795625`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.227106951818089}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.8250798518207709, 1.864080130807681}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.974001029221839, 6.429719478039138}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.0241960674538575`, 6.429719478039138}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.532062329207643, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6240440648234626`, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.416581053724763}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1715056141884346`, 
             2.187174241482718}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.22276862160913655`, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.2433732333621994`, 5.537334267018537}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 0.7476353658440151}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7565130561817651, 
             2.702032128776647}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.4079456086518722`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.598497972395766, 
             1.9600947840472698`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 0.9654617758806044}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[$CellContext`\[FivePointedStar], {-1.71869489837105, 
             2.1400661634962708`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.0181583132629375`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.7181373293574413`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-1.491654876777717, 1.783559272662715}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.676945820702642, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8587568185269134`, 2.136530508663963}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.7329280505717899, 7.8709295967551425`}],
             5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5793937910857236`, 2.5087859235779435`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0700248318161971`, 
             2.58851563240702}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0700248318161971`, 
             2.58851563240702}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-5.298317366548036, 2.6490076604684267`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.21678878567620194`, 
             4.386889790339869}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-0.6474092888860916, 8.006367567650246}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.437937594271729}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-6.191868611452702, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-4.3428059215206005`, 
             3.2386784521643803`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164563795096671, 6.939253946041508}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3478567954878509, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020229905154391, 5.583496308781699}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.462149662665384}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-4.417032243872697, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.4342248948774405`, 
             4.386765389021055}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 2.246332151443247}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.894078619827491, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.931658209005277, 1.8625285401162623`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.2867117438377558`, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-3.872802292274865, 1.601405740736836}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.466278187121473, 4.787491742782046}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2173252490432223`, 4.386889790339869}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6792442753909539, 2.0719132752590443`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.083998270167957, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.068859330518762, 
             2.3896797998449792`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.874045755297392, 6.429719478039138}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020229905154391, 5.583496308781699}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6445470895476684`, 5.736572297479192}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.462149662665384}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.5824869781268642`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 1.0868770324496888`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-5.566981433164056, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7533219035960154, 8.350429973538136}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 
             1.3045418592476314`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4329667693183212`, 
             2.425687290128029}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.7828868907244566`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3171415024315738`, 6.063785208687608}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2437536743377806`, 7.360103972989152}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.0942695392339727`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.0678093795130645`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.5824869781268642`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.5841201044498106`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-55.46685482648658, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.615959129424366, 
             2.0425181875752383`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.615959129424366, 
             2.0425181875752383`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.227106951818089}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.815475995845371}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.598497972395766, 
             1.9600947840472698`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0971007679422797`, 2.0082140323914683`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.5824869781268642`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.491327217590923, 2.0719132752590443`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4728877844255986, 1.937301774518713}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.5087859235779435`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             0.7975071958841882}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 0.9666035457477442}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 1.6384140206706175`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-3.293868803909631, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.344384958042681, 7.759614150696903}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.599387576580599}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0645007590393418`, 
             2.494031557565001}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6654793033177253`, 
             2.0930978681273213`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.269044801069651, 
             2.3896797998449792`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.269044801069651, 
             2.3896797998449792`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751531979714171, 5.8522024797744745`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.5978370007556204, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             2.1094856630282126`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.70036037299184, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.227106951818089}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1150465951315345`, 7.488852955733459}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2651392395634233`, 1.5953389880545987`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5692561228012685`, 
             1.9892432737616872`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.863232841258714, 1.007592890280941}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0940068428223313`, 4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.604170685655008, 4.499809670330265}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.227106951818089}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.091798316674432, 4.386889790339869}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.975391927697949, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.029509172931627, 2.4997952622817508`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324790142551358`, 5.971261839790462}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 1.1684492482568893`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.132893222644984, 
             2.425687290128029}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-66.46748299707936, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9747212309094329`, 2.0095554142156695`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.5191254931746836`, 6.684611727667927}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.087375656742122, 
             2.3711778844596574`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyUpTriangle]", {-1.05211045501669, 7.55171221535131}],
             5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.0177699008240089`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 1.599387576580599}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             2.1151705891340815`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.773934884315503}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.7164562218841706`, 4.787491742782046}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.817803785159501, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.104394898075602, 4.499809670330265}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751531979714171, 5.8522024797744745`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-6.667164814064207, 
             4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6969544189028993, 2.0082140323914683`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 1.497835735852798}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-6.502290170873972, 1.2424239907001886`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.571249159610065, 2.0719132752590443`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 0.849723487602042}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.9180410777537094`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.6854573524495757`, 5.768320995793772}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-6.667164814064207, 4.386889790339869}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1821389399181785`, 6.921658184151129}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.3749057545736716`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1062413158326008`, 
             2.3523271848888596`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2063088641234838`, 
             2.3523271848888596`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.9180031958023054`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.9177918580004223, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3842963584572177`, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.8183088044615916`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6906479678596436`, 
             2.0681277817795625`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0942219403668167`, 
             2.1644717908644115`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.742398039690331, 
             2.0162354657760435`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.3749057545736716`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-7.286383733136742, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2072749131897207`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5338868320097188`, 1.937301774518713}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2395270305647338, 1.4996230464268938`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.3101690833145914`, 5.393627546352362}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-4.632849755094834, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.3749057545736716`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.3492738284584218, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.21927603978772048`, 1.860974538249528}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.377692565480851}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.30432512701003, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.49397078181451, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0189110419398038`, 6.584791392385716}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 2.424802725718295}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.6407445017668969, 
             4.512945241945574}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.719319793360441}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.657689841763261, 1.8625285401162623`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.1177951080848836`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-7.166785108860756, 4.386889790339869}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0186003506987251`, 2.4176979000945504`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4701108472130011`, 
             2.58851563240702}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-8.622553707074063, 0.973049065692764}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.0940068428223313`, 
             4.386765389021055}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.3137876703331426`, 7.090076835776092}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 0.7485818874480459}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.1866231659908228`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.0475390184841091`, 8.006367567650246}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.904054835778969, 4.499809670330265}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.7837272975307907`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.741256487054948, 
             2.1174596088673567`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.430789601006442}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-3.3524072174927233`, 1.497835735852798}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.7985076962177716, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.6593256320844346, 7.944492163932159}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 1.599387576580599}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2824955457644808, 1.7817091333745536`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5561717255328675, 1.864080130807681}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             0.766397642299538}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1409980051645476`, 
             2.1174596088673567`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             1.8728785205128469`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-48.341370727608414`, 4.512945241945574}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.5978370007556204, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.575036485716768, 2.020222182019865}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.666853965970644, 
             4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5823216254710607, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 0.849723487602042}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.71869489837105, 
             2.1400661634962708`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047875165492457`, 6.298949246855942}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.926290362185661}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316692464055834`, 6.672032945461067}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.462149662665384}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.5205117032396989`, 7.783224016336037}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.694093021166824, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.095273387402595}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1464364105041143`, 5.634789603169249}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7159101569446171`, 
             2.0425181875752383`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.915963072687361, 
             2.0425181875752383`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.612442421454399, 5.768320995793772}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.9407951330603375`, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.1151705891340815`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-8.599488434143067, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4361820807702249, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-0.6204544951665047, 7.783224016336037}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.4028303297599902`, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.9572739077056285`}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.96443110720209, 
             2.494031557565001}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.2164073967529934`, 2.0719132752590443`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             0.761739972025557}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.953887209526845, 4.499809670330265}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1184069159962893`, 
             2.1400661634962708`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.246332151443247}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1689274625831354`, 
             2.3896797998449792`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             2.3243465847755584`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.6393849888020524`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.227106951818089}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.9837562915454279`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.227106951818089}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.314556464775266, 2.0706530356467567`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             0.9364854391596744}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.7254100886865211`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.7820071777853768`, 2.50470927708418}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.6409365794934714`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.0102369597568726`, 5.393627546352362}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.7710464276305133`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             2.2086040295231517`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6907507040241487`, 2.005525858729668}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.8122154777954373`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.4911047254722358`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.8180773925856184`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.7310567536331655, 1.864080130807681}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.5808504555821878`, 6.249975242259483}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.741256487054948, 
             2.1174596088673567`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 1.3147983594148207`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             1.9838938336679197`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.995732273553991, 5.991464547107982}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-6.214608098422191, 1.6094379124341003`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-7.418747583305227, 1.7328937163610187`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2184098521237055`, 
             2.1400661634962708`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2739976361421332`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3329431856228962`, 
             2.425687290128029}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             1.9838938336679197`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6691879168398742`, 
             1.9892432737616872`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6691879168398742`, 
             1.9892432737616872`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.215506040139609}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-5.298317366548036, 2.0471765810925606`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.5824869781268642`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.194022473472768, 
             2.1644717908644115`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9306432380985556, 
             2.827905162910489}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.554477071672573, 4.499809670330265}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.694451286761057, 
             2.1644717908644115`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.0942695392339727`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8307082193666298`, 2.512035317176253}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.5338519254775054`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1111386284230904`, 5.66988092298052}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.6843598389513597`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             2.209811692841691}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             1.8526977673331346`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2654936609741865`, 
             2.0930978681273213`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.599387576580599}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6044503709230613`, 6.999422467507961}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.793961892783255, 
             2.1644717908644115`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7145751279735658, 1.9387416595767009`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             0.898534010284896}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-0.3504089023600859, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.515036014769512, 1.4951487660319727`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.4420193761824103`, 
             3.2386784521643803`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.9405834244431995, 6.39024066706535}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.823966230699553, 6.429719478039138}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.612442421454399, 5.768320995793772}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2595256035335987`, 5.521460917862246}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             1.5904589458362974`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 1.1464496180822696`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.816258383443767, 4.787491742782046}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7625890919282752`, 6.841615476477592}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.154094566627875, 4.499809670330265}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.813734143549063, 8.290041618704489}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.7406415980494447`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             1.721694594779768}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.725971728690052, 6.104793232414985}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.110313205346923, 2.0719132752590443`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8944568674663975`, 
             2.1644717908644115`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.666853965970644, 
             4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.466278187121473, 4.787491742782046}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 1.599387576580599}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3645328693383778`, 
             2.494031557565001}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-52.467202900682494`, 4.386889790339869}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7565130561817651, 
             2.702032128776647}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.9980550336767947}], 6., 
            
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.780226233414382, 1.9300710850255671`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 0.9666035457477442}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.3540294005326152`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5228016057745537`, 5.857933154483459}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1874435023747254`, 
             2.3711778844596574`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.974001029221839, 2.502255288122613}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.416581053724763}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.2636117187095923`, 6.040254711277414}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5015355768588979, 1.6956156086751528`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.2862680470527663`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.953887209526845, 4.499809670330265}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.803865056899991, 4.499809670330265}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 1.3321021320364639`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5079962967558309, 2.134048091170708}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.5824869781268642`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             1.8526977673331346`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-56.46701553651661, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.44926026810783587`, 2.0719132752590443`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.8012039280560548`, 4.386765389021055}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.725433722188183, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.9910270779881722}], 6., 
            
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7120245012092015`, 2.506341930508065}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             0.8977193462887197}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 2.293947899598382}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.9782390361706734`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.6126737964100685, 2.005525858729668}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.0279882600909205`, 4.386765389021055}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.698815723585317, 
             1.9600947840472698`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.698815723585317, 
             1.9600947840472698`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7048480972387587`, 1.8656293177945105`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 1.416581053724763}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.064355904261795, 6.539585955617669}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.965852822566973}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.225346881840062, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7655070980839893`, 
             2.0930978681273213`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.6888794541139363`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.349630376748299}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.6788498758591209, 1.599387576580599}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2330583852210326`, 
             2.425687290128029}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2330583852210326`, 
             2.425687290128029}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.2098554674840916`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.5338519254775054`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.5532907518110994`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.7985076962177716, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7655070980839893`, 
             2.0930978681273213`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.5895081458004594, 6.7912214627261855`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1644316297054034`, 
             2.494031557565001}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1644316297054034`, 
             2.494031557565001}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.475327636634016, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.7406415980494447`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.2158025560795132`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.659260036932778, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 2.090999490513565}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 1.173410498743296}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.411934093335004, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.1733127572899065`, 2.419478844465545}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 0.965080896043587}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 0.9403978072173882}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0645007590393418`, 1.7817091333745536`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0024805005437076`, 2.0719132752590443`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.3563504847468186`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.8526977673331346`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 0.7499999921527281}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.599292605088321, 2.0719132752590443`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.341928551227046, 4.386889790339869}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820086052689358`, 6.921658184151129}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2409826299598365`, 
             2.1174596088673567`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7159101569446171`, 
             2.0425181875752383`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             0.9290095042819297}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-0.8205261098897758, 7.783224016336037}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6497392092076262`, 6.131226489483141}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.2975725511705014`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.402871609042948, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.6409365794934714`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5473167323484057, 1.9358598132018119`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7406861990440543`, 6.040254711277414}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.898454207899018, 
             1.9600947840472698`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6864844231876495`, 1.7817091333745536`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.166888494485349, 
             4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.7109170813839543`, 5.66988092298052}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.418894215394429, 1.6882490928583902`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 1.721694594779768}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.462149662665384}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.178596114669692, 5.075173815233827}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.5338519254775054`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.7479817218821596`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5213811377055073, 2.0719132752590443`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9293759714228106, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.556451816951096}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.7539022397884905`, 4.499809670330265}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             0.8055826098897335}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.3407610128583247`, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.227106951818089}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111964733385396, 6.492239835020471}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.860379772276308, 5.393627546352362}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.040829633207479, 
             4.512945241945574}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8891518152367044`, 2.0731719286662407`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.6269849783062765, 1.937301774518713}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.9572739077056285`}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.294616923344869, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.227106951818089}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6939993778795506`, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4599740936085572, 2.004179057179289}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.3137523001849649, 8.290041618704489}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8865098057738656`, 2.5771819258971713`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1702157075278026`, 
             2.58851563240702}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8407396514497736`, 5.940171252720432}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.382026634673881, 0.8441500540964727}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.071483621279857, 
             2.187174241482718}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 0.7485818874480459}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.0281898243715637`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9565920286476808, 
             2.702032128776647}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9565920286476808, 
             2.702032128776647}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.094604267270571}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4605869657017456`, 2.4176979000945504`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-46.34085167560773, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.421661504957182}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.6409365794934714`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 2.330200260027019}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.7181023127908395`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-5.493845750829273, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.5808504555821878`, 6.249975242259483}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 2.04225875055212}],
             5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.816462081868427, 
             2.0425181875752383`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-4.8283137373023015`, 2.0471765810925606`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6416938989710297, 1.8625285401162623`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9038682118755978, 6.476972362889683}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3585338134237321, 1.6956156086751528`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.428942281870568, 1.937301774518713}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.1597073880279205`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7667937207282438, 
             4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.9005275521158795`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.640548907459153}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6029589463363911`, 7.501082124259871}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-1.491654876777717, 1.094604267270571}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-6.113858195322049, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7637552728184576`, 2.4265710727750367`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.4307829160924542, 2.647592232065096}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             1.5904589458362974`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             2.4561641809223462`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-43.340988541359216`, 4.512945241945574}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.746403767507258, 5.634789603169249}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.8442026554799011, 7.759614150696903}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0645007590393418`, 
             2.494031557565001}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-3.166995202991212, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.536314386533157, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-4.893919494400295, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.0968250627658085`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.528780009416646, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8189251373008244`, 
             2.1400661634962708`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.215506040139609}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.631199404215613}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.2908841763152323`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6029589463363911`, 7.501082124259871}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5918549290780729, 1.6034198401085373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.7859090555498793`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 2.193662685769859}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5474025215146479`, 2.414126467726953}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9186841628017217`, 
             2.1400661634962708`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8714522381373035`, 
             2.187174241482718}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.426283369336254, 6.104793232414985}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2977324083052823, 1.6114359150967734`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.742398039690331, 
             2.0162354657760435`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.064355904261795, 6.539585955617669}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.416581053724763}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.004138294335951, 4.499809670330265}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.7840632625935846`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.412288358086009, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.640548907459153}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 
             2.1627481478062465`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.110245660342752, 5.393627546352362}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.100426344668657, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8773173575897015`, 1.6114359150967734`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.9031380572114442`, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706800981701778, 6.396929655216146}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.703886158927249, 4.499809670330265}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-6.667164814064207, 
             4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.6178619668786562`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3035404883862389, 1.5107219394949427`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.26443077336305, 
             2.494031557565001}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3861841168703593`, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.9521761906339596`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.6139480679119864`, 7.090076835776092}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.701553201341906, 2.418588768750352}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             2.330200260027019}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2909841813155656`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047875165492457`, 6.298949246855942}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0328245481301066`, 
             2.425687290128029}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7696066645869217`, 
             1.9892432737616872`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9542522381612738, 2.0719132752590443`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7672619976276676`, 
             4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8016468498397944`, 2.130609828254235}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-45.34120604098636, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 1.721515815839451}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8470607850131444`, 6.756932389247553}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.3354096411241523`, 5.768320995793772}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.4854489341097463`, 5.768320995793772}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7987840841650193`, 
             1.9600947840472698`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.462149662665384}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.491779868965868}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7987840841650193`, 
             1.9600947840472698`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8426317996018116`, 
             2.0162354657760435`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0202633222571333`, 1.4929040961781488`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5342648554997536, 2.0068708488450007`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4267908948229169, 1.6974487897568136`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.810913836561449, 4.969813299576001}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9414202437824613`, 
             2.1174596088673567`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.816462081868427, 
             2.0425181875752383`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.3089630181835672`, 4.386765389021055}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.612442421454399, 5.768320995793772}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.045554398052668, 0.7485818874480459}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.64930970607961, 2.0719132752590443`}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.2855499581361935`, 5.768320995793772}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9428149441480107`, 
             2.0162354657760435`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9001713499942718, 1.4951487660319727`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8566077297129814, 
             2.702032128776647}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             0.8028980445190645}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7002308520500784`, 1.691939133945844}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-1.155182640156504, 2.570319527636131}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-3.49397078181451, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.412267540691536, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0129050178795915`, 5.768320995793772}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.161367091078508}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.91139112512024, 2.0068708488450007`}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.592214878401959, 4.386889790339869}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.694451286761057, 6.0867747269123065`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 0.9707789171582248}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-0.9205497887945385, 7.783224016336037}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.869504817852908, 
             1.9892432737616872`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.8470364847178946`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.8699543168131119`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9696906777207166`, 
             1.9892432737616872`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             2.078566158643882}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4375876555074412`, 2.0149030205422647`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 0.848868055556721}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.0335402919243948`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 0.7466879474879751}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.132893222644984, 
             2.425687290128029}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.3871630694693433`, 5.393627546352362}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.77313400510489, 2.0731719286662407`}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8598242001421843`, 5.521460917862246}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 1.599387576580599}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.9639722918737217`, 7.090076835776092}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7912011210353335, 1.4951487660319727`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.4753441779534016`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8350845939664286`, 2.4265710727750367`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.152761077153482, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.0289048762432895`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3193836558372638`, 6.461468176353717}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5901256014017275`, 7.013915474810528}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.898454207899018, 
             1.9600947840472698`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-0.8706006059570394, 7.783224016336037}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-1.491654876777717, 0.849723487602042}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.51624397679369, 4.787491742782046}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-6.442136248054226, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.25165731439258, 5.8522024797744745`}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-4.199705077879927, 0.7997569156182036}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3039860739096736`, 4.386765389021055}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.5100594684538216`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.6623114020411685`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.5902550930173265`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.51875303057183, 5.111987788356544}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6745099091778153`, 1.9300710850255671`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0181583132629375`, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9002402920947703`, 1.7850704810772584`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5404260935422814, 8.063377822367027}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.417771502803163, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.804781390061982, 6.298949246855942}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020229905154391, 5.583496308781699}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.768756076219605, 5.111987788356544}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.038175919864279, 1.864080130807681}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.612240146256234, 2.1329823086078656`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.7535382564078572`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.270112606830481, 
             2.58851563240702}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7696066645869217`, 
             1.9892432737616872`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.279055610450292, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.378751192832325, 5.075173815233827}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.552112845814831, 5.8289456176102075`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3037931396081468`, 6.476972362889683}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             0.9345235001352147}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.7963700817857382`, 6.907755278982137}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.3865452232556535, 7.24422751560335}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.178596114669692, 5.075173815233827}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.7867719277170158`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 2.2044208442068145`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.6661962462527091`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6445470895476684`, 5.736572297479192}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6790255220615937`, 2.134048091170708}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.7406415980494447`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.491654876777717, 1.416581053724763}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6398971199188088`, 2.0843046973458237`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.416204086475468, 4.787491742782046}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 2.031563461435372}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.706800981701778, 1.4883995840570443`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 2.209811692841691}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.538054293998892, 2.134048091170708}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 0.8514321595256585}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.2499926428748753`, 6.253828811575473}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8129108417183852`, 1.937301774518713}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.227106951818089}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2960880932337415`, 1.4883995840570443`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 1.416581053724763}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-4.294015757351168, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.820158943749753, 5.560681631015528}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.4588475538015993`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.804781390061982, 6.298949246855942}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-1.585233223737283, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 
             1.0420419371797154`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8566077297129814, 
             2.702032128776647}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.0598714603516792`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.517955942272351, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.3204807842031671, 6.960347729101308}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.6675181235106251`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.045554398052668, 0.9604989865384754}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-6.214608098422191, 2.0471765810925606`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.2072749131897207`, 1.497835735852798}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6286207318508743`, 2.4176979000945504`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.739076112448345}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.5978370007556204, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             0.8202202631234213}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.0654001544619962`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.3540294005326152`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.166785108860756, 
             4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7212874278842305`, 2.0719132752590443`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.9582864201233687`, 5.823045895483019}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.2072749131897207`, 6.396929655216146}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.06016413371338, 5.393627546352362}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.7985076962177716, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 0.7485818874480459}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.712716261887602}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 1.2190584417439767`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8500747011316276`, 2.0731719286662407`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.6528674703614363`, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.406587064387653}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.2063088641234838`, 6.674561391814426}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.3281354469463584`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.7929254558680243`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.766368110426725, 2.0068708488450007`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.595748829015065, 5.991464547107982}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9200474895295858`, 2.498151876538021}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.5366522427084526`, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.1966460289394751`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.1589994386832048`, 4.386765389021055}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.6354040111173562`, 5.768320995793772}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.8069317506623275`, 4.386765389021055}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.5260163042950279`, 6.104793232414985}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.527397202097891, 7.076653815443951}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7004573108212688`, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.044846896915337, 5.736572297479192}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 2.0427775573082445`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.251047211711865}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.300710797475603, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.4365120772805082`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.074653024948039, 6.429719478039138}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.500810170663849, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.66873333872526, 5.111987788356544}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1593181637855046`, 7.944492163932159}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.2864827918762988, 7.24422751560335}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.227106951818089}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.984837274409265, 2.005525858729668}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.10045059841862, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.2919836816486494`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.4911047254722358`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.6936470556015963}], 6., 
            
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640797356921787`, 6.539585955617669}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             2.3243465847755584`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 0.7485818874480459}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.700587583759682, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.3282528397426234`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-5.166938288491657, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4092798316650086`, 6.194405391104672}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.6562368265398482, 6.674561391814426}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.466163406970865, 2.1329823086078656`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.4307829160924542, 1.726509584019938}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.2140221401789375`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.4915548717773834`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8042369907391675`, 4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8470607850131444`, 6.756932389247553}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.548102073285148, 1.864080130807681}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.2164073967529934`, 2.131796772013764}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9186841628017217`, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.7268653293100646`}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.016955910005618, 6.0867747269123065`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.3907040696085906`, 6.39024066706535}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 2.044332364566268}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.424802725718295}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.6260755535871236`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4918104261047946`, 4.386889790339869}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.6888794541139363`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.119430549896199, 2.1329823086078656`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316692464055834`, 6.672032945461067}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8413699697813894`, 
             2.1174596088673567`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8551011438142453`, 1.864080130807681}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.9405834244431995, 6.39024066706535}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7955707986317053`, 2.0706530356467567`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-3.894183087299815, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.978697138696139, 5.075173815233827}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-2.659260036932778, 0.849723487602042}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.4307829160924542, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.558002204858551}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.841967538444134, 4.386889790339869}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 0.9669838461896731}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.227106951818089}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[$CellContext`\[FivePointedStar], {-1.9987836386623814`, 
             1.9600947840472698`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0514564223263525`, 2.0028304393079956`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.7406415980494447`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.389499492068839, 5.991464547107982}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.4305321073246677`, 1.8656293177945105`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             2.0624225365102413`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0108761743640229`, 1.937301774518713}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.220083871482302, 2.424802725718295}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346745988779815, 6.756932389247553}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.893897967672723, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751531979714171, 5.8522024797744745`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.220083871482302, 5.560681631015528}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 1.900464386136271}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-5.366810362993337, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.1498640059763816`, 6.253828811575473}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 0.849723487602042}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-34.340745544411554`, 4.512945241945574}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.7083778602890038`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 1.715777948205427}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5104979645791967`, 1.9358598132018119`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-3.694093021166824, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.516892795645856, 6.0867747269123065`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7672619976276676`, 4.386889790339869}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 0.7485818874480459}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.4920048155420047`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.4338645826298623, 1.601405740736836}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.6409365794934714`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.3003570667360838`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 1.2669476034873244`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.4911047254722358`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.4871090733432, 5.393627546352362}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8121662790057176`, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.036482917202561, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4405393759722864`, 5.940171252720432}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.036382052219389, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.4307829160924542, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324790142551358`, 5.971261839790462}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8656213178265104`, 
             2.0930978681273213`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.4126383364594925`, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.319222734147069, 6.784457062637643}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9192952408944538, 6.461468176353717}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.9474803442248305`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.049977288406387, 6.253828811575473}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.227106951818089}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.7333680090865, 6.253828811575473}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.007679175452945, 5.823045895483019}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.676945820702642, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-5.7340355178272215`, 4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.435545220250276, 1.776645831418007}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.016955910005618, 6.0867747269123065`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.0942695392339727`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346745988779815, 6.756932389247553}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.1603343472961065`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             2.1992225799988927`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5608378214218233`, 1.7833912195575383`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.6287255312941893`, 5.075173815233827}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.9453385571563557`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.4146388341290332`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 5.991464547107982}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.995732273553991, 1.497835735852798}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.5077842587076005`, 5.823045895483019}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             2.1992225799988927`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.4179367056664534`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 0.9566646260124284}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.59947470469731, 8.004365564979574}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-8.532306829226286, 1.2424239907001886`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2315538186741798, 1.6956156086751528`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706800981701778, 6.396929655216146}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.227106951818089}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111964733385396, 6.492239835020471}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-2.995732273553991, 5.991464547107982}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.975391927697949, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.466024904841838, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.090999490513565}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 2.377692565480851}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.9782390361706734`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 1.191191469961203}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.293947899598382}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5612262966614128`, 1.691939133945844}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.7790406968202803`, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.493987758524193, 4.386765389021055}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9085180298382507`, 2.423031246069913}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.973281345851445, 2.4239173781615704`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 
             1.7693434299437227`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1593181637855046`, 7.944492163932159}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7389772837890856`, 7.365180126021013}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5188771693591536`, 6.584791392385716}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.8540604954254345`, 5.676753802268282}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.090999490513565}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9519282213808764`, 5.8289456176102075`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 0.911479174876933}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.44238846221276223`, 1.501852701754163}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.2919836816486494`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 1.0962762288705619`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8407396514497736`, 5.940171252720432}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7306413849875258, 
             2.827905162910489}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.3524072174927233`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6702500518308578`, 7.433666540166168}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.6218266343535928`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-4.0757190980989355`, 1.4996230464268938`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.5338519254775054`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.2568373311553196`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.227106951818089}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2072749131897207`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.363503507963463, 6.040254711277414}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.103158068297152}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             0.986935571443487}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.2072749131897207`, 6.396929655216146}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9896682016789307, 6.7912214627261855`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.5366522427084526`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.8420006856648017`, 
             4.386889790339869}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.5787702314339063`, 5.075173815233827}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0923241675108497`, 
             4.386889790339869}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 2.1122716862705384`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 0.7485818874480459}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0053952069569758`, 2.498151876538021}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9806466361359503`, 2.005525858729668}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2303167796655379`, 1.691939133945844}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.6218266343535928`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.716864386545305, 4.386889790339869}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1111386284230904`, 5.66988092298052}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.100386954332169, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 2.215282764591249}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.60100614381313, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.3504080825554816`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.266557384867768, 4.787491742782046}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.1029215602562081`, 7.600902459542082}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.391511302188447}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7078502210995437`, 1.5973653311998313`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.296603021316498, 6.907755278982137}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-8.850570223130148, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 1.416581053724763}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6941476808935289, 1.4951487660319727`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1702157075278026`, 7.433666540166168}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.359436906950008}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.9110235456270366`, 4.969813299576001}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.0218709311636855`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5449114637250294`, 1.5933085305042167`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.5068336024964532, 1.601405740736836}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 1.416581053724763}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.912572089444803, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8598242001421843`, 5.521460917862246}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.1627481478062465`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.6888794541139363`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6115589009134488`, 6.492239835020471}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.8805331812814825`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.4307829160924542, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5082360319251331`, 6.272877006546167}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.152962883418191, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.29356601561075557`, 1.6956156086751528`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.5177604746590787`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0898959995836948`, 7.013915474810528}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7414001807837645`, 2.131796772013764}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0605908459024875`, 1.6956156086751528`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.166785108860756, 
             4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6798603767306461`, 7.424165281042028}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.166888494485349, 
             4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.090999490513565}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-65.466905183977, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             2.193662685769859}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-50.341331645288825`, 4.512945241945574}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 0.8060293376166178}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.293897511853923, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 1.416581053724763}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3678803477808931, 1.4973884086254774`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1026203100656484`, 7.501082124259871}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.4126383364594925`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.5919427181706105`, 
             4.386889790339869}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8016236568960291, 6.579251212010101}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.6305480388034254, 
             2.827905162910489}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5663784229736533`, 6.214608098422191}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.269150316907808, 5.111987788356544}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.9910142780700916, 7.6128310304073565`}],
             5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.3540294005326152`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.26683423993894284`, 
             4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.2862680470527663`, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3093333199837622`, 7.294377299288821}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.4307829160924542, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8195418502405067`, 6.784457062637643}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6005679992668521, 1.4996230464268938`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.5845302767279155`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8426317996018116`, 
             2.0162354657760435`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-70.4670522818902, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9306432380985556, 
             2.827905162910489}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.045554398052668, 0.8514321595256585}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 2.217027204632399}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.475327636634016, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 
             1.6378309869353183`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.7268653293100646`}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.096384262410148, 6.907755278982137}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 0.9669838461896731}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.8665717425242287`, 4.787491742782046}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.2867117438377558`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.5978370007556204, 1.497835735852798}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.6108369333478076`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0549440700794483`, 2.418588768750352}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.5774997570339834, 8.026170194946426}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2815740503494875`, 7.822444729489319}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7672619976276676`, 
             4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.9317114296555002`, 6.672032945461067}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.031563461435372}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706800981701778, 6.396929655216146}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.2072749131897207`, 6.396929655216146}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1535965970008693`, 1.4906543764441336`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.235513466021224, 5.768320995793772}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 0.8046885552928528}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.900464386136271}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-49.34073194467232, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.606941032235513, 1.7833912195575383`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.940865372113151, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.376740148315079, 7.226936018493289}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.4532518292447716`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132468797127462, 5.971261839790462}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1464364105041143`, 5.634789603169249}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.6888794541139363`, 1.0942695392339727`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.741256487054948, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.4722426732562555`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 1.322289031143978}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-7.1308988302963465`, 1.7328937163610187`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4947708374559745`, 5.886104031450156}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8799351601317804`, 7.22402480828583}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8461060995981784`, 2.004179057179289}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.2704687956143002`, 7.783224016336037}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.666828609658249, 
             4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2815740503494875`, 7.822444729489319}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-7.412267540691536, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.606941032235513, 6.173786103901937}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.7406415980494447`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.666828609658249, 
             4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.6661962462527091`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.7693434299437227`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.9353900445478294`, 5.768320995793772}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-8.412382827063892, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.0935997468445653`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.6378309869353183`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.8162894669713328`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.4138711288901251`, 7.090076835776092}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.36571568859088144`, 1.6034198401085373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.1587147225743437`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             1.9313764735639716`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820086052689358`, 6.921658184151129}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-8.350408373771412, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047875165492457`, 6.298949246855942}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.2072749131897207`, 1.726509584019938}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.4307829160924542, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4240364936935998, 8.1797604936999}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.220083871482302, 5.560681631015528}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-5.298317366548036, 2.6490076604684267`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2201021862558195`, 
             7.8838232148921525`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.9093711079059474`, 6.194405391104672}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.4911047254722358`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5059792040658704`, 2.0843046973458237`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 
             0.7802418874108791}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.3998672158005996`, 6.253828811575473}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.84195543139986, 4.386889790339869}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7903604483143476`, 
             2.0681277817795625`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-72.46692041972995, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.2568373311553196`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.2917089186300228`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.144222799920162}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-4.3428059215206005`, 3.2386784521643803`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.2919836816486494`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.3754861624032872`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.516892795645856, 6.0867747269123065`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-3.224893897193764, 1.937301774518713}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.8140100781628747`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.3540294005326152`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-0.696151689580244, 6.684611727667927}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.5338519254775054`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9065879564127699, 7.697121317282625}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-5.991464547107982, 1.445270566220188}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.506518858426259}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.793961892783255, 5.537334267018537}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.2181715237257489`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.60100614381313, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-4.76686592498839, 4.386889790339869}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.525061368884541, 1.7833912195575383`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.6623114020411685`, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164563795096671, 6.939253946041508}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.9105241293044104`, 5.393627546352362}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.2581768583394481`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.416581053724763}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.7406415980494447`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.7109170813839543`, 5.66988092298052}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.9904756300635316, 6.39024066706535}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4028684822608984, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.5554040239416147`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.2672179491567546`, 
             4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.896419739771488}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.2255369822417765`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.9510398268753117`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 2.078566158643882}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.0287936073591935`, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.402746540537711, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.044846896915337, 5.736572297479192}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.975450465015525, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-38.34104853637971, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.416581053724763}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 2.066736169182282}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 1.416581053724763}],
             3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.186787979571835, 1.7833912195575383`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.317867774075151, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.5257286443082556`, 1.266384064447333}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-7.957577403480815, 0.8046885552928528}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.8424288832756998}], 6., 
            
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.6587993419718245`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.162823150618887, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.2936253516225737`, 5.537334267018537}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 1.506518858426259}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.84195543139986, 4.386889790339869}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.2672179491567546`, 
             4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.2157956136516715, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6734432424100127`, 1.691939133945844}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-0.908818717035454, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.880084850028029, 5.723585101952381}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 1.671097292820828}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.662352421858305, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2909841813155656`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             2.0680013515372804`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.6624240079171049, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.66442222076686, 6.939253946041508}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.557794679282262, 1.8687205103641833`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.2319770007355333`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.5047438413194347`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4007990473227723`, 6.380122536899765}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-4.966857671750368, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.7418655495969406`, 4.386889790339869}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.2136588837996443`, 7.090076835776092}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.719252778441307, 6.684611727667927}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.841967538444134, 4.386889790339869}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7813228714636707, 7.822444729489319}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.5919427181706105`, 
             4.386889790339869}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.2761851384398606`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.532062329207643, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             2.0624225365102413`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.725971728690052, 6.104793232414985}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 0.9654617758806044}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.807005375881994, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.0794415416798357`, 2.187398683184928}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-3.6888794541139363`, 2.9290581402859983`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-68.46724388757043, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.9317114296555002`, 6.672032945461067}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.4569857892424236`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.804781390061982, 6.298949246855942}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.2669476034873244`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 1.0335402919243948`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-3.4420193761824103`, 3.2386784521643803`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-33.34092227159292, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-29.340832002509437`, 4.512945241945574}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.104554242494911, 2.421256622711544}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-6.03270329512458, 1.7328937163610187`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.869504817852908, 
             1.9892432737616872`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.2178763245351174`, 4.512945241945574}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2669126040998102`, 
             4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9515240188896708`, 1.6956156086751528`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.6444188813293459`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1111386284230904`, 5.66988092298052}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0442924641693683`, 1.9358598132018119`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.599387576580599}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.2909841813155656`, 2.414126467726953}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.606941032235513, 6.173786103901937}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.68510181635509}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-6.214608098422191, 2.3933394562625097`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.416581053724763}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.46298829435183064`, 6.81783057145415}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-2.214574215671332, 4.386765389021055}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.606941032235513, 6.173786103901937}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.7867719277170158`, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 0.9991602096964498}], 6., 
            
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.8826660279157308`}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.2756420910162956`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.4971646699513146`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.721515815839451}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1821389399181785`, 6.921658184151129}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-2.5609672964009644`, 4.969813299576001}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-6.571283042360924, 2.0471765810925606`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 2.0215475632609334`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.3071607397357723`, 1.864080130807681}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.2262184132732556`, 6.104793232414985}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             2.0680013515372804`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.6591800043289144`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-6.536881615643591, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-3.366795954944823, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4092798316650086`, 6.194405391104672}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5288198871382693, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.1236024374656055`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.4226262903672808`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.8499018253424513`, 6.253828811575473}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.659260036932778, 1.0845133642886082`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8953440995227226`, 1.9358598132018119`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.4722426732562555`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.5539252025038417`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.3162388941358785`, 4.787491742782046}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.9286606465811693`, 5.075173815233827}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-7.600902459542082, 1.6094379124341003`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.9540431322855023`, 5.676753802268282}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.0738571633859353`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.090999490513565}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.6888794541139363`, 5.298317366548036}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.7406415980494447`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3799147541558516`, 7.22402480828583}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.8843386505211481`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-31.34091993726656, 4.512945241945574}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.4958211856471328`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-2.617843933216061, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.9313764735639716`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8598242001421843`, 5.521460917862246}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.786359562282124, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.592214878401959, 4.386889790339869}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.564942672547549, 5.966146739123692}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.880084850028029, 5.723585101952381}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020229905154391, 5.583496308781699}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.090999490513565}],
             5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.340512168464763}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.201916872261721, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.7109170813839543`, 5.66988092298052}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 
             1.3754861624032872`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             1.8002235476401844`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.5978370007556204, 1.4964931534179662`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledDiamond]", {-6.717134919373487, 4.386889790339869}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.860379772276308, 5.393627546352362}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.605170185988091, 2.9290581402859983`}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.863232841258714, 0.8333438110532289}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.6761120457020933`, 6.104793232414985}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.8146187633741377`, 5.966146739123692}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8997902134417601`, 6.704414354964107}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.7406415980494447`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.536881615643591, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-5.411934093335004, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0189110419398038`, 6.584791392385716}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.599387576580599}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.4890765557629164`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.500433550670171, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706800981701778, 6.396929655216146}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4092798316650086`, 6.194405391104672}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.493879571799828, 4.386889790339869}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.3524072174927233`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.406587064387653}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.8002235476401844`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-8.849872629798755, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.018486244188825}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.3498863661120586`, 6.253828811575473}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.1026043099376472`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-6.912265434460023, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-4.8283137373023015`, 1.7328937163610187`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.5978370007556204, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.8470364847178946`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.2909841813155656`, 2.187398683184928}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.7031992922485748`, 7.600902459542082}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 1.5377270648801}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.0776338822829181`, 8.026170194946426}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.9093711079059474`, 6.194405391104672}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.6661962462527091`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.7406415980494447`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.599387576580599}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262403303361214, 6.841615476477592}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.6661962462527091`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 0.6951451832226183}], 6., 
            
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 2.187398683184928}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.7147984280919266`, 1.497835735852798}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.725332537920259, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.389499492068839, 5.991464547107982}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.820158943749753, 5.560681631015528}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 0.880041599199034}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316692464055834`, 6.672032945461067}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.0136538011418326`, 7.090076835776092}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.3540294005326152`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.540748536722336, 
             4.512945241945574}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.6527732864216721, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8951219822232084`, 5.886104031450156}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.7760829898430475`, 6.104793232414985}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-0.09926800165866902, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.6761120457020933`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2201021862558195`, 
             7.8838232148921525`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.835485924411894, 5.768320995793772}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 2.1872864686305826`}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.2262184132732556`, 6.104793232414985}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.2792657883613672`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.613467558616262, 6.040254711277414}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.2158025560795132`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5220551057175394, 1.4951487660319727`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.5232317641096684`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.744112815760702, 7.360103972989152}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-58.4670151515563, 4.386889790339869}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.725433722188183, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.864975531559314, 5.966146739123692}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-0.9122987106046175, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2783372196147982`, 1.864080130807681}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-1.0498221244986778`, 2.187398683184928}],
             5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.669026703845758}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.9005275521158795`, 
             4.386889790339869}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.6704076935904559, 6.960347729101308}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-0.8029620465671519, 7.600902459542082}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.989444152396731, 1.5107219394949427`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[CircleMinus]", {-5.2030071867437115`, 1.7328937163610187`}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-1.4528616053920038`, 7.600902459542082}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8122154777954373`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.9754419516613513`, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.6168849633501186`, 4.386765389021055}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346745988779815, 6.756932389247553}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316692464055834`, 6.672032945461067}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.3540294005326152`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.864704011147587, 1.3452119160186606`}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0302996484860225`, 2.1329823086078656`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.880084850028029, 5.723585101952381}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.01348899514325, 6.040254711277414}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.497835735852798}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-6.975391927697949, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0939462278827174`, 4.386889790339869}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.700547258981618, 4.386889790339869}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.987774353154012, 5.393627546352362}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.7378311272024993`}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.902767737471098, 4.512945241945574}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-4.199705077879927, 4.787491742782046}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.3137523001849649, 8.290041618704489}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3617968895195032`, 1.9416152247724325`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-7.036270701217564, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.559220196273483, 2.135349173618132}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.171276846068922, 1.9358598132018119`}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1526461771605954`, 1.8656293177945105`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.5703987153008919, 6.960347729101308}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3993162819538174`, 6.704414354964107}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyCircle]", {-3.117899907528199, 4.512945241945574}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-2.966950472128539, 1.937301774518713}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.2742448573112677`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4088348928367562`, 4.386765389021055}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0339487753423875`, 2.418588768750352}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.1625110145183415`, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0898959995836948`, 7.013915474810528}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.5978370007556204, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8805331812814825`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4524341636244356`, 7.151485463904735}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.6661962462527091`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.9510398268753117`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0288996762568094`, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.9368694044031642`}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.9205497887945385, 6.960347729101308}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledSquare]", {-1.369240606554063, 1.691939133945844}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.016955910005618, 6.0867747269123065`}],
             4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.26683423993894284`, 4.386889790339869}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0898959995836948`, 7.013915474810528}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.196424897165655, 6.907755278982137}], 
            4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.4722426732562555`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.664950622364359, 5.966146739123692}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-7.286383733136742, 4.512945241945574}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1028721491118945`, 1.937301774518713}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.5287678617828835`, 
             4.512945241945574}], 4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.618595850218866}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.0215475632609334`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 1.669026703845758}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.7147984280919266`, 1.726509584019938}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.555615105736594}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.6593256320844346, 7.944492163932159}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.380218975276964, 5.723585101952381}], 
            4.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-3.6100682736896466`, 5.393627546352362}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.7406415980494447`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.6240307955986357`, 6.429719478039138}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4912105310694506`, 
             7.6128310304073565`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.475392057419415, 4.386889790339869}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptyDiamond]", {-1.0891571298973546`, 6.29156913955832}],
             6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.529318843261892, 
             1.9033008439609624`}], 5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.3524072174927233`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[FilledCircle]", {-2.659260036932778, 1.416581053724763}], 
            3.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8305718564716175, 
             2.827905162910489}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8305718564716175, 
             2.827905162910489}], 5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-1.9661128563728327`, 1.497835735852798}],
             6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4126383364594925`, 1.8625285401162623`}], 
            5., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[CircleMinus]", {-2.3691523372661587`, 6.684611727667927}],
             4.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.376740148315079, 7.226936018493289}], 
            5.75, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[EmptySquare]", {-0.5978370007556204, 2.647592232065096}], 
            6.5, 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.236923904465622}], 6., 
            RGBColor[0, 0.7, 0]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.9474803442248305`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.7218733417638885`}], 5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9949325933834268`, 1.599387576580599}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-0.636577829072051, 7.24422751560335}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9240709191931175, 8.1797604936999}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.8805331812814825`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751531979714171, 5.8522024797744745`}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4679383501604009`, 1.7833912195575383`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-5.744604469176456, 2.3933394562625097`}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-2.7177975525570903`, 4.512945241945574}],
             5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.557794679282262, 5.823045895483019}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-32.34077434210908, 4.512945241945574}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262403303361214, 6.841615476477592}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-5.340807418168989, 4.512945241945574}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.25165731439258, 5.8522024797744745`}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-4.204382667431038, 4.499809670330265}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 6.999422467507961}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-36.34119244432727, 4.512945241945574}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.3418458069473482`, 
             4.386889790339869}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-4.605170185988091, 2.3933394562625097`}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5191402744533198`, 1.6882490928583902`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5366522427084526`, 7.56734567601324}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-6.725433722188183, 4.386889790339869}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.9510398268753117`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.813734143549063, 8.290041618704489}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.7937956240634962`, 1.6114359150967734`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.963188584855586}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.8122154777954373`}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.894078619827491, 4.386765389021055}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.995732273553991, 1.0335402919243948`}],
             6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-1.8195418502405067`, 6.684611727667927}],
             4.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.7435408969575807`, 5.537334267018537}],
             6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-3.017773404430871, 4.512945241945574}], 
            5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.653113060608557, 4.512945241945574}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2016421889876536`, 6.579251212010101}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7985076962177716, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.090999490513565}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-2.995732273553991, 1.2669476034873244`}],
             6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.2406103170142067`, 1.8656293177945105`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-1.5639866495301828`, 7.090076835776092}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-28.340907620492793`, 4.512945241945574}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.1921026317554486`}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6115589009134488`, 6.492239835020471}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.7985076962177716, 1.726509584019938}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-1.820158943749753, 5.560681631015528}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0604498275737608`, 2.0719132752590443`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.3731931852525583`, 1.860974538249528}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.278964002683987, 4.512945241945574}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-4.199705077879927, 2.0471765810925606`}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.746403767507258, 5.634789603169249}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.2669476034873244`}], 5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9477043045434095`, 1.8625285401162623`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.4307829160924542, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.2919836816486494`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-64.46739506232224, 4.386889790339869}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-2.9178457348969196`, 4.512945241945574}],
             5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-1.808498793232353, 7.295735072749282}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 1.599387576580599}],
             3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.9661128563728327`, 1.726509584019938}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-6.907755278982137, 0.8046885552928528}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-3.522010001878903, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.7985076962177716, 1.497835735852798}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 0.9034081060431414}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0923241675108497`, 
             4.386889790339869}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 0.9543569326806114}], 6., 
            
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.4686200579795896`, 1.7817091333745536`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-0.3492738284584218, 4.512945241945574}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4118173183509766`, 1.5973653311998313`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.9510398268753117`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9712750402069146, 
             7.6324011266014535`}], 4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6115589009134488`, 6.492239835020471}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-1.4961092271270973`, 6.907755278982137}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.9368694044031642`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-2.3025850929940455`, 6.684611727667927}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7306413849875258, 
             2.827905162910489}], 5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.040959012419865, 
             4.512945241945574}], 5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-3.283414346005772, 5.703782474656201}], 
            4.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.9510398268753117`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5188771693591536`, 6.584791392385716}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6311724045801064`, 1.4883995840570443`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0939232991819783`, 4.386889790339869}], 5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7789229575813493, 
             4.512945241945574}], 4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.808498793232353, 7.295735072749282}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0918353043890858`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-6.662458923026794, 4.512945241945574}], 
            5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9317114296555002`, 6.672032945461067}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0891571298973546`, 2.0082140323914683`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-5.403677882205863, 1.445270566220188}], 
            4.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-1.9696906777207166`, 6.684611727667927}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.1850957485562468`}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-8.850570223130148, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.900458886151396, 5.480638923341991}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1080567474961094`, 6.272877006546167}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.809109107563168, 1.4951487660319727`}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.3540294005326152`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.8146618624453594`}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledDiamond]", {-4.166915255056936, 4.386889790339869}],
             4.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-0.7985076962177716, 2.647592232065096}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-8.047189562170502, 1.2424239907001886`}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.9569913819232716`}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2815740503494875`, 7.822444729489319}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8122154777954373`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7625890919282752`, 6.841615476477592}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.779362064213738, 4.512945241945574}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 1.599387576580599}],
             3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8122154777954373`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.599387576580599}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledCircle]", {-1.443923473956527, 2.418588768750352}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.527397202097891, 7.076653815443951}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.1499389158334503`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 1.599387576580599}],
             3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.864704011147587, 1.0732944806838198`}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-8.286478374605709, 4.512945241945574}], 
            5.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.8805331812814825`}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.529318843261892, 4.512945241945574}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324790142551358`, 5.971261839790462}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8997902134417601`, 6.704414354964107}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.6888794541139363`, 0.8505781885087738}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4850103340590484`, 2.135349173618132}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262403303361214, 6.841615476477592}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.700587583759682, 4.386889790339869}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.552112845814831, 5.8289456176102075`}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-4.196377287787253, 1.0360274134764884`}],
             5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.7406415980494447`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 0.9329511727672622}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.552112845814831, 7.55171221535131}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9317114296555002`, 6.672032945461067}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.2909841813155656`, 1.497835735852798}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-63.46698269688735, 4.386889790339869}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-6.140893060599911, 4.512945241945574}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-2.563430511492267, 6.040254711277414}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.6661962462527091`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.8344641259578687`, 6.152732694704104}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-7.725332537920259, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.8056623743970464`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.599387576580599}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 1.5377270648801}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.399798360748448, 1.7833912195575383`}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-7.536426440357718, 4.512945241945574}], 
            5.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-0.536314386533157, 4.512945241945574}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3257638613798584`, 1.776645831418007}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.0215475632609334`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2595256035335987`, 5.521460917862246}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.516892795645856, 6.0867747269123065`}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.5902550930173265`}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-6.786422993814612, 4.512945241945574}], 
            5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-0.4307829160924542, 2.187398683184928}], 
            5.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-3.522010001878903, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.4407825464039603`}], 5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-3.184232881424661, 1.860974538249528}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7573580425107227`, 1.589235205116581}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 1.4964931534179662`}], 
            5.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.9028810449642375, 
             4.512945241945574}], 4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1214715828141923`, 1.9387416595767009`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9840343839606746, 6.396929655216146}],
             6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0027568884909557`, 1.7833912195575383`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.2319770007355333`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.715777948205427}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-2.8179208722379223`, 4.512945241945574}],
             5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledCircle]", {-1.313415715707318, 2.498151876538021}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.380218975276964, 5.723585101952381}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8097197946050478`, 7.294377299288821}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.6544352783648362`, 5.676753802268282}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.599387576580599}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-2.6609757937162812`, 4.969813299576001}],
             6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.6888794541139363`, 0.9669838461896731}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-2.2256240518579173`, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.5978370007556204, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledDiamond]", {-4.566911473871001, 4.386889790339869}],
             4.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 1.506518858426259}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2669126040998102`, 4.386889790339869}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.726509584019938}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.993630885266725, 5.537334267018537}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2016421889876536`, 6.579251212010101}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.95263269481614, 7.151485463904735}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.795734531747094, 
             5.991464547107982}], 5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-2.540842282118304, 4.512945241945574}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7625890919282752`, 6.841615476477592}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 0.8450095298691913}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6149530931222105`, 7.488852955733459}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.3649243353836982`, 5.966146739123692}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-1.0029385385998273`, 7.600902459542082}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.995732273553991, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8195418502405067`, 6.784457062637643}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-0.8940401229393353, 4.386889790339869}],
             5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.084253098677058, 4.386765389021055}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.2919836816486494`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 0.9858167945227654}],
             5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.107781777362614, 1.8625285401162623`}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyUpTriangle]", {-1.05211045501669, 7.55171221535131}],
             5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             1.5532907518110994`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3037931396081468`, 6.476972362889683}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3482281603134343`, 2.1329823086078656`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-0.18777640747691846`, 7.1929342212158}],
             6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-2.66341149948383, 6.040254711277414}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8195418502405067`, 6.784457062637643}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706800981701778, 6.396929655216146}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111964733385396, 6.492239835020471}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.100765130025024, 4.386889790339869}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520318812570019, 5.583496308781699}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.7042981934580606`, 
             4.386765389021055}], 4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.6772785424354564`, 6.309918278226516}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.49314943875304795`, 6.887552571664617}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.7985076962177716, 1.4964931534179662`}], 
            5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132468797127462, 5.971261839790462}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.3964921860963366`}], 5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.3261404383001434`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7625890919282752`, 6.841615476477592}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-6.807005375881994, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0417762120553977`, 1.4883995840570443`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-7.786268646522262, 4.512945241945574}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.5978370007556204, 1.726509584019938}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.708153885373258, 5.823045895483019}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.5558971455060706`, 2.3456445824544927`}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.25165731439258, 5.8522024797744745`}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-2.9634587130036953`, 6.040254711277414}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.864975531559314, 5.966146739123692}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0272286702329017`, 7.076653815443951}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2909841813155656`, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.9736550492637259, 1.9198594718553708`}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.7406415980494447`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.380218975276964, 5.723585101952381}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.6888794541139363`, 0.7485818874480459}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.0808706071919527`, 6.249975242259483}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346745988779815, 6.756932389247553}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.716864386545305, 4.386889790339869}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 1.406587064387653}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.8944568674663975`, 
             4.386765389021055}], 4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8457617469776957`, 5.991464547107982}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.2919836816486494`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.395133309787095, 2.0731719286662407`}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0129050178795915`, 5.768320995793772}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8805331812814825`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520318812570019, 5.583496308781699}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0918353043890858`, 
             4.386889790339869}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledDiamond]", {-3.76705723517796, 4.386889790339869}], 
            4.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-4.940782792197422, 4.512945241945574}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledDiamond]", {-4.366940997255841, 4.386889790339869}],
             4.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.9372477759766606`, 5.393627546352362}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7985076962177716, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-2.219163484854973, 5.111987788356544}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-3.030116700415822, 1.864080130807681}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-4.504420282887948, 4.499809670330265}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.4847813078345447`}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledDiamond]", {-3.567015866357096, 4.386889790339869}],
             4.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7985076962177716, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-0.8130574772325029, 6.81783057145415}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.807796846925679}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.8162894669713328`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-2.2256240518579173`, 4.386889790339869}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 1.133013715385442}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.6544352783648362`, 5.676753802268282}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.6744763086133228`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8805331812814825`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8470607850131444`, 6.756932389247553}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.2809338454620642`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-7.1622605067393605`, 4.512945241945574}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1150465951315345`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.5645401798583287`, 1.6956156086751528`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.9670073137609054`, 4.386889790339869}], 
            4.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 0.7802418874108791}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-5.009386074695824, 4.0943445622221}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 6.999422467507961}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.100386954332169, 4.386889790339869}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.0498221244986778`, 1.497835735852798}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.531088946023124, 6.249975242259483}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2371849385320495`, 1.9401794743463283`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.8006962066887295`, 
             4.386889790339869}], 5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.7406415980494447`}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-0.7129418078881248, 6.81783057145415}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5173146235582946`, 7.086737934510577}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4179914478631452`, 6.363028103540465}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.036482917202561, 7.56734567601324}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-4.991862608772972, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.1151415906193203`}], 5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-0.6624240079171049, 4.512945241945574}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8799351601317804`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2909841813155656`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.7406415980494447`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132468797127462, 5.971261839790462}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5832829549572491`, 1.5933085305042167`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.6825463842547386`, 2.2648832258100344`}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-4.509860006183766, 4.0943445622221}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8933068954837797, 6.887552571664617}],
             6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.344384958042681, 7.759614150696903}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8470607850131444`, 6.756932389247553}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7170231231140378`, 6.063785208687608}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-2.795734531747094, 5.991464547107982}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-2.475392057419415, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.8056623743970464`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7969533492855345, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262403303361214, 6.841615476477592}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.900422093749666, 4.386889790339869}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2496677635880655`, 6.131226489483141}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-37.34075273404506, 4.512945241945574}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-3.0635829404621653`, 6.040254711277414}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8805331812814825`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledCircle]", {-0.7667937207282438, 4.386889790339869}],
             3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 1.599387576580599}],
             5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3838972365201692`, 6.396929655216146}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 0.8060293376166178}], 
            5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.700587583759682, 4.386889790339869}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.9518038754399907`, 1.4973884086254774`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-0.5878866699024524, 7.1929342212158}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-2.2246985543369746`, 6.429719478039138}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-1.2909841813155656`, 1.266384064447333}],
             5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-5.201916872261721, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.0497721232486361`}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-2.019664337643975, 6.684611727667927}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.7188583998188136`, 5.111987788356544}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.2170885989659, 4.386889790339869}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-2.174191878225647, 6.429719478039138}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.6661962462527091`}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.3039860739096736`, 
             4.386765389021055}], 4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.2909841813155656`, 1.726509584019938}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.4938666711595117`, 4.386889790339869}], 5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.4122057429043917`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7199019178687649, 
             7.8838232148921525`}], 4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.9093711079059474`, 6.194405391104672}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.5107219394949427`}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 1.170932950247736}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7985076962177716, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.036482917202561, 7.56734567601324}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.696151689580244, 6.684611727667927}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.612442421454399, 5.768320995793772}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             0.9411784473819341}], 5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-2.674083651538937, 6.429719478039138}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.8442026554799011, 7.759614150696903}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3082228256997352`, 7.295735072749282}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8122154777954373`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.599387576580599}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.1167795926235586`}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1199358770132974`, 1.599387576580599}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             1.2756420910162956`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.652827532407001, 4.512945241945574}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.5432981099295553`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-2.0939462278827174`, 5.537334267018537}],
             6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.4371455863897404`, 5.393627546352362}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0272286702329017`, 7.076653815443951}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-2.5257286443082556`, 6.461468176353717}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.238564249095555, 7.365180126021013}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3799147541558516`, 7.22402480828583}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.5920892740994874`, 
             4.386889790339869}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6149530931222105`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-6.437751649736401, 0.973049065692764}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3528595850336531`, 7.751045117971802}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8122154777954373`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.2761851384398606`, 6.104793232414985}],
             6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-3.868484703413663, 1.501852701754163}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5082360319251331`, 6.272877006546167}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 0.9489515141137035}],
             5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8997902134417601`, 6.704414354964107}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6115589009134488`, 6.492239835020471}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.067986095126349, 2.3456445824544927`}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164563795096671, 6.939253946041508}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.4588475538015993`}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-2.023439351564551, 5.2574953720277815`}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.3418458069473482`, 
             4.386889790339869}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1821389399181785`, 6.921658184151129}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.6661962462527091`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-0.3960099493374092, 6.984716320118266}],
             6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.6916833814466705`, 1.6956156086751528`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.344384958042681, 7.759614150696903}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.319222734147069, 6.784457062637643}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520318812570019, 5.583496308781699}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-27.341341040814093`, 4.512945241945574}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346745988779815, 6.756932389247553}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.8122154777954373`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.2787091504399533`}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-3.2602187884025833`, 5.393627546352362}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0189110419398038`, 6.584791392385716}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1150465951315345`, 7.488852955733459}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.2319770007355333`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-7.662352421858305, 4.512945241945574}], 
            5.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.804781390061982, 6.298949246855942}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.251619457793289}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.599387576580599}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.500433550670171, 4.386889790339869}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111964733385396, 6.492239835020471}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-1.036482917202561, 4.512945241945574}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.9563317814113389, 6.674561391814426}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.8205261098897758, 6.960347729101308}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-3.9165331609060323`, 4.787491742782046}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.4203757208439185, 6.960347729101308}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-2.1464364105041143`, 6.907755278982137}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-0.6539264674066639, 4.386889790339869}],
             5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3208812225716584`, 2.0095554142156695`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.5338519254775054`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-8.850570223130148, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8951219822232084`, 5.886104031450156}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.744112815760702, 7.360103972989152}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.5845302767279155`}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8805331812814825`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.064355904261795, 6.539585955617669}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0929041853062644`, 1.7833912195575383`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.6939993778795506`, 
             4.386765389021055}], 4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1270117631898076`, 6.253828811575473}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-1.9754419516613513`, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-0.273910668367863, 4.386889790339869}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-40.340943771488284`, 4.512945241945574}],
             6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.6661962462527091`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-6.662458923026794, 4.512945241945574}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 1.599387576580599}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1821389399181785`, 6.921658184151129}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.9093711079059474`, 6.194405391104672}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.7960662345677868, 6.984716320118266}],
             6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.878196476740593, 
             1.7776605448485534`}], 5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-1.5960282255241827`, 6.907755278982137}],
             4.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.3420861064555702`, 
             4.386889790339869}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6029589463363911`, 7.501082124259871}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4912105310694506`, 
             7.6128310304073565`}], 5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-7.036270701217564, 4.512945241945574}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7168253079145225, 
             4.386889790339869}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7813228714636707, 7.822444729489319}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-3.7317869551252127`, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-1.8799351601317804`, 7.22402480828583}],
             6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.8078888511579385`, 5.823045895483019}],
             6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-2.659260036932778, 1.007592890280941}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-0.8563722416629115, 6.674561391814426}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-3.741015208534465, 4.512945241945574}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.1760334356366946`, 6.104793232414985}],
             6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.8420006856648017`, 
             4.386889790339869}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-2.007679175452945, 5.823045895483019}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1806171127511105`, 1.7817091333745536`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820086052689358`, 6.921658184151129}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.703510521060178, 1.8389610707123492`}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             1.3302529702362658`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2437536743377806`, 7.360103972989152}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-0.7985076962177716, 1.266384064447333}], 
            5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-2.4018530946527146`, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-2.3191210616341453`, 6.684611727667927}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.483987072728617, 4.386765389021055}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.340556469446037, 6.040254711277414}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2069773133462347`, 6.173786103901937}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 1.144222799920162}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[CircleMinus]", {-5.2030071867437115`, 2.3933394562625097`}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0963149296194261`, 6.684611727667927}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-6.912265434460023, 4.512945241945574}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-0.8505029913361519, 4.386889790339869}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3037931396081468`, 6.476972362889683}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3093333199837622`, 7.294377299288821}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.156840433948748, 1.6974487897568136`}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-2.168928708181372, 5.111987788356544}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.946310229076653, 7.157735484249907}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-3.1958919884778254`, 
             5.991464547107982}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3093333199837622`, 7.294377299288821}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.8958869385842747`, 
             5.991464547107982}], 5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.406905315024015, 7.697121317282625}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.279055610450292, 2.0731719286662407`}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-7.975450465015525, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0969137320325284`, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.2299329059954676`}], 5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.016955910005618, 6.0867747269123065`}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.9568962497687927`, 1.7316555451583497`}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.900422093749666, 4.386889790339869}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.9969586349416099, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.4312677267626217`}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-71.46678568954108, 4.386889790339869}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5173146235582946`, 7.086737934510577}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 1.68510181635509}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1304126012179074`, 2.1329823086078656`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.6777417097034806`, 1.601405740736836}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.327296573822621, 1.7850704810772584`}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.5779472453427295`}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.2262184132732556`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-59.467094916063616`, 4.386889790339869}],
             6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-2.1413169453979233`, 4.512945241945574}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-0.786359562282124, 4.512945241945574}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2595256035335987`, 5.521460917862246}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.168283961917429, 2.0719132752590443`}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-1.7254100886865211`, 4.386889790339869}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.2808538486618937`, 6.249975242259483}],
             6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2026403590921573`, 2.0095554142156695`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-0.9122987106046175, 4.512945241945574}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-4.216512196196308, 4.787491742782046}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8195418502405067`, 6.784457062637643}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[CircleMinus]", {-3.6888794541139363`, 2.3933394562625097`}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.5732134108799993`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.9317114296555002`, 6.672032945461067}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 1.421661504957182}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-6.786422993814612, 4.512945241945574}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5082360319251331`, 6.272877006546167}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5188771693591536`, 6.584791392385716}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.6298561136644754`, 1.6956156086751528`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 5.991464547107982}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-3.395911377232918, 5.991464547107982}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.599387576580599}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-2.8610265707016995`, 4.969813299576001}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.0498221244986778`, 1.726509584019938}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-7.786268646522262, 4.512945241945574}], 
            5.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-2.1269525243508878`, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.864704011147587, 1.3326298365341978`}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4405393759722864`, 5.940171252720432}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.4907663827166018`, 6.39024066706535}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.6744763086133228`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.946310229076653, 7.157735484249907}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.741858378904823, 1.6034198401085373`}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.8947738884119054, 1.7316555451583497`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.4964931534179662`}],
             5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.30031936921871, 4.386889790339869}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.3149043650332175`, 5.966146739123692}],
             6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.3811078344325904`, 6.249975242259483}],
             6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.000759888500605, 6.380122536899765}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 1.0360274134764884`}], 
            5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 1.0360274134764884`}], 
            5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640797356921787`, 6.539585955617669}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.406905315024015, 7.697121317282625}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.4929837772928636`, 1.6974487897568136`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.3281354469463584`}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-2.475392057419415, 4.386889790339869}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6798603767306461`, 7.424165281042028}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4296194858582643`, 7.674152921281675}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6115589009134488`, 6.492239835020471}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-0.3504089023600859, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8773173575897015`, 7.226936018493289}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.152897360346143, 4.512945241945574}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1958919884778254`, 5.991464547107982}], 5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2437536743377806`, 7.360103972989152}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.795734531747094, 
             5.991464547107982}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-39.34081340913477, 4.512945241945574}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.1541650878757723`, 5.676753802268282}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.2367852454117685`, 1.599387576580599}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.8442026554799011, 7.759614150696903}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8016236568960291, 6.579251212010101}],
             6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 1.4964931534179662`}], 
            5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.0808706071919527`, 6.249975242259483}],
             6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.9910142780700916, 7.6128310304073565`}],
             5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-4.781788039865368, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1702157075278026`, 7.433666540166168}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 0.7975071958841882}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-1.389499492068839, 5.991464547107982}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.4146938356415886`, 5.966146739123692}],
             6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2069773133462347`, 6.173786103901937}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2361517026901712`, 2.1329823086078656`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-2.7499665442035015`, 6.253828811575473}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.253208503948706, 1.7850704810772584`}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.7788336680347445`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.0845133642886082`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4007990473227723`, 6.380122536899765}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.8528465593176202, 7.751045117971802}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-5.744604469176456, 1.7328937163610187`}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.131032179924221, 6.249975242259483}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-1.9754419516613513`, 4.386889790339869}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324790142551358`, 5.971261839790462}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-5.740861482897622, 4.512945241945574}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.30031936921871, 4.386889790339869}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5228016057745537`, 5.857933154483459}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 0.8989410935390421}],
             6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-0.8505029913361519, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3005870903313728`, 5.480638923341991}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-3.660097652688484, 5.393627546352362}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4714166145367258`, 
             7.6324011266014535`}], 4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-2.693851481702397, 4.386889790339869}], 
            5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1026203100656484`, 2.2648832258100344`}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-8.599488434143067, 4.512945241945574}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0592954262911594`, 6.721425700790643}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 0.766397642299538}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-7.1308988302963465`, 0.973049065692764}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-3.941966881801218, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.028919972120757, 4.512945241945574}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.0261055978813616`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.30031936921871, 4.386889790339869}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-8.162319869424133, 4.512945241945574}], 
            5.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0189110419398038`, 6.584791392385716}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-7.600902459542082, 1.445270566220188}], 
            4.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-3.6504282677396835`, 1.5432981099295553`}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.8006962066887295`, 
             4.386889790339869}], 5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-1.4753441779534016`, 4.386889790339869}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.101092789211817, 0.911479174876933}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-3.145857732131629, 5.991464547107982}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.9146052992269007`, 5.966146739123692}],
             6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.4532518292447716`}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-3.7317869551252127`, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.23395175003081314`, 7.146772179452637}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7389772837890856`, 7.365180126021013}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.900588627802483, 4.386889790339869}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.25165731439258, 5.8522024797744745`}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-2.4018530946527146`, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1026203100656484`, 7.501082124259871}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020229905154391, 5.583496308781699}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0277811079075183`, 1.9768549529047348`}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.9372477759766606`, 5.393627546352362}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.3470736479666092`, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.1780394222994315`}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.5539252025038417`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.5159350591325786`, 1.6034198401085373`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.599387576580599}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3993162819538174`, 6.704414354964107}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5782126424678459, 1.5432981099295553`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8097197946050478`, 7.294377299288821}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.252691173362931, 1.6974487897568136`}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-8.350408373771412, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 1.4964931534179662`}], 
            5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-7.975450465015525, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.25165731439258, 5.8522024797744745`}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.5895081458004594, 6.7912214627261855`}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9038682118755978, 6.476972362889683}],
             6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.219163484854973, 5.111987788356544}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.336815122732887, 1.6974487897568136`}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.1966460289394751`}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.319222734147069, 6.784457062637643}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1796551117149194`, 1.4906543764441336`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.0360274134764884`}],
             5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.902818692021688, 4.512945241945574}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1663559407546291`, 6.214608098422191}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.6339353209280992, 7.146772179452637}],
             6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.8269722249837996`, 2.1825620503943153`}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.659260036932778, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262403303361214, 6.841615476477592}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-8.94874563428772, 0.973049065692764}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-1.0498221244986778`, 1.266384064447333}],
             5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5366522427084526`, 7.56734567601324}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2736802167507564`, 6.507277712385012}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9896682016789307, 6.7912214627261855`}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 0.8307328435125084}],
             6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.421604191439818, 1.6956156086751528`}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-1.926205565780978, 7.3777589082278725`}],
             4.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-7.912330925723864, 4.512945241945574}], 
            5.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8734707346912269, 6.507277712385012}],
             6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-2.7188583998188136`, 5.111987788356544}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3082228256997352`, 7.295735072749282}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316692464055834`, 6.672032945461067}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-2.2739976361421332`, 6.429719478039138}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4714166145367258`, 7.6324011266014535`}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-8.412382827063892, 4.512945241945574}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0272286702329017`, 7.076653815443951}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.66442222076686, 6.939253946041508}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346745988779815, 6.756932389247553}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-2.8610265707016995`, 4.969813299576001}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.380218975276964, 5.723585101952381}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             1.2908841763152323`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1080567474961094`, 6.272877006546167}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.5432981099295553`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-2.3109197297841035`, 4.969813299576001}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.4964931534179662`}],
             5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-7.912330925723864, 4.512945241945574}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.9005275521158795`, 
             4.386889790339869}], 5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7168253079145225, 
             4.386889790339869}], 4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6044503709230613`, 6.999422467507961}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.744112815760702, 7.360103972989152}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.7148128361404407`, 1.4996230464268938`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-2.449925680892755, 6.253828811575473}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.376740148315079, 7.226936018493289}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-7.284632930238389, 
             1.6094379124341003`}], 5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-8.036311444023319, 4.512945241945574}], 
            5.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-0.3504089023600859, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 6.684611727667927}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-2.2256240518579173`, 4.386889790339869}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.0738571633859353`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             1.1990607599649155`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-0.606235808570649, 6.674561391814426}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8997902134417601`, 6.704414354964107}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.48175237628028356`, 
             8.122074375362217}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 0.9290095042819297}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.016955910005618, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-1.7254100886865211`, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132468797127462, 5.971261839790462}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.21678878567620194`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.5732134108799993`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6702500518308578`, 7.433666540166168}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-1.340556469446037, 6.040254711277414}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0592954262911594`, 6.721425700790643}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.327853987437946, 1.6034198401085373`}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5901256014017275`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9065879564127699, 7.697121317282625}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8830977645183911, 6.897704943128636}],
             6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-4.57270299585059, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-3.1958919884778254`, 
             5.991464547107982}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-4.991862608772972, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 0.9925107577855641}],
             6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1026203100656484`, 7.501082124259871}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2282654968949804`, 6.152732694704104}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.0654001544619962`}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.3003570667360838`, 
             4.386889790339869}], 5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.9296292963133357, 7.674152921281675}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-1.95263269481614, 7.151485463904735}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.48304834276654407`, 6.897704943128636}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-3.1958919884778254`, 
             5.991464547107982}], 5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 6.999422467507961}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8470607850131444`, 6.756932389247553}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.4371455863897404`, 5.393627546352362}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 0.898534010284896}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 0.8028980445190645}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-62.46685674510361, 4.386889790339869}], 
            6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-4.15218556191195, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.500433550670171, 4.386889790339869}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.700547258981618, 4.386889790339869}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 0.9345235001352147}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.319222734147069, 6.784457062637643}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-1.746403767507258, 6.907755278982137}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledSquare]", {-3.604906020337758, 1.601405740736836}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.2170885989659, 4.386889790339869}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.3649243353836982`, 5.966146739123692}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.5332441625824873`, 1.4951487660319727`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.017406150760383, 7.086737934510577}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7389772837890856`, 7.365180126021013}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.6003175012993283`, 
             4.386889790339869}], 5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.95263269481614, 7.151485463904735}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[FilledCircle]", {-1.984131361875511, 7.003065458786462}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-1.6960857191597725`, 6.907755278982137}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1279381180499384`, 2.1174596088673567`}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.1406850650900175`, 6.39024066706535}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.406905315024015, 7.697121317282625}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-0.8505029913361519, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9712750402069146, 
             7.6324011266014535`}], 4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1796054478776414`, 7.424165281042028}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.4370318346713713`, 1.599387576580599}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5173146235582946`, 7.086737934510577}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.322289031143978}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-1.160913314865489, 6.620073206530356}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1199380753828623`, 2.065596134857783}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.319222734147069, 6.784457062637643}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.082935809283102, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6798603767306461`, 7.424165281042028}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-1.5136732904497212`, 7.090076835776092}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640797356921787`, 6.539585955617669}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.2406367886975274`, 6.39024066706535}], 
            6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-2.1269525243508878`, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9816295731824954, 8.122074375362217}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.95263269481614, 7.151485463904735}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-4.362224007377702, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-3.710307401527557, 5.393627546352362}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-2.0794415416798357`, 6.907755278982137}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[FilledCircle]", {-1.95263269481614, 2.1174596088673567`}],
             3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-4.57270299585059, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.1541650878757723`, 5.676753802268282}],
             6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9065879564127699, 7.697121317282625}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520318812570019, 5.583496308781699}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.036482917202561, 7.56734567601324}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-8.11206147220931, 0.973049065692764}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.4226262903672808`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.238564249095555, 7.365180126021013}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-3.270169119255751, 1.6272778305624314`}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0177699008240089`, 6.363028103540465}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.0598714603516792`}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.802272141469027, 1.4951487660319727`}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 6.999422467507961}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.064355904261795, 6.539585955617669}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-0.6593256320844346, 6.721425700790643}],
             6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-4.909388227079972, 4.0943445622221}], 
            4.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.266384064447333}], 
            5.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.3082536360194172`, 1.4929040961781488`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.424056675808238, 1.4951487660319727`}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.900588627802483, 4.386889790339869}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7625890919282752`, 6.841615476477592}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.4122057429043917`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-8.350408373771412, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[CircleMinus]", {-4.609379030762146, 4.0943445622221}], 
            4.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-3.0957736277342174`, 
             5.991464547107982}], 5., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1230074455028314`, 2.1825620503943153`}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             1.1597073880279205`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0272286702329017`, 7.076653815443951}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9317114296555002`, 6.672032945461067}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164563795096671, 6.939253946041508}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3799147541558516`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.5005758256424344`, 
             4.386889790339869}], 5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1796054478776414`, 7.424165281042028}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9065879564127699, 7.697121317282625}],
             6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3082228256997352`, 7.295735072749282}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8799351601317804`, 7.22402480828583}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2330583852210326`, 
             7.8709295967551425`}], 5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.6302332586812027`, 1.4951487660319727`}], 
            5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-2.5740001929819547`, 6.429719478039138}],
             4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-4.781788039865368, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3082228256997352`, 7.295735072749282}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-4.362224007377702, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.946310229076653, 7.157735484249907}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.60100614381313, 4.386889790339869}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.808498793232353, 7.295735072749282}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             1.0678093795130645`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.191191469961203}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-0.7607838292757566, 6.620073206530356}],
             6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6044503709230613`, 6.999422467507961}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164563795096671, 6.939253946041508}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.8871696540327132`, 5.393627546352362}],
             6.5, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8799351601317804`, 7.22402480828583}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-4.541256860244439, 4.512945241945574}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8337895103624113, 6.946975992135418}],
             6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.808498793232353, 7.295735072749282}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[Times]", {-4.140807436632442, 4.512945241945574}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 1.018486244188825}],
             4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[CircleMinus]", {-4.3428059215206005`, 2.6490076604684267`}], 
            4.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3993162819538174`, 6.704414354964107}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-7.523941418405954, 1.497835735852798}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.2045513527226803`, 5.676753802268282}],
             6.5, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.0289048762432895`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8195418502405067`, 6.784457062637643}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[Times]", {-1.2255369822417765`, 4.386889790339869}], 6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6149530931222105`, 7.488852955733459}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.10045059841862, 4.386889790339869}], 
            5.75, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-0.6593256320844346, 6.721425700790643}],
             6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-3.2957568692041583`, 
             5.991464547107982}], 5., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132468797127462, 5.971261839790462}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1702157075278026`, 7.433666540166168}],
             4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            5.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.000759888500605, 6.380122536899765}], 
            6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.1499389158334503`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1080567474961094`, 6.272877006546167}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9038682118755978, 6.476972362889683}],
             6., 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 6., 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.95263269481614, 7.151485463904735}], 
            4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.2809338454620642`}], 4.25, 
            RGBColor[0., 0.75, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.5016459737922982`, 1.9198594718553708`}], 
            3.75, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.238564249095555, 7.365180126021013}], 
            4.25, 
            RGBColor[0.75, 0.75, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 0.766397642299538}],
             4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[Times]", {-3.941966881801218, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.1603343472961065`}], 4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[Times]", {-8.036311444023319, 4.512945241945574}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-8.286478374605709, 4.512945241945574}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1702157075278026`, 7.433666540166168}],
             4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9317114296555002`, 6.672032945461067}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3799147541558516`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4524341636244356`, 7.151485463904735}],
             4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.2917089186300228`}], 4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-0.4338645826298623, 6.946975992135418}],
             6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.380218975276964, 5.723585101952381}], 
            4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[CircleMinus]", {-7.1308988302963465`, 1.2424239907001886`}], 
            4.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.9317114296555002`, 6.672032945461067}],
             4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.104554242494911, 6.999422467507961}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             1.0281898243715637`}], 4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-7.1308988302963465`, 1.445270566220188}],
             4.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3993162819538174`, 6.704414354964107}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7903190923122189, 1.6272778305624314`}], 
            3.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.5005758256424344`, 
             4.386889790339869}], 5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820086052689358`, 6.921658184151129}],
             4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4460443655256647`, 7.157735484249907}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-5.744604469176456, 2.0471765810925606`}],
             4.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640797356921787`, 6.539585955617669}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6029589463363911`, 7.501082124259871}],
             4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1026203100656484`, 7.501082124259871}],
             4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             0.9364854391596744}], 4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             0.8977193462887197}], 4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8470607850131444`, 6.756932389247553}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.527397202097891, 7.076653815443951}], 
            4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-6.607650686531799, 1.445270566220188}], 
            4.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9712750402069146, 
             7.6324011266014535`}], 4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8097197946050478`, 7.294377299288821}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4524341636244356`, 7.151485463904735}],
             4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-9.567158183262826, 0.8046885552928528}], 
            4.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-1.4753441779534016`, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-7.600902459542082, 0.973049065692764}], 
            4.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.101092789211817, 0.7802418874108791}], 
            4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.064355904261795, 6.539585955617669}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[Times]", {-4.15218556191195, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1026203100656484`, 7.501082124259871}],
             4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6044503709230613`, 6.999422467507961}],
             4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-6.571283042360924, 1.7328937163610187`}],
             4.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0272286702329017`, 7.076653815443951}],
             4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 1.0360274134764884`}],
             5.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.100426344668657, 4.386889790339869}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1821389399181785`, 6.921658184151129}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.5366522427084526`, 7.56734567601324}],
             6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-8.622553707074063, 0.8046885552928528}], 
            4.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7625890919282752`, 6.841615476477592}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6702500518308578`, 7.433666540166168}],
             4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.7329280505717899, 7.8709295967551425`}],
             5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.0580715159436433`, 5.823045895483019}],
             6.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8470607850131444`, 6.756932389247553}],
             4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4714166145367258`, 
             7.6324011266014535`}], 4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[Times]", {-8.162319869424133, 4.512945241945574}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.3434070875143007`, 5.537334267018537}],
             6.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledCircle]", {-2.064355904261795, 2.065596134857783}], 
            3.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.036482917202561, 7.56734567601324}], 
            4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.6311724045801064`, 6.249975242259483}],
             6.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5188771693591536`, 6.584791392385716}],
             4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             0.8055826098897335}], 4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-7.819058469345253, 
             1.3540294005326152`}], 5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4524341636244356`, 7.151485463904735}],
             4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8097197946050478`, 7.294377299288821}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5366522427084526`, 7.56734567601324}], 
            4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4460443655256647`, 7.157735484249907}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8773173575897015`, 7.226936018493289}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.247228312996893, 6.5337888379333435`}],
             6.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316692464055834`, 6.672032945461067}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[CircleMinus]", {-6.214608098422191, 2.0471765810925606`}],
             4.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-7.600902459542082, 1.2424239907001886`}],
             4.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.3137523001849649, 8.290041618704489}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6029589463363911`, 7.501082124259871}],
             4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[Times]", {-1.2255369822417765`, 4.386889790339869}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.0845133642886082`}], 
            3.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 1.0360274134764884`}], 
            5.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1702157075278026`, 7.433666540166168}],
             4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2815740503494875`, 7.822444729489319}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.030860186617291, 6.249975242259483}], 
            6.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5901256014017275`, 7.013915474810528}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.7199019178687649, 7.8838232148921525`}], 
            6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6149530931222105`, 7.488852955733459}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.813734143549063, 8.290041618704489}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-0.9631203192309531, 6.81783057145415}], 
            6.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.66442222076686, 6.939253946041508}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.900346940202133, 4.386889790339869}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7389772837890856`, 7.365180126021013}],
             4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-8.05031945517943, 1.2424239907001886`}],
             5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.238564249095555, 7.365180126021013}], 
            4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6702500518308578`, 7.433666540166168}],
             4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7389772837890856`, 7.365180126021013}],
             4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9712750402069146, 7.6324011266014535`}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8997902134417601`, 6.704414354964107}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8470607850131444`, 6.756932389247553}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.017406150760383, 7.086737934510577}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.527397202097891, 7.076653815443951}], 
            4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.2919836816486494`}], 
            5., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.2319770007355333`}], 
            5., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-2.360956006320375, 4.969813299576001}], 
            6.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 1.4964931534179662`}], 
            5.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.333559897293476, 1.9768549529047348`}], 
            3.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.527397202097891, 7.076653815443951}], 
            4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.793961892783255, 5.537334267018537}], 
            6.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.8006962066887295`, 
             4.386889790339869}], 5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-0.5629964960949002, 6.81783057145415}], 
            6.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.527397202097891, 7.076653815443951}], 
            4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.808498793232353, 7.295735072749282}], 
            4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316692464055834`, 6.672032945461067}],
             4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6029589463363911`, 7.501082124259871}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-8.403864506109235, 
             1.0698698198024557`}], 5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.1892564076870427`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.017406150760383, 7.086737934510577}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-1.5077842587076005`, 5.823045895483019}],
             6.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.266384064447333}], 
            5.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820086052689358`, 6.921658184151129}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.8469979053782056, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.104554242494911, 6.999422467507961}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.400308181522661, 4.386889790339869}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8773173575897015`, 7.226936018493289}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 6.999422467507961}], 
            4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.4722426732562555`}], 
            5., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.238564249095555, 7.365180126021013}], 
            4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1150465951315345`, 7.488852955733459}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-1.3799147541558516`, 7.22402480828583}],
             6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8457617469776957`, 5.991464547107982}], 5., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.599387576580599}], 5., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-60.466869255317796`, 4.386889790339869}],
             6.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.344384958042681, 7.759614150696903}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6044503709230613`, 6.999422467507961}],
             4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.0845133642886082`}], 
            3.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7625890919282752`, 6.841615476477592}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8799351601317804`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346745988779815, 6.756932389247553}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2201021862558195`, 7.8838232148921525`}], 
            6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262403303361214, 6.841615476477592}], 
            4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346745988779815, 6.756932389247553}], 
            4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262403303361214, 6.841615476477592}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1821389399181785`, 6.921658184151129}],
             4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520318812570019, 5.583496308781699}], 
            4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1150465951315345`, 7.488852955733459}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.007592890280941}], 
            3.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-0.8906229851255774, 6.39024066706535}], 
            6.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.1062413158326008`, 6.674561391814426}],
             6.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-4.196377287787253, 0.8060293376166178}], 
            5.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-0.7813228714636707, 7.822444729489319}],
             6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.3003570667360838`, 
             4.386889790339869}], 5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0898959995836948`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3093333199837622`, 7.294377299288821}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6702500518308578`, 7.433666540166168}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7625890919282752`, 6.841615476477592}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8470607850131444`, 6.756932389247553}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.6003175012993283`, 
             4.386889790339869}], 5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.5338519254775054`}], 
            5., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4460443655256647`, 7.157735484249907}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.813734143549063, 8.290041618704489}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.5005758256424344`, 
             4.386889790339869}], 5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.900422093749666, 4.386889790339869}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5901256014017275`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-2.2936253516225737`, 5.537334267018537}],
             6.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0898959995836948`, 7.013915474810528}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.66442222076686, 6.939253946041508}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.3137523001849649, 8.290041618704489}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.659260036932778, 1.4722426732562555`}], 5., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.1637756145745228`}], 
            5., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-0.7062324201086008, 6.674561391814426}], 
            6.5, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5901256014017275`, 7.013915474810528}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.946310229076653, 7.157735484249907}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3993162819538174`, 6.704414354964107}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 0.8060293376166178}], 
            5.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3082228256997352`, 7.295735072749282}],
             4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptySquare]", {-0.746969987257452, 6.5337888379333435`}],
             6.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.10045059841862, 4.386889790339869}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledSquare]", {-3.145857732131629, 5.991464547107982}], 
            5., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.376740148315079, 7.226936018493289}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-8.685611843041201, 0.9360933591703348}],
             5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4524341636244356`, 7.151485463904735}],
             4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.900588627802483, 4.386889790339869}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.946310229076653, 7.157735484249907}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.900346940202133, 4.386889790339869}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0272286702329017`, 7.076653815443951}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2201021862558195`, 7.8838232148921525`}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1821389399181785`, 6.921658184151129}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.300630996469888, 4.386889790339869}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.0360274134764884`}],
             5.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.017406150760383, 7.086737934510577}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7389772837890856`, 7.365180126021013}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316692464055834`, 6.672032945461067}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledSquare]", {-2.945799904805782, 5.991464547107982}], 
            5., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3799147541558516`, 7.22402480828583}], 
            4.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[FilledSquare]", {-2.659260036932778, 1.416581053724763}], 
            5., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.95263269481614, 7.151485463904735}], 
            4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.036482917202561, 7.56734567601324}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8442026554799011, 7.759614150696903}],
             6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.95263269481614, 7.151485463904735}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.406905315024015, 7.697121317282625}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2815740503494875`, 7.822444729489319}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0272286702329017`, 7.076653815443951}],
             4.25, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.100765130025024, 4.386889790339869}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.659260036932778, 1.1637756145745228`}], 5., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledSquare]", {-3.045763207159556, 5.991464547107982}], 
            5., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820086052689358`, 6.921658184151129}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7625890919282752`, 6.841615476477592}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5173146235582946`, 7.086737934510577}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.808498793232353, 7.295735072749282}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.7199019178687649, 7.8838232148921525`}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.8799351601317804`, 7.22402480828583}],
             6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-2.0794415416798357`, 1.266384064447333}],
             5.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.659260036932778, 1.0845133642886082`}], 5., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4460443655256647`, 7.157735484249907}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4524341636244356`, 7.151485463904735}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.344384958042681, 7.759614150696903}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.7813228714636707, 7.822444729489319}],
             6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820086052689358`, 6.921658184151129}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820086052689358`, 6.921658184151129}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-61.467195171508536`, 4.386889790339869}],
             6.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346745988779815, 6.756932389247553}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.100426344668657, 4.386889790339869}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4714166145367258`, 7.6324011266014535`}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.527397202097891, 7.076653815443951}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-8.955698153602603, 0.8046885552928528}],
             5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.300630996469888, 4.386889790339869}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1026203100656484`, 7.501082124259871}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.104554242494911, 6.999422467507961}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.700547258981618, 4.386889790339869}], 
            5.75, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9065879564127699, 7.697121317282625}],
             6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 0.8060293376166178}], 
            5.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 0.8060293376166178}], 
            5.25, 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6044503709230613`, 6.999422467507961}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8442026554799011, 7.759614150696903}],
             6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262403303361214, 6.841615476477592}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.100765130025024, 4.386889790339869}], 
            5.75, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6044503709230613`, 6.999422467507961}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1821389399181785`, 6.921658184151129}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            6., 
            RGBColor[0., 0.5, 0.75]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0272286702329017`, 7.076653815443951}], 6., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.5366522427084526`, 7.56734567601324}],
             6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.527397202097891, 7.076653815443951}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 0.8060293376166178}], 
            5.25, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptyDiamond]", {-1.406905315024015, 7.697121317282625}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 1.0360274134764884`}], 
            5.25, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6044503709230613`, 6.999422467507961}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.95263269481614, 7.151485463904735}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6702500518308578`, 7.433666540166168}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6029589463363911`, 7.501082124259871}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.808498793232353, 7.295735072749282}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4714166145367258`, 7.6324011266014535`}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.8799351601317804`, 7.22402480828583}],
             6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1702157075278026`, 7.433666540166168}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6044503709230613`, 6.999422467507961}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9712750402069146, 7.6324011266014535`}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.5366522427084526`, 7.56734567601324}],
             6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.900346940202133, 4.386889790339869}], 
            5.75, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 6., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7389772837890856`, 7.365180126021013}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4524341636244356`, 7.151485463904735}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            6., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.104554242494911, 6.999422467507961}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 6., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0272286702329017`, 7.076653815443951}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9065879564127699, 7.697121317282625}],
             6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6029589463363911`, 7.501082124259871}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            6., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptyDiamond]", {-1.527397202097891, 7.076653815443951}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.400308181522661, 4.386889790339869}], 
            5.75, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptyDiamond]", {-1.95263269481614, 7.151485463904735}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7389772837890856`, 7.365180126021013}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.70036037299184, 4.386889790339869}], 
            5.75, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9712750402069146, 7.6324011266014535`}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.238564249095555, 7.365180126021013}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6702500518308578`, 7.433666540166168}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {-54.46678982836, 4.386889790339869}], 6.5, 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptyDiamond]", {-1.8799351601317804`, 7.22402480828583}],
             6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.808498793232353, 7.295735072749282}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.500810170663849, 4.386889790339869}], 
            5.75, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.036482917202561, 7.56734567601324}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.3799147541558516`, 7.22402480828583}],
             6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.036482917202561, 7.56734567601324}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.527397202097891, 7.076653815443951}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4524341636244356`, 7.151485463904735}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            6., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptyDiamond]", {-1.238564249095555, 7.365180126021013}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.300630996469888, 4.386889790339869}], 
            5.75, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1026203100656484`, 7.501082124259871}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.400308181522661, 4.386889790339869}], 
            5.75, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4524341636244356`, 7.151485463904735}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3082228256997352`, 7.295735072749282}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3082228256997352`, 7.295735072749282}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1026203100656484`, 7.501082124259871}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1702157075278026`, 7.433666540166168}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.3799147541558516`, 7.22402480828583}],
             6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1702157075278026`, 7.433666540166168}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3082228256997352`, 7.295735072749282}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.3799147541558516`, 7.22402480828583}],
             6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.238564249095555, 7.365180126021013}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.70036037299184, 4.386889790339869}], 
            5.75, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            6., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.500810170663849, 4.386889790339869}], 
            5.75, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            6., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            6., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            6., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            6., 
            RGBColor[0., 0., 0.7]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 6., 
            RGBColor[0.7, 0., 0.]]}}, {
         Frame -> True, 
          FrameTicks -> {{{-13.815510557964274`, 
              "\!\(\*SuperscriptBox[\(10\), \(-6\)]\)", {0.02, 
              0.}}, {-13.122363377404328`, "", {
              0.01, 0}}, {-12.716898269296165`, "", {
              0.01, 0}}, {-12.429216196844383`, "", {
              0.01, 0}}, {-12.206072645530174`, "", {
              0.01, 0}}, {-12.02375108873622, "", {
              0.01, 0}}, {-11.86960040890896, "", {
              0.01, 0}}, {-11.736069016284437`, "", {
              0.01, 0}}, {-11.618285980628055`, "", {
              0.01, 0}}, {-11.512925464970229`, 
              "\!\(\*SuperscriptBox[\(10\), \(-5\)]\)", {0.02, 
              0.}}, {-10.819778284410283`, "", {
              0.01, 0}}, {-10.414313176302118`, "", {
              0.01, 0}}, {-10.126631103850338`, "", {
              0.01, 0}}, {-9.903487552536127, "", {
              0.01, 0}}, {-9.721165995742174, "", {
              0.01, 0}}, {-9.567015315914915, "", {
              0.01, 0}}, {-9.433483923290392, "", {
              0.01, 0}}, {-9.315700887634009, "", {
              0.01, 0}}, {-9.210340371976182, 
              "\!\(\*SuperscriptBox[\(10\), \(-4\)]\)", {0.02, 
              0.}}, {-8.517193191416238, "", {0.01, 0}}, {-8.111728083308073, 
              "", {0.01, 0}}, {-7.824046010856292, "", {
              0.01, 0}}, {-7.600902459542082, "", {
              0.01, 0}}, {-7.418580902748127, "", {
              0.01, 0}}, {-7.264430222920869, "", {
              0.01, 0}}, {-7.1308988302963465`, "", {
              0.01, 0}}, {-7.013115794639964, "", {
              0.01, 0}}, {-6.907755278982137, 
              "\!\(\*SuperscriptBox[\(10\), \(-3\)]\)", {0.02, 
              0.}}, {-6.214608098422191, "", {0.01, 0}}, {-5.809142990314028, 
              "", {0.01, 0}}, {-5.521460917862246, "", {
              0.01, 0}}, {-5.298317366548036, "", {
              0.01, 0}}, {-5.115995809754082, "", {
              0.01, 0}}, {-4.961845129926823, "", {
              0.01, 0}}, {-4.8283137373023015`, "", {
              0.01, 0}}, {-4.710530701645918, "", {
              0.01, 0}}, {-4.605170185988091, 
              "\!\(\*SuperscriptBox[\(10\), \(-2\)]\)", {0.02, 
              0.}}, {-3.912023005428146, "", {0.01, 0}}, {-3.506557897319982, 
              "", {0.01, 0}}, {-3.2188758248682006`, "", {
              0.01, 0}}, {-2.995732273553991, "", {
              0.01, 0}}, {-2.8134107167600364`, "", {
              0.01, 0}}, {-2.659260036932778, "", {
              0.01, 0}}, {-2.5257286443082556`, "", {
              0.01, 0}}, {-2.4079456086518722`, "", {
              0.01, 0}}, {-2.3025850929940455`, 
              "\!\(\*SuperscriptBox[\(10\), \(-1\)]\)", {0.02, 
              0.}}, {-1.6094379124341003`, "", {
              0.01, 0}}, {-1.203972804325936, "", {
              0.01, 0}}, {-0.916290731874155, "", {
              0.01, 0}}, {-0.6931471805599453, "", {
              0.01, 0}}, {-0.5108256237659905, "", {
              0.01, 0}}, {-0.3566749439387323, "", {
              0.01, 0}}, {-0.2231435513142097, "", {
              0.01, 0}}, {-0.10536051565782628`, "", {0.01, 0}}, {
             0., "1", {0.02, 0.}}, {0.6931471805599453, "", {0.01, 0}}, {
             1.0986122886681098`, "", {0.01, 0}}, {
             1.3862943611198906`, "", {0.01, 0}}, {
             1.6094379124341003`, "", {0.01, 0}}, {
             1.791759469228055, "", {0.01, 0}}, {
             1.9459101490553132`, "", {0.01, 0}}, {
             2.0794415416798357`, "", {0.01, 0}}, {
             2.1972245773362196`, "", {0.01, 0}}, {
             2.302585092994046, "\!\(\*SuperscriptBox[\(10\), \(1\)]\)", {
              0.02, 0.}}, {2.995732273553991, "", {0.01, 0}}, {
             3.4011973816621555`, "", {0.01, 0}}, {
             3.6888794541139363`, "", {0.01, 0}}, {
             3.912023005428146, "", {0.01, 0}}, {
             4.0943445622221, "", {0.01, 0}}, {
             4.248495242049359, "", {0.01, 0}}, {
             4.382026634673881, "", {0.01, 0}}, {
             4.499809670330265, "", {0.01, 0}}, {
             4.605170185988092, "\!\(\*SuperscriptBox[\(10\), \(2\)]\)", {
              0.02, 0.}}, {5.298317366548036, "", {0.01, 0}}, {
             5.703782474656201, "", {0.01, 0}}, {
             5.991464547107982, "", {0.01, 0}}, {
             6.214608098422191, "", {0.01, 0}}, {
             6.396929655216146, "", {0.01, 0}}, {
             6.551080335043404, "", {0.01, 0}}, {
             6.684611727667927, "", {0.01, 0}}, {
             6.802394763324311, "", {0.01, 0}}, {
             6.907755278982137, "\!\(\*SuperscriptBox[\(10\), \(3\)]\)", {
              0.02, 0.}}, {7.600902459542082, "", {0.01, 0}}, {
             8.006367567650246, "", {0.01, 0}}, {
             8.294049640102028, "", {0.01, 0}}, {
             8.517193191416238, "", {0.01, 0}}, {
             8.699514748210191, "", {0.01, 0}}, {
             8.85366542803745, "", {0.01, 0}}, {
             8.987196820661973, "", {0.01, 0}}, {
             9.104979856318357, "", {0.01, 0}}, {
             9.210340371976184, "\!\(\*SuperscriptBox[\(10\), \(4\)]\)", {
              0.02, 0.}}, {9.903487552536127, "", {0.01, 0}}, {
             10.308952660644293`, "", {0.01, 0}}, {
             10.596634733096073`, "", {0.01, 0}}, {
             10.819778284410283`, "", {0.01, 0}}, {
             11.002099841204238`, "", {0.01, 0}}, {
             11.156250521031495`, "", {0.01, 0}}, {
             11.289781913656018`, "", {0.01, 0}}, {
             11.407564949312402`, "", {0.01, 0}}}, {{-13.815510557964274`, 
              "\!\(\*SuperscriptBox[\(10\), \(-6\)]\)", {0.02, 
              0.}}, {-13.122363377404328`, "", {
              0.01, 0}}, {-12.716898269296165`, "", {
              0.01, 0}}, {-12.429216196844383`, "", {
              0.01, 0}}, {-12.206072645530174`, "", {
              0.01, 0}}, {-12.02375108873622, "", {
              0.01, 0}}, {-11.86960040890896, "", {
              0.01, 0}}, {-11.736069016284437`, "", {
              0.01, 0}}, {-11.618285980628055`, "", {
              0.01, 0}}, {-11.512925464970229`, 
              "\!\(\*SuperscriptBox[\(10\), \(-5\)]\)", {0.02, 
              0.}}, {-10.819778284410283`, "", {
              0.01, 0}}, {-10.414313176302118`, "", {
              0.01, 0}}, {-10.126631103850338`, "", {
              0.01, 0}}, {-9.903487552536127, "", {
              0.01, 0}}, {-9.721165995742174, "", {
              0.01, 0}}, {-9.567015315914915, "", {
              0.01, 0}}, {-9.433483923290392, "", {
              0.01, 0}}, {-9.315700887634009, "", {
              0.01, 0}}, {-9.210340371976182, 
              "\!\(\*SuperscriptBox[\(10\), \(-4\)]\)", {0.02, 
              0.}}, {-8.517193191416238, "", {0.01, 0}}, {-8.111728083308073, 
              "", {0.01, 0}}, {-7.824046010856292, "", {
              0.01, 0}}, {-7.600902459542082, "", {
              0.01, 0}}, {-7.418580902748127, "", {
              0.01, 0}}, {-7.264430222920869, "", {
              0.01, 0}}, {-7.1308988302963465`, "", {
              0.01, 0}}, {-7.013115794639964, "", {
              0.01, 0}}, {-6.907755278982137, 
              "\!\(\*SuperscriptBox[\(10\), \(-3\)]\)", {0.02, 
              0.}}, {-6.214608098422191, "", {0.01, 0}}, {-5.809142990314028, 
              "", {0.01, 0}}, {-5.521460917862246, "", {
              0.01, 0}}, {-5.298317366548036, "", {
              0.01, 0}}, {-5.115995809754082, "", {
              0.01, 0}}, {-4.961845129926823, "", {
              0.01, 0}}, {-4.8283137373023015`, "", {
              0.01, 0}}, {-4.710530701645918, "", {
              0.01, 0}}, {-4.605170185988091, 
              "\!\(\*SuperscriptBox[\(10\), \(-2\)]\)", {0.02, 
              0.}}, {-3.912023005428146, "", {0.01, 0}}, {-3.506557897319982, 
              "", {0.01, 0}}, {-3.2188758248682006`, "", {
              0.01, 0}}, {-2.995732273553991, "", {
              0.01, 0}}, {-2.8134107167600364`, "", {
              0.01, 0}}, {-2.659260036932778, "", {
              0.01, 0}}, {-2.5257286443082556`, "", {
              0.01, 0}}, {-2.4079456086518722`, "", {
              0.01, 0}}, {-2.3025850929940455`, 
              "\!\(\*SuperscriptBox[\(10\), \(-1\)]\)", {0.02, 
              0.}}, {-1.6094379124341003`, "", {
              0.01, 0}}, {-1.203972804325936, "", {
              0.01, 0}}, {-0.916290731874155, "", {
              0.01, 0}}, {-0.6931471805599453, "", {
              0.01, 0}}, {-0.5108256237659905, "", {
              0.01, 0}}, {-0.3566749439387323, "", {
              0.01, 0}}, {-0.2231435513142097, "", {
              0.01, 0}}, {-0.10536051565782628`, "", {0.01, 0}}, {
             0., "1", {0.02, 0.}}, {0.6931471805599453, "", {0.01, 0}}, {
             1.0986122886681098`, "", {0.01, 0}}, {
             1.3862943611198906`, "", {0.01, 0}}, {
             1.6094379124341003`, "", {0.01, 0}}, {
             1.791759469228055, "", {0.01, 0}}, {
             1.9459101490553132`, "", {0.01, 0}}, {
             2.0794415416798357`, "", {0.01, 0}}, {
             2.1972245773362196`, "", {0.01, 0}}, {
             2.302585092994046, "\!\(\*SuperscriptBox[\(10\), \(1\)]\)", {
              0.02, 0.}}, {2.995732273553991, "", {0.01, 0}}, {
             3.4011973816621555`, "", {0.01, 0}}, {
             3.6888794541139363`, "", {0.01, 0}}, {
             3.912023005428146, "", {0.01, 0}}, {
             4.0943445622221, "", {0.01, 0}}, {
             4.248495242049359, "", {0.01, 0}}, {
             4.382026634673881, "", {0.01, 0}}, {
             4.499809670330265, "", {0.01, 0}}, {
             4.605170185988092, "\!\(\*SuperscriptBox[\(10\), \(2\)]\)", {
              0.02, 0.}}, {5.298317366548036, "", {0.01, 0}}, {
             5.703782474656201, "", {0.01, 0}}, {
             5.991464547107982, "", {0.01, 0}}, {
             6.214608098422191, "", {0.01, 0}}, {
             6.396929655216146, "", {0.01, 0}}, {
             6.551080335043404, "", {0.01, 0}}, {
             6.684611727667927, "", {0.01, 0}}, {
             6.802394763324311, "", {0.01, 0}}, {
             6.907755278982137, "\!\(\*SuperscriptBox[\(10\), \(3\)]\)", {
              0.02, 0.}}, {7.600902459542082, "", {0.01, 0}}, {
             8.006367567650246, "", {0.01, 0}}, {
             8.294049640102028, "", {0.01, 0}}, {
             8.517193191416238, "", {0.01, 0}}, {
             8.699514748210191, "", {0.01, 0}}, {
             8.85366542803745, "", {0.01, 0}}, {
             8.987196820661973, "", {0.01, 0}}, {
             9.104979856318357, "", {0.01, 0}}, {
             9.210340371976184, "\!\(\*SuperscriptBox[\(10\), \(4\)]\)", {
              0.02, 0.}}, {9.903487552536127, "", {0.01, 0}}, {
             10.308952660644293`, "", {0.01, 0}}, {
             10.596634733096073`, "", {0.01, 0}}, {
             10.819778284410283`, "", {0.01, 0}}, {
             11.002099841204238`, "", {0.01, 0}}, {
             11.156250521031495`, "", {0.01, 0}}, {
             11.289781913656018`, "", {0.01, 0}}, {
             11.407564949312402`, "", {0.01, 0}}}, {{-13.815510557964274`, 
              ""}, {-13.122363377404328`, ""}, {-12.716898269296165`, 
              ""}, {-12.429216196844383`, ""}, {-12.206072645530174`, 
              ""}, {-12.02375108873622, ""}, {-11.86960040890896, 
              ""}, {-11.736069016284437`, ""}, {-11.618285980628055`, 
              ""}, {-11.512925464970229`, ""}, {-10.819778284410283`, 
              ""}, {-10.414313176302118`, ""}, {-10.126631103850338`, 
              ""}, {-9.903487552536127, ""}, {-9.721165995742174, 
              ""}, {-9.567015315914915, ""}, {-9.433483923290392, 
              ""}, {-9.315700887634009, ""}, {-9.210340371976182, 
              ""}, {-8.517193191416238, ""}, {-8.111728083308073, 
              ""}, {-7.824046010856292, ""}, {-7.600902459542082, 
              ""}, {-7.418580902748127, ""}, {-7.264430222920869, 
              ""}, {-7.1308988302963465`, ""}, {-7.013115794639964, 
              ""}, {-6.907755278982137, ""}, {-6.214608098422191, 
              ""}, {-5.809142990314028, ""}, {-5.521460917862246, 
              ""}, {-5.298317366548036, ""}, {-5.115995809754082, 
              ""}, {-4.961845129926823, ""}, {-4.8283137373023015`, 
              ""}, {-4.710530701645918, ""}, {-4.605170185988091, 
              ""}, {-3.912023005428146, ""}, {-3.506557897319982, 
              ""}, {-3.2188758248682006`, ""}, {-2.995732273553991, 
              ""}, {-2.8134107167600364`, ""}, {-2.659260036932778, 
              ""}, {-2.5257286443082556`, ""}, {-2.4079456086518722`, 
              ""}, {-2.3025850929940455`, ""}, {-1.6094379124341003`, 
              ""}, {-1.203972804325936, ""}, {-0.916290731874155, 
              ""}, {-0.6931471805599453, ""}, {-0.5108256237659905, 
              ""}, {-0.3566749439387323, ""}, {-0.2231435513142097, 
              ""}, {-0.10536051565782628`, ""}, {0., ""}, {
             0.6931471805599453, ""}, {1.0986122886681098`, ""}, {
             1.3862943611198906`, ""}, {1.6094379124341003`, ""}, {
             1.791759469228055, ""}, {1.9459101490553132`, ""}, {
             2.0794415416798357`, ""}, {2.1972245773362196`, ""}, {
             2.302585092994046, ""}, {2.995732273553991, ""}, {
             3.4011973816621555`, ""}, {3.6888794541139363`, ""}, {
             3.912023005428146, ""}, {4.0943445622221, ""}, {
             4.248495242049359, ""}, {4.382026634673881, ""}, {
             4.499809670330265, ""}, {4.605170185988092, ""}, {
             5.298317366548036, ""}, {5.703782474656201, ""}, {
             5.991464547107982, ""}, {6.214608098422191, ""}, {
             6.396929655216146, ""}, {6.551080335043404, ""}, {
             6.684611727667927, ""}, {6.802394763324311, ""}, {
             6.907755278982137, ""}, {7.600902459542082, ""}, {
             8.006367567650246, ""}, {8.294049640102028, ""}, {
             8.517193191416238, ""}, {8.699514748210191, ""}, {
             8.85366542803745, ""}, {8.987196820661973, ""}, {
             9.104979856318357, ""}, {9.210340371976184, ""}, {
             9.903487552536127, ""}, {10.308952660644293`, ""}, {
             10.596634733096073`, ""}, {10.819778284410283`, ""}, {
             11.002099841204238`, ""}, {11.156250521031495`, ""}, {
             11.289781913656018`, ""}, {
             11.407564949312402`, ""}}, {{-13.815510557964274`, 
              ""}, {-13.122363377404328`, ""}, {-12.716898269296165`, 
              ""}, {-12.429216196844383`, ""}, {-12.206072645530174`, 
              ""}, {-12.02375108873622, ""}, {-11.86960040890896, 
              ""}, {-11.736069016284437`, ""}, {-11.618285980628055`, 
              ""}, {-11.512925464970229`, ""}, {-10.819778284410283`, 
              ""}, {-10.414313176302118`, ""}, {-10.126631103850338`, 
              ""}, {-9.903487552536127, ""}, {-9.721165995742174, 
              ""}, {-9.567015315914915, ""}, {-9.433483923290392, 
              ""}, {-9.315700887634009, ""}, {-9.210340371976182, 
              ""}, {-8.517193191416238, ""}, {-8.111728083308073, 
              ""}, {-7.824046010856292, ""}, {-7.600902459542082, 
              ""}, {-7.418580902748127, ""}, {-7.264430222920869, 
              ""}, {-7.1308988302963465`, ""}, {-7.013115794639964, 
              ""}, {-6.907755278982137, ""}, {-6.214608098422191, 
              ""}, {-5.809142990314028, ""}, {-5.521460917862246, 
              ""}, {-5.298317366548036, ""}, {-5.115995809754082, 
              ""}, {-4.961845129926823, ""}, {-4.8283137373023015`, 
              ""}, {-4.710530701645918, ""}, {-4.605170185988091, 
              ""}, {-3.912023005428146, ""}, {-3.506557897319982, 
              ""}, {-3.2188758248682006`, ""}, {-2.995732273553991, 
              ""}, {-2.8134107167600364`, ""}, {-2.659260036932778, 
              ""}, {-2.5257286443082556`, ""}, {-2.4079456086518722`, 
              ""}, {-2.3025850929940455`, ""}, {-1.6094379124341003`, 
              ""}, {-1.203972804325936, ""}, {-0.916290731874155, 
              ""}, {-0.6931471805599453, ""}, {-0.5108256237659905, 
              ""}, {-0.3566749439387323, ""}, {-0.2231435513142097, 
              ""}, {-0.10536051565782628`, ""}, {0., ""}, {
             0.6931471805599453, ""}, {1.0986122886681098`, ""}, {
             1.3862943611198906`, ""}, {1.6094379124341003`, ""}, {
             1.791759469228055, ""}, {1.9459101490553132`, ""}, {
             2.0794415416798357`, ""}, {2.1972245773362196`, ""}, {
             2.302585092994046, ""}, {2.995732273553991, ""}, {
             3.4011973816621555`, ""}, {3.6888794541139363`, ""}, {
             3.912023005428146, ""}, {4.0943445622221, ""}, {
             4.248495242049359, ""}, {4.382026634673881, ""}, {
             4.499809670330265, ""}, {4.605170185988092, ""}, {
             5.298317366548036, ""}, {5.703782474656201, ""}, {
             5.991464547107982, ""}, {6.214608098422191, ""}, {
             6.396929655216146, ""}, {6.551080335043404, ""}, {
             6.684611727667927, ""}, {6.802394763324311, ""}, {
             6.907755278982137, ""}, {7.600902459542082, ""}, {
             8.006367567650246, ""}, {8.294049640102028, ""}, {
             8.517193191416238, ""}, {8.699514748210191, ""}, {
             8.85366542803745, ""}, {8.987196820661973, ""}, {
             9.104979856318357, ""}, {9.210340371976184, ""}, {
             9.903487552536127, ""}, {10.308952660644293`, ""}, {
             10.596634733096073`, ""}, {10.819778284410283`, ""}, {
             11.002099841204238`, ""}, {11.156250521031495`, ""}, {
             11.289781913656018`, ""}, {11.407564949312402`, ""}}}, Axes -> 
          False, PlotLabel -> Style["Sensitivity to g(x,\[Mu]), CT14NNLO", 24, 
            GrayLevel[0]], FrameLabel -> {
            Style["x", 18, 
             GrayLevel[0]], 
            Style["\[Mu] [GeV]", 18, 
             GrayLevel[0]]}, FrameTicksStyle -> GrayLevel[0], 
          ImageSize -> {{600}, {600}}, AspectRatio -> 1., 
          GridLines -> {{-16.11809565095832, -13.815510557964274`, \
-11.512925464970229`, -9.210340371976182, -6.907755278982137, \
-4.605170185988091, -2.3025850929940455`}, {
             Log[10], 
             Log[50], 
             Log[100], 
             Log[500], 
             Log[1000], 
             Log[5000], 
             Log[10000]}}, GridLinesStyle -> Directive[
            Dashing[{Small, Small}]], PlotRangeClipping -> True, 
          DisplayFunction -> Identity, PlotRangePadding -> {{0, 0}, {0, 0}}, 
          AxesOrigin -> {0, 0}, PlotRange -> {{-Log[100000], 0}, {0, 
             Log[6000]}}, PlotRangeClipping -> True, ImagePadding -> All, 
          DisplayFunction -> Identity, AspectRatio -> 1, Axes -> {True, True},
           AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
          Identity, Epilog -> {{
             Text[
              Style["Npt: 3920", 16, 
               GrayLevel[0]], 
              Scaled[{0.1, 0.9}]]}, {{
              Text[
               Style["Npt: 3920", 16, 
                GrayLevel[0]], 
               Scaled[{0.1, 0.9}]]}}}, 
          Frame -> {{False, False}, {False, False}}, 
          FrameLabel -> {{None, None}, {None, None}}, 
          FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
          GridLines -> {None, None}, GridLinesStyle -> Directive[
            GrayLevel[0.5, 0.4]], 
          Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& )}}, PlotRange -> {{-Log[100000], 0}, {0, 
             Log[6000]}}, PlotRangeClipping -> True, 
          PlotRangePadding -> {{0, 0}, {0, 0}}, 
          Ticks -> {Automatic, Automatic}}], 
        Placed[
         Unevaluated[
          BarLegend[{{
             RGBColor[0., 0., 0.7], 
             RGBColor[0., 0., 0.7], 
             RGBColor[0., 0.5, 0.75], 
             RGBColor[0., 0.75, 0.75], 
             RGBColor[0, 0.7, 0], 
             RGBColor[0.75, 0.75, 0.], 
             RGBColor[0.75, 0.55, 0.], 
             RGBColor[0.7, 0., 0.], 
             RGBColor[0.7, 0., 0.]}, {-3.006, 
            3.006}}, {-3.006, -3., -1., -0.3333333333333333, \
-0.1111111111111111, 0.1111111111111111, 0.3333333333333333, 1., 3., 3.006}, 
           LabelStyle -> {FontSize -> 14, 
             GrayLevel[0]}, LegendLabel -> "", LegendLayout -> "Column", 
           LegendMarkerSize -> {}, Charting`TickAnnotations -> None, 
           Charting`TickSide -> Right, ColorFunctionScaling -> True]], {1., 
         0.5}, Identity]]& ],
      AutoDelete->True,
      Editable->True,
      SelectWithContents->False,
      Selectable->True], ",", 
     TagBox[GridBox[{
        {
         InterpretationBox[Cell[BoxData[
           FormBox[
            StyleBox["\<\"Sensitivity to g(x,\[Mu]), CT14NNLO\\n\\n\"\>",
             StripOnInput->False,
             FontSize->24], TextForm]], "InlineText"],
          Text[
           Style["Sensitivity to g(x,\[Mu]), CT14NNLO\n\n", FontSize -> 24]]],
          "\[SpanFromLeft]", "\[SpanFromLeft]"},
        {"\<\"Data Sets\"\>", "", ""},
        {"\<\"\[FilledCircle]BcdF2pCor(101)\"\>", \
"\<\"\[FilledSquare]BcdF2dCor(102)\"\>", \
"\<\"\[FilledDiamond]NmcRatCor(104)\"\>"},
        {"\<\"\[FilledUpTriangle]cdhswf2(108)\"\>", \
"\<\"\[FilledDownTriangle]cdhswf3(109)\"\>", \
"\<\"\[EmptyCircle]ccfrf2.mi(110)\"\>"},
        {"\<\"\[EmptySquare]ccfrf3.md(111)\"\>", \
"\<\"\[EmptyDiamond]NuTvNuChXN(124)\"\>", \
"\<\"\[EmptyUpTriangle]NuTvNbChXN(125)\"\>"},
        {"\<\"\[EmptyDownTriangle]CcfrNuChXN(126)\"\>", \
"\<\"\[Times]CcfrNbChXN(127)\"\>", "\<\"\[CircleMinus]Hn1X0c(147)\"\>"},
        {"\<\"\[FivePointedStar]e605(201)\"\>", \
"\<\"\[FilledCircle]e866f(203)\"\>", "\<\"\[FilledSquare]e866ppxf(204)\"\>"},
        {"\<\"\[FilledDiamond]cdfLasy(225)\"\>", \
"\<\"\[FilledUpTriangle]cdfLasy2(227)\"\>", \
"\<\"\[FilledDownTriangle]d02Masy1(234)\"\>"},
        {"\<\"\[EmptyCircle]ZyD02a(260)\"\>", \
"\<\"\[EmptySquare]cdf2jtCor2(504)\"\>", "\<\"\[EmptyDiamond]d02jtCor2(514)\"\
\>"},
        {"\<\"\[EmptyUpTriangle]Hn+9900x0b(145)\"\>", "\<\"\
\[EmptyDownTriangle]H1FL10(169)\"\>", "\<\"\[Times]ATL7_WZ(268)\"\>"},
        {"\<\"\[CircleMinus]ATL7jtR6(535)\"\>", \
"\<\"\[FivePointedStar]LHCb7_WZ1(240)\"\>", \
"\<\"\[FilledCircle]LHCb7Wasy1(241)\"\>"},
        {"\<\"\[FilledSquare]d02Easy5(281)\"\>", \
"\<\"\[FilledDiamond]CMS7Masy2(266)\"\>", \
"\<\"\[FilledUpTriangle]CMS7jtR7v2(538)\"\>"},
        {"\<\"\[FilledDownTriangle]LHCb7ZWrap(245)\"\>", \
"\<\"\[EmptyCircle]LHCb8Zeer(246)\"\>", "\<\"\[EmptySquare]ATL7ZW(248)\"\>"},
        {"\<\"\[EmptyDiamond]CMS7jtR7y6(542)\"\>", \
"\<\"\[EmptyUpTriangle]ATL7jtR6u(544)\"\>", \
"\<\"\[EmptyDownTriangle]CMS8Wxa(249)\"\>"},
        {"\<\"\[Times]LHCb8WZ(250)\"\>", \
"\<\"\[CircleMinus]ATL8ttpt(565)\"\>", "\<\"\[FivePointedStar]ATL8ttya(566)\"\
\>"},
        {"\<\"\[FilledCircle]ATL8ttmtt(567)\"\>", \
"\<\"\[FilledSquare]ATL8ttytt(568)\"\>", ""},
        {
         InterpretationBox[Cell[BoxData[
           FormBox[
            StyleBox["\<\"\"\>",
             StripOnInput->False,
             FontSize->16], TextForm]], "InlineText"],
          Text[
           Style["", FontSize -> 16]]], "\[SpanFromLeft]", "\[SpanFromLeft]"}
       },
       AutoDelete->False,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{14}}},
       GridBoxItemStyle->{"Columns" -> {{
            Directive[FontSize -> 18, 
             GrayLevel[0]]}}, "Rows" -> {{
            Directive[FontSize -> 18, 
             GrayLevel[0]]}}}],
      "Grid"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     GraphicsBox[{
       {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
        EdgeForm[{Opacity[0.11199999999999999`], Thickness[Small]}], {}, 
        {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
         EdgeForm[{Opacity[0.11199999999999999`], Thickness[Small]}], 
         RectangleBox[{-2.46, 0}, {-2.4, 1},
          RoundingRadius->0], RectangleBox[{-2.34, 0}, {-2.28, 2},
          RoundingRadius->0], RectangleBox[{-2.04, 0}, {-1.98, 1},
          RoundingRadius->0], RectangleBox[{-1.56, 0}, {-1.5, 1},
          RoundingRadius->0], RectangleBox[{-1.44, 0}, {-1.38, 1},
          RoundingRadius->0], RectangleBox[{-1.32, 0}, {-1.26, 2},
          RoundingRadius->0], RectangleBox[{-1.26, 0}, {-1.2, 2},
          RoundingRadius->0], 
         RectangleBox[{-1.2, 0}, {-1.1400000000000001, 1},
          RoundingRadius->0], RectangleBox[{-1.08, 0}, {-1.02, 2},
          RoundingRadius->0], RectangleBox[{-1.02, 0}, {-0.96, 1},
          RoundingRadius->0], 
         RectangleBox[{-0.96, 0}, {-0.8999999999999999, 2},
          RoundingRadius->0], 
         RectangleBox[{-0.8999999999999999, 0}, {-0.8400000000000001, 1},
          RoundingRadius->0], 
         RectangleBox[{-0.8400000000000001, 0}, {-0.78, 1},
          RoundingRadius->0], RectangleBox[{-0.78, 0}, {-0.72, 3},
          RoundingRadius->0], 
         RectangleBox[{-0.72, 0}, {-0.6600000000000001, 4},
          RoundingRadius->0], 
         RectangleBox[{-0.6600000000000001, 0}, {-0.6000000000000001, 14},
          RoundingRadius->0], 
         RectangleBox[{-0.6000000000000001, 0}, {-0.54, 17},
          RoundingRadius->0], RectangleBox[{-0.54, 0}, {-0.48, 16},
          RoundingRadius->0], 
         RectangleBox[{-0.48, 0}, {-0.41999999999999993, 30},
          RoundingRadius->0], 
         RectangleBox[{-0.41999999999999993, 0}, {-0.3599999999999999, 22},
          RoundingRadius->0], 
         RectangleBox[{-0.3599999999999999, 0}, {-0.2999999999999998, 65},
          RoundingRadius->0], 
         RectangleBox[{-0.2999999999999998, 0}, {-0.2400000000000002, 108},
          RoundingRadius->0], 
         RectangleBox[{-0.2400000000000002, 0}, {-0.18000000000000016, 130},
          RoundingRadius->0], 
         RectangleBox[{-0.18000000000000016, 0}, {-0.1200000000000001, 260},
          RoundingRadius->0], 
         RectangleBox[{-0.1200000000000001, 0}, {-0.06000000000000005, 526},
          RoundingRadius->0], 
         RectangleBox[{-0.06000000000000005, 0}, {0., 1036},
          RoundingRadius->0], 
         RectangleBox[{0., 0}, {0.06000000000000005, 738},
          RoundingRadius->0], 
         RectangleBox[{0.06000000000000005, 0}, {0.1200000000000001, 304},
          RoundingRadius->0], 
         RectangleBox[{0.1200000000000001, 0}, {0.17999999999999972, 152},
          RoundingRadius->0], 
         RectangleBox[{0.17999999999999972, 0}, {0.23999999999999977, 116},
          RoundingRadius->0], 
         RectangleBox[{0.23999999999999977, 0}, {0.2999999999999998, 89},
          RoundingRadius->0], 
         RectangleBox[{0.2999999999999998, 0}, {0.3599999999999999, 58},
          RoundingRadius->0], 
         RectangleBox[{0.3599999999999999, 0}, {0.41999999999999993, 35},
          RoundingRadius->0], 
         RectangleBox[{0.41999999999999993, 0}, {0.48, 27},
          RoundingRadius->0], RectangleBox[{0.48, 0}, {0.54, 16},
          RoundingRadius->0], 
         RectangleBox[{0.54, 0}, {0.6000000000000001, 8},
          RoundingRadius->0], 
         RectangleBox[{0.6000000000000001, 0}, {0.6600000000000001, 16},
          RoundingRadius->0], 
         RectangleBox[{0.6600000000000001, 0}, {0.7199999999999998, 10},
          RoundingRadius->0], 
         RectangleBox[{0.7199999999999998, 0}, {0.7799999999999998, 10},
          RoundingRadius->0], 
         RectangleBox[{0.7799999999999998, 0}, {0.8399999999999999, 7},
          RoundingRadius->0], 
         RectangleBox[{0.8399999999999999, 0}, {0.8999999999999999, 9},
          RoundingRadius->0], 
         RectangleBox[{0.8999999999999999, 0}, {0.96, 6},
          RoundingRadius->0], RectangleBox[{0.96, 0}, {1.02, 5},
          RoundingRadius->0], RectangleBox[{1.02, 0}, {1.08, 5},
          RoundingRadius->0], 
         RectangleBox[{1.08, 0}, {1.1399999999999997, 9},
          RoundingRadius->0], 
         RectangleBox[{1.1399999999999997, 0}, {1.1999999999999997, 6},
          RoundingRadius->0], 
         RectangleBox[{1.1999999999999997, 0}, {1.2599999999999998, 6},
          RoundingRadius->0], 
         RectangleBox[{1.2599999999999998, 0}, {1.3199999999999998, 2},
          RoundingRadius->0], 
         RectangleBox[{1.3199999999999998, 0}, {1.38, 5},
          RoundingRadius->0], RectangleBox[{1.38, 0}, {1.44, 4},
          RoundingRadius->0], RectangleBox[{1.44, 0}, {1.5, 7},
          RoundingRadius->0], RectangleBox[{1.5, 0}, {1.5599999999999996, 3},
          RoundingRadius->0], 
         RectangleBox[{1.5599999999999996, 0}, {1.62, 6},
          RoundingRadius->0], 
         RectangleBox[{1.62, 0}, {1.6799999999999997, 4},
          RoundingRadius->0], 
         RectangleBox[{1.6799999999999997, 0}, {1.7400000000000002, 2},
          RoundingRadius->0], 
         RectangleBox[{1.7999999999999998, 0}, {1.8600000000000003, 1},
          RoundingRadius->0], 
         RectangleBox[{1.8600000000000003, 0}, {1.92, 1},
          RoundingRadius->0], 
         RectangleBox[{1.9799999999999995, 0}, {2.04, 1},
          RoundingRadius->0], 
         RectangleBox[{2.04, 0}, {2.0999999999999996, 2},
          RoundingRadius->0], 
         RectangleBox[{2.3999999999999995, 0}, {2.46, 1},
          
          RoundingRadius->
           0]}, {}, {}}, {{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}}},
      AspectRatio->1,
      Axes->False,
      AxesLabel->{None, None},
      AxesOrigin->{-3.12, 0.},
      BaseStyle->{FontSize -> 16},
      Epilog->{{
         Thickness[Large], {
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[0.7, 0., 0.], StripOnInput -> False], 
            TraditionalForm], {-1, 1020.4599999999998`}], 
          StyleBox[
           LineBox[{{-1, 0.}, {-1, 984.1999999999999}}], 
           RGBColor[0.7, 0., 0.], StripOnInput -> False]}, {
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[0.7, 0., 0.], StripOnInput -> False], 
            TraditionalForm], {1, 979.0199999999999}], 
          StyleBox[
           LineBox[{{1, 0.}, {1, 984.1999999999999}}], 
           RGBColor[0.7, 0., 0.], StripOnInput -> False]}}, {
         Thickness[Large], 
         StyleBox[
          LineBox[{{0., 0.}, {0., 0.}}], 
          RGBColor[0., 0., 0.7], StripOnInput -> False]}, 
        InsetBox[
         FormBox[
          StyleBox["\"Npt: 3920\"", 16, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         Scaled[{0.1, 0.9}]]},
      Frame->True,
      FrameLabel->{
        FormBox[
         StyleBox["\"Sensitivity to g(x,\[Mu])\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm], 
        FormBox[
         StyleBox["\"#points\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm]},
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImageSize->{{600}, {600}},
      PlotLabel->FormBox[
        StyleBox["\"Sensitivity to g(x,\[Mu]), CT14NNLO\"", 24, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{-3., 3.}, {0., 1036}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}], ",", 
     GraphicsBox[{
       {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
        EdgeForm[{Opacity[0.39899999999999997`], Thickness[Small]}], {}, 
        {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
         EdgeForm[{Opacity[0.39899999999999997`], Thickness[Small]}], 
         RectangleBox[{0., 0}, {0.06, 1774},
          RoundingRadius->0], RectangleBox[{0.06, 0}, {0.12, 830},
          RoundingRadius->0], RectangleBox[{0.12, 0}, {0.18, 412},
          RoundingRadius->0], RectangleBox[{0.18, 0}, {0.24, 246},
          RoundingRadius->0], RectangleBox[{0.24, 0}, {0.3, 197},
          RoundingRadius->0], RectangleBox[{0.3, 0}, {0.36, 123},
          RoundingRadius->0], RectangleBox[{0.36, 0}, {0.42, 57},
          RoundingRadius->0], RectangleBox[{0.42, 0}, {0.48, 57},
          RoundingRadius->0], RectangleBox[{0.48, 0}, {0.54, 32},
          RoundingRadius->0], RectangleBox[{0.54, 0}, {0.6, 25},
          RoundingRadius->0], 
         RectangleBox[{0.6, 0}, {0.6599999999999999, 30},
          RoundingRadius->0], 
         RectangleBox[{0.6599999999999999, 0}, {0.72, 14},
          RoundingRadius->0], RectangleBox[{0.72, 0}, {0.78, 13},
          RoundingRadius->0], RectangleBox[{0.78, 0}, {0.84, 8},
          RoundingRadius->0], 
         RectangleBox[{0.84, 0}, {0.8999999999999999, 10},
          RoundingRadius->0], 
         RectangleBox[{0.8999999999999999, 0}, {0.96, 8},
          RoundingRadius->0], RectangleBox[{0.96, 0}, {1.02, 6},
          RoundingRadius->0], RectangleBox[{1.02, 0}, {1.08, 7},
          RoundingRadius->0], RectangleBox[{1.08, 0}, {1.14, 9},
          RoundingRadius->0], RectangleBox[{1.14, 0}, {1.2, 7},
          RoundingRadius->0], RectangleBox[{1.2, 0}, {1.26, 8},
          RoundingRadius->0], 
         RectangleBox[{1.26, 0}, {1.3199999999999998, 4},
          RoundingRadius->0], 
         RectangleBox[{1.3199999999999998, 0}, {1.38, 5},
          RoundingRadius->0], RectangleBox[{1.38, 0}, {1.44, 5},
          RoundingRadius->0], RectangleBox[{1.44, 0}, {1.5, 7},
          RoundingRadius->0], RectangleBox[{1.5, 0}, {1.56, 4},
          RoundingRadius->0], 
         RectangleBox[{1.56, 0}, {1.6199999999999999, 6},
          RoundingRadius->0], 
         RectangleBox[{1.6199999999999999, 0}, {1.68, 4},
          RoundingRadius->0], RectangleBox[{1.68, 0}, {1.74, 2},
          RoundingRadius->0], 
         RectangleBox[{1.7999999999999998, 0}, {1.8599999999999999, 1},
          RoundingRadius->0], 
         RectangleBox[{1.8599999999999999, 0}, {1.92, 1},
          RoundingRadius->0], RectangleBox[{1.98, 0}, {2.04, 2},
          RoundingRadius->0], RectangleBox[{2.04, 0}, {2.1, 2},
          RoundingRadius->0], RectangleBox[{2.28, 0}, {2.34, 2},
          RoundingRadius->0], RectangleBox[{2.4, 0}, {2.46, 2},
          
          RoundingRadius->
           0]}, {}, {}}, {{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}}},
      AspectRatio->1,
      Axes->False,
      AxesLabel->{None, None},
      AxesOrigin->{-0.06, 0.},
      BaseStyle->{FontSize -> 16},
      Epilog->{{
         Thickness[Large], {
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[0.7, 0., 0.], StripOnInput -> False], 
            TraditionalForm], {1, 1747.3899999999999`}], 
          StyleBox[
           LineBox[{{1, 0.}, {1, 1685.3}}], 
           RGBColor[0.7, 0., 0.], StripOnInput -> False]}}, {
         Thickness[Large], 
         StyleBox[
          LineBox[{{0., 0.}, {0., 0.}}], 
          RGBColor[0., 0., 0.7], StripOnInput -> False]}, 
        InsetBox[
         FormBox[
          StyleBox["\"Npt: 3920\"", 16, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         Scaled[{0.1, 0.9}]]},
      Frame->True,
      FrameLabel->{
        FormBox[
         StyleBox["\"| Sensitivity to g(x,\[Mu]) |\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm], 
        FormBox[
         StyleBox["\"#points\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm]},
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImageSize->{{600}, {600}},
      PlotLabel->FormBox[
        StyleBox["\"| Sensitivity to g(x,\[Mu]) |, CT14NNLO\"", 24, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{0., 3.}, {0., 1774}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.721098224805241*^9, 3.7210982311744633`*^9}, 
   3.7211435380492697`*^9, 3.7211778834774847`*^9, 3.721177924545485*^9, {
   3.721177960799922*^9, 3.7211779822342777`*^9}, 3.721178445662434*^9, 
   3.72117848240415*^9, 3.721178556281643*^9, 3.721178731190819*^9, {
   3.721178795662386*^9, 3.7211788610852537`*^9}, 3.721178947332925*^9, 
   3.7211790952069807`*^9, 3.7211791643476067`*^9, 3.721179232815298*^9, 
   3.721179349735002*^9, 3.721179416409322*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"processdataplotsmultiexp7percentage", "[", 
  RowBox[{
   RowBox[{"{", "corrdataclassfinal", "}"}], ",", 
   RowBox[{"readcorrconfigfile6", "[", 
    RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "6", ",", "0"}],
   " ", "]"}]], "Input",
 CellChangeTimes->{
  3.719195460775262*^9, {3.719195599508301*^9, 3.719195599612256*^9}, {
   3.7192229111768*^9, 3.719222911330307*^9}, {3.721098236326846*^9, 
   3.721098236894834*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     TagBox[
      GraphicsBox[{InsetBox[
         GraphicsBox[{{{{}, {{}, 
              {GrayLevel[1], PointSize[0.012833333333333334`], 
               AbsoluteThickness[1.6], 
               StyleBox[PointBox[{{0.00001, 2.}, {0.99, 1200.}}],
                FontFamily->"Helvetica"]}, {}}, {}, {}, {{}, {}}}, {
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3716028123769008, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.300710797475603, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.6003175012993283, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.57270299585059, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 1.2184672504763885}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 1.0511712140679732}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3960170377865984, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0564152399683213, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-51.46677778703915, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.4886252922173524}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-42.34081632550436, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 2.2976730486330252}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.318612854071243, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.5922917535991299}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.33687231664255274, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8701230510291479, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.517264565896126, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6266106567597011, 2.4265710727750367}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.475327636634016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6977577931176286, 2.4265710727750367}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.2672179491567546, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4422299934501939, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4159291662495814, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.300710797475603, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.695775840226822, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.100386954332169, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-53.46678887337479, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-57.46750061412042, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.6564295976247825, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.225346881840062, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-67.46691559681179, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-69.46689851604965, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-41.34127116323533, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4184044150381243, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 2.296667619230008}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.9334368907091256, 1.8389610707123492}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.536426440357718, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-44.34079097851618, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5898688311064436, 2.506341930508065}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.225346881840062, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.70036037299184, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7064996252772315, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.7027460895677522}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.312220927289192, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1464364105041143, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1307223425863433, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7627116439458544, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.4018530946527146, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.47352983902229373, 2.599722324216582}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.8643901602629624}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.6389967146756448}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-35.340845982694816, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.807005375881994, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.312220927289192, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-52.467202900682494, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7756596021344095, 2.418588768750352}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-30.340822850069564, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3645328693383778, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4082690354408987, 1.860974538249528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 0.9654617758806044}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.725332537920259, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8627499649461253, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1564532883579597, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.18765575838465653, 2.6224923127405635}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-55.46685482648658, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.1862091035211472, 2.423031246069913}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.836849948493799, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.5920892740994874, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3943265328171548, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3528595850336531, 7.751045117971802}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9715392061046336, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.176833887688485, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.532062329207643, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.49397078181451, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-56.46701553651661, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2569588998089404, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8701230510291479, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.500810170663849, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.091798316674432, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.3205066205818874, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4947708374559745, 5.886104031450156}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.1269525243508878, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.919365593833201, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.694093021166824, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.5859645562484583}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-66.46748299707936, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.0966102859974367}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.5299617109323036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.966967075507594, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.421883011611913, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.676945820702642, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9699552564598479, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.683996966534062, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 2.2927367569392314}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6529653909271136, 2.506341930508065}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 1.8359358315608838}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4409617624621989, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2149273965428693, 2.519308076505333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-43.340988541359216, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0564152399683213, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.256670593326385, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5235731965884932, 2.50470927708418}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.8528465593176202, 7.751045117971802}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.9139271032022627, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1409980051645476, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.797175250983993, 2.512035317176253}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6667000105450971, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.2876820724517809, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-72.46692041972995, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.209094749906707, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.894183087299815, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.767041814295392, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 1.2172838183856083}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.781788039865368, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.60100614381313, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9329283730271782, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.764428382564909, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.4159777803491362, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.3504080825554816}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 0.848868055556721}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.217869048507598, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3903023825174294, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.60100614381313, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7174398731289899, 2.5087859235779435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.362224007377702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.1564532883579597, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.257346872655708, 2.0028304393079956}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.494523665901028, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.4854489341097463, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.300710797475603, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-5.093908213290077, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0129050178795915, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-47.34086951027008, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.2576117273513145, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5705756281717647, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-34.340745544411554, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5601909533113197, 2.423031246069913}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.9005275521158795, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.348592493935879}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 2.075809955445786}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4182464424728975, 2.6019486702196644}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4911864085136422, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.8006962066887295, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-58.4670151515563, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.911914268349973, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4653375684603434, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.017383521085972, 0.986935571443487}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.25154302583590776, 2.130609828254235}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.341928551227046, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.809142990314028, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.0941445822194344, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.6854573524495757, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-70.4670522818902, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-5.293927018246744, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 1.3480731482996928}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6873994539038122, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.382026634673881, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.100426344668657, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.469241281940817, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.4395981331422016}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3134438363289216, 1.534714366238164}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.7177791303707455, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.162823150618887, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.836849948493799, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 0.7476353658440151}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.539739633930633, 2.5974910105351463}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-65.466905183977, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2173252490432223, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.197324582336553, 1.9401794743463283}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8763491247812073, 2.503891949699081}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.2876820724517809, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3226876816505963, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9699552564598479, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-33.34092227159292, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.10045059841862, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2453891602615295, 2.424802725718295}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.18260159600127354, 2.136530508663963}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 0.9654617758806044}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3983669423541598, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.21678878567620194, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.746403767507258, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 1.094604267270571}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 1.9254158540407285}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 2.647592232065096}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 2.0766877534832147}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.1136189934814222, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.3681303904922195}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.975391927697949, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.270112606830481, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6218266343535928, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.863232841258714, 0.8458682675776092}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 2.0759354023505483}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.017383521085972, 0.8385453832493022}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.908846148194222, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.461401833606696}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8344803566765893, 2.131796772013764}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-6.191868611452702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.278818960372969, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.966950472128539, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.002290482491421}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-64.46739506232224, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-8.666853965970644, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5716605481000705, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.15218556191195, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-46.34085167560773, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.594056810395798, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.9245405804618736}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.922779731666459, 5.857933154483459}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0305798782762827, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.770028224895903, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-63.46698269688735, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 1.5473497201206787}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.46013250945047257, 2.512035317176253}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.922779731666459, 5.857933154483459}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.199705077879927, 0.755182571479398}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6338708029279587, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7463370090740643, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.600868576791223, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.26683423993894284, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.410950117672171, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.2876820724517809, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.5305182571117267, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 0.9150900112976361}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.153303390278291, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3657077275115024, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.3420861064555702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.100386954332169, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7650729201315343, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6064191770501212, 2.5877640352277083}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.058828136697741, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.036382052219389, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-5.234028876665675, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.991862608772972, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8505029913361519, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.0968250627658085, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.30432512701003, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.412288358086009, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 0.848868055556721}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.2568373311553196, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.489435120039404, 6.29156913955832}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.19455609446229716, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.7254100886865211, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6039529822035308, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.3089739467365655, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2496677635880655, 6.131226489483141}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-45.34120604098636, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6713133161521878, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.863232841258714, 1.007592890280941}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.8178684794407625, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3348410795309749, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164563795096671, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 2.28401370740861}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8584936331479384, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6691879168398742, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0191543673333943, 2.570319527636131}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.091798316674432, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.904054835778969, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.566981433164056, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0931348688118385, 2.0095554142156695}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.7317869551252127, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.9267273296385394}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.40649706843741, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.809015255353917, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.2166915767337108}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.3504089023600859, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6149530931222105, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-48.341370727608414, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-5.493845750829273, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.49331319868135953, 2.4239173781615704}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.36154392105023625, 2.599722324216582}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.3930425881096072, 1.6384140206706175}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.069887328875024, 1.9416152247724325}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.8006962066887295, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4903224315439383, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.083998270167957, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7958982916754054, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-8.166888494485349, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4943251053335957, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4943251053335957, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7042981934580606, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-5.504112279527633, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.369240606554063, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.3732221725934863, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.522010001878903, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.3003570667360838, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2740421867477461, 2.5771819258971713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8787541283454292, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.666828609658249, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3138891646209549, 2.5862591440482876}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8644101099971662, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9958752112169974, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.6358850824489488}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.1413169453979233, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2854179707987138, 2.4997952622817508}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3005870903313728, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.27128392664214473, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-59.467094916063616, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.1454883067486056, 2.432735777459091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-38.34104853637971, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.463458318582131, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4983438649285135, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.349630376748299}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6009911288088023, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3413209954771594, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-5.7340355178272215, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2010151992412087, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.725433722188183, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-71.46678568954108, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0129050178795915, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.430789601006442}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6497392092076262, 6.131226489483141}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.7710464276305133}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3657077275115024, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.900422093749666, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-6.442136248054226, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4714166145367258, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4714166145367258, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.975450465015525, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.028748427364318, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.66442222076686, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-6.113858195322049, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.9999411183280458, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-4.083998270167957, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5178502387029551, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3186357126460757, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3426311639367969, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.3302529702362658}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.0365602553118024, 7.24422751560335}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6747180450915782, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-5.0040073078060345, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3983901944362025, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3688474475161698, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8821308802274503, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.995732273553991, 1.4772770088317615}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3180038323381698, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-29.340832002509437, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.33589240475620386, 2.502255288122613}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5186835491656363, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5186835491656363, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0700248318161971, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0700248318161971, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3413209954771594, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.6003175012993283, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7406861990440543, 6.040254711277414}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5828588266658222, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.41779075779880137, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.912572089444803, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.4109447331170353, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.941966881801218, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.500433550670171, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.100386954332169, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.184789984909162}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9689006821464524, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4159291662495814, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 0.761739972025557}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3186357126460757, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9565920286476808, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9565920286476808, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3118381623295401, 2.6993457604720636}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.2788685663767296, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.304161419150561, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3903023825174294, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3027280306570521, 2.419478844465545}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.0935997468445653}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.927891643552635}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4918104261047946, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.30938249943111995, 2.131796772013764}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.900422093749666, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7505644514298959, 2.5817308344235403}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.39809235377875135, 2.498151876538021}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.785741396902492}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 0.7466879474879751}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-62.46685674510361, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7797949872856175, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.218243944560295, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.1625110145183415, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 0.9654617758806044}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5159475693467614, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-68.46724388757043, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.700547258981618, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3874950816964096, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.4753441779534016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.60100614381313, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.911914268349973, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6622300779252237, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.225346881840062, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3154677188250594, 1.9387416595767009}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.458005208673891, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.342468881579861, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.312220927289192, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1208578976154293, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8328691237350826, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-7.166785108860756, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.893919494400295, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2942622756733968, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.42266213293668586, 2.418588768750352}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1702157075278026, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.48175237628028356, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 0.9666035457477442}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.700587583759682, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.1622605067393605, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.0968250627658085, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6548884684428551, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.584387646805562, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8438952236485835, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-4.199705077879927, 0.7997569156182036}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1564532883579597, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.694093021166824, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.532062329207643, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-40.340943771488284, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4409617624621989, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.832423655941967, 1.6937790608678513}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2942622756733968, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4184044150381243, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.318488613869894, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.1990607599649155}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4422299934501939, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 2.253709925211909}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 2.647592232065096}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6184786570862495, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.858931232061846, 1.5953389880545987}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5269366909223567, 6.253828811575473}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.004138294335951, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8442026554799011, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.475327636634016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-36.34119244432727, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2306590695884416, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.0942695392339727}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.100765130025024, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.8006962066887295, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.350408373771412, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9747212309094329, 2.0095554142156695}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9519282213808764, 5.8289456176102075}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8807977354618917, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3716028123769008, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5413120833865, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5413120833865, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.725971728690052, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3678803477808931, 2.421256622711544}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3943265328171548, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7832907304129113, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.360956006320375, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0053952069569758, 2.498151876538021}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3329431856228962, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0024805005437076, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.06016413371338, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.013077000561847, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.694451286761057, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 0.9666035457477442}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7611345721946656, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.2867117438377558, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1062413158326008, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7565130561817651, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.271538123821702, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.110313205346923, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2149273965428693, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 1.8728785205128469}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-6.541030999190403, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.9005275521158795, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.617850239145466, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.017383521085972, 0.7347688552507647}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4653375684603434, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-31.34091993726656, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.166995202991212, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.400308181522661, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.2164073967529934, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-60.466869255317796, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9519179095173061, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4171835010623628, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7448616162466241, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-28.340907620492793, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.4865920824352545}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.716864386545305, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-4.95401869367736, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.403068631572368, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.632849755094834, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.271538123821702, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.0942695392339727}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.5356434782150785, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6281111776997217, 6.152732694704104}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.565421027017326, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.565421027017326, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9306432380985556, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.719319793360441}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.316022308134559, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.063052113269559, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.104554242494911, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.6409365794934714}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.542246662893777, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164563795096671, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.850570223130148, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8566077297129814, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4460443655256647, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8773173575897015, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.96443110720209, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 0.849723487602042}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.094520670764856, 1.6937790608678513}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-4.76404869105558, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6414447085691868, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.6397713603489157}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8891518152367044, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.469241281940817, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.617854196524514, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.2101638842661795, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.700587583759682, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6039529822035308, 2.6993457604720636}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8566077297129814, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9390477189967712, 2.414126467726953}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.475327636634016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9306432380985556, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.314556464775266, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.6393849888020524}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9058454740126164, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.7847348542910906}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.49397078181451, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7565130561817651, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-4.2845370133966245, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4903224315439383, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.987249820814649, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-6.667164814064207, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 2.0427775573082445}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 1.6304163188192922}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.366810362993337, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-5.166938288491657, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6788498758591209, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.155182640156504, 2.570319527636131}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.1634411179801, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.382026634673881, 0.8441500540964727}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.341928551227046, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9186841628017217, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.220083871482302, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3700273886560186, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.719319793360441}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.2255369822417765, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-6.717134919373487, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 0.7499999921527281}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 1.1684492482568893}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.6526889544284153}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 2.073423469354273}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.190415030972834, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.290620611051608, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.694093021166824, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.91782824451005, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-4.382026634673881, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.417032243872697, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2942622756733968, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 1.0678093795130645}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8058680506240641, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9293759714228106, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 0.8202202631234213}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.836849948493799, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 1.0868770324496888}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7813228714636707, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-39.34081340913477, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5716605481000705, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.045554398052668, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5015355768588979, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0202633222571333, 1.4929040961781488}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.006215439402142, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.100426344668657, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.26443077336305, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.541030999190403, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.201916872261721, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2790527457537265, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6792442753909539, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.8420006856648017, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.7822140563845235}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.719319793360441}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8689301605143175, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8121662790057176, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7225041580723603, 1.9387416595767009}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 2.2044208442068145}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.623341473175256, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.659260036932778, 0.849723487602042}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4329667693183212, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3005870903313728, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3893457262282811, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.491327217590923, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.5087859235779435}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.523226215615035}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 1.2190584417439767}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.430629081771714, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0529699307894087, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1702157075278026, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.319222734147069, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 1.2499017362143359}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 0.848868055556721}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-27.341341040814093, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 1.9453385571563557}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0181583132629375, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.3178664036290963, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5692561228012685, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.887460350206278, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.931658209005277, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.418781887396557, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.76686592498839, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.7722610630529876, 0.986935571443487}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5159475693467614, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.7418655495969406, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1111386284230904, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.2178763245351174, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8643301620628905, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.159425367681418, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 1.3982229319851645}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.863232841258714, 0.8333438110532289}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.30031936921871, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.518075479137158, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6240440648234626, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9001713499942718, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.019664337643975, 1.8687205103641833}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4983438649285135, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5823216254710607, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.771368779580321, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.71869489837105, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.9063404010209869, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-49.34073194467232, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.900588627802483, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.4178610876830975, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.9736550492637259, 1.9198594718553708}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 0.849723487602042}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.491779868965868}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.9542522381612738, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 0.9364854391596744}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.966857671750368, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8250798518207709, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6654793033177253, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5906161581935125, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5906161581935125, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.377606779979768, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5561717255328675, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-4.524512282970637, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.9245405804618736}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.5338868320097188, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.606442403454302, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2654936609741865, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.9251241812954787}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3670139217339117, 2.134048091170708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4728877844255986, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.84195543139986, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.975391927697949, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.571249159610065, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-37.34075273404506, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640797356921787, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 1.3147983594148207}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.594056810395798, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.1975522365230131}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.800001029850119, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.468806782694355, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.30031936921871, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.9754419516613513, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0923241675108497, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.592214878401959, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.161367091078508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6332184410995039, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.21927603978772048, 1.860974538249528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 2.075684492802124}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.795734531747094, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6969544189028993, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4405393759722864, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0645007590393418, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.932401799030521, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.377692565480851}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8476951015583583, 2.0149030205422647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 0.766397642299538}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.6305480388034254, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.5978370007556204, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7912011210353335, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.741256487054948, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.975391927697949, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.51796702860799, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.411934093335004, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2409826299598365, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.657689841763261, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5918549290780729, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 2.647592232065096}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.0218709311636855, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2184098521237055, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.7828868907244566}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.087375656742122, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.542246662893777, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.77313400510489, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7178497932003172, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0339487753423875, 2.418588768750352}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.279845606024556, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.428942281870568, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.500433550670171, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 2.075308010398229}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.783559272662715}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.965852822566973}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2651392395634233, 1.5953389880545987}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.5257286443082556, 0.8055826098897335}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3478567954878509, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.3282528397426234}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.064355904261795, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.308100273682156, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.9568962497687927, 1.7316555451583497}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.10045059841862, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7672619976276676, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-61.467195171508536, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 0.9669838461896731}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1796054478776414, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.017810977845351, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 2.1122716862705384}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5064301623598713, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2971851860481147, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.5919427181706105, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.924832423452417}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.810369351701646, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.598497972395766, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.532062329207643, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.700587583759682, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4571461020918417, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 0.9403978072173882}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.194022473472768, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1715056141884346, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.6409365794934714}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-50.341331645288825, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6184786570862495, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.7042981934580606, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0186003506987251, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.793961892783255, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.61797181824309, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 1.3321021320364639}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6922761907431048, 2.6019486702196644}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6414447085691868, 2.599722324216582}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.30031936921871, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.615959129424366, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.615959129424366, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7004573108212688, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.900346940202133, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.119430549896199, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.215490386143112, 1.6114359150967734}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.8944568674663975, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.4028303297599902, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.8947738884119054, 1.7316555451583497}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3171415024315738, 6.063785208687608}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8305718564716175, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.8305718564716175, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.417776806585365, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.703510521060178, 1.8389610707123492}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.8012039280560548, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 2.217027204632399}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.735370011757173, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.246332151443247}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.6003175012993283, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.493879571799828, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.3178883284558303, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4079456086518722, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.984837274409265, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.900422093749666, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.0218709311636855, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6414447085691868, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.366795954944823, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.9005275521158795, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1464364105041143, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.3524072174927233, 1.0962762288705619}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3789263262507685, 1.589235205116581}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.3003570667360838, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.9782390361706734}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0328245481301066, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6906479678596436, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.585233223737283, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.666335489679042, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.926290362185661}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1208578976154293, 2.377692565480851}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.15455075984859803, 2.5756610130564646}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-32.34077434210908, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8940401229393353, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.2158025560795132}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.270112606830481, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.0841264243165862, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.841967538444134, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.313415715707318, 2.498151876538021}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.402871609042948, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.49397078181451, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.676945820702642, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5692561228012685, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.117817918407743, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.9661128563728327, 1.0942695392339727}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.894183087299815, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 0.8977193462887197}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.6407445017668969, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.502828177375842, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6941476808935289, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.9754419516613513, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.2256240518579173, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4876628555081794, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4361820807702249, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.841967538444134, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.9031380572114442, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7538858167999734, 2.599722324216582}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2960880932337415, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.701553201341906, 2.418588768750352}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2862680470527663, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.443923473956527, 2.418588768750352}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.5191254931746836, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7306413849875258, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.5558971455060706, 2.3456445824544927}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6539264674066639, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.579879110192556, 2.5974910105351463}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7120245012092015, 2.506341930508065}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6286207318508743, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.5177707239082765, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.117830825699811, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7406861990440543, 6.040254711277414}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1644316297054034, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1644316297054034, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.2941383093687477, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.556451816951096}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.095273387402595}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.4179914478631452, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4079456086518722, 1.773934884315503}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5288198871382693, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.7740297600361856, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.5919427181706105, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.103158068297152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.850570223130148, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2595256035335987, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5079962967558309, 2.134048091170708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-4.045554398052668, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7655070980839893, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.2164073967529934, 2.131796772013764}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7306413849875258, 2.827905162910489}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7637552728184576, 2.4265710727750367}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4267908948229169, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6424777665123005, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6424777665123005, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.640548907459153}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.719319793360441}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.6700167631710908, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0898959995836948, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.349630376748299}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.599292605088321, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3567355588783463, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7310567536331655, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.6397713603489157}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6416938989710297, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2824955457644808, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1409980051645476, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.317908016313041, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.2178439823981595, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.8027388571900397, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.7837272975307907}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.412267540691536, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6218266343535928, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 2.1151705891340815}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.592214878401959, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.068859330518762, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4028684822608984, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.40649706843741, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.5565205830281202, 2.702032128776647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.2170885989659, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.712716261887602}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6907507040241487, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1184069159962893, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.566911473871001, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1535965970008693, 1.4906543764441336}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.725332537920259, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2669126040998102, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8189251373008244, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.9910270779881722}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7159101569446171, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5068336024964532, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.500433550670171, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.700547258981618, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.475392057419415, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6492187824459448, 2.506341930508065}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.717779984300055, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3842963584572177, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.5087859235779435}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7820071777853768, 2.50470927708418}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0645007590393418, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6654793033177253, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.6825463842547386, 2.2648832258100344}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8195418502405067, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7145751279735658, 1.9387416595767009}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.166915255056936, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0942219403668167, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.071483621279857, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.598497972395766, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.6409365794934714}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.094604267270571}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4307829160924542, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3861841168703593, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 0.849723487602042}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5793937910857236, 2.5087859235779435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5324768712979722, 2.5877640352277083}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.96443110720209, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.215506040139609}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.82821600623867, 2.5862591440482876}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.612442421454399, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.9110235456270366, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.22276862160913655, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.725332537920259, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.377692565480851}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.8118888405232207}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.900458886151396, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.44926026810783587, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.286383733136742, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.036482917202561, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.725433722188183, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0898959995836948, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.0281898243715637}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.26443077336305, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6445470895476684, 5.736572297479192}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5876764206525877, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.045554398052668, 0.9604989865384754}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.437937594271729}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8407396514497736, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3874950816964096, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5474025215146479, 2.414126467726953}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0939232991819783, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.3286906908754075, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.094604267270571}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0108761743640229, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3063747379440172, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3063747379440172, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8350845939664286, 2.4265710727750367}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7903604483143476, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.666853965970644, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.2072749131897207, 1.902704363179782}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.287354413264987, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.287354413264987, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.246332151443247}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 0.7975071958841882}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8307082193666298, 2.512035317176253}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.719319793360441}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.6527732864216721, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.132893222644984, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.366940997255841, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8714522381373035, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.2862680470527663, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8413699697813894, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6005679992668521, 1.4996230464268938}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.893897967672723, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.2256240518579173, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4307829160924542, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.716864386545305, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4599740936085572, 2.004179057179289}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0975128932248088, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.912572089444803, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6691879168398742, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6691879168398742, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5366522427084526, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0918353043890858, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.3492738284584218, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5473167323484057, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.612442421454399, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.424802725718295}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.067986095126349, 2.3456445824544927}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.0279882600909205, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 2.1151705891340815}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.279055610450292, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.659260036932778, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3329431856228962, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.084253098677058, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 1.9838938336679197}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2063088641234838, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6126737964100685, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7168253079145225, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 0.965080896043587}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.0241960674538575, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6713133161521878, 2.187174241482718}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.4342248948774405, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.595748829015065, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.391511302188447}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.7840632625935846}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7109170813839543, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.746403767507258, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.536314386533157, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5687759307152107, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.7254100886865211, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.4920048155420047}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6398971199188088, 2.0843046973458237}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.4126383364594925, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0963149296194261, 6.684611727667927}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4605869657017456, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.5841201044498106}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3688474475161698, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1041274693562197, 2.413231613081109}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640797356921787, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7667937207282438, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.719319793360441}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.0906441190189327, 2.558002204858551}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 0.9707789171582248}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 1.9838938336679197}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.742398039690331, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4307829160924542, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.725433722188183, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2330583852210326, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2330583852210326, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.269044801069651, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.269044801069651, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.462743533283297, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.3089630181835672, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1689274625831354, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5213811377055073, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.640548907459153}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0277811079075183, 1.9768549529047348}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.0968250627658085, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.3645328693383778, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2063088641234838, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1542307124311217, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.5974734304916628, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2180717287054377, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 1.4915548717773834}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.1597073880279205}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.84195543139986, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.6906479678596436, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0645007590393418, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3585338134237321, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 1.8526977673331346}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.9999411183280458, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.270169119255751, 1.6272778305624314}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4934342366777942, 2.512035317176253}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6993626199620875, 2.020222182019865}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.528780009416646, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.4365120772805082}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.294015757351168, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.536314386533157, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.466163406970865, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.666853965970644, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-4.045554398052668, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.612442421454399, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.466024904841838, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 0.766397642299538}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6864844231876495, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 0.9290095042819297}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.817803785159501, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.8840655845794182, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.007679175452945, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.3418458069473482, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.900588627802483, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.2533450600473311, 8.350429973538136}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 0.8028980445190645}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8865098057738656, 2.5771819258971713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0996442489973552, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.4028303297599902, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8656213178265104, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.036382052219389, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4007990473227723, 2.5817308344235403}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.152962883418191, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8042369907391675, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4304552569056603, 2.503891949699081}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6218266343535928, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8944568674663975, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4307829160924542, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.881903019081021, 2.6224923127405635}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.9670073137609054, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.5077842587076005, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1874435023747254, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.1589994386832048, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 1.721694594779768}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.3407610128583247, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.6269849783062765, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.900458886151396, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4871090733432, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 0.9669838461896731}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.9499943818801375, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4329667693183212, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.1413169453979233, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.300630996469888, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.816462081868427, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.662352421858305, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9085180298382507, 2.423031246069913}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.137918471438812, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3842963584572177, 2.413231613081109}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.6888794541139363, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4240364936935998, 8.1797604936999}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.908818717035454, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5220551057175394, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.6624240079171049, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4338645826298623, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0404377246170375, 8.063377822367027}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.038175919864279, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.3137876703331426, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.995732273553991, 3.8004208288468435}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.8505029913361519, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.4307829160924542, 1.5904589458362974}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0302996484860225, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-7.1308988302963465, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.807005375881994, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.559220196273483, 2.135349173618132}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.294616923344869, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.9177918580004223, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0091694886945044, 2.5756610130564646}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 1.8526977673331346}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.2909841813155656, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7159101569446171, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 1.1464496180822696}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.694451286761057, 2.1644717908644115}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.400308181522661, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.298317366548036, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.6179742434563866, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.698815723585317, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.698815723585317, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-4.045554398052668, 0.8514321595256585}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.900346940202133, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8587568185269134, 2.136530508663963}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.8843386505211481}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7696066645869217, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.293947899598382}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.2908841763152323}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.117766656001504, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8598242001421843, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.768756076219605, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5342648554997536, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7789229575813493, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.538054293998892, 2.134048091170708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.850570223130148, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.475392057419415, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.1177951080848836, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.6190782472999463, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.5808504555821878, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.6528674703614363, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 0.9345235001352147}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5064301623598713, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.152761077153482, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9200474895295858, 2.498151876538021}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.71869489837105, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.807005375881994, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.9980550336767947}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.6888794541139363, 0.8505781885087738}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.3492738284584218, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.968974088653865, 1.803358605071407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.7378311272024993}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.694451286761057, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.64930970607961, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9186841628017217, 2.1400661634962708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.273910668367863, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2315538186741798, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.694451286761057, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7168253079145225, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.0598714603516792}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.995732273553991, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.878625402249717, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.540748536722336, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.567015866357096, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.29356601561075557, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.3101690833145914, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8997902134417601, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.6409365794934714}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4876628555081794, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.468806782694355, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8426317996018116, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 0.8514321595256585}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8407396514497736, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 0.849723487602042}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.780226233414382, 1.9300710850255671}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.7867719277170158, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3563472847519384, 2.3850863145057892}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7903190923122189, 1.6272778305624314}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.462149662665384}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.7790406968202803, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.8269722249837996, 2.1825620503943153}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.4305321073246677, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8904754421672127, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.8505029913361519, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1880994551696458, 2.3850863145057892}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.612240146256234, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.76705723517796, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.293868803909631, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7435408969575807, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.0654001544619962}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.5288035062673013, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2739976361421332, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.9639722918737217, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.599488434143067, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.548102073285148, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0177699008240089, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.421661504957182}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 0.898534010284896}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 2.4561641809223462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.278964002683987, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-6.667164814064207, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.742398039690331, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 1.721694594779768}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.1625110145183415, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.741256487054948, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0940068428223313, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.973281345851445, 2.4239173781615704}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.293897511853923, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.894078619827491, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.2170885989659, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.228790658775024, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9784819201474635, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9414202437824613, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8016468498397944, 2.130609828254235}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-5.817847430944174, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1026203100656484, 2.2648832258100344}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8195418502405067, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.995732273553991, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.911914268349973, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7199019178687649, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7987840841650193, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7212874278842305, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.515036014769512, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.191191469961203}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0288996762568094, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.786359562282124, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5228016057745537, 5.857933154483459}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.200028504668954, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.082935809283102, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.36571568859088144, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.4753441779534016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0604498275737608, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.8283137373023015, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.44238846221276223, 1.501852701754163}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.0940068428223313, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.1966460289394751}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.974001029221839, 2.502255288122613}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2330583852210326, 7.8709295967551425}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7414001807837645, 2.131796772013764}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.766368110426725, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.869504817852908, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.66442222076686, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.162823150618887, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.359873830032749, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.411934093335004, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.915963072687361, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.8699543168131119}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.220083871482302, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6497392092076262, 6.131226489483141}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.1866231659908228}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.1627481478062465}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.5532907518110994}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.3563504847468186}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.6623114020411685, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.6790255220615937, 2.134048091170708}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.7867719277170158, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.214574215671332, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.4405393759722864, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3193836558372638, 6.461468176353717}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0129050178795915, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.196377287787253, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.2157956136516715, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.376740148315079, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4850103340590484, 2.135349173618132}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.9122987106046175, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.820158943749753, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.9028810449642375, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8129108417183852, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.7181373293574413, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.995732273553991, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.786359562282124, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2072749131897207, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7655070980839893, 2.0930978681273213}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.7083778602890038}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.6624240079171049, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.6888794541139363, 1.0942695392339727}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.412288358086009, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.823966230699553, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9240709191931175, 8.1797604936999}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.9975007872996983, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7696066645869217, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-5.10045059841862, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0612087734187763, 2.519308076505333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8997902134417601, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.5016459737922982, 1.9198594718553708}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7002308520500784, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.2867117438377558, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 1.3045418592476314}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.322289031143978}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.3281354469463584}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-6.667164814064207, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.975450465015525, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.132893222644984, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.3504080825554816}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.0289048762432895}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.3504089023600859, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3039860739096736, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.029509172931627, 2.4997952622817508}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.350408373771412, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6445470895476684, 5.736572297479192}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.2207799226423173, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.30348549823721, 2.432735777459091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4307829160924542, 1.5904589458362974}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.9407951330603375, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 1.173410498743296}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 2.215282764591249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.995732273553991, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.6843598389513597}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8551011438142453, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-3.6504282677396835, 1.5432981099295553}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2669126040998102, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.359873830032749, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.028556821684098, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.7147984280919266, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5663784229736533, 6.214608098422191}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9428149441480107, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.491654876777717, 0.7485818874480459}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.100765130025024, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2069773133462347, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.418894215394429, 1.6882490928583902}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2977324083052823, 1.6114359150967734}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.4847813078345447}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5059792040658704, 2.0843046973458237}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5644645467913691, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.8505029913361519, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 2.066736169182282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.640928579525471, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9038682118755978, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9110235456270366, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.282782465697866, 2.423031246069913}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.4588475538015993}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.7667937207282438, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.898454207899018, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7903604483143476, 2.0681277817795625}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 1.0420419371797154}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.4354783156390294, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7955707986317053, 2.0706530356467567}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5782126424678459, 1.5432981099295553}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.8069317506623275, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2437536743377806, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0993125337825032, 8.004365564979574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 0.911479174876933}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.3039860739096736, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.2255369822417765, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7109170813839543, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1199380753828623, 2.065596134857783}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0549440700794483, 2.418588768750352}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.3491115699921747}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 2.3243465847755584}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6544352783648362, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7987840841650193, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3678803477808931, 1.4973884086254774}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.575036485716768, 2.020222182019865}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.885443919659868, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.6623114020411685, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.462149662665384}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5901256014017275, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8500747011316276, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1230074455028314, 2.1825620503943153}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0794415416798357, 1.815475995845371}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.23876493221716663, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.4532518292447716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.975450465015525, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-3.101092789211817, 0.7802418874108791}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.552112845814831, 7.55171221535131}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.4911047254722358}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.007679175452945, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.0923241675108497, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0891571298973546, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 2.031563461435372}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.036482917202561, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3993162819538174, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9696906777207166, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.5329399414613754, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.5902550930173265}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.4420193761824103, 3.2386784521643803}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.6094379124341003, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-0.7985076962177716, 1.2140221401789375}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.816462081868427, 2.0425181875752383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.3524072174927233, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.1603343472961065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.6888794541139363, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0971007679422797, 2.0082140323914683}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.300630996469888, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.1279381180499384, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.419118909249997, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.4405393759722864, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.739076112448345}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.3003570667360838, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.9122987106046175, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9002402920947703, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7672619976276676, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.807796846925679}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.344384958042681, 7.759614150696903}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-3.6888794541139363, 0.9669838461896731}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.3524072174927233, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.5824869781268642}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1111386284230904, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.104554242494911, 2.421256622711544}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.220083871482302, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.552112845814831, 5.8289456176102075}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.6260755535871236, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.8424288832756998}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.159425367681418, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.220083871482302, 2.424802725718295}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.676945820702642, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1689274625831354, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.6888794541139363, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.319222734147069, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.5287678617828835, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4644721421839146, 2.494031557565001}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.5845302767279155}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.3035404883862389, 1.5107219394949427}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7667937207282438, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.1733127572899065, 2.419478844465545}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.95263269481614, 2.1174596088673567}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.51875303057183, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6745099091778153, 1.9300710850255671}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.721515815839451}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6939993778795506, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.3524072174927233, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-6.912265434460023, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1464364105041143, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.4088348928367562, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.2181715237257489}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5173146235582946, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.435545220250276, 1.776645831418007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.706800981701778, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9192952408944538, 6.461468176353717}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.209391157353635, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 2.2086040295231517}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.2098554674840916}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.6888794541139363, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2395270305647338, 1.4996230464268938}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-3.3524072174927233, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.3504089023600859, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.974001029221839, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.350408373771412, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.9987836386623814, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 1.7535382564078572}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1874435023747254, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2942622756733968, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.8610265707016995, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.8183088044615916, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1304126012179074, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.864975531559314, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.110245660342752, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.400308181522661, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.6108369333478076}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.8526977673331346}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.7078502210995437, 1.5973653311998313}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.8426317996018116, 2.0162354657760435}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-54.46678982836, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.820158943749753, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.946310229076653, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.100426344668657, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.2636117187095923, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.5005758256424344, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4912105310694506, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.0287936073591935, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8461060995981784, 2.004179057179289}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.70036037299184, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8598242001421843, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.786268646522262, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.940865372113151, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.9910142780700916, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9515240188896708, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.900588627802483, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.5779472453427295}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.506518858426259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.064355904261795, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6163727633271883, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.715777948205427}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.606941032235513, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.493987758524193, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3037931396081468, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.309519943887134, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 2.044332364566268}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.1941832122778293, 0.6936470556015963}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.412382827063892, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.995732273553991, 5.991464547107982}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.742969305058623, 1.9837562915454279}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 2.647592232065096}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.21678878567620194, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.2917089186300228}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4947708374559745, 5.886104031450156}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.4307829160924542, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 2.647592232065096}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-2.6168849633501186, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.874045755297392, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.900464386136271}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.869504817852908, 1.9892432737616872}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0514564223263525, 2.0028304393079956}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.810913836561449, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.894078619827491, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.213639558072954, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.4312677267626217}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.556451816951096}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.0102369597568726, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0181583132629375, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.3452119160186606}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.286383733136742, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 2.193662685769859}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8195418502405067, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9661128563728327, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3482281603134343, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.017939231019695, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.389499492068839, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0918353043890858, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.963188584855586}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2063088641234838, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.5808504555821878, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.7329280505717899, 7.8709295967551425}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.424802725718295}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.8470364847178946}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1214715828141923, 1.9387416595767009}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.500810170663849, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.91139112512024, 2.0068708488450007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-1.7897614665653818, 2.04225875055212}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.599488434143067, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.0328245481301066, 2.425687290128029}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.5608378214218233, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.8146618624453594}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.26683423993894284, 4.386889790339869}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.293947899598382}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.044846896915337, 5.736572297479192}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.483987072728617, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.5449114637250294, 1.5933085305042167}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.8420006856648017, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.4701108472130011, 2.58851563240702}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9806466361359503, 2.005525858729668}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.170085660698769, 0.7802418874108791}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7147984280919266, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 0.9654617758806044}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7109170813839543, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9949325933834268, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.219163484854973, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.1627481478062465}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.693851481702397, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 1.9782390361706734}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.898454207899018, 1.9600947840472698}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.4226262903672808}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.4135166537013273, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.333559897293476, 1.9768549529047348}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2303167796655379, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.7254100886865211, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.395133309787095, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.389499492068839, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2361517026901712, 2.1329823086078656}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2433732333621994, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.3749057545736716}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.036270701217564, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.378751192832325, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.5005758256424344, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2377341206744292, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8407396514497736, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 2.031563461435372}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.2568373311553196, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.902767737471098, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 1.8826660279157308}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.9180031958023054, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.064355904261795, 2.065596134857783}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.6854573524495757, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.412382827063892, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.900346940202133, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.5978370007556204, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.168283961917429, 2.0719132752590443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.5005758256424344, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.152897360346143, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.4126383364594925, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7048480972387587, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.9754419516613513, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.5047438413194347}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.224893897193764, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.6139480679119864, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.900464386136271}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.0939462278827174, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.4018530946527146, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.491654876777717, 2.1094856630282126}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.2568373311553196, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.7693434299437227}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9519282213808764, 5.8289456176102075}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.5539252025038417}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.671097292820828}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.7693434299437227}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.6939993778795506, 4.386765389021055}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1111386284230904, 5.66988092298052}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.317800258800526, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1150465951315345, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.5920892740994874, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.575036485716768, 1.1780394222994315}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.5366522427084526, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.816258383443767, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.296603021316498, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.6378309869353183}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.1409980051645476, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.652827532407001, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.286478374605709, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.7164562218841706, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.555615105736594}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.491654876777717, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.3326298365341978}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8953440995227226, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-0.26683423993894284, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5173146235582946, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4375876555074412, 2.0149030205422647}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0417762120553977, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.2975725511705014}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.7188583998188136, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5978370007556204, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.166888494485349, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8598242001421843, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.506518858426259}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.1892564076870427, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0898959995836948, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-6.786422993814612, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 2.0624225365102413}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.0738571633859353, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.1526461771605954, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.779362064213738, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.68510181635509}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.3420861064555702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.4938666711595117, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 2.090999490513565}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.475392057419415, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.3204807842031671, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.5978370007556204, 1.3754861624032872}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.100765130025024, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5129946410508307, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.279055610450292, 2.0731719286662407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.5609672964009644, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8997902134417601, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.044846896915337, 5.736572297479192}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.46298829435183064, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.4753441779534016, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-2.3418458069473482, 4.386889790339869}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.940782792197422, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.70036037299184, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.466278187121473, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.171276846068922, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.653113060608557, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.5612262966614128, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-5.298317366548036, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-8.028919972120757, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.725971728690052, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.612442421454399, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.953887209526845, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.6591800043289144}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.170932950247736}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.912330925723864, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.0136538011418326, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDiamond]\"\>", {-1.0498221244986778, 1.0935997468445653}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2026403590921573, 2.0095554142156695}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.8162894669713328}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.966950472128539, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.05211045501669, 7.55171221535131}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.2761851384398606, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.2158025560795132}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 1.0732944806838198}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.9477043045434095, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164563795096671, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.3354096411241523, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8951219822232084, 5.886104031450156}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.6378309869353183}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.412267540691536, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.4407825464039603}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-6.662458923026794, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.5100594684538216}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.1622605067393605, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.902818692021688, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5104979645791967, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-7.7788336680347445, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3993162819538174, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.5107219394949427}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.6587993419718245}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.7929254558680243}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.201916872261721, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.166888494485349, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.2255369822417765, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.849872629798755, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.017406150760383, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.631199404215613}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7389772837890856, 1.803358605071407}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.697356025334, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.186787979571835, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 1.9474803442248305}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.2742448573112677}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.166785108860756, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.286478374605709, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.529318843261892, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.500810170663849, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.068859330518762, 2.3896797998449792}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3208812225716584, 2.0095554142156695}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1028721491118945, 1.937301774518713}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.1269525243508878, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.536881615643591, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.3731931852525583, 1.860974538249528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.06016413371338, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-0.09926800165866902, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0442924641693683, 1.9358598132018119}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.4307829160924542, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.4179367056664534, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6888794541139363, 2.9290581402859983}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.9313764735639716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9372477759766606, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 2.078566158643882}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.196424897165655, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-0.7985076962177716, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.317867774075151, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.912265434460023, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.8499018253424513, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8997902134417601, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.2672179491567546, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.199705077879927, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.018486244188825}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-6.402746540537711, 4.512945241945574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 0.9925107577855641}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.411934093335004, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.0335402919243948}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8540604954254345, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.6593256320844346, 7.944492163932159}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.087375656742122, 2.3711778844596574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.1062413158326008, 2.3523271848888596}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.2256240518579173, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.166785108860756, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.8442026554799011, 7.759614150696903}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.2909841813155656, 2.209811692841691}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0027568884909557, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.517955942272351, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.5606477482646683, 1.251619457793289}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.7539022397884905, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-7.036270701217564, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.227106951818089}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 1.1151415906193203}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6544352783648362, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4007990473227723, 6.380122536899765}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2371849385320495, 1.9401794743463283}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-4.300630996469888, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.162319869424133, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.251047211711865}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.2499926428748753, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.1499389158334503}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.506518858426259}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.557794679282262, 1.8687205103641833}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2262184132732556, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 2.090999490513565}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 2.647592232065096}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.786422993814612, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0605908459024875, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2909841813155656, 2.414126467726953}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3498863661120586, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.6178619668786562, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8773173575897015, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.6761120457020933, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-8.036311444023319, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-6.536881615643591, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.040829633207479, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1199358770132974, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 0.9489515141137035}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.5895081458004594, 6.7912214627261855}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 2.4561641809223462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.2178763245351174, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 2.330200260027019}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3993162819538174, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 2.3243465847755584}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 0.8307328435125084}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.793961892783255, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.864704011147587, 0.9858167945227654}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.074653024948039, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.4018530946527146, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.746403767507258, 5.634789603169249}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.1269525243508878, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3617968895195032, 1.9416152247724325}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.3071607397357723, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.2809338454620642}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 2.193662685769859}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.662458923026794, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9582864201233687, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5901256014017275, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.813734143549063, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.900458886151396, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.864704011147587, 0.8989410935390421}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.418747583305227, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.030116700415822, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 2.0624225365102413}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3093333199837622, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.9180410777537094, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.0218709311636855, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3470736479666092, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.4907663827166018, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.9313764735639716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2936253516225737, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.525061368884541, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.201916872261721, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.4122057429043917}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.8002235476401844}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8238695231462887, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4371455863897404, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.1498640059763816, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.7539022397884905, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.8002235476401844}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.406587064387653}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-4.3428059215206005, 2.6490076604684267}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.993630885266725, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.4307829160924542, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0891571298973546, 6.29156913955832}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5228016057745537, 5.857933154483459}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.741015208534465, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3649243353836982, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.9205497887945385, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 0.880041599199034}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.669026703845758}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.4146388341290332}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.5432981099295553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.340807418168989, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.5639866495301828, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4460443655256647, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-6.140893060599911, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.2406103170142067, 1.8656293177945105}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1796551117149194, 1.4906543764441336}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.2581768583394481}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.5377270648801}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 1.497835735852798}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.8205261098897758, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.2876820724517809, 2.1587147225743437}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.502290170873972, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.049977288406387, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.1428411385922033, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.406587064387653}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.6744763086133228}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.7859090555498793}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.9521761906339596}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              
              StyleBox[
               InsetBox["\<\"\[EmptySquare]\"\>", 
                {-1.0498221244986778, 1.726509584019938}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4118173183509766, 1.5973653311998313}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5978370007556204, 1.3754861624032872}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7985076962177716, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.8056623743970464}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.1029215602562081, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.2756420910162956}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.107781777362614, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.7181023127908395, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8016236568960291, 6.579251212010101}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.864975531559314, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.606941032235513, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.666828609658249, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.991862608772972, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-0.7985076962177716, 1.144222799920162}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.363503507963463, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.2136588837996443, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 1.9569913819232716}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.117899907528199, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.0929041853062644, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 1.9368694044031642}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.5102244577722903, 6.476972362889683}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.184232881424661, 1.860974538249528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1883639489040227, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 2.0680013515372804}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2783372196147982, 1.864080130807681}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.1541650878757723, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 2.1992225799988927}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 2.1872864686305826}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledDownTriangle]\"\>", {-1.0498221244986778, 2.330200260027019}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0498221244986778, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 2.1992225799988927}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8195418502405067, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.133013715385442}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.540842282118304, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-8.040959012419865, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4126383364594925, 1.8625285401162623}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 1.1026043099376472}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.904054835778969, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-3.2957568692041583, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1593181637855046, 7.944492163932159}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.8180773925856184, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.4854489341097463, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.426283369336254, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8146187633741377, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.959419502711985, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.606941032235513, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.156840433948748, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.708153885373258, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.666828609658249, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.604170685655008, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.2792657883613672}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.8195418502405067, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 0.9543569326806114}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.820158943749753, 5.560681631015528}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.605170185988091, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.3137523001849649, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 2.4176979000945504}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.2909841813155656, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 0.9991602096964498}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.795734531747094, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2595256035335987, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.4686200579795896, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1806171127511105, 1.7817091333745536}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.104394898075602, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.995732273553991, 5.991464547107982}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.522010001878903, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.6562368265398482, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.0498221244986778, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.6736487743848776, 0.6951451832226183}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.669026703845758}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.6916833814466705, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.2030071867437115, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-1.741256487054948, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.035305048673814, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.8773173575897015, 1.6114359150967734}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.2367852454117685, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.389499492068839, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.991862608772972, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.7760829898430475, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4405393759722864, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.6609757937162812, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.017773404430871, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9840343839606746, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.253208503948706, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.6354040111173562, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.802272141469027, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3055896020143445, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.66442222076686, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.162319869424133, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.399798360748448, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.3082536360194172, 1.4929040961781488}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.1308988302963465, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.263088979544526, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.252691173362931, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.3109197297841035, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.946310229076653, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.064355904261795, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.327296573822621, 1.7850704810772584}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 2.0680013515372804}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.319222734147069, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.2672179491567546, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.868484703413663, 1.501852701754163}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.3257638613798584, 1.776645831418007}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.9518038754399907, 1.4973884086254774}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.66442222076686, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.7148128361404407, 1.4996230464268938}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.7672619976276676, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.66873333872526, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.781788039865368, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.781788039865368, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-3.700547258981618, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.7479817218821596}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.896419739771488}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.235513466021224, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.359436906950008}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.376740148315079, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.666335489679042, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9540431322855023, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.4679383501604009, 1.7833912195575383}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.9299445330159877, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.725971728690052, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640797356921787, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.336815122732887, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.6298561136644754, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2496677635880655, 6.131226489483141}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.421604191439818, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9405834244431995, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.7963700817857382, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.327853987437946, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6734432424100127, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3998672158005996, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.604906020337758, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2016421889876536, 6.579251212010101}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.417771502803163, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.57270299585059, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.9353900445478294, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9317114296555002, 1.534714366238164}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-1.2669126040998102, 4.386889790339869}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.416581053724763}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.5645401798583287, 1.6956156086751528}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.6302332586812027, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.4971646699513146}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.5159350591325786, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.0939462278827174, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.989444152396731, 1.5107219394949427}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.491654876777717, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 0.9566646260124284}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.741858378904823, 1.6034198401085373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.4370318346713713, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-8.036311444023319, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.6777417097034806, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.536426440357718, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.541256860244439, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-4.0757190980989355, 1.4996230464268938}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.872802292274865, 1.601405740736836}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.5332441625824873, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 1.0497721232486361}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.786268646522262, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.424056675808238, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.140807436632442, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.7937956240634962, 1.6114359150967734}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.5377270648801}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.395911377232918, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6798603767306461, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.5774997570339834, 8.026170194946426}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9405834244431995, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.369240606554063, 1.691939133945844}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.696151689580244, 6.684611727667927}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.4929837772928636, 1.6974487897568136}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.4420193761824103, 3.2386784521643803}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.360956006320375, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.618595850218866}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.416204086475468, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.9178457348969196, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.6240307955986357, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.662352421858305, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.66442222076686, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.803865056899991, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-7.912330925723864, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2072749131897207, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5901256014017275, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.362224007377702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.9368694044031642}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.5404260935422814, 8.063377822367027}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.51624397679369, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.57270299585059, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.5260163042950279, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.319222734147069, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.491654876777717, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.4569857892424236}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7897614665653818, 5.991464547107982}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.6311724045801064, 1.4883995840570443}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.564942672547549, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2069773133462347, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6426838976709575, 5.961005339623274}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.552112845814831, 5.8289456176102075}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.5077842587076005, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.7218733417638885}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.4890765557629164}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.3261404383001434, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 2.209811692841691}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2437536743377806, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.5554040239416147}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.0128784323889617, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.4138711288901251, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3149043650332175, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              
              StyleBox[
               InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.016955910005618, 6.0867747269123065}]
                ,
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.860379772276308, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1270117631898076, 6.253828811575473}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5191402744533198, 1.6882490928583902}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.376740148315079, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7573580425107227, 1.589235205116581}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.9782390361706734}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.8179208722379223, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.0498221244986778, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.15218556191195, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-7.540748536722336, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.8140100781628747}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5177604746590787, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.4961092271270973, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3093333199837622, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3838972365201692, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.719252778441307, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.631089159966082, 0.9034081060431414}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.3434070875143007, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.406587064387653}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.941966881801218, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7533219035960154, 8.350429973538136}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8078888511579385, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.741256487054948, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.362224007377702, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.860379772276308, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.6444188813293459}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.7630345094349695, 5.840641657373398}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3093333199837622, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.8056623743970464}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164563795096671, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.7317869551252127, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.0738571633859353, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.016955910005618, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 2.078566158643882}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.8470364847178946}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2815740503494875, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.0498221244986778, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.7147984280919266, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.5732134108799993, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2201021862558195, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.466278187121473, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3025850929940455, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0129050178795915, 5.768320995793772}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7170231231140378, 6.063785208687608}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.1715568305876416, 1.6675181235106251}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.56019682034536, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9205497887945385, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.9105241293044104, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.1541650878757723, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.178596114669692, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.491654876777717, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.5832829549572491, 1.5933085305042167}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4179914478631452, 6.363028103540465}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.4958211856471328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3037931396081468, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.981226494182881, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6100682736896466, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.617843933216061, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.978697138696139, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8195418502405067, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8951219822232084, 5.886104031450156}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.5978370007556204, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.8958869385842747, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.168928708181372, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.7177975525570903, 4.512945241945574}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.7406415980494447}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.715777948205427}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.721515815839451}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.59947470469731, 8.004365564979574}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.522010001878903, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-4.15218556191195, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.2909841813155656, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.9910142780700916, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5082360319251331, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.8122154777954373}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1150465951315345, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.9474803442248305}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.269150316907808, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6287255312941893, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.606941032235513, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 0.8450095298691913}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2201021862558195, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.957577403480815, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.809109107563168, 1.4951487660319727}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.795734531747094, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.946310229076653, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.941966881801218, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.219163484854973, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8997902134417601, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9146052992269007, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.3865452232556535, 7.24422751560335}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6888794541139363, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.2669476034873244}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.664950622364359, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9896682016789307, 6.7912214627261855}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.987774353154012, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.2756420910162956}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.4528616053920038, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.5845302767279155}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.516892795645856, 6.0867747269123065}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2045513527226803, 5.676753802268282}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.6744763086133228}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.03270329512458, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.706800981701778, 6.396929655216146}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 2.187398683184928}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.2909841813155656, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.236923904465622}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.5902550930173265}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.7147984280919266, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6798603767306461, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.862757913051401}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.2262184132732556, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5082360319251331, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 0.9329511727672622}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4460443655256647, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.386702935511703, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3037931396081468, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.340512168464763}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5901256014017275, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.7188583998188136, 5.111987788356544}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.2787091504399533}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.8162894669713328}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.2855499581361935, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.3964921860963366}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.793961892783255, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.8283137373023015, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.1850957485562468}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2808538486618937, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.744112815760702, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.007592890280941}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2595256035335987, 5.521460917862246}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.198225077669803, 1.1921026317554486}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 1.2299329059954676}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.5878700408461053, 5.19295685089021}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-4.3428059215206005, 3.2386784521643803}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6761120457020933, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.953887209526845, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.4532518292447716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.8805331812814825}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-3.7317869551252127, 4.386889790339869}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3649243353836982, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7969533492855345, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.0776338822829181, 8.026170194946426}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.132468797127462, 5.971261839790462}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.1464364105041143, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.4240364936935998, 8.1797604936999}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0029385385998273, 7.600902459542082}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.5732134108799993, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-2.3025850929940455, 0.9411784473819341}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8457617469776957, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.7268653293100646}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.4588475538015993}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.835485924411894, 5.768320995793772}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3811078344325904, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.2926347621408776, 1.1167795926235586}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.68510181635509}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-2.795734531747094, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.8706006059570394, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5352740571517867, 6.068425588244111}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.8866985125298688, 5.717027701406222}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.4286713586629105, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.5787702314339063, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.6324790142551358, 5.971261839790462}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.2864827918762988, 7.24422751560335}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.322289031143978}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4007990473227723, 6.380122536899765}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.6661962462527091}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.606235808570649, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.5432981099295553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-0.7985076962177716, 1.599387576580599}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.096384262410148, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7985076962177716, 1.144222799920162}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.1236024374656055, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.4809943129680847, 6.62273632394984}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6149530931222105, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-4.196377287787253, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.9572739077056285}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.5539252025038417}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.204382667431038, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1663559407546291, 6.214608098422191}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.9317114296555002, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.191191469961203}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.3281354469463584}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.554477071672573, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.6311724045801064, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3005870903313728, 5.480638923341991}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.164563795096671, 6.939253946041508}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3993162819538174, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.3162388941358785, 4.787491742782046}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8470607850131444, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0592954262911594, 6.721425700790643}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.064355904261795, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3047875165492457, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.1406850650900175, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.5978370007556204, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5082360319251331, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.571283042360924, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 1.0598714603516792}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.4226262903672808}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.1743805849816495, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 0.766397642299538}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-5.740861482897622, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1593181637855046, 7.944492163932159}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8097197946050478, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8097197946050478, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.020229905154391, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.340556469446037, 6.040254711277414}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2815740503494875, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.6115589009134488, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 0.7975071958841882}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.491654876777717, 0.9290095042819297}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2406367886975274, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5173146235582946, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.154094566627875, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.4122057429043917}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.1966460289394751}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              
              StyleBox[
               InsetBox["\<\"\[FilledUpTriangle]\"\>", 
                {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.4964931534179662}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.659260036932778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.8610265707016995, 4.969813299576001}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.8457617469776957, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.0580715159436433, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.101092789211817, 0.911479174876933}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 1.9510398268753117}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.834634353211663, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.2917089186300228}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.744112815760702, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 0.898534010284896}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.957577403480815, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[Times]\"\>", {-2.1413169453979233, 4.512945241945574}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.319222734147069, 6.784457062637643}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6149530931222105, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640797356921787, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0189110419398038, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.744112815760702, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.1603343472961065}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.111964733385396, 6.492239835020471}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.266384064447333}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6149530931222105, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2909841813155656, 1.0289048762432895}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2282654968949804, 6.152732694704104}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              
              StyleBox[
               InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.2319770007355333}],\

               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.378751192832325, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.340556469446037, 6.040254711277414}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 1.0654001544619962}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.659260036932778, 1.416581053724763}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.178596114669692, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.2246985543369746, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.5232317641096684, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.5960282255241827, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2437536743377806, 7.360103972989152}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.5338519254775054}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-0.7985076962177716, 1.599387576580599}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.101092789211817, 0.7802418874108791}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.8871696540327132, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7199019178687649, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2016421889876536, 6.579251212010101}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 0.9345235001352147}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.557794679282262, 5.823045895483019}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.2809338454620642}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.742969305058623, 0.8028980445190645}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0898959995836948, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.214608098422191, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.740780025725129, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.710307401527557, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.6704076935904559, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-3.1958919884778254, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8773173575897015, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.531088946023124, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.030860186617291, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-5.298317366548036, 2.6490076604684267}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-1.9661128563728327, 2.0215475632609334}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.804781390061982, 6.298949246855942}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1080567474961094, 6.272877006546167}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.9661128563728327, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.023439351564551, 5.2574953720277815}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.3907040696085906, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.6486027424587903, 6.455198563340122}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.659260036932778, 1.4722426732562555}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.3871630694693433, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.2319770007355333}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.9372477759766606, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0808706071919527, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5703987153008919, 6.960347729101308}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.1499389158334503}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.344384958042681, 7.759614150696903}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.6593256320844346, 7.944492163932159}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.3428059215206005, 2.6490076604684267}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.2936253516225737, 5.537334267018537}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.991464547107982, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-6.214608098422191, 1.6094379124341003}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.5640797356921787, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.5532907518110994}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-3.1958919884778254, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.334591889129132, 6.269096283706261}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.25165731439258, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.064355904261795, 6.539585955617669}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 0.8055826098897335}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0969137320325284, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.622553707074063, 0.973049065692764}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.0498221244986778, 1.018486244188825}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-8.532306829226286, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9969586349416099, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.157075423962754, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.017406150760383, 7.086737934510577}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.1958919884778254, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.8130574772325029, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.2815740503494875, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 0.9364854391596744}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4405393759722864, 5.940171252720432}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.552112845814831, 7.55171221535131}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4460443655256647, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.2739976361421332, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.12893600699172, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.3993162819538174, 6.704414354964107}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0826466726287842, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4390923376487086, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.659260036932778, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.2919836816486494}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1796054478776414, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.421661504957182}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.9286606465811693, 5.075173815233827}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.1760334356366946, 6.104793232414985}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.6888794541139363, 5.298317366548036}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 1.0678093795130645}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.751531979714171, 5.8522024797744745}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5188771693591536, 6.584791392385716}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.563430511492267, 6.040254711277414}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 1.1990607599649155}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4092798316650086, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6798603767306461, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-1.742969305058623, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.174191878225647, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.593338543970313, 4.787491742782046}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.6569932652516144, 5.44673737166631}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 0.766397642299538}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.5257286443082556, 1.3302529702362658}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2736802167507564, 6.507277712385012}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-3.101092789211817, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.283414346005772, 5.703782474656201}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7129418078881248, 6.81783057145415}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.880084850028029, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.2908841763152323}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8734707346912269, 6.507277712385012}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.659260036932778, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.674083651538937, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.0845133642886082}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-3.1958919884778254, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.839070463540614, 4.941642422609304}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.145857732131629, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.0794415416798357, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 0.8977193462887197}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.1597073880279205}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.000759888500605, 6.380122536899765}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.6960857191597725, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8097197946050478, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.504420282887948, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.3025850929940455, 1.1637756145745228}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0794415416798357, 1.0281898243715637}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8773173575897015, 7.226936018493289}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.2602187884025833, 5.393627546352362}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4912105310694506, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.335971596744448, 5.267858159063328}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.8344641259578687, 6.152732694704104}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.05211045501669, 7.55171221535131}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9563317814113389, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.7056031974591583, 5.075173815233827}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8016236568960291, 6.579251212010101}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1796054478776414, 7.424165281042028}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.5136732904497212, 7.090076835776092}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2201021862558195, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.403677882205863, 1.445270566220188}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.636577829072051, 7.24422751560335}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.4316692464055834, 6.672032945461067}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-2.4371455863897404, 5.393627546352362}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 1.0360274134764884}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2815740503494875, 7.822444729489319}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.5257286443082556, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\[FivePointedStar]", {-3.0957736277342174, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7625890919282752, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.6149530931222105, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.344384958042681, 7.759614150696903}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9240709191931175, 8.1797604936999}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-2.945799904805782, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.6474092888860916, 8.006367567650246}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.5257286443082556, 6.461468176353717}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.8563722416629115, 6.674561391814426}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7199019178687649, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7813228714636707, 7.822444729489319}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.3428059215206005, 3.2386784521643803}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 1.007592890280941}],
               StripOnInput->False,
               FontSize->3.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.4824297199131076, 5.298317366548036}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.946310229076653, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.409603402444116, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.1093512670354135, 4.0943445622221}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1150465951315345, 7.488852955733459}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyCircle]\"\>", {-2.0794415416798357, 0.8060293376166178}],
               StripOnInput->False,
               FontSize->5.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.746969987257452, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.0898959995836948, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.2704687956143002, 7.783224016336037}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.346745988779815, 6.756932389247553}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9093711079059474, 6.194405391104672}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-3.512911371292157, 5.5909869805108565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.946310229076653, 7.157735484249907}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.000759888500605, 6.380122536899765}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.047189562170502, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3691523372661587, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.907755278982137, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.8906229851255774, 6.39024066706535}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5901256014017275, 7.013915474810528}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.746403767507258, 6.907755278982137}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.6593256320844346, 6.721425700790643}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.4146938356415886, 5.966146739123692}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.262403303361214, 6.841615476477592}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.8097197946050478, 7.294377299288821}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.744604469176456, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4296194858582643, 7.674152921281675}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.019664337643975, 6.684611727667927}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.520318812570019, 5.583496308781699}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3528595850336531, 7.751045117971802}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4912105310694506, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.5740001929819547, 6.429719478039138}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.0808706071919527, 6.249975242259483}],
               StripOnInput->False,
               FontSize->6.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.045763207159556, 5.991464547107982}],
               StripOnInput->False,
               FontSize->5.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.3137523001849649, 8.290041618704489}],
               StripOnInput->False,
               FontSize->5.75]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9038682118755978, 6.476972362889683}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.380218975276964, 5.723585101952381}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2069773133462347, 6.173786103901937}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->4.25]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.004138294335951, 4.499809670330265}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.7499665442035015, 6.253828811575473}],
               StripOnInput->False,
               FontSize->4.5]}, 
             {RGBColor[0.6, 0.6, 0.6], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->6.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.703886158927249, 4.499809670330265}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.696151689580244, 6.684611727667927}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.241489993634235, 6.363028103540465}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.017406150760383, 7.086737934510577}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.66341149948383, 6.040254711277414}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.0635829404621653, 6.040254711277414}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.7813228714636707, 7.822444729489319}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0261055978813616, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.199705077879927, 4.787491742782046}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.266557384867768, 4.787491742782046}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-6.214608098422191, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledSquare]\"\>", {-3.145857732131629, 5.991464547107982}],
               StripOnInput->False,
               FontSize->10.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9904756300635316, 6.39024066706535}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.9634587130036953, 6.040254711277414}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9038682118755978, 6.476972362889683}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1150465951315345, 7.488852955733459}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.160913314865489, 6.620073206530356}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.8442026554799011, 7.759614150696903}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.4799159663735604, 5.123963979403259}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.298317366548036, 2.6490076604684267}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.7333680090865, 6.253828811575473}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.8442026554799011, 7.759614150696903}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.9696906777207166, 6.684611727667927}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.344384958042681, 7.759614150696903}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.0475390184841091, 8.006367567650246}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0177699008240089, 6.363028103540465}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.3137523001849649, 8.290041618704489}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.48175237628028356, 8.122074375362217}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.9165331609060323, 4.787491742782046}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2815740503494875, 7.822444729489319}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.2201021862558195, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.7389772837890856, 7.365180126021013}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.49314943875304795, 6.887552571664617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.1821389399181785, 6.921658184151129}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.429964022323876, 6.173786103901937}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2262184132732556, 6.104793232414985}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0592954262911594, 6.721425700790643}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.131032179924221, 6.249975242259483}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.7031992922485748, 7.600902459542082}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.813734143549063, 8.290041618704489}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.2330583852210326, 7.8709295967551425}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              
              StyleBox[
               InsetBox["\<\"\[FilledUpTriangle]\"\>", {-3.520318812570019, 5.583496308781699}],\

               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.149006005065745, 6.455198563340122}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.5205117032396989, 7.783224016336037}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.808498793232353, 7.295735072749282}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.8665717425242287, 4.787491742782046}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-1.926205565780978, 7.3777589082278725}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.613467558616262, 6.040254711277414}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.813734143549063, 8.290041618704489}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.344384958042681, 7.759614150696903}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.6745821494131117, 5.429345628954441}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.9933351489542694, 4.787491742782046}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1080567474961094, 6.272877006546167}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.660097652688484, 5.393627546352362}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.104554242494911, 6.999422467507961}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.18777640747691846, 7.1929342212158}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.6204544951665047, 7.783224016336037}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.2761851384398606, 6.104793232414985}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-2.017406150760383, 7.086737934510577}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.247228312996893, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8337895103624113, 6.946975992135418}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.1308988302963465, 0.973049065692764}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7813228714636707, 7.822444729489319}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.406905315024015, 7.697121317282625}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-3.01348899514325, 6.040254711277414}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-7.600902459542082, 1.6094379124341003}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.5173146235582946, 7.086737934510577}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.376740148315079, 7.226936018493289}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6702500518308578, 7.433666540166168}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-0.8029620465671519, 7.600902459542082}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.8799351601317804, 7.22402480828583}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-2.0272286702329017, 7.076653815443951}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.3191210616341453, 6.684611727667927}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.813734143549063, 8.290041618704489}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.5366522427084526, 7.56734567601324}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7607838292757566, 6.620073206530356}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.1150465951315345, 7.488852955733459}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.95263269481614, 7.151485463904735}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.9910142780700916, 7.6128310304073565}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.4714166145367258, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8442026554799011, 7.759614150696903}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-1.6029589463363911, 7.501082124259871}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.8205261098897758, 6.960347729101308}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-2.449925680892755, 6.253828811575473}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.3093333199837622, 7.294377299288821}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-1.4460443655256647, 7.157735484249907}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1080567474961094, 6.272877006546167}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.0963149296194261, 6.684611727667927}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.3137523001849649, 8.290041618704489}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.009386074695824, 4.0943445622221}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.4203757208439185, 6.960347729101308}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.94874563428772, 0.973049065692764}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-1.1062413158326008, 6.674561391814426}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.4338645826298623, 6.946975992135418}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[FilledUpTriangle]\"\>", {-0.9816295731824954, 8.122074375362217}],
               StripOnInput->False,
               FontSize->8.5]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.606746624575414, 4.997212273764115}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-9.567158183262826, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.9631203192309531, 6.81783057145415}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6820086052689358, 6.921658184151129}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.8359883191521487, 5.267858159063328}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.744604469176456, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8933068954837797, 6.887552571664617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.216512196196308, 4.787491742782046}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.75, 0.55, 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.3960099493374092, 6.984716320118266}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.600902459542082, 0.973049065692764}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.6593256320844346, 6.721425700790643}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.9296292963133357, 7.674152921281675}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.607650686531799, 1.445270566220188}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.509860006183766, 4.0943445622221}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.437751649736401, 0.973049065692764}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.605170185988091, 2.9290581402859983}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.2030071867437115, 2.3933394562625097}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.1308988302963465, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.6044503709230613, 6.999422467507961}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7199019178687649, 7.8838232148921525}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.527397202097891, 7.076653815443951}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3082228256997352, 7.295735072749282}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.238564249095555, 7.365180126021013}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.4524341636244356, 7.151485463904735}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.3799147541558516, 7.22402480828583}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.752032269119205, 4.852030263919617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-1.984131361875511, 7.003065458786462}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.23395175003081314, 7.146772179452637}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7813228714636707, 7.822444729489319}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.5629964960949002, 6.81783057145415}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1702157075278026, 7.433666540166168}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8442026554799011, 7.759614150696903}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-3.9797666575146655, 5.123963979403259}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.1026203100656484, 7.501082124259871}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9065879564127699, 7.697121317282625}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.8528465593176202, 7.751045117971802}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9712750402069146, 7.6324011266014535}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-1.036482917202561, 7.56734567601324}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.7960662345677868, 6.984716320118266}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.11206147220931, 0.973049065692764}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.5895081458004594, 6.7912214627261855}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.5878866699024524, 7.1929342212158}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.571283042360924, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.1068220837332134, 4.997212273764115}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.909388227079972, 4.0943445622221}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyUpTriangle]\"\>", {-0.7329280505717899, 7.8709295967551425}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.7062324201086008, 6.674561391814426}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.3025850929940455, 6.684611727667927}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.6339353209280992, 7.146772179452637}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.8830977645183911, 6.897704943128636}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-4.609379030762146, 4.0943445622221}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[FilledCircle]\"\>", {-2.6772785424354564, 6.309918278226516}],
               StripOnInput->False,
               FontSize->7.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-4.251700372998307, 4.852030263919617}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.9896682016789307, 6.7912214627261855}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptySquare]\"\>", {-0.8469979053782056, 6.5337888379333435}],
               StripOnInput->False,
               FontSize->13.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.1308988302963465, 1.445270566220188}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDiamond]\"\>", {-0.48304834276654407, 6.897704943128636}],
               StripOnInput->False,
               FontSize->12.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.600902459542082, 1.445270566220188}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-7.600902459542082, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-6.214608098422191, 2.0471765810925606}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-5.744604469176456, 1.7328937163610187}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.529318843261892, 1.9033008439609624}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-6.878196476740593, 1.7776605448485534}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-7.284632930238389, 1.6094379124341003}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-7.523941418405954, 1.497835735852798}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[CircleMinus]\"\>", {-8.622553707074063, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->9.]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-7.819058469345253, 1.3540294005326152}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-8.05031945517943, 1.2424239907001886}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-8.403864506109235, 1.0698698198024557}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-8.685611843041201, 0.9360933591703348}],
               StripOnInput->False,
               FontSize->11.5]}, 
             {RGBColor[0.7, 0., 0.], 
              StyleBox[InsetBox["\<\"\[EmptyDownTriangle]\"\>", {-8.955698153602603, 0.8046885552928528}],
               StripOnInput->False,
               FontSize->11.5]}}}, {}},
          AspectRatio->1.,
          Axes->False,
          AxesLabel->{None, None},
          AxesOrigin->{0, 0},
          BaseStyle->{FontFamily -> "Helvetica", 16},
          DisplayFunction->Identity,
          Epilog->{{
             InsetBox[
              FormBox[
               StyleBox["\"Npt: 3920\"", 16, 
                GrayLevel[0], StripOnInput -> False], TraditionalForm], 
              Scaled[{0.1, 0.9}]], 
             InsetBox[
              FormBox[
               StyleBox[
               "\"highlighted range:\\n{{-1., -0.7}, {0.7, 1.}}\"", 16, 
                GrayLevel[0], StripOnInput -> False], TraditionalForm], 
              Scaled[{0.2, 0.7}]]}, {{
              InsetBox[
               FormBox[
                StyleBox["\"Npt: 3920\"", 16, 
                 GrayLevel[0], StripOnInput -> False], TraditionalForm], 
               Scaled[{0.1, 0.9}]], 
              InsetBox[
               FormBox[
                StyleBox[
                "\"highlighted range:\\n{{-1., -0.7}, {0.7, 1.}}\"", 16, 
                 GrayLevel[0], StripOnInput -> False], TraditionalForm], 
               Scaled[{0.2, 0.7}]]}}},
          Frame->True,
          FrameLabel->{
            FormBox[
             StyleBox["\"x\"", 18, 
              GrayLevel[0], StripOnInput -> False], TraditionalForm], 
            FormBox[
             StyleBox["\"\[Mu] [GeV]\"", 18, 
              GrayLevel[0], StripOnInput -> False], TraditionalForm]},
          FrameTicks->{{{-13.815510557964274`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.512925464970229`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.210340371976182, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.605170185988091, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.3025850929940455`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
              FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
             0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.791759469228055, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.302585092994046, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.0943445622221, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.248495242049359, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.382026634673881, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.499809670330265, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.605170185988092, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.703782474656201, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.991464547107982, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.396929655216146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.551080335043404, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.684611727667927, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.802394763324311, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.006367567650246, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.294049640102028, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.699514748210191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.987196820661973, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.104979856318357, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.210340371976184, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.308952660644293`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.596634733096073`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.002099841204238`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.156250521031495`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.289781913656018`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.407564949312402`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}}, {{-13.815510557964274`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-11.512925464970229`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-9.210340371976182, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-4.605170185988091, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-2.3025850929940455`, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
              FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
             0.6931471805599453, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.791759469228055, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             2.302585092994046, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             3.912023005428146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.0943445622221, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.248495242049359, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.382026634673881, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.499809670330265, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             4.605170185988092, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.703782474656201, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             5.991464547107982, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.214608098422191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.396929655216146, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.551080335043404, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.684611727667927, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.802394763324311, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             6.907755278982137, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.006367567650246, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.294049640102028, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.517193191416238, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.699514748210191, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             8.987196820661973, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.104979856318357, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             9.210340371976184, 
              FormBox[
              "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
               TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.308952660644293`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.596634733096073`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             10.819778284410283`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.002099841204238`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.156250521031495`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.289781913656018`, 
              FormBox["\"\"", TraditionalForm], {0.01, 0}}, {
             11.407564949312402`, 
              FormBox["\"\"", TraditionalForm], {
              0.01, 0}}}, {{-13.815510557964274`, 
              FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
              FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
              FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
              FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
              FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm]}, {0., 
              FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
              FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
              FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
              FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
              FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
              FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
              FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
              FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
              FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
              FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
              FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
              FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
              FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
              FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
              FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
              FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
              FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
              FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
              FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
              FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
              FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
              FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
              FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
              FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
              FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
              FormBox["\"\"", TraditionalForm]}}, {{-13.815510557964274`, 
              FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
              FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
              FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
              FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
              FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
              FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
              FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
              FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
              FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
              FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
              FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
              FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
              FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
              FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
              FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
              FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
              FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
              FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
              FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
              FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
              FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
              FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
              FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
              FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
              FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
              FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
              FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
              FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
              FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
              FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
              FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
              FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
              FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
              FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
              FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
              FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
              FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
              FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
              FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
              FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
              FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
              FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
              FormBox["\"\"", TraditionalForm]}, {0., 
              FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
              FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
              FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
              FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
              FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
              FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
              FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
              FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
              FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
              FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
              FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
              FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
              FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
              FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
              FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
              FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
              FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
              FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
              FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
              FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
              FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
              FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
              FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
              FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
              FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
              FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
              FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
              FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
              FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
              FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
              FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
              FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
              FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
              FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
              FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
              FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
              FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
              FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
              FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
              FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
              FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
              FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
              FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
              FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
              FormBox["\"\"", TraditionalForm]}}},
          FrameTicksStyle->GrayLevel[0],
          
          GridLines->
           NCache[{{-16.11809565095832, -13.815510557964274`, \
-11.512925464970229`, -9.210340371976182, -6.907755278982137, \
-4.605170185988091, -2.3025850929940455`}, {
              Log[10], 
              Log[50], 
              Log[100], 
              Log[500], 
              Log[1000], 
              Log[5000], 
              Log[
              10000]}}, {{-16.11809565095832, -13.815510557964274`, \
-11.512925464970229`, -9.210340371976182, -6.907755278982137, \
-4.605170185988091, -2.3025850929940455`}, {2.302585092994046, 
            3.912023005428146, 4.605170185988092, 6.214608098422191, 
            6.907755278982137, 8.517193191416238, 9.210340371976184}}],
          GridLinesStyle->Directive[
            Dashing[{Small, Small}]],
          ImagePadding->All,
          ImageSize->{{600}, {600}},
          Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& )}},
          PlotLabel->None,
          PlotRange->NCache[{{-Log[100000], 0}, {0, 
              Log[6000]}}, {{-11.512925464970229`, 0}, {
             0, 8.699514748210191}}],
          PlotRangeClipping->True,
          PlotRangePadding->{{0, 0}, {0, 0}},
          Ticks->{Automatic, Automatic}], Scaled[{0.5, 0.5}], Center, 
         Scaled[{1, 1}]], InsetBox[
         TemplateBox[{FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   StyleBox["\"\"", {FontSize -> 14, 
                    GrayLevel[0], FontFamily -> "Arial"}, Background -> 
                    Automatic, StripOnInput -> False]}, {
                   GraphicsBox[{{}, {}, 
                    
                    RasterBox[{{{0., 0.7, 0.}}, {{0., 0.7, 0.}}, {{0.75, 0.75,
                     0.}}, {{0.75, 0.5499999999999997, 0.}}, {{0.7, 0., 
                    0.}}, {{0.7, 0., 0.}}}, {{
                    Rational[-15, 2], -75}, {
                    Rational[15, 2], 75}}], {Antialiasing -> False, 
                    AbsoluteThickness[0.1], 
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]], 
                    LineBox[
                    NCache[{{
                    Rational[15, 2], -75}, {
                    Rational[-15, 2], -75}, {
                    Rational[-15, 2], 75}, {
                    Rational[15, 2], 75}, {
                    Rational[15, 2], -75}}, {{
                    7.5, -75}, {-7.5, -75}, {-7.5, 75}, {7.5, 75}, {
                    7.5, -75}}]]}, {
                    CapForm[None], {}}, {Antialiasing -> False, 
                    StyleBox[
                    LineBox[{{7.500000000000001, -75.}, {7.500000000000001, 
                    75.}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.500000000000001, -50.}, 
                    Offset[{4., 0}, {7.500000000000001, -50.}]}, {{
                    7.500000000000001, -25.}, 
                    Offset[{4., 0}, {7.500000000000001, -25.}]}, {{
                    7.500000000000001, 0.}, 
                    Offset[{4., 0}, {7.500000000000001, 0.}]}, {{
                    7.500000000000001, 24.999999999999986`}, 
                    
                    Offset[{4., 0}, {7.500000000000001, 
                    24.999999999999986`}]}, {{7.500000000000001, 
                    49.999999999999986`}, 
                    
                    Offset[{4., 0}, {7.500000000000001, 
                    49.999999999999986`}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox["0", TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, -50.}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"0.50\"", 0.5, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, -25.}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"0.70\"", 0.7, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, 0.}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"0.85\"", 0.85, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    
                    Offset[{7., 0.}, {7.500000000000001, 
                    24.999999999999986`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"1.00\"", 1., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    
                    Offset[{7., 0.}, {7.500000000000001, 
                    49.999999999999986`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1], FontSize -> 14, 
                    GrayLevel[0]]}, StripOnInput -> False]}, {}}, {
                    Directive[
                    Opacity[1], FontSize -> 14, 
                    GrayLevel[0]]}, StripOnInput -> False], "GraphicsLabel", 
                    StripOnInput -> False]}, "GraphicsTicks", StripOnInput -> 
                    False], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                    Scaled[0.02], PlotRange -> All, Frame -> True, 
                    FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                    Opacity[0], FrameTicksStyle -> Opacity[0], 
                    ImageSize -> {Automatic, 150}, BaseStyle -> {}, 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}]}}, 
                 GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontSize -> 14, 
              GrayLevel[0], FontFamily -> "Arial"}, Background -> Automatic, 
             StripOnInput -> False], TraditionalForm]},
          "BarLegend",
          DisplayFunction->(#& ),
          InterpretationFunction:>(RowBox[{"BarLegend", "[", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0, 0.7, 0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0.4666666666666667, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "RGBColor[0, 0.7, 0]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0, 0.7, 0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0, 0.7, 0], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0, 0.7, 0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0.4666666666666667, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "RGBColor[0, 0.7, 0]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0, 0.7, 0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0, 0.7, 0], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.75, 0.75, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.5, 0.5, 0.], FrameTicks -> 
                    None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "RGBColor[0.75, 0.75, 0.]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.75, 0.75, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.75, 0.75, 0.], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.75, 0.55, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.5, 0.3666666666666667, 0.],
                     FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "RGBColor[0.75, 0.55, 0.]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.75, 0.55, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.75, 0.55, 0.], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0., 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.4666666666666667, 0., 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "RGBColor[0.7, 0., 0.]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0., 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0., 0.], Editable -> False, Selectable -> 
                    False], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0., 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.4666666666666667, 0., 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "RGBColor[0.7, 0., 0.]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0., 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0., 0.], Editable -> False, Selectable -> 
                    False]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "0.001`"}], ",", "1.001`"}], "}"}]}], "}"}], 
               ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.001`"}], ",", "0", ",", "0.5`", ",", 
                   "0.7`", ",", "0.85`", ",", "1", ",", "1.001`"}], "}"}], 
               ",", 
               RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"FontSize", "\[Rule]", "14"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "GrayLevel[0]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False]}], 
                   "}"}]}], ",", 
               RowBox[{"LegendLabel", "\[Rule]", "\"\""}], ",", 
               RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
               RowBox[{"LegendMarkerSize", "\[Rule]", 
                 RowBox[{"{", "}"}]}], ",", 
               RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
               RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
               RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], 
             "]"}]& )], Scaled[{1., 0.5}], ImageScaled[{0, 0.5}],
         BaseStyle->{FontSize -> Larger},
         FormatType->StandardForm]},
       AspectRatio->1.,
       Axes->False,
       AxesLabel->{None, None},
       AxesOrigin->{0, 0},
       BaseStyle->{FontFamily -> "Helvetica", 16},
       DisplayFunction->Identity,
       Frame->False,
       FrameLabel->{
         FormBox[
          StyleBox["\"x\"", 18, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         FormBox[
          StyleBox["\"\[Mu] [GeV]\"", 18, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm]},
       FrameTicks->{{{-13.815510557964274`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.02375108873622, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.86960040890896, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.512925464970229`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.903487552536127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.721165995742174, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.567015315914915, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.433483923290392, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.315700887634009, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.210340371976182, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-8.111728083308073, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.824046010856292, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.600902459542082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.418580902748127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.264430222920869, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.013115794639964, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-6.907755278982137, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.809142990314028, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.521460917862246, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.298317366548036, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.115995809754082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.961845129926823, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.710530701645918, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.605170185988091, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.506557897319982, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.995732273553991, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.659260036932778, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.3025850929940455`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-1.203972804325936, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.916290731874155, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
           FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
          0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.302585092994046, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.605170185988092, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.907755278982137, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.210340371976184, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}}, {{-13.815510557964274`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-6\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-12.02375108873622, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-11.86960040890896, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-11.512925464970229`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-5\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.903487552536127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.721165995742174, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.567015315914915, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.433483923290392, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.315700887634009, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-9.210340371976182, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-8.111728083308073, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.824046010856292, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.600902459542082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.418580902748127, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.264430222920869, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-7.013115794639964, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-6.907755278982137, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.809142990314028, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.521460917862246, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.298317366548036, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-5.115995809754082, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.961845129926823, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.710530701645918, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-4.605170185988091, 
           
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-3.506557897319982, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.995732273553991, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-2.659260036932778, 
           
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-2.3025850929940455`, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(-1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-1.203972804325936, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.916290731874155, 
           
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {0., 
           FormBox["\"1\"", TraditionalForm], {0.02, 0.}}, {
          0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {2.302585092994046, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(1\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {4.605170185988092, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(2\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {6.907755278982137, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(3\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {9.210340371976184, 
           FormBox[
           "\"\\!\\(\\*SuperscriptBox[\\(10\\), \\(4\\)]\\)\"", 
            TraditionalForm], {0.02, 0.}}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm], {0.01, 0}}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm], {
           0.01, 0}}}, {{-13.815510557964274`, 
           FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
           FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
           FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
           FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
           FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
           FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
           FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
           FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
           FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
           FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
           FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
           FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
           FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
           FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
           FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
           FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
           FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
           FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
           FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
           FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
           FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
           FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
           FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm]}, {0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
           FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm]}}, {{-13.815510557964274`, 
           FormBox["\"\"", TraditionalForm]}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm]}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm]}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm]}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm]}, {-12.02375108873622, 
           FormBox["\"\"", TraditionalForm]}, {-11.86960040890896, 
           FormBox["\"\"", TraditionalForm]}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm]}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
           FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm]}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {-9.721165995742174, 
           FormBox["\"\"", TraditionalForm]}, {-9.567015315914915, 
           FormBox["\"\"", TraditionalForm]}, {-9.433483923290392, 
           FormBox["\"\"", TraditionalForm]}, {-9.315700887634009, 
           FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
           FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {-8.111728083308073, 
           FormBox["\"\"", TraditionalForm]}, {-7.824046010856292, 
           FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {-7.418580902748127, 
           FormBox["\"\"", TraditionalForm]}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm]}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm]}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
           FormBox["\"\"", TraditionalForm]}, {-5.521460917862246, 
           FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {-5.115995809754082, 
           FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
           FormBox["\"\"", TraditionalForm]}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm]}, {-4.710530701645918, 
           FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
           FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
           FormBox["\"\"", TraditionalForm]}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
           FormBox["\"\"", TraditionalForm]}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm]}, {-2.4079456086518722`, 
           FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
           FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {-1.203972804325936, 
           FormBox["\"\"", TraditionalForm]}, {-0.916290731874155, 
           FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm]}, {-0.3566749439387323, 
           FormBox["\"\"", TraditionalForm]}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm]}, {-0.10536051565782628`, 
           FormBox["\"\"", TraditionalForm]}, {0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm]}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm]}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm]}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm]}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm]}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm]}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm]}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm]}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm]}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm]}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm]}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {8.699514748210191, 
           FormBox["\"\"", TraditionalForm]}, {8.85366542803745, 
           FormBox["\"\"", TraditionalForm]}, {8.987196820661973, 
           FormBox["\"\"", TraditionalForm]}, {9.104979856318357, 
           FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
           FormBox["\"\"", TraditionalForm]}, {9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {10.308952660644293`, 
           FormBox["\"\"", TraditionalForm]}, {10.596634733096073`, 
           FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {11.002099841204238`, 
           FormBox["\"\"", TraditionalForm]}, {11.156250521031495`, 
           FormBox["\"\"", TraditionalForm]}, {11.289781913656018`, 
           FormBox["\"\"", TraditionalForm]}, {11.407564949312402`, 
           FormBox["\"\"", TraditionalForm]}}},
       FrameTicksStyle->GrayLevel[0],
       ImagePadding->All,
       ImageSize->{{600}, {600}},
       Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
             (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
              Part[#, 1]], 
             (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
              Part[#, 2]]}& ), "CopiedValueFunction" -> ({
             (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
              Part[#, 1]], 
             (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
              Part[#, 2]]}& )}},
       PlotLabel->FormBox[
         StyleBox[
         "\"| Corr( g(x,\[Mu]), \\!\\(\\*SubscriptBox[\\(r\\), \\(i\\)]\\)) \
|, CT14NNLO\"", 24, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm],
       PlotRange->Automatic,
       PlotRangeClipping->False,
       PlotRangePadding->{{0, 0}, {0, 0}},
       Ticks->{Automatic, Automatic},
       ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]],
      InterpretTemplate[Legended[
        Graphics[{{{}, {{{}, {
              Hue[0.67, 0.6, 0.6], 
              Directive[
               PointSize[0.012833333333333334`], 
               AbsoluteThickness[1.6], FontFamily -> "Helvetica", 
               GrayLevel[1]], 
              
              Point[{{0.00001, 2.}, {0.99, 
               1200.}}]}, {}}}, {}, {}, {{}, {}}}, {
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262403303361214, 6.841615476477592}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3716028123769008`, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.300710797475603, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.6003175012993283`, 
             4.386889790339869}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.57270299585059, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 1.2184672504763885`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             1.0511712140679732`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.3960170377865984`, 6.907755278982137}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0564152399683213`, 
             2.702032128776647}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-51.46677778703915, 4.386889790339869}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.4886252922173524`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-42.34081632550436, 4.512945241945574}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.880084850028029, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 2.2976730486330252`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.318612854071243, 2.005525858729668}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.5922917535991299`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.33687231664255274`, 1.937301774518713}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8701230510291479, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.517264565896126, 2.0068708488450007`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.215506040139609}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6266106567597011, 2.4265710727750367`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.475327636634016, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6977577931176286, 2.4265710727750367`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.2672179491567546`, 4.386889790339869}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4422299934501939`, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4159291662495814`, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.300710797475603, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.695775840226822, 
             5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.100386954332169, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-53.46678887337479, 4.386889790339869}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-57.46750061412042, 4.386889790339869}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.516892795645856, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.6564295976247825, 
             2.702032128776647}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.225346881840062, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-67.46691559681179, 4.386889790339869}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-69.46689851604965, 4.386889790339869}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-41.34127116323533, 4.512945241945574}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6044503709230613`, 6.999422467507961}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.4079456086518722`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4184044150381243`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 2.296667619230008}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.9334368907091256, 1.8389610707123492`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.536426440357718, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-44.34079097851618, 4.512945241945574}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5898688311064436, 2.506341930508065}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.225346881840062, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.70036037299184, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.4722426732562555`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7064996252772315`, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.7027460895677522`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0189110419398038`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.312220927289192, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1464364105041143`, 5.634789603169249}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1307223425863433`, 
             2.827905162910489}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7627116439458544, 1.6974487897568136`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.4018530946527146`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.47352983902229373`, 2.599722324216582}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.8643901602629624`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.6389967146756448`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-35.340845982694816`, 4.512945241945574}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.462149662665384}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.807005375881994, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.312220927289192, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-52.467202900682494`, 4.386889790339869}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7756596021344095, 2.418588768750352}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-30.340822850069564`, 4.512945241945574}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.2072749131897207`, 6.396929655216146}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3645328693383778`, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4082690354408987, 1.860974538249528}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 0.9654617758806044}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.725332537920259, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8627499649461253, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1564532883579597`, 
             2.702032128776647}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 2.1587147225743437`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.18765575838465653`, 2.6224923127405635`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.227106951818089}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-55.46685482648658, 4.386889790339869}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.1862091035211472, 2.423031246069913}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.836849948493799, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.104554242494911, 6.999422467507961}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.5920892740994874`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3943265328171548`, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3528595850336531`, 7.751045117971802}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9715392061046336, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.176833887688485, 1.8625285401162623`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.532062329207643, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.49397078181451, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.659260036932778, 1.0845133642886082`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-56.46701553651661, 4.386889790339869}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2569588998089404, 2.0731719286662407`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8701230510291479, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.500810170663849, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.090999490513565}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.091798316674432, 4.386889790339869}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.3205066205818874`, 7.783224016336037}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4947708374559745`, 5.886104031450156}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.1269525243508878`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262403303361214, 6.841615476477592}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.919365593833201, 6.684611727667927}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.694093021166824, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9317114296555002`, 6.672032945461067}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.5859645562484583`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.5338519254775054`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-66.46748299707936, 4.386889790339869}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.0966102859974367`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.5299617109323036`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-5.966967075507594, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-8.421883011611913, 1.2424239907001886`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.676945820702642, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9699552564598479, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.683996966534062, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 2.2927367569392314`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.6529653909271136, 2.506341930508065}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             1.8359358315608838`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.491654876777717, 1.599387576580599}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4409617624621989`, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 2.0719132752590443`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2149273965428693, 2.519308076505333}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-43.340988541359216`, 4.512945241945574}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0564152399683213`, 
             2.702032128776647}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.256670593326385, 
             2.702032128776647}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5235731965884932, 2.50470927708418}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.8528465593176202, 7.751045117971802}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.9139271032022627`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1409980051645476`, 
             4.512945241945574}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.797175250983993, 2.512035317176253}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6667000105450971, 1.6974487897568136`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.2876820724517809, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-72.46692041972995, 4.386889790339869}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.215506040139609}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.209094749906707, 2.0082140323914683`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.894183087299815, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-5.767041814295392, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             1.2172838183856083`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.781788039865368, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.60100614381313, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9329283730271782, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.764428382564909, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.4159777803491362`, 2.0082140323914683`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.3504080825554816`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-2.995732273553991, 0.848868055556721}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.217869048507598, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5188771693591536`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3903023825174294`, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.60100614381313, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7174398731289899, 2.5087859235779435`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.362224007377702, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316692464055834`, 6.672032945461067}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.1564532883579597`, 6.674561391814426}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.257346872655708, 2.0028304393079956`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.494523665901028, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.4854489341097463`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.300710797475603, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-5.093908213290077, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0129050178795915`, 5.768320995793772}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-47.34086951027008, 4.512945241945574}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.2576117273513145`, 1.691939133945844}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.804781390061982, 6.298949246855942}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5705756281717647, 1.7817091333745536`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-34.340745544411554`, 4.512945241945574}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5601909533113197, 2.423031246069913}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.9005275521158795`, 
             4.386889790339869}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0272286702329017`, 7.076653815443951}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.348592493935879}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 2.075809955445786}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4182464424728975, 2.6019486702196644`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4911864085136422, 1.7850704810772584`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.8006962066887295`, 
             4.386889790339869}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-58.4670151515563, 4.386889790339869}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.911914268349973, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4653375684603434`, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346745988779815, 6.756932389247553}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.017383521085972, 0.986935571443487}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.25154302583590776`, 2.130609828254235}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.341928551227046, 4.386889790339869}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.809142990314028, 1.2424239907001886`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-4.0941445822194344`, 4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.6854573524495757`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-70.4670522818902, 4.386889790339869}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.4911047254722358`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.462149662665384}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-5.293927018246744, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 1.3480731482996928`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6873994539038122`, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.382026634673881, 0.7485818874480459}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.100426344668657, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.469241281940817, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.4395981331422016`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3134438363289216`, 1.534714366238164}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.7177791303707455`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.162823150618887, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.836849948493799, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 1.4964931534179662`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 0.7476353658440151}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316692464055834`, 6.672032945461067}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.539739633930633, 2.5974910105351463`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-65.466905183977, 4.386889790339869}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2173252490432223`, 4.386889790339869}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.9317114296555002`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.197324582336553, 1.9401794743463283`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.8763491247812073, 2.503891949699081}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.2876820724517809, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.3226876816505963, 2.005525858729668}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9699552564598479, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820086052689358`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-33.34092227159292, 4.512945241945574}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 2.090999490513565}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.10045059841862, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2453891602615295, 2.424802725718295}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.18260159600127354`, 2.136530508663963}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 0.9654617758806044}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316692464055834`, 6.672032945461067}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3983669423541598`, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.21678878567620194`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.5978370007556204, 2.187398683184928}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.746403767507258, 5.634789603169249}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.9093711079059474`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-2.995732273553991, 1.094604267270571}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 1.9254158540407285`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.5978370007556204, 2.647592232065096}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 2.0766877534832147`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.1136189934814222`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.3681303904922195`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.975391927697949, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.270112606830481, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6218266343535928`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.863232841258714, 0.8458682675776092}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 2.0759354023505483`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.017383521085972, 0.8385453832493022}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.908846148194222, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.461401833606696}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.8344803566765893, 2.131796772013764}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-6.191868611452702, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.278818960372969, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 5.991464547107982}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-2.966950472128539, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.002290482491421}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-64.46739506232224, 4.386889790339869}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-8.666853965970644, 4.386889790339869}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.491654876777717, 2.227106951818089}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5716605481000705`, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.15218556191195, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5366522427084526`, 7.56734567601324}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-46.34085167560773, 4.512945241945574}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.594056810395798, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.9245405804618736`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.922779731666459, 5.857933154483459}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0305798782762827`, 
             2.827905162910489}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.2072749131897207`, 6.396929655216146}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.770028224895903, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 1.7833912195575383`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-63.46698269688735, 4.386889790339869}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             1.5473497201206787`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.46013250945047257`, 2.512035317176253}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.922779731666459, 5.857933154483459}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.199705077879927, 0.755182571479398}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6338708029279587`, 1.937301774518713}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7463370090740643, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-3.600868576791223, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.26683423993894284`, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.410950117672171, 4.969813299576001}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.4911047254722358`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.2876820724517809, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.5305182571117267, 
             2.827905162910489}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 0.9150900112976361}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.153303390278291, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3657077275115024`, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.3420861064555702`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 2.090999490513565}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.4079456086518722`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.100386954332169, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7650729201315343, 2.0731719286662407`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.4079456086518722`, 1.497835735852798}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6064191770501212, 2.5877640352277083`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-5.058828136697741, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.036382052219389, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-5.234028876665675, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.991862608772972, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8505029913361519, 2.4176979000945504`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.0968250627658085`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.30432512701003, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.412288358086009, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 0.848868055556721}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.2568373311553196`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.489435120039404, 6.29156913955832}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.19455609446229716`, 2.0706530356467567`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.7254100886865211`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.6039529822035308`, 5.676753802268282}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-5.3089739467365655`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2496677635880655`, 6.131226489483141}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-45.34120604098636, 4.512945241945574}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6713133161521878`, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.863232841258714, 1.007592890280941}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.8178684794407625`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.3348410795309749`, 2.58851563240702}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164563795096671, 6.939253946041508}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 2.28401370740861}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8584936331479384, 2.0706530356467567`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6691879168398742`, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0191543673333943`, 2.570319527636131}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.091798316674432, 4.386889790339869}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.904054835778969, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-5.566981433164056, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0931348688118385`, 2.0095554142156695`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.7317869551252127`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.9267273296385394`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.40649706843741, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-3.809015255353917, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.2166915767337108`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-0.3504089023600859, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6149530931222105`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-48.341370727608414`, 4.512945241945574}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-5.493845750829273, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.49331319868135953`, 2.4239173781615704`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.36154392105023625`, 2.599722324216582}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.3930425881096072, 1.6384140206706175`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.069887328875024, 1.9416152247724325`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.8006962066887295`, 
             4.386889790339869}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4903224315439383`, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.083998270167957, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7958982916754054`, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-8.166888494485349, 4.386889790339869}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4943251053335957`, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4943251053335957`, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.7042981934580606`, 5.676753802268282}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-5.504112279527633, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.369240606554063, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.3732221725934863`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.522010001878903, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.3003570667360838`, 
             4.386889790339869}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.215506040139609}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2740421867477461, 2.5771819258971713`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.8787541283454292, 1.599387576580599}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-7.666828609658249, 4.386889790339869}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.090999490513565}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3138891646209549, 2.5862591440482876`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8644101099971662, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.9958752112169974, 1.599387576580599}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.6358850824489488`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.1413169453979233`, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2854179707987138, 2.4997952622817508`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3005870903313728`, 5.480638923341991}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.27128392664214473`, 1.9358598132018119`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-59.467094916063616`, 4.386889790339869}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 1.266384064447333}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.1454883067486056, 2.432735777459091}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-38.34104853637971, 4.512945241945574}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4714166145367258`, 
             7.6324011266014535`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.463458318582131, 6.040254711277414}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4983438649285135`, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.349630376748299}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.090999490513565}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6009911288088023`, 2.0082140323914683`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3413209954771594`, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-5.7340355178272215`, 4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2010151992412087, 2.0082140323914683`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.725433722188183, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-71.46678568954108, 4.386889790339869}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0129050178795915`, 5.768320995793772}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.430789601006442}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6497392092076262`, 6.131226489483141}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.7710464276305133`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3657077275115024`, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.900422093749666, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-6.442136248054226, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4714166145367258`, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4714166145367258`, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.975450465015525, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.028748427364318, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2072749131897207`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.66442222076686, 6.939253946041508}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-6.113858195322049, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.9999411183280458`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-4.083998270167957, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.5178502387029551, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3186357126460757`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.462149662665384}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3426311639367969, 1.8656293177945105`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.3302529702362658`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.0365602553118024, 7.24422751560335}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.6747180450915782, 2.58851563240702}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1821389399181785`, 6.921658184151129}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-5.0040073078060345`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3983901944362025, 1.9358598132018119`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3688474475161698`, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8821308802274503, 2.0082140323914683`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.995732273553991, 1.4772770088317615`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3180038323381698, 2.0731719286662407`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-29.340832002509437`, 4.512945241945574}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820086052689358`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.33589240475620386`, 2.502255288122613}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5186835491656363`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5186835491656363`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0700248318161971`, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[$CellContext`\[FivePointedStar], {-1.0700248318161971`, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3413209954771594`, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 2.227106951818089}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.6003175012993283`, 
             4.386889790339869}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7406861990440543`, 6.040254711277414}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5828588266658222, 1.6974487897568136`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.41779075779880137`, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.912572089444803, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.4109447331170353`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.941966881801218, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.500433550670171, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.100386954332169, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.4722426732562555`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.184789984909162}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9689006821464524, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4159291662495814`, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             0.761739972025557}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3186357126460757`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9565920286476808, 
             2.702032128776647}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9565920286476808, 
             2.702032128776647}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346745988779815, 6.756932389247553}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3118381623295401, 2.6993457604720636`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.2788685663767296`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.304161419150561, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3903023825174294`, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.3027280306570521, 2.419478844465545}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.0935997468445653`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.927891643552635}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4918104261047946`, 4.386889790339869}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.30938249943111995`, 2.131796772013764}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.900422093749666, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7505644514298959, 2.5817308344235403`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.39809235377875135`, 2.498151876538021}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.785741396902492}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 0.7466879474879751}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-62.46685674510361, 4.386889790339869}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7797949872856175, 1.6034198401085373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.218243944560295, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.1625110145183415`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 0.9654617758806044}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5159475693467614`, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-68.46724388757043, 4.386889790339869}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.700547258981618, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3874950816964096`, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.4753441779534016`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.60100614381313, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.911914268349973, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6622300779252237, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.225346881840062, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3154677188250594`, 1.9387416595767009`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.458005208673891, 5.823045895483019}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.342468881579861, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.312220927289192, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1208578976154293`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8328691237350826, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 1.726509584019938}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-7.166785108860756, 4.386889790339869}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-4.893919494400295, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2942622756733968`, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.42266213293668586`, 2.418588768750352}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1702157075278026`, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.48175237628028356`, 1.8625285401162623`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.491654876777717, 2.090999490513565}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 0.9666035457477442}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.700587583759682, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-7.1622605067393605`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.0968250627658085`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6548884684428551, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-4.584387646805562, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.8438952236485835`, 5.537334267018537}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-4.199705077879927, 0.7997569156182036}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1564532883579597`, 
             2.702032128776647}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.694093021166824, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7625890919282752`, 6.841615476477592}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.532062329207643, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-40.340943771488284`, 4.512945241945574}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4409617624621989`, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.832423655941967, 1.6937790608678513`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2942622756733968`, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4184044150381243`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1821389399181785`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.318488613869894, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.1990607599649155`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4422299934501939`, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 2.253709925211909}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.9510398268753117`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.0498221244986778`, 2.647592232065096}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6184786570862495`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.858931232061846, 1.5953389880545987`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5269366909223567`, 6.253828811575473}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.7817091333745536`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.004138294335951, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.8442026554799011, 1.7850704810772584`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.475327636634016, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-36.34119244432727, 4.512945241945574}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.462149662665384}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2306590695884416`, 
             2.827905162910489}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4092798316650086`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.0942695392339727`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.100765130025024, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 0.7485818874480459}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.8006962066887295`, 
             4.386889790339869}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-8.350408373771412, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9747212309094329`, 2.0095554142156695`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9519282213808764`, 5.8289456176102075`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8807977354618917`, 1.4883995840570443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3716028123769008`, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5413120833865, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5413120833865, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.725971728690052, 7.3777589082278725`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.3678803477808931, 2.421256622711544}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3943265328171548`, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7832907304129113, 2.0068708488450007`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.360956006320375, 4.969813299576001}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0053952069569758`, 2.498151876538021}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3329431856228962`, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020229905154391, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 2.0215475632609334`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0024805005437076`, 2.0719132752590443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.06016413371338, 5.393627546352362}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.5338519254775054`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111964733385396, 6.492239835020471}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.013077000561847, 6.81783057145415}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8470607850131444`, 6.756932389247553}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.694451286761057, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 0.9666035457477442}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7611345721946656`, 1.864080130807681}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.2867117438377558`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1062413158326008`, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7565130561817651, 
             2.702032128776647}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.271538123821702, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.110313205346923, 2.0719132752590443`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2149273965428693, 1.937301774518713}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             1.8728785205128469`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-6.541030999190403, 
             4.512945241945574}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.9005275521158795`, 
             4.386889790339869}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.617850239145466, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.017383521085972, 0.7347688552507647}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4653375684603434`, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-31.34091993726656, 4.512945241945574}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.227106951818089}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-3.166995202991212, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.400308181522661, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.2164073967529934`, 2.0719132752590443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-60.466869255317796`, 4.386889790339869}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9519179095173061, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7625890919282752`, 6.841615476477592}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4171835010623628, 1.7850704810772584`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7448616162466241, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-28.340907620492793`, 4.512945241945574}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.4079456086518722`, 1.726509584019938}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.4865920824352545`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.716864386545305, 4.386889790339869}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.4079456086518722`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-4.95401869367736, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.403068631572368, 2.0731719286662407`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.632849755094834, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.271538123821702, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.5978370007556204, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.0942695392339727`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.5356434782150785`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6281111776997217`, 6.152732694704104}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.565421027017326, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.565421027017326, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9306432380985556, 
             2.827905162910489}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.719319793360441}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.316022308134559, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.462149662665384}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.063052113269559, 6.81783057145415}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.104554242494911, 5.676753802268282}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.6409365794934714`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.542246662893777, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164563795096671, 6.939253946041508}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-8.850570223130148, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.4911047254722358`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8566077297129814, 
             2.702032128776647}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4460443655256647`, 7.157735484249907}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 2.187398683184928}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8773173575897015`, 7.226936018493289}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.96443110720209, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 0.849723487602042}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.094520670764856, 1.6937790608678513`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-4.76404869105558, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6414447085691868`, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             2.6397713603489157`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8891518152367044`, 2.0731719286662407`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.469241281940817, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.617854196524514, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2072749131897207`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.2101638842661795`, 5.393627546352362}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.700587583759682, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.5824869781268642`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6039529822035308`, 2.6993457604720636`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8566077297129814, 
             2.702032128776647}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.9390477189967712, 2.414126467726953}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.475327636634016, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9306432380985556, 
             2.827905162910489}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.314556464775266, 2.0706530356467567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.6393849888020524`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.9058454740126164, 1.937301774518713}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.7847348542910906`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.49397078181451, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7565130561817651, 
             2.702032128776647}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-4.2845370133966245`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4903224315439383`, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.987249820814649, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-6.667164814064207, 4.386889790339869}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 2.0427775573082445`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 1.6304163188192922`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-5.366810362993337, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-5.166938288491657, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.6788498758591209, 1.599387576580599}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.5824869781268642`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-1.155182640156504, 2.570319527636131}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.1634411179801, 6.040254711277414}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.382026634673881, 0.8441500540964727}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.341928551227046, 4.386889790339869}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9186841628017217`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.7985076962177716, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.220083871482302, 5.560681631015528}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3700273886560186`, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.719319793360441}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.2255369822417765`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6702500518308578`, 7.433666540166168}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-6.717134919373487, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 0.7499999921527281}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 1.1684492482568893`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.6526889544284153`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-1.491654876777717, 2.073423469354273}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.190415030972834, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.290620611051608, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.694093021166824, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.090999490513565}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.91782824451005, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-4.382026634673881, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047875165492457`, 6.298949246855942}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.417032243872697, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2942622756733968`, 6.0867747269123065`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             1.0678093795130645`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.8058680506240641, 1.937301774518713}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9293759714228106, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6044503709230613`, 6.999422467507961}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             0.8202202631234213}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.836849948493799, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 1.0868770324496888`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7813228714636707, 7.822444729489319}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-39.34081340913477, 4.512945241945574}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5716605481000705`, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.7985076962177716, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.659260036932778, 0.7485818874480459}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.045554398052668, 0.7485818874480459}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8470607850131444`, 6.756932389247553}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5015355768588979, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0202633222571333`, 1.4929040961781488`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.006215439402142, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.100426344668657, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.26443077336305, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.541030999190403, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.201916872261721, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2790527457537265, 1.864080130807681}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6792442753909539, 2.0719132752590443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.8420006856648017`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.7822140563845235`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.719319793360441}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8689301605143175, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1821389399181785`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8121662790057176`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324790142551358`, 5.971261839790462}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7225041580723603`, 1.9387416595767009`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 2.2044208442068145`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.623341473175256, 5.2574953720277815`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-2.659260036932778, 0.849723487602042}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4329667693183212`, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.4722426732562555`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.7985076962177716, 2.187398683184928}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3005870903313728`, 5.480638923341991}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3893457262282811, 2.0068708488450007`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.491327217590923, 2.0719132752590443`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             2.5087859235779435`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.523226215615035}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 1.2190584417439767`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.430629081771714, 
             2.827905162910489}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.0529699307894087`, 7.600902459542082}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1702157075278026`, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.319222734147069, 6.784457062637643}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 1.2499017362143359`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324790142551358`, 5.971261839790462}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 1.497835735852798}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 0.848868055556721}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-27.341341040814093`, 4.512945241945574}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.6661962462527091`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047875165492457`, 6.298949246855942}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 1.9453385571563557`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.462149662665384}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0181583132629375`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.3178664036290963, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5692561228012685`, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.887460350206278, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.931658209005277, 1.8625285401162623`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.418781887396557, 5.111987788356544}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.76686592498839, 4.386889790339869}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.7722610630529876`, 
             0.986935571443487}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5159475693467614`, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.7418655495969406`, 4.386889790339869}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1111386284230904`, 5.66988092298052}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.2178763245351174`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8643301620628905`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.159425367681418, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 1.3982229319851645`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.863232841258714, 0.8333438110532289}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.30031936921871, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.880084850028029, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.518075479137158, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6240440648234626`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.527397202097891, 7.076653815443951}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9001713499942718, 1.4951487660319727`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.019664337643975, 1.8687205103641833`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4983438649285135`, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.462149662665384}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5823216254710607, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.771368779580321, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.71869489837105, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.9063404010209869, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-49.34073194467232, 4.512945241945574}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.900588627802483, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.4178610876830975`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.9736550492637259, 1.9198594718553708`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 0.849723487602042}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.491779868965868}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.9542522381612738, 2.0719132752590443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820086052689358`, 6.921658184151129}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             0.9364854391596744}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.966857671750368, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.8250798518207709, 1.864080130807681}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6654793033177253`, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5906161581935125`, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5906161581935125`, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.377606779979768, 2.0706530356467567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5561717255328675, 1.864080130807681}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-4.524512282970637, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.9245405804618736`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5338868320097188`, 1.937301774518713}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.606442403454302, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2654936609741865`, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.9251241812954787`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.3670139217339117, 2.134048091170708}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4728877844255986, 1.937301774518713}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.84195543139986, 4.386889790339869}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.975391927697949, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.571249159610065, 2.0719132752590443`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-37.34075273404506, 4.512945241945574}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640797356921787`, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 1.3147983594148207`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.594056810395798, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.462149662665384}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.1975522365230131`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.800001029850119, 6.253828811575473}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.468806782694355, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.30031936921871, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.227106951818089}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.9754419516613513`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0923241675108497`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.592214878401959, 4.386889790339869}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.161367091078508}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6332184410995039`, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.21927603978772048`, 1.860974538249528}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 2.075684492802124}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.795734531747094, 
             5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6969544189028993, 2.0082140323914683`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4405393759722864`, 5.940171252720432}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[$CellContext`\[FivePointedStar], {-1.0645007590393418`, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.932401799030521, 1.9358598132018119`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 2.377692565480851}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8476951015583583`, 2.0149030205422647`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             0.766397642299538}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.6305480388034254, 
             2.827905162910489}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 0.7485818874480459}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.5978370007556204, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 1.599387576580599}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7912011210353335, 1.4951487660319727`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9317114296555002`, 6.672032945461067}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.741256487054948, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262403303361214, 6.841615476477592}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.975391927697949, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-5.51796702860799, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.411934093335004, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2409826299598365`, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.657689841763261, 1.8625285401162623`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5918549290780729, 1.6034198401085373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.7985076962177716, 2.647592232065096}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.0218709311636855`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8470607850131444`, 6.756932389247553}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2184098521237055`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.7828868907244566`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.087375656742122, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.542246662893777, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.77313400510489, 2.0731719286662407`}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.7178497932003172, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0339487753423875`, 2.418588768750352}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.279845606024556, 1.7833912195575383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.428942281870568, 1.937301774518713}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.500433550670171, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 2.075308010398229}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-1.491654876777717, 1.783559272662715}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.965852822566973}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.462149662665384}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2651392395634233`, 1.5953389880545987`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.5257286443082556`, 
             0.8055826098897335}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3478567954878509, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.3282528397426234`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.064355904261795, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.308100273682156, 1.864080130807681}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.9568962497687927`, 1.7316555451583497`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.10045059841862, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7672619976276676`, 4.386889790339869}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751531979714171, 5.8522024797744745`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-61.467195171508536`, 4.386889790339869}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 0.9669838461896731}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1796054478776414`, 7.424165281042028}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-5.017810977845351, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.9572739077056285`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 2.1122716862705384`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5064301623598713`, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2971851860481147`, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.5919427181706105`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.516892795645856, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.924832423452417}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.215506040139609}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.810369351701646, 5.393627546352362}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.598497972395766, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.532062329207643, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.700587583759682, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4571461020918417`, 1.4883995840570443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 0.9403978072173882}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.194022473472768, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1715056141884346`, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 1.2669476034873244`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.6409365794934714`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-50.341331645288825`, 4.512945241945574}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6184786570862495`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.7042981934580606`, 
             4.386765389021055}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0186003506987251`, 2.4176979000945504`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.793961892783255, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-5.61797181824309, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 1.3321021320364639`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6922761907431048`, 2.6019486702196644`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6414447085691868`, 2.599722324216582}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.30031936921871, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.615959129424366, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.615959129424366, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7004573108212688`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.900346940202133, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.119430549896199, 2.1329823086078656`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.215490386143112, 1.6114359150967734`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.8944568674663975`, 
             4.386765389021055}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.4028303297599902`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.8947738884119054, 1.7316555451583497`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3171415024315738`, 6.063785208687608}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8305718564716175, 
             2.827905162910489}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.8305718564716175, 
             2.827905162910489}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-5.417776806585365, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.703510521060178, 1.8389610707123492`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.8012039280560548`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 2.217027204632399}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.735370011757173, 5.768320995793772}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 2.246332151443247}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.6003175012993283`, 
             4.386889790339869}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.3540294005326152`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.493879571799828, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.3178883284558303`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.4079456086518722`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.984837274409265, 2.005525858729668}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2072749131897207`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.900422093749666, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.0218709311636855`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6414447085691868`, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-3.366795954944823, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.9005275521158795`, 
             4.386889790339869}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1464364105041143`, 5.634789603169249}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.3524072174927233`, 1.0962762288705619`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3789263262507685`, 1.589235205116581}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.462149662665384}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.3003570667360838`, 
             4.386889790339869}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.9782390361706734`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0328245481301066`, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6906479678596436`, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-1.585233223737283, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.666335489679042, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.926290362185661}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1208578976154293`, 2.377692565480851}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.15455075984859803`, 2.5756610130564646`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-32.34077434210908, 4.512945241945574}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.8940401229393353, 4.386889790339869}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.2158025560795132`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.270112606830481, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.0841264243165862`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.841967538444134, 4.386889790339869}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-1.313415715707318, 2.498151876538021}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.402871609042948, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.49397078181451, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.676945820702642, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5692561228012685`, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.117817918407743, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.9661128563728327`, 1.0942695392339727`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.416581053724763}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.894183087299815, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             0.8977193462887197}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.6407445017668969, 
             4.512945241945574}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.502828177375842, 7.600902459542082}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6941476808935289, 1.4951487660319727`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.9754419516613513`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.2256240518579173`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4876628555081794`, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4361820807702249, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.841967538444134, 4.386889790339869}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.9031380572114442`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.5824869781268642`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7538858167999734`, 2.599722324216582}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4092798316650086`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2960880932337415`, 1.4883995840570443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.701553201341906, 2.418588768750352}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.2862680470527663`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-1.443923473956527, 2.418588768750352}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.5191254931746836`, 6.684611727667927}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.4307829160924542, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7306413849875258, 
             2.827905162910489}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.5558971455060706`, 2.3456445824544927`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.6539264674066639, 4.386889790339869}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.579879110192556, 2.5974910105351463`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7120245012092015`, 2.506341930508065}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6286207318508743`, 2.4176979000945504`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.5177707239082765`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-5.117830825699811, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7406861990440543`, 6.040254711277414}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1644316297054034`, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1644316297054034`, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.2941383093687477`, 
             4.386765389021055}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 2.556451816951096}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.095273387402595}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.4179914478631452`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4079456086518722`, 1.773934884315503}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5288198871382693, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.7740297600361856`, 6.429719478039138}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.5919427181706105`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.462149662665384}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.103158068297152}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-8.850570223130148, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2595256035335987`, 5.521460917862246}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5079962967558309, 2.134048091170708}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-4.045554398052668, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7655070980839893`, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.2164073967529934`, 2.131796772013764}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7306413849875258, 
             2.827905162910489}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7637552728184576`, 2.4265710727750367`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 6.999422467507961}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4267908948229169, 1.6974487897568136`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6424777665123005`, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6424777665123005`, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.640548907459153}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.719319793360441}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.6700167631710908, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0898959995836948`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.349630376748299}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.599292605088321, 2.0719132752590443`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3567355588783463`, 
             2.702032128776647}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7310567536331655, 1.864080130807681}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.6397713603489157`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6416938989710297, 1.8625285401162623`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2824955457644808, 1.7817091333745536`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1409980051645476`, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-5.317908016313041, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-5.2178439823981595`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.8027388571900397, 2.58851563240702}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.7837272975307907`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.462149662665384}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.412267540691536, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6218266343535928`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             2.1151705891340815`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.592214878401959, 4.386889790339869}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.068859330518762, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4028684822608984, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.40649706843741, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.5565205830281202, 
             2.702032128776647}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.2170885989659, 4.386889790339869}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.712716261887602}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 1.0335402919243948`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6907507040241487`, 2.005525858729668}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1184069159962893`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.566911473871001, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1535965970008693`, 1.4906543764441336`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.725332537920259, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2669126040998102`, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.9572739077056285`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8189251373008244`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.9910270779881722}], 6., 
            
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7159101569446171`, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.5824869781268642`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5068336024964532, 1.601405740736836}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.500433550670171, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.700547258981618, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.475392057419415, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6492187824459448`, 2.506341930508065}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-5.717779984300055, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3842963584572177`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.5087859235779435`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.7820071777853768`, 2.50470927708418}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0645007590393418`, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6654793033177253`, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.6825463842547386`, 2.2648832258100344`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8195418502405067`, 6.784457062637643}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7145751279735658, 1.9387416595767009`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.166915255056936, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0942219403668167`, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.071483621279857, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346745988779815, 6.756932389247553}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.598497972395766, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.5824869781268642`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.6409365794934714`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-1.491654876777717, 1.094604267270571}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.4307829160924542, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3861841168703593`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 0.849723487602042}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5793937910857236`, 2.5087859235779435`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5324768712979722`, 2.5877640352277083`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.96443110720209, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.215506040139609}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.82821600623867, 2.5862591440482876`}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.612442421454399, 5.768320995793772}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.9110235456270366`, 4.969813299576001}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.22276862160913655`, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.725332537920259, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.462149662665384}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.377692565480851}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.8118888405232207`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.900458886151396, 5.480638923341991}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.44926026810783587`, 2.0719132752590443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-7.286383733136742, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.036482917202561, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.725433722188183, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0898959995836948`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.0281898243715637`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.26443077336305, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.659260036932778, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6445470895476684`, 5.736572297479192}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5876764206525877`, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.045554398052668, 0.9604989865384754}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.437937594271729}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8407396514497736`, 5.940171252720432}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3874950816964096`, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5474025215146479`, 2.414126467726953}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0939232991819783`, 4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.3286906908754075`, 5.075173815233827}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.094604267270571}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0108761743640229`, 1.937301774518713}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3063747379440172`, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3063747379440172`, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8350845939664286`, 2.4265710727750367`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7903604483143476`, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.666853965970644, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.2072749131897207`, 1.902704363179782}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.287354413264987, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.287354413264987, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.246332151443247}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             0.7975071958841882}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8307082193666298`, 2.512035317176253}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.719319793360441}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.6527732864216721, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.132893222644984, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-4.366940997255841, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8714522381373035`, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.2862680470527663`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8413699697813894`, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.6005679992668521, 1.4996230464268938`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7389772837890856`, 7.365180126021013}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.893897967672723, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.2256240518579173`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.4307829160924542, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.716864386545305, 4.386889790339869}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.2072749131897207`, 1.497835735852798}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4599740936085572, 2.004179057179289}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.0975128932248088`, 8.006367567650246}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.912572089444803, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6691879168398742`, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6691879168398742`, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5366522427084526`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0918353043890858`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-0.3492738284584218, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.416581053724763}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5473167323484057, 1.9358598132018119`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.612442421454399, 5.768320995793772}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 2.424802725718295}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.067986095126349, 2.3456445824544927`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.0279882600909205`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             2.1151705891340815`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.279055610450292, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.659260036932778, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3329431856228962`, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.5978370007556204, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.084253098677058, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             1.9838938336679197`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2063088641234838`, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.6126737964100685, 2.005525858729668}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7168253079145225, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 0.965080896043587}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.0241960674538575`, 6.429719478039138}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6713133161521878`, 
             2.187174241482718}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.4342248948774405`, 
             4.386765389021055}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.595748829015065, 5.991464547107982}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.7985076962177716, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.391511302188447}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.7840632625935846`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.7109170813839543`, 5.66988092298052}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751531979714171, 5.8522024797744745`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.746403767507258, 5.634789603169249}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-0.536314386533157, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.9317114296555002`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5687759307152107`, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.7254100886865211`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.4920048155420047`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6398971199188088`, 2.0843046973458237`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.4126383364594925`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0963149296194261`, 6.684611727667927}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4605869657017456`, 2.4176979000945504`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.5841201044498106`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3688474475161698`, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1041274693562197`, 2.413231613081109}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640797356921787`, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7667937207282438, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.719319793360441}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.0906441190189327`, 
             2.558002204858551}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 0.9707789171582248}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 1.599387576580599}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             1.9838938336679197`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.742398039690331, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.4307829160924542, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.725433722188183, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2330583852210326`, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2330583852210326`, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.269044801069651, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.269044801069651, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.462743533283297, 2.58851563240702}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.3089630181835672`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[$CellContext`\[FivePointedStar], {-1.1689274625831354`, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5213811377055073, 2.0719132752590443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.640548907459153}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0277811079075183`, 1.9768549529047348`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.0968250627658085`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.3645328693383778`, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2063088641234838`, 6.674561391814426}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1542307124311217`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020229905154391, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.5974734304916628, 8.006367567650246}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.2180717287054377`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 1.4915548717773834`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.1597073880279205`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.84195543139986, 4.386889790339869}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.6906479678596436`, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0645007590393418`, 1.7817091333745536`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3585338134237321, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             1.8526977673331346`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.9999411183280458`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 0.7485818874480459}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-3.270169119255751, 1.6272778305624314`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.227106951818089}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4934342366777942`, 2.512035317176253}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6993626199620875`, 2.020222182019865}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.528780009416646, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.4365120772805082`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-4.294015757351168, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.536314386533157, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111964733385396, 6.492239835020471}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.466163406970865, 2.1329823086078656`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.666853965970644, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-4.045554398052668, 1.0335402919243948`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.612442421454399, 5.768320995793772}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.466024904841838, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             0.766397642299538}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6864844231876495`, 1.7817091333745536`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             0.9290095042819297}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.817803785159501, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.8840655845794182, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.007679175452945, 5.823045895483019}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.3418458069473482`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.900588627802483, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.2533450600473311, 8.350429973538136}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             0.8028980445190645}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8865098057738656`, 2.5771819258971713`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0996442489973552`, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.4028303297599902`, 7.600902459542082}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.406905315024015, 7.697121317282625}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8656213178265104`, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.036382052219389, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4007990473227723`, 2.5817308344235403`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.152962883418191, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8042369907391675`, 4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4304552569056603`, 2.503891949699081}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6218266343535928`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8944568674663975`, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.4307829160924542, 1.726509584019938}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.881903019081021, 2.6224923127405635`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.9670073137609054`, 4.386889790339869}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.5077842587076005`, 5.823045895483019}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1874435023747254`, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.1589994386832048`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             1.721694594779768}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.5978370007556204, 1.4964931534179662`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.3407610128583247`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.6269849783062765, 1.937301774518713}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.900458886151396, 5.480638923341991}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.4871090733432, 5.393627546352362}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 0.9669838461896731}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.9499943818801375`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4329667693183212`, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.1413169453979233`, 
             4.512945241945574}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.300630996469888, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.816462081868427, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.662352421858305, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.7268653293100646`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9085180298382507`, 2.423031246069913}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.137918471438812, 5.393627546352362}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3842963584572177`, 2.413231613081109}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.6888794541139363`, 0.7485818874480459}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4240364936935998, 8.1797604936999}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-0.908818717035454, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5220551057175394, 1.4951487660319727`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-0.6624240079171049, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4338645826298623, 1.601405740736836}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324790142551358`, 5.971261839790462}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0404377246170375`, 8.063377822367027}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.038175919864279, 1.864080130807681}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.4722426732562555`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.3137876703331426`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.995732273553991, 3.8004208288468435`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-0.8505029913361519, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.4307829160924542, 
             1.5904589458362974`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.5338519254775054`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0302996484860225`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 1.4911047254722358`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-7.1308988302963465`, 
             1.2424239907001886`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.807005375881994, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.559220196273483, 2.135349173618132}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.294616923344869, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.9177918580004223, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0091694886945044`, 2.5756610130564646`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             1.8526977673331346`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.2909841813155656`, 1.4911047254722358`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7159101569446171`, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 1.1464496180822696`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.694451286761057, 
             2.1644717908644115`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.400308181522661, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.298317366548036, 2.0471765810925606`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1821389399181785`, 6.921658184151129}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.6179742434563866`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.698815723585317, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.698815723585317, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-4.045554398052668, 0.8514321595256585}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.900346940202133, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8587568185269134`, 2.136530508663963}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.0498221244986778`, 2.187398683184928}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.8843386505211481`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7696066645869217`, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316692464055834`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 2.293947899598382}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.2908841763152323`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.117766656001504, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8598242001421843`, 5.521460917862246}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.768756076219605, 5.111987788356544}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5342648554997536, 2.0068708488450007`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7789229575813493, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.538054293998892, 2.134048091170708}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-8.850570223130148, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.5824869781268642`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.475392057419415, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.1177951080848836`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.6190782472999463`, 6.684611727667927}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.5808504555821878`, 6.249975242259483}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.6528674703614363`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             0.9345235001352147}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020229905154391, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5064301623598713`, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.016955910005618, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.152761077153482, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9200474895295858`, 2.498151876538021}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.71869489837105, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751531979714171, 5.8522024797744745`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.807005375881994, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.9980550336767947}], 6., 
            
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.6888794541139363`, 0.8505781885087738}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.3492738284584218, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.968974088653865, 1.803358605071407}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.0335402919243948`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.7378311272024993`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.694451286761057, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.64930970607961, 2.0719132752590443`}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9186841628017217`, 
             2.1400661634962708`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.273910668367863, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2315538186741798, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.694451286761057, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.2072749131897207`, 1.726509584019938}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7168253079145225, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.0598714603516792`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.995732273553991, 1.497835735852798}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.878625402249717, 1.8656293177945105`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.540748536722336, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-3.567015866357096, 4.386889790339869}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.29356601561075557`, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.090999490513565}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.3101690833145914`, 5.393627546352362}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8997902134417601`, 6.704414354964107}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.6409365794934714`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4876628555081794`, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.468806782694355, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8426317996018116`, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 0.8514321595256585}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8407396514497736`, 5.940171252720432}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-1.491654876777717, 0.849723487602042}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.780226233414382, 1.9300710850255671`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.7867719277170158`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3563472847519384`, 2.3850863145057892`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7903190923122189, 1.6272778305624314`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.462149662665384}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6029589463363911`, 7.501082124259871}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.7790406968202803`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.8269722249837996`, 2.1825620503943153`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.4305321073246677`, 1.8656293177945105`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8904754421672127`, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-0.8505029913361519, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.808498793232353, 7.295735072749282}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1880994551696458`, 2.3850863145057892`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.5338519254775054`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.612240146256234, 2.1329823086078656`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-3.76705723517796, 4.386889790339869}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.293868803909631, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.4307829160924542, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.7435408969575807`, 5.537334267018537}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.0654001544619962`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047875165492457`, 6.298949246855942}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.462149662665384}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.5288035062673013`, 5.075173815233827}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2739976361421332`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.9639722918737217`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-8.599488434143067, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.548102073285148, 1.864080130807681}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.0177699008240089`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.421661504957182}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020229905154391, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             0.898534010284896}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             2.4561641809223462`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.516892795645856, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.278964002683987, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-6.667164814064207, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.742398039690331, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 1.721694594779768}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.1625110145183415`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.3540294005326152`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.5824869781268642`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.741256487054948, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0940068428223313`, 4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.973281345851445, 2.4239173781615704`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.293897511853923, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.894078619827491, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.2170885989659, 4.386889790339869}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.228790658775024, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9784819201474635`, 2.0706530356467567`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9414202437824613`, 
             2.1174596088673567`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8016468498397944`, 2.130609828254235}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-5.817847430944174, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1026203100656484`, 2.2648832258100344`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8195418502405067`, 6.784457062637643}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.995732273553991, 1.2669476034873244`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.911914268349973, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7199019178687649, 
             7.8838232148921525`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4092798316650086`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7987840841650193`, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7212874278842305`, 2.0719132752590443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.515036014769512, 1.4951487660319727`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 1.191191469961203}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0288996762568094`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.786359562282124, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5228016057745537`, 5.857933154483459}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.200028504668954, 6.253828811575473}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.082935809283102, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.36571568859088144`, 1.6034198401085373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.4753441779534016`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0604498275737608`, 2.0719132752590443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-4.8283137373023015`, 2.0471765810925606`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.104554242494911, 6.999422467507961}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.44238846221276223`, 1.501852701754163}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.0940068428223313`, 
             4.386765389021055}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.1966460289394751`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.974001029221839, 2.502255288122613}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2330583852210326`, 
             7.8709295967551425`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7414001807837645`, 2.131796772013764}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.766368110426725, 2.0068708488450007`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.869504817852908, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.66442222076686, 6.939253946041508}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.162823150618887, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.359873830032749, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.411934093335004, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.915963072687361, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.8699543168131119`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.220083871482302, 5.560681631015528}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6497392092076262`, 6.131226489483141}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.1866231659908228`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 
             2.1627481478062465`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.5532907518110994`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.3563504847468186`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.6623114020411685`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.6790255220615937`, 2.134048091170708}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.7867719277170158`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledDiamond]", {-2.214574215671332, 4.386765389021055}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.4405393759722864`, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3193836558372638`, 6.461468176353717}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0129050178795915`, 5.768320995793772}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.196377287787253, 1.0360274134764884`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.2157956136516715, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.2072749131897207`, 6.396929655216146}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.376740148315079, 7.226936018493289}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4850103340590484`, 2.135349173618132}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.9122987106046175, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.820158943749753, 5.560681631015528}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.9028810449642375, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047875165492457`, 6.298949246855942}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8129108417183852`, 1.937301774518713}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.7181373293574413`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.995732273553991, 1.0335402919243948`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.7268653293100646`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-0.786359562282124, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.2072749131897207`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7655070980839893`, 
             2.0930978681273213`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.7083778602890038`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.6624240079171049, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0272286702329017`, 7.076653815443951}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.6888794541139363`, 1.0942695392339727`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.412288358086009, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.823966230699553, 6.429719478039138}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9240709191931175, 8.1797604936999}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.9975007872996983, 8.006367567650246}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7696066645869217`, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.2669476034873244`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-5.10045059841862, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.8799351601317804`, 7.22402480828583}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0612087734187763`, 2.519308076505333}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8997902134417601`, 6.704414354964107}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.5016459737922982`, 1.9198594718553708`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7002308520500784`, 1.691939133945844}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.2867117438377558`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 
             1.3045418592476314`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1702157075278026`, 7.433666540166168}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.95263269481614, 7.151485463904735}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 1.322289031143978}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.3281354469463584`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-6.667164814064207, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.975450465015525, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.132893222644984, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.3504080825554816`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.0289048762432895`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-0.3504089023600859, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3039860739096736`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.029509172931627, 2.4997952622817508`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-8.350408373771412, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0272286702329017`, 7.076653815443951}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6445470895476684`, 5.736572297479192}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.2207799226423173`, 7.783224016336037}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.30348549823721, 2.432735777459091}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4307829160924542, 
             1.5904589458362974`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.9407951330603375`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.090999490513565}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 1.173410498743296}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 2.215282764591249}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.995732273553991, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.6843598389513597`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8551011438142453`, 1.864080130807681}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-3.6504282677396835`, 1.5432981099295553`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2669126040998102`, 4.386889790339869}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.9661128563728327`, 1.497835735852798}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.359873830032749, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.028556821684098, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.7147984280919266`, 0.7485818874480459}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 2.4176979000945504`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5663784229736533`, 6.214608098422191}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9428149441480107`, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2909841813155656`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.491654876777717, 0.7485818874480459}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.100765130025024, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2069773133462347`, 6.173786103901937}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8470607850131444`, 6.756932389247553}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.418894215394429, 1.6882490928583902`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2977324083052823, 1.6114359150967734`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.4847813078345447`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5059792040658704`, 2.0843046973458237`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5644645467913691`, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-0.8505029913361519, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 2.066736169182282}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.640928579525471, 
             4.512945241945574}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9038682118755978, 6.476972362889683}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9110235456270366`, 2.0731719286662407`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.282782465697866, 2.423031246069913}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.4588475538015993`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.7667937207282438, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706800981701778, 6.396929655216146}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.898454207899018, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7903604483143476`, 
             2.0681277817795625`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 
             1.0420419371797154`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.4354783156390294`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7955707986317053`, 2.0706530356467567`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5782126424678459, 1.5432981099295553`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.8069317506623275`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2437536743377806`, 7.360103972989152}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0993125337825032`, 8.004365564979574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 0.911479174876933}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.3039860739096736`, 
             4.386765389021055}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.2255369822417765`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.7109170813839543`, 5.66988092298052}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.7147984280919266`, 1.497835735852798}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1199380753828623`, 2.065596134857783}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0549440700794483`, 2.418588768750352}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.3491115699921747`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             2.3243465847755584`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.6544352783648362`, 5.676753802268282}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7987840841650193`, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3678803477808931, 1.4973884086254774`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.575036485716768, 2.020222182019865}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.885443919659868, 5.768320995793772}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.6623114020411685`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.462149662665384}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5901256014017275`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8500747011316276`, 2.0731719286662407`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1230074455028314`, 2.1825620503943153`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0794415416798357`, 
             1.815475995845371}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.23876493221716663`, 1.601405740736836}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.3749057545736716`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.491654876777717, 1.416581053724763}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.4532518292447716`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.975450465015525, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.4722426732562555`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-3.101092789211817, 
             0.7802418874108791}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.552112845814831, 7.55171221535131}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.4911047254722358`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.007679175452945, 5.823045895483019}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.0923241675108497`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0891571298973546`, 2.0082140323914683`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 2.031563461435372}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.8122154777954373`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.036482917202561, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3993162819538174`, 6.704414354964107}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9696906777207166`, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.5329399414613754`, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.5902550930173265`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.4307829160924542, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.2919836816486494`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.880084850028029, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.227106951818089}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-3.4420193761824103`, 3.2386784521643803`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.6094379124341003`, 7.3777589082278725`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3799147541558516`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.804781390061982, 6.298949246855942}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-0.7985076962177716, 1.2140221401789375`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.816462081868427, 
             2.0425181875752383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-3.3524072174927233`, 1.497835735852798}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.1603343472961065`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.6888794541139363`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111964733385396, 6.492239835020471}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.9661128563728327`, 1.726509584019938}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0971007679422797`, 2.0082140323914683`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0189110419398038`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.300630996469888, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.1279381180499384`, 2.1174596088673567`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.419118909249997, 6.684611727667927}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.9510398268753117`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4092798316650086`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.7406415980494447`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.4405393759722864`, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.739076112448345}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706800981701778, 6.396929655216146}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.497835735852798}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.3003570667360838`, 
             4.386889790339869}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4524341636244356`, 7.151485463904735}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-0.9122987106046175, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9002402920947703`, 1.7850704810772584`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7672619976276676`, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.807796846925679}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.344384958042681, 7.759614150696903}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751531979714171, 5.8522024797744745`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-3.6888794541139363`, 0.9669838461896731}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.3524072174927233`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.5824869781268642`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1111386284230904`, 5.66988092298052}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.104554242494911, 2.421256622711544}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.220083871482302, 5.560681631015528}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.552112845814831, 5.8289456176102075`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.6260755535871236`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.8424288832756998}], 6., 
            
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.159425367681418, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.220083871482302, 2.424802725718295}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.676945820702642, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1689274625831354`, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.6888794541139363`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316692464055834`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.319222734147069, 6.784457062637643}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.016955910005618, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.5287678617828835`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4644721421839146`, 
             2.494031557565001}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.5845302767279155`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.7147984280919266`, 1.726509584019938}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.6661962462527091`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.3035404883862389, 1.5107219394949427`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7667937207282438, 4.386889790339869}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.1733127572899065`, 2.419478844465545}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-1.95263269481614, 2.1174596088673567`}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.51875303057183, 5.111987788356544}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6745099091778153`, 1.9300710850255671`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 1.721515815839451}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6939993778795506`, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.3524072174927233`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-6.912265434460023, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1464364105041143`, 5.634789603169249}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.4088348928367562`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.2181715237257489`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5173146235582946`, 7.086737934510577}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.435545220250276, 1.776645831418007}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.706800981701778, 1.4883995840570443`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9192952408944538, 6.461468176353717}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.209391157353635, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             2.2086040295231517`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.2098554674840916`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.6888794541139363`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2395270305647338, 1.4996230464268938`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-3.3524072174927233`, 0.8046885552928528}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6115589009134488`, 6.492239835020471}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-0.3504089023600859, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.974001029221839, 6.429719478039138}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-8.350408373771412, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.9987836386623814`, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 
             1.7535382564078572`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1874435023747254`, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2942622756733968`, 6.0867747269123065`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.8610265707016995`, 4.969813299576001}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.8183088044615916`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1304126012179074`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.864975531559314, 5.966146739123692}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.110245660342752, 5.393627546352362}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.400308181522661, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.6108369333478076`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 2.090999490513565}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.8526977673331346`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.7078502210995437`, 1.5973653311998313`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.8426317996018116`, 
             2.0162354657760435`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-54.46678982836, 4.386889790339869}], 6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.820158943749753, 5.560681631015528}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.946310229076653, 7.157735484249907}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.100426344668657, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.2636117187095923`, 6.040254711277414}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.5005758256424344`, 
             4.386889790339869}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4912105310694506`, 
             7.6128310304073565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.0287936073591935`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8461060995981784`, 2.004179057179289}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.70036037299184, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.95263269481614, 7.151485463904735}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8598242001421843`, 5.521460917862246}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.786268646522262, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.940865372113151, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.9910142780700916, 7.6128310304073565`}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2909841813155656`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6115589009134488`, 6.492239835020471}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9515240188896708`, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.900588627802483, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.5779472453427295`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 1.506518858426259}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.064355904261795, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.6163727633271883`, 4.787491742782046}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.2919836816486494`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 1.715777948205427}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.606941032235513, 6.173786103901937}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.493987758524193, 4.386765389021055}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3037931396081468`, 6.476972362889683}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.309519943887134, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.516892795645856, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262403303361214, 6.841615476477592}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 2.044332364566268}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.1941832122778293`, 0.6936470556015963}], 6., 
            
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.726509584019938}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-8.412382827063892, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.995732273553991, 5.991464547107982}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.742969305058623, 
             1.9837562915454279`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.4307829160924542, 2.647592232065096}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.21678878567620194`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.2917089186300228`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4947708374559745`, 5.886104031450156}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 1.7268653293100646`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.4307829160924542, 2.187398683184928}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.5978370007556204, 2.647592232065096}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-2.6168849633501186`, 4.386765389021055}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.874045755297392, 6.429719478039138}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 1.900464386136271}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0189110419398038`, 6.584791392385716}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.869504817852908, 
             1.9892432737616872`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.527397202097891, 7.076653815443951}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0514564223263525`, 2.0028304393079956`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.810913836561449, 4.969813299576001}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.894078619827491, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.213639558072954, 6.040254711277414}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.4312677267626217`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.556451816951096}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.0102369597568726`, 5.393627546352362}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.416581053724763}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.0181583132629375`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.864704011147587, 1.3452119160186606`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.286383733136742, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 2.193662685769859}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8195418502405067`, 6.784457062637643}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.5257286443082556`, 1.266384064447333}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.9661128563728327`, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3482281603134343`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.017939231019695, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.389499492068839, 5.991464547107982}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0918353043890858`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.963188584855586}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2063088641234838`, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.5808504555821878`, 6.249975242259483}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.7329280505717899, 7.8709295967551425`}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.5978370007556204, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.424802725718295}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.8470364847178946`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1214715828141923`, 1.9387416595767009`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.500810170663849, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.91139112512024, 2.0068708488450007`}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-1.7897614665653818`, 2.04225875055212}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-8.599488434143067, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.0328245481301066`, 
             2.425687290128029}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5608378214218233`, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.8146618624453594`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.26683423993894284`, 4.386889790339869}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.090999490513565}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.3047875165492457`, 6.298949246855942}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.293947899598382}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.044846896915337, 5.736572297479192}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.483987072728617, 4.386765389021055}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5449114637250294`, 1.5933085305042167`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.8420006856648017`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.4701108472130011`, 
             2.58851563240702}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9806466361359503`, 2.005525858729668}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.170085660698769, 0.7802418874108791}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.7147984280919266`, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 0.9654617758806044}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.7109170813839543`, 5.66988092298052}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.5978370007556204, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4092798316650086`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9949325933834268`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.219163484854973, 5.111987788356544}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.1627481478062465`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.2975725511705014`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.693851481702397, 4.386889790339869}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             1.9782390361706734`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.898454207899018, 
             1.9600947840472698`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.227106951818089}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.4226262903672808`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.4135166537013273`, 6.040254711277414}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.333559897293476, 1.9768549529047348`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111964733385396, 6.492239835020471}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2303167796655379`, 1.691939133945844}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.7254100886865211`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.395133309787095, 2.0731719286662407`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.389499492068839, 5.991464547107982}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2361517026901712`, 2.1329823086078656`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.2433732333621994`, 5.537334267018537}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.516892795645856, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.3749057545736716`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 1.9569913819232716`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 2.0215475632609334`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-7.036270701217564, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.378751192832325, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8799351601317804`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.5005758256424344`, 
             4.386889790339869}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.2377341206744292`, 5.393627546352362}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8407396514497736`, 5.940171252720432}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             2.031563461435372}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.2568373311553196`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.902767737471098, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 1.8826660279157308`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.9180031958023054`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-2.064355904261795, 2.065596134857783}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.6854573524495757`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-8.412382827063892, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.900346940202133, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.5978370007556204, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.5978370007556204, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.168283961917429, 2.0719132752590443`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2909841813155656`, 1.497835735852798}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.5005758256424344`, 
             4.386889790339869}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.152897360346143, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.4126383364594925`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7048480972387587`, 1.8656293177945105`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.9754419516613513`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.804781390061982, 6.298949246855942}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.5047438413194347`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.3871630694693433`, 5.393627546352362}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.224893897193764, 1.937301774518713}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.6139480679119864`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.900464386136271}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.0939462278827174`, 4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346745988779815, 6.756932389247553}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.3540294005326152`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 1.416581053724763}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.4018530946527146`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.491654876777717, 
             2.1094856630282126`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.2568373311553196`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.7693434299437227`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9519282213808764`, 5.8289456176102075`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 5.991464547107982}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.5539252025038417`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 1.671097292820828}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.5978370007556204, 1.726509584019938}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 
             1.7693434299437227`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520318812570019, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.6939993778795506`, 
             4.386765389021055}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1111386284230904`, 5.66988092298052}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.317800258800526, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1150465951315345`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.5920892740994874`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.575036485716768, 1.1780394222994315`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.5366522427084526`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.816258383443767, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.296603021316498, 6.907755278982137}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.6378309869353183`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.1409980051645476`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6702500518308578`, 7.433666540166168}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.652827532407001, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.2909841813155656`, 2.187398683184928}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.804781390061982, 6.298949246855942}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-8.286478374605709, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.7164562218841706`, 4.787491742782046}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.555615105736594}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-2.659260036932778, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9317114296555002`, 6.672032945461067}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.491654876777717, 2.1872864686305826`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.864704011147587, 1.3326298365341978`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8953440995227226`, 1.9358598132018119`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-0.26683423993894284`, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 0.8060293376166178}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5173146235582946`, 7.086737934510577}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4375876555074412`, 2.0149030205422647`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0417762120553977`, 1.4883995840570443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.2975725511705014`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.2319770007355333`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.7188583998188136`, 5.111987788356544}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.5978370007556204, 1.497835735852798}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.166888494485349, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8598242001421843`, 5.521460917862246}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.506518858426259}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.1892564076870427`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0898959995836948`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-6.786422993814612, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             2.0624225365102413`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.2072749131897207`, 6.396929655216146}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-0.7985076962177716, 1.4964931534179662`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.0738571633859353`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.4307829160924542, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.1526461771605954`, 1.8656293177945105`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.779362064213738, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.68510181635509}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.3420861064555702`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.4938666711595117`, 4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 2.090999490513565}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.475392057419415, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.3204807842031671, 6.960347729101308}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.5978370007556204, 
             1.3754861624032872`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.100765130025024, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.5129946410508307, 6.81783057145415}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.0215475632609334`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7625890919282752`, 6.841615476477592}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706800981701778, 6.396929655216146}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.279055610450292, 2.0731719286662407`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.5609672964009644`, 4.969813299576001}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 1.416581053724763}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.3540294005326152`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8997902134417601`, 6.704414354964107}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132468797127462, 5.971261839790462}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.044846896915337, 5.736572297479192}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.8122154777954373`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.46298829435183064`, 6.81783057145415}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2909841813155656`, 1.726509584019938}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.4753441779534016`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-2.3418458069473482`, 
             4.386889790339869}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.940782792197422, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.70036037299184, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.466278187121473, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.171276846068922, 1.9358598132018119`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.653113060608557, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.751531979714171, 5.8522024797744745`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.5612262966614128`, 1.691939133945844}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.6661962462527091`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-5.298317366548036, 2.0471765810925606`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-8.028919972120757, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.725971728690052, 6.104793232414985}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.612442421454399, 5.768320995793772}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.25165731439258, 5.8522024797744745`}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.953887209526845, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.6591800043289144`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 1.170932950247736}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.912330925723864, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.8805331812814825`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.0136538011418326`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.880084850028029, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7625890919282752`, 6.841615476477592}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDiamond]", {-1.0498221244986778`, 1.0935997468445653`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2026403590921573`, 2.0095554142156695`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.8162894669713328`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.966950472128539, 1.937301774518713}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyUpTriangle]", {-1.05211045501669, 7.55171221535131}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.880084850028029, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.2761851384398606`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.111964733385396, 6.492239835020471}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.2158025560795132`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.864704011147587, 1.0732944806838198`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.9477043045434095`, 1.8625285401162623`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164563795096671, 6.939253946041508}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.3354096411241523`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8951219822232084`, 5.886104031450156}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 
             1.6378309869353183`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.2876820724517809, 2.227106951818089}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-7.412267540691536, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.4407825464039603`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-6.662458923026794, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.5100594684538216`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.1622605067393605`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.902818692021688, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5104979645791967`, 1.9358598132018119`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324790142551358`, 5.971261839790462}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-7.7788336680347445`, 
             4.512945241945574}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3993162819538174`, 6.704414354964107}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.6661962462527091`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.5107219394949427`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.6587993419718245`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.7929254558680243`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.201916872261721, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.166888494485349, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.2255369822417765`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-8.849872629798755, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.017406150760383, 7.086737934510577}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.631199404215613}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7389772837890856`, 1.803358605071407}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.016955910005618, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.697356025334, 8.006367567650246}], 4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.186787979571835, 1.7833912195575383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             1.9474803442248305`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.2742448573112677`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.166785108860756, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-8.286478374605709, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2909841813155656`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.529318843261892, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.5338519254775054`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.3540294005326152`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.500810170663849, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.068859330518762, 
             2.3896797998449792`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3208812225716584`, 2.0095554142156695`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1028721491118945`, 1.937301774518713}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.4307829160924542, 2.090999490513565}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.1269525243508878`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.536881615643591, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.3731931852525583`, 1.860974538249528}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.06016413371338, 5.393627546352362}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.659260036932778, 1.0845133642886082`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-0.09926800165866902, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0442924641693683`, 1.9358598132018119`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262403303361214, 6.841615476477592}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.4307829160924542, 1.599387576580599}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.416581053724763}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7625890919282752`, 6.841615476477592}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.2919836816486494`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.2876820724517809, 2.1587147225743437`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.4179367056664534`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.238564249095555, 7.365180126021013}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-3.6888794541139363`, 2.9290581402859983`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             1.9313764735639716`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.9372477759766606`, 5.393627546352362}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 1.416581053724763}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             2.078566158643882}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.196424897165655, 6.907755278982137}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346745988779815, 6.756932389247553}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0272286702329017`, 7.076653815443951}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-0.7985076962177716, 1.266384064447333}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.317867774075151, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.912265434460023, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.8499018253424513`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.2919836816486494`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8997902134417601`, 6.704414354964107}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.2672179491567546`, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 6.999422467507961}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.8805331812814825`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.104554242494911, 6.999422467507961}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.199705077879927, 2.0471765810925606`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.018486244188825}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-6.402746540537711, 4.512945241945574}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 0.9925107577855641}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.411934093335004, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 1.0335402919243948`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.8540604954254345`, 5.676753802268282}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.6593256320844346, 7.944492163932159}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.087375656742122, 
             2.3711778844596574`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.1062413158326008`, 
             2.3523271848888596`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.2909841813155656`, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.2256240518579173`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.166785108860756, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.8442026554799011, 7.759614150696903}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.2909841813155656`, 
             2.209811692841691}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0027568884909557`, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.517955942272351, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.5606477482646683`, 1.251619457793289}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262403303361214, 6.841615476477592}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.7539022397884905`, 4.499809670330265}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-7.036270701217564, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.2876820724517809, 2.227106951818089}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 
             1.1151415906193203`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.2909841813155656`, 1.266384064447333}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.416581053724763}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.6544352783648362`, 5.676753802268282}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.9093711079059474`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4007990473227723`, 6.380122536899765}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2371849385320495`, 1.9401794743463283`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-4.300630996469888, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-8.162319869424133, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.0498221244986778`, 1.266384064447333}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.251047211711865}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.2499926428748753`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.1499389158334503`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 1.506518858426259}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.557794679282262, 1.8687205103641833`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2262184132732556`, 6.104793232414985}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 2.090999490513565}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.7985076962177716, 2.647592232065096}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.786422993814612, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0605908459024875`, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2909841813155656`, 2.414126467726953}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.3498863661120586`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.6178619668786562`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8773173575897015`, 7.226936018493289}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.6761120457020933`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-8.036311444023319, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-6.536881615643591, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.040829633207479, 
             4.512945241945574}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1199358770132974`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 0.9489515141137035}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.5895081458004594, 6.7912214627261855`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             2.4561641809223462`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132468797127462, 5.971261839790462}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7985076962177716, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.2178763245351174`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 2.330200260027019}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3993162819538174`, 6.704414354964107}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 1.4964931534179662`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             2.3243465847755584`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.6661962462527091`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 1.0360274134764884`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 0.8307328435125084}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.793961892783255, 5.537334267018537}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.864704011147587, 0.9858167945227654}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.074653024948039, 6.429719478039138}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.4018530946527146`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9317114296555002`, 6.672032945461067}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.746403767507258, 5.634789603169249}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.9317114296555002`, 6.672032945461067}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.1269525243508878`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3617968895195032`, 1.9416152247724325`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.3071607397357723`, 1.864080130807681}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.2809338454620642`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7985076962177716, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 1.599387576580599}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             2.193662685769859}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.662458923026794, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.9582864201233687`, 5.823045895483019}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5901256014017275`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.813734143549063, 8.290041618704489}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.900458886151396, 5.480638923341991}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.864704011147587, 0.8989410935390421}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6324790142551358`, 5.971261839790462}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0272286702329017`, 7.076653815443951}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-7.418747583305227, 1.7328937163610187`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.030116700415822, 1.864080130807681}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             2.0624225365102413`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3093333199837622`, 7.294377299288821}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.9180410777537094`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1821389399181785`, 6.921658184151129}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7985076962177716, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.0218709311636855`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.3470736479666092`, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.3540294005326152`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.4907663827166018`, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.9313764735639716`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.2936253516225737`, 5.537334267018537}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.9510398268753117`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.525061368884541, 1.7833912195575383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.201916872261721, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.4122057429043917`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             1.8002235476401844`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.808498793232353, 7.295735072749282}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8238695231462887`, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.4371455863897404`, 5.393627546352362}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.1498640059763816`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.7539022397884905`, 4.499809670330265}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.8002235476401844`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.406587064387653}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-4.3428059215206005`, 
             2.6490076604684267`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.993630885266725, 5.537334267018537}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.4307829160924542, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.4964931534179662`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.0891571298973546`, 6.29156913955832}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.7985076962177716, 1.726509584019938}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5228016057745537`, 5.857933154483459}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.741015208534465, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.3649243353836982`, 5.966146739123692}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.9205497887945385, 7.783224016336037}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.0498221244986778`, 1.497835735852798}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 0.880041599199034}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.669026703845758}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.4146388341290332`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.5432981099295553`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.340807418168989, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.5639866495301828`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4460443655256647`, 7.157735484249907}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-6.140893060599911, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.2406103170142067`, 1.8656293177945105`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1796551117149194`, 1.4906543764441336`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.2581768583394481`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.95263269481614, 7.151485463904735}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 1.5377270648801}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.7985076962177716, 1.497835735852798}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132468797127462, 5.971261839790462}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.8205261098897758, 7.783224016336037}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.2876820724517809, 2.1587147225743437`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6115589009134488`, 6.492239835020471}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-6.502290170873972, 1.2424239907001886`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.049977288406387, 6.253828811575473}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.1428411385922033`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6115589009134488`, 6.492239835020471}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.406587064387653}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.6744763086133228`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.7859090555498793`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.9521761906339596`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.0498221244986778`, 1.726509584019938}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4118173183509766`, 1.5973653311998313`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8805331812814825`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5978370007556204, 
             1.3754861624032872`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.9093711079059474`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8470607850131444`, 6.756932389247553}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7985076962177716, 1.2669476034873244`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.8056623743970464`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.1029215602562081`, 7.600902459542082}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.2756420910162956`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.107781777362614, 1.8625285401162623`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.7181023127908395`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8016236568960291, 6.579251212010101}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.864975531559314, 5.966146739123692}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.606941032235513, 6.173786103901937}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.666828609658249, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.991862608772972, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-0.7985076962177716, 
             1.144222799920162}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.363503507963463, 6.040254711277414}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.2136588837996443`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 1.9569913819232716`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.117899907528199, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 1.0360274134764884`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.0929041853062644`, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             1.9368694044031642`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.5102244577722903`, 6.476972362889683}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.184232881424661, 1.860974538249528}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.1883639489040227`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             2.0680013515372804`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2783372196147982`, 1.864080130807681}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.1541650878757723`, 5.676753802268282}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             2.1992225799988927`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 2.1872864686305826`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0189110419398038`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledDownTriangle]", {-1.0498221244986778`, 
             2.330200260027019}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0498221244986778`, 2.4176979000945504`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             2.1992225799988927`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.4964931534179662`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8195418502405067`, 6.784457062637643}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 1.133013715385442}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.540842282118304, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-8.040959012419865, 
             4.512945241945574}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4126383364594925`, 1.8625285401162623`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 1.1026043099376472`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.904054835778969, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-3.2957568692041583`, 
             5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1593181637855046`, 7.944492163932159}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 1.4964931534179662`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.8180773925856184`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.4854489341097463`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.426283369336254, 6.104793232414985}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.8146187633741377`, 5.966146739123692}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.959419502711985, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.606941032235513, 1.7833912195575383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.156840433948748, 1.6974487897568136`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.708153885373258, 5.823045895483019}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.666828609658249, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.8799351601317804`, 7.22402480828583}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.604170685655008, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.2792657883613672`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820086052689358`, 6.921658184151129}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.8195418502405067`, 6.684611727667927}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.4722426732562555`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 0.9543569326806114}], 6., 
            
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.820158943749753, 5.560681631015528}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.605170185988091, 2.3933394562625097`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6029589463363911`, 7.501082124259871}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.3137523001849649, 8.290041618704489}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 2.4176979000945504`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.2909841813155656`, 1.4964931534179662`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 0.9991602096964498}], 6., 
            
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.795734531747094, 
             5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2595256035335987`, 5.521460917862246}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.4686200579795896`, 1.7817091333745536`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1806171127511105`, 1.7817091333745536`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.104394898075602, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-2.995732273553991, 5.991464547107982}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.522010001878903, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.6562368265398482, 6.674561391814426}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-1.0498221244986778`, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.6736487743848776`, 0.6951451832226183}], 6., 
            
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 1.669026703845758}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3082228256997352`, 7.295735072749282}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.5188771693591536`, 6.584791392385716}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.6916833814466705`, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-5.2030071867437115`, 1.7328937163610187`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520318812570019, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-1.741256487054948, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.035305048673814, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.8773173575897015`, 1.6114359150967734`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.2367852454117685`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.389499492068839, 5.991464547107982}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.991862608772972, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.7760829898430475`, 6.104793232414985}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.380218975276964, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 0.8060293376166178}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4405393759722864`, 5.940171252720432}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.5338519254775054`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.6609757937162812`, 4.969813299576001}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.017773404430871, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9840343839606746, 6.396929655216146}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.253208503948706, 1.7850704810772584`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6044503709230613`, 6.999422467507961}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820086052689358`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3082228256997352`, 7.295735072749282}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.6354040111173562`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.802272141469027, 1.4951487660319727`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5188771693591536`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3055896020143445`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.808498793232353, 7.295735072749282}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.66442222076686, 6.939253946041508}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-8.162319869424133, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.399798360748448, 1.7833912195575383`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.3082536360194172`, 1.4929040961781488`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-7.1308988302963465`, 1.7328937163610187`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.380218975276964, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.263088979544526, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.252691173362931, 1.6974487897568136`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.3109197297841035`, 4.969813299576001}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.946310229076653, 7.157735484249907}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.064355904261795, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8799351601317804`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.327296573822621, 1.7850704810772584`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             2.0680013515372804`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.4722426732562555`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.319222734147069, 6.784457062637643}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.2672179491567546`, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.868484703413663, 1.501852701754163}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.3257638613798584`, 1.776645831418007}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.9518038754399907`, 1.4973884086254774`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.66442222076686, 6.939253946041508}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.7148128361404407`, 1.4996230464268938`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.7672619976276676`, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.66873333872526, 5.111987788356544}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.781788039865368, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.781788039865368, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-3.700547258981618, 4.386889790339869}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.7479817218821596`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.896419739771488}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.235513466021224, 5.768320995793772}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.359436906950008}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.376740148315079, 7.226936018493289}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.666335489679042, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.9540431322855023`, 5.676753802268282}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.4679383501604009`, 1.7833912195575383`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 1.416581053724763}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.406905315024015, 7.697121317282625}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.5338519254775054`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.9299445330159877`, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.725971728690052, 6.104793232414985}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.491654876777717, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640797356921787`, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820086052689358`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.3540294005326152`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.6661962462527091`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.336815122732887, 1.6974487897568136`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7389772837890856`, 7.365180126021013}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.6298561136644754`, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2496677635880655`, 6.131226489483141}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.421604191439818, 1.6956156086751528`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.9093711079059474`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.8122154777954373`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.9405834244431995, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.7963700817857382`, 6.907755278982137}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.95263269481614, 7.151485463904735}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.327853987437946, 1.6034198401085373`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6734432424100127`, 1.691939133945844}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.3998672158005996`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.604906020337758, 1.601405740736836}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2016421889876536`, 6.579251212010101}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.417771502803163, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.57270299585059, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4714166145367258`, 7.6324011266014535`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.9353900445478294`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9317114296555002`, 1.534714366238164}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-1.2669126040998102`, 
             4.386889790339869}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 1.416581053724763}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.5645401798583287`, 1.6956156086751528`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.6302332586812027`, 1.4951487660319727`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.4971646699513146`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.5159350591325786`, 1.6034198401085373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6115589009134488`, 6.492239835020471}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.0939462278827174`, 5.537334267018537}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.989444152396731, 1.5107219394949427`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.2072749131897207`, 6.396929655216146}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1821389399181785`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-1.491654876777717, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 0.9566646260124284}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.741858378904823, 1.6034198401085373`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.4370318346713713`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706800981701778, 6.396929655216146}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4524341636244356`, 7.151485463904735}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-8.036311444023319, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.6777417097034806`, 1.601405740736836}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6044503709230613`, 6.999422467507961}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-7.536426440357718, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.541256860244439, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.6661962462527091`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-4.0757190980989355`, 1.4996230464268938`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 2.187398683184928}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.872802292274865, 1.601405740736836}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6702500518308578`, 7.433666540166168}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9065879564127699, 7.697121317282625}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.5332441625824873`, 1.4951487660319727`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 1.0497721232486361`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-7.786268646522262, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.424056675808238, 1.4951487660319727`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316692464055834`, 6.672032945461067}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.140807436632442, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.7937956240634962`, 1.6114359150967734`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 1.5377270648801}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.7406415980494447`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.395911377232918, 5.991464547107982}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6798603767306461`, 7.424165281042028}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.5774997570339834, 8.026170194946426}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.9405834244431995, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-1.369240606554063, 1.691939133945844}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0189110419398038`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.696151689580244, 6.684611727667927}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.4929837772928636`, 1.6974487897568136`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.4420193761824103`, 
             3.2386784521643803`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.360956006320375, 4.969813299576001}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.618595850218866}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3082228256997352`, 7.295735072749282}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.416204086475468, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6029589463363911`, 7.501082124259871}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.9178457348969196`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.6240307955986357`, 6.429719478039138}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-7.662352421858305, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.66442222076686, 6.939253946041508}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.803865056899991, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-7.912330925723864, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2072749131897207`, 6.396929655216146}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5901256014017275`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.362224007377702, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.9368694044031642`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.5404260935422814, 8.063377822367027}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.51624397679369, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.57270299585059, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.5260163042950279`, 6.104793232414985}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.25165731439258, 5.8522024797744745`}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6044503709230613`, 6.999422467507961}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.020229905154391, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.319222734147069, 6.784457062637643}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.491654876777717, 1.6661962462527091`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.3799147541558516`, 7.22402480828583}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.4569857892424236`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.9317114296555002`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7625890919282752`, 6.841615476477592}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7897614665653818`, 5.991464547107982}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.6311724045801064`, 1.4883995840570443`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.564942672547549, 5.966146739123692}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2069773133462347`, 6.173786103901937}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6426838976709575`, 5.961005339623274}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.5366522427084526`, 7.56734567601324}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.552112845814831, 5.8289456176102075`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.5077842587076005`, 5.823045895483019}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.7218733417638885`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.4890765557629164`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.3261404383001434`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.527397202097891, 7.076653815443951}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 2.209811692841691}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2437536743377806`, 7.360103972989152}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.5554040239416147`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.5338519254775054`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.0128784323889617`, 
             5.5909869805108565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.4138711288901251`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8799351601317804`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.3149043650332175`, 5.966146739123692}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5188771693591536`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.016955910005618, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.860379772276308, 5.393627546352362}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1270117631898076`, 6.253828811575473}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.266384064447333}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5191402744533198`, 1.6882490928583902`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.376740148315079, 7.226936018493289}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7573580425107227`, 1.589235205116581}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.9782390361706734`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.3540294005326152`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 6.999422467507961}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.8179208722379223`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1821389399181785`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.0498221244986778`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.15218556191195, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-7.540748536722336, 
             4.512945241945574}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.8140100781628747`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4316692464055834`, 6.672032945461067}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.5177604746590787`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.4961092271270973`, 6.907755278982137}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3093333199837622`, 7.294377299288821}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3838972365201692`, 6.396929655216146}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.5978370007556204, 1.5338519254775054`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.016955910005618, 6.0867747269123065`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.719252778441307, 6.684611727667927}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.631089159966082, 0.9034081060431414}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132468797127462, 5.971261839790462}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4524341636244356`, 7.151485463904735}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.3434070875143007`, 5.537334267018537}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 1.406587064387653}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.987774353154012, 5.393627546352362}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.941966881801218, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8470607850131444`, 6.756932389247553}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.2319770007355333`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7533219035960154, 8.350429973538136}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.8078888511579385`, 5.823045895483019}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.741256487054948, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.9093711079059474`, 6.194405391104672}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520318812570019, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.362224007377702, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.860379772276308, 5.393627546352362}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.6444188813293459`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.7630345094349695`, 5.840641657373398}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3093333199837622`, 7.294377299288821}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.8056623743970464`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164563795096671, 6.939253946041508}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.7317869551252127`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.0738571633859353`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.016955910005618, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 2.078566158643882}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.8470364847178946`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2815740503494875`, 7.822444729489319}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.0498221244986778`, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.7147984280919266`, 1.2319770007355333`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.5732134108799993`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2201021862558195`, 
             7.8838232148921525`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.7406415980494447`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.466278187121473, 4.787491742782046}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.3025850929940455`, 6.684611727667927}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0129050178795915`, 5.768320995793772}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7170231231140378`, 6.063785208687608}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.2919836816486494`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.1715568305876416`, 
             1.6675181235106251`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.56019682034536, 4.0943445622221}], 4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.9205497887945385, 6.960347729101308}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.9105241293044104`, 5.393627546352362}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.1541650878757723`, 5.676753802268282}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 1.416581053724763}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7625890919282752`, 6.841615476477592}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.706800981701778, 6.396929655216146}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.178596114669692, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.491654876777717, 1.0360274134764884`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.5832829549572491`, 1.5933085305042167`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4179914478631452`, 6.363028103540465}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.4958211856471328`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3799147541558516`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3037931396081468`, 6.476972362889683}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.981226494182881, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.6100682736896466`, 5.393627546352362}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.617843933216061, 4.512945241945574}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.978697138696139, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8195418502405067`, 6.784457062637643}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8951219822232084`, 5.886104031450156}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.5978370007556204, 1.599387576580599}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.8958869385842747`, 
             5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.168928708181372, 5.111987788356544}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.7177975525570903`, 4.512945241945574}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.7406415980494447`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.715777948205427}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.721515815839451}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.59947470469731, 8.004365564979574}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.522010001878903, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.132468797127462, 5.971261839790462}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-4.15218556191195, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.2909841813155656`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.9910142780700916, 7.6128310304073565`}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.808498793232353, 7.295735072749282}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5082360319251331`, 6.272877006546167}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3799147541558516`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.8122154777954373`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1150465951315345`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.9474803442248305`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.269150316907808, 5.111987788356544}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-0.7985076962177716, 1.6661962462527091`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.6287255312941893`, 5.075173815233827}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.606941032235513, 6.173786103901937}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.25165731439258, 5.8522024797744745`}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.804781390061982, 6.298949246855942}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 0.8450095298691913}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2201021862558195`, 
             7.8838232148921525`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-7.957577403480815, 1.445270566220188}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.809109107563168, 1.4951487660319727`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.795734531747094, 5.991464547107982}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.946310229076653, 7.157735484249907}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.941966881801218, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.219163484854973, 5.111987788356544}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8997902134417601`, 6.704414354964107}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.9146052992269007`, 5.966146739123692}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.3865452232556535, 7.24422751560335}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.527397202097891, 7.076653815443951}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-3.6888794541139363`, 2.3933394562625097`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.2669476034873244`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.664950622364359, 5.966146739123692}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9896682016789307, 6.7912214627261855`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.987774353154012, 5.393627546352362}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 
             1.2756420910162956`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.4528616053920038`, 7.600902459542082}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.5845302767279155`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.516892795645856, 6.0867747269123065`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.2919836816486494`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.2045513527226803`, 5.676753802268282}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.6744763086133228`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-6.03270329512458, 1.7328937163610187`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.706800981701778, 6.396929655216146}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.0794415416798357`, 2.187398683184928}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.2909841813155656`, 1.599387576580599}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8470607850131444`, 6.756932389247553}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.236923904465622}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.5902550930173265`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.7147984280919266`, 1.0845133642886082`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6798603767306461`, 7.424165281042028}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.862757913051401}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.2262184132732556`, 7.3777589082278725`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4524341636244356`, 7.151485463904735}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5082360319251331`, 6.272877006546167}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 0.9329511727672622}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4460443655256647`, 7.157735484249907}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.386702935511703, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8470607850131444`, 6.756932389247553}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3037931396081468`, 6.476972362889683}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.340512168464763}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5901256014017275`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.7188583998188136`, 5.111987788356544}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.2787091504399533`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.8162894669713328`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.2855499581361935`, 5.768320995793772}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.3964921860963366`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.793961892783255, 5.537334267018537}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-4.8283137373023015`, 1.7328937163610187`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.1850957485562468`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2808538486618937`, 6.249975242259483}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.744112815760702, 7.360103972989152}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-2.659260036932778, 1.007592890280941}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2595256035335987`, 5.521460917862246}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.198225077669803, 1.1921026317554486`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             1.2299329059954676`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7389772837890856`, 7.365180126021013}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.5878700408461053`, 5.19295685089021}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 1.0360274134764884`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-4.3428059215206005`, 
             3.2386784521643803`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.6761120457020933`, 6.104793232414985}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.953887209526845, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.4532518292447716`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.8805331812814825`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-3.7317869551252127`, 4.386889790339869}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.3649243353836982`, 5.966146739123692}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.7969533492855345, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7389772837890856`, 7.365180126021013}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.0776338822829181`, 8.026170194946426}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.132468797127462, 5.971261839790462}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.1464364105041143`, 6.907755278982137}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.4240364936935998, 8.1797604936999}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9712750402069146, 
             7.6324011266014535`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 1.599387576580599}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262403303361214, 6.841615476477592}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.0029385385998273`, 7.600902459542082}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.2919836816486494`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.5732134108799993`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-2.3025850929940455`, 
             0.9411784473819341}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8457617469776957`, 5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 1.7268653293100646`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.5978370007556204, 1.6661962462527091`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.266384064447333}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.4588475538015993`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.835485924411894, 5.768320995793772}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.25165731439258, 5.8522024797744745`}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.3811078344325904`, 6.249975242259483}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.2926347621408776`, 1.1167795926235586`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 1.68510181635509}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-2.795734531747094, 
             5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.8706006059570394, 7.783224016336037}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5352740571517867`, 6.068425588244111}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.8866985125298688`, 5.717027701406222}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.4286713586629105`, 5.075173815233827}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.5787702314339063`, 5.075173815233827}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.380218975276964, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.6324790142551358`, 5.971261839790462}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.2864827918762988, 7.24422751560335}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6820086052689358`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.322289031143978}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4007990473227723`, 6.380122536899765}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-0.7985076962177716, 1.6661962462527091`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.9317114296555002`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.606235808570649, 6.674561391814426}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.5432981099295553`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledCircle]", {-0.7985076962177716, 1.599387576580599}],
             3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.096384262410148, 6.907755278982137}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7985076962177716, 1.144222799920162}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.1236024374656055`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.4809943129680847`, 6.62273632394984}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6149530931222105`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-4.196377287787253, 0.8060293376166178}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.8470607850131444`, 6.756932389247553}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 1.9572739077056285`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.5539252025038417`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.204382667431038, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1663559407546291`, 6.214608098422191}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.9317114296555002`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346745988779815, 6.756932389247553}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.191191469961203}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.3281354469463584`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346745988779815, 6.756932389247553}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1026203100656484`, 7.501082124259871}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.554477071672573, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.95263269481614, 7.151485463904735}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.6311724045801064`, 6.249975242259483}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3005870903313728`, 5.480638923341991}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.164563795096671, 6.939253946041508}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3993162819538174`, 6.704414354964107}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.599387576580599}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.3162388941358785`, 4.787491742782046}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8470607850131444`, 6.756932389247553}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0592954262911594`, 6.721425700790643}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.064355904261795, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3047875165492457`, 6.298949246855942}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.1406850650900175`, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.5978370007556204, 1.599387576580599}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.5082360319251331`, 6.272877006546167}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-6.571283042360924, 2.0471765810925606`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 1.0598714603516792`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316692464055834`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.4226262903672808`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.1743805849816495`, 5.429345628954441}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 0.766397642299538}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-5.740861482897622, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.527397202097891, 7.076653815443951}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1593181637855046`, 7.944492163932159}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8097197946050478`, 7.294377299288821}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6044503709230613`, 6.999422467507961}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8097197946050478`, 7.294377299288821}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.020229905154391, 5.583496308781699}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.340556469446037, 6.040254711277414}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2815740503494875`, 7.822444729489319}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.6115589009134488`, 6.492239835020471}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 0.7975071958841882}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.491654876777717, 0.9290095042819297}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.2406367886975274`, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5173146235582946`, 7.086737934510577}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.154094566627875, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6702500518308578`, 7.433666540166168}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.4122057429043917`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.1966460289394751`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0272286702329017`, 7.076653815443951}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 1.4964931534179662`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.659260036932778, 1.4722426732562555`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.8610265707016995`, 4.969813299576001}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346745988779815, 6.756932389247553}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.8457617469776957`, 5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.0580715159436433`, 5.823045895483019}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.101092789211817, 0.911479174876933}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 1.9510398268753117`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.834634353211663, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.2917089186300228`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5366522427084526`, 7.56734567601324}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.744112815760702, 7.360103972989152}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 0.898534010284896}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-7.957577403480815, 0.8046885552928528}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.238564249095555, 7.365180126021013}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6029589463363911`, 7.501082124259871}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[Times]", {-2.1413169453979233`, 4.512945241945574}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.319222734147069, 6.784457062637643}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6149530931222105`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640797356921787`, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.25165731439258, 5.8522024797744745`}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8799351601317804`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0189110419398038`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.744112815760702, 7.360103972989152}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.1603343472961065`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1702157075278026`, 7.433666540166168}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.111964733385396, 6.492239835020471}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-2.0794415416798357`, 1.266384064447333}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6149530931222105`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2909841813155656`, 
             1.0289048762432895`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2282654968949804`, 6.152732694704104}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.2319770007355333`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.378751192832325, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7625890919282752`, 6.841615476477592}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.340556469446037, 6.040254711277414}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 1.0654001544619962`}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.659260036932778, 1.416581053724763}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.178596114669692, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.036482917202561, 7.56734567601324}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.2246985543369746`, 6.429719478039138}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-2.5232317641096684`, 5.2574953720277815`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.5960282255241827`, 6.907755278982137}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2437536743377806`, 7.360103972989152}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.238564249095555, 7.365180126021013}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.5338519254775054`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-0.7985076962177716, 1.599387576580599}],
             5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.101092789211817, 0.7802418874108791}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9065879564127699, 7.697121317282625}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7625890919282752`, 6.841615476477592}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.406905315024015, 7.697121317282625}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.8871696540327132`, 5.393627546352362}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.7199019178687649, 7.8838232148921525`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2016421889876536`, 6.579251212010101}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 0.9345235001352147}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.557794679282262, 5.823045895483019}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.2809338454620642`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.742969305058623, 0.8028980445190645}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0898959995836948`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-6.214608098422191, 2.3933394562625097`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.4722426732562555`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0272286702329017`, 7.076653815443951}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.740780025725129, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.710307401527557, 5.393627546352362}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.6704076935904559, 6.960347729101308}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-3.1958919884778254`, 
             5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8773173575897015`, 7.226936018493289}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.531088946023124, 6.249975242259483}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.030860186617291, 6.249975242259483}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-5.298317366548036, 2.6490076604684267`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-1.9661128563728327`, 2.0215475632609334`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.804781390061982, 6.298949246855942}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1080567474961094`, 6.272877006546167}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-1.9661128563728327`, 1.0845133642886082`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.023439351564551, 5.2574953720277815`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.3907040696085906`, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 1.0360274134764884`}],
             5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.6486027424587903`, 6.455198563340122}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.659260036932778, 1.4722426732562555`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.3871630694693433`, 5.393627546352362}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.2319770007355333`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.9372477759766606`, 5.393627546352362}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.0808706071919527`, 6.249975242259483}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.5703987153008919, 6.960347729101308}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 
             1.1499389158334503`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.344384958042681, 7.759614150696903}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5366522427084526`, 7.56734567601324}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.6593256320844346, 7.944492163932159}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-4.3428059215206005`, 2.6490076604684267`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.346745988779815, 6.756932389247553}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.2936253516225737`, 5.537334267018537}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5188771693591536`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.991464547107982, 1.445270566220188}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-6.214608098422191, 1.6094379124341003`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.5640797356921787`, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             1.5532907518110994`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-3.1958919884778254`, 
             5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.334591889129132, 6.269096283706261}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.25165731439258, 5.8522024797744745`}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820086052689358`, 6.921658184151129}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6044503709230613`, 6.999422467507961}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.064355904261795, 6.539585955617669}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 1.0360274134764884`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             0.8055826098897335}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-1.0969137320325284`, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-8.622553707074063, 0.973049065692764}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.0498221244986778`, 1.018486244188825}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-8.532306829226286, 1.2424239907001886`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.9969586349416099, 6.5337888379333435`}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.157075423962754, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.017406150760383, 7.086737934510577}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-3.1958919884778254`, 5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.8130574772325029, 6.81783057145415}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6702500518308578`, 7.433666540166168}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4714166145367258`, 
             7.6324011266014535`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.2815740503494875`, 7.822444729489319}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             0.9364854391596744}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4405393759722864`, 5.940171252720432}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.552112845814831, 7.55171221535131}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4460443655256647`, 7.157735484249907}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.2739976361421332`, 6.429719478039138}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.12893600699172, 5.075173815233827}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9712750402069146, 7.6324011266014535`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.3993162819538174`, 6.704414354964107}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316692464055834`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0826466726287842`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4390923376487086`, 4.941642422609304}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.659260036932778, 1.1637756145745228`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.2919836816486494`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1796054478776414`, 7.424165281042028}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 1.421661504957182}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.9286606465811693`, 5.075173815233827}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.1760334356366946`, 6.104793232414985}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.6888794541139363`, 5.298317366548036}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             1.0678093795130645`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.751531979714171, 5.8522024797744745`}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7389772837890856`, 7.365180126021013}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5188771693591536`, 6.584791392385716}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.563430511492267, 6.040254711277414}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             1.1990607599649155`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4092798316650086`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6798603767306461`, 7.424165281042028}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.808498793232353, 7.295735072749282}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-1.742969305058623, 0.8060293376166178}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.808498793232353, 7.295735072749282}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6702500518308578`, 7.433666540166168}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.174191878225647, 6.429719478039138}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.593338543970313, 4.787491742782046}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.6569932652516144`, 5.44673737166631}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 0.766397642299538}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.5257286443082556`, 
             1.3302529702362658`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2736802167507564`, 6.507277712385012}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyCircle]", {-3.101092789211817, 0.8060293376166178}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.283414346005772, 5.703782474656201}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.7129418078881248, 6.81783057145415}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.880084850028029, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 6.999422467507961}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             1.2908841763152323`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8734707346912269, 6.507277712385012}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.659260036932778, 1.0845133642886082`}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.674083651538937, 6.429719478039138}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.0845133642886082`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.1637756145745228`}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6029589463363911`, 7.501082124259871}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.95263269481614, 7.151485463904735}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.380218975276964, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-3.1958919884778254`, 
             5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.839070463540614, 4.941642422609304}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.145857732131629, 5.991464547107982}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.262403303361214, 6.841615476477592}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.0794415416798357`, 6.907755278982137}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             0.8977193462887197}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             1.1597073880279205`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.000759888500605, 6.380122536899765}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1026203100656484`, 7.501082124259871}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.6960857191597725`, 6.907755278982137}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8097197946050478`, 7.294377299288821}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.504420282887948, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.8799351601317804`, 7.22402480828583}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledSquare]", {-2.3025850929940455`, 1.1637756145745228`}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0794415416798357`, 
             1.0281898243715637`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8773173575897015`, 7.226936018493289}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-3.2602187884025833`, 5.393627546352362}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4912105310694506`, 
             7.6128310304073565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.335971596744448, 5.267858159063328}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.5366522427084526`, 7.56734567601324}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820086052689358`, 6.921658184151129}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.8344641259578687`, 6.152732694704104}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.527397202097891, 7.076653815443951}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyUpTriangle]", {-1.05211045501669, 7.55171221535131}],
             5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.9563317814113389, 6.674561391814426}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.7056031974591583`, 5.075173815233827}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.380218975276964, 5.723585101952381}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8016236568960291, 6.579251212010101}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.808498793232353, 7.295735072749282}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.527397202097891, 7.076653815443951}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1702157075278026`, 7.433666540166168}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1796054478776414`, 7.424165281042028}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4714166145367258`, 7.6324011266014535`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.5136732904497212`, 7.090076835776092}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2201021862558195`, 7.8838232148921525`}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.403677882205863, 1.445270566220188}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520318812570019, 5.583496308781699}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.636577829072051, 7.24422751560335}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.4316692464055834`, 6.672032945461067}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-2.4371455863897404`, 5.393627546352362}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 1.0360274134764884`}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2815740503494875`, 7.822444729489319}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6029589463363911`, 7.501082124259871}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1026203100656484`, 7.501082124259871}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.5257286443082556`, 0.8060293376166178}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            
            Text[$CellContext`\[FivePointedStar], {-3.0957736277342174`, 
             5.991464547107982}], 5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.104554242494911, 6.999422467507961}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7625890919282752`, 6.841615476477592}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.6149530931222105`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.344384958042681, 7.759614150696903}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9240709191931175, 8.1797604936999}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6044503709230613`, 6.999422467507961}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.406905315024015, 7.697121317282625}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-2.945799904805782, 5.991464547107982}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-0.6474092888860916, 8.006367567650246}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.5257286443082556`, 6.461468176353717}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.8563722416629115, 6.674561391814426}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7199019178687649, 
             7.8838232148921525`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7813228714636707, 7.822444729489319}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.036482917202561, 7.56734567601324}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[CircleMinus]", {-4.3428059215206005`, 3.2386784521643803`}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1702157075278026`, 7.433666540166168}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 1.007592890280941}], 
            3.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4524341636244356`, 7.151485463904735}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.95263269481614, 7.151485463904735}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.4824297199131076`, 5.298317366548036}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.95263269481614, 7.151485463904735}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.036482917202561, 7.56734567601324}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.946310229076653, 7.157735484249907}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.8799351601317804`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.409603402444116, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.1093512670354135`, 4.0943445622221}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1150465951315345`, 7.488852955733459}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyCircle]", {-2.0794415416798357`, 0.8060293376166178}], 
            5.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262403303361214, 6.841615476477592}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.746969987257452, 6.5337888379333435`}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.0898959995836948`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7389772837890856`, 7.365180126021013}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.527397202097891, 7.076653815443951}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.2704687956143002`, 7.783224016336037}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.346745988779815, 6.756932389247553}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3082228256997352`, 7.295735072749282}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9093711079059474`, 6.194405391104672}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-3.512911371292157, 5.5909869805108565`}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1026203100656484`, 7.501082124259871}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.946310229076653, 7.157735484249907}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.000759888500605, 6.380122536899765}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.036482917202561, 7.56734567601324}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-8.047189562170502, 1.2424239907001886`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.3691523372661587`, 6.684611727667927}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-6.907755278982137, 0.8046885552928528}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-0.8906229851255774, 6.39024066706535}], 
            6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5901256014017275`, 7.013915474810528}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.3799147541558516`, 7.22402480828583}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-1.746403767507258, 6.907755278982137}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0272286702329017`, 7.076653815443951}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.6593256320844346, 6.721425700790643}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.4146938356415886`, 5.966146739123692}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.1821389399181785`, 6.921658184151129}],
             4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-2.262403303361214, 6.841615476477592}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3799147541558516`, 7.22402480828583}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.8097197946050478`, 7.294377299288821}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-5.744604469176456, 2.3933394562625097`}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4296194858582643`, 7.674152921281675}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1702157075278026`, 7.433666540166168}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.019664337643975, 6.684611727667927}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-3.520318812570019, 5.583496308781699}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3528595850336531`, 7.751045117971802}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4912105310694506`, 
             7.6128310304073565`}], 5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.5740001929819547`, 6.429719478039138}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3082228256997352`, 7.295735072749282}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptySquare]", {-1.0808706071919527`, 6.249975242259483}],
             6.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[FilledSquare]", {-3.045763207159556, 5.991464547107982}], 
            5., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.3137523001849649, 8.290041618704489}], 
            5.75, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9038682118755978, 6.476972362889683}],
             6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.380218975276964, 5.723585101952381}], 
            4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2069773133462347`, 6.173786103901937}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[EmptyDiamond]", {-1.238564249095555, 7.365180126021013}], 
            6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9712750402069146, 
             7.6324011266014535`}], 4.25, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.004138294335951, 4.499809670330265}], 
            4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-2.7499665442035015`, 6.253828811575473}],
             4.5, 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 6., 
            RGBColor[0.6, 0.6, 0.6]], 
           Style[
            Text["\[CircleMinus]", {-4.703886158927249, 4.499809670330265}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4524341636244356`, 7.151485463904735}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1026203100656484`, 7.501082124259871}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.696151689580244, 6.684611727667927}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.241489993634235, 6.363028103540465}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.017406150760383, 7.086737934510577}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-2.0272286702329017`, 7.076653815443951}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-2.66341149948383, 6.040254711277414}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-3.0635829404621653`, 6.040254711277414}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.7813228714636707, 7.822444729489319}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[CircleMinus]", {-1.0261055978813616`, 7.3777589082278725`}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-4.199705077879927, 4.787491742782046}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.527397202097891, 7.076653815443951}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9065879564127699, 7.697121317282625}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-4.266557384867768, 4.787491742782046}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-6.214608098422191, 2.0471765810925606`}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1026203100656484`, 7.501082124259871}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[FilledSquare]", {-3.145857732131629, 5.991464547107982}], 
            10., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6029589463363911`, 7.501082124259871}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.9904756300635316, 6.39024066706535}], 
            13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-2.9634587130036953`, 6.040254711277414}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9038682118755978, 6.476972362889683}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1150465951315345`, 7.488852955733459}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.104554242494911, 6.999422467507961}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.5366522427084526`, 7.56734567601324}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4524341636244356`, 7.151485463904735}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.7389772837890856`, 7.365180126021013}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.160913314865489, 6.620073206530356}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.8442026554799011, 7.759614150696903}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4714166145367258`, 7.6324011266014535`}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6702500518308578`, 7.433666540166168}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.4799159663735604`, 5.123963979403259}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-5.298317366548036, 2.6490076604684267`}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3799147541558516`, 7.22402480828583}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-2.7333680090865, 6.253828811575473}], 9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.406905315024015, 7.697121317282625}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.8442026554799011, 7.759614150696903}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-1.9696906777207166`, 6.684611727667927}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.344384958042681, 7.759614150696903}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9065879564127699, 7.697121317282625}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-1.0475390184841091`, 8.006367567650246}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1821389399181785`, 6.921658184151129}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0177699008240089`, 6.363028103540465}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.3137523001849649, 8.290041618704489}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.48175237628028356`, 
             8.122074375362217}], 8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-3.9165331609060323`, 4.787491742782046}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2815740503494875`, 7.822444729489319}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.2201021862558195`, 7.8838232148921525`}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.7389772837890856`, 7.365180126021013}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.49314943875304795`, 6.887552571664617}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.1821389399181785`, 6.921658184151129}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.3082228256997352`, 7.295735072749282}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.429964022323876, 6.173786103901937}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.2262184132732556`, 6.104793232414985}],
             13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0592954262911594`, 6.721425700790643}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.131032179924221, 6.249975242259483}], 
            13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6044503709230613`, 6.999422467507961}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-1.7031992922485748`, 7.600902459542082}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.238564249095555, 7.365180126021013}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.036482917202561, 7.56734567601324}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.813734143549063, 8.290041618704489}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.2330583852210326`, 
             7.8709295967551425`}], 11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.1702157075278026`, 7.433666540166168}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-3.520318812570019, 5.583496308781699}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.149006005065745, 6.455198563340122}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-1.5205117032396989`, 7.783224016336037}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.808498793232353, 7.295735072749282}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-3.8665717425242287`, 4.787491742782046}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-1.926205565780978, 7.3777589082278725`}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-2.613467558616262, 6.040254711277414}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.813734143549063, 8.290041618704489}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.344384958042681, 7.759614150696903}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.6745821494131117`, 5.429345628954441}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.9933351489542694`, 4.787491742782046}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1080567474961094`, 6.272877006546167}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-3.660097652688484, 5.393627546352362}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-2.104554242494911, 6.999422467507961}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.18777640747691846`, 7.1929342212158}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-0.6204544951665047, 7.783224016336037}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9712750402069146, 
             7.6324011266014535`}], 8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.2761851384398606`, 6.104793232414985}],
             13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-2.017406150760383, 7.086737934510577}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.247228312996893, 6.5337888379333435`}],
             13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8337895103624113, 6.946975992135418}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-7.1308988302963465`, 0.973049065692764}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.7813228714636707, 7.822444729489319}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.238564249095555, 7.365180126021013}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4524341636244356`, 7.151485463904735}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.406905315024015, 7.697121317282625}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-3.01348899514325, 6.040254711277414}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-7.600902459542082, 1.6094379124341003`}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.5173146235582946`, 7.086737934510577}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.376740148315079, 7.226936018493289}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6702500518308578`, 7.433666540166168}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-0.8029620465671519, 7.600902459542082}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.8799351601317804`, 7.22402480828583}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-2.0272286702329017`, 7.076653815443951}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-2.3191210616341453`, 6.684611727667927}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.813734143549063, 8.290041618704489}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.5366522427084526`, 7.56734567601324}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.7607838292757566, 6.620073206530356}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.1150465951315345`, 7.488852955733459}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.95263269481614, 7.151485463904735}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.9910142780700916, 7.6128310304073565`}],
             11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.4714166145367258`, 
             7.6324011266014535`}], 8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8442026554799011, 7.759614150696903}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-1.6029589463363911`, 7.501082124259871}],
             8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.8205261098897758, 6.960347729101308}], 
            13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-2.449925680892755, 6.253828811575473}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.3093333199837622`, 7.294377299288821}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-1.4460443655256647`, 7.157735484249907}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1080567474961094`, 6.272877006546167}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.0963149296194261`, 6.684611727667927}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.3799147541558516`, 7.22402480828583}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.3137523001849649, 8.290041618704489}], 
            11.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-5.009386074695824, 4.0943445622221}], 9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.4203757208439185, 6.960347729101308}], 
            13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-8.94874563428772, 0.973049065692764}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-1.1062413158326008`, 6.674561391814426}],
             13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.4338645826298623, 6.946975992135418}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[FilledUpTriangle]", {-0.9816295731824954, 8.122074375362217}], 
            8.5, 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.606746624575414, 4.997212273764115}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-9.567158183262826, 0.8046885552928528}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.9631203192309531, 6.81783057145415}], 
            13., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9065879564127699, 7.697121317282625}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6820086052689358`, 6.921658184151129}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.8359883191521487`, 5.267858159063328}], 
            12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-5.744604469176456, 2.0471765810925606`}],
             9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8933068954837797, 6.887552571664617}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[CircleMinus]", {-4.216512196196308, 4.787491742782046}], 
            9., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.3960099493374092, 6.984716320118266}],
             12., 
            RGBColor[0.75, 0.55, 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3082228256997352`, 7.295735072749282}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[CircleMinus]", {-7.600902459542082, 0.973049065692764}], 
            9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9712750402069146, 7.6324011266014535`}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.6593256320844346, 6.721425700790643}],
             12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.9296292963133357, 7.674152921281675}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[CircleMinus]", {-6.607650686531799, 1.445270566220188}], 
            9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[CircleMinus]", {-4.509860006183766, 4.0943445622221}], 9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[CircleMinus]", {-6.437751649736401, 0.973049065692764}], 
            9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[CircleMinus]", {-4.605170185988091, 2.9290581402859983`}],
             9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.036482917202561, 7.56734567601324}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[CircleMinus]", {-5.2030071867437115`, 2.3933394562625097`}], 
            9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[CircleMinus]", {-7.1308988302963465`, 1.2424239907001886`}], 
            9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.6044503709230613`, 6.999422467507961}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.7199019178687649, 7.8838232148921525`}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.238564249095555, 7.365180126021013}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.527397202097891, 7.076653815443951}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1026203100656484`, 7.501082124259871}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.3082228256997352`, 7.295735072749282}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.238564249095555, 7.365180126021013}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.4524341636244356`, 7.151485463904735}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.3799147541558516`, 7.22402480828583}],
             12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1702157075278026`, 7.433666540166168}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-3.752032269119205, 4.852030263919617}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[FilledCircle]", {-1.984131361875511, 7.003065458786462}], 
            7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.23395175003081314`, 7.146772179452637}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.7813228714636707, 7.822444729489319}],
             12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.5629964960949002, 6.81783057145415}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1702157075278026`, 7.433666540166168}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8442026554799011, 7.759614150696903}],
             12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-3.9797666575146655`, 5.123963979403259}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-1.1026203100656484`, 7.501082124259871}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.9065879564127699, 7.697121317282625}],
             12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.8528465593176202, 7.751045117971802}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9712750402069146, 7.6324011266014535`}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-1.036482917202561, 7.56734567601324}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.7960662345677868, 6.984716320118266}],
             12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[CircleMinus]", {-8.11206147220931, 0.973049065692764}], 
            9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.5895081458004594, 6.7912214627261855`}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.5878866699024524, 7.1929342212158}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[CircleMinus]", {-6.571283042360924, 1.7328937163610187`}],
             9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-4.1068220837332134`, 4.997212273764115}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[CircleMinus]", {-4.909388227079972, 4.0943445622221}], 9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyUpTriangle]", {-0.7329280505717899, 7.8709295967551425`}],
             11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptySquare]", {-0.7062324201086008, 6.674561391814426}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.3025850929940455`, 6.684611727667927}], 
            7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.6339353209280992, 7.146772179452637}],
             12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-0.8830977645183911, 6.897704943128636}],
             12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[CircleMinus]", {-4.609379030762146, 4.0943445622221}], 9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[FilledCircle]", {-2.6772785424354564`, 6.309918278226516}], 
            7.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[EmptyDiamond]", {-4.251700372998307, 4.852030263919617}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.9896682016789307, 6.7912214627261855`}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptySquare]", {-0.8469979053782056, 6.5337888379333435`}], 
            13., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[CircleMinus]", {-7.1308988302963465`, 1.445270566220188}],
             9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDiamond]", {-0.48304834276654407`, 6.897704943128636}], 
            12., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[CircleMinus]", {-7.600902459542082, 1.445270566220188}], 
            9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[CircleMinus]", {-7.600902459542082, 1.2424239907001886`}],
             9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[CircleMinus]", {-6.214608098422191, 2.0471765810925606`}],
             9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[CircleMinus]", {-5.744604469176456, 1.7328937163610187`}],
             9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.529318843261892, 
             1.9033008439609624`}], 11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-6.878196476740593, 
             1.7776605448485534`}], 11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-7.284632930238389, 
             1.6094379124341003`}], 11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-7.523941418405954, 1.497835735852798}], 
            11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text["\[CircleMinus]", {-8.622553707074063, 0.8046885552928528}], 
            9., 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-7.819058469345253, 
             1.3540294005326152`}], 11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-8.05031945517943, 1.2424239907001886`}],
             11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-8.403864506109235, 
             1.0698698198024557`}], 11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-8.685611843041201, 0.9360933591703348}],
             11.5, 
            RGBColor[0.7, 0., 0.]], 
           Style[
            Text[
            "\[EmptyDownTriangle]", {-8.955698153602603, 0.8046885552928528}],
             11.5, 
            RGBColor[0.7, 0., 0.]]}}, {
         Frame -> True, 
          FrameTicks -> {{{-13.815510557964274`, 
              "\!\(\*SuperscriptBox[\(10\), \(-6\)]\)", {0.02, 
              0.}}, {-13.122363377404328`, "", {
              0.01, 0}}, {-12.716898269296165`, "", {
              0.01, 0}}, {-12.429216196844383`, "", {
              0.01, 0}}, {-12.206072645530174`, "", {
              0.01, 0}}, {-12.02375108873622, "", {
              0.01, 0}}, {-11.86960040890896, "", {
              0.01, 0}}, {-11.736069016284437`, "", {
              0.01, 0}}, {-11.618285980628055`, "", {
              0.01, 0}}, {-11.512925464970229`, 
              "\!\(\*SuperscriptBox[\(10\), \(-5\)]\)", {0.02, 
              0.}}, {-10.819778284410283`, "", {
              0.01, 0}}, {-10.414313176302118`, "", {
              0.01, 0}}, {-10.126631103850338`, "", {
              0.01, 0}}, {-9.903487552536127, "", {
              0.01, 0}}, {-9.721165995742174, "", {
              0.01, 0}}, {-9.567015315914915, "", {
              0.01, 0}}, {-9.433483923290392, "", {
              0.01, 0}}, {-9.315700887634009, "", {
              0.01, 0}}, {-9.210340371976182, 
              "\!\(\*SuperscriptBox[\(10\), \(-4\)]\)", {0.02, 
              0.}}, {-8.517193191416238, "", {0.01, 0}}, {-8.111728083308073, 
              "", {0.01, 0}}, {-7.824046010856292, "", {
              0.01, 0}}, {-7.600902459542082, "", {
              0.01, 0}}, {-7.418580902748127, "", {
              0.01, 0}}, {-7.264430222920869, "", {
              0.01, 0}}, {-7.1308988302963465`, "", {
              0.01, 0}}, {-7.013115794639964, "", {
              0.01, 0}}, {-6.907755278982137, 
              "\!\(\*SuperscriptBox[\(10\), \(-3\)]\)", {0.02, 
              0.}}, {-6.214608098422191, "", {0.01, 0}}, {-5.809142990314028, 
              "", {0.01, 0}}, {-5.521460917862246, "", {
              0.01, 0}}, {-5.298317366548036, "", {
              0.01, 0}}, {-5.115995809754082, "", {
              0.01, 0}}, {-4.961845129926823, "", {
              0.01, 0}}, {-4.8283137373023015`, "", {
              0.01, 0}}, {-4.710530701645918, "", {
              0.01, 0}}, {-4.605170185988091, 
              "\!\(\*SuperscriptBox[\(10\), \(-2\)]\)", {0.02, 
              0.}}, {-3.912023005428146, "", {0.01, 0}}, {-3.506557897319982, 
              "", {0.01, 0}}, {-3.2188758248682006`, "", {
              0.01, 0}}, {-2.995732273553991, "", {
              0.01, 0}}, {-2.8134107167600364`, "", {
              0.01, 0}}, {-2.659260036932778, "", {
              0.01, 0}}, {-2.5257286443082556`, "", {
              0.01, 0}}, {-2.4079456086518722`, "", {
              0.01, 0}}, {-2.3025850929940455`, 
              "\!\(\*SuperscriptBox[\(10\), \(-1\)]\)", {0.02, 
              0.}}, {-1.6094379124341003`, "", {
              0.01, 0}}, {-1.203972804325936, "", {
              0.01, 0}}, {-0.916290731874155, "", {
              0.01, 0}}, {-0.6931471805599453, "", {
              0.01, 0}}, {-0.5108256237659905, "", {
              0.01, 0}}, {-0.3566749439387323, "", {
              0.01, 0}}, {-0.2231435513142097, "", {
              0.01, 0}}, {-0.10536051565782628`, "", {0.01, 0}}, {
             0., "1", {0.02, 0.}}, {0.6931471805599453, "", {0.01, 0}}, {
             1.0986122886681098`, "", {0.01, 0}}, {
             1.3862943611198906`, "", {0.01, 0}}, {
             1.6094379124341003`, "", {0.01, 0}}, {
             1.791759469228055, "", {0.01, 0}}, {
             1.9459101490553132`, "", {0.01, 0}}, {
             2.0794415416798357`, "", {0.01, 0}}, {
             2.1972245773362196`, "", {0.01, 0}}, {
             2.302585092994046, "\!\(\*SuperscriptBox[\(10\), \(1\)]\)", {
              0.02, 0.}}, {2.995732273553991, "", {0.01, 0}}, {
             3.4011973816621555`, "", {0.01, 0}}, {
             3.6888794541139363`, "", {0.01, 0}}, {
             3.912023005428146, "", {0.01, 0}}, {
             4.0943445622221, "", {0.01, 0}}, {
             4.248495242049359, "", {0.01, 0}}, {
             4.382026634673881, "", {0.01, 0}}, {
             4.499809670330265, "", {0.01, 0}}, {
             4.605170185988092, "\!\(\*SuperscriptBox[\(10\), \(2\)]\)", {
              0.02, 0.}}, {5.298317366548036, "", {0.01, 0}}, {
             5.703782474656201, "", {0.01, 0}}, {
             5.991464547107982, "", {0.01, 0}}, {
             6.214608098422191, "", {0.01, 0}}, {
             6.396929655216146, "", {0.01, 0}}, {
             6.551080335043404, "", {0.01, 0}}, {
             6.684611727667927, "", {0.01, 0}}, {
             6.802394763324311, "", {0.01, 0}}, {
             6.907755278982137, "\!\(\*SuperscriptBox[\(10\), \(3\)]\)", {
              0.02, 0.}}, {7.600902459542082, "", {0.01, 0}}, {
             8.006367567650246, "", {0.01, 0}}, {
             8.294049640102028, "", {0.01, 0}}, {
             8.517193191416238, "", {0.01, 0}}, {
             8.699514748210191, "", {0.01, 0}}, {
             8.85366542803745, "", {0.01, 0}}, {
             8.987196820661973, "", {0.01, 0}}, {
             9.104979856318357, "", {0.01, 0}}, {
             9.210340371976184, "\!\(\*SuperscriptBox[\(10\), \(4\)]\)", {
              0.02, 0.}}, {9.903487552536127, "", {0.01, 0}}, {
             10.308952660644293`, "", {0.01, 0}}, {
             10.596634733096073`, "", {0.01, 0}}, {
             10.819778284410283`, "", {0.01, 0}}, {
             11.002099841204238`, "", {0.01, 0}}, {
             11.156250521031495`, "", {0.01, 0}}, {
             11.289781913656018`, "", {0.01, 0}}, {
             11.407564949312402`, "", {0.01, 0}}}, {{-13.815510557964274`, 
              "\!\(\*SuperscriptBox[\(10\), \(-6\)]\)", {0.02, 
              0.}}, {-13.122363377404328`, "", {
              0.01, 0}}, {-12.716898269296165`, "", {
              0.01, 0}}, {-12.429216196844383`, "", {
              0.01, 0}}, {-12.206072645530174`, "", {
              0.01, 0}}, {-12.02375108873622, "", {
              0.01, 0}}, {-11.86960040890896, "", {
              0.01, 0}}, {-11.736069016284437`, "", {
              0.01, 0}}, {-11.618285980628055`, "", {
              0.01, 0}}, {-11.512925464970229`, 
              "\!\(\*SuperscriptBox[\(10\), \(-5\)]\)", {0.02, 
              0.}}, {-10.819778284410283`, "", {
              0.01, 0}}, {-10.414313176302118`, "", {
              0.01, 0}}, {-10.126631103850338`, "", {
              0.01, 0}}, {-9.903487552536127, "", {
              0.01, 0}}, {-9.721165995742174, "", {
              0.01, 0}}, {-9.567015315914915, "", {
              0.01, 0}}, {-9.433483923290392, "", {
              0.01, 0}}, {-9.315700887634009, "", {
              0.01, 0}}, {-9.210340371976182, 
              "\!\(\*SuperscriptBox[\(10\), \(-4\)]\)", {0.02, 
              0.}}, {-8.517193191416238, "", {0.01, 0}}, {-8.111728083308073, 
              "", {0.01, 0}}, {-7.824046010856292, "", {
              0.01, 0}}, {-7.600902459542082, "", {
              0.01, 0}}, {-7.418580902748127, "", {
              0.01, 0}}, {-7.264430222920869, "", {
              0.01, 0}}, {-7.1308988302963465`, "", {
              0.01, 0}}, {-7.013115794639964, "", {
              0.01, 0}}, {-6.907755278982137, 
              "\!\(\*SuperscriptBox[\(10\), \(-3\)]\)", {0.02, 
              0.}}, {-6.214608098422191, "", {0.01, 0}}, {-5.809142990314028, 
              "", {0.01, 0}}, {-5.521460917862246, "", {
              0.01, 0}}, {-5.298317366548036, "", {
              0.01, 0}}, {-5.115995809754082, "", {
              0.01, 0}}, {-4.961845129926823, "", {
              0.01, 0}}, {-4.8283137373023015`, "", {
              0.01, 0}}, {-4.710530701645918, "", {
              0.01, 0}}, {-4.605170185988091, 
              "\!\(\*SuperscriptBox[\(10\), \(-2\)]\)", {0.02, 
              0.}}, {-3.912023005428146, "", {0.01, 0}}, {-3.506557897319982, 
              "", {0.01, 0}}, {-3.2188758248682006`, "", {
              0.01, 0}}, {-2.995732273553991, "", {
              0.01, 0}}, {-2.8134107167600364`, "", {
              0.01, 0}}, {-2.659260036932778, "", {
              0.01, 0}}, {-2.5257286443082556`, "", {
              0.01, 0}}, {-2.4079456086518722`, "", {
              0.01, 0}}, {-2.3025850929940455`, 
              "\!\(\*SuperscriptBox[\(10\), \(-1\)]\)", {0.02, 
              0.}}, {-1.6094379124341003`, "", {
              0.01, 0}}, {-1.203972804325936, "", {
              0.01, 0}}, {-0.916290731874155, "", {
              0.01, 0}}, {-0.6931471805599453, "", {
              0.01, 0}}, {-0.5108256237659905, "", {
              0.01, 0}}, {-0.3566749439387323, "", {
              0.01, 0}}, {-0.2231435513142097, "", {
              0.01, 0}}, {-0.10536051565782628`, "", {0.01, 0}}, {
             0., "1", {0.02, 0.}}, {0.6931471805599453, "", {0.01, 0}}, {
             1.0986122886681098`, "", {0.01, 0}}, {
             1.3862943611198906`, "", {0.01, 0}}, {
             1.6094379124341003`, "", {0.01, 0}}, {
             1.791759469228055, "", {0.01, 0}}, {
             1.9459101490553132`, "", {0.01, 0}}, {
             2.0794415416798357`, "", {0.01, 0}}, {
             2.1972245773362196`, "", {0.01, 0}}, {
             2.302585092994046, "\!\(\*SuperscriptBox[\(10\), \(1\)]\)", {
              0.02, 0.}}, {2.995732273553991, "", {0.01, 0}}, {
             3.4011973816621555`, "", {0.01, 0}}, {
             3.6888794541139363`, "", {0.01, 0}}, {
             3.912023005428146, "", {0.01, 0}}, {
             4.0943445622221, "", {0.01, 0}}, {
             4.248495242049359, "", {0.01, 0}}, {
             4.382026634673881, "", {0.01, 0}}, {
             4.499809670330265, "", {0.01, 0}}, {
             4.605170185988092, "\!\(\*SuperscriptBox[\(10\), \(2\)]\)", {
              0.02, 0.}}, {5.298317366548036, "", {0.01, 0}}, {
             5.703782474656201, "", {0.01, 0}}, {
             5.991464547107982, "", {0.01, 0}}, {
             6.214608098422191, "", {0.01, 0}}, {
             6.396929655216146, "", {0.01, 0}}, {
             6.551080335043404, "", {0.01, 0}}, {
             6.684611727667927, "", {0.01, 0}}, {
             6.802394763324311, "", {0.01, 0}}, {
             6.907755278982137, "\!\(\*SuperscriptBox[\(10\), \(3\)]\)", {
              0.02, 0.}}, {7.600902459542082, "", {0.01, 0}}, {
             8.006367567650246, "", {0.01, 0}}, {
             8.294049640102028, "", {0.01, 0}}, {
             8.517193191416238, "", {0.01, 0}}, {
             8.699514748210191, "", {0.01, 0}}, {
             8.85366542803745, "", {0.01, 0}}, {
             8.987196820661973, "", {0.01, 0}}, {
             9.104979856318357, "", {0.01, 0}}, {
             9.210340371976184, "\!\(\*SuperscriptBox[\(10\), \(4\)]\)", {
              0.02, 0.}}, {9.903487552536127, "", {0.01, 0}}, {
             10.308952660644293`, "", {0.01, 0}}, {
             10.596634733096073`, "", {0.01, 0}}, {
             10.819778284410283`, "", {0.01, 0}}, {
             11.002099841204238`, "", {0.01, 0}}, {
             11.156250521031495`, "", {0.01, 0}}, {
             11.289781913656018`, "", {0.01, 0}}, {
             11.407564949312402`, "", {0.01, 0}}}, {{-13.815510557964274`, 
              ""}, {-13.122363377404328`, ""}, {-12.716898269296165`, 
              ""}, {-12.429216196844383`, ""}, {-12.206072645530174`, 
              ""}, {-12.02375108873622, ""}, {-11.86960040890896, 
              ""}, {-11.736069016284437`, ""}, {-11.618285980628055`, 
              ""}, {-11.512925464970229`, ""}, {-10.819778284410283`, 
              ""}, {-10.414313176302118`, ""}, {-10.126631103850338`, 
              ""}, {-9.903487552536127, ""}, {-9.721165995742174, 
              ""}, {-9.567015315914915, ""}, {-9.433483923290392, 
              ""}, {-9.315700887634009, ""}, {-9.210340371976182, 
              ""}, {-8.517193191416238, ""}, {-8.111728083308073, 
              ""}, {-7.824046010856292, ""}, {-7.600902459542082, 
              ""}, {-7.418580902748127, ""}, {-7.264430222920869, 
              ""}, {-7.1308988302963465`, ""}, {-7.013115794639964, 
              ""}, {-6.907755278982137, ""}, {-6.214608098422191, 
              ""}, {-5.809142990314028, ""}, {-5.521460917862246, 
              ""}, {-5.298317366548036, ""}, {-5.115995809754082, 
              ""}, {-4.961845129926823, ""}, {-4.8283137373023015`, 
              ""}, {-4.710530701645918, ""}, {-4.605170185988091, 
              ""}, {-3.912023005428146, ""}, {-3.506557897319982, 
              ""}, {-3.2188758248682006`, ""}, {-2.995732273553991, 
              ""}, {-2.8134107167600364`, ""}, {-2.659260036932778, 
              ""}, {-2.5257286443082556`, ""}, {-2.4079456086518722`, 
              ""}, {-2.3025850929940455`, ""}, {-1.6094379124341003`, 
              ""}, {-1.203972804325936, ""}, {-0.916290731874155, 
              ""}, {-0.6931471805599453, ""}, {-0.5108256237659905, 
              ""}, {-0.3566749439387323, ""}, {-0.2231435513142097, 
              ""}, {-0.10536051565782628`, ""}, {0., ""}, {
             0.6931471805599453, ""}, {1.0986122886681098`, ""}, {
             1.3862943611198906`, ""}, {1.6094379124341003`, ""}, {
             1.791759469228055, ""}, {1.9459101490553132`, ""}, {
             2.0794415416798357`, ""}, {2.1972245773362196`, ""}, {
             2.302585092994046, ""}, {2.995732273553991, ""}, {
             3.4011973816621555`, ""}, {3.6888794541139363`, ""}, {
             3.912023005428146, ""}, {4.0943445622221, ""}, {
             4.248495242049359, ""}, {4.382026634673881, ""}, {
             4.499809670330265, ""}, {4.605170185988092, ""}, {
             5.298317366548036, ""}, {5.703782474656201, ""}, {
             5.991464547107982, ""}, {6.214608098422191, ""}, {
             6.396929655216146, ""}, {6.551080335043404, ""}, {
             6.684611727667927, ""}, {6.802394763324311, ""}, {
             6.907755278982137, ""}, {7.600902459542082, ""}, {
             8.006367567650246, ""}, {8.294049640102028, ""}, {
             8.517193191416238, ""}, {8.699514748210191, ""}, {
             8.85366542803745, ""}, {8.987196820661973, ""}, {
             9.104979856318357, ""}, {9.210340371976184, ""}, {
             9.903487552536127, ""}, {10.308952660644293`, ""}, {
             10.596634733096073`, ""}, {10.819778284410283`, ""}, {
             11.002099841204238`, ""}, {11.156250521031495`, ""}, {
             11.289781913656018`, ""}, {
             11.407564949312402`, ""}}, {{-13.815510557964274`, 
              ""}, {-13.122363377404328`, ""}, {-12.716898269296165`, 
              ""}, {-12.429216196844383`, ""}, {-12.206072645530174`, 
              ""}, {-12.02375108873622, ""}, {-11.86960040890896, 
              ""}, {-11.736069016284437`, ""}, {-11.618285980628055`, 
              ""}, {-11.512925464970229`, ""}, {-10.819778284410283`, 
              ""}, {-10.414313176302118`, ""}, {-10.126631103850338`, 
              ""}, {-9.903487552536127, ""}, {-9.721165995742174, 
              ""}, {-9.567015315914915, ""}, {-9.433483923290392, 
              ""}, {-9.315700887634009, ""}, {-9.210340371976182, 
              ""}, {-8.517193191416238, ""}, {-8.111728083308073, 
              ""}, {-7.824046010856292, ""}, {-7.600902459542082, 
              ""}, {-7.418580902748127, ""}, {-7.264430222920869, 
              ""}, {-7.1308988302963465`, ""}, {-7.013115794639964, 
              ""}, {-6.907755278982137, ""}, {-6.214608098422191, 
              ""}, {-5.809142990314028, ""}, {-5.521460917862246, 
              ""}, {-5.298317366548036, ""}, {-5.115995809754082, 
              ""}, {-4.961845129926823, ""}, {-4.8283137373023015`, 
              ""}, {-4.710530701645918, ""}, {-4.605170185988091, 
              ""}, {-3.912023005428146, ""}, {-3.506557897319982, 
              ""}, {-3.2188758248682006`, ""}, {-2.995732273553991, 
              ""}, {-2.8134107167600364`, ""}, {-2.659260036932778, 
              ""}, {-2.5257286443082556`, ""}, {-2.4079456086518722`, 
              ""}, {-2.3025850929940455`, ""}, {-1.6094379124341003`, 
              ""}, {-1.203972804325936, ""}, {-0.916290731874155, 
              ""}, {-0.6931471805599453, ""}, {-0.5108256237659905, 
              ""}, {-0.3566749439387323, ""}, {-0.2231435513142097, 
              ""}, {-0.10536051565782628`, ""}, {0., ""}, {
             0.6931471805599453, ""}, {1.0986122886681098`, ""}, {
             1.3862943611198906`, ""}, {1.6094379124341003`, ""}, {
             1.791759469228055, ""}, {1.9459101490553132`, ""}, {
             2.0794415416798357`, ""}, {2.1972245773362196`, ""}, {
             2.302585092994046, ""}, {2.995732273553991, ""}, {
             3.4011973816621555`, ""}, {3.6888794541139363`, ""}, {
             3.912023005428146, ""}, {4.0943445622221, ""}, {
             4.248495242049359, ""}, {4.382026634673881, ""}, {
             4.499809670330265, ""}, {4.605170185988092, ""}, {
             5.298317366548036, ""}, {5.703782474656201, ""}, {
             5.991464547107982, ""}, {6.214608098422191, ""}, {
             6.396929655216146, ""}, {6.551080335043404, ""}, {
             6.684611727667927, ""}, {6.802394763324311, ""}, {
             6.907755278982137, ""}, {7.600902459542082, ""}, {
             8.006367567650246, ""}, {8.294049640102028, ""}, {
             8.517193191416238, ""}, {8.699514748210191, ""}, {
             8.85366542803745, ""}, {8.987196820661973, ""}, {
             9.104979856318357, ""}, {9.210340371976184, ""}, {
             9.903487552536127, ""}, {10.308952660644293`, ""}, {
             10.596634733096073`, ""}, {10.819778284410283`, ""}, {
             11.002099841204238`, ""}, {11.156250521031495`, ""}, {
             11.289781913656018`, ""}, {11.407564949312402`, ""}}}, Axes -> 
          False, PlotLabel -> 
          Style["| Corr( g(x,\[Mu]), \!\(\*SubscriptBox[\(r\), \(i\)]\)) |, \
CT14NNLO", 24, 
            GrayLevel[0]], FrameLabel -> {
            Style["x", 18, 
             GrayLevel[0]], 
            Style["\[Mu] [GeV]", 18, 
             GrayLevel[0]]}, FrameTicksStyle -> GrayLevel[0], 
          ImageSize -> {{600}, {600}}, AspectRatio -> 1., 
          GridLines -> {{-16.11809565095832, -13.815510557964274`, \
-11.512925464970229`, -9.210340371976182, -6.907755278982137, \
-4.605170185988091, -2.3025850929940455`}, {
             Log[10], 
             Log[50], 
             Log[100], 
             Log[500], 
             Log[1000], 
             Log[5000], 
             Log[10000]}}, GridLinesStyle -> Directive[
            Dashing[{Small, Small}]], PlotRangeClipping -> True, 
          DisplayFunction -> Identity, PlotRangePadding -> {{0, 0}, {0, 0}}, 
          AxesOrigin -> {0, 0}, PlotRange -> {{-Log[100000], 0}, {0, 
             Log[6000]}}, PlotRangeClipping -> True, ImagePadding -> All, 
          DisplayFunction -> Identity, AspectRatio -> 1, Axes -> {True, True},
           AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
          Identity, Epilog -> {{
             Text[
              Style["Npt: 3920", 16, 
               GrayLevel[0]], 
              Scaled[{0.1, 0.9}]], 
             Text[
              Style["highlighted range:\n{{-1., -0.7}, {0.7, 1.}}", 16, 
               GrayLevel[0]], 
              Scaled[{0.2, 0.7}]]}, {{
              Text[
               Style["Npt: 3920", 16, 
                GrayLevel[0]], 
               Scaled[{0.1, 0.9}]], 
              Text[
               Style["highlighted range:\n{{-1., -0.7}, {0.7, 1.}}", 16, 
                GrayLevel[0]], 
               Scaled[{0.2, 0.7}]]}}}, 
          Frame -> {{False, False}, {False, False}}, 
          FrameLabel -> {{None, None}, {None, None}}, 
          FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
          GridLines -> {None, None}, GridLinesStyle -> Directive[
            GrayLevel[0.5, 0.4]], 
          Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
                 Part[#, 1]], 
                (
                Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
                 Part[#, 2]]}& )}}, PlotRange -> {{-Log[100000], 0}, {0, 
             Log[6000]}}, PlotRangeClipping -> True, 
          PlotRangePadding -> {{0, 0}, {0, 0}}, 
          Ticks -> {Automatic, Automatic}}], 
        Placed[
         Unevaluated[
          BarLegend[{{
             RGBColor[0, 0.7, 0], 
             RGBColor[0, 0.7, 0], 
             RGBColor[0.75, 0.75, 0.], 
             RGBColor[0.75, 0.55, 0.], 
             RGBColor[0.7, 0., 0.], 
             RGBColor[0.7, 0., 0.]}, {-0.001, 1.001}}, {-0.001, 0, 0.5, 0.7, 
            0.85, 1, 1.001}, LabelStyle -> {FontSize -> 14, 
             GrayLevel[0]}, LegendLabel -> "", LegendLayout -> "Column", 
           LegendMarkerSize -> {}, Charting`TickAnnotations -> None, 
           Charting`TickSide -> Right, ColorFunctionScaling -> True]], {1., 
         0.5}, Identity]]& ],
      AutoDelete->True,
      Editable->True,
      SelectWithContents->False,
      Selectable->True], ",", 
     TagBox[GridBox[{
        {
         InterpretationBox[Cell[BoxData[
           FormBox[
            
            StyleBox["\<\"| Corr( g(x,\[Mu]), \\!\\(\\*SubscriptBox[\\(r\\), \
\\(i\\)]\\)) |, CT14NNLO\\n\\n\"\>",
             StripOnInput->False,
             FontSize->24], TextForm]], "InlineText"],
          Text[
           Style[
           "| Corr( g(x,\[Mu]), \!\(\*SubscriptBox[\(r\), \(i\)]\)) |, \
CT14NNLO\n\n", FontSize -> 24]]], "\[SpanFromLeft]", "\[SpanFromLeft]"},
        {"\<\"Data Sets\"\>", "", ""},
        {"\<\"\[FilledCircle]BcdF2pCor(101)\"\>", \
"\<\"\[FilledSquare]BcdF2dCor(102)\"\>", \
"\<\"\[FilledDiamond]NmcRatCor(104)\"\>"},
        {"\<\"\[FilledUpTriangle]cdhswf2(108)\"\>", \
"\<\"\[FilledDownTriangle]cdhswf3(109)\"\>", \
"\<\"\[EmptyCircle]ccfrf2.mi(110)\"\>"},
        {"\<\"\[EmptySquare]ccfrf3.md(111)\"\>", \
"\<\"\[EmptyDiamond]NuTvNuChXN(124)\"\>", \
"\<\"\[EmptyUpTriangle]NuTvNbChXN(125)\"\>"},
        {"\<\"\[EmptyDownTriangle]CcfrNuChXN(126)\"\>", \
"\<\"\[Times]CcfrNbChXN(127)\"\>", "\<\"\[CircleMinus]Hn1X0c(147)\"\>"},
        {"\<\"\[FivePointedStar]e605(201)\"\>", \
"\<\"\[FilledCircle]e866f(203)\"\>", "\<\"\[FilledSquare]e866ppxf(204)\"\>"},
        {"\<\"\[FilledDiamond]cdfLasy(225)\"\>", \
"\<\"\[FilledUpTriangle]cdfLasy2(227)\"\>", \
"\<\"\[FilledDownTriangle]d02Masy1(234)\"\>"},
        {"\<\"\[EmptyCircle]ZyD02a(260)\"\>", \
"\<\"\[EmptySquare]cdf2jtCor2(504)\"\>", "\<\"\[EmptyDiamond]d02jtCor2(514)\"\
\>"},
        {"\<\"\[EmptyUpTriangle]Hn+9900x0b(145)\"\>", "\<\"\
\[EmptyDownTriangle]H1FL10(169)\"\>", "\<\"\[Times]ATL7_WZ(268)\"\>"},
        {"\<\"\[CircleMinus]ATL7jtR6(535)\"\>", \
"\<\"\[FivePointedStar]LHCb7_WZ1(240)\"\>", \
"\<\"\[FilledCircle]LHCb7Wasy1(241)\"\>"},
        {"\<\"\[FilledSquare]d02Easy5(281)\"\>", \
"\<\"\[FilledDiamond]CMS7Masy2(266)\"\>", \
"\<\"\[FilledUpTriangle]CMS7jtR7v2(538)\"\>"},
        {"\<\"\[FilledDownTriangle]LHCb7ZWrap(245)\"\>", \
"\<\"\[EmptyCircle]LHCb8Zeer(246)\"\>", "\<\"\[EmptySquare]ATL7ZW(248)\"\>"},
        {"\<\"\[EmptyDiamond]CMS7jtR7y6(542)\"\>", \
"\<\"\[EmptyUpTriangle]ATL7jtR6u(544)\"\>", \
"\<\"\[EmptyDownTriangle]CMS8Wxa(249)\"\>"},
        {"\<\"\[Times]LHCb8WZ(250)\"\>", \
"\<\"\[CircleMinus]ATL8ttpt(565)\"\>", "\<\"\[FivePointedStar]ATL8ttya(566)\"\
\>"},
        {"\<\"\[FilledCircle]ATL8ttmtt(567)\"\>", \
"\<\"\[FilledSquare]ATL8ttytt(568)\"\>", ""},
        {
         InterpretationBox[Cell[BoxData[
           FormBox[
            StyleBox["\<\"\"\>",
             StripOnInput->False,
             FontSize->16], TextForm]], "InlineText"],
          Text[
           Style["", FontSize -> 16]]], "\[SpanFromLeft]", "\[SpanFromLeft]"}
       },
       AutoDelete->False,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{14}}},
       GridBoxItemStyle->{"Columns" -> {{
            Directive[FontSize -> 18, 
             GrayLevel[0]]}}, "Rows" -> {{
            Directive[FontSize -> 18, 
             GrayLevel[0]]}}}],
      "Grid"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     GraphicsBox[{
       {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
        EdgeForm[{Opacity[0.45499999999999996`], Thickness[Small]}], {}, 
        {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
         EdgeForm[{Opacity[0.45499999999999996`], Thickness[Small]}], 
         RectangleBox[{-0.96, 0}, {-0.8999999999999999, 12},
          RoundingRadius->0], 
         RectangleBox[{-0.8999999999999999, 0}, {-0.84, 11},
          RoundingRadius->0], RectangleBox[{-0.84, 0}, {-0.78, 28},
          RoundingRadius->0], RectangleBox[{-0.78, 0}, {-0.72, 34},
          RoundingRadius->0], 
         RectangleBox[{-0.72, 0}, {-0.6599999999999999, 17},
          RoundingRadius->0], 
         RectangleBox[{-0.6599999999999999, 0}, {-0.6, 28},
          RoundingRadius->0], RectangleBox[{-0.6, 0}, {-0.54, 48},
          RoundingRadius->0], RectangleBox[{-0.54, 0}, {-0.48, 61},
          RoundingRadius->0], 
         RectangleBox[{-0.48, 0}, {-0.41999999999999993, 80},
          RoundingRadius->0], 
         RectangleBox[{-0.41999999999999993, 0}, {-0.36, 104},
          RoundingRadius->0], 
         RectangleBox[{-0.36, 0}, {-0.30000000000000004, 144},
          RoundingRadius->0], 
         RectangleBox[{-0.30000000000000004, 0}, {-0.24, 197},
          RoundingRadius->0], 
         RectangleBox[{-0.24, 0}, {-0.17999999999999994, 234},
          RoundingRadius->0], 
         RectangleBox[{-0.17999999999999994, 0}, {-0.12, 304},
          RoundingRadius->0], 
         RectangleBox[{-0.12, 0}, {-0.06000000000000005, 441},
          RoundingRadius->0], 
         RectangleBox[{-0.06000000000000005, 0}, {0., 506},
          RoundingRadius->0], 
         RectangleBox[{0., 0}, {0.06000000000000005, 411},
          RoundingRadius->0], 
         RectangleBox[{0.06000000000000005, 0}, {0.1200000000000001, 320},
          RoundingRadius->0], 
         RectangleBox[{0.1200000000000001, 0}, {0.17999999999999994, 224},
          RoundingRadius->0], 
         RectangleBox[{0.17999999999999994, 0}, {0.24, 116},
          RoundingRadius->0], 
         RectangleBox[{0.24, 0}, {0.30000000000000004, 93},
          RoundingRadius->0], 
         RectangleBox[{0.30000000000000004, 0}, {0.3599999999999999, 88},
          RoundingRadius->0], 
         RectangleBox[{0.3599999999999999, 0}, {0.41999999999999993, 61},
          RoundingRadius->0], 
         RectangleBox[{0.41999999999999993, 0}, {0.48, 60},
          RoundingRadius->0], RectangleBox[{0.48, 0}, {0.54, 46},
          RoundingRadius->0], 
         RectangleBox[{0.54, 0}, {0.6000000000000001, 52},
          RoundingRadius->0], 
         RectangleBox[{0.6000000000000001, 0}, {0.6599999999999999, 45},
          RoundingRadius->0], 
         RectangleBox[{0.6599999999999999, 0}, {0.72, 44},
          RoundingRadius->0], RectangleBox[{0.72, 0}, {0.78, 36},
          RoundingRadius->0], 
         RectangleBox[{0.78, 0}, {0.8399999999999999, 21},
          RoundingRadius->0], 
         RectangleBox[{0.8399999999999999, 0}, {0.8999999999999999, 37},
          RoundingRadius->0], 
         RectangleBox[{0.8999999999999999, 0}, {0.96, 4},
          RoundingRadius->0], RectangleBox[{0.96, 0}, {1.02, 13},
          
          RoundingRadius->
           0]}, {}, {}}, {{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}}},
      AspectRatio->1,
      Axes->False,
      AxesLabel->{None, None},
      AxesOrigin->{-3.12, 0.},
      BaseStyle->{FontSize -> 16},
      Epilog->{{
         Thickness[Large], {
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[0.7, 0., 0.], StripOnInput -> False], 
            TraditionalForm], {-0.7, 498.40999999999997`}], 
          StyleBox[
           LineBox[{{-0.7, 0.}, {-0.7, 480.7}}], 
           RGBColor[0.7, 0., 0.], StripOnInput -> False]}, {
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[0.7, 0., 0.], StripOnInput -> False], 
            TraditionalForm], {0.7, 478.16999999999996`}], 
          StyleBox[
           LineBox[{{0.7, 0.}, {0.7, 480.7}}], 
           RGBColor[0.7, 0., 0.], StripOnInput -> False]}}, {
         Thickness[Large], 
         StyleBox[
          LineBox[{{-1., 0.}, {-0.7, 0.}}], 
          RGBColor[0., 0., 0.7], StripOnInput -> False], 
         StyleBox[
          LineBox[{{0.7, 0.}, {1., 0.}}], 
          RGBColor[0., 0., 0.7], StripOnInput -> False]}, 
        InsetBox[
         FormBox[
          StyleBox["\"Npt: 3920\"", 16, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         Scaled[{0.1, 0.9}]]},
      Frame->True,
      FrameLabel->{
        FormBox[
         StyleBox[
         "\"Corr( g(x,\[Mu]), \\!\\(\\*SubscriptBox[\\(r\\), \\(i\\)]\\))\"", 
          18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm], 
        FormBox[
         StyleBox["\"#points\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm]},
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImageSize->{{600}, {600}},
      PlotLabel->FormBox[
        StyleBox[
        "\"Corr( g(x,\[Mu]), \\!\\(\\*SubscriptBox[\\(r\\), \\(i\\)]\\)), \
CT14NNLO\"", 24, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{-3., 3.}, {0., 506}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}], ",", 
     GraphicsBox[{
       {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
        EdgeForm[{Opacity[0.567], Thickness[Small]}], {}, 
        {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], 
         EdgeForm[{Opacity[0.567], Thickness[Small]}], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{0., 0}, {0.06, 917}, "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{74., 84.34}, {-245.12500000000009`, 
              232.00000000000003`}}],
            StatusArea[#, 917]& ,
            TagBoxNote->"917"],
           StyleBox["917", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[917, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{0.06, 0}, {0.12, 761}, "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{83.84, 94.18}, {-164.0415757906217, 
              232.00000000000003`}}],
            StatusArea[#, 761]& ,
            TagBoxNote->"761"],
           StyleBox["761", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[761, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{0.12, 0}, {0.18, 528}, "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{93.68, 104.02}, {-42.93620501635772, 
              232.00000000000003`}}],
            StatusArea[#, 528]& ,
            TagBoxNote->"528"],
           StyleBox["528", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[528, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{0.18, 0}, {0.24, 350}, "RoundingRadius" -> 0]},
             ImageSizeCache->{{103.52, 113.86}, {49.582061068702274`, 
              232.00000000000003`}}],
            StatusArea[#, 350]& ,
            TagBoxNote->"350"],
           StyleBox["350", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[350, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{0.24, 0}, {0.3, 290}, "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{113.36, 123.69999999999999`}, {
              80.76799345692476, 232.00000000000003`}}],
            StatusArea[#, 290]& ,
            TagBoxNote->"290"],
           StyleBox["290", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[290, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{0.3, 0}, {0.36, 232}, "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{123.19999999999999`, 133.54}, {
              110.9143947655398, 232.00000000000003`}}],
            StatusArea[#, 232]& ,
            TagBoxNote->"232"],
           StyleBox["232", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[232, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{0.36, 0}, {0.42, 165}, "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{133.04, 143.38}, {145.73868593238822`, 
              232.00000000000003`}}],
            StatusArea[#, 165]& ,
            TagBoxNote->"165"],
           StyleBox["165", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[165, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{0.42, 0}, {0.48, 140}, "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{142.88, 153.22}, {158.73282442748092`, 
              232.00000000000003`}}],
            StatusArea[#, 140]& ,
            TagBoxNote->"140"],
           StyleBox["140", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[140, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{0.48, 0}, {0.54, 107}, "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{152.72, 163.06}, {175.88508724100328`, 
              232.00000000000003`}}],
            StatusArea[#, 107]& ,
            TagBoxNote->"107"],
           StyleBox["107", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[107, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{0.54, 0}, {0.6, 100}, "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{162.56, 172.89999999999998`}, {
              179.52344601962923`, 232.00000000000003`}}],
            StatusArea[#, 100]& ,
            TagBoxNote->"100"],
           StyleBox["100", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[100, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              
              RectangleBox[{0.6, 0}, {0.6599999999999999, 73}, 
               "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{172.39999999999998`, 182.73999999999998`}, {
              193.55711559432936`, 232.00000000000003`}}],
            StatusArea[#, 73]& ,
            TagBoxNote->"73"],
           StyleBox["73", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[73, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              
              RectangleBox[{0.6599999999999999, 0}, {0.72, 61}, 
               "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{182.23999999999998`, 192.57999999999998`}, {
              199.79430207197385`, 232.00000000000003`}}],
            StatusArea[#, 61]& ,
            TagBoxNote->"61"],
           StyleBox["61", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[61, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{0.72, 0}, {0.78, 70}, "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{192.07999999999998`, 202.42000000000002`}, {
              195.1164122137405, 232.00000000000003`}}],
            StatusArea[#, 70]& ,
            TagBoxNote->"70"],
           StyleBox["70", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[70, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{0.78, 0}, {0.84, 49}, "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{201.92000000000002`, 212.26}, {
              206.03148854961833`, 232.00000000000003`}}],
            StatusArea[#, 49]& ,
            TagBoxNote->"49"],
           StyleBox["49", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[49, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              
              RectangleBox[{0.84, 0}, {0.8999999999999999, 48}, 
               "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{211.76, 222.1}, {206.55125408942206`, 
              232.00000000000003`}}],
            StatusArea[#, 48]& ,
            TagBoxNote->"48"],
           StyleBox["48", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[48, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              
              RectangleBox[{0.8999999999999999, 0}, {0.96, 16}, 
               "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{221.6, 231.94}, {223.18375136314071`, 
              232.00000000000003`}}],
            StatusArea[#, 16]& ,
            TagBoxNote->"16"],
           StyleBox["16", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[16, {}], "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           TagBox[
            DynamicBox[{
              FEPrivate`If[
               CurrentValue["MouseOver"], 
               EdgeForm[{
                 GrayLevel[0.5], 
                 AbsoluteThickness[1.5], 
                 Opacity[0.66]}], {}, {}], 
              RectangleBox[{0.96, 0}, {1.02, 13}, "RoundingRadius" -> 0]},
             
             ImageSizeCache->{{231.44, 241.78}, {224.74304798255181`, 
              232.00000000000003`}}],
            StatusArea[#, 13]& ,
            TagBoxNote->"13"],
           StyleBox["13", {}, StripOnInput -> False]],
          Annotation[#, 
           Style[13, {}], 
           "Tooltip"]& ]}, {}, {}}, {{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}}},
      AspectRatio->1,
      Axes->False,
      AxesLabel->{None, None},
      AxesOrigin->{-0.06, 0.},
      BaseStyle->{FontSize -> 16},
      Epilog->{{
         Thickness[Large], {
          InsetBox[
           FormBox[
            StyleBox["\"\"", 16, 
             RGBColor[0.7, 0., 0.], StripOnInput -> False], TraditionalForm], 
           {0.7, 903.245}], 
          StyleBox[
           LineBox[{{0.7, 0.}, {0.7, 871.15}}], 
           RGBColor[0.7, 0., 0.], StripOnInput -> False]}}, {
         Thickness[Large], 
         StyleBox[
          LineBox[{{-1., 0.}, {-0.7, 0.}}], 
          RGBColor[0., 0., 0.7], StripOnInput -> False], 
         StyleBox[
          LineBox[{{0.7, 0.}, {1., 0.}}], 
          RGBColor[0., 0., 0.7], StripOnInput -> False]}, 
        InsetBox[
         FormBox[
          StyleBox["\"Npt: 3920\"", 16, 
           GrayLevel[0], StripOnInput -> False], TraditionalForm], 
         Scaled[{0.1, 0.9}]]},
      Frame->True,
      FrameLabel->{
        FormBox[
         StyleBox[
         "\"| Corr( g(x,\[Mu]), \\!\\(\\*SubscriptBox[\\(r\\), \\(i\\)]\\)) |\
\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm], 
        FormBox[
         StyleBox["\"#points\"", 18, 
          GrayLevel[0], StripOnInput -> False], TraditionalForm]},
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImageSize->{{600}, {600}},
      PlotLabel->FormBox[
        StyleBox[
        "\"| Corr( g(x,\[Mu]), \\!\\(\\*SubscriptBox[\\(r\\), \\(i\\)]\\)) |, \
CT14NNLO\"", 24, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{0., 3.}, {0., 917}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.721098221342964*^9, 3.721098240103747*^9}, 
   3.721143494380678*^9, 3.721143771004697*^9, 3.721143900553447*^9, 
   3.7211439649886713`*^9, 3.7211778651463833`*^9, 3.7211789381416483`*^9, 
   3.7211792456059*^9, 3.721179409701474*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Get", "[", "\"\<corr_proj_funcs.m\>\"", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ReadLisFile", "[", "datalistFile", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.721179392348611*^9, 3.721179392604404*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"present directory: \"\>", 
   "\[InvisibleSpace]", \
"\<\"/home/botingw/Downloads/Sean_20171114/xqplotter_user_func_debug/\
xqplotter-master/bin\"\>"}],
  SequenceForm[
  "present directory: ", 
   "/home/botingw/Downloads/Sean_20171114/xqplotter_user_func_debug/xqplotter-\
master/bin"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.71920736331831*^9, 3.71920824541186*^9, 3.71921199276584*^9, 
   3.719212982419402*^9, {3.719214701123074*^9, 3.719214722453102*^9}, 
   3.719223478608391*^9, 3.719736992410942*^9, 3.719737568399859*^9, 
   3.7197389824142427`*^9, 3.719739198109377*^9, 3.7197508124632397`*^9, 
   3.7198243915798473`*^9, 3.719824604151128*^9, 3.719839878733622*^9, 
   3.7201309633394957`*^9, 3.7206284534361153`*^9, 3.7206285601885767`*^9, 
   3.720628707367035*^9, 3.720628874385874*^9, 3.720628915742462*^9, {
   3.720629169967013*^9, 3.720629199916547*^9}, 3.720629275874687*^9, 
   3.720631094645805*^9, 3.720631182938241*^9, 3.7206790931981707`*^9, 
   3.720711796374774*^9, 3.720712057190523*^9, 3.720712199651598*^9, 
   3.720713931075514*^9, 3.720713980328638*^9, 3.720714202251737*^9, 
   3.720717634290675*^9, 3.720717793241078*^9, 3.720718117991589*^9, 
   3.7207192893623238`*^9, 3.721098585876829*^9, 3.7211437469251842`*^9, 
   3.7211439518811274`*^9, 3.721177840914796*^9, 3.721179379875828*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"loading \"\>", 
   "\[InvisibleSpace]", "\<\"../lib/pdfParsePDS2013.m\"\>"}],
  SequenceForm["loading ", "../lib/pdfParsePDS2013.m"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.71920736331831*^9, 3.71920824541186*^9, 3.71921199276584*^9, 
   3.719212982419402*^9, {3.719214701123074*^9, 3.719214722453102*^9}, 
   3.719223478608391*^9, 3.719736992410942*^9, 3.719737568399859*^9, 
   3.7197389824142427`*^9, 3.719739198109377*^9, 3.7197508124632397`*^9, 
   3.7198243915798473`*^9, 3.719824604151128*^9, 3.719839878733622*^9, 
   3.7201309633394957`*^9, 3.7206284534361153`*^9, 3.7206285601885767`*^9, 
   3.720628707367035*^9, 3.720628874385874*^9, 3.720628915742462*^9, {
   3.720629169967013*^9, 3.720629199916547*^9}, 3.720629275874687*^9, 
   3.720631094645805*^9, 3.720631182938241*^9, 3.7206790931981707`*^9, 
   3.720711796374774*^9, 3.720712057190523*^9, 3.720712199651598*^9, 
   3.720713931075514*^9, 3.720713980328638*^9, 3.720714202251737*^9, 
   3.720717634290675*^9, 3.720717793241078*^9, 3.720718117991589*^9, 
   3.7207192893623238`*^9, 3.721098585876829*^9, 3.7211437469251842`*^9, 
   3.7211439518811274`*^9, 3.721177840914796*^9, 3.721179379900876*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"loading \"\>", 
   "\[InvisibleSpace]", "\<\"../lib/dtareadbotingw2016.m\"\>"}],
  SequenceForm["loading ", "../lib/dtareadbotingw2016.m"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.71920736331831*^9, 3.71920824541186*^9, 3.71921199276584*^9, 
   3.719212982419402*^9, {3.719214701123074*^9, 3.719214722453102*^9}, 
   3.719223478608391*^9, 3.719736992410942*^9, 3.719737568399859*^9, 
   3.7197389824142427`*^9, 3.719739198109377*^9, 3.7197508124632397`*^9, 
   3.7198243915798473`*^9, 3.719824604151128*^9, 3.719839878733622*^9, 
   3.7201309633394957`*^9, 3.7206284534361153`*^9, 3.7206285601885767`*^9, 
   3.720628707367035*^9, 3.720628874385874*^9, 3.720628915742462*^9, {
   3.720629169967013*^9, 3.720629199916547*^9}, 3.720629275874687*^9, 
   3.720631094645805*^9, 3.720631182938241*^9, 3.7206790931981707`*^9, 
   3.720711796374774*^9, 3.720712057190523*^9, 3.720712199651598*^9, 
   3.720713931075514*^9, 3.720713980328638*^9, 3.720714202251737*^9, 
   3.720717634290675*^9, 3.720717793241078*^9, 3.720718117991589*^9, 
   3.7207192893623238`*^9, 3.721098585876829*^9, 3.7211437469251842`*^9, 
   3.7211439518811274`*^9, 3.721177840914796*^9, 3.721179379924151*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReadUserFunction", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Directory", "[", "]"}], "<>", "\"\</\>\""}], ",", 
   "\"\<user_define_func.txt\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.719206361352789*^9, 3.719206370853891*^9}, {
  3.7192064011377983`*^9, 3.719206407240177*^9}, {3.719206445664157*^9, 
  3.719206528792143*^9}, {3.719206588535296*^9, 3.719206758197659*^9}, {
  3.719206835269075*^9, 3.719206860655794*^9}, {3.719206926062944*^9, 
  3.7192069340405273`*^9}, {3.719207018158044*^9, 3.719207039243352*^9}, {
  3.719207163488001*^9, 3.719207209035729*^9}, {3.7192072780710287`*^9, 
  3.7192072929961853`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\" sigma_Higgs (pb)\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
    "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",",
      "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", 
     "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", 
     "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", 
     "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", 
     "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", 
     "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.012`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.719207365791872*^9, 3.719207397889358*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "Jobid", ",", "PDFname", ",", "FigureType", ",", "FigureFlag", ",", 
      "ExptidType", ",", "ExptidFlag", ",", "CorrelationArgType", ",", 
      "CorrelationArgFlag", ",", "UserArgName", ",", "UserArgValue", ",", 
      "\[IndentingNewLine]", "XQfigureXrange", ",", "XQfigureYrange", ",", 
      "Hist1figureNbin", ",", "Hist1figureXrange", ",", 
      RowBox[{"(*", "Hist1figureYrange", "*)"}], "dummy12", ",", 
      "\[IndentingNewLine]", "ColorSeperator", ",", "\[IndentingNewLine]", 
      "Size", ",", "HighlightType", ",", "HighlightMode", ",", 
      "HighlightMode1", ",", "HighlightMode2"}], "}"}], "="}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"readcorrconfigfile4", "[", 
    RowBox[{"configDir", ",", "configfilename"}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"readcorrconfigfile5", "[", 
     RowBox[{"configDir", ",", "configfilename"}], "]"}], "[", 
    RowBox[{"[", 
     RowBox[{"-", "2"}], "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.719208238444277*^9, 3.7192082486568937`*^9}, {
  3.7192082961088057`*^9, 3.719208300960734*^9}, {3.719212096748006*^9, 
  3.71921209875319*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"70805", ",", "\<\"CT14NNLO\"\>", ",", 
   RowBox[{"{", 
    RowBox[{"\<\"1\"\>", ",", "\<\"2\"\>", ",", "\<\"3\"\>", ",", "\<\"4\"\>",
      ",", "\<\"5\"\>", ",", "\<\"6\"\>", ",", "\<\"7\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0"}],
     "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "701", ",", "702", ",", "703", ",", "159", ",", "101", ",", "102", ",", 
     "103", ",", "104", ",", "106", ",", "108", ",", "109", ",", "110", ",", 
     "111", ",", "124", ",", "125", ",", "126", ",", "127", ",", "147", ",", 
     "201", ",", "203", ",", "204", ",", "225", ",", "227", ",", "231", ",", 
     "234", ",", "260", ",", "261", ",", "504", ",", "514", ",", "145", ",", 
     "169", ",", "267", ",", "268", ",", "535", ",", "240", ",", "241", ",", 
     "281", ",", "265", ",", "266", ",", "538"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"bb\"\>", ",", "\<\"cb\"\>", ",", "\<\"sb\"\>", 
     ",", "\<\"db\"\>", ",", "\<\"ub\"\>", ",", "\<\"g\"\>", ",", "\<\"u\"\>",
      ",", "\<\"d\"\>", ",", "\<\"s\"\>", ",", "\<\"c\"\>", ",", "\<\"b\"\>", 
     ",", "\<\"q6\"\>", ",", "\<\"q7\"\>", ",", "\<\"q8\"\>", 
     ",", "\<\"user\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
    "}"}], ",", "\<\" \"\>", ",", 
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.00001`", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.`", ",", "2000.`"}], "}"}], ",", "\<\"auto\"\>", ",", 
   RowBox[{"{", 
    RowBox[{"\<\"auto\"\>", ",", "\<\"auto\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "\<\"auto\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"50", ",", "70", ",", "85"}], "}"}], ",", "\<\"tiny\"\>", ",", 
   RowBox[{"{", 
    RowBox[{"\<\"1\"\>", ",", "\<\"2\"\>", ",", "\<\"3\"\>", ",", "\<\"4\"\>",
      ",", "\<\"5\"\>", ",", "\<\"6\"\>", ",", "\<\"7\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "2", ",", "2", ",", "2", ",", "2", ",", "2", ",", "1"}],
     "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1.`", ",", "5.`", ",", "0.2`", ",", "10", ",", "1.`", ",", "5.`", ",", 
     "1.`", ",", "5.`", ",", "1.`", ",", "5.`", ",", "0.7`", ",", "1.`", ",", 
     "1.`", ",", "5.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.`", ",", "0.`", ",", "85", ",", "100", ",", "85", ",", "100", ",", 
     "85", ",", "100", ",", "85", ",", "100", ",", "85", ",", "100", ",", 
     "0.`", ",", "0.`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.7192082528097143`*^9, 3.719208302758484*^9, 3.719208582294437*^9, 
   3.719211998083878*^9, {3.719212088779896*^9, 3.7192121272015467`*^9}, 
   3.719212196556542*^9}],

Cell[BoxData[
 TemplateBox[{
  "Read","readn",
   "\"Invalid real number found when reading from \
\\!\\(\\*RowBox[{\\\"StringToStream\\\", \\\"[\\\", \\\"\\\\\\\"unset\\\\\\\"\
\\\", \\\"]\\\"}]\\).\"",2,45,111,25821210537327940555,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.719208252708137*^9, 3.7192083027630663`*^9, 3.719208582181964*^9, 
   3.719211997950513*^9, {3.719212088632493*^9, 3.71921212707336*^9}, 
   3.71921219656231*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","partw",
   "\"Part \\!\\(\\*RowBox[{\\\"2\\\"}]\\) of \\!\\(\\*RowBox[{\\\"{\\\", \
\\\"$Failed\\\", \\\"}\\\"}]\\) does not exist.\"",2,45,112,
   25821210537327940555,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.719208252708137*^9, 3.7192083027630663`*^9, 3.719208582181964*^9, 
   3.719211997950513*^9, {3.719212088632493*^9, 3.71921212707336*^9}, 
   3.7192121965745907`*^9}],

Cell[BoxData[
 TemplateBox[{
  "Read","readn",
   "\"Invalid real number found when reading from \
\\!\\(\\*RowBox[{\\\"StringToStream\\\", \\\"[\\\", \\\"\\\\\\\"unset\\\\\\\"\
\\\", \\\"]\\\"}]\\).\"",2,45,113,25821210537327940555,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.719208252708137*^9, 3.7192083027630663`*^9, 3.719208582181964*^9, 
   3.719211997950513*^9, {3.719212088632493*^9, 3.71921212707336*^9}, 
   3.71921219658741*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","partw",
   "\"Part \\!\\(\\*RowBox[{\\\"2\\\"}]\\) of \\!\\(\\*RowBox[{\\\"{\\\", \
\\\"$Failed\\\", \\\"}\\\"}]\\) does not exist.\"",2,45,114,
   25821210537327940555,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.719208252708137*^9, 3.7192083027630663`*^9, 3.719208582181964*^9, 
   3.719211997950513*^9, {3.719212088632493*^9, 3.71921212707336*^9}, 
   3.719212196600133*^9}],

Cell[BoxData[
 TemplateBox[{
  "Read","readn",
   "\"Invalid real number found when reading from \
\\!\\(\\*RowBox[{\\\"StringToStream\\\", \\\"[\\\", \\\"\\\\\\\"unset\\\\\\\"\
\\\", \\\"]\\\"}]\\).\"",2,45,115,25821210537327940555,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.719208252708137*^9, 3.7192083027630663`*^9, 3.719208582181964*^9, 
   3.719211997950513*^9, {3.719212088632493*^9, 3.71921212707336*^9}, 
   3.7192121966115923`*^9}],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"Read\\\", \\\"::\\\", \
\\\"readn\\\"}], \\\"MessageName\\\"]\\) will be suppressed during this \
calculation.\"",2,45,116,25821210537327940555,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.719208252708137*^9, 3.7192083027630663`*^9, 3.719208582181964*^9, 
   3.719211997950513*^9, {3.719212088632493*^9, 3.71921212707336*^9}, 
   3.719212196623006*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","partw",
   "\"Part \\!\\(\\*RowBox[{\\\"2\\\"}]\\) of \\!\\(\\*RowBox[{\\\"{\\\", \
\\\"$Failed\\\", \\\"}\\\"}]\\) does not exist.\"",2,45,117,
   25821210537327940555,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.719208252708137*^9, 3.7192083027630663`*^9, 3.719208582181964*^9, 
   3.719211997950513*^9, {3.719212088632493*^9, 3.71921212707336*^9}, 
   3.71921219666077*^9}],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"Part\\\", \\\"::\\\", \
\\\"partw\\\"}], \\\"MessageName\\\"]\\) will be suppressed during this \
calculation.\"",2,45,118,25821210537327940555,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.719208252708137*^9, 3.7192083027630663`*^9, 3.719208582181964*^9, 
   3.719211997950513*^9, {3.719212088632493*^9, 3.71921212707336*^9}, 
   3.7192121966729937`*^9}],

Cell[BoxData[
 TemplateBox[{
  "ReadList","readn",
   "\"Invalid real number found when reading from \
\\!\\(\\*RowBox[{\\\"StringToStream\\\", \\\"[\\\", \\\"\\\\\\\"unset\\\\\\\"\
\\\", \\\"]\\\"}]\\).\"",2,45,119,25821210537327940555,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.719208252708137*^9, 3.7192083027630663`*^9, 3.719208582181964*^9, 
   3.719211997950513*^9, {3.719212088632493*^9, 3.71921212707336*^9}, 
   3.719212196683104*^9}],

Cell[BoxData[
 RowBox[{"{", "unset", "}"}]], "Output",
 CellChangeTimes->{
  3.7192082528097143`*^9, 3.719208302758484*^9, 3.719208582294437*^9, 
   3.719211998083878*^9, {3.719212088779896*^9, 3.7192121272015467`*^9}, 
   3.719212196691596*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"20171109", ":", " ", 
    RowBox[{"seperate", " ", "user", " ", "difine", " ", 
     RowBox[{"function", "/", "data"}], " ", "IO", " ", "and", " ", 
     "configure", " ", "file"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"userfuncfilename", "=", "\"\<user_define_func.txt\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"UserArgName", ",", "UserArgValue"}], "}"}], "=", 
    RowBox[{"ReadUserFunction", "[", 
     RowBox[{"\"\<./\>\"", ",", "userfuncfilename"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.719191350439296*^9, 3.719191351444817*^9}, {
   3.7191913915234013`*^9, 3.719191542948613*^9}, {3.719191579916553*^9, 
   3.719191608650613*^9}, {3.71919227592983*^9, 3.719192288781296*^9}, {
   3.7191923331675873`*^9, 3.7191923866844063`*^9}, {3.7191924359464827`*^9, 
   3.719192510042478*^9}, {3.719192540110292*^9, 3.719192590689439*^9}, {
   3.7191926289901857`*^9, 3.71919264133893*^9}, {3.719192705618341*^9, 
   3.719192775000009*^9}, {3.7191928207204847`*^9, 3.7191929214824*^9}, {
   3.719192988237002*^9, 3.719192991894369*^9}, {3.7191930997034483`*^9, 
   3.719193108867979*^9}, {3.719193251526259*^9, 3.719193262072785*^9}, {
   3.7191933781344*^9, 3.71919338543708*^9}, {3.719193444086508*^9, 
   3.719193469747447*^9}, {3.719193562493108*^9, 3.719193577993537*^9}, {
   3.71919373787492*^9, 3.719193740748376*^9}, {3.7191937910345163`*^9, 
   3.7191938059509697`*^9}, {3.719193884246745*^9, 3.719193934538932*^9}, {
   3.719194022420391*^9, 3.719194046647883*^9}, {3.719194076769895*^9, 
   3.719194086872014*^9}, {3.719194192431547*^9, 3.719194258995154*^9}, 
   3.71919439159704*^9, {3.719194429618018*^9, 3.719194432631043*^9}, {
   3.71919450143403*^9, 3.719194529182914*^9}, {3.719194635646356*^9, 
   3.7191946536721153`*^9}, {3.7191946950828238`*^9, 3.719194708174732*^9}, {
   3.7191947955228157`*^9, 3.719194848070615*^9}, {3.7191949463400717`*^9, 
   3.719194960747587*^9}, {3.719195036771473*^9, 3.7191950778321857`*^9}, {
   3.7191951677811403`*^9, 3.719195291171475*^9}, {3.719195328406781*^9, 
   3.719195343911694*^9}, {3.719212457840344*^9, 3.719212465643208*^9}, {
   3.7192124964794693`*^9, 3.7192126548279057`*^9}, {3.7192127724438457`*^9, 
   3.719212822123301*^9}, 3.719212860835353*^9, {3.719212891451104*^9, 
   3.719212960456065*^9}, {3.7192132853251457`*^9, 3.719213484780237*^9}, {
   3.719213515608519*^9, 3.719213547278957*^9}, {3.719213590311339*^9, 
   3.7192136125315847`*^9}, {3.719213698453277*^9, 3.719213730590592*^9}, {
   3.719213789299914*^9, 3.719213834906002*^9}, {3.719213882242855*^9, 
   3.7192139044347486`*^9}, {3.719213936787261*^9, 3.719213985464634*^9}, {
   3.719214097234009*^9, 3.719214151577786*^9}, {3.7192146897077637`*^9, 
   3.7192146898857107`*^9}, {3.719215614845934*^9, 3.7192156150917063`*^9}, {
   3.71922046828438*^9, 3.71922050065518*^9}, {3.719220645423839*^9, 
   3.71922064863894*^9}, {3.719220861754607*^9, 3.71922095481752*^9}, {
   3.719221035577244*^9, 3.7192210654184237`*^9}, {3.719221117344846*^9, 
   3.719221160936112*^9}, {3.719221263262035*^9, 3.719221309521122*^9}, {
   3.7192214233647346`*^9, 3.7192214348505898`*^9}, {3.719221520075737*^9, 
   3.7192215770495033`*^9}, {3.719221751786022*^9, 3.719221779006188*^9}, {
   3.719222119450335*^9, 3.719222156463868*^9}, {3.719222772112879*^9, 
   3.719222777822998*^9}, {3.71922333354941*^9, 3.7192233425927477`*^9}, {
   3.719223373727326*^9, 3.7192233756177177`*^9}, 3.719223410228778*^9, {
   3.720134882224613*^9, 3.720134886608931*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\" sigma_Higgs (pb)\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
    "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",",
      "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", 
     "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", 
     "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", 
     "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", 
     "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", 
     "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", ",", "0.012`", 
     ",", "0.012`", ",", "0.012`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.7192234105940237`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"ReadUserFunctionV3", "[", 
  RowBox[{"\"\<./\>\"", ",", "userfuncfilename"}], "]"}]], "Input",
 CellChangeTimes->{{3.7201300071921473`*^9, 3.72013000752887*^9}, 
   3.7201348882822247`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fxQsamept2classfinal", "[", 
  RowBox[{"[", 
   RowBox[{"3", ",", "17"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.720130051372602*^9, 3.7201301391646023`*^9}}],

Cell[BoxData[
 TemplateBox[{
  "Part","partw",
   "\"Part \\!\\(\\*RowBox[{\\\"3\\\"}]\\) of \\!\\(\\*RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"\[LeftSkeleton]\\\", \\\"1\\\", \\\"\
\[RightSkeleton]\\\"}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{\\\
\"\[LeftSkeleton]\\\", \\\"1\\\", \\\"\[RightSkeleton]\\\"}], \\\"}\\\"}]}], \
\\\"}\\\"}]\\) does not exist.\"",2,54,7,25827493381616713808,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7201301399336853`*^9}],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   FrameBox[GridBox[{
      {
       ItemBox[
        TagBox[
         RowBox[{
          TemplateBox[{"1"},
           "OutputSizeLimit`Skeleton",
           DisplayFunction->(FrameBox[
             RowBox[{"\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
             Background -> GrayLevel[0.75], 
             BaseStyle -> {
              "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
               ShowStringCharacters -> False}, BaselinePosition -> Baseline, 
             ContentPadding -> False, FrameMargins -> {{1, 1}, {1, 2}}, 
             FrameStyle -> None, RoundingRadius -> 7]& )], 
          "\[LeftDoubleBracket]", 
          RowBox[{"3", ",", "17"}], "\[RightDoubleBracket]"}],
         Short[#, 5]& ],
        BaseStyle->{Deployed -> False},
        StripOnInput->False]},
      {GridBox[{
         {
          TagBox[
           TooltipBox[
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource[
                "FEStrings", "sizeBriefExplanation"], StandardForm],
               ImageSizeCache->{74., {2., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarCategory",
             StripOnInput->False],
            StyleBox[
             DynamicBox[
              ToBoxes[
               FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
               StandardForm]], DynamicUpdating -> True, StripOnInput -> 
             False]],
           Annotation[#, 
            Style[
             Dynamic[
              FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"]], 
             DynamicUpdating -> True], "Tooltip"]& ], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{67., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 54, 25827493381616713808, 5/2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{73., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{73., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 54, 25827493381616713808, 5 2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{56., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 54, 25827493381616713808, Infinity],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{100., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{100., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           ButtonFunction:>FrontEndExecute[{
              FrontEnd`SetOptions[
              FrontEnd`$FrontEnd, 
               FrontEnd`PreferencesSettings -> {"Page" -> "Evaluation"}], 
              FrontEnd`FrontEndToken["PreferencesDialog"]}],
           Evaluator->None,
           Method->"Preemptive"]}
        },
        AutoDelete->False,
        FrameStyle->GrayLevel[0.85],
        GridBoxDividers->{"Columns" -> {False, {True}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
        GridBoxSpacings->{"Columns" -> {{2}}}]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], 
         Offset[1.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Background->RGBColor[0.9657, 0.9753, 0.9802],
    FrameMargins->{{12, 12}, {0, 15}},
    FrameStyle->GrayLevel[0.85],
    RoundingRadius->5,
    StripOnInput->False],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  Out[54]]], "Output",
 CellChangeTimes->{{3.720130057918419*^9, 3.720130140161817*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["exptidDir"], "Input",
 CellChangeTimes->{{3.720145041963225*^9, 3.720145047777162*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringDrop", "[", 
   RowBox[{"\<\"\"\>", ",", 
    RowBox[{"-", "1"}]}], "]"}], "<>", "\<\"/\"\>"}]], "Output",
 CellChangeTimes->{3.720145048576503*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["exptid"], "Input"],

Cell[BoxData["101"], "Output",
 CellChangeTimes->{3.720145092353647*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["fxQDatabaseExptlist"], "Input",
 CellChangeTimes->{{3.719644788934949*^9, 3.719645133393556*^9}, {
   3.7196451782562017`*^9, 3.7196454122764683`*^9}, {3.719645468733173*^9, 
   3.719645471238447*^9}, {3.719645634919951*^9, 3.7196456566849747`*^9}, {
   3.719645815998908*^9, 3.719645847283451*^9}, {3.719646064971663*^9, 
   3.7196461648210497`*^9}, {3.719646339220385*^9, 3.719646342411758*^9}, {
   3.71964646284031*^9, 3.719646464824644*^9}, {3.719646606013377*^9, 
   3.719646683448421*^9}, {3.7196467386478443`*^9, 3.7196467544303617`*^9}, {
   3.719646819713044*^9, 3.719646820559676*^9}, {3.719646857883507*^9, 
   3.719646876335994*^9}, {3.7196469362995377`*^9, 3.719646953608491*^9}, {
   3.7196472127909517`*^9, 3.719647275147904*^9}, {3.7196473090771093`*^9, 
   3.719647350968659*^9}, {3.719647388803999*^9, 3.71964742523739*^9}, {
   3.7196475046882687`*^9, 3.719647507109137*^9}, {3.7196476349255457`*^9, 
   3.719647663313012*^9}, {3.71964821963371*^9, 3.7196482225285387`*^9}, {
   3.719648862695269*^9, 3.719648863722289*^9}, {3.7198190817755632`*^9, 
   3.719819094616254*^9}, {3.7198493000164843`*^9, 3.7198501815122433`*^9}, {
   3.719851046682987*^9, 3.719851050967414*^9}, {3.71985276915901*^9, 
   3.719852771115087*^9}, {3.720136205054118*^9, 3.720136218733345*^9}, {
   3.7201403822168703`*^9, 3.720140421927147*^9}, {3.720140646947536*^9, 
   3.720140668621038*^9}, {3.7201408857494583`*^9, 3.720141110795075*^9}, {
   3.720141307142659*^9, 3.7201413212002573`*^9}, {3.72014183345184*^9, 
   3.7201419614634027`*^9}, {3.720142024736053*^9, 3.720142037555791*^9}, {
   3.720142175805664*^9, 3.720142196768915*^9}, {3.720142297874094*^9, 
   3.720142479001603*^9}, 3.720142515082511*^9, {3.720142970482079*^9, 
   3.720143000624256*^9}, {3.7201433487488317`*^9, 3.720143558911973*^9}, {
   3.720143598288005*^9, 3.7201436188658333`*^9}, {3.720143657568027*^9, 
   3.720143665432598*^9}, {3.720143704045146*^9, 3.720143747871608*^9}, {
   3.7201437918289824`*^9, 3.7201438818969383`*^9}, {3.720143939452106*^9, 
   3.720143991860527*^9}, {3.720144030553961*^9, 3.7201441298043423`*^9}, {
   3.720144371410325*^9, 3.720144451674851*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "101", ",", "102", ",", "104", ",", "106", ",", "108", ",", "109", ",", 
   "110", ",", "111", ",", "124", ",", "125", ",", "126", ",", "127", ",", 
   "145", ",", "147", ",", "159", ",", "169", ",", "201", ",", "203", ",", 
   "204", ",", "225", ",", "227", ",", "234", ",", "240", ",", "241", ",", 
   "260", ",", "261", ",", "266", ",", "267", ",", "268", ",", "281", ",", 
   "504", ",", "514", ",", "535", ",", "538"}], "}"}]], "Output",
 CellChangeTimes->{3.720145567366337*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"fxQDatabaselist", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", 
         RowBox[{"iu", "+", "6"}], ",", "3"}], "]"}], "]"}], "/.", 
      RowBox[{"LF", "\[Rule]", "List"}]}], ")"}], "-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"fxQDatabaselist", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", 
         RowBox[{"iubar", "+", "6"}], ",", "3"}], "]"}], "]"}], "/.", 
      RowBox[{"LF", "\[Rule]", "List"}]}], ")"}]}], ")"}], "/", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"fxQDatabaselist", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", 
         RowBox[{"iu", "+", "6"}], ",", "3"}], "]"}], "]"}], "/.", 
      RowBox[{"LF", "\[Rule]", "List"}]}], ")"}], "+", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"fxQDatabaselist", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", 
         RowBox[{"iubar", "+", "6"}], ",", "3"}], "]"}], "]"}], "/.", 
      RowBox[{"LF", "\[Rule]", "List"}]}], ")"}]}], 
   ")"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fxQsamept2classfinal", "[", 
    RowBox[{"[", 
     RowBox[{"2", ",", 
      RowBox[{"-", "1"}]}], "]"}], "]"}], "[", 
   RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
  RowBox[{"[", "1", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.719644788934949*^9, 3.719645133393556*^9}, {
   3.7196451782562017`*^9, 3.7196454122764683`*^9}, {3.719645468733173*^9, 
   3.719645471238447*^9}, {3.719645634919951*^9, 3.7196456566849747`*^9}, {
   3.719645815998908*^9, 3.719645847283451*^9}, {3.719646064971663*^9, 
   3.7196461648210497`*^9}, {3.719646339220385*^9, 3.719646342411758*^9}, {
   3.71964646284031*^9, 3.719646464824644*^9}, {3.719646606013377*^9, 
   3.719646683448421*^9}, {3.7196467386478443`*^9, 3.7196467544303617`*^9}, {
   3.719646819713044*^9, 3.719646820559676*^9}, {3.719646857883507*^9, 
   3.719646876335994*^9}, {3.7196469362995377`*^9, 3.719646953608491*^9}, {
   3.7196472127909517`*^9, 3.719647275147904*^9}, {3.7196473090771093`*^9, 
   3.719647350968659*^9}, {3.719647388803999*^9, 3.71964742523739*^9}, {
   3.7196475046882687`*^9, 3.719647507109137*^9}, {3.7196476349255457`*^9, 
   3.719647663313012*^9}, {3.71964821963371*^9, 3.7196482225285387`*^9}, {
   3.719648862695269*^9, 3.719648863722289*^9}, {3.7198190817755632`*^9, 
   3.719819094616254*^9}, {3.7198493000164843`*^9, 3.7198501815122433`*^9}, {
   3.719851046682987*^9, 3.719851050967414*^9}, {3.71985276915901*^9, 
   3.719852771115087*^9}, {3.720136205054118*^9, 3.720136218733345*^9}, {
   3.7201403822168703`*^9, 3.720140421927147*^9}, {3.720140646947536*^9, 
   3.720140668621038*^9}, {3.7201408857494583`*^9, 3.720141110795075*^9}, {
   3.720141307142659*^9, 3.7201413212002573`*^9}, {3.72014183345184*^9, 
   3.7201419614634027`*^9}, {3.720142024736053*^9, 3.720142037555791*^9}, {
   3.720142175805664*^9, 3.720142196768915*^9}, {3.720142297874094*^9, 
   3.720142479001603*^9}, 3.720142515082511*^9, {3.720142970482079*^9, 
   3.720143000624256*^9}, {3.7201433487488317`*^9, 3.720143558911973*^9}, {
   3.720143598288005*^9, 3.7201436188658333`*^9}, {3.720143657568027*^9, 
   3.720143665432598*^9}, {3.720143704045146*^9, 3.720143747871608*^9}, {
   3.7201437918289824`*^9, 3.7201438818969383`*^9}, {3.720143939452106*^9, 
   3.720143991860527*^9}, {3.720144030553961*^9, 3.7201441298043423`*^9}, {
   3.720144371410325*^9, 3.720144451674851*^9}, {3.720145664221147*^9, 
   3.720145846547496*^9}, {3.72014587673007*^9, 3.7201458883594*^9}, {
   3.720145942438614*^9, 3.7201459560754967`*^9}, {3.720146755620428*^9, 
   3.7201467556766977`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.`", ",", "0.`", ",", "0.7325203403254198`", ",", "0.7398961670707842`", 
   ",", "0.7370916755429413`", ",", "0.737801091948698`", ",", 
   "0.7324533443731553`", ",", "0.7331043859218316`", ",", 
   "0.7338453551128826`", ",", "0.7408455418476348`", ",", 
   "0.7276854486283896`", ",", "0.7266880893525024`", ",", 
   "0.7372345934735001`", ",", "0.7292456372572195`", ",", 
   "0.7394206515684165`", ",", "0.7301006198032995`", ",", 
   "0.7339488105730146`", ",", "0.7310930939396928`", ",", 
   "0.7381789749155877`", ",", "0.7199501338921726`", ",", 
   "0.7462728607872583`", ",", "0.7303654657747838`", ",", 
   "0.7350029216161464`", ",", "0.7322118675303653`", ",", 
   "0.7327744707658013`", ",", "0.7233870253307806`", ",", 
   "0.7425421753627093`", ",", "0.736026279232759`", ",", 
   "0.7298189998153578`", ",", "0.7354914232277872`", ",", 
   "0.7274359995673283`", ",", "0.7373558037451721`", ",", 
   "0.7294566128479375`", ",", "0.7253023117280991`", ",", 
   "0.7436869479406223`", ",", "0.7309088388341644`", ",", 
   "0.7339413696681164`", ",", "0.7330601637867304`", ",", 
   "0.7325826064184869`", ",", "0.7289241824701893`", ",", 
   "0.7367616036081575`", ",", "0.7272227661130493`", ",", 
   "0.7404514279014149`", ",", "0.7316214298903893`", ",", 
   "0.7327438348831531`", ",", "0.7307064356294725`", ",", 
   "0.7334225032044372`", ",", "0.7430151591829272`", ",", 
   "0.7276971494492852`", ",", "0.7152370876282537`", ",", 
   "0.7484406422339298`", ",", "0.7389307838535614`", ",", 
   "0.7245072283361272`", ",", "0.7331991474943079`", ",", 
   "0.7296870532699736`", ",", "0.7327231382942233`", ",", 
   "0.7354273768200662`", ",", "0.7283923350560747`", ",", 
   "0.724289957709076`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.7201456782820387`*^9, {3.7201457484152946`*^9, 3.720145762020005*^9}, {
   3.720145822095257*^9, 3.720145847887529*^9}, {3.720145883082008*^9, 
   3.7201458924153347`*^9}, {3.720145943052682*^9, 3.7201459570368967`*^9}, {
   3.7201467483970413`*^9, 3.720146756236794*^9}}],

Cell[BoxData[
 RowBox[{"LF", "[", 
  RowBox[{
  "0.04577879148136942`", ",", "80.38`", ",", "0.7325203403254198`", ",", 
   "0.7398961670707842`", ",", "0.7370916755429413`", ",", 
   "0.737801091948698`", ",", "0.7324533443731553`", ",", 
   "0.7331043859218316`", ",", "0.7338453551128826`", ",", 
   "0.7408455418476348`", ",", "0.7276854486283896`", ",", 
   "0.7266880893525024`", ",", "0.7372345934735001`", ",", 
   "0.7292456372572195`", ",", "0.7394206515684165`", ",", 
   "0.7301006198032995`", ",", "0.7339488105730146`", ",", 
   "0.7310930939396928`", ",", "0.7381789749155877`", ",", 
   "0.7199501338921726`", ",", "0.7462728607872583`", ",", 
   "0.7303654657747838`", ",", "0.7350029216161464`", ",", 
   "0.7322118675303653`", ",", "0.7327744707658013`", ",", 
   "0.7233870253307806`", ",", "0.7425421753627093`", ",", 
   "0.736026279232759`", ",", "0.7298189998153578`", ",", 
   "0.7354914232277872`", ",", "0.7274359995673283`", ",", 
   "0.7373558037451721`", ",", "0.7294566128479375`", ",", 
   "0.7253023117280991`", ",", "0.7436869479406223`", ",", 
   "0.7309088388341644`", ",", "0.7339413696681164`", ",", 
   "0.7330601637867304`", ",", "0.7325826064184869`", ",", 
   "0.7289241824701893`", ",", "0.7367616036081575`", ",", 
   "0.7272227661130493`", ",", "0.7404514279014149`", ",", 
   "0.7316214298903893`", ",", "0.7327438348831531`", ",", 
   "0.7307064356294725`", ",", "0.7334225032044372`", ",", 
   "0.7430151591829272`", ",", "0.7276971494492852`", ",", 
   "0.7152370876282537`", ",", "0.7484406422339298`", ",", 
   "0.7389307838535614`", ",", "0.7245072283361272`", ",", 
   "0.7331991474943079`", ",", "0.7296870532699736`", ",", 
   "0.7327231382942233`", ",", "0.7354273768200662`", ",", 
   "0.7283923350560747`", ",", "0.724289957709076`"}], "]"}]], "Output",
 CellChangeTimes->{
  3.7201456782820387`*^9, {3.7201457484152946`*^9, 3.720145762020005*^9}, {
   3.720145822095257*^9, 3.720145847887529*^9}, {3.720145883082008*^9, 
   3.7201458924153347`*^9}, {3.720145943052682*^9, 3.7201459570368967`*^9}, {
   3.7201467483970413`*^9, 3.720146756247449*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"fxQDatabaselist", "[", 
       RowBox[{"[", 
        RowBox[{"10", ",", 
         RowBox[{"iu", "+", "6"}], ",", "1"}], "]"}], "]"}], "/.", 
      RowBox[{"LF", "\[Rule]", "List"}]}], ")"}], "-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"fxQDatabaselist", "[", 
       RowBox[{"[", 
        RowBox[{"10", ",", 
         RowBox[{"iubar", "+", "6"}], ",", "1"}], "]"}], "]"}], "/.", 
      RowBox[{"LF", "\[Rule]", "List"}]}], ")"}]}], ")"}], "/", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"fxQDatabaselist", "[", 
       RowBox[{"[", 
        RowBox[{"10", ",", 
         RowBox[{"iu", "+", "6"}], ",", "1"}], "]"}], "]"}], "/.", 
      RowBox[{"LF", "\[Rule]", "List"}]}], ")"}], "+", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"fxQDatabaselist", "[", 
       RowBox[{"[", 
        RowBox[{"10", ",", 
         RowBox[{"iubar", "+", "6"}], ",", "1"}], "]"}], "]"}], "/.", 
      RowBox[{"LF", "\[Rule]", "List"}]}], ")"}]}], 
   ")"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fxQsamept2classfinal", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", 
      RowBox[{"-", "2"}]}], "]"}], "]"}], "[", 
   RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
  RowBox[{"[", "1", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fxQsamept2classfinal", "[", 
   RowBox[{"[", 
    RowBox[{"1", ",", "1"}], "]"}], "]"}], "[", 
  RowBox[{"[", 
   RowBox[{"\"\<exptinfo\>\"", ",", "\"\<exptid\>\""}], "]"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.7201464391471663`*^9, 3.720146495706332*^9}, {
  3.720146555309065*^9, 3.7201465698617496`*^9}, {3.720146602281864*^9, 
  3.720146679460599*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.`", ",", "0.`", ",", "0.7673128870135113`", ",", "0.7742951462428858`", 
   ",", "0.7715631990959222`", ",", "0.7709559531070869`", ",", 
   "0.7674493034856964`", ",", "0.7684220988166247`", ",", 
   "0.7676283432751239`", ",", "0.7749785217376207`", ",", 
   "0.7630226085002104`", ",", "0.7622588315663519`", ",", 
   "0.7713898321268348`", ",", "0.7641755561564605`", ",", 
   "0.7738482471463993`", ",", "0.7647985540914621`", ",", 
   "0.7690744014856744`", ",", "0.7652327499701215`", ",", 
   "0.7744057393401105`", ",", "0.7553972098254204`", ",", 
   "0.7803051762810836`", ",", "0.7655559829153676`", ",", 
   "0.7694003927542181`", ",", "0.7675428485496436`", ",", 
   "0.767252570793876`", ",", "0.7586814673956316`", ",", 
   "0.7767348465102574`", ",", "0.7729105813268987`", ",", 
   "0.7629841733456987`", ",", "0.7691942205872861`", ",", 
   "0.7641097768350271`", ",", "0.7724262411957292`", ",", 
   "0.7640797575395035`", ",", "0.7606250539905774`", ",", 
   "0.7775864353204749`", ",", "0.7651137373543853`", ",", 
   "0.7692663109886424`", ",", "0.7677293346441358`", ",", 
   "0.7673957676695818`", ",", "0.7644402610055284`", ",", 
   "0.7707701451221853`", ",", "0.7629942811230962`", ",", 
   "0.7744185137870014`", ",", "0.7658608528822817`", ",", 
   "0.7683381369994831`", ",", "0.7661760100382952`", ",", 
   "0.7676479628766655`", ",", "0.7767727834332623`", ",", 
   "0.7629187760103486`", ",", "0.7509867284421667`", ",", 
   "0.7823116303165036`", ",", "0.773000218304053`", ",", 
   "0.7597500998907898`", ",", "0.7670255693545881`", ",", 
   "0.7656351081765229`", ",", "0.766225550403424`", ",", 
   "0.7688339638320286`", ",", "0.7643908734224414`", ",", 
   "0.757922173039569`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.720146440493102*^9, 3.720146498294066*^9, 3.720146570385024*^9, 
   3.720146606841536*^9, {3.7201466395877237`*^9, 3.720146651296315*^9}, {
   3.720146730327156*^9, 3.720146735005526*^9}}],

Cell[BoxData[
 RowBox[{"LF", "[", 
  RowBox[{
  "0.114`", ",", "2.411`", ",", "0.7673128870135113`", ",", 
   "0.7742951462428858`", ",", "0.7715631990959222`", ",", 
   "0.7709559531070869`", ",", "0.7674493034856964`", ",", 
   "0.7684220988166247`", ",", "0.7676283432751239`", ",", 
   "0.7749785217376207`", ",", "0.7630226085002104`", ",", 
   "0.7622588315663519`", ",", "0.7713898321268348`", ",", 
   "0.7641755561564605`", ",", "0.7738482471463993`", ",", 
   "0.7647985540914621`", ",", "0.7690744014856744`", ",", 
   "0.7652327499701215`", ",", "0.7744057393401105`", ",", 
   "0.7553972098254204`", ",", "0.7803051762810836`", ",", 
   "0.7655559829153676`", ",", "0.7694003927542181`", ",", 
   "0.7675428485496436`", ",", "0.767252570793876`", ",", 
   "0.7586814673956316`", ",", "0.7767348465102574`", ",", 
   "0.7729105813268987`", ",", "0.7629841733456987`", ",", 
   "0.7691942205872861`", ",", "0.7641097768350271`", ",", 
   "0.7724262411957292`", ",", "0.7640797575395035`", ",", 
   "0.7606250539905774`", ",", "0.7775864353204749`", ",", 
   "0.7651137373543853`", ",", "0.7692663109886424`", ",", 
   "0.7677293346441358`", ",", "0.7673957676695818`", ",", 
   "0.7644402610055284`", ",", "0.7707701451221853`", ",", 
   "0.7629942811230962`", ",", "0.7744185137870014`", ",", 
   "0.7658608528822817`", ",", "0.7683381369994831`", ",", 
   "0.7661760100382952`", ",", "0.7676479628766655`", ",", 
   "0.7767727834332623`", ",", "0.7629187760103486`", ",", 
   "0.7509867284421667`", ",", "0.7823116303165036`", ",", 
   "0.773000218304053`", ",", "0.7597500998907898`", ",", 
   "0.7670255693545881`", ",", "0.7656351081765229`", ",", 
   "0.766225550403424`", ",", "0.7688339638320286`", ",", 
   "0.7643908734224414`", ",", "0.757922173039569`"}], "]"}]], "Output",
 CellChangeTimes->{
  3.720146440493102*^9, 3.720146498294066*^9, 3.720146570385024*^9, 
   3.720146606841536*^9, {3.7201466395877237`*^9, 3.720146651296315*^9}, {
   3.720146730327156*^9, 3.720146735012916*^9}}],

Cell[BoxData["125"], "Output",
 CellChangeTimes->{
  3.720146440493102*^9, 3.720146498294066*^9, 3.720146570385024*^9, 
   3.720146606841536*^9, {3.7201466395877237`*^9, 3.720146651296315*^9}, {
   3.720146730327156*^9, 3.720146735018619*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"processdataplotsmultiexp7percentage", "[", 
  RowBox[{
   RowBox[{"{", "corrdataclassfinal", "}"}], ",", 
   RowBox[{"readcorrconfigfile6", "[", 
    RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "1", ",", "0"}],
   " ", "]"}]], "Input",
 CellChangeTimes->{{3.721098349413968*^9, 3.721098349915257*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of data: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "41", "}"}]}],
  SequenceForm["dim of data: ", {41}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.720678756083688*^9, 3.720679098212495*^9, 3.720679171159223*^9, 
   3.720679276278612*^9, 3.720679336999907*^9, 3.7206796705010853`*^9, 
   3.7206798233154078`*^9, 3.720679960862331*^9, {3.7206799965499496`*^9, 
   3.7206800089779463`*^9}, 3.720680047583005*^9, 3.720680112122644*^9, 
   3.720680154265918*^9, 3.720680597692483*^9, 3.7206810031693687`*^9, 
   3.7206825777505836`*^9, 3.720684515965987*^9, 3.720684585573718*^9, 
   3.720684646788583*^9, 3.720684780390971*^9, 3.720684950301311*^9, 
   3.72068519375809*^9, 3.7206854018543653`*^9, 3.7206854704250402`*^9, 
   3.720711299045362*^9, 3.7207117269780703`*^9, 3.7207122456459227`*^9, 
   3.7207130881992702`*^9, 3.72071764207288*^9, 3.720720182887279*^9, 
   3.720720278877294*^9, 3.720720905578414*^9, 3.720721032205325*^9, 
   3.721098055678149*^9, 3.721098351244479*^9, 3.721098596884348*^9, 
   3.721143464942238*^9, 3.7211437582149467`*^9, 3.721143858792585*^9, 
   3.7211778493883753`*^9, 3.721178721732436*^9, 3.721179023975519*^9, 
   3.721179060664522*^9, 3.721179139080368*^9, 3.7211792182278767`*^9, 
   3.721179297489375*^9, 3.721179337908765*^9, 3.72117939612984*^9, 
   3.721179847524909*^9, 3.721179938631817*^9, 3.7211799887490463`*^9, 
   3.7211800473363123`*^9, 3.721180096369959*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"exptlist \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "101", ",", "102", ",", "104", ",", "108", ",", "109", ",", "110", ",", 
     "111", ",", "124", ",", "125", ",", "126", ",", "127", ",", "147", ",", 
     "201", ",", "203", ",", "204", ",", "225", ",", "227", ",", "234", ",", 
     "260", ",", "504", ",", "514", ",", "145", ",", "169", ",", "268", ",", 
     "535", ",", "240", ",", "241", ",", "281", ",", "266", ",", "538", ",", 
     "245", ",", "246", ",", "248", ",", "542", ",", "544", ",", "249", ",", 
     "250", ",", "565", ",", "566", ",", "567", ",", "568"}], "}"}]}],
  SequenceForm[
  "exptlist ", {101, 102, 104, 108, 109, 110, 111, 124, 125, 126, 127, 147, 
   201, 203, 204, 225, 227, 234, 260, 504, 514, 145, 169, 268, 535, 240, 241, 
   281, 266, 538, 245, 246, 248, 542, 544, 249, 250, 565, 566, 567, 568}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.720678756083688*^9, 3.720679098212495*^9, 3.720679171159223*^9, 
   3.720679276278612*^9, 3.720679336999907*^9, 3.7206796705010853`*^9, 
   3.7206798233154078`*^9, 3.720679960862331*^9, {3.7206799965499496`*^9, 
   3.7206800089779463`*^9}, 3.720680047583005*^9, 3.720680112122644*^9, 
   3.720680154265918*^9, 3.720680597692483*^9, 3.7206810031693687`*^9, 
   3.7206825777505836`*^9, 3.720684515965987*^9, 3.720684585573718*^9, 
   3.720684646788583*^9, 3.720684780390971*^9, 3.720684950301311*^9, 
   3.72068519375809*^9, 3.7206854018543653`*^9, 3.7206854704250402`*^9, 
   3.720711299045362*^9, 3.7207117269780703`*^9, 3.7207122456459227`*^9, 
   3.7207130881992702`*^9, 3.72071764207288*^9, 3.720720182887279*^9, 
   3.720720278877294*^9, 3.720720905578414*^9, 3.720721032205325*^9, 
   3.721098055678149*^9, 3.721098351244479*^9, 3.721098596884348*^9, 
   3.721143464942238*^9, 3.7211437582149467`*^9, 3.721143858792585*^9, 
   3.7211778493883753`*^9, 3.721178721732436*^9, 3.721179023975519*^9, 
   3.721179060664522*^9, 3.721179139080368*^9, 3.7211792182278767`*^9, 
   3.721179297489375*^9, 3.721179337908765*^9, 3.72117939612984*^9, 
   3.721179847524909*^9, 3.721179938631817*^9, 3.7211799887490463`*^9, 
   3.7211800473363123`*^9, 3.7211800963939857`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of data: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "42", "}"}]}],
  SequenceForm["dim of data: ", {42}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.720678756083688*^9, 3.720679098212495*^9, 3.720679171159223*^9, 
   3.720679276278612*^9, 3.720679336999907*^9, 3.7206796705010853`*^9, 
   3.7206798233154078`*^9, 3.720679960862331*^9, {3.7206799965499496`*^9, 
   3.7206800089779463`*^9}, 3.720680047583005*^9, 3.720680112122644*^9, 
   3.720680154265918*^9, 3.720680597692483*^9, 3.7206810031693687`*^9, 
   3.7206825777505836`*^9, 3.720684515965987*^9, 3.720684585573718*^9, 
   3.720684646788583*^9, 3.720684780390971*^9, 3.720684950301311*^9, 
   3.72068519375809*^9, 3.7206854018543653`*^9, 3.7206854704250402`*^9, 
   3.720711299045362*^9, 3.7207117269780703`*^9, 3.7207122456459227`*^9, 
   3.7207130881992702`*^9, 3.72071764207288*^9, 3.720720182887279*^9, 
   3.720720278877294*^9, 3.720720905578414*^9, 3.720721032205325*^9, 
   3.721098055678149*^9, 3.721098351244479*^9, 3.721098596884348*^9, 
   3.721143464942238*^9, 3.7211437582149467`*^9, 3.721143858792585*^9, 
   3.7211778493883753`*^9, 3.721178721732436*^9, 3.721179023975519*^9, 
   3.721179060664522*^9, 3.721179139080368*^9, 3.7211792182278767`*^9, 
   3.721179297489375*^9, 3.721179337908765*^9, 3.72117939612984*^9, 
   3.721179847524909*^9, 3.721179938631817*^9, 3.7211799887490463`*^9, 
   3.7211800473363123`*^9, 3.721180096417718*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  TemplateBox[{GraphicsBox[{{}, {{{
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.7, 0.2, 0.2], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[FilledCircle]\"", FontSize -> 5.625, StripOnInput -> False],
              TraditionalForm]], {0., 0.}], CompressedData["
1:eJzV1E9Ik3Ecx/Fnz1rCKCLJlZrlDhaMPBRCBMHzXIq6RBMWFRQlWEaJQSyI
dWnRIaFgFUmXrq0NCQtTNqOMICL7o1FQsgykQxdZZj6tyZaHvX/B97JguT2C
Hl78eL6/z57f7/l427pa252apvkdmjb/p+nz//nz/kbfTteTjS5rsHZ92sAP
1obu+Q5+N2oC/cm+k7pax3L9eu/z5ne3p42qVNPwlmD+MetYrnsDmYvND3/8
Xd+fWGXFZ5Q/PI0k62I/jd2bc+fedmXVPMw8zDy1XpiH5bzJNeu+7o3NGq7P
7gujKUvNw8xT64V5mHlYzjt+Y19gz1VLOetf7o92/1Lu7j3dubono7w909T+
KPrbCAePVU3cmVF5MHnUeiEPJg8mDyYPJg8mD5Z5OibqHPGPWeVIdkP0fW7O
GDnVv6t6JK3yYfJh8mHyYfJh8mHyYfJh8mGZr/WAe/auJ2fUh+udR658U3kx
eTF5MXkxeTF5MXkxeTF5MXmxzBu3bl0Obs0r1zTMNXo3aaanb2xFyDup8mLy
YvJi8mLyYvJi8mLyYvJi8mKZ91MslT6U0Ew9UR2ejoyr/TH7Y/bH7I/ZH7M/
Zn8s90+9Ortt2Q6HeW28ZWXbiTE1HzMfMx8zHzMfM1/2K+Z7l32Kua9qXfTl
v/Yp5n5g7kepfYrlPO4blv1Xqb7Fst/s0q+Y+2f3fsV8H5jvY7H3Leb7xnzf
i72Psfw9rqWeMw2jDtv1NZb5QgPJgc6j+oL3OWZ/zP70O+ePOX/6XJr7gHnf
9DXrWK5zHpjzKNbHmOexfJ73iXmfxfoV8zyWz3MemPMotT8x87Gcz3ljzvt/
9yFmPyz3435h7le5+w2TB8s8tW96br7O62al+wqTD8t8z9yDl0L3nabd+guT
F5O33H2GyYPJQ1/x/jDvjz6SJj8mPyZ/sf7BPI/l8/z+UvsIy3m8T8z7XOh+
wnI/zg9zfuXuKyz35/5Uuq+wzDPU8nJqKrrEtFtfYZnvy4vDQ75hl1npfsLk
w+Qrdz9h8mDy/AEc071y
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.2, 0.2, 0.7], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[FilledSquare]\"", FontSize -> 7.5, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}], CompressedData["
1:eJzN1D1IVlEcB2B9zQIpIkkrzcjBBsmhCCII3ncpaokUjAqKEuyDCoMwCFsy
GhIKrEhaWjNFwsIMNfogiMg+NApKzEAaWsS+ND/QXJ4bnAYHSx3u8HC55/c7
51z+uSVlRaUpSUlJwxNP8sQTm3jGTxeuzN+c+vDO8opb+bu/xvlyw9OCN9e/
xTOKm1obj8T+cm7x0NmCu9//vN/Zsniw/kd8Xnfeo7Xl4w+85/D9u8fVrVl1
PyP3Ll3xeXvdQOSDV3YUb7s4GN+6ZuzU67KRaD22HluPrcfheiOFCwprq35F
rmo4fmxJzVA89WPamY7uwSiP5bE8lsfyWB6HeRuH8krv1w5HPtSTlVz/fiRe
WX5gXs+NH1E+y2f5LJ/ls3yWz2F+9ciq2rdjo5GLdqUN3Mwci7cfbdqS3t4f
9WP9WD/Wj/Vj/Vg/1o/147Bf/eC18+XrxyNn5IyuzF2dlMiuzE7Zd+FL1J/1
Z/1Zf9af9Wf9WX/Wn/Vn/Tns/6Guu39Pyx93vzi5Yf6m5ERmY+fCitzeaD9s
P2w/bD9sP2w/bD9sP2w/bD9sP2w/HO4ndW7miZyO5ESsJb3yW3VX1I/1Y/1Y
P9aP9WP9WD/Wj8N+Fc2tzcf2xxKXutYtKjncGeWzfJbP8lk+y2f5LN98d//s
/s3z0P4Hdt7mtfccvncf7D4mm8fsew6/d57sPCebr+x7Dr93H+w+pjo/2foc
ru++2X3/63nI8jjM83+x/2u65xvrw2GfZa9qrr4cjyVmel6xfhz2e5J271zF
7ZTEbJtfrC/rO93zjPVhfcwr58fOzzwKrT/rz/pPNn/Y9xx+b/9TnUccruc8
2Xn+7/nEYZ77Y/c33fOKw3z/z0zPKw77tK173tdXOycx2+YVh/0+Pdvblv8o
NTHT84n1Y/2mez6xPqzPb4eH42g=
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.2, 0.7, 0.2], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[FilledDiamond]\"", FontSize -> 6.75, StripOnInput -> False],
              TraditionalForm]], {0., 0.}], CompressedData["
1:eJxN1GtMU2cYB/BDz5oGmFpYaCAERzXYadgFYiCOsXO8UMfiBSdRNBlqnawb
NcQiyoCJLa4C4jZgmInajYqBbdniomJ0Lm3VuU2rE5niLlycmOo6yo6H2ng4
tuuX/9N9eD/8ci7P/3ne8x6toeKNLSzDMLWRFRNZishasrv6SdbeBNf8STtj
mPRycGCd8bGe9XFTy7y/HHtBTdfhpsNPevyvRq+fvzBaajzn56aZs/MGrNPo
ftjgvuycyPWR1x99K7VRiN5vWu66lG4VuNp49ejZ/jjXPG/Js8NjXnJB57mV
Ey/5yHgePpFSJpQ0R5/3cidMiy0i+Zvt/OrXiwJc693K2kVBlWt44Umm6x8v
Wbbp1o7P9ZFPczOT1ff85OaBzy7UNwjk3uPMnsFdItkTUzjnVGv0/WfjLLnj
jiAXrluVPk+vpHnA6AeWxjI+etfvJ9/88YzZUC+QC/NzDrTuFMlpS7daCg4F
yJ45WrexP1rvz2TW9KJG4rQ938vVi1mqD6NfGPVh7AdsGNTt6DOL5DW6I0rN
pwFyuWr884//CJJPz0y81ZEZre+917Ev1iBzI2afs743hvLAyANj/jDywMgD
15fUsY86AmTkgfc31tmLF0jk24V///WwIZrnylNvamu2hTjVUIY7uyrs/LLm
56lw2EvGfsHIByMfjHywUJpw5mZ7gJzo2NhaPBwktxSr3L6XJfI6/uuKOxaZ
3N20Qu27HOIKs0LvXa+YcmJ+MM4jjPMB4/uFkQ/G/OCf2nTdxqEg+VejOuc4
J5GVM6xvn7TJ5BTzDnbl1f/l05QvWdrO8MrhOEv/UJDywpgnXHa/86FdPUFG
XrjomZZN45UiGXlh7Dd8yTXVp18okS8qvzBXNclkzBM2JeXHbzjA8NaqMtVI
zyTlhZEXfvT09WLhjp+cmZm1Od8mkDFfGOcFRl4Y84XjY3c5MpplctzsoqQ0
T4ict2y6Jq8zmnfzse8SDqoUvMd06rVEz7/0fcL4n8DJ2ipT1/siGfOEkQ/G
POHZ67f6Ptgnk7vC5weTboTIadlfVTOHGMqzvG6v1Fug4FOtqezG/Q+cInul
xmESORj/M9h2lN3GjwTJqA+3GCpn6T+UyWPd2+933w6RG/piq6cfYaje4/Ty
UttaBa/59saMWu1d6hdGvzDqwZNiZtuWNpms7FsVOzoQIuc6nlfuifQLz2IG
Cto3KPgH5TtTDut+c2a847YLORIHP9fG5f3QKJPtoxd/330tRP7kmsQtirwP
XvOK3ujYpOD/Az66A9I=
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.6, 0.4, 0.2], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[FilledUpTriangle]\"", FontSize -> 6.375, StripOnInput -> 
              False], TraditionalForm]], {0., 0.}], CompressedData["
1:eJxF0WswVAEUB/C7u9Yr2VGiNEwyjBRmStNj1b2TJsmgZFmP8YiNZEprdpXo
IYqw6SGmVDKG9MClYqTuDnlVmF56SJIR67nW7t3L2pUve/bD+fCbM3P+/5lj
e+SkP4+BIAhnaWhLQ1+a4q2pTUY9huLpt0+/vlaOoloX3P0b0es0iTZoXLbj
bnri9lShC6ddAt458N6vRqnb75564UWsmgE/FAxwQlxnweH2lYH1+xVo0hM2
WluKiDNMnYMDLo+Cg9I2TFg3ToBJy7BNyUlS8JhDFmeDSAbe53TJSVghB7tG
hK1fR5DgysMesZ4/KbQle3PHliEVER4fuysIl4CNbnZ9vjcyCVaZexkOLpsB
/5ri+wrtZ8HT1QFyY0wBHusNzEoMUoIHR00OV5+aA29zN9oYkKNCmb+NL37s
VxK+L2/1OGdKwB0mn+z4jZPg+53NbWyFFNxnk9Bpw5oF85VGOasdFeBhTrI6
A1OCBZZRx91D5sDs7+M3Pyfp8jnW+rbCPDW4KlI811++iKYLjhoMVMgJ7T+0
dhHl896JJ8CtolJFjFAKtl4sIRrzZbp9SiHV+1gOLhijOla2kOAYmf/TP78o
sFl3ir8zOQ/ui/TOyWSpwVltmMOgo66fXYGf90gJgmnNv90gxp/RsA8JL/av
+CAlDp6OZjd4S1GtLRN3BzsclYF/FEhSn5+Tg1vJaya8IhJ8UO9vaDBOgTOa
hE8q3s2D2/k/d2qGFsDP8jpa49UacGfayIG9OQj0yW5eTqcX6fpN3ag2xMro
2Nr0tYzIPAmxcox1vclXhmqdacqrMjgmB1/lGiZGXSTBZ7j9+JU7FFhV48/l
PJ8H1z+SuNV3LYDTsqP1xv9pwHua9aO/nUcg/1BtFfNBLg3sdQpnehTp+nly
FbE7yhmYBf6JddZ2iDhB7mhX00hUa4XyVUadFQUu3PLFQ+Q2D17DSDRl+y2A
19VYcX3iNOC4UXNuGYbA/a7zpf98fWhgA333UFoIHVyK45SGp+tzobeYfi9J
D6M3rkiXXe8jhhUR5pn8OVTr1cllD1m5KnCFBS2+vEwNbjo5LDB4swge5HSL
fo8jcO/Etjp1KkUDywXMqktMBviOoC5EY6bLvz+ZwMdsmNh/vD/Bfw==
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.8, 0.4, 0.], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[FilledDownTriangle]\"", FontSize -> 6.375, StripOnInput -> 
              False], TraditionalForm]], {0., 0.}], CompressedData["
1:eJxF021MU1cYwPHbNyiO0akMnA4iEonWgcvs4qTMezOWARKKQyoFjMCw4hgR
LGvZsIyJsIFIJ2MoYeoUCehE4AIKQfQ2ON4caKYb20TeZLy0UKylvb1taRlf
+twPz4dfTvKcf3Jy/D7LjJGyEARJXh3G6jBXpzxRo8wffEP9dsbEtS/5c+jF
95Vdbo+56pe/Nfx1z0y78ucXScN8HVhgquALGvRg7g6R175eA7ipbSQ8bdyI
djiCPsAFbHWfUhEk7tOAg8d/j24268B7F29HEG++Al+Vj4sTdi6BD2+9cbA9
3ARuOFk9NZNiBkemkFqXXAuafVOIttQg6kKPwPjY7+bAcXnbF3w6F8Ck96F3
crL1YG1AsXi7ygD+hH+ar6g3gncmHdqymSDBNw6EpoU9o8D/jWVG+S9ZwYGh
Q6p33e3og5L3+ndN2YjD6WkfxuEasFvF0NNLszqwzTOCO/naK/DzRZlIsXUJ
/LIp1rgGM4G1wweLs+LM4Mk59wNNJyzg3SFuO2JLbeB6L0Z6XS3doyXuhOTc
W0E5Y2tO/TFqJkR3fnocWKQB97s/8Zd16sCXB7p7hSY9eMQ3Y8CXtwSWmd1K
N2wzgafFOfZCzAyWe6d8EZJgAQv/ma94mm0Di31c/BRldnBjstoyWkf3hbXo
2cETCFYgP+o6Xm8knO/rdJDqnPShegHco6oxHVHowT4rV4jOcwb6PPcCNfyr
EVyppfrXPyDBRwwxDRPPKfDaR7kxgaQVPJIcWVrEs4OLe7GAyW0rYP/K6MjZ
K3Sv7HyHGr/FwAYzboevG9QT+79KFXZE6lGnvbP2xgccNYD/rdQo274xgnvI
H9ylVSR4P/tFYjxOgQu7FDfrH1rBfbJnwY6pZfCtsv6edLsDPJA3u+/jUgR6
SrpfZzKr6L7FH5u4WC0T21SwiZVcpiHWa3nlXSID6nSRh7TR9XMj+IyEm5Vy
igR/LRnFv6+mwLbmGIm4zQpuv64RtA8tg/NKUtnzMw7wR90uqX/nI3D/py2N
nF/OMsARJ3BOaBXdFyYxpe2pY2Fe+BPeSb8p4ji5p8/OIFGnTea7ha0bKfCF
XX+GqgRW8FusLA9h9DJ4c/NGSdQxB/jYnKekFkNg/1B+zYwoigF2dQlJZCQw
wTU4TjmkdM+3wxeZl7LZGLNzXYGhfISYNiV5FsksqNMbcmqv8s7awM7/6nRX
5rTc9f4KeFL8SDU2j8C+47tb7UqKATbKOY2nOSxwtbw1wbGWvv+yLkOG+XKw
/wH7Khvz
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.7, 0., 0.7], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[EmptyCircle]\"", FontSize -> 7.875, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}], CompressedData["
1:eJxdzU8ogwEYx/F3m8XrgHbg8CpWTg5T/pSS3lcoR7m4OEhxUlpy2lvyXkRR
a7ntsjk4OG2ltAi5MMvi4CKWXtIcGK12WL3zXr7P4T08h09P/b7hpbW55YCi
KNPu+dzzu3f3nu3tuu24LF0dqE6+rGNzoj8WT1T05Ih5phZb5I+9/4FU8Ueb
rIoPbfU+/VsTL+R6dsdTdf3UiYxmhptkD7OH2cPsYe/e9v531Jlt6OvHY3o2
rcg+Zh+zj9nH7GPv/te5+Zbf9BnXO4M3Q3b9gh6mh+lhepgepofpBV9btx5e
atLD9DA9TA/Tw/Swt5fs7mtE5wOGtbHSXDqqSh/Tx/QxfUwf08f0Mf3C6slM
qFCRHqaH6WF6mB6mh729j8+2p6lI0NAsLbC4V5YepofpYXqYHqaH6XVmHttj
YVv2MfuYfcw+Zh+z78+FrL/4s+xh9jB7mD3M3j+X8075
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.7, 0.7, 0.], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[EmptySquare]\"", FontSize -> 9.75, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}], CompressedData["
1:eJxlzU8og3Ecx/E9e1qrMWwHFw4mLjuoLbk4PMu/rOTfAQcHFEVqmdTWFOag
kYWcFnHRlJPkstKmHBwUplZaQ0lruUiyMjx2ef8Oj8NzePX8vu+PbczTPy7r
dLqB4icVP33xa1v0/ThWLInxoXCTPpFTCl3Z64OGin/+2g2vjYbeFLPX2XwX
NIv/WPtf2j66n2r/UAIlFU+xW5N4j3mPte/t7otIbT6vbD7PBlryRnGPucfc
Y+7V+b4ae4dB3GPuMfdYe29c9S9f7hUUW/Ts29cqix6mh+lheljb+9z/daR6
VOXR+xpfOJREH9PH9DF9TB/TN2bqz51zapw+po/pY/qYPtb2vXJ36caC5HI7
fv03noLYw+xh9jB7mD3MHmbP8GBaus3kxR5mD7OH2cPsYfYwe8G5CeNj9EP0
MX1MH9PH9LG2fzIcCdl6ZdfV9Gmn9epN7GH2MHuYPcweZg/vVNepM4OyqypY
JY+s50Qf08f0MX1MH2v7L9myVFuDwVV5nCwP2J5FH9PH9DF9TB/T18eswffN
tOhhepgepreVbrSMTSbFe8x7zPs/JrS/sQ==
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.7, 0.2, 0.2], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[EmptyDiamond]\"", FontSize -> 9., StripOnInput -> False], 
             TraditionalForm]], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGBQA2JGIGYC4vtdL54EhDMdWCD2OSeQ67U928KM13cW/dmv
yq9rtb37o/3c7tsbON5/3C9Y+WdR85Nv9v2njrx/+YrtQLduMHfs1Ff2MP0H
O4zcQ+59hOtfbGe78c7jr3D9u2IZ1xfZ/Ybrf7Z/8+ulh97D9Z888njn9NIv
cP2SSZ2KO6t+wPXPZLl6rOvKX7h+g987ZBSOvIHr/3B91Ve1b5/g+o1WNot9
+f0Nrj/kXepxk7A/cP3C3wsNVPZ8guv/37Yj5IL/d7j+6txPrC2hv+H61ZV6
D80OZ3DoD9gw79lzvgOybTcXH1j1Cm6eV+bNlcVBX+Hm/ZFUOnzk6U+4eaLz
d5uHvv4LNy/vpXPq8kWMDjD9c60irprpfEToN2V95XDgK1y/9vp9n/4c/QnX
n6a2Kkha4b89zD0BXPYhUYKv4e6ZflX83Z9WhHtmHX3anSL5C26eJfPmzDT5
f3Dzol4EHqrYwwj3nzrr9x2S8h/g5n39vrtls9QPuHnLnwfOurT+D9y80N32
b09FMTjAzPtSyrqumZXZAQAE52O4
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.2, 0.2, 0.7], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[EmptyUpTriangle]\"", FontSize -> 8.625, StripOnInput -> 
              False], TraditionalForm]], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGBQBGJGIGYCYmEbNoPIeMYDk/Z+/e+j+ca+Z4JTaaTxz/2f
Tjfdtb/5yf5wgHllBQ/rgUcbzsjuePHGHqZ+0//wv5cUPsHVZzg8+VPx7Ju9
yKGP90JjOA+8P7Lm6t7vL+D656yfeevu6Q9w/WtL7dLvl3+B6+f8HjHH1f4n
XP30K3ZK/+e8g6uv2bJyUsYfhH1zT+Ryrzr4HW6fV1C6yl7xd3D9HJukMyZG
f4brn7g8mHcGx3e4/s7HIswa537D9W8MvKR9M/kjXP+d7HsT5mz+CtffbXM7
TibhJ1z/JeuXHg5q/+D6m3Lf3sjyeAvXf47pbvizL5/g+jcfbQ6JWfQNrj9T
/ZCWZzrCfvOTR65934gIb6uEizdPMX6H608oul+tvu4XXH/jqVtiSiX/7SdG
v6ypPyNwoK5/1YXZ01/CzSsL02DM4vwKN+/YkRlBfRE/4eY912vN02f7Czfv
fPKyTe+eMjgAAAIlADQ=
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.2, 0.7, 0.2], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[EmptyDownTriangle]\"", FontSize -> 8.625, StripOnInput -> 
              False], TraditionalForm]], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGDQAGJGIGYCYtHQrbs3ZjMd0Jyc5qwk986ebWHG6zuL/uwP
eryxQ0fzs72Dbo69e/HH/Uxe245/PPjDvv/UkfcvX7Ed4Cu9POF87Dt7mP7q
1AqFc2s/w/Wfu9JxXOTkd7j+VXsUHf7F/4XrF3yZuHXe9Y9w/d+LjxlwRHyD
6+faIP0zs/AXXL+7SvT9DSwMDjD980K6Vp7vfg/Xzzhl9c0s1y9w/Vnzjxcr
xf+A65++Z325//e/9oHefqbTdfkOqJptmWBn/wruHpUfwZP9kr/AzdMKywt5
/+gH3LyNvQrq9X//wM1bvTLsSpUXowPMvPXVwS9+TnkPN++Z7fX/hbzf4ebN
X7ea/3TPb7h56xIO/Ly77D/cPF6ZGDbnBUxw89b+rmnUSXgBNy9AuCfxbfFn
uHkm6x59SPryHW7e/ecVinV8CPdx2vZ2ulxmgJuXs0nvxYyLH+DmrTcwdc8T
/gE3b3/F5njRyX/g5u3eVXOwO4zBAWZenH/52guKzHDzdqy4N+Nf5We4ee+m
X2y+sOcX3Lz3199Iytr8h5sn+PbJNIvVjHDzfm9Rv3OyjMUBAA4qUbM=
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.6, 0.4, 0.2], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox["\"\[Times]\"", FontSize -> 9., StripOnInput -> False], 
             TraditionalForm]], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGBQA2JGIGYC4tMnv39fmMx64Jl5rcxCu2f2/7b2sX+fynig
e/bPrD233tp/+fb1aOaPH/vnqz2RX8T2xf5z0MS363s5D/hdjPCPNnpmD9PP
Fn+pR7zrHVz/qeu9preEPsP1M27YfuSV9g+4/sL/t7N0v76C62c+tjPLZclH
uP5FyuaP9xR9hes3DeQJZej5BdfPzNf+qWnZc7h+n27mq3I/38P1r1II3VFw
CmE/+zWXVWceI+yXZNCQEfzwHq4/I28TX53iF7h+T28Bo0fvvsP1G7N2PLjF
8df+rlnUnzOCAgd4anJ/WjY/h5v39QxT3+3wT3DzuiI4ChIbv8HN8zrgrNPl
/wtunk3s3zyLzP9w/SekdbPrtiHcw3r/gIgXC8I9OfedPzheRrhHb+fXpD1v
/sDds65/hULs1Vdw87QFW77N+P8Zbt6EZAY5E80fcPOmXJ2+bvf333DztE4y
/FzTweAAM299dfCLn1Pew8276h3GJB//DW6ebvAx3cKuX3Dz/r2aY7kn/B/c
vD11XdrPdjA6AAAV+2J5
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.8, 0.4, 0.], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[CircleMinus]\"", FontSize -> 6.75, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGDQB2JGIGYC4indG/uSlJQPpEb0mTEdeGn/8yh7zH47RTj/
ctRe7f4r8nD+gv/9M7sWSsP5ir/u/Tn4VPFA147A0+bK7+H6YfzV/TzyCZYK
cP49t/yfQelycH7hlTPhXG0ycL5x79vvjgck4fyXFpd5GG8oHKjTrv31/cFn
e4eKL1aaEgg+zDwYH2YejC/NdiQqgkkKoX7fk1/9NuJwPsx/DDNq2K/If4eb
B+PDzIPxFfU9flvnScH5Ex8XVzt9F4fzI49K7ImdKwrnn/SZp3VmjeyBurzP
h97t/I1wH5QffuZf9j8PKTjfWeHPjxpFCTj/qyvfjMpfYnC+xer1sg/Pi8D5
zzU/VRoGCGOY9zy/XXZeAoND0o4NloduS8D5MPNg/OA5U6SrDEXhfJh5MP7E
6Jc19WcEMMw78FdNo1+VGW4ejA9zH4wvGrp198ZsITift8jI+nITL5wPs/9e
65K3WoasDhWW35s54gXhfJh+s8dHOLblscP1w/gw9c1Fk+wvvOB0uGqWXuLY
yQ3nQ+KH/cCqSnFO53Q+BwDj/3Mo
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.7, 0., 0.7], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\[FivePointedStar]", FontSize -> 7.5, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}], CompressedData["
1:eJxd1XtczXccx/FzOrUlXSVShsxlx9jCXKbp/GJbLqNWTaWwhNBKZMloxJw2
2mRC0yiPpdSykVzWyq+biolHRbZKc0mdnE6d2++czn39473H4/PH+4/nP9//
vp+X1/ptQRsFPB6vf2j8oVkNTe5q/sblczOru/RWeHqkRZT8+ElTU70RdiuO
3Rj+jgF2yZr4847jOrhsT+7WeTotLN7XIri2TgPHLPn4WUqvia08sLRK3mIR
nVIpXQMCjTCzLDvaXKqHW4t6VhZ76uA3elImCw5o4VEjs1o3SzjYq3LNntg9
JlYdFuLEePGYYas/re14YoD9Fr5fe9JfDzv0zGu1uzgI/9ahrFrnqoVNaRvy
K7/i4OMNzJEFziZ2r/bbOtdQHlMzf9uctTsNsKaxgdO26eCdN+wXBvkNwsm9
MaHnCzRwnyR6c5wjB9uZwyyB543sje/cMsVHeMxld+9nXfYGOPXZTZkwUQdv
yNn3WeTfWjhhy+vXLvpq4EohczcqXw2nv6Zc+43IyE7fHepedJPH3Drnm9t4
Xg8fE86Xaobr4LRZ6+/Z7NDCiu6sMPk/HGzpVPonidTw88w3at7tMLAJKQ8L
f5DzmFWqR+KIxXq4fKaifW7hIJxpbJDOcNTCSbOd+Q5JHOyxUnjauV0FM2X3
x6f5KWFhV+38un0G1iz3sWofx2c6w0OfLH2h+98+duPTPhmE/0xUtDRc1sCP
EpqrvcZw8BmZKCT7axW8yDsl39ylgE93PFAljzWwqdajT7YG8pmF7bev+aXq
4Klmp+1VEi3cHZi/ShiggXNjp0Z+clUNl46YFHDdQwX3OqY97k9VwJOfv2l7
pULPzj0eP+ezfXxmsYMk7dBkHdxy9vnkvsNauGDahjtuSg526BkVOT9MDdcF
Vv6696YSbj6y2+ruJAV8oSTj4CqPQXbU9Q9fZjRZMTnlMhdBqgYOz9s7q7db
DSdnWIvtVqjg4mon92lXFLD/poDIL8fI4TPXL56o4MlgB09zxq5GLXvIZtXY
6YNWzFaVyu6d2Rq4IJyT835Swx5VttW1FiW8vWGRdddGBRzybvFA+qkB+JFv
psh1Ux88a3jKYZ/9WvahNmq78zgBE3ejNvNuNwfPtO+Q8leq4TyHxCWyK0rY
/MvthfYeClh2sIP3AX8AXhxWkfPxPSlccG5qRrxMw96JkpbfixEwh5rbfMqD
OTgzuDcuu0wF/9DXlBcyQQn/kXXENlEsh7u9vzyd3iaDs5cNm/I4/yX8Ld8q
dsJDjnVMntdUpxp6P2ZBjaePGtbP3u908JwSnrKoSDnTVgEfLXHLPdvRD3+d
675BVCiF6wSSA7OSJLC19+2sqKCh+2IY8bv/VWuGf9TF870/lPCegQsRzeMU
cHXqxOx/hw3AywO45fZ/S+FFWWt8RuRJ4JT+EnNdwgu460Sj8OF+JetestKm
5owN43a0qMi1Rw7nmR882/RzP/x2veuZkC1S+LJ4S+fqORL4bFZFXjL/Bewp
4Bjr+09hRydj8IN6Gds/TluRnvMaE1HlHD888yVcaF1qtzWqB7Zo8kcmzuiC
f3k/7Qu+/gnsnlvmH3e0Haa9pD2lvaU9pr2Oikj53tpggWkvaU9pb2mPaa9/
v8msaztogWkvaU9pb2mPaa/3/rlz/C03C0x7SXtKe0t7THtt/tH9RUOBGaa9
pD2lvaU9pr2eY1o3I1pkhmkvaU9pb2mPaa/FGdMrTvxjgmkvaU9pb2mPaa//
rd4fwSSZYPHmuGJHZwtMe0l7SntLe0x7bfNRoe+nHiZ4x3rhtKEvD9Ne0p7S
3tIe015fji5f71JqhLfMHc0vCTDDtJe0p7S3tMe01xNEo++IQ42wcK6se5fC
BNNe0p7S3tIe0153dnuqjFd0sMjH9fvmFQaY9pL2lPaW9pj2ujGEix4fo4Nb
nnYcO2nRw7SXtKe0t7THtNdt9UF3Ssfo4Ff365VpL2lPaW9pj2mvL8nfs+0T
D8LpCsOFQi89THtJe0p7S3tMe90ZvDT0q3gtXCYW6Ifb6mDaS9pT2lvaY9pr
z/h7reekHDxpY57qx0NamPaS9pT2lvaY9nqzpDonyFMNn/SNDfO+ysG0p7S3
tMeav44F+6XI4dYP8gISRivhmjRxRv0lFfwfiV2LTQ==
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.7, 0.7, 0.], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[FilledCircle]\"", FontSize -> 5.625, StripOnInput -> False],
              TraditionalForm]], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGCQA2JGIGYC4kr+jWe2NzzaH8DyKDpy4w974dA7zt5eL/d/
Dq+pCuH8Zd+W3njzz8I3+33dnhXe2fLb3tPiPNf2e2/3S1hNLUzK+Wv/p8N1
kZ7G+/1ve09M2Lf9nz1/b9ysU4Uf9gdP3bXCaOF/+845J+q3BH/cLyr7R0FR
h8GhkeOrvsvrj/tjVum7hLcxOPz8xXedg+fT/oLaqyv7PjA46Ezbufza94/7
cyrniz8uZXToNtplGLrk4/7pzw9IVMsxOUhkFE2rEPu4/1txr9/Dw0wOsdF/
7/F2f9g/h7tJ0DWS2cH++zUPSbEP+1/EC/Ka/2F20IgJOV/i92G/0l7r9cwT
WBzurQ/aI2zCewDm3xl7Y3L9NLkOwPzrkTDZYudy9gMw/0YePiR/agHrAZh/
de7e+RbHzHIA5t8J/BOLFVczHYD5V20Gz90ZzYwHYP4VuO/AfraZ4QDMvy/i
rh7/bfsf7t9l4gFW7tZ/4f69wPHs4NbXv+D+nWa2L/3Lkx9w/66X02zwl/oO
9+97uwlGB5i/wv37UODYqQXVn+D+BQBNMe4v
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.7, 0.2, 0.2], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[FilledSquare]\"", FontSize -> 7.5, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}], CompressedData["
1:eJxFl3k8VPsbx2fMGcYasqSQpZCUKKmkc4iUomi7UbQobhEpFa3WVLJEm1vp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          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.2, 0.2, 0.7], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[FilledDiamond]\"", FontSize -> 6.75, StripOnInput -> False],
              TraditionalForm]], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGAQA2JGIGYCYgMNTsWH/9kPXHV/YsnTI+jwZ5rlohklbHA+
y13zpMT3LHB+z5RCK29XZjg/5s+29UXbGeH8Wsl1LwItGeB8puvHTHdf/LMf
xp+3371ZNvYnnD8zco1J88cvcP7yBZf/OXV/gvPD5Er/com+hfPXzHb+aLqP
E27+o9mZKXM9ueH8EEkT/SnneOD8rHW1f+9U8MH56mHWV2xYBOD8q8ezNP4c
QvAN7JQbuFYLwvm3l6se4ewQgvNfRPdNWLFIGM53OJdTaGsjAuefNJq0KtlG
FM4HAHlynZk=
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.2, 0.7, 0.2], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[FilledUpTriangle]\"", FontSize -> 6.375, StripOnInput -> 
              False], TraditionalForm]], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGAQA2JGIGYC4vyozkqvNRwHrro/seTpEXT4spFxo5A6O5zP
VL+727+XFc6//Gj2rfWfmeF8T159hwl5THD+7uSHHQrXGOD8WVIGd72v/N0P
N/++1ELRPz8R/F0WH4TVvsH5co/nzd9V/gnOZzdd+cLZ6w2cr7R8vt6bPC64
+XZTOb4s+8wN5x+NCFrS0MsL5/tvSynzVOdH+E+rdglzmACc/0tjz+pYZUE4
3+Ra2X5JSSE4f1LXpuNJfMJwvsPj+7VSLCJwPn8qn8vS9wi+YWgGkxmLGJwP
AJMemxs=
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.6, 0.4, 0.2], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[FilledDownTriangle]\"", FontSize -> 6.375, StripOnInput -> 
              False], TraditionalForm]], {0., 0.}], {{{-3.0940068428223313`, 
          4.386765389021055}}, {{-2.894078619827491, 
          4.386765389021055}}, {{-2.6939993778795506`, 
          4.386765389021055}}, {{-2.483987072728617, 
          4.386765389021055}}, {{-2.3039860739096736`, 
          4.386765389021055}}, {{-2.084253098677058, 
          4.386765389021055}}, {{-1.8944568674663975`, 
          4.386765389021055}}, {{-1.7042981934580606`, 
          4.386765389021055}}, {{-1.4342248948774405`, 
          4.386765389021055}}, {{-3.2941383093687477`, 
          4.386765389021055}}, {{-3.49397078181451, 
          4.386765389021055}}, {{-3.694093021166824, 
          4.386765389021055}}, {{-3.904054835778969, 
          4.386765389021055}}, {{-4.083998270167957, 
          4.386765389021055}}, {{-4.30432512701003, 
          4.386765389021055}}, {{-4.494523665901028, 
          4.386765389021055}}, {{-4.683996966534062, 
          4.386765389021055}}, {{-4.95401869367736, 4.386765389021055}}}]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.8, 0.4, 0.], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[EmptyCircle]\"", FontSize -> 7.875, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGCwAGJGIGYCYhf1b4lpKhwHFPWqWxx5hRy07Qwb94ezw/mu
l9QlpbrZ4Px03tVLePaxwvnh/T81Ij6ywPmXJ/fNildB8B3fvJ06I5wZzjdZ
vfHOrS4mOP9bbfK6b/sY4fyZ6xmW6n9kgPMNX/foG6gi+LObKuVUNvzbD+N/
4Rf+eUr8L5yvwVE1sbb2N5z/e+m1rxaPf8L5UUYJX056/IDznd1fnhHf8A3O
T/6eLiQk9hXOr+x9f9yi9jOcH7u8V7720Uc4/6RbnvhJjw9wftDmK+y9cW/h
fJnDP68Xab+C8wW61RUX/HgG51+d80Oz7OhjON+u/91Kq0kP4Hwbj5Ai0b23
4Pzviawhb8KvwPmH3Hc0ln5ExN+a2c4fTfdxwvlW1wuc/nVxwfleoqLG78O5
4fz/C46JHlPhgfP5azPnJn5E8N99epKzZh8vnF/J8k0jp5sPzt++cdVr1Qh+
hH69rJVxQgJw/rZjK52WViD4KbMiBCTvI/jXHgg9VHQThPOPVj0/9ng1gr+N
+X5Ck5AQnF97afXutRUIftAxrjrG+wh+YlNfQL2rMJyvJHBN6/ZqBF8yp5bL
VkgEzu+Pvb1kRQWCbyVvUCd0H8GfcPbK2k5XUTj/vd3TdWdXI/juMg8/pQqJ
wfnzLmyZdbYCwVfRjtzOeB/BTxVnOVPpKg7nAwC7TFA6
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.7, 0., 0.7], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[EmptySquare]\"", FontSize -> 9.75, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}], CompressedData["
1:eJzV1Ps/VHkcx/EZJre2q6WZQRFZsZNit0TLMRpL03YRyu6WSli0TeWSNhvx
CIWQbM1IbXTV9OjhthjsOexuSaUl2tEjPYwwxowZxpg7s/3ic/6Gfvj8/n4+
Xud8HQ6zQqKNCQRC0ccjfjyjjxe3l3j0XRoJ+/XG6xZrgSWi8EzaXRVhjGFu
9Anuyc+RHUxP7poNRthGyegA19QKycGGDElUIsYqOE2xLLFCDP4d6aIRA5qR
7KfwdrZG9mVfDPepmkUP/zkon6uzRmLiHd3YoTq08PXSvBfbViDLd4j3EC00
aEr1ysthAysQwcKKzMU9StSc3jG+I4GMbAuXcQ6eVaA1/hcyNQYysv8SW+eL
yNEHyW/9ygopyC2/4udWQhlKKMm5yF5NRcxvHmmPiRWjI/JaL6yGiuy/wglP
+HcUtaNfO5jMsEHCeGlddcgQet92TXT0fzaIz7Gz4uawHlTk4fDUWmuLYL2N
Z/5KMwL/U0UsUxVBBL9pYJaasJ4A/ofut7r4G+bQeX99K88xb0QH/kNfruN0
PtCAv+qYBWN2jwr8i1Q9Lv3mM+BPmStimXXLwd+xaysSe3YS/Jy/GU906RLw
b7vP5NCEQvDf9mRVBsV8AL+a8PAe+9YA+F9deNbXltkL/uOXn7NNGivA35pl
t+n3YGPw88tNgry+MAK/nSo00HEW9y/Si36RvDSAX+pI+/Zaxiz4mfmN67q2
6sA/FmNtx5Oowb9d9p7wW4US/N38Ehv/BAX4g9Uqj3qyHPzXE1/LNdUy8Nu4
SCLKqGLwhzadak5ij4L/5uOd3stIQ+B/cTegmCV8C/7GbEvhlg947xssQwcf
w3tT86qO0q/i3jyyQ7ZqDu9dHdVyeFmdHryRrw7YF6dqwatZax41tAr3Cl5E
jvLe4L1r3SUeV29Mg7exYLfWlzkF3rDS4Z/oFCl4nV4l7rydIQJvyNGCyGHD
MHi/+aezJTF+ELyfmo/GZT56FLwA9josdpmNdSbB3sGTC8d+0OPvD/V83hrB
KP7+yOrpghiMgM3vnfKhN7cHGGCvMsHlne2EHvYau+QGVFZqYS+j/dzyong1
7L3pEZJDoihhb1MTVXmnfxr2irv642byp6AHZf0DGwZHCj1YCTvtiknj0CPw
7vs+beIIfH+UBkuaSysf/j+3vpN/PAk2BT+jQVYa52wC/qbN25M4ehL4QzHb
E+wRY/Dvql+6aTtqBH5aZE+3uIKIzfslSVIPaQoBm/fH8i+5bq6YA/+5Joah
L14P/kr5li1BFC34s4XN/bS3KvC3rJwhlxfMgD+1iJRt8d00+Lm6J1K60RT4
2zrv9jolT4B/0vHeKf6BYfBb+aJHsDQT8K8s/HGgKGIB+Csrrq2+4o77JQ35
02Nk3H+CcrzqZzkR/M1Rglz7NwTw16xwdXIKM0D/ieiNjx+ZzYJfXMAc+L5b
C/4yXcyqvelq8D+ztxaFIErwJ6XKuHcU0+Dnti8hu9ZOgT+r0blO0C0FP69W
pkb9x8Ev/GrZ6KEPuHcwjtbnheHe6wNVoslS3NtjGecemI57q5Ulfvsi8N6u
w71Cng/eW3niDIW3BO9t6elbOvkG91bXm+VeKdeB9/ZpEX8tUwPeIwmBpMTP
8N7d41KE0aYA73Dpy7V9GXLwyofKvIu+ngTvp+b7Hy+sgcg=
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.7, 0.7, 0.], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[EmptyDiamond]\"", FontSize -> 9., StripOnInput -> False], 
             TraditionalForm]], {0., 0.}], CompressedData["
1:eJztlVlTk2cYhkMSIVhFaSTJl4AVcUG0g2CpqATfggQVB2hAwVYWFUTEDxrw
gLh0BjrghkXKoqUZxaVUKjigGBCF9yPoICriEoZAQCwWJCSMWQm75STvQXrA
geOoMx48P+C+536uy3FXEj+WQiKROqfOYurIUxeSGujvDKlEk3CDV8wSOnhM
0rT5/EIhIo/xFNy7dHDdzW5IJiAT6Y1hEaNb5gHPQB/D3TQLIjBl7qGCe/OA
JL3oik8JiQgR5XEOutmB2eOKg6rmtzDplBCj59oBY6E413/vJLSqdxKtUNmB
qFab8civJqCmih/i5M0A9buVBQNRY7CwpN7XUMYA+3ll+08/GoGEzepayZdM
QPGIfJ43YIRZNW86Ik8ywan+hqe71w3BnFcph3yMTFCUsHTHlpt6WCoNF8rD
WWB79BFBY5AO+tEo4/oKFphZs0n8e40GvryvtMWZGLjiRG22p6ghRXqhzTsD
A7wHXlZHVCpIkiYKEvoxwFgp+auvWAEfWLSsXfo9G0SXCvu7eX2wxSVEPrOW
DR7QXriCrh6Y5nHc4OHCAU++6C6RZHdD/fzneR1ZHCDt4jusDW+HQWOFwu1q
DnD66XipjfV9WFUYn3X6nj343Pe79f1z0uWzvgMvoLhRPbT+DAesEIsyHLXN
sFm2Njmg4P33e7jae0Zb/QRcJHjaPmLHADdfltP9NGNQ1LJ4k+UJBhDgvX/M
DR6FnsCJDLQMIDx31P9A6zDMdKua3xbMBDEJPGrKLCOMCrgD7kiYwDlmeZgy
2QAdmzRHPZexQMY54/lLkzpY//CiV3QmC2zMfyKLKdHCXdXlayRyFsClTy1X
4hpoW3kby3HBgI7qXOZx5A1kdK2vOVCAgYKd6t5UnRJW3ya3pFixQck8n9Cw
8H74uuJwqv4gG2C6PbbuWC+clc1NqO1hA4jz9Ul35RDn2dIrmzifXH/yiGdG
Mt0Acxf09gd/N/0em3iJzKaNaihTF12qTfn/Hs37+dB9mP/nzhzB6tiIYYhf
3mWVmTj9nrLTYPVIsQ72LbxkiBWxQFx1zmEuTQtd37rdUFIwoOBHd3TtG4ST
WxkOJ2XYR88n8/zmfDL/n7OPW69v11qhPPhv63P3iS1RHmc+bTP9zxkoT7ac
62G4QUV5kpcN2lM7KSiPqipL18+iEKY8Z/NDvymMIxOmPKQlq7bellgQpjwO
7quKRa9IhCnP4tGvtTibRJjyOPgJ8QT+JOKt5YW9ys6L4yhPYadUl2o/hnhr
3Uo8shKPoH1X8MbZdxyH0b5fB9J8S+OHEG8b5Aa3bZ16tG/WQp3z4Bod4m1j
0OzMtBMaxNuaDZTiHVffIN7+LSoNG85XIb/hMRG9UUIF8hv32PlKY0sP8tvn
vt+t7ycvPL23+aiQ36ICem+5b/oX+e199+vxbZdzOp1MmHiEpwZ39C23IEw8
KisSlct+JBEmPu/JdGVg694iPv/TKk64mjKBeBTec+Zee/sY4tFm0Wt1aOwo
+s/kIO6znjkjyG+80AvKW1Ij8tvEnDpcsGgI+S2Ocz9tMlqP/BYdP7sNy9Ui
v9FyHkq6tWrE7wWLZNvirg0gv31q/f1ApnIHU8eQ36bbo6+/4hGzfAj5zXyP
5v186D7M//N8pc21yoZJxPfp9lT3a1xg3axR5Deaq8Jla+Iw8ttLlwBrd3sD
8tvHzifz/OZ8Mv+f/wAqX4+E
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.7, 0.2, 0.2], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[EmptyUpTriangle]\"", FontSize -> 8.625, StripOnInput -> 
              False], TraditionalForm]], {0., 0.}], {{{-8.532306829226286, 
          1.2424239907001886`}}, {{-7.1308988302963465`, 
          1.2424239907001886`}}, {{-7.600902459542082, 
          1.6094379124341003`}}, {{-6.214608098422191, 
          1.6094379124341003`}}, {{-6.214608098422191, 
          2.0471765810925606`}}, {{-5.298317366548036, 
          2.0471765810925606`}}, {{-5.298317366548036, 
          2.6490076604684267`}}, {{-4.3428059215206005`, 
          2.6490076604684267`}}, {{-4.3428059215206005`, 
          3.2386784521643803`}}, {{-3.4420193761824103`, 
          3.2386784521643803`}}}]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.2, 0.2, 0.7], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[EmptyDownTriangle]\"", FontSize -> 8.625, StripOnInput -> 
              False], TraditionalForm]], {0., 0.}], {{{-8.955698153602603, 
          0.8046885552928528}}, {{-8.685611843041201, 
          0.9360933591703348}}, {{-8.403864506109235, 
          1.0698698198024557`}}, {{-8.05031945517943, 
          1.2424239907001886`}}, {{-7.819058469345253, 
          1.3540294005326152`}}, {{-7.523941418405954, 
          1.497835735852798}}, {{-7.284632930238389, 
          1.6094379124341003`}}, {{-6.878196476740593, 
          1.7776605448485534`}}, {{-6.529318843261892, 
          1.9033008439609624`}}}]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.2, 0.7, 0.2], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox["\"\[Times]\"", FontSize -> 9., StripOnInput -> False], 
             TraditionalForm]], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGAIAmJGIGYC4rm8y26+KhI8wLoq6JpOj6CDY7hux7XZAnD+
TqZd71Q7+RF883q5zbd44fxznEVThHV54PyrC3l3M/BxwfliyzasOqXDAefn
tR5OureRDWHeEiG7hp8scH7+4qiD/8yY4fzOW4nr/zMzwvnnq2Qv608QOKCo
V93iyCvkwPxlc+LMt7xw/pLL71882MkF588PnJnzpI0dzr/73l9uaTALnJ9z
Lex4liIjnP94iuxh/Tu/98P4DrvOy7c7foLzh1p4DTX31v8vXV7kJQTnb2+w
4+5VEIbzqy1eX1n1HcHfVP/a+/A5EYR733DzXloqCudvCGbxNNwqBuf3uc29
dWapOJw/neeHtFqyBJz/OHT/9W32knB+d2vtpysKUnD+r3yWefFW0nC+5kdW
W3stIXj66W0qmRBzWBjOrxFZO+9PjCicb7m0PmXJNzE434TLztVtggScXz5l
HzuLlhQiPb9edCb+sDSc7xzC9GenphycP9TCa6i5FwDSViEU
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.6, 0.4, 0.2], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[CircleMinus]\"", FontSize -> 6.75, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}], CompressedData["
1:eJy11Ps7030cx3FszGazMSrnRHfhvquRllDfVKSD3Jrq0kGJuRxyWHcHrQtN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          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.8, 0.4, 0.], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\[FivePointedStar]", FontSize -> 7.5, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGCQAWJGIGYC4pxrYcezFBkPKOpVtzjyCjnEKjcF2zn+2g/j
O+w6L9/u+AnOP3acde6vhidwfpkTi5azMtMB1lVB13R6BB2MUkxatrj92Q/j
Z/2erubm+gXOLzul+WdS5ws4/1FG/evzwhcR8lQ2r3zKPnYWLSm4/86H+tqd
15SB851DmP7s1JSD83ctTp3yQ0QBzs8/ddRBd7UU3D1qggbbT66SgfNPC1fJ
XV0lB+dHnFycURSqAOe3S/E9yg1VhPOpbR4AJEy3fQ==
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.7, 0., 0.7], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[FilledCircle]\"", FontSize -> 5.625, StripOnInput -> False],
              TraditionalForm]], {0., 0.}], {{{-2.2672179491567546`, 
          4.386889790339869}}, {{-1.7672619976276676`, 
          4.386889790339869}}, {{-1.2669126040998102`, 
          4.386889790339869}}, {{-0.7667937207282438, 
          4.386889790339869}}, {{-0.26683423993894284`, 
          4.386889790339869}}, {{-6.667164814064207, 
          4.386889790339869}}, {{-7.166785108860756, 
          4.386889790339869}}, {{-7.666828609658249, 
          4.386889790339869}}, {{-8.166888494485349, 
          4.386889790339869}}, {{-8.666853965970644, 4.386889790339869}}}]}, {
        
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.7, 0.7, 0.], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[FilledSquare]\"", FontSize -> 7.5, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGCQAmJGIGYC4gDdOyvaDnAcYF0VdE2nR9Dh82uPX5vV2OF8
5e5CRqZeVjjfbXtnXMFnZjjf8JWIXEI0E5z/fqvTw7QDDHD+lpDw2er3/uyH
8cXWC7i8e/YdzteZO+fB2c1f4PytUku3b234COevO6TF8Wv2Gzi/k/mD0fc3
T+B82emr5hxovwjny90yeHw9kgtuv91Uji/LPnPD+UcjgpY09PLC+f7bUso8
1fnh/PaX3/LTEwTg/BfBleVCuoJwfvVdme2ZYUJwvtDlYwvjJwvD+fkLmis1
E0TgfG95b5PfOqJwvkVQyOZNPxH8vHV7GJe/F4Pz92io2k0vkYDzAVVxtp4=

          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.7, 0.2, 0.2], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[FilledDiamond]\"", FontSize -> 6.75, StripOnInput -> False],
              TraditionalForm]], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGAQA2JGIGYCYmGp6sT95YIHWFcFXdPpEXQw3Kh29fUqATg/
/cickLw9/HA+y//I5++U+OD8Bx1Bc+07eeB894ht243ec8H5prW7pzCGccL5
k9VK2wP2sMP56kk9JuHvWeH89rn/fa3eM8P5Wx5psoruZYTz9ZkZCltchOD8
3d8FfF0FheH8G+YMH/jvIfgZYs/ufVwlAucv7j+sNLdcFM5/0/z4+DQXMYR5
DmcyigXF4fy5Jd/m6txD8N+69ppUHpGA8xuEw2P3H5GE87Nkj82NuCcF5wMA
LvSUgQ==
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.2, 0.2, 0.7], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[FilledUpTriangle]\"", FontSize -> 6.375, StripOnInput -> 
              False], TraditionalForm]], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGDgYmRgACIGJiCuCHjhnafJcSDLPI+vIVTMoXUWy9tMLvYD
DRzGdZ+fiDn80bxmpMzMdsDvXMCR5RniDjP4fDUC+VkPPGXaXjbpkbiD1KZl
G2YosRxYcyWi8naEhAOPv3yjiRvzgW3XP5sIHZdweFv2L9+kgOnAp8WRB+SN
JB3uF73eX7+C8YDYXftdJdMkHVZOUDzi+5ThgOE5lR28PyQdUgJFr+5SYziw
TJa173KYlEP8gyo7rxf/9v+L7krX3CDl4LtBdE5/79/9F9OPeEiySztUPlk4
b4Lxn/3psr1FF2KlHU63f77V+PLX/iCRPZrH10s7HNz2Se3K6p/7w8OKZ2X8
l3aYYFTAY1HwY7/IicqwOj8Zh0uHWGdr237fb6iZyig/W8bB/4FrnaLIt/22
QSmH0p7KOETqHuGrfvdlv+CXYzpX9WQdMg7/3adx8fN+m8WZxz+Wyjow9gtK
m+z8tD+m466I8B5Zh26jXYahSz7u32qpuEaaUc6h6luzTP7UD/t/MF9w/uYi
5xDRvDhlvcj7/YcvG2lOaZdz2LLh+74jTG/3C3uv0b51Us7hSUG/51bm1/v3
ee72usEp71C8ZeKlGQwv98dvqv+s5yXvkBZntD+f8/l+9YVvP3N0yjtIfk4T
NJJ8uv/ZKt0vGsflHa535E1+qvd4/9aFvCY2TAoO/ZlbV2p7P9wftv0KX7EC
kB+n9y1T+fb+6dLOEzljFBwmZj4wOmd2Yf/VI9v7sjcrOIymh+GVHtDjezR+
B3f8Mlhavma/em9/w47gjga70fiid3yh56/R8Mcf/ujhuenW7RdzNHng4XVc
gNF+Axc3PLz03vx4kcLMBQ8vDcvfZ7z5OeHhNWvq9uM7lTjg4SUgyByT4sYO
Dy++71stDQvY4OF1rOWla/tyVnh4/Wa0+FfxhAUeXuL+J4RWqrHAw+sDYwMj
fwnzAVh47V9w7pDSMaYDsPB6nmz0PE2S6QAsvJabbXJiLWU8AAuv3ckPOxSu
MRyAhddCf8dVh80ZDsDC60Xc1eO/bf/Dw8vl7tfHZiL/4OGVONcmb877P/D0
evqY6o2bl37D0+trcR+5iJ2/4On1WttW9x1Lf8LD10ChZqXCtB/w9Hp53mPV
N13f4eWLTs9J1fVN3+Dli12hw9mZTV/h5cvH4lmnghu/wNO3yOfd9zpbP8Pr
j7CHH40n9nyC1x+qd7z2npj2Ed6eOCnMw75o6Qd4e2L5eWXdvxPfwuuX/KOZ
nWbSL+DtidH0MLzSA3p8j8bv4I5f5zjjnKbM9/D2xGh80Te+0PPXaPjjD3/0
8AQAHJes3Q==
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.2, 0.7, 0.2], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[FilledDownTriangle]\"", FontSize -> 6.375, StripOnInput -> 
              False], TraditionalForm]], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGBwAmJGIGYC4obDyYXy1kwHFPWqWxx5hRy2Pt6j8N2SEc7f
vWtWyQMrBjhf7YP5E4fif/th/FudGxM+l/2B8xcbymqqFv2C89dN/Mz2qPQH
nG9U72T+r/AbnD83mYuFufwLnK/UHmPaWfQJztc3PdYYX/YBzjeYznkq7ckb
OH+z99xr79+8gPMvus452/L4CZzPXC6+XvzNAzj/7ZSfj2acuAnn/+pYcN5g
/mk4f9GLjuWSe5gOsK4KuqbTI+gQuZ2hRGQvA5zPbsu07WrF3/0wfrqs5yyj
yp9wvpfHL3f9yq9wfnzTeW+Nio9wviLLuQXWH57B+dpm/ip79p+G8wfafrH9
F6ZlzpGEx/eku86HWOWk4PzXc/tXn5yD4HNrHRMTlJOG81m8AlXz5yD4xkfc
hWpkZeD8mOeRablzEPzflhu3N8nKwvmGfqwJXXMQfCWltqBSWTk4375c7FLd
HAS/692WSW2y8nB+2dmLDTVzkPivbWae41OA89evFJng4Yfgf528Iu5KH4I/
5+qvC7PeIfjzDu+enBsnBQ9/nqXse3XipOF80+P7ExjiZOD8L1FLWpTiZOH8
NdPjrNXi5OB8C9OuCZpx8nC++cmFNmr5CnC+6iH/mxz5inD+QNsPAIPQo6s=

          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.6, 0.4, 0.2], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[EmptyCircle]\"", FontSize -> 7.875, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGBQAmJGIGYC4g+MW67F+jAfUNSrbnHkFXKI97nZpu/NBOdv
bwm3LPNlhPMn9ySvafJigPOz2r4ZPJ35bz+M3++przlv2h8437bP4vrlGb/g
fAOFmpUK037A+Tu2Mq3QmvUNzn+2ef/Z3ilf4PySTk+1pTM/wflV35pl8qd+
gPPbo44L9Bq+hfMDDsa039Z8CedfuOV0dbLRUzjfReLiyRrNh3D+n+9L5jZE
XYPzdXlDvI+oSsH9tyX+6MLoZQh+INteQR9VaTh/nfTPFxrLEHwTxT5VFVUZ
OJ+52X2e+jIE/++2/8ccVWXh/GuPA8s0lyH4xvocP31U5RDmWc/cZr8Mwd+8
e9VsZVV5OF++hEXEahmC/0XyYeZ0IQU4/2oo63TpYAR/4yNl77WTEPzj4e3X
lS8j+Pyfn6p+MFKE8wHXf8ss
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.8, 0.4, 0.], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[EmptySquare]\"", FontSize -> 9.75, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}], CompressedData["
1:eJxN0VtIUwEcx3E1vFWmRiZGAxXJ9EjL8trxbGd6nNq8rtWsrGWmCdlFiIy8
UFgYYhRZguW8VwePLLOibMVx6zgbtKAaGivnFW9dhYo0hHzx/+/h+/B5/P/+
AYdPKvNXODg45CzluJTTUgPjCUodu40O2FJ6UeaxllYOc++fsNvB1/5+UfSx
EeDyfC/PbjYS/MxVPNvHRoH3NQ+XCmw0OK9+UmNgY8DJYT2feDYW/CM9o9zI
7gDvTxLnNbAk2N+we7WRjQM7XTUreZYCn81aozOyEvDj2mmXl6wUbMu0TatU
NPhQ+W23HCuaC68+mquSgZtDTrpprP85Nnw+VxUP1oUMO2db0QtBUcF5qgTw
XnvCKY0VbfK1V+WoGHBLxK3sXCu6XWvTkUwi7dyhHAir8aZnv/lbpAK6LLtj
LpaRgz/y8RKpgN4qM7+PZJLAxtCm76SAjvQaEzYxyeBWuV9xtIBu/O6TRTEp
4B/1vLtUQL+r40ooZie4WKLOEgvowugCFckowFFvTtm2C+iVtyo30EwqmO46
8Y4S0OEVB1spJg0ckm8fpAR0kWvf7xgmHeycN15NC+iJop+OJJMBTlHcXLof
Hb9O439YTfYu7y2ff/U0UR0HTo/0F2g1BZb0Xw+l1RKwVHS8Sq6Wgnft0VQ0
EjRYVKZQt3Ho+72va7SEDPxBuWewmUPXruDCO4l48AXNRrOWQ79YXXruHpEA
tgb6mpo4dN3mu6vaCQY8d8PJpOPQfxav2JuIRPCxnojKOxzaxn91byLk4F/a
nrZODv3W6OvaQiSBAwsfNrRw6KniaPduIhk8f/nJBi2HLrccNHQRKeCa2REN
r0/pXf5HdeVimoXcCXZuH3nO69EPTo8LPKkAd9oDJg16tJsbE9pPpoJn6COe
g3r00G734H4yDXw+Y5Ng1qMv1RAaI5kOjqGCPSx6dLX3jt8GMgP8+Yx5vUmP
9uMXXs+IMsFTI0mm0QNon3kL9VmLDqz9OTc6hH7hO62cEmWBFyWZHaMH0AWe
MvGEFl3yyOft8BD6VZDYZUykBP8D7yU6Gw==
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.7, 0., 0.7], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[EmptyDiamond]\"", FontSize -> 9., StripOnInput -> False], 
             TraditionalForm]], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGCwYWRgACIGJiDeYNVdp8nCd2DjJ6n5VRnCDnwiOT/n3uI5
EPXptpnqX2GH9RaL9e5d4z4gtPZq5oc6EYfX5skPBDdwHTCbfCTDU0jUYXHu
m6WKqZwHrmrkJC7bLupQEfDCO0+T40CWeR5fQ6iYQ+sslreZXOwHGjiM6z4/
EXP4o3nNSJmZ7YDfuYAjyzPEHWbw+WoE8rMeeMq0vWzSI3EHqU3LNsxQYjmw
5kpE5e0ICQcef/lGEzfmA9uufzYROi7h8LbsX75JAdOBT4sjD8gbSTrcL3q9
v34F4wGxu/a7SqZJOqycoHjE9ynDAcNzKjt4f0g6pASKXt2lxnBgmSxr3+Uw
KYf4B1V2Xi/+7f8X3ZWuuUHKwXeD6Jz+3r/7L6Yf8ZBkl3aofLJw3gTjP/vT
ZXuLLsRKO5xu/3yr8eWv/UEiezSPr5d2OLjtk9qV1T/3h4cVz8r4L+0wwaiA
x6Lgx36RE5VhdX4yDpcOsc7Wtv2+31AzlVF+toyD/wPXOkWRb/ttg1IOpT2V
cYjUPcJX/e7LfsEvx3Su6sk6ZBz+u0/j4uf9Noszj38slXVg7BeUNtn5aX9M
x10R4T2yDt1GuwxDl3zcv9VScY00o5xD1bdmmfypH/b/YL7g/M1FziGieXHK
epH3+w9fNtKc0i7nsGXD931HmN7uF/Zeo33rpJzDk4J+z63Mr/fv89ztdYNT
3qF4y8RLMxhe7o/fVP9Zz0veIS3OaH8+5/P96gvffubolHcYTQ+j6WE0PYyc
9DAav4M7fkfjh7rxM9LC88QayX17GQXh/t1Rv+FIUq4A3L/nnux91n+NH+7f
OUevLJHawAf37/6+wuDuVF64fzfduv1ijiYP3L/HBRjtN3Bxw/2r9+bHixRm
Lrh/NSx/n/Hm54T7d9bU7cd3KnHA/SsgyByT4sYO9y/f962WhgVscP8ea3np
2r6cFe7f34wW/yqesMD9K+5/QmilGgvcvx8YGxj5S5gPwNLP/gXnDikdYzoA
Sz/Pk42ep0kyHYCln+Vmm5xYSxkPwNLP7uSHHQrXGA7A0s9Cf8dVh80ZDsDS
z4u4q8d/2/6H52+Xu18fm4n8g+fvxLk2eXPe/4Hn79PHVG/cvPQbnr9fi/vI
Rez8Bc/f19q2uu9Y+hNefhso1KxUmPYDXn5fnvdY9U3Xd3j5rdNzUnV90zd4
+W1X6HB2ZtNXeH3+sXjWqeDGL/D6XOTz7nudrZ/h9floehhND6PpYeSkh9H4
HdzxOxo/1I2fkRaeALjQFyM=
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.7, 0.7, 0.], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[EmptyUpTriangle]\"", FontSize -> 8.625, StripOnInput -> 
              False], TraditionalForm]], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGCQYGRgACIGJiBWTW8/tMGR88DJKy2tpSdFHdoq3zMmSHEc
WDn/2QbtWDEHw0tHk7+Ksx/oK6tvsrkn5nD9g+21jVJsBw55r9C6GCPu8Nln
Yom5CuuBkluLTwjeEHc48/LcYVsPlgMO9+uiBd0kHDo2G/2aUMB8wJWD+c+X
jRIO6h1azXZrmQ4k/Hz+s1dY0kHtsLvfpHeMB258WLB4b7Gkw5PAUn4tQ8YD
U95WTZK/JOkgcN+B/WwzwwEmzmaLTg0ph8D96b1Sm//vD57qOn1drZSD1RP7
nK7Uf/vL56r+D7wo5fDyuPur6zJ/9ydOCdnmoSzt8HiK7GH9O7/3i64vPl9W
LO2w5N45w8qFv/a39gSfPH1Q2kHoxosu9cKf+8882HLbnk/GoefcvU2v3X7s
n6PncOVihIzD32/Ls/4rfd8/S0wzs3WhjMP+5Y1rFdi/7be7lfYq8YWMg5n3
uTr2z1/2Z7eq2BXqyjpY/djhkPXs8/6F03sk9hfIOiiK+X5bef/T/vBNGkkR
m2Qd+jdZSlpf/7g/e1vrvalfZB1OWBw8Wnj1w36vz2w8X0zkHIIPu05O3vZ+
f4S326/OYjmHMnOlD6373+4vXLhVJXSTnIPHeYl7LV6v90/mXPdDkFHeQenO
hzbVkuf7tXfd+X6lWt5hv6jt0QdVj/a33mTTS+NVcCjYKtreInJlv9zCo6EN
UxQcRuN7cMc3ofgdjc/BFZ/o8TcaP7SNH/TwHw1v/OGNHr7o4TfYwws9fND9
nzA1fn2rIy/c/SKTXrsVSvHA3X89MGvrd3FuuPvzlkuknpPigrtfwVzsaacK
J9z9xQ3ZzH4eHHD3Z+glH2orYIe738hn5rGQtWxw999XZxCRe8sKd//eZeWL
wgxY4e5/IdRpY9PMAo9vX5F73cI3mQ/A/MPCIrfnjCHzAVh8G2ZKLTvSy3QA
Ft+w8IH592nshktsgYwHYPHdy3YpRXoHwwFYfL+QY7q2VJnhACx/pQvdMRRT
+Q+P/4qfH97Ucv6D568ALp99c778geevlgXM1x89/w0v/9wr7Ny2PvgFL/8Y
u3/w3rz2E55+Kue1u5dc/QGvzzT9nk36f/s7vDx8f2T6uh33v8HbLyWn54gH
LP0Kr9+mBL/Mnb3rM7x+Sy6fzvbX9iO8/eJy8ai+DNcreP4eje/BHd+E4nc0
PgdXfKLH32j80DZ+0MN/NLzxhzd6+KKH32APL/TwQfc/AMKkOpk=
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.7, 0.2, 0.2], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[EmptyDownTriangle]\"", FontSize -> 8.625, StripOnInput -> 
              False], TraditionalForm]], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGBwAmJGIGYC4i7WRYlXGIQOsK4KuqbTI+ggw7Rizg1jQTi/
Xjnjp166AJzvU1tzPt2EH85XZy9t3TGLF87PzWZ6psvIA+crcojNVkzngvOv
CF4IXnOWA86PZlxVL2DCDufHJkg5F59lgfMdNsw/dsWYGc4fdS9t3eu0gtVV
+yzCveqPY3q+zBSG84M8e1rvpInA+b4zt7xuMxaF80PPiC8vZBCD83nfPriS
dhbBd/3A+lR5ljic/8Wk/NrpNAk4/+ENpo63xpJwfkbtRPW8dCk4fzLn9S0v
jaVH3Usn9wIAVhqrKQ==
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.2, 0.2, 0.7], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox["\"\[Times]\"", FontSize -> 9., StripOnInput -> False], 
             TraditionalForm]], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGAIAWJGIGYCYlaN25GzzjIfYF0VdE2nR9BhZ+z838LnGOH8
3U0SrJmz/++H8af3fpztPvs3nG9VplXPNPs7nF/tumbVmdmf4fwr3PN4gsxf
w/nvPL6XSuZeg/MH2v4PjFuuxfowH1DUq25x5BVyiPe52abvzQTnb28Jtyzz
ZYTzJ/ckr2nyYoDzs9q+GTyd+W8/jN/vqa85b9ofON+2z+L65Rm/4HwDhZqV
CtN+wPk7tjKt0Jr1Dc5/tnn/2d4pX+D8kk5PtaUzP8H5Vd+aZfKnfoDz26OO
C/QavoXzAw7GtN/WfAnnX7jldHWy0VM430Xi4skazYdw/p/vS+Y2RF2D8y1P
r9yyIHMnnD/Q8fP2FoPkjWdScPt+/LJQOftMGs6/xWEfevCZDJzf/XKH555n
snB+RtySSXufycH5fgUzau48k4fz6/Q/78zYrADnO0zf9qF2s+KBwWK/Lm+I
9xFVKXh62xJ/dGH0MgQ/kG2voI+qNJy/TvrnC41lCL6JYp+qiqoMnM/c7D5P
fRmC/3fb/2OOqrJw/rXHgWWayxB8Y32Onz6qcgjzrGdus1+G4G/evWq2sqo8
nC9fwiJitQzB/yL5MHO6kAKcfzWUdbp0MIK/8ZGy99pJCP7x8PbrypcRfP7P
T1U/GCnC+TMbYhuVNiP4Ax0/AIMrNes=
          "]]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.2, 0.7, 0.2], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[CircleMinus]\"", FontSize -> 6.75, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}], {{{-4.199705077879927, 
          4.787491742782046}}, {{-3.6888794541139363`, 
          5.298317366548036}}, {{-3.283414346005772, 
          5.703782474656201}}, {{-2.995732273553991, 
          5.991464547107982}}, {{-2.7333680090865, 
          6.253828811575473}}, {{-2.5257286443082556`, 
          6.461468176353717}}, {{-2.3025850929940455`, 
          6.684611727667927}}, {{-2.0794415416798357`, 
          6.907755278982137}}}]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.6, 0.4, 0.2], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\[FivePointedStar]", FontSize -> 7.5, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}], {{{-2.8958869385842747`, 
          5.991464547107982}}, {{-2.795734531747094, 
          5.991464547107982}}, {{-2.795734531747094, 
          5.991464547107982}}, {{-2.795734531747094, 
          5.991464547107982}}, {{-2.695775840226822, 
          5.991464547107982}}, {{-3.0957736277342174`, 
          5.991464547107982}}, {{-3.1958919884778254`, 
          5.991464547107982}}, {{-3.1958919884778254`, 
          5.991464547107982}}, {{-3.1958919884778254`, 
          5.991464547107982}}, {{-3.2957568692041583`, 
          5.991464547107982}}}]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.8, 0.4, 0.], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[FilledCircle]\"", FontSize -> 5.625, StripOnInput -> False],
              TraditionalForm]], {0., 0.}], {{{-2.995732273553991, 
          5.991464547107982}}, {{-2.8344641259578687`, 
          6.152732694704104}}, {{-2.6772785424354564`, 
          6.309918278226516}}, {{-2.5102244577722903`, 
          6.476972362889683}}, {{-2.3025850929940455`, 
          6.684611727667927}}, {{-1.984131361875511, 
          7.003065458786462}}, {{-1.6094379124341003`, 
          7.3777589082278725`}}}]}, {
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.7, 0., 0.7], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[FilledSquare]\"", FontSize -> 7.5, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}], {{{-2.945799904805782, 
          5.991464547107982}}, {{-2.795734531747094, 
          5.991464547107982}}, {{-2.8457617469776957`, 
          5.991464547107982}}, {{-2.8457617469776957`, 
          5.991464547107982}}, {{-2.595748829015065, 
          5.991464547107982}}, {{-3.045763207159556, 
          5.991464547107982}}, {{-3.1958919884778254`, 
          5.991464547107982}}, {{-3.145857732131629, 
          5.991464547107982}}, {{-3.145857732131629, 
          5.991464547107982}}, {{-3.395911377232918, 5.991464547107982}}}]}, {
        
         Directive[
          PointSize[0.003666666666666667], 
          AbsoluteThickness[1.6], FontSize -> 18, 
          RGBColor[0.7, 0.7, 0.], 
          AbsolutePointSize[6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
             "\"\[FilledDiamond]\"", FontSize -> 6.75, StripOnInput -> False],
              TraditionalForm]], {0., 0.}], {{{0.6931471805599453, 
          2.302585092994046}}, {{0.6931471805599453, 
          2.302585092994046}}}]}, {}}}, {}, {}, {{}, {}}}, {
     DisplayFunction -> Identity, GridLines -> 
      NCache[{{-11.512925464970229`, -9.210340371976182, -6.907755278982137, \
-4.605170185988091, -2.3025850929940455`}, {
          Log[10], 
          Log[50], 
          Log[100], 
          Log[500], 
          Log[
          1000]}}, {{-11.512925464970229`, -9.210340371976182, \
-6.907755278982137, -4.605170185988091, -2.3025850929940455`}, {
        2.302585092994046, 3.912023005428146, 4.605170185988092, 
        6.214608098422191, 6.907755278982137}}], DisplayFunction -> Identity, 
      DisplayFunction -> Identity, DisplayFunction -> Identity, 
      PlotRangePadding -> {{0, 0}, {0, 0}}, 
      AxesOrigin -> {-11.455360837645378`, 0.043497573741050954`}, PlotRange -> 
      NCache[{{-Log[100000], 0}, {0, 
          Log[6000]}}, {{-11.512925464970229`, 0}, {0, 8.699514748210191}}], 
      PlotRangeClipping -> True, ImagePadding -> All, DisplayFunction -> 
      Identity, AspectRatio -> 1, Axes -> {True, True}, 
      AxesLabel -> {None, None}, 
      AxesOrigin -> {-11.455360837645378`, 0.043497573741050954`}, 
      BaseStyle -> {FontSize -> 18}, DisplayFunction :> Identity, 
      Frame -> {{True, True}, {True, True}}, FrameLabel -> {{
         FormBox[
          StyleBox["\"\[Mu] [GeV]\"", 18, StripOnInput -> False], 
          TraditionalForm], None}, {
         FormBox[
          StyleBox["\"x\"", 18, StripOnInput -> False], TraditionalForm], 
         None}}, FrameTicks -> {{
         Charting`ScaledTicks[{Log, Exp}], 
         Charting`ScaledFrameTicks[{Log, Exp}]}, {
         Charting`ScaledTicks[{Log, Exp}], 
         Charting`ScaledFrameTicks[{Log, Exp}]}}, FrameTicksStyle -> Directive[
        GrayLevel[0], 18], GridLines -> 
      NCache[{{-11.512925464970229`, -9.210340371976182, -6.907755278982137, \
-4.605170185988091, -2.3025850929940455`}, {
          Log[10], 
          Log[50], 
          Log[100], 
          Log[500], 
          Log[
          1000]}}, {{-11.512925464970229`, -9.210340371976182, \
-6.907755278982137, -4.605170185988091, -2.3025850929940455`}, {
        2.302585092994046, 3.912023005428146, 4.605170185988092, 
        6.214608098422191, 6.907755278982137}}], GridLinesStyle -> Directive[
        Dashing[{Small, Small}]], ImageSize -> {{700}, {700}}, 
      Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Part[{{Log, Exp}, {Log, Exp}}, 1, 2][#]& )[
             Part[#, 1]], 
            (Part[{{Log, Exp}, {Log, Exp}}, 2, 2][#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Part[{{Log, Exp}, {Log, Exp}}, 1, 2][#]& )[
             Part[#, 1]], 
            (Part[{{Log, Exp}, {Log, Exp}}, 2, 2][#]& )[
             Part[#, 2]]}& )}}, PlotLabel -> FormBox[
        StyleBox[
        "\"Experimental data in CT14NNLO analysis\"", 24, StripOnInput -> 
         False], TraditionalForm], PlotRange -> NCache[{{-Log[100000], 0}, {0, 
          Log[6000]}}, {{-11.512925464970229`, 0}, {0, 8.699514748210191}}], 
      PlotRangeClipping -> True, PlotRangePadding -> {{0, 0}, {0, 0}}, Ticks -> {
        Charting`ScaledTicks[{Log, Exp}], 
        Charting`ScaledTicks[{Log, Exp}]}}, 
     BaseStyle -> {FontFamily -> "Helvetica", 16}],FormBox[
     FormBox[
      TemplateBox[{
       "\"BcdF2pCor\"", "\"BcdF2dCor\"", "\"NmcRatCor\"", "\"cdhswf2\"", 
        "\"cdhswf3\"", "\"ccfrf2.mi\"", "\"ccfrf3.md\"", "\"NuTvNuChXN\"", 
        "\"NuTvNbChXN\"", "\"CcfrNuChXN\"", "\"CcfrNbChXN\"", "\"Hn1X0c\"", 
        "\"e605\"", "\"e866f\"", "\"e866ppxf\"", "\"cdfLasy\"", 
        "\"cdfLasy2\"", "\"d02Masy1\"", "\"ZyD02a\"", "\"cdf2jtCor2\"", 
        "\"d02jtCor2\"", "\"Hn+9900x0b\"", "\"H1FL10\"", "\"ATL7_WZ\"", 
        "\"ATL7jtR6\"", "\"LHCb7_WZ1\"", "\"LHCb7Wasy1\"", "\"d02Easy5\"", 
        "\"CMS7Masy2\"", "\"CMS7jtR7v2\"", "\"LHCb7ZWrap\"", "\"LHCb8Zeer\"", 
        "\"ATL7ZW\"", "\"CMS7jtR7y6\"", "\"ATL7jtR6u\"", "\"CMS8Wxa\"", 
        "\"LHCb8WZ\"", "\"ATL8ttpt\"", "\"ATL8ttya\"", "\"ATL8ttmtt\"", 
        "\"ATL8ttytt\""}, "PointLegend", DisplayFunction -> (FormBox[
         FrameBox[
          StyleBox[
           StyleBox[
            PaneBox[
             TagBox[
              GridBox[{{
                 TagBox[
                  GridBox[{{
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0.2, 0.2]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledCircle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0.2, 0.2]], FontSize -> 5.625, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.2, 0.7]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledSquare]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.2, 0.7]], FontSize -> 7.5, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #2}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.7, 0.2]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledDiamond]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.7, 0.2]], FontSize -> 6.75, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #3}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.6, 0.4, 0.2]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledUpTriangle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.6, 0.4, 0.2]], FontSize -> 6.375, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #4}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.8, 0.4, 0.]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledDownTriangle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.8, 0.4, 0.]], FontSize -> 6.375, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #5}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0., 0.7]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[EmptyCircle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0., 0.7]], FontSize -> 7.875, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #6}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0.7, 0.]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[EmptySquare]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0.7, 0.]], FontSize -> 9.75, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #7}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0.2, 0.2]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[EmptyDiamond]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0.2, 0.2]], FontSize -> 9., Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #8}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.2, 0.7]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[EmptyUpTriangle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.2, 0.7]], FontSize -> 8.625, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #9}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                   AutoDelete -> False, 
                   GridBoxDividers -> {
                    "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                   GridBoxItemSize -> {
                    "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"], 
                 TagBox[
                  GridBox[{{
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.7, 0.2]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[EmptyDownTriangle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.7, 0.2]], FontSize -> 8.625, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #10}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.6, 0.4, 0.2]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[Times]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.6, 0.4, 0.2]], FontSize -> 9., Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #11}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.8, 0.4, 0.]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[CircleMinus]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.8, 0.4, 0.]], FontSize -> 6.75, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #12}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0., 0.7]], {
                    InsetBox[
                    FormBox[
                    StyleBox[
                    "\[FivePointedStar]", FontSize -> 7.5, StripOnInput -> 
                    False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #13}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0.7, 0.]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledCircle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0.7, 0.]], FontSize -> 5.625, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #14}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0.2, 0.2]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledSquare]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0.2, 0.2]], FontSize -> 7.5, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #15}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.2, 0.7]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledDiamond]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.2, 0.7]], FontSize -> 6.75, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #16}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.7, 0.2]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledUpTriangle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.7, 0.2]], FontSize -> 6.375, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #17}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.6, 0.4, 0.2]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledDownTriangle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.6, 0.4, 0.2]], FontSize -> 6.375, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #18}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                   AutoDelete -> False, 
                   GridBoxDividers -> {
                    "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                   GridBoxItemSize -> {
                    "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"], 
                 TagBox[
                  GridBox[{{
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.8, 0.4, 0.]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[EmptyCircle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.8, 0.4, 0.]], FontSize -> 7.875, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #19}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0., 0.7]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[EmptySquare]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0., 0.7]], FontSize -> 9.75, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #20}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0.7, 0.]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[EmptyDiamond]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0.7, 0.]], FontSize -> 9., Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #21}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0.2, 0.2]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[EmptyUpTriangle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0.2, 0.2]], FontSize -> 8.625, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #22}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.2, 0.7]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[EmptyDownTriangle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.2, 0.7]], FontSize -> 8.625, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #23}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.7, 0.2]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[Times]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.7, 0.2]], FontSize -> 9., Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #24}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.6, 0.4, 0.2]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[CircleMinus]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.6, 0.4, 0.2]], FontSize -> 6.75, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #25}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.8, 0.4, 0.]], {
                    InsetBox[
                    FormBox[
                    StyleBox[
                    "\[FivePointedStar]", FontSize -> 7.5, StripOnInput -> 
                    False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #26}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0., 0.7]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledCircle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0., 0.7]], FontSize -> 5.625, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #27}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                   AutoDelete -> False, 
                   GridBoxDividers -> {
                    "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                   GridBoxItemSize -> {
                    "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"], 
                 TagBox[
                  GridBox[{{
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0.7, 0.]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledSquare]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0.7, 0.]], FontSize -> 7.5, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #28}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0.2, 0.2]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledDiamond]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0.2, 0.2]], FontSize -> 6.75, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #29}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.2, 0.7]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledUpTriangle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.2, 0.7]], FontSize -> 6.375, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #30}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.7, 0.2]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledDownTriangle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.7, 0.2]], FontSize -> 6.375, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #31}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.6, 0.4, 0.2]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[EmptyCircle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.6, 0.4, 0.2]], FontSize -> 7.875, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #32}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.8, 0.4, 0.]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[EmptySquare]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.8, 0.4, 0.]], FontSize -> 9.75, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #33}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0., 0.7]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[EmptyDiamond]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0., 0.7]], FontSize -> 9., Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #34}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0.7, 0.]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[EmptyUpTriangle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0.7, 0.]], FontSize -> 8.625, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #35}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0.2, 0.2]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[EmptyDownTriangle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0.2, 0.2]], FontSize -> 8.625, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #36}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                   AutoDelete -> False, 
                   GridBoxDividers -> {
                    "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                   GridBoxItemSize -> {
                    "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"], 
                 TagBox[
                  GridBox[{{
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.2, 0.7]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[Times]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.2, 0.7]], FontSize -> 9., Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #37}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.7, 0.2]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[CircleMinus]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.2, 0.7, 0.2]], FontSize -> 6.75, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #38}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.6, 0.4, 0.2]], {
                    InsetBox[
                    FormBox[
                    StyleBox[
                    "\[FivePointedStar]", FontSize -> 7.5, StripOnInput -> 
                    False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #39}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.8, 0.4, 0.]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledCircle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.8, 0.4, 0.]], FontSize -> 5.625, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #40}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0., 0.7]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledSquare]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08800000000000001], 
                    AbsoluteThickness[1.6], FontSize -> 18, 
                    RGBColor[0.7, 0., 0.7]], FontSize -> 7.5, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15, 15}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline), 
                    BaseStyle -> {FontFamily -> "Helvetica", 16}], #41}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                   AutoDelete -> False, 
                   GridBoxDividers -> {
                    "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                   GridBoxItemSize -> {
                    "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
               GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}},
                AutoDelete -> False, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
              "Grid"], Alignment -> Left, AppearanceElements -> None, 
             ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
             "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
            Directive[
             GrayLevel[0], 12, FontFamily -> "Latin Modern Roman Caps"], 
            FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
           False], StripOnInput -> False], TraditionalForm]& ), 
       InterpretationFunction :> (RowBox[{"PointLegend", "[", 
          RowBox[{
            RowBox[{"{", 
              RowBox[{
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0.2, 0.2], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.4666666666666667, 0.13333333333333336`, 
                    0.13333333333333336`], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0.2, 0.2]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0.2, 0.2]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0.2, 0.2], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.2, 0.2, 0.7], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.13333333333333336`, 0.13333333333333336`, 
                    0.4666666666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.2, 0.2, 0.7]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.2, 0.2, 0.7]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.2, 0.2, 0.7], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.2, 0.7, 0.2], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.13333333333333336`, 0.4666666666666667, 
                    0.13333333333333336`], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.2, 0.7, 0.2]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.2, 0.7, 0.2]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.2, 0.7, 0.2], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.6, 0.4, 0.2], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.4, 0.2666666666666667, 0.13333333333333336`], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.6, 0.4, 0.2]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.6, 0.4, 0.2]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.6, 0.4, 0.2], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.8, 0.4, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.5333333333333334, 0.2666666666666667, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.8, 0.4, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.8, 0.4, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.8, 0.4, 0.], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0., 0.7], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.4666666666666667, 0., 0.4666666666666667], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0., 0.7]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0., 0.7]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0., 0.7], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0.7, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.4666666666666667, 0.4666666666666667, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0.7, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0.7, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0.7, 0.], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0.2, 0.2], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.4666666666666667, 0.13333333333333336`, 
                    0.13333333333333336`], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0.2, 0.2]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0.2, 0.2]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0.2, 0.2], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.2, 0.2, 0.7], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.13333333333333336`, 0.13333333333333336`, 
                    0.4666666666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.2, 0.2, 0.7]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.2, 0.2, 0.7]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.2, 0.2, 0.7], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.2, 0.7, 0.2], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.13333333333333336`, 0.4666666666666667, 
                    0.13333333333333336`], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.2, 0.7, 0.2]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.2, 0.7, 0.2]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.2, 0.7, 0.2], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.6, 0.4, 0.2], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.4, 0.2666666666666667, 0.13333333333333336`], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.6, 0.4, 0.2]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.6, 0.4, 0.2]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.6, 0.4, 0.2], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.8, 0.4, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.5333333333333334, 0.2666666666666667, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.8, 0.4, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.8, 0.4, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.8, 0.4, 0.], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0., 0.7], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.4666666666666667, 0., 0.4666666666666667], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0., 0.7]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0., 0.7]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0., 0.7], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0.7, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.4666666666666667, 0.4666666666666667, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0.7, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0.7, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0.7, 0.], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0.2, 0.2], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.4666666666666667, 0.13333333333333336`, 
                    0.13333333333333336`], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0.2, 0.2]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0.2, 0.2]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0.2, 0.2], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.2, 0.2, 0.7], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.13333333333333336`, 0.13333333333333336`, 
                    0.4666666666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.2, 0.2, 0.7]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.2, 0.2, 0.7]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.2, 0.2, 0.7], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.2, 0.7, 0.2], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.13333333333333336`, 0.4666666666666667, 
                    0.13333333333333336`], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.2, 0.7, 0.2]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.2, 0.7, 0.2]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.2, 0.7, 0.2], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.6, 0.4, 0.2], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.4, 0.2666666666666667, 0.13333333333333336`], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.6, 0.4, 0.2]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.6, 0.4, 0.2]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.6, 0.4, 0.2], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.8, 0.4, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.5333333333333334, 0.2666666666666667, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.8, 0.4, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.8, 0.4, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.8, 0.4, 0.], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0., 0.7], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.4666666666666667, 0., 0.4666666666666667], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0., 0.7]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0., 0.7]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0., 0.7], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0.7, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.4666666666666667, 0.4666666666666667, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0.7, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0.7, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0.7, 0.], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0.2, 0.2], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.4666666666666667, 0.13333333333333336`, 
                    0.13333333333333336`], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0.2, 0.2]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0.2, 0.2]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0.2, 0.2], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.2, 0.2, 0.7], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.13333333333333336`, 0.13333333333333336`, 
                    0.4666666666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.2, 0.2, 0.7]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.2, 0.2, 0.7]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.2, 0.2, 0.7], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.2, 0.7, 0.2], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.13333333333333336`, 0.4666666666666667, 
                    0.13333333333333336`], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.2, 0.7, 0.2]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.2, 0.7, 0.2]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.2, 0.7, 0.2], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.6, 0.4, 0.2], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.4, 0.2666666666666667, 0.13333333333333336`], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.6, 0.4, 0.2]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.6, 0.4, 0.2]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.6, 0.4, 0.2], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.8, 0.4, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.5333333333333334, 0.2666666666666667, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.8, 0.4, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.8, 0.4, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.8, 0.4, 0.], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0., 0.7], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.4666666666666667, 0., 0.4666666666666667], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0., 0.7]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0., 0.7]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0., 0.7], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0.7, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.4666666666666667, 0.4666666666666667, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0.7, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0.7, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0.7, 0.], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0.2, 0.2], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.4666666666666667, 0.13333333333333336`, 
                    0.13333333333333336`], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0.2, 0.2]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0.2, 0.2]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0.2, 0.2], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.2, 0.2, 0.7], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.13333333333333336`, 0.13333333333333336`, 
                    0.4666666666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.2, 0.2, 0.7]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.2, 0.2, 0.7]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.2, 0.2, 0.7], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.2, 0.7, 0.2], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.13333333333333336`, 0.4666666666666667, 
                    0.13333333333333336`], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.2, 0.7, 0.2]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.2, 0.7, 0.2]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.2, 0.7, 0.2], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.6, 0.4, 0.2], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.4, 0.2666666666666667, 0.13333333333333336`], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.6, 0.4, 0.2]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.6, 0.4, 0.2]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.6, 0.4, 0.2], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.8, 0.4, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.5333333333333334, 0.2666666666666667, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.8, 0.4, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.8, 0.4, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.8, 0.4, 0.], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0., 0.7], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.4666666666666667, 0., 0.4666666666666667], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0., 0.7]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0., 0.7]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0., 0.7], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0.7, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.4666666666666667, 0.4666666666666667, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0.7, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0.7, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0.7, 0.], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0.2, 0.2], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.4666666666666667, 0.13333333333333336`, 
                    0.13333333333333336`], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0.2, 0.2]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0.2, 0.2]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0.2, 0.2], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.2, 0.2, 0.7], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.13333333333333336`, 0.13333333333333336`, 
                    0.4666666666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.2, 0.2, 0.7]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.2, 0.2, 0.7]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.2, 0.2, 0.7], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.2, 0.7, 0.2], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.13333333333333336`, 0.4666666666666667, 
                    0.13333333333333336`], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.2, 0.7, 0.2]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.2, 0.7, 0.2]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.2, 0.7, 0.2], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.6, 0.4, 0.2], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.4, 0.2666666666666667, 0.13333333333333336`], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.6, 0.4, 0.2]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.6, 0.4, 0.2]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.6, 0.4, 0.2], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.8, 0.4, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.5333333333333334, 0.2666666666666667, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.8, 0.4, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.8, 0.4, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.8, 0.4, 0.], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0., 0.7], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.4666666666666667, 0., 0.4666666666666667], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0., 0.7]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0., 0.7]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0., 0.7], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"PointSize", "[", "0.003666666666666667`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.7, 0.7, 0.], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.4666666666666667, 0.4666666666666667, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.7, 0.7, 0.]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.7, 0.7, 0.]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.7, 0.7, 0.], Editable -> False, Selectable -> 
                    False]}], "]"}]}], "}"}], ",", 
            RowBox[{"{", 
              
              RowBox[{#, ",", #2, ",", #3, ",", #4, ",", #5, ",", #6, ",", #7,
                 ",", #8, ",", #9, ",", #10, ",", #11, ",", #12, ",", #13, 
                ",", #14, ",", #15, ",", #16, ",", #17, ",", #18, ",", #19, 
                ",", #20, ",", #21, ",", #22, ",", #23, ",", #24, ",", #25, 
                ",", #26, ",", #27, ",", #28, ",", #29, ",", #30, ",", #31, 
                ",", #32, ",", #33, ",", #34, ",", #35, ",", #36, ",", #37, 
                ",", #38, ",", #39, ",", #40, ",", #41}], "}"}], ",", 
            RowBox[{"LegendMarkers", "\[Rule]", 
              RowBox[{"{", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"\"\[FilledCircle]\"", ",", "5.625`"}], "}"}], 
                  ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[FilledSquare]\"", ",", "7.5`"}], "}"}], ",", 
                  
                  RowBox[{"{", 
                    RowBox[{"\"\[FilledDiamond]\"", ",", "6.75`"}], "}"}], 
                  ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[FilledUpTriangle]\"", ",", "6.375`"}], "}"}],
                   ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[FilledDownTriangle]\"", ",", "6.375`"}], 
                    "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[EmptyCircle]\"", ",", "7.875`"}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[EmptySquare]\"", ",", "9.75`"}], "}"}], ",", 
                  
                  RowBox[{"{", 
                    RowBox[{"\"\[EmptyDiamond]\"", ",", "9.`"}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[EmptyUpTriangle]\"", ",", "8.625`"}], "}"}], 
                  ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[EmptyDownTriangle]\"", ",", "8.625`"}], 
                    "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[Times]\"", ",", "9.`"}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[CircleMinus]\"", ",", "6.75`"}], "}"}], ",", 
                  
                  RowBox[{"{", 
                    RowBox[{"\[FivePointedStar]", ",", "7.5`"}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[FilledCircle]\"", ",", "5.625`"}], "}"}], 
                  ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[FilledSquare]\"", ",", "7.5`"}], "}"}], ",", 
                  
                  RowBox[{"{", 
                    RowBox[{"\"\[FilledDiamond]\"", ",", "6.75`"}], "}"}], 
                  ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[FilledUpTriangle]\"", ",", "6.375`"}], "}"}],
                   ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[FilledDownTriangle]\"", ",", "6.375`"}], 
                    "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[EmptyCircle]\"", ",", "7.875`"}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[EmptySquare]\"", ",", "9.75`"}], "}"}], ",", 
                  
                  RowBox[{"{", 
                    RowBox[{"\"\[EmptyDiamond]\"", ",", "9.`"}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[EmptyUpTriangle]\"", ",", "8.625`"}], "}"}], 
                  ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[EmptyDownTriangle]\"", ",", "8.625`"}], 
                    "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[Times]\"", ",", "9.`"}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[CircleMinus]\"", ",", "6.75`"}], "}"}], ",", 
                  
                  RowBox[{"{", 
                    RowBox[{"\[FivePointedStar]", ",", "7.5`"}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[FilledCircle]\"", ",", "5.625`"}], "}"}], 
                  ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[FilledSquare]\"", ",", "7.5`"}], "}"}], ",", 
                  
                  RowBox[{"{", 
                    RowBox[{"\"\[FilledDiamond]\"", ",", "6.75`"}], "}"}], 
                  ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[FilledUpTriangle]\"", ",", "6.375`"}], "}"}],
                   ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[FilledDownTriangle]\"", ",", "6.375`"}], 
                    "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[EmptyCircle]\"", ",", "7.875`"}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[EmptySquare]\"", ",", "9.75`"}], "}"}], ",", 
                  
                  RowBox[{"{", 
                    RowBox[{"\"\[EmptyDiamond]\"", ",", "9.`"}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[EmptyUpTriangle]\"", ",", "8.625`"}], "}"}], 
                  ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[EmptyDownTriangle]\"", ",", "8.625`"}], 
                    "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[Times]\"", ",", "9.`"}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[CircleMinus]\"", ",", "6.75`"}], "}"}], ",", 
                  
                  RowBox[{"{", 
                    RowBox[{"\[FivePointedStar]", ",", "7.5`"}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[FilledCircle]\"", ",", "5.625`"}], "}"}], 
                  ",", 
                  RowBox[{"{", 
                    RowBox[{"\"\[FilledSquare]\"", ",", "7.5`"}], "}"}], ",", 
                  
                  RowBox[{"{", 
                    RowBox[{"\"\[FilledDiamond]\"", ",", "6.75`"}], "}"}]}], 
                "}"}]}], ",", 
            RowBox[{"Joined", "\[Rule]", 
              RowBox[{"{", 
                
                RowBox[{
                 "False", ",", "False", ",", "False", ",", "False", ",", 
                  "False", ",", "False", ",", "False", ",", "False", ",", 
                  "False", ",", "False", ",", "False", ",", "False", ",", 
                  "False", ",", "False", ",", "False", ",", "False", ",", 
                  "False", ",", "False", ",", "False", ",", "False", ",", 
                  "False", ",", "False", ",", "False", ",", "False", ",", 
                  "False", ",", "False", ",", "False", ",", "False", ",", 
                  "False", ",", "False", ",", "False", ",", "False", ",", 
                  "False", ",", "False", ",", "False", ",", "False", ",", 
                  "False", ",", "False", ",", "False", ",", "False", ",", 
                  "False", ",", "False"}], "}"}]}], ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
              RowBox[{"Directive", "[", 
                RowBox[{
                  InterpretationBox[
                   ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                   GrayLevel[0], Editable -> False, Selectable -> False], ",",
                   "12", ",", 
                  
                  RowBox[{
                   "FontFamily", "\[Rule]", "\"Latin Modern Roman Caps\""}]}],
                 "]"}]}], ",", 
            RowBox[{"LegendFunction", "\[Rule]", "Framed"}], ",", 
            RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
            RowBox[{"LegendMarkerSize", "\[Rule]", "15"}]}], "]"}]& ), 
       Editable -> True], TraditionalForm], TraditionalForm]},
   "Legended",
   DisplayFunction->(GridBox[{{
       TagBox[
        ItemBox[
         PaneBox[
          TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
          BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
        "SkipImageSizeLevel"], 
       ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
     GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
     AutoDelete -> False, GridBoxItemSize -> Automatic, 
     BaselinePosition -> {1, 1}]& ),
   Editable->True,
   InterpretationFunction->(RowBox[{"Legended", "[", 
      RowBox[{#, ",", 
        RowBox[{"Placed", "[", 
          RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )], "}"}]], "Output",
 CellChangeTimes->{3.721098351963484*^9, 3.721098597593071*^9, 
  3.7211434656569653`*^9, 3.721143758958506*^9, 3.721143859549501*^9, 
  3.72117785429531*^9, 3.72117872248603*^9, 3.721179024720764*^9, 
  3.7211790614632187`*^9, 3.721179139856339*^9, 3.721179218975247*^9, 
  3.7211792982562847`*^9, 3.721179338739472*^9, 3.7211793968290243`*^9, 
  3.721179848267617*^9, 3.721179939381654*^9, 3.721179989511187*^9, 
  3.721180048081558*^9, 3.721180097148375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Get", "[", "\"\<corr_proj_funcs.m\>\"", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"present directory: \"\>", 
   "\[InvisibleSpace]", \
"\<\"/home/botingw/Downloads/Sean_20171114/xqplotter_user_func_debug/\
xqplotter-master/bin\"\>"}],
  SequenceForm[
  "present directory: ", 
   "/home/botingw/Downloads/Sean_20171114/xqplotter_user_func_debug/xqplotter-\
master/bin"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.720679168721499*^9, 3.720679274155623*^9, 3.720679334805973*^9, 
   3.720679668139942*^9, 3.720679820775874*^9, 3.7206799589952106`*^9, {
   3.720679994363359*^9, 3.7206800070116*^9}, 3.720680045442141*^9, 
   3.720680109969396*^9, 3.7206801525466747`*^9, 3.7206805952114077`*^9, 
   3.720680999415127*^9, 3.720682574968412*^9, 3.7206845130805683`*^9, 
   3.720684582482995*^9, 3.720684643718712*^9, 3.720684778520616*^9, 
   3.7206849443801317`*^9, 3.7206851907507*^9, 3.720685398961608*^9, 
   3.720685467106028*^9, 3.7207112972350817`*^9, 3.720711723653116*^9, 
   3.720713085326661*^9, 3.720720153679646*^9, 3.720720275873672*^9, 
   3.720721029118372*^9, 3.720903999673359*^9, 3.720904866984297*^9, 
   3.720905756056313*^9, 3.720906627894506*^9, 3.72090683160122*^9, 
   3.720906927633853*^9, 3.721143456358876*^9, 3.721143853040431*^9, 
   3.721178715233067*^9, 3.721179011095316*^9, 3.721179055026512*^9, 
   3.721179132655476*^9, 3.721179213059825*^9, 3.721179292266344*^9, 
   3.721179332870055*^9, 3.721179842431343*^9, 3.7211799333769712`*^9, 
   3.721179984456069*^9, 3.7211800427545*^9, 3.721180091193223*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"loading \"\>", 
   "\[InvisibleSpace]", "\<\"../lib/pdfParsePDS2013.m\"\>"}],
  SequenceForm["loading ", "../lib/pdfParsePDS2013.m"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.720679168721499*^9, 3.720679274155623*^9, 3.720679334805973*^9, 
   3.720679668139942*^9, 3.720679820775874*^9, 3.7206799589952106`*^9, {
   3.720679994363359*^9, 3.7206800070116*^9}, 3.720680045442141*^9, 
   3.720680109969396*^9, 3.7206801525466747`*^9, 3.7206805952114077`*^9, 
   3.720680999415127*^9, 3.720682574968412*^9, 3.7206845130805683`*^9, 
   3.720684582482995*^9, 3.720684643718712*^9, 3.720684778520616*^9, 
   3.7206849443801317`*^9, 3.7206851907507*^9, 3.720685398961608*^9, 
   3.720685467106028*^9, 3.7207112972350817`*^9, 3.720711723653116*^9, 
   3.720713085326661*^9, 3.720720153679646*^9, 3.720720275873672*^9, 
   3.720721029118372*^9, 3.720903999673359*^9, 3.720904866984297*^9, 
   3.720905756056313*^9, 3.720906627894506*^9, 3.72090683160122*^9, 
   3.720906927633853*^9, 3.721143456358876*^9, 3.721143853040431*^9, 
   3.721178715233067*^9, 3.721179011095316*^9, 3.721179055026512*^9, 
   3.721179132655476*^9, 3.721179213059825*^9, 3.721179292266344*^9, 
   3.721179332870055*^9, 3.721179842431343*^9, 3.7211799333769712`*^9, 
   3.721179984456069*^9, 3.7211800427545*^9, 3.7211800912171*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"loading \"\>", 
   "\[InvisibleSpace]", "\<\"../lib/dtareadbotingw2016.m\"\>"}],
  SequenceForm["loading ", "../lib/dtareadbotingw2016.m"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.720679168721499*^9, 3.720679274155623*^9, 3.720679334805973*^9, 
   3.720679668139942*^9, 3.720679820775874*^9, 3.7206799589952106`*^9, {
   3.720679994363359*^9, 3.7206800070116*^9}, 3.720680045442141*^9, 
   3.720680109969396*^9, 3.7206801525466747`*^9, 3.7206805952114077`*^9, 
   3.720680999415127*^9, 3.720682574968412*^9, 3.7206845130805683`*^9, 
   3.720684582482995*^9, 3.720684643718712*^9, 3.720684778520616*^9, 
   3.7206849443801317`*^9, 3.7206851907507*^9, 3.720685398961608*^9, 
   3.720685467106028*^9, 3.7207112972350817`*^9, 3.720711723653116*^9, 
   3.720713085326661*^9, 3.720720153679646*^9, 3.720720275873672*^9, 
   3.720721029118372*^9, 3.720903999673359*^9, 3.720904866984297*^9, 
   3.720905756056313*^9, 3.720906627894506*^9, 3.72090683160122*^9, 
   3.720906927633853*^9, 3.721143456358876*^9, 3.721143853040431*^9, 
   3.721178715233067*^9, 3.721179011095316*^9, 3.721179055026512*^9, 
   3.721179132655476*^9, 3.721179213059825*^9, 3.721179292266344*^9, 
   3.721179332870055*^9, 3.721179842431343*^9, 3.7211799333769712`*^9, 
   3.721179984456069*^9, 3.7211800427545*^9, 3.721180091241056*^9}]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"ReadLisFile", "[", "datalistFile", "]"}], ";"}]], "Input",
 CellChangeTimes->{3.720714281110385*^9}],

Cell[CellGroupData[{

Cell[BoxData["lisTable"], "Input"],

Cell[BoxData["lisTable"], "Output",
 CellChangeTimes->{3.720713665426074*^9, 3.720713775429111*^9, 
  3.720714285574958*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"readcorrconfigfile6", "[", 
   RowBox[{"configDir", ",", "configfilename"}], "]"}], "//", 
  "TableForm"}]], "Input",
 CellChangeTimes->{{3.7209038223677*^9, 3.7209038652511387`*^9}, {
  3.720904004755351*^9, 3.720904016909762*^9}, {3.7209048802068243`*^9, 
  3.72090488049798*^9}, {3.7209056189021463`*^9, 3.720905631581305*^9}}],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {"\<\"aaaa\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"\<\"CT14HERA2NNLO\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"\<\"1\"\>", "\<\"2\"\>", "\<\"3\"\>", "\<\"4\"\>", "\<\"5\"\>", \
"\<\"6\"\>", "\<\"7\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\
\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"0", "0", "0", "0", "1", "0", 
     "0", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\
\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"701", "702", "703", "159", "101", "102", "103", "104", "106", "108", 
     "109", "110", "111", "124", "125", "126", "127", "147", "201", "203", 
     "204", "225", "227", "231", "234", "260", "261", "504", "514", "145", 
     "169", "267", "268", "535", "240", "241", "281", "265", "266", "538", 
     "245", "246", "247", "248", "542", "544", "249", "250", "565", "566", 
     "567", "568", "545", "160"},
    {"0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", 
     "1", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "1", 
     "0", "0", "1", "0", "0", "0", "1", "0", "1", "0", "0", "0", "0", "0", 
     "0", "0", "0", "0", "0", "0", "0", "0", "0", "1", "0", "1"},
    {"\<\"bb\"\>", "\<\"cb\"\>", "\<\"sb\"\>", "\<\"db\"\>", "\<\"ub\"\>", \
"\<\"g\"\>", "\<\"u\"\>", "\<\"d\"\>", "\<\"s\"\>", "\<\"c\"\>", "\<\"b\"\>", \
"\<\"user\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\
\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>"},
    {"0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", 
     "0", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\
\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"\<\"auto\"\>", "\<\"auto\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"1", 
     "6000", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {
     RowBox[{"-", "1.`"}], 
     "1.`", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"100", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"50", "70", 
     "85", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"\<\"tiny\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"\<\"1\"\>", "\<\"2\"\>", "\<\"3\"\>", "\<\"4\"\>", "\<\"5\"\>", \
"\<\"6\"\>", "\<\"7\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\
\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"0", "0", "0", "0", "1", "1", 
     "0", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\
\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>",
      "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {
        RowBox[{"-", "5.`"}], 
        RowBox[{"-", "0.25`"}]},
       {"0.25`", "5.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {
        RowBox[{"-", "1.`"}], 
        RowBox[{"-", "0.7`"}]},
       {"0.7`", "1.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, 
        "RowsIndexed" -> {}}], "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>"},
    {GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, 
        "RowsIndexed" -> {}}], "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  TableForm[{
   "aaaa", "CT14HERA2NNLO", {"1", "2", "3", "4", "5", "6", "7"}, {0, 0, 0, 0, 
    1, 0, 0}, {701, 702, 703, 159, 101, 102, 103, 104, 106, 108, 109, 110, 
    111, 124, 125, 126, 127, 147, 201, 203, 204, 225, 227, 231, 234, 260, 261,
     504, 514, 145, 169, 267, 268, 535, 240, 241, 281, 265, 266, 538, 245, 
    246, 247, 248, 542, 544, 249, 250, 565, 566, 567, 568, 545, 160}, {0, 0, 
    0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0,
     1, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    1, 0, 1}, {
    "bb", "cb", "sb", "db", "ub", "g", "u", "d", "s", "c", "b", "user"}, {0, 
    0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0}, {"auto", "auto"}, {1, 6000}, {-1., 1.}, 
    100, {50, 70, 85}, "tiny", {"1", "2", "3", "4", "5", "6", "7"}, {0, 0, 0, 
    0, 1, 1, 0}, {{{0., 0.}}, {{0., 0.}}, {{0., 0.}}, {{0., 
     0.}}, {{-5., -0.25}, {0.25, 5.}}, {{-1., -0.7}, {0.7, 1.}}, {{0., 
     0.}}}, {{{0., 0.}}, {{0., 0.}}, {{0., 0.}}, {{0., 0.}}, {{0., 0.}}, {{0.,
     0.}}, {{0., 0.}}}}]]], "Output",
 CellChangeTimes->{{3.720903819490367*^9, 3.720903865890451*^9}, {
  3.720904006343362*^9, 3.720904039902103*^9}, {3.7209048735164423`*^9, 
  3.7209048984905653`*^9}, {3.7209056200555153`*^9, 3.720905632417553*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"readcorrconfigfile6", "[", 
   RowBox[{"configDir", ",", "configfilename"}], "]"}], "//", 
  "TableForm"}]], "Input"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {"\<\"aaaa\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"\<\"CT14HERA2NNLO\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"\<\"1\"\>", "\<\"2\"\>", "\<\"3\"\>", "\<\"4\"\>", "\<\"5\"\>", \
"\<\"6\"\>", "\<\"7\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\
\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"0", "0", "0", "0", "1", "0", 
     "0", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\
\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"701", "702", "703", "159", "101", "102", "103", "104", "106", "108", 
     "109", "110", "111", "124", "125", "126", "127", "147", "201", "203", 
     "204", "225", "227", "231", "234", "260", "261", "504", "514", "145", 
     "169", "267", "268", "535", "240", "241", "281", "265", "266", "538", 
     "245", "246", "247", "248", "542", "544", "249", "250", "565", "566", 
     "567", "568", "545", "160"},
    {"0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", 
     "1", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "1", 
     "0", "0", "1", "0", "0", "0", "1", "0", "1", "0", "0", "0", "0", "0", 
     "0", "0", "0", "0", "0", "0", "0", "0", "0", "1", "0", "1"},
    {"\<\"bb\"\>", "\<\"cb\"\>", "\<\"sb\"\>", "\<\"db\"\>", "\<\"ub\"\>", \
"\<\"g\"\>", "\<\"u\"\>", "\<\"d\"\>", "\<\"s\"\>", "\<\"c\"\>", "\<\"b\"\>", \
"\<\"user\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\
\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>"},
    {"0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", 
     "0", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\
\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"\<\"auto\"\>", "\<\"auto\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"1", 
     "6000", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {
     RowBox[{"-", "1.`"}], 
     "1.`", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"100", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"\<\"tiny\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"\<\"1\"\>", "\<\"2\"\>", "\<\"3\"\>", "\<\"4\"\>", "\<\"5\"\>", \
"\<\"6\"\>", "\<\"7\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\
\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"0", "0", "0", "0", "1", "1", 
     "0", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\
\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {
        RowBox[{"-", "5.`"}], 
        RowBox[{"-", "0.25`"}]},
       {"0.25`", "5.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {
        RowBox[{"-", "1.`"}], 
        RowBox[{"-", "0.7`"}]},
       {"0.7`", "1.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, 
        "RowsIndexed" -> {}}], "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>"},
    {GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, 
        "RowsIndexed" -> {}}], "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  TableForm[{
   "aaaa", "CT14HERA2NNLO", {"1", "2", "3", "4", "5", "6", "7"}, {0, 0, 0, 0, 
    1, 0, 0}, {701, 702, 703, 159, 101, 102, 103, 104, 106, 108, 109, 110, 
    111, 124, 125, 126, 127, 147, 201, 203, 204, 225, 227, 231, 234, 260, 261,
     504, 514, 145, 169, 267, 268, 535, 240, 241, 281, 265, 266, 538, 245, 
    246, 247, 248, 542, 544, 249, 250, 565, 566, 567, 568, 545, 160}, {0, 0, 
    0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0,
     1, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    1, 0, 1}, {
    "bb", "cb", "sb", "db", "ub", "g", "u", "d", "s", "c", "b", "user"}, {0, 
    0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0}, {"auto", "auto"}, {1, 6000}, {-1., 1.}, 
    100, "tiny", {"1", "2", "3", "4", "5", "6", "7"}, {0, 0, 0, 0, 1, 1, 
    0}, {{{0., 0.}}, {{0., 0.}}, {{0., 0.}}, {{0., 0.}}, {{-5., -0.25}, {0.25,
      5.}}, {{-1., -0.7}, {0.7, 1.}}, {{0., 0.}}}, {{{0., 0.}}, {{0., 0.}}, {{
    0., 0.}}, {{0., 0.}}, {{0., 0.}}, {{0., 0.}}, {{0., 0.}}}}]]], "Output",
 CellChangeTimes->{{3.720905747187449*^9, 3.720905758723373*^9}, 
   3.720905884366248*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"readcorrconfigfile6", "[", 
   RowBox[{"configDir", ",", "configfilename"}], "]"}], "//", 
  "TableForm"}]], "Input"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {"\<\"CT14NNLOallIDs\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
    {"\<\" CT14NNLO all Expts to Higgs fake data\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"\<\"CT14NNLO\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"\<\"1\"\>", "\<\"2\"\>", "\<\"3\"\>", "\<\"4\"\>", "\<\"5\"\>", \
"\<\"6\"\>", "\<\"7\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\
\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"1", "1", "1", "1", "1", "1", 
     "0", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\
\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"701", "702", "703", "159", "101", "102", "103", "104", "106", "108", 
     "109", "110", "111", "124", "125", "126", "127", "147", "201", "203", 
     "204", "225", "227", "231", "234", "260", "261", "504", "514", "145", 
     "169", "267", "268", "535", "240", "241", "281", "265", "266", "538", 
     "245", "246", "247", "248", "542", "544", "249", "250", "565", "566", 
     "567", "568", "545", "160"},
    {"0", "0", "0", "0", "1", "1", "0", "1", "0", "1", "1", "1", "1", "1", 
     "1", "1", "1", "1", "1", "1", "1", "1", "1", "0", "1", "1", "0", "1", 
     "1", "1", "1", "0", "1", "1", "1", "1", "1", "0", "1", "1", "1", "1", 
     "0", "1", "1", "1", "1", "1", "1", "1", "1", "1", "0", "1"},
    {"\<\"bb\"\>", "\<\"cb\"\>", "\<\"sb\"\>", "\<\"db\"\>", "\<\"ub\"\>", \
"\<\"g\"\>", "\<\"u\"\>", "\<\"d\"\>", "\<\"s\"\>", "\<\"c\"\>", "\<\"b\"\>", \
"\<\"user\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\
\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>"},
    {"0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", 
     "1", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\
\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"\<\"auto\"\>", "\<\"auto\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"1", 
     "6000", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {
     RowBox[{"-", "3.`"}], 
     "3.`", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"100", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"\<\"tiny\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"\<\"1\"\>", "\<\"2\"\>", "\<\"3\"\>", "\<\"4\"\>", "\<\"5\"\>", \
"\<\"6\"\>", "\<\"7\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\
\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"0", "0", "1", "1", "1", "1", 
     "0", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\
\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {
        RowBox[{"-", "100"}], 
        RowBox[{"-", "1"}]},
       {"1", "100"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"1", "100"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {
        RowBox[{"-", "5.`"}], 
        RowBox[{"-", "0.25`"}]},
       {"0.25`", "5.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {
        RowBox[{"-", "1.`"}], 
        RowBox[{"-", "0.7`"}]},
       {"0.7`", "1.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, 
        "RowsIndexed" -> {}}], "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>"},
    {GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"0.`", "0.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, 
        "RowsIndexed" -> {}}], "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  TableForm[{
   "CT14NNLOallIDs", " CT14NNLO all Expts to Higgs fake data", "CT14NNLO", {
    "1", "2", "3", "4", "5", "6", "7"}, {1, 1, 1, 1, 1, 1, 0}, {701, 702, 703,
     159, 101, 102, 103, 104, 106, 108, 109, 110, 111, 124, 125, 126, 127, 
    147, 201, 203, 204, 225, 227, 231, 234, 260, 261, 504, 514, 145, 169, 267,
     268, 535, 240, 241, 281, 265, 266, 538, 245, 246, 247, 248, 542, 544, 
    249, 250, 565, 566, 567, 568, 545, 160}, {0, 0, 0, 0, 1, 1, 0, 1, 0, 1, 1,
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 0, 1, 1, 1, 1, 0, 1, 1, 1, 
    1, 1, 0, 1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1}, {
    "bb", "cb", "sb", "db", "ub", "g", "u", "d", "s", "c", "b", "user"}, {0, 
    0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1}, {"auto", "auto"}, {1, 6000}, {-3., 3.}, 
    100, "tiny", {"1", "2", "3", "4", "5", "6", "7"}, {0, 0, 1, 1, 1, 1, 
    0}, {{{0., 0.}}, {{0., 0.}}, {{-100, -1}, {1, 100}}, {{1, 
     100}}, {{-5., -0.25}, {0.25, 5.}}, {{-1., -0.7}, {0.7, 1.}}, {{0., 
     0.}}}, {{{0., 0.}}, {{0., 0.}}, {{0., 0.}}, {{0., 0.}}, {{0., 0.}}, {{0.,
     0.}}, {{0., 0.}}}}]]], "Output",
 CellChangeTimes->{
  3.7209065896975517`*^9, 3.720906634265645*^9, 3.720906836308202*^9, {
   3.7209069315321293`*^9, 3.7209069429382763`*^9}, 3.720906999568829*^9, 
   3.721098139641149*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["test run the info of data", "Subsection",
 CellChangeTimes->{{3.721240075020898*^9, 3.721240084526144*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "20171126", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"when", " ", "call", " ", "processdataplotsmultiexp7percentage"}],
     ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"if", " ", "plot", " ", "type"}], " ", "=", " ", "1"}], ",", " ", 
    RowBox[{
    "call", " ", "this", " ", "function", " ", "to", " ", "draw", " ", "data",
      " ", "sets", " ", "on", " ", 
     RowBox[{"(", 
      RowBox[{"x", ",", "Q"}], ")"}], " ", "plane"}]}], "\[IndentingNewLine]",
    "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"PlotDataTypeOneTest", "[", 
    RowBox[{
    "corrfxQdtaobsclassin_", ",", "pdfcorrin_", ",", "exptlistin_", ",", 
     "xyrangein_", ",", "classifymodein_", ",", "configargumentsin_"}], "]"}],
    ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"corrfxQdtaobsclass", "=", "corrfxQdtaobsclassin"}], ",", 
       RowBox[{"pdfcorr", "=", "pdfcorrin"}], ",", 
       RowBox[{"exptlist", "=", "exptlistin"}], ",", 
       RowBox[{"classifymode", "=", "classifymodein"}], ",", 
       RowBox[{"configarguments", "=", "configargumentsin"}], ",", 
       "\[IndentingNewLine]", "plottype", ",", "expttype", ",", 
       "\[IndentingNewLine]", "Jobid", ",", "PDFname", ",", "FigureType", ",",
        "FigureFlag", ",", "ExptidType", ",", "ExptidFlag", ",", 
       "CorrelationArgType", ",", "CorrelationArgFlag", ",", 
       RowBox[{"(*", 
        RowBox[{"UserArgName", ",", "UserArgValue", ","}], "*)"}], "\n", 
       "XQfigureXrange", ",", "XQfigureYrange", ",", "Hist1figureNbin", ",", 
       "Hist1figureXrange", ",", "Hist1figureYrange", ",", "\n", 
       "ColorSeperator", ",", "\n", "Size", ",", "HighlightType", ",", 
       "HighlightMode", ",", "HighlightMode1", ",", "HighlightMode2", ",", 
       "\[IndentingNewLine]", "lgdpos", ",", "xyrangeplot1", ",", "plotrange",
        ",", "\[IndentingNewLine]", "myplotsetting", ",", "imgsize", ",", 
       "title", ",", "xtitle", ",", "ytitle", ",", "lgdlabel", ",", "xrange", 
       ",", "yrange", ",", "epilog", ",", "titlesize", ",", "xtitlesize", ",",
        "ytitlesize", ",", "lgdlabelsize", ",", "ticklablesize", ",", 
       "myplotstyle", ",", "myMarker", ",", "\[IndentingNewLine]", "plot1", 
       ",", "\[IndentingNewLine]", 
       RowBox[{"xyrange", "=", "xyrangein"}], ",", "\[IndentingNewLine]", 
       "groupnames", ",", "groupExptIDs", ",", "\[IndentingNewLine]", 
       "ColorPaletterange", ",", "JobDescription", ",", "\[IndentingNewLine]",
        "Ncolor"}], "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     
     RowBox[{"(*", 
      RowBox[{
      "read", " ", "arguments", " ", "in", " ", "config", " ", "file"}], 
      "*)"}], "\n", 
     RowBox[{"(*", 
      RowBox[{
      "===", "===", "===", "===", "===", "===", "===", "===", "===", "==="}], 
      "*)"}], "\n", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Jobid", ",", "JobDescription", 
         RowBox[{"(*", "20171128", "*)"}], ",", "PDFname", ",", "FigureType", 
         ",", "FigureFlag", ",", "ExptidType", ",", "ExptidFlag", ",", 
         "CorrelationArgType", ",", "CorrelationArgFlag", ",", 
         RowBox[{"(*", 
          RowBox[{"UserArgName", ",", "UserArgValue", ","}], "*)"}], "\n", 
         "XQfigureXrange", ",", "XQfigureYrange", ",", "ColorPaletterange", 
         RowBox[{"(*", "20171128", "*)"}], ",", "Hist1figureNbin", ",", 
         RowBox[{"(*", 
          RowBox[{"Hist1figureXrange", ",", "Hist1figureYrange", ","}], 
          "*)"}], "\n", 
         RowBox[{"(*", 
          RowBox[{"ColorSeperator", ","}], "*)"}], "\n", "Size", ",", 
         "HighlightType", ",", "HighlightMode", ",", "HighlightMode1", ",", 
         "HighlightMode2"}], "}"}], "=", "configarguments"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"20171128", ":", " ", 
         RowBox[{
         "set", " ", "hist", " ", "xrange", " ", "determined", " ", "by", " ",
           "the", " ", "range", " ", "of", " ", "color", " ", "palette"}]}], 
        ",", " ", 
        RowBox[{"yrange", " ", "alway", " ", "auto"}]}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"Hist1figureXrange", "=", "ColorPaletterange"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Hist1figureYrange", "=", 
       RowBox[{"{", 
        RowBox[{"\"\<auto\>\"", ",", "\"\<auto\>\""}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
       "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
         "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
         "===", "===", "===", "===", "===", "===", "===", "===", 
        RowBox[{"==", 
         RowBox[{
         "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
           "===", "==="}]}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"plot", " ", "type", " ", "1"}], ":", " ", 
         RowBox[{
          RowBox[{"generate", " ", "plots"}], "===", "===", "===", "===", "===",
           "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
          RowBox[{"==", 
           RowBox[{"===", "===", "===", "===", 
            RowBox[{"==", 
             RowBox[{
             "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
               "===", "===", "===", "===", "==="}]}]}]}]}]}], "=", "="}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
        "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
         "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
          "===", "===", "===", "===", "==="}], "=", 
        RowBox[{"===", "===", "===", "===", 
         RowBox[{"==", "=="}], "===", "===", "===", "===", "===", "===", "===",
          "===", "===", "===", "==="}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "myplotsetting", ",", "imgsize", ",", "title", ",", "xtitle", ",", 
        "ytitle", ",", "lgdlabel", ",", "xrange", ",", "yrange", ",", 
        "epilog", ",", "titlesize", ",", "xtitlesize", ",", "ytitlesize", ",",
         "lgdlabelsize", ",", "ticklablesize", ",", "myplotstyle", ",", 
        "myMarker"}], "}"}], ";", "\n", "\[IndentingNewLine]", 
      RowBox[{"(*", "plot1", "*)"}], "\n", "\n", 
      RowBox[{"expttype", "=", "\"\<multi\>\""}], ";", "\n", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"20170515", " ", "groups", " ", "of", " ", "data"}], ",", " ", 
        RowBox[{
        "legend", " ", "is", " ", "exptids", " ", "in", " ", "all", " ", 
         "groups"}], ",", " ", 
        RowBox[{"using", " ", "Flatten"}], ",", " ", 
        RowBox[{
        "PDFname", " ", "should", " ", "be", " ", "took", " ", "cared"}]}], 
       "*)"}], "\n", 
      RowBox[{"myplotsetting", "=", 
       RowBox[{"setplotsetting", "[", 
        RowBox[{
         RowBox[{"Flatten", "[", 
          RowBox[{"corrfxQdtaobsclassin", ",", "1"}], "]"}], ",", 
         RowBox[{"exptlist", "//", "Flatten"}], ",", "expttype", ",", "1", 
         ",", "\"\<test\>\"", ",", "\"\<test\>\""}], "]"}]}], ";", "\n", 
      RowBox[{"imgsize", "=", 
       RowBox[{"myplotsetting", "[", 
        RowBox[{"[", "\"\<imgsize\>\"", "]"}], "]"}]}], ";", "\n", 
      RowBox[{"title", "=", 
       RowBox[{"myplotsetting", "[", 
        RowBox[{"[", "\"\<title\>\"", "]"}], "]"}]}], ";", "\n", 
      RowBox[{"xtitle", "=", 
       RowBox[{"myplotsetting", "[", 
        RowBox[{"[", "\"\<xtitle\>\"", "]"}], "]"}]}], ";", "\n", 
      RowBox[{"ytitle", "=", 
       RowBox[{"myplotsetting", "[", 
        RowBox[{"[", "\"\<ytitle\>\"", "]"}], "]"}]}], ";", "\n", 
      RowBox[{"lgdlabel", "=", 
       RowBox[{"myplotsetting", "[", 
        RowBox[{"[", "\"\<lgdlabel\>\"", "]"}], "]"}]}], ";", "\n", 
      RowBox[{"xrange", "=", 
       RowBox[{"myplotsetting", "[", 
        RowBox[{"[", "\"\<xrange\>\"", "]"}], "]"}]}], ";", "\n", 
      RowBox[{"yrange", "=", 
       RowBox[{"myplotsetting", "[", 
        RowBox[{"[", "\"\<yrange\>\"", "]"}], "]"}]}], ";", "\n", 
      RowBox[{"epilog", "=", 
       RowBox[{"myplotsetting", "[", 
        RowBox[{"[", "\"\<epilog\>\"", "]"}], "]"}]}], ";", "\n", 
      RowBox[{"titlesize", "=", 
       RowBox[{"myplotsetting", "[", 
        RowBox[{"[", "\"\<titlesize\>\"", "]"}], "]"}]}], ";", "\n", 
      RowBox[{"xtitlesize", "=", 
       RowBox[{"myplotsetting", "[", 
        RowBox[{"[", "\"\<xtitlesize\>\"", "]"}], "]"}]}], ";", "\n", 
      RowBox[{"ytitlesize", "=", 
       RowBox[{"myplotsetting", "[", 
        RowBox[{"[", "\"\<ytitlesize\>\"", "]"}], "]"}]}], ";", "\n", 
      RowBox[{"lgdlabelsize", "=", 
       RowBox[{"myplotsetting", "[", 
        RowBox[{"[", "\"\<lgdlabelsize\>\"", "]"}], "]"}]}], ";", "\n", 
      RowBox[{"ticklablesize", "=", 
       RowBox[{"myplotsetting", "[", 
        RowBox[{"[", "\"\<ticklablesize\>\"", "]"}], "]"}]}], ";", "\n", "\n", 
      RowBox[{"myplotstyle", "=", 
       RowBox[{"myplotsetting", "[", 
        RowBox[{"[", "\"\<plotstyle\>\"", "]"}], "]"}]}], ";", "\n", 
      RowBox[{"myMarker", "=", 
       RowBox[{"myplotsetting", "[", 
        RowBox[{"[", "\"\<marker\>\"", "]"}], "]"}]}], ";", "\n", "\n", 
      RowBox[{"title", "=", 
       RowBox[{
       "\"\<Experimental data in \>\"", "<>", "PDFname", "<>", 
        "\"\< analysis\>\""}]}], ";", "\n", 
      RowBox[{"lgdpos", "=", 
       RowBox[{"{", 
        RowBox[{"0.25", ",", "0.725"}], "}"}]}], ";", "\n", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"xyrangeplot1", "=", "plotrange"}], ";"}], "*)"}], 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"20170307", " ", "change", " ", 
         RowBox[{"it", "'"}], "s", " ", "name"}], ",", " ", 
        RowBox[{"avoid", " ", "duplicate"}]}], "*)"}], "\n", 
      RowBox[{"(*", 
       RowBox[{"20170515", ":", " ", 
        RowBox[{
        "consider", " ", "expts", " ", "in", " ", "all", " ", "groups"}]}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"20170515", ":", " ", 
         RowBox[{
         "consider", " ", "expts", " ", "of", " ", "all", " ", "groups"}]}], 
        ",", " ", 
        RowBox[{"so", " ", "use", " ", 
         RowBox[{"Flatten", "[", 
          RowBox[{"data", ",", "1"}], "]"}]}]}], " ", "*)"}], 
      "\[IndentingNewLine]", "\n", 
      RowBox[{"(*", "\n", 
       RowBox[{
        RowBox[{"Print", "[", 
         RowBox[{"\"\<dim of p1: \>\"", ",", 
          RowBox[{"Dimensions", "[", "pdfcorr", "]"}]}], " ", "]"}], ";", 
        "\n", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<dim of p1: \>\"", ",", 
          RowBox[{"Dimensions", "[", 
           RowBox[{"Flatten", "[", 
            RowBox[{"pdfcorr", ",", "1"}], "]"}], " ", "]"}]}], "]"}], ";", 
        "\n", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<data of p1: \>\"", ",", 
          RowBox[{
           RowBox[{"Flatten", "[", 
            RowBox[{"pdfcorr", ",", "1"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], " ", "]"}], ";", "\n", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<data of p1: \>\"", ",", 
          RowBox[{
           RowBox[{"Flatten", "[", 
            RowBox[{"pdfcorr", ",", "1"}], "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], " ", "]"}], ";", "\n", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<data of p1: \>\"", ",", 
          RowBox[{
           RowBox[{"Flatten", "[", 
            RowBox[{"pdfcorr", ",", "1"}], "]"}], "[", 
           RowBox[{"[", "3", "]"}], "]"}]}], " ", "]"}], ";", "\n", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<data of p1: \>\"", ",", 
          RowBox[{
           RowBox[{"Flatten", "[", 
            RowBox[{"pdfcorr", ",", "1"}], "]"}], "[", 
           RowBox[{"[", "4", "]"}], "]"}]}], " ", "]"}], ";", "\n", 
        RowBox[{"PDFloglogplot", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Flatten", "[", 
            RowBox[{"pdfcorr", ",", "1"}], "]"}], "/.", 
           RowBox[{"LF1", "\[Rule]", "List"}]}], ",", "myMarker", ",", 
          "myplotstyle", ",", "title", ",", "xtitle", ",", "ytitle", ",", 
          "xyrangeplot1", ",", "lgdlabel", ",", "lgdpos", ",", "imgsize"}], 
         "]"}], ";", "\n", 
        RowBox[{"Abort", "[", "]"}], ";"}], "\n", "*)"}], "\n", 
      RowBox[{"(*", 
       RowBox[{"20171126", ":", " ", 
        RowBox[{"use", " ", "marker", " ", "list"}]}], "*)"}], "\n", 
      RowBox[{"myMarker", "=", 
       RowBox[{"PlotMarkerList", "[", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"myMarker", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "=", 
       RowBox[{"0.0075", "*", 
        RowBox[{"myMarker", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}]}], ";", "\n", 
      RowBox[{"myMarker", "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"myMarker", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
        "20171130", " ", "set", " ", "color", " ", "for", " ", "points"}], 
        ",", " ", 
        RowBox[{
        "everytime", " ", "the", " ", "shape", " ", "return", " ", "to", " ", 
         "the", " ", "first", " ", "shape"}], ",", " ", 
        RowBox[{"change", " ", "to", " ", "another", " ", "color"}]}], "*)"}],
       "\[IndentingNewLine]", 
      RowBox[{"Ncolor", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"RGBColor", "[", 
          RowBox[{"0.7", ",", " ", "0.2", ",", " ", "0.2"}], "]"}], ",", " ", 
         
         RowBox[{"RGBColor", "[", 
          RowBox[{"0.2", ",", " ", "0.2", ",", " ", "0.7"}], "]"}], ",", " ", 
         
         RowBox[{"RGBColor", "[", 
          RowBox[{"0.2", ",", " ", "0.7", ",", " ", "0.2"}], "]"}], ",", " ", 
         
         RowBox[{"RGBColor", "[", 
          RowBox[{"0.6", ",", " ", "0.4", ",", " ", "0.2"}], "]"}], ",", " ", 
         
         RowBox[{"RGBColor", "[", 
          RowBox[{"0.8", ",", " ", "0.4", ",", " ", "0."}], "]"}], ",", " ", 
         "\n", " ", 
         RowBox[{"RGBColor", "[", 
          RowBox[{"0.7", ",", " ", "0.", ",", " ", "0.7"}], "]"}], ",", " ", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", " ", "0.6", ",", " ", "0.6"}], "]"}], ","}], 
          "*)"}], " ", 
         RowBox[{"RGBColor", "[", 
          RowBox[{"0.7", ",", " ", "0.7", ",", " ", "0."}], "]"}]}], "}"}]}], 
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"myplotstyle", "=", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"Ncolor", "[", 
               RowBox[{"[", "icolor", "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"imarker", ",", 
                RowBox[{"Length", "[", "myMarker", "]"}]}], "}"}]}], "]"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{"icolor", ",", 
              RowBox[{"Length", "[", "Ncolor", "]"}]}], "}"}]}], "]"}], "//", 
          "Flatten"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"myplotstyle", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Ncolor", "&"}], "/@", 
          RowBox[{"Range", "[", 
           RowBox[{"Length", "[", "myMarker", "]"}], " ", "]"}]}], ")"}], 
        "]"}]}], ";", 
      RowBox[{"(*", 
       RowBox[{"20171201", ":", " ", 
        RowBox[{
        "color", " ", "also", " ", "rotation", " ", "for", " ", "every", " ", 
         "Expt", " ", "ID"}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
        "when", " ", "all", " ", "shapes", " ", "are", " ", "used", " ", 
         "out"}], ",", " ", 
        RowBox[{"return", " ", "to", " ", "the", " ", "first", " ", "one"}]}],
        "*)"}], "\[IndentingNewLine]", 
      RowBox[{"myMarker", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"myMarker", "&"}], "/@", 
           RowBox[{"Range", "[", 
            RowBox[{"Length", "[", "Ncolor", "]"}], " ", "]"}]}], ")"}], ",", 
         "1"}], "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<dim of data: \>\"", ",", 
        RowBox[{"Dimensions", "[", "pdfcorr", "]"}]}], " ", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<exptlist \>\"", ",", "exptlist"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"always", " ", 
        RowBox[{"don", "'"}], "t", " ", "show", " ", "only", " ", "one", " ", 
        "shape", " ", "for", " ", "all", " ", "expt", " ", "ID", " ", 
        "points"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"classifymode", "\[Equal]", "\"\<all\>\""}], ",", 
        RowBox[{"classifymode", "=", "\"\<single\>\""}]}], "]"}], ";", "\n", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"groupnames", ",", "groupExptIDs", ",", 
         RowBox[{"(*", "groupdata", "*)"}], "pdfcorr"}], "}"}], "=", 
       RowBox[{"ClassifyPlottedData", "[", 
        RowBox[{"pdfcorr", ",", "exptlist", ",", "classifymode"}], "]"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"pdfcorr", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"pdfcorr", "[", 
            RowBox[{"[", "igroup", "]"}], "]"}], ",", "1"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"igroup", ",", 
           RowBox[{"Length", "[", "pdfcorr", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"lgdlabel", "=", "\[IndentingNewLine]", 
       RowBox[{"Switch", "[", 
        RowBox[{
        "classifymode", ",", "\"\<single\>\"", ",", "lgdlabel", ",", 
         "\"\<all\>\"", ",", "groupnames"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<dim of data: \>\"", ",", 
        RowBox[{"Dimensions", "[", "pdfcorr", "]"}]}], " ", "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"plot1", "=", 
       RowBox[{"PDFloglogplot", "[", 
        RowBox[{"(*", 
         RowBox[{"Flatten", "[", 
          RowBox[{"pdfcorr", ",", "1"}], "]"}], "*)"}], 
        RowBox[{
        "pdfcorr", ",", "myMarker", ",", "myplotstyle", ",", "title", ",", 
         "xtitle", ",", "ytitle", ",", "xyrange", 
         RowBox[{"(*", "plot1", "*)"}], ",", "lgdlabel", ",", "lgdpos", ",", 
         "imgsize"}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", "return", "*)"}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"{", "plot1", "}"}]}]}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", "\n", 
     RowBox[{"{", 
      RowBox[{
      "myMarker", ",", "myplotstyle", ",", "title", ",", "xtitle", ",", 
       "ytitle", ",", "xyrange", ",", "lgdlabel", ",", "lgdpos", ",", 
       "imgsize"}], "}"}], "\[IndentingNewLine]", "*)"}], 
    "\[IndentingNewLine]", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.720675304821692*^9, 3.7206753281306553`*^9}, {
   3.7206754118260183`*^9, 3.720675457450101*^9}, {3.720675504032565*^9, 
   3.7206755252575197`*^9}, {3.720675864176115*^9, 3.720675865522732*^9}, {
   3.7206758971627407`*^9, 3.720675945496163*^9}, {3.720675977107223*^9, 
   3.720675991778627*^9}, {3.720676028406795*^9, 3.7206760289744177`*^9}, {
   3.720676059921961*^9, 3.7206762639809303`*^9}, {3.72067794008708*^9, 
   3.720677959564046*^9}, {3.720677993054392*^9, 3.720677995708756*^9}, {
   3.7206781979343643`*^9, 3.720678314735587*^9}, {3.720678626984606*^9, 
   3.7206786734154053`*^9}, {3.720679202381044*^9, 3.720679260778564*^9}, {
   3.720679319561089*^9, 3.720679322025947*^9}, {3.7206794213901587`*^9, 
   3.720679421815835*^9}, {3.720679489203315*^9, 3.72067957720411*^9}, {
   3.720679646034233*^9, 3.720679650597658*^9}, {3.720679907632362*^9, 
   3.720679945902267*^9}, {3.7206799801143103`*^9, 3.7206799807532043`*^9}, 
   3.720680035096743*^9, {3.720680084116913*^9, 3.7206800999264936`*^9}, {
   3.720680136274412*^9, 3.7206801430616093`*^9}, {3.720683891768881*^9, 
   3.720683893523321*^9}, {3.720683930821724*^9, 3.720683932172841*^9}, {
   3.720684267315998*^9, 3.720684366324304*^9}, {3.720684441539659*^9, 
   3.7206845011384974`*^9}, {3.720684544768931*^9, 3.720684572403267*^9}, {
   3.720684759483012*^9, 3.720684770210362*^9}, {3.7206849347289124`*^9, 
   3.720684935322394*^9}, {3.720685146471149*^9, 3.720685161601048*^9}, {
   3.720685293655161*^9, 3.7206853527760487`*^9}, {3.7206854288372307`*^9, 
   3.720685432675012*^9}, {3.720720948966887*^9, 3.720721006360352*^9}, {
   3.720891565332143*^9, 3.7208916168367434`*^9}, {3.720891782699897*^9, 
   3.7208917836267643`*^9}, {3.7209076516105547`*^9, 
   3.7209076809205008`*^9}, {3.7210919133812304`*^9, 
   3.7210920378816566`*^9}, {3.7210920696846523`*^9, 3.721092138345351*^9}, {
   3.721092227696541*^9, 3.721092228996233*^9}, {3.721092293109357*^9, 
   3.7210923905659943`*^9}, {3.721095523276417*^9, 3.721095536438854*^9}, {
   3.721098517318123*^9, 3.721098545014638*^9}, {3.72117973573477*^9, 
   3.72117982475323*^9}, {3.721179915890369*^9, 3.72117991983962*^9}, {
   3.721179960556913*^9, 3.721179966843978*^9}, {3.721180020950543*^9, 
   3.721180030210011*^9}, {3.7211800650179663`*^9, 3.721180076680336*^9}, {
   3.721240459408258*^9, 3.721240461764323*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"modify", " ", "of", " ", "3"}], ":", " ", 
      RowBox[{"when", " ", "plottype"}]}], " ", "=", " ", "5"}], ",", " ", 
    "6", ",", " ", 
    RowBox[{
    "extract", " ", "data", " ", "of", " ", "that", " ", "flavour"}]}], 
   "*)"}], "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"modify", " ", "of", " ", "4"}], ":", " ", 
     RowBox[{
      RowBox[{"don", "'"}], "t", " ", "set", " ", "local", " ", "variable", 
      " ", "of", " ", "corrfxQdtaobsclassin"}]}], ",", " ", 
    RowBox[{
    "avoiding", " ", "time", " ", "to", " ", "copy", " ", "large", " ", 
     "data", " ", "to", " ", "local", " ", "variable"}], ",", " ", 
    RowBox[{"for", " ", "mode", " ", "5"}], ",", 
    RowBox[{
    "6", " ", "only", " ", "deal", " ", "with", " ", "\n", "corresponding", 
     " ", "flavour", " ", "data", " ", 
     RowBox[{"(", 
      RowBox[{"by", " ", "flavourin"}], ")"}]}]}], "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{
   "20170515", " ", "this", " ", "version", " ", "corrfxQdtaobsclassin", " ", 
    "structure", " ", "is", " ", 
    RowBox[{"{", 
     RowBox[{"class1", ",", " ", "class2", ",", "..."}], "}"}], "\n", "it", 
    " ", "is", " ", "for", " ", "plotting", " ", "different", " ", "group", 
    " ", "of", " ", "data", " ", "in", " ", "different", " ", "point", " ", 
    "shapes"}], "\n", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"20171108", ":", " ", 
    RowBox[{"reorganize", " ", "the", " ", "function"}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "use", " ", "the", " ", "new", " ", "highlight", " ", "range", " ", 
    "convention"}], "*)"}], "\n", 
  RowBox[{
   RowBox[{"getcorrinfo", "[", 
    RowBox[{
    "corrfxQdtaobsclassin_", ",", "configargumentsin_", ",", "plottypein_", 
     ",", "flavourin_"}], "]"}], ":=", "\n", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"corrfxQdtaobsclass", "=", "corrfxQdtaobsclassin"}], ","}], 
       "*)"}], 
      RowBox[{
       RowBox[{"configarguments", "=", "configargumentsin"}], ",", "\n", 
       RowBox[{"plottype", "=", "plottypein"}], ",", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"flavour", "=", "flavourin"}], ","}], "*)"}], "flavour", ",",
        "\n", "Jobid", ",", "PDFname", ",", "FigureType", ",", "FigureFlag", 
       ",", "ExptidType", ",", "ExptidFlag", ",", "CorrelationArgType", ",", 
       "CorrelationArgFlag", ",", "UserArgName", ",", "UserArgValue", ",", 
       "\n", "XQfigureXrange", ",", "XQfigureYrange", ",", "Hist1figureNbin", 
       ",", "Hist1figureXrange", ",", "Hist1figureYrange", ",", "\n", 
       "ColorSeperator", ",", "\n", "Size", ",", "HighlightType", ",", 
       "HighlightMode", ",", "HighlightMode1", ",", "HighlightMode2", ",", 
       "\n", "processes", ",", "ExptList1", ",", "pdfsetexps", ",", 
       "processestitle", ",", "PDISNCtitle", ",", "NDISCCtitle", ",", 
       "PDISNCCCtitle", ",", "PVBPZtitle", ",", "PVBPWtitle", ",", "PJPtitle",
        ",", "hDISNCtitle", ",", "hDISCCtitle", ",", "hVBPZtitle", ",", 
       "pdfnamelable", ",", "PDFsetlabel", ",", "pdffile", ",", "corrfile", 
       ",", "pdfcorr", ",", "pdfcorrdr", ",", "deltaR", ",", "textsize", ",", 
       "Npttext", ",", "maxtext", ",", "maxmarker", ",", "mintext", ",", 
       "minmarker", ",", "cuttext", ",", "epilogxQ", ",", "epilogxQcorr", ",",
        "corrtitle1", ",", "corrdrtitle1", ",", "deltaRtitle1", ",", "title2",
        ",", "obsname", ",", "title3", ",", "title4", ",", "title", ",", 
       "xtitle", ",", "ytitle", ",", "xhisttitle", ",", "xhistabstitle", ",", 
       "yhisttitle", ",", "plotrange", ",", "stretchx", ",", "stretchy", ",", 
       "legendlabel", ",", "barseperator", ",", "binset", ",", "lineelement", 
       ",", "plotrangex", ",", "SM", ",", "SM1", ",", "SM2", ",", "SM3", ",", 
       "xQplotcorr", " ", ",", "histplotcorr1", ",", "histplotcorr2", ",", 
       "xQplotcorrdr", ",", "histplotcorrdr1", ",", "histplotcorrdr2", ",", 
       "xQplotdr", ",", "histplotdr2", ",", "myexpids", ",", "fmax", ",", 
       "fmax2", ",", "\n", "imgsize", ",", 
       RowBox[{"(*", 
        RowBox[{"title", ",", "xtitle", ",", "ytitle", ","}], "*)"}], 
       "lgdlabel", ",", "xrange", ",", "yrange", ",", "epilog", ",", 
       "titlesize", ",", "xtitlesize", ",", "ytitlesize", ",", "lgdlabelsize",
        ",", "ticklablesize", ",", "\n", "myplotstyle", ",", "myMarker", ",", 
       "\n", "lgdpos", ",", "xyrangeplot1", ",", "\n", "myplotsetting", ",", 
       "plot1data", ",", "plot1", ",", "processesplot1order", ",", "\n", 
       "dummy1", ",", "dummy2", ",", "percentagetext", ",", "hist1plotrangex",
        ",", "histautoxrange", ",", "hist2autoxrange", ",", "hist2plotrangex",
        ",", "xQautorange", ",", "unhighlightsize", ",", "highlightrange", 
       ",", "highlighttext", ",", "\n", "exptlist", ",", "expttype", ",", 
       "\n", "rows", ",", "exptnames", ",", "exptnamestable", ",", "\n", 
       "lineelement2", ",", "maxdata", ",", "\[IndentingNewLine]", 
       "barlegend", ",", "\[IndentingNewLine]", "histtitle", ",", 
       "histabstitle", ",", "yhistabstitle", ",", "HistAutoMode", ",", 
       "userdifinefuncfilename", ",", "\[IndentingNewLine]", 
       "hist1plotrangey", ",", "hist2plotrangey", ",", "BinWidth", ",", 
       "hist1plotrange", ",", "hist2plotrange", ",", "highlightlines", ",", 
       "\[IndentingNewLine]", "xmintmp", ",", "xmaxtmp", ",", "ymintmp", ",", 
       "hist1epilogtext", ",", "hist2epilogtext", ",", "hist1standardlines", 
       ",", "hist2standardlines", ",", "LineWidth", ",", 
       "HistAutoFixXrangeBool", ",", "\[IndentingNewLine]", "datemode", ",", 
       "HistDataList", ",", "HistAbsDataList", ",", "DataMax", ",", "DataMin",
        ",", "AbsDataMax", ",", "AbsDataMin", ",", "DataMean", ",", 
       "AbsDataMean", ",", "DataMedian", ",", "AbsDataMedian", ",", "DataSD", 
       ",", "AbsDataSD", ",", "\[IndentingNewLine]", "ColorPaletteMode", ",", 
       "PaletteMax", ",", "PaletteMin", ",", "\[IndentingNewLine]", 
       "groupnames", ",", "groupExptIDs", ",", "classifymode", ",", 
       "\[IndentingNewLine]", "ColorPaletterange", ",", "JobDescription", ",",
        "\[IndentingNewLine]", "shapeslist", ",", "abstitle", ",", 
       "absPaletteMax", ",", "absbarseperator", ",", "absbarlegend", ",", 
       "xQplotcorr2", ",", "exptnamestitle", ",", "\[IndentingNewLine]", 
       "safewidth", ",", "datatype", ",", "output"}], "}"}], ",", "\n", "\n", 
     
     RowBox[{"(*", 
      RowBox[{
      "read", " ", "arguments", " ", "in", " ", "config", " ", "file"}], 
      "*)"}], "\n", 
     RowBox[{"(*", 
      RowBox[{
      "===", "===", "===", "===", "===", "===", "===", "===", "===", "==="}], 
      "*)"}], "\n", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Jobid", ",", "JobDescription", 
         RowBox[{"(*", "20171128", "*)"}], ",", "PDFname", ",", "FigureType", 
         ",", "FigureFlag", ",", "ExptidType", ",", "ExptidFlag", ",", 
         "CorrelationArgType", ",", "CorrelationArgFlag", ",", 
         RowBox[{"(*", 
          RowBox[{"UserArgName", ",", "UserArgValue", ","}], "*)"}], "\n", 
         "XQfigureXrange", ",", "XQfigureYrange", ",", "ColorPaletterange", 
         RowBox[{"(*", "20171128", "*)"}], ",", "Hist1figureNbin", ",", 
         RowBox[{"(*", 
          RowBox[{"Hist1figureXrange", ",", "Hist1figureYrange", ","}], 
          "*)"}], "\n", 
         RowBox[{"(*", 
          RowBox[{"ColorSeperator", ","}], "*)"}], "\n", "Size", ",", 
         "HighlightType", ",", "HighlightMode", ",", "HighlightMode1", ",", 
         "HighlightMode2"}], "}"}], "=", "configarguments"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"20171128", ":", " ", 
         RowBox[{
         "set", " ", "hist", " ", "xrange", " ", "determined", " ", "by", " ",
           "the", " ", "range", " ", "of", " ", "color", " ", "palette"}]}], 
        ",", " ", 
        RowBox[{"yrange", " ", "alway", " ", "auto"}]}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"Hist1figureXrange", "=", "ColorPaletterange"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Hist1figureYrange", "=", 
       RowBox[{"{", 
        RowBox[{"\"\<auto\>\"", ",", "\"\<auto\>\""}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"should", " ", "be", " ", "three", " ", "numbers"}], ",", " ", 
        RowBox[{"representing", " ", "percentage"}], ",", " ", 
        RowBox[{"and", " ", "from", " ", "small", " ", "to", " ", "large"}], 
        ",", " ", 
        RowBox[{"ex", ":", " ", "30"}], ",", " ", "50", ",", " ", "70"}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"ColorSeperator", "=", 
       RowBox[{"{", 
        RowBox[{"50", ",", "70", ",", "85"}], "}"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"20171109", ":", " ", 
        RowBox[{"seperate", " ", "user", " ", "difine", " ", 
         RowBox[{"function", "/", "data"}], " ", "IO", " ", "and", " ", 
         "configure", " ", "file"}]}], "*)"}], 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"20171116", ":"}], " ", "->", "ReadUserFunctionV2"}], ",", 
        " ", 
        RowBox[{
        "which", " ", "read", " ", "Expression", " ", "from", " ", "the", " ",
          "file"}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"20171119", " ", "new", " ", "user", " ", "function", " ", 
        RowBox[{"format", ":", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"user", " ", "name", " ", "1"}], ",", " ", 
             RowBox[{"user", " ", "function", " ", "1"}]}], "}"}], ",", " ", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"user", " ", "name", " ", "2"}], ",", " ", 
              RowBox[{"user", " ", "function", " ", "2"}]}], "}"}], "..."}]}],
           "}"}]}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"userdifinefuncfilename", "=", "\"\<user_func.txt\>\""}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"UserArgName", ",", "UserArgValue"}], "}"}], "=", 
         RowBox[{"ReadUserFunctionV2", "[", 
          RowBox[{"\"\<./\>\"", ",", "userdifinefuncfilename"}], "]"}]}], 
        ";"}], "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", "20171127", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"CorrelationArgFlag", "[", 
          RowBox[{"[", 
           RowBox[{"-", "1"}], "]"}], "]"}], "\[Equal]", "1"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"UserArgName", "=", 
          RowBox[{"ReadUserFunctionV3", "[", 
           RowBox[{"\"\<./\>\"", ",", "userdifinefuncfilename"}], "]"}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"UserArgName", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "&"}], "/@", "UserArgName"}]}], 
         ";", "\[IndentingNewLine]", "\"\<dummy\>\""}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"20171109", ":", " ", 
        RowBox[{
        "shorten", " ", "the", " ", "tiles", " ", "of", " ", "figures"}]}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
        "PDFname", "\[Equal]", 
         "\"\<2017.1008.0954.-0500_CT14HERA2-jet.ev\>\""}], ",", 
        RowBox[{"PDFname", "=", "\"\<CT14HERA2-jet.ev\>\""}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
       "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
        "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
        "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
        "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
        "===", "=="}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"Data", " ", "organization"}], "===", "===", "===", "===", "===",
         "===", "===", "===", "===", "===", "===", 
        RowBox[{"==", 
         RowBox[{
         "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
           "===", "===", "===", "===", "===", "===", "===", "===", "===", 
          RowBox[{"==", 
           RowBox[{"===", "===", "===", "===", "=="}]}]}]}]}], "*)"}], "\n", 
      RowBox[{"(*", 
       RowBox[{
       "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
         "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
         "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
         "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
         "=="}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"read", " ", "exptlist"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"exptlist", "=", 
       RowBox[{"{", "}"}]}], ";", "\n", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"plottype", "==", "1"}], "  ", "||", " ", 
         RowBox[{"plottype", "==", "5"}], "  ", "||", " ", 
         RowBox[{"plottype", "==", "6"}]}], ",", 
        RowBox[{"exptlist", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"#", "[", 
               RowBox[{"[", 
                RowBox[{"iexpt", ",", "6"}], "]"}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{"\"\<exptinfo\>\"", ",", "\"\<exptid\>\""}], "]"}], 
              "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"iexpt", ",", "1", ",", 
               RowBox[{"Length", "[", "#", "]"}]}], "}"}]}], "]"}], "&"}], "/@",
           "corrfxQdtaobsclassin"}]}]}], " ", "]"}], ";", "\n", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"plottype", "==", "2"}], "  ", "||", " ", 
         RowBox[{"plottype", "==", "3"}], "  ", "||", " ", 
         RowBox[{"plottype", "==", "4"}]}], ",", "\n", 
        RowBox[{"exptlist", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"#", "[", 
               RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{"\"\<exptinfo\>\"", ",", "\"\<exptid\>\""}], "]"}], 
              "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"iexpt", ",", "1", ",", 
               RowBox[{"Length", "[", "#", "]"}]}], "}"}]}], "]"}], "&"}], "/@",
           "corrfxQdtaobsclassin"}]}]}], " ", "]"}], ";", "\n", 
      RowBox[{"(*", "test", "*)"}], 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"Print", "[", 
         RowBox[{"\"\<expts: \>\"", ",", "exptlist"}], "]"}], ";"}], "*)"}], 
      "\n", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
        "20171126", " ", "classify", " ", "mode", " ", "for", " ", "data"}], 
        " ", "\[Rule]", " ", 
        RowBox[{
        "different", " ", "shape", " ", "for", " ", "each", " ", "group"}]}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"classifymode", "=", "ClassifyMode"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", "********************************)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
       "prepare", " ", "for", " ", "data", " ", "input", " ", "to", " ", 
        "processdataplotsmultiexp"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", "********************************)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
        "transf", " ", "format", " ", "from", " ", "LF", " ", "to", " ", 
         "LF1"}], ",", " ", 
        RowBox[{
        "since", " ", "plot", " ", "functions", " ", "use", " ", "LF1"}]}], 
       "*)"}], "\n", "\n", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"if", " ", "dr", "*", "corr", " ", "or", " ", "corr"}], ",", 
        " ", 
        RowBox[{"data", " ", 
         RowBox[{"is", " ", "[", 
          RowBox[{"[", 
           RowBox[{"iexpt", ",", "flavour"}], "]"}], "]"}]}]}], "*)"}], "\n", 
      
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"20170515", ":", " ", "pdfcorr"}], " ", "=", " ", 
         RowBox[{"{", 
          RowBox[{"group1data", ",", " ", "group2data", ",", " ", "..."}], 
          "}"}]}], ",", " ", 
        RowBox[{"groupNdata", " ", "=", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"LF1", "[", 
            RowBox[{"x", ",", "Q", ",", "obs"}], "]"}], ",", "..."}], 
          "}"}]}]}], "*)"}], "\n", 
      RowBox[{"If", "[", "\n", 
       RowBox[{
        RowBox[{
         RowBox[{"plottype", "==", "5"}], "  ", "||", " ", 
         RowBox[{"plottype", "==", "6"}]}], ",", "\n", 
        RowBox[{
         RowBox[{"fmax", "=", 
          RowBox[{"Length", "[", 
           RowBox[{"corrfxQdtaobsclassin", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "1"}], "]"}], "]"}], " ", "]"}]}], ";", "\n", 
         "\n", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"data", " ", "format"}], " ", "\[Equal]", " ", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"LF", "[", 
               RowBox[{"x", ",", "Q", ",", "obs"}], "]"}], ",", "...", ",", 
              "..."}], "}"}]}], ",", " ", 
           RowBox[{"to", " ", "LF1"}]}], "*)"}], "\n", 
         RowBox[{"pdfcorr", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", 
                  RowBox[{"iexpt", ",", 
                   RowBox[{"flavourin", "+", "6"}]}], "]"}], "]"}], "[", 
                RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "/.", 
               RowBox[{"LF", "->", "LF1"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"iexpt", ",", "1", ",", 
                RowBox[{"Length", "[", "#", "]"}]}], "}"}]}], "]"}], "&"}], "/@",
            "corrfxQdtaobsclassin"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"Print", "[", 
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"exptlist", "[", 
             RowBox[{"[", "1", "]"}], "]"}], " ", "]"}], ",", "\"\<  \>\"", 
           ",", 
           RowBox[{"Length", "[", 
            RowBox[{"pdfcorr", "[", 
             RowBox[{"[", "1", "]"}], "]"}], " ", "]"}]}], " ", "]"}], ";", 
         RowBox[{"(*", 
          RowBox[{"test", " ", "length", " ", "data"}], "*)"}], "\n", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{"20171126", ":", " ", 
           RowBox[{
           "classify", " ", "exptid", " ", "by", " ", "defined", " ", 
            "groups", " ", "with", " ", "classifymode"}]}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"groupnames", ",", "groupExptIDs", ",", 
            RowBox[{"(*", "groupdata", "*)"}], "pdfcorr"}], "}"}], "=", 
          RowBox[{"ClassifyPlottedData", "[", 
           RowBox[{
            RowBox[{"pdfcorr", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{"exptlist", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", "classifymode"}], "]"}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"Print", "[", 
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"exptlist", "[", 
             RowBox[{"[", "1", "]"}], "]"}], " ", "]"}], ",", "\"\<  \>\"", 
           ",", 
           RowBox[{"Length", "[", "pdfcorr", "]"}]}], " ", "]"}], ";", 
         RowBox[{"(*", 
          RowBox[{"test", " ", "length", " ", "data"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"pdfcorr", "=", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"Flatten", "[", 
               RowBox[{
                RowBox[{"pdfcorr", "[", 
                 RowBox[{"[", "igroup", "]"}], "]"}], ",", "1"}], "]"}], ",", 
              
              RowBox[{"{", 
               RowBox[{"igroup", ",", 
                RowBox[{"Length", "[", "pdfcorr", "]"}]}], "}"}]}], "]"}]}], 
           ";"}], "*)"}], "\[IndentingNewLine]", "\n", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
           "merge", " ", "all", " ", "experimental", " ", "data", " ", "into",
             " ", "one"}], ",", " ", 
           RowBox[{"for", " ", "all", " ", "flavours"}]}], "*)"}], "\n", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"ex", ":", " ", 
            RowBox[{"corrdataforplot", "[", 
             RowBox[{"[", 
              RowBox[{"iexpt", ",", "flavour", ",", "Npt"}], "]"}], "]"}]}], 
           " ", "\[Rule]", " ", 
           RowBox[{"orrdataforplot", "[", 
            RowBox[{"[", 
             RowBox[{"flavour", ",", "Npt"}], "]"}], "]"}]}], "*)"}], "\n", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"pdfcorr", " ", ",", "dummy1", ",", "dummy2"}], "}"}], 
            "=", 
            RowBox[{"mergeplotdata", "[", 
             RowBox[{"{", 
              RowBox[{"pdfcorr", " ", ",", "pdfcorr", ",", "pdfcorr"}], "}"}],
              "]"}]}], ";"}], "*)"}], "\n", 
         RowBox[{"pdfcorr", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"Flatten", "[", 
             RowBox[{"#", ",", "1"}], "]"}], "&"}], "/@", "pdfcorr"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"Print", "[", 
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"exptlist", "[", 
             RowBox[{"[", "1", "]"}], "]"}], " ", "]"}], ",", "\"\<  \>\"", 
           ",", 
           RowBox[{"Length", "[", "pdfcorr", "]"}], ",", "\"\< \>\"", ",", 
           RowBox[{"Length", "[", "groupnames", "]"}], ",", "\"\< \>\"", ",", 
           
           RowBox[{"Length", "[", "groupExptIDs", "]"}]}], " ", "]"}], ";", 
         RowBox[{"(*", 
          RowBox[{"test", " ", "length", " ", "data"}], "*)"}], "\n", "\n", 
         RowBox[{"(*", " ", 
          RowBox[{"deletezerovalue", ":", " ", 
           RowBox[{
           "delete", " ", "data", " ", "with", " ", "0", " ", "value", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
              "0", " ", "value", " ", "usually", " ", "from", " ", "mb"}], 
              ",", " ", 
              RowBox[{"mc", " ", "cut"}]}], ")"}]}]}], "*)"}], "\n", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"pdfcorr", " ", ",", "dummy1", ",", "dummy2"}], "}"}], 
            "=", 
            RowBox[{"deletezerovalue", "[", 
             RowBox[{"{", 
              RowBox[{"pdfcorr", " ", ",", "pdfcorr", ",", "pdfcorr"}], "}"}],
              "]"}]}], ";"}], "*)"}], "\n", 
         RowBox[{"pdfcorr", "=", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Select", "[", 
             RowBox[{
              RowBox[{"pdfcorr", "[", 
               RowBox[{"[", "igroup", "]"}], "]"}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "!=", "0"}], "&"}]}], "]"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{"igroup", ",", "1", ",", 
              RowBox[{"Length", "[", "pdfcorr", "]"}]}], "}"}]}], "]"}]}], 
         ";", "\n", "\"\<dummy\>\""}]}], "\n", "]"}], ";", "\n", "\n", 
      RowBox[{"(*", 
       RowBox[{"data", " ", 
        RowBox[{"of", " ", "[", 
         RowBox[{"[", "iexpt", "]"}], "]"}]}], "*)"}], "\n", 
      RowBox[{"If", "[", "\n", 
       RowBox[{
        RowBox[{
         RowBox[{"plottype", "==", "2"}], " ", "||", " ", 
         RowBox[{"plottype", "==", "3"}], " ", "||", " ", 
         RowBox[{"plottype", "==", "4"}]}], ",", "\n", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"take", " ", "data"}], ",", " ", 
          RowBox[{
          "and", " ", "format", " ", "from", " ", "LF", " ", "to", " ", "LF1",
            " ", 
           RowBox[{"(", 
            RowBox[{
            "LF1", " ", "is", " ", "format", " ", "to", " ", "input", " ", 
             "to", " ", "plot", " ", "functions"}], ")"}]}]}], "*)"}], "\n", 
        RowBox[{
         RowBox[{"pdfcorr", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "/.", 
               RowBox[{"LF", "->", "LF1"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"iexpt", ",", "1", ",", 
                RowBox[{"Length", "[", "#", "]"}]}], "}"}]}], "]"}], "&"}], "/@",
            "corrfxQdtaobsclassin"}]}], ";", "\n", 
         RowBox[{"(*", 
          RowBox[{
          "20171108", " ", "expt", " ", "error", " ", "ratio", " ", "values", 
           " ", "should", " ", "be", " ", "absolute", " ", "value"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"plottype", "==", "2"}], ",", 
           RowBox[{"pdfcorr", "=", 
            RowBox[{"pdfcorr", "/.", 
             RowBox[{
              RowBox[{"LF1", "[", "a__", "]"}], "\[RuleDelayed]", 
              RowBox[{"LF1", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", "a", "}"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"{", "a", "}"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}], ",", 
                RowBox[{"Abs", "[", 
                 RowBox[{
                  RowBox[{"{", "a", "}"}], "[", 
                  RowBox[{"[", "3", "]"}], "]"}], " ", "]"}]}], " ", 
               "]"}]}]}]}]}], " ", "]"}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{"20171126", ":", " ", 
           RowBox[{
           "classify", " ", "exptid", " ", "by", " ", "defined", " ", 
            "groups", " ", "with", " ", "classifymode"}]}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"groupnames", ",", "groupExptIDs", ",", 
            RowBox[{"(*", "groupdata", "*)"}], "pdfcorr"}], "}"}], "=", 
          RowBox[{"ClassifyPlottedData", "[", 
           RowBox[{
            RowBox[{"pdfcorr", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{"exptlist", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", "classifymode"}], "]"}]}], 
         ";", "\[IndentingNewLine]", "\n", 
         RowBox[{"(*", 
          RowBox[{"merge", " ", "all", " ", "data", " ", "into", " ", "one"}],
           "*)"}], "\n", 
         RowBox[{"pdfcorr", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"Flatten", "[", 
             RowBox[{"#", ",", "1"}], "]"}], "&"}], "/@", "pdfcorr"}]}], ";", 
         "\n", "\"\<dummy\>\""}]}], "\n", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"test", " ", "print"}], "*)"}], 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"Print", "[", "pdfcorr", " ", "]"}], ";", 
        RowBox[{"Print", "[", 
         RowBox[{"pdfcorr", "/.", 
          RowBox[{"LF1", "->", "LF2"}]}], " ", "]"}], ";", 
        RowBox[{"Print", "[", 
         RowBox[{"pdfcorr", "/.", 
          RowBox[{
           RowBox[{"LF1", "[", "a__", "]"}], ":>", 
           RowBox[{
            RowBox[{"{", "a", "}"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}]}]}], " ", "]"}], ";"}], "*)"}], 
      "\n", "\n", 
      RowBox[{"If", "[", "\n", 
       RowBox[{
        RowBox[{"plottype", "==", "1"}], ",", "\n", 
        RowBox[{
         RowBox[{"fmax", "=", 
          RowBox[{"Length", "[", 
           RowBox[{"corrfxQdtaobsclassin", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "1"}], "]"}], "]"}], " ", "]"}]}], ";", "\n", 
         "\n", 
         RowBox[{"(*", 
          RowBox[{"set", " ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"corr", "[", 
              RowBox[{"[", "flavour", "]"}], "]"}], ",", 
             RowBox[{"drcorr", "[", 
              RowBox[{"[", "flavour", "]"}], "]"}], ",", 
             RowBox[{"dr", "[", 
              RowBox[{"[", "flavour", "]"}], "]"}]}], "}"}]}], "*)"}], "\n", 
         RowBox[{"(*", 
          RowBox[{
          "they", " ", "are", " ", "used", " ", "to", "  ", "input", " ", 
           "into", " ", "processdataplotsmultiexp"}], "*)"}], "\n", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"data", " ", "format"}], " ", "\[Equal]", " ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"LF", "[", 
              RowBox[{"x", ",", "Q", ",", "obs"}], "]"}], ",", "...", ",", 
             "..."}], "}"}]}], "*)"}], "\n", 
         RowBox[{"pdfcorr", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"Datamethods", "[", 
                  RowBox[{"[", "\"\<take\>\"", "]"}], "]"}], "[", 
                 RowBox[{
                  RowBox[{"#", "[", 
                   RowBox[{"[", 
                    RowBox[{"iexpt", ",", 
                    RowBox[{"flavourin", "+", "6"}]}], "]"}], "]"}], ",", 
                  "2"}], "]"}], "[", 
                RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "/.", 
               RowBox[{"LF", "->", "LF1"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"iexpt", ",", "1", ",", 
                RowBox[{"Length", "[", "#", "]"}]}], "}"}]}], "]"}], "&"}], "/@",
            "corrfxQdtaobsclassin"}]}], ";"}]}], "\n", "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"20171202", ":", " ", 
         RowBox[{
         "if", " ", "the", " ", "\"\<other\>\"", " ", "type", " ", "has", " ",
           "no", " ", "expt", " ", "ID"}]}], ",", " ", 
        RowBox[{"delete", " ", "it"}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", 
          RowBox[{"groupExptIDs", "[", 
           RowBox[{"[", 
            RowBox[{"-", "1"}], "]"}], "]"}], " ", "]"}], "\[Equal]", "0"}], 
        ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"groupnames", ",", "groupExptIDs", ",", 
           RowBox[{"(*", "groupdata", "*)"}], "pdfcorr"}], "}"}], "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Drop", "[", 
            RowBox[{"#", ",", 
             RowBox[{"-", "1"}]}], "]"}], "&"}], "/@", 
          RowBox[{"{", 
           RowBox[{"groupnames", ",", "groupExptIDs", ",", 
            RowBox[{"(*", "groupdata", "*)"}], "pdfcorr"}], "}"}]}]}]}], 
       "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{
        RowBox[{"Length", "[", 
         RowBox[{"exptlist", "[", 
          RowBox[{"[", "1", "]"}], "]"}], " ", "]"}], ",", "\"\<  \>\"", ",", 
        
        RowBox[{"Length", "[", "pdfcorr", "]"}]}], " ", "]"}], ";", 
      RowBox[{"(*", 
       RowBox[{"test", " ", "length", " ", "data"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
        "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
         "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
          "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
          "===", "===", "===", "===", "==="}], "=", 
        RowBox[{"===", "===", "===", "===", 
         RowBox[{"==", "=="}], "==="}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"Statistical", " ", "quantities", " ", "of", " ", "data"}], "===",
          "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
         RowBox[{"==", 
          RowBox[{
          "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
            "===", "===", "===", "===", "===", 
           RowBox[{"==", 
            RowBox[{
            "===", "===", "===", "===", "===", "===", "===", "==="}]}]}]}]}], 
        "=", "="}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
        "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
         "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
          "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
          "===", 
         RowBox[{"==", 
          RowBox[{"===", "===", "===", "===", "=="}]}]}], "=", 
        RowBox[{"===", "===", "===", "===", "==="}]}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"(*", "20171115", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "HistDataList", ",", "HistAbsDataList", ",", "DataMax", ",", "DataMin",
         ",", "AbsDataMax", ",", "AbsDataMin", ",", "DataMean", ",", 
        "AbsDataMean", ",", "DataMedian", ",", "AbsDataMedian", ",", "DataSD",
         ",", "AbsDataSD"}], "}"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"plottype", "\[Equal]", "2"}], " ", "||", " ", 
         RowBox[{"plottype", "==", "3"}], " ", "||", " ", 
         RowBox[{"plottype", "==", "4"}], " ", "||", " ", 
         RowBox[{"plottype", "==", "5"}], " ", "||", " ", 
         RowBox[{"plottype", "\[Equal]", "6"}]}], ",", "\[IndentingNewLine]", 
        
        RowBox[{
         RowBox[{"HistDataList", "=", 
          RowBox[{
           RowBox[{"Flatten", "[", "pdfcorr", "]"}], "/.", 
           RowBox[{
            RowBox[{"LF1", "[", "a__", "]"}], "\[RuleDelayed]", 
            RowBox[{
             RowBox[{"{", "a", "}"}], "[", 
             RowBox[{"[", "3", "]"}], "]"}]}]}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"HistAbsDataList", "=", 
          RowBox[{
           RowBox[{"Flatten", "[", "pdfcorr", "]"}], "/.", 
           RowBox[{
            RowBox[{"LF1", "[", "a__", "]"}], "\[RuleDelayed]", 
            RowBox[{"Abs", "[", 
             RowBox[{
              RowBox[{"{", "a", "}"}], "[", 
              RowBox[{"[", "3", "]"}], "]"}], " ", "]"}]}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"DataMax", "=", 
          RowBox[{"Max", "[", "HistDataList", "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"DataMin", "=", 
          RowBox[{"Min", "[", "HistDataList", "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"AbsDataMax", "=", 
          RowBox[{"Max", "[", "HistAbsDataList", "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"AbsDataMin", "=", 
          RowBox[{"Min", "[", "HistAbsDataList", "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"DataMean", "=", 
          RowBox[{"Mean", "[", "HistDataList", "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"AbsDataMean", "=", 
          RowBox[{"Mean", "[", "HistAbsDataList", "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"DataMedian", "=", 
          RowBox[{"Median", "[", "HistDataList", "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"AbsDataMedian", "=", 
          RowBox[{"Median", "[", "HistAbsDataList", "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"DataSD", "=", 
          RowBox[{"StandardDeviation", "[", "HistDataList", "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"AbsDataSD", "=", 
          RowBox[{"StandardDeviation", "[", "HistAbsDataList", "]"}]}], ";", 
         "\[IndentingNewLine]", "\"\<dummy\>\""}]}], "\[IndentingNewLine]", 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
        "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
         "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
          "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
          "==="}], "=", 
        RowBox[{"===", "===", "===", "===", 
         RowBox[{"==", "=="}], "===", "===", "===", "===", "==="}]}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"Highlight", " ", "range", " ", "setting"}], "===", "===", "===",
          "===", "===", "===", "===", "===", "===", "===", "===", 
         RowBox[{"==", 
          RowBox[{
          "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
            "===", 
           RowBox[{"==", 
            RowBox[{"===", "===", "===", "===", "=="}]}]}]}]}], "=", 
        RowBox[{
         RowBox[{"===", "===", "===", "===", "===", "===", "==="}], "=", 
         "="}]}], "*)"}], "\n", 
      RowBox[{"(*", 
       RowBox[{
       "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
         "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
         "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
         "===", "===", "===", "===", 
        RowBox[{"==", 
         RowBox[{"===", "===", "===", "===", "===", "==="}]}]}], "*)"}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"for", " ", "no", " ", "highlight", " ", "mode"}], ",", " ", 
        RowBox[{
        "choose", " ", "size", " ", "of", " ", "data", " ", "point", " ", 
         "in", " ", "plot", " ", "by", " ", "Size", "\n", "for", " ", 
         "highlight", " ", "mode"}], ",", " ", 
        RowBox[{
        "set", " ", "size", " ", "of", " ", "unhighlighted", " ", "data", " ",
          "as", " ", "Size"}], ",", " ", 
        RowBox[{
        "size", " ", "of", " ", "highlighted", " ", "data", " ", "is", " ", 
         "larger", " ", "than", " ", "Size"}]}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
       "===", "===", "===", "===", "===", "===", "===", "===", "===", "==="}],
        "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"highlightrange", "=", "\n", 
       RowBox[{"Switch", "[", "\n", 
        RowBox[{
         RowBox[{"HighlightMode", "[", 
          RowBox[{"[", "plottype", "]"}], "]"}], ",", "\n", "0", ",", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"0.0", ",", "0.0"}], "}"}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{"20171109", ":", " ", 
           RowBox[{
           "use", " ", "new", " ", "highlight", " ", "range", " ", 
            "convention"}]}], "*)"}], "\n", "1", ",", 
         RowBox[{"(*", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"HighlightMode1", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"2", "*", "plottype"}], "-", "1"}], "]"}], "]"}], ",", 
            
            RowBox[{"HighlightMode1", "[", 
             RowBox[{"[", 
              RowBox[{"2", "*", "plottype"}], "]"}], "]"}]}], "}"}], "*)"}], 
         RowBox[{"HighlightMode1", "[", 
          RowBox[{"[", "plottype", "]"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{"20171111", ":", " ", 
           RowBox[{"percentage", " ", "highlight"}], ":", " ", 
           RowBox[{
            RowBox[{"don", "'"}], "t", " ", "take", " ", "absolute", " ", 
            "values", " ", "for", " ", "data"}]}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"20171201", ":", " ", 
            RowBox[{
            "percentage", " ", "highlight", " ", "depends", " ", "on", " ", 
             "drawing", " ", "data"}]}], ",", " ", 
           RowBox[{
            RowBox[{"if", " ", "draw"}], " ", "|", "data", "|"}], ",", " ", 
           RowBox[{
            RowBox[{"use", " ", "percentage", " ", "of"}], " ", "|", "data", 
            "|"}]}], "*)"}], "\n", "2", ",", 
         RowBox[{"Switch", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"FigureFlag", "[", 
            RowBox[{"[", "plottype", "]"}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"-", "1"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"GetDataPercentage", "[", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{"Flatten", "[", "pdfcorr", "]"}], "/.", 
                RowBox[{
                 RowBox[{"LF1", "[", "a__", "]"}], "\[RuleDelayed]", 
                 RowBox[{
                  RowBox[{"{", "a", "}"}], "[", 
                  RowBox[{"[", "3", "]"}], "]"}]}]}], "*)"}], 
              RowBox[{"HistDataList", ",", 
               RowBox[{"(*", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"HighlightMode2", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"2", "*", "plottype"}], "-", "1"}], "]"}], "]"}], 
                  ",", 
                  RowBox[{"HighlightMode2", "[", 
                   RowBox[{"[", 
                    RowBox[{"2", "*", "plottype"}], "]"}], "]"}]}], "}"}], 
                "*)"}], "#"}], "]"}], "&"}], "/@", 
            RowBox[{"HighlightMode2", "[", 
             RowBox[{"[", "plottype", "]"}], "]"}]}], ",", 
           "\[IndentingNewLine]", "1", ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"GetDataPercentage", "[", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{"Flatten", "[", "pdfcorr", "]"}], "/.", 
                RowBox[{
                 RowBox[{"LF1", "[", "a__", "]"}], "\[RuleDelayed]", 
                 RowBox[{
                  RowBox[{"{", "a", "}"}], "[", 
                  RowBox[{"[", "3", "]"}], "]"}]}]}], "*)"}], 
              RowBox[{"HistAbsDataList", ",", 
               RowBox[{"(*", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"HighlightMode2", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"2", "*", "plottype"}], "-", "1"}], "]"}], "]"}], 
                  ",", 
                  RowBox[{"HighlightMode2", "[", 
                   RowBox[{"[", 
                    RowBox[{"2", "*", "plottype"}], "]"}], "]"}]}], "}"}], 
                "*)"}], "#"}], "]"}], "&"}], "/@", 
            RowBox[{"HighlightMode2", "[", 
             RowBox[{"[", "plottype", "]"}], "]"}]}], ",", 
           "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
            "Print", "[", "\"\<error, figure flag should be 1 or -1\>\"", 
             "]"}], ";", 
            RowBox[{"Abort", "[", "]"}]}]}], "\[IndentingNewLine]", "]"}], 
         "\n", 
         RowBox[{"(*", "\n", 
          RowBox[{"Which", "[", "\n", 
           RowBox[{
            RowBox[{
             RowBox[{"plottype", "\[Equal]", "5"}], "  ", "||", " ", 
             RowBox[{"plottype", "\[Equal]", "6"}]}], ",", "\n", 
            RowBox[{"GetDataPercentage", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"pdfcorr", "[", 
                RowBox[{"[", 
                 RowBox[{"flavourin", "+", "6"}], "]"}], "]"}], "/.", 
               RowBox[{
                RowBox[{"LF1", "[", "a__", "]"}], "\[RuleDelayed]", 
                RowBox[{"Abs", "[", 
                 RowBox[{
                  RowBox[{"{", "a", "}"}], "[", 
                  RowBox[{"[", "3", "]"}], "]"}], " ", "]"}]}]}], " ", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"HighlightMode2", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"2", "*", "plottype"}], "-", "1"}], "]"}], "]"}], 
                ",", 
                RowBox[{"HighlightMode2", "[", 
                 RowBox[{"[", 
                  RowBox[{"2", "*", "plottype"}], "]"}], "]"}]}], "}"}]}], 
             "]"}], ",", "\n", " ", 
            RowBox[{
             RowBox[{"plottype", "\[Equal]", "2"}], " ", "||", " ", 
             RowBox[{"plottype", "\[Equal]", "3"}], " ", "||", " ", 
             RowBox[{"plottype", "\[Equal]", "4"}]}], ",", "\n", 
            RowBox[{"GetDataPercentage", "[", 
             RowBox[{
              RowBox[{"pdfcorr", "/.", 
               RowBox[{
                RowBox[{"LF1", "[", "a__", "]"}], "\[RuleDelayed]", 
                RowBox[{"Abs", "[", 
                 RowBox[{
                  RowBox[{"{", "a", "}"}], "[", 
                  RowBox[{"[", "3", "]"}], "]"}], " ", "]"}]}]}], " ", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"HighlightMode2", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"2", "*", "plottype"}], "-", "1"}], "]"}], "]"}], 
                ",", 
                RowBox[{"HighlightMode2", "[", 
                 RowBox[{"[", 
                  RowBox[{"2", "*", "plottype"}], "]"}], "]"}]}], "}"}]}], 
             "]"}], ",", "\n", "True", ",", 
            RowBox[{
             RowBox[{
             "Print", "[", "\"\<presently plottype is only 2~6 \>\"", "]"}], 
             ";", 
             RowBox[{"Abort", "[", "]"}]}]}], "\n", "]"}], "*)"}], ",", "\n", 
         "_", ",", 
         RowBox[{
          RowBox[{
          "Print", "[", "\"\<error, highlight mode should be 0, 1, 2\>\"", 
           "]"}], ";", 
          RowBox[{"Abort", "[", "]"}]}]}], "\n", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
       "20171201", " ", "for", " ", "percentage", " ", "highlight", " ", 
        "the", " ", "largest", " ", "one", " ", "should", " ", "have", " ", 
        "a", " ", "range", " ", "of", " ", "width", " ", "to", " ", "include",
         " ", "the", " ", "highest", " ", "percentage", " ", "point"}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"HighlightMode", "[", 
          RowBox[{"[", "plottype", "]"}], "]"}], "\[Equal]", "2"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"safewidth", "=", 
             RowBox[{"0.000001", "*", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"highlightrange", "[", 
                 RowBox[{"[", 
                  RowBox[{"iHL", ",", "2"}], "]"}], "]"}], "-", 
                RowBox[{"highlightrange", "[", 
                 RowBox[{"[", 
                  RowBox[{"iHL", ",", "1"}], "]"}], "]"}]}], ")"}]}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"highlightrange", "[", 
              RowBox[{"[", 
               RowBox[{"iHL", ",", "1"}], "]"}], "]"}], "=", 
             RowBox[{
              RowBox[{"highlightrange", "[", 
               RowBox[{"[", 
                RowBox[{"iHL", ",", "1"}], "]"}], "]"}], "-", "safewidth"}]}],
             ";", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"highlightrange", "[", 
              RowBox[{"[", 
               RowBox[{"iHL", ",", "2"}], "]"}], "]"}], "=", 
             RowBox[{
              RowBox[{"highlightrange", "[", 
               RowBox[{"[", 
                RowBox[{"iHL", ",", "2"}], "]"}], "]"}], "+", 
              "safewidth"}]}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"iHL", ",", 
             RowBox[{"Length", "[", "highlightrange", "]"}]}], "}"}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         "\"\<dummy\>\""}]}], " ", "\[IndentingNewLine]", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"**", "**"}], "**"}], "**"}], "**"}], "**"}], "**"}]\
, "**"}], "**"}], "**"}], "**"}], "**"}], "**"}], "**"}], "**"}], "**"}], 
                    "**"}], "**"}], "**"}], "**"}], "**"}], "**"}], "**"}], 
                    "**"}], "**"}], "**"}], "**"}], "**"}], "**"}], "**"}], 
             "**"}], "**"}], "**"}], "**"}], "**"}], "**"}], "******)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"pdfnamelable", "=", 
       RowBox[{"{", 
        RowBox[{
        "\"\<bbar(x,Q)\>\"", ",", "\"\<cbar(x,Q)\>\"", ",", 
         "\"\<sbar(x,Q)\>\"", ",", "\"\<dbar(x,Q)\>\"", ",", 
         "\"\<ubar(x,Q)\>\"", ",", "\"\<g(x,\[Mu])\>\"", ",", 
         "\"\<u(x,\[Mu])\>\"", ",", "\"\<d(x,\[Mu])\>\"", ",", 
         "\"\<s(x,\[Mu])\>\"", ",", "\"\<c(x,\[Mu])\>\"", ",", 
         "\"\<b(x,\[Mu])\>\""}], "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"20171127", ":", " ", 
        RowBox[{
        "only", " ", "add", " ", "new", " ", "string", " ", "when", " ", 
         "user", " ", "function", " ", "is", " ", "mode", " ", "on"}]}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"CorrelationArgFlag", "[", 
          RowBox[{"[", 
           RowBox[{"-", "1"}], "]"}], "]"}], "\[Equal]", "1"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"pdfnamelable", "=", 
          RowBox[{"pdfnamelable", "~", "Join", "~", 
           RowBox[{"{", 
            RowBox[{"Sequence", "@@", "UserArgName"}], 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{"20171119", " ", "change", " ", "to", " ", "multi"}], 
              "-", 
              RowBox[{"user", " ", "functions"}]}], "*)"}], "}"}]}]}], ";", 
         "\[IndentingNewLine]", "\"\<dummy\>\""}]}], "\[IndentingNewLine]", 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"20171202", " ", "select", " ", "highlighted", " ", "points"}],
        "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{
         "20171202", " ", "if", " ", "plot", " ", "type", " ", "flag"}], " ", 
         "=", " ", 
         RowBox[{"-", "1"}]}], ",", " ", 
        RowBox[{
         RowBox[{"show", " ", "statistics", " ", "of"}], " ", "|", "data", 
         "|"}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"datatype", "=", 
       RowBox[{"{", 
        RowBox[{
        "\"\<xQ plot\>\"", ",", "\"\<|sigma/D|\>\"", ",", 
         "\"\<r (residuals)\>\"", ",", 
         "\"\<deltaR (uncertainties of residuals)\>\"", ",", 
         "\"\<Sens(r, f(x,Q))\>\"", ",", "\"\<Corr(r, f(x,Q))\>\""}], "}"}]}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"datatype", "=", 
       RowBox[{"datatype", "[", 
        RowBox[{"[", "plottype", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"FigureFlag", "[", 
          RowBox[{"[", "plottype", "]"}], "]"}], "\[Equal]", "1"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"pdfcorr", "=", 
          RowBox[{"pdfcorr", "/.", 
           RowBox[{
            RowBox[{"LF1", "[", "a__", "]"}], "\[RuleDelayed]", 
            RowBox[{"LF1", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"{", "a", "}"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{
               RowBox[{"{", "a", "}"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], ",", 
              RowBox[{"Abs", "[", 
               RowBox[{
                RowBox[{"{", "a", "}"}], "[", 
                RowBox[{"[", "3", "]"}], "]"}], " ", "]"}]}], " ", 
             "]"}]}]}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"plottype", "\[Equal]", "3"}], " ", "||", " ", 
            RowBox[{"plottype", "\[Equal]", "5"}], " ", "||", " ", 
            RowBox[{"plottype", "\[Equal]", "6"}]}], ",", 
           RowBox[{"datatype", "=", 
            RowBox[{"\"\<|\>\"", "<>", "datatype", "<>", "\"\<|\>\""}]}]}], 
          "]"}], ";", "\[IndentingNewLine]", "\"\<dummy\>\""}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"pdfcorr", "[", 
          RowBox[{"[", "iexpt", "]"}], "]"}], "=", "\[IndentingNewLine]", 
         RowBox[{"Select", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"pdfcorr", "[", 
            RowBox[{"[", "iexpt", "]"}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"Intersection", "[", 
               RowBox[{
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ">=", 
                    RowBox[{"highlightrange", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "1"}], "]"}], "]"}]}], " ", "&&", " ", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "<", 
                    RowBox[{"highlightrange", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "2"}], "]"}], "]"}]}]}], ")"}], ",", 
                    "True", ",", "False"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"i", ",", 
                    RowBox[{"Length", "[", "highlightrange", "]"}]}], "}"}]}],
                  "]"}], ",", 
                RowBox[{"{", "True", "}"}]}], "]"}], " ", "]"}], ">", "0"}], 
            "&"}]}], "\[IndentingNewLine]", "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"iexpt", ",", 
          RowBox[{"Length", "[", "pdfcorr", "]"}]}], "}"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{
        RowBox[{"Length", "[", 
         RowBox[{"exptlist", "[", 
          RowBox[{"[", "1", "]"}], "]"}], " ", "]"}], ",", "\"\< \>\"", ",", 
        RowBox[{"Length", "[", "pdfcorr", "]"}]}], " ", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", "output", "*)"}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"if", " ", "|", "data", "|"}], ",", " ", 
        RowBox[{
         RowBox[{
         "define", " ", "get", " ", "statistical", " ", "quantities", " ", 
          "of"}], " ", "|", "data", "|"}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"FigureFlag", "[", 
          RowBox[{"[", "plottype", "]"}], "]"}], "\[Equal]", "1"}], ",", 
        RowBox[{
         RowBox[{"DataMax", "=", "AbsDataMax"}], ";", 
         RowBox[{"DataMin", "=", "AbsDataMin"}], ";", 
         RowBox[{"DataMean", "=", "AbsDataMean"}], ";", 
         RowBox[{"DataMedian", "=", "AbsDataMedian"}], ";", 
         RowBox[{"DataSD", "=", "AbsDataSD"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"output", " ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", "labels", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"values", " ", "or", " ", "descriptions"}], "}"}]}], 
         "}"}]}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"plottype", "\[Equal]", "5"}], " ", "||", " ", 
          RowBox[{"plottype", "\[Equal]", "6"}]}], ")"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"output", "=", "\[IndentingNewLine]", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "\"\<datatype\>\"", ",", "\"\<flavour\>\"", ",", "\"\<Expts\>\"", 
             ",", "\"\<DataMax\>\"", ",", "\"\<DataMin\>\"", ",", 
             "\"\<DataMean\>\"", ",", "\"\<DataMedian\>\"", ",", 
             "\"\<DataSD\>\"", ",", "\"\<highlightrange\>\"", ",", 
             "\"\<highlighted data\>\""}], "}"}], ",", "\n", 
           RowBox[{"{", 
            RowBox[{"datatype", ",", 
             RowBox[{"pdfnamelable", "[", 
              RowBox[{"[", 
               RowBox[{"flavourin", "+", "6"}], "]"}], "]"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{"ExptIDtoName", "[", 
                  RowBox[{"#", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], " ", "]"}]}], "}"}], "&"}],
               "/@", "groupExptIDs"}], ",", "DataMax", ",", "DataMin", ",", 
             "DataMean", ",", "DataMedian", ",", "DataSD", ",", 
             "highlightrange", ",", 
             RowBox[{"Transpose", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"ExptIDtoName", "[", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], " ", "]"}]}], "}"}], 
                   "&"}], "/@", "groupExptIDs"}], ",", "pdfcorr"}], "}"}], 
               ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}]}], "]"}]}], "}"}]}], 
          "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", "]"}], ";",
       "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"plottype", "\[Equal]", "2"}], " ", "||", " ", 
          RowBox[{"plottype", "\[Equal]", "3"}], " ", "||", " ", 
          RowBox[{"plottype", "\[Equal]", "4"}]}], ")"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"output", "=", "\[IndentingNewLine]", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"\"\<datatype\>\"", ",", 
             RowBox[{"(*", 
              RowBox[{"\"\<flavour\>\"", ","}], "*)"}], "\"\<Expts\>\"", ",", 
             "\"\<DataMax\>\"", ",", "\"\<DataMin\>\"", ",", 
             "\"\<DataMean\>\"", ",", "\"\<DataMedian\>\"", ",", 
             "\"\<DataSD\>\"", ",", "\"\<highlightrange\>\"", ",", 
             "\"\<highlighted data\>\""}], "}"}], ",", "\n", 
           RowBox[{"{", 
            RowBox[{"datatype", ",", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"pdfnamelable", "[", 
                RowBox[{"[", 
                 RowBox[{"flavourin", "+", "6"}], "]"}], "]"}], ","}], "*)"}], 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{"ExptIDtoName", "[", 
                  RowBox[{"#", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], " ", "]"}]}], "}"}], "&"}],
               "/@", "groupExptIDs"}], ",", "DataMax", ",", "DataMin", ",", 
             "DataMean", ",", "DataMedian", ",", "DataSD", ",", 
             "highlightrange", ",", 
             RowBox[{"Transpose", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"ExptIDtoName", "[", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], " ", "]"}]}], "}"}], 
                   "&"}], "/@", "groupExptIDs"}], ",", "pdfcorr"}], "}"}], 
               ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}]}], "]"}]}], "}"}]}], 
          "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "output"}]}], "\[IndentingNewLine]", 
    RowBox[{
    "(*", "\[IndentingNewLine]", "groupExptIDs", "\[IndentingNewLine]", 
     "*)"}], "\n", 
    RowBox[{"(*", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"exptlist", ",", "highlightrange", ",", "pdfcorr"}], "}"}], 
     "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", "]"}]}]}]], "Input",\

 CellChangeTimes->{{3.719191350439296*^9, 3.719191351444817*^9}, {
   3.7191913915234013`*^9, 3.719191542948613*^9}, {3.719191579916553*^9, 
   3.719191608650613*^9}, {3.71919227592983*^9, 3.719192288781296*^9}, {
   3.7191923331675873`*^9, 3.7191923866844063`*^9}, {3.7191924359464827`*^9, 
   3.719192510042478*^9}, {3.719192540110292*^9, 3.719192590689439*^9}, {
   3.7191926289901857`*^9, 3.71919264133893*^9}, {3.719192705618341*^9, 
   3.719192775000009*^9}, {3.7191928207204847`*^9, 3.7191929214824*^9}, {
   3.719192988237002*^9, 3.719192991894369*^9}, {3.7191930997034483`*^9, 
   3.719193108867979*^9}, {3.719193251526259*^9, 3.719193262072785*^9}, {
   3.7191933781344*^9, 3.71919338543708*^9}, {3.719193444086508*^9, 
   3.719193469747447*^9}, {3.719193562493108*^9, 3.719193577993537*^9}, {
   3.71919373787492*^9, 3.719193740748376*^9}, {3.7191937910345163`*^9, 
   3.7191938059509697`*^9}, {3.719193884246745*^9, 3.719193934538932*^9}, {
   3.719194022420391*^9, 3.719194046647883*^9}, {3.719194076769895*^9, 
   3.719194086872014*^9}, {3.719194192431547*^9, 3.719194258995154*^9}, 
   3.71919439159704*^9, {3.719194429618018*^9, 3.719194432631043*^9}, {
   3.71919450143403*^9, 3.719194529182914*^9}, {3.719194635646356*^9, 
   3.7191946536721153`*^9}, {3.7191946950828238`*^9, 3.719194708174732*^9}, {
   3.7191947955228157`*^9, 3.719194848070615*^9}, {3.7191949463400717`*^9, 
   3.719194960747587*^9}, {3.719195036771473*^9, 3.7191950778321857`*^9}, {
   3.7191951677811403`*^9, 3.719195291171475*^9}, {3.719195328406781*^9, 
   3.719195343911694*^9}, {3.719212457840344*^9, 3.719212465643208*^9}, {
   3.7192124964794693`*^9, 3.7192126548279057`*^9}, {3.7192127724438457`*^9, 
   3.719212822123301*^9}, 3.719212860835353*^9, {3.719212891451104*^9, 
   3.719212960456065*^9}, {3.7192132853251457`*^9, 3.719213484780237*^9}, {
   3.719213515608519*^9, 3.719213547278957*^9}, {3.719213590311339*^9, 
   3.7192136125315847`*^9}, {3.719213698453277*^9, 3.719213730590592*^9}, {
   3.719213789299914*^9, 3.719213834906002*^9}, {3.719213882242855*^9, 
   3.7192139044347486`*^9}, {3.719213936787261*^9, 3.719213985464634*^9}, {
   3.719214097234009*^9, 3.719214151577786*^9}, {3.7192146897077637`*^9, 
   3.7192146898857107`*^9}, {3.719215614845934*^9, 3.7192156150917063`*^9}, {
   3.71922046828438*^9, 3.71922050065518*^9}, {3.719220645423839*^9, 
   3.71922064863894*^9}, {3.719220861754607*^9, 3.71922095481752*^9}, {
   3.719221035577244*^9, 3.7192210654184237`*^9}, {3.719221117344846*^9, 
   3.719221160936112*^9}, {3.719221263262035*^9, 3.719221309521122*^9}, {
   3.7192214233647346`*^9, 3.7192214348505898`*^9}, {3.719221520075737*^9, 
   3.7192215770495033`*^9}, {3.719221751786022*^9, 3.719221779006188*^9}, {
   3.719222119450335*^9, 3.719222156463868*^9}, {3.719222772112879*^9, 
   3.719222777822998*^9}, {3.71922333354941*^9, 3.7192233425927477`*^9}, {
   3.719223373727326*^9, 3.7192233756177177`*^9}, {3.719224222841838*^9, 
   3.719224230384398*^9}, {3.719225408102343*^9, 3.7192254473635178`*^9}, {
   3.719225599562457*^9, 3.719225628277442*^9}, {3.719225686853244*^9, 
   3.719225717747253*^9}, {3.719225806056829*^9, 3.7192258086633167`*^9}, {
   3.719226291568231*^9, 3.719226323429061*^9}, {3.71922637563286*^9, 
   3.719226381610854*^9}, {3.719226667507865*^9, 3.7192267227290907`*^9}, {
   3.719226766351672*^9, 3.71922676719886*^9}, {3.7192303331103477`*^9, 
   3.7192303361274433`*^9}, {3.719233359306839*^9, 3.719233448509202*^9}, {
   3.7193723494649343`*^9, 3.7193724161865873`*^9}, {3.7193728567509003`*^9, 
   3.719372992750545*^9}, {3.719373047062029*^9, 3.719373117239787*^9}, {
   3.719373343655808*^9, 3.7193734044837837`*^9}, {3.719373542547351*^9, 
   3.719373548722864*^9}, {3.7193737382242813`*^9, 3.719373799090427*^9}, {
   3.719373950631941*^9, 3.719374018003107*^9}, 3.7193740598087873`*^9, {
   3.719374098830105*^9, 3.71937411946563*^9}, {3.719374214737276*^9, 
   3.7193742306450243`*^9}, {3.719374274271574*^9, 3.719374277209031*^9}, {
   3.719374349486148*^9, 3.71937436215309*^9}, {3.7193746599495687`*^9, 
   3.719374662460743*^9}, {3.719374706889711*^9, 3.719374709762846*^9}, {
   3.719374756913718*^9, 3.7193747598637342`*^9}, {3.719374800636602*^9, 
   3.7193748272222757`*^9}, {3.719374893467725*^9, 3.719374966221829*^9}, 
   3.719375082014297*^9, {3.7193751711853743`*^9, 3.719375209571512*^9}, {
   3.7193753775305758`*^9, 3.719375424993235*^9}, {3.719375491493847*^9, 
   3.719375542253042*^9}, {3.719375574880682*^9, 3.719375579720907*^9}, {
   3.719375613837223*^9, 3.719375654611128*^9}, {3.719375706509927*^9, 
   3.7193758110118303`*^9}, {3.719375893231751*^9, 3.719375959350172*^9}, {
   3.7193763029011993`*^9, 3.719376353822229*^9}, {3.7193764138563833`*^9, 
   3.719376535101802*^9}, {3.719376626616325*^9, 3.719376651871345*^9}, {
   3.719376717455179*^9, 3.719376778402616*^9}, {3.719376808596657*^9, 
   3.7193769432016973`*^9}, {3.719376973593143*^9, 3.719376975261236*^9}, {
   3.719377012332148*^9, 3.719377059122686*^9}, {3.719377777584405*^9, 
   3.7193778091483297`*^9}, 3.719377971008458*^9, {3.719378026878957*^9, 
   3.7193781024583597`*^9}, {3.719378140048925*^9, 3.7193782521946783`*^9}, {
   3.719378287786497*^9, 3.719378316569647*^9}, {3.719378502906801*^9, 
   3.719378548818185*^9}, {3.719378611881403*^9, 3.7193786131000347`*^9}, {
   3.719378757709013*^9, 3.719378759461516*^9}, {3.719379415274158*^9, 
   3.71937942513279*^9}, {3.719379482108552*^9, 3.719379537498927*^9}, {
   3.719379580315465*^9, 3.719379587974066*^9}, {3.719379636244514*^9, 
   3.7193796685696707`*^9}, {3.719379771235111*^9, 3.719379774583075*^9}, {
   3.719379942972769*^9, 3.719379944218351*^9}, {3.719380239883707*^9, 
   3.719380247110546*^9}, {3.7193802926629143`*^9, 3.719380321300606*^9}, {
   3.719380383426834*^9, 3.719380384371234*^9}, {3.719410927602684*^9, 
   3.719410947531323*^9}, {3.71941115570693*^9, 3.719411182375504*^9}, {
   3.719411323018412*^9, 3.719411374914762*^9}, {3.719411932566101*^9, 
   3.71941194131717*^9}, {3.719412494882868*^9, 3.719412524529385*^9}, {
   3.719429521184019*^9, 3.719429539354175*^9}, {3.719430243596363*^9, 
   3.7194302455907297`*^9}, {3.719431998264893*^9, 3.719432001094755*^9}, {
   3.719432681645471*^9, 3.7194327083301764`*^9}, {3.719435094405047*^9, 
   3.719435164419894*^9}, {3.71943540639283*^9, 3.719435418729204*^9}, {
   3.719435622241881*^9, 3.719435622319841*^9}, {3.7194455776690483`*^9, 
   3.719445590139872*^9}, {3.719445621438319*^9, 3.7194458312676153`*^9}, {
   3.719445883628224*^9, 3.719445949230064*^9}, {3.7194459838120193`*^9, 
   3.7194460205993*^9}, {3.719446482632455*^9, 3.719446516453521*^9}, {
   3.719446551570148*^9, 3.719446717643243*^9}, {3.71944875286518*^9, 
   3.719448756623694*^9}, {3.719448786792386*^9, 3.7194488535836687`*^9}, {
   3.719448911621567*^9, 3.719448942061219*^9}, {3.719449378295261*^9, 
   3.719449661274048*^9}, {3.719449730269857*^9, 3.719449800176487*^9}, {
   3.719449833360957*^9, 3.71944996028517*^9}, {3.719450067201412*^9, 
   3.71945010377172*^9}, {3.719450309663664*^9, 3.7194503884549417`*^9}, {
   3.719451554410502*^9, 3.719451554464432*^9}, {3.719452621959433*^9, 
   3.719452622067562*^9}, {3.71973030754456*^9, 3.7197303175345383`*^9}, {
   3.719730362633093*^9, 3.719730367124958*^9}, {3.7197304427850657`*^9, 
   3.7197304537174997`*^9}, {3.719734610317069*^9, 3.719734635678891*^9}, {
   3.7197347001255493`*^9, 3.7197347051271553`*^9}, {3.719735207206112*^9, 
   3.719735271869824*^9}, {3.7197353762858458`*^9, 3.7197353902536173`*^9}, {
   3.719735423748863*^9, 3.7197354986609573`*^9}, {3.719735537888715*^9, 
   3.719735645930702*^9}, {3.719735691986335*^9, 3.719735707550108*^9}, {
   3.7197358584135647`*^9, 3.719735860752963*^9}, {3.719736648880659*^9, 
   3.719736679662773*^9}, {3.7197369467181396`*^9, 3.7197369644445744`*^9}, {
   3.719737175765066*^9, 3.719737241360602*^9}, {3.7197374722253237`*^9, 
   3.719737546227788*^9}, {3.719737669398809*^9, 3.719737669494697*^9}, {
   3.719737933611417*^9, 3.7197379718437443`*^9}, {3.719738181845558*^9, 
   3.7197381854317923`*^9}, {3.719738251418407*^9, 3.719738337124282*^9}, {
   3.719738370672596*^9, 3.719738545569077*^9}, {3.719738689538014*^9, 
   3.7197387630659733`*^9}, {3.719738855535997*^9, 3.71973891756887*^9}, {
   3.719739094751033*^9, 3.719739094831616*^9}, {3.719739184956101*^9, 
   3.719739185031064*^9}, {3.719739238827668*^9, 3.7197392389167557`*^9}, {
   3.719739289723925*^9, 3.719739519713244*^9}, {3.7197453857056303`*^9, 
   3.7197454292406197`*^9}, {3.7197454886506844`*^9, 
   3.7197456331659813`*^9}, {3.719745789818274*^9, 3.719745838482885*^9}, {
   3.719745930785759*^9, 3.719745955173485*^9}, {3.719746101843025*^9, 
   3.719746198433139*^9}, {3.719746240005314*^9, 3.7197463417030973`*^9}, {
   3.7197464164099083`*^9, 3.719746420321539*^9}, {3.71974666095483*^9, 
   3.719746732757098*^9}, {3.719746769347896*^9, 3.719746779637402*^9}, {
   3.719746843460355*^9, 3.719746915600006*^9}, {3.719747009422263*^9, 
   3.7197473655944033`*^9}, {3.719747400702529*^9, 3.719747452907586*^9}, {
   3.719747577933001*^9, 3.719747697584831*^9}, {3.719747743520114*^9, 
   3.719747748346672*^9}, {3.719747795360474*^9, 3.719747801366164*^9}, {
   3.719747873840131*^9, 3.7197479074564867`*^9}, {3.719747977234586*^9, 
   3.719747980608316*^9}, {3.719748014809596*^9, 3.719748041831657*^9}, {
   3.719748185164146*^9, 3.7197482853152723`*^9}, {3.719749302320261*^9, 
   3.71974930384836*^9}, {3.719749381812298*^9, 3.719749421947859*^9}, {
   3.719749507213346*^9, 3.71974950810254*^9}, {3.719749673305876*^9, 
   3.719749688476239*^9}, {3.719750779100937*^9, 3.719750779160798*^9}, {
   3.719751007967667*^9, 3.719751009056855*^9}, {3.719754328273507*^9, 
   3.719754359921247*^9}, {3.719755117860854*^9, 3.719755128818756*^9}, {
   3.719755253871963*^9, 3.7197552745061893`*^9}, {3.719824532607543*^9, 
   3.71982458799199*^9}, {3.720130389826198*^9, 3.7201303903474607`*^9}, {
   3.720130475651126*^9, 3.720130540227475*^9}, {3.720130613516943*^9, 
   3.7201306475107307`*^9}, {3.7201309372452507`*^9, 3.720130937365878*^9}, {
   3.720132239810392*^9, 3.720132240023964*^9}, {3.720630048792336*^9, 
   3.720630071132453*^9}, {3.720630222736999*^9, 3.7206302533724937`*^9}, 
   3.720630294915011*^9, {3.720630346133216*^9, 3.7206303935104094`*^9}, {
   3.720630425632263*^9, 3.720630447168253*^9}, {3.72063064322199*^9, 
   3.7206306677146597`*^9}, {3.720630813948081*^9, 3.720630847799562*^9}, {
   3.7206308852932587`*^9, 3.7206310605159483`*^9}, {3.7206311668320017`*^9, 
   3.720631167738859*^9}, {3.720631486215749*^9, 3.720631487645629*^9}, {
   3.720631547001309*^9, 3.720631565159815*^9}, {3.7206316245127077`*^9, 
   3.720631631251802*^9}, {3.7206316791759377`*^9, 3.7206317164067993`*^9}, {
   3.720632058453725*^9, 3.72063205854086*^9}, {3.720632275080412*^9, 
   3.72063228630508*^9}, {3.720632510100124*^9, 3.7206325422154827`*^9}, {
   3.720632593336327*^9, 3.7206325974580297`*^9}, {3.7206326704680634`*^9, 
   3.7206326705730352`*^9}, {3.720634852158196*^9, 3.720634963062826*^9}, 
   3.72063502987082*^9, {3.72063507313945*^9, 3.720635114967638*^9}, {
   3.720635192620606*^9, 3.720635195681109*^9}, 3.720635253478383*^9, {
   3.7206353210630608`*^9, 3.720635321118186*^9}, {3.720635405690898*^9, 
   3.720635409900752*^9}, {3.720635445131652*^9, 3.720635477077651*^9}, {
   3.7206355182959003`*^9, 3.7206355183551197`*^9}, {3.720635878950655*^9, 
   3.720635879553233*^9}, {3.7206364834733067`*^9, 3.720636487569153*^9}, {
   3.720636624139971*^9, 3.720636625317734*^9}, {3.7206366992383204`*^9, 
   3.720636731639377*^9}, {3.720637073646166*^9, 3.720637191978167*^9}, {
   3.720637254003458*^9, 3.720637290812704*^9}, {3.720678894207802*^9, 
   3.720678978873992*^9}, {3.72067903416343*^9, 3.7206790779100227`*^9}, {
   3.720679709811699*^9, 3.720679747948186*^9}, 3.720679809061594*^9, {
   3.720680530821375*^9, 3.720680552705038*^9}, {3.720684626218635*^9, 
   3.7206846281618834`*^9}, {3.720684900424103*^9, 3.720684911492807*^9}, {
   3.720685456257711*^9, 3.720685456499976*^9}, {3.720711445608337*^9, 
   3.720711563701641*^9}, {3.720711594485352*^9, 3.720711597449399*^9}, {
   3.72071176564924*^9, 3.7207117667886*^9}, {3.720712269252139*^9, 
   3.720712269790185*^9}, {3.720712730269505*^9, 3.7207128447533827`*^9}, {
   3.720712947102788*^9, 3.72071294760005*^9}, {3.7207129788088818`*^9, 
   3.720713074200501*^9}, {3.7207138565670757`*^9, 3.720713903964205*^9}, {
   3.720713949476252*^9, 3.720713958155899*^9}, {3.720714172289364*^9, 
   3.720714176525723*^9}, {3.720718081048695*^9, 3.7207181008620443`*^9}, {
   3.720719132043776*^9, 3.720719152697773*^9}, {3.720720838713292*^9, 
   3.7207208391216583`*^9}, 3.720721483678307*^9, {3.7207698450924263`*^9, 
   3.7207698891582747`*^9}, {3.72080786914332*^9, 3.720807871763599*^9}, {
   3.7208153097163057`*^9, 3.7208153269724073`*^9}, {3.720815396447703*^9, 
   3.720815400384811*^9}, {3.720815433747621*^9, 3.7208154860509644`*^9}, {
   3.720815526417013*^9, 3.720815570012949*^9}, {3.720883958186975*^9, 
   3.7208839583306026`*^9}, {3.720891637059492*^9, 3.720891765976737*^9}, {
   3.720900457679925*^9, 3.7209005589303837`*^9}, {3.72090060417584*^9, 
   3.7209006434765253`*^9}, {3.720900759359568*^9, 3.720900814901713*^9}, {
   3.720901402320765*^9, 3.720901406166045*^9}, {3.720907695049552*^9, 
   3.720907701238843*^9}, {3.720907756247596*^9, 3.720907790548869*^9}, {
   3.720907961155912*^9, 3.72090798656814*^9}, {3.7209089211466417`*^9, 
   3.720909006745267*^9}, 3.7209092334330597`*^9, {3.720917954989224*^9, 
   3.7209179587498198`*^9}, {3.7209180121241198`*^9, 3.720918040656427*^9}, {
   3.720918082518865*^9, 3.720918257983251*^9}, {3.72091836822939*^9, 
   3.720918378292173*^9}, {3.720918430038577*^9, 3.7209184403250437`*^9}, {
   3.72109772538013*^9, 3.721097779840007*^9}, {3.721097823787078*^9, 
   3.721097943001803*^9}, {3.721098026732465*^9, 3.721098027217887*^9}, {
   3.721136543709221*^9, 3.7211366166028233`*^9}, {3.721136662462229*^9, 
   3.721136671394308*^9}, {3.72113672107053*^9, 3.721136732366805*^9}, {
   3.721136898116221*^9, 3.721137152706811*^9}, {3.721137226445004*^9, 
   3.7211372273724413`*^9}, {3.721137348533586*^9, 3.721137381387086*^9}, {
   3.721137440625211*^9, 3.721137450942737*^9}, {3.7211375775953293`*^9, 
   3.721137606408523*^9}, {3.72113766887457*^9, 3.721137676800915*^9}, {
   3.721137728897091*^9, 3.721137776238801*^9}, {3.721137815403962*^9, 
   3.7211378466703377`*^9}, {3.721137899030697*^9, 3.721138032278323*^9}, {
   3.7211381355175447`*^9, 3.721138166323894*^9}, {3.72114002317517*^9, 
   3.721140213000949*^9}, {3.72114026244418*^9, 3.7211402672994013`*^9}, 
   3.721140341799656*^9, {3.721140387658812*^9, 3.721140413936448*^9}, 
   3.721140479060536*^9, {3.721140524575735*^9, 3.721140648572177*^9}, {
   3.7211415697992764`*^9, 3.721141602854368*^9}, {3.721141635606455*^9, 
   3.721141677897851*^9}, {3.721141787071376*^9, 3.72114184596136*^9}, {
   3.7211429522507257`*^9, 3.721142961254627*^9}, {3.721142993145372*^9, 
   3.721143028086097*^9}, {3.7211430933912277`*^9, 3.7211431084050703`*^9}, 
   3.721143225042094*^9, {3.721143266384363*^9, 3.721143413838175*^9}, {
   3.721143669572219*^9, 3.721143678884747*^9}, {3.721143709599697*^9, 
   3.7211437212510843`*^9}, {3.721143788639337*^9, 3.721143789002284*^9}, {
   3.7211438231789093`*^9, 3.721143835053357*^9}, {3.721143930686695*^9, 
   3.721143933965529*^9}, {3.7211767558205*^9, 3.721176769189869*^9}, {
   3.721176804782391*^9, 3.7211769023382473`*^9}, {3.721176977136099*^9, 
   3.721177215357095*^9}, {3.721177551458544*^9, 3.721177644219138*^9}, {
   3.721177675236228*^9, 3.721177678698148*^9}, {3.721178192439331*^9, 
   3.721178316875202*^9}, {3.721178644240705*^9, 3.721178700573794*^9}, {
   3.721240502490727*^9, 3.7212405079699507`*^9}, {3.721240549152767*^9, 
   3.7212406328343983`*^9}, {3.721240664690443*^9, 3.7212406656882553`*^9}, {
   3.721240702337984*^9, 3.721240741197475*^9}, {3.7212408319707327`*^9, 
   3.72124083282238*^9}, {3.721240912023752*^9, 3.721240913544929*^9}, {
   3.7212427199023046`*^9, 3.721242793392638*^9}, {3.721242861197867*^9, 
   3.721242867039957*^9}, {3.721243178131461*^9, 3.721243316260601*^9}, {
   3.721243420061112*^9, 3.7212434253136263`*^9}, {3.721243594628933*^9, 
   3.7212436007485867`*^9}, {3.721243854040637*^9, 3.721244023049765*^9}, {
   3.721244511411675*^9, 3.7212445747399187`*^9}, {3.7212446091350393`*^9, 
   3.721244630532765*^9}, {3.7212446778947897`*^9, 3.721244747534264*^9}, {
   3.721244807868478*^9, 3.7212448326285133`*^9}, {3.7212450057895308`*^9, 
   3.721245015526346*^9}, {3.72124626614005*^9, 3.721246273660789*^9}, {
   3.721246321099434*^9, 3.721246355708845*^9}, {3.721246395675804*^9, 
   3.7212463963370733`*^9}, {3.721246430234705*^9, 3.721246469938772*^9}, {
   3.721246504728619*^9, 3.721246615078002*^9}, {3.721246881685997*^9, 
   3.721246952120058*^9}, {3.721247037186327*^9, 3.7212470672476387`*^9}, {
   3.721247133489829*^9, 3.721247142496415*^9}, {3.721247385699316*^9, 
   3.721247388170515*^9}, {3.721247427393928*^9, 3.721247429989277*^9}, {
   3.7212514333876963`*^9, 3.721251450852207*^9}, {3.721251486152021*^9, 
   3.7212514955198917`*^9}, {3.721251619516759*^9, 3.7212517510759487`*^9}, {
   3.721251786695211*^9, 3.7212517935817633`*^9}, {3.721251836572253*^9, 
   3.721251841921132*^9}, {3.721264525277989*^9, 3.7212645255566196`*^9}, {
   3.72126731622113*^9, 3.721267335207155*^9}, {3.7212673698380404`*^9, 
   3.721267440005477*^9}, {3.72126754078472*^9, 3.7212675853488827`*^9}, {
   3.721267764977043*^9, 3.7212677984319468`*^9}, {3.721268090542268*^9, 
   3.7212681435145073`*^9}, {3.721268476090892*^9, 3.7212684816251383`*^9}, 
   3.72126873608854*^9, {3.7212690735384083`*^9, 3.721269194084498*^9}, {
   3.721269253762356*^9, 3.72126926563235*^9}, {3.721269319582057*^9, 
   3.721269348299985*^9}, {3.721269383464848*^9, 3.721269660536734*^9}, {
   3.721269713946868*^9, 3.721269778589849*^9}, {3.721269991463077*^9, 
   3.721270000012088*^9}, {3.7212701192090063`*^9, 3.721270219193698*^9}, {
   3.721270265019486*^9, 3.721270377705325*^9}, {3.72127045724055*^9, 
   3.7212706782035303`*^9}, {3.721270741387692*^9, 3.721270745512568*^9}, {
   3.721278590083641*^9, 3.721278606689032*^9}, {3.721278640279109*^9, 
   3.721278678761841*^9}, {3.72127874278128*^9, 3.721278775337491*^9}, {
   3.721278809120688*^9, 3.721278847354587*^9}, {3.7212790612763557`*^9, 
   3.72127908054705*^9}, {3.721279173251145*^9, 3.721279192090746*^9}, 
   3.7212793143619633`*^9, {3.721279438327916*^9, 3.721279480565634*^9}, {
   3.721279546709159*^9, 3.7212795677045107`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"getcorrinfo", "[", 
   RowBox[{
    RowBox[{"{", "dRdataclassfinal", "}"}], ",", 
    RowBox[{"readcorrconfigfile6", "[", 
     RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "4", ",", 
    "flavour"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"getcorrinfo", "[", 
   RowBox[{
    RowBox[{"{", "corrdataclassfinal", "}"}], ",", 
    RowBox[{"readcorrconfigfile6", "[", 
     RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "6", ",", 
    "0"}], " ", "]"}], ";"}]}], "Input",
 CellChangeTimes->{
  3.72127923826082*^9, {3.721279576103445*^9, 3.721279594101089*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7212792433839197`*^9, 3.7212793191568947`*^9, 3.721279463090527*^9, {
   3.72127955699609*^9, 3.721279594730628*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  
  SequenceForm[41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7212792433839197`*^9, 3.7212793191568947`*^9, 3.721279463090527*^9, {
   3.72127955699609*^9, 3.721279594821343*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7212792433839197`*^9, 3.7212793191568947`*^9, 3.721279463090527*^9, {
   3.72127955699609*^9, 3.721279595102488*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "42"}],
  SequenceForm[41, "  ", 42],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7212792433839197`*^9, 3.7212793191568947`*^9, 3.721279463090527*^9, {
   3.72127955699609*^9, 3.721279595128441*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "42", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "42", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "42"}],
  SequenceForm[41, "  ", 42, " ", 42, " ", 42],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7212792433839197`*^9, 3.7212793191568947`*^9, 3.721279463090527*^9, {
   3.72127955699609*^9, 3.7212795951519136`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7212792433839197`*^9, 3.7212793191568947`*^9, 3.721279463090527*^9, {
   3.72127955699609*^9, 3.721279595178911*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  
  SequenceForm[41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7212792433839197`*^9, 3.7212793191568947`*^9, 3.721279463090527*^9, {
   3.72127955699609*^9, 3.721279595204014*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Select", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"getcorrinfo", "[", 
      RowBox[{
       RowBox[{"{", "corrdataclassfinal", "}"}], ",", 
       RowBox[{"readcorrconfigfile6", "[", 
        RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "6", ",", 
       "0"}], " ", "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"3", ",", "25"}], "]"}], "]"}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "3", "]"}], "]"}], ">", "0.7"}], " ", "||", " ", 
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "3", "]"}], "]"}], "<", 
        RowBox[{"-", "0.7"}]}]}], ")"}], "&"}]}], "]"}], " "}]], "Input",
 CellChangeTimes->{{3.721240691716098*^9, 3.721240694969981*^9}, {
  3.7212428775040092`*^9, 3.7212428800805264`*^9}, {3.721243428076179*^9, 
  3.721243470434648*^9}, {3.721243618493709*^9, 3.721243618658543*^9}, {
  3.721244798668315*^9, 3.721244903630548*^9}, {3.721244948856739*^9, 
  3.7212449909999228`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"LF1", "[", 
    RowBox[{"0.009958`", ",", "60.`", ",", 
     RowBox[{"-", "0.9204516835689338`"}]}], "]"}], ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.01991`", ",", "120.`", ",", "0.7529231048619205`"}], "]"}], 
   ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.06971`", ",", "420.`", ",", "0.7096200867495766`"}], "]"}], 
   ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.0863`", ",", "520.`", ",", "0.8187240713600872`"}], "]"}], ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.011`", ",", "60.`", ",", "0.8616689729830072`"}], "]"}], ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.02093`", ",", "120.`", ",", 
     RowBox[{"-", "0.7703491112964703`"}]}], "]"}], ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.07328`", ",", "420.`", ",", "0.770766552063419`"}], "]"}], ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.1395`", ",", "800.`", ",", "0.7457237644880053`"}], "]"}], ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.3584`", ",", "1600.`", ",", 
     RowBox[{"-", "0.7113207343606538`"}]}], "]"}], ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.448`", ",", "2000.`", ",", 
     RowBox[{"-", "0.7939132162756783`"}]}], "]"}], ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.5377`", ",", "2400.`", ",", 
     RowBox[{"-", "0.7766120870737563`"}]}], "]"}], ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.007377`", ",", "60.`", ",", 
     RowBox[{"-", "0.9062531644012819`"}]}], "]"}], ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.01475`", ",", "120.`", ",", "0.8470828393075303`"}], "]"}], 
   ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.05164`", ",", "420.`", ",", "0.7242242045632422`"}], "]"}], 
   ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.09836`", ",", "800.`", ",", "0.7959712962813797`"}], "]"}], 
   ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.006675`", ",", "60.`", ",", "0.8249850725887281`"}], "]"}], 
   ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.04672`", ",", "420.`", ",", "0.7106648877199201`"}], "]"}], 
   ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.01403`", ",", "120.`", ",", 
     RowBox[{"-", "0.7167402533387255`"}]}], "]"}], ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.02573`", ",", "220.`", ",", "0.7739718777477778`"}], "]"}], 
   ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.04912`", ",", "420.`", ",", "0.7893225871901616`"}], "]"}], 
   ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.3508`", ",", "3000.`", ",", 
     RowBox[{"-", "0.746913154865687`"}]}], "]"}], ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.1457`", ",", "1600.`", ",", 
     RowBox[{"-", "0.7703696353114345`"}]}], "]"}], ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.1821`", ",", "2000.`", ",", 
     RowBox[{"-", "0.7588682479809999`"}]}], "]"}], ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.2186`", ",", "2400.`", ",", 
     RowBox[{"-", "0.7691588560550343`"}]}], "]"}], ",", 
   RowBox[{"LF1", "[", 
    RowBox[{"0.00906`", ",", "90.`", ",", "0.7022109667702966`"}], "]"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.721240696056773*^9, 3.721240706133185*^9}, 
   3.721240756410231*^9, 3.721240839248724*^9, 3.721242740366992*^9, {
   3.721242871261281*^9, 3.721242880893099*^9}, {3.721243299990423*^9, 
   3.721243319998475*^9}, {3.72124343240304*^9, 3.7212434714491367`*^9}, {
   3.721243604105094*^9, 3.7212436202460127`*^9}, {3.721244780173003*^9, 
   3.7212448545435743`*^9}, 3.721244905346259*^9, {3.721244941649458*^9, 
   3.721245021634021*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "\"\<../plots/\>\"", "<>", "jobpath", "<>", "\"\<test_data_info.txt\>\""}],
    ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"getcorrinfo", "[", 
       RowBox[{
        RowBox[{"{", "corrdataclassfinal", "}"}], ",", 
        RowBox[{"readcorrconfigfile6", "[", 
         RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "6", ",", 
        "0"}], " ", "]"}], "//", "TableForm"}], ")"}], "//", "OutputForm"}]}],
   "]"}]], "Input",
 CellChangeTimes->{{3.721245090077105*^9, 3.721245090197921*^9}, {
   3.721246371065279*^9, 3.7212463716759663`*^9}, {3.7212466302153187`*^9, 
   3.721246631664019*^9}, {3.721251498814507*^9, 3.721251499851022*^9}, {
   3.7212518124709053`*^9, 3.7212518167896347`*^9}, {3.721251881260106*^9, 
   3.721251939274994*^9}, {3.721251974530487*^9, 3.721251986649294*^9}, 
   3.721252155779079*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.721246473106348*^9, {3.721246510720365*^9, 3.721246632725195*^9}, {
   3.7212469330860777`*^9, 3.7212469572328176`*^9}, 3.7212470806679707`*^9, 
   3.721247159309971*^9, 3.721247395702909*^9, 3.7212474574753*^9, 
   3.721251457021345*^9, 3.72125150066954*^9, {3.7212517775515757`*^9, 
   3.721251847370085*^9}, 3.7212519888685837`*^9, 3.7212521582514677`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "42"}],
  SequenceForm[41, "  ", 42],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.721246473106348*^9, {3.721246510720365*^9, 3.721246632725195*^9}, {
   3.7212469330860777`*^9, 3.7212469572328176`*^9}, 3.7212470806679707`*^9, 
   3.721247159309971*^9, 3.721247395702909*^9, 3.7212474574753*^9, 
   3.721251457021345*^9, 3.72125150066954*^9, {3.7212517775515757`*^9, 
   3.721251847370085*^9}, 3.7212519888685837`*^9, 3.721252158271389*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41, " ", 41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.721246473106348*^9, {3.721246510720365*^9, 3.721246632725195*^9}, {
   3.7212469330860777`*^9, 3.7212469572328176`*^9}, 3.7212470806679707`*^9, 
   3.721247159309971*^9, 3.721247395702909*^9, 3.7212474574753*^9, 
   3.721251457021345*^9, 3.72125150066954*^9, {3.7212517775515757`*^9, 
   3.721251847370085*^9}, 3.7212519888685837`*^9, 3.721252158290687*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.721246473106348*^9, {3.721246510720365*^9, 3.721246632725195*^9}, {
   3.7212469330860777`*^9, 3.7212469572328176`*^9}, 3.7212470806679707`*^9, 
   3.721247159309971*^9, 3.721247395702909*^9, 3.7212474574753*^9, 
   3.721251457021345*^9, 3.72125150066954*^9, {3.7212517775515757`*^9, 
   3.721251847370085*^9}, 3.7212519888685837`*^9, 3.721252158309881*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  
  SequenceForm[41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.721246473106348*^9, {3.721246510720365*^9, 3.721246632725195*^9}, {
   3.7212469330860777`*^9, 3.7212469572328176`*^9}, 3.7212470806679707`*^9, 
   3.721247159309971*^9, 3.721247395702909*^9, 3.7212474574753*^9, 
   3.721251457021345*^9, 3.72125150066954*^9, {3.7212517775515757`*^9, 
   3.721251847370085*^9}, 3.7212519888685837`*^9, 3.721252158328896*^9}]
}, Open  ]],

Cell[BoxData["\<\"../plots/Jobs/CT14NNLOallIDs/test_data_info.txt\"\>"], \
"Output",
 CellChangeTimes->{
  3.721245030965948*^9, 3.721245092746786*^9, {3.721246372702113*^9, 
   3.721246399560807*^9}, 3.7212464373734493`*^9, 3.721246473246748*^9, {
   3.721246510855727*^9, 3.7212466328915443`*^9}, {3.7212469333098907`*^9, 
   3.721246957480524*^9}, 3.72124708093668*^9, 3.721247159556691*^9, 
   3.721247395972385*^9, 3.721247457716674*^9, 3.721251457271213*^9, 
   3.721251500737462*^9, {3.721251777621129*^9, 3.721251847491661*^9}, 
   3.72125198929329*^9, 3.721252158421624*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DirectoryQ", "[", 
  RowBox[{"\"\<../plots/\>\"", "<>", "jobpath"}], "]"}]], "Input",
 CellChangeTimes->{{3.721252058789089*^9, 3.721252069044688*^9}, {
  3.721252111167691*^9, 3.721252144655155*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.72125206989846*^9, {3.72125212467782*^9, 3.7212521453942337`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["jobpath"], "Input"],

Cell[BoxData["\<\"Jobs/CT14NNLOallIDs/\"\>"], "Output",
 CellChangeTimes->{3.72125208245957*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Directory", "[", "]"}]], "Input",
 CellChangeTimes->{{3.721252099067142*^9, 3.721252099830412*^9}}],

Cell[BoxData["\<\"/home/botingw/Downloads/Sean_20171114/xqplotter_user_func_\
debug/xqplotter-master/bin\"\>"], "Output",
 CellChangeTimes->{3.721252100178191*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"getdatainfotext", "[", 
    RowBox[{
    "corrfxQdtaobsclassin_", ",", "configargumentsin_", ",", "plottypein_"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"configarguments", "=", "configargumentsin"}], ",", "\n", 
       RowBox[{"plottype", "=", "plottypein"}], ",", "\[IndentingNewLine]", 
       "Jobid", ",", "JobDescription", 
       RowBox[{"(*", "20171128", "*)"}], ",", "PDFname", ",", "FigureType", 
       ",", "FigureFlag", ",", "ExptidType", ",", "ExptidFlag", ",", 
       "CorrelationArgType", ",", "CorrelationArgFlag", ",", 
       RowBox[{"(*", 
        RowBox[{"UserArgName", ",", "UserArgValue", ","}], "*)"}], "\n", 
       "XQfigureXrange", ",", "XQfigureYrange", ",", "ColorPaletterange", 
       RowBox[{"(*", "20171128", "*)"}], ",", "Hist1figureNbin", ",", 
       RowBox[{"(*", 
        RowBox[{"Hist1figureXrange", ",", "Hist1figureYrange", ","}], "*)"}], 
       "\n", 
       RowBox[{"(*", 
        RowBox[{"ColorSeperator", ","}], "*)"}], "\n", "Size", ",", 
       "HighlightType", ",", "HighlightMode", ",", "HighlightMode1", ",", 
       "HighlightMode2", ",", "\[IndentingNewLine]", "alldatainfo", ",", 
       "fmax", ",", "userdifinefuncfilename", ",", "UserArgName"}], "}"}], 
     ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
      "read", " ", "arguments", " ", "in", " ", "config", " ", "file"}], 
      "*)"}], "\n", 
     RowBox[{"(*", 
      RowBox[{
      "===", "===", "===", "===", "===", "===", "===", "===", "===", "==="}], 
      "*)"}], "\n", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Jobid", ",", "JobDescription", 
         RowBox[{"(*", "20171128", "*)"}], ",", "PDFname", ",", "FigureType", 
         ",", "FigureFlag", ",", "ExptidType", ",", "ExptidFlag", ",", 
         "CorrelationArgType", ",", "CorrelationArgFlag", ",", 
         RowBox[{"(*", 
          RowBox[{"UserArgName", ",", "UserArgValue", ","}], "*)"}], "\n", 
         "XQfigureXrange", ",", "XQfigureYrange", ",", "ColorPaletterange", 
         RowBox[{"(*", "20171128", "*)"}], ",", "Hist1figureNbin", ",", 
         RowBox[{"(*", 
          RowBox[{"Hist1figureXrange", ",", "Hist1figureYrange", ","}], 
          "*)"}], "\n", 
         RowBox[{"(*", 
          RowBox[{"ColorSeperator", ","}], "*)"}], "\n", "Size", ",", 
         "HighlightType", ",", "HighlightMode", ",", "HighlightMode1", ",", 
         "HighlightMode2"}], "}"}], "=", "configarguments"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
       "===", "===", "===", "===", "===", "===", "===", "===", "===", "==="}],
        "*)"}], "\[IndentingNewLine]", 
      RowBox[{"userdifinefuncfilename", "=", "\"\<user_func.txt\>\""}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", "20171127", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"CorrelationArgFlag", "[", 
          RowBox[{"[", 
           RowBox[{"-", "1"}], "]"}], "]"}], "\[Equal]", "1"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"UserArgName", "=", 
          RowBox[{"ReadUserFunctionV3", "[", 
           RowBox[{"\"\<./\>\"", ",", "userdifinefuncfilename"}], "]"}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"UserArgName", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "&"}], "/@", "UserArgName"}]}], 
         ";", "\[IndentingNewLine]", "\"\<dummy\>\""}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"fmax", "=", 
       RowBox[{"Length", "[", 
        RowBox[{"corrfxQdtaobsclassin", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1"}], "]"}], "]"}], " ", "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"alldatainfo", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"If", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"CorrelationArgFlag", "[", 
             RowBox[{"[", 
              RowBox[{"iflavour", "+", "6"}], "]"}], "]"}], "\[Equal]", "1"}],
            ",", "\[IndentingNewLine]", 
           RowBox[{"alldatainfo", "=", 
            RowBox[{"Append", "[", 
             RowBox[{"alldatainfo", ",", 
              RowBox[{"getcorrinfo", "[", 
               RowBox[{
               "corrfxQdtaobsclassin", ",", "configarguments", ",", 
                "plottype", ",", "iflavour"}], "]"}]}], " ", "]"}]}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         "\"\<dummy\>\""}], "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"iflavour", ",", 
          RowBox[{"-", "5"}], ",", 
          RowBox[{
           RowBox[{"-", "5"}], "+", "fmax", "-", "1"}]}], "}"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "alldatainfo"}]}], "\[IndentingNewLine]", 
    "]"}]}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"datainfototext", "[", 
   RowBox[{
   "corrfxQdtaobsclassin_", ",", "configargumentsin_", ",", "plottypein_", 
    ",", "flavourin_"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"corrfxQdtaobsclass", "=", "corrfxQdtaobsclassin"}], ","}], 
      "*)"}], 
     RowBox[{
      RowBox[{"configarguments", "=", "configargumentsin"}], ",", "\n", 
      RowBox[{"plottype", "=", "plottypein"}], ",", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"flavour", "=", "flavourin"}], ","}], "*)"}], "flavour", ",", 
      "\[IndentingNewLine]", "input", ",", "Nlabel", ",", "infostring", ",", 
      "Nexpt", ",", "exptID", ",", "exptdata", ",", "xqvaluestr"}], 
     "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"input", "=", 
      RowBox[{"getcorrinfo", "[", 
       RowBox[{
       "corrfxQdtaobsclassin", ",", "configarguments", ",", "plottype", ",", 
        "flavourin"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Nlabel", "=", 
      RowBox[{"Length", "[", 
       RowBox[{"input", "[", 
        RowBox[{"[", "1", "]"}], "]"}], " ", "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"infostring", "=", "\"\<\>\""}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
      "only", " ", "show", " ", "the", " ", "meta", " ", "data", " ", 
       "part"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"infostring", "=", 
        RowBox[{"infostring", "<>", 
         RowBox[{"ToString", "[", 
          RowBox[{"input", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", "ilabel"}], "]"}], "]"}], " ", "]"}], "<>", 
         "\"\<: \>\"", "<>", 
         RowBox[{"ToString", "[", 
          RowBox[{"input", "[", 
           RowBox[{"[", 
            RowBox[{"2", ",", "ilabel"}], "]"}], "]"}], " ", "]"}], "<>", 
         "\"\<\\n\>\""}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"ilabel", ",", 
         RowBox[{"Nlabel", "-", "1"}]}], "}"}]}], "\[IndentingNewLine]", 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"show", " ", "the", " ", "data", " ", "part"}], ",", " ", 
       RowBox[{"format", ":", " ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"exptname", ",", " ", 
            RowBox[{
            "data", " ", "with", " ", "in", " ", "the", " ", "highlight", " ",
              "range"}]}], "}"}], ",", "..."}], "}"}]}]}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"infostring", "=", 
      RowBox[{"infostring", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"input", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "]"}], "]"}], " ", "]"}], "<>", 
       "\"\<\\n\>\""}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Nexpt", "=", 
      RowBox[{"Length", "[", 
       RowBox[{"input", "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", 
          RowBox[{"-", "1"}]}], "]"}], "]"}], " ", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"exptID", "=", 
         RowBox[{
          RowBox[{"input", "[", 
           RowBox[{"[", 
            RowBox[{"2", ",", 
             RowBox[{"-", "1"}], ",", "iexpt", ",", "1"}], "]"}], "]"}], "//",
           "ToString"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"xqvaluestr", "=", "\"\<{x, Q, value}\>\""}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"exptdata", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"ToString", "[", "#", "]"}], "<>", "\"\<\\n\>\""}], 
            ")"}], "&"}], "/@", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"input", "[", 
             RowBox[{"[", 
              RowBox[{"2", ",", 
               RowBox[{"-", "1"}], ",", "iexpt", ",", "2"}], "]"}], "]"}], "/.", 
            RowBox[{"LF1", "\[Rule]", "List"}]}], ")"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"infostring", "=", 
         RowBox[{
         "infostring", "<>", "exptID", "<>", "\"\<\\n\>\"", "<>", 
          "xqvaluestr", "<>", "\"\<\\n\>\"", "<>", "exptdata", "<>", 
          "\"\<\\n\>\""}]}], ";", "\[IndentingNewLine]", "\"\<dummy\>\""}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"iexpt", ",", "Nexpt"}], "}"}]}], "\[IndentingNewLine]", 
      "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     "infostring"}]}], "\[IndentingNewLine]", "]"}]}]}], "Input",
 CellChangeTimes->{{3.721253023379712*^9, 3.721253273675366*^9}, 
   3.721253324447118*^9, {3.721253393008363*^9, 3.721253437681078*^9}, {
   3.721253477635284*^9, 3.721253481056782*^9}, {3.721253659991989*^9, 
   3.7212537724118843`*^9}, {3.721253873274611*^9, 3.721253882039934*^9}, {
   3.721254173959692*^9, 3.721254179220578*^9}, {3.7212542607695923`*^9, 
   3.72125436963737*^9}, {3.72125540675355*^9, 3.721255409843863*^9}, {
   3.721257867670363*^9, 3.721257906899425*^9}, {3.721263708429057*^9, 
   3.721263716896776*^9}, {3.721263757485907*^9, 3.7212637708861856`*^9}, {
   3.7212638394117126`*^9, 3.721263881628018*^9}, {3.721264268171461*^9, 
   3.721264424961738*^9}, {3.721264559981793*^9, 3.721264583753998*^9}, {
   3.7212647385557327`*^9, 3.721264977007882*^9}, {3.72126504276527*^9, 
   3.721265061310114*^9}, {3.721265128014029*^9, 3.72126527275987*^9}, {
   3.721265361086125*^9, 3.7212653614421587`*^9}, {3.721265477140065*^9, 
   3.721265480112845*^9}, {3.721266378492486*^9, 3.72126645585816*^9}, {
   3.7212665590344*^9, 3.721266608419188*^9}, {3.721266749760516*^9, 
   3.7212668515059023`*^9}, {3.721267061018291*^9, 3.721267063481707*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"getcorrinfo", "[", 
   RowBox[{
    RowBox[{"{", "corrdataclassfinal", "}"}], ",", 
    RowBox[{"readcorrconfigfile6", "[", 
     RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "6", ",", 
    "0"}], " ", "]"}], "[", 
  RowBox[{"[", 
   RowBox[{"2", ",", 
    RowBox[{"-", "1"}], ",", "1", ",", "1"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.7212654044815683`*^9, 3.721265432598076*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{{3.721265409159219*^9, 3.721265433502593*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "42"}],
  SequenceForm[41, "  ", 42],
  Editable->False]], "Print",
 CellChangeTimes->{{3.721265409159219*^9, 3.721265433526627*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41, " ", 41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{{3.721265409159219*^9, 3.721265433550413*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{{3.721265409159219*^9, 3.721265433574503*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  
  SequenceForm[41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{{3.721265409159219*^9, 3.7212654335980043`*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", "101", "}"}]], "Output",
 CellChangeTimes->{{3.721265409291443*^9, 3.721265433620797*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"ReadLisFile", "[", "datalistFile", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ExptIDtoName", "[", "101", "]"}]], "Input",
 CellChangeTimes->{{3.721268258561097*^9, 3.721268265564632*^9}}],

Cell[BoxData["\<\"BcdF2pCor\"\>"], "Output",
 CellChangeTimes->{3.721268266226162*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"getcorrinfo", "[", 
   RowBox[{
    RowBox[{"{", "corrdataclassfinal", "}"}], ",", 
    RowBox[{"readcorrconfigfile6", "[", 
     RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "6", ",", 
    RowBox[{"-", "5"}]}], "]"}], "[", 
  RowBox[{"[", 
   RowBox[{"2", ",", "2", ",", "1"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.721268385644218*^9, 3.7212684200422688`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.7212684209926*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "42"}],
  SequenceForm[41, "  ", 42],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421017624*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41, " ", 41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421040482*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.7212684210682592`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  
  SequenceForm[41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421099206*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "101", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {101}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421122365*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "102", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {102}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.7212684211435003`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "104", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {104}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421165326*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "108", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {108}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421186028*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "109", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {109}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421206615*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "110", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {110}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421227188*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "111", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {111}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.72126842124922*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "124", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {124}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421303068*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "125", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {125}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.72126842132471*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "126", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {126}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421347042*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "127", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {127}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421368479*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "147", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {147}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.7212684213903723`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "201", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {201}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421411751*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "203", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {203}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.7212684214333057`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "204", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {204}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.7212684214557467`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "225", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {225}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.7212684214765368`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "227", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {227}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421499043*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "234", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {234}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421520297*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "260", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {260}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421541209*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "504", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {504}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.72126842156322*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "514", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {514}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.72126842158442*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "145", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {145}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421605712*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "169", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {169}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.7212684216265717`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "268", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {268}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421650868*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "535", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {535}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421672676*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "240", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {240}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421693544*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "241", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {241}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.7212684217157907`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "281", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {281}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.72126842173911*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "266", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {266}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421763543*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "538", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {538}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421785407*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "245", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {245}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.7212684218065443`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "246", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {246}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421828088*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "248", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {248}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.7212684218506603`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "542", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {542}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.7212684218757763`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "544", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {544}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421898861*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "249", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {249}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421921382*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "250", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {250}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421944393*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "565", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {565}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421968257*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "566", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {566}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268421990534*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "567", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {567}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.721268422012349*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"can not find expt id = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "568", "}"}], "\[InvisibleSpace]", "\<\" in lisTable\"\>"}],
  SequenceForm["can not find expt id = ", {568}, " in lisTable"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7212684074941397`*^9, 3.7212684220344973`*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "101", "}"}], ",", "\<\"None\"\>"}], "}"}]], "Output",
 CellChangeTimes->{{3.721268408627574*^9, 3.721268422056728*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
   "\"\<../plots/\>\"", "<>", "jobpath", "<>", "\"\<test_data_info.txt\>\""}],
    ",", "\[IndentingNewLine]", 
   RowBox[{"datainfototext", "[", 
    RowBox[{
     RowBox[{"{", "corrdataclassfinal", "}"}], ",", 
     RowBox[{"readcorrconfigfile6", "[", 
      RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "6", ",", 
     RowBox[{"-", "5"}]}], "]"}]}], "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.7212644887644*^9, 3.721264492673111*^9}, {
  3.721264619530273*^9, 3.721264646332858*^9}, {3.721266872910158*^9, 
  3.721266878608523*^9}, {3.721267473334928*^9, 3.721267491270549*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.72126707581192*^9, {3.7212674557192993`*^9, 3.721267492252102*^9}, 
   3.7212675967187977`*^9, 3.721267816819422*^9, 3.721268152054994*^9, 
   3.7212681882271433`*^9, 3.721268268994288*^9, 3.721268502514152*^9, 
   3.721268752333665*^9, 3.7212700089930267`*^9, 3.721270688749825*^9, 
   3.7212707558114*^9, 3.7212708130057077`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "42"}],
  SequenceForm[41, "  ", 42],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.72126707581192*^9, {3.7212674557192993`*^9, 3.721267492252102*^9}, 
   3.7212675967187977`*^9, 3.721267816819422*^9, 3.721268152054994*^9, 
   3.7212681882271433`*^9, 3.721268268994288*^9, 3.721268502514152*^9, 
   3.721268752333665*^9, 3.7212700089930267`*^9, 3.721270688749825*^9, 
   3.7212707558114*^9, 3.721270813029316*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41, " ", 41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.72126707581192*^9, {3.7212674557192993`*^9, 3.721267492252102*^9}, 
   3.7212675967187977`*^9, 3.721267816819422*^9, 3.721268152054994*^9, 
   3.7212681882271433`*^9, 3.721268268994288*^9, 3.721268502514152*^9, 
   3.721268752333665*^9, 3.7212700089930267`*^9, 3.721270688749825*^9, 
   3.7212707558114*^9, 3.7212708130525513`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.72126707581192*^9, {3.7212674557192993`*^9, 3.721267492252102*^9}, 
   3.7212675967187977`*^9, 3.721267816819422*^9, 3.721268152054994*^9, 
   3.7212681882271433`*^9, 3.721268268994288*^9, 3.721268502514152*^9, 
   3.721268752333665*^9, 3.7212700089930267`*^9, 3.721270688749825*^9, 
   3.7212707558114*^9, 3.721270813074696*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  
  SequenceForm[41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.72126707581192*^9, {3.7212674557192993`*^9, 3.721267492252102*^9}, 
   3.7212675967187977`*^9, 3.721267816819422*^9, 3.721268152054994*^9, 
   3.7212681882271433`*^9, 3.721268268994288*^9, 3.721268502514152*^9, 
   3.721268752333665*^9, 3.7212700089930267`*^9, 3.721270688749825*^9, 
   3.7212707558114*^9, 3.721270813140417*^9}]
}, Open  ]],

Cell[BoxData["\<\"../plots/Jobs/CT14NNLOallIDs/test_data_info.txt\"\>"], \
"Output",
 CellChangeTimes->{
  3.72126449707063*^9, {3.7212645366679983`*^9, 3.721264587499236*^9}, 
   3.721264648467536*^9, 3.7212647753189363`*^9, 3.721265278990218*^9, 
   3.7212653647937183`*^9, 3.72126548526302*^9, 3.72126646022366*^9, 
   3.7212666132085867`*^9, 3.7212668804733343`*^9, 3.721267076200384*^9, {
   3.7212674560597353`*^9, 3.721267492670842*^9}, 3.72126759711959*^9, 
   3.721267817221943*^9, 3.721268153191554*^9, 3.721268189416937*^9, 
   3.72126827050196*^9, 3.721268502928438*^9, 3.72126875268237*^9, 
   3.7212700094103394`*^9, 3.721270689119282*^9, 3.721270756244071*^9, 
   3.721270813414351*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
   "\"\<../plots/\>\"", "<>", "jobpath", "<>", "\"\<test_data_info.txt\>\""}],
    ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"datainfototext", "[", 
       RowBox[{
        RowBox[{"{", "corrdataclassfinal", "}"}], ",", 
        RowBox[{"readcorrconfigfile6", "[", 
         RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "6", ",", 
        "iflavour"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"iflavour", ",", 
        RowBox[{"-", "5"}], ",", "5"}], "}"}]}], "]"}], "//", 
    "StringJoin"}]}], "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.721271972617679*^9, 3.7212720174093657`*^9}, {
  3.721272151688995*^9, 3.7212721519121*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272152812011*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "42"}],
  SequenceForm[41, "  ", 42],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272152838974*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41, " ", 41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272152863181*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272152887884*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  
  SequenceForm[41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272152914089*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272153196393*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "42"}],
  SequenceForm[41, "  ", 42],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.7212721532223577`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41, " ", 41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272153246146*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272153270035*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  
  SequenceForm[41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272153297084*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272153586926*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "42"}],
  SequenceForm[41, "  ", 42],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272153612814*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41, " ", 41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272153637714*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.72127215366119*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  
  SequenceForm[41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272153687643*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272153957322*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "42"}],
  SequenceForm[41, "  ", 42],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.7212721539830303`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41, " ", 41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272154009109*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272154033845*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  
  SequenceForm[41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.7212721540617933`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272154323205*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "42"}],
  SequenceForm[41, "  ", 42],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272154350215*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41, " ", 41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.7212721543783712`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272154405604*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  
  SequenceForm[41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272154474985*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272154785225*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "42"}],
  SequenceForm[41, "  ", 42],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272154810266*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41, " ", 41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272154834556*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.7212721548583384`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  
  SequenceForm[41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.72127215488619*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272155152238*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "42"}],
  SequenceForm[41, "  ", 42],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272155179427*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41, " ", 41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272155206184*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272155230945*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  
  SequenceForm[41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272155258872*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272155574501*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "42"}],
  SequenceForm[41, "  ", 42],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272155604266*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41, " ", 41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272155632306*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.7212721556592484`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  
  SequenceForm[41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.7212721556884813`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272156002014*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "42"}],
  SequenceForm[41, "  ", 42],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.7212721560320587`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41, " ", 41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272156059362*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272156085657*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  
  SequenceForm[41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.7212721561140223`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.7212721564056673`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "42"}],
  SequenceForm[41, "  ", 42],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272156432337*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41, " ", 41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272156458709*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272156481989*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  
  SequenceForm[41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.7212721565077047`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272156822256*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "42"}],
  SequenceForm[41, "  ", 42],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272156849429*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41, " ", 41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272156877768*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.721272156907847*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  
  SequenceForm[41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721272023630278*^9, 3.7212721569333878`*^9}]
}, Open  ]],

Cell[BoxData["\<\"../plots/Jobs/CT14NNLOallIDs/test_data_info.txt\"\>"], \
"Output",
 CellChangeTimes->{3.721272027982662*^9, 3.721272157389942*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"getdatainfotext", "[", 
   RowBox[{
    RowBox[{"{", "corrdataclassfinal", "}"}], ",", 
    RowBox[{"readcorrconfigfile6", "[", 
     RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "6"}], "]"}], "//",
   "Length"}]], "Input",
 CellChangeTimes->{{3.7212532883588037`*^9, 3.7212533305151367`*^9}, {
   3.721253364401576*^9, 3.7212533653248367`*^9}, 3.721253406399188*^9, {
   3.721253493535204*^9, 3.721253534277*^9}, {3.721253640604623*^9, 
   3.721253641870577*^9}, {3.721253710466667*^9, 3.721253710732174*^9}, {
   3.721253747212131*^9, 3.721253796450321*^9}, {3.721253889499607*^9, 
   3.7212538918640347`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{{3.721253486911673*^9, 3.721253534828554*^9}, 
   3.7212536425721073`*^9, {3.7212536869682407`*^9, 3.721253798741549*^9}, 
   3.721253892566531*^9, 3.721254379709117*^9, 3.721255375293445*^9, 
   3.721255414427759*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "42"}],
  SequenceForm[41, "  ", 42],
  Editable->False]], "Print",
 CellChangeTimes->{{3.721253486911673*^9, 3.721253534828554*^9}, 
   3.7212536425721073`*^9, {3.7212536869682407`*^9, 3.721253798741549*^9}, 
   3.721253892566531*^9, 3.721254379709117*^9, 3.721255375293445*^9, 
   3.721255414447904*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41, " ", 41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{{3.721253486911673*^9, 3.721253534828554*^9}, 
   3.7212536425721073`*^9, {3.7212536869682407`*^9, 3.721253798741549*^9}, 
   3.721253892566531*^9, 3.721254379709117*^9, 3.721255375293445*^9, 
   3.721255414467003*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{{3.721253486911673*^9, 3.721253534828554*^9}, 
   3.7212536425721073`*^9, {3.7212536869682407`*^9, 3.721253798741549*^9}, 
   3.721253892566531*^9, 3.721254379709117*^9, 3.721255375293445*^9, 
   3.7212554144866*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  
  SequenceForm[41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{{3.721253486911673*^9, 3.721253534828554*^9}, 
   3.7212536425721073`*^9, {3.7212536869682407`*^9, 3.721253798741549*^9}, 
   3.721253892566531*^9, 3.721254379709117*^9, 3.721255375293445*^9, 
   3.7212554145067987`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{{3.721253486911673*^9, 3.721253534828554*^9}, 
   3.7212536425721073`*^9, {3.7212536869682407`*^9, 3.721253798741549*^9}, 
   3.721253892566531*^9, 3.721254379709117*^9, 3.721255375293445*^9, 
   3.721255414712708*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "42"}],
  SequenceForm[41, "  ", 42],
  Editable->False]], "Print",
 CellChangeTimes->{{3.721253486911673*^9, 3.721253534828554*^9}, 
   3.7212536425721073`*^9, {3.7212536869682407`*^9, 3.721253798741549*^9}, 
   3.721253892566531*^9, 3.721254379709117*^9, 3.721255375293445*^9, 
   3.721255414732729*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41, " ", 41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{{3.721253486911673*^9, 3.721253534828554*^9}, 
   3.7212536425721073`*^9, {3.7212536869682407`*^9, 3.721253798741549*^9}, 
   3.721253892566531*^9, 3.721254379709117*^9, 3.721255375293445*^9, 
   3.7212554147520857`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{{3.721253486911673*^9, 3.721253534828554*^9}, 
   3.7212536425721073`*^9, {3.7212536869682407`*^9, 3.721253798741549*^9}, 
   3.721253892566531*^9, 3.721254379709117*^9, 3.721255375293445*^9, 
   3.721255414771367*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  
  SequenceForm[41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{{3.721253486911673*^9, 3.721253534828554*^9}, 
   3.7212536425721073`*^9, {3.7212536869682407`*^9, 3.721253798741549*^9}, 
   3.721253892566531*^9, 3.721254379709117*^9, 3.721255375293445*^9, 
   3.721255414790485*^9}]
}, Open  ]],

Cell[BoxData[
 TemplateBox[{
  "Part","partw",
   "\"Part \\!\\(\\*RowBox[{\\\"13\\\"}]\\) of \\!\\(\\*RowBox[{\\\"{\\\", \
RowBox[{\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"1\\\", \\\",\\\", \\\"0\\\", \
\\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"1\\\"}], \\\"}\\\"}]\\) does not exist.\"",2,186,45,
   25834786221962601457,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.721254380518579*^9, 3.721255376065287*^9, 
  3.7212554152205*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","partw",
   "\"Part \\!\\(\\*RowBox[{\\\"14\\\"}]\\) of \\!\\(\\*RowBox[{\\\"{\\\", \
RowBox[{\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"1\\\", \\\",\\\", \\\"0\\\", \
\\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"1\\\"}], \\\"}\\\"}]\\) does not exist.\"",2,186,46,
   25834786221962601457,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.721254380518579*^9, 3.721255376065287*^9, 
  3.721255415575656*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","partw",
   "\"Part \\!\\(\\*RowBox[{\\\"15\\\"}]\\) of \\!\\(\\*RowBox[{\\\"{\\\", \
RowBox[{\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"1\\\", \\\",\\\", \\\"0\\\", \
\\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"1\\\"}], \\\"}\\\"}]\\) does not exist.\"",2,186,47,
   25834786221962601457,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.721254380518579*^9, 3.721255376065287*^9, 
  3.7212554159496727`*^9}],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"Part\\\", \\\"::\\\", \
\\\"partw\\\"}], \\\"MessageName\\\"]\\) will be suppressed during this \
calculation.\"",2,186,48,25834786221962601457,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.721254380518579*^9, 3.721255376065287*^9, 
  3.72125541616055*^9}],

Cell[BoxData["2"], "Output",
 CellChangeTimes->{
  3.7212536427067337`*^9, {3.721253687063415*^9, 3.721253799187338*^9}, 
   3.721253897676543*^9, 3.721254381403401*^9, 3.721255376943335*^9, 
   3.7212554161791897`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"corrdataclassfinal", "//", "Dimensions"}]], "Input",
 CellChangeTimes->{{3.7212533084663677`*^9, 3.721253310126569*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"41", ",", "17"}], "}"}]], "Output",
 CellChangeTimes->{3.7212533106861353`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"corrdataclassfinal", "[", 
  RowBox[{"[", 
   RowBox[{"2", ",", "8"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.721253538757516*^9, 3.721253579340131*^9}}],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"label\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\<\"x\"\>", ",", "\<\"Q\"\>", ",", "\<\"corr\"\>"}], "}"}]}], 
   ",", 
   RowBox[{"\<\"data\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"LF", "[", 
       RowBox[{"0.07`", ",", "2.958`", ",", "0.580394015633719`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.07`", ",", "3.202`", ",", "0.5073442099869513`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.1`", ",", "3.202`", ",", "0.35136064867420796`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.1`", ",", "3.428`", ",", "0.3280795426664024`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.1`", ",", "3.64`", ",", "0.43727914873933726`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.14`", ",", "3.428`", ",", "0.057164843157333195`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.14`", ",", "3.64`", ",", "0.0545099168919067`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.14`", ",", "3.873`", ",", "0.010065510053340524`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.14`", ",", "4.123`", ",", "0.09376876080475686`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.14`", ",", "4.359`", ",", "0.321424592520622`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.18`", ",", "3.428`", ",", 
        RowBox[{"-", "0.017325742794841968`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.18`", ",", "3.64`", ",", 
        RowBox[{"-", "0.13245033956232635`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.18`", ",", "3.873`", ",", 
        RowBox[{"-", "0.0635047662250632`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.18`", ",", "4.123`", ",", 
        RowBox[{"-", "0.16127336451511726`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.18`", ",", "4.359`", ",", 
        RowBox[{"-", "0.1870169104723349`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.18`", ",", "4.636`", ",", 
        RowBox[{"-", "0.002996665341103949`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.18`", ",", "4.95`", ",", "0.039955844963922266`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.225`", ",", "3.428`", ",", 
        RowBox[{"-", "0.12021283823963433`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.225`", ",", "3.64`", ",", 
        RowBox[{"-", "0.13717684520051923`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.225`", ",", "3.873`", ",", "0.022294170262546327`"}], "]"}],
       ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.225`", ",", "4.123`", ",", 
        RowBox[{"-", "0.05449293895627135`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.225`", ",", "4.359`", ",", 
        RowBox[{"-", "0.08408759126190396`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.225`", ",", "4.636`", ",", 
        RowBox[{"-", "0.0982551449819027`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.225`", ",", "4.95`", ",", 
        RowBox[{"-", "0.006598320337832042`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.225`", ",", "5.292`", ",", "0.5762011199350205`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.225`", ",", "5.701`", ",", "0.588192122702628`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "3.64`", ",", "0.05388651574503547`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "3.873`", ",", 
        RowBox[{"-", "0.02520770935133286`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "4.123`", ",", 
        RowBox[{"-", "0.035395766047901074`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "4.359`", ",", 
        RowBox[{"-", "0.05059733733742052`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "4.636`", ",", "0.10250128763382797`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "4.95`", ",", "0.49897342456226285`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "5.292`", ",", "0.4291461511501063`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "5.701`", ",", "0.5302646785714942`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "6.124`", ",", "0.5611897825337859`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "6.557`", ",", "0.5289798587620725`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "3.64`", ",", "0.10914833510732141`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "3.873`", ",", "0.07411570011317105`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "4.123`", ",", "0.06205236929514923`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "4.359`", ",", "0.07628671438818511`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "4.636`", ",", "0.07501060928353254`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "4.95`", ",", "0.35808442761961484`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "5.292`", ",", "0.3924950274423431`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "5.701`", ",", "0.4684523496575102`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "6.124`", ",", "0.5894025913425945`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "6.557`", ",", "0.5484045118683741`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "7.036`", ",", "0.5912058810774415`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "7.55`", ",", "0.5743827010743963`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "3.64`", ",", 
        RowBox[{"-", "0.13805126033763582`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "3.873`", ",", 
        RowBox[{"-", "0.17527276677321135`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "4.123`", ",", 
        RowBox[{"-", "0.1413233123995813`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "4.359`", ",", 
        RowBox[{"-", "0.021846669399296047`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "4.636`", ",", "0.09260320433510318`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "4.95`", ",", "0.339840712921832`"}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "5.292`", ",", "0.33727031079324565`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "5.701`", ",", "0.4775755317692902`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "6.124`", ",", "0.5327312620807979`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "6.557`", ",", "0.447779809969414`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "7.036`", ",", "0.4760388128495955`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "7.55`", ",", "0.39765543167044737`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "8.093`", ",", "0.500302881920326`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "8.66`", ",", "0.526068567676301`"}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "3.873`", ",", 
        RowBox[{"-", "0.4552635868883505`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "4.123`", ",", 
        RowBox[{"-", "0.4544278445241155`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "4.359`", ",", 
        RowBox[{"-", "0.3907427894741227`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "4.636`", ",", 
        RowBox[{"-", "0.37326227974412873`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "4.95`", ",", "0.009742495120797175`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "5.292`", ",", "0.3253028083119683`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "5.701`", ",", "0.44043362434472894`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "6.124`", ",", "0.4614370964436421`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "6.557`", ",", "0.46787891246545266`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "7.036`", ",", "0.4789576992065821`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "7.55`", ",", "0.48959924055155885`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "8.093`", ",", "0.49605806805118335`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "8.66`", ",", "0.4862599935008113`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "9.273`", ",", "0.47937889468321654`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "4.95`", ",", 
        RowBox[{"-", "0.31295265348306656`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "5.292`", ",", 
        RowBox[{"-", "0.11510297027956552`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "5.701`", ",", "0.31910835600009374`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "6.124`", ",", "0.43232567895470847`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "6.557`", ",", "0.454362018604216`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "7.036`", ",", "0.4591971610462433`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "7.55`", ",", "0.47096082951215007`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "8.093`", ",", "0.4705365920617784`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "8.66`", ",", "0.4743556986725549`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "9.273`", ",", "0.4650918916976536`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "9.95`", ",", "0.46818708435000544`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "6.124`", ",", "0.13424139845271435`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "6.557`", ",", "0.2885005841033889`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "7.036`", ",", "0.3466984620675747`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "7.55`", ",", "0.3809350731235013`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "8.093`", ",", "0.4006022085677376`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "8.66`", ",", "0.4086865400454759`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "9.273`", ",", "0.4192942838760848`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "9.95`", ",", "0.4213304733190807`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.07`", ",", "4.123`", ",", "0.7253433485235201`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.07`", ",", "4.359`", ",", "0.6695463603434062`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.1`", ",", "4.359`", ",", "0.5504824293637166`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.1`", ",", "4.636`", ",", "0.5484347537559152`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.1`", ",", "4.95`", ",", "0.5924458695262816`"}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.14`", ",", "4.636`", ",", "0.4156456806826395`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.14`", ",", "4.95`", ",", "0.31812244590649225`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.14`", ",", "5.292`", ",", "0.43819666708238764`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.14`", ",", "5.701`", ",", "0.5107050427375686`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.18`", ",", "4.636`", ",", "0.09530546561261452`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.18`", ",", "4.95`", ",", "0.3898907266508812`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.18`", ",", "5.292`", ",", "0.3107711912415063`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.18`", ",", "5.701`", ",", "0.4394515184315283`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.18`", ",", "6.124`", ",", "0.5235371195154491`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.18`", ",", "6.557`", ",", "0.5279447502042519`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.225`", ",", "5.292`", ",", "0.4059128303845119`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.225`", ",", "5.701`", ",", "0.32417395869162485`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.225`", ",", "6.124`", ",", "0.4477977479452446`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.225`", ",", "6.557`", ",", "0.5351750859577938`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.225`", ",", "7.036`", ",", "0.5048300280312203`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.225`", ",", "7.55`", ",", "0.5148939533044147`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "5.292`", ",", "0.22450681873616463`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "5.701`", ",", "0.4863782478223088`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "6.124`", ",", "0.4816050695749293`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "6.557`", ",", "0.5115469873157735`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "7.036`", ",", "0.4779526612013334`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "7.55`", ",", "0.5426135404335531`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "8.093`", ",", "0.5771570009750705`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "8.66`", ",", "0.5043197207728488`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "5.701`", ",", "0.4166996298979899`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "6.124`", ",", "0.4592537541058315`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "6.557`", ",", "0.461249392393385`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "7.036`", ",", "0.4724597559145309`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "7.55`", ",", "0.43653030615245036`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "8.093`", ",", "0.5314893418292781`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "8.66`", ",", "0.5733108719166248`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "9.273`", ",", "0.4707364111143447`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "9.95`", ",", "0.5437243115075975`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "5.701`", ",", "0.1708929660523423`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "6.124`", ",", "0.25813575427195395`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "6.557`", ",", "0.42279788550015646`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "7.036`", ",", "0.4793802144040427`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "7.55`", ",", "0.5289100794961633`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "8.093`", ",", "0.4413315997155678`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "8.66`", ",", "0.51039940792525`"}], "]"}], ",", 
      
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "9.273`", ",", "0.4528620674748528`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "9.95`", ",", "0.5219672705566049`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "10.75`", ",", "0.46771121507636226`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "5.701`", ",", 
        RowBox[{"-", "0.2951978667631839`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "6.124`", ",", 
        RowBox[{"-", "0.022077179873744593`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "6.557`", ",", "0.22094078489728763`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "7.036`", ",", "0.3734146001994395`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "7.55`", ",", "0.4526371887396923`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "8.093`", ",", "0.47740537391383936`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "8.66`", ",", "0.488180144850719`"}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "9.273`", ",", "0.47792164255440484`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "9.95`", ",", "0.49180252040183275`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "10.75`", ",", "0.4933200534813006`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "11.73`", ",", "0.4705295397045065`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "5.701`", ",", 
        RowBox[{"-", "0.4679217545700624`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "6.124`", ",", 
        RowBox[{"-", "0.4750141361245332`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "6.557`", ",", 
        RowBox[{"-", "0.18517385761537675`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "7.036`", ",", "0.27729619168804487`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "7.55`", ",", "0.4147848450874276`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "8.093`", ",", "0.44683346148873676`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "8.66`", ",", "0.42643538490446864`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "9.273`", ",", "0.45990786036631376`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "9.95`", ",", "0.4653553055964756`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "10.75`", ",", "0.4680264679551234`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "11.73`", ",", "0.4695644637777878`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "6.557`", ",", 
        RowBox[{"-", "0.4488847394087447`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "7.036`", ",", 
        RowBox[{"-", "0.3269144205962041`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "7.55`", ",", 
        RowBox[{"-", "0.07398982726585064`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "8.093`", ",", "0.173415802746707`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "8.66`", ",", "0.29167363718952893`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "9.273`", ",", "0.3495857883612547`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "9.95`", ",", "0.37687874714686853`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "10.75`", ",", "0.4022432649667918`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "11.73`", ",", "0.4106448743105984`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.1`", ",", "5.701`", ",", "0.10334027789860588`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.1`", ",", "6.124`", ",", "0.3023100983777217`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.14`", ",", "6.124`", ",", 
        RowBox[{"-", "0.3177328886198487`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.14`", ",", "6.557`", ",", 
        RowBox[{"-", "0.1574143508393718`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.14`", ",", "7.036`", ",", 
        RowBox[{"-", "0.1549235342830412`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.14`", ",", "7.55`", ",", 
        RowBox[{"-", "0.19001013416386606`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.18`", ",", "6.124`", ",", 
        RowBox[{"-", "0.13562635861567904`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.18`", ",", "6.557`", ",", 
        RowBox[{"-", "0.18758311235721664`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.18`", ",", "7.036`", ",", 
        RowBox[{"-", "0.14110161095091717`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.18`", ",", "7.55`", ",", "0.42659387333961113`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.18`", ",", "8.093`", ",", "0.38735176095409907`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.225`", ",", "6.124`", ",", 
        RowBox[{"-", "0.08513649442781406`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.225`", ",", "6.557`", ",", 
        RowBox[{"-", "0.1757761712912499`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.225`", ",", "7.036`", ",", 
        RowBox[{"-", "0.07938687945782466`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.225`", ",", "7.55`", ",", "0.4354773239175442`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.225`", ",", "8.093`", ",", "0.43085834891354646`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.225`", ",", "8.66`", ",", "0.3910750860124134`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.225`", ",", "9.273`", ",", "0.42051793236085505`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "6.124`", ",", 
        RowBox[{"-", "0.12203581321600547`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "6.557`", ",", "0.07849132703338231`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "7.036`", ",", 
        RowBox[{"-", "0.06668385843594281`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "7.55`", ",", "0.35732498762752474`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "8.093`", ",", "0.3399022050643879`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "8.66`", ",", "0.3201046969457106`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "9.273`", ",", "0.4476313001954676`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "9.95`", ",", "0.5518173563645957`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.275`", ",", "10.75`", ",", "0.426710932334906`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "6.557`", ",", 
        RowBox[{"-", "0.1103661857877912`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "7.036`", ",", "0.02959040600141695`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "7.55`", ",", "0.46884687394481545`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "8.093`", ",", "0.4832262158420782`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "8.66`", ",", "0.4656129843074056`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "9.273`", ",", "0.5043938130531844`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "9.95`", ",", "0.49996322058396425`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "10.75`", ",", "0.56499091105699`"}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.35`", ",", "11.73`", ",", "0.5257053508615279`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "6.557`", ",", 
        RowBox[{"-", "0.07319570399053732`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "7.036`", ",", 
        RowBox[{"-", "0.13190126217415338`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "7.55`", ",", "0.32133015946721694`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "8.093`", ",", "0.5199246533891986`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "8.66`", ",", "0.48560857247914074`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "9.273`", ",", "0.5577212161971801`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "9.95`", ",", "0.49017404691727784`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "10.75`", ",", "0.5541028200298489`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "11.73`", ",", "0.5287504780538848`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.45`", ",", "13.23`", ",", "0.5319599967530245`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "6.557`", ",", 
        RowBox[{"-", "0.1818244262438647`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "7.036`", ",", 
        RowBox[{"-", "0.10310336783299011`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "7.55`", ",", "0.06687977897102078`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "8.093`", ",", "0.2404581076718039`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "8.66`", ",", "0.39678867522431843`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "9.273`", ",", "0.46900154948044387`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "9.95`", ",", "0.47573321320170525`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "10.75`", ",", "0.4800347273204746`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "11.73`", ",", "0.37589175582284373`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "13.23`", ",", "0.48336201788827543`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.55`", ",", "15.17`", ",", "0.4816667342752578`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "7.036`", ",", 
        RowBox[{"-", "0.33051104927293723`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "7.55`", ",", 
        RowBox[{"-", "0.12331769983878205`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "8.093`", ",", "0.03212270369607242`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "8.66`", ",", "0.1901606449159218`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "9.273`", ",", "0.29106905598991206`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "9.95`", ",", "0.36809280317002296`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "10.75`", ",", "0.4327548496072278`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "11.73`", ",", "0.45479463875593656`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "13.23`", ",", "0.4735482889103166`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.65`", ",", "15.17`", ",", "0.465366244187978`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "7.55`", ",", 
        RowBox[{"-", "0.4719834060433774`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "8.093`", ",", 
        RowBox[{"-", "0.38275466500272004`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "8.66`", ",", 
        RowBox[{"-", "0.15775075418493853`"}]}], "]"}], ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "9.273`", ",", "0.10896363655477453`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "9.95`", ",", "0.2395750052733364`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "10.75`", ",", "0.3228683475357361`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "11.73`", ",", "0.37514093972533247`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "13.23`", ",", "0.40661699140211105`"}], "]"}], 
      ",", 
      RowBox[{"LF", "[", 
       RowBox[{"0.75`", ",", "15.17`", ",", "0.41406156965020324`"}], "]"}]}],
      "}"}]}], ",", 
   RowBox[{"\<\"exptinfo\"\>", "\[Rule]", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"\<\"exptid\"\>", "\[Rule]", "102"}], ",", 
      RowBox[{"\<\"exptname\"\>", "\[Rule]", "\<\"BcdF2dCor\"\>"}], ",", 
      RowBox[{"\<\"feyndiagram\"\>", "\[Rule]", "\<\"unset\"\>"}]}], 
     "\[RightAssociation]"}]}], ",", 
   RowBox[{"\<\"PDFinfo\"\>", "\[Rule]", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"\<\"PDFname\"\>", "\[Rule]", "\<\"CT14NNLO\"\>"}], ",", 
      RowBox[{"\<\"PDFsetmethod\"\>", "\[Rule]", "\<\"Hessian\"\>"}], ",", 
      RowBox[{"\<\"Nset\"\>", "\[Rule]", "\<\"unset\"\>"}], ",", 
      RowBox[{"\<\"iset\"\>", "\[Rule]", "\<\"unset\"\>"}], ",", 
      RowBox[{"\<\"flavour\"\>", "\[Rule]", "\<\"unset\"\>"}]}], 
     "\[RightAssociation]"}]}]}], "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{{3.72125354027859*^9, 3.7212535798880377`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Jobid", ",", "JobDescription", 
       RowBox[{"(*", "20171128", "*)"}], ",", "PDFname", ",", "FigureType", 
       ",", "FigureFlag", ",", "ExptidType", ",", "ExptidFlag", ",", 
       "CorrelationArgType", ",", "CorrelationArgFlag", ",", 
       RowBox[{"(*", 
        RowBox[{"UserArgName", ",", "UserArgValue", ","}], "*)"}], 
       "\[IndentingNewLine]", "XQfigureXrange", ",", "XQfigureYrange", ",", 
       "ColorPaletterange", 
       RowBox[{"(*", "20171128", "*)"}], ",", "Hist1figureNbin", ",", 
       RowBox[{"(*", 
        RowBox[{"Hist1figureXrange", ",", 
         RowBox[{"(*", "Hist1figureYrange", "*)"}], "dummy12", ","}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{"ColorSeperator", ","}], "*)"}], "\[IndentingNewLine]", 
       "Size", ",", "HighlightType", ",", "HighlightMode", ",", 
       "HighlightMode1", ",", "HighlightMode2"}], "}"}], "=", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", "readcorrconfigfile4", "*)"}], 
     RowBox[{"readcorrconfigfile6", "[", 
      RowBox[{"configDir", ",", "configfilename"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"FigureFlag", "[", 
         RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", "1"}], " ", "||", " ", 
       RowBox[{
        RowBox[{"FigureFlag", "[", 
         RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", 
        RowBox[{"-", "1"}]}]}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Print", "[", 
        RowBox[{"\"\<making plot of figure type \>\"", ",", 
         RowBox[{"FigureType", "[", 
          RowBox[{"[", "3", "]"}], "]"}], ",", "\"\<, flavour = \>\"", ",", 
         "flavour"}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"p234", "=", 
        RowBox[{"processdataplotsmultiexp7percentage", "[", 
         RowBox[{
          RowBox[{"{", "residualdataclassfinal", "}"}], ",", 
          RowBox[{"readcorrconfigfile6", "[", 
           RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "3", ",",
           "flavour"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
        "20171202", " ", "add", " ", "important", " ", "data", " ", "info"}], 
        "*)"}], "\[IndentingNewLine]", 
       RowBox[{"datainfostr", "=", 
        RowBox[{"datainfototext", "[", 
         RowBox[{
          RowBox[{"{", "residualdataclassfinal", "}"}], ",", 
          RowBox[{"readcorrconfigfile6", "[", 
           RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "3", ",",
           "flavour"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"p5", "=", 
          RowBox[{"GraphicsGrid", "[", 
           RowBox[{"p5", ",", 
            RowBox[{"Spacings", "\[Rule]", 
             RowBox[{"Scaled", "[", "0.15", "]"}]}]}], " ", "]"}]}], ";"}], 
        "*)"}], "\[IndentingNewLine]", 
       RowBox[{"Table", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"filename", "=", 
           RowBox[{
            RowBox[{"obsname", "[", 
             RowBox[{"[", "3", "]"}], "]"}], "<>", "\"\<_\>\"", "<>", 
            RowBox[{"representationname", "[", 
             RowBox[{"[", "5", "]"}], "]"}], "<>", "\"\<_samept\>\"", "<>", 
            RowBox[{"extensionname", "[", 
             RowBox[{"[", 
              RowBox[{"iext", "[", 
               RowBox[{"[", "i", "]"}], "]"}], " ", "]"}], "]"}]}]}], ";", 
          "\n", 
          RowBox[{"Export", "[", 
           RowBox[{
            RowBox[{"saveparentpath", "<>", 
             RowBox[{"(*", 
              RowBox[{"pdfnameexpttypeDir", "<>", "exptidDir"}], "*)"}], 
             "jobpath", "<>", "filename"}], ",", 
            RowBox[{"p234", "[", 
             RowBox[{"[", 
              RowBox[{"1", ",", "2"}], "]"}], "]"}], ",", 
            RowBox[{"ImageResolution", "\[Rule]", "imgresol"}]}], "  ", "]"}],
           ";", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"20171201", " ", "for"}], " ", "+", "1"}], ":", " ", 
             RowBox[{"absolute", " ", "values", " ", "of", " ", "data"}]}], 
            ",", " ", 
            RowBox[{
             RowBox[{"for", " ", "-", "1"}], ":", " ", 
             RowBox[{"sign", " ", "data"}]}]}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"If", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"FigureFlag", "[", 
              RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", 
             RowBox[{"-", "1"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"filename", "=", 
              RowBox[{
               RowBox[{"obsname", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "<>", "\"\<_\>\"", "<>", 
               RowBox[{"representationname", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "<>", "\"\<_samept\>\"", "<>", 
               RowBox[{"extensionname", "[", 
                RowBox[{"[", 
                 RowBox[{"iext", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], " ", "]"}], "]"}]}]}], ";", 
             "\n", 
             RowBox[{"Export", "[", 
              RowBox[{
               RowBox[{"saveparentpath", "<>", 
                RowBox[{"(*", 
                 RowBox[{"pdfnameexpttypeDir", "<>", "exptidDir"}], "*)"}], 
                "jobpath", "<>", "filename"}], ",", 
               RowBox[{"p234", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"ImageResolution", "\[Rule]", "imgresol"}]}], "  ", 
              "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"filename", "=", 
              RowBox[{
               RowBox[{"obsname", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "<>", "\"\<_\>\"", "<>", 
               RowBox[{"representationname", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "<>", "\"\<_samept\>\"", "<>", 
               RowBox[{"extensionname", "[", 
                RowBox[{"[", 
                 RowBox[{"iext", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], " ", "]"}], "]"}]}]}], ";", 
             "\n", 
             RowBox[{"Export", "[", 
              RowBox[{
               RowBox[{"saveparentpath", "<>", 
                RowBox[{"(*", 
                 RowBox[{"pdfnameexpttypeDir", "<>", "exptidDir"}], "*)"}], 
                "jobpath", "<>", "filename"}], ",", 
               RowBox[{"p234", "[", 
                RowBox[{"[", 
                 RowBox[{"2", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"ImageResolution", "\[Rule]", "imgresol"}]}], " ", 
              "]"}], ";", "\[IndentingNewLine]", "\"\<dummy\>\""}]}], 
           "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"FigureFlag", "[", 
              RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", "1"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"filename", "=", 
              RowBox[{
               RowBox[{"obsname", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "<>", "\"\<_\>\"", "<>", 
               RowBox[{"representationname", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "<>", "\"\<_samept\>\"", "<>", 
               RowBox[{"extensionname", "[", 
                RowBox[{"[", 
                 RowBox[{"iext", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], " ", "]"}], "]"}]}]}], ";", 
             "\n", 
             RowBox[{"Export", "[", 
              RowBox[{
               RowBox[{"saveparentpath", "<>", 
                RowBox[{"(*", 
                 RowBox[{"pdfnameexpttypeDir", "<>", "exptidDir"}], "*)"}], 
                "jobpath", "<>", "filename"}], ",", 
               RowBox[{"p234", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"ImageResolution", "\[Rule]", "imgresol"}]}], "  ", 
              "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"filename", "=", 
              RowBox[{
               RowBox[{"obsname", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "<>", "\"\<_\>\"", "<>", 
               RowBox[{"representationname", "[", 
                RowBox[{"[", "4", "]"}], "]"}], "<>", "\"\<_samept\>\"", "<>", 
               RowBox[{"extensionname", "[", 
                RowBox[{"[", 
                 RowBox[{"iext", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], " ", "]"}], "]"}]}]}], ";", 
             "\n", 
             RowBox[{"Export", "[", 
              RowBox[{
               RowBox[{"saveparentpath", "<>", 
                RowBox[{"(*", 
                 RowBox[{"pdfnameexpttypeDir", "<>", "exptidDir"}], "*)"}], 
                "jobpath", "<>", "filename"}], ",", 
               RowBox[{"p234", "[", 
                RowBox[{"[", 
                 RowBox[{"2", ",", "2"}], "]"}], "]"}], ",", 
               RowBox[{"ImageResolution", "\[Rule]", "imgresol"}]}], " ", 
              "]"}], ";", "\[IndentingNewLine]", "\"\<dummy\>\""}]}], 
           "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "\"\<dummy\>\""}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"Length", "[", "iext", "]"}]}], "}"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{"20171103", ":", " ", 
         RowBox[{
         "add", " ", "files", " ", "storing", " ", "mathematica", " ", 
          "expressions", " ", "so", " ", "that", " ", "users", " ", "can", 
          " ", "change", " ", "details", " ", "of", " ", "every", " ", 
          "figure"}]}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
       
       RowBox[{"filename", "=", 
        RowBox[{
         RowBox[{"obsname", "[", 
          RowBox[{"[", "3", "]"}], "]"}], "<>", "\"\<_\>\"", "<>", 
         RowBox[{"representationname", "[", 
          RowBox[{"[", "5", "]"}], "]"}], "<>", "\"\<_samept\>\"", "<>", 
         "\"\<.m\>\""}]}], ";", "\n", 
       RowBox[{"Export", "[", 
        RowBox[{
         RowBox[{"saveparentpath", "<>", 
          RowBox[{"(*", 
           RowBox[{"pdfnameexpttypeDir", "<>", "exptidDir"}], "*)"}], 
          "jobpath", "<>", "filename"}], ",", 
         RowBox[{"p234", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "2"}], "]"}], "]"}]}], "  ", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"20171201", " ", "for"}], " ", "+", "1"}], ":", " ", 
          RowBox[{"absolute", " ", "values", " ", "of", " ", "data"}]}], ",", 
         " ", 
         RowBox[{
          RowBox[{"for", " ", "-", "1"}], ":", " ", 
          RowBox[{"sign", " ", "data"}]}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"FigureFlag", "[", 
           RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", 
          RowBox[{"-", "1"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"filename", "=", 
           RowBox[{
            RowBox[{"obsname", "[", 
             RowBox[{"[", "3", "]"}], "]"}], "<>", "\"\<_\>\"", "<>", 
            RowBox[{"representationname", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "<>", "\"\<_samept\>\"", "<>", 
            "\"\<.m\>\""}]}], ";", "\n", 
          RowBox[{"Export", "[", 
           RowBox[{
            RowBox[{"saveparentpath", "<>", 
             RowBox[{"(*", 
              RowBox[{"pdfnameexpttypeDir", "<>", "exptidDir"}], "*)"}], 
             "jobpath", "<>", "filename"}], ",", 
            RowBox[{"p234", "[", 
             RowBox[{"[", 
              RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "  ", "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"filename", "=", 
           RowBox[{
            RowBox[{"obsname", "[", 
             RowBox[{"[", "3", "]"}], "]"}], "<>", "\"\<_\>\"", "<>", 
            RowBox[{"representationname", "[", 
             RowBox[{"[", "3", "]"}], "]"}], "<>", "\"\<_samept\>\"", "<>", 
            "\"\<.m\>\""}]}], ";", "\n", 
          RowBox[{"Export", "[", 
           RowBox[{
            RowBox[{"saveparentpath", "<>", 
             RowBox[{"(*", 
              RowBox[{"pdfnameexpttypeDir", "<>", "exptidDir"}], "*)"}], 
             "jobpath", "<>", "filename"}], ",", 
            RowBox[{"p234", "[", 
             RowBox[{"[", 
              RowBox[{"2", ",", "1"}], "]"}], "]"}]}], " ", "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
           "20171202", " ", "add", " ", "important", " ", "data", " ", 
            "info"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"filename", "=", 
           RowBox[{
            RowBox[{"obsname", "[", 
             RowBox[{"[", "3", "]"}], "]"}], "<>", "\"\<_\>\"", "<>", 
            RowBox[{"representationname", "[", 
             RowBox[{"[", "7", "]"}], "]"}], "<>", "\"\<_samept\>\"", "<>", 
            "\"\<.txt\>\""}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"Export", "[", 
           RowBox[{
            RowBox[{"saveparentpath", "<>", 
             RowBox[{"(*", 
              RowBox[{"pdfnameexpttypeDir", "<>", "exptidDir"}], "*)"}], 
             "jobpath", "<>", "filename"}], ",", "datainfostr"}], "  ", "]"}],
           ";", "\[IndentingNewLine]", "\"\<dummy\>\""}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"FigureFlag", "[", 
           RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", "1"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"filename", "=", 
           RowBox[{
            RowBox[{"obsname", "[", 
             RowBox[{"[", "3", "]"}], "]"}], "<>", "\"\<_\>\"", "<>", 
            RowBox[{"representationname", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "<>", "\"\<_samept\>\"", "<>", 
            "\"\<.m\>\""}]}], ";", "\n", 
          RowBox[{"Export", "[", 
           RowBox[{
            RowBox[{"saveparentpath", "<>", 
             RowBox[{"(*", 
              RowBox[{"pdfnameexpttypeDir", "<>", "exptidDir"}], "*)"}], 
             "jobpath", "<>", "filename"}], ",", 
            RowBox[{"p234", "[", 
             RowBox[{"[", 
              RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "  ", "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"filename", "=", 
           RowBox[{
            RowBox[{"obsname", "[", 
             RowBox[{"[", "3", "]"}], "]"}], "<>", "\"\<_\>\"", "<>", 
            RowBox[{"representationname", "[", 
             RowBox[{"[", "4", "]"}], "]"}], "<>", "\"\<_samept\>\"", "<>", 
            "\"\<.m\>\""}]}], ";", "\n", 
          RowBox[{"Export", "[", 
           RowBox[{
            RowBox[{"saveparentpath", "<>", 
             RowBox[{"(*", 
              RowBox[{"pdfnameexpttypeDir", "<>", "exptidDir"}], "*)"}], 
             "jobpath", "<>", "filename"}], ",", 
            RowBox[{"p234", "[", 
             RowBox[{"[", 
              RowBox[{"2", ",", "2"}], "]"}], "]"}]}], " ", "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
           "20171202", " ", "add", " ", "important", " ", "data", " ", 
            "info"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"filename", "=", 
           RowBox[{
            RowBox[{"obsname", "[", 
             RowBox[{"[", "3", "]"}], "]"}], "<>", "\"\<_\>\"", "<>", 
            RowBox[{"representationname", "[", 
             RowBox[{"[", "8", "]"}], "]"}], "<>", "\"\<_samept\>\"", "<>", 
            "\"\<.txt\>\""}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"Export", "[", 
           RowBox[{
            RowBox[{"saveparentpath", "<>", 
             RowBox[{"(*", 
              RowBox[{"pdfnameexpttypeDir", "<>", "exptidDir"}], "*)"}], 
             "jobpath", "<>", "filename"}], ",", "datainfostr"}], "  ", "]"}],
           ";", "\[IndentingNewLine]", "\"\<dummy\>\""}]}], 
        "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";"}]}]}]], "Input",\

 CellChangeTimes->{{3.721278344833599*^9, 3.721278348193844*^9}, {
  3.721279719376267*^9, 3.72127973187002*^9}, {3.721279802221884*^9, 
  3.721279806857922*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"making plot of figure type \"\>", 
   "\[InvisibleSpace]", "\<\"3\"\>", 
   "\[InvisibleSpace]", "\<\", flavour = \"\>", "\[InvisibleSpace]", 
   "flavour"}],
  SequenceForm[
  "making plot of figure type ", "3", ", flavour = ", $CellContext`flavour],
  Editable->False]], "Print",
 CellChangeTimes->{3.7212783604187803`*^9, 3.721278881326288*^9, 
  3.721279606406824*^9, 3.721279733852714*^9, 3.7212798410943623`*^9, 
  3.72128002110181*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.7212783604187803`*^9, 3.721278881326288*^9, 
  3.721279606406824*^9, 3.721279733852714*^9, 3.7212798410943623`*^9, 
  3.72128002236973*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  
  SequenceForm[41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.7212783604187803`*^9, 3.721278881326288*^9, 
  3.721279606406824*^9, 3.721279733852714*^9, 3.7212798410943623`*^9, 
  3.721280022584942*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["representationname"], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"xQ-1\"\>", ",", "\<\"xQ+1\"\>", ",", "\<\"hist-1\"\>", 
   ",", "\<\"hist+1\"\>", ",", "\<\"legend\"\>", ",", "\<\"xQ\"\>"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.721279916874858*^9, 3.721279958027755*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"representationname", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<xQ-1\>\"", ",", "\"\<xQ+1\>\"", ",", "\"\<hist-1\>\"", ",", 
     "\"\<hist+1\>\"", ",", "\"\<legend\>\"", ",", "\"\<xQ\>\"", ",", 
     "\"\<info-1\>\"", ",", "\"\<info+1\>\""}], "}"}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"20171202", " ", "for", " ", "plot", " ", "type"}], " ", "=", 
     " ", 
     RowBox[{"5", " ", "or", " ", "6"}]}], ",", " ", 
    RowBox[{"write", " ", "data", " ", "info", " ", "into", " ", "files"}], 
    ",", " ", 
    RowBox[{
     RowBox[{"if", " ", "flavour", " ", "flag"}], " ", "=", " ", "1"}], ",", 
    " ", 
    RowBox[{"record", " ", "the", " ", "info"}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"If", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"FigureFlag", "[", 
         RowBox[{"[", "6", "]"}], "]"}], "\[Equal]", "1"}], " ", "||", " ", 
       RowBox[{
        RowBox[{"FigureFlag", "[", 
         RowBox[{"[", "6", "]"}], "]"}], "\[Equal]", 
        RowBox[{"-", "1"}]}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"(*", "filename", "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"filename", "=", "\[IndentingNewLine]", 
        RowBox[{"Switch", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"FigureFlag", "[", 
           RowBox[{"[", "6", "]"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"-", "1"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"obsname", "[", 
            RowBox[{"[", "6", "]"}], "]"}], "<>", "\"\<_\>\"", "<>", 
           RowBox[{"representationname", "[", 
            RowBox[{"[", "7", "]"}], "]"}], "<>", "\"\<_\>\"", "<>", 
           "\"\<_samept_info\>\"", "<>", "\"\<.txt\>\""}], ",", 
          "\[IndentingNewLine]", "1", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"obsname", "[", 
            RowBox[{"[", "6", "]"}], "]"}], "<>", "\"\<_\>\"", "<>", 
           RowBox[{"representationname", "[", 
            RowBox[{"[", "8", "]"}], "]"}], "<>", "\"\<_\>\"", "<>", 
           "\"\<_samept_info\>\"", "<>", "\"\<.txt\>\""}]}], 
         "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{"info", " ", "string"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"datainfostr", "=", "\[IndentingNewLine]", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"CorrelationArgFlag", "[", 
              RowBox[{"[", 
               RowBox[{"flavour", "+", "6"}], "]"}], "]"}], "\[Equal]", "1"}],
             ",", "\[IndentingNewLine]", 
            RowBox[{"datainfototext", "[", 
             RowBox[{
              RowBox[{"{", "corrdataclassfinal", "}"}], ",", 
              RowBox[{"readcorrconfigfile6", "[", 
               RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "6", 
              ",", "flavour"}], "]"}], ",", "\[IndentingNewLine]", 
            "\"\<\>\""}], "\[IndentingNewLine]", "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"flavour", ",", 
            RowBox[{"-", "5"}], ",", 
            RowBox[{
             RowBox[{"-", "5"}], "+", "fmax", "-", "1"}]}], "}"}]}], 
         "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{"export", " ", "the", " ", "info", " ", "file"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
        "20171202", " ", "add", " ", "important", " ", "data", " ", "info"}], 
        "*)"}], "\[IndentingNewLine]", 
       RowBox[{"Export", "[", 
        RowBox[{
         RowBox[{"saveparentpath", "<>", 
          RowBox[{"(*", 
           RowBox[{"pdfnameexpttypeDir", "<>", "exptidDir"}], "*)"}], 
          "jobpath", "<>", "filename"}], ",", 
         RowBox[{"datainfostr", "//", "StringJoin"}]}], "  ", "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\"\<dummy\>\""}]}], 
     "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721281698846631*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "42"}],
  SequenceForm[41, "  ", 42],
  Editable->False]], "Print",
 CellChangeTimes->{3.7212816988576813`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "42", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "42", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "42"}],
  SequenceForm[41, "  ", 42, " ", 42, " ", 42],
  Editable->False]], "Print",
 CellChangeTimes->{3.721281698868403*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.7212816988787518`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  
  SequenceForm[41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721281698917679*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721281699144141*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "42"}],
  SequenceForm[41, "  ", 42],
  Editable->False]], "Print",
 CellChangeTimes->{3.7212816991575413`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "42", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "42", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "42"}],
  SequenceForm[41, "  ", 42, " ", 42, " ", 42],
  Editable->False]], "Print",
 CellChangeTimes->{3.7212816991715927`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "41"}],
  SequenceForm[41, "  ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721281699184121*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "41"}],
  
  SequenceForm[41, " ", 41],
  Editable->False]], "Print",
 CellChangeTimes->{3.721281699238965*^9}]
}, Open  ]],

Cell[BoxData[
 TemplateBox[{
  "Part","partw",
   "\"Part \\!\\(\\*RowBox[{\\\"13\\\"}]\\) of \\!\\(\\*RowBox[{\\\"{\\\", \
RowBox[{\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"1\\\", \\\",\\\", \\\"0\\\", \
\\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"1\\\"}], \\\"}\\\"}]\\) does not exist.\"",2,292,92,
   25834786221962601457,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7212817004064198`*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","partw",
   "\"Part \\!\\(\\*RowBox[{\\\"14\\\"}]\\) of \\!\\(\\*RowBox[{\\\"{\\\", \
RowBox[{\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"1\\\", \\\",\\\", \\\"0\\\", \
\\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"1\\\"}], \\\"}\\\"}]\\) does not exist.\"",2,292,93,
   25834786221962601457,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.721281701614318*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","partw",
   "\"Part \\!\\(\\*RowBox[{\\\"15\\\"}]\\) of \\!\\(\\*RowBox[{\\\"{\\\", \
RowBox[{\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"1\\\", \\\",\\\", \\\"0\\\", \
\\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"1\\\"}], \\\"}\\\"}]\\) does not exist.\"",2,292,94,
   25834786221962601457,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.72128170277334*^9}],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"Part\\\", \\\"::\\\", \
\\\"partw\\\"}], \\\"MessageName\\\"]\\) will be suppressed during this \
calculation.\"",2,292,95,25834786221962601457,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7212817036425037`*^9}],

Cell[BoxData[
 TemplateBox[{
  "StringJoin","string",
   "\"String expected at position \\!\\(\\*RowBox[{\\\"2\\\"}]\\) in \
\\!\\(\\*RowBox[{RowBox[{\\\"\[LeftSkeleton]\\\", \\\"10881\\\", \\\"\
\[RightSkeleton]\\\"}], \\\"<>\\\", RowBox[{\\\"If\\\", \\\"[\\\", \
RowBox[{RowBox[{RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \
\\\",\\\", \\\"1\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"1\\\"}], \\\"}\\\"}], \\\"\[LeftDoubleBracket]\\\", \\\"13\\\", \\\"\
\[RightDoubleBracket]\\\"}], \\\"\[Equal]\\\", \\\"1\\\"}], \\\",\\\", \
RowBox[{\\\"datainfototext\\\", \\\"[\\\", RowBox[{RowBox[{\\\"{\\\", \
\\\"corrdataclassfinal\\\", \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"readcorrconfigfile6\\\", \\\"[\\\", RowBox[{\\\"configDir\\\", \\\
\",\\\", \\\"configfilename\\\"}], \\\"]\\\"}], \\\",\\\", \\\"6\\\", \\\",\\\
\", \\\"flavour\\\"}], \\\"]\\\"}], \\\",\\\", \\\"\\\\\\\"\\\\\\\"\\\"}], \\\
\"]\\\"}], \\\"<>\\\", RowBox[{\\\"If\\\", \\\"[\\\", \
RowBox[{RowBox[{RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \
\\\",\\\", \\\"1\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"1\\\"}], \\\"}\\\"}], \\\"\[LeftDoubleBracket]\\\", \\\"14\\\", \\\"\
\[RightDoubleBracket]\\\"}], \\\"\[Equal]\\\", \\\"1\\\"}], \\\",\\\", \
RowBox[{\\\"datainfototext\\\", \\\"[\\\", RowBox[{RowBox[{\\\"{\\\", \
\\\"corrdataclassfinal\\\", \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"readcorrconfigfile6\\\", \\\"[\\\", RowBox[{\\\"configDir\\\", \\\
\",\\\", \\\"configfilename\\\"}], \\\"]\\\"}], \\\",\\\", \\\"6\\\", \\\",\\\
\", \\\"flavour\\\"}], \\\"]\\\"}], \\\",\\\", \\\"\\\\\\\"\\\\\\\"\\\"}], \\\
\"]\\\"}], \\\"<>\\\", RowBox[{\\\"If\\\", \\\"[\\\", \
RowBox[{RowBox[{RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \
\\\",\\\", \\\"1\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"1\\\"}], \\\"}\\\"}], \\\"\[LeftDoubleBracket]\\\", \\\"15\\\", \\\"\
\[RightDoubleBracket]\\\"}], \\\"\[Equal]\\\", \\\"1\\\"}], \\\",\\\", \
RowBox[{\\\"datainfototext\\\", \\\"[\\\", RowBox[{RowBox[{\\\"{\\\", \
\\\"corrdataclassfinal\\\", \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"readcorrconfigfile6\\\", \\\"[\\\", RowBox[{\\\"\[LeftSkeleton]\\\
\", \\\"1\\\", \\\"\[RightSkeleton]\\\"}], \\\"]\\\"}], \\\",\\\", \\\"6\\\", \
\\\",\\\", \\\"flavour\\\"}], \\\"]\\\"}], \\\",\\\", \
\\\"\\\\\\\"\\\\\\\"\\\"}], \\\"]\\\"}], \\\"<>\\\", RowBox[{\\\"If\\\", \
\\\"[\\\", RowBox[{RowBox[{RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \
\\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"1\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \
\\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"1\\\"}], \\\"}\\\"}], \\\"\[LeftDoubleBracket]\\\", \\\"16\\\", \\\"\
\[RightDoubleBracket]\\\"}], \\\"\[Equal]\\\", \\\"1\\\"}], \\\",\\\", \
RowBox[{\\\"datainfototext\\\", \\\"[\\\", RowBox[{RowBox[{\\\"{\\\", \
\\\"corrdataclassfinal\\\", \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"readcorrconfigfile6\\\", \\\"[\\\", RowBox[{\\\"configDir\\\", \\\
\",\\\", \\\"configfilename\\\"}], \\\"]\\\"}], \\\",\\\", \\\"6\\\", \\\",\\\
\", \\\"flavour\\\"}], \\\"]\\\"}], \\\",\\\", \\\"\\\\\\\"\\\\\\\"\\\"}], \\\
\"]\\\"}], \\\"<>\\\", RowBox[{\\\"If\\\", \\\"[\\\", \
RowBox[{RowBox[{RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \
\\\",\\\", \\\"1\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"1\\\"}], \\\"}\\\"}], \\\"\[LeftDoubleBracket]\\\", \\\"17\\\", \\\"\
\[RightDoubleBracket]\\\"}], \\\"\[Equal]\\\", \\\"1\\\"}], \\\",\\\", \
RowBox[{\\\"datainfototext\\\", \\\"[\\\", RowBox[{RowBox[{\\\"{\\\", \
\\\"corrdataclassfinal\\\", \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"readcorrconfigfile6\\\", \\\"[\\\", RowBox[{\\\"configDir\\\", \\\
\",\\\", \\\"configfilename\\\"}], \\\"]\\\"}], \\\",\\\", \\\"6\\\", \\\",\\\
\", \\\"flavour\\\"}], \\\"]\\\"}], \\\",\\\", \\\"\\\\\\\"\\\\\\\"\\\"}], \\\
\"]\\\"}]}]\\).\"",2,292,96,25834786221962601457,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.721281704825515*^9}],

Cell[BoxData[
 TemplateBox[{
  "StringJoin","string",
   "\"String expected at position \\!\\(\\*RowBox[{\\\"3\\\"}]\\) in \
\\!\\(\\*RowBox[{RowBox[{\\\"\[LeftSkeleton]\\\", \\\"10881\\\", \\\"\
\[RightSkeleton]\\\"}], \\\"<>\\\", RowBox[{\\\"If\\\", \\\"[\\\", \
RowBox[{RowBox[{RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \
\\\",\\\", \\\"1\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"1\\\"}], \\\"}\\\"}], \\\"\[LeftDoubleBracket]\\\", \\\"13\\\", \\\"\
\[RightDoubleBracket]\\\"}], \\\"\[Equal]\\\", \\\"1\\\"}], \\\",\\\", \
RowBox[{\\\"datainfototext\\\", \\\"[\\\", RowBox[{RowBox[{\\\"{\\\", \
\\\"corrdataclassfinal\\\", \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"readcorrconfigfile6\\\", \\\"[\\\", RowBox[{\\\"configDir\\\", \\\
\",\\\", \\\"configfilename\\\"}], \\\"]\\\"}], \\\",\\\", \\\"6\\\", \\\",\\\
\", \\\"flavour\\\"}], \\\"]\\\"}], \\\",\\\", \\\"\\\\\\\"\\\\\\\"\\\"}], \\\
\"]\\\"}], \\\"<>\\\", RowBox[{\\\"If\\\", \\\"[\\\", \
RowBox[{RowBox[{RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \
\\\",\\\", \\\"1\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"1\\\"}], \\\"}\\\"}], \\\"\[LeftDoubleBracket]\\\", \\\"14\\\", \\\"\
\[RightDoubleBracket]\\\"}], \\\"\[Equal]\\\", \\\"1\\\"}], \\\",\\\", \
RowBox[{\\\"datainfototext\\\", \\\"[\\\", RowBox[{RowBox[{\\\"{\\\", \
\\\"corrdataclassfinal\\\", \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"readcorrconfigfile6\\\", \\\"[\\\", RowBox[{\\\"configDir\\\", \\\
\",\\\", \\\"configfilename\\\"}], \\\"]\\\"}], \\\",\\\", \\\"6\\\", \\\",\\\
\", \\\"flavour\\\"}], \\\"]\\\"}], \\\",\\\", \\\"\\\\\\\"\\\\\\\"\\\"}], \\\
\"]\\\"}], \\\"<>\\\", RowBox[{\\\"If\\\", \\\"[\\\", \
RowBox[{RowBox[{RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \
\\\",\\\", \\\"1\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"1\\\"}], \\\"}\\\"}], \\\"\[LeftDoubleBracket]\\\", \\\"15\\\", \\\"\
\[RightDoubleBracket]\\\"}], \\\"\[Equal]\\\", \\\"1\\\"}], \\\",\\\", \
RowBox[{\\\"datainfototext\\\", \\\"[\\\", RowBox[{RowBox[{\\\"{\\\", \
\\\"corrdataclassfinal\\\", \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"readcorrconfigfile6\\\", \\\"[\\\", RowBox[{\\\"\[LeftSkeleton]\\\
\", \\\"1\\\", \\\"\[RightSkeleton]\\\"}], \\\"]\\\"}], \\\",\\\", \\\"6\\\", \
\\\",\\\", \\\"flavour\\\"}], \\\"]\\\"}], \\\",\\\", \
\\\"\\\\\\\"\\\\\\\"\\\"}], \\\"]\\\"}], \\\"<>\\\", RowBox[{\\\"If\\\", \
\\\"[\\\", RowBox[{RowBox[{RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \
\\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"1\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \
\\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"1\\\"}], \\\"}\\\"}], \\\"\[LeftDoubleBracket]\\\", \\\"16\\\", \\\"\
\[RightDoubleBracket]\\\"}], \\\"\[Equal]\\\", \\\"1\\\"}], \\\",\\\", \
RowBox[{\\\"datainfototext\\\", \\\"[\\\", RowBox[{RowBox[{\\\"{\\\", \
\\\"corrdataclassfinal\\\", \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"readcorrconfigfile6\\\", \\\"[\\\", RowBox[{\\\"configDir\\\", \\\
\",\\\", \\\"configfilename\\\"}], \\\"]\\\"}], \\\",\\\", \\\"6\\\", \\\",\\\
\", \\\"flavour\\\"}], \\\"]\\\"}], \\\",\\\", \\\"\\\\\\\"\\\\\\\"\\\"}], \\\
\"]\\\"}], \\\"<>\\\", RowBox[{\\\"If\\\", \\\"[\\\", \
RowBox[{RowBox[{RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \
\\\",\\\", \\\"1\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"1\\\"}], \\\"}\\\"}], \\\"\[LeftDoubleBracket]\\\", \\\"17\\\", \\\"\
\[RightDoubleBracket]\\\"}], \\\"\[Equal]\\\", \\\"1\\\"}], \\\",\\\", \
RowBox[{\\\"datainfototext\\\", \\\"[\\\", RowBox[{RowBox[{\\\"{\\\", \
\\\"corrdataclassfinal\\\", \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"readcorrconfigfile6\\\", \\\"[\\\", RowBox[{\\\"configDir\\\", \\\
\",\\\", \\\"configfilename\\\"}], \\\"]\\\"}], \\\",\\\", \\\"6\\\", \\\",\\\
\", \\\"flavour\\\"}], \\\"]\\\"}], \\\",\\\", \\\"\\\\\\\"\\\\\\\"\\\"}], \\\
\"]\\\"}]}]\\).\"",2,292,97,25834786221962601457,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.721281705955482*^9}],

Cell[BoxData[
 TemplateBox[{
  "StringJoin","string",
   "\"String expected at position \\!\\(\\*RowBox[{\\\"4\\\"}]\\) in \
\\!\\(\\*RowBox[{RowBox[{\\\"\[LeftSkeleton]\\\", \\\"10881\\\", \\\"\
\[RightSkeleton]\\\"}], \\\"<>\\\", RowBox[{\\\"If\\\", \\\"[\\\", \
RowBox[{RowBox[{RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \
\\\",\\\", \\\"1\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"1\\\"}], \\\"}\\\"}], \\\"\[LeftDoubleBracket]\\\", \\\"13\\\", \\\"\
\[RightDoubleBracket]\\\"}], \\\"\[Equal]\\\", \\\"1\\\"}], \\\",\\\", \
RowBox[{\\\"datainfototext\\\", \\\"[\\\", RowBox[{RowBox[{\\\"{\\\", \
\\\"corrdataclassfinal\\\", \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"readcorrconfigfile6\\\", \\\"[\\\", RowBox[{\\\"configDir\\\", \\\
\",\\\", \\\"configfilename\\\"}], \\\"]\\\"}], \\\",\\\", \\\"6\\\", \\\",\\\
\", \\\"flavour\\\"}], \\\"]\\\"}], \\\",\\\", \\\"\\\\\\\"\\\\\\\"\\\"}], \\\
\"]\\\"}], \\\"<>\\\", RowBox[{\\\"If\\\", \\\"[\\\", \
RowBox[{RowBox[{RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \
\\\",\\\", \\\"1\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"1\\\"}], \\\"}\\\"}], \\\"\[LeftDoubleBracket]\\\", \\\"14\\\", \\\"\
\[RightDoubleBracket]\\\"}], \\\"\[Equal]\\\", \\\"1\\\"}], \\\",\\\", \
RowBox[{\\\"datainfototext\\\", \\\"[\\\", RowBox[{RowBox[{\\\"{\\\", \
\\\"corrdataclassfinal\\\", \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"readcorrconfigfile6\\\", \\\"[\\\", RowBox[{\\\"configDir\\\", \\\
\",\\\", \\\"configfilename\\\"}], \\\"]\\\"}], \\\",\\\", \\\"6\\\", \\\",\\\
\", \\\"flavour\\\"}], \\\"]\\\"}], \\\",\\\", \\\"\\\\\\\"\\\\\\\"\\\"}], \\\
\"]\\\"}], \\\"<>\\\", RowBox[{\\\"If\\\", \\\"[\\\", \
RowBox[{RowBox[{RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \
\\\",\\\", \\\"1\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"1\\\"}], \\\"}\\\"}], \\\"\[LeftDoubleBracket]\\\", \\\"15\\\", \\\"\
\[RightDoubleBracket]\\\"}], \\\"\[Equal]\\\", \\\"1\\\"}], \\\",\\\", \
RowBox[{\\\"datainfototext\\\", \\\"[\\\", RowBox[{RowBox[{\\\"{\\\", \
\\\"corrdataclassfinal\\\", \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"readcorrconfigfile6\\\", \\\"[\\\", RowBox[{\\\"\[LeftSkeleton]\\\
\", \\\"1\\\", \\\"\[RightSkeleton]\\\"}], \\\"]\\\"}], \\\",\\\", \\\"6\\\", \
\\\",\\\", \\\"flavour\\\"}], \\\"]\\\"}], \\\",\\\", \
\\\"\\\\\\\"\\\\\\\"\\\"}], \\\"]\\\"}], \\\"<>\\\", RowBox[{\\\"If\\\", \
\\\"[\\\", RowBox[{RowBox[{RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \
\\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"1\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \
\\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"1\\\"}], \\\"}\\\"}], \\\"\[LeftDoubleBracket]\\\", \\\"16\\\", \\\"\
\[RightDoubleBracket]\\\"}], \\\"\[Equal]\\\", \\\"1\\\"}], \\\",\\\", \
RowBox[{\\\"datainfototext\\\", \\\"[\\\", RowBox[{RowBox[{\\\"{\\\", \
\\\"corrdataclassfinal\\\", \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"readcorrconfigfile6\\\", \\\"[\\\", RowBox[{\\\"configDir\\\", \\\
\",\\\", \\\"configfilename\\\"}], \\\"]\\\"}], \\\",\\\", \\\"6\\\", \\\",\\\
\", \\\"flavour\\\"}], \\\"]\\\"}], \\\",\\\", \\\"\\\\\\\"\\\\\\\"\\\"}], \\\
\"]\\\"}], \\\"<>\\\", RowBox[{\\\"If\\\", \\\"[\\\", \
RowBox[{RowBox[{RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \
\\\",\\\", \\\"1\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"1\\\"}], \\\"}\\\"}], \\\"\[LeftDoubleBracket]\\\", \\\"17\\\", \\\"\
\[RightDoubleBracket]\\\"}], \\\"\[Equal]\\\", \\\"1\\\"}], \\\",\\\", \
RowBox[{\\\"datainfototext\\\", \\\"[\\\", RowBox[{RowBox[{\\\"{\\\", \
\\\"corrdataclassfinal\\\", \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"readcorrconfigfile6\\\", \\\"[\\\", RowBox[{\\\"configDir\\\", \\\
\",\\\", \\\"configfilename\\\"}], \\\"]\\\"}], \\\",\\\", \\\"6\\\", \\\",\\\
\", \\\"flavour\\\"}], \\\"]\\\"}], \\\",\\\", \\\"\\\\\\\"\\\\\\\"\\\"}], \\\
\"]\\\"}]}]\\).\"",2,292,98,25834786221962601457,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.721281707083671*^9}],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"StringJoin\\\", \
\\\"::\\\", \\\"string\\\"}], \\\"MessageName\\\"]\\) will be suppressed \
during this calculation.\"",2,292,99,25834786221962601457,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7212817079181843`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"saveparentpath", "<>", 
  "jobpath"}], "\[IndentingNewLine]", "PDFxQSelectMethod", "\
\[IndentingNewLine]", "\"\<.pdf\>\""}], "Input",
 CellChangeTimes->{{3.721867533975401*^9, 3.7218675393341637`*^9}}],

Cell[BoxData["\<\"../plots/Jobs/test_running/\"\>"], "Output",
 CellChangeTimes->{{3.721867528328966*^9, 3.7218675398632298`*^9}}],

Cell[BoxData["\<\"samept\"\>"], "Output",
 CellChangeTimes->{{3.721867528328966*^9, 3.721867539882687*^9}}],

Cell[BoxData["\<\".pdf\"\>"], "Output",
 CellChangeTimes->{{3.721867528328966*^9, 3.721867539902794*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[""], "Input",
 CellChangeTimes->{
  3.7218677574520807`*^9, {3.721867886160489*^9, 3.721867941512347*^9}, {
   3.721867974734548*^9, 3.72186804672285*^9}, 3.721868098002903*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"search figures under\"\>", 
   "\[InvisibleSpace]", "\<\"../plots/Jobs/test_running/\"\>", 
   "\[InvisibleSpace]", "\<\", extension = \"\>", 
   "\[InvisibleSpace]", "\<\".pdf\"\>", 
   "\[InvisibleSpace]", "\<\", total #flavour for check = \"\>", 
   "\[InvisibleSpace]", "100"}],
  SequenceForm[
  "search figures under", "../plots/Jobs/test_running/", ", extension = ", 
   ".pdf", ", total #flavour for check = ", 100],
  Editable->False]], "Print",
 CellChangeTimes->{3.7218675479685802`*^9, 3.7218680531610527`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"../plots/Jobs/test_running/corr_xQ-1_f-1_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corr_hist-1_f-1_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corr_legend_f-1_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corrdr_xQ+1_f-1_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corrdr_hist+1_f-1_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corrdr_legend_f-1_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corr_xQ-1_f0_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corr_hist-1_f0_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corr_legend_f0_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corrdr_xQ+1_f0_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corrdr_hist+1_f0_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corrdr_legend_f0_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corr_xQ-1_f1_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corr_hist-1_f1_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corr_legend_f1_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corrdr_xQ+1_f1_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corrdr_hist+1_f1_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corrdr_legend_f1_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corr_xQ-1_f3_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corr_hist-1_f3_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corr_legend_f3_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corrdr_xQ+1_f3_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corrdr_hist+1_f3_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corrdr_legend_f3_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corr_xQ-1_f5_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corr_hist-1_f5_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corr_legend_f5_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corrdr_xQ+1_f5_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corrdr_hist+1_f5_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/corrdr_legend_f5_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/expt_error_ratio_xQ+1_samept.pdf\"\>",
    ",", "\<\"../plots/Jobs/test_running/expt_error_ratio_hist+1_samept.pdf\"\
\>", ",", \
"\<\"../plots/Jobs/test_running/expt_error_ratio_legend_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/residual_xQ-1_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/residual_hist-1_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/residual_legend_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/dr_xQ+1_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/dr_hist+1_samept.pdf\"\>", 
   ",", "\<\"../plots/Jobs/test_running/dr_legend_samept.pdf\"\>"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.7218675480834713`*^9, 3.721868054382715*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"generate merge file: \"\>", 
   "\[InvisibleSpace]", "\<\"../plots/Jobs/test_running/allfigs.pdf\"\>"}],
  SequenceForm[
  "generate merge file: ", "../plots/Jobs/test_running/allfigs.pdf"],
  Editable->False]], "Print",
 CellChangeTimes->{3.7218675479685802`*^9, 3.721868054395049*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["BranchMode"], "Input"],

Cell[BoxData["2"], "Output",
 CellChangeTimes->{3.7218685436622868`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"dRcorrdataclassfinal", "[", 
   RowBox[{"[", 
    RowBox[{"1", ",", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "6"}]}], "]"}], "]"}], "[", 
  RowBox[{"[", "\"\<data\>\"", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.7221892464691896`*^9, 3.722189256675721*^9}}],

Cell[BoxData[
 TemplateBox[{
  "Part","pkspec1",
   "\"The expression \\!\\(\\*RowBox[{\\\"iexpt\\\"}]\\) cannot be used as a \
part specification.\"",2,11,43,25841003483535711501,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7221892573966312`*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","pspec1",
   "\"Part specification \\!\\(\\*RowBox[{\\\"\\\\\\\"data\\\\\\\"\\\"}]\\) \
is not applicable.\"",2,11,44,25841003483535711501,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7221892574775877`*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","pkspec1",
   "\"The expression \\!\\(\\*RowBox[{\\\"ipt\\\"}]\\) cannot be used as a \
part specification.\"",2,11,45,25841003483535711501,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.722189257582171*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","pkspec1",
   "\"The expression \\!\\(\\*RowBox[{\\\"iexpt\\\"}]\\) cannot be used as a \
part specification.\"",2,11,46,25841003483535711501,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.722189257687499*^9}],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"Part\\\", \\\"::\\\", \
\\\"pkspec1\\\"}], \\\"MessageName\\\"]\\) will be suppressed during this \
calculation.\"",2,11,47,25841003483535711501,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7221892577922153`*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","pspec1",
   "\"Part specification \\!\\(\\*RowBox[{\\\"\\\\\\\"data\\\\\\\"\\\"}]\\) \
is not applicable.\"",2,11,48,25841003483535711501,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.72218925789959*^9}],

Cell[BoxData[
 TemplateBox[{
  "Part","pspec1",
   "\"Part specification \\!\\(\\*RowBox[{\\\"\\\\\\\"data\\\\\\\"\\\"}]\\) \
is not applicable.\"",2,11,49,25841003483535711501,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.722189258005246*^9}],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"Part\\\", \\\"::\\\", \
\\\"pspec1\\\"}], \\\"MessageName\\\"]\\) will be suppressed during this \
calculation.\"",2,11,50,25841003483535711501,"New Kernel"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7221892581109953`*^9}],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   FrameBox[GridBox[{
      {
       ItemBox[
        TagBox[
         RowBox[{"{", 
          RowBox[{
           RowBox[{"LF", "[", 
            RowBox[{"0.008`", ",", "17.32`", ",", 
             RowBox[{"0.010738941266064868`", "/", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"\[LeftAssociation]", 
                    RowBox[{
                    RowBox[{"\<\"label\"\>", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"\<\"x\"\>", ",", "\<\"Q\"\>", ",", "\<\"1\"\>"}],
                     "}"}]}], ",", 
                    TemplateBox[{"3"},
                    "OutputSizeLimit`Skeleton",
                    DisplayFunction->(FrameBox[
                    
                    RowBox[{
                    "\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
                    Background -> GrayLevel[0.75], 
                    BaseStyle -> {
                    "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                    ShowStringCharacters -> False}, BaselinePosition -> 
                    Baseline, ContentPadding -> False, 
                    FrameMargins -> {{1, 1}, {1, 2}}, FrameStyle -> None, 
                    RoundingRadius -> 7]& )], ",", 
                    RowBox[{"\<\"rawdata\"\>", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"160", ",", 
                    TemplateBox[{"6"},
                    "OutputSizeLimit`Skeleton",
                    DisplayFunction->(FrameBox[
                    
                    RowBox[{"\" \[CenterEllipsis]\"", #, 
                    "\"\[CenterEllipsis] \""}], Background -> GrayLevel[0.75],
                     BaseStyle -> {
                    "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                    ShowStringCharacters -> False}, BaselinePosition -> 
                    Baseline, ContentPadding -> False, 
                    FrameMargins -> {{1, 1}, {1, 2}}, FrameStyle -> None, 
                    RoundingRadius -> 7]& )], ",", 
                    
                    RowBox[{"\<\"R^2, r(k) =   87.490   0.108   0.441  -1.258 \
 -0.807   0.918  -0.600  -0.115  -0.063  -\"\>", 
                    "\[Ellipsis]", "\<\"  -0.060  -0.976  -0.523  -0.259   \
2.056   1.414   0.408   0.731   0.192  -0.762   0.983\"\>"}]}], "}"}]}]}], 
                    "\[RightAssociation]"}], ",", 
                   TemplateBox[{"47"},
                    "OutputSizeLimit`Skeleton",
                    DisplayFunction->(FrameBox[
                    
                    RowBox[{
                    "\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
                    Background -> GrayLevel[0.75], 
                    BaseStyle -> {
                    "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                    ShowStringCharacters -> False}, BaselinePosition -> 
                    Baseline, ContentPadding -> False, 
                    FrameMargins -> {{1, 1}, {1, 2}}, FrameStyle -> None, 
                    RoundingRadius -> 7]& )], ",", 
                   RowBox[{"\[LeftAssociation]", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton",
                    DisplayFunction->(FrameBox[
                    
                    RowBox[{
                    "\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
                    Background -> GrayLevel[0.75], 
                    BaseStyle -> {
                    "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                    ShowStringCharacters -> False}, BaselinePosition -> 
                    Baseline, ContentPadding -> False, 
                    FrameMargins -> {{1, 1}, {1, 2}}, FrameStyle -> None, 
                    RoundingRadius -> 7]& )], "\[RightAssociation]"}]}], 
                  "}"}], "\[LeftDoubleBracket]", "iexpt", 
                 "\[RightDoubleBracket]"}], 
                "\[LeftDoubleBracket]", "\<\"data\"\>", 
                "\[RightDoubleBracket]"}], "\[LeftDoubleBracket]", 
               RowBox[{"ipt", ",", "3"}], "\[RightDoubleBracket]"}]}]}], 
            "]"}], ",", 
           RowBox[{"LF", "[", 
            RowBox[{"0.013`", ",", "17.32`", ",", 
             FractionBox["0.01064356405080254`", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  TemplateBox[{"1"},
                   "OutputSizeLimit`Skeleton",
                   DisplayFunction->(FrameBox[
                    RowBox[{
                    "\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
                    Background -> GrayLevel[0.75], 
                    BaseStyle -> {
                    "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                    ShowStringCharacters -> False}, BaselinePosition -> 
                    Baseline, ContentPadding -> False, 
                    FrameMargins -> {{1, 1}, {1, 2}}, FrameStyle -> None, 
                    RoundingRadius -> 7]& )], "}"}], "\[LeftDoubleBracket]", 
                 "iexpt", "\[RightDoubleBracket]"}], 
                "\[LeftDoubleBracket]", "\<\"data\"\>", 
                "\[RightDoubleBracket]"}], "\[LeftDoubleBracket]", 
               RowBox[{"ipt", ",", "3"}], "\[RightDoubleBracket]"}]]}], "]"}],
            ",", 
           TemplateBox[{"1116"},
            "OutputSizeLimit`Skeleton",
            DisplayFunction->(FrameBox[
              RowBox[{"\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}],
               Background -> GrayLevel[0.75], 
              BaseStyle -> {
               "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                ShowStringCharacters -> False}, BaselinePosition -> Baseline, 
              ContentPadding -> False, FrameMargins -> {{1, 1}, {1, 2}}, 
              FrameStyle -> None, RoundingRadius -> 7]& )], ",", 
           RowBox[{"LF", "[", 
            RowBox[{"0.4`", ",", "173.2`", ",", 
             FractionBox["0.05666693594924495`", 
              TemplateBox[{"1"},
               "OutputSizeLimit`Skeleton",
               DisplayFunction->(FrameBox[
                 
                 RowBox[{
                  "\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
                 Background -> GrayLevel[0.75], 
                 BaseStyle -> {
                  "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                   ShowStringCharacters -> False}, BaselinePosition -> 
                 Baseline, ContentPadding -> False, 
                 FrameMargins -> {{1, 1}, {1, 2}}, FrameStyle -> None, 
                 RoundingRadius -> 7]& )]]}], "]"}], ",", 
           RowBox[{"LF", "[", 
            RowBox[{"0.65`", ",", "173.2`", ",", 
             FractionBox["0.010237250530716448`", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"\[LeftAssociation]", 
                    RowBox[{
                    RowBox[{"\<\"label\"\>", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"\<\"x\"\>", ",", "\<\"Q\"\>", ",", "\<\"1\"\>"}],
                     "}"}]}], ",", 
                    TemplateBox[{"3"},
                    "OutputSizeLimit`Skeleton",
                    DisplayFunction->(FrameBox[
                    
                    RowBox[{
                    "\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
                    Background -> GrayLevel[0.75], 
                    BaseStyle -> {
                    "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                    ShowStringCharacters -> False}, BaselinePosition -> 
                    Baseline, ContentPadding -> False, 
                    FrameMargins -> {{1, 1}, {1, 2}}, FrameStyle -> None, 
                    RoundingRadius -> 7]& )], ",", 
                    RowBox[{"\<\"rawdata\"\>", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"160", ",", 
                    TemplateBox[{"6"},
                    "OutputSizeLimit`Skeleton",
                    DisplayFunction->(FrameBox[
                    
                    RowBox[{"\" \[CenterEllipsis]\"", #, 
                    "\"\[CenterEllipsis] \""}], Background -> GrayLevel[0.75],
                     BaseStyle -> {
                    "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                    ShowStringCharacters -> False}, BaselinePosition -> 
                    Baseline, ContentPadding -> False, 
                    FrameMargins -> {{1, 1}, {1, 2}}, FrameStyle -> None, 
                    RoundingRadius -> 7]& )], ",", 
                    
                    RowBox[{"\<\"R^2, \"\>", 
                    "\[Ellipsis]", "\<\" 0.983\"\>"}]}], "}"}]}]}], 
                    "\[RightAssociation]"}], ",", 
                   TemplateBox[{"47"},
                    "OutputSizeLimit`Skeleton",
                    DisplayFunction->(FrameBox[
                    
                    RowBox[{
                    "\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
                    Background -> GrayLevel[0.75], 
                    BaseStyle -> {
                    "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                    ShowStringCharacters -> False}, BaselinePosition -> 
                    Baseline, ContentPadding -> False, 
                    FrameMargins -> {{1, 1}, {1, 2}}, FrameStyle -> None, 
                    RoundingRadius -> 7]& )], ",", 
                   RowBox[{"\[LeftAssociation]", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton",
                    DisplayFunction->(FrameBox[
                    
                    RowBox[{
                    "\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
                    Background -> GrayLevel[0.75], 
                    BaseStyle -> {
                    "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                    ShowStringCharacters -> False}, BaselinePosition -> 
                    Baseline, ContentPadding -> False, 
                    FrameMargins -> {{1, 1}, {1, 2}}, FrameStyle -> None, 
                    RoundingRadius -> 7]& )], "\[RightAssociation]"}]}], 
                  "}"}], "\[LeftDoubleBracket]", "iexpt", 
                 "\[RightDoubleBracket]"}], 
                "\[LeftDoubleBracket]", "\<\"data\"\>", 
                "\[RightDoubleBracket]"}], "\[LeftDoubleBracket]", 
               RowBox[{"ipt", ",", "3"}], "\[RightDoubleBracket]"}]]}], 
            "]"}]}], "}"}],
         Short[#, 5]& ],
        BaseStyle->{Deployed -> False},
        StripOnInput->False]},
      {GridBox[{
         {
          TagBox[
           TooltipBox[
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource[
                "FEStrings", "sizeBriefExplanation"], StandardForm],
               ImageSizeCache->{74., {2., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarCategory",
             StripOnInput->False],
            StyleBox[
             DynamicBox[
              ToBoxes[
               FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
               StandardForm]], DynamicUpdating -> True, StripOnInput -> 
             False]],
           Annotation[#, 
            Style[
             Dynamic[
              FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"]], 
             DynamicUpdating -> True], "Tooltip"]& ], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{67., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 11, 25841003483535711501, 5/2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{73., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 11, 25841003483535711501, 5 2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{56., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 11, 25841003483535711501, Infinity],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{100., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{100., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           ButtonFunction:>FrontEndExecute[{
              FrontEnd`SetOptions[
              FrontEnd`$FrontEnd, 
               FrontEnd`PreferencesSettings -> {"Page" -> "Evaluation"}], 
              FrontEnd`FrontEndToken["PreferencesDialog"]}],
           Evaluator->None,
           Method->"Preemptive"]}
        },
        AutoDelete->False,
        FrameStyle->GrayLevel[0.85],
        GridBoxDividers->{"Columns" -> {False, {True}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
        GridBoxSpacings->{"Columns" -> {{2}}}]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], 
         Offset[1.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Background->RGBColor[0.9657, 0.9753, 0.9802],
    FrameMargins->{{12, 12}, {0, 15}},
    FrameStyle->GrayLevel[0.85],
    RoundingRadius->5,
    StripOnInput->False],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  Out[11]]], "Output",
 CellChangeTimes->{3.7221893355995092`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"20171213", " ", "redefine", " ", "sensitivity", " ", "as", " ", 
    RowBox[{"(", 
     RowBox[{"\[Delta]r", "/", "r"}], ")"}], "*", "Corr", 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["r", "i"], ",", 
      RowBox[{"f", 
       SubscriptBox[
        RowBox[{"(", 
         RowBox[{"x", ",", "Q"}], ")"}], "i"]}]}], ")"}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"testupdatesens", "=", "\[IndentingNewLine]", 
   RowBox[{"Table", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Npt", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"dRcorrdataclassfinal", "[", 
          RowBox[{"[", 
           RowBox[{"iexpt", ",", 
            RowBox[{"flavour", "+", "6"}]}], "]"}], "]"}], "[", 
         RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "//", "Length"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tmpdata", "=", 
       RowBox[{"dRcorrdataclassfinal", "[", 
        RowBox[{"[", 
         RowBox[{"iexpt", ",", 
          RowBox[{"flavour", "+", "6"}]}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"tmpdata", "[", 
            RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"ipt", ",", "3"}], "]"}], "]"}], "=", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"dRcorrdataclassfinal", "[", 
               RowBox[{"[", 
                RowBox[{"iexpt", ",", 
                 RowBox[{"flavour", "+", "6"}]}], "]"}], "]"}], "[", 
              RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"ipt", ",", "3"}], "]"}], "]"}], "/", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{"prevent", " ", "the", " ", 
               RowBox[{"dr", "/", "r"}], " ", "blow", " ", "up", " ", "when", 
               " ", "r"}], " ", "=", " ", "0"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"residualdataclassfinal", "[", 
                  RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                 RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{"ipt", ",", "3"}], "]"}], "]"}], "\[NotEqual]", 
               "0.0"}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"residualdataclassfinal", "[", 
                 RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
                RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
               RowBox[{"[", 
                RowBox[{"ipt", ",", "3"}], "]"}], "]"}], ",", 
              SuperscriptBox["10.0", 
               RowBox[{"-", "8"}]]}], "]"}]}], ")"}]}], ";", 
         "\[IndentingNewLine]", "\"\<dummy\>\""}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"ipt", ",", "Npt"}], "}"}]}], "\[IndentingNewLine]", "]"}], 
      ";", "\[IndentingNewLine]", "tmpdata"}], " ", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"iexpt", ",", "1", ",", 
       RowBox[{"Length", "[", "residualNsetclassfinal", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"flavour", ",", 
       RowBox[{"-", "5"}], ",", 
       RowBox[{
        RowBox[{"-", "5"}], "+", "fmax", "-", "1"}]}], "}"}]}], 
    "\[IndentingNewLine]", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.72218964933517*^9, 3.722189677271216*^9}, 
   3.722189824031975*^9, {3.722190054950604*^9, 3.722190097335478*^9}, {
   3.722190227255642*^9, 3.722190242105249*^9}}],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   FrameBox[GridBox[{
      {
       ItemBox[
        TagBox[
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"\[LeftAssociation]", 
              RowBox[{
               RowBox[{"\<\"label\"\>", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"\<\"x\"\>", ",", "\<\"Q\"\>", ",", "\<\"corr\"\>"}],
                  "}"}]}], ",", 
               RowBox[{"\<\"data\"\>", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"LF", "[", 
                   RowBox[{
                   "0.008`", ",", "17.32`", ",", "0.0231501231327136`"}], 
                   "]"}], ",", 
                  RowBox[{"LF", "[", 
                   RowBox[{
                   "0.013`", ",", "17.32`", ",", "0.016749263350567662`"}], 
                   "]"}], ",", 
                  RowBox[{"LF", "[", 
                   RowBox[{
                   "0.032`", ",", "17.32`", ",", "0.02414631745079801`"}], 
                   "]"}], ",", 
                  RowBox[{"LF", "[", 
                   RowBox[{"0.08`", ",", "17.32`", ",", 
                    RowBox[{"-", "0.057628167614570035`"}]}], "]"}], ",", 
                  RowBox[{"LF", "[", 
                   RowBox[{"0.13`", ",", "17.32`", ",", 
                    RowBox[{"-", "0.012807291103245043`"}]}], "]"}], ",", 
                  TemplateBox[{"1110"},
                   "OutputSizeLimit`Skeleton",
                   DisplayFunction->(FrameBox[
                    
                    RowBox[{
                    "\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
                    Background -> GrayLevel[0.75], 
                    BaseStyle -> {
                    "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                    ShowStringCharacters -> False}, BaselinePosition -> 
                    Baseline, ContentPadding -> False, 
                    FrameMargins -> {{1, 1}, {1, 2}}, FrameStyle -> None, 
                    RoundingRadius -> 7]& )], ",", 
                  RowBox[{"LF", "[", 
                   RowBox[{"0.25`", ",", "141.4`", ",", 
                    RowBox[{"-", "0.6033864376559059`"}]}], "]"}], ",", 
                  RowBox[{"LF", "[", 
                   RowBox[{
                   "0.4`", ",", "141.4`", ",", "0.6571187930143879`"}], "]"}],
                   ",", 
                  RowBox[{"LF", "[", 
                   RowBox[{"0.65`", ",", "141.4`", ",", 
                    RowBox[{"-", "0.02203149242601528`"}]}], "]"}], ",", 
                  RowBox[{"LF", "[", 
                   RowBox[{"0.4`", ",", "173.2`", ",", 
                    RowBox[{"-", "0.17168200809585513`"}]}], "]"}], ",", 
                  RowBox[{"LF", "[", 
                   RowBox[{
                   "0.65`", ",", "173.2`", ",", "0.049247655264777056`"}], 
                   "]"}]}], "}"}]}], ",", 
               RowBox[{"\<\"exptinfo\"\>", "\[Rule]", 
                RowBox[{"\[LeftAssociation]", 
                 TemplateBox[{"1"},
                  "OutputSizeLimit`Skeleton",
                  DisplayFunction->(FrameBox[
                    
                    RowBox[{
                    "\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
                    Background -> GrayLevel[0.75], 
                    BaseStyle -> {
                    "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                    ShowStringCharacters -> False}, BaselinePosition -> 
                    Baseline, ContentPadding -> False, 
                    FrameMargins -> {{1, 1}, {1, 2}}, FrameStyle -> None, 
                    RoundingRadius -> 7]& )], "\[RightAssociation]"}]}], ",", 
               
               RowBox[{"\<\"PDFinfo\"\>", "\[Rule]", 
                RowBox[{"\[LeftAssociation]", 
                 RowBox[{
                  
                  RowBox[{"\<\"PDFname\"\>", 
                   "\[Rule]", "\<\"2017.1014.1041.-0500_CT14HERA2.ev02\"\>"}],
                   ",", 
                  
                  RowBox[{"\<\"PDFsetmethod\"\>", 
                   "\[Rule]", "\<\"Hessian\"\>"}], ",", 
                  RowBox[{"\<\"Nset\"\>", "\[Rule]", "\<\"unset\"\>"}], ",", 
                  RowBox[{"\<\"iset\"\>", "\[Rule]", "\<\"unset\"\>"}], ",", 
                  RowBox[{"\<\"flavour\"\>", "\[Rule]", "\<\"unset\"\>"}]}], 
                 "\[RightAssociation]"}]}]}], "\[RightAssociation]"}], ",", 
             TemplateBox[{"19"},
              "OutputSizeLimit`Skeleton",
              DisplayFunction->(FrameBox[
                
                RowBox[{
                 "\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
                Background -> GrayLevel[0.75], 
                BaseStyle -> {
                 "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                  ShowStringCharacters -> False}, BaselinePosition -> 
                Baseline, ContentPadding -> False, 
                FrameMargins -> {{1, 1}, {1, 2}}, FrameStyle -> None, 
                RoundingRadius -> 7]& )], ",", 
             RowBox[{"\[LeftAssociation]", 
              TemplateBox[{"1"},
               "OutputSizeLimit`Skeleton",
               DisplayFunction->(FrameBox[
                 
                 RowBox[{
                  "\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
                 Background -> GrayLevel[0.75], 
                 BaseStyle -> {
                  "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                   ShowStringCharacters -> False}, BaselinePosition -> 
                 Baseline, ContentPadding -> False, 
                 FrameMargins -> {{1, 1}, {1, 2}}, FrameStyle -> None, 
                 RoundingRadius -> 7]& )], "\[RightAssociation]"}]}], "}"}], 
           ",", 
           TemplateBox[{"47"},
            "OutputSizeLimit`Skeleton",
            DisplayFunction->(FrameBox[
              RowBox[{"\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}],
               Background -> GrayLevel[0.75], 
              BaseStyle -> {
               "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                ShowStringCharacters -> False}, BaselinePosition -> Baseline, 
              ContentPadding -> False, FrameMargins -> {{1, 1}, {1, 2}}, 
              FrameStyle -> None, RoundingRadius -> 7]& )], ",", 
           RowBox[{"{", 
            TemplateBox[{"1"},
             "OutputSizeLimit`Skeleton",
             DisplayFunction->(FrameBox[
               
               RowBox[{
                "\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
               Background -> GrayLevel[0.75], 
               BaseStyle -> {
                "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                 ShowStringCharacters -> False}, BaselinePosition -> Baseline,
                ContentPadding -> False, FrameMargins -> {{1, 1}, {1, 2}}, 
               FrameStyle -> None, RoundingRadius -> 7]& )], "}"}]}], "}"}],
         Short[#, 5]& ],
        BaseStyle->{Deployed -> False},
        StripOnInput->False]},
      {GridBox[{
         {
          TagBox[
           TooltipBox[
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource[
                "FEStrings", "sizeBriefExplanation"], StandardForm],
               ImageSizeCache->{74., {2., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarCategory",
             StripOnInput->False],
            StyleBox[
             DynamicBox[
              ToBoxes[
               FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
               StandardForm]], DynamicUpdating -> True, StripOnInput -> 
             False]],
           Annotation[#, 
            Style[
             Dynamic[
              FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"]], 
             DynamicUpdating -> True], "Tooltip"]& ], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{67., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 41, 25841003483535711501, 5/2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{73., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 41, 25841003483535711501, 5 2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{56., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 41, 25841003483535711501, Infinity],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{100., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           ButtonFunction:>FrontEndExecute[{
              FrontEnd`SetOptions[
              FrontEnd`$FrontEnd, 
               FrontEnd`PreferencesSettings -> {"Page" -> "Evaluation"}], 
              FrontEnd`FrontEndToken["PreferencesDialog"]}],
           Evaluator->None,
           Method->"Preemptive"]}
        },
        AutoDelete->False,
        FrameStyle->GrayLevel[0.85],
        GridBoxDividers->{"Columns" -> {False, {True}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
        GridBoxSpacings->{"Columns" -> {{2}}}]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], 
         Offset[1.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Background->RGBColor[0.9657, 0.9753, 0.9802],
    FrameMargins->{{12, 12}, {0, 15}},
    FrameStyle->GrayLevel[0.85],
    RoundingRadius->5,
    StripOnInput->False],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  Out[41]]], "Output",
 CellChangeTimes->{3.72218982611684*^9, 3.722190103150077*^9, 
  3.722190153352333*^9, 3.7221902456870003`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"dRcorrdataclassfinal", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", 
      RowBox[{"0", "+", "6"}]}], "]"}], "]"}], "[", 
   RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
  RowBox[{"[", 
   RowBox[{"5", ",", "3"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.72218999129046*^9, 3.722190017542715*^9}}],

Cell[BoxData[
 RowBox[{"-", "0.0035379423819029694`"}]], "Output",
 CellChangeTimes->{{3.722189997628085*^9, 3.722190020251605*^9}}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Table", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"testupdatesens", "[", 
    RowBox[{"[", 
     RowBox[{"iexpt", ",", "6"}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"iexpt", ",", "1", ",", 
     RowBox[{"(*", 
      RowBox[{"Length", "[", "residualNsetclassfinal", "]"}], "*)"}], "1"}], 
    "}"}]}], "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dRcorrdataclassfinal", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "6"}], "]"}], "]"}], "[", 
   RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "/.", 
  RowBox[{
   RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
   RowBox[{
    RowBox[{"{", "a", "}"}], "[", 
    RowBox[{"[", "3", "]"}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.72218970589251*^9, 3.722189800376478*^9}, {
  3.7221898807129927`*^9, 3.722189927882021*^9}}],

Cell[BoxData[
 RowBox[{"testupdatesens", "[", 
  RowBox[{"[", 
   RowBox[{"10", ",", "5"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.7221901095738792`*^9, 3.7221901342765713`*^9}}],

Cell[BoxData[
 RowBox[{"dRcorrdataclassfinal", "[", 
  RowBox[{"[", 
   RowBox[{"2", ",", 
    RowBox[{"1", "+", "6"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.722190182306629*^9, 3.7221901859442797`*^9}, 
   3.722190257127054*^9, 3.722190628443693*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"dtacentralclassfinal", "[", 
   RowBox[{"[", "3", "]"}], "]"}], "[", 
  RowBox[{"[", "1", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dtacentralclassfinal", "[", 
    RowBox[{"[", "3", "]"}], "]"}], "[", 
   RowBox[{"[", "2", "]"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dtacentralclassfinal", "[", 
   RowBox[{"[", "3", "]"}], "]"}], "[", 
  RowBox[{"[", "3", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dtacentralclassfinal", "[", 
   RowBox[{"[", "3", "]"}], "]"}], "[", 
  RowBox[{"[", "4", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dtacentralclassfinal", "[", 
   RowBox[{"[", "3", "]"}], "]"}], "[", 
  RowBox[{"[", "5", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"dtacentralclassfinal", "[", 
     RowBox[{"[", "#", "]"}], "]"}], "[", 
    RowBox[{"[", 
     RowBox[{"5", ",", "5"}], "]"}], "]"}], "&"}], "/@", 
  RowBox[{"Range", "[", 
   RowBox[{"1", ",", "49"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.722193065466819*^9, 3.722193066811499*^9}, {
  3.722193333972033*^9, 3.722193432471571*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Q\"\>", ",", "\<\"x\"\>", ",", "\<\"y\"\>", ",", "\<\"Exp\"\>",
    ",", "\<\"Th./Norm\"\>", ",", "\<\"TotErr\"\>", ",", "\<\"EXP/FIT\"\>", 
   ",", "\<\"ERR/FIT\"\>", ",", "\<\"ChiSq\"\>", ",", "\<\"Shift\"\>", 
   ",", "\<\"ShiftedData\"\>", ",", "\<\"UnCorErr\"\>", 
   ",", "\<\"ReducedChi2\"\>", ",", "\<\"lob/lio\"\>", ",", "\<\"x\"\>", 
   ",", "\<\"Q\"\>", ",", "\<\"residual\"\>"}], "}"}]], "Output",
 CellChangeTimes->{
  3.722193067527564*^9, {3.7221933356911716`*^9, 3.722193433293324*^9}}],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"exptid\"\>", "\[Rule]", "102"}], ",", 
   RowBox[{"\<\"exptname\"\>", "\[Rule]", "\<\"BcdF2dCor\"\>"}], ",", 
   RowBox[{"\<\"feyndiagram\"\>", "\[Rule]", "\<\"unset\"\>"}]}], 
  "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{
  3.722193067527564*^9, {3.7221933356911716`*^9, 3.7221934333044558`*^9}}],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"PDFname\"\>", 
    "\[Rule]", "\<\"2017.1014.1041.-0500_CT14HERA2.ev02\"\>"}], ",", 
   RowBox[{"\<\"PDFsetmethod\"\>", "\[Rule]", "\<\"Hessian\"\>"}], ",", 
   RowBox[{"\<\"Nset\"\>", "\[Rule]", "\<\"unset\"\>"}], ",", 
   RowBox[{"\<\"iset\"\>", "\[Rule]", "\<\"unset\"\>"}], ",", 
   RowBox[{"\<\"flavour\"\>", "\[Rule]", "\<\"unset\"\>"}]}], 
  "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{
  3.722193067527564*^9, {3.7221933356911716`*^9, 3.722193433314151*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "102", ",", "\<\"BcdF2dCor\"\>", 
   ",", "\<\"     Q          x         y          Exp      Th./Norm     \
TotErr     EXP/FIT  ERR/FIT    ChiSq  Shift    ShiftedData  UnCorErr  \
ReducedChi2  lob/lio\"\>", ",", "0.9694`", ",", "250", 
   ",", "\<\"R^2, r(k) =   11.468  -0.030  -3.115   1.158   0.150  \
-0.635\"\>", ",", "1.4856`", 
   ",", "\<\"R^2, r(k) =   11.468  -0.030  -3.115   1.158   0.150  \
-0.635\"\>"}], "}"}]], "Output",
 CellChangeTimes->{
  3.722193067527564*^9, {3.7221933356911716`*^9, 3.72219343332401*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1120", ",", "337", ",", "250", ",", "123", ",", "85", ",", "96", ",", "69",
    ",", "86", ",", "38", ",", "33", ",", "40", ",", "38", ",", "47", ",", 
   "119", ",", "15", ",", "184", ",", "11", ",", "11", ",", "9", ",", "28", 
   ",", "72", ",", "110", ",", "10", ",", "9", ",", "11", ",", "41", ",", 
   "90", ",", "14", ",", "5", ",", "13", ",", "11", ",", "133", ",", "33", 
   ",", "17", ",", "8", ",", "46", ",", "66", ",", "60", ",", "33", ",", "42",
    ",", "8", ",", "5", ",", "7", ",", "5", ",", "185", ",", "48", ",", "45", 
   ",", "20", ",", "9"}], "}"}]], "Output",
 CellChangeTimes->{
  3.722193067527564*^9, {3.7221933356911716`*^9, 3.7221934333339252`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"dtacentralclassfinal", "[", 
    RowBox[{"[", "3", "]"}], "]"}], "[", 
   RowBox[{"[", "2", "]"}], "]"}], "//", "Length"}]], "Input",
 CellChangeTimes->{{3.7221934867138357`*^9, 3.722193488034737*^9}}],

Cell[BoxData["250"], "Output",
 CellChangeTimes->{3.7221934885641603`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Position", "[", 
   RowBox[{
    RowBox[{"dtacentralclassfinal", "[", 
     RowBox[{"[", "5", "]"}], "]"}], ",", "\"\<ReducedChi2\>\""}], "]"}], "[", 
  RowBox[{"[", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.722193541738966*^9, 3.722193575778276*^9}, {
  3.722193629577547*^9, 3.722193666871294*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Key", "[", "\<\"label\"\>", "]"}], ",", "13"}], "}"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.72219357661174*^9, 3.722193631676485*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"dtacentralclassfinal", "[", 
   RowBox[{"[", "1", "]"}], "]"}], "[", 
  RowBox[{"[", "\"\<label\>\"", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.72219360628645*^9, 3.722193613415406*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Q\"\>", ",", "\<\"x\"\>", ",", "\<\"y\"\>", ",", "\<\"Exp\"\>",
    ",", "\<\"Th./Norm\"\>", ",", "\<\"TotErr\"\>", ",", "\<\"EXP/FIT\"\>", 
   ",", "\<\"ERR/FIT\"\>", ",", "\<\"ChiSq\"\>", ",", "\<\"Shift\"\>", 
   ",", "\<\"ShiftedData\"\>", ",", "\<\"UnCorErr\"\>", 
   ",", "\<\"ReducedChi2\"\>", ",", "\<\"lob/lio\"\>", ",", "\<\"x\"\>", 
   ",", "\<\"Q\"\>", ",", "\<\"residual\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.7221936140262613`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Position", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"dtacentralclassfinal", "[", 
       RowBox[{"[", "1", "]"}], "]"}], "[", 
      RowBox[{"[", "\"\<label\>\"", "]"}], "]"}], ",", 
     "\"\<ReducedChi2\>\""}], "]"}], "[", 
   RowBox[{"[", 
    RowBox[{"1", ",", "1"}], "]"}], "]"}], "//", "Head"}]], "Input",
 CellChangeTimes->{{3.7221936837732267`*^9, 3.7221937275900908`*^9}}],

Cell[BoxData["Integer"], "Output",
 CellChangeTimes->{
  3.722193686613963*^9, {3.722193717077776*^9, 3.722193728097097*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"dtacentralclassfinal", "[", 
   RowBox[{"[", "1", "]"}], "]"}], "[", 
  RowBox[{"[", "\"\<data\>\"", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.7221937434149723`*^9, 3.7221937474723*^9}}],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   FrameBox[GridBox[{
      {
       ItemBox[
        TagBox[
         RowBox[{"{", 
          RowBox[{
           RowBox[{"LF", "[", 
            RowBox[{
            "17.32`", ",", "0.008`", ",", "0.3705`", ",", "1.93442`", ",", 
             "1.30153`", ",", "0.7883`", ",", "1.486`", ",", "0.606`", ",", 
             RowBox[{"-", "0.644`"}], ",", 
             RowBox[{"-", "0.02306`"}], ",", "1.957`", ",", "0.7708`", ",", 
             RowBox[{"-", "0.72`"}], ",", "21", ",", "0.008`", ",", "17.32`", 
             ",", 
             RowBox[{"-", "0.850376232485729`"}]}], "]"}], ",", 
           RowBox[{"LF", "[", 
            RowBox[{
            "17.32`", ",", "0.013`", ",", "0.228`", ",", "1.18842`", ",", 
             "1.26829`", ",", "0.106`", ",", "0.937`", ",", "0.084`", ",", 
             "0.568`", ",", 
             RowBox[{"-", "0.03271`"}], ",", "1.221`", ",", "0.102`", ",", 
             "0.21`", ",", "21", ",", "0.013`", ",", "17.32`", ",", 
             "0.46362745098039054`"}], "]"}], ",", 
           TemplateBox[{"1116"},
            "OutputSizeLimit`Skeleton",
            DisplayFunction->(FrameBox[
              RowBox[{"\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}],
               Background -> GrayLevel[0.75], 
              BaseStyle -> {
               "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                ShowStringCharacters -> False}, BaselinePosition -> Baseline, 
              ContentPadding -> False, FrameMargins -> {{1, 1}, {1, 2}}, 
              FrameStyle -> None, RoundingRadius -> 7]& )], ",", 
           RowBox[{"LF", "[", 
            RowBox[{
            "173.2`", ",", "0.4`", ",", "0.7411`", ",", "0.059638`", ",", 
             "0.0506171`", ",", "0.01489`", ",", "1.178`", ",", "0.294`", ",", 
             RowBox[{"-", "0.367`"}], ",", "0.001681`", ",", "0.05796`", ",", 
             "0.01465`", ",", 
             RowBox[{"-", "0.25`"}], ",", 
             RowBox[{"-", "22"}], ",", "0.4`", ",", "173.2`", ",", 
             RowBox[{"-", "0.5012218430034129`"}]}], "]"}], ",", 
           RowBox[{"LF", "[", 
            RowBox[{
            "173.2`", ",", "0.65`", ",", "0.4561`", ",", "0.0085041`", ",", 
             "0.0100307`", ",", "0.005932`", ",", "0.848`", ",", "0.591`", 
             ",", "0.066`", ",", "0.00007813`", ",", "0.008426`", ",", 
             "0.00593`", ",", "0.07`", ",", 
             RowBox[{"-", "22"}], ",", "0.65`", ",", "173.2`", ",", 
             "0.2706070826306915`"}], "]"}]}], "}"}],
         Short[#, 5]& ],
        BaseStyle->{Deployed -> False},
        StripOnInput->False]},
      {GridBox[{
         {
          TagBox[
           TooltipBox[
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource[
                "FEStrings", "sizeBriefExplanation"], StandardForm],
               ImageSizeCache->{74., {2., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarCategory",
             StripOnInput->False],
            StyleBox[
             DynamicBox[
              ToBoxes[
               FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
               StandardForm]], DynamicUpdating -> True, StripOnInput -> 
             False]],
           Annotation[#, 
            Style[
             Dynamic[
              FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"]], 
             DynamicUpdating -> True], "Tooltip"]& ], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{67., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 104, 25841003483535711501, 5/2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{73., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 104, 25841003483535711501, 5 2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{56., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{56., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 104, 25841003483535711501, Infinity],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{100., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{100., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           ButtonFunction:>FrontEndExecute[{
              FrontEnd`SetOptions[
              FrontEnd`$FrontEnd, 
               FrontEnd`PreferencesSettings -> {"Page" -> "Evaluation"}], 
              FrontEnd`FrontEndToken["PreferencesDialog"]}],
           Evaluator->None,
           Method->"Preemptive"]}
        },
        AutoDelete->False,
        FrameStyle->GrayLevel[0.85],
        GridBoxDividers->{"Columns" -> {False, {True}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
        GridBoxSpacings->{"Columns" -> {{2}}}]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], 
         Offset[1.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Background->RGBColor[0.9657, 0.9753, 0.9802],
    FrameMargins->{{12, 12}, {0, 15}},
    FrameStyle->GrayLevel[0.85],
    RoundingRadius->5,
    StripOnInput->False],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  Out[104]]], "Output",
 CellChangeTimes->{3.722193748072896*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["NormalizeIDs"], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1.0834592417675093`", ",", "1.0446415482794527`", ",", 
   "1.0439348638684314`", ",", "1.01436832039989`", ",", "0.954678880412614`",
    ",", "0.8783863045380432`", ",", "1.0033277962194942`", ",", 
   "0.578992709919162`", ",", "0.7430378611873655`", ",", 
   "0.9856546816787062`", ",", "0.8555699854482975`", ",", 
   "0.7251134212550548`", ",", "0.9865046828888864`", ",", 
   "0.9032155442239307`", ",", "1.042113237609042`", ",", 
   "1.1341296222213757`", ",", "0.9050364131298304`", ",", 
   "1.1497035190944584`", ",", "0.9351173426070358`", ",", 
   "0.7365459931328119`", ",", "1.1807782552772534`", ",", 
   "1.0088246987099754`", ",", "0.7739509028355739`", ",", 
   "1.3515423288475528`", ",", "0.9899494936611666`", ",", 
   "0.9384730722386623`", ",", "0.6725077446889863`", ",", 
   "0.8370867850553404`", ",", "1.13754120804479`", ",", 
   "1.3094332303005696`", ",", "1.0036297759994606`", ",", 
   "0.8537674852785851`", ",", "1.403998618664606`", ",", 
   "1.722515260753707`", ",", "4.788136380680902`", ",", "7.800418048997787`",
    ",", "1.36698074735395`", ",", "1.2102668146784266`", ",", 
   "7.682033348250733`", ",", "1.9539337611232226`", ",", 
   "0.5099019513592785`", ",", "1.2288205727444508`", ",", 
   "0.4174754056057845`", ",", "1.3274034804836092`", ",", 
   "0.9444648690601937`", ",", "1.1251477444355964`", ",", 
   "1.2906501376352066`", ",", "1.0249390225764652`", ",", 
   "1.5832456116050555`"}], "}"}]], "Output",
 CellChangeTimes->{3.722195733188231*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"Table", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"residualNsetclassfinal", "[", 
        RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"\"\<exptinfo\>\"", ",", "\"\<exptid\>\""}], "]"}], "]"}], 
      ",", 
      RowBox[{"NormalizeIDs", "[", 
       RowBox[{"[", "iexpt", "]"}], "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"iexpt", ",", "1", ",", 
      RowBox[{"Length", "[", "residualNsetclassfinal", "]"}]}], "}"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 CellChangeTimes->{{3.722195723728026*^9, 3.722195744499476*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"160", ",", "1.0834592417675093`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"101", ",", "1.0446415482794527`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"102", ",", "1.0439348638684314`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"104", ",", "1.01436832039989`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"108", ",", "0.954678880412614`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"109", ",", "0.8783863045380432`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"110", ",", "1.0033277962194942`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"111", ",", "0.578992709919162`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"124", ",", "0.7430378611873655`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"125", ",", "0.9856546816787062`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"126", ",", "0.8555699854482975`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"127", ",", "0.7251134212550548`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"147", ",", "0.9865046828888864`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"201", ",", "0.9032155442239307`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"203", ",", "1.042113237609042`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"204", ",", "1.1341296222213757`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"225", ",", "0.9050364131298304`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"227", ",", "1.1497035190944584`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"234", ",", "0.9351173426070358`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"260", ",", "0.7365459931328119`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"504", ",", "1.1807782552772534`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"514", ",", "1.0088246987099754`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"145", ",", "0.7739509028355739`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"169", ",", "1.3515423288475528`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"267", ",", "0.9899494936611666`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"268", ",", "0.9384730722386623`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"535", ",", "0.6725077446889863`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"240", ",", "0.8370867850553404`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"241", ",", "1.13754120804479`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"281", ",", "1.3094332303005696`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"266", ",", "1.0036297759994606`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"538", ",", "0.8537674852785851`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"245", ",", "1.403998618664606`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"246", ",", "1.722515260753707`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"247", ",", "4.788136380680902`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"248", ",", "7.800418048997787`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"542", ",", "1.36698074735395`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"544", ",", "1.2102668146784266`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"249", ",", "7.682033348250733`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"250", ",", "1.9539337611232226`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"565", ",", "0.5099019513592785`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"566", ",", "1.2288205727444508`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"567", ",", "0.4174754056057845`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"568", ",", "1.3274034804836092`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"545", ",", "0.9444648690601937`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"252", ",", "1.1251477444355964`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"253", ",", "1.2906501376352066`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"254", ",", "1.0249390225764652`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"255", ",", "1.5832456116050555`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.722195724501585*^9, 3.722195745270109*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"fxQsamept2classfinal", "[", 
     RowBox[{"[", 
      RowBox[{"#", ",", "1"}], "]"}], "]"}], "[", 
    RowBox[{"[", 
     RowBox[{"\"\<exptinfo\>\"", ",", "\"\<exptid\>\""}], "]"}], "]"}], "&"}],
   "/@", 
  RowBox[{"Range", "[", "49", "]"}]}]], "Input",
 CellChangeTimes->{{3.722485471630673*^9, 3.722485503094816*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "160", ",", "101", ",", "102", ",", "104", ",", "108", ",", "109", ",", 
   "110", ",", "111", ",", "124", ",", "125", ",", "126", ",", "127", ",", 
   "147", ",", "201", ",", "203", ",", "204", ",", "225", ",", "227", ",", 
   "234", ",", "260", ",", "504", ",", "514", ",", "145", ",", "169", ",", 
   "267", ",", "268", ",", "535", ",", "240", ",", "241", ",", "281", ",", 
   "266", ",", "538", ",", "245", ",", "246", ",", "247", ",", "248", ",", 
   "542", ",", "544", ",", "249", ",", "250", ",", "565", ",", "566", ",", 
   "567", ",", "568", ",", "545", ",", "252", ",", "253", ",", "254", ",", 
   "255"}], "}"}]], "Output",
 CellChangeTimes->{3.7224855039252863`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"fxQsamept2classfinal", "[", 
   RowBox[{"[", 
    RowBox[{"21", ",", "5"}], "]"}], "]"}], "[", 
  RowBox[{"[", "\"\<data\>\"", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.722485553830308*^9, 3.7224855690908613`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"LF", "[", 
    RowBox[{
    "0.07723`", ",", "144.`", ",", "1.53`", ",", "1.554`", ",", "1.517`", ",",
      "1.529`", ",", "1.533`", ",", "1.54`", ",", "1.514`", ",", "1.495`", 
     ",", "1.54`", ",", "1.53`", ",", "1.524`", ",", "1.518`", ",", "1.539`", 
     ",", "1.524`", ",", "1.529`", ",", "1.465`", ",", "1.59`", ",", "1.493`",
      ",", "1.56`", ",", "1.547`", ",", "1.514`", ",", "1.548`", ",", 
     "1.514`", ",", "1.541`", ",", "1.513`", ",", "1.515`", ",", "1.542`", 
     ",", "1.537`", ",", "1.523`", ",", "1.518`", ",", "1.536`", ",", 
     "1.562`", ",", "1.489`", ",", "1.549`", ",", "1.512`", ",", "1.56`", ",",
      "1.494`", ",", "1.516`", ",", "1.54`", ",", "1.542`", ",", "1.513`", 
     ",", "1.519`", ",", "1.522`", ",", "1.555`", ",", "1.486`", ",", 
     "1.436`", ",", "1.601`", ",", "1.517`", ",", "1.529`", ",", "1.507`", 
     ",", "1.513`", ",", "1.531`", ",", "1.535`", ",", "1.509`", ",", 
     "1.513`", ",", "1.525`", ",", "1.534`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.08903`", ",", "166.`", ",", "1.113`", ",", "1.127`", ",", "1.108`", 
     ",", "1.112`", ",", "1.116`", ",", "1.119`", ",", "1.101`", ",", 
     "1.086`", ",", "1.121`", ",", "1.114`", ",", "1.106`", ",", "1.104`", 
     ",", "1.117`", ",", "1.107`", ",", "1.113`", ",", "1.063`", ",", 
     "1.158`", ",", "1.087`", ",", "1.133`", ",", "1.129`", ",", "1.097`", 
     ",", "1.123`", ",", "1.103`", ",", "1.125`", ",", "1.095`", ",", "1.1`", 
     ",", "1.123`", ",", "1.124`", ",", "1.101`", ",", "1.106`", ",", 
     "1.116`", ",", "1.137`", ",", "1.082`", ",", "1.129`", ",", "1.097`", 
     ",", "1.141`", ",", "1.078`", ",", "1.105`", ",", "1.118`", ",", 
     "1.122`", ",", "1.099`", ",", "1.104`", ",", "1.107`", ",", "1.136`", 
     ",", "1.074`", ",", "1.042`", ",", "1.166`", ",", "1.102`", ",", 
     "1.119`", ",", "1.096`", ",", "1.1`", ",", "1.121`", ",", "1.119`", ",", 
     "1.098`", ",", "1.099`", ",", "1.109`", ",", "1.115`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.1029`", ",", "192.`", ",", "0.7863`", ",", "0.7946`", ",", "0.7869`", 
     ",", "0.7861`", ",", "0.7886`", ",", "0.7904`", ",", "0.7784`", ",", 
     "0.7667`", ",", "0.793`", ",", "0.7897`", ",", "0.7787`", ",", "0.7818`",
      ",", "0.7862`", ",", "0.7807`", ",", "0.788`", ",", "0.7505`", ",", 
     "0.8187`", ",", "0.7698`", ",", "0.7989`", ",", "0.8015`", ",", 
     "0.7721`", ",", "0.7915`", ",", "0.7804`", ",", "0.8009`", ",", 
     "0.7695`", ",", "0.7744`", ",", "0.7966`", ",", "0.7993`", ",", 
     "0.7728`", ",", "0.7829`", ",", "0.7878`", ",", "0.8035`", ",", 
     "0.7644`", ",", "0.7997`", ",", "0.7733`", ",", "0.8095`", ",", 
     "0.7576`", ",", "0.7831`", ",", "0.7883`", ",", "0.7933`", ",", 
     "0.7765`", ",", "0.7792`", ",", "0.7833`", ",", "0.8091`", ",", 
     "0.7523`", ",", "0.737`", ",", "0.8228`", ",", "0.7778`", ",", "0.7971`",
      ",", "0.7744`", ",", "0.7777`", ",", "0.7979`", ",", "0.7929`", ",", 
     "0.7755`", ",", "0.7769`", ",", "0.7836`", ",", "0.7879`"}], "]"}], ",", 
   
   RowBox[{"LF", "[", 
    RowBox[{
    "0.1179`", ",", "220.`", ",", "0.5601`", ",", "0.5645`", ",", "0.5634`", 
     ",", "0.5603`", ",", "0.5614`", ",", "0.5627`", ",", "0.5547`", ",", 
     "0.546`", ",", "0.5659`", ",", "0.566`", ",", "0.5514`", ",", "0.5585`", 
     ",", "0.557`", ",", "0.5546`", ",", "0.5629`", ",", "0.5342`", ",", 
     "0.5834`", ",", "0.5498`", ",", "0.5677`", ",", "0.5737`", ",", 
     "0.5475`", ",", "0.563`", ",", "0.5563`", ",", "0.5756`", ",", "0.544`", 
     ",", "0.5489`", ",", "0.5704`", ",", "0.5721`", ",", "0.5476`", ",", 
     "0.559`", ",", "0.5605`", ",", "0.5722`", ",", "0.5447`", ",", "0.5703`",
      ",", "0.5502`", ",", "0.5777`", ",", "0.5383`", ",", "0.5597`", ",", 
     "0.5601`", ",", "0.5654`", ",", "0.5528`", ",", "0.5539`", ",", 
     "0.5599`", ",", "0.5819`", ",", "0.53`", ",", "0.5272`", ",", "0.5838`", 
     ",", "0.5538`", ",", "0.5719`", ",", "0.5513`", ",", "0.5546`", ",", 
     "0.5725`", ",", "0.5664`", ",", "0.5521`", ",", "0.5537`", ",", 
     "0.5581`", ",", "0.5612`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.1362`", ",", "254.`", ",", "0.3823`", ",", "0.3843`", ",", "0.3865`", 
     ",", "0.3828`", ",", "0.3828`", ",", "0.3839`", ",", "0.3788`", ",", 
     "0.3728`", ",", "0.3872`", ",", "0.3901`", ",", "0.3731`", ",", 
     "0.3829`", ",", "0.3774`", ",", "0.3773`", ",", "0.3858`", ",", 
     "0.3644`", ",", "0.3984`", ",", "0.3766`", ",", "0.3864`", ",", 
     "0.3939`", ",", "0.3718`", ",", "0.384`", ",", "0.3799`", ",", "0.3976`",
      ",", "0.3676`", ",", "0.372`", ",", "0.3924`", ",", "0.3919`", ",", 
     "0.3724`", ",", "0.3826`", ",", "0.3821`", ",", "0.3904`", ",", 
     "0.3721`", ",", "0.3893`", ",", "0.3757`", ",", "0.3941`", ",", 
     "0.3679`", ",", "0.3838`", ",", "0.3811`", ",", "0.3863`", ",", 
     "0.3772`", ",", "0.3771`", ",", "0.3844`", ",", "0.4026`", ",", 
     "0.3564`", ",", "0.363`", ",", "0.3957`", ",", "0.3786`", ",", "0.393`", 
     ",", "0.3759`", ",", "0.3794`", ",", "0.3935`", ",", "0.388`", ",", 
     "0.3764`", ",", "0.3785`", ",", "0.381`", ",", "0.383`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.1566`", ",", "292.`", ",", "0.2559`", ",", "0.2568`", ",", "0.2598`", 
     ",", "0.2565`", ",", "0.2559`", ",", "0.2568`", ",", "0.2537`", ",", 
     "0.2498`", ",", "0.26`", ",", "0.2644`", ",", "0.2471`", ",", "0.2577`", 
     ",", "0.2504`", ",", "0.2515`", ",", "0.2595`", ",", "0.2439`", ",", 
     "0.2667`", ",", "0.2531`", ",", "0.2578`", ",", "0.2653`", ",", 
     "0.2475`", ",", "0.2568`", ",", "0.2544`", ",", "0.2696`", ",", 
     "0.2434`", ",", "0.2468`", ",", "0.2652`", ",", "0.2628`", ",", 
     "0.2488`", ",", "0.2566`", ",", "0.2556`", ",", "0.2612`", ",", 
     "0.2494`", ",", "0.2603`", ",", "0.2519`", ",", "0.263`", ",", "0.2474`",
      ",", "0.2584`", ",", "0.2542`", ",", "0.2588`", ",", "0.2523`", ",", 
     "0.2517`", ",", "0.259`", ",", "0.274`", ",", "0.2343`", ",", "0.2461`", 
     ",", "0.2623`", ",", "0.2546`", ",", "0.2643`", ",", "0.251`", ",", 
     "0.2549`", ",", "0.2648`", ",", "0.2608`", ",", "0.2515`", ",", 
     "0.2539`", ",", "0.2551`", ",", "0.2564`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.1812`", ",", "338.`", ",", "0.1618`", ",", "0.1622`", ",", "0.1647`", 
     ",", "0.1623`", ",", "0.1616`", ",", "0.1622`", ",", "0.1605`", ",", 
     "0.1581`", ",", "0.1652`", ",", "0.1697`", ",", "0.1542`", ",", 
     "0.1638`", ",", "0.1567`", ",", "0.1582`", ",", "0.1651`", ",", 
     "0.1542`", ",", "0.1686`", ",", "0.1608`", ",", "0.1624`", ",", 
     "0.1689`", ",", "0.1555`", ",", "0.162`", ",", "0.161`", ",", "0.1728`", 
     ",", "0.152`", ",", "0.1543`", ",", "0.1697`", ",", "0.1661`", ",", 
     "0.1574`", ",", "0.1624`", ",", "0.1615`", ",", "0.1651`", ",", 
     "0.1577`", ",", "0.1641`", ",", "0.1598`", ",", "0.1653`", ",", 
     "0.1578`", ",", "0.1646`", ",", "0.1599`", ",", "0.1639`", ",", 
     "0.1594`", ",", "0.1588`", ",", "0.165`", ",", "0.1769`", ",", "0.145`", 
     ",", "0.1583`", ",", "0.1636`", ",", "0.1626`", ",", "0.1673`", ",", 
     "0.1581`", ",", "0.162`", ",", "0.168`", ",", "0.1657`", ",", "0.1586`", 
     ",", "0.161`", ",", "0.1613`", ",", "0.1621`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.2091`", ",", "390.`", ",", "0.09871`", ",", "0.09899`", ",", "0.1004`",
      ",", "0.09891`", ",", "0.09868`", ",", "0.09883`", ",", "0.09798`", ",",
      "0.0966`", ",", "0.1013`", ",", "0.1052`", ",", "0.09268`", ",", 
     "0.1004`", ",", "0.09466`", ",", "0.09592`", ",", "0.1013`", ",", 
     "0.09405`", ",", "0.1028`", ",", "0.0985`", ",", "0.0987`", ",", 
     "0.1038`", ",", "0.09426`", ",", "0.09841`", ",", "0.0984`", ",", 
     "0.1066`", ",", "0.09163`", ",", "0.09295`", ",", "0.1048`", ",", 
     "0.1011`", ",", "0.09631`", ",", "0.099`", ",", "0.09854`", ",", 
     "0.1007`", ",", "0.09617`", ",", "0.09959`", ",", "0.09799`", ",", 
     "0.09994`", ",", "0.09736`", ",", "0.1012`", ",", "0.097`", ",", 
     "0.1002`", ",", "0.09707`", ",", "0.09672`", ",", "0.1013`", ",", 
     "0.1104`", ",", "0.08637`", ",", "0.09857`", ",", "0.09815`", ",", 
     "0.1007`", ",", "0.1016`", ",", "0.09597`", ",", "0.09958`", ",", 
     "0.1026`", ",", "0.1016`", ",", "0.09648`", ",", "0.09856`", ",", 
     "0.09836`", ",", "0.09889`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.2402`", ",", "448.`", ",", "0.0579`", ",", "0.05821`", ",", "0.05872`",
      ",", "0.05788`", ",", "0.05817`", ",", "0.05786`", ",", "0.05756`", ",",
      "0.05671`", ",", "0.05995`", ",", "0.06273`", ",", "0.0536`", ",", 
     "0.05908`", ",", "0.05508`", ",", "0.05593`", ",", "0.05989`", ",", 
     "0.05519`", ",", "0.06028`", ",", "0.05802`", ",", "0.05771`", ",", 
     "0.06136`", ",", "0.05493`", ",", "0.0573`", ",", "0.05799`", ",", 
     "0.06308`", ",", "0.05328`", ",", "0.05381`", ",", "0.0624`", ",", 
     "0.05913`", ",", "0.05674`", ",", "0.05794`", ",", "0.05787`", ",", 
     "0.05923`", ",", "0.05629`", ",", "0.05807`", ",", "0.05785`", ",", 
     "0.05804`", ",", "0.05787`", ",", "0.06001`", ",", "0.05652`", ",", 
     "0.05901`", ",", "0.05681`", ",", "0.05678`", ",", "0.05976`", ",", 
     "0.0665`", ",", "0.0495`", ",", "0.05916`", ",", "0.05656`", ",", 
     "0.06058`", ",", "0.05902`", ",", "0.05595`", ",", "0.05896`", ",", 
     "0.06035`", ",", "0.05992`", ",", "0.05647`", ",", "0.05801`", ",", 
     "0.05769`", ",", "0.05802`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.2778`", ",", "518.`", ",", "0.03079`", ",", "0.03111`", ",", 
     "0.03099`", ",", "0.03059`", ",", "0.03132`", ",", "0.03066`", ",", 
     "0.03069`", ",", "0.03012`", ",", "0.0323`", ",", "0.0339`", ",", 
     "0.0281`", ",", "0.03144`", ",", "0.02913`", ",", "0.02955`", ",", 
     "0.0321`", ",", "0.02935`", ",", "0.03205`", ",", "0.03097`", ",", 
     "0.03059`", ",", "0.03292`", ",", "0.02899`", ",", "0.0301`", ",", 
     "0.03111`", ",", "0.03366`", ",", "0.02819`", ",", "0.02819`", ",", 
     "0.03372`", ",", "0.03131`", ",", "0.03033`", ",", "0.03067`", ",", 
     "0.03084`", ",", "0.03161`", ",", "0.02979`", ",", "0.03065`", ",", 
     "0.031`", ",", "0.03052`", ",", "0.03121`", ",", "0.03232`", ",", 
     "0.0298`", ",", "0.03155`", ",", "0.0301`", ",", "0.0303`", ",", 
     "0.03186`", ",", "0.03641`", ",", "0.02572`", ",", "0.03228`", ",", 
     "0.02947`", ",", "0.03343`", ",", "0.03081`", ",", "0.02951`", ",", 
     "0.03173`", ",", "0.03227`", ",", "0.03198`", ",", "0.02999`", ",", 
     "0.03093`", ",", "0.03067`", ",", "0.03085`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.3196`", ",", "596.`", ",", "0.01528`", ",", "0.01556`", ",", "0.0152`",
      ",", "0.01502`", ",", "0.01593`", ",", "0.01512`", ",", "0.0153`", ",", 
     "0.01488`", ",", "0.01635`", ",", "0.01707`", ",", "0.01378`", ",", 
     "0.01556`", ",", "0.01444`", ",", "0.01457`", ",", "0.01605`", ",", 
     "0.01457`", ",", "0.01591`", ",", "0.01542`", ",", "0.01514`", ",", 
     "0.0165`", ",", "0.01427`", ",", "0.0147`", ",", "0.01564`", ",", 
     "0.01666`", ",", "0.014`", ",", "0.01377`", ",", "0.01703`", ",", 
     "0.01549`", ",", "0.01512`", ",", "0.01512`", ",", "0.01535`", ",", 
     "0.01578`", ",", "0.01468`", ",", "0.0151`", ",", "0.0155`", ",", 
     "0.01498`", ",", "0.0157`", ",", "0.01628`", ",", "0.01465`", ",", 
     "0.01578`", ",", "0.01486`", ",", "0.01513`", ",", "0.0158`", ",", 
     "0.01861`", ",", "0.01253`", ",", "0.01645`", ",", "0.01434`", ",", 
     "0.01744`", ",", "0.01488`", ",", "0.01452`", ",", "0.01597`", ",", 
     "0.01627`", ",", "0.01588`", ",", "0.01491`", ",", "0.01536`", ",", 
     "0.01522`", ",", "0.01531`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.369`", ",", "688.`", ",", "0.006631`", ",", "0.006831`", ",", 
     "0.006479`", ",", "0.006397`", ",", "0.007228`", ",", "0.006497`", ",", 
     "0.006695`", ",", "0.006389`", ",", "0.007324`", ",", "0.007513`", ",", 
     "0.005923`", ",", "0.006709`", ",", "0.006292`", ",", "0.006278`", ",", 
     "0.007027`", ",", "0.00632`", ",", "0.006908`", ",", "0.006713`", ",", 
     "0.006558`", ",", "0.007253`", ",", "0.006128`", ",", "0.006252`", ",", 
     "0.006918`", ",", "0.007156`", ",", "0.006123`", ",", "0.005873`", ",", 
     "0.007553`", ",", "0.006707`", ",", "0.006584`", ",", "0.006501`", ",", 
     "0.006691`", ",", "0.006906`", ",", "0.006303`", ",", "0.006508`", ",", 
     "0.006774`", ",", "0.006441`", ",", "0.006893`", ",", "0.007194`", ",", 
     "0.006283`", ",", "0.006923`", ",", "0.006402`", ",", "0.006632`", ",", 
     "0.006822`", ",", "0.00833`", ",", "0.005374`", ",", "0.007335`", ",", 
     "0.006099`", ",", "0.008117`", ",", "0.006206`", ",", "0.006238`", ",", 
     "0.007051`", ",", "0.007358`", ",", "0.006857`", ",", "0.006513`", ",", 
     "0.00665`", ",", "0.0066`", ",", "0.006647`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.4247`", ",", "792.`", ",", "0.002503`", ",", "0.002618`", ",", 
     "0.002388`", ",", "0.002344`", ",", "0.002939`", ",", "0.002411`", ",", 
     "0.002563`", ",", "0.002362`", ",", "0.002907`", ",", "0.002873`", ",", 
     "0.00222`", ",", "0.002504`", ",", "0.002399`", ",", "0.002351`", ",", 
     "0.002678`", ",", "0.002383`", ",", "0.002612`", ",", "0.002541`", ",", 
     "0.00247`", ",", "0.002784`", ",", "0.002282`", ",", "0.002311`", ",", 
     "0.002674`", ",", "0.002655`", ",", "0.002345`", ",", "0.002172`", ",", 
     "0.002929`", ",", "0.002531`", ",", "0.002488`", ",", "0.002426`", ",", 
     "0.002539`", ",", "0.002635`", ",", "0.002346`", ",", "0.002447`", ",", 
     "0.002567`", ",", "0.002412`", ",", "0.002625`", ",", "0.002772`", ",", 
     "0.00234`", ",", "0.002652`", ",", "0.002391`", ",", "0.002534`", ",", 
     "0.002553`", ",", "0.00324`", ",", "0.002027`", ",", "0.002842`", ",", 
     "0.00226`", ",", "0.003359`", ",", "0.002222`", ",", "0.00233`", ",", 
     "0.002713`", ",", "0.003028`", ",", "0.002551`", ",", "0.002495`", ",", 
     "0.002487`", ",", "0.002489`", ",", "0.002509`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.4902`", ",", "914.`", ",", "0.0007466`", ",", "0.0007971`", ",", 
     "0.0006901`", ",", "0.0006677`", ",", "0.0009916`", ",", "0.0006989`", 
     ",", "0.0007835`", ",", "0.0006789`", ",", "0.0009433`", ",", 
     "0.0008697`", ",", "0.0006595`", ",", "0.0007345`", ",", "0.0007286`", 
     ",", "0.000695`", ",", "0.0008082`", ",", "0.0007097`", ",", 
     "0.0007816`", ",", "0.0007611`", ",", "0.0007348`", ",", "0.0008505`", 
     ",", "0.0006685`", ",", "0.0006778`", ",", "0.000821`", ",", 
     "0.0007737`", ",", "0.0007147`", ",", "0.000631`", ",", "0.0009075`", 
     ",", "0.0007566`", ",", "0.0007413`", ",", "0.0007141`", ",", 
     "0.0007623`", ",", "0.0007971`", ",", "0.0006883`", ",", "0.0007313`", 
     ",", "0.0007652`", ",", "0.0007162`", ",", "0.0007876`", ",", 
     "0.0008471`", ",", "0.0006877`", ",", "0.0008081`", ",", "0.0007032`", 
     ",", "0.0007664`", ",", "0.0007539`", ",", "0.0009955`", ",", 
     "0.0006136`", ",", "0.0008697`", ",", "0.0006641`", ",", "0.001137`", 
     ",", "0.0006166`", ",", "0.0006882`", ",", "0.0008276`", ",", 
     "0.001072`", ",", "0.0007391`", ",", "0.0007669`", ",", "0.0007276`", 
     ",", "0.0007421`", ",", "0.0007487`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.5653`", ",", "1054.`", ",", "0.0001637`", ",", "0.0001794`", ",", 
     "0.0001454`", ",", "0.0001368`", ",", "0.0002632`", ",", "0.0001464`", 
     ",", "0.000179`", ",", "0.0001398`", ",", "0.0002374`", ",", 
     "0.0001941`", ",", "0.0001442`", ",", "0.0001576`", ",", "0.0001638`", 
     ",", "0.0001506`", ",", "0.0001799`", ",", "0.0001551`", ",", 
     "0.0001723`", ",", "0.0001679`", ",", "0.0001604`", ",", "0.000193`", 
     ",", "0.0001428`", ",", "0.0001479`", ",", "0.0001857`", ",", 
     "0.0001653`", ",", "0.0001607`", ",", "0.0001336`", ",", "0.0002101`", 
     ",", "0.0001665`", ",", "0.0001621`", ",", "0.0001543`", ",", 
     "0.0001684`", ",", "0.0001775`", ",", "0.0001482`", ",", "0.0001625`", 
     ",", "0.0001661`", ",", "0.0001569`", ",", "0.0001729`", ",", 
     "0.0001908`", ",", "0.0001484`", ",", "0.0001822`", ",", "0.0001513`", 
     ",", "0.0001698`", ",", "0.000164`", ",", "0.0002243`", ",", 
     "0.0001391`", ",", "0.0001949`", ",", "0.0001442`", ",", "0.000296`", 
     ",", "0.0001229`", ",", "0.0001495`", ",", "0.0001861`", ",", 
     "0.0003176`", ",", "0.0001545`", ",", "0.0001772`", ",", "0.0001539`", 
     ",", "0.0001626`", ",", "0.0001642`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.7509`", ",", "1400.`", ",", "1.016`*^-6", ",", "1.194`*^-6", ",", 
     "8.149`*^-7", ",", "7.41`*^-7", ",", "3.345`*^-6", ",", "8.036`*^-7", 
     ",", "1.298`*^-6", ",", "7.051`*^-7", ",", "2.702`*^-6", ",", 
     "1.26`*^-6", ",", "8.923`*^-7", ",", "9.223`*^-7", ",", "1.087`*^-6", 
     ",", "9.014`*^-7", ",", "1.174`*^-6", ",", "9.546`*^-7", ",", 
     "1.086`*^-6", ",", "1.073`*^-6", ",", "9.753`*^-7", ",", "1.337`*^-6", 
     ",", "8.229`*^-7", ",", "9.586`*^-7", ",", "1.263`*^-6", ",", 
     "9.849`*^-7", ",", "1.047`*^-6", ",", "7.851`*^-7", ",", "1.543`*^-6", 
     ",", "1.024`*^-6", ",", "1.015`*^-6", ",", "9.317`*^-7", ",", 
     "1.061`*^-6", ",", "1.134`*^-6", ",", "8.965`*^-7", ",", "1.107`*^-6", 
     ",", "9.639`*^-7", ",", "9.948`*^-7", ",", "1.045`*^-6", ",", 
     "1.263`*^-6", ",", "8.932`*^-7", ",", "1.206`*^-6", ",", "9.057`*^-7", 
     ",", "1.018`*^-6", ",", "1.06`*^-6", ",", "1.544`*^-6", ",", "9.28`*^-7",
      ",", "1.253`*^-6", ",", "9.017`*^-7", ",", "3.477`*^-6", ",", 
     "5.889`*^-7", ",", "9.066`*^-7", ",", "1.25`*^-6", ",", "7.205`*^-6", 
     ",", "9.442`*^-7", ",", "1.364`*^-6", ",", "8.326`*^-7", ",", 
     "1.009`*^-6", ",", "1.019`*^-6"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.1096`", ",", "144.`", ",", "0.6886`", ",", "0.6953`", ",", "0.6905`", 
     ",", "0.6887`", ",", "0.6903`", ",", "0.6921`", ",", "0.6817`", ",", 
     "0.6715`", ",", "0.6947`", ",", "0.6929`", ",", "0.6806`", ",", 
     "0.6854`", ",", "0.6872`", ",", "0.683`", ",", "0.6908`", ",", "0.6566`",
      ",", "0.7176`", ",", "0.6745`", ",", "0.6993`", ",", "0.7031`", ",", 
     "0.6751`", ",", "0.693`", ",", "0.6835`", ",", "0.7035`", ",", "0.6722`",
      ",", "0.6769`", ",", "0.6989`", ",", "0.7014`", ",", "0.6753`", ",", 
     "0.6862`", ",", "0.6896`", ",", "0.7038`", ",", "0.6693`", ",", 
     "0.7011`", ",", "0.6765`", ",", "0.7101`", ",", "0.6621`", ",", 
     "0.6867`", ",", "0.6897`", ",", "0.6948`", ",", "0.6799`", ",", 
     "0.6819`", ",", "0.6867`", ",", "0.7111`", ",", "0.6557`", ",", 
     "0.6456`", ",", "0.7202`", ",", "0.6806`", ",", "0.7001`", ",", "0.678`",
      ",", "0.6812`", ",", "0.7005`", ",", "0.6949`", ",", "0.6789`", ",", 
     "0.6803`", ",", "0.6863`", ",", "0.6899`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.1263`", ",", "166.`", ",", "0.4774`", ",", "0.4806`", ",", "0.4813`", 
     ",", "0.4778`", ",", "0.4781`", ",", "0.4795`", ",", "0.4727`", ",", 
     "0.4655`", ",", "0.4826`", ",", "0.4841`", ",", "0.4684`", ",", 
     "0.4769`", ",", "0.4733`", ",", "0.472`", ",", "0.4805`", ",", "0.4548`",
      ",", "0.4976`", ",", "0.4691`", ",", "0.4834`", ",", "0.4901`", ",", 
     "0.4657`", ",", "0.4798`", ",", "0.4742`", ",", "0.4929`", ",", 
     "0.4618`", ",", "0.4665`", ",", "0.4876`", ",", "0.4885`", ",", 
     "0.4657`", ",", "0.477`", ",", "0.4775`", ",", "0.4878`", ",", "0.4643`",
      ",", "0.4865`", ",", "0.4686`", ",", "0.4929`", ",", "0.4582`", ",", 
     "0.478`", ",", "0.4768`", ",", "0.4819`", ",", "0.4711`", ",", "0.4716`",
      ",", "0.4783`", ",", "0.4988`", ",", "0.4486`", ",", "0.4503`", ",", 
     "0.4967`", ",", "0.4719`", ",", "0.4891`", ",", "0.4696`", ",", 
     "0.4729`", ",", "0.4893`", ",", "0.4833`", ",", "0.4702`", ",", "0.472`",
      ",", "0.4757`", ",", "0.4783`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.1461`", ",", "192.`", ",", "0.3209`", ",", "0.3223`", ",", "0.3251`", 
     ",", "0.3215`", ",", "0.3209`", ",", "0.3221`", ",", "0.3179`", ",", 
     "0.3131`", ",", "0.3253`", ",", "0.3291`", ",", "0.3117`", ",", 
     "0.3222`", ",", "0.3154`", ",", "0.316`", ",", "0.3245`", ",", "0.3056`",
      ",", "0.3345`", ",", "0.3165`", ",", "0.3239`", ",", "0.3315`", ",", 
     "0.3113`", ",", "0.3222`", ",", "0.3188`", ",", "0.3356`", ",", "0.307`",
      ",", "0.311`", ",", "0.3306`", ",", "0.3293`", ",", "0.3121`", ",", 
     "0.3214`", ",", "0.3206`", ",", "0.3277`", ",", "0.3124`", ",", 
     "0.3268`", ",", "0.3153`", ",", "0.3307`", ",", "0.3089`", ",", 
     "0.3229`", ",", "0.3193`", ",", "0.3242`", ",", "0.3165`", ",", "0.316`",
      ",", "0.3236`", ",", "0.3404`", ",", "0.2965`", ",", "0.306`", ",", 
     "0.3309`", ",", "0.3181`", ",", "0.3307`", ",", "0.3151`", ",", 
     "0.3188`", ",", "0.331`", ",", "0.3261`", ",", "0.3155`", ",", "0.3179`",
      ",", "0.3198`", ",", "0.3215`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.1674`", ",", "220.`", ",", "0.2141`", ",", "0.2147`", ",", "0.2177`", 
     ",", "0.2147`", ",", "0.2138`", ",", "0.2148`", ",", "0.2122`", ",", 
     "0.2091`", ",", "0.2178`", ",", "0.2225`", ",", "0.2056`", ",", 
     "0.2161`", ",", "0.2085`", ",", "0.2099`", ",", "0.2176`", ",", 
     "0.2039`", ",", "0.2231`", ",", "0.2121`", ",", "0.2154`", ",", 
     "0.2225`", ",", "0.2065`", ",", "0.2147`", ",", "0.2128`", ",", 
     "0.2269`", ",", "0.2024`", ",", "0.2055`", ",", "0.2228`", ",", 
     "0.2199`", ",", "0.2081`", ",", "0.2148`", ",", "0.2137`", ",", 
     "0.2185`", ",", "0.2086`", ",", "0.2176`", ",", "0.2108`", ",", 
     "0.2196`", ",", "0.2074`", ",", "0.2168`", ",", "0.2122`", ",", 
     "0.2166`", ",", "0.211`", ",", "0.2103`", ",", "0.2174`", ",", "0.2312`",
      ",", "0.194`", ",", "0.207`", ",", "0.2183`", ",", "0.2135`", ",", 
     "0.2213`", ",", "0.2096`", ",", "0.2136`", ",", "0.2218`", ",", 
     "0.2186`", ",", "0.2101`", ",", "0.2126`", ",", "0.2134`", ",", 
     "0.2145`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.1933`", ",", "254.`", ",", "0.1342`", ",", "0.1345`", ",", "0.1366`", 
     ",", "0.1346`", ",", "0.1339`", ",", "0.1345`", ",", "0.1331`", ",", 
     "0.1312`", ",", "0.1372`", ",", "0.1417`", ",", "0.127`", ",", "0.1361`",
      ",", "0.1293`", ",", "0.1308`", ",", "0.1373`", ",", "0.1278`", ",", 
     "0.1398`", ",", "0.1335`", ",", "0.1345`", ",", "0.1405`", ",", 
     "0.1286`", ",", "0.1342`", ",", "0.1335`", ",", "0.1441`", ",", 
     "0.1253`", ",", "0.1273`", ",", "0.1414`", ",", "0.1376`", ",", 
     "0.1306`", ",", "0.1347`", ",", "0.1339`", ",", "0.1369`", ",", 
     "0.1308`", ",", "0.1358`", ",", "0.1327`", ",", "0.1366`", ",", 
     "0.1313`", ",", "0.1369`", ",", "0.1323`", ",", "0.136`", ",", "0.1321`",
      ",", "0.1315`", ",", "0.1373`", ",", "0.1482`", ",", "0.1188`", ",", 
     "0.1322`", ",", "0.1348`", ",", "0.1355`", ",", "0.1386`", ",", 
     "0.1308`", ",", "0.1347`", ",", "0.1394`", ",", "0.1377`", ",", 
     "0.1313`", ",", "0.1337`", ",", "0.1337`", ",", "0.1344`"}], "]"}], ",", 
   
   RowBox[{"LF", "[", 
    RowBox[{
    "0.2222`", ",", "292.`", ",", "0.08129`", ",", "0.08158`", ",", 
     "0.08266`", ",", "0.08144`", ",", "0.08129`", ",", "0.08135`", ",", 
     "0.0807`", ",", "0.0796`", ",", "0.08366`", ",", "0.08724`", ",", 
     "0.07585`", ",", "0.08284`", ",", "0.07764`", ",", "0.07879`", ",", 
     "0.08374`", ",", "0.07743`", ",", "0.08467`", ",", "0.08124`", ",", 
     "0.08118`", ",", "0.08573`", ",", "0.07743`", ",", "0.08084`", ",", 
     "0.08114`", ",", "0.08821`", ",", "0.07511`", ",", "0.07614`", ",", 
     "0.08684`", ",", "0.08317`", ",", "0.07944`", ",", "0.08148`", ",", 
     "0.08117`", ",", "0.08305`", ",", "0.07915`", ",", "0.08186`", ",", 
     "0.08086`", ",", "0.08202`", ",", "0.08054`", ",", "0.08372`", ",", 
     "0.07966`", ",", "0.08261`", ",", "0.07989`", ",", "0.07961`", ",", 
     "0.08371`", ",", "0.09201`", ",", "0.07032`", ",", "0.08188`", ",", 
     "0.08027`", ",", "0.08367`", ",", "0.08345`", ",", "0.07882`", ",", 
     "0.08229`", ",", "0.08456`", ",", "0.08389`", ",", "0.07934`", ",", 
     "0.08128`", ",", "0.081`", ",", "0.08144`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.2572`", ",", "338.`", ",", "0.04502`", ",", "0.04535`", ",", 
     "0.04555`", ",", "0.04494`", ",", "0.04536`", ",", "0.04494`", ",", 
     "0.04478`", ",", "0.04409`", ",", "0.04682`", ",", "0.04915`", ",", 
     "0.04138`", ",", "0.04599`", ",", "0.04267`", ",", "0.04336`", ",", 
     "0.04673`", ",", "0.0429`", ",", "0.04688`", ",", "0.04519`", ",", 
     "0.04481`", ",", "0.04788`", ",", "0.04257`", ",", "0.04434`", ",", 
     "0.04524`", ",", "0.0492`", ",", "0.04127`", ",", "0.04156`", ",", 
     "0.04885`", ",", "0.04588`", ",", "0.04422`", ",", "0.04498`", ",", 
     "0.04503`", ",", "0.04612`", ",", "0.0437`", ",", "0.04502`", ",", 
     "0.04512`", ",", "0.04492`", ",", "0.04526`", ",", "0.04692`", ",", 
     "0.04378`", ",", "0.04596`", ",", "0.04412`", ",", "0.04417`", ",", 
     "0.04657`", ",", "0.05243`", ",", "0.03799`", ",", "0.04652`", ",", 
     "0.04359`", ",", "0.04778`", ",", "0.04558`", ",", "0.04333`", ",", 
     "0.04608`", ",", "0.04695`", ",", "0.0467`", ",", "0.04385`", ",", 
     "0.04518`", ",", "0.04485`", ",", "0.04511`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.2968`", ",", "390.`", ",", "0.02327`", ",", "0.02359`", ",", 
     "0.02332`", ",", "0.02305`", ",", "0.02385`", ",", "0.02313`", ",", 
     "0.02323`", ",", "0.02274`", ",", "0.02458`", ",", "0.02581`", ",", 
     "0.02111`", ",", "0.02376`", ",", "0.02197`", ",", "0.02226`", ",", 
     "0.02435`", ",", "0.02218`", ",", "0.02423`", ",", "0.02345`", ",", 
     "0.02309`", ",", "0.02498`", ",", "0.02183`", ",", "0.0226`", ",", 
     "0.02364`", ",", "0.02545`", ",", "0.02128`", ",", "0.02116`", ",", 
     "0.02568`", ",", "0.02362`", ",", "0.02298`", ",", "0.02312`", ",", 
     "0.02334`", ",", "0.02395`", ",", "0.02245`", ",", "0.02309`", ",", 
     "0.02351`", ",", "0.02296`", ",", "0.02373`", ",", "0.02459`", ",", 
     "0.02243`", ",", "0.02391`", ",", "0.02271`", ",", "0.02294`", ",", 
     "0.0241`", ",", "0.02792`", ",", "0.01922`", ",", "0.02469`", ",", 
     "0.02207`", ",", "0.02578`", ",", "0.02304`", ",", "0.02221`", ",", 
     "0.02414`", ",", "0.02448`", ",", "0.02421`", ",", "0.02266`", ",", 
     "0.02341`", ",", "0.02318`", ",", "0.02332`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.3409`", ",", "448.`", ",", "0.01113`", ",", "0.01139`", ",", "0.011`", 
     ",", "0.01088`", ",", "0.01177`", ",", "0.01098`", ",", "0.01117`", ",", 
     "0.0108`", ",", "0.01204`", ",", "0.01252`", ",", "0.00999`", ",", 
     "0.01131`", ",", "0.01052`", ",", "0.01058`", ",", "0.01174`", ",", 
     "0.01061`", ",", "0.01159`", ",", "0.01125`", ",", "0.01102`", ",", 
     "0.01208`", ",", "0.01035`", ",", "0.01061`", ",", "0.01148`", ",", 
     "0.0121`", ",", "0.01021`", ",", "0.009964`", ",", "0.01251`", ",", 
     "0.01127`", ",", "0.01104`", ",", "0.01097`", ",", "0.0112`", ",", 
     "0.01153`", ",", "0.01065`", ",", "0.01096`", ",", "0.01133`", ",", 
     "0.01087`", ",", "0.01149`", ",", "0.01195`", ",", "0.01062`", ",", 
     "0.01154`", ",", "0.0108`", ",", "0.01106`", ",", "0.0115`", ",", 
     "0.01376`", ",", "0.009048`", ",", "0.01213`", ",", "0.01035`", ",", 
     "0.01306`", ",", "0.01067`", ",", "0.01052`", ",", "0.01172`", ",", 
     "0.01199`", ",", "0.01156`", ",", "0.01087`", ",", "0.01119`", ",", 
     "0.01108`", ",", "0.01116`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.3942`", ",", "518.`", ",", "0.004488`", ",", "0.004653`", ",", 
     "0.004344`", ",", "0.004285`", ",", "0.005026`", ",", "0.004371`", ",", 
     "0.004554`", ",", "0.004293`", ",", "0.005051`", ",", "0.005118`", ",", 
     "0.003993`", ",", "0.004522`", ",", "0.004272`", ",", "0.004234`", ",", 
     "0.004777`", ",", "0.004276`", ",", "0.004679`", ",", "0.00455`", ",", 
     "0.004434`", ",", "0.004942`", ",", "0.004126`", ",", "0.004188`", ",", 
     "0.004733`", ",", "0.004814`", ",", "0.004165`", ",", "0.003941`", ",", 
     "0.005169`", ",", "0.004537`", ",", "0.004462`", ",", "0.004379`", ",", 
     "0.004539`", ",", "0.004697`", ",", "0.004241`", ",", "0.004395`", ",", 
     "0.004596`", ",", "0.004344`", ",", "0.004686`", ",", "0.004915`", ",", 
     "0.004227`", ",", "0.004713`", ",", "0.004316`", ",", "0.004511`", ",", 
     "0.004605`", ",", "0.005727`", ",", "0.00362`", ",", "0.005028`", ",", 
     "0.004091`", ",", "0.005708`", ",", "0.00411`", ",", "0.0042`", ",", 
     "0.004815`", ",", "0.005125`", ",", "0.004624`", ",", "0.004429`", ",", 
     "0.00449`", ",", "0.004467`", ",", "0.0045`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.4536`", ",", "596.`", ",", "0.00156`", ",", "0.001646`", ",", 
     "0.00147`", ",", "0.001437`", ",", "0.001917`", ",", "0.001487`", ",", 
     "0.001612`", ",", "0.001453`", ",", "0.001869`", ",", "0.001803`", ",", 
     "0.00138`", ",", "0.001551`", ",", "0.001505`", ",", "0.00146`", ",", 
     "0.001678`", ",", "0.001485`", ",", "0.00163`", ",", "0.001587`", ",", 
     "0.001538`", ",", "0.001751`", ",", "0.001413`", ",", "0.001427`", ",", 
     "0.001689`", ",", "0.00164`", ",", "0.001474`", ",", "0.001339`", ",", 
     "0.001853`", ",", "0.001578`", ",", "0.001551`", ",", "0.001504`", ",", 
     "0.001587`", ",", "0.001653`", ",", "0.001452`", ",", "0.001525`", ",", 
     "0.001602`", ",", "0.0015`", ",", "0.001641`", ",", "0.001747`", ",", 
     "0.001449`", ",", "0.001667`", ",", "0.001482`", ",", "0.001589`", ",", 
     "0.001586`", ",", "0.002051`", ",", "0.001265`", ",", "0.001794`", ",", 
     "0.001398`", ",", "0.002205`", ",", "0.001344`", ",", "0.001445`", ",", 
     "0.001709`", ",", "0.002003`", ",", "0.001576`", ",", "0.001571`", ",", 
     "0.001541`", ",", "0.001552`", ",", "0.001564`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.5236`", ",", "688.`", ",", "0.00041`", ",", "0.0004426`", ",", 
     "0.0003726`", ",", "0.000357`", ",", "0.0005864`", ",", "0.0003772`", 
     ",", "0.000437`", ",", "0.000364`", ",", "0.000546`", ",", "0.0004813`", 
     ",", "0.0003614`", ",", "0.0003998`", ",", "0.0004041`", ",", 
     "0.0003797`", ",", "0.0004468`", ",", "0.0003892`", ",", "0.0004302`", 
     ",", "0.000419`", ",", "0.0004028`", ",", "0.0004735`", ",", 
     "0.0003634`", ",", "0.0003701`", ",", "0.0004576`", ",", "0.0004201`", 
     ",", "0.0003967`", ",", "0.0003414`", ",", "0.0005093`", ",", 
     "0.000416`", ",", "0.0004068`", ",", "0.0003896`", ",", "0.00042`", ",", 
     "0.0004409`", ",", "0.0003748`", ",", "0.0004032`", ",", "0.0004191`", 
     ",", "0.0003928`", ",", "0.0004331`", ",", "0.0004711`", ",", 
     "0.0003748`", ",", "0.0004488`", ",", "0.0003831`", ",", "0.0004231`", 
     ",", "0.0004124`", ",", "0.0005549`", ",", "0.0003402`", ",", 
     "0.0004831`", ",", "0.0003625`", ",", "0.0006705`", ",", "0.0003252`", 
     ",", "0.0003759`", ",", "0.0004599`", ",", "0.0006588`", ",", 
     "0.0003989`", ",", "0.0004293`", ",", "0.0003945`", ",", "0.0004074`", 
     ",", "0.0004112`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.6028`", ",", "792.`", ",", "0.00007551`", ",", "0.0000839`", ",", 
     "0.00006563`", ",", "0.00006074`", ",", "0.0001359`", ",", "0.00006574`",
      ",", "0.00008464`", ",", "0.00006203`", ",", "0.0001193`", ",", 
     "0.00009043`", ",", "0.00006638`", ",", "0.00007183`", ",", 
     "0.00007653`", ",", "0.00006898`", ",", "0.00008372`", ",", 
     "0.00007135`", ",", "0.00007975`", ",", "0.00007779`", ",", 
     "0.00007374`", ",", "0.00009078`", ",", "0.00006491`", ",", 
     "0.00006839`", ",", "0.00008699`", ",", "0.0000754`", ",", "0.00007497`",
      ",", "0.00006043`", ",", "0.00009998`", ",", "0.0000769`", ",", 
     "0.00007466`", ",", "0.00007066`", ",", "0.00007792`", ",", 
     "0.00008249`", ",", "0.00006777`", ",", "0.00007578`", ",", 
     "0.00007594`", ",", "0.00007241`", ",", "0.00007964`", ",", 
     "0.00008924`", ",", "0.00006788`", ",", "0.00008528`", ",", 
     "0.00006907`", ",", "0.00007844`", ",", "0.00007561`", ",", "0.0001049`",
      ",", "0.00006529`", ",", "0.00009078`", ",", "0.00006631`", ",", 
     "0.0001506`", ",", "0.00005377`", ",", "0.00006859`", ",", "0.00008698`",
      ",", "0.0001767`", ",", "0.00006953`", ",", "0.0000844`", ",", 
     "0.00006938`", ",", "0.00007496`", ",", "0.00007575`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.6956`", ",", "914.`", ",", "6.789`*^-6", ",", "7.825`*^-6", ",", 
     "5.583`*^-6", ",", "4.967`*^-6", ",", "0.00001739`", ",", "5.475`*^-6", 
     ",", "8.249`*^-6", ",", "4.956`*^-6", ",", "0.00001437`", ",", 
     "8.345`*^-6", ",", "5.948`*^-6", ",", "6.26`*^-6", ",", "7.128`*^-6", 
     ",", "6.083`*^-6", ",", "7.721`*^-6", ",", "6.374`*^-6", ",", 
     "7.237`*^-6", ",", "7.096`*^-6", ",", "6.556`*^-6", ",", "8.65`*^-6", 
     ",", "5.594`*^-6", ",", "6.304`*^-6", ",", "8.124`*^-6", ",", 
     "6.637`*^-6", ",", "6.906`*^-6", ",", "5.199`*^-6", ",", "9.848`*^-6", 
     ",", "6.909`*^-6", ",", "6.716`*^-6", ",", "6.254`*^-6", ",", 
     "7.061`*^-6", ",", "7.535`*^-6", ",", "5.995`*^-6", ",", "7.131`*^-6", 
     ",", "6.591`*^-6", ",", "6.565`*^-6", ",", "7.082`*^-6", ",", 
     "8.289`*^-6", ",", "5.998`*^-6", ",", "7.962`*^-6", ",", "6.061`*^-6", 
     ",", "6.97`*^-6", ",", "6.899`*^-6", ",", "9.797`*^-6", ",", 
     "6.171`*^-6", ",", "8.293`*^-6", ",", "5.976`*^-6", ",", "0.00001833`", 
     ",", "4.194`*^-6", ",", "6.099`*^-6", ",", "8.105`*^-6", ",", 
     "0.00002958`", ",", "5.97`*^-6", ",", "8.457`*^-6", ",", "5.788`*^-6", 
     ",", "6.736`*^-6", ",", "6.809`*^-6"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.8022`", ",", "1054.`", ",", "1.131`*^-7", ",", "1.328`*^-7", ",", 
     "9.158`*^-8", ",", "1.006`*^-7", ",", "4.668`*^-7", ",", "1.004`*^-7", 
     ",", "1.439`*^-7", ",", "8.577`*^-8", ",", "3.811`*^-7", ",", 
     "1.355`*^-7", ",", "1.01`*^-7", ",", "1.024`*^-7", ",", "1.211`*^-7", 
     ",", "1.004`*^-7", ",", "1.314`*^-7", ",", "1.082`*^-7", ",", 
     "1.186`*^-7", ",", "1.192`*^-7", ",", "1.089`*^-7", ",", "1.469`*^-7", 
     ",", "9.476`*^-8", ",", "1.018`*^-7", ",", "1.591`*^-7", ",", 
     "1.068`*^-7", ",", "1.194`*^-7", ",", "1.005`*^-7", ",", "1.632`*^-7", 
     ",", "1.095`*^-7", ",", "1.176`*^-7", ",", "1.039`*^-7", ",", 
     "1.182`*^-7", ",", "1.26`*^-7", ",", "1.011`*^-7", ",", "1.251`*^-7", 
     ",", "1.084`*^-7", ",", "1.132`*^-7", ",", "1.129`*^-7", ",", 
     "1.434`*^-7", ",", "9.964`*^-8", ",", "1.28`*^-7", ",", "1.057`*^-7", 
     ",", "1.072`*^-7", ",", "1.231`*^-7", ",", "2.056`*^-7", ",", 
     "9.03`*^-8", ",", "1.446`*^-7", ",", "1.003`*^-7", ",", "5.262`*^-7", 
     ",", "6.837`*^-8", ",", "9.895`*^-8", ",", "1.489`*^-7", ",", 
     "1.449`*^-6", ",", "1.434`*^-7", ",", "1.569`*^-7", ",", "9.673`*^-8", 
     ",", "1.128`*^-7", ",", "1.132`*^-7"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.1807`", ",", "144.`", ",", "0.175`", ",", "0.1754`", ",", "0.1782`", 
     ",", "0.1756`", ",", "0.1744`", ",", "0.1755`", ",", "0.1734`", ",", 
     "0.171`", ",", "0.1782`", ",", "0.1832`", ",", "0.1669`", ",", "0.1771`",
      ",", "0.1695`", ",", "0.171`", ",", "0.1784`", ",", "0.1665`", ",", 
     "0.1825`", ",", "0.1736`", ",", "0.1757`", ",", "0.1824`", ",", 
     "0.1683`", ",", "0.1753`", ",", "0.1739`", ",", "0.1867`", ",", 
     "0.1644`", ",", "0.1671`", ",", "0.1831`", ",", "0.1797`", ",", 
     "0.1702`", ",", "0.1756`", ",", "0.1746`", ",", "0.1786`", ",", 
     "0.1705`", ",", "0.1777`", ",", "0.1725`", ",", "0.1791`", ",", "0.17`", 
     ",", "0.1778`", ",", "0.173`", ",", "0.177`", ",", "0.1724`", ",", 
     "0.1716`", ",", "0.1784`", ",", "0.1911`", ",", "0.1565`", ",", 
     "0.1705`", ",", "0.1773`", ",", "0.1752`", ",", "0.1811`", ",", "0.171`",
      ",", "0.175`", ",", "0.1815`", ",", "0.179`", ",", "0.1714`", ",", 
     "0.174`", ",", "0.1744`", ",", "0.1753`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.2083`", ",", "166.`", ",", "0.108`", ",", "0.1083`", ",", "0.11`", ",",
      "0.1084`", ",", "0.1077`", ",", "0.1082`", ",", "0.1071`", ",", 
     "0.1057`", ",", "0.1106`", ",", "0.1149`", ",", "0.1015`", ",", 
     "0.1099`", ",", "0.1035`", ",", "0.105`", ",", "0.1109`", ",", "0.1028`",
      ",", "0.1126`", ",", "0.1077`", ",", "0.1081`", ",", "0.1134`", ",", 
     "0.1032`", ",", "0.1078`", ",", "0.1076`", ",", "0.1167`", ",", 
     "0.1002`", ",", "0.1018`", ",", "0.1145`", ",", "0.1107`", ",", 
     "0.1053`", ",", "0.1084`", ",", "0.1078`", ",", "0.1103`", ",", 
     "0.1052`", ",", "0.1091`", ",", "0.107`", ",", "0.1096`", ",", "0.1062`",
      ",", "0.1107`", ",", "0.1062`", ",", "0.1095`", ",", "0.1063`", ",", 
     "0.1057`", ",", "0.1109`", ",", "0.1208`", ",", "0.09435`", ",", 
     "0.1075`", ",", "0.1076`", ",", "0.1098`", ",", "0.1114`", ",", "0.105`",
      ",", "0.1088`", ",", "0.1122`", ",", "0.1111`", ",", "0.1055`", ",", 
     "0.1078`", ",", "0.1076`", ",", "0.1082`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.2409`", ",", "192.`", ",", "0.06222`", ",", "0.06253`", ",", 
     "0.06319`", ",", "0.06231`", ",", "0.06228`", ",", "0.06223`", ",", 
     "0.0618`", ",", "0.06097`", ",", "0.06428`", ",", "0.06739`", ",", 
     "0.05758`", ",", "0.06355`", ",", "0.05912`", ",", "0.0601`", ",", 
     "0.06436`", ",", "0.05924`", ",", "0.06483`", ",", "0.06232`", ",", 
     "0.06203`", ",", "0.06587`", ",", "0.05907`", ",", "0.06162`", ",", 
     "0.06227`", ",", "0.06788`", ",", "0.05716`", ",", "0.05786`", ",", 
     "0.06697`", ",", "0.06352`", ",", "0.06097`", ",", "0.06229`", ",", 
     "0.06217`", ",", "0.06364`", ",", "0.0605`", ",", "0.06248`", ",", 
     "0.06208`", ",", "0.06248`", ",", "0.06204`", ",", "0.06447`", ",", 
     "0.06074`", ",", "0.06332`", ",", "0.06109`", ",", "0.06092`", ",", 
     "0.0643`", ",", "0.07156`", ",", "0.05296`", ",", "0.06346`", ",", 
     "0.06084`", ",", "0.06489`", ",", "0.06354`", ",", "0.06008`", ",", 
     "0.06333`", ",", "0.06469`", ",", "0.06441`", ",", "0.0606`", ",", 
     "0.06235`", ",", "0.062`", ",", "0.06234`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.276`", ",", "220.`", ",", "0.03473`", ",", "0.03507`", ",", "0.03504`",
      ",", "0.03461`", ",", "0.03513`", ",", "0.03463`", ",", "0.03458`", ",",
      "0.03401`", ",", "0.03631`", ",", "0.03822`", ",", "0.0317`", ",", 
     "0.03551`", ",", "0.03281`", ",", "0.03334`", ",", "0.03619`", ",", 
     "0.03308`", ",", "0.03618`", ",", "0.03492`", ",", "0.03452`", ",", 
     "0.03708`", ",", "0.03274`", ",", "0.034`", ",", "0.03505`", ",", 
     "0.03805`", ",", "0.03174`", ",", "0.03185`", ",", "0.03796`", ",", 
     "0.03532`", ",", "0.03421`", ",", "0.03463`", ",", "0.03477`", ",", 
     "0.03564`", ",", "0.03364`", ",", "0.03463`", ",", "0.03492`", ",", 
     "0.0345`", ",", "0.03512`", ",", "0.03643`", ",", "0.03364`", ",", 
     "0.03553`", ",", "0.034`", ",", "0.0341`", ",", "0.036`", ",", 
     "0.04108`", ",", "0.0289`", ",", "0.03632`", ",", "0.03331`", ",", 
     "0.03749`", ",", "0.03487`", ",", "0.03328`", ",", "0.03576`", ",", 
     "0.03624`", ",", "0.03612`", ",", "0.03378`", ",", "0.03491`", ",", 
     "0.0346`", ",", "0.03481`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.3187`", ",", "254.`", ",", "0.01715`", ",", "0.01745`", ",", 
     "0.01709`", ",", "0.01691`", ",", "0.01775`", ",", "0.017`", ",", 
     "0.01714`", ",", "0.01672`", ",", "0.01827`", ",", "0.01916`", ",", 
     "0.01545`", ",", "0.01749`", ",", "0.01617`", ",", "0.01635`", ",", 
     "0.01801`", ",", "0.01634`", ",", "0.01786`", ",", "0.0173`", ",", 
     "0.017`", ",", "0.01849`", ",", "0.01603`", ",", "0.01651`", ",", 
     "0.01754`", ",", "0.01874`", ",", "0.01567`", ",", "0.01548`", ",", 
     "0.01908`", ",", "0.01737`", ",", "0.01698`", ",", "0.01698`", ",", 
     "0.01722`", ",", "0.0177`", ",", "0.01649`", ",", "0.01696`", ",", 
     "0.01738`", ",", "0.01684`", ",", "0.01759`", ",", "0.01826`", ",", 
     "0.01644`", ",", "0.01767`", ",", "0.0167`", ",", "0.01694`", ",", 
     "0.01777`", ",", "0.02092`", ",", "0.01398`", ",", "0.01843`", ",", 
     "0.0161`", ",", "0.01947`", ",", "0.01675`", ",", "0.01628`", ",", 
     "0.01792`", ",", "0.01814`", ",", "0.01786`", ",", "0.0167`", ",", 
     "0.01726`", ",", "0.01708`", ",", "0.01719`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.3664`", ",", "292.`", ",", "0.007727`", ",", "0.007949`", ",", 
     "0.007572`", ",", "0.007492`", ",", "0.008331`", ",", "0.007591`", ",", 
     "0.007783`", ",", "0.007461`", ",", "0.00848`", ",", "0.008752`", ",", 
     "0.006895`", ",", "0.007832`", ",", "0.007312`", ",", "0.007316`", ",", 
     "0.008185`", ",", "0.007361`", ",", "0.008052`", ",", "0.00782`", ",", 
     "0.007642`", ",", "0.008433`", ",", "0.007153`", ",", "0.007288`", ",", 
     "0.008051`", ",", "0.008367`", ",", "0.00711`", ",", "0.006857`", ",", 
     "0.008775`", ",", "0.00781`", ",", "0.007677`", ",", "0.007583`", ",", 
     "0.007793`", ",", "0.00804`", ",", "0.007352`", ",", "0.007587`", ",", 
     "0.007889`", ",", "0.007513`", ",", "0.008021`", ",", "0.008375`", ",", 
     "0.007325`", ",", "0.008048`", ",", "0.007471`", ",", "0.007707`", ",", 
     "0.007969`", ",", "0.009723`", ",", "0.006219`", ",", "0.008535`", ",", 
     "0.00711`", ",", "0.009381`", ",", "0.007266`", ",", "0.007263`", ",", 
     "0.008211`", ",", "0.008466`", ",", "0.00802`", ",", "0.007565`", ",", 
     "0.007764`", ",", "0.007692`", ",", "0.007745`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.4241`", ",", "338.`", ",", "0.002853`", ",", "0.002981`", ",", 
     "0.002728`", ",", "0.002685`", ",", "0.003313`", ",", "0.002755`", ",", 
     "0.002914`", ",", "0.002699`", ",", "0.003293`", ",", "0.003276`", ",", 
     "0.002527`", ",", "0.002858`", ",", "0.002728`", ",", "0.002679`", ",", 
     "0.003052`", ",", "0.002716`", ",", "0.002977`", ",", "0.002896`", ",", 
     "0.002815`", ",", "0.003167`", ",", "0.002606`", ",", "0.00263`", ",", 
     "0.003048`", ",", "0.003035`", ",", "0.002665`", ",", "0.002478`", ",", 
     "0.00333`", ",", "0.002882`", ",", "0.002838`", ",", "0.002767`", ",", 
     "0.002893`", ",", "0.003003`", ",", "0.002676`", ",", "0.002788`", ",", 
     "0.002927`", ",", "0.002751`", ",", "0.002991`", ",", "0.003159`", ",", 
     "0.002667`", ",", "0.003017`", ",", "0.002729`", ",", "0.002883`", ",", 
     "0.002917`", ",", "0.003707`", ",", "0.002291`", ",", "0.003241`", ",", 
     "0.002574`", ",", "0.003808`", ",", "0.00254`", ",", "0.002652`", ",", 
     "0.003094`", ",", "0.0034`", ",", "0.002922`", ",", "0.002834`", ",", 
     "0.002842`", ",", "0.002838`", ",", "0.00286`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.4894`", ",", "390.`", ",", "0.0008647`", ",", "0.0009225`", ",", 
     "0.0008009`", ",", "0.0007776`", ",", "0.001133`", ",", "0.0008122`", 
     ",", "0.0009049`", ",", "0.0007888`", ",", "0.001083`", ",", "0.001007`",
      ",", "0.0007626`", ",", "0.0008521`", ",", "0.0008417`", ",", 
     "0.0008047`", ",", "0.0009361`", ",", "0.0008217`", ",", "0.0009052`", 
     ",", "0.0008814`", ",", "0.000851`", ",", "0.0009828`", ",", 
     "0.0007756`", ",", "0.0007828`", ",", "0.0009517`", ",", "0.0008982`", 
     ",", "0.0008256`", ",", "0.0007317`", ",", "0.001048`", ",", 
     "0.0008754`", ",", "0.0008595`", ",", "0.0008273`", ",", "0.0008827`", 
     ",", "0.000923`", ",", "0.0007973`", ",", "0.0008461`", ",", 
     "0.0008871`", ",", "0.0008294`", ",", "0.0009122`", ",", "0.0009815`", 
     ",", "0.0007962`", ",", "0.0009341`", ",", "0.0008154`", ",", 
     "0.0008862`", ",", "0.0008746`", ",", "0.001158`", ",", "0.0007044`", 
     ",", "0.001008`", ",", "0.0007679`", ",", "0.001309`", ",", "0.0007159`",
      ",", "0.0007955`", ",", "0.0009595`", ",", "0.001216`", ",", 
     "0.0008613`", ",", "0.0008842`", ",", "0.0008456`", ",", "0.0008596`", 
     ",", "0.0008672`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.5621`", ",", "448.`", ",", "0.0002022`", ",", "0.0002212`", ",", 
     "0.00018`", ",", "0.0001702`", ",", "0.0003186`", ",", "0.0001818`", ",",
      "0.00022`", ",", "0.0001737`", ",", "0.0002891`", ",", "0.0002396`", 
     ",", "0.0001778`", ",", "0.000195`", ",", "0.0002016`", ",", "0.000186`",
      ",", "0.0002221`", ",", "0.0001915`", ",", "0.0002127`", ",", 
     "0.0002073`", ",", "0.0001981`", ",", "0.0002375`", ",", "0.0001768`", 
     ",", "0.0001819`", ",", "0.0002296`", ",", "0.0002046`", ",", 
     "0.0001979`", ",", "0.0001653`", ",", "0.0002582`", ",", "0.0002054`", 
     ",", "0.0002004`", ",", "0.0001906`", ",", "0.0002079`", ",", 
     "0.0002192`", ",", "0.000183`", ",", "0.0002002`", ",", "0.0002055`", 
     ",", "0.0001936`", ",", "0.0002136`", ",", "0.0002357`", ",", 
     "0.0001832`", ",", "0.0002244`", ",", "0.0001871`", ",", "0.0002095`", 
     ",", "0.0002027`", ",", "0.0002783`", ",", "0.00017`", ",", "0.0002411`",
      ",", "0.0001777`", ",", "0.0003615`", ",", "0.0001525`", ",", 
     "0.0001842`", ",", "0.00023`", ",", "0.0003791`", ",", "0.0001925`", ",",
      "0.0002173`", ",", "0.0001911`", ",", "0.0002008`", ",", "0.0002028`"}],
     "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.65`", ",", "518.`", ",", "0.00002633`", ",", "0.00002981`", ",", 
     "0.00002224`", ",", "0.00002015`", ",", "0.00005579`", ",", 
     "0.00002207`", ",", "0.00003063`", ",", "0.00002042`", ",", 
     "0.00004745`", ",", "0.00003197`", ",", "0.00002308`", ",", 
     "0.00002466`", ",", "0.00002714`", ",", "0.00002381`", ",", 
     "0.00002956`", ",", "0.00002479`", ",", "0.00002794`", ",", "0.0000273`",
      ",", "0.00002558`", ",", "0.00003254`", ",", "0.00002217`", ",", 
     "0.00002402`", ",", "0.00003096`", ",", "0.00002598`", ",", 
     "0.00002648`", ",", "0.00002054`", ",", "0.00003645`", ",", 
     "0.00002683`", ",", "0.00002602`", ",", "0.00002442`", ",", 
     "0.00002729`", ",", "0.00002903`", ",", "0.00002339`", ",", 
     "0.00002693`", ",", "0.00002609`", ",", "0.00002531`", ",", 
     "0.00002767`", ",", "0.00003168`", ",", "0.00002342`", ",", 
     "0.00003032`", ",", "0.00002377`", ",", "0.00002728`", ",", 
     "0.00002647`", ",", "0.00003735`", ",", "0.00002329`", ",", "0.000032`", 
     ",", "0.00002307`", ",", "0.00006053`", ",", "0.00001742`", ",", 
     "0.00002374`", ",", "0.0000309`", ",", "0.00008155`", ",", "0.00002357`",
      ",", "0.0000309`", ",", "0.00002339`", ",", "0.00002612`", ",", 
     "0.00002641`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.7479`", ",", "596.`", ",", "1.361`*^-6", ",", "1.602`*^-6", ",", 
     "1.088`*^-6", ",", "9.853`*^-7", ",", "4.422`*^-6", ",", "1.072`*^-6", 
     ",", "1.736`*^-6", ",", "9.397`*^-7", ",", "3.575`*^-6", ",", 
     "1.692`*^-6", ",", "1.191`*^-6", ",", "1.234`*^-6", ",", "1.455`*^-6", 
     ",", "1.204`*^-6", ",", "1.574`*^-6", ",", "1.276`*^-6", ",", 
     "1.455`*^-6", ",", "1.437`*^-6", ",", "1.304`*^-6", ",", "1.79`*^-6", 
     ",", "1.101`*^-6", ",", "1.276`*^-6", ",", "1.697`*^-6", ",", 
     "1.318`*^-6", ",", "1.401`*^-6", ",", "1.042`*^-6", ",", "2.071`*^-6", 
     ",", "1.373`*^-6", ",", "1.359`*^-6", ",", "1.244`*^-6", ",", 
     "1.421`*^-6", ",", "1.522`*^-6", ",", "1.195`*^-6", ",", "1.478`*^-6", 
     ",", "1.292`*^-6", ",", "1.329`*^-6", ",", "1.402`*^-6", ",", 
     "1.698`*^-6", ",", "1.191`*^-6", ",", "1.618`*^-6", ",", "1.209`*^-6", 
     ",", "1.366`*^-6", ",", "1.417`*^-6", ",", "2.077`*^-6", ",", 
     "1.238`*^-6", ",", "1.685`*^-6", ",", "1.201`*^-6", ",", "4.618`*^-6", 
     ",", "7.794`*^-7", ",", "1.208`*^-6", ",", "1.679`*^-6", ",", 
     "9.317`*^-6", ",", "1.256`*^-6", ",", "1.818`*^-6", ",", "1.119`*^-6", 
     ",", "1.351`*^-6", ",", "1.364`*^-6"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.8633`", ",", "688.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.9938`", ",", "792.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.2834`", ",", "144.`", ",", "0.03243`", ",", "0.03277`", ",", 
     "0.03269`", ",", "0.03232`", ",", "0.0328`", ",", "0.03234`", ",", 
     "0.03228`", ",", "0.03176`", ",", "0.03394`", ",", "0.03578`", ",", 
     "0.02952`", ",", "0.03318`", ",", "0.03058`", ",", "0.03109`", ",", 
     "0.03384`", ",", "0.03088`", ",", "0.03379`", ",", "0.03263`", ",", 
     "0.03222`", ",", "0.03465`", ",", "0.03055`", ",", "0.03167`", ",", 
     "0.03278`", ",", "0.03558`", ",", "0.02958`", ",", "0.02967`", ",", 
     "0.03552`", ",", "0.03295`", ",", "0.03198`", ",", "0.03231`", ",", 
     "0.03248`", ",", "0.0333`", ",", "0.03138`", ",", "0.03231`", ",", 
     "0.03263`", ",", "0.03217`", ",", "0.03284`", ",", "0.0341`", ",", 
     "0.03136`", ",", "0.03318`", ",", "0.03174`", ",", "0.03183`", ",", 
     "0.03366`", ",", "0.03862`", ",", "0.02679`", ",", "0.03405`", ",", 
     "0.031`", ",", "0.0352`", ",", "0.03247`", ",", "0.03101`", ",", 
     "0.03347`", ",", "0.0338`", ",", "0.03376`", ",", "0.03151`", ",", 
     "0.03263`", ",", "0.03231`", ",", "0.0325`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.3267`", ",", "166.`", ",", "0.01591`", ",", "0.01621`", ",", 
     "0.01584`", ",", "0.01569`", ",", "0.0165`", ",", "0.01578`", ",", 
     "0.01591`", ",", "0.01551`", ",", "0.01699`", ",", "0.01783`", ",", 
     "0.0143`", ",", "0.01624`", ",", "0.01499`", ",", "0.01515`", ",", 
     "0.01674`", ",", "0.01516`", ",", "0.01658`", ",", "0.01607`", ",", 
     "0.01577`", ",", "0.01718`", ",", "0.01486`", ",", "0.01527`", ",", 
     "0.01632`", ",", "0.0174`", ",", "0.01453`", ",", "0.01433`", ",", 
     "0.01775`", ",", "0.01611`", ",", "0.01577`", ",", "0.01574`", ",", 
     "0.01599`", ",", "0.01644`", ",", "0.01528`", ",", "0.01572`", ",", 
     "0.01615`", ",", "0.01561`", ",", "0.01635`", ",", "0.017`", ",", 
     "0.01523`", ",", "0.01641`", ",", "0.01549`", ",", "0.01573`", ",", 
     "0.0165`", ",", "0.01956`", ",", "0.01288`", ",", "0.01718`", ",", 
     "0.01489`", ",", "0.01822`", ",", "0.01548`", ",", "0.01507`", ",", 
     "0.01668`", ",", "0.01683`", ",", "0.0166`", ",", "0.01548`", ",", 
     "0.01603`", ",", "0.01585`", ",", "0.01595`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.3778`", ",", "192.`", ",", "0.006772`", ",", "0.006984`", ",", 
     "0.006614`", ",", "0.006548`", ",", "0.007355`", ",", "0.006642`", ",", 
     "0.00683`", ",", "0.006525`", ",", "0.007475`", ",", "0.007695`", ",", 
     "0.006027`", ",", "0.006857`", ",", "0.006409`", ",", "0.0064`", ",", 
     "0.007188`", ",", "0.006449`", ",", "0.007059`", ",", "0.006858`", ",", 
     "0.006694`", ",", "0.007407`", ",", "0.006258`", ",", "0.006354`", ",", 
     "0.007089`", ",", "0.007322`", ",", "0.006236`", ",", "0.005988`", ",", 
     "0.007721`", ",", "0.006838`", ",", "0.006735`", ",", "0.006633`", ",", 
     "0.006836`", ",", "0.00706`", ",", "0.006428`", ",", "0.006641`", ",", 
     "0.006922`", ",", "0.006574`", ",", "0.007043`", ",", "0.007372`", ",", 
     "0.006401`", ",", "0.007065`", ",", "0.006539`", ",", "0.006763`", ",", 
     "0.006983`", ",", "0.008598`", ",", "0.005416`", ",", "0.007526`", ",", 
     "0.006202`", ",", "0.008348`", ",", "0.006312`", ",", "0.006345`", ",", 
     "0.007228`", ",", "0.007467`", ",", "0.007031`", ",", "0.006633`", ",", 
     "0.006804`", ",", "0.006741`", ",", "0.006788`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.4329`", ",", "220.`", ",", "0.002611`", ",", "0.002735`", ",", 
     "0.002489`", ",", "0.002451`", ",", "0.003057`", ",", "0.002518`", ",", 
     "0.002671`", ",", "0.002464`", ",", "0.003032`", ",", "0.003005`", ",", 
     "0.002309`", ",", "0.002613`", ",", "0.002498`", ",", "0.002449`", ",", 
     "0.002798`", ",", "0.002484`", ",", "0.002726`", ",", "0.002652`", ",", 
     "0.002576`", ",", "0.002904`", ",", "0.002381`", ",", "0.002397`", ",", 
     "0.002802`", ",", "0.002773`", ",", "0.002441`", ",", "0.002262`", ",", 
     "0.003058`", ",", "0.002637`", ",", "0.0026`", ",", "0.002528`", ",", 
     "0.00265`", ",", "0.002753`", ",", "0.002444`", ",", "0.00255`", ",", 
     "0.002681`", ",", "0.002516`", ",", "0.00274`", ",", "0.002902`", ",", 
     "0.002435`", ",", "0.002766`", ",", "0.002495`", ",", "0.002641`", ",", 
     "0.002669`", ",", "0.003418`", ",", "0.002088`", ",", "0.00298`", ",", 
     "0.002348`", ",", "0.003533`", ",", "0.002306`", ",", "0.002421`", ",", 
     "0.002842`", ",", "0.00314`", ",", "0.002674`", ",", "0.002597`", ",", 
     "0.002601`", ",", "0.002597`", ",", "0.002618`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.4998`", ",", "254.`", ",", "0.0007625`", ",", "0.0008161`", ",", 
     "0.0007029`", ",", "0.0006819`", ",", "0.001016`", ",", "0.0007136`", 
     ",", "0.0008005`", ",", "0.0006915`", ",", "0.0009675`", ",", 
     "0.0008908`", ",", "0.0006715`", ",", "0.0007497`", ",", "0.0007436`", 
     ",", "0.0007083`", ",", "0.0008272`", ",", "0.0007242`", ",", 
     "0.0007987`", ",", "0.0007777`", ",", "0.00075`", ",", "0.0008694`", ",",
      "0.0006823`", ",", "0.0006874`", ",", "0.000844`", ",", "0.0007898`", 
     ",", "0.0007296`", ",", "0.0006425`", ",", "0.0009293`", ",", 
     "0.0007718`", ",", "0.0007581`", ",", "0.000728`", ",", "0.0007791`", 
     ",", "0.0008158`", ",", "0.000701`", ",", "0.0007463`", ",", 
     "0.0007822`", ",", "0.0007309`", ",", "0.0008049`", ",", "0.0008693`", 
     ",", "0.0007`", ",", "0.0008258`", ",", "0.0007176`", ",", "0.0007823`", 
     ",", "0.0007707`", ",", "0.001029`", ",", "0.0006199`", ",", 
     "0.0008935`", ",", "0.0006749`", ",", "0.001178`", ",", "0.0006237`", 
     ",", "0.0006994`", ",", "0.0008499`", ",", "0.001098`", ",", "0.000758`",
      ",", "0.0007824`", ",", "0.0007441`", ",", "0.0007579`", ",", 
     "0.0007647`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.5746`", ",", "292.`", ",", "0.000168`", ",", "0.0001847`", ",", 
     "0.0001486`", ",", "0.00014`", ",", "0.0002729`", ",", "0.00015`", ",", 
     "0.000184`", ",", "0.0001427`", ",", "0.0002458`", ",", "0.0001998`", 
     ",", "0.0001475`", ",", "0.0001614`", ",", "0.0001681`", ",", 
     "0.0001542`", ",", "0.0001851`", ",", "0.000159`", ",", "0.0001769`", 
     ",", "0.0001725`", ",", "0.0001644`", ",", "0.0001984`", ",", 
     "0.0001464`", ",", "0.0001508`", ",", "0.000192`", ",", "0.0001694`", 
     ",", "0.000165`", ",", "0.0001365`", ",", "0.0002165`", ",", 
     "0.0001707`", ",", "0.0001665`", ",", "0.000158`", ",", "0.0001729`", 
     ",", "0.0001826`", ",", "0.0001516`", ",", "0.0001667`", ",", 
     "0.0001705`", ",", "0.0001609`", ",", "0.0001775`", ",", "0.0001969`", 
     ",", "0.0001517`", ",", "0.0001872`", ",", "0.000155`", ",", 
     "0.0001741`", ",", "0.0001684`", ",", "0.0002332`", ",", "0.0001415`", 
     ",", "0.0002013`", ",", "0.0001472`", ",", "0.0003097`", ",", 
     "0.0001245`", ",", "0.0001526`", ",", "0.0001921`", ",", "0.0003309`", 
     ",", "0.0001592`", ",", "0.000182`", ",", "0.000158`", ",", "0.0001668`",
      ",", "0.0001685`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.6652`", ",", "338.`", ",", "0.0000194`", ",", "0.00002211`", ",", 
     "0.00001623`", ",", "0.00001463`", ",", "0.00004342`", ",", 
     "0.00001607`", ",", "0.00002285`", ",", "0.00001476`", ",", "0.0000366`",
      ",", "0.00002368`", ",", "0.00001697`", ",", "0.00001808`", ",", 
     "0.0000201`", ",", "0.00001748`", ",", "0.00002188`", ",", "0.00001824`",
      ",", "0.00002062`", ",", "0.00002017`", ",", "0.00001881`", ",", 
     "0.00002419`", ",", "0.00001623`", ",", "0.00001772`", ",", 
     "0.00002302`", ",", "0.00001908`", ",", "0.00001958`", ",", 
     "0.00001501`", ",", "0.00002726`", ",", "0.00001976`", ",", 
     "0.00001918`", ",", "0.00001793`", ",", "0.00002014`", ",", 
     "0.00002146`", ",", "0.00001717`", ",", "0.00001997`", ",", 
     "0.00001913`", ",", "0.00001867`", ",", "0.00002035`", ",", "0.0000235`",
      ",", "0.00001719`", ",", "0.00002248`", ",", "0.00001744`", ",", 
     "0.00002006`", ",", "0.00001956`", ",", "0.00002782`", ",", 
     "0.00001723`", ",", "0.0000237`", ",", "0.00001697`", ",", "0.00004693`",
      ",", "0.0000125`", ",", "0.00001742`", ",", "0.00002295`", ",", 
     "0.00006608`", ",", "0.0000173`", ",", "0.00002313`", ",", "0.00001706`",
      ",", "0.00001925`", ",", "0.00001946`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.7675`", ",", "390.`", ",", "7.07`*^-7", ",", "8.385`*^-7", ",", 
     "5.599`*^-7", ",", "5.244`*^-7", ",", "2.533`*^-6", ",", "5.616`*^-7", 
     ",", "9.156`*^-7", ",", "4.845`*^-7", ",", "2.04`*^-6", ",", 
     "8.797`*^-7", ",", "6.186`*^-7", ",", "6.373`*^-7", ",", "7.597`*^-7", 
     ",", "6.227`*^-7", ",", "8.235`*^-7", ",", "6.636`*^-7", ",", 
     "7.553`*^-7", ",", "7.491`*^-7", ",", "6.76`*^-7", ",", "9.372`*^-7", 
     ",", "5.715`*^-7", ",", "6.591`*^-7", ",", "9.092`*^-7", ",", 
     "6.813`*^-7", ",", "7.319`*^-7", ",", "5.497`*^-7", ",", "1.087`*^-6", 
     ",", "7.072`*^-7", ",", "7.118`*^-7", ",", "6.445`*^-7", ",", 
     "7.397`*^-7", ",", "7.932`*^-7", ",", "6.199`*^-7", ",", "7.773`*^-7", 
     ",", "6.678`*^-7", ",", "6.943`*^-7", ",", "7.23`*^-7", ",", "8.92`*^-7",
      ",", "6.161`*^-7", ",", "8.398`*^-7", ",", "6.304`*^-7", ",", 
     "6.99`*^-7", ",", "7.466`*^-7", ",", "1.128`*^-6", ",", "6.311`*^-7", 
     ",", "8.857`*^-7", ",", "6.225`*^-7", ",", "2.673`*^-6", ",", 
     "3.952`*^-7", ",", "6.216`*^-7", ",", "8.91`*^-7", ",", "5.919`*^-6", 
     ",", "6.941`*^-7", ",", "9.678`*^-7", ",", "5.795`*^-7", ",", 
     "7.023`*^-7", ",", "7.086`*^-7"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.8816`", ",", "448.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.4672`", ",", "144.`", ",", "0.00153`", ",", "0.001619`", ",", 
     "0.001436`", ",", "0.001409`", ",", "0.001888`", ",", "0.001458`", ",", 
     "0.001581`", ",", "0.00142`", ",", "0.001842`", ",", "0.001775`", ",", 
     "0.001348`", ",", "0.00152`", ",", "0.001474`", ",", "0.001428`", ",", 
     "0.00165`", ",", "0.001454`", ",", "0.0016`", ",", "0.001557`", ",", 
     "0.001507`", ",", "0.001719`", ",", "0.001384`", ",", "0.001387`", ",", 
     "0.00167`", ",", "0.001607`", ",", "0.001444`", ",", "0.001309`", ",", 
     "0.001823`", ",", "0.001545`", ",", "0.001524`", ",", "0.001471`", ",", 
     "0.001558`", ",", "0.001625`", ",", "0.001419`", ",", "0.001493`", ",", 
     "0.001572`", ",", "0.00147`", ",", "0.001611`", ",", "0.001724`", ",", 
     "0.001415`", ",", "0.001636`", ",", "0.001452`", ",", "0.001557`", ",", 
     "0.001557`", ",", "0.002044`", ",", "0.001222`", ",", "0.001773`", ",", 
     "0.001362`", ",", "0.002204`", ",", "0.001303`", ",", "0.001408`", ",", 
     "0.001687`", ",", "0.001971`", ",", "0.001553`", ",", "0.001538`", ",", 
     "0.001514`", ",", "0.001521`", ",", "0.001534`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.5386`", ",", "166.`", ",", "0.0003905`", ",", "0.0004235`", ",", 
     "0.0003528`", ",", "0.0003388`", ",", "0.0005676`", ",", "0.0003582`", 
     ",", "0.0004174`", ",", "0.0003441`", ",", "0.0005271`", ",", 
     "0.0004605`", ",", "0.0003429`", ",", "0.0003799`", ",", "0.0003851`", 
     ",", "0.0003604`", ",", "0.000427`", ",", "0.0003702`", ",", 
     "0.0004101`", ",", "0.0003995`", ",", "0.0003832`", ",", "0.0004522`", 
     ",", "0.0003453`", ",", "0.0003493`", ",", "0.0004404`", ",", 
     "0.0003992`", ",", "0.0003783`", ",", "0.0003234`", ",", "0.0004882`", 
     ",", "0.0003957`", ",", "0.000388`", ",", "0.0003698`", ",", 
     "0.0004006`", ",", "0.0004214`", ",", "0.0003553`", ",", "0.0003839`", 
     ",", "0.0003993`", ",", "0.0003739`", ",", "0.0004127`", ",", 
     "0.000452`", ",", "0.0003551`", ",", "0.0004285`", ",", "0.0003642`", 
     ",", "0.0004028`", ",", "0.0003931`", ",", "0.0005377`", ",", 
     "0.0003205`", ",", "0.0004641`", ",", "0.0003429`", ",", "0.000657`", 
     ",", "0.0003042`", ",", "0.0003556`", ",", "0.0004418`", ",", 
     "0.0006423`", ",", "0.0003812`", ",", "0.0004096`", ",", "0.0003756`", 
     ",", "0.000388`", ",", "0.0003916`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.623`", ",", "192.`", ",", "0.00006222`", ",", "0.00006972`", ",", 
     "0.00005347`", ",", "0.00004937`", ",", "0.0001176`", ",", "0.0000536`", 
     ",", "0.0000705`", ",", "0.00005013`", ",", "0.0001024`", ",", 
     "0.00007504`", ",", "0.00005448`", ",", "0.00005887`", ",", 
     "0.00006335`", ",", "0.00005656`", ",", "0.0000694`", ",", "0.00005869`",
      ",", "0.00006585`", ",", "0.00006427`", ",", "0.00006063`", ",", 
     "0.00007543`", ",", "0.00005317`", ",", "0.000056`", ",", "0.00007275`", 
     ",", "0.00006186`", ",", "0.00006201`", ",", "0.00004926`", ",", 
     "0.00008368`", ",", "0.00006331`", ",", "0.0000616`", ",", "0.00005794`",
      ",", "0.00006436`", ",", "0.00006835`", ",", "0.00005547`", ",", 
     "0.0000627`", ",", "0.00006241`", ",", "0.00005968`", ",", "0.00006561`",
      ",", "0.00007434`", ",", "0.00005555`", ",", "0.00007073`", ",", 
     "0.00005664`", ",", "0.00006457`", ",", "0.00006242`", ",", "0.0000883`",
      ",", "0.00005358`", ",", "0.00007559`", ",", "0.00005429`", ",", 
     "0.0001312`", ",", "0.00004285`", ",", "0.00005606`", ",", "0.00007257`",
      ",", "0.000158`", ",", "0.00005725`", ",", "0.00007041`", ",", 
     "0.0000568`", ",", "0.00006176`", ",", "0.00006242`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.7138`", ",", "220.`", ",", "5.343`*^-6", ",", "6.223`*^-6", ",", 
     "4.334`*^-6", ",", "3.87`*^-6", ",", "0.0000147`", ",", "4.263`*^-6", 
     ",", "6.595`*^-6", ",", "3.804`*^-6", ",", "0.00001205`", ",", 
     "6.621`*^-6", ",", "4.66`*^-6", ",", "4.895`*^-6", ",", "5.642`*^-6", 
     ",", "4.756`*^-6", ",", "6.125`*^-6", ",", "5.006`*^-6", ",", 
     "5.709`*^-6", ",", "5.608`*^-6", ",", "5.143`*^-6", ",", "6.88`*^-6", 
     ",", "4.374`*^-6", ",", "4.935`*^-6", ",", "6.53`*^-6", ",", 
     "5.205`*^-6", ",", "5.455`*^-6", ",", "4.051`*^-6", ",", "7.907`*^-6", 
     ",", "5.423`*^-6", ",", "5.303`*^-6", ",", "4.896`*^-6", ",", 
     "5.572`*^-6", ",", "5.967`*^-6", ",", "4.686`*^-6", ",", "5.66`*^-6", 
     ",", "5.161`*^-6", ",", "5.175`*^-6", ",", "5.563`*^-6", ",", 
     "6.612`*^-6", ",", "4.683`*^-6", ",", "6.311`*^-6", ",", "4.748`*^-6", 
     ",", "5.455`*^-6", ",", "5.468`*^-6", ",", "7.946`*^-6", ",", 
     "4.824`*^-6", ",", "6.61`*^-6", ",", "4.673`*^-6", ",", "0.00001559`", 
     ",", "3.163`*^-6", ",", "4.748`*^-6", ",", "6.49`*^-6", ",", 
     "0.00002637`", ",", "4.766`*^-6", ",", "6.783`*^-6", ",", "4.522`*^-6", 
     ",", "5.301`*^-6", ",", "5.359`*^-6"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.8241`", ",", "254.`", ",", "3.904`*^-8", ",", "4.494`*^-8", ",", 
     "3.306`*^-8", ",", "4.925`*^-8", ",", "1.763`*^-7", ",", "4.46`*^-8", 
     ",", "4.433`*^-8", ",", "3.726`*^-8", ",", "1.51`*^-7", ",", 
     "4.259`*^-8", ",", "3.586`*^-8", ",", "3.589`*^-8", ",", "4.062`*^-8", 
     ",", "3.511`*^-8", ",", "4.502`*^-8", ",", "3.884`*^-8", ",", 
     "3.908`*^-8", ",", "4.028`*^-8", ",", "3.83`*^-8", ",", "4.577`*^-8", 
     ",", "3.641`*^-8", ",", "2.899`*^-8", ",", "6.926`*^-8", ",", 
     "3.464`*^-8", ",", "4.312`*^-8", ",", "4.428`*^-8", ",", "4.467`*^-8", 
     ",", "3.476`*^-8", ",", "4.374`*^-8", ",", "3.592`*^-8", ",", 
     "4.084`*^-8", ",", "4.355`*^-8", ",", "3.541`*^-8", ",", "4.139`*^-8", 
     ",", "4.039`*^-8", ",", "4.021`*^-8", ",", "3.745`*^-8", ",", 
     "5.157`*^-8", ",", "3.429`*^-8", ",", "3.851`*^-8", ",", "4.035`*^-8", 
     ",", "3.417`*^-8", ",", "4.444`*^-8", ",", "9.699`*^-8", ",", 
     "1.967`*^-8", ",", "5.523`*^-8", ",", "3.33`*^-8", ",", "2.434`*^-7", 
     ",", "2.684`*^-8", ",", "3.217`*^-8", ",", "5.833`*^-8", ",", 
     "7.854`*^-7", ",", "7.801`*^-8", ",", "5.006`*^-8", ",", "3.985`*^-8", 
     ",", "3.926`*^-8", ",", "3.895`*^-8"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.9474`", ",", "292.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", 
     ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.06988`", ",", "144.`", ",", "1.89`", ",", "1.921`", ",", "1.87`", ",", 
     "1.888`", ",", "1.893`", ",", "1.903`", ",", "1.869`", ",", "1.849`", 
     ",", "1.902`", ",", "1.89`", ",", "1.884`", ",", "1.876`", ",", "1.901`",
      ",", "1.883`", ",", "1.888`", ",", "1.811`", ",", "1.962`", ",", 
     "1.844`", ",", "1.927`", ",", "1.906`", ",", "1.874`", ",", "1.916`", 
     ",", "1.867`", ",", "1.899`", ",", "1.871`", ",", "1.872`", ",", 
     "1.903`", ",", "1.892`", ",", "1.888`", ",", "1.875`", ",", "1.897`", 
     ",", "1.928`", ",", "1.841`", ",", "1.909`", ",", "1.871`", ",", 
     "1.918`", ",", "1.855`", ",", "1.871`", ",", "1.904`", ",", "1.903`", 
     ",", "1.869`", ",", "1.876`", ",", "1.881`", ",", "1.916`", ",", 
     "1.841`", ",", "1.779`", ",", "1.974`", ",", "1.876`", ",", "1.881`", 
     ",", "1.861`", ",", "1.869`", ",", "1.884`", ",", "1.893`", ",", 
     "1.864`", ",", "1.869`", ",", "1.883`", ",", "1.894`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.08056`", ",", "166.`", ",", "1.388`", ",", "1.408`", ",", "1.377`", 
     ",", "1.386`", ",", "1.391`", ",", "1.396`", ",", "1.373`", ",", 
     "1.355`", ",", "1.397`", ",", "1.387`", ",", "1.381`", ",", "1.376`", 
     ",", "1.394`", ",", "1.381`", ",", "1.387`", ",", "1.327`", ",", 
     "1.442`", ",", "1.354`", ",", "1.413`", ",", "1.404`", ",", "1.371`", 
     ",", "1.402`", ",", "1.373`", ",", "1.399`", ",", "1.37`", ",", "1.373`",
      ",", "1.398`", ",", "1.396`", ",", "1.378`", ",", "1.377`", ",", 
     "1.392`", ",", "1.417`", ",", "1.35`", ",", "1.405`", ",", "1.37`", ",", 
     "1.417`", ",", "1.351`", ",", "1.376`", ",", "1.396`", ",", "1.398`", 
     ",", "1.371`", ",", "1.377`", ",", "1.38`", ",", "1.412`", ",", "1.345`",
      ",", "1.301`", ",", "1.452`", ",", "1.375`", ",", "1.389`", ",", 
     "1.366`", ",", "1.372`", ",", "1.391`", ",", "1.393`", ",", "1.369`", 
     ",", "1.371`", ",", "1.382`", ",", "1.39`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.09318`", ",", "192.`", ",", "0.9976`", ",", "1.009`", ",", "0.9948`", 
     ",", "0.9969`", ",", "1.`", ",", "1.003`", ",", "0.9873`", ",", 
     "0.9732`", ",", "1.005`", ",", "0.9992`", ",", "0.9906`", ",", "0.9906`",
      ",", "1.`", ",", "0.9917`", ",", "0.9982`", ",", "0.9532`", ",", 
     "1.037`", ",", "0.9753`", ",", "1.014`", ",", "1.013`", ",", "0.9824`", 
     ",", "1.005`", ",", "0.9891`", ",", "1.011`", ",", "0.9803`", ",", 
     "0.9849`", ",", "1.007`", ",", "1.009`", ",", "0.9846`", ",", "0.9918`", 
     ",", "1.`", ",", "1.019`", ",", "0.97`", ",", "1.012`", ",", "0.9826`", 
     ",", "1.023`", ",", "0.965`", ",", "0.9914`", ",", "1.001`", ",", 
     "1.006`", ",", "0.9855`", ",", "0.9895`", ",", "0.9924`", ",", "1.02`", 
     ",", "0.9605`", ",", "0.9346`", ",", "1.044`", ",", "0.9875`", ",", 
     "1.005`", ",", "0.9826`", ",", "0.9864`", ",", "1.007`", ",", "1.004`", 
     ",", "0.9841`", ",", "0.9856`", ",", "0.994`", ",", "0.9996`"}], "]"}], 
   ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.1067`", ",", "220.`", ",", "0.7173`", ",", "0.7242`", ",", "0.7188`", 
     ",", "0.7172`", ",", "0.7193`", ",", "0.7209`", ",", "0.7101`", ",", 
     "0.6992`", ",", "0.7237`", ",", "0.7214`", ",", "0.7092`", ",", 
     "0.7137`", ",", "0.7161`", ",", "0.7116`", ",", "0.7193`", ",", 
     "0.6846`", ",", "0.7468`", ",", "0.7027`", ",", "0.7282`", ",", 
     "0.7321`", ",", "0.7034`", ",", "0.7216`", ",", "0.7121`", ",", 
     "0.7323`", ",", "0.7005`", ",", "0.7055`", ",", "0.7276`", ",", 
     "0.7301`", ",", "0.7038`", ",", "0.7146`", ",", "0.7184`", ",", 
     "0.7329`", ",", "0.6974`", ",", "0.7296`", ",", "0.7052`", ",", 
     "0.7388`", ",", "0.6906`", ",", "0.7149`", ",", "0.7186`", ",", 
     "0.7238`", ",", "0.7082`", ",", "0.7104`", ",", "0.7151`", ",", 
     "0.7397`", ",", "0.6844`", ",", "0.6731`", ",", "0.7497`", ",", 
     "0.7094`", ",", "0.7286`", ",", "0.7064`", ",", "0.7096`", ",", 
     "0.7294`", ",", "0.7238`", ",", "0.7074`", ",", "0.7088`", ",", 
     "0.7147`", ",", "0.7186`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.1232`", ",", "254.`", ",", "0.4965`", ",", "0.5`", ",", "0.5003`", ",",
      "0.4969`", ",", "0.4976`", ",", "0.4987`", ",", "0.4918`", ",", 
     "0.484`", ",", "0.5021`", ",", "0.5032`", ",", "0.4876`", ",", "0.4958`",
      ",", "0.4927`", ",", "0.4912`", ",", "0.4996`", ",", "0.4735`", ",", 
     "0.5172`", ",", "0.488`", ",", "0.5028`", ",", "0.5095`", ",", "0.4846`",
      ",", "0.4989`", ",", "0.4933`", ",", "0.5121`", ",", "0.4808`", ",", 
     "0.4856`", ",", "0.5068`", ",", "0.5079`", ",", "0.4847`", ",", "0.496`",
      ",", "0.4967`", ",", "0.5072`", ",", "0.483`", ",", "0.5056`", ",", 
     "0.4878`", ",", "0.5122`", ",", "0.4773`", ",", "0.4969`", ",", 
     "0.4961`", ",", "0.5014`", ",", "0.49`", ",", "0.4906`", ",", "0.4972`", 
     ",", "0.5178`", ",", "0.4678`", ",", "0.4686`", ",", "0.5165`", ",", 
     "0.4912`", ",", "0.5082`", ",", "0.4886`", ",", "0.492`", ",", "0.5088`",
      ",", "0.5027`", ",", "0.4893`", ",", "0.4911`", ",", "0.4948`", ",", 
     "0.4975`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.1417`", ",", "292.`", ",", "0.3402`", ",", "0.3418`", ",", "0.3444`", 
     ",", "0.3408`", ",", "0.3405`", ",", "0.3415`", ",", "0.3371`", ",", 
     "0.3318`", ",", "0.3449`", ",", "0.3483`", ",", "0.3311`", ",", 
     "0.3413`", ",", "0.335`", ",", "0.3353`", ",", "0.3438`", ",", "0.3243`",
      ",", "0.3545`", ",", "0.3355`", ",", "0.3435`", ",", "0.3511`", ",", 
     "0.3303`", ",", "0.3416`", ",", "0.3381`", ",", "0.3551`", ",", 
     "0.3261`", ",", "0.3302`", ",", "0.3501`", ",", "0.349`", ",", "0.3311`",
      ",", "0.3407`", ",", "0.3399`", ",", "0.3474`", ",", "0.3313`", ",", 
     "0.3463`", ",", "0.3344`", ",", "0.3504`", ",", "0.3277`", ",", 
     "0.3421`", ",", "0.3388`", ",", "0.3438`", ",", "0.3356`", ",", 
     "0.3353`", ",", "0.3427`", ",", "0.3598`", ",", "0.3157`", ",", 
     "0.3242`", ",", "0.3511`", ",", "0.3373`", ",", "0.3502`", ",", 
     "0.3343`", ",", "0.338`", ",", "0.3508`", ",", "0.3457`", ",", "0.3348`",
      ",", "0.337`", ",", "0.339`", ",", "0.3408`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.164`", ",", "338.`", ",", "0.2208`", ",", "0.2215`", ",", "0.2244`", 
     ",", "0.2214`", ",", "0.2207`", ",", "0.2215`", ",", "0.2189`", ",", 
     "0.2156`", ",", "0.2247`", ",", "0.2292`", ",", "0.2123`", ",", 
     "0.2227`", ",", "0.2154`", ",", "0.2166`", ",", "0.2244`", ",", 
     "0.2104`", ",", "0.2301`", ",", "0.2187`", ",", "0.2222`", ",", 
     "0.2295`", ",", "0.2131`", ",", "0.2214`", ",", "0.2195`", ",", 
     "0.2336`", ",", "0.2091`", ",", "0.2122`", ",", "0.2297`", ",", 
     "0.2268`", ",", "0.2147`", ",", "0.2215`", ",", "0.2205`", ",", 
     "0.2254`", ",", "0.2152`", ",", "0.2244`", ",", "0.2176`", ",", 
     "0.2265`", ",", "0.214`", ",", "0.2234`", ",", "0.219`", ",", "0.2235`", 
     ",", "0.2177`", ",", "0.217`", ",", "0.224`", ",", "0.2379`", ",", 
     "0.2009`", ",", "0.2135`", ",", "0.2253`", ",", "0.2203`", ",", 
     "0.2282`", ",", "0.2164`", ",", "0.2203`", ",", "0.2288`", ",", 
     "0.2254`", ",", "0.2168`", ",", "0.2193`", ",", "0.2201`", ",", 
     "0.2212`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.1892`", ",", "390.`", ",", "0.1391`", ",", "0.1394`", ",", "0.1415`", 
     ",", "0.1394`", ",", "0.1389`", ",", "0.1394`", ",", "0.1379`", ",", 
     "0.1359`", ",", "0.1422`", ",", "0.1466`", ",", "0.1319`", ",", "0.141`",
      ",", "0.1343`", ",", "0.1357`", ",", "0.1422`", ",", "0.1325`", ",", 
     "0.1448`", ",", "0.1383`", ",", "0.1394`", ",", "0.1455`", ",", 
     "0.1334`", ",", "0.1391`", ",", "0.1384`", ",", "0.149`", ",", "0.1301`",
      ",", "0.1321`", ",", "0.1464`", ",", "0.1427`", ",", "0.1354`", ",", 
     "0.1395`", ",", "0.1388`", ",", "0.1419`", ",", "0.1355`", ",", 
     "0.1408`", ",", "0.1375`", ",", "0.1416`", ",", "0.1361`", ",", 
     "0.1418`", ",", "0.1372`", ",", "0.141`", ",", "0.1369`", ",", "0.1364`",
      ",", "0.1421`", ",", "0.153`", ",", "0.1237`", ",", "0.1369`", ",", 
     "0.1399`", ",", "0.1403`", ",", "0.1436`", ",", "0.1357`", ",", 
     "0.1395`", ",", "0.1445`", ",", "0.1427`", ",", "0.1362`", ",", 
     "0.1385`", ",", "0.1386`", ",", "0.1393`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.2174`", ",", "448.`", ",", "0.08486`", ",", "0.08515`", ",", 
     "0.08627`", ",", "0.08498`", ",", "0.08493`", ",", "0.08492`", ",", 
     "0.08427`", ",", "0.08307`", ",", "0.08733`", ",", "0.09087`", ",", 
     "0.07936`", ",", "0.0864`", ",", "0.08119`", ",", "0.08233`", ",", 
     "0.08733`", ",", "0.08087`", ",", "0.08836`", ",", "0.08478`", ",", 
     "0.08477`", ",", "0.08943`", ",", "0.08088`", ",", "0.08445`", ",", 
     "0.08468`", ",", "0.09191`", ",", "0.07857`", ",", "0.07961`", ",", 
     "0.09052`", ",", "0.08687`", ",", "0.08289`", ",", "0.08507`", ",", 
     "0.08474`", ",", "0.08668`", ",", "0.08264`", ",", "0.08547`", ",", 
     "0.0844`", ",", "0.08567`", ",", "0.08402`", ",", "0.08728`", ",", 
     "0.08324`", ",", "0.08626`", ",", "0.0834`", ",", "0.08316`", ",", 
     "0.08727`", ",", "0.09564`", ",", "0.07379`", ",", "0.08528`", ",", 
     "0.08396`", ",", "0.08718`", ",", "0.08716`", ",", "0.08238`", ",", 
     "0.08581`", ",", "0.08834`", ",", "0.08751`", ",", "0.08289`", ",", 
     "0.08481`", ",", "0.08456`", ",", "0.08502`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.2513`", ",", "518.`", ",", "0.04753`", ",", "0.04785`", ",", "0.0481`",
      ",", "0.04743`", ",", "0.04791`", ",", "0.04745`", ",", "0.04729`", ",",
      "0.04654`", ",", "0.0494`", ",", "0.05176`", ",", "0.0438`", ",", 
     "0.04852`", ",", "0.04513`", ",", "0.04582`", ",", "0.04928`", ",", 
     "0.04531`", ",", "0.04948`", ",", "0.04769`", ",", "0.04733`", ",", 
     "0.05051`", ",", "0.04498`", ",", "0.04688`", ",", "0.04772`", ",", 
     "0.05186`", ",", "0.04365`", ",", "0.04397`", ",", "0.05148`", ",", 
     "0.04848`", ",", "0.04665`", ",", "0.0475`", ",", "0.04753`", ",", 
     "0.04867`", ",", "0.04616`", ",", "0.04756`", ",", "0.04761`", ",", 
     "0.04747`", ",", "0.04773`", ",", "0.04945`", ",", "0.04628`", ",", 
     "0.04852`", ",", "0.04659`", ",", "0.04665`", ",", "0.04911`", ",", 
     "0.05507`", ",", "0.04035`", ",", "0.04896`", ",", "0.04614`", ",", 
     "0.05026`", ",", "0.04821`", ",", "0.04582`", ",", "0.04857`", ",", 
     "0.04961`", ",", "0.04926`", ",", "0.04634`", ",", "0.04767`", ",", 
     "0.04736`", ",", "0.04763`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.2892`", ",", "596.`", ",", "0.02516`", ",", "0.02548`", ",", 
     "0.02524`", ",", "0.02493`", ",", "0.02575`", ",", "0.02502`", ",", 
     "0.02511`", ",", "0.02459`", ",", "0.02653`", ",", "0.02783`", ",", 
     "0.02288`", ",", "0.02568`", ",", "0.02379`", ",", "0.0241`", ",", 
     "0.02629`", ",", "0.02399`", ",", "0.02619`", ",", "0.02534`", ",", 
     "0.02498`", ",", "0.02698`", ",", "0.02363`", ",", "0.02449`", ",", 
     "0.02551`", ",", "0.0275`", ",", "0.02303`", ",", "0.02293`", ",", 
     "0.0277`", ",", "0.02556`", ",", "0.02482`", ",", "0.02502`", ",", 
     "0.02522`", ",", "0.02587`", ",", "0.0243`", ",", "0.02499`", ",", 
     "0.02539`", ",", "0.02486`", ",", "0.02561`", ",", "0.02652`", ",", 
     "0.02429`", ",", "0.02584`", ",", "0.02456`", ",", "0.0248`", ",", 
     "0.02604`", ",", "0.03`", ",", "0.0209`", ",", "0.02658`", ",", 
     "0.02395`", ",", "0.02769`", ",", "0.025`", ",", "0.02406`", ",", 
     "0.02603`", ",", "0.02646`", ",", "0.02615`", ",", "0.02452`", ",", 
     "0.02529`", ",", "0.02506`", ",", "0.02521`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.3339`", ",", "688.`", ",", "0.01189`", ",", "0.01215`", ",", 
     "0.01177`", ",", "0.01163`", ",", "0.01254`", ",", "0.01174`", ",", 
     "0.01193`", ",", "0.01155`", ",", "0.01283`", ",", "0.01335`", ",", 
     "0.01069`", ",", "0.01209`", ",", "0.01124`", ",", "0.01131`", ",", 
     "0.01252`", ",", "0.01134`", ",", "0.01238`", ",", "0.01201`", ",", 
     "0.01178`", ",", "0.01289`", ",", "0.01107`", ",", "0.01137`", ",", 
     "0.01224`", ",", "0.01293`", ",", "0.01091`", ",", "0.01066`", ",", 
     "0.01334`", ",", "0.01204`", ",", "0.01178`", ",", "0.01173`", ",", 
     "0.01196`", ",", "0.01231`", ",", "0.01139`", ",", "0.01172`", ",", 
     "0.01209`", ",", "0.01162`", ",", "0.01226`", ",", "0.01274`", ",", 
     "0.01136`", ",", "0.01232`", ",", "0.01154`", ",", "0.01181`", ",", 
     "0.01228`", ",", "0.01462`", ",", "0.009716`", ",", "0.01291`", ",", 
     "0.01109`", ",", "0.01384`", ",", "0.01145`", ",", "0.01126`", ",", 
     "0.01249`", ",", "0.01279`", ",", "0.01235`", ",", "0.01162`", ",", 
     "0.01195`", ",", "0.01184`", ",", "0.01192`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.3843`", ",", "792.`", ",", "0.005024`", ",", "0.005197`", ",", 
     "0.004878`", ",", "0.00481`", ",", "0.005581`", ",", "0.004901`", ",", 
     "0.00509`", ",", "0.004817`", ",", "0.005621`", ",", "0.005715`", ",", 
     "0.004478`", ",", "0.005068`", ",", "0.004779`", ",", "0.004746`", ",", 
     "0.005339`", ",", "0.004788`", ",", "0.005236`", ",", "0.005091`", ",", 
     "0.004966`", ",", "0.005521`", ",", "0.004626`", ",", "0.004708`", ",", 
     "0.005276`", ",", "0.005398`", ",", "0.004657`", ",", "0.004425`", ",", 
     "0.005765`", ",", "0.005081`", ",", "0.004991`", ",", "0.00491`", ",", 
     "0.005077`", ",", "0.005248`", ",", "0.004758`", ",", "0.004923`", ",", 
     "0.005141`", ",", "0.004868`", ",", "0.005238`", ",", "0.005482`", ",", 
     "0.004743`", ",", "0.005267`", ",", "0.004837`", ",", "0.005043`", ",", 
     "0.005157`", ",", "0.006366`", ",", "0.004069`", ",", "0.005601`", ",", 
     "0.004596`", ",", "0.006303`", ",", "0.004637`", ",", "0.004713`", ",", 
     "0.005371`", ",", "0.005689`", ",", "0.005178`", ",", "0.004953`", ",", 
     "0.005028`", ",", "0.005`", ",", "0.005037`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.4435`", ",", "914.`", ",", "0.001758`", ",", "0.00185`", ",", 
     "0.001663`", ",", "0.001627`", ",", "0.002133`", ",", "0.001681`", ",", 
     "0.001812`", ",", "0.001644`", ",", "0.002087`", ",", "0.002027`", ",", 
     "0.001558`", ",", "0.001751`", ",", "0.001694`", ",", "0.001648`", ",", 
     "0.001888`", ",", "0.001674`", ",", "0.001836`", ",", "0.001787`", ",", 
     "0.001734`", ",", "0.001969`", ",", "0.001596`", ",", "0.001614`", ",", 
     "0.001894`", ",", "0.001853`", ",", "0.001658`", ",", "0.001515`", ",", 
     "0.002079`", ",", "0.001779`", ",", "0.001748`", ",", "0.001698`", ",", 
     "0.001787`", ",", "0.001859`", ",", "0.001641`", ",", "0.001719`", ",", 
     "0.001805`", ",", "0.001692`", ",", "0.001848`", ",", "0.001961`", ",", 
     "0.001637`", ",", "0.001875`", ",", "0.001673`", ",", "0.001788`", ",", 
     "0.001788`", ",", "0.002296`", ",", "0.001429`", ",", "0.002013`", ",", 
     "0.00158`", ",", "0.002443`", ",", "0.00153`", ",", "0.001633`", ",", 
     "0.001918`", ",", "0.00222`", ",", "0.001779`", ",", "0.001767`", ",", 
     "0.001739`", ",", "0.001749`", ",", "0.001763`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.5115`", ",", "1054.`", ",", "0.000487`", ",", "0.0005237`", ",", 
     "0.0004452`", ",", "0.0004277`", ",", "0.0006797`", ",", "0.0004506`", 
     ",", "0.0005164`", ",", "0.000436`", ",", "0.000637`", ",", "0.00057`", 
     ",", "0.0004299`", ",", "0.0004763`", ",", "0.0004785`", ",", 
     "0.0004519`", ",", "0.0005294`", ",", "0.0004626`", ",", "0.0005106`", 
     ",", "0.0004972`", ",", "0.0004788`", ",", "0.0005598`", ",", 
     "0.0004331`", ",", "0.0004409`", ",", "0.0005403`", ",", "0.0005008`", 
     ",", "0.0004697`", ",", "0.0004078`", ",", "0.0006004`", ",", 
     "0.0004941`", ",", "0.0004832`", ",", "0.0004639`", ",", "0.0004983`", 
     ",", "0.0005223`", ",", "0.0004467`", ",", "0.0004783`", ",", 
     "0.0004982`", ",", "0.0004668`", ",", "0.0005142`", ",", "0.0005568`", 
     ",", "0.0004466`", ",", "0.0005311`", ",", "0.0004563`", ",", 
     "0.0005018`", ",", "0.0004903`", ",", "0.0006544`", ",", "0.0004038`", 
     ",", "0.0005711`", ",", "0.0004318`", ",", "0.0007762`", ",", 
     "0.0003921`", ",", "0.0004477`", ",", "0.0005436`", ",", "0.0007539`", 
     ",", "0.000476`", ",", "0.0005068`", ",", "0.0004704`", ",", "0.000484`",
      ",", "0.0004885`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.6794`", ",", "1400.`", ",", "9.95`*^-6", ",", "0.00001138`", ",", 
     "8.265`*^-6", ",", "7.376`*^-6", ",", "0.00002388`", ",", "8.122`*^-6", 
     ",", "0.00001191`", ",", "7.42`*^-6", ",", "0.00001989`", ",", 
     "0.00001216`", ",", "8.73`*^-6", ",", "9.224`*^-6", ",", "0.00001038`", 
     ",", "8.952`*^-6", ",", "0.00001125`", ",", "9.353`*^-6", ",", 
     "0.00001058`", ",", "0.00001036`", ",", "9.631`*^-6", ",", "0.00001254`",
      ",", "8.257`*^-6", ",", "9.214`*^-6", ",", "0.00001179`", ",", 
     "9.756`*^-6", ",", "0.00001008`", ",", "7.673`*^-6", ",", "0.00001419`", 
     ",", "0.00001013`", ",", "9.832`*^-6", ",", "9.195`*^-6", ",", 
     "0.00001033`", ",", "0.000011`", ",", "8.815`*^-6", ",", "0.00001036`", 
     ",", "9.722`*^-6", ",", "9.604`*^-6", ",", "0.0000104`", ",", 
     "0.00001206`", ",", "8.825`*^-6", ",", "0.00001159`", ",", "8.917`*^-6", 
     ",", "0.00001025`", ",", "0.00001006`", ",", "0.00001418`", ",", 
     "9.008`*^-6", ",", "0.0000121`", ",", "8.764`*^-6", ",", "0.00002529`", 
     ",", "6.318`*^-6", ",", "8.974`*^-6", ",", "0.00001177`", ",", 
     "0.00003857`", ",", "8.749`*^-6", ",", "0.00001215`", ",", "8.587`*^-6", 
     ",", "9.872`*^-6", ",", "9.981`*^-6"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.04924`", ",", "144.`", ",", "3.816`", ",", "3.883`", ",", "3.761`", 
     ",", "3.81`", ",", "3.812`", ",", "3.849`", ",", "3.77`", ",", "3.746`", 
     ",", "3.843`", ",", "3.832`", ",", "3.8`", ",", "3.799`", ",", "3.832`", 
     ",", "3.8`", ",", "3.815`", ",", "3.674`", ",", "3.944`", ",", "3.727`", 
     ",", "3.887`", ",", "3.825`", ",", "3.804`", ",", "3.887`", ",", 
     "3.756`", ",", "3.827`", ",", "3.789`", ",", "3.781`", ",", "3.842`", 
     ",", "3.792`", ",", "3.84`", ",", "3.794`", ",", "3.826`", ",", "3.879`",
      ",", "3.734`", ",", "3.83`", ",", "3.8`", ",", "3.819`", ",", "3.812`", 
     ",", "3.771`", ",", "3.849`", ",", "3.836`", ",", "3.781`", ",", 
     "3.783`", ",", "3.824`", ",", "3.849`", ",", "3.739`", ",", "3.645`", 
     ",", "3.942`", ",", "3.793`", ",", "3.765`", ",", "3.759`", ",", 
     "3.778`", ",", "3.778`", ",", "3.804`", ",", "3.762`", ",", "3.78`", ",",
      "3.802`", ",", "3.825`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.05677`", ",", "166.`", ",", "2.88`", ",", "2.929`", ",", "2.84`", ",", 
     "2.875`", ",", "2.88`", ",", "2.902`", ",", "2.846`", ",", "2.822`", ",",
      "2.898`", ",", "2.885`", ",", "2.869`", ",", "2.862`", ",", "2.894`", 
     ",", "2.868`", ",", "2.877`", ",", "2.768`", ",", "2.981`", ",", "2.81`",
      ",", "2.934`", ",", "2.892`", ",", "2.865`", ",", "2.927`", ",", 
     "2.838`", ",", "2.889`", ",", "2.856`", ",", "2.853`", ",", "2.898`", 
     ",", "2.867`", ",", "2.891`", ",", "2.858`", ",", "2.889`", ",", 
     "2.931`", ",", "2.812`", ",", "2.897`", ",", "2.861`", ",", "2.897`", 
     ",", "2.857`", ",", "2.846`", ",", "2.903`", ",", "2.897`", ",", 
     "2.851`", ",", "2.856`", ",", "2.876`", ",", "2.909`", ",", "2.816`", 
     ",", "2.733`", ",", "2.988`", ",", "2.861`", ",", "2.848`", ",", 
     "2.836`", ",", "2.849`", ",", "2.857`", ",", "2.876`", ",", "2.839`", 
     ",", "2.85`", ",", "2.869`", ",", "2.886`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.06566`", ",", "192.`", ",", "2.137`", ",", "2.172`", ",", "2.112`", 
     ",", "2.134`", ",", "2.14`", ",", "2.152`", ",", "2.113`", ",", "2.091`",
      ",", "2.151`", ",", "2.138`", ",", "2.13`", ",", "2.122`", ",", 
     "2.149`", ",", "2.129`", ",", "2.134`", ",", "2.05`", ",", "2.216`", ",",
      "2.085`", ",", "2.178`", ",", "2.153`", ",", "2.121`", ",", "2.167`", 
     ",", "2.11`", ",", "2.147`", ",", "2.117`", ",", "2.118`", ",", "2.151`",
      ",", "2.136`", ",", "2.138`", ",", "2.12`", ",", "2.145`", ",", 
     "2.178`", ",", "2.084`", ",", "2.155`", ",", "2.118`", ",", "2.163`", 
     ",", "2.104`", ",", "2.114`", ",", "2.153`", ",", "2.152`", ",", 
     "2.114`", ",", "2.121`", ",", "2.129`", ",", "2.163`", ",", "2.085`", 
     ",", "2.017`", ",", "2.227`", ",", "2.122`", ",", "2.123`", ",", 
     "2.105`", ",", "2.114`", ",", "2.128`", ",", "2.139`", ",", "2.108`", 
     ",", "2.114`", ",", "2.129`", ",", "2.142`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.07524`", ",", "220.`", ",", "1.601`", ",", "1.625`", ",", "1.587`", 
     ",", "1.599`", ",", "1.604`", ",", "1.611`", ",", "1.584`", ",", 
     "1.564`", ",", "1.611`", ",", "1.601`", ",", "1.594`", ",", "1.588`", 
     ",", "1.609`", ",", "1.594`", ",", "1.599`", ",", "1.534`", ",", 
     "1.662`", ",", "1.563`", ",", "1.63`", ",", "1.617`", ",", "1.584`", ",",
      "1.619`", ",", "1.584`", ",", "1.612`", ",", "1.582`", ",", "1.585`", 
     ",", "1.612`", ",", "1.607`", ",", "1.594`", ",", "1.589`", ",", 
     "1.606`", ",", "1.633`", ",", "1.559`", ",", "1.619`", ",", "1.583`", 
     ",", "1.629`", ",", "1.565`", ",", "1.586`", ",", "1.611`", ",", 
     "1.613`", ",", "1.583`", ",", "1.589`", ",", "1.593`", ",", "1.625`", 
     ",", "1.556`", ",", "1.505`", ",", "1.673`", ",", "1.588`", ",", 
     "1.598`", ",", "1.577`", ",", "1.583`", ",", "1.602`", ",", "1.606`", 
     ",", "1.579`", ",", "1.583`", ",", "1.595`", ",", "1.604`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.08686`", ",", "254.`", ",", "1.156`", ",", "1.171`", ",", "1.151`", 
     ",", "1.155`", ",", "1.16`", ",", "1.163`", ",", "1.144`", ",", "1.128`",
      ",", "1.165`", ",", "1.157`", ",", "1.149`", ",", "1.147`", ",", 
     "1.16`", ",", "1.15`", ",", "1.156`", ",", "1.106`", ",", "1.201`", ",", 
     "1.13`", ",", "1.176`", ",", "1.172`", ",", "1.14`", ",", "1.166`", ",", 
     "1.146`", ",", "1.169`", ",", "1.138`", ",", "1.143`", ",", "1.166`", 
     ",", "1.167`", ",", "1.144`", ",", "1.149`", ",", "1.159`", ",", "1.18`",
      ",", "1.125`", ",", "1.172`", ",", "1.14`", ",", "1.183`", ",", 
     "1.122`", ",", "1.148`", ",", "1.162`", ",", "1.166`", ",", "1.142`", 
     ",", "1.147`", ",", "1.15`", ",", "1.18`", ",", "1.117`", ",", "1.084`", 
     ",", "1.21`", ",", "1.145`", ",", "1.162`", ",", "1.139`", ",", "1.143`",
      ",", "1.164`", ",", "1.163`", ",", "1.141`", ",", "1.143`", ",", 
     "1.152`", ",", "1.158`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.09986`", ",", "292.`", ",", "0.8305`", ",", "0.8392`", ",", "0.8305`", 
     ",", "0.8301`", ",", "0.8332`", ",", "0.8348`", ",", "0.8223`", ",", 
     "0.8096`", ",", "0.8377`", ",", "0.8338`", ",", "0.8227`", ",", 
     "0.8255`", ",", "0.8307`", ",", "0.8248`", ",", "0.8319`", ",", 
     "0.7935`", ",", "0.8639`", ",", "0.8132`", ",", "0.8436`", ",", "0.846`",
      ",", "0.8159`", ",", "0.8359`", ",", "0.8243`", ",", "0.8452`", ",", 
     "0.8132`", ",", "0.8184`", ",", "0.8408`", ",", "0.8435`", ",", 
     "0.8169`", ",", "0.8267`", ",", "0.8321`", ",", "0.8483`", ",", 
     "0.8077`", ",", "0.8439`", ",", "0.8175`", ",", "0.8538`", ",", 
     "0.8016`", ",", "0.8267`", ",", "0.8328`", ",", "0.8379`", ",", 
     "0.8202`", ",", "0.823`", ",", "0.8271`", ",", "0.8532`", ",", "0.7963`",
      ",", "0.7793`", ",", "0.8684`", ",", "0.822`", ",", "0.8409`", ",", 
     "0.8181`", ",", "0.8216`", ",", "0.8422`", ",", "0.8374`", ",", 
     "0.8194`", ",", "0.8207`", ",", "0.8275`", ",", "0.8321`"}], "]"}], ",", 
   
   RowBox[{"LF", "[", 
    RowBox[{
    "0.1155`", ",", "338.`", ",", "0.5774`", ",", "0.582`", ",", "0.5805`", 
     ",", "0.5776`", ",", "0.5791`", ",", "0.5801`", ",", "0.572`", ",", 
     "0.5628`", ",", "0.5835`", ",", "0.5834`", ",", "0.5687`", ",", 
     "0.5757`", ",", "0.5745`", ",", "0.572`", ",", "0.5801`", ",", "0.5512`",
      ",", "0.6011`", ",", "0.567`", ",", "0.5852`", ",", "0.5913`", ",", 
     "0.5647`", ",", "0.5803`", ",", "0.5737`", ",", "0.5931`", ",", 
     "0.5611`", ",", "0.5661`", ",", "0.5878`", ",", "0.5895`", ",", 
     "0.5648`", ",", "0.5763`", ",", "0.5779`", ",", "0.5898`", ",", 
     "0.5618`", ",", "0.5876`", ",", "0.5677`", ",", "0.595`", ",", "0.5558`",
      ",", "0.5769`", ",", "0.5776`", ",", "0.583`", ",", "0.57`", ",", 
     "0.5711`", ",", "0.5771`", ",", "0.5992`", ",", "0.5475`", ",", 
     "0.5441`", ",", "0.6016`", ",", "0.5713`", ",", "0.5891`", ",", 
     "0.5686`", ",", "0.5719`", ",", "0.5901`", ",", "0.584`", ",", "0.5694`",
      ",", "0.571`", ",", "0.5754`", ",", "0.5786`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.1333`", ",", "390.`", ",", "0.3945`", ",", "0.3966`", ",", "0.3985`", 
     ",", "0.3949`", ",", "0.3952`", ",", "0.396`", ",", "0.3909`", ",", 
     "0.3845`", ",", "0.3996`", ",", "0.4022`", ",", "0.3853`", ",", 
     "0.3949`", ",", "0.3897`", ",", "0.3894`", ",", "0.3979`", ",", 
     "0.3763`", ",", "0.4108`", ",", "0.3886`", ",", "0.3986`", ",", 
     "0.4062`", ",", "0.3838`", ",", "0.3961`", ",", "0.3921`", ",", 
     "0.4097`", ",", "0.3797`", ",", "0.3841`", ",", "0.4046`", ",", 
     "0.4043`", ",", "0.3843`", ",", "0.3946`", ",", "0.3943`", ",", 
     "0.4028`", ",", "0.384`", ",", "0.4015`", ",", "0.3878`", ",", "0.4064`",
      ",", "0.3799`", ",", "0.3958`", ",", "0.3934`", ",", "0.3986`", ",", 
     "0.3892`", ",", "0.3892`", ",", "0.3963`", ",", "0.4146`", ",", 
     "0.3687`", ",", "0.3746`", ",", "0.4083`", ",", "0.3908`", ",", 
     "0.4051`", ",", "0.388`", ",", "0.3915`", ",", "0.4059`", ",", "0.4003`",
      ",", "0.3885`", ",", "0.3905`", ",", "0.3931`", ",", "0.3952`"}], "]"}],
    ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.1532`", ",", "448.`", ",", "0.2652`", ",", "0.2662`", ",", "0.2691`", 
     ",", "0.2657`", ",", "0.2654`", ",", "0.2661`", ",", "0.263`", ",", 
     "0.2588`", ",", "0.2695`", ",", "0.2736`", ",", "0.2564`", ",", 
     "0.2668`", ",", "0.2598`", ",", "0.2608`", ",", "0.2688`", ",", 
     "0.2529`", ",", "0.2762`", ",", "0.2623`", ",", "0.2672`", ",", 
     "0.2748`", ",", "0.2567`", ",", "0.2661`", ",", "0.2637`", ",", 
     "0.2789`", ",", "0.2526`", ",", "0.256`", ",", "0.2746`", ",", "0.2724`",
      ",", "0.2579`", ",", "0.2659`", ",", "0.2649`", ",", "0.2707`", ",", 
     "0.2585`", ",", "0.2697`", ",", "0.2612`", ",", "0.2725`", ",", 
     "0.2565`", ",", "0.2676`", ",", "0.2636`", ",", "0.2683`", ",", 
     "0.2615`", ",", "0.261`", ",", "0.2682`", ",", "0.2832`", ",", "0.2437`",
      ",", "0.2549`", ",", "0.272`", ",", "0.2639`", ",", "0.2737`", ",", 
     "0.2603`", ",", "0.2641`", ",", "0.2744`", ",", "0.2703`", ",", 
     "0.2608`", ",", "0.2631`", ",", "0.2643`", ",", "0.2657`"}], "]"}], ",", 
   
   RowBox[{"LF", "[", 
    RowBox[{
    "0.1771`", ",", "518.`", ",", "0.1688`", ",", "0.1692`", ",", "0.1716`", 
     ",", "0.1691`", ",", "0.1687`", ",", "0.1692`", ",", "0.1674`", ",", 
     "0.1649`", ",", "0.1722`", ",", "0.1767`", ",", "0.1611`", ",", 
     "0.1707`", ",", "0.1637`", ",", "0.1651`", ",", "0.172`", ",", "0.1609`",
      ",", "0.1757`", ",", "0.1676`", ",", "0.1694`", ",", "0.1761`", ",", 
     "0.1623`", ",", "0.169`", ",", "0.1679`", ",", "0.1798`", ",", "0.1588`",
      ",", "0.1611`", ",", "0.1767`", ",", "0.1733`", ",", "0.1642`", ",", 
     "0.1693`", ",", "0.1685`", ",", "0.1722`", ",", "0.1645`", ",", 
     "0.1711`", ",", "0.1667`", ",", "0.1724`", ",", "0.1645`", ",", 
     "0.1714`", ",", "0.1669`", ",", "0.171`", ",", "0.1662`", ",", "0.1657`",
      ",", "0.1719`", ",", "0.1839`", ",", "0.1518`", ",", "0.1649`", ",", 
     "0.1708`", ",", "0.1694`", ",", "0.1744`", ",", "0.1651`", ",", 
     "0.1689`", ",", "0.1753`", ",", "0.1728`", ",", "0.1655`", ",", 
     "0.1679`", ",", "0.1682`", ",", "0.1691`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.2038`", ",", "596.`", ",", "0.1044`", ",", "0.1047`", ",", "0.1062`", 
     ",", "0.1046`", ",", "0.1045`", ",", "0.1045`", ",", "0.1037`", ",", 
     "0.1021`", ",", "0.1072`", ",", "0.111`", ",", "0.09832`", ",", 
     "0.1061`", ",", "0.1003`", ",", "0.1016`", ",", "0.1071`", ",", 
     "0.09958`", ",", "0.1087`", ",", "0.1041`", ",", "0.1044`", ",", 
     "0.1097`", ",", "0.09983`", ",", "0.1042`", ",", "0.1041`", ",", 
     "0.1126`", ",", "0.09719`", ",", "0.09854`", ",", "0.1107`", ",", 
     "0.107`", ",", "0.1018`", ",", "0.1047`", ",", "0.1042`", ",", "0.1066`",
      ",", "0.1017`", ",", "0.1054`", ",", "0.1036`", ",", "0.1058`", ",", 
     "0.1029`", ",", "0.1069`", ",", "0.1027`", ",", "0.106`", ",", "0.1027`",
      ",", "0.1024`", ",", "0.1071`", ",", "0.1163`", ",", "0.0919`", ",", 
     "0.104`", ",", "0.1041`", ",", "0.1064`", ",", "0.1075`", ",", "0.1016`",
      ",", "0.1052`", ",", "0.1087`", ",", "0.1074`", ",", "0.1021`", ",", 
     "0.1042`", ",", "0.104`", ",", "0.1046`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.2352`", ",", "688.`", ",", "0.06052`", ",", "0.06082`", ",", 
     "0.06137`", ",", "0.06047`", ",", "0.06083`", ",", "0.06047`", ",", 
     "0.06017`", ",", "0.05925`", ",", "0.06264`", ",", "0.06542`", ",", 
     "0.05614`", ",", "0.06171`", ",", "0.05766`", ",", "0.05851`", ",", 
     "0.06254`", ",", "0.0577`", ",", "0.06299`", ",", "0.06062`", ",", 
     "0.06034`", ",", "0.06409`", ",", "0.05745`", ",", "0.05995`", ",", 
     "0.06058`", ",", "0.06582`", ",", "0.05578`", ",", "0.05633`", ",", 
     "0.06512`", ",", "0.06183`", ",", "0.05926`", ",", "0.06057`", ",", 
     "0.06048`", ",", "0.06189`", ",", "0.05886`", ",", "0.06071`", ",", 
     "0.06045`", ",", "0.06071`", ",", "0.06043`", ",", "0.06263`", ",", 
     "0.05913`", ",", "0.06168`", ",", "0.05938`", ",", "0.05937`", ",", 
     "0.06239`", ",", "0.0692`", ",", "0.052`", ",", "0.06168`", ",", 
     "0.05924`", ",", "0.06315`", ",", "0.06174`", ",", "0.05854`", ",", 
     "0.06155`", ",", "0.06312`", ",", "0.06258`", ",", "0.05907`", ",", 
     "0.0606`", ",", "0.0603`", ",", "0.06064`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.2708`", ",", "792.`", ",", "0.03309`", ",", "0.03341`", ",", 
     "0.03333`", ",", "0.03289`", ",", "0.03364`", ",", "0.03296`", ",", 
     "0.03298`", ",", "0.03237`", ",", "0.03467`", ",", "0.03634`", ",", 
     "0.03027`", ",", "0.03378`", ",", "0.03135`", ",", "0.03179`", ",", 
     "0.03445`", ",", "0.03155`", ",", "0.03443`", ",", "0.03327`", ",", 
     "0.03289`", ",", "0.03534`", ",", "0.03118`", ",", "0.03242`", ",", 
     "0.03338`", ",", "0.03613`", ",", "0.03034`", ",", "0.03036`", ",", 
     "0.03616`", ",", "0.03368`", ",", "0.03256`", ",", "0.03298`", ",", 
     "0.03313`", ",", "0.03395`", ",", "0.03205`", ",", "0.03297`", ",", 
     "0.03329`", ",", "0.03284`", ",", "0.03349`", ",", "0.03466`", ",", 
     "0.03207`", ",", "0.03389`", ",", "0.03236`", ",", "0.03256`", ",", 
     "0.03421`", ",", "0.0389`", ",", "0.0278`", ",", "0.03456`", ",", 
     "0.03178`", ",", "0.03573`", ",", "0.0332`", ",", "0.03177`", ",", 
     "0.03403`", ",", "0.03469`", ",", "0.03434`", ",", "0.03226`", ",", 
     "0.03322`", ",", "0.03296`", ",", "0.03316`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.3125`", ",", "914.`", ",", "0.01638`", ",", "0.01666`", ",", 
     "0.01631`", ",", "0.01611`", ",", "0.01704`", ",", "0.01622`", ",", 
     "0.0164`", ",", "0.01596`", ",", "0.01749`", ",", "0.01826`", ",", 
     "0.0148`", ",", "0.01668`", ",", "0.01549`", ",", "0.01563`", ",", 
     "0.01719`", ",", "0.01562`", ",", "0.01705`", ",", "0.01653`", ",", 
     "0.01624`", ",", "0.01767`", ",", "0.01531`", ",", "0.0158`", ",", 
     "0.01673`", ",", "0.01785`", ",", "0.01502`", ",", "0.0148`", ",", 
     "0.01822`", ",", "0.01661`", ",", "0.0162`", ",", "0.01622`", ",", 
     "0.01645`", ",", "0.0169`", ",", "0.01575`", ",", "0.0162`", ",", 
     "0.01661`", ",", "0.01608`", ",", "0.0168`", ",", "0.01741`", ",", 
     "0.01573`", ",", "0.0169`", ",", "0.01594`", ",", "0.01622`", ",", 
     "0.01693`", ",", "0.01984`", ",", "0.0135`", ",", "0.01757`", ",", 
     "0.01542`", ",", "0.01857`", ",", "0.01601`", ",", "0.01559`", ",", 
     "0.01708`", ",", "0.01743`", ",", "0.01701`", ",", "0.01599`", ",", 
     "0.01646`", ",", "0.01631`", ",", "0.01642`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.3604`", ",", "1054.`", ",", "0.00727`", ",", "0.007476`", ",", 
     "0.007121`", ",", "0.007028`", ",", "0.007883`", ",", "0.007131`", ",", 
     "0.007333`", ",", "0.007016`", ",", "0.007997`", ",", "0.008219`", ",", 
     "0.006506`", ",", "0.007361`", ",", "0.006898`", ",", "0.006892`", ",", 
     "0.007693`", ",", "0.006932`", ",", "0.007572`", ",", "0.007357`", ",", 
     "0.007192`", ",", "0.00794`", ",", "0.006727`", ",", "0.006879`", ",", 
     "0.007561`", ",", "0.007854`", ",", "0.00671`", ",", "0.006457`", ",", 
     "0.008257`", ",", "0.007358`", ",", "0.007213`", ",", "0.007137`", ",", 
     "0.007332`", ",", "0.007562`", ",", "0.006922`", ",", "0.007141`", ",", 
     "0.007421`", ",", "0.00707`", ",", "0.007547`", ",", "0.007864`", ",", 
     "0.006902`", ",", "0.007581`", ",", "0.007025`", ",", "0.007266`", ",", 
     "0.007481`", ",", "0.009076`", ",", "0.005918`", ",", "0.008008`", ",", 
     "0.006709`", ",", "0.008805`", ",", "0.006846`", ",", "0.006854`", ",", 
     "0.007708`", ",", "0.008029`", ",", "0.007518`", ",", "0.007139`", ",", 
     "0.007291`", ",", "0.007237`", ",", "0.007288`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.02987`", ",", "144.`", ",", "9.458`", ",", "9.597`", ",", "9.356`", 
     ",", "9.427`", ",", "9.432`", ",", "9.565`", ",", "9.329`", ",", 
     "9.331`", ",", "9.546`", ",", "9.538`", ",", "9.413`", ",", "9.463`", 
     ",", "9.46`", ",", "9.4`", ",", "9.484`", ",", "9.172`", ",", "9.711`", 
     ",", "9.279`", ",", "9.601`", ",", "9.434`", ",", "9.468`", ",", 
     "9.629`", ",", "9.313`", ",", "9.479`", ",", "9.416`", ",", "9.379`", 
     ",", "9.515`", ",", "9.425`", ",", "9.486`", ",", "9.476`", ",", 
     "9.449`", ",", "9.568`", ",", "9.309`", ",", "9.447`", ",", "9.461`", 
     ",", "9.372`", ",", "9.562`", ",", "9.364`", ",", "9.529`", ",", 
     "9.484`", ",", "9.39`", ",", "9.356`", ",", "9.569`", ",", "9.504`", ",",
      "9.312`", ",", "9.229`", ",", "9.604`", ",", "9.391`", ",", "9.319`", 
     ",", "9.337`", ",", "9.37`", ",", "9.374`", ",", "9.369`", ",", "9.335`",
      ",", "9.375`", ",", "9.421`", ",", "9.482`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.03443`", ",", "166.`", ",", "7.385`", ",", "7.501`", ",", "7.293`", 
     ",", "7.364`", ",", "7.367`", ",", "7.461`", ",", "7.288`", ",", 
     "7.275`", ",", "7.447`", ",", "7.441`", ",", "7.348`", ",", "7.379`", 
     ",", "7.393`", ",", "7.344`", ",", "7.398`", ",", "7.149`", ",", 
     "7.594`", ",", "7.236`", ",", "7.503`", ",", "7.374`", ",", "7.385`", 
     ",", "7.523`", ",", "7.268`", ",", "7.404`", ",", "7.344`", ",", "7.32`",
      ",", "7.432`", ",", "7.345`", ",", "7.422`", ",", "7.381`", ",", 
     "7.386`", ",", "7.478`", ",", "7.259`", ",", "7.383`", ",", "7.38`", ",",
      "7.33`", ",", "7.451`", ",", "7.305`", ",", "7.444`", ",", "7.409`", 
     ",", "7.328`", ",", "7.308`", ",", "7.453`", ",", "7.428`", ",", 
     "7.261`", ",", "7.165`", ",", "7.533`", ",", "7.336`", ",", "7.274`", 
     ",", "7.285`", ",", "7.315`", ",", "7.313`", ",", "7.328`", ",", 
     "7.286`", ",", "7.32`", ",", "7.356`", ",", "7.403`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.03982`", ",", "192.`", ",", "5.673`", ",", "5.767`", ",", "5.596`", 
     ",", "5.66`", ",", "5.663`", ",", "5.727`", ",", "5.603`", ",", "5.58`", 
     ",", "5.716`", ",", "5.71`", ",", "5.646`", ",", "5.661`", ",", "5.686`",
      ",", "5.646`", ",", "5.678`", ",", "5.482`", ",", "5.844`", ",", 
     "5.552`", ",", "5.77`", ",", "5.673`", ",", "5.667`", ",", "5.78`", ",", 
     "5.583`", ",", "5.69`", ",", "5.637`", ",", "5.623`", ",", "5.71`", ",", 
     "5.637`", ",", "5.709`", ",", "5.657`", ",", "5.68`", ",", "5.752`", ",",
      "5.568`", ",", "5.68`", ",", "5.663`", ",", "5.647`", ",", "5.705`", 
     ",", "5.608`", ",", "5.721`", ",", "5.696`", ",", "5.626`", ",", 
     "5.617`", ",", "5.709`", ",", "5.713`", ",", "5.571`", ",", "5.471`", 
     ",", "5.816`", ",", "5.638`", ",", "5.59`", ",", "5.593`", ",", "5.619`",
      ",", "5.617`", ",", "5.64`", ",", "5.596`", ",", "5.623`", ",", 
     "5.651`", ",", "5.687`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.04563`", ",", "220.`", ",", "4.387`", ",", "4.461`", ",", "4.326`", 
     ",", "4.379`", ",", "4.382`", ",", "4.425`", ",", "4.334`", ",", 
     "4.308`", ",", "4.417`", ",", "4.408`", ",", "4.368`", ",", "4.371`", 
     ",", "4.402`", ",", "4.369`", ",", "4.386`", ",", "4.232`", ",", 
     "4.526`", ",", "4.289`", ",", "4.465`", ",", "4.394`", ",", "4.376`", 
     ",", "4.466`", ",", "4.32`", ",", "4.401`", ",", "4.356`", ",", "4.348`",
      ",", "4.415`", ",", "4.359`", ",", "4.415`", ",", "4.366`", ",", 
     "4.396`", ",", "4.454`", ",", "4.298`", ",", "4.399`", ",", "4.373`", 
     ",", "4.382`", ",", "4.392`", ",", "4.335`", ",", "4.424`", ",", 
     "4.408`", ",", "4.348`", ",", "4.346`", ",", "4.402`", ",", "4.422`", 
     ",", "4.303`", ",", "4.206`", ",", "4.518`", ",", "4.361`", ",", 
     "4.327`", ",", "4.323`", ",", "4.344`", ",", "4.345`", ",", "4.37`", ",",
      "4.327`", ",", "4.347`", ",", "4.37`", ",", "4.397`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.05268`", ",", "254.`", ",", "3.319`", ",", "3.375`", ",", "3.274`", 
     ",", "3.314`", ",", "3.319`", ",", "3.345`", ",", "3.281`", ",", 
     "3.254`", ",", "3.341`", ",", "3.329`", ",", "3.306`", ",", "3.302`", 
     ",", "3.334`", ",", "3.307`", ",", "3.316`", ",", "3.196`", ",", "3.43`",
      ",", "3.243`", ",", "3.38`", ",", "3.331`", ",", "3.305`", ",", 
     "3.374`", ",", "3.272`", ",", "3.331`", ",", "3.292`", ",", "3.29`", ",",
      "3.339`", ",", "3.303`", ",", "3.335`", ",", "3.298`", ",", "3.329`", 
     ",", "3.375`", ",", "3.246`", ",", "3.335`", ",", "3.302`", ",", 
     "3.332`", ",", "3.304`", ",", "3.281`", ",", "3.347`", ",", "3.338`", 
     ",", "3.288`", ",", "3.291`", ",", "3.32`", ",", "3.35`", ",", "3.25`", 
     ",", "3.163`", ",", "3.435`", ",", "3.299`", ",", "3.281`", ",", "3.27`",
      ",", "3.286`", ",", "3.293`", ",", "3.313`", ",", "3.274`", ",", 
     "3.287`", ",", "3.306`", ",", "3.327`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.06057`", ",", "292.`", ",", "2.508`", ",", "2.549`", ",", "2.477`", 
     ",", "2.504`", ",", "2.511`", ",", "2.526`", ",", "2.48`", ",", "2.455`",
      ",", "2.524`", ",", "2.511`", ",", "2.499`", ",", "2.491`", ",", 
     "2.521`", ",", "2.499`", ",", "2.505`", ",", "2.411`", ",", "2.596`", 
     ",", "2.449`", ",", "2.554`", ",", "2.523`", ",", "2.492`", ",", 
     "2.544`", ",", "2.476`", ",", "2.519`", ",", "2.485`", ",", "2.486`", 
     ",", "2.523`", ",", "2.503`", ",", "2.512`", ",", "2.489`", ",", 
     "2.516`", ",", "2.553`", ",", "2.449`", ",", "2.525`", ",", "2.49`", ",",
      "2.531`", ",", "2.48`", ",", "2.48`", ",", "2.527`", ",", "2.524`", ",",
      "2.482`", ",", "2.488`", ",", "2.502`", ",", "2.536`", ",", "2.451`", 
     ",", "2.377`", ",", "2.606`", ",", "2.492`", ",", "2.487`", ",", 
     "2.471`", ",", "2.482`", ",", "2.495`", ",", "2.509`", ",", "2.474`", 
     ",", "2.482`", ",", "2.498`", ",", "2.513`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.07011`", ",", "338.`", ",", "1.835`", ",", "1.863`", ",", "1.817`", 
     ",", "1.832`", ",", "1.839`", ",", "1.847`", ",", "1.815`", ",", 
     "1.793`", ",", "1.847`", ",", "1.835`", ",", "1.828`", ",", "1.821`", 
     ",", "1.844`", ",", "1.828`", ",", "1.832`", ",", "1.761`", ",", 
     "1.902`", ",", "1.792`", ",", "1.868`", ",", "1.851`", ",", "1.818`", 
     ",", "1.856`", ",", "1.815`", ",", "1.846`", ",", "1.814`", ",", 
     "1.818`", ",", "1.847`", ",", "1.839`", ",", "1.83`", ",", "1.821`", ",",
      "1.841`", ",", "1.87`", ",", "1.789`", ",", "1.853`", ",", "1.817`", 
     ",", "1.863`", ",", "1.8`", ",", "1.817`", ",", "1.847`", ",", "1.848`", 
     ",", "1.815`", ",", "1.821`", ",", "1.827`", ",", "1.86`", ",", "1.787`",
      ",", "1.73`", ",", "1.913`", ",", "1.821`", ",", "1.828`", ",", 
     "1.808`", ",", "1.815`", ",", "1.833`", ",", "1.84`", ",", "1.811`", ",",
      "1.815`", ",", "1.828`", ",", "1.839`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.08089`", ",", "390.`", ",", "1.336`", ",", "1.353`", ",", "1.327`", 
     ",", "1.334`", ",", "1.34`", ",", "1.343`", ",", "1.322`", ",", "1.304`",
      ",", "1.345`", ",", "1.336`", ",", "1.329`", ",", "1.325`", ",", 
     "1.341`", ",", "1.33`", ",", "1.335`", ",", "1.28`", ",", "1.386`", ",", 
     "1.306`", ",", "1.359`", ",", "1.352`", ",", "1.319`", ",", "1.348`", 
     ",", "1.323`", ",", "1.349`", ",", "1.316`", ",", "1.321`", ",", 
     "1.346`", ",", "1.346`", ",", "1.325`", ",", "1.327`", ",", "1.34`", ",",
      "1.363`", ",", "1.3`", ",", "1.352`", ",", "1.319`", ",", "1.363`", ",",
      "1.301`", ",", "1.325`", ",", "1.343`", ",", "1.346`", ",", "1.32`", 
     ",", "1.325`", ",", "1.328`", ",", "1.36`", ",", "1.295`", ",", "1.255`",
      ",", "1.396`", ",", "1.324`", ",", "1.339`", ",", "1.316`", ",", 
     "1.321`", ",", "1.342`", ",", "1.342`", ",", "1.318`", ",", "1.321`", 
     ",", "1.331`", ",", "1.338`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.09293`", ",", "448.`", ",", "0.9705`", ",", "0.9814`", ",", "0.9685`", 
     ",", "0.9697`", ",", "0.974`", ",", "0.9756`", ",", "0.9609`", ",", 
     "0.9462`", ",", "0.9786`", ",", "0.9731`", ",", "0.9628`", ",", "0.964`",
      ",", "0.9721`", ",", "0.9648`", ",", "0.9712`", ",", "0.9286`", ",", 
     "1.008`", ",", "0.95`", ",", "0.986`", ",", "0.9866`", ",", "0.9552`", 
     ",", "0.9772`", ",", "0.963`", ",", "0.985`", ",", "0.9524`", ",", 
     "0.9578`", ",", "0.9809`", ",", "0.9832`", ",", "0.9571`", ",", 
     "0.9654`", ",", "0.9726`", ",", "0.9908`", ",", "0.9444`", ",", 
     "0.9846`", ",", "0.9566`", ",", "0.9951`", ",", "0.94`", ",", "0.9648`", 
     ",", "0.9741`", ",", "0.979`", ",", "0.9587`", ",", "0.9621`", ",", 
     "0.966`", ",", "0.9936`", ",", "0.9347`", ",", "0.9116`", ",", "1.014`", 
     ",", "0.9613`", ",", "0.9794`", ",", "0.9564`", ",", "0.9602`", ",", 
     "0.9816`", ",", "0.9777`", ",", "0.9579`", ",", "0.9594`", ",", 
     "0.9669`", ",", "0.9724`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.1074`", ",", "518.`", ",", "0.6786`", ",", "0.6845`", ",", "0.6806`", 
     ",", "0.6784`", ",", "0.681`", ",", "0.6818`", ",", "0.6722`", ",", 
     "0.6612`", ",", "0.6854`", ",", "0.6837`", ",", "0.6701`", ",", 
     "0.6756`", ",", "0.6768`", ",", "0.6731`", ",", "0.6808`", ",", 
     "0.6485`", ",", "0.7057`", ",", "0.6658`", ",", "0.6881`", ",", 
     "0.6933`", ",", "0.665`", ",", "0.6821`", ",", "0.6742`", ",", "0.6942`",
      ",", "0.6616`", ",", "0.6669`", ",", "0.6891`", ",", "0.6913`", ",", 
     "0.6653`", ",", "0.6765`", ",", "0.6794`", ",", "0.693`", ",", "0.6603`",
      ",", "0.6897`", ",", "0.6678`", ",", "0.6981`", ",", "0.6545`", ",", 
     "0.6768`", ",", "0.6796`", ",", "0.6851`", ",", "0.67`", ",", "0.6718`", 
     ",", "0.6771`", ",", "0.7007`", ",", "0.6473`", ",", "0.6388`", ",", 
     "0.7077`", ",", "0.6718`", ",", "0.69`", ",", "0.6686`", ",", "0.6719`", 
     ",", "0.6915`", ",", "0.6856`", ",", "0.6695`", ",", "0.671`", ",", 
     "0.6761`", ",", "0.6799`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.1236`", ",", "596.`", ",", "0.4707`", ",", "0.4736`", ",", "0.4744`", 
     ",", "0.4709`", ",", "0.472`", ",", "0.4726`", ",", "0.4664`", ",", 
     "0.4586`", ",", "0.4764`", ",", "0.4778`", ",", "0.4616`", ",", 
     "0.4702`", ",", "0.4666`", ",", "0.4655`", ",", "0.4738`", ",", 
     "0.4494`", ",", "0.4897`", ",", "0.4631`", ",", "0.4761`", ",", 
     "0.4834`", ",", "0.459`", ",", "0.4726`", ",", "0.4679`", ",", "0.4862`",
      ",", "0.4551`", ",", "0.4598`", ",", "0.481`", ",", "0.4816`", ",", 
     "0.4593`", ",", "0.4704`", ",", "0.4707`", ",", "0.4806`", ",", 
     "0.4582`", ",", "0.4788`", ",", "0.4629`", ",", "0.4847`", ",", 
     "0.4535`", ",", "0.4712`", ",", "0.4701`", ",", "0.4756`", ",", 
     "0.4644`", ",", "0.4649`", ",", "0.4716`", ",", "0.4914`", ",", 
     "0.4434`", ",", "0.4456`", ",", "0.4884`", ",", "0.4662`", ",", 
     "0.4819`", ",", "0.4633`", ",", "0.4667`", ",", "0.483`", ",", "0.477`", 
     ",", "0.464`", ",", "0.4658`", ",", "0.469`", ",", "0.4716`"}], "]"}], 
   ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.1427`", ",", "688.`", ",", "0.3167`", ",", "0.318`", ",", "0.3206`", 
     ",", "0.3171`", ",", "0.3173`", ",", "0.3178`", ",", "0.314`", ",", 
     "0.3088`", ",", "0.3215`", ",", "0.325`", ",", "0.3077`", ",", "0.3179`",
      ",", "0.3115`", ",", "0.312`", ",", "0.3202`", ",", "0.3023`", ",", 
     "0.3297`", ",", "0.3128`", ",", "0.3195`", ",", "0.3273`", ",", 
     "0.3072`", ",", "0.3178`", ",", "0.3149`", ",", "0.3311`", ",", 
     "0.3032`", ",", "0.307`", ",", "0.3265`", ",", "0.325`", ",", "0.3082`", 
     ",", "0.3172`", ",", "0.3164`", ",", "0.3233`", ",", "0.3086`", ",", 
     "0.322`", ",", "0.3118`", ",", "0.3256`", ",", "0.306`", ",", "0.3187`", 
     ",", "0.3153`", ",", "0.3203`", ",", "0.3123`", ",", "0.3121`", ",", 
     "0.3193`", ",", "0.3355`", ",", "0.2938`", ",", "0.3029`", ",", "0.326`",
      ",", "0.3146`", ",", "0.3261`", ",", "0.3113`", ",", "0.3149`", ",", 
     "0.327`", ",", "0.3222`", ",", "0.3118`", ",", "0.3139`", ",", "0.3156`",
      ",", "0.3173`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.1642`", ",", "792.`", ",", "0.2074`", ",", "0.208`", ",", "0.2107`", 
     ",", "0.2078`", ",", "0.2076`", ",", "0.208`", ",", "0.2058`", ",", 
     "0.2025`", ",", "0.2114`", ",", "0.2156`", ",", "0.1993`", ",", 
     "0.2092`", ",", "0.2022`", ",", "0.2034`", ",", "0.2109`", ",", 
     "0.1979`", ",", "0.2159`", ",", "0.2057`", ",", "0.2086`", ",", 
     "0.2157`", ",", "0.2001`", ",", "0.2079`", ",", "0.2063`", ",", 
     "0.2196`", ",", "0.1964`", ",", "0.1991`", ",", "0.216`", ",", "0.2131`",
      ",", "0.2017`", ",", "0.2081`", ",", "0.2071`", ",", "0.2117`", ",", 
     "0.2022`", ",", "0.2105`", ",", "0.2047`", ",", "0.2123`", ",", 
     "0.2016`", ",", "0.21`", ",", "0.2057`", ",", "0.2101`", ",", "0.2044`", 
     ",", "0.2039`", ",", "0.2105`", ",", "0.2236`", ",", "0.1888`", ",", 
     "0.2012`", ",", "0.2112`", ",", "0.2074`", ",", "0.2142`", ",", 
     "0.2033`", ",", "0.2071`", ",", "0.2152`", ",", "0.2119`", ",", 
     "0.2038`", ",", "0.2061`", ",", "0.2067`", ",", "0.2078`"}], "]"}], ",", 
   
   RowBox[{"LF", "[", 
    RowBox[{
    "0.01904`", ",", "144.`", ",", "20.19`", ",", "20.39`", ",", "20.11`", 
     ",", "20.07`", ",", "20.15`", ",", "20.47`", ",", "19.88`", ",", 
     "20.01`", ",", "20.4`", ",", "20.35`", ",", "20.13`", ",", "20.24`", ",",
      "20.17`", ",", "20.04`", ",", "20.29`", ",", "19.69`", ",", "20.61`", 
     ",", "19.89`", ",", "20.42`", ",", "20.08`", ",", "20.26`", ",", 
     "20.43`", ",", "19.97`", ",", "20.19`", ",", "20.17`", ",", "20.1`", ",",
      "20.23`", ",", "20.28`", ",", "20.07`", ",", "20.33`", ",", "20.12`", 
     ",", "20.38`", ",", "19.93`", ",", "20.12`", ",", "20.23`", ",", 
     "20.01`", ",", "20.39`", ",", "20.07`", ",", "20.28`", ",", "20.21`", 
     ",", "20.07`", ",", "19.99`", ",", "20.5`", ",", "20.21`", ",", "19.98`",
      ",", "19.99`", ",", "20.25`", ",", "20.02`", ",", "19.97`", ",", 
     "19.98`", ",", "20.01`", ",", "20.08`", ",", "19.93`", ",", "19.97`", 
     ",", "20.`", ",", "20.11`", ",", "20.24`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.02195`", ",", "166.`", ",", "16.03`", ",", "16.22`", ",", "15.93`", 
     ",", "15.96`", ",", "16.`", ",", "16.24`", ",", "15.8`", ",", "15.87`", 
     ",", "16.19`", ",", "16.17`", ",", "15.97`", ",", "16.07`", ",", 
     "16.02`", ",", "15.92`", ",", "16.1`", ",", "15.62`", ",", "16.39`", ",",
      "15.78`", ",", "16.24`", ",", "15.96`", ",", "16.08`", ",", "16.25`", 
     ",", "15.84`", ",", "16.05`", ",", "16.`", ",", "15.94`", ",", "16.09`", 
     ",", "16.07`", ",", "15.99`", ",", "16.13`", ",", "15.99`", ",", 
     "16.19`", ",", "15.82`", ",", "15.99`", ",", "16.06`", ",", "15.89`", 
     ",", "16.21`", ",", "15.92`", ",", "16.12`", ",", "16.06`", ",", 
     "15.93`", ",", "15.87`", ",", "16.27`", ",", "16.07`", ",", "15.84`", 
     ",", "15.81`", ",", "16.14`", ",", "15.9`", ",", "15.84`", ",", "15.86`",
      ",", "15.89`", ",", "15.93`", ",", "15.85`", ",", "15.85`", ",", 
     "15.89`", ",", "15.97`", ",", "16.07`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.02539`", ",", "192.`", ",", "12.56`", ",", "12.72`", ",", "12.46`", 
     ",", "12.51`", ",", "12.53`", ",", "12.71`", ",", "12.39`", ",", 
     "12.41`", ",", "12.68`", ",", "12.67`", ",", "12.51`", ",", "12.58`", 
     ",", "12.55`", ",", "12.48`", ",", "12.6`", ",", "12.21`", ",", "12.86`",
      ",", "12.35`", ",", "12.73`", ",", "12.52`", ",", "12.59`", ",", 
     "12.76`", ",", "12.39`", ",", "12.58`", ",", "12.52`", ",", "12.47`", 
     ",", "12.62`", ",", "12.55`", ",", "12.56`", ",", "12.61`", ",", 
     "12.54`", ",", "12.69`", ",", "12.38`", ",", "12.54`", ",", "12.57`", 
     ",", "12.44`", ",", "12.7`", ",", "12.45`", ",", "12.64`", ",", "12.59`",
      ",", "12.48`", ",", "12.43`", ",", "12.73`", ",", "12.61`", ",", 
     "12.39`", ",", "12.33`", ",", "12.7`", ",", "12.47`", ",", "12.39`", ",",
      "12.41`", ",", "12.45`", ",", "12.47`", ",", "12.43`", ",", "12.41`", 
     ",", "12.45`", ",", "12.51`", ",", "12.59`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.02909`", ",", "220.`", ",", "9.957`", ",", "10.09`", ",", "9.855`", 
     ",", "9.922`", ",", "9.934`", ",", "10.06`", ",", "9.824`", ",", 
     "9.826`", ",", "10.04`", ",", "10.03`", ",", "9.91`", ",", "9.962`", ",",
      "9.958`", ",", "9.9`", ",", "9.981`", ",", "9.667`", ",", "10.21`", ",",
      "9.775`", ",", "10.1`", ",", "9.931`", ",", "9.968`", ",", "10.12`", 
     ",", "9.813`", ",", "9.98`", ",", "9.911`", ",", "9.88`", ",", "10.01`", 
     ",", "9.926`", ",", "9.983`", ",", "9.977`", ",", "9.947`", ",", 
     "10.06`", ",", "9.806`", ",", "9.944`", ",", "9.961`", ",", "9.87`", ",",
      "10.06`", ",", "9.861`", ",", "10.02`", ",", "9.983`", ",", "9.888`", 
     ",", "9.852`", ",", "10.07`", ",", "10.`", ",", "9.808`", ",", "9.725`", 
     ",", "10.1`", ",", "9.886`", ",", "9.817`", ",", "9.834`", ",", "9.867`",
      ",", "9.874`", ",", "9.865`", ",", "9.832`", ",", "9.872`", ",", 
     "9.918`", ",", "9.982`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.03359`", ",", "254.`", ",", "7.743`", ",", "7.861`", ",", "7.651`", 
     ",", "7.721`", ",", "7.728`", ",", "7.822`", ",", "7.644`", ",", "7.63`",
      ",", "7.805`", ",", "7.802`", ",", "7.705`", ",", "7.738`", ",", 
     "7.751`", ",", "7.704`", ",", "7.755`", ",", "7.505`", ",", "7.955`", 
     ",", "7.593`", ",", "7.863`", ",", "7.732`", ",", "7.744`", ",", "7.88`",
      ",", "7.627`", ",", "7.765`", ",", "7.7`", ",", "7.68`", ",", "7.787`", 
     ",", "7.705`", ",", "7.779`", ",", "7.741`", ",", "7.743`", ",", 
     "7.838`", ",", "7.616`", ",", "7.741`", ",", "7.74`", ",", "7.688`", ",",
      "7.81`", ",", "7.662`", ",", "7.803`", ",", "7.769`", ",", "7.685`", 
     ",", "7.663`", ",", "7.813`", ",", "7.787`", ",", "7.618`", ",", 
     "7.522`", ",", "7.892`", ",", "7.692`", ",", "7.632`", ",", "7.642`", 
     ",", "7.673`", ",", "7.673`", ",", "7.685`", ",", "7.643`", ",", 
     "7.677`", ",", "7.712`", ",", "7.762`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.03862`", ",", "292.`", ",", "5.994`", ",", "6.089`", ",", "5.915`", 
     ",", "5.979`", ",", "5.985`", ",", "6.049`", ",", "5.92`", ",", "5.896`",
      ",", "6.037`", ",", "6.033`", ",", "5.965`", ",", "5.981`", ",", 
     "6.005`", ",", "5.966`", ",", "5.997`", ",", "5.798`", ",", "6.168`", 
     ",", "5.87`", ",", "6.091`", ",", "5.993`", ",", "5.987`", ",", "6.1`", 
     ",", "5.903`", ",", "6.012`", ",", "5.954`", ",", "5.943`", ",", 
     "6.029`", ",", "5.957`", ",", "6.028`", ",", "5.979`", ",", "6.`", ",", 
     "6.074`", ",", "5.886`", ",", "5.999`", ",", "5.984`", ",", "5.965`", 
     ",", "6.028`", ",", "5.926`", ",", "6.042`", ",", "6.017`", ",", 
     "5.945`", ",", "5.934`", ",", "6.032`", ",", "6.034`", ",", "5.889`", 
     ",", "5.788`", ",", "6.137`", ",", "5.957`", ",", "5.908`", ",", 
     "5.912`", ",", "5.938`", ",", "5.937`", ",", "5.959`", ",", "5.914`", 
     ",", "5.942`", ",", "5.97`", ",", "6.008`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.0447`", ",", "338.`", ",", "4.547`", ",", "4.622`", ",", "4.486`", ",",
      "4.538`", ",", "4.544`", ",", "4.586`", ",", "4.494`", ",", "4.466`", 
     ",", "4.578`", ",", "4.57`", ",", "4.527`", ",", "4.531`", ",", "4.562`",
      ",", "4.529`", ",", "4.546`", ",", "4.391`", ",", "4.687`", ",", 
     "4.449`", ",", "4.625`", ",", "4.554`", ",", "4.536`", ",", "4.625`", 
     ",", "4.48`", ",", "4.563`", ",", "4.513`", ",", "4.509`", ",", "4.574`",
      ",", "4.52`", ",", "4.574`", ",", "4.526`", ",", "4.556`", ",", 
     "4.615`", ",", "4.458`", ",", "4.558`", ",", "4.533`", ",", "4.542`", 
     ",", "4.553`", ",", "4.495`", ",", "4.585`", ",", "4.569`", ",", 
     "4.508`", ",", "4.505`", ",", "4.562`", ",", "4.583`", ",", "4.462`", 
     ",", "4.364`", ",", "4.679`", ",", "4.52`", ",", "4.487`", ",", "4.483`",
      ",", "4.504`", ",", "4.507`", ",", "4.53`", ",", "4.486`", ",", 
     "4.507`", ",", "4.529`", ",", "4.558`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.05158`", ",", "390.`", ",", "3.442`", ",", "3.499`", ",", "3.397`", 
     ",", "3.436`", ",", "3.444`", ",", "3.469`", ",", "3.404`", ",", 
     "3.375`", ",", "3.465`", ",", "3.454`", ",", "3.428`", ",", "3.425`", 
     ",", "3.457`", ",", "3.43`", ",", "3.439`", ",", "3.318`", ",", "3.554`",
      ",", "3.365`", ",", "3.503`", ",", "3.454`", ",", "3.428`", ",", 
     "3.496`", ",", "3.395`", ",", "3.456`", ",", "3.414`", ",", "3.414`", 
     ",", "3.462`", ",", "3.427`", ",", "3.458`", ",", "3.421`", ",", 
     "3.452`", ",", "3.498`", ",", "3.369`", ",", "3.457`", ",", "3.426`", 
     ",", "3.454`", ",", "3.428`", ",", "3.403`", ",", "3.47`", ",", "3.462`",
      ",", "3.41`", ",", "3.413`", ",", "3.444`", ",", "3.474`", ",", 
     "3.373`", ",", "3.285`", ",", "3.559`", ",", "3.422`", ",", "3.404`", 
     ",", "3.393`", ",", "3.409`", ",", "3.417`", ",", "3.437`", ",", 
     "3.397`", ",", "3.41`", ",", "3.429`", ",", "3.45`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.05925`", ",", "448.`", ",", "2.596`", ",", "2.638`", ",", "2.565`", 
     ",", "2.592`", ",", "2.6`", ",", "2.615`", ",", "2.568`", ",", "2.542`", 
     ",", "2.613`", ",", "2.601`", ",", "2.586`", ",", "2.58`", ",", "2.609`",
      ",", "2.588`", ",", "2.593`", ",", "2.498`", ",", "2.685`", ",", 
     "2.537`", ",", "2.643`", ",", "2.611`", ",", "2.58`", ",", "2.632`", ",",
      "2.564`", ",", "2.609`", ",", "2.572`", ",", "2.574`", ",", "2.611`", 
     ",", "2.591`", ",", "2.601`", ",", "2.578`", ",", "2.604`", ",", 
     "2.642`", ",", "2.536`", ",", "2.613`", ",", "2.578`", ",", "2.618`", 
     ",", "2.569`", ",", "2.568`", ",", "2.616`", ",", "2.613`", ",", "2.57`",
      ",", "2.575`", ",", "2.591`", ",", "2.625`", ",", "2.539`", ",", 
     "2.464`", ",", "2.695`", ",", "2.58`", ",", "2.575`", ",", "2.559`", ",",
      "2.57`", ",", "2.584`", ",", "2.597`", ",", "2.562`", ",", "2.571`", 
     ",", "2.586`", ",", "2.602`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.01155`", ",", "144.`", ",", "44.85`", ",", "45.11`", ",", "44.99`", 
     ",", "44.51`", ",", "44.84`", ",", "45.62`", ",", "44.12`", ",", 
     "44.69`", ",", "45.33`", ",", "45.12`", ",", "44.82`", ",", "44.98`", 
     ",", "44.81`", ",", "44.48`", ",", "45.14`", ",", "43.99`", ",", 
     "45.56`", ",", "44.36`", ",", "45.24`", ",", "44.55`", ",", "45.07`", 
     ",", "45.05`", ",", "44.63`", ",", "44.78`", ",", "44.96`", ",", "44.9`",
      ",", "44.72`", ",", "45.31`", ",", "44.34`", ",", "45.19`", ",", 
     "44.69`", ",", "45.23`", ",", "44.34`", ",", "44.64`", ",", "45.02`", 
     ",", "44.66`", ",", "45.05`", ",", "44.84`", ",", "44.88`", ",", 
     "44.88`", ",", "44.62`", ",", "44.57`", ",", "45.54`", ",", "44.76`", 
     ",", "44.6`", ",", "44.92`", ",", "44.57`", ",", "44.46`", ",", "44.57`",
      ",", "44.49`", ",", "44.51`", ",", "44.64`", ",", "44.26`", ",", 
     "44.46`", ",", "44.41`", ",", "44.72`", ",", "44.96`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.01331`", ",", "166.`", ",", "36.09`", ",", "36.34`", ",", "36.14`", 
     ",", "35.84`", ",", "36.07`", ",", "36.67`", ",", "35.52`", ",", 
     "35.91`", ",", "36.47`", ",", "36.33`", ",", "36.05`", ",", "36.2`", ",",
      "36.06`", ",", "35.81`", ",", "36.3`", ",", "35.36`", ",", "36.71`", 
     ",", "35.67`", ",", "36.43`", ",", "35.86`", ",", "36.26`", ",", 
     "36.32`", ",", "35.87`", ",", "36.05`", ",", "36.15`", ",", "36.08`", 
     ",", "36.04`", ",", "36.42`", ",", "35.73`", ",", "36.38`", ",", 
     "35.96`", ",", "36.4`", ",", "35.67`", ",", "35.94`", ",", "36.21`", ",",
      "35.9`", ",", "36.31`", ",", "36.03`", ",", "36.16`", ",", "36.12`", 
     ",", "35.9`", ",", "35.83`", ",", "36.65`", ",", "36.05`", ",", "35.85`",
      ",", "36.05`", ",", "35.96`", ",", "35.78`", ",", "35.82`", ",", 
     "35.79`", ",", "35.81`", ",", "35.93`", ",", "35.62`", ",", "35.76`", 
     ",", "35.75`", ",", "35.98`", ",", "36.18`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.0154`", ",", "192.`", ",", "28.8`", ",", "29.04`", ",", "28.78`", ",", 
     "28.62`", ",", "28.77`", ",", "29.24`", ",", "28.36`", ",", "28.62`", 
     ",", "29.1`", ",", "29.01`", ",", "28.75`", ",", "28.88`", ",", "28.77`",
      ",", "28.59`", ",", "28.96`", ",", "28.18`", ",", "29.33`", ",", 
     "28.44`", ",", "29.1`", ",", "28.64`", ",", "28.92`", ",", "29.04`", ",",
      "28.58`", ",", "28.79`", ",", "28.82`", ",", "28.75`", ",", "28.8`", 
     ",", "29.02`", ",", "28.56`", ",", "29.03`", ",", "28.7`", ",", "29.05`",
      ",", "28.46`", ",", "28.7`", ",", "28.88`", ",", "28.61`", ",", 
     "29.02`", ",", "28.71`", ",", "28.89`", ",", "28.83`", ",", "28.65`", 
     ",", "28.57`", ",", "29.25`", ",", "28.8`", ",", "28.57`", ",", "28.67`",
      ",", "28.78`", ",", "28.56`", ",", "28.55`", ",", "28.55`", ",", 
     "28.57`", ",", "28.67`", ",", "28.44`", ",", "28.52`", ",", "28.54`", 
     ",", "28.71`", ",", "28.88`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.01764`", ",", "220.`", ",", "23.17`", ",", "23.39`", ",", "23.11`", 
     ",", "23.04`", ",", "23.14`", ",", "23.5`", ",", "22.83`", ",", "22.99`",
      ",", "23.4`", ",", "23.35`", ",", "23.11`", ",", "23.23`", ",", 
     "23.15`", ",", "23.01`", ",", "23.28`", ",", "22.64`", ",", "23.63`", 
     ",", "22.86`", ",", "23.42`", ",", "23.05`", ",", "23.26`", ",", 
     "23.41`", ",", "22.96`", ",", "23.17`", ",", "23.16`", ",", "23.09`", 
     ",", "23.2`", ",", "23.3`", ",", "23.03`", ",", "23.34`", ",", "23.09`", 
     ",", "23.38`", ",", "22.89`", ",", "23.1`", ",", "23.23`", ",", "22.99`",
      ",", "23.38`", ",", "23.06`", ",", "23.26`", ",", "23.2`", ",", 
     "23.04`", ",", "22.96`", ",", "23.52`", ",", "23.19`", ",", "22.95`", 
     ",", "22.99`", ",", "23.22`", ",", "22.98`", ",", "22.94`", ",", 
     "22.95`", ",", "22.98`", ",", "23.05`", ",", "22.89`", ",", "22.93`", 
     ",", "22.96`", ",", "23.09`", ",", "23.23`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.02037`", ",", "254.`", ",", "18.32`", ",", "18.52`", ",", "18.23`", 
     ",", "18.23`", ",", "18.29`", ",", "18.57`", ",", "18.06`", ",", 
     "18.15`", ",", "18.5`", ",", "18.47`", ",", "18.26`", ",", "18.36`", ",",
      "18.31`", ",", "18.2`", ",", "18.4`", ",", "17.88`", ",", "18.71`", ",",
      "18.05`", ",", "18.54`", ",", "18.24`", ",", "18.38`", ",", "18.55`", 
     ",", "18.13`", ",", "18.34`", ",", "18.29`", ",", "18.24`", ",", 
     "18.37`", ",", "18.38`", ",", "18.26`", ",", "18.44`", ",", "18.27`", 
     ",", "18.49`", ",", "18.09`", ",", "18.27`", ",", "18.36`", ",", 
     "18.17`", ",", "18.51`", ",", "18.21`", ",", "18.41`", ",", "18.35`", 
     ",", "18.22`", ",", "18.15`", ",", "18.59`", ",", "18.36`", ",", 
     "18.12`", ",", "18.11`", ",", "18.42`", ",", "18.18`", ",", "18.12`", 
     ",", "18.14`", ",", "18.17`", ",", "18.22`", ",", "18.11`", ",", 
     "18.13`", ",", "18.17`", ",", "18.25`", ",", "18.37`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "0.02342`", ",", "292.`", ",", "14.54`", ",", "14.71`", ",", "14.43`", 
     ",", "14.47`", ",", "14.51`", ",", "14.72`", ",", "14.34`", ",", 
     "14.38`", ",", "14.67`", ",", "14.66`", ",", "14.48`", ",", "14.56`", 
     ",", "14.53`", ",", "14.45`", ",", "14.59`", ",", "14.16`", ",", 
     "14.87`", ",", "14.31`", ",", "14.72`", ",", "14.48`", ",", "14.57`", 
     ",", "14.74`", ",", "14.36`", ",", "14.56`", ",", "14.49`", ",", 
     "14.45`", ",", "14.59`", ",", "14.55`", ",", "14.52`", ",", "14.61`", 
     ",", "14.51`", ",", "14.68`", ",", "14.34`", ",", "14.51`", ",", 
     "14.56`", ",", "14.41`", ",", "14.69`", ",", "14.43`", ",", "14.62`", 
     ",", "14.57`", ",", "14.45`", ",", "14.39`", ",", "14.73`", ",", 
     "14.58`", ",", "14.36`", ",", "14.3`", ",", "14.67`", ",", "14.43`", ",",
      "14.36`", ",", "14.38`", ",", "14.41`", ",", "14.44`", ",", "14.38`", 
     ",", "14.37`", ",", "14.42`", ",", "14.48`", ",", "14.58`"}], "]"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.722485570691852*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"corrdataclassfinal", ";"}], "\[IndentingNewLine]", 
 RowBox[{"dRcorrdataclassfinal", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{
   "expterrordataclassfinal", ",", "residualdataclassfinal", ",", 
    "dRdataclassfinal"}], "}"}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"corrdataclassfinal", "[", 
      RowBox[{"[", 
       RowBox[{"iexpt", ",", "flavour"}], "]"}], "]"}], "[", 
     RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "//", "Length"}], ",", 
   RowBox[{"{", 
    RowBox[{"iexpt", ",", "49"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"flavour", ",", "17"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.722488010165983*^9, 3.7224880575784483`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1120", ",", "1120", ",", "1120", ",", "1120", ",", "1120", ",", "1120", 
     ",", "1120", ",", "1120", ",", "1120", ",", "1120", ",", "1120", ",", 
     "1120", ",", "1120", ",", "1120", ",", "1120", ",", "1120", ",", 
     "1120"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "337", ",", "337", ",", "337", ",", "337", ",", "337", ",", "337", ",", 
     "337", ",", "337", ",", "337", ",", "337", ",", "337", ",", "337", ",", 
     "337", ",", "337", ",", "337", ",", "337", ",", "337"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "250", ",", "250", ",", "250", ",", "250", ",", "250", ",", "250", ",", 
     "250", ",", "250", ",", "250", ",", "250", ",", "250", ",", "250", ",", 
     "250", ",", "250", ",", "250", ",", "250", ",", "250"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "123", ",", "123", ",", "123", ",", "123", ",", "123", ",", "123", ",", 
     "123", ",", "123", ",", "123", ",", "123", ",", "123", ",", "123", ",", 
     "123", ",", "123", ",", "123", ",", "123", ",", "123"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "85", ",", "85", ",", "85", ",", "85", ",", "85", ",", "85", ",", "85", 
     ",", "85", ",", "85", ",", "85", ",", "85", ",", "85", ",", "85", ",", 
     "85", ",", "85", ",", "85", ",", "85"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "96", ",", "96", ",", "96", ",", "96", ",", "96", ",", "96", ",", "96", 
     ",", "96", ",", "96", ",", "96", ",", "96", ",", "96", ",", "96", ",", 
     "96", ",", "96", ",", "96", ",", "96"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "69", ",", "69", ",", "69", ",", "69", ",", "69", ",", "69", ",", "69", 
     ",", "69", ",", "69", ",", "69", ",", "69", ",", "69", ",", "69", ",", 
     "69", ",", "69", ",", "69", ",", "69"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "86", ",", "86", ",", "86", ",", "86", ",", "86", ",", "86", ",", "86", 
     ",", "86", ",", "86", ",", "86", ",", "86", ",", "86", ",", "86", ",", 
     "86", ",", "86", ",", "86", ",", "86"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "38", ",", "38", ",", "38", ",", "38", ",", "38", ",", "38", ",", "38", 
     ",", "38", ",", "38", ",", "38", ",", "38", ",", "38", ",", "38", ",", 
     "38", ",", "38", ",", "38", ",", "38"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "33", ",", "33", ",", "33", ",", "33", ",", "33", ",", "33", ",", "33", 
     ",", "33", ",", "33", ",", "33", ",", "33", ",", "33", ",", "33", ",", 
     "33", ",", "33", ",", "33", ",", "33"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "40", ",", "40", ",", "40", ",", "40", ",", "40", ",", "40", ",", "40", 
     ",", "40", ",", "40", ",", "40", ",", "40", ",", "40", ",", "40", ",", 
     "40", ",", "40", ",", "40", ",", "40"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "38", ",", "38", ",", "38", ",", "38", ",", "38", ",", "38", ",", "38", 
     ",", "38", ",", "38", ",", "38", ",", "38", ",", "38", ",", "38", ",", 
     "38", ",", "38", ",", "38", ",", "38"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "47", ",", "47", ",", "47", ",", "47", ",", "47", ",", "47", ",", "47", 
     ",", "47", ",", "47", ",", "47", ",", "47", ",", "47", ",", "47", ",", 
     "47", ",", "47", ",", "47", ",", "47"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "238", ",", "238", ",", "238", ",", "238", ",", "238", ",", "238", ",", 
     "238", ",", "238", ",", "238", ",", "238", ",", "238", ",", "238", ",", 
     "238", ",", "238", ",", "238", ",", "238", ",", "238"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "30", ",", "30", ",", "30", ",", "30", ",", "30", ",", "30", ",", "30", 
     ",", "30", ",", "30", ",", "30", ",", "30", ",", "30", ",", "30", ",", 
     "30", ",", "30", ",", "30", ",", "30"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "368", ",", "368", ",", "368", ",", "368", ",", "368", ",", "368", ",", 
     "368", ",", "368", ",", "368", ",", "368", ",", "368", ",", "368", ",", 
     "368", ",", "368", ",", "368", ",", "368", ",", "368"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "22", ",", "22", ",", "22", ",", "22", ",", "22", ",", "22", ",", "22", 
     ",", "22", ",", "22", ",", "22", ",", "22", ",", "22", ",", "22", ",", 
     "22", ",", "22", ",", "22", ",", "22"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "22", ",", "22", ",", "22", ",", "22", ",", "22", ",", "22", ",", "22", 
     ",", "22", ",", "22", ",", "22", ",", "22", ",", "22", ",", "22", ",", 
     "22", ",", "22", ",", "22", ",", "22"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "18", ",", "18", ",", "18", ",", "18", ",", "18", ",", "18", ",", "18", 
     ",", "18", ",", "18", ",", "18", ",", "18", ",", "18", ",", "18", ",", 
     "18", ",", "18", ",", "18", ",", "18"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "56", ",", "56", ",", "56", ",", "56", ",", "56", ",", "56", ",", "56", 
     ",", "56", ",", "56", ",", "56", ",", "56", ",", "56", ",", "56", ",", 
     "56", ",", "56", ",", "56", ",", "56"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "118", ",", "118", ",", "118", ",", "118", ",", "118", ",", "118", ",", 
     "118", ",", "118", ",", "118", ",", "118", ",", "118", ",", "118", ",", 
     "118", ",", "118", ",", "118", ",", "118", ",", "118"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "176", ",", "176", ",", "176", ",", "176", ",", "176", ",", "176", ",", 
     "176", ",", "176", ",", "176", ",", "176", ",", "176", ",", "176", ",", 
     "176", ",", "176", ",", "176", ",", "176", ",", "176"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "10", ",", "10", ",", "10", ",", "10", ",", "10", ",", "10", ",", "10", 
     ",", "10", ",", "10", ",", "10", ",", "10", ",", "10", ",", "10", ",", 
     "10", ",", "10", ",", "10", ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "9", ",", "9", ",", "9", ",", "9", ",", "9", ",", "9", ",", "9", ",", "9",
      ",", "9", ",", "9", ",", "9", ",", "9", ",", "9", ",", "9", ",", "9", 
     ",", "9", ",", "9"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "22", ",", "22", ",", "22", ",", "22", ",", "22", ",", "22", ",", "22", 
     ",", "22", ",", "22", ",", "22", ",", "22", ",", "22", ",", "22", ",", 
     "22", ",", "22", ",", "22", ",", "22"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "82", ",", "82", ",", "82", ",", "82", ",", "82", ",", "82", ",", "82", 
     ",", "82", ",", "82", ",", "82", ",", "82", ",", "82", ",", "82", ",", 
     "82", ",", "82", ",", "82", ",", "82"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "150", ",", "150", ",", "150", ",", "150", ",", "150", ",", "150", ",", 
     "150", ",", "150", ",", "150", ",", "150", ",", "150", ",", "150", ",", 
     "150", ",", "150", ",", "150", ",", "150", ",", "150"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "28", ",", "28", ",", "28", ",", "28", ",", "28", ",", "28", ",", "28", 
     ",", "28", ",", "28", ",", "28", ",", "28", ",", "28", ",", "28", ",", 
     "28", ",", "28", ",", "28", ",", "28"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "10", ",", "10", ",", "10", ",", "10", ",", "10", ",", "10", ",", "10", 
     ",", "10", ",", "10", ",", "10", ",", "10", ",", "10", ",", "10", ",", 
     "10", ",", "10", ",", "10", ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "26", ",", "26", ",", "26", ",", "26", ",", "26", ",", "26", ",", "26", 
     ",", "26", ",", "26", ",", "26", ",", "26", ",", "26", ",", "26", ",", 
     "26", ",", "26", ",", "26", ",", "26"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "22", ",", "22", ",", "22", ",", "22", ",", "22", ",", "22", ",", "22", 
     ",", "22", ",", "22", ",", "22", ",", "22", ",", "22", ",", "22", ",", 
     "22", ",", "22", ",", "22", ",", "22"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "222", ",", "222", ",", "222", ",", "222", ",", "222", ",", "222", ",", 
     "222", ",", "222", ",", "222", ",", "222", ",", "222", ",", "222", ",", 
     "222", ",", "222", ",", "222", ",", "222", ",", "222"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "66", ",", "66", ",", "66", ",", "66", ",", "66", ",", "66", ",", "66", 
     ",", "66", ",", "66", ",", "66", ",", "66", ",", "66", ",", "66", ",", 
     "66", ",", "66", ",", "66", ",", "66"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "34", ",", "34", ",", "34", ",", "34", ",", "34", ",", "34", ",", "34", 
     ",", "34", ",", "34", ",", "34", ",", "34", ",", "34", ",", "34", ",", 
     "34", ",", "34", ",", "34", ",", "34"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "8", ",", "8", ",", "8", ",", "8", ",", "8", ",", "8", ",", "8", ",", "8",
      ",", "8", ",", "8", ",", "8", ",", "8", ",", "8", ",", "8", ",", "8", 
     ",", "8", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "92", ",", "92", ",", "92", ",", "92", ",", "92", ",", "92", ",", "92", 
     ",", "92", ",", "92", ",", "92", ",", "92", ",", "92", ",", "92", ",", 
     "92", ",", "92", ",", "92", ",", "92"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "132", ",", "132", ",", "132", ",", "132", ",", "132", ",", "132", ",", 
     "132", ",", "132", ",", "132", ",", "132", ",", "132", ",", "132", ",", 
     "132", ",", "132", ",", "132", ",", "132", ",", "132"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "118", ",", "118", ",", "118", ",", "118", ",", "118", ",", "118", ",", 
     "118", ",", "118", ",", "118", ",", "118", ",", "118", ",", "118", ",", 
     "118", ",", "118", ",", "118", ",", "118", ",", "118"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "66", ",", "66", ",", "66", ",", "66", ",", "66", ",", "66", ",", "66", 
     ",", "66", ",", "66", ",", "66", ",", "66", ",", "66", ",", "66", ",", 
     "66", ",", "66", ",", "66", ",", "66"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "84", ",", "84", ",", "84", ",", "84", ",", "84", ",", "84", ",", "84", 
     ",", "84", ",", "84", ",", "84", ",", "84", ",", "84", ",", "84", ",", 
     "84", ",", "84", ",", "84", ",", "84"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "8", ",", "8", ",", "8", ",", "8", ",", "8", ",", "8", ",", "8", ",", "8",
      ",", "8", ",", "8", ",", "8", ",", "8", ",", "8", ",", "8", ",", "8", 
     ",", "8", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "10", ",", "10", ",", "10", ",", "10", ",", "10", ",", "10", ",", "10", 
     ",", "10", ",", "10", ",", "10", ",", "10", ",", "10", ",", "10", ",", 
     "10", ",", "10", ",", "10", ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "7", ",", "7", ",", "7", ",", "7", ",", "7", ",", "7", ",", "7", ",", "7",
      ",", "7", ",", "7", ",", "7", ",", "7", ",", "7", ",", "7", ",", "7", 
     ",", "7", ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "10", ",", "10", ",", "10", ",", "10", ",", "10", ",", "10", ",", "10", 
     ",", "10", ",", "10", ",", "10", ",", "10", ",", "10", ",", "10", ",", 
     "10", ",", "10", ",", "10", ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "288", ",", "288", ",", "288", ",", "288", ",", "288", ",", "288", ",", 
     "288", ",", "288", ",", "288", ",", "288", ",", "288", ",", "288", ",", 
     "288", ",", "288", ",", "288", ",", "288", ",", "288"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "94", ",", "94", ",", "94", ",", "94", ",", "94", ",", "94", ",", "94", 
     ",", "94", ",", "94", ",", "94", ",", "94", ",", "94", ",", "94", ",", 
     "94", ",", "94", ",", "94", ",", "94"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "45", ",", "45", ",", "45", ",", "45", ",", "45", ",", "45", ",", "45", 
     ",", "45", ",", "45", ",", "45", ",", "45", ",", "45", ",", "45", ",", 
     "45", ",", "45", ",", "45", ",", "45"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "40", ",", "40", ",", "40", ",", "40", ",", "40", ",", "40", ",", "40", 
     ",", "40", ",", "40", ",", "40", ",", "40", ",", "40", ",", "40", ",", 
     "40", ",", "40", ",", "40", ",", "40"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "9", ",", "9", ",", "9", ",", "9", ",", "9", ",", "9", ",", "9", ",", "9",
      ",", "9", ",", "9", ",", "9", ",", "9", ",", "9", ",", "9", ",", "9", 
     ",", "9", ",", "9"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.722488059559349*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"corrdataclassfinal", "[", 
   RowBox[{"[", 
    RowBox[{
     RowBox[{"-", "14"}], ",", "14"}], "]"}], "]"}], "[", 
  RowBox[{"[", "\"\<data\>\"", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.722488576378346*^9, 3.722488582519628*^9}, {
  3.722488612741428*^9, 3.722488612855085*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"LF", "[", 
    RowBox[{"1.269`*^8", ",", "91.19`", ",", "0.07148527168535605`"}], "]"}], 
   ",", 
   RowBox[{"LF", "[", 
    RowBox[{"3.45`*^8", ",", "91.19`", ",", "0.08774397707846443`"}], "]"}], 
   ",", 
   RowBox[{"LF", "[", 
    RowBox[{"9.38`*^8", ",", "91.19`", ",", "0.08627186040048007`"}], "]"}], 
   ",", 
   RowBox[{"LF", "[", 
    RowBox[{"2.549`*^9", ",", "91.19`", ",", "0.13768600263303618`"}], "]"}], 
   ",", 
   RowBox[{"LF", "[", 
    RowBox[{"6.931`*^9", ",", "91.19`", ",", "0.2195759823228939`"}], "]"}], 
   ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.884`*^10", ",", "91.19`", ",", "0.2725090614647587`"}], "]"}], 
   ",", 
   RowBox[{"LF", "[", 
    RowBox[{"5.121`*^10", ",", "91.19`", ",", 
     RowBox[{"-", "0.013186569408800948`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.392`*^11", ",", "91.19`", ",", 
     RowBox[{"-", "0.03044708977390365`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"3.784`*^11", ",", "91.19`", ",", 
     RowBox[{"-", "0.02439762960181808`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.028`*^12", ",", "91.19`", ",", 
     RowBox[{"-", "0.031232626714412674`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"2.796`*^12", ",", "91.19`", ",", "0.015323445581876203`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"7.6`*^12", ",", "91.19`", ",", "0.09650632697165477`"}], "]"}], 
   ",", 
   RowBox[{"LF", "[", 
    RowBox[{"2.066`*^13", ",", "91.19`", ",", "0.10784764430022271`"}], "]"}],
    ",", 
   RowBox[{"LF", "[", 
    RowBox[{"5.616`*^13", ",", "91.19`", ",", "0.10501453685670023`"}], "]"}],
    ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.526`*^14", ",", "91.19`", ",", "0.12176616696896048`"}], "]"}],
    ",", 
   RowBox[{"LF", "[", 
    RowBox[{"4.149`*^14", ",", "91.19`", ",", "0.1275140701559934`"}], "]"}], 
   ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.128`*^15", ",", "91.19`", ",", "0.12581503786278941`"}], "]"}],
    ",", 
   RowBox[{"LF", "[", 
    RowBox[{"3.066`*^15", ",", "91.19`", ",", "0.15798125471254548`"}], "]"}],
    ",", 
   RowBox[{"LF", "[", 
    RowBox[{"8.335`*^15", ",", "91.19`", ",", 
     RowBox[{"-", "0.0679027322484664`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"2.265`*^16", ",", "91.19`", ",", 
     RowBox[{"-", "0.046076489308457286`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"6.159`*^16", ",", "91.19`", ",", "0.0018745085559105793`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.674`*^17", ",", "91.19`", ",", "0.07838609849262262`"}], "]"}],
    ",", 
   RowBox[{"LF", "[", 
    RowBox[{"4.55`*^17", ",", "91.19`", ",", "0.11915714528832769`"}], "]"}], 
   ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.237`*^18", ",", "91.19`", ",", "0.15279876047973162`"}], "]"}],
    ",", 
   RowBox[{"LF", "[", 
    RowBox[{"2.964`*^18", ",", "80.39`", ",", 
     RowBox[{"-", "0.08663488558841975`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"8.058`*^18", ",", "80.39`", ",", 
     RowBox[{"-", "0.08874763117413842`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"2.19`*^19", ",", "80.39`", ",", 
     RowBox[{"-", "0.09371422894256223`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"5.954`*^19", ",", "80.39`", ",", 
     RowBox[{"-", "0.10767801726146896`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.618`*^20", ",", "80.39`", ",", 
     RowBox[{"-", "0.059828405471005625`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"4.399`*^20", ",", "80.39`", ",", 
     RowBox[{"-", "0.018336778547105533`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.195`*^21", ",", "80.39`", ",", "0.02223395170732696`"}], "]"}],
    ",", 
   RowBox[{"LF", "[", 
    RowBox[{"3.25`*^21", ",", "80.39`", ",", "0.026839575240792703`"}], "]"}],
    ",", 
   RowBox[{"LF", "[", 
    RowBox[{"8.836`*^21", ",", "80.39`", ",", "0.0062175349065454015`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"2.402`*^22", ",", "80.39`", ",", "0.03338402901635574`"}], "]"}],
    ",", 
   RowBox[{"LF", "[", 
    RowBox[{"6.529`*^22", ",", "80.39`", ",", "0.020914431989352184`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.774`*^23", ",", "80.39`", ",", "0.0008071868788813191`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"4.824`*^23", ",", "80.39`", ",", 
     RowBox[{"-", "0.0034981898212063964`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.311`*^24", ",", "80.39`", ",", 
     RowBox[{"-", "0.008639686794137316`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"3.565`*^24", ",", "80.39`", ",", 
     RowBox[{"-", "0.02236444796675264`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"9.69`*^24", ",", "80.39`", ",", 
     RowBox[{"-", "0.03048422657760157`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"2.634`*^25", ",", "80.39`", ",", 
     RowBox[{"-", "0.02413506257750134`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"7.16`*^25", ",", "80.39`", ",", 
     RowBox[{"-", "0.03738193111262985`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.946`*^26", ",", "80.39`", ",", "0.012865421126389156`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"5.291`*^26", ",", "80.39`", ",", "0.046802781428471066`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.438`*^27", ",", "80.39`", ",", "0.05628942002634358`"}], "]"}],
    ",", 
   RowBox[{"LF", "[", 
    RowBox[{"3.909`*^27", ",", "80.39`", ",", "0.12131882503520226`"}], "]"}],
    ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.336`*^-12", ",", "91.19`", ",", "0.07148527168535605`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"4.917`*^-13", ",", "91.19`", ",", "0.08774397707846443`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.809`*^-13", ",", "91.19`", ",", "0.08627186040048007`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"6.655`*^-14", ",", "91.19`", ",", "0.13768600263303618`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"2.448`*^-14", ",", "91.19`", ",", "0.2195759823228939`"}], "]"}],
    ",", 
   RowBox[{"LF", "[", 
    RowBox[{"9.007`*^-15", ",", "91.19`", ",", "0.2725090614647587`"}], "]"}],
    ",", 
   RowBox[{"LF", "[", 
    RowBox[{"3.313`*^-15", ",", "91.19`", ",", 
     RowBox[{"-", "0.013186569408800948`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.219`*^-15", ",", "91.19`", ",", 
     RowBox[{"-", "0.03044708977390365`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"4.484`*^-16", ",", "91.19`", ",", 
     RowBox[{"-", "0.02439762960181808`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.649`*^-16", ",", "91.19`", ",", 
     RowBox[{"-", "0.031232626714412674`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"6.069`*^-17", ",", "91.19`", ",", "0.015323445581876203`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"2.232`*^-17", ",", "91.19`", ",", "0.09650632697165477`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"8.213`*^-18", ",", "91.19`", ",", "0.10784764430022271`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"3.021`*^-18", ",", "91.19`", ",", "0.10501453685670023`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.111`*^-18", ",", "91.19`", ",", "0.12176616696896048`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"4.089`*^-19", ",", "91.19`", ",", "0.1275140701559934`"}], "]"}],
    ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.504`*^-19", ",", "91.19`", ",", "0.12581503786278941`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"5.534`*^-20", ",", "91.19`", ",", "0.15798125471254548`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"2.035`*^-20", ",", "91.19`", ",", 
     RowBox[{"-", "0.0679027322484664`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"7.489000000000001`*^-21", ",", "91.19`", ",", 
     RowBox[{"-", "0.046076489308457286`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "2.7550000000000002`*^-21", ",", "91.19`", ",", 
     "0.0018745085559105793`"}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.013`*^-21", ",", "91.19`", ",", "0.07838609849262262`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "3.7289999999999995`*^-22", ",", "91.19`", ",", "0.11915714528832769`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "1.3709999999999998`*^-22", ",", "91.19`", ",", "0.15279876047973162`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"4.449`*^-23", ",", "80.39`", ",", 
     RowBox[{"-", "0.08663488558841975`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.636`*^-23", ",", "80.39`", ",", 
     RowBox[{"-", "0.08874763117413842`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"6.021`*^-24", ",", "80.39`", ",", 
     RowBox[{"-", "0.09371422894256223`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"2.2149999999999998`*^-24", ",", "80.39`", ",", 
     RowBox[{"-", "0.10767801726146896`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"8.148`*^-25", ",", "80.39`", ",", 
     RowBox[{"-", "0.059828405471005625`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"2.9970000000000002`*^-25", ",", "80.39`", ",", 
     RowBox[{"-", "0.018336778547105533`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.102`*^-25", ",", "80.39`", ",", "0.02223395170732696`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "4.0560000000000005`*^-26", ",", "80.39`", ",", "0.026839575240792703`"}],
     "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.492`*^-26", ",", "80.39`", ",", "0.0062175349065454015`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "5.490000000000001`*^-27", ",", "80.39`", ",", "0.03338402901635574`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"2.019`*^-27", ",", "80.39`", ",", "0.020914431989352184`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"7.43`*^-28", ",", "80.39`", ",", "0.0008071868788813191`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"2.7330000000000003`*^-28", ",", "80.39`", ",", 
     RowBox[{"-", "0.0034981898212063964`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.0049999999999999`*^-28", ",", "80.39`", ",", 
     RowBox[{"-", "0.008639686794137316`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"3.699`*^-29", ",", "80.39`", ",", 
     RowBox[{"-", "0.02236444796675264`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.36`*^-29", ",", "80.39`", ",", 
     RowBox[{"-", "0.03048422657760157`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"5.0060000000000006`*^-30", ",", "80.39`", ",", 
     RowBox[{"-", "0.02413506257750134`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{"1.8410000000000003`*^-30", ",", "80.39`", ",", 
     RowBox[{"-", "0.03738193111262985`"}]}], "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "6.7749999999999995`*^-31", ",", "80.39`", ",", "0.012865421126389156`"}],
     "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "2.4920000000000003`*^-31", ",", "80.39`", ",", "0.046802781428471066`"}],
     "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "9.170000000000001`*^-32", ",", "80.39`", ",", "0.05628942002634358`"}], 
    "]"}], ",", 
   RowBox[{"LF", "[", 
    RowBox[{
    "3.3730000000000003`*^-32", ",", "80.39`", ",", "0.12131882503520226`"}], 
    "]"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.7224885844674177`*^9, 3.722488614398902*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"PlotMarkerList", "[", "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}], "&"}], "/@", 
    RowBox[{"Range", "[", "10", "]"}]}], ")"}], "//", "Flatten"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"\[FilledCircle]\"\>", ",", "\<\"\[FilledSquare]\"\>", 
   ",", "\<\"\[FilledDiamond]\"\>", ",", "\<\"\[FilledUpTriangle]\"\>", 
   ",", "\<\"\[FilledDownTriangle]\"\>", ",", "\<\"\[EmptyCircle]\"\>", 
   ",", "\<\"\[EmptySquare]\"\>", ",", "\<\"\[EmptyDiamond]\"\>", 
   ",", "\<\"\[EmptyUpTriangle]\"\>", ",", "\<\"\[EmptyDownTriangle]\"\>", 
   ",", "\<\"\[Times]\"\>", ",", "\<\"\[CircleMinus]\"\>", ",", 
   "\[FivePointedStar]", ",", "\<\"\[FilledCircle]\"\>", 
   ",", "\<\"\[FilledSquare]\"\>", ",", "\<\"\[FilledDiamond]\"\>", 
   ",", "\<\"\[FilledUpTriangle]\"\>", ",", "\<\"\[FilledDownTriangle]\"\>", 
   ",", "\<\"\[EmptyCircle]\"\>", ",", "\<\"\[EmptySquare]\"\>", 
   ",", "\<\"\[EmptyDiamond]\"\>", ",", "\<\"\[EmptyUpTriangle]\"\>", 
   ",", "\<\"\[EmptyDownTriangle]\"\>", ",", "\<\"\[Times]\"\>", 
   ",", "\<\"\[CircleMinus]\"\>", ",", "\[FivePointedStar]", 
   ",", "\<\"\[FilledCircle]\"\>", ",", "\<\"\[FilledSquare]\"\>", 
   ",", "\<\"\[FilledDiamond]\"\>", ",", "\<\"\[FilledUpTriangle]\"\>", 
   ",", "\<\"\[FilledDownTriangle]\"\>", ",", "\<\"\[EmptyCircle]\"\>", 
   ",", "\<\"\[EmptySquare]\"\>", ",", "\<\"\[EmptyDiamond]\"\>", 
   ",", "\<\"\[EmptyUpTriangle]\"\>", ",", "\<\"\[EmptyDownTriangle]\"\>", 
   ",", "\<\"\[Times]\"\>", ",", "\<\"\[CircleMinus]\"\>", ",", 
   "\[FivePointedStar]", ",", "\<\"\[FilledCircle]\"\>", 
   ",", "\<\"\[FilledSquare]\"\>", ",", "\<\"\[FilledDiamond]\"\>", 
   ",", "\<\"\[FilledUpTriangle]\"\>", ",", "\<\"\[FilledDownTriangle]\"\>", 
   ",", "\<\"\[EmptyCircle]\"\>", ",", "\<\"\[EmptySquare]\"\>", 
   ",", "\<\"\[EmptyDiamond]\"\>", ",", "\<\"\[EmptyUpTriangle]\"\>", 
   ",", "\<\"\[EmptyDownTriangle]\"\>", ",", "\<\"\[Times]\"\>", 
   ",", "\<\"\[CircleMinus]\"\>", ",", "\[FivePointedStar]", 
   ",", "\<\"\[FilledCircle]\"\>", ",", "\<\"\[FilledSquare]\"\>", 
   ",", "\<\"\[FilledDiamond]\"\>", ",", "\<\"\[FilledUpTriangle]\"\>", 
   ",", "\<\"\[FilledDownTriangle]\"\>", ",", "\<\"\[EmptyCircle]\"\>", 
   ",", "\<\"\[EmptySquare]\"\>", ",", "\<\"\[EmptyDiamond]\"\>", 
   ",", "\<\"\[EmptyUpTriangle]\"\>", ",", "\<\"\[EmptyDownTriangle]\"\>", 
   ",", "\<\"\[Times]\"\>", ",", "\<\"\[CircleMinus]\"\>", ",", 
   "\[FivePointedStar]", ",", "\<\"\[FilledCircle]\"\>", 
   ",", "\<\"\[FilledSquare]\"\>", ",", "\<\"\[FilledDiamond]\"\>", 
   ",", "\<\"\[FilledUpTriangle]\"\>", ",", "\<\"\[FilledDownTriangle]\"\>", 
   ",", "\<\"\[EmptyCircle]\"\>", ",", "\<\"\[EmptySquare]\"\>", 
   ",", "\<\"\[EmptyDiamond]\"\>", ",", "\<\"\[EmptyUpTriangle]\"\>", 
   ",", "\<\"\[EmptyDownTriangle]\"\>", ",", "\<\"\[Times]\"\>", 
   ",", "\<\"\[CircleMinus]\"\>", ",", "\[FivePointedStar]", 
   ",", "\<\"\[FilledCircle]\"\>", ",", "\<\"\[FilledSquare]\"\>", 
   ",", "\<\"\[FilledDiamond]\"\>", ",", "\<\"\[FilledUpTriangle]\"\>", 
   ",", "\<\"\[FilledDownTriangle]\"\>", ",", "\<\"\[EmptyCircle]\"\>", 
   ",", "\<\"\[EmptySquare]\"\>", ",", "\<\"\[EmptyDiamond]\"\>", 
   ",", "\<\"\[EmptyUpTriangle]\"\>", ",", "\<\"\[EmptyDownTriangle]\"\>", 
   ",", "\<\"\[Times]\"\>", ",", "\<\"\[CircleMinus]\"\>", ",", 
   "\[FivePointedStar]", ",", "\<\"\[FilledCircle]\"\>", 
   ",", "\<\"\[FilledSquare]\"\>", ",", "\<\"\[FilledDiamond]\"\>", 
   ",", "\<\"\[FilledUpTriangle]\"\>", ",", "\<\"\[FilledDownTriangle]\"\>", 
   ",", "\<\"\[EmptyCircle]\"\>", ",", "\<\"\[EmptySquare]\"\>", 
   ",", "\<\"\[EmptyDiamond]\"\>", ",", "\<\"\[EmptyUpTriangle]\"\>", 
   ",", "\<\"\[EmptyDownTriangle]\"\>", ",", "\<\"\[Times]\"\>", 
   ",", "\<\"\[CircleMinus]\"\>", ",", "\[FivePointedStar]", 
   ",", "\<\"\[FilledCircle]\"\>", ",", "\<\"\[FilledSquare]\"\>", 
   ",", "\<\"\[FilledDiamond]\"\>", ",", "\<\"\[FilledUpTriangle]\"\>", 
   ",", "\<\"\[FilledDownTriangle]\"\>", ",", "\<\"\[EmptyCircle]\"\>", 
   ",", "\<\"\[EmptySquare]\"\>", ",", "\<\"\[EmptyDiamond]\"\>", 
   ",", "\<\"\[EmptyUpTriangle]\"\>", ",", "\<\"\[EmptyDownTriangle]\"\>", 
   ",", "\<\"\[Times]\"\>", ",", "\<\"\[CircleMinus]\"\>", ",", 
   "\[FivePointedStar]", ",", "\<\"\[FilledCircle]\"\>", 
   ",", "\<\"\[FilledSquare]\"\>", ",", "\<\"\[FilledDiamond]\"\>", 
   ",", "\<\"\[FilledUpTriangle]\"\>", ",", "\<\"\[FilledDownTriangle]\"\>", 
   ",", "\<\"\[EmptyCircle]\"\>", ",", "\<\"\[EmptySquare]\"\>", 
   ",", "\<\"\[EmptyDiamond]\"\>", ",", "\<\"\[EmptyUpTriangle]\"\>", 
   ",", "\<\"\[EmptyDownTriangle]\"\>", ",", "\<\"\[Times]\"\>", 
   ",", "\<\"\[CircleMinus]\"\>", ",", "\[FivePointedStar]"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.722871604100833*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"residualNsetclassfinal", "//", 
  "Dimensions"}], "\[IndentingNewLine]", 
 RowBox[{"expterrordataclassfinal", "//", 
  "Dimensions"}], "\[IndentingNewLine]", 
 RowBox[{"dRdataclassfinal", "//", "Dimensions"}], "\[IndentingNewLine]", 
 RowBox[{"dtacentralclassfinal", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.7319544100292377`*^9, 3.7319544475755863`*^9}, {
  3.731955181367441*^9, 3.7319551879385157`*^9}}],

Cell[BoxData[
 RowBox[{"{", "47", "}"}]], "Output",
 CellChangeTimes->{{3.731954416481144*^9, 3.7319544490057373`*^9}, 
   3.731955188561555*^9}],

Cell[BoxData[
 RowBox[{"{", "47", "}"}]], "Output",
 CellChangeTimes->{{3.731954416481144*^9, 3.7319544490057373`*^9}, 
   3.731955188578519*^9}],

Cell[BoxData[
 RowBox[{"{", "47", "}"}]], "Output",
 CellChangeTimes->{{3.731954416481144*^9, 3.7319544490057373`*^9}, 
   3.731955188594664*^9}],

Cell[BoxData[
 RowBox[{"{", "47", "}"}]], "Output",
 CellChangeTimes->{{3.731954416481144*^9, 3.7319544490057373`*^9}, 
   3.731955188610955*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"residualNsetclassfinal", "[", 
   RowBox[{"[", "4", "]"}], "]"}], "[", 
  RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dtacentralclassfinal", "[", 
    RowBox[{"[", "4", "]"}], "]"}], "[", 
   RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
  RowBox[{"[", 
   RowBox[{"All", ",", "15"}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.731954458802495*^9, 3.7319544676842737`*^9}, {
  3.73195519341112*^9, 3.731955218350144*^9}}],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   FrameBox[GridBox[{
      {
       ItemBox[
        TagBox[
         RowBox[{"{", 
          RowBox[{
           RowBox[{"LF", "[", 
            RowBox[{
            "0.0125`", ",", "2.114`", ",", "0.1478`", ",", "0.1946`", ",", 
             RowBox[{"-", "0.05326`"}], ",", "0.2815`", ",", 
             RowBox[{"-", "0.03052`"}], ",", 
             RowBox[{"-", "0.03726`"}], ",", "0.3045`", ",", "0.2544`", ",", 
             "0.06136`", ",", "0.2581`", ",", "0.03557`", ",", "0.5393`", ",", 
             RowBox[{"-", "0.3859`"}], ",", "0.09821`", ",", "0.2115`", ",", 
             "0.02768`", ",", "0.3272`", ",", "0.1949`", ",", "0.1308`", ",", 
             "0.1775`", ",", "0.1217`", ",", "0.05305`", ",", "0.225`", ",", 
             "0.7815`", ",", 
             RowBox[{"-", "0.396`"}], ",", 
             RowBox[{"-", "0.1392`"}], ",", "0.4718`", ",", 
             RowBox[{"-", "0.5044`"}], ",", "0.8574`", ",", "0.074`", ",", 
             "0.1842`", ",", "0.1313`", ",", "0.1809`", ",", "1.178`", ",", 
             RowBox[{"-", "0.8508`"}], ",", 
             RowBox[{"-", "0.2767`"}], ",", "0.6765`", ",", 
             RowBox[{"-", "0.7864`"}], ",", "0.8417`", ",", "0.3382`", ",", 
             "0.01515`", ",", "0.6429`", ",", 
             RowBox[{"-", "0.5771`"}], ",", "0.249`", ",", "0.04936`", ",", 
             RowBox[{"-", "0.03768`"}], ",", "0.3303`", ",", "0.5038`", ",", 
             RowBox[{"-", "0.3781`"}], ",", "0.1811`", ",", "0.06642`", ",", 
             RowBox[{"-", "0.08368`"}], ",", "0.2931`", ",", "0.2447`", ",", 
             "0.4597`", ",", "0.1514`", ",", "0.1522`"}], "]"}], ",", 
           TemplateBox[{"121"},
            "OutputSizeLimit`Skeleton",
            DisplayFunction->(FrameBox[
              RowBox[{"\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}],
               Background -> GrayLevel[0.75], 
              BaseStyle -> {
               "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                ShowStringCharacters -> False}, BaselinePosition -> Baseline, 
              ContentPadding -> False, FrameMargins -> {{1, 1}, {1, 2}}, 
              FrameStyle -> None, RoundingRadius -> 7]& )], ",", 
           RowBox[{"LF", "[", 
            RowBox[{"0.675`", ",", "9.951`", ",", 
             RowBox[{"-", "0.5649`"}], ",", 
             RowBox[{"-", "0.6344`"}], ",", 
             RowBox[{"-", "0.5726`"}], ",", 
             RowBox[{"-", "0.5504`"}], ",", 
             RowBox[{"-", "0.5877`"}], ",", 
             TemplateBox[{"45"},
              "OutputSizeLimit`Skeleton",
              DisplayFunction->(FrameBox[
                
                RowBox[{
                 "\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
                Background -> GrayLevel[0.75], 
                BaseStyle -> {
                 "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                  ShowStringCharacters -> False}, BaselinePosition -> 
                Baseline, ContentPadding -> False, 
                FrameMargins -> {{1, 1}, {1, 2}}, FrameStyle -> None, 
                RoundingRadius -> 7]& )], ",", 
             RowBox[{"-", "0.946`"}], ",", 
             RowBox[{"-", "0.6427`"}], ",", 
             RowBox[{"-", "0.488`"}], ",", 
             RowBox[{"-", "0.5109`"}], ",", 
             RowBox[{"-", "0.495`"}], ",", 
             RowBox[{"-", "0.565`"}], ",", 
             RowBox[{"-", "0.5648`"}]}], "]"}]}], "}"}],
         Short[#, 5]& ],
        BaseStyle->{Deployed -> False},
        StripOnInput->False]},
      {GridBox[{
         {
          TagBox[
           TooltipBox[
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource[
                "FEStrings", "sizeBriefExplanation"], StandardForm],
               ImageSizeCache->{74., {2., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarCategory",
             StripOnInput->False],
            StyleBox[
             DynamicBox[
              ToBoxes[
               FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
               StandardForm]], DynamicUpdating -> True, StripOnInput -> 
             False]],
           Annotation[#, 
            Style[
             Dynamic[
              FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"]], 
             DynamicUpdating -> True], "Tooltip"]& ], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{67., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{67., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 32, 25904995082918537737, 5/2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{73., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{73., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 32, 25904995082918537737, 5 2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{56., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 32, 25904995082918537737, Infinity],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{100., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{100., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           ButtonFunction:>FrontEndExecute[{
              FrontEnd`SetOptions[
              FrontEnd`$FrontEnd, 
               FrontEnd`PreferencesSettings -> {"Page" -> "Evaluation"}], 
              FrontEnd`FrontEndToken["PreferencesDialog"]}],
           Evaluator->None,
           Method->"Preemptive"]}
        },
        AutoDelete->False,
        FrameStyle->GrayLevel[0.85],
        GridBoxDividers->{"Columns" -> {False, {True}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
        GridBoxSpacings->{"Columns" -> {{2}}}]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], 
         Offset[1.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Background->RGBColor[0.9657, 0.9753, 0.9802],
    FrameMargins->{{12, 12}, {0, 15}},
    FrameStyle->GrayLevel[0.85],
    RoundingRadius->5,
    StripOnInput->False],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  Out[32]]], "Output",
 CellChangeTimes->{{3.731954464011859*^9, 3.7319544682611523`*^9}, {
  3.7319551979569407`*^9, 3.731955218957762*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7", ",", "8", 
   ",", "9", ",", "10", ",", "11", ",", "12", ",", "13", ",", "14", ",", "15",
    ",", "16", ",", "17", ",", "18", ",", "19", ",", "20", ",", "21", ",", 
   "22", ",", "23", ",", "24", ",", "25", ",", "26", ",", "27", ",", "28", 
   ",", "29", ",", "30", ",", "31", ",", "32", ",", "33", ",", "34", ",", 
   "35", ",", "36", ",", "37", ",", "38", ",", "39", ",", "40", ",", "41", 
   ",", "42", ",", "43", ",", "44", ",", "45", ",", "46", ",", "47", ",", 
   "48", ",", "49", ",", "50", ",", "51", ",", "52", ",", "53", ",", "54", 
   ",", "55", ",", "56", ",", "57", ",", "58", ",", "59", ",", "60", ",", 
   "61", ",", "62", ",", "63", ",", "64", ",", "65", ",", "66", ",", "67", 
   ",", "68", ",", "69", ",", "70", ",", "71", ",", "72", ",", "73", ",", 
   "74", ",", "75", ",", "76", ",", "77", ",", "78", ",", "79", ",", "80", 
   ",", "81", ",", "82", ",", "83", ",", "84", ",", "85", ",", "86", ",", 
   "87", ",", "88", ",", "89", ",", "90", ",", "91", ",", "92", ",", "93", 
   ",", "94", ",", "95", ",", "96", ",", "97", ",", "98", ",", "99", ",", 
   "100", ",", "101", ",", "102", ",", "103", ",", "104", ",", "105", ",", 
   "106", ",", "107", ",", "108", ",", "109", ",", "110", ",", "111", ",", 
   "112", ",", "113", ",", "114", ",", "115", ",", "116", ",", "117", ",", 
   "118", ",", "119", ",", "120", ",", "121", ",", "122", ",", "123"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.731954464011859*^9, 3.7319544682611523`*^9}, {
  3.7319551979569407`*^9, 3.7319552189707336`*^9}}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"GatherByNptSpecified", "[", 
     RowBox[{"specifieddatain_", ",", "ptindexlistin_"}], "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"specifieddata", "=", "specifieddatain"}], ",", 
        RowBox[{"ptindexlist", "=", "ptindexlistin"}], ",", "Npt1", ",", 
        "Npt2", ",", "outputin"}], "}"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Npt1", "=", 
        RowBox[{"Length", "[", "specifieddata", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Npt2", "=", 
        RowBox[{"Length", "[", "ptindexlist", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"Npt1", "\[NotEqual]", "Npt2"}], ",", 
         RowBox[{
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<error, the length of input data should be the same as the ipt \
index list, {Ndata, Niptlist} = \>\"", ",", 
            RowBox[{"{", 
             RowBox[{"Npt1", ",", "Npt2"}], "}"}]}], "]"}], ";", 
          RowBox[{"Abort", "[", "]"}]}]}], " ", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
        "gather", " ", "the", " ", "specified", " ", "data", " ", "by", " ", 
         "the", " ", "pt", " ", "index"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"outputin", "=", 
        RowBox[{"GatherBy", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"ptindexlist", ",", "specifieddata"}], "}"}], "//", 
           "Transpose"}], ",", 
          RowBox[{
           RowBox[{"#", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "&"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
        "the", " ", "dimension", " ", "of", " ", "the", " ", "output", " ", 
         "is", " ", 
         RowBox[{"{", 
          RowBox[{"groups", ",", 
           RowBox[{"data", " ", "in", " ", "the", " ", "same", " ", "group"}],
            ",", " ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"pt", " ", "index"}], ",", " ", "data"}], "}"}]}], 
          "}"}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
        "we", " ", "only", " ", "take", " ", "the", " ", "data", " ", 
         "part"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"outputin", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "All", ",", "2"}], "]"}], "]"}]}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DeleteDuplicatesByNptSpecified", "[", 
    RowBox[{"specifieddatain_", ",", "ptindexlistin_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"specifieddata", "=", "specifieddatain"}], ",", 
       RowBox[{"ptindexlist", "=", "ptindexlistin"}], ",", "Npt1", ",", 
       "Npt2", ",", "outputin"}], "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Npt1", "=", 
       RowBox[{"Length", "[", "specifieddata", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Npt2", "=", 
       RowBox[{"Length", "[", "ptindexlist", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Npt1", "\[NotEqual]", "Npt2"}], ",", 
        RowBox[{
         RowBox[{"Print", "[", 
          RowBox[{
          "\"\<error, the length of input data should be the same as the ipt \
index list, {Ndata, Niptlist} = \>\"", ",", 
           RowBox[{"{", 
            RowBox[{"Npt1", ",", "Npt2"}], "}"}]}], "]"}], ";", 
         RowBox[{"Abort", "[", "]"}]}]}], " ", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
       "delete", " ", "the", " ", "duplicate", " ", "data", " ", "by", " ", 
        "the", " ", "specified", " ", "data", " ", "by", " ", "the", " ", 
        "pt", " ", "index"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"outputin", "=", 
       RowBox[{"DeleteDuplicatesBy", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"ptindexlist", ",", "specifieddata"}], "}"}], "//", 
          "Transpose"}], ",", 
         RowBox[{
          RowBox[{"#", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "&"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
       "the", " ", "dimension", " ", "of", " ", "the", " ", "output", " ", 
        "is", " ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"left", " ", "data"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"pt", " ", "index"}], ",", " ", "data"}], "}"}]}], 
         "}"}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
       "we", " ", "only", " ", "take", " ", "the", " ", "data", " ", "part"}],
        "*)"}], "\[IndentingNewLine]", 
      RowBox[{"outputin", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "2"}], "]"}], "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.731955388394079*^9, 3.7319553988669443`*^9}, 
   3.731955444537608*^9, {3.731969193195204*^9, 3.731969244374816*^9}, {
   3.731969291629718*^9, 3.731969467882964*^9}, {3.731969560469057*^9, 
   3.73196958364359*^9}, {3.731970238783201*^9, 3.731970280411231*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"GatherByNptSpecified", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"dRdataclassfinal", "[", 
     RowBox[{"[", "44", "]"}], "]"}], "[", 
    RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"dtacentralclassfinal", "[", 
      RowBox[{"[", "44", "]"}], "]"}], "[", 
     RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "15"}], "]"}], "]"}]}], " ", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"iptpos", "=", 
     RowBox[{
      RowBox[{"Position", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"dtacentralclassfinal", "[", 
          RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
         RowBox[{"[", "\"\<label\>\"", "]"}], "]"}], ",", "\"\<ipt\>\""}], 
       "]"}], "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"dRdataclassfinal", "[", 
        RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"\"\<exptinfo\>\"", ",", "\"\<exptid\>\""}], "]"}], "]"}], 
      ",", 
      RowBox[{
       RowBox[{"DeleteDuplicatesByNptSpecified", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"dRdataclassfinal", "[", 
           RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
          RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"dtacentralclassfinal", "[", 
            RowBox[{"[", "iexpt", "]"}], "]"}], "[", 
           RowBox[{"[", "\"\<data\>\"", "]"}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "iptpos"}], "]"}], "]"}]}], " ", "]"}], "//", 
       "Length"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"iexpt", ",", 
     RowBox[{"Length", "[", "dRdataclassfinal", "]"}]}], "}"}]}], 
  "\[IndentingNewLine]", "]"}]}], "Input",
 CellChangeTimes->{{3.731955527769594*^9, 3.731955602559729*^9}, {
  3.731969480122364*^9, 3.731969487419548*^9}, {3.731969592388649*^9, 
  3.731969601338038*^9}, {3.731969635387418*^9, 3.731969727857152*^9}, {
  3.731969759520783*^9, 3.73196978355492*^9}, {3.7319698886958847`*^9, 
  3.731969971948606*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"LF", "[", 
      RowBox[{"0.05256`", ",", "400.`", ",", "1.201005642159936`"}], "]"}], 
     ",", 
     RowBox[{"LF", "[", 
      RowBox[{"0.04756`", ",", "400.`", ",", "1.201005642159936`"}], "]"}]}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"LF", "[", 
      RowBox[{"0.06749`", ",", "400.`", ",", "0.5566356550743045`"}], "]"}], 
     ",", 
     RowBox[{"LF", "[", 
      RowBox[{"0.03704`", ",", "400.`", ",", "0.5566356550743045`"}], "]"}]}],
     "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"LF", "[", 
      RowBox[{"0.09577`", ",", "400.`", ",", "0.2927159786110933`"}], "]"}], 
     ",", 
     RowBox[{"LF", "[", 
      RowBox[{"0.0261`", ",", "400.`", ",", "0.2927159786110933`"}], "]"}]}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"LF", "[", 
      RowBox[{"0.1292`", ",", "400.`", ",", "1.2257923967785085`"}], "]"}], 
     ",", 
     RowBox[{"LF", "[", 
      RowBox[{"0.01933`", ",", "400.`", ",", "1.2257923967785085`"}], "]"}]}],
     "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"LF", "[", 
      RowBox[{"0.224`", ",", "400.`", ",", "0.6591875977481676`"}], "]"}], 
     ",", 
     RowBox[{"LF", "[", 
      RowBox[{"0.01115`", ",", "400.`", ",", "0.6591875977481676`"}], "]"}]}],
     "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.731955556068194*^9, 3.731955603781268*^9}, {
   3.73196947770019*^9, 3.7319694881104*^9}, 3.7319696057621098`*^9, 
   3.731969731687729*^9, {3.731969768639284*^9, 3.731969784286112*^9}, {
   3.731969938196865*^9, 3.7319699725498533`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"160", ",", "1120"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"101", ",", "337"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"102", ",", "250"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"104", ",", "123"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"108", ",", "85"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"109", ",", "96"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"110", ",", "69"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"111", ",", "86"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"124", ",", "38"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"125", ",", "33"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"126", ",", "40"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"127", ",", "38"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"147", ",", "47"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"201", ",", "119"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"203", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"204", ",", "184"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"225", ",", "11"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"227", ",", "11"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"234", ",", "9"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"260", ",", "28"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"261", ",", "29"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"504", ",", "72"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"514", ",", "110"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"145", ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"169", ",", "9"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"267", ",", "11"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"268", ",", "41"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"535", ",", "90"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"240", ",", "14"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"241", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"281", ",", "13"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"266", ",", "11"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"538", ",", "133"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"245", ",", "33"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"246", ",", "17"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"247", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"542", ",", "158"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"544", ",", "140"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"249", ",", "33"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"250", ",", "42"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"565", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"566", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"567", ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"568", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"545", ",", "185"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"252", ",", "48"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"253", ",", "45"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.731955556068194*^9, 3.731955603781268*^9}, {
   3.73196947770019*^9, 3.7319694881104*^9}, 3.7319696057621098`*^9, 
   3.731969731687729*^9, {3.731969768639284*^9, 3.731969784286112*^9}, {
   3.731969938196865*^9, 3.731969972560298*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Transpose", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "2", ",", "2", ",", "2"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "1", ",", "2", ",", "1"}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"4", ",", "5", ",", "6"}], "}"}]}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.731973474393278*^9, 3.731973530541638*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", "4"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2", ",", "2"}], "}"}], ",", "5"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "1", ",", "2", ",", "1"}], "}"}], ",", "6"}], "}"}]}],
   "}"}]], "Output",
 CellChangeTimes->{{3.731973489211122*^9, 3.731973531446939*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"processdatatotsv", "[", 
  RowBox[{
   RowBox[{"readcorrconfigfile6", "[", 
    RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "2", ",", "0"}],
   "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim meta: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1120", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"337", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"250", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"123", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"85", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"96", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"69", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"86", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"38", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"33", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"40", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"38", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"47", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"238", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"30", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"368", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"22", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"22", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"18", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"56", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"58", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"131", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"198", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"9", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"22", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"82", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"165", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"28", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"26", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"22", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"244", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"66", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"34", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"298", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"258", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"66", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"84", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"7", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"329", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"95", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"45", ",", "6"}], "}"}]}], "}"}]}],
  SequenceForm["dim meta: ", CompressedData["
1:eJxTTMoPymNiYGDQB2IQncDCwMAGpAMZIfQvBghdDaVDoXQClHaF0mFQWg1K
K0JpDTRxfSj9DkrLQekCqH1iDKi0EJS2gNJWULoZSh+D0lxQmhNNfxCUXgql
ZdDUS6Gp/wKlnaC0EpTmgNJaUHcyMaKqC0FTBzOfHY3vCdUXD+XrQmkAXoYP
SA==
   "]],
  Editable->False]], "Print",
 CellChangeTimes->{3.731973698842813*^9, 3.7319743731319513`*^9, 
  3.7319745804385557`*^9, 3.731974680562579*^9, 3.731974788182819*^9, 
  3.731974943453712*^9, 3.731975028407218*^9, 3.731977225060288*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim vec: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "1120", "}"}], ",", 
     RowBox[{"{", "337", "}"}], ",", 
     RowBox[{"{", "250", "}"}], ",", 
     RowBox[{"{", "123", "}"}], ",", 
     RowBox[{"{", "85", "}"}], ",", 
     RowBox[{"{", "96", "}"}], ",", 
     RowBox[{"{", "69", "}"}], ",", 
     RowBox[{"{", "86", "}"}], ",", 
     RowBox[{"{", "38", "}"}], ",", 
     RowBox[{"{", "33", "}"}], ",", 
     RowBox[{"{", "40", "}"}], ",", 
     RowBox[{"{", "38", "}"}], ",", 
     RowBox[{"{", "47", "}"}], ",", 
     RowBox[{"{", "238", "}"}], ",", 
     RowBox[{"{", "30", "}"}], ",", 
     RowBox[{"{", "368", "}"}], ",", 
     RowBox[{"{", "22", "}"}], ",", 
     RowBox[{"{", "22", "}"}], ",", 
     RowBox[{"{", "18", "}"}], ",", 
     RowBox[{"{", "56", "}"}], ",", 
     RowBox[{"{", "58", "}"}], ",", 
     RowBox[{"{", "131", "}"}], ",", 
     RowBox[{"{", "198", "}"}], ",", 
     RowBox[{"{", "10", "}"}], ",", 
     RowBox[{"{", "9", "}"}], ",", 
     RowBox[{"{", "22", "}"}], ",", 
     RowBox[{"{", "82", "}"}], ",", 
     RowBox[{"{", "165", "}"}], ",", 
     RowBox[{"{", "28", "}"}], ",", 
     RowBox[{"{", "10", "}"}], ",", 
     RowBox[{"{", "26", "}"}], ",", 
     RowBox[{"{", "22", "}"}], ",", 
     RowBox[{"{", "244", "}"}], ",", 
     RowBox[{"{", "66", "}"}], ",", 
     RowBox[{"{", "34", "}"}], ",", 
     RowBox[{"{", "8", "}"}], ",", 
     RowBox[{"{", "298", "}"}], ",", 
     RowBox[{"{", "258", "}"}], ",", 
     RowBox[{"{", "66", "}"}], ",", 
     RowBox[{"{", "84", "}"}], ",", 
     RowBox[{"{", "8", "}"}], ",", 
     RowBox[{"{", "10", "}"}], ",", 
     RowBox[{"{", "7", "}"}], ",", 
     RowBox[{"{", "10", "}"}], ",", 
     RowBox[{"{", "329", "}"}], ",", 
     RowBox[{"{", "95", "}"}], ",", 
     RowBox[{"{", "45", "}"}]}], "}"}]}],
  SequenceForm[
  "dim vec: ", {{1120}, {337}, {250}, {123}, {85}, {96}, {69}, {86}, {38}, {
   33}, {40}, {38}, {47}, {238}, {30}, {368}, {22}, {22}, {18}, {56}, {58}, {
   131}, {198}, {10}, {9}, {22}, {82}, {165}, {28}, {10}, {26}, {22}, {244}, {
   66}, {34}, {8}, {298}, {258}, {66}, {84}, {8}, {10}, {7}, {10}, {329}, {
   95}, {45}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.731973698842813*^9, 3.7319743731319513`*^9, 
  3.7319745804385557`*^9, 3.731974680562579*^9, 3.731974788182819*^9, 
  3.731974943453712*^9, 3.731975028407218*^9, 3.73197722507266*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "47", "}"}], ",", 
     RowBox[{"{", "47", "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{47}, {47}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.731973698842813*^9, 3.7319743731319513`*^9, 
  3.7319745804385557`*^9, 3.731974680562579*^9, 3.731974788182819*^9, 
  3.731974943453712*^9, 3.731975028407218*^9, 3.731977225083885*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLOall_AbsSens_newSens_formula_cutbrokenpoints_\
NoHighlight/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLOall_AbsSens_newSens_formula_cutbrokenpoints_\
NoHighlight/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{3.731973698842813*^9, 3.7319743731319513`*^9, 
  3.7319745804385557`*^9, 3.731974680562579*^9, 3.731974788182819*^9, 
  3.731974943453712*^9, 3.731975028407218*^9, 3.731977225094192*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLOall_AbsSens_newSens_formula_cutbrokenpoints_\
NoHighlight/expt_error.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLOall_AbsSens_newSens_formula_cutbrokenpoints_\
NoHighlight/expt_error.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{3.731973698842813*^9, 3.7319743731319513`*^9, 
  3.7319745804385557`*^9, 3.731974680562579*^9, 3.731974788182819*^9, 
  3.731974943453712*^9, 3.731975028407218*^9, 3.7319772257338247`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"5440", ",", "6"}], "}"}], ",", 
     RowBox[{"{", "5439", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{5440, 6}, {5439}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.731973698842813*^9, 3.7319743731319513`*^9, 
  3.7319745804385557`*^9, 3.731974680562579*^9, 3.731974788182819*^9, 
  3.731974943453712*^9, 3.731975028407218*^9, 3.731977225899168*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "47", "}"}], ",", 
     RowBox[{"{", "47", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{47}, {47}, {}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.731973698842813*^9, 3.7319743731319513`*^9, 
  3.7319745804385557`*^9, 3.731974680562579*^9, 3.731974788182819*^9, 
  3.731974943453712*^9, 3.731975028407218*^9, 3.7319772259108467`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLOall_AbsSens_newSens_formula_cutbrokenpoints_\
NoHighlight/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLOall_AbsSens_newSens_formula_cutbrokenpoints_\
NoHighlight/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{3.731973698842813*^9, 3.7319743731319513`*^9, 
  3.7319745804385557`*^9, 3.731974680562579*^9, 3.731974788182819*^9, 
  3.731974943453712*^9, 3.731975028407218*^9, 3.7319772259214497`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLOall_AbsSens_newSens_formula_cutbrokenpoints_\
NoHighlight/expt_error_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLOall_AbsSens_newSens_formula_cutbrokenpoints_\
NoHighlight/expt_error_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{3.731973698842813*^9, 3.7319743731319513`*^9, 
  3.7319745804385557`*^9, 3.731974680562579*^9, 3.731974788182819*^9, 
  3.731974943453712*^9, 3.731975028407218*^9, 3.7319772264056187`*^9}]
}, Open  ]],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   FrameBox[GridBox[{
      {
       ItemBox[
        TagBox[
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              
              RowBox[{"\<\"InFit\"\>", ",", "\<\"Type\"\>", ",", "\<\"ID\"\>",
                ",", "\<\"pt\"\>", ",", "\<\"x\"\>", ",", "\<\"mu\"\>"}], 
              "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "1", ",", "1", ",", "160", ",", "1", ",", "0.008`", ",", 
               "17.32`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "1", ",", "1", ",", "160", ",", "2", ",", "0.013`", ",", 
               "17.32`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "1", ",", "1", ",", "160", ",", "3", ",", "0.032`", ",", 
               "17.32`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "1", ",", "1", ",", "160", ",", "4", ",", "0.08`", ",", 
               "17.32`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "1", ",", "1", ",", "160", ",", "5", ",", "0.13`", ",", 
               "17.32`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "1", ",", "1", ",", "160", ",", "6", ",", "0.013`", ",", 
               "22.36`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "1", ",", "1", ",", "160", ",", "7", ",", "0.032`", ",", 
               "22.36`"}], "}"}], ",", 
             TemplateBox[{"5425"},
              "OutputSizeLimit`Skeleton",
              DisplayFunction->(FrameBox[
                
                RowBox[{
                 "\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
                Background -> GrayLevel[0.75], 
                BaseStyle -> {
                 "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                  ShowStringCharacters -> False}, BaselinePosition -> 
                Baseline, ContentPadding -> False, 
                FrameMargins -> {{1, 1}, {1, 2}}, FrameStyle -> None, 
                RoundingRadius -> 7]& )], ",", 
             RowBox[{"{", 
              RowBox[{
              "0", ",", "2", ",", "253", ",", "39", ",", 
               "0.020610695797328146`", ",", "164.88556637862516`"}], "}"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{
              "0", ",", "2", ",", "253", ",", "40", ",", 
               "0.017761000112606274`", ",", "142.08800090085018`"}], "}"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{
              "0", ",", "2", ",", "253", ",", "41", ",", 
               "0.018238438118435472`", ",", "145.90750494748377`"}], "}"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{
              "0", ",", "2", ",", "253", ",", "42", ",", 
               "0.018787046734385904`", ",", "150.29637387508723`"}], "}"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{
              "0", ",", "2", ",", "253", ",", "43", ",", 
               "0.01940078928806764`", ",", "155.2063143045411`"}], "}"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{
              "0", ",", "2", ",", "253", ",", "44", ",", 
               "0.02043052250922624`", ",", "163.44418007380992`"}], "}"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{
              "0", ",", "2", ",", "253", ",", "45", ",", 
               "0.02303029594360437`", ",", "184.24236754883498`"}], "}"}]}], 
            "}"}], ",", 
           RowBox[{"{", 
            TemplateBox[{"1"},
             "OutputSizeLimit`Skeleton",
             DisplayFunction->(FrameBox[
               
               RowBox[{
                "\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
               Background -> GrayLevel[0.75], 
               BaseStyle -> {
                "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                 ShowStringCharacters -> False}, BaselinePosition -> Baseline,
                ContentPadding -> False, FrameMargins -> {{1, 1}, {1, 2}}, 
               FrameStyle -> None, RoundingRadius -> 7]& )], "}"}], ",", 
           "residualNormList$910998"}], "}"}],
         Short[#, 5]& ],
        BaseStyle->{Deployed -> False},
        StripOnInput->False]},
      {GridBox[{
         {
          TagBox[
           TooltipBox[
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource[
                "FEStrings", "sizeBriefExplanation"], StandardForm],
               ImageSizeCache->{74., {2., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarCategory",
             StripOnInput->False],
            StyleBox[
             DynamicBox[
              ToBoxes[
               FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
               StandardForm]], DynamicUpdating -> True, StripOnInput -> 
             False]],
           Annotation[#, 
            Style[
             Dynamic[
              FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"]], 
             DynamicUpdating -> True], "Tooltip"]& ], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{67., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 91, 25904995082918537737, 5/2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{73., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 91, 25904995082918537737, 5 2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{56., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 91, 25904995082918537737, Infinity],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{100., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{100., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           ButtonFunction:>FrontEndExecute[{
              FrontEnd`SetOptions[
              FrontEnd`$FrontEnd, 
               FrontEnd`PreferencesSettings -> {"Page" -> "Evaluation"}], 
              FrontEnd`FrontEndToken["PreferencesDialog"]}],
           Evaluator->None,
           Method->"Preemptive"]}
        },
        AutoDelete->False,
        FrameStyle->GrayLevel[0.85],
        GridBoxDividers->{"Columns" -> {False, {True}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
        GridBoxSpacings->{"Columns" -> {{2}}}]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], 
         Offset[1.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Background->RGBColor[0.9657, 0.9753, 0.9802],
    FrameMargins->{{12, 12}, {0, 15}},
    FrameStyle->GrayLevel[0.85],
    RoundingRadius->5,
    StripOnInput->False],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  Out[91]]], "Output",
 CellChangeTimes->{3.731973701210176*^9, 3.7319743738682947`*^9, 
  3.731974581267511*^9, 3.7319746813887177`*^9, 3.73197478910634*^9, 
  3.731974944416195*^9, 3.731975029977043*^9, 3.731977226633559*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"processdatatotsv", "[", 
  RowBox[{
   RowBox[{"readcorrconfigfile6", "[", 
    RowBox[{"configDir", ",", "configfilename"}], "]"}], ",", "5", ",", "0"}],
   "]"}]], "Input",
 CellChangeTimes->{{3.731977298981443*^9, 3.731977299662051*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLOall_AbsSens_newSens_formula_cutbrokenpoints_\
NoHighlight/metadata.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLOall_AbsSens_newSens_formula_cutbrokenpoints_\
NoHighlight/metadata.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{3.731977302878269*^9, 3.731977434699093*^9, 
  3.73201668494258*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLOall_AbsSens_newSens_formula_cutbrokenpoints_\
NoHighlight/corrdr_1_f0.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLOall_AbsSens_newSens_formula_cutbrokenpoints_\
NoHighlight/corrdr_1_f0.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{3.731977302878269*^9, 3.731977434699093*^9, 
  3.732016685885607*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"5439", ",", "56"}], "}"}]}],
  SequenceForm["dim: ", {5439, 56}],
  Editable->False]], "Print",
 CellChangeTimes->{3.731977302878269*^9, 3.731977434699093*^9, 
  3.7320166907728863`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"5439", ",", "56"}], "}"}]}],
  SequenceForm["dim: ", {5439, 56}],
  Editable->False]], "Print",
 CellChangeTimes->{3.731977302878269*^9, 3.731977434699093*^9, 
  3.732016690783691*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLOall_AbsSens_newSens_formula_cutbrokenpoints_\
NoHighlight/residual_all_norm_1.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLOall_AbsSens_newSens_formula_cutbrokenpoints_\
NoHighlight/residual_all_norm_1.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{3.731977302878269*^9, 3.731977434699093*^9, 
  3.73201669079432*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLOall_AbsSens_newSens_formula_cutbrokenpoints_\
NoHighlight/residual_all_norm_1_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLOall_AbsSens_newSens_formula_cutbrokenpoints_\
NoHighlight/residual_all_norm_1_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{3.731977302878269*^9, 3.731977434699093*^9, 
  3.732016699279735*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"5440", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5439", ",", "28"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5439", ",", "56"}], "}"}]}], "}"}]}],
  SequenceForm["dim: ", {{5440, 6}, {5439, 28}, {5439, 56}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.731977302878269*^9, 3.731977434699093*^9, 
  3.732016705542492*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dim of raw: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "47", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4021", ",", "56"}], "}"}]}], "}"}]}],
  SequenceForm["dim of raw: ", {{47}, {}, {4021, 56}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.731977302878269*^9, 3.731977434699093*^9, 
  3.732016705553447*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"now writing file: \"\>", 
   "\[InvisibleSpace]", \
"\<\"../plots/Jobs/CT14HERA2NNLOall_AbsSens_newSens_formula_cutbrokenpoints_\
NoHighlight/metadata_RawData.tsv\"\>"}],
  SequenceForm[
  "now writing file: ", 
   "../plots/Jobs/CT14HERA2NNLOall_AbsSens_newSens_formula_cutbrokenpoints_\
NoHighlight/metadata_RawData.tsv"],
  Editable->False]], "Print",
 CellChangeTimes->{3.731977302878269*^9, 3.731977434699093*^9, 
  3.732016705563264*^9}]
}, Open  ]],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   FrameBox[GridBox[{
      {
       ItemBox[
        TagBox[
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              
              RowBox[{"\<\"InFit\"\>", ",", "\<\"Type\"\>", ",", "\<\"ID\"\>",
                ",", "\<\"pt\"\>", ",", "\<\"x\"\>", ",", "\<\"mu\"\>"}], 
              "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "1", ",", "1", ",", "160", ",", "1", ",", "0.008`", ",", 
               "17.32`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "1", ",", "1", ",", "160", ",", "2", ",", "0.013`", ",", 
               "17.32`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "1", ",", "1", ",", "160", ",", "3", ",", "0.032`", ",", 
               "17.32`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "1", ",", "1", ",", "160", ",", "4", ",", "0.08`", ",", 
               "17.32`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "1", ",", "1", ",", "160", ",", "5", ",", "0.13`", ",", 
               "17.32`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "1", ",", "1", ",", "160", ",", "6", ",", "0.013`", ",", 
               "22.36`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "1", ",", "1", ",", "160", ",", "7", ",", "0.032`", ",", 
               "22.36`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "1", ",", "1", ",", "160", ",", "8", ",", "0.08`", ",", 
               "22.36`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "1", ",", "1", ",", "160", ",", "9", ",", "0.13`", ",", 
               "22.36`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "1", ",", "1", ",", "160", ",", "10", ",", "0.013`", ",", 
               "31.62`"}], "}"}], ",", 
             TemplateBox[{"5418"},
              "OutputSizeLimit`Skeleton",
              DisplayFunction->(FrameBox[
                
                RowBox[{
                 "\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
                Background -> GrayLevel[0.75], 
                BaseStyle -> {
                 "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                  ShowStringCharacters -> False}, BaselinePosition -> 
                Baseline, ContentPadding -> False, 
                FrameMargins -> {{1, 1}, {1, 2}}, FrameStyle -> None, 
                RoundingRadius -> 7]& )], ",", 
             RowBox[{"{", 
              RowBox[{
              "0", ",", "2", ",", "253", ",", "35", ",", "0.01535`", ",", 
               "122.8`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "0", ",", "2", ",", "253", ",", "36", ",", "0.01599`", ",", 
               "127.9`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "0", ",", "2", ",", "253", ",", "37", ",", "0.0169`", ",", 
               "135.2`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "0", ",", "2", ",", "253", ",", "38", ",", "0.01833`", ",", 
               "146.6`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "0", ",", "2", ",", "253", ",", "39", ",", "0.02061`", ",", 
               "164.8`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "0", ",", "2", ",", "253", ",", "40", ",", "0.01776`", ",", 
               "142.`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "0", ",", "2", ",", "253", ",", "41", ",", "0.01823`", ",", 
               "145.9`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "0", ",", "2", ",", "253", ",", "42", ",", "0.01878`", ",", 
               "150.2`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "0", ",", "2", ",", "253", ",", "43", ",", "0.0194`", ",", 
               "155.2`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "0", ",", "2", ",", "253", ",", "44", ",", "0.02043`", ",", 
               "163.4`"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "0", ",", "2", ",", "253", ",", "45", ",", "0.02303`", ",", 
               "184.2`"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            TemplateBox[{"1"},
             "OutputSizeLimit`Skeleton",
             DisplayFunction->(FrameBox[
               
               RowBox[{
                "\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
               Background -> GrayLevel[0.75], 
               BaseStyle -> {
                "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                 ShowStringCharacters -> False}, BaselinePosition -> Baseline,
                ContentPadding -> False, FrameMargins -> {{1, 1}, {1, 2}}, 
               FrameStyle -> None, RoundingRadius -> 7]& )], "}"}], ",", 
           RowBox[{"{", 
            TemplateBox[{"1"},
             "OutputSizeLimit`Skeleton",
             DisplayFunction->(FrameBox[
               
               RowBox[{
                "\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
               Background -> GrayLevel[0.75], 
               BaseStyle -> {
                "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                 ShowStringCharacters -> False}, BaselinePosition -> Baseline,
                ContentPadding -> False, FrameMargins -> {{1, 1}, {1, 2}}, 
               FrameStyle -> None, RoundingRadius -> 7]& )], "}"}]}], "}"}],
         Short[#, 5]& ],
        BaseStyle->{Deployed -> False},
        StripOnInput->False]},
      {GridBox[{
         {
          TagBox[
           TooltipBox[
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource[
                "FEStrings", "sizeBriefExplanation"], StandardForm],
               ImageSizeCache->{74., {2., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarCategory",
             StripOnInput->False],
            StyleBox[
             DynamicBox[
              ToBoxes[
               FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
               StandardForm]], DynamicUpdating -> True, StripOnInput -> 
             False]],
           Annotation[#, 
            Style[
             Dynamic[
              FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"]], 
             DynamicUpdating -> True], "Tooltip"]& ], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{67., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 97, 25904995082918537737, 5/2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{73., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 97, 25904995082918537737, 5 2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{56., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 97, 25904995082918537737, Infinity],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{100., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           ButtonFunction:>FrontEndExecute[{
              FrontEnd`SetOptions[
              FrontEnd`$FrontEnd, 
               FrontEnd`PreferencesSettings -> {"Page" -> "Evaluation"}], 
              FrontEnd`FrontEndToken["PreferencesDialog"]}],
           Evaluator->None,
           Method->"Preemptive"]}
        },
        AutoDelete->False,
        FrameStyle->GrayLevel[0.85],
        GridBoxDividers->{"Columns" -> {False, {True}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
        GridBoxSpacings->{"Columns" -> {{2}}}]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], 
         Offset[1.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Background->RGBColor[0.9657, 0.9753, 0.9802],
    FrameMargins->{{12, 12}, {0, 15}},
    FrameStyle->GrayLevel[0.85],
    RoundingRadius->5,
    StripOnInput->False],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  Out[97]]], "Output",
 CellChangeTimes->{3.731977312697744*^9, 3.731977450618454*^9, 
  3.7320167080694427`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
Evaluator->"New Kernel",
WindowSize->{1535, 848},
WindowMargins->{{0, Automatic}, {0, 28}},
FrontEndVersion->"11.0 for Linux x86 (64-bit) (July 28, 2016)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 162, 2, 65, "Section"],
Cell[745, 26, 4077, 68, 665, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4859, 99, 145, 2, 65, "Section"],
Cell[5007, 103, 2163, 35, 167, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7207, 143, 112, 1, 65, "Section"],
Cell[7322, 146, 4136, 107, 356, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[11483, 257, 1872, 44, 223, "Input"],
Cell[13358, 303, 394, 8, 23, "Message"],
Cell[13755, 313, 274, 6, 23, "Message"],
Cell[14032, 321, 360, 7, 23, "Message"],
Cell[14395, 330, 272, 6, 23, "Message"],
Cell[14670, 338, 337, 7, 23, "Message"],
Cell[CellGroupData[{
Cell[15032, 349, 133, 2, 24, "Print"],
Cell[15168, 353, 258, 6, 24, "Print"]
}, Open  ]],
Cell[15441, 362, 394, 8, 23, "Message"],
Cell[15838, 372, 341, 7, 23, "Message"],
Cell[16182, 381, 272, 6, 23, "Message"],
Cell[16457, 389, 342, 7, 23, "Message"],
Cell[16802, 398, 348, 8, 23, "Message"],
Cell[17153, 408, 348, 8, 23, "Message"],
Cell[17504, 418, 505, 10, 23, "Message"],
Cell[18012, 430, 477, 10, 23, "Message"],
Cell[18492, 442, 505, 10, 23, "Message"],
Cell[19000, 454, 342, 7, 23, "Message"],
Cell[19345, 463, 338, 7, 23, "Message"],
Cell[CellGroupData[{
Cell[19708, 474, 133, 2, 24, "Print"],
Cell[19844, 478, 258, 6, 24, "Print"]
}, Open  ]],
Cell[20117, 487, 348, 8, 23, "Message"],
Cell[20468, 497, 341, 7, 23, "Message"],
Cell[20812, 506, 241, 5, 32, "Output"]
}, Open  ]],
Cell[21068, 514, 6300, 132, 801, "Input",
 InitializationCell->True],
Cell[27371, 648, 1506, 37, 228, "Input"],
Cell[28880, 687, 5551, 141, 615, "Input",
 InitializationCell->True],
Cell[34434, 830, 71380, 1564, 6785, "Input",
 InitializationCell->True],
Cell[105817, 2396, 139, 2, 32, "Input"],
Cell[105959, 2400, 92, 1, 30, "Input"],
Cell[CellGroupData[{
Cell[106076, 2405, 748, 21, 80, "Input"],
Cell[106827, 2428, 365, 8, 23, "Message"],
Cell[107195, 2438, 274, 6, 23, "Message"],
Cell[107472, 2446, 121, 2, 30, "Output"],
Cell[107596, 2450, 124, 2, 30, "Output"],
Cell[107723, 2454, 122, 2, 30, "Output"]
}, Open  ]],
Cell[107860, 2459, 2869, 71, 355, "Input"],
Cell[CellGroupData[{
Cell[110754, 2534, 462, 9, 35, "Input"],
Cell[111219, 2545, 554, 11, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[111810, 2561, 363, 8, 35, "Input"],
Cell[112176, 2571, 311, 7, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[112524, 2583, 388, 12, 35, "Input"],
Cell[112915, 2597, 335, 8, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[113287, 2610, 1218, 28, 95, "Input"],
Cell[114508, 2640, 358, 7, 23, "Message"],
Cell[114869, 2649, 1210, 17, 30, "Output"],
Cell[116082, 2668, 1649, 29, 32, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[117780, 2703, 222, 3, 65, "Section"],
Cell[118005, 2708, 2973, 56, 107, "Input",
 InitializationCell->True],
Cell[120981, 2766, 1582, 33, 128, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[122588, 2803, 2557, 48, 337, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[125170, 2855, 1570, 28, 24, "Print"],
Cell[126743, 2885, 1391, 23, 24, "Print"],
Cell[128137, 2910, 1399, 23, 24, "Print"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[129597, 2940, 247, 3, 65, "Section"],
Cell[129847, 2945, 4869, 104, 609, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[134753, 3054, 255, 6, 65, "Section"],
Cell[135011, 3062, 171592, 3477, 15493, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[306640, 6544, 116, 1, 65, "Section"],
Cell[CellGroupData[{
Cell[306781, 6549, 9173, 213, 1404, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[315979, 6766, 5444, 76, 24, "Print"],
Cell[321426, 6844, 5671, 82, 24, "Print"],
Cell[327100, 6928, 5612, 81, 24, "Print"],
Cell[332715, 7011, 11272, 200, 119, "Print"],
Cell[343990, 7213, 5428, 76, 22, "Print"],
Cell[349421, 7291, 5970, 88, 24, "Print"],
Cell[355394, 7381, 5788, 86, 43, "Print"],
Cell[361185, 7469, 6197, 91, 62, "Print"],
Cell[367385, 7562, 5428, 76, 22, "Print"],
Cell[372816, 7640, 5448, 76, 24, "Print"],
Cell[378267, 7718, 6190, 91, 24, "Print"],
Cell[384460, 7811, 5427, 76, 22, "Print"],
Cell[389890, 7889, 5454, 76, 24, "Print"],
Cell[395347, 7967, 5592, 81, 24, "Print"],
Cell[400942, 8050, 6155, 92, 80, "Print"],
Cell[407100, 8144, 5454, 76, 24, "Print"],
Cell[412557, 8222, 6005, 92, 24, "Print"],
Cell[418565, 8316, 5430, 76, 22, "Print"],
Cell[423998, 8394, 5809, 86, 24, "Print"],
Cell[429810, 8482, 5428, 76, 22, "Print"],
Cell[435241, 8560, 5499, 77, 24, "Print"],
Cell[440743, 8639, 6170, 91, 24, "Print"],
Cell[446916, 8732, 6212, 91, 43, "Print"],
Cell[453131, 8825, 5428, 76, 22, "Print"],
Cell[458562, 8903, 5480, 77, 24, "Print"],
Cell[464045, 8982, 5949, 90, 24, "Print"],
Cell[469997, 9074, 5428, 76, 22, "Print"],
Cell[475428, 9152, 5624, 81, 24, "Print"]
}, Open  ]],
Cell[481067, 9236, 671, 12, 50, "Message"],
Cell[481741, 9250, 671, 12, 50, "Message"],
Cell[482415, 9264, 671, 12, 50, "Message"],
Cell[483089, 9278, 749, 13, 23, "Message"],
Cell[483841, 9293, 708, 13, 23, "Message"],
Cell[484552, 9308, 706, 13, 23, "Message"],
Cell[485261, 9323, 708, 13, 23, "Message"],
Cell[485972, 9338, 753, 13, 23, "Message"],
Cell[CellGroupData[{
Cell[486750, 9355, 6103, 90, 24, "Print"],
Cell[492856, 9447, 5566, 80, 22, "Print"],
Cell[498425, 9529, 5428, 76, 22, "Print"],
Cell[503856, 9607, 5571, 78, 24, "Print"],
Cell[509430, 9687, 5428, 76, 22, "Print"],
Cell[514861, 9765, 5494, 77, 24, "Print"],
Cell[520358, 9844, 5671, 82, 24, "Print"],
Cell[526032, 9928, 5807, 84, 24, "Print"],
Cell[531842, 10014, 5763, 84, 24, "Print"],
Cell[537608, 10100, 5428, 76, 22, "Print"],
Cell[543039, 10178, 5598, 78, 24, "Print"],
Cell[548640, 10258, 5430, 76, 22, "Print"],
Cell[554073, 10336, 5891, 85, 24, "Print"],
Cell[559967, 10423, 5891, 85, 24, "Print"],
Cell[565861, 10510, 5891, 85, 24, "Print"],
Cell[571755, 10597, 5893, 85, 24, "Print"],
Cell[577651, 10684, 5891, 85, 24, "Print"],
Cell[583545, 10771, 5891, 85, 24, "Print"],
Cell[589439, 10858, 5891, 85, 24, "Print"],
Cell[595333, 10945, 5891, 85, 24, "Print"],
Cell[601227, 11032, 5891, 85, 24, "Print"],
Cell[607121, 11119, 5891, 85, 24, "Print"],
Cell[613015, 11206, 5891, 85, 24, "Print"],
Cell[618909, 11293, 5890, 85, 24, "Print"],
Cell[624802, 11380, 5893, 85, 24, "Print"],
Cell[630698, 11467, 5893, 85, 24, "Print"],
Cell[636594, 11554, 5891, 85, 24, "Print"],
Cell[642488, 11641, 5891, 85, 24, "Print"],
Cell[648382, 11728, 5891, 85, 24, "Print"],
Cell[654276, 11815, 5891, 85, 24, "Print"],
Cell[660170, 11902, 5891, 85, 24, "Print"],
Cell[666064, 11989, 5891, 85, 24, "Print"],
Cell[671958, 12076, 5891, 85, 24, "Print"],
Cell[677852, 12163, 5893, 85, 24, "Print"],
Cell[683748, 12250, 5891, 85, 24, "Print"],
Cell[689642, 12337, 5893, 85, 24, "Print"],
Cell[695538, 12424, 5893, 85, 24, "Print"],
Cell[701434, 12511, 5893, 85, 24, "Print"],
Cell[707330, 12598, 5891, 85, 24, "Print"],
Cell[713224, 12685, 5891, 85, 24, "Print"],
Cell[719118, 12772, 5891, 85, 24, "Print"],
Cell[725012, 12859, 5893, 85, 24, "Print"],
Cell[730908, 12946, 5891, 85, 24, "Print"],
Cell[736802, 13033, 5891, 85, 24, "Print"],
Cell[742696, 13120, 5447, 76, 24, "Print"],
Cell[748146, 13198, 6124, 95, 24, "Print"],
Cell[754273, 13295, 5428, 76, 22, "Print"],
Cell[759704, 13373, 5691, 84, 24, "Print"],
Cell[765398, 13459, 5701, 84, 24, "Print"],
Cell[771102, 13545, 5727, 86, 24, "Print"],
Cell[776832, 13633, 5703, 85, 24, "Print"],
Cell[782538, 13720, 5707, 84, 24, "Print"],
Cell[788248, 13806, 5715, 84, 24, "Print"],
Cell[793966, 13892, 5693, 84, 24, "Print"],
Cell[799662, 13978, 5697, 84, 24, "Print"],
Cell[805362, 14064, 5759, 87, 24, "Print"],
Cell[811124, 14153, 5702, 85, 24, "Print"],
Cell[816829, 14240, 5707, 84, 24, "Print"],
Cell[822539, 14326, 5711, 84, 24, "Print"],
Cell[828253, 14412, 5693, 84, 24, "Print"],
Cell[833949, 14498, 5681, 83, 24, "Print"],
Cell[839633, 14583, 5727, 86, 24, "Print"],
Cell[845363, 14671, 5705, 85, 24, "Print"],
Cell[851071, 14758, 5707, 84, 24, "Print"],
Cell[856781, 14844, 5701, 84, 24, "Print"],
Cell[862485, 14930, 5691, 84, 24, "Print"],
Cell[868179, 15016, 5701, 84, 24, "Print"],
Cell[873883, 15102, 5604, 82, 24, "Print"],
Cell[879490, 15186, 5604, 82, 24, "Print"],
Cell[885097, 15270, 5713, 84, 24, "Print"],
Cell[890813, 15356, 5734, 86, 24, "Print"],
Cell[896550, 15444, 5803, 88, 24, "Print"],
Cell[902356, 15534, 5739, 86, 24, "Print"],
Cell[908098, 15622, 5706, 84, 24, "Print"],
Cell[913807, 15708, 5691, 84, 24, "Print"],
Cell[919501, 15794, 5699, 84, 24, "Print"],
Cell[925203, 15880, 5602, 82, 24, "Print"],
Cell[930808, 15964, 5602, 82, 24, "Print"],
Cell[936413, 16048, 5713, 84, 24, "Print"],
Cell[942129, 16134, 5734, 86, 24, "Print"],
Cell[947866, 16222, 5803, 88, 24, "Print"],
Cell[953672, 16312, 5739, 86, 24, "Print"],
Cell[959414, 16400, 5707, 84, 24, "Print"],
Cell[965124, 16486, 5693, 84, 24, "Print"],
Cell[970820, 16572, 5697, 84, 24, "Print"],
Cell[976520, 16658, 5604, 82, 24, "Print"],
Cell[982127, 16742, 5602, 82, 24, "Print"],
Cell[987732, 16826, 5713, 84, 24, "Print"],
Cell[993448, 16912, 5734, 86, 24, "Print"],
Cell[999185, 17000, 5803, 88, 24, "Print"],
Cell[1004991, 17090, 5739, 86, 24, "Print"],
Cell[1010733, 17178, 5707, 84, 24, "Print"],
Cell[1016443, 17264, 5693, 84, 24, "Print"],
Cell[1022139, 17350, 5699, 84, 24, "Print"],
Cell[1027841, 17436, 5601, 82, 24, "Print"],
Cell[1033445, 17520, 5602, 82, 24, "Print"],
Cell[1039050, 17604, 5715, 84, 24, "Print"],
Cell[1044768, 17690, 5734, 86, 24, "Print"],
Cell[1050505, 17778, 5805, 88, 24, "Print"],
Cell[1056313, 17868, 5739, 86, 24, "Print"],
Cell[1062055, 17956, 5707, 84, 24, "Print"],
Cell[1067765, 18042, 5691, 84, 24, "Print"],
Cell[1073459, 18128, 5697, 84, 24, "Print"],
Cell[1079159, 18214, 5602, 82, 24, "Print"],
Cell[1084764, 18298, 5604, 82, 24, "Print"],
Cell[1090371, 18382, 5713, 84, 24, "Print"],
Cell[1096087, 18468, 5733, 86, 24, "Print"],
Cell[1101823, 18556, 5803, 88, 24, "Print"],
Cell[1107629, 18646, 5739, 86, 24, "Print"],
Cell[1113371, 18734, 5709, 84, 24, "Print"],
Cell[1119083, 18820, 5691, 84, 24, "Print"],
Cell[1124777, 18906, 5699, 84, 24, "Print"],
Cell[1130479, 18992, 5602, 82, 24, "Print"],
Cell[1136084, 19076, 5602, 82, 24, "Print"],
Cell[1141689, 19160, 5713, 84, 24, "Print"],
Cell[1147405, 19246, 5736, 86, 24, "Print"],
Cell[1153144, 19334, 5805, 88, 24, "Print"],
Cell[1158952, 19424, 5739, 86, 24, "Print"],
Cell[1164694, 19512, 5707, 84, 24, "Print"],
Cell[1170404, 19598, 5691, 84, 24, "Print"],
Cell[1176098, 19684, 5697, 84, 24, "Print"],
Cell[1181798, 19770, 5604, 82, 24, "Print"],
Cell[1187405, 19854, 5602, 82, 24, "Print"],
Cell[1193010, 19938, 5713, 84, 24, "Print"],
Cell[1198726, 20024, 5734, 86, 24, "Print"],
Cell[1204463, 20112, 5803, 88, 24, "Print"],
Cell[1210269, 20202, 5739, 86, 24, "Print"],
Cell[1216011, 20290, 5707, 84, 24, "Print"],
Cell[1221721, 20376, 5691, 84, 24, "Print"],
Cell[1227415, 20462, 5697, 84, 24, "Print"],
Cell[1233115, 20548, 5602, 82, 24, "Print"],
Cell[1238720, 20632, 5602, 82, 24, "Print"],
Cell[1244325, 20716, 5713, 84, 24, "Print"],
Cell[1250041, 20802, 5734, 86, 24, "Print"],
Cell[1255778, 20890, 5805, 88, 24, "Print"],
Cell[1261586, 20980, 5741, 86, 24, "Print"],
Cell[1267330, 21068, 5709, 84, 24, "Print"],
Cell[1273042, 21154, 5691, 84, 24, "Print"],
Cell[1278736, 21240, 5696, 84, 24, "Print"],
Cell[1284435, 21326, 5602, 82, 24, "Print"],
Cell[1290040, 21410, 5602, 82, 24, "Print"],
Cell[1295645, 21494, 5713, 84, 24, "Print"],
Cell[1301361, 21580, 5734, 86, 24, "Print"],
Cell[1307098, 21668, 5805, 88, 24, "Print"],
Cell[1312906, 21758, 5739, 86, 24, "Print"],
Cell[1318648, 21846, 5709, 84, 24, "Print"],
Cell[1324360, 21932, 5690, 84, 24, "Print"],
Cell[1330053, 22018, 5697, 84, 24, "Print"],
Cell[1335753, 22104, 5602, 82, 24, "Print"],
Cell[1341358, 22188, 5604, 82, 24, "Print"],
Cell[1346965, 22272, 5713, 84, 24, "Print"],
Cell[1352681, 22358, 5736, 86, 24, "Print"],
Cell[1358420, 22446, 5803, 88, 24, "Print"],
Cell[1364226, 22536, 5739, 86, 24, "Print"],
Cell[1369968, 22624, 5707, 84, 24, "Print"],
Cell[1375678, 22710, 5691, 84, 24, "Print"],
Cell[1381372, 22796, 5697, 84, 24, "Print"],
Cell[1387072, 22882, 5604, 82, 24, "Print"],
Cell[1392679, 22966, 5604, 82, 24, "Print"],
Cell[1398286, 23050, 5712, 84, 24, "Print"],
Cell[1404001, 23136, 5734, 86, 24, "Print"],
Cell[1409738, 23224, 5803, 88, 24, "Print"],
Cell[1415544, 23314, 5741, 86, 24, "Print"],
Cell[1421288, 23402, 5707, 84, 24, "Print"],
Cell[1426998, 23488, 5691, 84, 24, "Print"],
Cell[1432692, 23574, 5697, 84, 24, "Print"],
Cell[1438392, 23660, 5602, 82, 24, "Print"],
Cell[1443997, 23744, 5604, 82, 24, "Print"],
Cell[1449604, 23828, 5713, 84, 24, "Print"],
Cell[1455320, 23914, 5734, 86, 24, "Print"],
Cell[1461057, 24002, 5805, 88, 24, "Print"],
Cell[1466865, 24092, 5739, 86, 24, "Print"],
Cell[1472607, 24180, 5707, 84, 24, "Print"],
Cell[1478317, 24266, 5691, 84, 24, "Print"],
Cell[1484011, 24352, 5699, 84, 24, "Print"],
Cell[1489713, 24438, 5602, 82, 24, "Print"],
Cell[1495318, 24522, 5602, 82, 24, "Print"],
Cell[1500923, 24606, 5715, 84, 24, "Print"],
Cell[1506641, 24692, 5734, 86, 24, "Print"],
Cell[1512378, 24780, 5803, 88, 24, "Print"],
Cell[1518184, 24870, 5739, 86, 24, "Print"],
Cell[1523926, 24958, 5707, 84, 24, "Print"],
Cell[1529636, 25044, 5691, 84, 24, "Print"],
Cell[1535330, 25130, 5699, 84, 24, "Print"],
Cell[1541032, 25216, 5602, 82, 24, "Print"],
Cell[1546637, 25300, 5602, 82, 24, "Print"],
Cell[1552242, 25384, 5713, 84, 24, "Print"],
Cell[1557958, 25470, 5734, 86, 24, "Print"],
Cell[1563695, 25558, 5803, 88, 24, "Print"],
Cell[1569501, 25648, 5739, 86, 24, "Print"],
Cell[1575243, 25736, 5707, 84, 24, "Print"],
Cell[1580953, 25822, 5693, 84, 24, "Print"],
Cell[1586649, 25908, 5701, 84, 24, "Print"],
Cell[1592353, 25994, 5602, 82, 24, "Print"],
Cell[1597958, 26078, 5604, 82, 24, "Print"],
Cell[1603565, 26162, 5713, 84, 24, "Print"],
Cell[1609281, 26248, 5734, 86, 24, "Print"],
Cell[1615018, 26336, 5803, 88, 24, "Print"],
Cell[1620824, 26426, 5739, 86, 24, "Print"],
Cell[1626566, 26514, 5707, 84, 24, "Print"],
Cell[1632276, 26600, 5693, 84, 24, "Print"],
Cell[1637972, 26686, 5699, 84, 24, "Print"],
Cell[1643674, 26772, 5601, 82, 24, "Print"],
Cell[1649278, 26856, 5602, 82, 24, "Print"],
Cell[1654883, 26940, 5715, 84, 24, "Print"],
Cell[1660601, 27026, 5734, 86, 24, "Print"],
Cell[1666338, 27114, 5803, 88, 24, "Print"],
Cell[1672144, 27204, 5739, 86, 24, "Print"],
Cell[1677886, 27292, 5707, 84, 24, "Print"],
Cell[1683596, 27378, 5691, 84, 24, "Print"],
Cell[1689290, 27464, 5699, 84, 24, "Print"],
Cell[1694992, 27550, 5604, 82, 24, "Print"],
Cell[1700599, 27634, 5601, 82, 24, "Print"],
Cell[1706203, 27718, 5713, 84, 24, "Print"],
Cell[1711919, 27804, 5736, 86, 24, "Print"],
Cell[1717658, 27892, 5805, 88, 24, "Print"],
Cell[1723466, 27982, 5739, 86, 24, "Print"],
Cell[1729208, 28070, 5707, 84, 24, "Print"],
Cell[1734918, 28156, 5691, 84, 24, "Print"],
Cell[1740612, 28242, 5699, 84, 24, "Print"],
Cell[1746314, 28328, 5602, 82, 24, "Print"],
Cell[1751919, 28412, 5601, 82, 24, "Print"],
Cell[1757523, 28496, 5713, 84, 24, "Print"],
Cell[1763239, 28582, 5734, 86, 24, "Print"],
Cell[1768976, 28670, 5803, 88, 24, "Print"],
Cell[1774782, 28760, 5741, 86, 24, "Print"],
Cell[1780526, 28848, 5709, 84, 24, "Print"],
Cell[1786238, 28934, 5691, 84, 24, "Print"],
Cell[1791932, 29020, 5697, 84, 24, "Print"],
Cell[1797632, 29106, 5759, 87, 24, "Print"],
Cell[1803394, 29195, 5697, 85, 24, "Print"],
Cell[1809094, 29282, 5707, 84, 24, "Print"],
Cell[1814804, 29368, 5693, 84, 24, "Print"],
Cell[1820500, 29454, 5697, 84, 24, "Print"],
Cell[1826200, 29540, 5759, 87, 24, "Print"],
Cell[1831962, 29629, 5695, 85, 24, "Print"],
Cell[1837660, 29716, 5707, 84, 24, "Print"],
Cell[1843370, 29802, 5690, 84, 24, "Print"],
Cell[1849063, 29888, 5693, 84, 24, "Print"],
Cell[1854759, 29974, 5759, 87, 24, "Print"],
Cell[1860521, 30063, 5695, 85, 24, "Print"],
Cell[1866219, 30150, 5707, 84, 24, "Print"],
Cell[1871929, 30236, 5691, 84, 24, "Print"],
Cell[1877623, 30322, 5695, 84, 24, "Print"],
Cell[1883321, 30408, 5759, 87, 24, "Print"],
Cell[1889083, 30497, 5695, 85, 24, "Print"],
Cell[1894781, 30584, 5709, 84, 24, "Print"],
Cell[1900493, 30670, 5691, 84, 24, "Print"],
Cell[1906187, 30756, 5693, 84, 24, "Print"],
Cell[1911883, 30842, 5759, 87, 24, "Print"],
Cell[1917645, 30931, 5697, 85, 24, "Print"],
Cell[1923345, 31018, 5709, 84, 24, "Print"],
Cell[1929057, 31104, 5691, 84, 24, "Print"],
Cell[1934751, 31190, 5691, 84, 24, "Print"],
Cell[1940445, 31276, 5759, 87, 24, "Print"],
Cell[1946207, 31365, 5695, 85, 24, "Print"],
Cell[1951905, 31452, 5707, 84, 24, "Print"],
Cell[1957615, 31538, 5693, 84, 24, "Print"],
Cell[1963311, 31624, 5693, 84, 24, "Print"],
Cell[1969007, 31710, 5759, 87, 24, "Print"],
Cell[1974769, 31799, 5695, 85, 24, "Print"],
Cell[1980467, 31886, 5707, 84, 24, "Print"],
Cell[1986177, 31972, 5691, 84, 24, "Print"],
Cell[1991871, 32058, 5695, 84, 24, "Print"],
Cell[1997569, 32144, 5759, 87, 24, "Print"],
Cell[2003331, 32233, 5695, 85, 24, "Print"],
Cell[2009029, 32320, 5707, 84, 24, "Print"],
Cell[2014739, 32406, 5693, 84, 24, "Print"],
Cell[2020435, 32492, 5693, 84, 24, "Print"],
Cell[2026131, 32578, 5759, 87, 24, "Print"],
Cell[2031893, 32667, 5697, 85, 24, "Print"],
Cell[2037593, 32754, 5707, 84, 24, "Print"],
Cell[2043303, 32840, 5691, 84, 24, "Print"],
Cell[2048997, 32926, 5695, 84, 24, "Print"],
Cell[2054695, 33012, 5758, 87, 24, "Print"],
Cell[2060456, 33101, 5695, 85, 24, "Print"],
Cell[2066154, 33188, 5707, 84, 24, "Print"],
Cell[2071864, 33274, 5691, 84, 24, "Print"],
Cell[2077558, 33360, 5695, 84, 24, "Print"],
Cell[2083256, 33446, 5761, 87, 24, "Print"],
Cell[2089020, 33535, 5695, 85, 24, "Print"],
Cell[2094718, 33622, 5707, 84, 24, "Print"],
Cell[2100428, 33708, 5693, 84, 24, "Print"],
Cell[2106124, 33794, 5693, 84, 24, "Print"],
Cell[2111820, 33880, 5759, 87, 24, "Print"],
Cell[2117582, 33969, 5695, 85, 24, "Print"],
Cell[2123280, 34056, 5709, 84, 24, "Print"],
Cell[2128992, 34142, 5691, 84, 24, "Print"],
Cell[2134686, 34228, 5695, 84, 24, "Print"],
Cell[2140384, 34314, 5759, 87, 24, "Print"],
Cell[2146146, 34403, 5695, 85, 24, "Print"],
Cell[2151844, 34490, 5709, 84, 24, "Print"],
Cell[2157556, 34576, 5691, 84, 24, "Print"],
Cell[2163250, 34662, 5695, 84, 24, "Print"],
Cell[2168948, 34748, 5759, 87, 24, "Print"],
Cell[2174710, 34837, 5695, 85, 24, "Print"],
Cell[2180408, 34924, 5707, 84, 24, "Print"],
Cell[2186118, 35010, 5691, 84, 24, "Print"],
Cell[2191812, 35096, 5697, 84, 24, "Print"],
Cell[2197512, 35182, 5759, 87, 24, "Print"],
Cell[2203274, 35271, 5697, 85, 24, "Print"],
Cell[2208974, 35358, 5707, 84, 24, "Print"],
Cell[2214684, 35444, 5693, 84, 24, "Print"],
Cell[2220380, 35530, 5695, 84, 24, "Print"],
Cell[2226078, 35616, 5761, 87, 24, "Print"],
Cell[2231842, 35705, 5697, 85, 24, "Print"],
Cell[2237542, 35792, 5707, 84, 24, "Print"],
Cell[2243252, 35878, 5693, 84, 24, "Print"],
Cell[2248948, 35964, 5695, 84, 24, "Print"],
Cell[2254646, 36050, 5759, 87, 24, "Print"],
Cell[2260408, 36139, 5697, 85, 24, "Print"],
Cell[2266108, 36226, 5709, 84, 24, "Print"],
Cell[2271820, 36312, 5691, 84, 24, "Print"],
Cell[2277514, 36398, 5695, 84, 24, "Print"],
Cell[2283212, 36484, 5759, 87, 24, "Print"],
Cell[2288974, 36573, 5697, 85, 24, "Print"],
Cell[2294674, 36660, 5707, 84, 24, "Print"],
Cell[2300384, 36746, 5707, 83, 24, "Print"],
Cell[2306094, 36831, 5710, 83, 24, "Print"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2311865, 36921, 93, 1, 65, "Section"],
Cell[CellGroupData[{
Cell[2311983, 36926, 143, 2, 30, "Input"],
Cell[2312129, 36930, 92, 2, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2312258, 36937, 1756, 40, 295, "Input"],
Cell[2314017, 36979, 311, 6, 32, "Output"],
Cell[2314331, 36987, 294, 5, 30, "Output"],
Cell[2314628, 36994, 8099, 207, 93, "Output"],
Cell[2322730, 37203, 311, 6, 32, "Output"],
Cell[2323044, 37211, 1488, 23, 52, "Output"],
Cell[2324535, 37236, 356, 6, 32, "Output"],
Cell[2324894, 37244, 382, 6, 32, "Output"],
Cell[2325279, 37252, 347, 7, 23, "Message"],
Cell[2325629, 37261, 8030, 207, 93, "Output"],
Cell[2333662, 37470, 311, 6, 32, "Output"],
Cell[2333976, 37478, 7908, 203, 93, "Output"],
Cell[2341887, 37683, 7906, 203, 93, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2349830, 37891, 160, 3, 32, "Input"],
Cell[2349993, 37896, 47545, 1003, 1984, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2397575, 38904, 176, 3, 35, "Input"],
Cell[2397754, 38909, 116, 2, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2397907, 38916, 396, 9, 35, "Input"],
Cell[2398306, 38927, 200, 3, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2398543, 38935, 500, 13, 35, "Input"],
Cell[2399046, 38950, 171, 4, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2399254, 38959, 585, 11, 52, "Input"],
Cell[2399842, 38972, 93, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2399972, 38978, 501, 14, 55, "Input"],
Cell[2400476, 38994, 169, 4, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2400682, 39003, 915, 25, 35, "Input"],
Cell[2401600, 39030, 168, 4, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2401805, 39039, 794, 21, 35, "Input"],
Cell[2402602, 39062, 5893, 140, 192, "Output"]
}, Open  ]],
Cell[2408510, 39205, 859, 25, 59, "Input"],
Cell[CellGroupData[{
Cell[2409394, 39234, 182, 4, 32, "Input"],
Cell[2409579, 39240, 351, 8, 24, "Print"],
Cell[2409933, 39250, 105, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2410075, 39256, 432, 9, 35, "Input"],
Cell[CellGroupData[{
Cell[2410532, 39269, 494, 10, 24, "Print"],
Cell[2411029, 39281, 540, 9, 24, "Print"],
Cell[2411572, 39292, 366, 4, 24, "Print"]
}, Open  ]],
Cell[2411953, 39299, 132726, 2480, 1199, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2544716, 41784, 462, 10, 35, "Input"],
Cell[CellGroupData[{
Cell[2545203, 41798, 694, 14, 24, "Print"],
Cell[2545900, 41814, 669, 12, 24, "Print"],
Cell[2546572, 41828, 669, 12, 24, "Print"],
Cell[2547244, 41842, 669, 12, 24, "Print"],
Cell[2547916, 41856, 669, 12, 24, "Print"],
Cell[2548588, 41870, 495, 7, 24, "Print"]
}, Open  ]],
Cell[2549098, 41880, 173098, 3391, 1199, "Output"]
}, Open  ]],
Cell[2722211, 45274, 90, 1, 30, "Input"],
Cell[2722304, 45277, 33956, 742, 1643, "Input"],
Cell[CellGroupData[{
Cell[2756285, 46023, 364, 8, 35, "Input"],
Cell[CellGroupData[{
Cell[2756674, 46035, 493, 10, 24, "Print"],
Cell[2757170, 46047, 537, 9, 24, "Print"],
Cell[2757710, 46058, 365, 4, 24, "Print"]
}, Open  ]],
Cell[2758090, 46065, 130863, 2429, 1208, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2888990, 48499, 212, 5, 32, "Input"],
Cell[2889205, 48506, 156971, 2871, 567, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3046213, 51382, 332, 7, 35, "Input"],
Cell[CellGroupData[{
Cell[3046570, 51393, 346, 8, 24, "Print"],
Cell[3046919, 51403, 390, 7, 24, "Print"],
Cell[3047312, 51412, 216, 2, 24, "Print"]
}, Open  ]],
Cell[3047543, 51417, 129203, 2397, 1208, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3176783, 53819, 339, 7, 35, "Input"],
Cell[3177125, 53828, 337, 7, 23, "Message"],
Cell[3177465, 53837, 333, 7, 23, "Message"],
Cell[3177801, 53846, 306, 7, 23, "Message"],
Cell[3178110, 53855, 331, 7, 23, "Message"],
Cell[3178444, 53864, 308, 7, 23, "Message"],
Cell[3178755, 53873, 331, 7, 23, "Message"],
Cell[3179089, 53882, 345, 7, 23, "Message"],
Cell[3179437, 53891, 306, 7, 23, "Message"],
Cell[3179746, 53900, 344, 7, 23, "Message"],
Cell[3180093, 53909, 335, 7, 23, "Message"],
Cell[3180431, 53918, 337, 7, 23, "Message"],
Cell[3180771, 53927, 349, 7, 23, "Message"],
Cell[CellGroupData[{
Cell[3181145, 53938, 547, 13, 24, "Print"],
Cell[3181695, 53953, 210, 2, 24, "Print"]
}, Open  ]],
Cell[3181920, 53958, 170, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3182127, 53965, 577, 13, 59, "Input"],
Cell[CellGroupData[{
Cell[3182729, 53982, 316, 8, 24, "Print"],
Cell[3183048, 53992, 293, 6, 24, "Print"],
Cell[3183344, 54000, 293, 6, 24, "Print"],
Cell[3183640, 54008, 293, 6, 24, "Print"],
Cell[3183936, 54016, 293, 6, 24, "Print"],
Cell[3184232, 54024, 121, 1, 24, "Print"]
}, Open  ]],
Cell[3184368, 54028, 89, 1, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3184494, 54034, 124, 2, 32, "Input"],
Cell[3184621, 54038, 100, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3184758, 54044, 65, 1, 32, "Input"],
Cell[3184826, 54047, 163, 2, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3185026, 54054, 123, 2, 32, "Input"],
Cell[3185152, 54058, 164, 2, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3185353, 54065, 116, 2, 35, "Input"],
Cell[3185472, 54069, 4440, 82, 191, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3189949, 54156, 193, 5, 35, "Input"],
Cell[3190145, 54163, 4438, 82, 191, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3194620, 54250, 246, 6, 35, "Input"],
Cell[3194869, 54258, 4461, 82, 191, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3199367, 54345, 290, 6, 59, "Input"],
Cell[3199660, 54353, 186, 4, 32, "Output"],
Cell[3199849, 54359, 186, 4, 32, "Output"]
}, Open  ]],
Cell[3200050, 54366, 25107, 344, 35, "Input"],
Cell[CellGroupData[{
Cell[3225182, 54714, 205, 4, 32, "Input"],
Cell[3225390, 54720, 6178, 153, 232, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3231605, 54878, 37, 0, 30, "Input"],
Cell[3231645, 54880, 91, 1, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3231773, 54886, 110, 2, 35, "Input"],
Cell[CellGroupData[{
Cell[3231908, 54892, 1317, 24, 24, "Print"],
Cell[3233228, 54918, 1161, 19, 24, "Print"],
Cell[3234392, 54939, 1168, 19, 24, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3235609, 54964, 447, 9, 35, "Input"],
Cell[3236059, 54975, 1078, 15, 24, "Print"],
Cell[3237140, 54992, 1659003, 37426, 1242, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4896180, 92423, 443, 9, 35, "Input"],
Cell[4896626, 92434, 1759214, 38749, 1181, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6655877, 131188, 443, 9, 35, "Input"],
Cell[6656323, 131199, 1709764, 37809, 1191, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8366124, 169013, 463, 10, 35, "Input"],
Cell[8366590, 169025, 1676739, 37404, 1181, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10043366, 206434, 462, 10, 35, "Input"],
Cell[10043831, 206446, 1694869, 37494, 1209, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11738737, 243945, 245, 5, 59, "Input"],
Cell[CellGroupData[{
Cell[11739007, 243954, 1387, 25, 24, "Print"],
Cell[11740397, 243981, 1232, 20, 24, "Print"],
Cell[11741632, 244003, 1238, 20, 24, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[11742919, 244029, 649, 12, 35, "Input"],
Cell[11743571, 244043, 1122, 18, 71, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11744730, 244066, 1233, 27, 148, "Input"],
Cell[11745966, 244095, 3326, 67, 112, "Output"],
Cell[11749295, 244164, 475, 10, 23, "Message"],
Cell[11749773, 244176, 453, 10, 23, "Message"],
Cell[11750229, 244188, 475, 10, 23, "Message"],
Cell[11750707, 244200, 451, 10, 23, "Message"],
Cell[11751161, 244212, 478, 10, 23, "Message"],
Cell[11751642, 244224, 490, 10, 23, "Message"],
Cell[11752135, 244236, 450, 10, 23, "Message"],
Cell[11752588, 244248, 492, 10, 23, "Message"],
Cell[11753083, 244260, 480, 10, 23, "Message"],
Cell[11753566, 244272, 245, 5, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11753848, 244282, 3611, 56, 81, "Input"],
Cell[11757462, 244340, 1102, 18, 71, "Output"]
}, Open  ]],
Cell[11758579, 244361, 213, 4, 35, "Input"],
Cell[CellGroupData[{
Cell[11758817, 244369, 189, 4, 32, "Input"],
Cell[11759009, 244375, 519, 9, 23, "Message"],
Cell[11759531, 244386, 7895, 203, 91, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11767463, 244594, 101, 1, 32, "Input"],
Cell[11767567, 244597, 189, 5, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11767793, 244607, 32, 0, 32, "Input"],
Cell[11767828, 244609, 72, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11767937, 244615, 2174, 29, 32, "Input"],
Cell[11770114, 244646, 526, 9, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11770677, 244660, 3675, 74, 80, "Input"],
Cell[11774355, 244736, 2082, 36, 90, "Output"],
Cell[11776440, 244774, 2108, 36, 90, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11778585, 244815, 1750, 52, 104, "Input"],
Cell[11780338, 244869, 1997, 35, 90, "Output"],
Cell[11782338, 244906, 2009, 35, 90, "Output"],
Cell[11784350, 244943, 243, 4, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11784630, 244952, 339, 7, 35, "Input"],
Cell[CellGroupData[{
Cell[11784994, 244963, 1478, 24, 24, "Print"],
Cell[11786475, 244989, 2221, 35, 43, "Print"],
Cell[11788699, 245026, 1478, 24, 24, "Print"]
}, Open  ]],
Cell[11790192, 245053, 231931, 4684, 717, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12022160, 249742, 80, 1, 35, "Input"],
Cell[CellGroupData[{
Cell[12022265, 249747, 1515, 27, 24, "Print"],
Cell[12023783, 249776, 1358, 22, 24, "Print"],
Cell[12025144, 249800, 1366, 22, 24, "Print"]
}, Open  ]]
}, Open  ]],
Cell[12026537, 249826, 135, 3, 35, "Input"],
Cell[CellGroupData[{
Cell[12026697, 249833, 34, 0, 30, "Input"],
Cell[12026734, 249835, 124, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12026895, 249842, 365, 7, 35, "Input"],
Cell[12027263, 249851, 19457, 365, 370, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12046757, 250221, 152, 4, 35, "Input"],
Cell[12046912, 250227, 18651, 353, 351, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12065600, 250585, 152, 4, 35, "Input"],
Cell[12065755, 250591, 19599, 370, 370, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12085391, 250966, 113, 1, 44, "Subsection"],
Cell[12085507, 250969, 21915, 473, 2259, "Input"],
Cell[12107425, 251444, 81295, 1705, 6052, "Input"],
Cell[CellGroupData[{
Cell[12188745, 253153, 638, 16, 59, "Input"],
Cell[CellGroupData[{
Cell[12189408, 253173, 315, 7, 22, "Print"],
Cell[12189726, 253182, 316, 8, 22, "Print"],
Cell[12190045, 253192, 315, 7, 22, "Print"],
Cell[12190363, 253201, 315, 7, 22, "Print"],
Cell[12190681, 253210, 468, 10, 22, "Print"],
Cell[12191152, 253222, 315, 7, 22, "Print"],
Cell[12191470, 253231, 316, 8, 22, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[12191835, 253245, 1042, 27, 35, "Input"],
Cell[12192880, 253274, 3398, 80, 112, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12196315, 253359, 915, 21, 35, "Input"],
Cell[CellGroupData[{
Cell[12197255, 253384, 557, 10, 22, "Print"],
Cell[12197815, 253396, 555, 10, 22, "Print"],
Cell[12198373, 253408, 706, 13, 22, "Print"],
Cell[12199082, 253423, 555, 10, 22, "Print"],
Cell[12199640, 253435, 556, 11, 22, "Print"]
}, Open  ]],
Cell[12200211, 253449, 583, 9, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12200831, 253463, 224, 4, 35, "Input"],
Cell[12201058, 253469, 122, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12201217, 253476, 33, 0, 32, "Input"],
Cell[12201253, 253478, 96, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12201386, 253484, 123, 2, 32, "Input"],
Cell[12201512, 253488, 163, 2, 32, "Output"]
}, Open  ]],
Cell[12201690, 253493, 11312, 255, 1581, "Input"],
Cell[CellGroupData[{
Cell[12213027, 253752, 438, 11, 35, "Input"],
Cell[CellGroupData[{
Cell[12213490, 253767, 239, 5, 22, "Print"],
Cell[12213732, 253774, 239, 5, 22, "Print"],
Cell[12213974, 253781, 390, 8, 22, "Print"],
Cell[12214367, 253791, 239, 5, 22, "Print"],
Cell[12214609, 253798, 242, 6, 22, "Print"]
}, Open  ]],
Cell[12214866, 253807, 118, 2, 32, "Output"]
}, Open  ]],
Cell[12214999, 253812, 93, 2, 35, "Input"],
Cell[CellGroupData[{
Cell[12215117, 253818, 133, 2, 32, "Input"],
Cell[12215253, 253822, 86, 1, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12215376, 253828, 418, 10, 35, "Input"],
Cell[CellGroupData[{
Cell[12215819, 253842, 239, 5, 22, "Print"],
Cell[12216061, 253849, 241, 5, 22, "Print"],
Cell[12216305, 253856, 392, 8, 22, "Print"],
Cell[12216700, 253866, 243, 5, 22, "Print"],
Cell[12216946, 253873, 242, 6, 22, "Print"],
Cell[12217191, 253881, 341, 6, 24, "Print"],
Cell[12217535, 253889, 343, 6, 24, "Print"],
Cell[12217881, 253897, 341, 6, 24, "Print"],
Cell[12218225, 253905, 341, 6, 24, "Print"],
Cell[12218569, 253913, 341, 6, 24, "Print"],
Cell[12218913, 253921, 341, 6, 24, "Print"],
Cell[12219257, 253929, 340, 6, 24, "Print"],
Cell[12219600, 253937, 341, 6, 24, "Print"],
Cell[12219944, 253945, 340, 6, 24, "Print"],
Cell[12220287, 253953, 341, 6, 24, "Print"],
Cell[12220631, 253961, 341, 6, 24, "Print"],
Cell[12220975, 253969, 343, 6, 24, "Print"],
Cell[12221321, 253977, 341, 6, 24, "Print"],
Cell[12221665, 253985, 343, 6, 24, "Print"],
Cell[12222011, 253993, 343, 6, 24, "Print"],
Cell[12222357, 254001, 343, 6, 24, "Print"],
Cell[12222703, 254009, 341, 6, 24, "Print"],
Cell[12223047, 254017, 341, 6, 24, "Print"],
Cell[12223391, 254025, 341, 6, 24, "Print"],
Cell[12223735, 254033, 340, 6, 24, "Print"],
Cell[12224078, 254041, 340, 6, 24, "Print"],
Cell[12224421, 254049, 341, 6, 24, "Print"],
Cell[12224765, 254057, 343, 6, 24, "Print"],
Cell[12225111, 254065, 341, 6, 24, "Print"],
Cell[12225455, 254073, 341, 6, 24, "Print"],
Cell[12225799, 254081, 341, 6, 24, "Print"],
Cell[12226143, 254089, 343, 6, 24, "Print"],
Cell[12226489, 254097, 340, 6, 24, "Print"],
Cell[12226832, 254105, 341, 6, 24, "Print"],
Cell[12227176, 254113, 341, 6, 24, "Print"],
Cell[12227520, 254121, 343, 6, 24, "Print"],
Cell[12227866, 254129, 341, 6, 24, "Print"],
Cell[12228210, 254137, 343, 6, 24, "Print"],
Cell[12228556, 254145, 343, 6, 24, "Print"],
Cell[12228902, 254153, 341, 6, 24, "Print"],
Cell[12229246, 254161, 341, 6, 24, "Print"],
Cell[12229590, 254169, 341, 6, 24, "Print"],
Cell[12229934, 254177, 341, 6, 24, "Print"],
Cell[12230278, 254185, 341, 6, 24, "Print"],
Cell[12230622, 254193, 341, 6, 24, "Print"],
Cell[12230966, 254201, 343, 6, 24, "Print"]
}, Open  ]],
Cell[12231324, 254210, 176, 4, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12231537, 254219, 698, 14, 105, "Input"],
Cell[CellGroupData[{
Cell[12232260, 254237, 529, 10, 22, "Print"],
Cell[12232792, 254249, 527, 10, 22, "Print"],
Cell[12233322, 254261, 680, 13, 22, "Print"],
Cell[12234005, 254276, 527, 10, 22, "Print"],
Cell[12234535, 254288, 528, 11, 22, "Print"]
}, Open  ]],
Cell[12235078, 254302, 701, 11, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12235816, 254318, 810, 20, 105, "Input"],
Cell[CellGroupData[{
Cell[12236651, 254342, 237, 5, 22, "Print"],
Cell[12236891, 254349, 237, 5, 22, "Print"],
Cell[12237131, 254356, 388, 8, 22, "Print"],
Cell[12237522, 254366, 237, 5, 22, "Print"],
Cell[12237762, 254373, 238, 6, 22, "Print"],
Cell[12238003, 254381, 237, 5, 22, "Print"],
Cell[12238243, 254388, 239, 5, 22, "Print"],
Cell[12238485, 254395, 388, 8, 22, "Print"],
Cell[12238876, 254405, 237, 5, 22, "Print"],
Cell[12239116, 254412, 238, 6, 22, "Print"],
Cell[12239357, 254420, 237, 5, 22, "Print"],
Cell[12239597, 254427, 237, 5, 22, "Print"],
Cell[12239837, 254434, 388, 8, 22, "Print"],
Cell[12240228, 254444, 236, 5, 22, "Print"],
Cell[12240467, 254451, 238, 6, 22, "Print"],
Cell[12240708, 254459, 237, 5, 22, "Print"],
Cell[12240948, 254466, 239, 5, 22, "Print"],
Cell[12241190, 254473, 388, 8, 22, "Print"],
Cell[12241581, 254483, 237, 5, 22, "Print"],
Cell[12241821, 254490, 240, 6, 22, "Print"],
Cell[12242064, 254498, 237, 5, 22, "Print"],
Cell[12242304, 254505, 237, 5, 22, "Print"],
Cell[12242544, 254512, 390, 8, 22, "Print"],
Cell[12242937, 254522, 237, 5, 22, "Print"],
Cell[12243177, 254529, 238, 6, 22, "Print"],
Cell[12243418, 254537, 237, 5, 22, "Print"],
Cell[12243658, 254544, 237, 5, 22, "Print"],
Cell[12243898, 254551, 388, 8, 22, "Print"],
Cell[12244289, 254561, 239, 5, 22, "Print"],
Cell[12244531, 254568, 237, 6, 22, "Print"],
Cell[12244771, 254576, 237, 5, 22, "Print"],
Cell[12245011, 254583, 237, 5, 22, "Print"],
Cell[12245251, 254590, 388, 8, 22, "Print"],
Cell[12245642, 254600, 237, 5, 22, "Print"],
Cell[12245882, 254607, 238, 6, 22, "Print"],
Cell[12246123, 254615, 237, 5, 22, "Print"],
Cell[12246363, 254622, 237, 5, 22, "Print"],
Cell[12246603, 254629, 388, 8, 22, "Print"],
Cell[12246994, 254639, 239, 5, 22, "Print"],
Cell[12247236, 254646, 240, 6, 22, "Print"],
Cell[12247479, 254654, 237, 5, 22, "Print"],
Cell[12247719, 254661, 239, 5, 22, "Print"],
Cell[12247961, 254668, 388, 8, 22, "Print"],
Cell[12248352, 254678, 237, 5, 22, "Print"],
Cell[12248592, 254685, 240, 6, 22, "Print"],
Cell[12248835, 254693, 239, 5, 22, "Print"],
Cell[12249077, 254700, 237, 5, 22, "Print"],
Cell[12249317, 254707, 388, 8, 22, "Print"],
Cell[12249708, 254717, 237, 5, 22, "Print"],
Cell[12249948, 254724, 240, 6, 22, "Print"],
Cell[12250191, 254732, 237, 5, 22, "Print"],
Cell[12250431, 254739, 237, 5, 22, "Print"],
Cell[12250671, 254746, 388, 8, 22, "Print"],
Cell[12251062, 254756, 237, 5, 22, "Print"],
Cell[12251302, 254763, 240, 6, 22, "Print"]
}, Open  ]],
Cell[12251557, 254772, 148, 2, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12251742, 254779, 660, 13, 35, "Input"],
Cell[CellGroupData[{
Cell[12252427, 254796, 411, 8, 22, "Print"],
Cell[12252841, 254806, 411, 8, 22, "Print"],
Cell[12253255, 254816, 562, 11, 22, "Print"],
Cell[12253820, 254829, 409, 8, 22, "Print"],
Cell[12254232, 254839, 414, 9, 22, "Print"],
Cell[12254649, 254850, 411, 8, 22, "Print"],
Cell[12255063, 254860, 411, 8, 22, "Print"],
Cell[12255477, 254870, 564, 11, 22, "Print"],
Cell[12256044, 254883, 411, 8, 22, "Print"],
Cell[12256458, 254893, 412, 9, 22, "Print"]
}, Open  ]],
Cell[12256885, 254905, 603, 11, 23, "Message"],
Cell[12257491, 254918, 605, 11, 23, "Message"],
Cell[12258099, 254931, 607, 11, 23, "Message"],
Cell[12258709, 254944, 390, 8, 23, "Message"],
Cell[12259102, 254954, 219, 4, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12259358, 254963, 144, 2, 30, "Input"],
Cell[12259505, 254967, 119, 3, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12259661, 254975, 184, 4, 32, "Input"],
Cell[12259848, 254981, 30916, 771, 892, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12290801, 255757, 16861, 376, 1565, "Input"],
Cell[CellGroupData[{
Cell[12307687, 256137, 491, 11, 24, "Print"],
Cell[12308181, 256150, 334, 7, 22, "Print"],
Cell[12308518, 256159, 336, 8, 22, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[12308903, 256173, 44, 0, 32, "Input"],
Cell[12308950, 256175, 254, 5, 32, "Output"]
}, Open  ]],
Cell[12309219, 256183, 306, 7, 35, "Input"],
Cell[CellGroupData[{
Cell[12309550, 256194, 3952, 90, 636, "Input"],
Cell[CellGroupData[{
Cell[12313527, 256288, 215, 5, 22, "Print"],
Cell[12313745, 256295, 217, 5, 22, "Print"],
Cell[12313965, 256302, 366, 8, 22, "Print"],
Cell[12314334, 256312, 217, 5, 22, "Print"],
Cell[12314554, 256319, 216, 6, 22, "Print"],
Cell[12314773, 256327, 215, 5, 22, "Print"],
Cell[12314991, 256334, 217, 5, 22, "Print"],
Cell[12315211, 256341, 368, 8, 22, "Print"],
Cell[12315582, 256351, 215, 5, 22, "Print"],
Cell[12315800, 256358, 216, 6, 22, "Print"]
}, Open  ]],
Cell[12316031, 256367, 560, 10, 23, "Message"],
Cell[12316594, 256379, 558, 10, 23, "Message"],
Cell[12317155, 256391, 557, 10, 23, "Message"],
Cell[12317715, 256403, 346, 7, 23, "Message"],
Cell[12318064, 256412, 4698, 67, 95, "Message"],
Cell[12322765, 256481, 4698, 67, 95, "Message"],
Cell[12327466, 256550, 4698, 67, 95, "Message"],
Cell[12332167, 256619, 353, 7, 23, "Message"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12332557, 256631, 227, 4, 71, "Input"],
Cell[12332787, 256637, 130, 1, 32, "Output"],
Cell[12332920, 256640, 107, 1, 32, "Output"],
Cell[12333030, 256643, 105, 1, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12333172, 256649, 190, 3, 30, "Input"],
Cell[12333365, 256654, 571, 12, 24, "Print"],
Cell[12333939, 256668, 2990, 43, 292, "Output"],
Cell[12336932, 256713, 335, 7, 24, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12337304, 256725, 36, 0, 30, "Input"],
Cell[12337343, 256727, 72, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12337452, 256733, 300, 8, 32, "Input"],
Cell[12337755, 256743, 279, 6, 23, "Message"],
Cell[12338037, 256751, 276, 6, 23, "Message"],
Cell[12338316, 256759, 275, 6, 23, "Message"],
Cell[12338594, 256767, 277, 6, 23, "Message"],
Cell[12338874, 256775, 347, 7, 23, "Message"],
Cell[12339224, 256784, 273, 6, 23, "Message"],
Cell[12339500, 256792, 274, 6, 23, "Message"],
Cell[12339777, 256800, 346, 7, 23, "Message"],
Cell[12340126, 256809, 17895, 401, 297, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12358058, 257215, 3843, 96, 416, "Input"],
Cell[12361904, 257313, 14163, 331, 191, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12376104, 257649, 355, 10, 32, "Input"],
Cell[12376462, 257661, 132, 2, 30, "Output"]
}, Open  ]],
Cell[12376609, 257666, 884, 23, 129, "Input"],
Cell[12377496, 257691, 185, 4, 32, "Input"],
Cell[12377684, 257697, 261, 6, 32, "Input"],
Cell[CellGroupData[{
Cell[12377970, 257707, 1163, 32, 132, "Input"],
Cell[12379136, 257741, 546, 9, 32, "Output"],
Cell[12379685, 257752, 382, 8, 32, "Output"],
Cell[12380070, 257762, 550, 11, 30, "Output"],
Cell[12380623, 257775, 570, 12, 52, "Output"],
Cell[12381196, 257789, 719, 12, 52, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12381952, 257806, 248, 6, 32, "Input"],
Cell[12382203, 257814, 74, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12382314, 257820, 339, 8, 35, "Input"],
Cell[12382656, 257830, 208, 6, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12382901, 257841, 225, 5, 32, "Input"],
Cell[12383129, 257848, 497, 8, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12383663, 257861, 434, 12, 35, "Input"],
Cell[12384100, 257875, 125, 2, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12384262, 257882, 225, 5, 32, "Input"],
Cell[12384490, 257889, 9676, 236, 159, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12394203, 258130, 38, 0, 30, "Input"],
Cell[12394244, 258132, 1548, 27, 71, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12395829, 258164, 722, 19, 127, "Input"],
Cell[12396554, 258185, 3976, 101, 112, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12400567, 258291, 380, 11, 35, "Input"],
Cell[12400950, 258304, 720, 12, 52, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12401707, 258321, 253, 6, 32, "Input"],
Cell[12401963, 258329, 129621, 1953, 8427, "Output"]
}, Open  ]],
Cell[12531599, 260285, 296, 7, 74, "Input"],
Cell[CellGroupData[{
Cell[12531920, 260296, 479, 13, 35, "Input"],
Cell[12532402, 260311, 12161, 249, 512, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12544600, 260565, 320, 8, 32, "Input"],
Cell[12544923, 260575, 11380, 288, 714, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12556340, 260868, 257, 8, 35, "Input"],
Cell[12556600, 260878, 4554, 68, 71, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12561191, 260951, 445, 8, 89, "Input"],
Cell[12561639, 260961, 145, 3, 32, "Output"],
Cell[12561787, 260966, 145, 3, 32, "Output"],
Cell[12561935, 260971, 145, 3, 32, "Output"],
Cell[12562083, 260976, 145, 3, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12562265, 260984, 520, 13, 52, "Input"],
Cell[12562788, 260999, 10729, 255, 159, "Output"],
Cell[12573520, 261256, 1620, 24, 71, "Output"]
}, Open  ]],
Cell[12575155, 261283, 5524, 140, 599, "Input"],
Cell[CellGroupData[{
Cell[12580704, 261427, 2285, 60, 179, "Input"],
Cell[12582992, 261489, 1638, 46, 52, "Output"],
Cell[12584633, 261537, 3230, 100, 72, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12587900, 261642, 522, 14, 32, "Input"],
Cell[12588425, 261658, 526, 18, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12588988, 261681, 198, 5, 35, "Input"],
Cell[CellGroupData[{
Cell[12589211, 261690, 3620, 108, 62, "Print"],
Cell[12592834, 261800, 2447, 61, 43, "Print"],
Cell[12595284, 261863, 480, 11, 24, "Print"],
Cell[12595767, 261876, 593, 13, 24, "Print"],
Cell[12596363, 261891, 599, 13, 24, "Print"],
Cell[12596965, 261906, 539, 13, 24, "Print"],
Cell[12597507, 261921, 517, 12, 24, "Print"],
Cell[12598027, 261935, 611, 13, 24, "Print"],
Cell[12598641, 261950, 615, 13, 24, "Print"]
}, Open  ]],
Cell[12599271, 261966, 11522, 290, 159, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12610830, 262261, 264, 6, 35, "Input"],
Cell[CellGroupData[{
Cell[12611119, 262271, 475, 12, 24, "Print"],
Cell[12611597, 262285, 482, 12, 24, "Print"],
Cell[12612082, 262299, 299, 8, 24, "Print"],
Cell[12612384, 262309, 297, 8, 24, "Print"],
Cell[12612684, 262319, 497, 12, 24, "Print"],
Cell[12613184, 262333, 514, 12, 24, "Print"],
Cell[12613701, 262347, 498, 14, 24, "Print"],
Cell[12614202, 262363, 434, 12, 24, "Print"],
Cell[12614639, 262377, 492, 12, 24, "Print"]
}, Open  ]],
Cell[12615146, 262392, 12815, 321, 212, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

